-- name=int_button_guide_impl
--******************************************************************************************
function public.Init ()

  public.DIRECTION = 0;
  public.POSITION = 965;

  private.MOUSE_OVER_ANIM_TIME = 0.3;

  if ( not IsCollectorsEdition() ) then

    ObjMultiSet( { {"int_button_guide", { input = false }},
                   {"spr_int_button_guide", { res = "assets/interface/resources/strategy_guide_button_na" }},
                   {"txt_int_button_guide", { visible = 0 }} } );

  else

    ObjSet("obj_int_button_guide", {
      event_mdown = function () int_button_guide.MouseDown(); cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk"); end,
      event_menter = private.MouseEnterAnim,
      event_mleave = private.MouseLeaveAnim
    });

  end;

end;
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then

    --
  
  else

    --

  end;

end;
--******************************************************************************************
function private.MouseEnterAnim()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_guide_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.MouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_button_guide_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );


end;
--******************************************************************************************