-- name=rm_bedroom
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_bedroom";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Wallmap();
  --------------------------------------------------------------------------------------------
  -- function get_crystalshoetip () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_crystalshoetip" ] = {
      type = "get",
      get_obj = "spr_bed_crystalshoetip",
      room = private.room_objname,
      zz = "zz_bed",
      zz_gate = "gzz_bedroom_bed"
  };
  --------------------------------------------------------------------------------------------
  local get_crystalshoetip_inv = function ()
  
    interface.InventoryItemAdd( "inv_crystalshoetip", "spr_bed_crystalshoetip" );
    int_map_impl.DecreaseRoomTasks("rm_bedroom");
  
  end;
  local get_crystalshoetip_end = function ()
  
    ObjDelete( "gfx_bed_crystalshoetip" );
    
    ObjDelete( "spr_bedroom_bed_shoe" );
    
    if cmn.IsEventDone("get_diary") then
      ObjDelete( "gzz_bedroom_bed" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_crystalshoetip", get_crystalshoetip_inv );
  cmn.AddSubscriber( "get_crystalshoetip", get_crystalshoetip_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_diary () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_diary" ] = {
      type = "get",
      get_obj = "spr_bed_diary",
      room = private.room_objname,
      zz = "zz_bed",
      zz_gate = "gzz_bedroom_bed"
  };
  --------------------------------------------------------------------------------------------
  local get_diary_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_diary", "spr_bed_diary" );
  
  end;
  local get_diary_end = function ()
  
    ObjDelete( "gfx_bed_diary" );
    ObjDelete( "spr_bed_diary_sh" );
    
    ObjDelete( "spr_bedroom_bed_diary" );
    
    if cmn.IsEventDone("get_crystalshoetip") then
      ObjDelete( "gzz_bedroom_bed" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_diary", get_diary_inv );
  cmn.AddSubscriber( "get_diary", get_diary_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crystalshoeheel () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_crystalshoeheel" ] = {
      type = "get",
      get_obj = "spr_wallmap_crystalshoeheel",
      room = private.room_objname,
      zz = "zz_wallmap",
      zz_gate = "gzz_bedroom_wallmap"
  };
  --------------------------------------------------------------------------------------------
  local get_crystalshoeheel_inv = function ()
  
    interface.InventoryItemAdd( "inv_crystalshoeheel", "spr_wallmap_crystalshoeheel" );
    int_map_impl.DecreaseRoomTasks("rm_bedroom");
  
  end;
  local get_crystalshoeheel_end = function ()
  
    ObjDelete( "gfx_wallmap_crystalshoeheel" );
    ObjDelete( "spr_wallmap_crystalshoeheel_sh" );
    
    ObjDelete( "spr_bedroom_map_shoe" );
    
    if cmn.IsEventDone("get_crystaltie") and cmn.IsEventDone("get_evilqueenfigurine") and cmn.IsEventDone("get_huntsmanfigurine") then
      ObjDelete( "gzz_bedroom_wallmap" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_crystalshoeheel", get_crystalshoeheel_inv );
  cmn.AddSubscriber( "get_crystalshoeheel", get_crystalshoeheel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crystaltie () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_crystaltie" ] = {
      type = "get",
      get_obj = "spr_wallmap_crystaltie",
      room = private.room_objname,
      zz = "zz_wallmap",
      zz_gate = "gzz_bedroom_wallmap"
  };
  --------------------------------------------------------------------------------------------
  local get_crystaltie_inv = function ()
  
    interface.InventoryItemAdd( "inv_crystaltie", "spr_wallmap_crystaltie" );
    int_map_impl.DecreaseRoomTasks("rm_bedroom");
  
  end;
  local get_crystaltie_end = function ()
  
    ObjDelete( "gfx_wallmap_crystaltie" );
    ObjDelete( "spr_wallmap_crystaltie_sh" );
    
    if cmn.IsEventDone("get_crystalshoeheel") and cmn.IsEventDone("get_evilqueenfigurine") and cmn.IsEventDone("get_huntsmanfigurine") then
      ObjDelete( "gzz_bedroom_wallmap" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_crystaltie", get_crystaltie_inv );
  cmn.AddSubscriber( "get_crystaltie", get_crystaltie_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_evilqueenfigurine () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_evilqueenfigurine" ] = {
      type = "get",
      get_obj = "spr_wallmap_evilqueenfigurine",
      room = private.room_objname,
      zz = "zz_wallmap",
      zz_gate = "gzz_bedroom_wallmap"
  };
  --------------------------------------------------------------------------------------------
  local get_evilqueenfigurine_inv = function ()
  
    interface.InventoryItemAdd( "inv_evilqueenfigurine", "spr_wallmap_evilqueenfigurine" );
  
  end;
  local get_evilqueenfigurine_end = function ()
  
    ObjDelete( "gfx_wallmap_evilqueenfigurine" );
    ObjDelete( "spr_wallmap_evilqueenfigurine_sh" );
    
    ObjDelete( "spr_bedroom_map_queen" );
    
    if cmn.IsEventDone("get_crystalshoeheel") and cmn.IsEventDone("get_crystaltie") and cmn.IsEventDone("get_huntsmanfigurine") then
      ObjDelete( "gzz_bedroom_wallmap" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_evilqueenfigurine", get_evilqueenfigurine_inv );
  cmn.AddSubscriber( "get_evilqueenfigurine", get_evilqueenfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_huntsmanfigurine () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_huntsmanfigurine" ] = {
      type = "get",
      get_obj = "spr_wallmap_huntsmanfigurine",
      room = private.room_objname,
      zz = "zz_wallmap",
      zz_gate = "gzz_bedroom_wallmap"
  };
  --------------------------------------------------------------------------------------------
  local get_huntsmanfigurine_inv = function ()
  
    interface.InventoryItemAdd( "inv_huntsmanfigurine", "spr_wallmap_huntsmanfigurine" );
  
  end;
  local get_huntsmanfigurine_end = function ()
  
    ObjDelete( "gfx_wallmap_huntsmanfigurine" );
    ObjDelete( "spr_wallmap_huntsmanfigurine_sh" );
    
    ObjDelete( "spr_bedroom_map_hunter" );
    
    if cmn.IsEventDone("get_crystalshoeheel") and cmn.IsEventDone("get_crystaltie") and cmn.IsEventDone("get_evilqueenfigurine") then
      ObjDelete( "gzz_bedroom_wallmap" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_huntsmanfigurine", get_huntsmanfigurine_inv );
  cmn.AddSubscriber( "get_huntsmanfigurine", get_huntsmanfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cabinethandle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_cabinethandle" ] = {
      type = "get",
      get_obj = "spr_wallmap_cabinethandle",
      room = private.room_objname,
      zz = "zz_wallmap",
      zz_gate = "gzz_bedroom_wallmap"
  };
  --------------------------------------------------------------------------------------------
  local get_cabinethandle_inv = function ()
  
    interface.InventoryItemAdd( "inv_cabinethandle", "spr_wallmap_cabinethandle" );
  
  end;
  local get_cabinethandle_end = function ()
  
    ObjDelete( "spr_wallmap_cabinethandle_sh" );
    ObjDelete( "gfx_wallmap_cabinethandle" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_cabinethandle", get_cabinethandle_inv );
  cmn.AddSubscriber( "get_cabinethandle", get_cabinethandle_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_pumpkinbranch () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_pumpkinbranch" ] = {
      type = "use",
      inv_obj = "inv_pumpkinbranch",
      use_place = "obj_bed_use_pumpkinbranch",
      room = private.room_objname,
      zz = "zz_bed",
      zz_gate = "gzz_bedroom_bed"
  };
  --------------------------------------------------------------------------------------------
  local use_pumpkinbranch_inv = function ()
  
    interface.InventoryItemRemove( "inv_pumpkinbranch" );
  
  end;
  local use_pumpkinbranch_beg = function ()
  
    ObjDelete( "obj_bed_use_pumpkinbranch" );
    ObjDelete( "anm_bed_touch_pumpkin" );
  
  end;
  local use_pumpkinbranch_end = function ()
  
    ObjMultiSet( { {"spr_bed_crystalshoetip", { input = 1 }},
                   {"spr_bedroom_bed_shoe", { alp = 1 }},
                   {"spr_bedroom_bed_cover_2", { alp = 1 }} } );
    
    ObjDelete( "anm_bed_use_pumpkinbranch" );
    ObjDelete( "spr_bedroom_bed_cover_1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pumpkinbranch", use_pumpkinbranch_beg, private.room_objname );
  cmn.AddSubscriber( "use_pumpkinbranch", use_pumpkinbranch_inv );
  cmn.AddSubscriber( "use_pumpkinbranch", use_pumpkinbranch_end, private.room_objname );
  cmn.AddSubscriber( "use_pumpkinbranch_inv", use_pumpkinbranch_inv, private.room_objname );
  cmn.AddSubscriber( "use_pumpkinbranch_beg", use_pumpkinbranch_beg, private.room_objname );
  cmn.AddSubscriber( "use_pumpkinbranch_end", use_pumpkinbranch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_easternprincess () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_easternprincess" ] = {
      type = "use",
      inv_obj = "inv_easternprincess",
      use_place = "obj_wallmap_use_easternprincess",
      room = private.room_objname,
      zz = "zz_wallmap",
      zz_gate = "gzz_bedroom_wallmap"
  };
  --------------------------------------------------------------------------------------------
  local use_easternprincess_inv = function ()
  
    interface.InventoryItemRemove( "inv_easternprincess" );
  
  end;
  local use_easternprincess_beg = function ()
  
    ObjDelete( "obj_wallmap_use_easternprincess" );
  
  end;
  local use_easternprincess_end = function ()
  
    ObjMultiSet( { {"spr_wallmap_figure_5", { alp = 1 }},
                   {"obj_wallmap_game", { input = 1 }},
                   {"spr_bedroom_map_figure", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_easternprincess", use_easternprincess_beg, private.room_objname );
  cmn.AddSubscriber( "use_easternprincess", use_easternprincess_inv );
  cmn.AddSubscriber( "use_easternprincess", use_easternprincess_end, private.room_objname );
  cmn.AddSubscriber( "use_easternprincess_inv", use_easternprincess_inv, private.room_objname );
  cmn.AddSubscriber( "use_easternprincess_beg", use_easternprincess_beg, private.room_objname );
  cmn.AddSubscriber( "use_easternprincess_end", use_easternprincess_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_unicornhorn () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_unicornhorn" ] = {
      type = "use",
      inv_obj = "inv_unicornhorn",
      use_place = "obj_wallmap_use_unicornhorn",
      room = private.room_objname,
      zz = "zz_wallmap",
      zz_gate = "gzz_bedroom_wallmap"
  };
  --------------------------------------------------------------------------------------------
  local use_unicornhorn_inv = function ()
  
    interface.InventoryItemRemove( "inv_unicornhorn" );
  
  end;
  local use_unicornhorn_beg = function ()
  
    ObjDelete( "obj_wallmap_use_unicornhorn" );
  
  end;
  local use_unicornhorn_end = function ()
  
    ObjDelete( "anm_wallmap_box_touch" );
    ObjDelete( "obj_wallmap_box_closed" );
  
    ObjMultiSet( { {"anm_wallmap_box_open", { alp = 1, input = 1, frame = 400 }},
                   {"spr_bedroom_map_drawer_open", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_unicornhorn", use_unicornhorn_beg, private.room_objname );
  cmn.AddSubscriber( "use_unicornhorn", use_unicornhorn_inv );
  cmn.AddSubscriber( "use_unicornhorn", use_unicornhorn_end, private.room_objname );
  cmn.AddSubscriber( "use_unicornhorn_inv", use_unicornhorn_inv, private.room_objname );
  cmn.AddSubscriber( "use_unicornhorn_beg", use_unicornhorn_beg, private.room_objname );
  cmn.AddSubscriber( "use_unicornhorn_end", use_unicornhorn_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mappart () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_mappart" ] = {
      type = "use",
      inv_obj = "inv_mappart",
      use_place = "obj_wallmap_use_mappart",
      room = private.room_objname,
      zz = "zz_wallmap",
      zz_gate = "gzz_bedroom_wallmap"
  };
  --------------------------------------------------------------------------------------------
  local use_mappart_inv = function ()
  
    interface.InventoryItemRemove( "inv_mappart" );
  
  end;
  local use_mappart_beg = function ()
  
    ObjDelete( "obj_wallmap_use_mappart" );
  
  end;
  local use_mappart_end = function ()
  
    ObjMultiSet( { {"spr_wallmap_map_piece", { alp = 1 }},
                   {"obj_wallmap_use_easternprincess", { input = 1 }},
                   {"spr_bedroom_map_part", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mappart", use_mappart_beg, private.room_objname );
  cmn.AddSubscriber( "use_mappart", use_mappart_inv );
  cmn.AddSubscriber( "use_mappart", use_mappart_end, private.room_objname );
  cmn.AddSubscriber( "use_mappart_inv", use_mappart_inv, private.room_objname );
  cmn.AddSubscriber( "use_mappart_beg", use_mappart_beg, private.room_objname );
  cmn.AddSubscriber( "use_mappart_end", use_mappart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pencil () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_pencil" ] = {
      type = "use",
      inv_obj = "inv_pencil",
      use_place = "obj_wardrobedoor_use_pencil",
      room = private.room_objname,
      zz = "zz_wardrobedoor",
      zz_gate = "gzz_bedroom_wardrobedoor"
  };
  --------------------------------------------------------------------------------------------
  local use_pencil_inv = function ()
  
    interface.InventoryItemRemove( "inv_pencil" );
  
  end;
  local use_pencil_beg = function ()
  
    ObjDelete( "obj_wardrobedoor_use_pencil" );
    ObjDelete( "anm_wardrobedoor_touch_doors" );
  
  end;
  local use_pencil_end = function ()
  
    ObjMultiSet( { {"gho_bedroom_inwardrobe",  { active = 1, input = 1, alp = 1 }},
                   {"spr_bedroom_wardrobe_open", { alp = 1 }} } );
    
    ObjDelete( "gzz_bedroom_wardrobedoor" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pencil", use_pencil_beg, private.room_objname );
  cmn.AddSubscriber( "use_pencil", use_pencil_inv );
  cmn.AddSubscriber( "use_pencil", use_pencil_end, private.room_objname );
  cmn.AddSubscriber( "use_pencil_inv", use_pencil_inv, private.room_objname );
  cmn.AddSubscriber( "use_pencil_beg", use_pencil_beg, private.room_objname );
  cmn.AddSubscriber( "use_pencil_end", use_pencil_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_bedroom () end;
  --------------------------------------------------------------------------------------------
  local opn_bedroom = function ()
  
    int_map_impl.OpenRoom( "rm_bedroom" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_bedroom", opn_bedroom );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_wallmap" );
  
  function zz_wallmap.PreOpen()
    
    cmn.Lock(1);
    private.zz_wallmap.DrawScene();
    
  end;
  
  function zz_wallmap.Open()
    
    if ( cmn.IsEventDone( "use_easternprincess" ) and not(cmn.IsEventDone( "win_wallmap" )) ) then
      
      cmn.MiniGameShow();
      private.zz_wallmap.CheckWin();
      
    else 
      cmn.Lock(0);
    end;
    
  end;
  
  function zz_wallmap.PreClose()
    
    if ( cmn.IsEventDone( "use_easternprincess" ) and not(cmn.IsEventDone( "win_wallmap" )) ) then
      cmn.MiniGameHide("wallmap");
    end;

  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_wallmap" ].state) then 
    private.zz_wallmap.StartConditions();
  end;

  private.zz_wallmap.state = ng_global.progress[ ng_global.currentprogress ][ "win_wallmap" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_bedroom();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/aud_bedroom_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/aud_bedroom_env");
  
  if not cmn.IsEventDone("win_inwardrobe") and ng_global.progress[ "std" ][ "win_inwardrobe" ].stage[1] == 13 then
    ObjSet("spr_bedroom_ho_box_open",  { alp = 1 });
    ObjDelete("spr_bedroom_ho_objects");
    ObjDelete("spr_bedroom_ho_box_closed");
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_pumpkinbranch()

  local item = "inv_pumpkinbranch";

  if cmn.ApplyObj( item, "gzz_bedroom_bed" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bed" );

  elseif ( cmn.ApplyObj( item, "obj_bed_use_pumpkinbranch" ) ) then

    cmn.CallEventHandler( "use_pumpkinbranch_inv" );
    cmn.CallEventHandler( "use_pumpkinbranch_beg" );

    local func_after = function ()

      

      cmn.SetEventDone( "use_pumpkinbranch" );
      cmn.CallEventHandler( "use_pumpkinbranch_end" );
      
      cmn.Lock( 0 );
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_bedroom/audio/aud_use_part_pumpkin");
    cmn.SetEventDone( "use_pumpkinbranch" );
    ObjSet("anm_bed_use_pumpkinbranch",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_easternprincess()

  local item = "inv_easternprincess";

  if cmn.ApplyObj( item, "gzz_bedroom_wallmap" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_wallmap" );

  elseif ( cmn.ApplyObj( item, "obj_wallmap_use_easternprincess" ) and cmn.IsEventDone("use_mappart") ) then

    cmn.CallEventHandler( "use_easternprincess_inv" );
    cmn.CallEventHandler( "use_easternprincess_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_easternprincess" );
      cmn.CallEventHandler( "use_easternprincess_end" );
      
      cmn.MiniGameShow();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_bedroom/audio/aud_xx_use_detail");

    ObjAnimate( "spr_wallmap_figure_5", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_unicornhorn()

  local item = "inv_unicornhorn";

  if cmn.ApplyObj( item, "gzz_bedroom_wallmap" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_wallmap" );

  elseif ( cmn.ApplyObj( item, "obj_wallmap_use_unicornhorn" ) ) then

    cmn.CallEventHandler( "use_unicornhorn_inv" );
    cmn.CallEventHandler( "use_unicornhorn_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_unicornhorn" );
      cmn.CallEventHandler( "use_unicornhorn_end" );
    
    end;
    
    local anm_open = function ()
      
      ObjDelete( "obj_wallmap_box_closed" );
    
      ObjMultiSet( { {"anm_wallmap_box_open",  { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_wallmap_box_touch", { alp = 0}} } );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_bedroom/audio/aud_use_horn");

    ObjAnimate("spr_wallmap_box_horn", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_mappart()

  local item = "inv_mappart";

  if cmn.ApplyObj( item, "gzz_bedroom_wallmap" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_wallmap" );

  elseif ( cmn.ApplyObj( item, "obj_wallmap_use_mappart" ) ) then

    cmn.CallEventHandler( "use_mappart_inv" );
    cmn.CallEventHandler( "use_mappart_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_mappart" );
      cmn.CallEventHandler( "use_mappart_end" );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_use_small_paper");

    ObjAnimate( "spr_wallmap_map_piece", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pencil()

  local item = "inv_pencil";

  if cmn.ApplyObj( item, "gzz_bedroom_wardrobedoor" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_wardrobedoor" );

  elseif ( cmn.ApplyObj( item, "obj_wardrobedoor_use_pencil" ) ) then

    cmn.CallEventHandler( "use_pencil_inv" );
    cmn.CallEventHandler( "use_pencil_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pencil" );
      cmn.CallEventHandler( "use_pencil_end" );
      
      common.CloseSubRoom();
    
    end;
  
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_bedroom/audio/aud_use_pencil");

    ObjSet("anm_wardrobedoor_use_pencil",  { alp = 1, playing = 1, endtrig = func_after });
    
  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_crystalshoetip()

  cmn.SetEventDone( "get_crystalshoetip" );
  cmn.CallEventHandler( "get_crystalshoetip" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_diary") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_diary()

  cmn.SetEventDone( "get_diary" );
  cmn.CallEventHandler( "get_diary" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_crystalshoetip") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_crystalshoeheel()

  cmn.SetEventDone( "get_crystalshoeheel" );
  cmn.CallEventHandler( "get_crystalshoeheel" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_crystaltie") and cmn.IsEventDone("get_evilqueenfigurine") and cmn.IsEventDone("get_huntsmanfigurine") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_crystaltie()
  
  ObjSet("spr_wallmap_crystaltie",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_crystaltie" );
  cmn.CallEventHandler( "get_crystaltie" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_crystalshoeheel") and cmn.IsEventDone("get_evilqueenfigurine") and cmn.IsEventDone("get_huntsmanfigurine") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_evilqueenfigurine()

  cmn.SetEventDone( "get_evilqueenfigurine" );
  cmn.CallEventHandler( "get_evilqueenfigurine" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_crystalshoeheel") and cmn.IsEventDone("get_crystaltie") and cmn.IsEventDone("get_huntsmanfigurine") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_huntsmanfigurine()

  cmn.SetEventDone( "get_huntsmanfigurine" );
  cmn.CallEventHandler( "get_huntsmanfigurine" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_crystalshoeheel") and cmn.IsEventDone("get_crystaltie") and cmn.IsEventDone("get_evilqueenfigurine") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_cabinethandle()
  
  ObjSet("spr_wallmap_cabinethandle",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_cabinethandle" );
  cmn.CallEventHandler( "get_cabinethandle" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.touch_punpkin()
  
  cmn.ShowBbt( "obj_bed_use_pumpkinbranch" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_bedroom/audio/aud_xx_pumpkin");
  
  ObjSet("anm_bed_touch_pumpkin",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_wardrobe()
  
  cmn.ShowBbt( "obj_wardrobedoor_use_pencil" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_bedroom/audio/aud_xx_self");
  
  ObjSet("anm_wardrobedoor_touch_doors",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_unicorn_box()
  
  cmn.ShowBbt( "obj_wallmap_use_unicornhorn" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_bedroom/audio/aud_xx_small_box1");
  
  ObjSet("anm_wallmap_box_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_map( num )
  
  if num == 1 then
    cmn.ShowBbt( "obj_wallmap_use_mappart" );
  else 
    cmn.ShowBbt( "obj_wallmap_use_easternprincess" );
  end;
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_bedroom/audio/aud_xx_map");
  
  ObjAnimate("spr_wallmap_map_right", "pos_x", 0, 0, function() cmn.Lock(0); end, { 0, 0, 120,   0.2, 0, 122,   0.4, 0, 120 });
  ObjAnimate("spr_wallmap_map_left", "pos_x", 0, 0, "", { 0, 0, -101,   0.2, 0, -103,   0.4, 0, -101 });
  
  for i = 1, 3, 1 do
    ObjAnimate("spr_wallmap_figure_"..private.zz_wallmap.state[i], "pos_x", 0, 0, "", { 0, 0, private.zz_wallmap.fig_pos[i][1],   0.2, 0, private.zz_wallmap.fig_pos[i][1]-2,   0.4, 0, private.zz_wallmap.fig_pos[i][1] });
  end;
  for i = 4, 6, 1 do
    ObjAnimate("spr_wallmap_figure_"..private.zz_wallmap.state[i], "pos_x", 0, 0, "", { 0, 0, private.zz_wallmap.fig_pos[i][1],   0.2, 0, private.zz_wallmap.fig_pos[i][1]+2,   0.4, 0, private.zz_wallmap.fig_pos[i][1] });
  end;
    
end;
--------------------------------------------------------------------------------------------
function public.touch_plant()
  
  local func_after = function ()
  
    cmn.Lock(0);
  
    ObjMultiSet( { {"anm_bedroom_plant", { alp = 1, playing = 1 }},
                   {"anm_bedroom_plant_touch", { alp = 0 }} } );
  
  end;
  
  cmn.Lock(1);
  
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_xx_leaves");
  
  ObjMultiSet( { {"anm_bedroom_plant", { alp = 0, playing = 0 }},
                 {"anm_bedroom_plant_touch", { alp = 1, playing = 1, endtrig = func_after }} } );
  
end;
--------------------------------------------------------------------------------------------
function private.opn_bedroom()

  if not ( cmn.IsEventDone( "opn_bedroom" ) ) then
    cmn.SetEventDone( "opn_bedroom" );
    cmn.CallEventHandler("opn_bedroom");
    cmn.ShowBbt( "bedroom_open" );
  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Wallmap *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_wallmap = {};
public.zz_wallmap = {};

function private.Init_Wallmap()
  
  private.zz_wallmap.selected_figure = 0;
  private.zz_wallmap.in_fly = false;

  private.zz_wallmap.start_state = {5, 4, 6, 3, 2, 1};
  private.zz_wallmap.fig_pos = { {-242, -126}, {-71, -173}, {-6, -93}, {75, -191}, {114, -115}, {230, -134} };
  
  -----------------------------------------------------------------------------------
  local win_wallmap = function ()

    if cmn.IsEventDone( "win_wallmap" ) then
      
      ObjDelete("spr_bedroom_map_map");

      ObjMultiSet( { {"obj_wallmap_game", { input = 0 }},
                     {"obj_wallmap_niche", { input = 1, alp = 1 }},
                     {"spr_wallmap_map_right", { pos_x = 186 }},
                     {"spr_wallmap_map_left", { pos_x = -273 }},
                     {"obj_wallmap_game_1", { pos_x = -172 }},
                     {"obj_wallmap_game_2", { pos_x = 66 }} } );
                     
      for i = 1, 3, 1 do
        ObjAttach("spr_wallmap_figure_"..i, "obj_wallmap_game_1");
      end;
      for i = 4, 6, 1 do
        ObjAttach("spr_wallmap_figure_"..i, "obj_wallmap_game_2");
      end;

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_wallmap", win_wallmap, "rm_bedroom" );
  
end;
--*********************************************************************************************************************
-----------------------------------------------------------------------------------
function private.zz_wallmap.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_wallmap" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_wallmap" ].state = { 5, 4, 6, 3, 2, 1 };

end;
-----------------------------------------------------------------------------------
function public.zz_wallmap.Reset()
  
  local need_r = false;
  local need_r2 = false;
  
  for i = 1, #private.zz_wallmap.state, 1 do
    
    if private.zz_wallmap.state[i] ~= private.zz_wallmap.start_state[i] then
      
      if not need_r then
        need_r = true;
      end;
      
      local ind = 0;

      for j = 1, #private.zz_wallmap.start_state, 1 do
      
        if private.zz_wallmap.start_state[j] == private.zz_wallmap.state[i] then
          ind =  j;
          break;
        end;
        
      end;
      
      if private.zz_wallmap.state[i] == i then
        ObjAnimate("spr_wallmap_figure_"..private.zz_wallmap.state[i].."_win", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 });
      end;
      
      ObjAnimate("spr_wallmap_figure_"..private.zz_wallmap.state[i], "pos_xy", 0, 0, "", { 0, 0, private.zz_wallmap.fig_pos[i][1], private.zz_wallmap.fig_pos[i][2], 
                                                                                         0.5, 0, private.zz_wallmap.fig_pos[ind][1], private.zz_wallmap.fig_pos[ind][2] });
      
    end;
    
  end;
                                                                                        
  if private.zz_wallmap.selected_figure ~= 0 then
    need_r2 = true;
    local sel = private.zz_wallmap.selected_figure;
    private.zz_wallmap.selected_figure = 0;
    ObjAnimate("spr_wallmap_figure_"..sel.."_select", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  end;
                                                                                        
  if need_r then
    
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level1/rm_bedroom/audio/aud_xx_move_detail");
    
    private.zz_wallmap.StartConditions();
    private.zz_wallmap.state = ng_global.progress[ ng_global.currentprogress ][ "win_wallmap" ].state;
    
    ObjSet("tmr_wallmap_timer",  { time = 0.5, playing = 1, endtrig = function() cmn.Lock(0); end });
    
  elseif need_r2 then
    
    cmn.Lock(1);
    ObjSet("tmr_wallmap_timer",  { time = 0.3, playing = 1, endtrig = function () cmn.Lock(0); private.zz_wallmap.DrawScene(); end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_wallmap.Skip()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_wallmap" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_wallmap" ].state = { 1, 2, 3, 4, 5, 6 };
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_bedroom/audio/aud_xx_move_detail");
  
  for i = 1, #private.zz_wallmap.state, 1 do
    
    if private.zz_wallmap.state[i] ~= i then
      
      local ind = private.zz_wallmap.state[i];
      
      ObjAnimate("spr_wallmap_figure_"..private.zz_wallmap.state[i].."_win", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,   0.7, 0, 1 });

      ObjAnimate("spr_wallmap_figure_"..private.zz_wallmap.state[i], "pos_xy", 0, 0, "", { 0, 0, private.zz_wallmap.fig_pos[i][1], private.zz_wallmap.fig_pos[i][2], 
                                                                                         0.5, 0, private.zz_wallmap.fig_pos[ind][1], private.zz_wallmap.fig_pos[ind][2] });
      
    end;
    
  end;
                                                                                        
  if private.zz_wallmap.selected_figure ~= 0 then
    ObjAnimate("spr_wallmap_figure_"..private.zz_wallmap.selected_figure.."_select", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    private.zz_wallmap.selected_figure = 0;
  end;
                                                                                        
  private.zz_wallmap.state = ng_global.progress[ ng_global.currentprogress ][ "win_wallmap" ].state;
  
  ObjSet("tmr_wallmap_timer",  { time = 0.7, playing = 1, endtrig = private.zz_wallmap.CheckWin });
  
end;
-----------------------------------------------------------------------------------
function private.zz_wallmap.DrawScene()
  
  for i = 1, #private.zz_wallmap.state, 1 do
    
    if private.zz_wallmap.state[i] == i then
      ObjSet("spr_wallmap_figure_"..private.zz_wallmap.state[i].."_win",  { alp = 1 });
    else 
      ObjSet("spr_wallmap_figure_"..private.zz_wallmap.state[i].."_win",  { alp = 0 });
    end;
    
    ObjSet("spr_wallmap_figure_"..private.zz_wallmap.state[i],  { pos_x = private.zz_wallmap.fig_pos[i][1],
                                                                  pos_y = private.zz_wallmap.fig_pos[i][2] });
    
  end;
                                                                          
  if private.zz_wallmap.selected_figure ~= 0 then
    ObjSet("spr_wallmap_figure_"..private.zz_wallmap.selected_figure.."_select",  { alp = 1 });
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_wallmap.FocusFigurine( fig, inout )

  local obj = "spr_wallmap_figure_"..fig.."_light";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.13 then
      cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_menter1");
    end;
  end;
  
  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });

end;
-----------------------------------------------------------------------------------
function public.zz_wallmap.ChooseFigurine( num )
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_bedroom/audio/aud_xx_clk_detail");
  
  if private.zz_wallmap.selected_figure ~= 0 then

    --cancel selection
    if private.zz_wallmap.selected_figure == num then

      private.zz_wallmap.selected_figure = 0;
      private.zz_wallmap.SelectAnim( num, 0 );

    --switch items
    else

      local old = private.zz_wallmap.selected_figure;
      private.zz_wallmap.selected_figure = 0;
      private.zz_wallmap.SwitchAnim( old, num  );

    end;

  --first selected
  else 

    private.zz_wallmap.selected_figure = num;
    private.zz_wallmap.SelectAnim( num, 1 );

  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_wallmap.SwitchAnim( num1, num2 )

  private.zz_wallmap.in_fly = true;

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/rm_bedroom/audio/aud_xx_move_detail");

  private.zz_wallmap.SelectAnim( num1, 0 );

  local ind1 = private.zz_wallmap.FindIndex(num1);
  local ind2 = private.zz_wallmap.FindIndex(num2);

  local temp = private.zz_wallmap.state[ind1];
  private.zz_wallmap.state[ind1] = private.zz_wallmap.state[ind2];
  private.zz_wallmap.state[ind2] = temp;
  
  local func_after = function ()
  
    ObjAttach("spr_wallmap_figure_"..num1, "obj_wallmap_game");
    ObjAttach("spr_wallmap_figure_"..num2, "obj_wallmap_game");
    
  end;

  ObjAttach("spr_wallmap_figure_"..num1, "obj_wallmap_game_fly");
  ObjAttach("spr_wallmap_figure_"..num2, "obj_wallmap_game_fly");
  
  ObjAnimate("spr_wallmap_figure_"..num1, "pos_xy", 0, 0, func_after, { 0, 0, private.zz_wallmap.fig_pos[ind1][1], private.zz_wallmap.fig_pos[ind1][2], 
                                                                      0.5, 0, private.zz_wallmap.fig_pos[ind2][1], private.zz_wallmap.fig_pos[ind2][2] });

  ObjAnimate("spr_wallmap_figure_"..num2, "pos_xy", 0, 0, "", { 0, 0, private.zz_wallmap.fig_pos[ind2][1], private.zz_wallmap.fig_pos[ind2][2], 
                                                              0.5, 0, private.zz_wallmap.fig_pos[ind1][1], private.zz_wallmap.fig_pos[ind1][2] });

  ObjSet("tmr_wallmap_timer",  { time = 0.5, playing = 1, endtrig = function() private.zz_wallmap.CheckPlace( ind1, ind2 ); end });

end;
-----------------------------------------------------------------------------------
function private.zz_wallmap.FindIndex( num )

  local ind = 0;

  for i = 1, #private.zz_wallmap.state, 1 do
  
    if private.zz_wallmap.state[i] == num then
      ind =  i;
      break;
    end;
    
  end;

  return ind;

end;
-----------------------------------------------------------------------------
function private.zz_wallmap.SelectAnim( num, inout )

  local name = "spr_wallmap_figure_"..num.."_select";
  local cur_alp = ObjGet(name).alp;

  local ind = private.zz_wallmap.FindIndex( num );

  if inout == 1 then

    ObjAnimate( name, "alp", 0, 0, "", { 0, 2, 0,   0.2, 2, 1 });

  elseif inout == 0 then

    ObjAnimate( name, "alp", 0, 0, "", { 0, 0, cur_alp,   0.2, 0, 0 });

  end;

end;
-----------------------------------------------------------------------------------
function private.zz_wallmap.CheckPlace( num1, num2 )
  
  local wait = false;
  local snd = false;
  
  if private.zz_wallmap.state[num1] == num1 then
    wait = true;
    snd = true;
    cmn.PlayAudio("snd", "assets/levels/level1/rm_bedroom/audio/aud_right_act2");
    ObjAnimate("spr_wallmap_figure_"..num1.."_win", "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 1 });
  elseif private.zz_wallmap.state[num2] == num1 then
    wait = true;
    ObjAnimate("spr_wallmap_figure_"..num1.."_win", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 });
  end;
  
  if private.zz_wallmap.state[num2] == num2 then
    wait = true;
    if not snd then
      cmn.PlayAudio("snd", "assets/levels/level1/rm_bedroom/audio/aud_right_act2");
    end;
    ObjAnimate("spr_wallmap_figure_"..num2.."_win", "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 1 });
  elseif private.zz_wallmap.state[num1] == num2 then
    wait = true;
    ObjAnimate("spr_wallmap_figure_"..num2.."_win", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 });
  end;
  
  if wait then
    ObjSet("tmr_wallmap_timer",  { time = 0.2, playing = 1, endtrig = private.zz_wallmap.CheckWin });
  else 
    private.zz_wallmap.CheckWin();
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_wallmap.CheckWin()

  private.zz_wallmap.in_fly = false;
  
  local win_flag = true;

  for i = 1, #private.zz_wallmap.state, 1 do

    if private.zz_wallmap.state[i] ~= i then

      win_flag = false;
      break;

    end;

  end;

  if win_flag then

    cmn.Lock(1);
    common_impl.PauseAchiev(1);
    
    cmn.MiniGameHide("wallmap");

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_bedroom/audio/aud_opn_map_wall");
    
    for i = 1, 3, 1 do
      ObjAttach("spr_wallmap_figure_"..i, "obj_wallmap_game_1");
    end;
    for i = 4, 6, 1 do
      ObjAttach("spr_wallmap_figure_"..i, "obj_wallmap_game_2");
    end;
    
    ObjSet("obj_wallmap_niche",  { alp = 1 });

    ObjAnimate("obj_wallmap_game_1", "pos_x", 0, 0, "", { 0, 0, 0,   1, 0, 0,   2, 0, -172 });
    ObjAnimate("obj_wallmap_game_2", "pos_x", 0, 0, "", { 0, 0, 0,   1, 0, 0,   2, 0, 66 });
    ObjAnimate("spr_wallmap_map_left", "pos_x", 0, 0, "", { 0, 0, -101,   1, 0, -101,   2, 0, -273 });
    ObjAnimate("spr_wallmap_map_right", "pos_x", 0, 0, private.zz_wallmap.Win, { 0, 0, 120,   1, 0, 120,   2, 0, 186 });

  else

    cmn.Lock( 0 );

  end;

end;
-----------------------------------------------------------------------------------
function private.zz_wallmap.Win()

  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_wallmap" );
  cmn.CallEventHandler( "win_wallmap" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_wallmap" ].skip == 0 and ng_global.noskipgames[ "win_wallmap" ] == nil then

    ng_global.noskipgames[ "win_wallmap" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

  cmn.Lock( 0 );
  --cmn.PlayAudio("mus", "assets/levels/common/audio/");

end;
--*********************************************************************************************************************