-- name=rm_demoscreen
--*********************************************************************************************************************
function public.Init()


end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()

  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_music_theme", 1);

end;
--*********************************************************************************************************************
function public.PreOpen()

  interface.InterfaceSetVisible( false, false );
  interface.InterfaceSetInput(0);

  cmn.StopAllEnv();

  if IsCollectorsEdition() then
    ObjSet("spr_demoscreen_logo_ce",  { alp = 1 });
  else
    ObjSet("spr_demoscreen_logo_ce",  { alp = 0 });
  end;

  if IsDemoEdition() then
    ObjMultiSet( { {"spr_demoscreen_thankforplaying_survey", { alp = 0 }},
                   {"spr_demoscreen_thankforplaying_demo", { alp = 1 }} } );
  else
    ObjMultiSet( { {"spr_demoscreen_thankforplaying_survey", { alp = 1 }},
                   {"spr_demoscreen_thankforplaying_demo", { alp = 0 }} } );
  end;

  if not IsDemoEdition() and not IsSurveyEdition() then

    cmn.LevelSwitch( "level2", 2 );
    ng_global.progress[ "std" ].common.chapter = "level2";
    ng_global.progress[ "std" ].common.currentroom = "rm_lvl2camera";

  end;

end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  interface.InterfaceSetVisible( true, true );
  interface.InterfaceSetInput(1);
  
  cmn.StopAllMus();

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_demoscreen()

  --if not ( cmn.IsEventDone( "opn_demoscreen" ) ) then
    --cmn.SetEventDone( "opn_demoscreen" );
  --end;

end;
------------------------------------------------------------------------------
function public.Exit()

  --cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_menubuttonpress" );

  if IsSurveyEdition() then

    Quit();

  else

    if cmn.is_inmenunow then

      room.Switch("rm_menu");

    else

      cmn.LevelSwitch( "menu", "game" );

    end;

  end;

end;
------------------------------------------------------------------------------
------------------------------------------------------------------------------
function public.MouseEnter( num )

  SetCursor( CURSOR_LOUPE );
  local obj = "spr_demoscreen_pic"..num;

  ObjAnimate( obj, 8,0,0, "", { 0,0,ObjGet( obj ).alp, 0.3,0,1 } );

end;

function public.MouseLeave( num )

  SetCursor( CURSOR_DEFAULT );
  local obj = "spr_demoscreen_pic"..num;

  ObjAnimate( obj, 8,0,0, "", { 0,0,ObjGet( obj ).alp, 0.3,0,0 } );

end;
------------------------------------------------------------------------------
function public.picture_clk( num )

  --cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_menubuttonpress" );

  ObjSet( "spr_demoscreen_bigpic"..num, { input = 1 } );
  ObjAnimate( "spr_demoscreen_bigpic"..num, "alp",0,0, "", { 0, 0, 0,
                                                             0.5, 0, 1 } );

end;

function public.bigpicture_clk( num )

  local end_trig = function () ObjSet( 'obj_demoscreen_lock', { input = 0 } ); end;
  ObjSet( "obj_demoscreen_lock", { input = 1 } );
  ObjSet( "spr_demoscreen_bigpic"..num, { input = 0 } );
  ObjAnimate( "spr_demoscreen_bigpic"..num, "alp",0,0, end_trig, { 0, 0, ObjGet("spr_demoscreen_bigpic"..num).alp,
                                                             0.5, 0, 0 } );

end;
------------------------------------------------------------------------------
function public.MouseEnterBig( num )

  SetCursor( CURSOR_DOWN );

end;

function public.MouseLeaveBig( num )

  SetCursor( CURSOR_DEFAULT );

end;
------------------------------------------------------------------------------
-----------------------------------------------------------------------------
--подсветка перехода в меню
function  public.ExitEnter( sender, cursor )

  local obj = sender;

  --if obj == "obj_demoscreen_gotosecretroom" then
  --  obj = "spr_demoscreen_visit";
  --end;

  local alp = ObjGet( obj.."_focus" ).alp;

  local tme = 0.3;

  ObjAnimate(obj.."_focus", "alp",0,0, "", { 0,0,alp, tme,0,1 });

  SetCursor( cursor );

end
------------------------------------------------------------------------------
--снятие подсветки перехода в меню
function  public.ExitLeave(sender)

  local obj = sender;

  --if obj == "obj_demoscreen_gotosecretroom" then
  --  obj = "spr_demoscreen_visit";
  --end;

  local alp = ObjGet( obj.."_focus" ).alp;

  local tme = 0.3;

  ObjAnimate(obj.."_focus", "alp",0,0, "", { 0,0,alp, tme,0,0 });

  SetCursor(CURSOR_DEFAULT);

end
--*********************************************************************************************************************
