-- name=rm_doctorstudy
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_doctorstudy";
  --------------------------------------------------------------------------------------------
  private.dlg_lipsync = "";
  private.dlg_finished = true;
  private.Init_Subroom();
  private.Init_Cardregister();
  --------------------------------------------------------------------------------------------
  -- function get_goldenring () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_goldenring" ] = {
      type = "get",
      get_obj = "spr_hygeastatuette_goldenring",
      room = private.room_objname,
      zz = "zz_hygeastatuette",
      zz_gate = "gzz_doctorstudy_hygeastatuette"
  };
  --------------------------------------------------------------------------------------------
  local get_goldenring_inv = function ()
  
    interface.InventoryItemAdd( "inv_goldenring", "spr_hygeastatuette_goldenring" );
  
  end;
  local get_goldenring_end = function ()
  
    ObjSet("spr_hygeastatuette_cardregistercypher",  { input = 1 });
  
    ObjDelete( "gfx_hygeastatuette_goldenring" );
    ObjDelete( "spr_hygeastatuette_goldenring_sh" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_goldenring", get_goldenring_inv );
  cmn.AddSubscriber( "get_goldenring", get_goldenring_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cardregistercypher () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_cardregistercypher" ] = {
      type = "get",
      get_obj = "spr_hygeastatuette_cardregistercypher",
      room = private.room_objname,
      zz = "zz_hygeastatuette",
      zz_gate = "gzz_doctorstudy_hygeastatuette"
  };
  --------------------------------------------------------------------------------------------
  local get_cardregistercypher_inv = function ()
  
    interface.InventoryItemAdd( "inv_cardregistercypher", "spr_hygeastatuette_cardregistercypher" );
  
  end;
  local get_cardregistercypher_end = function ()
  
    ObjDelete( "gfx_hygeastatuette_cardregistercypher" );
    
    ObjDelete( "gzz_doctorstudy_hygeastatuette" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_cardregistercypher", get_cardregistercypher_inv );
  cmn.AddSubscriber( "get_cardregistercypher", get_cardregistercypher_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hygeacup () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_hygeacup" ] = {
      type = "get",
      get_obj = "spr_cardregister_hygeacup",
      room = private.room_objname,
      zz = "zz_cardregister",
      zz_gate = "gzz_doctorstudy_cardregister"
  };
  --------------------------------------------------------------------------------------------
  local get_hygeacup_inv = function ()
  
    interface.InventoryItemAdd( "inv_hygeacup", "spr_cardregister_hygeacup" );
  
  end;
  local get_hygeacup_end = function ()
  
    ObjDelete( "spr_doctorstudy_register_cup" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_hygeacup", get_hygeacup_inv );
  cmn.AddSubscriber( "get_hygeacup", get_hygeacup_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_folder () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_folder" ] = {
      type = "get",
      get_obj = "spr_cardregister_folder",
      room = private.room_objname,
      zz = "zz_cardregister",
      zz_gate = "gzz_doctorstudy_cardregister"
  };
  --------------------------------------------------------------------------------------------
  local get_folder_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_folder", "spr_cardregister_folder" );
  
  end;
  local get_folder_end = function ()
  
    ObjDelete( "gfx_cardregister_folder" );
    ObjDelete( "spr_doctorstudy_register_case" );
    ObjDelete( "gzz_doctorstudy_cardregister" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_folder", get_folder_inv );
  cmn.AddSubscriber( "get_folder", get_folder_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cane () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_cane" ] = {
      type = "get",
      get_obj = "spr_closetdoor_cane",
      room = private.room_objname,
      zz = "zz_closetdoor",
      zz_gate = "gzz_doctorstudy_closetdoor"
  };
  --------------------------------------------------------------------------------------------
  local get_cane_inv = function ()
  
    interface.InventoryItemAdd( "inv_cane", "spr_closetdoor_cane" );
  
  end;
  local get_cane_end = function ()
  
    ObjSet("obj_closetdoor_use_closetroom",  { input = 1 });
  
    ObjDelete( "gfx_closetdoor_cane" );
    ObjDelete( "spr_closetdoor_door_handle" );
    ObjDelete( "spr_closetdoor_cane_sh" );
    
    ObjDelete( "spr_doctorstudy_closet_cane" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_cane", get_cane_inv );
  cmn.AddSubscriber( "get_cane", get_cane_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_hygeacup () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hygeacup" ] = {
      type = "use",
      inv_obj = "inv_hygeacup",
      use_place = "obj_hygeastatuette_use_hygeacup",
      room = private.room_objname,
      zz = "zz_hygeastatuette",
      zz_gate = "gzz_doctorstudy_hygeastatuette"
  };
  --------------------------------------------------------------------------------------------
  local use_hygeacup_inv = function ()
  
    interface.InventoryItemRemove( "inv_hygeacup" );
  
  end;
  local use_hygeacup_beg = function ()
  
    ObjDelete( "obj_hygeastatuette_use_hygeacup" );
    ObjDelete( "obj_hygeastatuette_touch_snake" );
    
  end;
  local use_hygeacup_end = function ()
  
    ObjMultiSet( { {"anm_hygeastatuette_use_cup", { alp = 1, input = 1, frame = 400 }},
                   {"spr_doctorstudy_hygea_cup", { alp = 1 }} } );
    
    ObjDelete( "spr_hygeastatuette_cup" );
    ObjDelete( "anm_hygeastatuette_touch_cup" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hygeacup", use_hygeacup_beg, private.room_objname );
  cmn.AddSubscriber( "use_hygeacup", use_hygeacup_inv );
  cmn.AddSubscriber( "use_hygeacup", use_hygeacup_end, private.room_objname );
  cmn.AddSubscriber( "use_hygeacup_inv", use_hygeacup_inv, private.room_objname );
  cmn.AddSubscriber( "use_hygeacup_beg", use_hygeacup_beg, private.room_objname );
  cmn.AddSubscriber( "use_hygeacup_end", use_hygeacup_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cardregistercypher () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_cardregistercypher" ] = {
      type = "use",
      inv_obj = "inv_cardregistercypher",
      use_place = "obj_cardregister_use_cardregistercypher",
      room = private.room_objname,
      zz = "zz_cardregister",
      zz_gate = "gzz_doctorstudy_cardregister"
  };
  --------------------------------------------------------------------------------------------
  local use_cardregistercypher_inv = function ()
  
    interface.InventoryItemRemove( "inv_cardregistercypher" );
  
  end;
  local use_cardregistercypher_beg = function ()
  
    ObjDelete( "obj_cardregister_use_cardregistercypher" );
  
  end;
  local use_cardregistercypher_end = function ()
    
    ObjMultiSet( { {"obj_cardregister_game", { input = 1 }},
                   {"spr_cardregister_card", { alp = 1 }},
                   {"obj_cardregister_touch_drawer", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cardregistercypher", use_cardregistercypher_beg, private.room_objname );
  cmn.AddSubscriber( "use_cardregistercypher", use_cardregistercypher_inv );
  cmn.AddSubscriber( "use_cardregistercypher", use_cardregistercypher_end, private.room_objname );
  cmn.AddSubscriber( "use_cardregistercypher_inv", use_cardregistercypher_inv, private.room_objname );
  cmn.AddSubscriber( "use_cardregistercypher_beg", use_cardregistercypher_beg, private.room_objname );
  cmn.AddSubscriber( "use_cardregistercypher_end", use_cardregistercypher_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cane () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_cane" ] = {
      type = "use",
      inv_obj = "inv_cane",
      use_place = "obj_cardregister_use_cane",
      room = private.room_objname,
      zz = "zz_cardregister",
      zz_gate = "gzz_doctorstudy_cardregister"
  };
  --------------------------------------------------------------------------------------------
  local use_cane_inv = function ()
  
    interface.InventoryItemRemove( "inv_cane" );
  
  end;
  local use_cane_beg = function ()
  
    ObjDelete( "obj_cardregister_use_cane" );
    ObjDelete( "anm_cardregister_touch_cup" );
  
  end;
  local use_cane_end = function ()
  
    --ObjSet( "spr_cardregister_hygeacup", { input = 1, alp = 1 } );
    ObjDelete( "anm_cardregister_use_cane" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cane", use_cane_beg, private.room_objname );
  cmn.AddSubscriber( "use_cane", use_cane_inv );
  cmn.AddSubscriber( "use_cane", use_cane_end, private.room_objname );
  cmn.AddSubscriber( "use_cane_inv", use_cane_inv, private.room_objname );
  cmn.AddSubscriber( "use_cane_beg", use_cane_beg, private.room_objname );
  cmn.AddSubscriber( "use_cane_end", use_cane_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_closetroom () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_closetroom" ] = {
      type = "use",
      inv_obj = "inv_closetroom",
      use_place = "obj_closetdoor_use_closetroom",
      room = private.room_objname,
      zz = "zz_closetdoor",
      zz_gate = "gzz_doctorstudy_closetdoor"
  };
  --------------------------------------------------------------------------------------------
  local use_closetroom_inv = function ()
  
    interface.InventoryItemRemove( "inv_closetroom" );
  
  end;
  local use_closetroom_beg = function ()
  
    ObjDelete( "obj_closetdoor_use_closetroom" );
  
  end;
  local use_closetroom_end = function ()
  
    ObjMultiSet( { {"spr_closetdoor_key_1", { alp = 1 }},
                   {"obj_closetdoor_clk_closetroom", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_closetroom", use_closetroom_beg, private.room_objname );
  cmn.AddSubscriber( "use_closetroom", use_closetroom_inv );
  cmn.AddSubscriber( "use_closetroom", use_closetroom_end, private.room_objname );
  cmn.AddSubscriber( "use_closetroom_inv", use_closetroom_inv, private.room_objname );
  cmn.AddSubscriber( "use_closetroom_beg", use_closetroom_beg, private.room_objname );
  cmn.AddSubscriber( "use_closetroom_end", use_closetroom_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_hanger () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_hanger" ] = {
    type = "click",
    use_place = "obj_doctorstudy_hunter_touch",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_hanger_task = function ()
    interface_impl.SetCurrentGlobalTask( 1 );
  end;
  local clk_hanger_beg = function ()
  
    ObjDelete( "obj_doctorstudy_hunter_touch" );
  
  end;
  local clk_hanger_end = function ()
  
    ObjDelete( "obj_doctorstudy_hanger_inhand" );
    ObjDelete( "obj_doctorstudy_clk_hangerempty" );
    ObjDelete( "tmr_doctorstudy_timer_hanger" );
    ObjDelete( "anm_doctorstudy_hunter" );
    ObjDelete( "anm_doctorstudy_hunter_touch" );
  
    ObjMultiSet( { {"gzz_doctorstudy_hygeastatuette", { alp = 1, input = 1, active = 1 }},
                   {"gzz_doctorstudy_cardregister", { alp = 1, input = 1, active = 1 }},
                   {"gzz_doctorstudy_closetdoor", { alp = 1, input = 1, active = 1 }},
                   {"spr_bonus_1", { alp = 1, input = 1 }},
                   {"obj_col_1", { input = 1 }},
                   {"spr_doctorstudy_hanger_2", { alp = 1 }},
                   {"spr_doctorstudy_broken_window", { alp = 1 }},
                   {"spr_doctorstudy_window_shards", { alp = 1 }},
                   {"obj_doctorstudy_window_bbt", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_hanger", clk_hanger_beg, private.room_objname );
  cmn.AddSubscriber( "clk_hanger", clk_hanger_end, private.room_objname );
  cmn.AddSubscriber( "clk_hanger_beg", clk_hanger_beg, private.room_objname );
  cmn.AddSubscriber( "clk_hanger_end", clk_hanger_end, private.room_objname );
  cmn.AddSubscriber( "clk_hanger", clk_hanger_task );
  cmn.AddSubscriber( "clk_hanger_task", clk_hanger_task );
  --------------------------------------------------------------------------------------------
  -- function clk_hunterhit1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_hunterhit1" ] = {
    type = "click",
    use_place = "obj_doctorstudy_hunter_touch",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_hunterhit1 = function ()
  
    ObjDelete( "anm_doctorstudy_hunter_hit_1" );
    ObjDelete("anm_doctorstudy_hunter_hit_1");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_hunterhit1", clk_hunterhit1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_hunterhit2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_hunterhit2" ] = {
    type = "click",
    use_place = "obj_doctorstudy_hunter_touch",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_hunterhit2 = function ()
  
    ObjDelete( "anm_doctorstudy_hunter_hit_2" );
    ObjDelete("anm_doctorstudy_hunter_hit_2");
    ObjSet("obj_doctorstudy_hunter_touch",  { event_mup = rm_doctorstudy.clk_hanger });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_hunterhit2", clk_hunterhit2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_hangerget () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_hangerget" ] = {
    type = "click",
    use_place = "obj_doctorstudy_clk_hanger",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_hangerget = function ()
  
    ObjDelete( "spr_doctorstudy_hanger_1" );
    ObjDelete( "obj_doctorstudy_clk_hanger" );

    ObjMultiSet( { {"obj_doctorstudy_hanger_inhand",  { alp = 1 }},
                   {"obj_doctorstudy_hunter_touch", { input = 1 }},
                   {"obj_doctorstudy_clk_hangerempty", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_hangerget", clk_hangerget, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_closetroom () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_closetroom" ] = {
    type = "click",
    use_place = "obj_closetdoor_clk_closetroom",
    room = private.room_objname,
    zz = "zz_closetdoor",
    zz_gate = "gzz_doctorstudy_closetdoor"
  };
  --------------------------------------------------------------------------------------------
  local clk_closetroom_beg = function ()
  
    ObjDelete( "obj_closetdoor_clk_closetroom" );
  
  end;
  local clk_closetroom_end = function ()
  
    ObjMultiSet( { {"gho_doctorstudy_debris", { alp = 1, input = 1, active = 1 }},
                   {"spr_doctorstudy_closet_open", { alp = 1 }} } );
    
    ObjDelete( "gzz_doctorstudy_closetdoor" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_closetroom", clk_closetroom_beg, private.room_objname );
  cmn.AddSubscriber( "clk_closetroom", clk_closetroom_end, private.room_objname );
  cmn.AddSubscriber( "clk_closetroom_beg", clk_closetroom_beg, private.room_objname );
  cmn.AddSubscriber( "clk_closetroom_end", clk_closetroom_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_folder1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_folder1" ] = {
    type = "click",
    use_place = "obj_cardregister_clk_folder1",
    room = private.room_objname,
    zz = "zz_cardregister",
    zz_gate = "gzz_doctorstudy_cardregister"
  };
  --------------------------------------------------------------------------------------------
  local clk_folder1_beg = function ()
  
    ObjDelete( "obj_cardregister_clk_folder1" );
  
  end;
  local clk_folder1_end = function ()
  
    ObjSet( "obj_cardregister_clk_folder2", { input = 1 } );
    ObjDelete( "spr_cardregister_folder_1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_folder1", clk_folder1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_folder1", clk_folder1_end, private.room_objname );
  cmn.AddSubscriber( "clk_folder1_beg", clk_folder1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_folder1_end", clk_folder1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_folder2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_folder2" ] = {
    type = "click",
    use_place = "obj_cardregister_clk_folder2",
    room = private.room_objname,
    zz = "zz_cardregister",
    zz_gate = "gzz_doctorstudy_cardregister"
  };
  --------------------------------------------------------------------------------------------
  local clk_folder2_beg = function ()
  
    ObjDelete( "obj_cardregister_clk_folder2" );
  
  end;
  local clk_folder2_end = function ()
  
    ObjSet( "spr_cardregister_folder", { input = 1 } );
    ObjDelete( "spr_cardregister_folder_2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_folder2", clk_folder2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_folder2", clk_folder2_end, private.room_objname );
  cmn.AddSubscriber( "clk_folder2_beg", clk_folder2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_folder2_end", clk_folder2_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function beg_level1 () end;
  --------------------------------------------------------------------------------------------
  local beg_level1 = function ()
  
    int_map_impl.OpenRoom( "rm_doctorstudy" );
    interface_impl.SetCurrentGlobalTask( 7 );
    ng_global.new_hint = false;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "beg_level1", beg_level1 );
  --------------------------------------------------------------------------------------------
  -- function opn_doctorstudyafterho () end;
  --------------------------------------------------------------------------------------------
  local opn_doctorstudyafterho = function ()
  
    ObjDelete("obj_doctorstudy_dialog_doctor");
    ObjDelete("vid_doctorstudy_dialog_doctor_lipsync_2");
    ObjDelete("vid_doctorstudy_dialog_doctor_lipsync_3");
    ObjDelete("vid_doctorstudy_dialog_doctor_idle");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_doctorstudyafterho", opn_doctorstudyafterho, private.room_objname );

  if port.ios_lang() == "ja" then
    ObjSet("txt_cardregister_disease_3_2",{ fontsize = 18 });
    ObjSet("txt_cardregister_disease_4_2",{ fontsize = 18 });
    ObjSet("txt_cardregister_case_name_1",{ fontsize = 14 });
    ObjSet("txt_cardregister_case_name_2",{ fontsize = 14 });
    ObjSet("txt_cardregister_case_name_3",{ fontsize = 14 });
    ObjSet("txt_cardregister_disease_3_1",{ fontsize = 14 });
    ObjSet("txt_cardregister_disease_4_1",{ fontsize = 14 });
  end;
  
  if port.ios_lang() == "ru" then
    ObjSet("txt_cardregister_disease_2_1",{ fontsize = 15 });
    ObjSet("txt_cardregister_disease_2_2",{ fontsize = 20 });
    ObjSet("txt_cardregister_case_name_2",{ fontsize = 20 });
    ObjSet("txt_cardregister_case_name_3",{ fontsize = 20 });
  end;
  
  if port.ios_lang() == "de" then
    ObjSet("txt_cardregister_disease_3_1",{ fontsize = 14 });
  end;
  
  if port.ios_lang() == "fr" then
    ObjSet("txt_cardregister_disease_3_1",{ fontsize = 14 });
  end;
  
  
end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_cardregister" );
  subroom.Define( "zz_closetdoor" );
  
  function zz_cardregister.PreOpen()
    
    cmn.Lock(1);
    private.zz_cardregister.DrawScene();
    
    if cmn.IsEventDone("tutor_1") and not cmn.IsEventDone("tutor_4") then
    
      if not(( ng_global.gamemode < 1 ) or ( ng_global.gamemode == 3 and ng_global.custom_gamemode.tutorial == 1 )) then
        cmn.SetEventDone("opn_cardregister");
      end;
      
    elseif cmn.IsEventDone("tutor_4") and not cmn.IsEventDone("opn_cardregister") then
      
      cmn.SetEventDone("opn_cardregister");
      
    end;
      
  end;
  
  function zz_cardregister.Open()
    
    cmn.Lock(0);
    
    if ( cmn.IsEventDone( "use_cardregistercypher" ) and not(cmn.IsEventDone( "win_cardregister" )) ) then
      
      cmn.MiniGameShow();
      private.zz_cardregister.CheckWin();
      
      if not(cmn.IsEventDone("tutor_13")) then

        local arrows = { { pos_x = 320, pos_y = 0, ang = -1.57 }, { pos_x = 300, pos_y = 120, ang = -2.6 } };

        if ( GetWideScreen() ) then

          ObjMultiSet( { {"obj_tutorial_tutor_13", { pos_x = -600 }},
                         {"obj_tutorial_tutor_13_1", { pos_x = 1127 }} } );

          arrows[1] = { pos_x = 400, pos_y = 0, ang = -1.57 };

          cmn.TutorialShow( "tutor_13", 0, 600, 511, arrows );

        else 

          ObjMultiSet( { {"obj_tutorial_tutor_13", { pos_x = -512 }},
                         {"obj_tutorial_tutor_13_1", { pos_x = 956 }} } );

          arrows[2] = { pos_x = 400, pos_y = 120, ang = -2.6 };

          cmn.TutorialShow( "tutor_13", 0, 512, 511, arrows );

        end;

      end;
      
    end;
    
    if not( cmn.IsEventDone( "tutor_1" )) then
      local arrows = { { pos_x = 0, pos_y = -180, ang = 0 } };
      cmn.TutorialShow( "tutor_1", 0, 600, 330, arrows );
    end;
    
    if ( ng_global.gamemode < 1 ) or ( ng_global.gamemode == 3 and ng_global.custom_gamemode.tutorial == 1 ) then
    
      if cmn.IsEventDone("tutor_1") and not cmn.IsEventDone("tutor_4") then
        
        if not cmn.IsEventDone("opn_cardregister") then

          local func_after = function ()
            cmn.SetEventDone("opn_cardregister");
          end;

          ObjSet("tmr_cardregister_timer",  { time = 0.31, playing = 1, endtrig = func_after });

        end;
        
        if cmn.IsEventDone("get_cane") and not cmn.IsEventDone("use_cane") and not(common_impl.go_acievements) then
        
          if not common_impl.CheckScrollSubroomHintPos("zz_cardregister", 2, "obj_cardregister_use_cane") then
            public.ShowTutor4();
          else 
            common_impl.ScrollSubroom();
          end;

        end;
        
      end;
      
    end;
      
  end;
  
  function zz_cardregister.PreClose()
    
    if ( cmn.IsEventDone( "use_cardregistercypher" ) and not(cmn.IsEventDone( "win_cardregister" )) ) then
      cmn.MiniGameHide("cardregister");
    end;

  end;
  
  function zz_cardregister.Scroll( type )

    if type == "up" then
      
      if cmn.IsEventDone("tutor_1") and not cmn.IsEventDone("tutor_4") then
        
        if cmn.IsEventDone("get_cane") and not cmn.IsEventDone("use_cane") and not(common_impl.go_acievements) then

          cmn.SetEventDone("opn_cardregister");
          public.ShowTutor4();

        end;
        
      end;
      
    end;

  end;
  
  function zz_closetdoor.Open()

    if not( cmn.IsEventDone( "tutor_3" )) and not cmn.IsEventDone("get_cane") then
      local arrows = { { pos_x = 320, pos_y = 100, ang = -2.3 } };
      cmn.TutorialShow( "tutor_3", 0, 300, 220, arrows );
    end;

  end;
  
  function zz_closetdoor.Close()

    if cmn.IsEventDone("clk_closetroom") then

      local arrows = { { pos_x = 320, pos_y = 0, ang = -1.57 } };
      cmn.TutorialShow( "tutor_5", 0, 512, 340, arrows );

    end;

  end;

end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_cardregister" ].state) then 
    private.zz_cardregister.StartConditions();
  end;

  private.zz_cardregister.state = ng_global.progress[ ng_global.currentprogress ][ "win_cardregister" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()
  
  if cmn.IsEventDone( "beg_level1" ) and not cmn.IsEventDone("clk_hanger") then
    
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_danger_track1_mus_env", 1);

  end;

  private.opn_doctorstudy();
  
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  if not ( cmn.IsEventDone( "beg_level1" ) ) then

    cmn.Lock(1);
    cmn.StopAllEnv();
    
    interface.WidgetSetVisible( "InterfaceWidget_Inventory", false, false );
    interface.WidgetSetInput( "InterfaceWidget_Inventory", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnHint", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnHint", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnGuide", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnGuide", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnMenu", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnMenu", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnMap", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnMap", 0 );

    ObjSet("rm_doctorstudy",  { color_r = 0, color_g = 0, color_b = 0 });
    
  else
    
    if cmn.IsEventDone("clk_hanger") then
      cmn.StopAllEnv("assets/levels/common/audio/aud_doctorstudy_env");
      cmn.PlayAudio("env", "assets/levels/common/audio/aud_doctorstudy_env");
    else 
      cmn.StopAllEnv("assets/levels/common/audio/aud_debris_env");
      cmn.PlayAudio("env", "assets/levels/common/audio/aud_debris_env");
    end;

  end;
  
  if cmn.IsEventDone("clk_hangerget") and not cmn.IsEventDone("clk_hanger") then
    private.drag_hanger();
  end;
  
  if cmn.IsEventDone("clk_hanger") then
    ObjSet("anm_doctorstudy_curtain",  { playing = 1 });
  end;
  
  if cmn.IsEventDone("opn_doctorstudyafterho") and private.dlg_finished then
    common_impl.current_dialog = "";
    cmn.Lock(1);
    cmn.StopAllEnv();
  end;
  
  if cmn.IsEventDone("win_debris") and not cmn.IsEventDone( "opn_doctorstudyafterho" ) then
    
    cmn.Lock(1);
    ObjAttach("obj_doctorstudy_dialog_doctor", "rm_doctorstudy");
    
  end;
  
  --анимация морф-оъекта
  if cmn.IsEventDone( "clk_hanger" ) and cmn.IsCollectableAvailible(1) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  
  SndStop( common_impl.audio.voc, 0.5 );
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_hygeacup()

  local item = "inv_hygeacup";

  if cmn.ApplyObj( item, "gzz_doctorstudy_hygeastatuette" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_hygeastatuette" );

  elseif ( cmn.ApplyObj( item, "obj_hygeastatuette_use_hygeacup" ) ) then

    cmn.CallEventHandler( "use_hygeacup_inv" );
    cmn.CallEventHandler( "use_hygeacup_beg" );
    
    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_hygeacup" );
      cmn.CallEventHandler( "use_hygeacup_end" );
      
    end;
    
    local anim_water = function ()
      
      ObjDelete( "spr_hygeastatuette_cup" );
      ObjDelete( "anm_hygeastatuette_touch_cup" );
      ObjSet("anm_hygeastatuette_use_cup", { alp = 1, playing = 1, endtrig = func_after });
  
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_use_bowl");

    ObjAnimate("spr_hygeastatuette_cup", "alp", 0, 0, anim_water, { 0, 0, 0,   0.5, 0, 1,   0.8, 0, 1 });
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_cardregistercypher()

  local item = "inv_cardregistercypher";
  local scroll = common_impl.CheckScrollSubroomHintPos("zz_cardregister", 2, "obj_cardregister_use_cardregistercypher");

  if cmn.ApplyObj( item, "gzz_doctorstudy_cardregister" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cardregister" );
    
  elseif (ObjIntersect( item, "obj_int_frame_subroom_frame_gate_bot" ) or ObjIntersect( item, "obj_int_frame_subroom_frame_button_down" )) and scroll then
    
    --interface.ObjDoNotDrop();
    common_impl.ScrollSubroom();

  elseif ( cmn.ApplyObj( item, "obj_cardregister_use_cardregistercypher" ) and not scroll ) then

    cmn.CallEventHandler( "use_cardregistercypher_inv" );
    cmn.CallEventHandler( "use_cardregistercypher_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_cardregistercypher" );
      cmn.CallEventHandler( "use_cardregistercypher_end" );
      
      cmn.MiniGameShow();
      
      if not(cmn.IsEventDone("tutor_13")) then

        local arrows = { { pos_x = 320, pos_y = 0, ang = -1.57 }, { pos_x = 300, pos_y = 120, ang = -2.6 } };

        if ( GetWideScreen() ) then

          ObjMultiSet( { {"obj_tutorial_tutor_13", { pos_x = -600 }},
                         {"obj_tutorial_tutor_13_1", { pos_x = 1127 }} } );

          arrows[1] = { pos_x = 400, pos_y = 0, ang = -1.57 };

          cmn.TutorialShow( "tutor_13", 0, 600, 511, arrows );

        else 

          ObjMultiSet( { {"obj_tutorial_tutor_13", { pos_x = -512 }},
                         {"obj_tutorial_tutor_13_1", { pos_x = 956 }} } );

          arrows[2] = { pos_x = 400, pos_y = 120, ang = -2.6 };

          cmn.TutorialShow( "tutor_13", 0, 512, 511, arrows );

        end;

      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_use_small_paper");

    ObjAnimate( "spr_cardregister_card", "alp", 0, 0, func_after,
    {
      0.0, 0, 0, 
      0.3, 0, 1
    } );
    
  elseif common.GetCurrentSubRoom() == "zz_cardregister" and scroll then

    common_impl.HintShowPlace( scroll, "", false, true );
    cmn.WrongApply(); 

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_cane()

  local item = "inv_cane";
  local scroll = common_impl.CheckScrollSubroomHintPos("zz_cardregister", 2, "obj_cardregister_use_cane");
  
  interface.PopupHide();

  if cmn.ApplyObj( item, "gzz_doctorstudy_cardregister" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cardregister" );
    
  elseif ( cmn.ApplyObj( item, "obj_cardregister_use_cane" ) and not scroll and cmn.IsEventDone("opn_cardregister") ) then

    if (( ng_global.gamemode < 1 ) or ( ng_global.gamemode == 3 and ng_global.custom_gamemode.tutorial == 1 ))
    and not cmn.IsEventDone( "tutor_4" ) and common_impl.tutorial.current == "tutor_4" then
      --DbgTrace( "показывается тутор 4" );
      common_impl.Tutorial_Click( "empty" );
    end;

    cmn.CallEventHandler( "use_cane_inv" );
    cmn.CallEventHandler( "use_cane_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_cane" );
      cmn.CallEventHandler( "use_cane_end" );
      
      public.get_hygeacup();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_use_cane");

    ObjSet("anm_cardregister_use_cane",  { alp = 1, playing = 1, endtrig = func_after });
    
  elseif common.GetCurrentSubRoom() == "zz_cardregister" and scroll then

    common_impl.HintShowPlace( scroll, "", false, true );
    
    cmn.WrongApply(); 

  else 

    if (( ng_global.gamemode < 1 ) or ( ng_global.gamemode == 3 and ng_global.custom_gamemode.tutorial == 1 ))
    and not cmn.IsEventDone( "tutor_4" ) and common_impl.tutorial.current == "tutor_4" and cmn.IsEventDone("opn_cardregister") then
      --DbgTrace( "показывается тутор 4" );
      common_impl.Tutorial_Click( "empty" );
    end;

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_closetroom()

  local item = "inv_closetroom";

  if cmn.ApplyObj( item, "gzz_doctorstudy_closetdoor" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_closetdoor" );

  elseif ( cmn.ApplyObj( item, "obj_closetdoor_use_closetroom" ) ) then

    cmn.CallEventHandler( "use_closetroom_inv" );
    cmn.CallEventHandler( "use_closetroom_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_closetroom" );
      cmn.CallEventHandler( "use_closetroom_end" );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_use_key_doctorstudy");

    ObjAnimate( "spr_closetdoor_key_1", "alp", 0, 0, func_after,
    {
      0.0, 0, 0, 
      0.3, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_goldenring()
  
  ObjSet("spr_hygeastatuette_goldenring",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_goldenring" );
  cmn.CallEventHandler( "get_goldenring" );

  --cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_cardregistercypher()

  cmn.SetEventDone( "get_cardregistercypher" );
  cmn.CallEventHandler( "get_cardregistercypher" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  public.get_goldenring();
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_hygeacup()
  
  ObjSet("spr_cardregister_hygeacup",  { alp = 1 });

  cmn.SetEventDone( "get_hygeacup" );
  cmn.CallEventHandler( "get_hygeacup" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_folder()

  cmn.SetEventDone( "get_folder" );
  cmn.CallEventHandler( "get_folder" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common.CloseSubRoom();
  
  ObjAttach("tmr_doctorstudy_timer", "cmn_timers");
  ObjSet("tmr_doctorstudy_timer",  { time = 1, playing = 1, endtrig = private.ShowTutor8 });

end;
--------------------------------------------------------------------------------------------
function public.get_cane()

  cmn.SetEventDone( "get_cane" );
  cmn.CallEventHandler( "get_cane" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_hangerget()
  
  local func_after = function ()
    cmn.SetEventDone("clk_hangerget");
    cmn.CallEventHandler("clk_hangerget");
    cmn.Lock(0);
  end;
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_take_hanger");
  private.drag_hanger();
  
  ObjAnimate("spr_doctorstudy_hanger_1", "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });
  ObjAnimate("obj_doctorstudy_hanger_inhand", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function public.clk_hanger()

  cmn.CallEventHandler( "clk_hanger_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_hanger" );
    cmn.CallEventHandler( "clk_hanger_end" );
    cmn.CallEventHandler("clk_hanger_task");

    --cmn.Lock( 0 );
    interface_impl.ShowGlobalTask();
    
    cmn.ShowBbt( "doctorstudy_after_win_hunter" );
    ObjSet("anm_doctorstudy_curtain",  { playing = 1 });
    
    cmn.TutorialShow("tutor_enable");
    
    cmn.PlayAudio("env", "assets/levels/common/audio/aud_doctorstudy_env");
    
    if cmn.IsCollectableAvailible(1) then
      private.AnimMorphObject();
    end;
    
  end;
  
  --cmn.Lock( 1 );
  ObjSet("tmr_doctorstudy_timer_hanger",  { playing = 0 });

  cmn.StopAllEnv();
  cmn.PlayFullscreenVideo( "assets/levels/level1/rm_doctorstudy/vid_defeatinghuntsman", func_after, "assets/levels/level1/rm_doctorstudy/audio/aud_defeatinghuntsman", "assets/levels/level1/rm_doctorstudy/audio/aud_defeatinghuntsman_voc");

end;
--------------------------------------------------------------------------------------------
function public.clk_closetroom()

  cmn.CallEventHandler( "clk_closetroom_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_closetroom" );
    cmn.CallEventHandler( "clk_closetroom_end" );

    cmn.Lock( 0 );
    
    common.CloseSubRoom();
  
  end;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_clk_key_doctorstudy");

  ObjAnimate("spr_closetdoor_key_1", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0,   1, 0, 1,   1.5, 0, 1 });
  ObjAnimate("spr_closetdoor_key_2", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1,   1, 0, 0 });

end;
--------------------------------------------------------------------------------------------
function public.clk_folder1()

  cmn.CallEventHandler( "clk_folder1_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_folder1" );
    cmn.CallEventHandler( "clk_folder1_end" );

    cmn.Lock( 0 );
    
  end;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_clk_card_folder");

  ObjAnimate("spr_cardregister_folder_1", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });

end;
--------------------------------------------------------------------------------------------
function public.clk_folder2()

  cmn.CallEventHandler( "clk_folder2_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_folder2" );
    cmn.CallEventHandler( "clk_folder2_end" );

    cmn.Lock( 0 );
    
  end;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_clk_card_folder");

  ObjAnimate("spr_cardregister_folder_2", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_doctorstudy()

  if not ( cmn.IsEventDone( "beg_level1" ) ) then
    
    local func_after = function ()

      ObjSet("rm_doctorstudy",  { color_r = 1, color_g = 1, color_b = 1 });
      interface.WidgetSetVisible( "InterfaceWidget_Inventory", true, true );
      interface.WidgetSetInput( "InterfaceWidget_Inventory", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnHint", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnHint", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnGuide", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnGuide", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnMenu", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnMenu", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnMap", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnMap", 1 );

      cmn.ShowBbt( "doctorstudy_open" );
      interface_impl.ShowGlobalTask();

      cmn.PlayAudio("mus", "assets/levels/common/audio/aud_danger_track1_mus_env", 1);
      cmn.PlayAudio("env", "assets/levels/common/audio/aud_debris_env");

      --cmn.TutorialShow("tutor_enable");

    end;

    cmn.Lock(0);
    
    cmn.SetEventDone( "beg_level1" );
    cmn.CallEventHandler("beg_level1");
    
    cmn.PlayFullscreenVideo( "assets/levels/level1/rm_doctorstudy/vid_lvl1intro", func_after, "assets/levels/level1/rm_doctorstudy/audio/aud_intro_1lvl", "assets/levels/level1/rm_doctorstudy/audio/aud_intro_1lvl_voc");
    
  end;
  
  if cmn.IsEventDone("opn_doctorstudyafterho") and private.dlg_finished then
    
    local func_after = function ()
      ObjSet("rm_doctorstudy",  { color_r = 0, color_g = 0, color_b = 0 });
      interface.WidgetSetVisible( "InterfaceWidget_Inventory", false, false );
      interface.WidgetSetInput( "InterfaceWidget_Inventory", 0 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnHint", false, false );
      interface.WidgetSetInput( "InterfaceWidget_BtnHint", 0 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnGuide", false, false );
      interface.WidgetSetInput( "InterfaceWidget_BtnGuide", 0 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnMenu", false, false );
      interface.WidgetSetInput( "InterfaceWidget_BtnMenu", 0 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnMap", false, false );
      interface.WidgetSetInput( "InterfaceWidget_BtnMap", 0 );
      cmn.GotoRoom("mg_pursuit");
    end;
    
    cmn.Lock(0);
    cmn.PlayFullscreenVideo( "assets/levels/level1/rm_doctorstudy/vid_runingaway", func_after, "assets/levels/level1/rm_doctorstudy/audio/aud_jump", "assets/levels/level1/rm_doctorstudy/audio/aud_jump_voc");
    
  end;
  
  if cmn.IsEventDone("win_debris") and not cmn.IsEventDone( "opn_doctorstudyafterho" ) then
    
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    private.dlg_finished = false;
    
    cmn.SetEventDone( "opn_doctorstudyafterho" );
    ObjAnimate("obj_doctorstudy_dialog_doctor", "alp", 0, 0, private.dialog_doctor_beg, { 0, 0, 0,   0.5, 0, 1 });
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_drawer( num )
  
  cmn.Lock(1);
  
  if num == 1 then
    cmn.ShowBbt( "obj_cardregister_use_cardregistercypher" );
  else 
    cmn.ShowBbt( "cardregister_game" );
  end;
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_xx_drawer");
  
  ObjSet("anm_cardregister_touch_drawer",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  ObjAnimate("obj_cardregister_drawer_texts", "pos_xy", 0, 0, "", { 0, 0, -15, 181,   0.3, 0, -16, 183,   0.6, 0, -15, 181 });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_hygea_cup()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_cardregister_use_cane" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_xx_bowl");
  
  ObjSet("anm_cardregister_touch_cup",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_closet_door()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_closetdoor_use_closetroom" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_xx_door");
  
  ObjSet("anm_closetdoor_door_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_snake()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_hygeastatuette_use_hygeacup" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_xx_hand");
  ObjSet("anm_hygeastatuette_touch_cup",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function private.dialog_doctor_beg()
  
  cmn.Lock(0);
  --interface.InterfaceSetInput( false ); 
  interface.WidgetSetInput( "InterfaceWidget_Inventory", 0 );
  interface.WidgetSetInput( "InterfaceWidget_BtnHint", 0 );
  interface.WidgetSetInput( "InterfaceWidget_BtnGuide", 0 );
  interface.WidgetSetInput( "InterfaceWidget_BtnMenu", 0 );
  interface.WidgetSetInput( "InterfaceWidget_BtnMap", 0 );
  
  common_impl.CharacterDialogButtonsShow( "doctorstudy", "doctor", 2 );

  local dialog_end = function ()

    cmn.CallEventHandler( "opn_doctorstudyafterho" );
    
    interface.WidgetSetVisible( "InterfaceWidget_Inventory", false, false );
    interface.WidgetSetInput( "InterfaceWidget_Inventory", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnHint", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnHint", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnGuide", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnGuide", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnMenu", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnMenu", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnMap", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnMap", 0 );
    
    ObjSet("rm_doctorstudy",  { color_r = 0, color_g = 0, color_b = 0 });
    cmn.GotoRoom("mg_pursuit");
    
  end;
  
  local dialog_hide = function ()

    private.dlg_lipsync = "";
    private.dlg_finished = true;
    
    --interface.InterfaceSetInput( true );
    
    int_blackbartext.Hide();
    cmn.Lock(0);
    common_impl.current_dialog = "";
    common_impl.CharacterDialogButtonsHide();
    --ObjAnimate( "obj_doctorstudy_dialog_doctor", "alp", 0, 0, dialog_end, { 0, 0, 1,   0.6, 0, 0 } );
    
    SndStop( common_impl.audio.voc, 0.5 );
    ObjSet("tmr_doctorstudy_dialog_doctor_timer",  { playing = 0 });
    
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level1/rm_doctorstudy/vid_runingaway", dialog_end, "assets/levels/level1/rm_doctorstudy/audio/aud_jump", "assets/levels/level1/rm_doctorstudy/audio/aud_jump_voc");

  end;
  
  local doc_talks3 = function ()
    
    ObjDelete("vid_doctorstudy_dialog_doctor_lipsync_2");
    ObjAttach("vid_doctorstudy_dialog_doctor_lipsync_3", "obj_doctorstudy_dialog_doctor");
  
    cmn.ShowDlgBbt( "dlg_doctor_phrase_2_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level1/rm_doctorstudy/audio/aud_therapist_dlg_1_4_voc");
    private.dlg_lipsync = "vid_doctorstudy_dialog_doctor_lipsync_3";

    ObjMultiSet( { {"tmr_doctorstudy_dialog_doctor_timer", { endtrig = dialog_hide, time = 6.6, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = dialog_hide }},
                   {"obj_character_dialog_continue", { event_mup = dialog_hide }},
                   {"vid_doctorstudy_dialog_doctor_lipsync_3", { playing = 1 }} } );
  
  end;
  
  local doc_talks2 = function ()
    
    ObjDelete("vid_doctorstudy_dialog_doctor_idle");
    ObjAttach("vid_doctorstudy_dialog_doctor_lipsync_2", "obj_doctorstudy_dialog_doctor");
  
    cmn.ShowDlgBbt( "dlg_doctor_phrase_2_1" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level1/rm_doctorstudy/audio/aud_therapist_dlg_1_3_voc");
    private.dlg_lipsync = "vid_doctorstudy_dialog_doctor_lipsync_2";

    ObjMultiSet( { {"tmr_doctorstudy_dialog_doctor_timer", { endtrig = doc_talks3, time = 14.2, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = doc_talks3 }},
                   {"obj_character_dialog_continue", { event_mup = doc_talks3 }},
                   {"vid_doctorstudy_dialog_doctor_lipsync_2", { playing = 1 }} } );
  
  end;
                 
  local cindy_talks = function ()
    
    ObjDelete("vid_doctorstudy_dialog_doctor_lipsync_1");
    ObjAttach("vid_doctorstudy_dialog_doctor_idle", "obj_doctorstudy_dialog_doctor");
  
    cmn.ShowDlgBbt( "dlg_doctor_answer_1" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level1/rm_doctorstudy/audio/aud_therapist_dlg_1_2_voc");
    private.dlg_lipsync = "";

    ObjMultiSet( { {"tmr_doctorstudy_dialog_doctor_timer", { endtrig = doc_talks2, time = 4, playing = 1 }},
                   {"vid_doctorstudy_dialog_doctor_idle", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = doc_talks2 }},
                   {"obj_character_dialog_continue", { event_mup = doc_talks2 }} } );
  
  end;

  private.dlg_lipsync = "vid_doctorstudy_dialog_doctor_lipsync_1";

  cmn.ShowDlgBbt( "dlg_doctor_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level1/rm_doctorstudy/audio/aud_therapist_dlg_1_1_voc");

  ObjMultiSet( { {"tmr_doctorstudy_dialog_doctor_timer", { time = 6, playing = 1, endtrig = cindy_talks }},
                 {"vid_doctorstudy_dialog_doctor_lipsync_1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = cindy_talks }},
                 {"obj_character_dialog_continue", { event_mup = cindy_talks }} } );

end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_doctor()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");

  interface.InterfaceSetInput( true );
  --cmn.Lock(1);
  private.dlg_finished = true;
  common_impl.current_dialog = "";

  local func_after_dlg = function ()

    --cmn.Lock(0);
    cmn.CallEventHandler( "opn_doctorstudyafterho" );

    interface.WidgetSetVisible( "InterfaceWidget_Inventory", false, false );
    interface.WidgetSetInput( "InterfaceWidget_Inventory", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnHint", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnHint", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnGuide", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnGuide", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnMenu", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnMenu", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnMap", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnMap", 0 );

    ObjSet("rm_doctorstudy",  { color_r = 0, color_g = 0, color_b = 0 });
    cmn.GotoRoom("mg_pursuit");

  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjSet(private.dlg_lipsync,  { endtrig = "" });
    private.dlg_lipsync = "";
  end;

  ObjSet("tmr_doctorstudy_dialog_doctor_timer",  { playing = 0 });
  common_impl.CharacterDialogButtonsHide();
  --ObjAnimate("obj_doctorstudy_dialog_doctor", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.6, 0, 0 });
  
  cmn.StopAllEnv();
  cmn.PlayFullscreenVideo( "assets/levels/level1/rm_doctorstudy/vid_runingaway", func_after_dlg, "assets/levels/level1/rm_doctorstudy/audio/aud_jump", "assets/levels/level1/rm_doctorstudy/audio/aud_jump_voc");

end;
--------------------------------------------------------------------------------------------
function private.ShowTutor8()

  ObjAttach("tmr_doctorstudy_timer", "rm_doctorstudy");

  if not( cmn.IsEventDone( "tutor_8" )) and (ObjGet("hub_int_inventory_folder")) then

    interface.InventoryAutoHideSave();

    if int_inventory.GetAutohide() then
      int_inventory.SetAutohide(false);
      int_inventory.Show( true );
    end;

    local cosmeticsbag_pos = GetObjPosByObj("hub_int_inventory_folder");

    ObjMultiSet( { {"obj_tutorial_tutor_8", { pos_x = -math.floor(cosmeticsbag_pos[1]) }},
                   {"obj_tutorial_tutor_8_1", { pos_x = math.floor(cosmeticsbag_pos[1]), pos_y = 726 }} } );

    local arrows = { { pos_x = 0, pos_y = 160, ang = 3.14 } };
    cmn.TutorialShow( "tutor_8", 0, math.floor(cosmeticsbag_pos[1]), 450, arrows );

  end;

end;
--------------------------------------------------------------------------------------------
function public.ShowTutor4()
  
  if ( ng_global.gamemode < 1 ) or ( ng_global.gamemode == 3 and ng_global.custom_gamemode.tutorial == 1 ) then

    interface.InventoryAutoHideSave();

    if int_inventory.GetAutohide() then
      int_inventory.SetAutohide(false);
      int_inventory.Show( true );
    end;

  end;

  local carkey_pos = GetObjPosByObj("hub_int_inventory_cane");
  local px = 0;

  if ObjGet("hub_int_inventory_cane") then
    px = math.floor(carkey_pos[1]);
  end;
    
  ObjSet("obj_tutorial_tutor_4_2",  { pos_x = px, pos_y = 730 });

  local arrows = { { pos_x = 260, pos_y = -200, ang = -0.6 }, { pos_x = px - 400, pos_y = 246, ang = 3.14 } };

  if int_inventory.GetDraggingObject() then
    arrows = { { pos_x = 260, pos_y = -200, ang = -0.6 } };
  end;

  cmn.TutorialShow( "tutor_4", 0, 400, 400, arrows );
  
end;
--------------------------------------------------------------------------------------------
function private.drag_hanger()
  
  local curspos = private.get_hanger_pos();
  
  ObjMultiSet( { {"obj_doctorstudy_hanger_inhand",  { pos_x = curspos[1], pos_y = curspos[2] }},
                 {"tmr_doctorstudy_timer_hanger", { time = 0.001, playing = 1, endtrig = private.drag_hanger }} } );
  
end;
--------------------------------------------------------------------------------------------
function private.get_hanger_pos()
  
  local curspos = GetZoomCursorPos();
  local range = { {0, 1024}, {160, 580} };
  curspos[1] = math.floor(curspos[1]);
  curspos[2] = math.floor(curspos[2]);
  
  if curspos[1] < range[1][1] then
    curspos[1] = range[1][1];
  elseif curspos[1] > range[1][2] then
    curspos[1] = range[1][2];
  end;
  
  if curspos[2] < range[2][1] then
    curspos[2] = range[2][1];
  elseif curspos[2] > range[2][2] then
    curspos[2] = range[2][2];
  end;
  
  return curspos;
  
end;
--------------------------------------------------------------------------------------------
function public.clk_hunter()
  
  local func_after = function ()
    
    cmn.Lock(0);

    if not cmn.IsEventDone("clk_hunterhit1") then
      cmn.SetEventDone("clk_hunterhit1");
      cmn.CallEventHandler("clk_hunterhit1");
    else 
      cmn.SetEventDone("clk_hunterhit2");
      cmn.CallEventHandler("clk_hunterhit2");
    end;
    
  end;
  
  local anm_hanger = function ()
    
    ObjSet("anm_doctorstudy_hunter",  { alp = 1, playing = 1 });
    
    if not cmn.IsEventDone("clk_hunterhit1") then
      ObjDelete("anm_doctorstudy_hunter_hit_1");
      ObjAnimate("anm_doctorstudy_hanger_hit_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    else 
      ObjDelete("anm_doctorstudy_hunter_hit_2");
      ObjAnimate("anm_doctorstudy_hanger_hit_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    end;
    
    ObjAnimate("obj_doctorstudy_hanger_inhand", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    
  end;
  
  cmn.Lock(1);
  
  if not cmn.IsEventDone("clk_hunterhit1") then
    cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_pokehanger1");
    ObjMultiSet( { {"anm_doctorstudy_hunter", { alp = 0, playing = 0 }},
                   {"obj_doctorstudy_hanger_inhand", { alp = 0 }},
                   {"anm_doctorstudy_hunter_hit_1", { alp = 1, playing = 1, endtrig = anm_hanger }},
                   {"anm_doctorstudy_hanger_hit_1", { alp = 1, playing = 1 }} } );
  else 
    cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_pokehanger2");               
    ObjMultiSet( { {"anm_doctorstudy_hunter", { alp = 0, playing = 0 }},
                   {"obj_doctorstudy_hanger_inhand", { alp = 0 }},
                   {"anm_doctorstudy_hunter_hit_2", { alp = 1, playing = 1, endtrig = anm_hanger }},
                   {"anm_doctorstudy_hanger_hit_2", { alp = 1, playing = 1 }} } );
  end;          
  
end;
--------------------------------------------------------------------------------------------
function public.clk_hangerempty()
  
  local func_after = function ()
    cmn.Lock(0);
  end;
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_pokehanger");
  
  ObjAnimate("anm_doctorstudy_hanger_inhand", "pos_xy", 0, 0, func_after, { 0, 0, -600, -370,   0.3, 0, -700, -470,   0.6, 0, -600, -370 });
  
end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_1_1", { alp = 1 }},
                 {"spr_col_1_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_1_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_1_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_1_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_1_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_1_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_1_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Cardregister *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_cardregister = {};
public.zz_cardregister = {};

function private.Init_Cardregister()
  
  private.zz_cardregister.selected_figure = 0;
  private.zz_cardregister.in_fly = false;

  private.zz_cardregister.start_state = {4, 1, 5, 3, 2};
  private.zz_cardregister.fig_pos = { {-180, -52}, {-90, -40}, {-6, -24}, {80, -7}, {164, 9} };
  
  -----------------------------------------------------------------------------------
  local win_cardregister = function ()

    if cmn.IsEventDone( "win_cardregister" ) then

      ObjMultiSet( { {"obj_cardregister_drawer_open", { alp = 1, input = 1 }},
                     {"obj_cardregister_game", { input = 0 }},
                     {"spr_doctorstudy_register_drawer", { alp = 1 }} } );
                     
      ObjDelete( "anm_cardregister_touch_drawer" );
      ObjDelete( "obj_cardregister_touch_drawer" );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_cardregister", win_cardregister, "rm_doctorstudy" );

end;
--*********************************************************************************************************************
-----------------------------------------------------------------------------------
function private.zz_cardregister.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_cardregister" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_cardregister" ].state = { 4, 1, 5, 3, 2 };

end;
-----------------------------------------------------------------------------------
function public.zz_cardregister.Reset()
  
  local need_r = false;
  local need_r2 = false;
  
  for i = 1, #private.zz_cardregister.state, 1 do
    
    if private.zz_cardregister.state[i] ~= private.zz_cardregister.start_state[i] then
      
      if not need_r then
        need_r = true;
      end;
      
      local ind = 0;

      for j = 1, #private.zz_cardregister.start_state, 1 do
      
        if private.zz_cardregister.start_state[j] == private.zz_cardregister.state[i] then
          ind =  j;
          break;
        end;
        
      end;
      
      if private.zz_cardregister.state[i] == i then
        ObjAnimate("spr_cardregister_figure_"..private.zz_cardregister.state[i].."_win", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 });
      end;
      
      ObjAnimate("spr_cardregister_figure_"..private.zz_cardregister.state[i], "pos_xy", 0, 0, "", { 0, 0, private.zz_cardregister.fig_pos[i][1], private.zz_cardregister.fig_pos[i][2], 
                                                                                                   0.5, 0, private.zz_cardregister.fig_pos[ind][1], private.zz_cardregister.fig_pos[ind][2] });
      
    end;
    
  end;
                                                                                        
  if private.zz_cardregister.selected_figure ~= 0 then
    need_r2 = true;
    local sel = private.zz_cardregister.selected_figure;
    private.zz_cardregister.selected_figure = 0;
    ObjAnimate("spr_cardregister_figure_"..sel.."_select", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  end;
                                                                                        
  if need_r then
    
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_xx_slide");
    
    private.zz_cardregister.StartConditions();
    private.zz_cardregister.state = ng_global.progress[ ng_global.currentprogress ][ "win_cardregister" ].state;
    
    ObjSet("tmr_cardregister_timer",  { time = 0.5, playing = 1, endtrig = function() cmn.Lock(0); end });
    
  elseif need_r2 then
    
    cmn.Lock(1);
    ObjSet("tmr_cardregister_timer",  { time = 0.3, playing = 1, endtrig = function () cmn.Lock(0); private.zz_cardregister.DrawScene(); end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_cardregister.Skip()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_cardregister" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_cardregister" ].state = { 1, 2, 3, 4, 5 };
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_xx_slide");
  
  for i = 1, #private.zz_cardregister.state, 1 do
    
    if private.zz_cardregister.state[i] ~= i then
      
      local ind = private.zz_cardregister.state[i];
      
      ObjAnimate("spr_cardregister_figure_"..private.zz_cardregister.state[i].."_win", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,   0.7, 0, 1 });

      ObjAnimate("spr_cardregister_figure_"..private.zz_cardregister.state[i], "pos_xy", 0, 0, "", { 0, 0, private.zz_cardregister.fig_pos[i][1], private.zz_cardregister.fig_pos[i][2], 
                                                                                                   0.5, 0, private.zz_cardregister.fig_pos[ind][1], private.zz_cardregister.fig_pos[ind][2] });
      
    end;
    
  end;
                                                                                        
  if private.zz_cardregister.selected_figure ~= 0 then
    ObjAnimate("spr_cardregister_figure_"..private.zz_cardregister.selected_figure.."_select", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    private.zz_cardregister.selected_figure = 0;
  end;
                                                                                        
  private.zz_cardregister.state = ng_global.progress[ ng_global.currentprogress ][ "win_cardregister" ].state;
  
  ObjSet("tmr_cardregister_timer",  { time = 0.7, playing = 1, endtrig = private.zz_cardregister.CheckWin });
  
end;
-----------------------------------------------------------------------------------
function private.zz_cardregister.DrawScene()
  
  for i = 1, #private.zz_cardregister.state, 1 do
    
    if private.zz_cardregister.state[i] == i then
      ObjSet("spr_cardregister_figure_"..private.zz_cardregister.state[i].."_win",  { alp = 1 });
    else 
      ObjSet("spr_cardregister_figure_"..private.zz_cardregister.state[i].."_win",  { alp = 0 });
    end;
    
    ObjSet("spr_cardregister_figure_"..private.zz_cardregister.state[i],  { pos_x = private.zz_cardregister.fig_pos[i][1],
                                                                            pos_y = private.zz_cardregister.fig_pos[i][2] });
    
  end;
                                                                          
  if private.zz_cardregister.selected_figure ~= 0 then
    ObjSet("spr_cardregister_figure_"..private.zz_cardregister.selected_figure.."_select",  { alp = 1 });
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_cardregister.FocusFigurine( book, inout )

  local obj = "spr_cardregister_figure_"..book.."_light";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.13 then
      cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_menter1");
    end;
  end;
  
  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });

end;
-----------------------------------------------------------------------------------
function public.zz_cardregister.ChooseFigurine( num )
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_xx_click1");
  
  if private.zz_cardregister.selected_figure ~= 0 then

    --cancel selection
    if private.zz_cardregister.selected_figure == num then

      private.zz_cardregister.selected_figure = 0;
      private.zz_cardregister.SelectAnim( num, 0 );

    --switch items
    else

      local old = private.zz_cardregister.selected_figure;
      private.zz_cardregister.selected_figure = 0;
      private.zz_cardregister.SwitchAnim( old, num  );

    end;

  --first selected
  else 

    private.zz_cardregister.selected_figure = num;
    private.zz_cardregister.SelectAnim( num, 1 );

  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_cardregister.SwitchAnim( num1, num2 )

  private.zz_cardregister.in_fly = true;

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_xx_slide");

  private.zz_cardregister.SelectAnim( num1, 0 );

  local ind1 = private.zz_cardregister.FindIndex(num1);
  local ind2 = private.zz_cardregister.FindIndex(num2);

  local temp = private.zz_cardregister.state[ind1];
  private.zz_cardregister.state[ind1] = private.zz_cardregister.state[ind2];
  private.zz_cardregister.state[ind2] = temp;
  
  local func_after = function ()
  
    ObjAttach("spr_cardregister_figure_"..num1, "obj_cardregister_game");
    ObjAttach("spr_cardregister_figure_"..num2, "obj_cardregister_game");
    
  end;

  ObjAttach("spr_cardregister_figure_"..num1, "obj_cardregister_game_fly");
  ObjAttach("spr_cardregister_figure_"..num2, "obj_cardregister_game_fly");
  
  ObjAnimate("spr_cardregister_figure_"..num1, "pos_xy", 0, 0, func_after, { 0, 0, private.zz_cardregister.fig_pos[ind1][1], private.zz_cardregister.fig_pos[ind1][2], 
                                                                           0.5, 0, private.zz_cardregister.fig_pos[ind2][1], private.zz_cardregister.fig_pos[ind2][2] });

  ObjAnimate("spr_cardregister_figure_"..num2, "pos_xy", 0, 0, "", { 0, 0, private.zz_cardregister.fig_pos[ind2][1], private.zz_cardregister.fig_pos[ind2][2], 
                                                                   0.5, 0, private.zz_cardregister.fig_pos[ind1][1], private.zz_cardregister.fig_pos[ind1][2] });

  ObjSet("tmr_cardregister_timer",  { time = 0.5, playing = 1, endtrig = function() private.zz_cardregister.CheckPlace( ind1, ind2 ); end });

end;
-----------------------------------------------------------------------------------
function private.zz_cardregister.FindIndex( num )

  local ind = 0;

  for i = 1, #private.zz_cardregister.state, 1 do
  
    if private.zz_cardregister.state[i] == num then
      ind =  i;
      break;
    end;
    
  end;

  return ind;

end;
-----------------------------------------------------------------------------
function private.zz_cardregister.SelectAnim( num, inout )

  local name = "spr_cardregister_figure_"..num.."_select";
  local cur_alp = ObjGet(name).alp;

  local ind = private.zz_cardregister.FindIndex( num );

  if inout == 1 then

    ObjAnimate( name, "alp", 0, 0, "", { 0, 2, 0,   0.2, 2, 1 });

  elseif inout == 0 then

    ObjAnimate( name, "alp", 0, 0, "", { 0, 0, cur_alp,   0.2, 0, 0 });

  end;

end;
-----------------------------------------------------------------------------------
function private.zz_cardregister.CheckPlace( num1, num2 )
  
  local wait = false;
  local snd = false;
  
  if private.zz_cardregister.state[num1] == num1 then
    wait = true;
    snd = true;
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_right_act" );
    ObjAnimate("spr_cardregister_figure_"..num1.."_win", "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 1 });
  elseif private.zz_cardregister.state[num2] == num1 then
    wait = true;
    ObjAnimate("spr_cardregister_figure_"..num1.."_win", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 });
  end;
  
  if private.zz_cardregister.state[num2] == num2 then
    wait = true;
    if not snd then
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_right_act" );
    end;
    ObjAnimate("spr_cardregister_figure_"..num2.."_win", "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 1 });
  elseif private.zz_cardregister.state[num1] == num2 then
    wait = true;
    ObjAnimate("spr_cardregister_figure_"..num2.."_win", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 });
  end;
  
  if wait then
    ObjSet("tmr_cardregister_timer",  { time = 0.2, playing = 1, endtrig = private.zz_cardregister.CheckWin });
  else 
    private.zz_cardregister.CheckWin();
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_cardregister.CheckWin()

  private.zz_cardregister.in_fly = false;
  
  local win_flag = true;

  for i = 1, #private.zz_cardregister.state, 1 do

    if private.zz_cardregister.state[i] ~= i then

      win_flag = false;
      break;

    end;

  end;

  if win_flag then

    cmn.Lock(1);
    common_impl.PauseAchiev(1);
    
    cmn.MiniGameHide("cardregister");

    cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_opn_drawer");
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );

    ObjAnimate("anm_cardregister_touch_drawer", "alp", 0, 0, "", { 0, 0, 1,   1, 0, 1,   1.5, 0, 0 });
    ObjAnimate("obj_cardregister_drawer_open", "alp", 0, 0, private.zz_cardregister.Win, { 0, 0, 0,   1, 0, 0,   1.5, 0, 1 });

  else

    cmn.Lock( 0 );

  end;

end;
-----------------------------------------------------------------------------------
function private.zz_cardregister.Win()

  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_cardregister" );
  cmn.CallEventHandler( "win_cardregister" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_cardregister" ].skip == 0 and ng_global.noskipgames[ "win_cardregister" ] == nil then

    ng_global.noskipgames[ "win_cardregister" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

  cmn.Lock( 0 );
  --cmn.PlayAudio("mus", "assets/levels/common/audio/");

end;
--*********************************************************************************************************************
