-- name=rm_nearcastle
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_nearcastle";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  --------------------------------------------------------------------------------------------
  -- function get_salamander () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_salamander" ] = {
      type = "get",
      get_obj = "obj_pond_salamander",
      room = private.room_objname,
      zz = "zz_pond",
      zz_gate = "gzz_nearcastle_pond"
  };
  --------------------------------------------------------------------------------------------
  local get_salamander_inv = function ()
  
    interface.InventoryItemAdd( "inv_salamander", "obj_pond_salamander" );
  
  end;
  local get_salamander_end = function ()
  
    ObjDelete( "gfx_pond_salamander" );
    ObjDelete( "spr_pond_salamander_sh" );
    
    ObjDelete( "spr_nearcastle_salamander_2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_salamander", get_salamander_inv );
  cmn.AddSubscriber( "get_salamander", get_salamander_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rubyheart () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_rubyheart" ] = {
      type = "get",
      get_obj = "spr_pond_rubyheart",
      room = private.room_objname,
      zz = "zz_pond",
      zz_gate = "gzz_nearcastle_pond"
  };
  --------------------------------------------------------------------------------------------
  local get_rubyheart_inv = function ()
  
    interface.InventoryItemAdd( "inv_rubyheart", "obj_pond_rubyheart" );
    ObjSet("inv_heartmedallion_star_light",  { alp = 1 });
  
  end;
  local get_rubyheart_end = function ()
  
    ObjDelete( "gfx_pond_rubyheart" );
    ObjDelete( "gzz_nearcastle_pond" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_rubyheart", get_rubyheart_inv );
  cmn.AddSubscriber( "get_rubyheart", get_rubyheart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gnomegirlfigurine () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_gnomegirlfigurine" ] = {
      type = "get",
      get_obj = "spr_summerhouse_gnomegirlfigurine",
      room = private.room_objname,
      zz = "zz_summerhouse",
      zz_gate = "gzz_nearcastle_summerhouse"
  };
  --------------------------------------------------------------------------------------------
  local get_gnomegirlfigurine_inv = function ()
  
    interface.InventoryItemAdd( "inv_gnomegirlfigurine", "spr_summerhouse_gnomegirlfigurine" );
  
  end;
  local get_gnomegirlfigurine_end = function ()
  
    ObjDelete( "gfx_summerhouse_gnomegirlfigurine" );
    ObjDelete( "spr_summerhouse_gnomegirlfigurine_sh" );
    ObjDelete( "spr_nearcastle_arbor_gnome" );
    
    ObjSet("gzz_nearcastle_summerhouse",  { alp = 0, active = 0 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_gnomegirlfigurine", get_gnomegirlfigurine_inv );
  cmn.AddSubscriber( "get_gnomegirlfigurine", get_gnomegirlfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lionhead () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lionhead" ] = {
      type = "get",
      get_obj = "spr_summerhouse_lionhead",
      room = private.room_objname,
      zz = "zz_summerhouse",
      zz_gate = "gzz_nearcastle_summerhouse"
  };
  --------------------------------------------------------------------------------------------
  local get_lionhead_inv = function ()
  
    interface.InventoryItemAdd( "inv_lionhead", "spr_summerhouse_lionhead" );
  
  end;
  local get_lionhead_end = function ()
  
    ObjDelete( "gfx_summerhouse_lionhead" );
    ObjDelete( "spr_summerhouse_lionhead_sh" );
    
    ObjDelete( "spr_nearcastle_arbor_lionhead" );
    
    if cmn.IsEventDone("get_scissors") then
      ObjSet("obj_summerhouse_use_lovesymbol",  { input = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_lionhead", get_lionhead_inv );
  cmn.AddSubscriber( "get_lionhead", get_lionhead_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_scissors () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_scissors" ] = {
      type = "get",
      get_obj = "spr_summerhouse_scissors",
      room = private.room_objname,
      zz = "zz_summerhouse",
      zz_gate = "gzz_nearcastle_summerhouse"
  };
  --------------------------------------------------------------------------------------------
  local get_scissors_inv = function ()
  
    interface.InventoryItemAdd( "inv_scissors", "spr_summerhouse_scissors" );
    ObjSet("inv_brokenscoopnet_star_light",  { alp = 1 });
  
  end;
  local get_scissors_end = function ()
  
    ObjDelete( "gfx_summerhouse_scissors" );
    ObjDelete( "spr_summerhouse_scissors_sh" );
    
    if cmn.IsEventDone("get_lionhead") then
      ObjSet("obj_summerhouse_use_lovesymbol",  { input = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_scissors", get_scissors_inv );
  cmn.AddSubscriber( "get_scissors", get_scissors_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_jug () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_jug" ] = {
      type = "get",
      get_obj = "spr_summerhouse_jug",
      room = private.room_objname,
      zz = "zz_summerhouse",
      zz_gate = "gzz_nearcastle_summerhouse"
  };
  --------------------------------------------------------------------------------------------
  local get_jug_inv = function ()
  
    interface.InventoryItemAdd( "inv_jug", "spr_summerhouse_jug" );
  
  end;
  local get_jug_end = function ()
  
    ObjDelete( "gfx_summerhouse_jug" );
    ObjDelete( "spr_summerhouse_jug_sh" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_jug", get_jug_inv );
  cmn.AddSubscriber( "get_jug", get_jug_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mosaicpart3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_mosaicpart3" ] = {
      type = "get",
      get_obj = "spr_summerhouse_mosaicpart3",
      room = private.room_objname,
      zz = "zz_summerhouse",
      zz_gate = "gzz_nearcastle_summerhouse"
  };
  --------------------------------------------------------------------------------------------
  local get_mosaicpart3_inv = function ()
  
    interface.InventoryItemAdd( "inv_mosaicpart", "spr_summerhouse_mosaicpart3", function () cmn.GetMultyObject( 'mosaicpart', 3 ); end );
  
  end;
  local get_mosaicpart3_end = function ()
  
    ObjDelete( "gfx_summerhouse_mosaicpart3" );
    ObjDelete( "spr_summerhouse_mosaicpart3_sh" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_mosaicpart3", get_mosaicpart3_inv );
  cmn.AddSubscriber( "get_mosaicpart3", get_mosaicpart3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stick () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_stick" ] = {
      type = "get",
      get_obj = "spr_gnome_stick",
      room = private.room_objname,
      zz = "zz_gnome",
      zz_gate = "gzz_nearcastle_gnome"
  };
  --------------------------------------------------------------------------------------------
  local get_stick_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_stick", "spr_gnome_stick" );
  
  end;
  local get_stick_end = function ()
  
    ObjDelete( "gfx_gnome_stick" );
    ObjDelete( "spr_nearcastle_branch" );

    ObjSet( "anm_gnome_gnome", { animfunc = "func_clk_stone_gnome" } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_stick", get_stick_inv );
  cmn.AddSubscriber( "get_stick", get_stick_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokenscoopnet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_brokenscoopnet" ] = {
      type = "get",
      get_obj = "obj_gnome_brokenscoopnet",
      room = private.room_objname,
      zz = "zz_gnome",
      zz_gate = "gzz_nearcastle_gnome"
  };
  --------------------------------------------------------------------------------------------
  local get_brokenscoopnet_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_brokenscoopnet", "obj_gnome_brokenscoopnet" );
  
  end;
  local get_brokenscoopnet_end = function ()
  
    ObjDelete( "gfx_gnome_brokenscoopnet" );
    ObjDelete( "spr_nearcastle_scoopnet" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_brokenscoopnet", get_brokenscoopnet_inv );
  cmn.AddSubscriber( "get_brokenscoopnet", get_brokenscoopnet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bracelet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bracelet" ] = {
      type = "get",
      get_obj = "spr_gnome_bracelet",
      room = private.room_objname,
      zz = "zz_gnome",
      zz_gate = "gzz_nearcastle_gnome"
  };
  --------------------------------------------------------------------------------------------
  local get_bracelet_inv = function ()
  
    interface.InventoryItemAdd( "inv_bracelet", "spr_gnome_bracelet" );
  
  end;
  local get_bracelet_end = function ()
  
    ObjDelete( "gfx_gnome_bracelet" );
    ObjDelete( "spr_nearcastle_braslet" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bracelet", get_bracelet_inv );
  cmn.AddSubscriber( "get_bracelet", get_bracelet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magnet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_magnet" ] = {
      type = "get",
      get_obj = "spr_gnome_magnet",
      room = private.room_objname,
      zz = "zz_gnome",
      zz_gate = "gzz_nearcastle_gnome"
  };
  --------------------------------------------------------------------------------------------
  local get_magnet_inv = function ()
  
    interface.InventoryItemAdd( "inv_magnet", "spr_gnome_magnet" );
    int_map_impl.DecreaseRoomTasks("rm_nearcastle");
  
  end;
  local get_magnet_end = function ()
  
    ObjDelete( "gfx_gnome_magnet" );
    ObjDelete( "spr_nearcastle_gnome_magnet" );
  
  end;
  local get_magnet_end2 = function ()

    if ( cmn.IsEventDone( "get_gnomehammer" ) ) then
      ObjDelete( "anm_gnome_gnome" );

      ObjDelete( "spr_nearcastle_gnome_2" );
      ObjDelete( "spr_nearcastle_gnome_girl" );
      ObjDelete( "anm_nearcastle_gnome_kid3" );

      ObjMultiSet( { { "spr_gnome_note_small", { input = 1 } },
                     { "gzz_nearcastle_gnome", { alp = 0, active = 0 } } } );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_magnet", get_magnet_inv );
  cmn.AddSubscriber( "get_magnet", get_magnet_end, private.room_objname );
  cmn.AddSubscriber( "get_magnet", get_magnet_end2, private.room_objname );
  cmn.AddSubscriber( "get_magnet_inv", get_magnet_inv, private.room_objname );
  cmn.AddSubscriber( "get_magnet_end", get_magnet_end, private.room_objname );
  cmn.AddSubscriber( "get_magnet_end2", get_magnet_end2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gnomehammer () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_gnomehammer" ] = {
      type = "get",
      get_obj = "spr_gnome_gnomehammer",
      room = private.room_objname,
      zz = "zz_gnome",
      zz_gate = "gzz_nearcastle_gnome"
  };
  --------------------------------------------------------------------------------------------
  local get_gnomehammer_inv = function ()
  
    interface.InventoryItemAdd( "inv_gnomehammer", "spr_gnome_gnomehammer" );
  
  end;
  local get_gnomehammer_end = function ()
  
    ObjDelete( "gfx_gnome_gnomehammer" );
    ObjDelete( "spr_nearcastle_gnome_hammer" );
  
  end;
  local get_gnomehammer_end2 = function ()

    if ( cmn.IsEventDone( "get_magnet" ) ) then
      ObjDelete( "anm_gnome_gnome" );

      ObjDelete( "spr_nearcastle_gnome_2" );
      ObjDelete( "spr_nearcastle_gnome_girl" );
      ObjDelete( "anm_nearcastle_gnome_kid3" );

      ObjMultiSet( { { "spr_gnome_note_small", { input = 1 } },
                     { "gzz_nearcastle_gnome", { alp = 0, active = 0 } } } );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_gnomehammer", get_gnomehammer_inv );
  cmn.AddSubscriber( "get_gnomehammer", get_gnomehammer_end, private.room_objname );
  cmn.AddSubscriber( "get_gnomehammer", get_gnomehammer_end2, private.room_objname );
  cmn.AddSubscriber( "get_gnomehammer_inv", get_gnomehammer_inv, private.room_objname );
  cmn.AddSubscriber( "get_gnomehammer_end", get_gnomehammer_end, private.room_objname );
  cmn.AddSubscriber( "get_gnomehammer_end2", get_gnomehammer_end2, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_coals () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_coals" ] = {
      type = "use",
      inv_obj = "inv_coals",
      use_place = "obj_pond_use_coals",
      room = private.room_objname,
      zz = "zz_pond",
      zz_gate = "gzz_nearcastle_pond"
  };
  --------------------------------------------------------------------------------------------
  local use_coals_inv = function ()
  
    interface.InventoryItemRemove( "inv_coals" );
  
  end;
  local use_coals_beg = function ()
  
    ObjDelete( "obj_pond_use_coals" );
    ObjDelete( "anm_pond_salamander_2_touch" );
  
  end;
  local use_coals_end = function ()
  
    ObjMultiSet( { {"obj_pond_salamander", { input = 1 }},
                   {"anm_pond_salamander_2", { alp = 1 }},
                   {"anm_pond_salamander_fire", { alp = 1 }} } );
    ObjDelete( "anm_pond_use_coal" );
    ObjDelete( "tmr_pond_timer" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_coals", use_coals_beg, private.room_objname );
  cmn.AddSubscriber( "use_coals", use_coals_inv );
  cmn.AddSubscriber( "use_coals", use_coals_end, private.room_objname );
  cmn.AddSubscriber( "use_coals_inv", use_coals_inv, private.room_objname );
  cmn.AddSubscriber( "use_coals_beg", use_coals_beg, private.room_objname );
  cmn.AddSubscriber( "use_coals_end", use_coals_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fishingrod () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_fishingrod" ] = {
      type = "use",
      inv_obj = "inv_fishingrod",
      use_place = "obj_pond_use_fishingrod",
      room = private.room_objname,
      zz = "zz_pond",
      zz_gate = "gzz_nearcastle_pond"
  };
  --------------------------------------------------------------------------------------------
  local use_fishingrod_inv = function ()
  
    interface.InventoryItemRemove( "inv_fishingrod" );
  
  end;
  local use_fishingrod_beg = function ()
  
    ObjDelete( "obj_pond_use_fishingrod" );
    ObjDelete( "anm_pond_salamander_1_touch" );
    ObjDelete( "anm_pond_salamander_1" );
  
  end;
  local use_fishingrod_end = function ()
    
    ObjDelete( "anm_pond_use_fishingrod" );
    ObjDelete( "anm_pond_salamander_jump" );
    
    ObjDelete( "spr_nearcastle_salamander_1" );
  
    ObjMultiSet( { {"obj_pond_use_coals", { alp = 1, input = 1 }},
                   {"obj_pond_salamander", { alp = 1 }},
                   {"spr_nearcastle_salamander_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fishingrod", use_fishingrod_beg, private.room_objname );
  cmn.AddSubscriber( "use_fishingrod", use_fishingrod_inv );
  cmn.AddSubscriber( "use_fishingrod", use_fishingrod_end, private.room_objname );
  cmn.AddSubscriber( "use_fishingrod_inv", use_fishingrod_inv, private.room_objname );
  cmn.AddSubscriber( "use_fishingrod_beg", use_fishingrod_beg, private.room_objname );
  cmn.AddSubscriber( "use_fishingrod_end", use_fishingrod_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_yingyangfish () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_yingyangfish" ] = {
      type = "use",
      inv_obj = "inv_yingyangfish",
      use_place = "obj_pond_use_yingyangfish",
      room = private.room_objname,
      zz = "zz_pond",
      zz_gate = "gzz_nearcastle_pond"
  };
  --------------------------------------------------------------------------------------------
  local use_yingyangfish_inv = function ()
  
    interface.InventoryItemRemove( "inv_yingyangfish" );
  
  end;
  local use_yingyangfish_beg = function ()
  
    ObjDelete( "obj_pond_use_yingyangfish" );
  
  end;
  local use_yingyangfish_end = function ()

    ObjDelete( "anm_pond_fish" );
    ObjDelete( "vid_pond_use_fish" );
    ObjDelete( "fx_pond_heart" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_yingyangfish", use_yingyangfish_beg, private.room_objname );
  cmn.AddSubscriber( "use_yingyangfish", use_yingyangfish_inv );
  cmn.AddSubscriber( "use_yingyangfish", use_yingyangfish_end, private.room_objname );
  cmn.AddSubscriber( "use_yingyangfish_inv", use_yingyangfish_inv, private.room_objname );
  cmn.AddSubscriber( "use_yingyangfish_beg", use_yingyangfish_beg, private.room_objname );
  cmn.AddSubscriber( "use_yingyangfish_end", use_yingyangfish_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_salamander () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_salamander" ] = {
      type = "use",
      inv_obj = "inv_salamander",
      use_place = "obj_treehollow_use_salamander",
      room = private.room_objname,
      zz = "zz_treehollow",
      zz_gate = "gzz_nearcastle_treehollow"
  };
  --------------------------------------------------------------------------------------------
  local use_salamander_inv = function ()
  
    interface.InventoryItemRemove( "inv_salamander" );
  
  end;
  local use_salamander_beg = function ()
  
    ObjDelete( "obj_treehollow_use_salamander" );
  
  end;
  local use_salamander_end = function ()
  
    ObjMultiSet( { {"gho_nearcastle_intohollow",  { active = 1, input = 1, alp = 1 }},
                   {"spr_nearcastle_tree_hollow", { alp = 1 }} } );
    ObjDelete( "gzz_nearcastle_treehollow" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_salamander", use_salamander_beg, private.room_objname );
  cmn.AddSubscriber( "use_salamander", use_salamander_inv );
  cmn.AddSubscriber( "use_salamander", use_salamander_end, private.room_objname );
  cmn.AddSubscriber( "use_salamander_inv", use_salamander_inv, private.room_objname );
  cmn.AddSubscriber( "use_salamander_beg", use_salamander_beg, private.room_objname );
  cmn.AddSubscriber( "use_salamander_end", use_salamander_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_nestling () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_nestling" ] = {
      type = "use",
      inv_obj = "inv_nestling",
      use_place = "obj_summerhouse_use_nestling",
      room = private.room_objname,
      zz = "zz_summerhouse",
      zz_gate = "gzz_nearcastle_summerhouse"
  };
  --------------------------------------------------------------------------------------------
  local use_nestling_inv = function ()
  
    interface.InventoryItemRemove( "inv_nestling" );
  
  end;
  local use_nestling_beg = function ()
  
    ObjDelete( "obj_summerhouse_use_nestling" );
    ObjDelete( "anm_summerhouse_bird" );
    ObjDelete( "anm_summerhouse_bird_touch" );
  
  end;
  local use_nestling_end = function ()
    
    ObjDelete( "anm_summerhouse_use_nestling" );
    ObjDelete( "anm_summerhouse_use_nestling_2" );
  
    ObjMultiSet( { {"spr_summerhouse_nestling", { alp = 1 }},
                   {"spr_summerhouse_mosaicpart3", { input = 1 }},
                   {"spr_summerhouse_jug", { input = 1 }},
                   {"spr_nearcastle_arbor_nestling", { alp = 1 }},
                   {"anm_summerhouse_birds_together", { alp = 1 }},
                   {"anm_summerhouse_nestling_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_nestling", use_nestling_beg, private.room_objname );
  cmn.AddSubscriber( "use_nestling", use_nestling_inv );
  cmn.AddSubscriber( "use_nestling", use_nestling_end, private.room_objname );
  cmn.AddSubscriber( "use_nestling_inv", use_nestling_inv, private.room_objname );
  cmn.AddSubscriber( "use_nestling_beg", use_nestling_beg, private.room_objname );
  cmn.AddSubscriber( "use_nestling_end", use_nestling_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_flower () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_flower" ] = {
      type = "use",
      inv_obj = "inv_flower",
      use_place = "obj_summerhouse_use_flower",
      room = private.room_objname,
      zz = "zz_summerhouse",
      zz_gate = "gzz_nearcastle_summerhouse"
  };
  --------------------------------------------------------------------------------------------
  local use_flower_inv = function ()
  
    interface.InventoryItemRemove( "inv_flower" );
  
  end;
  local use_flower_beg = function ()
  
    ObjDelete( "obj_summerhouse_use_flower" );
    ObjDelete( "anm_summerhouse_lianas_touch" );
  
  end;
  local use_flower_end = function ()
  
    ObjMultiSet( { {"obj_summerhouse_open", { alp = 1, input = 1 }},
                   {"obj_summerhouse_back", { scale_x = 1, scale_y = 1 }},
                   {"spr_nearcastle_arbor_open", { alp = 1 }},
                   {"obj_summerhouse_note_small", { input = 1 }} } );
    
    ObjDelete( "anm_summerhouse_lianas" );
    ObjDelete( "spr_summerhouse_lianas_sh" );
    ObjDelete( "anm_summerhouse_use_flower" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_flower", use_flower_beg, private.room_objname );
  cmn.AddSubscriber( "use_flower", use_flower_inv );
  cmn.AddSubscriber( "use_flower", use_flower_end, private.room_objname );
  cmn.AddSubscriber( "use_flower_inv", use_flower_inv, private.room_objname );
  cmn.AddSubscriber( "use_flower_beg", use_flower_beg, private.room_objname );
  cmn.AddSubscriber( "use_flower_end", use_flower_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lovesymbol () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lovesymbol" ] = {
      type = "use",
      inv_obj = "inv_lovesymbol",
      use_place = "obj_summerhouse_use_lovesymbol",
      room = private.room_objname,
      zz = "zz_summerhouse",
      zz_gate = "gzz_nearcastle_summerhouse"
  };
  --------------------------------------------------------------------------------------------
  local use_lovesymbol_inv = function ()
  
    interface.InventoryItemRemove( "inv_lovesymbol" );
  
  end;
  local use_lovesymbol_beg = function ()
  
    ObjDelete( "obj_summerhouse_use_lovesymbol" );
  
  end;
  local use_lovesymbol_end = function ()
    
    ObjDelete( "anm_summerhouse_box_touch" );
    ObjDelete( "spr_nearcastle_arbor_box" );
  
    ObjMultiSet( { {"obj_summerhouse_box_open", { alp = 1, input = 1 }},
                   --{"spr_summerhouse_box_open", { alp = 1 }},
                   {"spr_nearcastle_arbor_gnome", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lovesymbol", use_lovesymbol_beg, private.room_objname );
  cmn.AddSubscriber( "use_lovesymbol", use_lovesymbol_inv );
  cmn.AddSubscriber( "use_lovesymbol", use_lovesymbol_end, private.room_objname );
  cmn.AddSubscriber( "use_lovesymbol_inv", use_lovesymbol_inv, private.room_objname );
  cmn.AddSubscriber( "use_lovesymbol_beg", use_lovesymbol_beg, private.room_objname );
  cmn.AddSubscriber( "use_lovesymbol_end", use_lovesymbol_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gnomehat () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_gnomehat" ] = {
      type = "use",
      inv_obj = "inv_gnomehat",
      use_place = "obj_gnome_use_gnomehat",
      room = private.room_objname,
      zz = "zz_gnome",
      zz_gate = "gzz_nearcastle_gnome"
  };
  --------------------------------------------------------------------------------------------
  local use_gnomehat_inv = function ()
  
    interface.InventoryItemRemove( "inv_gnomehat" );
  
  end;
  local use_gnomehat_beg = function ()
  
    ObjDelete( "obj_gnome_use_gnomehat" );
  
  end;
  local use_gnomehat_end = function ()

    local animfunc;
    if ( cmn.IsEventDone( "use_woodenwolf" ) ) then
      animfunc = "func_kid_gnome_03";
    else
      animfunc = "func_kid_gnome_02";
    end;
  
    ObjMultiSet( {
      {"anm_gnome_gnome_kid", { animfunc = animfunc, endtrig = "" }},
      {"obj_gnome_brokenscoopnet", { alp = 1, input = true }},
      {"gfx_gnome_brokenscoopnet", { active = true }},

      {"spr_nearcastle_scoopnet", { alp = 1 }},
      {"anm_nearcastle_gnome_kid_hat2", { alp = 1 }}
    } );

    ObjDelete( "anm_nearcastle_gnome_kid_hat1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gnomehat", use_gnomehat_beg, private.room_objname );
  cmn.AddSubscriber( "use_gnomehat", use_gnomehat_inv );
  cmn.AddSubscriber( "use_gnomehat", use_gnomehat_end, private.room_objname );
  cmn.AddSubscriber( "use_gnomehat_inv", use_gnomehat_inv, private.room_objname );
  cmn.AddSubscriber( "use_gnomehat_beg", use_gnomehat_beg, private.room_objname );
  cmn.AddSubscriber( "use_gnomehat_end", use_gnomehat_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_woodenwolf () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_woodenwolf" ] = {
      type = "use",
      inv_obj = "inv_woodenwolf",
      use_place = "obj_gnome_use_woodenwolf",
      room = private.room_objname,
      zz = "zz_gnome",
      zz_gate = "gzz_nearcastle_gnome"
  };
  --------------------------------------------------------------------------------------------
  local use_woodenwolf_inv = function ()
  
    interface.InventoryItemRemove( "inv_woodenwolf" );
  
  end;
  local use_woodenwolf_beg = function ()
  
    ObjDelete( "obj_gnome_use_woodenwolf" );
    ObjDelete( "obj_gnome_wolf" );
  
  end;
  local use_woodenwolf_end = function ()

    local animfunc;
    if ( cmn.IsEventDone( "use_gnomehat" ) ) then
      animfunc = "func_kid_gnome_03";
    else
      animfunc = "func_kid_gnome_plaing_on_scoopnet";
    end;

    ObjMultiSet( { { "anm_gnome_gnome_kid", { animfunc = animfunc, endtrig = "" } },
                   { "spr_gnome_bracelet", { alp = 1, input = true } },
                   { "gfx_gnome_bracelet", { active = true } },

                   { "spr_nearcastle_braslet", { alp = 1 }},
                   { "anm_nearcastle_gnome_kid2", { alp = 1 }} } );

    ObjDelete( "anm_nearcastle_gnome_kid" );
    ObjDelete( "spr_nearcastle_wolf" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_woodenwolf", use_woodenwolf_beg, private.room_objname );
  cmn.AddSubscriber( "use_woodenwolf", use_woodenwolf_inv );
  cmn.AddSubscriber( "use_woodenwolf", use_woodenwolf_end, private.room_objname );
  cmn.AddSubscriber( "use_woodenwolf_inv", use_woodenwolf_inv, private.room_objname );
  cmn.AddSubscriber( "use_woodenwolf_beg", use_woodenwolf_beg, private.room_objname );
  cmn.AddSubscriber( "use_woodenwolf_end", use_woodenwolf_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gnomegirlfigurine () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_gnomegirlfigurine" ] = {
      type = "use",
      inv_obj = "inv_gnomegirlfigurine",
      use_place = "obj_gnome_use_gnomegirlfigurine",
      room = private.room_objname,
      zz = "zz_gnome",
      zz_gate = "gzz_nearcastle_gnome"
  };
  --------------------------------------------------------------------------------------------
  local use_gnomegirlfigurine_inv = function ()
  
    interface.InventoryItemRemove( "inv_gnomegirlfigurine" );
  
  end;
  local use_gnomegirlfigurine_beg = function ()
  
    ObjDelete( "obj_gnome_use_gnomegirlfigurine" );
  
  end;
  local use_gnomegirlfigurine_end = function ()

    ObjDelete( "anm_gnome_gnome_kid" );
    ObjDelete( "anm_nearcastle_gnome_kid2" );
    ObjDelete( "anm_nearcastle_gnome_kid_hat2" );
    ObjDelete( "spr_nearcastle_gnome_1" );

    ObjMultiSet( {
      { "gfx_gnome_gnomehammer", { active = true } },
      { "gfx_gnome_magnet", { active = true } },
      { "anm_gnome_gnome", { animfunc = "func_gnome_giving_hands", endtrig = "", frame = 31, input = true } },

      { "spr_nearcastle_gnome_2", { alp = 1 } },
      { "spr_nearcastle_gnome_girl", { alp = 1 } },
      { "anm_nearcastle_gnome_kid3", { alp = 1 } },
      { "spr_gnome_note_small", { input = 0 } }
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gnomegirlfigurine", use_gnomegirlfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_gnomegirlfigurine", use_gnomegirlfigurine_inv );
  cmn.AddSubscriber( "use_gnomegirlfigurine", use_gnomegirlfigurine_end, private.room_objname );
  cmn.AddSubscriber( "use_gnomegirlfigurine_inv", use_gnomegirlfigurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_gnomegirlfigurine_beg", use_gnomegirlfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_gnomegirlfigurine_end", use_gnomegirlfigurine_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_nearcastlefirst () end;
  --------------------------------------------------------------------------------------------
  local clk_nearcastlefirst = function ()
    
    ObjDelete("obj_nearcastle_clk_nearcastlefirst");
    ObjDelete("anm_nearcastle_man_bridge");
    ObjDelete("spr_nearcastle_man_bridge_bl");
    
    ObjMultiSet( { { "obj_nearcastle_castle_bbt", { input = 1 } },
                   { "grm_nearcastle_castlegate", { event_mdown = function() cmn.GotoRoomMDown( "nearcastle_castlegate" ); end, event_mup = function() cmn.GotoRoomMUp( "nearcastle_castlegate", "rm_castlegate" ); end } },
                   { "gzz_nearcastle_pond", { event_mdown = function() cmn.GotoSubRoomMDown( "nearcastle_pond" ); end, event_mup = function() cmn.GotoSubRoomMUp( "nearcastle_pond", "zz_pond" ); end } },
                   { "gzz_nearcastle_treehollow", { event_mdown = function() cmn.GotoSubRoomMDown( "nearcastle_treehollow" ); end, event_mup = function() cmn.GotoSubRoomMUp( "nearcastle_treehollow", "zz_treehollow" ); end } },
                   { "gzz_nearcastle_summerhouse", { event_mdown = function() cmn.GotoSubRoomMDown( "nearcastle_summerhouse" ); end, event_mup = function() cmn.GotoSubRoomMUp( "nearcastle_summerhouse", "zz_summerhouse" ); end } },
                   { "gzz_nearcastle_gnome", { event_mdown = function() cmn.GotoSubRoomMDown( "nearcastle_gnome" ); end, event_mup = function() cmn.GotoSubRoomMUp( "nearcastle_gnome", "zz_gnome" ); end } },
                   { "grm_nearcastle_castlegate_focus", { res = "assets/levels/level1/rm_nearcastle/focus_castlegate" }},
                   { "spr_nearcastle_gate_open", { alp = 0 }} } );
                   
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_nearcastlefirst", clk_nearcastlefirst, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_nearcastle () end;
  --------------------------------------------------------------------------------------------
  local opn_nearcastle = function ()
  
    int_map_impl.OpenRoom( "rm_nearcastle" );
    int_map_impl.BlockRoom( "rm_apartmentlivingroom" );
    int_map_impl.BlockRoom( "rm_bedroom" );
    int_map_impl.BlockRoom( "rm_kitchen" );
    interface_impl.SetCurrentGlobalTask( 5 );
    
    interface.InventoryItemAdd( "inv_lvl1cinderellapage" );
    interface.InventoryItemRemove( "inv_magicpagepiece" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_nearcastle", opn_nearcastle );

  --------------------------------------------------------------------------------------------
  -- function opn_gnome () end;
  --------------------------------------------------------------------------------------------
  local opn_gnome = function ()
    
    ObjDelete("anm_nearcastle_gnome_kid_0");
    
    ObjMultiSet( { { "anm_gnome_gnome_kid", { animfunc = "func_kid_gnome_01", endtrig = "" } },
                   { "obj_gnome_wolf", { alp = 1, input = true } },
                   { "spr_nearcastle_wolf", { alp = 1 } },
                   { "anm_nearcastle_gnome_kid", { alp = 1 } } } );
                   
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_gnome", opn_gnome, private.room_objname );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_gnome" );
  subroom.Define( "zz_pond" );
  subroom.Define( "zz_summerhouse" );

  function zz_gnome.PreOpen()
    if cmn.IsEventDone( "opn_gnome" ) and not cmn.IsEventDone( "use_gnomegirlfigurine" ) then
      ObjSet( "anm_gnome_gnome_kid", { playing = true } );
    end;
  end;
  
  function zz_gnome.Open()
    
    if not(cmn.IsEventDone( "opn_gnome" )) then

      cmn.ShowBbt( "gnome_open" );
      cmn.Lock( 1 );

      ObjSet( "anm_gnome_gnome_kid", {
        playing = true,
        endtrig = function ()

          cmn.SetEventDone("opn_gnome");
          cmn.CallEventHandler( "opn_gnome" );

          ObjSet( "anm_gnome_gnome_kid", { playing = true } );
          cmn.Lock( 0 );

        end
      } );

    end;
      
  end;
  
  function zz_gnome.Close()
    
    cmn.HideNote( 0 );
      
  end;
  
  function zz_summerhouse.Open()
    
    if cmn.IsEventDone("use_flower") then
      cmn.PlayAudio("env", "assets/levels/common/audio/aud_chicken_env");
    end;
    
    if cmn.IsEventDone("use_nestling") then
      ObjMultiSet( { {"anm_summerhouse_birds_together",  { playing = 1 }},
                     {"anm_summerhouse_nestling_2",  { playing = 1 }} } );
    end;
      
  end;
                 
  function zz_summerhouse.PreClose()
    
    cmn.StopAllEnv("assets/levels/common/audio/aud_nearcastle_env");
    cmn.PlayAudio("env", "assets/levels/common/audio/aud_nearcastle_env");
      
  end;               
  
  function zz_summerhouse.Close()
    
    cmn.HideNote( 0 );
      
  end;
  
  function zz_pond.PreOpen()
    
    if cmn.IsEventDone( "use_fishingrod" ) and not cmn.IsEventDone("get_salamander") then
      ObjSet("anm_pond_salamander_2",  { playing = 1 });
    end;
    if cmn.IsEventDone( "use_coals" ) and not cmn.IsEventDone("get_salamander") then
      ObjSet("anm_pond_salamander_fire",  { playing = 1 });
    end;
      
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_nearcastle();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/aud_nearcastle_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/aud_nearcastle_env");
  
  if not ( cmn.IsEventDone( "opn_nearcastle" ) ) then
    cmn.Lock(1);
    --cmn.CallEventHandler("opn_nearcastle");
  end;
  
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(3) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_coals()

  local item = "inv_coals";

  if cmn.ApplyObj( item, "gzz_nearcastle_pond" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_pond" );

  elseif ( cmn.ApplyObj( item, "obj_pond_use_coals" ) and cmn.IsEventDone("use_fishingrod") ) then

    cmn.CallEventHandler( "use_coals_inv" );
    cmn.CallEventHandler( "use_coals_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_coals" );
      cmn.CallEventHandler( "use_coals_end" );
    
    end;
    
    local anm_fire = function ()
      
      ObjSet("anm_pond_salamander_fire",  { playing = 1 });
      ObjAnimate("anm_pond_salamander_fire", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_nearcastle/audio/aud_use_coal");

    ObjMultiSet( { {"anm_pond_use_coal", { alp = 1, playing = 1, endtrig = func_after }},
                   {"anm_pond_salamander_2", { alp = 0 }},
                   {"tmr_pond_timer", { time = 2, playing = 1, endtrig = anm_fire }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fishingrod()

  local item = "inv_fishingrod";

  if cmn.ApplyObj( item, "gzz_nearcastle_pond" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_pond" );

  elseif ( cmn.ApplyObj( item, "obj_pond_use_fishingrod" ) ) then

    cmn.CallEventHandler( "use_fishingrod_inv" );
    cmn.CallEventHandler( "use_fishingrod_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_fishingrod" );
      cmn.CallEventHandler( "use_fishingrod_end" );
      
      ObjSet("anm_pond_salamander_2",  { playing = 1 });
    
    end;
    
    local anm_jump = function ()
      
      ObjMultiSet( { {"anm_pond_salamander_jump", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_pond_use_fishingrod", { alp = 0 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_nearcastle/audio/aud_use_rod");

    ObjSet("anm_pond_use_fishingrod",  { alp = 1, playing = 1, endtrig = anm_jump });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_yingyangfish()

  local item = "inv_yingyangfish";

  if cmn.ApplyObj( item, "gzz_nearcastle_pond" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_pond" );

  elseif ( cmn.ApplyObj( item, "obj_pond_use_yingyangfish" ) ) then

    cmn.CallEventHandler( "use_yingyangfish_inv" );
    cmn.CallEventHandler( "use_yingyangfish_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      public.get_rubyheart();

      cmn.SetEventDone( "use_yingyangfish" );
      cmn.CallEventHandler( "use_yingyangfish_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_nearcastle/audio/aud_use_fish");

    ObjAttach("vid_pond_use_fish", "zz_pond");
    ObjAnimate("vid_pond_use_fish", "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 1 });
    VidPlay("vid_pond_use_fish", func_after);

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_salamander()

  local item = "inv_salamander";

  if cmn.ApplyObj( item, "gzz_nearcastle_treehollow" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_treehollow" );

  elseif ( cmn.ApplyObj( item, "obj_treehollow_use_salamander" ) ) then

    cmn.CallEventHandler( "use_salamander_inv" );
    cmn.CallEventHandler( "use_salamander_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_salamander" );
      cmn.CallEventHandler( "use_salamander_end" );
      
      common.CloseSubRoom();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_nearcastle/audio/aud_use_lizard");

    ObjSet("anm_treehollow_use_salamander",  { alp = 1, playing = 1, endtrig = func_after });
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_nestling()

  local item = "inv_nestling";

  if cmn.ApplyObj( item, "gzz_nearcastle_summerhouse" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_summerhouse" );

  elseif ( cmn.ApplyObj( item, "obj_summerhouse_use_nestling" ) and cmn.IsEventDone("use_flower") ) then

    cmn.CallEventHandler( "use_nestling_inv" );
    cmn.CallEventHandler( "use_nestling_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_nestling" );
      cmn.CallEventHandler( "use_nestling_end" );
      
      ObjMultiSet( { {"anm_summerhouse_birds_together",  { playing = 1 }},
                     {"anm_summerhouse_nestling_2",  { playing = 1 }} } );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_nearcastle/audio/aud_chick_use");

    ObjMultiSet( { {"anm_summerhouse_use_nestling",  { alp = 1, playing = 1, endtrig = func_after }},
                   {"anm_summerhouse_use_nestling_2", { alp = 1, playing = 1 }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_flower()

  local item = "inv_flower";

  if cmn.ApplyObj( item, "gzz_nearcastle_summerhouse" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_summerhouse" );

  elseif ( cmn.ApplyObj( item, "obj_summerhouse_use_flower" ) ) then

    cmn.CallEventHandler( "use_flower_inv" );
    cmn.CallEventHandler( "use_flower_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_flower" );
      cmn.CallEventHandler( "use_flower_end" );
    
    end;
    
    local anm_zoom = function ()
      
      cmn.PlayAudio("env", "assets/levels/common/audio/aud_chicken_env");
      ObjAnimate("obj_summerhouse_back", "scale_xy", 0, 0, func_after, { 0, 0, 0.72, 0.72,   1, 0, 1, 1 });
      
    end;
    
    local anm_lianas = function ()
      
      ObjDelete("anm_summerhouse_lianas");
      
      ObjAnimate("spr_summerhouse_lianas_sh", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjSet("anm_summerhouse_use_flower",  { alp = 1, playing = 1, endtrig = anm_zoom });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_nearcastle/audio/aud_use_flower");

    ObjAnimate( "obj_summerhouse_flower", "alp", 0, 0, anm_lianas,
    {
      0.0, 0, 0, 
      0.3, 0, 1, 
      0.6, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lovesymbol()

  local item = "inv_lovesymbol";

  if cmn.ApplyObj( item, "gzz_nearcastle_summerhouse" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_summerhouse" );

  elseif ( cmn.ApplyObj( item, "obj_summerhouse_use_lovesymbol" ) and cmn.IsEventDone("use_flower") ) then

    cmn.CallEventHandler( "use_lovesymbol_inv" );
    cmn.CallEventHandler( "use_lovesymbol_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lovesymbol" );
      cmn.CallEventHandler( "use_lovesymbol_end" );
    
    end;
    
    local anm_box = function ()
      
      ObjSet("obj_summerhouse_box_open",  { alp = 1 });
      
      --ObjAnimate("spr_summerhouse_box_open", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_summerhouse_box_touch", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_nearcastle/audio/aud_use_jewelery");
    
    if not cmn.IsEventDone("get_lionhead") or not cmn.IsEventDone("get_scissors") then
      
      if not cmn.IsEventDone("get_scissors") then
        cmn.SetEventDone( "get_scissors" );
        cmn.CallEventHandler( "get_scissors" );
      end;
      
      if not cmn.IsEventDone("get_lionhead") then
        cmn.SetEventDone( "get_lionhead" );
        cmn.CallEventHandler( "get_lionhead" );
      end;

      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
      
    end;

    ObjAnimate( "spr_summerhouse_box_heart", "alp", 0, 0, anm_box,
    {
      0.0, 0, 0, 
      0.3, 0, 1, 
      0.6, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_gnomehat()

  local item = "inv_gnomehat";

  if cmn.ApplyObj( item, "gzz_nearcastle_gnome" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_gnome" );

  elseif ( cmn.ApplyObj( item, "obj_gnome_use_gnomehat" ) and cmn.IsEventDone( "opn_gnome" ) ) then

    cmn.CallEventHandler( "use_gnomehat_inv" );
    cmn.CallEventHandler( "use_gnomehat_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_gnomehat" );
      cmn.CallEventHandler( "use_gnomehat_end" );

      ObjSet( "anm_gnome_gnome_kid", { playing = true } );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_nearcastle/audio/aud_cap");

    local animfunc;

    if ( cmn.IsEventDone( "use_woodenwolf" ) ) then
      animfunc = "func_kid_taking_off_scoopnet_wolftoy";
      ObjSet( "anm_gnome_gnome_kid", { pos_z = 7 } );
    else
      animfunc = "func_kid_taking_off_scoopnet_braslet";
    end;

    ObjSet( "anm_gnome_gnome_kid", { animfunc = animfunc, endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_woodenwolf()

  local item = "inv_woodenwolf";

  if cmn.ApplyObj( item, "gzz_nearcastle_gnome" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_gnome" );

  elseif ( ( cmn.ApplyObj( item, "obj_gnome_use_woodenwolf" ) or cmn.ApplyObj( item, "obj_gnome_wolf" ) )
  and cmn.IsEventDone( "opn_gnome" ) ) then

    cmn.CallEventHandler( "use_woodenwolf_inv" );
    cmn.CallEventHandler( "use_woodenwolf_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_woodenwolf" );
      cmn.CallEventHandler( "use_woodenwolf_end" );

      ObjSet( "anm_gnome_gnome_kid", { playing = true } );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_nearcastle/audio/aud_use_wood_wolf");

    local animfunc;

    if ( cmn.IsEventDone( "use_gnomehat" ) ) then
      animfunc = "func_kid_taking_wolfy_hat";
    else
      animfunc = "func_kid_taking_wolfy_scoopnet";
    end;

    ObjSet( "anm_gnome_gnome_kid", { animfunc = animfunc, endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_gnomegirlfigurine()

  local item = "inv_gnomegirlfigurine";

  if cmn.ApplyObj( item, "gzz_nearcastle_gnome" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_gnome" );

  elseif ( cmn.ApplyObj( item, "obj_gnome_use_gnomegirlfigurine" ) ) then

    cmn.CallEventHandler( "use_gnomegirlfigurine_inv" );
    cmn.CallEventHandler( "use_gnomegirlfigurine_beg" );

    local func_after2 = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_gnomegirlfigurine" );
      cmn.CallEventHandler( "use_gnomegirlfigurine_end" );
    
    end;

    local func_after = function ()
      ObjDelete( "anm_gnome_gnome_kid" );
      ObjSet( "anm_gnome_gnome", { animfunc = "func_gnome_giving_hands", endtrig = func_after2, playing = true } );
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_nearcastle/audio/aud_use_gnome");

    ObjSet( "anm_gnome_gnome", { animfunc = "func_breaking_stones", endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_salamander()

  cmn.SetEventDone( "get_salamander" );
  cmn.CallEventHandler( "get_salamander" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_rubyheart()
  
  ObjSet("obj_pond_rubyheart",  { alp = 1 });

  cmn.SetEventDone( "get_rubyheart" );
  cmn.CallEventHandler( "get_rubyheart" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_gnomegirlfigurine()

  cmn.SetEventDone( "get_gnomegirlfigurine" );
  cmn.CallEventHandler( "get_gnomegirlfigurine" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
    if port.isPortable()==1 then
      iOS_RateMe();
    end;
    
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_lionhead()

  cmn.SetEventDone( "get_lionhead" );
  cmn.CallEventHandler( "get_lionhead" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_scissors()

  cmn.SetEventDone( "get_scissors" );
  cmn.CallEventHandler( "get_scissors" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_jug()

  cmn.SetEventDone( "get_jug" );
  cmn.CallEventHandler( "get_jug" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_mosaicpart3()

  cmn.SetEventDone( "get_mosaicpart3" );
  cmn.CallEventHandler( "get_mosaicpart3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_stick()

  ObjSet( "spr_gnome_stick", { alp = 1 } );

  cmn.SetEventDone( "get_stick" );
  cmn.CallEventHandler( "get_stick" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_brokenscoopnet()

  cmn.SetEventDone( "get_brokenscoopnet" );
  cmn.CallEventHandler( "get_brokenscoopnet" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_bracelet()

  cmn.SetEventDone( "get_bracelet" );
  cmn.CallEventHandler( "get_bracelet" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_magnet()

  cmn.SetEventDone( "get_magnet" );
  cmn.CallEventHandler( "get_magnet_inv" );
  cmn.CallEventHandler( "get_magnet_end" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if ( cmn.IsEventDone( "get_gnomehammer" ) ) then

    cmn.Lock( 1 );

    local func_after = function ()
      cmn.CallEventHandler( "get_magnet_end2" );
      common.CloseSubRoom();
      cmn.Lock( 0 );
    end;

    ObjSet( "anm_gnome_gnome", { animfunc = "func_gnomes_leaving_us", endtrig = func_after, playing = true } );

  else

    public.get_gnomehammer( true );

  end;

end;
--------------------------------------------------------------------------------------------
function public.get_gnomehammer( not_play_aud_get )

  ObjSet( "spr_gnome_gnomehammer", { ang = 1.9326 } );

  cmn.SetEventDone( "get_gnomehammer" );
  cmn.CallEventHandler( "get_gnomehammer_inv" );
  cmn.CallEventHandler( "get_gnomehammer_end" );

  if ( not not_play_aud_get ) then
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  end;

  if ( cmn.IsEventDone( "get_magnet" ) ) then

    cmn.Lock( 1 );

    local func_after = function ()
      cmn.CallEventHandler( "get_gnomehammer_end2" );
      common.CloseSubRoom();
      cmn.Lock( 0 );
    end;

    ObjSet( "anm_gnome_gnome", { animfunc = "func_gnomes_leaving_us", endtrig = func_after, playing = true } );

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_nearcastlefirst()
  
  local func_after = function ()
    
    cmn.CallEventHandler("clk_nearcastlefirst");
    cmn.ShowBbt( "castlegate_open" );
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_track4_mus_env");
    
    cmn.PlayAudio("env", "assets/levels/common/audio/aud_nearcastle_env");
    
  end;
  
  SndStop( common_impl.audio.voc, 0.5 );
  
  ObjDelete("obj_nearcastle_clk_nearcastlefirst");
  
  cmn.StopAllEnv();
  
  cmn.SetEventDone("clk_nearcastlefirst");
  cmn.PlayFullscreenVideo( "assets/levels/level1/rm_nearcastle/vid_manonbridge", func_after, "assets/levels/level1/rm_nearcastle/audio/aud_manonbridge", "assets/levels/level1/rm_nearcastle/audio/aud_manonbridge_voc");
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_nearcastle()

  if not ( cmn.IsEventDone( "opn_nearcastle" ) ) then
    cmn.Lock(0);
    cmn.SetEventDone( "opn_nearcastle" );
    --cmn.CallEventHandler("opn_nearcastle");
    cmn.ShowDlgBbt( "nearcastle_open_voice", 1 );
    cmn.PlayAudio("voc", "assets/levels/level1/rm_nearcastle/audio/aud_cat_dlg_3_1_voc");
    interface_impl.ShowGlobalTask();
    int_map_impl.AddDiarypage( 4 );
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_salamander_1()
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_nearcastle/audio/aud_xx_lizard");
  cmn.ShowBbt( "obj_pond_use_fishingrod" );
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_pond_salamander_1", { alp = 1, playing = 1 }},
                   {"anm_pond_salamander_1_touch", { alp = 0 }} } );
    
  end;
  
  cmn.Lock(1);
  
  ObjMultiSet( { {"anm_pond_salamander_1", { alp = 0, playing = 0 }},
                 {"anm_pond_salamander_1_touch", { alp = 1, playing = 1, endtrig = func_after }} } );
    
end;
--------------------------------------------------------------------------------------------
function public.touch_salamander_2()
  
  cmn.ShowBbt( "obj_pond_use_coals" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_nearcastle/audio/aud_xx_mouth");
  
  ObjSet("anm_pond_salamander_2_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_brokenscoopnet()
  
  cmn.ShowBbt( "obj_gnome_use_gnomehat" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_nearcastle/audio/aud_xx_boy1");

  local animfunc;

  if ( cmn.IsEventDone( "use_woodenwolf" ) ) then
    animfunc = "func_clk_kid_gnome_wolf";
  else
    animfunc = "func_kid_gnome_scoopnet";
  end;
  
  ObjSet("anm_gnome_gnome_kid", { animfunc = animfunc, playing = true,
    endtrig = function()

      local animfunc2;

      if ( cmn.IsEventDone( "use_woodenwolf" ) ) then
        animfunc2 = "func_kid_gnome_plaing_on_scoopnet";
      else
        animfunc2 = "func_kid_gnome_01";
      end;

      ObjSet( "anm_gnome_gnome_kid", { animfunc = animfunc2, endtrig = "", playing = true } );

      cmn.Lock(0);

    end
  });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_bracelet()
  
  cmn.ShowBbt( "obj_gnome_use_woodenwolf" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_nearcastle/audio/aud_xx_boy");

  local animfunc;

  if ( cmn.IsEventDone( "use_gnomehat" ) ) then
    animfunc = "func_clk_kid_gnome_05";
  else
    animfunc = "func_clk_kid_gnome_04";
  end;

  ObjSet( "anm_gnome_gnome_kid",  { animfunc = animfunc, playing = true,
    endtrig = function()

      local animfunc2;

      if ( cmn.IsEventDone( "use_gnomehat" ) ) then
        animfunc2 = "func_kid_gnome_02";
      else
        animfunc2 = "func_kid_gnome_01";
      end;

      ObjSet( "anm_gnome_gnome_kid", { animfunc = animfunc2, endtrig = "", playing = true } );

      cmn.Lock(0);

    end
  });

end;
--------------------------------------------------------------------------------------------
function public.touch_gnome()

  cmn.ShowBbt( "obj_gnome_use_gnomegirlfigurine" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_nearcastle/audio/aud_xx_clk_stone");
  
  ObjSet( "anm_gnome_gnome",  { playing = 1, endtrig = function() cmn.Lock(0); end });

end;
--------------------------------------------------------------------------------------------
function public.touch_lianas()

  cmn.ShowBbt( "obj_summerhouse_use_flower" );
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_summerhouse_lianas_touch",  { alp = 0 }},
                   {"anm_summerhouse_lianas", { alp = 1, playing = 1 }} } );

                 
  end;
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_xx_leaves");
  
  ObjMultiSet( { {"anm_summerhouse_lianas_touch",  { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_summerhouse_lianas", { alp = 0, playing = 0 }} } );

end;
--------------------------------------------------------------------------------------------
function public.touch_bird()

  cmn.ShowBbt( "obj_summerhouse_use_nestling" );
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_summerhouse_bird_touch",  { alp = 0 }},
                   {"anm_summerhouse_bird", { alp = 1, playing = 1 }} } );

                 
  end;
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_nearcastle/audio/aud_chicken_xx");
  
  ObjMultiSet( { {"anm_summerhouse_bird_touch",  { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_summerhouse_bird", { alp = 0, playing = 0 }} } );

end;
--------------------------------------------------------------------------------------------
function public.touch_stone_box()

  cmn.ShowBbt( "obj_summerhouse_use_lovesymbol" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_nearcastle/audio/aud_xx_clk_stone_box");
  
  ObjSet( "anm_summerhouse_box_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });

end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_3_1", { alp = 1 }},
                 {"spr_col_3_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_3_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_3_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_3_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_3_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_3_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_3_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--*********************************************************************************************************************
