-- name=rm_nearhome
--*********************************************************************************************************************
function public.Init()

  if port.ios_lang() == "ja" or port.ios_lang() == "ru" or port.ios_lang() == "de" then
    ObjSet("txt_coinciergeroomwindow_concierge_name",{ fontsize = 16 });
  end;
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_nearhome";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Clock();
  --------------------------------------------------------------------------------------------
  -- function get_coin () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_coin" ] = {
      type = "get",
      get_obj = "spr_housedoor_coin",
      room = private.room_objname,
      zz = "zz_housedoor",
      zz_gate = "gzz_nearhome_housedoor"
  };
  --------------------------------------------------------------------------------------------
  local get_coin_inv = function ()
  
    interface.InventoryItemAdd( "inv_coin", "spr_housedoor_coin" );
  
  end;
  local get_coin_end = function ()
  
    ObjDelete( "gfx_housedoor_coin" );
    ObjDelete( "spr_housedoor_coin_sh" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_coin", get_coin_inv );
  cmn.AddSubscriber( "get_coin", get_coin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magnetkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_magnetkey" ] = {
      type = "get",
      get_obj = "spr_coinciergeroomwindow_magnetkey",
      room = private.room_objname,
      zz = "zz_coinciergeroomwindow",
      zz_gate = "gzz_nearhome_coinciergeroomwindow"
  };
  --------------------------------------------------------------------------------------------
  local get_magnetkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_magnetkey", "spr_coinciergeroomwindow_magnetkey" );
  
  end;
  local get_magnetkey_end = function ()
  
    ObjDelete( "gfx_coinciergeroomwindow_magnetkey" );
    ObjDelete( "spr_coinciergeroomwindow_magnetkey_sh" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_magnetkey", get_magnetkey_inv );
  cmn.AddSubscriber( "get_magnetkey", get_magnetkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_silversnake () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_silversnake" ] = {
      type = "get",
      get_obj = "spr_coinciergeroomwindow_silversnake",
      room = private.room_objname,
      zz = "zz_coinciergeroomwindow",
      zz_gate = "gzz_nearhome_coinciergeroomwindow"
  };
  --------------------------------------------------------------------------------------------
  local get_silversnake_inv = function ()
  
    interface.InventoryItemAdd( "inv_silversnake", "spr_coinciergeroomwindow_silversnake" );
  
  end;
  local get_silversnake_end = function ()
  
    ObjDelete( "gfx_coinciergeroomwindow_silversnake" );
    ObjDelete( "spr_coinciergeroomwindow_silversnake_sh" );
    
    if cmn.IsEventDone("get_pin") then
      ObjSet("gzz_nearhome_coinciergeroomwindow",  { alp = 0, active = 0 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_silversnake", get_silversnake_inv );
  cmn.AddSubscriber( "get_silversnake", get_silversnake_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pin () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_pin" ] = {
      type = "get",
      get_obj = "spr_coinciergeroomwindow_pin",
      room = private.room_objname,
      zz = "zz_coinciergeroomwindow",
      zz_gate = "gzz_nearhome_coinciergeroomwindow"
  };
  --------------------------------------------------------------------------------------------
  local get_pin_inv = function ()
  
    interface.InventoryItemAdd( "inv_pin", "spr_coinciergeroomwindow_pin" );
  
  end;
  local get_pin_end = function ()
  
    ObjDelete( "gfx_coinciergeroomwindow_pin" );
    ObjDelete( "spr_coinciergeroomwindow_pin_sh" );
    
    if cmn.IsEventDone("get_silversnake") then
      ObjSet("gzz_nearhome_coinciergeroomwindow",  { alp = 0, active = 0 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_pin", get_pin_inv );
  cmn.AddSubscriber( "get_pin", get_pin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cleanhanky () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_cleanhanky" ] = {
      type = "get",
      get_obj = "spr_carinterior_cleanhanky",
      room = private.room_objname,
      zz = "zz_carinterior",
      zz_gate = "gzz_nearhome_carinterior"
  };
  --------------------------------------------------------------------------------------------
  local get_cleanhanky_inv = function ()
  
    interface.InventoryItemAdd( "inv_cleanhanky", "spr_carinterior_cleanhanky" );
  
  end;
  local get_cleanhanky_end = function ()
  
    ObjDelete( "gfx_carinterior_cleanhanky" );
    ObjDelete( "spr_carinterior_cleanhanky_sh" );
    
    if cmn.IsEventDone("get_woodenring") and cmn.IsEventDone("get_antiseptic") then
      ObjDelete( "gzz_nearhome_carinterior" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_cleanhanky", get_cleanhanky_inv );
  cmn.AddSubscriber( "get_cleanhanky", get_cleanhanky_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_antiseptic () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_antiseptic" ] = {
      type = "get",
      get_obj = "spr_carinterior_antiseptic",
      room = private.room_objname,
      zz = "zz_carinterior",
      zz_gate = "gzz_nearhome_carinterior"
  };
  --------------------------------------------------------------------------------------------
  local get_antiseptic_inv = function ()
  
    interface.InventoryItemAdd( "inv_antiseptic", "spr_carinterior_antiseptic" );
  
  end;
  local get_antiseptic_end = function ()
  
    ObjDelete( "gfx_carinterior_antiseptic" );
    ObjDelete( "spr_carinterior_antiseptic_sh" );
    
    if cmn.IsEventDone("get_woodenring") and cmn.IsEventDone("get_cleanhanky") then
      ObjDelete( "gzz_nearhome_carinterior" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_antiseptic", get_antiseptic_inv );
  cmn.AddSubscriber( "get_antiseptic", get_antiseptic_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_woodenring () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_woodenring" ] = {
      type = "get",
      get_obj = "spr_carinterior_woodenring",
      room = private.room_objname,
      zz = "zz_carinterior",
      zz_gate = "gzz_nearhome_carinterior"
  };
  --------------------------------------------------------------------------------------------
  local get_woodenring_inv = function ()
  
    interface.InventoryItemAdd( "inv_woodenring", "spr_carinterior_woodenring" );
  
  end;
  local get_woodenring_end = function ()
  
    ObjDelete( "gfx_carinterior_woodenring" );
    ObjDelete( "spr_carinterior_woodenring_sh" );
    
    ObjDelete( "spr_nearhome_car_disk" );
    
    if cmn.IsEventDone("get_antiseptic") and cmn.IsEventDone("get_cleanhanky") then
      ObjDelete( "gzz_nearhome_carinterior" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_woodenring", get_woodenring_inv );
  cmn.AddSubscriber( "get_woodenring", get_woodenring_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sleepingpills () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_sleepingpills" ] = {
      type = "get",
      get_obj = "spr_carinterior_sleepingpills",
      room = private.room_objname,
      zz = "zz_carinterior",
      zz_gate = "gzz_nearhome_carinterior"
  };
  --------------------------------------------------------------------------------------------
  local get_sleepingpills_inv = function ()
  
    interface.InventoryItemAdd( "inv_sleepingpills", "spr_carinterior_sleepingpills" );
  
  end;
  local get_sleepingpills_end = function ()
  
    ObjDelete( "gfx_carinterior_sleepingpills" );
    ObjDelete( "spr_carinterior_sleepingpills_sh" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_sleepingpills", get_sleepingpills_inv );
  cmn.AddSubscriber( "get_sleepingpills", get_sleepingpills_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wheel () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_wheel" ] = {
      type = "get",
      get_obj = "spr_clockatentrace_wheel",
      room = private.room_objname,
      zz = "zz_clockatentrace",
      zz_gate = "gzz_nearhome_clockatentrace"
  };
  --------------------------------------------------------------------------------------------
  local get_wheel_inv = function ()
  
    interface.InventoryItemAdd( "inv_wheel", "spr_clockatentrace_wheel" );
  
  end;
  local get_wheel_end = function ()
  
    ObjDelete( "gfx_clockatentrace_wheel" );
    ObjDelete( "spr_nearhome_clock_wheel" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_wheel", get_wheel_inv );
  cmn.AddSubscriber( "get_wheel", get_wheel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magicpagepiece2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_magicpagepiece2" ] = {
      type = "get",
      get_obj = "spr_clockatentrace_magicpagepiece2",
      room = private.room_objname,
      zz = "zz_clockatentrace",
      zz_gate = "gzz_nearhome_clockatentrace"
  };
  --------------------------------------------------------------------------------------------
  local get_magicpagepiece2_inv = function ()
  
    interface.InventoryItemAdd( "inv_magicpagepiece", "spr_clockatentrace_magicpagepiece2", function () cmn.GetMultyObject( 'magicpagepiece', 4 ); end );
    int_map_impl.DecreaseRoomTasks("rm_nearhome");
      
  end;
  local get_magicpagepiece2_end = function ()
  
    ObjDelete( "gfx_clockatentrace_magicpagepiece2" );
    ObjDelete( "spr_nearhome_clock_paper" );
    
    if cmn.IsEventDone("get_unicornhorn") then
      ObjDelete( "gzz_nearhome_clockatentrace" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_magicpagepiece2", get_magicpagepiece2_inv );
  cmn.AddSubscriber( "get_magicpagepiece2", get_magicpagepiece2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_unicornhorn () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_unicornhorn" ] = {
      type = "get",
      get_obj = "spr_clockatentrace_unicornhorn",
      room = private.room_objname,
      zz = "zz_clockatentrace",
      zz_gate = "gzz_nearhome_clockatentrace"
  };
  --------------------------------------------------------------------------------------------
  local get_unicornhorn_inv = function ()
  
    interface.InventoryItemAdd( "inv_unicornhorn", "spr_clockatentrace_unicornhorn" );
    int_map_impl.DecreaseRoomTasks("rm_nearhome");
  
  end;
  local get_unicornhorn_end = function ()
  
    ObjDelete( "gfx_clockatentrace_unicornhorn" );
    ObjDelete( "spr_nearhome_clock_horn" );
    
    if cmn.IsEventDone("get_magicpagepiece2") then
      ObjDelete( "gzz_nearhome_clockatentrace" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_unicornhorn", get_unicornhorn_inv );
  cmn.AddSubscriber( "get_unicornhorn", get_unicornhorn_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_easternprincess () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_easternprincess" ] = {
      type = "get",
      get_obj = "spr_nearhome_easternprincess",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_easternprincess_inv = function ()
  
    interface.InventoryItemAdd( "inv_easternprincess", "spr_nearhome_easternprincess" );
    int_map_impl.DecreaseRoomTasks("rm_nearhome");
  
  end;
  local get_easternprincess_end = function ()
  
    ObjDelete( "gfx_nearhome_easternprincess" );
    ObjDelete( "anm_nearhome_use_toygun" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_easternprincess", get_easternprincess_inv );
  cmn.AddSubscriber( "get_easternprincess", get_easternprincess_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_magnetkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_magnetkey" ] = {
      type = "use",
      inv_obj = "inv_magnetkey",
      use_place = "obj_housedoor_use_magnetkey",
      room = private.room_objname,
      zz = "zz_housedoor",
      zz_gate = "gzz_nearhome_housedoor"
  };
  --------------------------------------------------------------------------------------------
  local use_magnetkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_magnetkey" );
  
  end;
  local use_magnetkey_beg = function ()
  
    ObjDelete( "obj_housedoor_use_magnetkey" );
    ObjDelete( "anm_housedoor_touch_lock" );
  
  end;
  local use_magnetkey_end = function ()
  
    ObjMultiSet( { {"grm_nearhome_apartmentlivingroom", { active = 1, input = 1, alp = 1 }},
                   {"spr_nearhome_door_open", { alp = 1 }} } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_nearhome_apartmentlivingroom_focus");
    end;
    ObjDelete( "gzz_nearhome_housedoor" );
    ObjDelete( "spr_nearhome_door_light" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magnetkey", use_magnetkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnetkey", use_magnetkey_inv );
  cmn.AddSubscriber( "use_magnetkey", use_magnetkey_end, private.room_objname );
  cmn.AddSubscriber( "use_magnetkey_inv", use_magnetkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_magnetkey_beg", use_magnetkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnetkey_end", use_magnetkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_coin () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_coin" ] = {
      type = "use",
      inv_obj = "inv_coin",
      use_place = "obj_coinciergeroomwindow_use_coin",
      room = private.room_objname,
      zz = "zz_coinciergeroomwindow",
      zz_gate = "gzz_nearhome_coinciergeroomwindow"
  };
  --------------------------------------------------------------------------------------------
  local use_coin_inv = function ()
  
    interface.InventoryItemRemove( "inv_coin" );
  
  end;
  local use_coin_beg = function ()
  
    ObjDelete( "obj_coinciergeroomwindow_use_coin" );
    ObjDelete( "anm_coinciergeroomwindow_grid_touch" );
    ObjDelete( "anm_coinciergeroomwindow_plate_touch" );
  
  end;
  local use_coin_end = function ()
  
    ObjSet("obj_coinciergeroomwindow_clk_coinciergewindow",  { input = 1 });
    
    ObjDelete( "anm_coinciergeroomwindow_grid_open" );
    ObjDelete( "anm_coinciergeroomwindow_use_coin" );
    ObjDelete( "anm_coinciergeroomwindow_plate_break" );
    ObjDelete( "spr_nearhome_window_bars" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_coin", use_coin_beg, private.room_objname );
  cmn.AddSubscriber( "use_coin", use_coin_inv );
  cmn.AddSubscriber( "use_coin", use_coin_end, private.room_objname );
  cmn.AddSubscriber( "use_coin_inv", use_coin_inv, private.room_objname );
  cmn.AddSubscriber( "use_coin_beg", use_coin_beg, private.room_objname );
  cmn.AddSubscriber( "use_coin_end", use_coin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_snowball () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_snowball" ] = {
      type = "use",
      inv_obj = "inv_snowball",
      use_place = "obj_coinciergeroomwindow_use_snowball",
      room = private.room_objname,
      zz = "zz_coinciergeroomwindow",
      zz_gate = "gzz_nearhome_coinciergeroomwindow"
  };
  --------------------------------------------------------------------------------------------
  local use_snowball_inv = function ()
  
    interface.InventoryItemRemove( "inv_snowball" );
  
  end;
  local use_snowball_beg = function ()
  
    ObjDelete( "obj_coinciergeroomwindow_use_snowball" );
  
  end;
  local use_snowball_end = function ()
  
    ObjMultiSet( { {"anm_coinciergeroomwindow_box_open", { alp = 1, input = 1, frame = 400 }},
                   {"spr_nearhome_window_globe", { alp = 1 }},
                   {"fx_coinciergeroomwindow_p_snowball", { alp = 1 }} } );
    
    ObjDelete( "anm_coinciergeroomwindow_box_touch" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_snowball", use_snowball_beg, private.room_objname );
  cmn.AddSubscriber( "use_snowball", use_snowball_inv );
  cmn.AddSubscriber( "use_snowball", use_snowball_end, private.room_objname );
  cmn.AddSubscriber( "use_snowball_inv", use_snowball_inv, private.room_objname );
  cmn.AddSubscriber( "use_snowball_beg", use_snowball_beg, private.room_objname );
  cmn.AddSubscriber( "use_snowball_end", use_snowball_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pin () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_pin" ] = {
      type = "use",
      inv_obj = "inv_pin",
      use_place = "obj_carinterior_use_pin",
      room = private.room_objname,
      zz = "zz_carinterior",
      zz_gate = "gzz_nearhome_carinterior"
  };
  --------------------------------------------------------------------------------------------
  local use_pin_inv = function ()
  
    interface.InventoryItemRemove( "inv_pin" );
  
  end;
  local use_pin_beg = function ()
  
    ObjDelete( "obj_carinterior_use_pin" );
    ObjDelete( "anm_carinterior_touch_lock" );
  
  end;
  local use_pin_end = function ()
  
    ObjMultiSet( { {"obj_carinterior_compartment_open", { alp = 1, input = 1 }},
                   {"spr_nearhome_car_compartment", { alp = 1 }} } );
    
    ObjDelete( "anm_carinterior_use_pin" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pin", use_pin_beg, private.room_objname );
  cmn.AddSubscriber( "use_pin", use_pin_inv );
  cmn.AddSubscriber( "use_pin", use_pin_end, private.room_objname );
  cmn.AddSubscriber( "use_pin_inv", use_pin_inv, private.room_objname );
  cmn.AddSubscriber( "use_pin_beg", use_pin_beg, private.room_objname );
  cmn.AddSubscriber( "use_pin_end", use_pin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_clockhand () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_clockhand" ] = {
      type = "use",
      inv_obj = "inv_clockhand",
      use_place = "obj_clockatentrace_use_clockhand",
      room = private.room_objname,
      zz = "zz_clockatentrace",
      zz_gate = "gzz_nearhome_clockatentrace"
  };
  --------------------------------------------------------------------------------------------
  local use_clockhand_inv = function ()
  
    interface.InventoryItemRemove( "inv_clockhand" );
  
  end;
  local use_clockhand_beg = function ()
  
    ObjDelete( "obj_clockatentrace_use_clockhand" );
  
  end;
  local use_clockhand_end = function ()
  
    ObjMultiSet( { {"obj_clockatentrace_clock_hands", { alp = 1, input = 1 }},
                   {"spr_nearhome_clock_hands", { alp = 1 }},
                   {"obj_clockatentrace_use_number12", { pos_z = 1 }} } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_clockhand", use_clockhand_beg, private.room_objname );
  cmn.AddSubscriber( "use_clockhand", use_clockhand_inv );
  cmn.AddSubscriber( "use_clockhand", use_clockhand_end, private.room_objname );
  cmn.AddSubscriber( "use_clockhand_inv", use_clockhand_inv, private.room_objname );
  cmn.AddSubscriber( "use_clockhand_beg", use_clockhand_beg, private.room_objname );
  cmn.AddSubscriber( "use_clockhand_end", use_clockhand_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_number12 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_number12" ] = {
      type = "use",
      inv_obj = "inv_number12",
      use_place = "obj_clockatentrace_use_number12",
      room = private.room_objname,
      zz = "zz_clockatentrace",
      zz_gate = "gzz_nearhome_clockatentrace"
  };
  --------------------------------------------------------------------------------------------
  local use_number12_inv = function ()
  
    interface.InventoryItemRemove( "inv_number12" );
  
  end;
  local use_number12_beg = function ()
  
    ObjDelete( "obj_clockatentrace_use_number12" );
  
  end;
  local use_number12_end = function ()
  
    ObjMultiSet( { {"spr_clockatentrace_number12", { alp = 1 }},
                   {"gmg_nearhome_memories", { alp = 1, input = 1, active = 1 }},
                   {"spr_nearhome_clock_number", { alp = 1 }},
                   {"spr_nearhome_clock_memories", { alp = 1 }},
                   {"gzz_nearhome_clockatentrace", { alp = 0, input = 0, active = 0 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_number12", use_number12_beg, private.room_objname );
  cmn.AddSubscriber( "use_number12", use_number12_inv );
  cmn.AddSubscriber( "use_number12", use_number12_end, private.room_objname );
  cmn.AddSubscriber( "use_number12_inv", use_number12_inv, private.room_objname );
  cmn.AddSubscriber( "use_number12_beg", use_number12_beg, private.room_objname );
  cmn.AddSubscriber( "use_number12_end", use_number12_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_toygun () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_toygun" ] = {
      type = "use",
      inv_obj = "inv_toygun",
      use_place = "obj_nearhome_use_toygun",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local use_toygun_inv = function ()
  
    interface.InventoryItemRemove( "inv_toygun" );
  
  end;
  local use_toygun_beg = function ()
  
    ObjDelete( "obj_nearhome_use_toygun" );
    ObjDelete( "anm_nearhome_crow" );
    ObjDelete( "anm_nearhome_crow_touch" );
  
  end;
  local use_toygun_end = function ()
  
    --ObjDelete( "anm_nearhome_use_toygun" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_toygun", use_toygun_beg, private.room_objname );
  cmn.AddSubscriber( "use_toygun", use_toygun_inv );
  cmn.AddSubscriber( "use_toygun", use_toygun_end, private.room_objname );
  cmn.AddSubscriber( "use_toygun_inv", use_toygun_inv, private.room_objname );
  cmn.AddSubscriber( "use_toygun_beg", use_toygun_beg, private.room_objname );
  cmn.AddSubscriber( "use_toygun_end", use_toygun_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_openfirstaidkit () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_openfirstaidkit" ] = {
    type = "click",
    use_place = "obj_carinterior_clk_openfirstaidkit",
    room = private.room_objname,
    zz = "zz_carinterior",
    zz_gate = "gzz_nearhome_carinterior"
  };
  --------------------------------------------------------------------------------------------
  local clk_openfirstaidkit_beg = function ()
  
    ObjDelete( "obj_carinterior_clk_openfirstaidkit" );
  
  end;
  local clk_openfirstaidkit_end = function ()
  
    ObjDelete( "spr_carinterior_aid_kit_closed" );
  
    ObjMultiSet( { {"spr_carinterior_antiseptic", { input = 1 }},
                   {"spr_carinterior_sleepingpills", { input = 1 }},
                   {"spr_carinterior_aid_kit_open", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_openfirstaidkit", clk_openfirstaidkit_beg, private.room_objname );
  cmn.AddSubscriber( "clk_openfirstaidkit", clk_openfirstaidkit_end, private.room_objname );
  cmn.AddSubscriber( "clk_openfirstaidkit_beg", clk_openfirstaidkit_beg, private.room_objname );
  cmn.AddSubscriber( "clk_openfirstaidkit_end", clk_openfirstaidkit_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_openglass () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_openglass" ] = {
    type = "click",
    use_place = "obj_clockatentrace_clk_openglass",
    room = private.room_objname,
    zz = "zz_clockatentrace",
    zz_gate = "gzz_nearhome_clockatentrace"
  };
  --------------------------------------------------------------------------------------------
  local clk_openglass_beg = function ()
  
    ObjDelete( "obj_clockatentrace_clk_openglass" );
  
  end;
  local clk_openglass_end = function ()
  
    ObjDelete( "anm_clockatentrace_open_clock" );
    ObjDelete( "spr_nearhome_clock_closed" );
  
    ObjMultiSet( { {"obj_clockatentrace_clock", { alp = 1 }},
                   {"obj_clockatentrace_use_clockhand", { input = 1 }},
                   {"obj_clockatentrace_use_number12", { input = 1 }},
                   {"spr_nearhome_clock_open", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_openglass", clk_openglass_beg, private.room_objname );
  cmn.AddSubscriber( "clk_openglass", clk_openglass_end, private.room_objname );
  cmn.AddSubscriber( "clk_openglass_beg", clk_openglass_beg, private.room_objname );
  cmn.AddSubscriber( "clk_openglass_end", clk_openglass_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_coinciergewindow () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_coinciergewindow" ] = {
    type = "click",
    use_place = "obj_coinciergeroomwindow_clk_coinciergewindow",
    room = private.room_objname,
    zz = "zz_coinciergeroomwindow",
    zz_gate = "gzz_nearhome_coinciergeroomwindow"
  };
  --------------------------------------------------------------------------------------------
  local clk_coinciergewindow_beg = function ()
  
    ObjDelete( "obj_coinciergeroomwindow_clk_coinciergewindow" );
  
  end;
  local clk_coinciergewindow_end = function ()
  
    ObjMultiSet( { {"obj_coinciergeroomwindow_use_snowball", { input = 1 }},
                   {"spr_coinciergeroomwindow_magnetkey", { input = 1 }},
                   {"spr_nearhome_window_open", { alp = 1 }},
                   {"obj_coinciergeroomwindow_note_small", { input = 1 }} } );
                   
    ObjDelete( "anm_coinciergeroomwindow_window_open" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_coinciergewindow", clk_coinciergewindow_beg, private.room_objname );
  cmn.AddSubscriber( "clk_coinciergewindow", clk_coinciergewindow_end, private.room_objname );
  cmn.AddSubscriber( "clk_coinciergewindow_beg", clk_coinciergewindow_beg, private.room_objname );
  cmn.AddSubscriber( "clk_coinciergewindow_end", clk_coinciergewindow_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function opn_nearhome () end;
  --------------------------------------------------------------------------------------------
  local opn_nearhome = function ()
  
    interface_impl.SetCurrentGlobalTask( 2 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_nearhome", opn_nearhome );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_clockatentrace" );
  subroom.Define( "zz_coinciergeroomwindow" );
  
  function zz_clockatentrace.PreOpen()
    
    if not cmn.IsEventDone("win_clockatentrace") then
      private.zz_clockatentrace.DrawScene();
    end;
    
    if ( cmn.IsEventDone( "win_memories" ) and not(cmn.IsEventDone( "opn_clockatentraceaftermg" )) ) then
      cmn.Lock(1);
    end;
      
  end;
  
  function zz_clockatentrace.Open()
    
    if cmn.IsEventDone("use_clockhand") and not cmn.IsEventDone("win_clockatentrace") then
      cmn.MiniGameShow();
      ObjAttach( "tmr_common_achiev", private.room_objname );
      ObjSet("tmr_common_achiev", {playing = true, time = 600, endtrig = function () ObjSet('tmr_common_achiev', {playing = false}); end});
      
      private.zz_clockatentrace.CheckWin();
    end;
    
    if ( cmn.IsEventDone( "win_memories" ) and not(cmn.IsEventDone( "opn_clockatentraceaftermg" )) ) then
      
      cmn.SetEventDone("opn_clockatentraceaftermg");
      
      local func_after = function ()
      
        cmn.Lock(0);
        cmn.CallEventHandler( "win_memories_end" );
      
      end;
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_opn_clock1");
      
      ObjSet("anm_clockatentrace_win_mg",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
      
  end;
  
  function zz_clockatentrace.PreClose()
    
    cmn.MiniGameHide("clockatentrace");
    
  end;
  
  function zz_coinciergeroomwindow.Close()
    
    cmn.HideNote( 0 );
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_clockatentrace" ].state) then 
    private.zz_clockatentrace.StartConditions();
  end;

  private.zz_clockatentrace.state = ng_global.progress[ ng_global.currentprogress ][ "win_clockatentrace" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_nearhome();

  private.set_anim_car( 1 );

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/aud_nearhome_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/aud_nearhome_env");
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_magnetkey()

  local item = "inv_magnetkey";

  if cmn.ApplyObj( item, "gzz_nearhome_housedoor" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_housedoor" );

  elseif ( cmn.ApplyObj( item, "obj_housedoor_use_magnetkey" ) ) then

    cmn.CallEventHandler( "use_magnetkey_inv" );
    cmn.CallEventHandler( "use_magnetkey_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_magnetkey" );
      cmn.CallEventHandler( "use_magnetkey_end" );
      
      common.CloseSubRoom();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_use_magnet_key");

    ObjSet("anm_housedoor_use_magnetkey",  { alp = 1, playing = 1, endtrig = func_after });
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_coin()

  local item = "inv_coin";

  if cmn.ApplyObj( item, "gzz_nearhome_coinciergeroomwindow" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_coinciergeroomwindow" );

  elseif ( cmn.ApplyObj( item, "obj_coinciergeroomwindow_use_coin" ) ) then

    cmn.CallEventHandler( "use_coin_inv" );
    cmn.CallEventHandler( "use_coin_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_coin" );
      cmn.CallEventHandler( "use_coin_end" );
    
    end;
    
    local anm_grid = function ()
    
      ObjMultiSet( { {"anm_coinciergeroomwindow_grid_open", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_coinciergeroomwindow_use_coin", { alp = 0 }},
                     {"anm_coinciergeroomwindow_plate_break", { alp = 0, playing = 0 }} } );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_use_coin");

    ObjSet("anm_coinciergeroomwindow_use_coin",  { alp = 1, playing = 1, endtrig = anm_grid });
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_snowball()

  local item = "inv_snowball";

  if cmn.ApplyObj( item, "gzz_nearhome_coinciergeroomwindow" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_coinciergeroomwindow" );

  elseif ( cmn.ApplyObj( item, "obj_coinciergeroomwindow_use_snowball" ) and cmn.IsEventDone("clk_coinciergewindow") ) then

    cmn.CallEventHandler( "use_snowball_inv" );
    cmn.CallEventHandler( "use_snowball_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_snowball" );
      cmn.CallEventHandler( "use_snowball_end" );
    
    end;
    
    local anm_box = function ()
    
      ObjMultiSet( { {"anm_coinciergeroomwindow_box_open", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_coinciergeroomwindow_box_touch", { alp = 0 }} } );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_use_snow_globe");

    ObjAnimate( "spr_coinciergeroomwindow_snowball", "alp", 0, 0, anm_box,
    {
      0.0, 0, 0, 
      0.3, 0, 1,
      0.6, 0, 1
    } );
    
    ObjAnimate("fx_coinciergeroomwindow_p_snowball", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pin()

  local item = "inv_pin";

  if cmn.ApplyObj( item, "gzz_nearhome_carinterior" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_carinterior" );

  elseif ( cmn.ApplyObj( item, "obj_carinterior_use_pin" ) ) then

    cmn.CallEventHandler( "use_pin_inv" );
    cmn.CallEventHandler( "use_pin_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pin" );
      cmn.CallEventHandler( "use_pin_end" );
    
    end;
    
    local anm_open = function ()

      ObjAnimate("obj_carinterior_compartment_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_use_pick_key");

    ObjSet("anm_carinterior_use_pin",  { alp = 1, playing = 1, endtrig = anm_open });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_clockhand()

  local item = "inv_clockhand";
  
  if cmn.ApplyObj( item, "gzz_nearhome_clockatentrace" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_clockatentrace" );

  elseif ( cmn.ApplyObj( item, "obj_clockatentrace_use_clockhand" ) and cmn.CheckMultiObject( "clockhand", 3 ) ) and cmn.IsEventDone("clk_openglass") then

    cmn.CallEventHandler( "use_clockhand_inv" );
    private.use_clockhand_end();
    
  elseif ( cmn.ApplyObj( item, "obj_clockatentrace_use_clockhand" ) and cmn.CheckMultiObject( "clockhand", 3 ) ) and not cmn.IsEventDone("clk_openglass") then

    cmn.CallEventHandler( "use_clockhand_inv" );
    public.clk_openglass(2);
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function private.use_clockhand_end()
  
  cmn.CallEventHandler( "use_clockhand_beg" );

  local func_after = function ()

    cmn.Lock( 0 );
    --cmn.ShowBbt( "clockatentrace_need_time" );

    cmn.SetEventDone( "use_clockhand" );
    cmn.CallEventHandler( "use_clockhand_end" );
    
    cmn.MiniGameShow();
    ObjAttach( "tmr_common_achiev", private.room_objname );
    ObjSet("tmr_common_achiev", {playing = true, time = 600, endtrig = function () ObjSet('tmr_common_achiev', {playing = false}); end});
  end;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_use_arrows");

  ObjAnimate( "obj_clockatentrace_clock_hands", "alp", 0, 0, func_after,
  {
    0.0, 0, 0, 
    0.3, 0, 1
  } );
  
end;
--------------------------------------------------------------------------------------------
function public.use_number12()

  local item = "inv_number12";

  if cmn.ApplyObj( item, "gzz_nearhome_clockatentrace" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_clockatentrace" );

  elseif ( cmn.ApplyObj( item, "obj_clockatentrace_use_number12" ) ) then

    cmn.CallEventHandler( "use_number12_inv" );
    cmn.CallEventHandler( "use_number12_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_number12" );
      cmn.CallEventHandler( "use_number12_end" );
      
      common.CloseSubRoom();
      cmn.GotoRoom( "mg_memories" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_use_arrows");

    ObjAnimate( "spr_clockatentrace_number12", "alp", 0, 0, func_after,
    {
      0.0, 0, 0, 
      0.3, 0, 1,
      0.6, 0, 1
    } );
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_toygun()

  local item = "inv_toygun";

  if ( cmn.ApplyObj( item, "obj_nearhome_use_toygun" ) ) then

    cmn.CallEventHandler( "use_toygun_inv" );
    cmn.CallEventHandler( "use_toygun_beg" );

    local func_after = function ()

      cmn.Lock( 0 );
      
      public.get_easternprincess();

      cmn.SetEventDone( "use_toygun" );
      cmn.CallEventHandler( "use_toygun_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_use_toy_gun");

    ObjSet("anm_nearhome_use_toygun",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_coin()

  cmn.SetEventDone( "get_coin" );
  cmn.CallEventHandler( "get_coin" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_magnetkey()

  cmn.SetEventDone( "get_magnetkey" );
  cmn.CallEventHandler( "get_magnetkey" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_silversnake()

  cmn.SetEventDone( "get_silversnake" );
  cmn.CallEventHandler( "get_silversnake" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_pin") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_pin()

  cmn.SetEventDone( "get_pin" );
  cmn.CallEventHandler( "get_pin" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_silversnake") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_cleanhanky()

  cmn.SetEventDone( "get_cleanhanky" );
  cmn.CallEventHandler( "get_cleanhanky" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_woodenring") and cmn.IsEventDone("get_antiseptic") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_antiseptic()

  cmn.SetEventDone( "get_antiseptic" );
  cmn.CallEventHandler( "get_antiseptic" );

  if not cmn.IsEventDone("get_sleepingpills") then
    public.get_sleepingpills();
  else 
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  end;
  
  if cmn.IsEventDone("get_woodenring") and cmn.IsEventDone("get_cleanhanky") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_woodenring()

  cmn.SetEventDone( "get_woodenring" );
  cmn.CallEventHandler( "get_woodenring" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_antiseptic") and cmn.IsEventDone("get_cleanhanky") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_sleepingpills()

  cmn.SetEventDone( "get_sleepingpills" );
  cmn.CallEventHandler( "get_sleepingpills" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_wheel()

  cmn.SetEventDone( "get_wheel" );
  cmn.CallEventHandler( "get_wheel" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_magicpagepiece2()

  cmn.SetEventDone( "get_magicpagepiece2" );
  cmn.CallEventHandler( "get_magicpagepiece2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
end;
--------------------------------------------------------------------------------------------
function public.get_unicornhorn()

  cmn.SetEventDone( "get_unicornhorn" );
  cmn.CallEventHandler( "get_unicornhorn" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common.CloseSubRoom();
  
  if not cmn.IsEventDone("get_magicpagepiece2") then
    cmn.SetEventDone( "get_magicpagepiece2" );
    cmn.CallEventHandler( "get_magicpagepiece2" );
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_easternprincess()
  
  ObjSet("spr_nearhome_easternprincess",  { ang = 2.7925 });

  cmn.SetEventDone( "get_easternprincess" );
  cmn.CallEventHandler( "get_easternprincess" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_openfirstaidkit()

  cmn.CallEventHandler( "clk_openfirstaidkit_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_openfirstaidkit" );
    cmn.CallEventHandler( "clk_openfirstaidkit_end" );

    cmn.Lock( 0 );
  
  end;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_opn_medicine");

  ObjAnimate( "spr_carinterior_aid_kit_closed", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1, 
    0.5, 0, 0
  } );
  
  ObjAnimate( "spr_carinterior_aid_kit_open", "alp", 0, 0, "", 
  { 
    0.0, 0, 0, 
    0.5, 0, 1
  } );

end;
--------------------------------------------------------------------------------------------
function public.clk_openglass( num )

  cmn.CallEventHandler( "clk_openglass_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_openglass" );
    cmn.CallEventHandler( "clk_openglass_end" );

    if num == 1 then
      cmn.Lock( 0 );
    else 
      private.use_clockhand_end();
    end;
  
  end;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_opn_clock");

  ObjSet("anm_clockatentrace_open_clock",  { playing = 1, endtrig = func_after });

end;
--------------------------------------------------------------------------------------------
function public.clk_coinciergewindow()

  cmn.CallEventHandler( "clk_coinciergewindow_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_coinciergewindow" );
    cmn.CallEventHandler( "clk_coinciergewindow_end" );

    cmn.Lock( 0 );
  
  end;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_opn_window");

  ObjSet("anm_coinciergeroomwindow_window_open",  { playing = 1, endtrig = func_after });
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_nearhome()

  if not ( cmn.IsEventDone( "opn_nearhome" ) ) then
    cmn.SetEventDone( "opn_nearhome" );
    cmn.CallEventHandler("opn_nearhome");
    cmn.ShowBbt( "nearhome_open" );
    interface_impl.ShowGlobalTask();
    int_map_impl.AddDiarypage( 1 );
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_compartment()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_carinterior_use_pin" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_xx_compartment");
  
  ObjSet("anm_carinterior_touch_lock",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_grid()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_coinciergeroomwindow_use_coin" );
  
  local func_after = function ()
  
    cmn.Lock(0);
  
    ObjMultiSet( { {"anm_coinciergeroomwindow_plate_touch",  { alp = 0, playing = 0 }},
                   {"anm_coinciergeroomwindow_plate_break", { alp = 1, playing = 1 }} } );
  
  end;
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_xx_grill");
  
  ObjMultiSet( { {"anm_coinciergeroomwindow_grid_touch",  { playing = 1, endtrig = func_after }},
                 {"anm_coinciergeroomwindow_plate_break", { alp = 0, playing = 0 }},
                 {"anm_coinciergeroomwindow_plate_touch", { alp = 1, playing = 1 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_snow_box()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_coinciergeroomwindow_use_snowball" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_xx_small_box");
  
  ObjSet("anm_coinciergeroomwindow_box_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_house_door()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_housedoor_use_magnetkey" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_xx_intercom");
  
  ObjSet("anm_housedoor_touch_lock",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_crow()
  
  local func_after = function ()
  
    cmn.Lock(0);
  
    ObjMultiSet( { {"anm_nearhome_crow", { alp = 1, playing = 1 }},
                   {"anm_nearhome_crow_touch", { alp = 0 }} } );
  
  end;
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_nearhome_use_toygun" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_xx_clk_crow");
  
  ObjMultiSet( { {"anm_nearhome_crow", { alp = 0, playing = 0 }},
                 {"anm_nearhome_crow_touch", { alp = 1, playing = 1, endtrig = func_after }} } );
  
end;
--------------------------------------------------------------------------------------------
function private.set_anim_car( side )
  
  local change_state = function ()
  
    local new_side = 2;
    if side == 2 then
      new_side = 1;
    end;
  
    ObjSet("anm_nearhome_car_"..side,  { alp = 0 });
    private.set_anim_car( new_side );
  
  end;
  
  local anim_car = function ()
  
    if side == 1 then
      cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_car_left");
    else 
      cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_car_right");
    end;
    
    ObjSet("anm_nearhome_car_"..side,  { alp = 1, playing = 1, endtrig = change_state });
  
  end;
  
  local delay = math.random(10, 50);
  ObjSet("tmr_nearhome_anim_car",  { time = delay, playing = 1, endtrig = anim_car });
  
end;
--------------------------------------------------------------------------------------------
function public.go_to_appartment()
  
  if not cmn.IsEventDone("opn_apartmentlivingroom") and common_impl.Get_goto_objname() == "nearhome_apartmentlivingroom" then
    cmn.Lock(1);
  end;
  
  cmn.GotoRoomMUp( "nearhome_apartmentlivingroom", "rm_apartmentlivingroom" );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Clock *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_clockatentrace = {};
public.zz_clockatentrace = {};

function private.Init_Clock()
  
  private.zz_clockatentrace.win = { -2.73, -3.36, -1.74 };
  private.zz_clockatentrace.start = { -0.95, -5.07, -3.35 };
  private.zz_clockatentrace.curent = 0;
  private.zz_clockatentrace.start_ang = 0;
  private.zz_clockatentrace.ang_tmp = 0;
  
  --------------------------------------------------------------------------------------------
  game.hint[ "win_clockatentrace" ] = {

      type = "win",
      room = "rm_nearhome",
      zz = "zz_clockatentrace",
      zz_gate = "gzz_nearhome_clockatentrace"
  };
  -----------------------------------------------------------------------------------
  local win_clockatentrace = function ()

    if cmn.IsEventDone( "win_clockatentrace" ) then

      ObjMultiSet( { {"spr_clockatentrace_wheel", { alp = 1, input = 1 }},
                     {"spr_nearhome_clock_wheel", { alp = 1 }},
                     {"anm_clockatentrace_clock_hands_end", { alp = 1 }} } );
    
      local angles = { -1.4945, -6.7451, 1.4007, 1.5266, 1.1509, 1.5031, 1.0899 };
      
      for i = 1, 7, 1 do
        ObjSet("spr_clockatentrace_clock_gear_"..i,  { ang = angles[i] });
      end;
      
      ObjDelete( "anm_clockatentrace_gear_fall" );
      ObjDelete( "obj_clockatentrace_clock_hands" );
      ObjDelete( "spr_clockatentrace_clock_wheel_1" );
      
    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_clockatentrace", win_clockatentrace, "rm_nearhome" );
  
end;
--*********************************************************************************************************************
-----------------------------------------------------------------------------------
function private.zz_clockatentrace.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_clockatentrace" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_clockatentrace" ].state = { -0.95, -5.07, -3.35 };

end;
-----------------------------------------------------------------------------------
function public.zz_clockatentrace.Reset()
  
  local need_r = false;
  
  for i = 1, 3, 1 do
    
    if private.zz_clockatentrace.state[ i ] ~= private.zz_clockatentrace.start[ i ] then
      
      if not need_r then
        need_r = true;
      end;
      
      local old_ang = private.zz_clockatentrace.state[ i ];
      
      if old_ang > 0 then
        old_ang = 2*math.pi-old_ang;
      end;
      
      ObjAnimate("spr_clockatentrace_clock_hand_"..i, "ang", 0, 0, "", { 0, 0, old_ang,   0.5, 0, private.zz_clockatentrace.start[ i ] });
      
    end;
    
  end;
  
  if need_r then
    
    cmn.Lock( 1 );
    private.zz_clockatentrace.StartConditions();
    private.zz_clockatentrace.state = ng_global.progress[ ng_global.currentprogress ][ "win_clockatentrace" ].state;
    
    ObjSet("tmr_clockatentrace_timer",  { time = 0.5, playing = 1, endtrig = function () cmn.Lock(0); end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_clockatentrace.Skip()
  
  cmn.Lock( 1 );
  
  ng_global.progress[ ng_global.currentprogress ][ "win_clockatentrace" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_clockatentrace" ].state = { -2.73, -3.36, -1.74 };
  
  for i = 1, 3, 1 do
    
    if private.zz_clockatentrace.state[ i ] ~= private.zz_clockatentrace.win[ i ] then
      
      local old_ang = private.zz_clockatentrace.state[ i ];
      
      if old_ang > 0 then
        old_ang = 2*math.pi-old_ang;
      end;
      
      ObjAnimate("spr_clockatentrace_clock_hand_"..i, "ang", 0, 0, "", { 0, 0, old_ang,   0.5, 0, private.zz_clockatentrace.win[ i ] });
      
    end;
    
  end;
  
  private.zz_clockatentrace.state = ng_global.progress[ ng_global.currentprogress ][ "win_clockatentrace" ].state;
    
  ObjSet("tmr_clockatentrace_timer",  { time = 0.5, playing = 1, endtrig = private.zz_clockatentrace.CheckWin });
  
end;
-----------------------------------------------------------------------------------
function private.zz_clockatentrace.DrawScene()
  
  for i = 1, 3, 1 do
    
    ObjSet("spr_clockatentrace_clock_hand_"..i,  { ang = private.zz_clockatentrace.state[i] });
    
    --if private.zz_clockatentrace.CheckHand( i ) then
    --  ObjSet("spr_clockatentrace_clock_hand_"..i,  { input = 0 });
    --end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_clockatentrace.StartDragHand( num )
  
  private.zz_clockatentrace.curent = num;
  
  SetCursor( CURSOR_DEFAULT );
  ObjStartDrag("obj_clockatentrace_drag");
  
  local curspos = GetZoomCursorPos();

  curspos[1] = curspos[1] - (ObjGet("zz_clockatentrace").pos_x - 6);
  curspos[2] = curspos[2] - (ObjGet("zz_clockatentrace").pos_y - 40);

  local ang = -math.atan2(curspos[2], curspos[1]);
  local old = private.zz_clockatentrace.state[num];

  private.zz_clockatentrace.start_ang = ang - old;
  
end;
-----------------------------------------------------------------------------------
function public.zz_clockatentrace.DragHand()
  
  local curspos = GetZoomCursorPos();

  curspos[1] = curspos[1] - (ObjGet("zz_clockatentrace").pos_x - 6);
  curspos[2] = curspos[2] - (ObjGet("zz_clockatentrace").pos_y - 40);

  local old = private.zz_clockatentrace.state[private.zz_clockatentrace.cur_arrow];
  local new_ang = - math.atan2(curspos[2], curspos[1]) - private.zz_clockatentrace.start_ang;

  if (private.zz_clockatentrace.curent ~= 0) then

    local ang_step = math.floor((new_ang % 0.392625)*10)/10;
    local ang_floor = math.floor(new_ang / 0.392625 + 0.1) * 0.392625;

    if ang_step == 0 and private.zz_clockatentrace.ang_tmp ~= ang_floor then

      --cmn.PlayAudio( "snd", "assets/levels/level1/rm_nearhome/audio/" );
      PlaySfx("assets/levels/level1/rm_nearhome/audio/aud_move_arrows", 1, "", 1);
      private.zz_clockatentrace.ang_tmp = ang_floor;
      
    else 
      
      SndStop("assets/levels/level1/rm_nearhome/audio/aud_move_arrows", 0.5);

    end;

    ObjSet("spr_clockatentrace_clock_hand_"..private.zz_clockatentrace.curent, { ang = new_ang } );

  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_clockatentrace.DropHand()
  
  SndStop("assets/levels/level1/rm_nearhome/audio/aud_move_arrows", 0.5);
  
  local num = private.zz_clockatentrace.curent;
  private.zz_clockatentrace.curent = 0;
  
  if (num ~= 0) then

    local curspos = GetZoomCursorPos();
    if  tostring(GetPlatform()) == "android" then
      curspos[2] = curspos[2] - 100;
    elseif tostring(GetPlatform()) == "ios" then
      if port.isTablet() == 0 then
        curspos[2] = curspos[2] - 75;
      else
        curspos[2] = curspos[2] - 50;
      end;
    end;
    
    curspos[1] = curspos[1] - (ObjGet("zz_clockatentrace").pos_x - 6);
    curspos[2] = curspos[2] - (ObjGet("zz_clockatentrace").pos_y - 40);

    local old = private.zz_clockatentrace.state[num];
    local new_ang = - math.atan2(curspos[2], curspos[1]) - private.zz_clockatentrace.start_ang;

    private.zz_clockatentrace.state[ num ] = new_ang;

    if ( private.zz_clockatentrace.state[ num ] <= -2*math.pi ) then
      private.zz_clockatentrace.state[ num ] = private.zz_clockatentrace.state[ num ] + 4*math.pi;
    elseif ( private.zz_clockatentrace.state[ num ] >= 2*math.pi ) then
      private.zz_clockatentrace.state[ num ] = private.zz_clockatentrace.state[ num ] - 2*math.pi;
    end;

    ObjSet("spr_clockatentrace_clock_hand_"..num, { ang = private.zz_clockatentrace.state[ num ] } );

  end;

  private.zz_clockatentrace.start_ang = 0;
  
  --if not private.zz_clockatentrace.CheckHand( num ) then
  --  cmn.ShowBbt( "clockatentrace_need_time" );
  --else 
  --  ObjSet("spr_clockatentrace_clock_hand_"..num,  { input = 0 });
  --end;

  private.zz_clockatentrace.CheckWin();
  
end;
-----------------------------------------------------------------------------------
function private.zz_clockatentrace.CheckHand( num )
  
  if (math.abs(private.zz_clockatentrace.state[num] - private.zz_clockatentrace.win[num]) <= 0.3) or 
     (math.abs(2*math.pi + private.zz_clockatentrace.state[num] - private.zz_clockatentrace.win[num]) <= 0.3) or 
     (math.abs(2*math.pi - private.zz_clockatentrace.state[num] + private.zz_clockatentrace.win[num]) <= 0.3) then
     
     return true;
     
  else 
     
     return false;
     
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_clockatentrace.CheckWin()
  
  local win_flag = true;
  local arrows_win = {0, 0, 0};
  
  for i = 1, 3, 1 do
    
    if not((math.abs(private.zz_clockatentrace.state[i] - private.zz_clockatentrace.win[i]) <= 0.3) or 
           (math.abs(2*math.pi + private.zz_clockatentrace.state[i] - private.zz_clockatentrace.win[i]) <= 0.3) or 
           (math.abs(2*math.pi - private.zz_clockatentrace.state[i] + private.zz_clockatentrace.win[i]) <= 0.3)) then
      win_flag = false;
      break;
    else 
      arrows_win[i] = 1;
    end;
    
  end;
  
  --for i = 1, 3, 1 do
  --
  --  if arrows_win[i] == 0 then
  --    game.hint[ "win_clockatentrace" ].inv_obj = "obj_clockatentrace_clock_hand_"..i.."_hint";
  --    game.hint[ "win_clockatentrace" ].use_place = "obj_clockatentrace_clock_num_"..i.."_hint";
  --    break;
  --  end;
  --  
  --end;
  
  if win_flag then
    
    cmn.Lock(1);
    common_impl.PauseAchiev(1);
    
    cmn.MiniGameHide("clockatentrace");
    local tme = ObjGet("tmr_common_achiev").time;
    --DbgTrace("tme = "..tme);

    if ( ( 600 - tme ) <= 60 ) and ( ng_global.achiev["one_mg_less_one_min"][1] == 0 ) then

      common_impl.CompleteAchiev("one_mg_less_one_min");

    end;
    
    ObjSet("tmr_common_achiev", {playing = false});
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
    
    local func_after = function ()

      cmn.Lock( 0 );
      common_impl.PauseAchiev(0);
    
      cmn.SetEventDone( "win_clockatentrace" );
      cmn.CallEventHandler( "win_clockatentrace" );
      
      if ng_global.progress[ ng_global.currentprogress ][ "win_clockatentrace" ].skip == 0 and ng_global.noskipgames[ "win_clockatentrace" ] == nil then

        ng_global.noskipgames[ "win_clockatentrace" ] = 1;
        common_impl.CheckAchiev("mg");

      end;
      
      ObjSet( "obj_clockatentrace_clock", { alp = 1 } );
    
    end;
    
    local anm_play = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_move_arrows1");
    
      ObjMultiSet( { {"anm_clockatentrace_gear_fall", { alp = 1, playing = 1, endtrig = func_after }},
                     {"obj_clockatentrace_clock", { alp = 0 }} } );
                     
    end;
                   
    for i = 1, 3, 1 do
      
      local new_ang = private.zz_clockatentrace.win[i];
      if private.zz_clockatentrace.state[i] > 0 then
        new_ang = 2*math.pi+private.zz_clockatentrace.win[i];
      end;
      
      ObjAnimate("spr_clockatentrace_clock_hand_"..i, "ang", 0, 0, anm_play, { 0, 0, private.zz_clockatentrace.state[i],   0.2, 0, new_ang });
      
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
--********************************************************************************************************************