-- name=inventory2
--*********************************************************************************************************************
function public.Init()
  
  if port.isPortable() == 1 then
    port.InventoryPopupInit("inventory2_hub");
    port.VideoResizeInRoom("inventory2");
  end;
  --------------------------------------------------------------------------------------------
  -- function get_selfmadebridgre () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_selfmadebridgre" ] = {

      type = "get",
      get_obj = "obj_complex_bridgebase_get_bridge",
      room = "int_complex_inv",
      zz = "inv_complex_bridgebase",
      zz_gate = "inv_bridgebase"
  };
  --------------------------------------------------------------------------------------------
  local get_selfmadebridgre_inv = function ()

    interface.InventoryItemRemove( "inv_bridgebase" );
    interface.InventoryItemAdd( "inv_selfmadebridgre", "spr_complex_bridgebase_selfmadebridgre" );

    ObjDelete("obj_complex_bridgebase_get_bridge");
    ObjDelete("anm_complex_bridgebase_use_planks");
    ObjDelete("anm_complex_bridgebase_use_hammer");
    ObjDelete("anm_complex_bridgebase_planks_touch");

  end;
  cmn.AddSubscriber( "get_selfmadebridgre", get_selfmadebridgre_inv );
  --------------------------------------------------------------------------------------------
  -- function get_blade () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_blade" ] = {

      type = "get",
      get_obj = "spr_complex_rustyblade_blade",
      room = "int_complex_inv",
      zz = "inv_complex_rustyblade",
      zz_gate = "inv_rustyblade"
  };
  --------------------------------------------------------------------------------------------
  local get_blade_inv = function ()

    interface.InventoryItemRemove( "inv_rustyblade" );
    interface.InventoryItemAdd( "inv_blade", "spr_complex_rustyblade_blade" );

    ObjDelete("gfx_complex_rustyblade_blade");

  end;
  cmn.AddSubscriber( "get_blade", get_blade_inv );
  --------------------------------------------------------------------------------------------
  -- function get_spider () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_spider" ] = {

      type = "get",
      get_obj = "obj_complex_brokenspider_spider",
      room = "int_complex_inv",
      zz = "inv_complex_brokenspider",
      zz_gate = "inv_brokenspider"
  };
  --------------------------------------------------------------------------------------------
  local get_spider_inv = function ()

    interface.InventoryItemRemove( "inv_brokenspider" );
    interface.InventoryItemAdd( "inv_spider", "obj_complex_brokenspider_spider" );

    ObjDelete("gfx_complex_brokenspider_spider");

  end;
  cmn.AddSubscriber( "get_spider", get_spider_inv );
  --------------------------------------------------------------------------------------------
  -- function get_powder () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_powder" ] = {

      type = "get",
      get_obj = "spr_complex_cosmeticsbag_powder",
      room = "int_complex_inv",
      zz = "inv_complex_cosmeticsbag",
      zz_gate = "inv_cosmeticsbag"
  };
  --------------------------------------------------------------------------------------------
  local get_powder_inv = function ()

    if cmn.IsEventDone("get_crabamulet") then
      interface.InventoryItemRemove( "inv_cosmeticsbag" );
    end;
    interface.InventoryItemAdd( "inv_powder", "spr_complex_cosmeticsbag_powder" );

    ObjDelete("gfx_complex_cosmeticsbag_powder");
    ObjDelete("spr_complex_cosmeticsbag_powder_sh");

  end;
  cmn.AddSubscriber( "get_powder", get_powder_inv );
  --------------------------------------------------------------------------------------------
  -- function get_crabamulet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_crabamulet" ] = {

      type = "get",
      get_obj = "spr_complex_cosmeticsbag_crabamulet",
      room = "int_complex_inv",
      zz = "inv_complex_cosmeticsbag",
      zz_gate = "inv_cosmeticsbag"
  };
  --------------------------------------------------------------------------------------------
  local get_crabamulet_inv = function ()

    if cmn.IsEventDone("get_powder") then
      interface.InventoryItemRemove( "inv_cosmeticsbag" );
    end;
    interface.InventoryItemAdd( "inv_crabamulet", "spr_complex_cosmeticsbag_crabamulet" );

    ObjDelete("gfx_complex_cosmeticsbag_crabamulet");
    ObjDelete("spr_complex_cosmeticsbag_crabamulet_sh");

  end;
  cmn.AddSubscriber( "get_crabamulet", get_crabamulet_inv );
  --------------------------------------------------------------------------------------------
  -- function get_nuts () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_nuts" ] = {

      type = "get",
      get_obj = "obj_complex_crumpledpackage_get_nuts",
      room = "int_complex_inv",
      zz = "inv_complex_crumpledpackage",
      zz_gate = "inv_crumpledpackage"
  };
  --------------------------------------------------------------------------------------------
  local get_nuts_inv = function ()

    interface.InventoryItemRemove( "inv_crumpledpackage" );
    interface.InventoryItemAdd( "inv_nuts", "obj_complex_crumpledpackage_get_nuts" );

    ObjDelete("gfx_complex_crumpledpackage_nuts");

  end;
  cmn.AddSubscriber( "get_nuts", get_nuts_inv );
  --------------------------------------------------------------------------------------------
  -- function get_magicpage3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_magicpage3" ] = {

      type = "get",
      get_obj = "spr_complex_notebook_magicpage3",
      room = "int_complex_inv",
      zz = "inv_complex_notebook",
      zz_gate = "inv_notebook"
  };
  --------------------------------------------------------------------------------------------
  local get_magicpage3_inv = function ()

    if cmn.IsEventDone("get_pendandwithsucker") then
      interface.InventoryItemRemove( "inv_notebook" );
    end;
    interface.InventoryItemAdd( "inv_magicpage", "spr_complex_notebook_magicpage3", function () cmn.GetMultyObject( 'magicpage', 6 ); end );

    ObjDelete("gfx_complex_notebook_magicpage3");
    ObjDelete("spr_complex_notebook_magicpage3_sh");

  end;
  cmn.AddSubscriber( "get_magicpage3", get_magicpage3_inv );
  --------------------------------------------------------------------------------------------
  -- function get_pendandwithsucker () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_pendandwithsucker" ] = {

      type = "get",
      get_obj = "spr_complex_notebook_pendandwithsucker",
      room = "int_complex_inv",
      zz = "inv_complex_notebook",
      zz_gate = "inv_notebook"
  };
  --------------------------------------------------------------------------------------------
  local get_pendandwithsucker_inv = function ()

    if cmn.IsEventDone("get_magicpage3") then
      interface.InventoryItemRemove( "inv_notebook" );
    end;
    interface.InventoryItemAdd( "inv_pendandwithsucker", "spr_complex_notebook_pendandwithsucker" );

    ObjDelete("gfx_complex_notebook_pendandwithsucker");
    ObjDelete("spr_complex_notebook_pendandwithsucker_sh");
    
    ObjSet("spr_complex_notebook_magicpage3",  { input = 1 });

  end;
  cmn.AddSubscriber( "get_pendandwithsucker", get_pendandwithsucker_inv );
  --------------------------------------------------------------------------------------------
  -- function get_magicpage2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_magicpage2" ] = {

      type = "get",
      get_obj = "spr_complex_giftegg_magicpage2",
      room = "int_complex_inv",
      zz = "inv_complex_giftegg",
      zz_gate = "inv_giftegg"
  };
  --------------------------------------------------------------------------------------------
  local get_magicpage2_inv = function ()

    if cmn.IsEventDone("get_heartamulet") then
      interface.InventoryItemRemove( "inv_giftegg" );
    end;
    interface.InventoryItemAdd( "inv_magicpage", "spr_complex_giftegg_magicpage2", function () cmn.GetMultyObject( 'magicpage', 6 ); end );

    ObjDelete("gfx_complex_giftegg_magicpage2");
    ObjDelete("spr_complex_giftegg_magicpage2_sh");

  end;
  cmn.AddSubscriber( "get_magicpage2", get_magicpage2_inv );
  --------------------------------------------------------------------------------------------
  -- function get_heartamulet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_heartamulet" ] = {

      type = "get",
      get_obj = "spr_complex_giftegg_heartamulet",
      room = "int_complex_inv",
      zz = "inv_complex_giftegg",
      zz_gate = "inv_giftegg"
  };
  --------------------------------------------------------------------------------------------
  local get_heartamulet_inv = function ()

    if cmn.IsEventDone("get_magicpage2") then
      interface.InventoryItemRemove( "inv_giftegg" );
    end;
    interface.InventoryItemAdd( "inv_heartamulet", "spr_complex_giftegg_heartamulet" );

    ObjDelete("gfx_complex_giftegg_heartamulet");
    ObjDelete("spr_complex_giftegg_heartamulet_sh");

  end;
  cmn.AddSubscriber( "get_heartamulet", get_heartamulet_inv );
  --------------------------------------------------------------------------------------------
  -- function get_spiderleg1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_spiderleg1" ] = {

      type = "get",
      get_obj = "spr_complex_pileofsheets_spiderleg1",
      room = "int_complex_inv",
      zz = "inv_complex_pileofsheets",
      zz_gate = "inv_pileofsheets"
  };
  --------------------------------------------------------------------------------------------
  local get_spiderleg1_inv = function ()

    interface.InventoryItemAdd( "inv_spiderleg", "spr_complex_pileofsheets_spiderleg1", function () cmn.GetMultyObject( 'spiderleg', 3 ); end );

    ObjDelete("gfx_complex_pileofsheets_spiderleg1");
    ObjDelete("spr_complex_pileofsheets_spiderleg1_sh");

  end;
  cmn.AddSubscriber( "get_spiderleg1", get_spiderleg1_inv );
  --------------------------------------------------------------------------------------------
  -- function get_hookwithrope () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_hookwithrope" ] = {

      type = "get",
      get_obj = "obj_complex_pileofsheets_sheets_get",
      room = "int_complex_inv",
      zz = "inv_complex_pileofsheets",
      zz_gate = "inv_pileofsheets"
  };
  --------------------------------------------------------------------------------------------
  local get_hookwithrope_inv = function ()

    interface.InventoryItemRemove( "inv_pileofsheets" );
    interface.InventoryItemAdd( "inv_hookwithrope", "obj_complex_pileofsheets_sheets_get" );

    ObjDelete("gfx_complex_pileofsheets_hookwithrope");

  end;
  cmn.AddSubscriber( "get_hookwithrope", get_hookwithrope_inv );
  
  --------------------------------------------------------------------------------------------
  -- function use_bridgeplanks () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_bridgeplanks" ] = {

      type = "use",
      inv_obj = "inv_bridgeplanks",
      use_place = "obj_complex_bridgebase_use_bridgeplanks",
      room = "int_complex_inv",
      zz = "inv_complex_bridgebase",
      zz_gate = "inv_bridgebase"
  };
  --------------------------------------------------------------------------------------------
  local use_bridgeplanks_inv = function ()

    interface.InventoryItemRemove( "inv_bridgeplanks" );
    
    if not cmn.IsEventDone("get_nails") then
      ObjSet("inv_bridgebase_star_light",  { alp = 0 });
    end;

  end;
  local use_bridgeplanks_beg = function ()

    ObjDelete( "obj_complex_bridgebase_use_bridgeplanks" );

  end;
  local use_bridgeplanks_end = function ()

    ObjMultiSet( { {"anm_complex_bridgebase_use_planks", { frame = 0, alp = 0 }},
                   {"anm_complex_bridgebase_planks_touch", { alp = 1 }},
                   {"obj_complex_bridgebase_use_nails", { input = 1 }} } );

  end;
  cmn.AddSubscriber( "use_bridgeplanks", use_bridgeplanks_inv );
  cmn.AddSubscriber( "use_bridgeplanks", use_bridgeplanks_beg, "inv_complex_bridgebase" );
  cmn.AddSubscriber( "use_bridgeplanks", use_bridgeplanks_end, "inv_complex_bridgebase" );
  cmn.AddSubscriber( "use_bridgeplanks_inv", use_bridgeplanks_inv );
  cmn.AddSubscriber( "use_bridgeplanks_beg", use_bridgeplanks_beg, "inv_complex_bridgebase" );
  cmn.AddSubscriber( "use_bridgeplanks_end", use_bridgeplanks_end, "inv_complex_bridgebase" );
  --------------------------------------------------------------------------------------------
  -- function use_nails () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_nails" ] = {

      type = "use",
      inv_obj = "inv_nails",
      use_place = "obj_complex_bridgebase_use_nails",
      room = "int_complex_inv",
      zz = "inv_complex_bridgebase",
      zz_gate = "inv_bridgebase"
  };
  --------------------------------------------------------------------------------------------
  local use_nails_inv = function ()

    interface.InventoryItemRemove( "inv_nails" );

  end;
  local use_nails_beg = function ()

    ObjDelete( "obj_complex_bridgebase_use_nails" );

  end;
  local use_nails_end = function ()
    
    ObjDelete( "anm_complex_bridgebase_use_nails" );

    ObjMultiSet( { {"anm_complex_bridgebase_nails_touch", { alp = 1 }},
                   {"anm_complex_bridgebase_use_planks", { alp = 1 }},
                   {"anm_complex_bridgebase_planks_touch", { alp = 0 }},
                   {"obj_complex_bridgebase_use_gnomeshammer", { input = 1 }} } );

  end;
  cmn.AddSubscriber( "use_nails", use_nails_inv );
  cmn.AddSubscriber( "use_nails", use_nails_beg, "inv_complex_bridgebase" );
  cmn.AddSubscriber( "use_nails", use_nails_end, "inv_complex_bridgebase" );
  cmn.AddSubscriber( "use_nails_inv", use_nails_inv );
  cmn.AddSubscriber( "use_nails_beg", use_nails_beg, "inv_complex_bridgebase" );
  cmn.AddSubscriber( "use_nails_end", use_nails_end, "inv_complex_bridgebase" );
  --------------------------------------------------------------------------------------------
  -- function use_acid () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_acid" ] = {

      type = "use",
      inv_obj = "inv_acid",
      use_place = "obj_complex_rustyblade_use_acid",
      room = "int_complex_inv",
      zz = "inv_complex_rustyblade",
      zz_gate = "inv_rustyblade"
  };
  --------------------------------------------------------------------------------------------
  local use_acid_inv = function ()

    interface.InventoryItemRemove( "inv_acid" );
    
    if not cmn.IsEventDone("get_cloth") then
      ObjSet("inv_rustyblade_star_light",  { alp = 0 });
    end;

  end;
  local use_acid_beg = function ()

    ObjDelete( "obj_complex_rustyblade_use_acid" );

  end;
  local use_acid_end = function ()

    if cmn.IsEventDone("use_cloth") then
      ObjSet("spr_complex_rustyblade_blade",  { alp = 1, input = 1 });
      ObjDelete( "anm_complex_rustyblade_use_acid" );
      ObjDelete( "anm_complex_rustyblade_clean" );
      ObjDelete( "spr_complex_rustyblade_acid" );
      ObjDelete( "spr_complex_rustyblade_cloth" );
      ObjDelete( "spr_complex_rustyblade_blade_rusty" );
    else 
      ObjSet("spr_complex_rustyblade_acid",  { alp = 1 });
    end;

  end;
  cmn.AddSubscriber( "use_acid", use_acid_inv );
  cmn.AddSubscriber( "use_acid", use_acid_beg, "inv_complex_rustyblade" );
  cmn.AddSubscriber( "use_acid", use_acid_end, "inv_complex_rustyblade" );
  cmn.AddSubscriber( "use_acid_inv", use_acid_inv );
  cmn.AddSubscriber( "use_acid_beg", use_acid_beg, "inv_complex_rustyblade" );
  cmn.AddSubscriber( "use_acid_end", use_acid_end, "inv_complex_rustyblade" );
  --------------------------------------------------------------------------------------------
  -- function use_cloth () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_cloth" ] = {

      type = "use",
      inv_obj = "inv_cloth",
      use_place = "obj_complex_rustyblade_use_cloth",
      room = "int_complex_inv",
      zz = "inv_complex_rustyblade",
      zz_gate = "inv_rustyblade"
  };
  --------------------------------------------------------------------------------------------
  local use_cloth_inv = function ()

    interface.InventoryItemRemove( "inv_cloth" );
    
    if not cmn.IsEventDone("get_acid") then
      ObjSet("inv_rustyblade_star_light",  { alp = 0 });
    end;

  end;
  local use_cloth_beg = function ()

    ObjDelete( "obj_complex_rustyblade_use_cloth" );

  end;
  local use_cloth_end = function ()

    if cmn.IsEventDone("use_acid") then
      ObjSet("spr_complex_rustyblade_blade",  { alp = 1, input = 1 });
      ObjDelete( "anm_complex_rustyblade_use_acid" );
      ObjDelete( "anm_complex_rustyblade_clean" );
      ObjDelete( "spr_complex_rustyblade_acid" );
      ObjDelete( "spr_complex_rustyblade_cloth" );
      ObjDelete( "spr_complex_rustyblade_blade_rusty" );
    else 
      ObjSet("spr_complex_rustyblade_cloth",  { alp = 1 });
    end;

  end;
  cmn.AddSubscriber( "use_cloth", use_cloth_inv );
  cmn.AddSubscriber( "use_cloth", use_cloth_beg, "inv_complex_rustyblade" );
  cmn.AddSubscriber( "use_cloth", use_cloth_end, "inv_complex_rustyblade" );
  cmn.AddSubscriber( "use_cloth_inv", use_cloth_inv );
  cmn.AddSubscriber( "use_cloth_beg", use_cloth_beg, "inv_complex_rustyblade" );
  cmn.AddSubscriber( "use_cloth_end", use_cloth_end, "inv_complex_rustyblade" );
  --------------------------------------------------------------------------------------------
  -- function use_spiderleg () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_spiderleg" ] = {

      type = "use",
      inv_obj = "inv_spiderleg",
      use_place = "obj_complex_brokenspider_use_spiderleg",
      room = "int_complex_inv",
      zz = "inv_complex_brokenspider",
      zz_gate = "inv_brokenspider"
  };
  --------------------------------------------------------------------------------------------
  local use_spiderleg_inv = function ()

    interface.InventoryItemRemove( "inv_spiderleg" );

  end;
  local use_spiderleg_beg = function ()

    ObjDelete( "obj_complex_brokenspider_use_spiderleg" );

  end;
  local use_spiderleg_end = function ()

    ObjMultiSet( { {"obj_complex_brokenspider_legs", { input = 1 }},
                   {"obj_complex_brokenspider_legs2", { alp = 1 }} } );

  end;
  cmn.AddSubscriber( "use_spiderleg", use_spiderleg_inv );
  cmn.AddSubscriber( "use_spiderleg", use_spiderleg_beg, "inv_complex_brokenspider" );
  cmn.AddSubscriber( "use_spiderleg", use_spiderleg_end, "inv_complex_brokenspider" );
  cmn.AddSubscriber( "use_spiderleg_inv", use_spiderleg_inv );
  cmn.AddSubscriber( "use_spiderleg_beg", use_spiderleg_beg, "inv_complex_brokenspider" );
  cmn.AddSubscriber( "use_spiderleg_end", use_spiderleg_end, "inv_complex_brokenspider" );
  --------------------------------------------------------------------------------------------
  -- function use_mermaidmedallion () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_mermaidmedallion" ] = {

      type = "use",
      inv_obj = "inv_mermaidmedallion",
      use_place = "obj_complex_notebook_use_mermaidmedallion",
      room = "int_complex_inv",
      zz = "inv_complex_notebook",
      zz_gate = "inv_notebook"
  };
  --------------------------------------------------------------------------------------------
  local use_mermaidmedallion_inv = function ()

    interface.InventoryItemRemove( "inv_mermaidmedallion" );

  end;
  local use_mermaidmedallion_beg = function ()

    ObjDelete( "obj_complex_notebook_use_mermaidmedallion" );

  end;
  local use_mermaidmedallion_end = function ()

    ObjSet("obj_complex_notebook_open",  { alp = 1, input = 1 });
    
    ObjDelete( "anm_complex_notebook_touch" );

  end;
  cmn.AddSubscriber( "use_mermaidmedallion", use_mermaidmedallion_inv );
  cmn.AddSubscriber( "use_mermaidmedallion", use_mermaidmedallion_beg, "inv_complex_notebook" );
  cmn.AddSubscriber( "use_mermaidmedallion", use_mermaidmedallion_end, "inv_complex_notebook" );
  cmn.AddSubscriber( "use_mermaidmedallion_inv", use_mermaidmedallion_inv );
  cmn.AddSubscriber( "use_mermaidmedallion_beg", use_mermaidmedallion_beg, "inv_complex_notebook" );
  cmn.AddSubscriber( "use_mermaidmedallion_end", use_mermaidmedallion_end, "inv_complex_notebook" );
  --------------------------------------------------------------------------------------------
  -- function use_graplinghook () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_graplinghook" ] = {

      type = "use",
      inv_obj = "inv_graplinghook",
      use_place = "obj_complex_pileofsheets_use_graplinghook",
      room = "int_complex_inv",
      zz = "inv_complex_pileofsheets",
      zz_gate = "inv_pileofsheets"
  };
  --------------------------------------------------------------------------------------------
  local use_graplinghook_inv = function ()

    interface.InventoryItemRemove( "inv_graplinghook" );

  end;
  local use_graplinghook_beg = function ()

    ObjDelete( "obj_complex_pileofsheets_use_graplinghook" );

  end;
  local use_graplinghook_end = function ()

    ObjMultiSet( { {"spr_complex_pileofsheets_hook_nod", { alp = 1 }},
                   {"obj_complex_pileofsheets_sheets_get", { input = 1 }},
                   {"gfx_complex_pileofsheets_hookwithrope", { alp = 1 }} } );

  end;
  cmn.AddSubscriber( "use_graplinghook", use_graplinghook_inv );
  cmn.AddSubscriber( "use_graplinghook", use_graplinghook_beg, "inv_complex_pileofsheets" );
  cmn.AddSubscriber( "use_graplinghook", use_graplinghook_end, "inv_complex_pileofsheets" );
  cmn.AddSubscriber( "use_graplinghook_inv", use_graplinghook_inv );
  cmn.AddSubscriber( "use_graplinghook_beg", use_graplinghook_beg, "inv_complex_pileofsheets" );
  cmn.AddSubscriber( "use_graplinghook_end", use_graplinghook_end, "inv_complex_pileofsheets" );
  
  --------------------------------------------------------------------------------------------
  -- function clk_installlegs1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_installlegs1" ] = {
      type = "click",
      use_place = "obj_complex_brokenspider_clk_installlegs1",
      room = "int_complex_inv",
      zz = "inv_complex_brokenspider",
      zz_gate = "inv_brokenspider"
  };
  --------------------------------------------------------------------------------------------
  local clk_installlegs1_beg = function ()
  
    ObjDelete( "obj_complex_brokenspider_clk_installlegs1" );
  
  end;
  local clk_installlegs1_end = function ()
    
    ObjSet("spr_complex_brokenspider_leg_1",  { pos_x = -101, pos_y = 9 });
  
    if cmn.IsEventDone("clk_installlegs2") and cmn.IsEventDone("clk_installlegs3") then
      ObjSet("obj_complex_brokenspider_spider",  { input = 1 });
    end;
    
  end;
  cmn.AddSubscriber( "clk_installlegs1", clk_installlegs1_beg, "inv_complex_brokenspider" );
  cmn.AddSubscriber( "clk_installlegs1", clk_installlegs1_end, "inv_complex_brokenspider" );
  cmn.AddSubscriber( "clk_installlegs1_beg", clk_installlegs1_beg, "inv_complex_brokenspider" );
  cmn.AddSubscriber( "clk_installlegs1_end", clk_installlegs1_end, "inv_complex_brokenspider" );
  --------------------------------------------------------------------------------------------
  -- function clk_installlegs2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_installlegs2" ] = {
      type = "click",
      use_place = "obj_complex_brokenspider_clk_installlegs2",
      room = "int_complex_inv",
      zz = "inv_complex_brokenspider",
      zz_gate = "inv_brokenspider"
  };
  --------------------------------------------------------------------------------------------
  local clk_installlegs2_beg = function ()
  
    ObjDelete( "obj_complex_brokenspider_clk_installlegs2" );
  
  end;
  local clk_installlegs2_end = function ()
    
    ObjSet("spr_complex_brokenspider_leg_2",  { pos_x = 5, pos_y = -81 });
  
    if cmn.IsEventDone("clk_installlegs1") and cmn.IsEventDone("clk_installlegs3") then
      ObjSet("obj_complex_brokenspider_spider",  { input = 1 });
    end;
    
  end;
  cmn.AddSubscriber( "clk_installlegs2", clk_installlegs2_beg, "inv_complex_brokenspider" );
  cmn.AddSubscriber( "clk_installlegs2", clk_installlegs2_end, "inv_complex_brokenspider" );
  cmn.AddSubscriber( "clk_installlegs2_beg", clk_installlegs2_beg, "inv_complex_brokenspider" );
  cmn.AddSubscriber( "clk_installlegs2_end", clk_installlegs2_end, "inv_complex_brokenspider" );
  --------------------------------------------------------------------------------------------
  -- function clk_installlegs3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_installlegs3" ] = {
      type = "click",
      use_place = "obj_complex_brokenspider_clk_installlegs3",
      room = "int_complex_inv",
      zz = "inv_complex_brokenspider",
      zz_gate = "inv_brokenspider"
  };
  --------------------------------------------------------------------------------------------
  local clk_installlegs3_beg = function ()
  
    ObjDelete( "obj_complex_brokenspider_clk_installlegs3" );
  
  end;
  local clk_installlegs3_end = function ()
    
    ObjSet("spr_complex_brokenspider_leg_3",  { pos_x = 76, pos_y = 71 });
  
    if cmn.IsEventDone("clk_installlegs1") and cmn.IsEventDone("clk_installlegs2") then
      ObjSet("obj_complex_brokenspider_spider",  { input = 1 });
    end;
    
  end;
  cmn.AddSubscriber( "clk_installlegs3", clk_installlegs3_beg, "inv_complex_brokenspider" );
  cmn.AddSubscriber( "clk_installlegs3", clk_installlegs3_end, "inv_complex_brokenspider" );
  cmn.AddSubscriber( "clk_installlegs3_beg", clk_installlegs3_beg, "inv_complex_brokenspider" );
  cmn.AddSubscriber( "clk_installlegs3_end", clk_installlegs3_end, "inv_complex_brokenspider" );
  --------------------------------------------------------------------------------------------
  -- function clk_unzip () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_unzip" ] = {
      type = "click",
      use_place = "obj_complex_cosmeticsbag_clk_unzip",
      room = "int_complex_inv",
      zz = "inv_complex_cosmeticsbag",
      zz_gate = "inv_cosmeticsbag"
  };
  --------------------------------------------------------------------------------------------
  local clk_unzip_beg = function ()
  
    ObjDelete( "obj_complex_cosmeticsbag_clk_unzip" );
  
  end;
  local clk_unzip_end = function ()
  
    ObjSet("anm_complex_cosmeticsbag_unzip",  { frame = 300, input = 1 });
    
  end;
  cmn.AddSubscriber( "clk_unzip", clk_unzip_beg, "inv_complex_cosmeticsbag" );
  cmn.AddSubscriber( "clk_unzip", clk_unzip_end, "inv_complex_cosmeticsbag" );
  cmn.AddSubscriber( "clk_unzip_beg", clk_unzip_beg, "inv_complex_cosmeticsbag" );
  cmn.AddSubscriber( "clk_unzip_end", clk_unzip_end, "inv_complex_cosmeticsbag" );
  --------------------------------------------------------------------------------------------
  -- function clk_unfold () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_unfold" ] = {
      type = "click",
      use_place = "obj_complex_crumpledpackage_clk_unfold",
      room = "int_complex_inv",
      zz = "inv_complex_crumpledpackage",
      zz_gate = "inv_crumpledpackage"
  };
  --------------------------------------------------------------------------------------------
  local clk_unfold_beg = function ()
  
    ObjDelete( "obj_complex_crumpledpackage_clk_unfold" );
  
  end;
  local clk_unfold_end = function ()

    ObjMultiSet( { { "obj_complex_crumpledpackage_clk_pournuts", { input = true } },
                   { "anm_complex_crumpledpackage_nuts", { alp = 1 } } } );

    ObjDelete( "spr_complex_crumpledpackage_package_1" );
    ObjDelete( "spr_complex_crumpledpackage_package_2" );
    
  end;
  cmn.AddSubscriber( "clk_unfold", clk_unfold_beg, "inv_complex_crumpledpackage" );
  cmn.AddSubscriber( "clk_unfold", clk_unfold_end, "inv_complex_crumpledpackage" );
  cmn.AddSubscriber( "clk_unfold_beg", clk_unfold_beg, "inv_complex_crumpledpackage" );
  cmn.AddSubscriber( "clk_unfold_end", clk_unfold_end, "inv_complex_crumpledpackage" );
  --------------------------------------------------------------------------------------------
  -- function clk_pournuts () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_pournuts" ] = {
      type = "click",
      use_place = "obj_complex_crumpledpackage_clk_pournuts",
      room = "int_complex_inv",
      zz = "inv_complex_crumpledpackage",
      zz_gate = "inv_crumpledpackage"
  };
  --------------------------------------------------------------------------------------------
  local clk_pournuts_beg = function ()
  
    ObjDelete( "obj_complex_crumpledpackage_clk_pournuts" );

    ObjMultiSet( { { "obj_complex_crumpledpackage_get_nuts", { alp = 1, input = 1 } },
                   { "gfx_complex_crumpledpackage_nuts", { active = true } } } );
  
  end;
  local clk_pournuts_end = function ()

    ObjDelete( "anm_complex_crumpledpackage_nuts" );
    
  end;
  cmn.AddSubscriber( "clk_pournuts", clk_pournuts_beg, "inv_complex_crumpledpackage" );
  cmn.AddSubscriber( "clk_pournuts", clk_pournuts_end, "inv_complex_crumpledpackage" );
  cmn.AddSubscriber( "clk_pournuts_beg", clk_pournuts_beg, "inv_complex_crumpledpackage" );
  cmn.AddSubscriber( "clk_pournuts_end", clk_pournuts_end, "inv_complex_crumpledpackage" );
  --------------------------------------------------------------------------------------------
  -- function clk_openegg () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_openegg" ] = {
      type = "click",
      use_place = "obj_complex_giftegg_clk_openegg",
      room = "int_complex_inv",
      zz = "inv_complex_giftegg",
      zz_gate = "inv_giftegg"
  };
  --------------------------------------------------------------------------------------------
  local clk_openegg_beg = function ()
  
    ObjDelete( "obj_complex_giftegg_clk_openegg" );
  
  end;
  local clk_openegg_end = function ()
    
    ObjDelete( "spr_complex_giftegg_foiled_egg" );
  
    ObjMultiSet( { {"obj_complex_giftegg_clk_eategg1", { input = 1 }},
                   {"spr_complex_giftegg_foil", { alp = 1 }} } );
    
  end;
  cmn.AddSubscriber( "clk_openegg", clk_openegg_beg, "inv_complex_giftegg" );
  cmn.AddSubscriber( "clk_openegg", clk_openegg_end, "inv_complex_giftegg" );
  cmn.AddSubscriber( "clk_openegg_beg", clk_openegg_beg, "inv_complex_giftegg" );
  cmn.AddSubscriber( "clk_openegg_end", clk_openegg_end, "inv_complex_giftegg" );
  --------------------------------------------------------------------------------------------
  -- function clk_openegg2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_openegg2" ] = {
      type = "click",
      use_place = "obj_complex_giftegg_clk_openegg2",
      room = "int_complex_inv",
      zz = "inv_complex_giftegg",
      zz_gate = "inv_giftegg"
  };
  --------------------------------------------------------------------------------------------
  local clk_openegg2_beg = function ()
  
    ObjDelete( "obj_complex_giftegg_clk_openegg2" );
  
  end;
  local clk_openegg2_end = function ()
    
    ObjDelete( "spr_complex_giftegg_heartamulet_bl_2" );
  
    ObjSet("spr_complex_giftegg_heartamulet",  { input = 1 });
    
  end;
  cmn.AddSubscriber( "clk_openegg2", clk_openegg2_beg, "inv_complex_giftegg" );
  cmn.AddSubscriber( "clk_openegg2", clk_openegg2_end, "inv_complex_giftegg" );
  cmn.AddSubscriber( "clk_openegg2_beg", clk_openegg2_beg, "inv_complex_giftegg" );
  cmn.AddSubscriber( "clk_openegg2_end", clk_openegg2_end, "inv_complex_giftegg" );
  --------------------------------------------------------------------------------------------
  -- function clk_eategg1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_eategg1" ] = {
      type = "click",
      use_place = "obj_complex_giftegg_clk_eategg1",
      room = "int_complex_inv",
      zz = "inv_complex_giftegg",
      zz_gate = "inv_giftegg"
  };
  --------------------------------------------------------------------------------------------
  local clk_eategg1_beg = function ()
  
    ObjDelete( "obj_complex_giftegg_clk_eategg1" );
  
  end;
  local clk_eategg1_end = function ()
  
    ObjDelete( "obj_complex_giftegg_egg_1" );
  
    ObjMultiSet( { {"obj_complex_giftegg_clk_eategg2", { input = 1 }},
                   {"obj_complex_giftegg_egg_2", { alp = 1 }} } );
    
  end;
  cmn.AddSubscriber( "clk_eategg1", clk_eategg1_beg, "inv_complex_giftegg" );
  cmn.AddSubscriber( "clk_eategg1", clk_eategg1_end, "inv_complex_giftegg" );
  cmn.AddSubscriber( "clk_eategg1_beg", clk_eategg1_beg, "inv_complex_giftegg" );
  cmn.AddSubscriber( "clk_eategg1_end", clk_eategg1_end, "inv_complex_giftegg" );
  --------------------------------------------------------------------------------------------
  -- function clk_eategg2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_eategg2" ] = {
      type = "click",
      use_place = "obj_complex_giftegg_clk_eategg2",
      room = "int_complex_inv",
      zz = "inv_complex_giftegg",
      zz_gate = "inv_giftegg"
  };
  --------------------------------------------------------------------------------------------
  local clk_eategg2_beg = function ()
  
    ObjDelete( "obj_complex_giftegg_clk_eategg2" );
  
  end;
  local clk_eategg2_end = function ()
  
    ObjDelete( "obj_complex_giftegg_egg_2" );
  
    ObjMultiSet( { {"obj_complex_giftegg_clk_eategg3", { input = 1 }},
                   {"obj_complex_giftegg_egg_3", { alp = 1 }} } );
    
  end;
  cmn.AddSubscriber( "clk_eategg2", clk_eategg2_beg, "inv_complex_giftegg" );
  cmn.AddSubscriber( "clk_eategg2", clk_eategg2_end, "inv_complex_giftegg" );
  cmn.AddSubscriber( "clk_eategg2_beg", clk_eategg2_beg, "inv_complex_giftegg" );
  cmn.AddSubscriber( "clk_eategg2_end", clk_eategg2_end, "inv_complex_giftegg" );
  --------------------------------------------------------------------------------------------
  -- function clk_eategg3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_eategg3" ] = {
      type = "click",
      use_place = "obj_complex_giftegg_clk_eategg3",
      room = "int_complex_inv",
      zz = "inv_complex_giftegg",
      zz_gate = "inv_giftegg"
  };
  --------------------------------------------------------------------------------------------
  local clk_eategg3_beg = function ()
  
    ObjDelete( "obj_complex_giftegg_clk_eategg3" );
  
  end;
  local clk_eategg3_end = function ()
  
    ObjDelete( "obj_complex_giftegg_egg_3" );
  
    ObjSet("obj_complex_giftegg_egg_4",  { alp = 1, input = 1 });
    
  end;
  cmn.AddSubscriber( "clk_eategg3", clk_eategg3_beg, "inv_complex_giftegg" );
  cmn.AddSubscriber( "clk_eategg3", clk_eategg3_end, "inv_complex_giftegg" );
  cmn.AddSubscriber( "clk_eategg3_beg", clk_eategg3_beg, "inv_complex_giftegg" );
  cmn.AddSubscriber( "clk_eategg3_end", clk_eategg3_end, "inv_complex_giftegg" );
  --------------------------------------------------------------------------------------------
  -- function clk_makelongrope1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_makelongrope1" ] = {
      type = "click",
      use_place = "obj_complex_pileofsheets_clk_makelongrope1",
      room = "int_complex_inv",
      zz = "inv_complex_pileofsheets",
      zz_gate = "inv_pileofsheets"
  };
  --------------------------------------------------------------------------------------------
  local clk_makelongrope1_beg = function ()
  
    ObjDelete( "obj_complex_pileofsheets_clk_makelongrope1" );
  
  end;
  local clk_makelongrope1_end = function ()
  
    ObjMultiSet( { {"obj_complex_pileofsheets_nod_1", { alp = 1 }},
                   {"obj_complex_pileofsheets_clk_makelongrope2", { input = 1 }} } );
    
  end;
  cmn.AddSubscriber( "clk_makelongrope1", clk_makelongrope1_beg, "inv_complex_pileofsheets" );
  cmn.AddSubscriber( "clk_makelongrope1", clk_makelongrope1_end, "inv_complex_pileofsheets" );
  cmn.AddSubscriber( "clk_makelongrope1_beg", clk_makelongrope1_beg, "inv_complex_pileofsheets" );
  cmn.AddSubscriber( "clk_makelongrope1_end", clk_makelongrope1_end, "inv_complex_pileofsheets" );
  --------------------------------------------------------------------------------------------
  -- function clk_makelongrope2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_makelongrope2" ] = {
      type = "click",
      use_place = "obj_complex_pileofsheets_clk_makelongrope2",
      room = "int_complex_inv",
      zz = "inv_complex_pileofsheets",
      zz_gate = "inv_pileofsheets"
  };
  --------------------------------------------------------------------------------------------
  local clk_makelongrope2_beg = function ()
  
    ObjDelete( "obj_complex_pileofsheets_clk_makelongrope2" );
  
  end;
  local clk_makelongrope2_end = function ()
  
    ObjMultiSet( { {"obj_complex_pileofsheets_nod_2", { alp = 1 }},
                   {"obj_complex_pileofsheets_clk_makelongrope3", { input = 1 }} } );
    
  end;
  cmn.AddSubscriber( "clk_makelongrope2", clk_makelongrope2_beg, "inv_complex_pileofsheets" );
  cmn.AddSubscriber( "clk_makelongrope2", clk_makelongrope2_end, "inv_complex_pileofsheets" );
  cmn.AddSubscriber( "clk_makelongrope2_beg", clk_makelongrope2_beg, "inv_complex_pileofsheets" );
  cmn.AddSubscriber( "clk_makelongrope2_end", clk_makelongrope2_end, "inv_complex_pileofsheets" );
  --------------------------------------------------------------------------------------------
  -- function clk_makelongrope3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_makelongrope3" ] = {
      type = "click",
      use_place = "obj_complex_pileofsheets_clk_makelongrope3",
      room = "int_complex_inv",
      zz = "inv_complex_pileofsheets",
      zz_gate = "inv_pileofsheets"
  };
  --------------------------------------------------------------------------------------------
  local clk_makelongrope3_beg = function ()
  
    ObjDelete( "obj_complex_pileofsheets_clk_makelongrope3" );
  
  end;
  local clk_makelongrope3_end = function ()
  
    ObjMultiSet( { {"obj_complex_pileofsheets_nod_3", { alp = 1 }},
                   {"obj_complex_pileofsheets_clk_makelongrope4", { input = 1 }} } );
    
  end;
  cmn.AddSubscriber( "clk_makelongrope3", clk_makelongrope3_beg, "inv_complex_pileofsheets" );
  cmn.AddSubscriber( "clk_makelongrope3", clk_makelongrope3_end, "inv_complex_pileofsheets" );
  cmn.AddSubscriber( "clk_makelongrope3_beg", clk_makelongrope3_beg, "inv_complex_pileofsheets" );
  cmn.AddSubscriber( "clk_makelongrope3_end", clk_makelongrope3_end, "inv_complex_pileofsheets" );
  --------------------------------------------------------------------------------------------
  -- function clk_makelongrope4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_makelongrope4" ] = {
      type = "click",
      use_place = "obj_complex_pileofsheets_clk_makelongrope4",
      room = "int_complex_inv",
      zz = "inv_complex_pileofsheets",
      zz_gate = "inv_pileofsheets"
  };
  --------------------------------------------------------------------------------------------
  local clk_makelongrope4_beg = function ()
  
    ObjDelete( "obj_complex_pileofsheets_clk_makelongrope4" );
  
  end;
  local clk_makelongrope4_end = function ()
  
    ObjDelete( "obj_complex_pileofsheets_sheets_out" );
    
    ObjMultiSet( { {"obj_complex_pileofsheets_sheets_get", { alp = 1 }},
                   {"obj_complex_pileofsheets_use_graplinghook", { input = 1 }} } );
    
  end;
  cmn.AddSubscriber( "clk_makelongrope4", clk_makelongrope4_beg, "inv_complex_pileofsheets" );
  cmn.AddSubscriber( "clk_makelongrope4", clk_makelongrope4_end, "inv_complex_pileofsheets" );
  cmn.AddSubscriber( "clk_makelongrope4_beg", clk_makelongrope4_beg, "inv_complex_pileofsheets" );
  cmn.AddSubscriber( "clk_makelongrope4_end", clk_makelongrope4_end, "inv_complex_pileofsheets" );
  --------------------------------------------------------------------------------------------
  -- function clk_sheetsundone () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_sheetsundone" ] = {
      type = "click",
      use_place = "spr_complex_pileofsheets_sheets_1",
      room = "int_complex_inv",
      zz = "inv_complex_pileofsheets",
      zz_gate = "inv_pileofsheets"
  };
  --------------------------------------------------------------------------------------------
  local clk_sheetsundone = function ()
  
    ObjDelete( "spr_complex_pileofsheets_sheets_1" );
    
    ObjMultiSet( { {"obj_complex_pileofsheets_sheets_out", { alp = 1 }},
                   {"obj_complex_pileofsheets_clk_makelongrope1", { input = 1 }} } );
    
  end;
  cmn.AddSubscriber( "clk_sheetsundone", clk_sheetsundone, "inv_complex_pileofsheets" );

end;
--*********************************************************************************************************************
-- function *** CLOSE FUNC *** () end;
--*********************************************************************************************************************
function public.inv_complex_bridgebase_close()

  if cmn.IsEventDone( "use_gnomeshammerbridge" ) and not cmn.IsEventDone( "get_selfmadebridgre" ) then
    
    ObjSet("spr_complex_bridgebase_selfmadebridgre",  { alp = 1 });
    
    cmn.SetEventDone( "get_selfmadebridgre" );
    cmn.CallEventHandler( "get_selfmadebridgre", "inv_complex_bridgebase" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_rustyblade_close()

  if cmn.IsEventDone( "use_acid" ) and cmn.IsEventDone( "use_cloth" ) and not cmn.IsEventDone( "get_blade" ) then
    
    cmn.SetEventDone( "get_blade" );
    cmn.CallEventHandler( "get_blade", "inv_complex_rustyblade" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_brokenspider_close()

  if cmn.IsEventDone( "clk_installlegs1" ) and cmn.IsEventDone( "clk_installlegs2" ) and cmn.IsEventDone( "clk_installlegs3" ) 
  and not cmn.IsEventDone( "get_spider" ) then
    
    cmn.SetEventDone( "get_spider" );
    cmn.CallEventHandler( "get_spider", "inv_complex_brokenspider" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_cosmeticsbag_close()

  if cmn.IsEventDone( "clk_unzip" ) then

    if not cmn.IsEventDone("get_powder") or not cmn.IsEventDone("get_crabamulet") then
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
    end;

    if not cmn.IsEventDone( "get_powder" ) then

      cmn.SetEventDone( "get_powder" );
      cmn.CallEventHandler( "get_powder", "inv_complex_cosmeticsbag" );

    end;

    if not cmn.IsEventDone( "get_crabamulet" ) then

      cmn.SetEventDone( "get_crabamulet" );
      cmn.CallEventHandler( "get_crabamulet", "inv_complex_cosmeticsbag" );

    end;

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_crumpledpackage_close()

  if cmn.IsEventDone( "clk_pournuts" ) and not cmn.IsEventDone( "get_nuts" ) then
    
    cmn.SetEventDone( "get_nuts" );
    cmn.CallEventHandler( "get_nuts", "inv_complex_crumpledpackage" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_notebook_close()

  if cmn.IsEventDone( "use_mermaidmedallion" ) then

    if not cmn.IsEventDone("get_magicpage3") or not cmn.IsEventDone("get_pendandwithsucker") then
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
    end;

    if not cmn.IsEventDone( "get_magicpage3" ) then

      cmn.SetEventDone( "get_magicpage3" );
      cmn.CallEventHandler( "get_magicpage3", "inv_complex_notebook" );

    end;

    if not cmn.IsEventDone( "get_pendandwithsucker" ) then

      cmn.SetEventDone( "get_pendandwithsucker" );
      cmn.CallEventHandler( "get_pendandwithsucker", "inv_complex_notebook" );

    end;

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_giftegg_close()

  if cmn.IsEventDone( "clk_eategg3" ) then

    if not cmn.IsEventDone("get_magicpage2") or not cmn.IsEventDone("get_heartamulet") and cmn.IsEventDone("clk_openegg2") then
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
    end;

    if not cmn.IsEventDone( "get_magicpage2" ) then

      cmn.SetEventDone( "get_magicpage2" );
      cmn.CallEventHandler( "get_magicpage2", "inv_complex_giftegg" );

    end;

    if not cmn.IsEventDone( "get_heartamulet" ) and cmn.IsEventDone("clk_openegg2") then

      cmn.SetEventDone( "get_heartamulet" );
      cmn.CallEventHandler( "get_heartamulet", "inv_complex_giftegg" );

    end;

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_pileofsheets_close()

  if cmn.IsEventDone( "use_graplinghook" ) and not cmn.IsEventDone( "get_hookwithrope" ) then
    
    cmn.SetEventDone( "get_hookwithrope" );
    cmn.CallEventHandler( "get_hookwithrope", "inv_complex_pileofsheets" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;
  
  if not cmn.IsEventDone( "get_spiderleg1" ) then
    
    cmn.SetEventDone( "get_spiderleg1" );
    cmn.CallEventHandler( "get_spiderleg1", "inv_complex_pileofsheets" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;
  
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_bridgeplanks()

  local item = "inv_bridgeplanks";

  if cmn.ObjIntersectCheck( item, "obj_complex_bridgebase_use_bridgeplanks" ) and cmn.CheckMultiObject( "bridgeplanks", 3 ) then

    cmn.CallEventHandler( "use_bridgeplanks_inv", "inv_complex_bridgebase" );
    cmn.CallEventHandler( "use_bridgeplanks_beg", "inv_complex_bridgebase" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_bridgeplanks" );
      cmn.CallEventHandler( "use_bridgeplanks_end", "inv_complex_bridgebase" );
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_bridgebase/audio/aud_use_boards");

    ObjSet("anm_complex_bridgebase_use_planks",  { alp = 1, playing = 1, endtrig = func_after });
    
  elseif ( cmn.ApplyObj( item, "obj_shore_use_selfmadebridgre" ) ) then
    
    cmn.Lock( 1 );
    cmn.ShowBbt( "shore_bridgeplanks_wrong" );
    ObjAnimate("obj_shore_use_selfmadebridgre", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 1,   0.3, 0, 1 });

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_nails()

  local item = "inv_nails";

  if cmn.ObjIntersectCheck( item, "obj_complex_bridgebase_use_nails" ) and cmn.IsEventDone("use_bridgeplanks") then

    cmn.CallEventHandler( "use_nails_inv", "inv_complex_bridgebase" );
    cmn.CallEventHandler( "use_nails_beg", "inv_complex_bridgebase" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_nails" );
      cmn.CallEventHandler( "use_nails_end", "inv_complex_bridgebase" );
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_bridgebase/audio/aud_use_nails");

    ObjSet("anm_complex_bridgebase_use_nails",  { alp = 1, playing = 1, endtrig = func_after });

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_acid()

  local item = "inv_acid";

  if cmn.ObjIntersectCheck( item, "obj_complex_rustyblade_use_acid" ) then

    cmn.CallEventHandler( "use_acid_inv", "inv_complex_rustyblade" );
    cmn.CallEventHandler( "use_acid_beg", "inv_complex_rustyblade" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_acid" );
      cmn.CallEventHandler( "use_acid_end", "inv_complex_rustyblade" );
      
    end;
    
    local anm_clean = function ()
      
      ObjMultiSet( { {"anm_complex_rustyblade_clean", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_complex_rustyblade_use_acid", { alp = 0 }},
                     {"spr_complex_rustyblade_blade_rusty", { alp = 0 }} } );
      
    end;
    
    local anm_acid = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_rustyblade/audio/aud_use_antirust");
      
      ObjMultiSet( { {"anm_complex_rustyblade_use_acid", { alp = 1, playing = 1, endtrig = anm_clean }},
                     {"spr_complex_rustyblade_cloth", { alp = 0 }} } );
      
    end;

    cmn.Lock( 1 );
    
    if cmn.IsEventDone("use_cloth") then
      anm_acid();
    else 
      cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_rustyblade/audio/aud_use_scull2");
      ObjAnimate( "spr_complex_rustyblade_acid", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;
    
  elseif cmn.ApplyObj( item, "obj_poinrter_use_file" ) then
      
    cmn.Lock( 1 );
    cmn.ShowBbt( "poinrter_use_acid_wrong" );       
    ObjAnimate("obj_poinrter_use_file", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 1,   0.3, 0, 1 });  

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_cloth()

  local item = "inv_cloth";

  if cmn.ObjIntersectCheck( item, "obj_complex_rustyblade_use_cloth" ) then

    cmn.CallEventHandler( "use_cloth_inv", "inv_complex_rustyblade" );
    cmn.CallEventHandler( "use_cloth_beg", "inv_complex_rustyblade" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_cloth" );
      cmn.CallEventHandler( "use_cloth_end", "inv_complex_rustyblade" );
      
    end;
    
    local anm_clean = function ()
      
      ObjMultiSet( { {"anm_complex_rustyblade_clean", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_complex_rustyblade_use_acid", { alp = 0 }},
                     {"spr_complex_rustyblade_blade_rusty", { alp = 0 }} } );
      
    end;
    
    local anm_acid = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_rustyblade/audio/aud_use_antirust");
      
      ObjAnimate("spr_complex_rustyblade_acid", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
      ObjMultiSet( { {"anm_complex_rustyblade_use_acid", { alp = 1, playing = 1, endtrig = anm_clean }},
                     {"spr_complex_rustyblade_cloth", { alp = 0 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_purse/audio/aud_xx_clk_cloth");

    if cmn.IsEventDone("use_acid") then
      ObjAnimate( "spr_complex_rustyblade_cloth", "alp", 0, 0, anm_acid, { 0, 0, 0,   0.3, 0, 1 } );
    else 
      ObjAnimate( "spr_complex_rustyblade_cloth", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_spiderleg()

  local item = "inv_spiderleg";

  if cmn.ObjIntersectCheck( item, "obj_complex_brokenspider_use_spiderleg" ) and cmn.CheckMultiObject( "spiderleg", 3 ) then

    cmn.CallEventHandler( "use_spiderleg_inv", "inv_complex_brokenspider" );
    cmn.CallEventHandler( "use_spiderleg_beg", "inv_complex_brokenspider" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_spiderleg" );
      cmn.CallEventHandler( "use_spiderleg_end", "inv_complex_brokenspider" );
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_brokenspider/audio/aud_use_plastic");

    ObjAnimate( "obj_complex_brokenspider_legs2", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_mermaidmedallion()

  local item = "inv_mermaidmedallion";

  if cmn.ObjIntersectCheck( item, "obj_complex_notebook_use_mermaidmedallion" ) then

    cmn.CallEventHandler( "use_mermaidmedallion_inv", "inv_complex_notebook" );
    cmn.CallEventHandler( "use_mermaidmedallion_beg", "inv_complex_notebook" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_mermaidmedallion" );
      cmn.CallEventHandler( "use_mermaidmedallion_end", "inv_complex_notebook" );
      
    end;
    
    local anm_open = function ()
      
      ObjAnimate("obj_complex_notebook_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_complex_notebook_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_diary/audio/aud_opn_book");

    ObjAnimate( "spr_complex_notebook_amulet", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,     0.6, 0, 1 } );

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_graplinghook()

  local item = "inv_graplinghook";

  if cmn.ObjIntersectCheck( item, "obj_complex_pileofsheets_use_graplinghook" ) and cmn.IsEventDone("clk_makelongrope4") then

    cmn.CallEventHandler( "use_graplinghook_inv", "inv_complex_pileofsheets" );
    cmn.CallEventHandler( "use_graplinghook_beg", "inv_complex_pileofsheets" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_graplinghook" );
      cmn.CallEventHandler( "use_graplinghook_end", "inv_complex_pileofsheets" );
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_pileofsheets/audio/aud_xx_clk_node");

    ObjAnimate( "spr_complex_pileofsheets_hook_nod", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 } );
    ObjAnimate( "gfx_complex_pileofsheets_hookwithrope", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 } );

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_selfmadebridgre()
  
  ObjSet("spr_complex_bridgebase_selfmadebridgre",  { alp = 1 });
  
  cmn.SetEventDone( "get_selfmadebridgre" );
  cmn.CallEventHandler( "get_selfmadebridgre", "inv_complex_bridgebase" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

    if port.isPortable()==1 then
      iOS_RateMe();
    end;
  
  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_blade()
  
  cmn.SetEventDone( "get_blade" );
  cmn.CallEventHandler( "get_blade", "inv_complex_rustyblade" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_spider()
  
  cmn.SetEventDone( "get_spider" );
  cmn.CallEventHandler( "get_spider", "inv_complex_brokenspider" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_powder()
  
  cmn.SetEventDone( "get_powder" );
  cmn.CallEventHandler( "get_powder", "inv_complex_cosmeticsbag" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if cmn.IsEventDone("get_crabamulet") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_crabamulet()
  
  cmn.SetEventDone( "get_crabamulet" );
  cmn.CallEventHandler( "get_crabamulet", "inv_complex_cosmeticsbag" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if cmn.IsEventDone("get_powder") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_nuts()
  
  cmn.SetEventDone( "get_nuts" );
  cmn.CallEventHandler( "get_nuts", "inv_complex_crumpledpackage" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_pendandwithsucker()
  
  cmn.SetEventDone( "get_pendandwithsucker" );
  cmn.CallEventHandler( "get_pendandwithsucker", "inv_complex_notebook" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if cmn.IsEventDone("get_magicpage3") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_magicpage3()
  
  cmn.SetEventDone( "get_magicpage3" );
  cmn.CallEventHandler( "get_magicpage3", "inv_complex_notebook" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if cmn.IsEventDone("get_pendandwithsucker") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_magicpage2()
  
  cmn.SetEventDone( "get_magicpage2" );
  cmn.CallEventHandler( "get_magicpage2", "inv_complex_giftegg" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if cmn.IsEventDone("get_heartamulet") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_heartamulet()
  
  cmn.SetEventDone( "get_heartamulet" );
  cmn.CallEventHandler( "get_heartamulet", "inv_complex_giftegg" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if cmn.IsEventDone("get_magicpage2") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_spiderleg1()
  
  cmn.SetEventDone( "get_spiderleg1" );
  cmn.CallEventHandler( "get_spiderleg1", "inv_complex_pileofsheets" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");
  
  public.clk_sheetsundone();

end;
--------------------------------------------------------------------------------------------
function public.get_hookwithrope()
  
  cmn.SetEventDone( "get_hookwithrope" );
  cmn.CallEventHandler( "get_hookwithrope", "inv_complex_pileofsheets" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function public.clk_installlegs( num )

  --cmn.Lock(1);
  cmn.CallEventHandler( "clk_installlegs"..num.."_beg", "inv_complex_brokenspider" );

  local func_after = function ()

    cmn.SetEventDone( "clk_installlegs"..num );
    cmn.CallEventHandler( "clk_installlegs"..num.."_end", "inv_complex_brokenspider" );

    cmn.Lock(0);
    cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_brokenspider/audio/aud_use_plastic1");

  end;
  
  local spider_leg_pos = { { {-166, 43}, {-101, 9} }, { {-11, -142}, {5, -81} }, { {164, 83}, {76, 71} } };
  
  local point_a, point_b = {}, {};
  point_a[1] = spider_leg_pos[num][1][1];
  point_a[2] = spider_leg_pos[num][1][2];
  point_b[1] = spider_leg_pos[num][2][1];
  point_b[2] = spider_leg_pos[num][2][2];
  local len = common_impl.math.FindSegmentLength( point_a, point_b );
  local tme = 0.002 * len;
  
  ObjAnimate( "spr_complex_brokenspider_leg_"..num, "pos_xy", 0, 0, func_after, { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] } );

end;
--------------------------------------------------------------------------------------------
function public.clk_unzip()

  cmn.Lock(1);
  cmn.CallEventHandler( "clk_unzip_beg", "inv_complex_cosmeticsbag" );

  local func_after = function ()

    cmn.SetEventDone( "clk_unzip" );
    cmn.CallEventHandler( "clk_unzip_end", "inv_complex_cosmeticsbag" );

    cmn.Lock(0);

  end;
  
  cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_cosmeticsbag/audio/aud_clk_zipper");

  ObjSet("anm_complex_cosmeticsbag_unzip",  { playing = 1, endtrig = func_after });

end;
--------------------------------------------------------------------------------------------
function public.clk_unfold()

  cmn.Lock(1);
  cmn.CallEventHandler( "clk_unfold_beg", "inv_complex_crumpledpackage" );

  local func_after = function ()

    cmn.SetEventDone( "clk_unfold" );
    cmn.CallEventHandler( "clk_unfold_end", "inv_complex_crumpledpackage" );

    cmn.Lock(0);

  end;
  
  cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_crumpledpackage/audio/aud_clk_paper4");

  ObjAnimate( "spr_complex_crumpledpackage_package_1", "alp", 0, 0, "",         { 0, 0, 1,    0.4, 0, 0 } );
  ObjAnimate( "spr_complex_crumpledpackage_package_2", "alp", 0, 0, "",         { 0, 0, 0,    0.4, 0, 1,    0.8, 0, 0 } );
  ObjAnimate( "anm_complex_crumpledpackage_nuts",      "alp", 0, 0, func_after, { 0, 0, 0,    0.4, 0, 0,    0.8, 0, 1 } );
  
end;
--------------------------------------------------------------------------------------------
function public.clk_pournuts()

  cmn.Lock(1);

  local func_after2 = function ()

    cmn.SetEventDone( "clk_pournuts" );
    cmn.CallEventHandler( "clk_pournuts_end", "inv_complex_crumpledpackage" );

    cmn.Lock(0);

  end;

  local func_after = function ()

    cmn.CallEventHandler( "clk_pournuts_beg", "inv_complex_crumpledpackage" );

    ObjMultiSet( { { "spr_complex_crumpledpackage_peanut_1", { alp = 0 } },
                   { "spr_complex_crumpledpackage_peanut_2", { alp = 0 } },
                   { "spr_complex_crumpledpackage_peanut_3", { alp = 0 } },
                   { "spr_complex_crumpledpackage_peanut_4", { alp = 0 } },
                   { "spr_complex_crumpledpackage_peanut_5", { alp = 0 } },
                   { "spr_complex_crumpledpackage_peanut_6", { alp = 0 } } } );

    ObjAnimate( "anm_complex_crumpledpackage_nuts", "alp", 0, 0, func_after2, { 0, 0, 1,    0.3, 0, 0 } );

  end;

  cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_crumpledpackage/audio/aud_clk_paper5");

  ObjSet( "anm_complex_crumpledpackage_nuts", { endtrig = func_after, playing = true } );

end;
--------------------------------------------------------------------------------------------
function public.clk_openegg()

  cmn.Lock(1);
  cmn.CallEventHandler( "clk_openegg_beg", "inv_complex_giftegg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_openegg" );
    cmn.CallEventHandler( "clk_openegg_end", "inv_complex_giftegg" );

    cmn.Lock(0);

  end;
  
  cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_giftegg/audio/aud_clk_egg1");

  ObjAnimate( "spr_complex_giftegg_foiled_egg", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1, 
    0.5, 0, 0
  } );
  
  ObjAnimate( "spr_complex_giftegg_foil", "alp", 0, 0, "", 
  { 
    0.0, 0, 0, 
    0.5, 0, 1
  } );
  
end;
--------------------------------------------------------------------------------------------
function public.clk_openegg2()

  cmn.Lock(1);
  cmn.CallEventHandler( "clk_openegg2_beg", "inv_complex_giftegg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_openegg2" );
    cmn.CallEventHandler( "clk_openegg2_end", "inv_complex_giftegg" );

    cmn.Lock(0);

  end;
  
  cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_giftegg/audio/aud_opn_plastic");

  ObjAnimate( "spr_complex_giftegg_heartamulet_bl_2", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1, 
    0.5, 0, 0
  } );
  
end;
--------------------------------------------------------------------------------------------
function public.clk_eategg( num )

  cmn.Lock(1);
  cmn.CallEventHandler( "clk_eategg"..num.."_beg", "inv_complex_giftegg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_eategg" ..num);
    cmn.CallEventHandler( "clk_eategg"..num.."_end", "inv_complex_giftegg" );

    cmn.Lock(0);

  end;
  
  cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_giftegg/audio/aud_clk_egg2");
  
  ObjAnimate( "obj_complex_giftegg_egg_"..(num+1), "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1  } );
  ObjAnimate( "obj_complex_giftegg_egg_"..num, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0  } );
  
end;
--------------------------------------------------------------------------------------------
function public.clk_sheetsundone()

  cmn.Lock(1);
  
  local func_after = function ()

    cmn.SetEventDone( "clk_sheetsundone");
    cmn.CallEventHandler( "clk_sheetsundone", "inv_complex_pileofsheets" );

    cmn.Lock(0);

  end;
  
  if not cmn.IsEventDone( "get_spiderleg1" ) then
    
    cmn.SetEventDone( "get_spiderleg1" );
    cmn.CallEventHandler( "get_spiderleg1", "inv_complex_pileofsheets" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;
  
  ObjAnimate("spr_complex_pileofsheets_sheets_1", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate("obj_complex_pileofsheets_sheets_out", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function public.clk_makelongrope( num )

  cmn.Lock(1);
  cmn.CallEventHandler( "clk_makelongrope"..num.."_beg", "inv_complex_pileofsheets" );
  
  if not cmn.IsEventDone( "get_spiderleg1" ) then
    
    cmn.SetEventDone( "get_spiderleg1" );
    cmn.CallEventHandler( "get_spiderleg1", "inv_complex_pileofsheets" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;

  local func_after = function ()

    cmn.SetEventDone( "clk_makelongrope" ..num);
    cmn.CallEventHandler( "clk_makelongrope"..num.."_end", "inv_complex_pileofsheets" );

    cmn.Lock(0);

  end;
  
  cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_pileofsheets/audio/aud_xx_clk_node");

  ObjAnimate( "obj_complex_pileofsheets_nod_"..num, "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1  } );
  
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.touch_planks()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_complex_bridgebase_use_nails" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_bridgebase/audio/aud_xx_wood_mid2");
  
  ObjSet("anm_complex_bridgebase_planks_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_nails()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_complex_bridgebase_use_gnomeshammer" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_bridgebase/audio/aud_xx_wood_mid2");
  
  ObjSet("anm_complex_bridgebase_nails_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_spider()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_complex_brokenspider_use_spiderleg" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_clk_box4");
  
  ObjSet("anm_complex_brokenspider_spider_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_sheets()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_complex_pileofsheets_use_graplinghook" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_purse/audio/aud_xx_clk_cloth");
  
  ObjSet("anm_complex_pileofsheets_sheets_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_notebook()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_complex_notebook_use_mermaidmedallion" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_notebook/audio/aud_xx_book");
  
  ObjSet("anm_complex_notebook_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
