-- name=level2

function public.Start ( param )

  game.play_hint_aud = false;
  ng_global.new_hint = true;

  interface.WidgetAdd( InterfaceWidget_Pause, 1800 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 10 );
  interface.WidgetAdd( InterfaceWidget_BtnGuide, 6 );

  interface.WidgetAdd( InterfaceWidget_BtnHint, 4  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 5 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 6 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 7 );

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 0 );

  interface.WidgetAdd( InterfaceWidget_TaskHeader, 1 );
  interface.WidgetAdd( InterfaceWidget_Inventory, 2 );
  --interface.WidgetAdd( InterfaceWidget_TaskPanel );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 3, "assets/interface/int_taskpanel");

  interface.WidgetAdd( InterfaceWidget_Effects, 50 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 4 );

  interface.WidgetAdd( InterfaceWidget_DialogHo, 260 );

  interface.ButtonLockAdd();

  interface.WidgetAdd( InterfaceWidget_ItemPanel, 3, "assets/interface/int_itempanel" );
  interface.WidgetAdd( InterfaceWidget_Popup, 250 );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog );

  interface.WidgetAdd( InterfaceWidget_DialogVideo, 300 );
  --interface.WidgetAdd( InterfaceWidget_DialogStory );
  --interface.WidgetAdd( InterfaceWidget_DialogCharacter, 900 );

  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial, 310 );

  interface.WidgetAdd( InterfaceWidget_Map, 200 );

  interface.PanelNotificationAdd();
  interface.ComplexInvAdd();
  interface_impl.DialogHintAdd();
  
  interface_impl.GlobalTaskAdd();
  
  ------------------------------------------------------
  if IsCollectorsEdition() or IsSurveyEdition() then
  
    ModLoad( "assets/levels/menu/rm_achievements/mod_achievements" );
    rm_achievements.Init();
  
    ModLoad( "assets/levels/menu/rm_collectable/mod_collectable" );
    rm_collectable.Init();

    interface_impl.AchievAdd();
    interface_impl.PopupAchievementAdd();

    interface_impl.BonusAdd();
  
  end;
  ------------------------------------------------------
  if IsCollectorsEdition() then
  
    interface.WidgetAdd( InterfaceWidget_StrategyGuide );
  
  end;
  ------------------------------------------------------
  
  --переменная для того, чтобы из титров не выкидывало в меню
  public.in_progress = true;
  --
  private.Init();
  --
  int_map_impl.CreateRooms( "level2" );

  ModLoad( "assets/levels/level2/mod_inventory2" );
  inventory2.Init();
  
  --ModLoad( "assets/levels/menu/rm_endroom/mod_endroom" );
  --rm_endroom.Init();
  
  ModLoad( "assets/levels/menu/rm_credits/mod_credits" );
  rm_credits.Init();

  common.LevelLoad( "level2", "std", "ho_incarriage", param );
  ng_global.progress[ "std" ].common.gamestart = true;
  
  common_impl.PlayBackgroundMusic();

  common_impl.DialogCustomUpdate();
  interface_impl.RemoveFlowersTotal();
  cmn.RemoveCollectable();

  game.play_hint_aud = true;

  common_impl.is_in_map = 0;

  int_button_hint_impl.SetNewVid();
  int_button_skip_impl.SetNewVid();

end;
    
function private.Init ()

  game.room_names =
  {
     "rm_forestthicket"
    ,"rm_atshore"
    ,"rm_foresthouse"
    ,"rm_nearhospital"
    ,"rm_corridor"
    ,"rm_clothesroom"
    ,"rm_mermaidsward"
    ,"ho_incarriage"
    ,"ho_hospitalroom"
    ,"ho_medical"
    ,"mg_onmagicstone"
    ,"mg_invendingmachine"
    ,"mg_onposter"
  };
  
  --имена диалогов с подбором предмета (для удаления gfx в кастом моде)
  game.dlg_witems_names =
  {
    "obj_atshore_dialog_veronica1",
    "obj_atshore_dialog_veronica3",
    "obj_mermaidsward_dialog_mermaid"
  };
  
   --таблица с координатами открытия зз
  game.zz_end_pos = {

    [ "zz_path" ] = {340, 330},
    [ "zz_stoneoftales" ] = {600, 360},
    [ "zz_poinrter" ] = {440, 340},
    [ "zz_fencegates" ] = {560, 360},
    
    [ "zz_woodenidol" ] = {650, 340},
    [ "zz_chest" ] = {390, 350},
    [ "zz_homedoor" ] = {590, 330},
    
    [ "zz_shore" ] = {300, 320},
    [ "zz_shipwreck" ] = {600, 360},
    
    [ "zz_motorcycle" ] = {390, 350},
    [ "zz_vendingmachine" ] = {590, 350},
    [ "zz_hospitalwindow" ] = {600, 360},
    
    [ "zz_liftpanel" ] = {300, 320},
    [ "zz_nurse" ] = {520, 340},
    [ "zz_warddoor" ] = {670, 320},
    [ "zz_clothesroomdoor" ] = {620, 330},
    [ "zz_medicalcart" ] = {580, 370},
    
    [ "zz_maidsclothes" ] = {512, 360},
    [ "zz_cabinet" ] = {340, 330},
    [ "zz_cabinetwithdrawers" ] = {600, 320},
    
    [ "zz_ecoposter" ] = {520, 320},
    [ "zz_wardwindow" ] = {340, 320},
    [ "zz_chestofdrawers" ] = {600, 360}
    
  };

-- 1 - открыта
-- 2 - таски выполнены
-- 3 - кол-во тасков
-- 4 блокирована
  game.map_rooms = {
  
    [ "rm_forestthicket" ] =           { 1, 0, 4, 0, 2 },
    [ "rm_atshore" ] =                 { 0, 0, 1, 0, 2 },
    [ "rm_foresthouse" ]   =           { 0, 0, 99, 0, 2 },
    [ "rm_nearhospital" ] =            { 0, 0, 3, 0, 2 },
    [ "rm_corridor" ] =                { 0, 0, 3, 0, 3 },
    [ "rm_clothesroom" ] =             { 0, 0, 3, 0, 3 },
    [ "rm_mermaidsward" ] =            { 0, 0, 1, 0, 3 }
    
  };

  --таблицы для динамического хинта
  --таблица для юзов на предметы, получаемые в хо и мультиюзов
  game.progress_multyuse =
  {
    
    {"use_pileofsheets", "win_hospitalroom"},
    {"use_room13key", "win_medical"},
    {"use_bell1", "beg_level2"},
    {"use_gnomeshammerpath1", "beg_level2"},
    {"use_gnomeshammerpath2", "beg_level2"},
    {"use_gnomeshammerbridge", "beg_level2"},
    {"use_lvl2sleepingpills", "beg_level2"},
    {"use_lvl2crystalshoe", "beg_level2"},
    {"use_screwdrivercart", "get_screwdriver"},
    {"use_screwdrivercloset", "get_screwdriver"},
    
    {"use_lvl2hoclock", "beg_level2"},
    {"use_lvl2hoscales", "beg_level2"},
    {"use_lvl2hosnowflake", "beg_level2"},
    {"use_lvl2hohammer", "beg_level2"},
    {"use_lvl2hogear", "beg_level2"},
    {"use_lvl2howeight", "beg_level2"},
    {"use_lvl2horune", "beg_level2"},
    {"use_lvl2hopickaxe", "beg_level2"}
    
  };

  --таблица на мультипредметы с количеством их частей
  game.progress_multyobj =
  {
    {"use_magicpage", 6},
    {"use_spiderleg", 3},
    {"use_shiningstone", 3},
    {"use_bridgeplanks", 3}
  };

  --таблица на юзы, разблокирующиеся другими юзами или кликами
  game.progress_blockeduse =
  {
    {"use_gnomeshammerbridge", "use_nails"},
    {"use_nails", "use_bridgeplanks"},
    {"use_graplinghook", "clk_makelongrope4"},
    {"use_lvl2crystalshoe", "use_selfmadebridgre"},
    {"opn_corridorkey", "get_emergencykey"},
    {"use_emergencykey", "opn_corridorkey"},
    {"use_screw", "use_cartwheel"},
    {"use_screwdrivercart", "use_screw"},
    {"clk_cartrollsaway", "use_screwdrivercart"},
    {"use_mermaidfigurine", "clk_openbag"},
    {"use_crabamulet", "clk_opencabinet"},
    {"use_nuts", "use_windowhandle"},
    {"use_gnomeshammerpath2", "get_wolffaceemblem"}
  };

  game.progress_names =
  {
    "beg_level2"
    ,"use_lvl2hoclock"
    ,"use_lvl2hoscales"
    ,"use_lvl2hosnowflake"
    ,"use_lvl2hohammer"
    ,"use_lvl2hogear"
    ,"use_lvl2howeight"
    ,"use_lvl2horune"
    ,"use_lvl2hopickaxe"
    ,"win_incarriage"
    ,"opn_forestthicket"
    ,"get_cloth"
    ,"get_shiningstone1"
    ,"get_rustyblade"
    ,"get_scull"
    ,"use_scull"
    ,"get_acid"
    ,"use_acid"
    ,"use_cloth"
    ,"get_blade"
    ,"use_blade"
    
    ,"opn_atshore"
    ,"get_shiningstone2"
    ,"opn_shipwreck"
    ,"get_file"
    ,"use_file"
    ,"get_wolffaceemblem"
    ,"use_wolffaceemblem"
    ,"win_fencegates"
    
    ,"opn_foresthouse"
    ,"get_shiningstone3"
    ,"use_shiningstone"
    ,"win_onmagicstone"
    ,"get_bell2"
    ,"get_crowfigurine"
    ,"use_crowfigurine"
    ,"get_staff"
    ,"use_staff"
    ,"get_bell3"
    ,"get_nails"
    ,"get_graplinghook"
    ,"use_bell1"
    ,"use_bell2"
    ,"use_bell3"
    ,"win_chest"
    ,"get_spade"
    ,"get_enchantedflute"
    ,"use_spade"
    ,"get_bridgebase"
    ,"use_gnomeshammerpath1"
    ,"get_bridgeplanks1"
    ,"get_bridgeplanks2"
    ,"use_gnomeshammerpath2"
    ,"get_bridgeplanks3"
    ,"use_bridgeplanks"
    ,"use_nails"
    ,"use_gnomeshammerbridge"
    ,"get_selfmadebridgre"
    ,"use_selfmadebridgre"
    ,"use_lvl2crystalshoe"
    ,"get_magicpage1"
    
    ,"opn_nearhospital"
    ,"clk_nearhospitalfirst"
    ,"get_scarf"
    ,"get_brokenspider"
    ,"opn_motorcycle"
    ,"get_bulb"
    ,"use_scarf"
    ,"win_hospitalroom"
    ,"get_spiderleg1"
    ,"clk_sheetsundone"
    ,"clk_makelongrope1"
    ,"clk_makelongrope2"
    ,"clk_makelongrope3"
    ,"clk_makelongrope4"
    ,"use_graplinghook"
    ,"get_hookwithrope"
    ,"use_hookwithrope"
    
    ,"opn_corridor"
    ,"opn_nurse"
    ,"use_lvl2sleepingpills"
    ,"get_accesscard"
    ,"get_brainamulet"
    ,"use_brainamulet"
    ,"get_switch"
    ,"get_number1"
    ,"get_spiderleg2"
    ,"use_accesscard"
    ,"win_clothesroomdoor"
    
    ,"opn_clothesroom"
    ,"get_dollar1"
    ,"get_horseshoe"
    ,"use_horseshoe"
    ,"get_dollar2"
    ,"use_dollar1"
    ,"use_dollar2"
    ,"win_invendingmachine"
    ,"get_giftegg"
    ,"clk_openegg"
    ,"clk_eategg1"
    ,"clk_eategg2"
    ,"clk_eategg3"
    ,"clk_openegg2"
    ,"get_heartamulet"
    ,"get_magicpage2"
    ,"use_heartamulet"
    ,"get_spiderleg3"
    ,"use_spiderleg"
    ,"clk_installlegs1"
    ,"clk_installlegs2"
    ,"clk_installlegs3"
    ,"get_spider"
    ,"use_spider"
    ,"get_screwdriver"
    ,"get_token"
    ,"use_screwdrivercloset"
    ,"get_cartwheel"
    ,"get_screw"
    ,"use_cartwheel"
    ,"use_screw"
    ,"use_screwdrivercart"
    ,"clk_cartrollsaway"
    ,"get_number3"
    ,"get_bluecable"
    ,"use_number1"
    ,"use_number3"
    ,"clk_opencabinet"
    ,"clk_openbag"
    ,"get_notebook"
    ,"get_redwire"
    ,"use_switch"
    ,"use_redwire"
    ,"use_bluecable"
    ,"use_bulb"
    ,"win_medical"
    ,"use_room13key"
    
    ,"opn_mermaidsward"
    ,"clk_mermaidswardfirst"
    ,"get_mermaidmedallion"
    ,"use_mermaidmedallion"
    ,"get_magicpage3"
    ,"get_pendandwithsucker"
    ,"use_pendandwithsucker"
    ,"get_mermaidfigurine"
    ,"use_mermaidfigurine"
    ,"get_sharphairpin"
    ,"get_seashell"
    ,"use_sharphairpin"
    ,"get_emergencykey"
    
    ,"opn_corridorkey"
    ,"get_puzzlepiece1"
    ,"use_emergencykey"
    ,"win_liftpanel"
    ,"get_bulldogkey"
    ,"use_bulldogkey"
    ,"get_magicpage4"
    ,"get_knife"
    ,"get_puzzlepiece2"
    ,"opn_wardwindow"
    ,"use_knife"
    ,"get_cosmeticsbag"
    ,"get_cutters"
    ,"clk_unzip"
    ,"get_powder"
    ,"get_crabamulet"
    ,"use_crabamulet"
    ,"get_puzzlepiece3"
    ,"get_powderbrush"
    ,"use_powder"
    ,"use_powderbrush"
    ,"win_medicalcart"
    ,"get_magicpage5"
    ,"get_windowhandle"
    ,"use_cutters"
    ,"get_crumpledpackage"
    ,"clk_unfold"
    ,"clk_pournuts"
    ,"get_nuts"
    ,"use_windowhandle"
    ,"use_nuts"
    ,"win_wardwindow"
    ,"get_puzzlepiece4"
    ,"use_puzzlepiece1"
    ,"use_puzzlepiece2"
    ,"use_puzzlepiece3"
    ,"use_puzzlepiece4"
    ,"opn_onposter"
    ,"win_onposter"
    ,"get_magicpage6"
    ,"get_bearfigurine"
    ,"get_stetoscope"
    ,"use_magicpage"
    
    ,"opn_atshoremagicpage"
    ,"get_bellknot"
    ,"use_bellknot"
    ,"opn_house"
    
    ,"tutor_21"
    ,"tutor_22"
    ,"tutor_23"
  
  };
  
  game.relations = {};

end;

function Test ()
    
  local profiles = GetProfileList();

  local cheater = false;

  for i = 1, #profiles, 1 do

    if ( profiles[ i ] == "CHEATER" ) then

      cheater = true;

    end;

  end;

  AddProfile( "CHEATER" );
  SetCurrentProfile( "CHEATER" );

  if ( not cheater ) then

    ng_global.gamemode = 0;
    ng_global.currentprogress = "std";
    ng_global.progress = {};
    ng_global.progress[ "std" ] = {};
    ng_global.progress[ "std" ].common = {};
    ng_global.progress[ "std" ].common.hinttimer = 0;

    SaveProfiles();

  end;

end;
