-- name=rm_clothesroom
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_clothesroom";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  --------------------------------------------------------------------------------------------
  -- function get_sharphairpin () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_sharphairpin" ] = {
      type = "get",
      get_obj = "spr_cabinet_sharphairpin",
      room = private.room_objname,
      zz = "zz_cabinet",
      zz_gate = "gzz_clothesroom_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local get_sharphairpin_inv = function ()
  
    interface.InventoryItemAdd( "inv_sharphairpin", "spr_cabinet_sharphairpin" );
  
  end;
  local get_sharphairpin_end = function ()
  
    ObjDelete( "gfx_cabinet_sharphairpin" );
    ObjDelete( "spr_cabinet_sharphairpin_sh" );
    
    ObjDelete( "spr_clothesroom_cabinet_hairpin" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_sharphairpin", get_sharphairpin_inv );
  cmn.AddSubscriber( "get_sharphairpin", get_sharphairpin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_powderbrush () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_powderbrush" ] = {
      type = "get",
      get_obj = "spr_cabinet_powderbrush",
      room = private.room_objname,
      zz = "zz_cabinet",
      zz_gate = "gzz_clothesroom_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local get_powderbrush_inv = function ()
  
    interface.InventoryItemAdd( "inv_powderbrush", "spr_cabinet_powderbrush" );
    int_map_impl.DecreaseRoomTasks("rm_clothesroom");
  
  end;
  local get_powderbrush_end = function ()
  
    ObjDelete( "gfx_cabinet_powderbrush" );
    ObjDelete( "spr_cabinet_powderbrush_sh" );
    
    ObjDelete( "spr_clothesroom_cabinet_brush" );
    
    if cmn.IsEventDone("get_puzzlepiece3") then
      ObjSet("gzz_clothesroom_cabinet",  { alp = 0, active = 0 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_powderbrush", get_powderbrush_inv );
  cmn.AddSubscriber( "get_powderbrush", get_powderbrush_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_notebook () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_notebook" ] = {
      type = "get",
      get_obj = "spr_cabinet_notebook",
      room = private.room_objname,
      zz = "zz_cabinet",
      zz_gate = "gzz_clothesroom_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local get_notebook_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_notebook", "spr_cabinet_notebook" );
  
  end;
  local get_notebook_end = function ()
  
    ObjDelete( "gfx_cabinet_notebook" );
    ObjDelete( "spr_cabinet_notebook_sh" );
    
    ObjDelete( "spr_clothesroom_cabinet_notebook" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_notebook", get_notebook_inv );
  cmn.AddSubscriber( "get_notebook", get_notebook_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_redwire () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_redwire" ] = {
      type = "get",
      get_obj = "spr_cabinet_redwire",
      room = private.room_objname,
      zz = "zz_cabinet",
      zz_gate = "gzz_clothesroom_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local get_redwire_inv = function ()
  
    interface.InventoryItemAdd( "inv_redwire", "spr_cabinet_redwire" );
  
  end;
  local get_redwire_end = function ()
  
    ObjDelete( "gfx_cabinet_redwire" );
    ObjDelete( "spr_cabinet_redwire_sh" );
    
    ObjDelete( "spr_clothesroom_cabinet_wire" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_redwire", get_redwire_inv );
  cmn.AddSubscriber( "get_redwire", get_redwire_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_seashell () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_seashell" ] = {
      type = "get",
      get_obj = "spr_cabinet_seashell",
      room = private.room_objname,
      zz = "zz_cabinet",
      zz_gate = "gzz_clothesroom_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local get_seashell_inv = function ()
  
    interface.InventoryItemAdd( "inv_seashell", "spr_cabinet_seashell" );
  
  end;
  local get_seashell_end = function ()
  
    ObjDelete( "gfx_cabinet_seashell" );
    ObjDelete( "spr_cabinet_seashell_sh" );
    
    ObjDelete( "spr_clothesroom_cabinet_seashell" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_seashell", get_seashell_inv );
  cmn.AddSubscriber( "get_seashell", get_seashell_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_puzzlepiece3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_puzzlepiece3" ] = {
      type = "get",
      get_obj = "spr_cabinet_puzzlepiece3",
      room = private.room_objname,
      zz = "zz_cabinet",
      zz_gate = "gzz_clothesroom_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local get_puzzlepiece3_inv = function ()
  
    interface.InventoryItemAdd( "inv_puzzlepiece3", "spr_cabinet_puzzlepiece3" );
    int_map_impl.DecreaseRoomTasks("rm_clothesroom");
  
  end;
  local get_puzzlepiece3_end = function ()
  
    ObjDelete( "gfx_cabinet_puzzlepiece3" );
    ObjDelete( "spr_cabinet_puzzlepiece3_sh" );
    
    ObjDelete( "spr_clothesroom_cabinet_puzzle" );
    
    if cmn.IsEventDone("get_powderbrush") then
      ObjSet("gzz_clothesroom_cabinet",  { alp = 0, active = 0 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_puzzlepiece3", get_puzzlepiece3_inv );
  cmn.AddSubscriber( "get_puzzlepiece3", get_puzzlepiece3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_horseshoe () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_horseshoe" ] = {
      type = "get",
      get_obj = "spr_cabinetwithdrawers_horseshoe",
      room = private.room_objname,
      zz = "zz_cabinetwithdrawers",
      zz_gate = "gzz_clothesroom_cabinetwithdrawers"
  };
  --------------------------------------------------------------------------------------------
  local get_horseshoe_inv = function ()
  
    interface.InventoryItemAdd( "inv_horseshoe", "spr_cabinetwithdrawers_horseshoe" );
  
  end;
  local get_horseshoe_end = function ()
  
    ObjDelete( "gfx_cabinetwithdrawers_horseshoe" );
    ObjDelete( "spr_cabinetwithdrawers_horseshoe_sh" );
    
    ObjDelete( "spr_clothesroom_drawers_horseshoe" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_horseshoe", get_horseshoe_inv );
  cmn.AddSubscriber( "get_horseshoe", get_horseshoe_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_emergencykey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_emergencykey" ] = {
      type = "get",
      get_obj = "spr_maidsclothes_emergencykey",
      room = private.room_objname,
      zz = "zz_maidsclothes",
      zz_gate = "gzz_clothesroom_maidsclothes"
  };
  --------------------------------------------------------------------------------------------
  local get_emergencykey_inv = function ()
  
    interface.InventoryItemAdd( "inv_emergencykey", "spr_maidsclothes_emergencykey" );
  
  end;
  local get_emergencykey_end = function ()
  
    ObjDelete( "gfx_maidsclothes_emergencykey" );
    ObjDelete( "spr_maidsclothes_emergencykey_sh" );
    
    ObjDelete( "spr_clothesroom_maid_key" );
    
    if cmn.IsEventDone("get_puzzlepiece1") then
      ObjDelete( "gzz_clothesroom_maidsclothes" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_emergencykey", get_emergencykey_inv );
  cmn.AddSubscriber( "get_emergencykey", get_emergencykey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_dollar1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_dollar1" ] = {
      type = "get",
      get_obj = "spr_maidsclothes_dollar1",
      room = private.room_objname,
      zz = "zz_maidsclothes",
      zz_gate = "gzz_clothesroom_maidsclothes"
  };
  --------------------------------------------------------------------------------------------
  local get_dollar1_inv = function ()
  
    interface.InventoryItemAdd( "inv_dollar1", "spr_maidsclothes_dollar1" );
  
  end;
  local get_dollar1_end = function ()
  
    ObjDelete( "gfx_maidsclothes_dollar1" );
    ObjDelete( "spr_maidsclothes_dollar1_sh" );
    ObjDelete( "spr_maidsclothes_dollar1_sh_2" );
    
    ObjDelete( "spr_clothesroom_maid_dollar" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_dollar1", get_dollar1_inv );
  cmn.AddSubscriber( "get_dollar1", get_dollar1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cartwheel () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_cartwheel" ] = {
      type = "get",
      get_obj = "spr_maidsclothes_cartwheel",
      room = private.room_objname,
      zz = "zz_maidsclothes",
      zz_gate = "gzz_clothesroom_maidsclothes"
  };
  --------------------------------------------------------------------------------------------
  local get_cartwheel_inv = function ()
  
    interface.InventoryItemAdd( "inv_cartwheel", "spr_maidsclothes_cartwheel" );
  
  end;
  local get_cartwheel_end = function ()
  
    ObjDelete( "gfx_maidsclothes_cartwheel" );

    ObjDelete( "spr_maidsclothes_wheel_sh_3" );
    
    ObjDelete( "spr_clothesroom_maid_wheel" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_cartwheel", get_cartwheel_inv );
  cmn.AddSubscriber( "get_cartwheel", get_cartwheel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_screw () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_screw" ] = {
      type = "get",
      get_obj = "spr_maidsclothes_screw",
      room = private.room_objname,
      zz = "zz_maidsclothes",
      zz_gate = "gzz_clothesroom_maidsclothes"
  };
  --------------------------------------------------------------------------------------------
  local get_screw_inv = function ()
  
    interface.InventoryItemAdd( "inv_screw", "spr_maidsclothes_screw" );
  
  end;
  local get_screw_end = function ()
  
    ObjDelete( "gfx_maidsclothes_screw" );
    ObjDelete( "spr_clothesroom_maid_screw" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_screw", get_screw_inv );
  cmn.AddSubscriber( "get_screw", get_screw_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_puzzlepiece1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_puzzlepiece1" ] = {
      type = "get",
      get_obj = "spr_maidsclothes_puzzlepiece1",
      room = private.room_objname,
      zz = "zz_maidsclothes",
      zz_gate = "gzz_clothesroom_maidsclothes"
  };
  --------------------------------------------------------------------------------------------
  local get_puzzlepiece1_inv = function ()
  
    interface.InventoryItemAdd( "inv_puzzlepiece1", "spr_maidsclothes_puzzlepiece1" );
    int_map_impl.DecreaseRoomTasks("rm_clothesroom");
  
  end;
  local get_puzzlepiece1_end = function ()
  
    ObjDelete( "gfx_maidsclothes_puzzlepiece1" );
    ObjDelete( "spr_maidsclothes_puzzlepiece1_sh" );
    
    ObjDelete( "spr_clothesroom_maid_puzzle" );
    
    if cmn.IsEventDone("get_emergencykey") then
      ObjDelete( "gzz_clothesroom_maidsclothes" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_puzzlepiece1", get_puzzlepiece1_inv );
  cmn.AddSubscriber( "get_puzzlepiece1", get_puzzlepiece1_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_number1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_number1" ] = {
      type = "use",
      inv_obj = "inv_number1",
      use_place = "obj_cabinet_use_number1",
      room = private.room_objname,
      zz = "zz_cabinet",
      zz_gate = "gzz_clothesroom_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local use_number1_inv = function ()
  
    interface.InventoryItemRemove( "inv_number1" );
  
  end;
  local use_number1_beg = function ()
  
    if cmn.IsEventDone("use_number3") then
      ObjDelete( "obj_cabinet_use_number1" );
    end;
  
  end;
  local use_number1_end = function ()
    
    ObjMultiSet( { {"spr_cabinet_number_1", { alp = 1 }},
                   {"spr_clothesroom_cabinet_number1", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_number3") then
      ObjSet( "obj_cabinet_clk_opencabinet", { input = 1, alp = 1 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_number1", use_number1_beg, private.room_objname );
  cmn.AddSubscriber( "use_number1", use_number1_inv );
  cmn.AddSubscriber( "use_number1", use_number1_end, private.room_objname );
  cmn.AddSubscriber( "use_number1_inv", use_number1_inv, private.room_objname );
  cmn.AddSubscriber( "use_number1_beg", use_number1_beg, private.room_objname );
  cmn.AddSubscriber( "use_number1_end", use_number1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_number3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_number3" ] = {
      type = "use",
      inv_obj = "inv_number3",
      use_place = "obj_cabinet_use_number3",
      room = private.room_objname,
      zz = "zz_cabinet",
      zz_gate = "gzz_clothesroom_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local use_number3_inv = function ()
  
    interface.InventoryItemRemove( "inv_number3" );
  
  end;
  local use_number3_beg = function ()
  
    ObjDelete( "obj_cabinet_use_number3" );
    if cmn.IsEventDone("use_number1") then
      ObjDelete( "obj_cabinet_use_number1" );
    end;
  
  end;
  local use_number3_end = function ()
    
    ObjMultiSet( { {"spr_cabinet_number_3", { alp = 1 }},
                   {"spr_clothesroom_cabinet_number3", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_number1") then
      ObjSet( "obj_cabinet_clk_opencabinet", { input = 1, alp = 1 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_number3", use_number3_beg, private.room_objname );
  cmn.AddSubscriber( "use_number3", use_number3_inv );
  cmn.AddSubscriber( "use_number3", use_number3_end, private.room_objname );
  cmn.AddSubscriber( "use_number3_inv", use_number3_inv, private.room_objname );
  cmn.AddSubscriber( "use_number3_beg", use_number3_beg, private.room_objname );
  cmn.AddSubscriber( "use_number3_end", use_number3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mermaidfigurine () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_mermaidfigurine" ] = {
      type = "use",
      inv_obj = "inv_mermaidfigurine",
      use_place = "obj_cabinet_use_mermaidfigurine",
      room = private.room_objname,
      zz = "zz_cabinet",
      zz_gate = "gzz_clothesroom_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local use_mermaidfigurine_inv = function ()
  
    interface.InventoryItemRemove( "inv_mermaidfigurine" );
  
  end;
  local use_mermaidfigurine_beg = function ()
  
    ObjDelete( "obj_cabinet_use_mermaidfigurine" );
    ObjDelete( "anm_cabinet_box_touch" );
    ObjSet("obj_cabinet_box_mermaid",  { alp = 1 });
  
  end;
  local use_mermaidfigurine_end = function ()
  
    ObjMultiSet( { {"obj_cabinet_box_mermaid_open",  { alp = 1, input = 1 }},
                   {"spr_clothesroom_cabinet_box_open", { alp = 1 }} } );
    
    ObjDelete( "spr_cabinet_box_mermaid_closed" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mermaidfigurine", use_mermaidfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_mermaidfigurine", use_mermaidfigurine_inv );
  cmn.AddSubscriber( "use_mermaidfigurine", use_mermaidfigurine_end, private.room_objname );
  cmn.AddSubscriber( "use_mermaidfigurine_inv", use_mermaidfigurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_mermaidfigurine_beg", use_mermaidfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_mermaidfigurine_end", use_mermaidfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crabamulet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_crabamulet" ] = {
      type = "use",
      inv_obj = "inv_crabamulet",
      use_place = "obj_cabinet_use_crabamulet",
      room = private.room_objname,
      zz = "zz_cabinet",
      zz_gate = "gzz_clothesroom_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local use_crabamulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_crabamulet" );
  
  end;
  local use_crabamulet_beg = function ()
  
    ObjDelete( "obj_cabinet_use_crabamulet" );
  
  end;
  local use_crabamulet_end = function ()
  
    ObjMultiSet( { {"obj_cabinet_crab_pocket_open",  { alp = 1, input = 1 }},
                   {"spr_clothesroom_cabinet_pocket_open", { alp = 1 }} } );
                   
    ObjDelete( "anm_cabinet_bag_pocket_touch" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crabamulet", use_crabamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_crabamulet", use_crabamulet_inv );
  cmn.AddSubscriber( "use_crabamulet", use_crabamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_crabamulet_inv", use_crabamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_crabamulet_beg", use_crabamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_crabamulet_end", use_crabamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bulb () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_bulb" ] = {
      type = "use",
      inv_obj = "inv_bulb",
      use_place = "obj_cabinetwithdrawers_use_bulb",
      room = private.room_objname,
      zz = "zz_cabinetwithdrawers",
      zz_gate = "gzz_clothesroom_cabinetwithdrawers"
  };
  --------------------------------------------------------------------------------------------
  local use_bulb_inv = function ()
  
    interface.InventoryItemRemove( "inv_bulb" );
  
  end;
  local use_bulb_beg = function ()
  
    if cmn.IsEventDone("use_switch") and cmn.IsEventDone("use_bluecable") and cmn.IsEventDone("use_redwire") then
      ObjDelete( "obj_cabinetwithdrawers_use_bulb" );
    end;
  
  end;
  local use_bulb_end = function ()
    
    ObjDelete( "anm_cabinetwithdrawers_bulb" );
    
    ObjMultiSet( { {"spr_clothesroom_drawers_lamp", { alp = 1 }},
                   {"spr_cabinetwithdrawers_bulb", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_switch") and cmn.IsEventDone("use_bluecable") and cmn.IsEventDone("use_redwire") then
      ObjDelete( "gzz_clothesroom_cabinetwithdrawers" );
      ObjDelete( "spr_clothesroom_drawers_lamp" );
      ObjMultiSet( { { "gho_clothesroom_medical",  { active = 1, input = 1, alp = 1 } },
                     { "fx_clothesroom_p_lamp",  { active = 1, visible = 1 } },
                     { "spr_clothesroom_drawers_lamp_light", { alp = 1 } } } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bulb", use_bulb_beg, private.room_objname );
  cmn.AddSubscriber( "use_bulb", use_bulb_inv );
  cmn.AddSubscriber( "use_bulb", use_bulb_end, private.room_objname );
  cmn.AddSubscriber( "use_bulb_inv", use_bulb_inv, private.room_objname );
  cmn.AddSubscriber( "use_bulb_beg", use_bulb_beg, private.room_objname );
  cmn.AddSubscriber( "use_bulb_end", use_bulb_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bluecable () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_bluecable" ] = {
      type = "use",
      inv_obj = "inv_bluecable",
      use_place = "obj_cabinetwithdrawers_use_bluecable",
      room = private.room_objname,
      zz = "zz_cabinetwithdrawers",
      zz_gate = "gzz_clothesroom_cabinetwithdrawers"
  };
  --------------------------------------------------------------------------------------------
  local use_bluecable_inv = function ()
  
    interface.InventoryItemRemove( "inv_bluecable" );
  
  end;
  local use_bluecable_beg = function ()
  
    ObjDelete( "obj_cabinetwithdrawers_use_bluecable" );
    if cmn.IsEventDone("use_switch") and cmn.IsEventDone("use_bulb") and cmn.IsEventDone("use_redwire") then
      ObjDelete( "obj_cabinetwithdrawers_use_bulb" );
    end;
  
  end;
  local use_bluecable_end = function ()
    
    ObjDelete( "anm_cabinetwithdrawers_blue" );
    
    ObjMultiSet( { {"spr_clothesroom_drawers_blue", { alp = 1 }},
                   {"spr_cabinetwithdrawers_bluewire", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_switch") and cmn.IsEventDone("use_bulb") and cmn.IsEventDone("use_redwire") then
      ObjDelete( "gzz_clothesroom_cabinetwithdrawers" );
      ObjDelete( "spr_clothesroom_drawers_lamp" );
      ObjMultiSet( { { "gho_clothesroom_medical",  { active = 1, input = 1, alp = 1 } },
                     { "fx_clothesroom_p_lamp",  { active = 1, visible = 1 } },
                     { "spr_clothesroom_drawers_lamp_light", { alp = 1 } } } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bluecable", use_bluecable_beg, private.room_objname );
  cmn.AddSubscriber( "use_bluecable", use_bluecable_inv );
  cmn.AddSubscriber( "use_bluecable", use_bluecable_end, private.room_objname );
  cmn.AddSubscriber( "use_bluecable_inv", use_bluecable_inv, private.room_objname );
  cmn.AddSubscriber( "use_bluecable_beg", use_bluecable_beg, private.room_objname );
  cmn.AddSubscriber( "use_bluecable_end", use_bluecable_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_switch () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_switch" ] = {
      type = "use",
      inv_obj = "inv_switch",
      use_place = "obj_cabinetwithdrawers_use_switch",
      room = private.room_objname,
      zz = "zz_cabinetwithdrawers",
      zz_gate = "gzz_clothesroom_cabinetwithdrawers"
  };
  --------------------------------------------------------------------------------------------
  local use_switch_inv = function ()
  
    interface.InventoryItemRemove( "inv_switch" );
  
  end;
  local use_switch_beg = function ()
  
    ObjDelete( "obj_cabinetwithdrawers_use_switch" );
    if cmn.IsEventDone("use_bluecable") and cmn.IsEventDone("use_bulb") and cmn.IsEventDone("use_redwire") then
      ObjDelete( "obj_cabinetwithdrawers_use_bulb" );
    end;
  
  end;
  local use_switch_end = function ()
    
    ObjDelete( "anm_cabinetwithdrawers_switch" );
    
    ObjMultiSet( { {"spr_clothesroom_drawers_switch", { alp = 1 }},
                   {"anm_cabinetwithdrawers_lamp_on", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_bluecable") and cmn.IsEventDone("use_bulb") and cmn.IsEventDone("use_redwire") then
      ObjDelete( "gzz_clothesroom_cabinetwithdrawers" );
      ObjDelete( "spr_clothesroom_drawers_lamp" );
      ObjMultiSet( { { "gho_clothesroom_medical",  { active = 1, input = 1, alp = 1 } },
                     { "fx_clothesroom_p_lamp",  { active = 1, visible = 1 } },
                     { "spr_clothesroom_drawers_lamp_light", { alp = 1 } } } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_switch", use_switch_beg, private.room_objname );
  cmn.AddSubscriber( "use_switch", use_switch_inv );
  cmn.AddSubscriber( "use_switch", use_switch_end, private.room_objname );
  cmn.AddSubscriber( "use_switch_inv", use_switch_inv, private.room_objname );
  cmn.AddSubscriber( "use_switch_beg", use_switch_beg, private.room_objname );
  cmn.AddSubscriber( "use_switch_end", use_switch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_redwire () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_redwire" ] = {
      type = "use",
      inv_obj = "inv_redwire",
      use_place = "obj_cabinetwithdrawers_use_redwire",
      room = private.room_objname,
      zz = "zz_cabinetwithdrawers",
      zz_gate = "gzz_clothesroom_cabinetwithdrawers"
  };
  --------------------------------------------------------------------------------------------
  local use_redwire_inv = function ()
  
    interface.InventoryItemRemove( "inv_redwire" );
  
  end;
  local use_redwire_beg = function ()
  
    ObjDelete( "obj_cabinetwithdrawers_use_redwire" );
    if cmn.IsEventDone("use_bluecable") and cmn.IsEventDone("use_bulb") and cmn.IsEventDone("use_switch") then
      ObjDelete( "obj_cabinetwithdrawers_use_bulb" );
    end;
  
  end;
  local use_redwire_end = function ()
    
    ObjDelete( "anm_cabinetwithdrawers_red" );
    
    ObjMultiSet( { {"spr_clothesroom_drawers_red", { alp = 1 }},
                   {"spr_cabinetwithdrawers_redwire", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_bluecable") and cmn.IsEventDone("use_bulb") and cmn.IsEventDone("use_switch") then
      ObjDelete( "gzz_clothesroom_cabinetwithdrawers" );
      ObjDelete( "spr_clothesroom_drawers_lamp" );
      ObjMultiSet( { { "gho_clothesroom_medical",  { active = 1, input = 1, alp = 1 } },
                     { "fx_clothesroom_p_lamp",  { active = 1, visible = 1 } },
                     { "spr_clothesroom_drawers_lamp_light", { alp = 1 } } } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_redwire", use_redwire_beg, private.room_objname );
  cmn.AddSubscriber( "use_redwire", use_redwire_inv );
  cmn.AddSubscriber( "use_redwire", use_redwire_end, private.room_objname );
  cmn.AddSubscriber( "use_redwire_inv", use_redwire_inv, private.room_objname );
  cmn.AddSubscriber( "use_redwire_beg", use_redwire_beg, private.room_objname );
  cmn.AddSubscriber( "use_redwire_end", use_redwire_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sharphairpin () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_sharphairpin" ] = {
      type = "use",
      inv_obj = "inv_sharphairpin",
      use_place = "obj_maidsclothes_use_sharphairpin",
      room = private.room_objname,
      zz = "zz_maidsclothes",
      zz_gate = "gzz_clothesroom_maidsclothes"
  };
  --------------------------------------------------------------------------------------------
  local use_sharphairpin_inv = function ()
  
    interface.InventoryItemRemove( "inv_sharphairpin" );
  
  end;
  local use_sharphairpin_beg = function ()
  
    ObjDelete( "obj_maidsclothes_use_sharphairpin" );
    ObjDelete( "anm_maidsclothes_box_touch" );
  
  end;
  local use_sharphairpin_end = function ()
    
    ObjDelete( "spr_maidsclothes_trunk_box_closed" );
    
    ObjDelete( "spr_clothesroom_maid_box_closed" );
  
    ObjMultiSet( { {"obj_maidsclothes_trunk_box", { alp = 1, input = 1 }},
                   {"spr_maidsclothes_trunk_box_open", { alp = 1 }},
                   {"anm_maidsclothes_use_pin", { alp = 1, frame = 400 }},
                   {"spr_clothesroom_maid_box_open", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sharphairpin", use_sharphairpin_beg, private.room_objname );
  cmn.AddSubscriber( "use_sharphairpin", use_sharphairpin_inv );
  cmn.AddSubscriber( "use_sharphairpin", use_sharphairpin_end, private.room_objname );
  cmn.AddSubscriber( "use_sharphairpin_inv", use_sharphairpin_inv, private.room_objname );
  cmn.AddSubscriber( "use_sharphairpin_beg", use_sharphairpin_beg, private.room_objname );
  cmn.AddSubscriber( "use_sharphairpin_end", use_sharphairpin_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_opencabinet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_opencabinet" ] = {
    type = "click",
    use_place = "obj_cabinet_clk_opencabinet",
    room = private.room_objname,
    zz = "zz_cabinet",
    zz_gate = "gzz_clothesroom_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local clk_opencabinet_beg = function ()
  
    ObjDelete( "obj_cabinet_clk_opencabinet" );
    ObjMultiSet( { {"obj_cabinet_cabinet_open", { alp = 1 }},
                   {"spr_cabinet_bag", { alp = 1 }},
                   {"spr_cabinet_note_small", { alp = 1 }} } );
  
  end;
  local clk_opencabinet_end = function ()
  
    ObjDelete( "anm_cabinet_door_touch" );
    ObjDelete( "obj_clothesroom_cabinet_closed" );
    
    ObjMultiSet( { {"obj_cabinet_cabinet_open", { input = 1 }},
                   {"spr_clothesroom_cabinet_open", { alp = 1 }},
                   {"spr_cabinet_note_small", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_opencabinet", clk_opencabinet_beg, private.room_objname );
  cmn.AddSubscriber( "clk_opencabinet", clk_opencabinet_end, private.room_objname );
  cmn.AddSubscriber( "clk_opencabinet_beg", clk_opencabinet_beg, private.room_objname );
  cmn.AddSubscriber( "clk_opencabinet_end", clk_opencabinet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_openbag () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_openbag" ] = {
    type = "click",
    use_place = "obj_cabinet_clk_openbag",
    room = private.room_objname,
    zz = "zz_cabinet",
    zz_gate = "gzz_clothesroom_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local clk_openbag_beg = function ()
  
    ObjDelete( "obj_cabinet_clk_openbag" );
  
  end;
  local clk_openbag_end = function ()
  
    ObjMultiSet( { {"obj_cabinet_bag_open",  { alp = 1, input = 1 }},
                   {"obj_clothesroom_cabinet_bag_open", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_openbag", clk_openbag_beg, private.room_objname );
  cmn.AddSubscriber( "clk_openbag", clk_openbag_end, private.room_objname );
  cmn.AddSubscriber( "clk_openbag_beg", clk_openbag_beg, private.room_objname );
  cmn.AddSubscriber( "clk_openbag_end", clk_openbag_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_clothesroom () end;
  --------------------------------------------------------------------------------------------
  local opn_clothesroom = function ()
  
    int_map_impl.OpenRoom( "rm_clothesroom" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_clothesroom", opn_clothesroom );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_cabinet" );
  
  function zz_cabinet.Close()
    cmn.HideNote( 0 );
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_clothesroom();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_hospitalroom_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_hospitalroom_env");
  
  if not cmn.IsEventDone("win_medical") and ng_global.progress[ ng_global.currentprogress ][ "win_medical" ].stage[1] > 1 then
    ObjSet("spr_clothesroom_ho_box_open",  { alp = 1 });
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_number1()

  local item = "inv_number1";

  if cmn.ApplyObj( item, "gzz_clothesroom_cabinet" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cabinet" );

  elseif ( cmn.ApplyObj( item, "obj_cabinet_use_number1" ) ) then

    cmn.CallEventHandler( "use_number1_inv" );
    cmn.CallEventHandler( "use_number1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_number1" );
      cmn.CallEventHandler( "use_number1_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_xx_use_part");

    ObjAnimate("spr_cabinet_number_1", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_number3()

  local item = "inv_number3";

  if cmn.ApplyObj( item, "gzz_clothesroom_cabinet" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cabinet" );

  elseif ( cmn.ApplyObj( item, "obj_cabinet_use_number1" ) ) then

    cmn.CallEventHandler( "use_number3_inv" );
    cmn.CallEventHandler( "use_number3_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_number3" );
      cmn.CallEventHandler( "use_number3_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_xx_use_part");

    ObjAnimate("spr_cabinet_number_3", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_mermaidfigurine()

  local item = "inv_mermaidfigurine";

  if cmn.ApplyObj( item, "gzz_clothesroom_cabinet" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cabinet" );

  elseif ( cmn.ApplyObj( item, "obj_cabinet_use_mermaidfigurine" ) and cmn.IsEventDone("clk_openbag") ) then

    cmn.CallEventHandler( "use_mermaidfigurine_inv" );
    cmn.CallEventHandler( "use_mermaidfigurine_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_mermaidfigurine" );
      cmn.CallEventHandler( "use_mermaidfigurine_end" );
    
    end;
    
    local anm_open = function ()
      
      ObjAnimate("obj_cabinet_box_mermaid_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("spr_cabinet_box_mermaid_closed", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_use_star");

    ObjAnimate( "spr_cabinet_box_mermaid_fig", "alp", 0, 0, anm_open,
    {
      0.0, 0, 0, 
      0.3, 0, 1, 
      0.6, 0, 1
    } );
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_crabamulet()

  local item = "inv_crabamulet";

  if cmn.ApplyObj( item, "gzz_clothesroom_cabinet" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cabinet" );

  elseif ( cmn.ApplyObj( item, "obj_cabinet_use_crabamulet" ) and cmn.IsEventDone("clk_opencabinet") ) then

    cmn.CallEventHandler( "use_crabamulet_inv" );
    cmn.CallEventHandler( "use_crabamulet_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_crabamulet" );
      cmn.CallEventHandler( "use_crabamulet_end" );
    
    end;

    local anm_open = function ()
      
      ObjAnimate("obj_cabinet_crab_pocket_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_cabinet_bag_pocket_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_use_crab");

    ObjAnimate( "spr_cabinet_bag_pocket_crab", "alp", 0, 0, anm_open,
    {
      0.0, 0, 0, 
      0.3, 0, 1, 
      0.6, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bulb()

  local item = "inv_bulb";

  if cmn.ApplyObj( item, "gzz_clothesroom_cabinetwithdrawers" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cabinetwithdrawers" );

  elseif ( cmn.ApplyObj( item, "obj_cabinetwithdrawers_use_bulb" ) ) then

    cmn.CallEventHandler( "use_bulb_inv" );
    cmn.CallEventHandler( "use_bulb_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_bulb" );
      cmn.CallEventHandler( "use_bulb_end" );
      
      if cmn.IsEventDone("use_redwire") and cmn.IsEventDone("use_bluecable") and cmn.IsEventDone("use_switch") then
        common.CloseSubRoom();
      end;
    
    end;
    
    local anm_light = function ()
      
      ObjAnimate("spr_cabinetwithdrawers_light", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
    local anm_switch = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_on_lamp");
      ObjSet("anm_cabinetwithdrawers_lamp_on",  { alp = 1, playing = 1, endtrig = anm_light });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_use_bulb");
    
    if cmn.IsEventDone("use_redwire") and cmn.IsEventDone("use_bluecable") and cmn.IsEventDone("use_switch") then
      ObjSet("anm_cabinetwithdrawers_bulb",  { alp = 1, playing = 1, endtrig = anm_switch });
    else
      ObjSet("anm_cabinetwithdrawers_bulb",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bluecable()

  local item = "inv_bluecable";

  if cmn.ApplyObj( item, "gzz_clothesroom_cabinetwithdrawers" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cabinetwithdrawers" );

  elseif ( cmn.ApplyObj( item, "obj_cabinetwithdrawers_use_bulb" ) ) then

    cmn.CallEventHandler( "use_bluecable_inv" );
    cmn.CallEventHandler( "use_bluecable_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_bluecable" );
      cmn.CallEventHandler( "use_bluecable_end" );
      
      if cmn.IsEventDone("use_redwire") and cmn.IsEventDone("use_bulb") and cmn.IsEventDone("use_switch") then
        common.CloseSubRoom();
      end      
    
    end;

    local anm_light = function ()
      
      ObjAnimate("spr_cabinetwithdrawers_light", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
    local anm_switch = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_on_lamp");
      ObjSet("anm_cabinetwithdrawers_lamp_on",  { alp = 1, playing = 1, endtrig = anm_light });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_use_wire");
    
    if cmn.IsEventDone("use_redwire") and cmn.IsEventDone("use_bulb") and cmn.IsEventDone("use_switch") then
      ObjSet("anm_cabinetwithdrawers_blue",  { alp = 1, playing = 1, endtrig = anm_switch });
    else
      ObjSet("anm_cabinetwithdrawers_blue",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_switch()

  local item = "inv_switch";

  if cmn.ApplyObj( item, "gzz_clothesroom_cabinetwithdrawers" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cabinetwithdrawers" );

  elseif ( cmn.ApplyObj( item, "obj_cabinetwithdrawers_use_bulb" ) ) then

    cmn.CallEventHandler( "use_switch_inv" );
    cmn.CallEventHandler( "use_switch_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_switch" );
      cmn.CallEventHandler( "use_switch_end" );
      
      if cmn.IsEventDone("use_redwire") and cmn.IsEventDone("use_bulb") and cmn.IsEventDone("use_bluecable") then
        common.CloseSubRoom();
      end
    
    end;

    local anm_light = function ()
      
      ObjAnimate("spr_cabinetwithdrawers_light", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
    local anm_switch = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_on_lamp");
      ObjSet("anm_cabinetwithdrawers_lamp_on",  { alp = 1, playing = 1, endtrig = anm_light });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_xx_use_plug");
    
    if cmn.IsEventDone("use_redwire") and cmn.IsEventDone("use_bulb") and cmn.IsEventDone("use_bluecable") then
      ObjSet("anm_cabinetwithdrawers_switch",  { alp = 1, playing = 1, endtrig = anm_switch });
    else
      ObjSet("anm_cabinetwithdrawers_switch",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_redwire()

  local item = "inv_redwire";

  if cmn.ApplyObj( item, "gzz_clothesroom_cabinetwithdrawers" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cabinetwithdrawers" );

  elseif ( cmn.ApplyObj( item, "obj_cabinetwithdrawers_use_bulb" ) ) then

    cmn.CallEventHandler( "use_redwire_inv" );
    cmn.CallEventHandler( "use_redwire_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_redwire" );
      cmn.CallEventHandler( "use_redwire_end" );
      
      if cmn.IsEventDone("use_bluecable") and cmn.IsEventDone("use_bulb") and cmn.IsEventDone("use_switch") then
        common.CloseSubRoom();
      end
    
    end;

    local anm_light = function ()
      
      ObjAnimate("spr_cabinetwithdrawers_light", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
    local anm_switch = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_on_lamp");
      ObjSet("anm_cabinetwithdrawers_lamp_on",  { alp = 1, playing = 1, endtrig = anm_light });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_use_wire");
    
    if cmn.IsEventDone("use_bluecable") and cmn.IsEventDone("use_bulb") and cmn.IsEventDone("use_switch") then
      ObjSet("anm_cabinetwithdrawers_red",  { alp = 1, playing = 1, endtrig = anm_switch });
    else
      ObjSet("anm_cabinetwithdrawers_red",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_sharphairpin()

  local item = "inv_sharphairpin";

  if cmn.ApplyObj( item, "gzz_clothesroom_maidsclothes" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_maidsclothes" );

  elseif ( cmn.ApplyObj( item, "obj_maidsclothes_use_sharphairpin" ) ) then

    cmn.CallEventHandler( "use_sharphairpin_inv" );
    cmn.CallEventHandler( "use_sharphairpin_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_sharphairpin" );
      cmn.CallEventHandler( "use_sharphairpin_end" );
    
    end;
    
    local anm_open = function ()
      
      ObjSet("obj_maidsclothes_trunk_box",  { alp = 1 });
      
      ObjAnimate("spr_maidsclothes_trunk_box_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("spr_maidsclothes_trunk_box_closed", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_use_pick_key2");

    ObjSet("anm_maidsclothes_use_pin",  { alp = 1, playing = 1, endtrig = anm_open });

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_sharphairpin()

  cmn.SetEventDone( "get_sharphairpin" );
  cmn.CallEventHandler( "get_sharphairpin" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if not cmn.IsEventDone("get_seashell") then
    cmn.SetEventDone( "get_seashell" );
    cmn.CallEventHandler( "get_seashell" );
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_powderbrush()

  cmn.SetEventDone( "get_powderbrush" );
  cmn.CallEventHandler( "get_powderbrush" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_puzzlepiece3") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_notebook()

  cmn.SetEventDone( "get_notebook" );
  cmn.CallEventHandler( "get_notebook" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_redwire()

  cmn.SetEventDone( "get_redwire" );
  cmn.CallEventHandler( "get_redwire" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_seashell()

  cmn.SetEventDone( "get_seashell" );
  cmn.CallEventHandler( "get_seashell" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_puzzlepiece3()

  cmn.SetEventDone( "get_puzzlepiece3" );
  cmn.CallEventHandler( "get_puzzlepiece3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_powderbrush") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_horseshoe()

  cmn.SetEventDone( "get_horseshoe" );
  cmn.CallEventHandler( "get_horseshoe" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_emergencykey()

  cmn.SetEventDone( "get_emergencykey" );
  cmn.CallEventHandler( "get_emergencykey" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_puzzlepiece1") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_dollar1()

  cmn.SetEventDone( "get_dollar1" );
  cmn.CallEventHandler( "get_dollar1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_cartwheel()
  
  ObjSet("spr_maidsclothes_cartwheel",  { ang = 1.5821 });

  cmn.SetEventDone( "get_cartwheel" );
  cmn.CallEventHandler( "get_cartwheel" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_screw()
  
  ObjSet("spr_maidsclothes_screw",  { ang = 0.2084 });

  cmn.SetEventDone( "get_screw" );
  cmn.CallEventHandler( "get_screw" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_puzzlepiece1()

  cmn.SetEventDone( "get_puzzlepiece1" );
  cmn.CallEventHandler( "get_puzzlepiece1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_emergencykey") then
    common.CloseSubRoom();
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_opencabinet()

  cmn.CallEventHandler( "clk_opencabinet_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_opencabinet" );
    cmn.CallEventHandler( "clk_opencabinet_end" );

    cmn.Lock( 0 );
  
  end;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_opn_metal_door");

  ObjAnimate( "anm_cabinet_door_touch", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1, 
    0.5, 0, 0
  } );

end;
--------------------------------------------------------------------------------------------
function public.clk_openbag()

  cmn.CallEventHandler( "clk_openbag_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_openbag" );
    cmn.CallEventHandler( "clk_openbag_end" );

    cmn.Lock( 0 );
  
  end;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_opn_bag");

  ObjAnimate( "obj_cabinet_bag_open", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 0, 
    0.5, 0, 1
  } );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_clothesroom()

  if not ( cmn.IsEventDone( "opn_clothesroom" ) ) then
    cmn.SetEventDone( "opn_clothesroom" );
    cmn.CallEventHandler("opn_clothesroom");
    cmn.ShowBbt( "clothesroom_open" );
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_cabinet_doors()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_cabinet_use_numbers" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_xx_clk_metal_door");
  
  ObjSet("anm_cabinet_door_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  ObjAnimate("obj_cabinet_numbers", "pos_y", 0, 0, "", { 0, 0, 0,   0.3, 0, -1,     0.6, 0, 0 });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_mermaid_box()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_cabinet_use_mermaidfigurine" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_xx_clk_wood4");
  
  ObjSet("anm_cabinet_box_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_bag_pocket()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_cabinet_use_crabamulet" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_purse/audio/aud_xx_clk_cloth");
  
  ObjSet("anm_cabinet_bag_pocket_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_maid_box()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_maidsclothes_use_sharphairpin" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_xx_chain");
  
  ObjSet("anm_maidsclothes_box_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_maid_wheel()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_maidsclothes_use_screwdriver" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_xx_button_lock");
  
  ObjSet("anm_maidsclothes_wheel_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_lamp()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_cabinetwithdrawers_use_bulb" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_xx_clk_lamp");
  
  ObjSet("anm_cabinetwithdrawers_lamp_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--*********************************************************************************************************************
