-- name=rm_foresthouse
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_foresthouse";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Chest();
  --------------------------------------------------------------------------------------------
  -- function get_staff () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_staff" ] = {
      type = "get",
      get_obj = "spr_woodenidol_staff",
      room = private.room_objname,
      zz = "zz_woodenidol",
      zz_gate = "gzz_foresthouse_woodenidol"
  };
  --------------------------------------------------------------------------------------------
  local get_staff_inv = function ()
  
    interface.InventoryItemAdd( "inv_staff", "spr_woodenidol_staff" );
  
  end;
  local get_staff_end = function ()
  
    ObjDelete( "gfx_woodenidol_staff" );
    
    ObjDelete( "spr_foresthouse_idol_staff" );
    ObjDelete( "gzz_foresthouse_woodenidol" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_staff", get_staff_inv );
  cmn.AddSubscriber( "get_staff", get_staff_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_spade () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_spade" ] = {
      type = "get",
      get_obj = "spr_chest_spade",
      room = private.room_objname,
      zz = "zz_chest",
      zz_gate = "gzz_foresthouse_chest"
  };
  --------------------------------------------------------------------------------------------
  local get_spade_inv = function ()
  
    interface.InventoryItemAdd( "inv_spade", "spr_chest_spade" );
  
  end;
  local get_spade_end = function ()
  
    ObjDelete( "gfx_chest_spade" );
    
    ObjDelete( "spr_foresthouse_chest_shovel" );
    ObjDelete( "gzz_foresthouse_chest" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_spade", get_spade_inv );
  cmn.AddSubscriber( "get_spade", get_spade_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_shiningstone3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_shiningstone3" ] = {
      type = "get",
      get_obj = "spr_chest_shiningstone3",
      room = private.room_objname,
      zz = "zz_chest",
      zz_gate = "gzz_foresthouse_chest"
  };
  --------------------------------------------------------------------------------------------
  local get_shiningstone3_inv = function ()
  
    interface.InventoryItemAdd( "inv_shiningstone", "spr_chest_shiningstone3", function () cmn.GetMultyObject( 'shiningstone', 3 ); end );
  
  end;
  local get_shiningstone3_end = function ()
  
    ObjDelete( "gfx_chest_shiningstone3" );
    ObjDelete( "spr_chest_shiningstone3_sh" );
    
    ObjDelete( "spr_foresthouse_chest_stone" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_shiningstone3", get_shiningstone3_inv );
  cmn.AddSubscriber( "get_shiningstone3", get_shiningstone3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_enchantedflute () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_enchantedflute" ] = {
      type = "get",
      get_obj = "spr_chest_enchantedflute",
      room = private.room_objname,
      zz = "zz_chest",
      zz_gate = "gzz_foresthouse_chest"
  };
  --------------------------------------------------------------------------------------------
  local get_enchantedflute_inv = function ()
  
    interface.InventoryItemAdd( "inv_enchantedflute", "spr_chest_enchantedflute" );
  
  end;
  local get_enchantedflute_end = function ()
  
    ObjDelete( "gfx_chest_enchantedflute" );
    ObjDelete( "spr_chest_enchantedflute_sh" );
    
    ObjDelete( "spr_foresthouse_chest_flute" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_enchantedflute", get_enchantedflute_inv );
  cmn.AddSubscriber( "get_enchantedflute", get_enchantedflute_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_crowfigurine () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_crowfigurine" ] = {
      type = "use",
      inv_obj = "inv_crowfigurine",
      use_place = "obj_woodenidol_use_crowfigurine",
      room = private.room_objname,
      zz = "zz_woodenidol",
      zz_gate = "gzz_foresthouse_woodenidol"
  };
  --------------------------------------------------------------------------------------------
  local use_crowfigurine_inv = function ()
  
    interface.InventoryItemRemove( "inv_crowfigurine" );
  
  end;
  local use_crowfigurine_beg = function ()
  
    ObjDelete( "obj_woodenidol_use_crowfigurine" );
    
  end;
  local use_crowfigurine_end = function ()
  
    ObjMultiSet( { {"anm_woodenidol_staff_give", { input = 1, alp = 1, frame = 300 }},
                   {"spr_foresthouse_idol_crow", { alp = 1 }},
                   {"spr_foresthouse_idol_hand_2", { alp = 1 }},
                   {"spr_foresthouse_idol_staff", { pos_x = 862, pos_y = 478, ang = 0.93 }} } );
    
    ObjDelete( "obj_woodenidol_woodsman" );
    ObjDelete( "anm_woodenidol_use_crow" );
    ObjDelete( "spr_foresthouse_idol_hand_1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crowfigurine", use_crowfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_crowfigurine", use_crowfigurine_inv );
  cmn.AddSubscriber( "use_crowfigurine", use_crowfigurine_end, private.room_objname );
  cmn.AddSubscriber( "use_crowfigurine_inv", use_crowfigurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_crowfigurine_beg", use_crowfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_crowfigurine_end", use_crowfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bell2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_bell2" ] = {
      type = "use",
      inv_obj = "inv_bell2",
      use_place = "obj_chest_use_bell2",
      room = private.room_objname,
      zz = "zz_chest",
      zz_gate = "gzz_foresthouse_chest"
  };
  --------------------------------------------------------------------------------------------
  local use_bell2_inv = function ()
  
    interface.InventoryItemRemove( "inv_bell2" );
  
  end;
  local use_bell2_beg = function ()
  
    ObjDelete( "obj_chest_use_bell2" );
    if cmn.IsEventDone("use_bell3") and cmn.IsEventDone("use_bell1") then
      ObjDelete( "obj_chest_use_bell1" );
      ObjDelete( "obj_chest_chest_touch" );
    end;
  
  end;
  local use_bell2_end = function ()
    
    ObjMultiSet( { {"anm_chest_bell_4", { alp = 1 }},
                   {"spr_foresthouse_chest_bell_2", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_bell1") and cmn.IsEventDone("use_bell3") then
      ObjDelete( "anm_chest_chest" );
      ObjMultiSet( { {"obj_chest_game", { input = 1 }},
                     {"anm_chest_chest_touch", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bell2", use_bell2_beg, private.room_objname );
  cmn.AddSubscriber( "use_bell2", use_bell2_inv );
  cmn.AddSubscriber( "use_bell2", use_bell2_end, private.room_objname );
  cmn.AddSubscriber( "use_bell2_inv", use_bell2_inv, private.room_objname );
  cmn.AddSubscriber( "use_bell2_beg", use_bell2_beg, private.room_objname );
  cmn.AddSubscriber( "use_bell2_end", use_bell2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bell3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_bell3" ] = {
      type = "use",
      inv_obj = "inv_bell3",
      use_place = "obj_chest_use_bell3",
      room = private.room_objname,
      zz = "zz_chest",
      zz_gate = "gzz_foresthouse_chest"
  };
  --------------------------------------------------------------------------------------------
  local use_bell3_inv = function ()
  
    interface.InventoryItemRemove( "inv_bell3" );
  
  end;
  local use_bell3_beg = function ()
  
    ObjDelete( "obj_chest_use_bell3" );
    if cmn.IsEventDone("use_bell1") and cmn.IsEventDone("use_bell2") then
      ObjDelete( "obj_chest_use_bell1" );
      ObjDelete( "obj_chest_chest_touch" );
    end;
  
  end;
  local use_bell3_end = function ()
    
    ObjMultiSet( { {"anm_chest_bell_5", { alp = 1 }},
                   {"spr_foresthouse_chest_bell_3", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_bell1") and cmn.IsEventDone("use_bell2") then
      ObjDelete( "anm_chest_chest" );
      ObjMultiSet( { {"obj_chest_game", { input = 1 }},
                     {"anm_chest_chest_touch", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bell3", use_bell3_beg, private.room_objname );
  cmn.AddSubscriber( "use_bell3", use_bell3_inv );
  cmn.AddSubscriber( "use_bell3", use_bell3_end, private.room_objname );
  cmn.AddSubscriber( "use_bell3_inv", use_bell3_inv, private.room_objname );
  cmn.AddSubscriber( "use_bell3_beg", use_bell3_beg, private.room_objname );
  cmn.AddSubscriber( "use_bell3_end", use_bell3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bell1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_bell1" ] = {
      type = "use",
      inv_obj = "inv_bell1",
      use_place = "obj_chest_use_bell1",
      room = private.room_objname,
      zz = "zz_chest",
      zz_gate = "gzz_foresthouse_chest"
  };
  --------------------------------------------------------------------------------------------
  local use_bell1_inv = function ()
  
    interface.InventoryItemRemove( "inv_bell1" );
  
  end;
  local use_bell1_beg = function ()
  
    if cmn.IsEventDone("use_bell3") and cmn.IsEventDone("use_bell2") then
      ObjDelete( "obj_chest_use_bell1" );
      ObjDelete( "obj_chest_chest_touch" );
    end;
  
  end;
  local use_bell1_end = function ()
    
    ObjMultiSet( { {"anm_chest_bell_2", { alp = 1 }},
                   {"spr_foresthouse_chest_bell_1", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_bell3") and cmn.IsEventDone("use_bell2") then
      ObjDelete( "anm_chest_chest" );
      ObjMultiSet( { {"obj_chest_game", { input = 1 }},
                     {"anm_chest_chest_touch", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bell1", use_bell1_beg, private.room_objname );
  cmn.AddSubscriber( "use_bell1", use_bell1_inv );
  cmn.AddSubscriber( "use_bell1", use_bell1_end, private.room_objname );
  cmn.AddSubscriber( "use_bell1_inv", use_bell1_inv, private.room_objname );
  cmn.AddSubscriber( "use_bell1_beg", use_bell1_beg, private.room_objname );
  cmn.AddSubscriber( "use_bell1_end", use_bell1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bellknot () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_bellknot" ] = {
      type = "use",
      inv_obj = "inv_bellknot",
      use_place = "obj_homedoor_use_bellknot",
      room = private.room_objname,
      zz = "zz_homedoor",
      zz_gate = "gzz_foresthouse_homedoor"
  };
  --------------------------------------------------------------------------------------------
  local use_bellknot_inv = function ()
  
    interface.InventoryItemRemove( "inv_bellknot" );
  
  end;
  local use_bellknot_beg = function ()
  
    ObjDelete( "obj_homedoor_use_bellknot" );
    ObjDelete( "obj_homedoor_touch_roots" );
    ObjDelete( "anm_homedoor_bell" );
  
  end;
  local use_bellknot_end = function ()
  
    ObjMultiSet( { {"grm_foresthouse_house", { alp = 1, input = 1 }},
                   {"spr_foresthouse_bellknot", { alp = 1 }},
                   {"spr_foresthouse_door_open", { alp = 1 }} } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_foresthouse_house_focus");
    end;
    ObjDelete( "gzz_foresthouse_homedoor" );
    ObjDelete( "spr_foresthouse_door_closed" );
    ObjDelete( "spr_foresthouse_bellknot_1" );
  
  end;
  local use_bellknot_end_forestthicket = function ()

    ObjSet( "spr_forestthicket_zz_homedoor", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bellknot", use_bellknot_beg, private.room_objname );
  cmn.AddSubscriber( "use_bellknot", use_bellknot_inv );
  cmn.AddSubscriber( "use_bellknot", use_bellknot_end, private.room_objname );
  cmn.AddSubscriber( "use_bellknot", use_bellknot_end_forestthicket, "rm_forestthicket" );
  cmn.AddSubscriber( "use_bellknot_inv", use_bellknot_inv, private.room_objname );
  cmn.AddSubscriber( "use_bellknot_beg", use_bellknot_beg, private.room_objname );
  cmn.AddSubscriber( "use_bellknot_end", use_bellknot_end, private.room_objname );
  cmn.AddSubscriber( "use_bellknot_end_forestthicket", use_bellknot_end_forestthicket, "rm_forestthicket" );

  --------------------------------------------------------------------------------------------
  -- function opn_foresthouse () end;
  --------------------------------------------------------------------------------------------
  local opn_foresthouse = function ()
  
    int_map_impl.OpenRoom( "rm_foresthouse" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_foresthouse", opn_foresthouse );
  --------------------------------------------------------------------------------------------
  -- function opn_house () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "opn_house" ] = {

      type = "clk",
      use_place = "grm_foresthouse_house",
      room = private.room_objname

  };
  --------------------------------------------------------------------------------------------
  local opn_house = function ()

    ObjMultiSet( { {"obj_foresthouse_gates", { input = 0, active = 0, visible = 0 }},
                   {"rm_foresthouse", { color_r = 0, color_g = 0, color_b = 0 }} } );

  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_house", opn_house, private.room_objname );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_chest" );
  
  function zz_chest.PreOpen()
    
    if cmn.IsEventDone( "use_bell1" ) and cmn.IsEventDone( "use_bell2" ) and cmn.IsEventDone( "use_bell3" ) and not cmn.IsEventDone( "win_chest" ) then
      private.zz_chest.DrawScene();
    end;
    
  end;
  
  function zz_chest.Open()
    
    if ( cmn.IsEventDone( "use_bell1" ) and cmn.IsEventDone( "use_bell2" ) and cmn.IsEventDone( "use_bell3" ) and not(cmn.IsEventDone( "win_chest" )) ) then
      
      cmn.MiniGameShow();
      
      if private.zz_chest.state[2] == 0 and private.zz_chest.state[1] < 4 then
        private.zz_chest.PlaySequence(1, private.zz_chest.state[1]);
      else 
        private.zz_chest.CheckWin();
      end;
      
    end;
    
  end;
  
  function zz_chest.PreClose()
    
    if ( cmn.IsEventDone( "use_bell1" ) and cmn.IsEventDone( "use_bell2" ) and cmn.IsEventDone( "use_bell3" ) and not(cmn.IsEventDone( "win_chest" )) ) then
      cmn.MiniGameHide("chest");
    end;

  end;
  
  function zz_chest.Close()
    cmn.HideNote( 0 );
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_chest" ].state) then 
    private.zz_chest.StartConditions();
  end;

  private.zz_chest.state = ng_global.progress[ ng_global.currentprogress ][ "win_chest" ].state;
  private.zz_chest.state[2] = 0;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_foresthouse();
  
  if cmn.IsEventDone( "opn_house" ) then

    local func_after = function ()

      --cmn.GotoRoom( "rm_endroom" );

      cmn.LevelSwitch( "level3", 2 );
      ng_global.progress["std"].common.chapter = "level3";
      ng_global.progress[ "std" ].common.currentroom = "rm_witchhouse";

    end;

    cmn.Lock( 0 );
    cmn.StopAllEnv();

    cmn.PlayFullscreenVideo( "assets/levels/level2/rm_foresthouse/vid_inspection",
                             func_after,
                             "assets/levels/level2/rm_foresthouse/audio/aud_inspection",
                             "assets/levels/level2/rm_foresthouse/audio/aud_inspection_voc" );

  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_foresthouse_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_foresthouse_env");
  
  if not ( cmn.IsEventDone( "opn_foresthouse" ) ) then
    cmn.Lock( 1 );
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_crowfigurine()

  local item = "inv_crowfigurine";

  if cmn.ApplyObj( item, "gzz_foresthouse_woodenidol" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_woodenidol" );

  elseif ( cmn.ApplyObj( item, "obj_woodenidol_use_crowfigurine" ) ) then

    cmn.CallEventHandler( "use_crowfigurine_inv" );
    cmn.CallEventHandler( "use_crowfigurine_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_crowfigurine" );
      cmn.CallEventHandler( "use_crowfigurine_end" );
      
      cmn.ShowBbt( "foresthouse_after_flashback2" );
    
    end;
    
    local anm_give = function ()
      
      cmn.Lock( 1 );
      cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_foresthouse_env");
      
      ObjSet("anm_woodenidol_staff_give",  { alp = 1, playing = 1, endtrig = func_after });
      ObjDelete( "obj_woodenidol_woodsman" );
      ObjDelete( "anm_woodenidol_use_crow" );
      
      cmn.PlayAudio("snd", "assets/levels/level2/rm_foresthouse/audio/aud_xx_wood_low");

    end;
    
    local play_flashback = function ()
      
      cmn.Lock( 0 );
      cmn.StopAllEnv();
      
      cmn.PlayCutScene( "flashback2",
                        "assets/levels/level2/rm_foresthouse/zz_woodenidol/cs_2/anm_cs_2",
                        { 0.4, 7, 15.1 },
                        anm_give, 
                        "assets/levels/level2/rm_foresthouse/audio/aud_flashback2",
                        "assets/levels/level2/rm_foresthouse/audio/aud_flashback2_voc" );
      
    end;

    cmn.Lock( 1 );

    ObjSet("anm_woodenidol_use_crow",  { alp = 1, playing = 1, endtrig = play_flashback });

    cmn.PlayAudio("snd", "assets/levels/level2/rm_foresthouse/audio/aud_use_crow");

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bell2()

  local item = "inv_bell2";

  if cmn.ApplyObj( item, "gzz_foresthouse_chest" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_chest" );

  elseif ( cmn.ApplyObj( item, "obj_chest_use_bell1" ) ) then

    cmn.CallEventHandler( "use_bell2_inv" );
    cmn.CallEventHandler( "use_bell2_beg" );

    local func_after = function ()

      cmn.SetEventDone( "use_bell2" );
      cmn.CallEventHandler( "use_bell2_end" );
      
      if cmn.IsEventDone("use_bell1") and cmn.IsEventDone("use_bell3") then
        cmn.MiniGameShow();
        ObjSet("anm_chest_chest_touch",  { frame = 0, animfunc = "func_mmg_lvl_1" });
        private.zz_chest.PlaySequence( 1, 1, false );
      else 
        cmn.Lock( 0 );
      end;
    
    end;
    
    cmn.Lock( 1 );
    
    ObjAnimate("anm_chest_bell_4", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });

    cmn.PlayAudio("snd", "assets/levels/level2/rm_foresthouse/audio/aud_xx_use_bell");

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bell3()

  local item = "inv_bell3";

  if cmn.ApplyObj( item, "gzz_foresthouse_chest" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_chest" );

  elseif ( cmn.ApplyObj( item, "obj_chest_use_bell1" ) ) then

    cmn.CallEventHandler( "use_bell3_inv" );
    cmn.CallEventHandler( "use_bell3_beg" );

    local func_after = function ()

      cmn.SetEventDone( "use_bell3" );
      cmn.CallEventHandler( "use_bell3_end" );
      
      if cmn.IsEventDone("use_bell1") and cmn.IsEventDone("use_bell2") then
        cmn.MiniGameShow();
        ObjSet("anm_chest_chest_touch",  { frame = 0, animfunc = "func_mmg_lvl_1" });
        private.zz_chest.PlaySequence( 1, 1, false );
      else 
        cmn.Lock( 0 );
      end;
    
    end;

    cmn.Lock( 1 );

    ObjAnimate("anm_chest_bell_5", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });

    cmn.PlayAudio("snd", "assets/levels/level2/rm_foresthouse/audio/aud_xx_use_bell");

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bell1()

  local item = "inv_bell1";

  if cmn.ApplyObj( item, "gzz_foresthouse_chest" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_chest" );

  elseif ( cmn.ApplyObj( item, "obj_chest_use_bell1" ) ) then

    cmn.CallEventHandler( "use_bell1_inv" );
    cmn.CallEventHandler( "use_bell1_beg" );

    local func_after = function ()

      cmn.SetEventDone( "use_bell1" );
      cmn.CallEventHandler( "use_bell1_end" );
      
      if cmn.IsEventDone("use_bell3") and cmn.IsEventDone("use_bell2") then
        cmn.MiniGameShow();
        ObjSet("anm_chest_chest_touch",  { frame = 0, animfunc = "func_mmg_lvl_1" });
        private.zz_chest.PlaySequence( 1, 1, false );
      else 
        cmn.Lock( 0 );
      end;
    
    end;

    cmn.Lock( 1 );

    ObjAnimate("anm_chest_bell_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });

    cmn.PlayAudio("snd", "assets/levels/level2/rm_foresthouse/audio/aud_xx_use_bell");

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bellknot()

  local item = "inv_bellknot";

  if cmn.ApplyObj( item, "gzz_foresthouse_homedoor" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_homedoor" );

  elseif ( cmn.ApplyObj( item, "obj_homedoor_use_bellknot" ) ) then

    cmn.CallEventHandler( "use_bellknot_inv" );
    cmn.CallEventHandler( "use_bellknot_beg" );

    local func_after = function ()
      
      cmn.Lock( 0 );

      cmn.SetEventDone( "use_bellknot" );
      cmn.CallEventHandler( "use_bellknot_end" );
      cmn.CallEventHandler( "use_bellknot_end_forestthicket" );
      
      common.CloseSubRoom();
    
    end;
    
    local anm_branch = function ()
      
      ObjDelete("anm_homedoor_tree_touch");
      ObjSet("anm_homedoor_tree",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_foresthouse/audio/aud_use_chimes");

    ObjSet("anm_homedoor_bell_ring",  { alp = 1, playing = 1, endtrig = anm_branch });

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_staff()
  
  ObjSet("spr_woodenidol_staff",  { ang = 0.3419 });

  cmn.SetEventDone( "get_staff" );
  cmn.CallEventHandler( "get_staff" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_spade()

  cmn.SetEventDone( "get_spade" );
  cmn.CallEventHandler( "get_spade" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common.CloseSubRoom();
  
  if not cmn.IsEventDone("get_enchantedflute") then
    cmn.SetEventDone( "get_enchantedflute" );
    cmn.CallEventHandler( "get_enchantedflute" );
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_shiningstone3()

  cmn.SetEventDone( "get_shiningstone3" );
  cmn.CallEventHandler( "get_shiningstone3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_enchantedflute()

  cmn.SetEventDone( "get_enchantedflute" );
  cmn.CallEventHandler( "get_enchantedflute" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_foresthouse()

  if not ( cmn.IsEventDone( "opn_foresthouse" ) ) then
    
    local func_after = function ()
      
      cmn.Lock( 0 );
      cmn.CallEventHandler("opn_foresthouse");
      
      cmn.ShowBbt( "foresthouse_open" );
      
    end;
    
    local unzoom = function ()
      
      ObjAnimate("rm_foresthouse", "scale_xy", 0, 0, func_after, { 0, 0, 1.5, 1.5,   0.7, 0, 1, 1 });
      ObjAnimate("rm_foresthouse", "pos_xy", 0, 0, "", { 0, 0, 48, -100,   0.7, 0, 0, 0 });
      
    end;
    
    local play_anim = function ()
      
      ObjSet("anm_foresthouse_granny",  { alp = 1, playing = 1, endtrig = unzoom });
      
    end;
    
    cmn.SetEventDone( "opn_foresthouse" );
    
    ObjAnimate("rm_foresthouse", "scale_xy", 0, 0, play_anim, { 0, 0, 1, 1,   0.7, 0, 1.5, 1.5 });
    ObjAnimate("rm_foresthouse", "pos_xy", 0, 0, "", { 0, 0, 0, 0,   0.7, 0, 48, -100 });
    
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_chest()
  
  cmn.Lock(1);
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_chest_chest_touch", { alp = 0 }},
                   {"anm_chest_chest", { alp = 1, playing = 1 }} } );
    
  end;
  
  cmn.ShowBbt( "obj_chest_chest_touch" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_foresthouse/audio/aud_xx_growl");
  
  ObjMultiSet( { {"anm_chest_chest_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_chest_chest", { alp = 0, playing = 0 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_chest_bells()
  
  cmn.Lock(1);
  
  local func_after = function ()
    
    cmn.Lock(0);
    
  end;
  
  cmn.ShowBbt( "obj_chest_use_bell" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_foresthouse/audio/aud_xx_clk_bell");
  
  ObjSet("anm_chest_bell_1",  { playing = 1, endtrig = func_after });
  
  for i = 2, 5, 1 do
    
    ObjSet("anm_chest_bell_"..i,  { playing = 1 });
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_bell()
  
  cmn.Lock(1);
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_homedoor_bell_touch", { alp = 0 }},
                   {"anm_homedoor_bell", { alp = 1, playing = 1 }} } );
    
  end;
  
  cmn.ShowBbt( "obj_homedoor_use_bellknot" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_foresthouse/audio/aud_xx_clk_chimes");
  
  ObjMultiSet( { {"anm_homedoor_bell_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_homedoor_bell", { alp = 0, playing = 0 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_roots()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_homedoor_use_bellknot" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_foresthouse/audio/aud_xx_clk_rustle2");
  
  ObjSet("anm_homedoor_tree_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_wooden_staff()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_woodenidol_use_crowfigurine" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_foresthouse/audio/aud_xx_clk_wood3");
  
  ObjSet("anm_woodenidol_staff_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.PlayOutro()
  
  local func_after = function ()

    cmn.CallEventHandler( "opn_house" );

    --cmn.GotoRoom( "rm_endroom" );

    cmn.LevelSwitch( "level3", 2 );
    ng_global.progress["std"].common.chapter = "level3";
    ng_global.progress[ "std" ].common.currentroom = "rm_witchhouse";

  end;

  local func_playoutro = function ()

    cmn.Lock( 0 );
    cmn.StopAllEnv();
    
    cmn.PlayFullscreenVideo( "assets/levels/level2/rm_foresthouse/vid_inspection",
                             func_after,
                             "assets/levels/level2/rm_foresthouse/audio/aud_inspection",
                             "assets/levels/level2/rm_foresthouse/audio/aud_inspection_voc" );

  end;

  if not ( cmn.IsEventDone( "opn_house" ) ) then

    cmn.SetEventDone( "opn_house" );
--    cmn.Lock( 1 );
--
--    ObjAnimate( "rm_foresthouse", "color_r", 0, 0, func_playoutro, {0,0,1,  1,0,0} );
--    ObjAnimate( "rm_foresthouse", "color_g", 0, 0, "", {0,0,1,  1,0,0} );
--    ObjAnimate( "rm_foresthouse", "color_b", 0, 0, "", {0,0,1,  1,0,0} );

    func_playoutro();

  end;
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Chest *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_chest = {};
public.zz_chest = {};

function private.Init_Chest()
  
  private.zz_chest.win = { {1, 5, 3}, {2, 4, 4, 1}, {1, 1, 5, 4, 3} };
  private.zz_chest.anim_time = 0.45;
  -----------------------------------------------------------------------------------
  local win_chest = function ()

    if cmn.IsEventDone( "win_chest" ) then

      ObjMultiSet( { {"obj_chest_open", { alp = 1, input = 1 }},
                     {"spr_chest_chest_open", { alp = 1 }},
                     {"obj_chest_game", { input = 0 }},
                     {"spr_foresthouse_chest_open", { alp = 1 }} } );
                     
      ObjDelete("anm_chest_chest_touch");
      ObjDelete("anm_foresthouse_chest");

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_chest", win_chest, "rm_foresthouse" );

end;
--*********************************************************************************************************************
-----------------------------------------------------------------------------------
function private.zz_chest.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_chest" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_chest" ].state = { 1, 0 }; --1 - этап мг, 2 - количество сделанных кликов

end;
-----------------------------------------------------------------------------------
function public.zz_chest.Reset()
  
  cmn.Lock(1);
  private.zz_chest.state[2] = 0;
  
  private.zz_chest.PlaySequence( 1, private.zz_chest.state[1], false );
  
end;
-----------------------------------------------------------------------------------
function public.zz_chest.Skip()
  
  cmn.Lock(1);

  ng_global.progress[ ng_global.currentprogress ][ "win_chest" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_chest" ].state = { 4, 0 };
  
  private.zz_chest.PlaySequence( private.zz_chest.state[2]+1, private.zz_chest.state[1], true );
  private.zz_chest.state = ng_global.progress[ ng_global.currentprogress ][ "win_chest" ].state;
  
end;
-----------------------------------------------------------------------------------
function private.zz_chest.DrawScene()
  
  if private.zz_chest.state[2] == 0 then
    cmn.Lock(1);
  end;
  
  if private.zz_chest.state[1] < 4 then
    ObjSet("anm_chest_chest_touch",  { animfunc = "func_mmg_lvl_"..private.zz_chest.state[1] });
  elseif not cmn.IsEventDone("win_chest") then
    ObjSet("anm_chest_chest_touch",  { animfunc = "func_mmg_lvl_3" });
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_chest.PlaySequence( bell, stage, skip )
  
  skip = skip or false;
  local func_after;
  
  if bell < #private.zz_chest.win[ stage ] then
    func_after = function() private.zz_chest.PlaySequence( bell+1, stage, skip ); end;
  elseif not skip then
    func_after = function() cmn.Lock(0); end;
  else 
    func_after = private.zz_chest.CheckWin;
  end;
    
  ObjSet("anm_chest_bell_"..private.zz_chest.win[ stage ][bell],  { playing = 1, endtrig = func_after });

  cmn.PlayAudio( "snd", "assets/levels/level2/rm_foresthouse/audio/aud_xx_clk_bell"..private.zz_chest.win[ stage ][bell]);
  
end;
-------------------------------------------------------------------------------------------
function public.zz_chest.ClickBell( bell )

  cmn.Lock(1);

  local func_after = function() cmn.Lock( 0 ); end;

  private.zz_chest.state[2] = private.zz_chest.state[2] + 1;

  --кликнули верный колокольчик
  if bell == private.zz_chest.win[ private.zz_chest.state[1] ][ private.zz_chest.state[2] ] then

    if private.zz_chest.state[2] == #private.zz_chest.win[ private.zz_chest.state[1] ] then

      private.zz_chest.state[1] = private.zz_chest.state[1] + 1;
      private.zz_chest.state[2] = 0;

      func_after = function() private.zz_chest.CheckWin(true); end;

    end;

    cmn.PlayAudio( "snd", "assets/levels/level2/rm_foresthouse/audio/aud_xx_clk_bell"..bell);

    ObjSet("anm_chest_bell_"..bell, { playing = 1, endtrig = func_after });

  --кликнули неверный колокольчик
  else 

    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_wrong_apply");
    ObjSet("anm_chest_bell_"..bell, { playing = 1, endtrig = public.zz_chest.Reset });

  end;

end;
-----------------------------------------------------------------------------------
function private.zz_chest.CheckWin( ingame )
  
  ingame = ingame or false;
  
  if private.zz_chest.state[1] < 4 and ingame then
    
    local func_after = function ()
      
      ObjSet("anm_chest_chest_touch",  { frame = 0, animfunc = "func_mmg_lvl_"..private.zz_chest.state[1] });
      private.zz_chest.PlaySequence( 1, private.zz_chest.state[1], false );
      
    end;

    cmn.PlayAudio( "snd", "assets/levels/level2/rm_foresthouse/audio/aud_xx_growl2" );
    
    ObjSet("anm_chest_chest_touch",  { playing = 1, endtrig = func_after });
    
  elseif private.zz_chest.state[1] >= 4 then
    
    cmn.Lock(1);
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("chest");
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
  
    local anm_chest = function ()
        
      ObjSet("obj_chest_open",  { alp = 1 });
      ObjAnimate("spr_chest_chest_open", "alp", 0, 0, private.zz_chest.Win, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_chest_chest_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });

      cmn.PlayAudio( "snd", "assets/levels/level2/rm_foresthouse/audio/aud_xx_opn_chest" );
      
    end;
    
    ObjSet("anm_chest_chest_touch",  { playing = 1, endtrig = anm_chest });

    cmn.PlayAudio( "snd", "assets/levels/level2/rm_foresthouse/audio/aud_xx_growl2" );
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_chest.Win()
  
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_chest" );
  cmn.CallEventHandler( "win_chest" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_chest" ].skip == 0 and ng_global.noskipgames[ "win_chest" ] == nil then

    ng_global.noskipgames[ "win_chest" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

  cmn.Lock( 0 );
  
end;
--*********************************************************************************************************************