-- name=rm_forestthicket
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_forestthicket";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Fencegates();
  --------------------------------------------------------------------------------------------
  -- function get_cloth () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_cloth" ] = {
      type = "get",
      get_obj = "spr_path_cloth",
      room = private.room_objname,
      zz = "zz_path",
      zz_gate = "gzz_forestthicket_path"
  };
  --------------------------------------------------------------------------------------------
  local get_cloth_inv = function ()
  
    interface.InventoryItemAdd( "inv_cloth", "spr_path_cloth" );
    ObjSet("inv_rustyblade_star_light",  { alp = 1 });
  
  end;
  local get_cloth_end = function ()
  
    ObjDelete( "gfx_path_cloth" );
    ObjDelete( "spr_path_cloth_sh" );
    ObjDelete( "spr_forestthicket_zz_path_cloth" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_cloth", get_cloth_inv );
  cmn.AddSubscriber( "get_cloth", get_cloth_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rustyblade () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_rustyblade" ] = {
      type = "get",
      get_obj = "spr_stoneoftales_rustyblade",
      room = private.room_objname,
      zz = "zz_stoneoftales",
      zz_gate = "gzz_forestthicket_stoneoftales"
  };
  --------------------------------------------------------------------------------------------
  local get_rustyblade_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_rustyblade", "spr_stoneoftales_rustyblade_fly" );
  
  end;
  local get_rustyblade_end = function ()
  
    ObjDelete( "spr_stoneoftales_rustyblade" );
    ObjDelete( "spr_forestthicket_zz_stoneoftales_blade" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_rustyblade", get_rustyblade_inv );
  cmn.AddSubscriber( "get_rustyblade", get_rustyblade_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_scull () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_scull" ] = {
      type = "get",
      get_obj = "spr_poinrter_scull",
      room = private.room_objname,
      zz = "zz_poinrter",
      zz_gate = "gzz_forestthicket_poinrter"
  };
  --------------------------------------------------------------------------------------------
  local get_scull_inv = function ()
  
    interface.InventoryItemAdd( "inv_scull", "spr_poinrter_scull" );
  
  end;
  local get_scull_end = function ()
  
    ObjDelete( "obj_poinrter_scull" );
    ObjDelete( "spr_poinrter_scull_sh" );
    ObjDelete( "spr_forestthicket_zz_pointer_skull" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_scull", get_scull_inv );
  cmn.AddSubscriber( "get_scull", get_scull_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wolffaceemblem () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_wolffaceemblem" ] = {
      type = "get",
      get_obj = "spr_poinrter_wolffaceemblem",
      room = private.room_objname,
      zz = "zz_poinrter",
      zz_gate = "gzz_forestthicket_poinrter"
  };
  --------------------------------------------------------------------------------------------
  local get_wolffaceemblem_inv = function ()
  
    interface.InventoryItemAdd( "inv_wolffaceemblem", "spr_poinrter_wolffaceemblem" );
  
  end;
  local get_wolffaceemblem_end = function ()
  
    ObjDelete( "gfx_poinrter_wolffaceemblem" );
    ObjDelete( "spr_forestthicket_zz_pointer_wolfhead" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_wolffaceemblem", get_wolffaceemblem_inv );
  cmn.AddSubscriber( "get_wolffaceemblem", get_wolffaceemblem_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bridgeplanks1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bridgeplanks1" ] = {
      type = "get",
      get_obj = "obj_poinrter_bridgeplanks",
      room = private.room_objname,
      zz = "zz_poinrter",
      zz_gate = "gzz_forestthicket_poinrter"
  };
  --------------------------------------------------------------------------------------------
  local get_bridgeplanks1_inv = function ()
  
    interface.InventoryItemAdd( "inv_bridgeplanks", "spr_poinrter_bridgeplanks_2", function () cmn.GetMultyObject( 'bridgeplanks', 3 ); end );
  
  end;
  local get_bridgeplanks1_end = function ()

    ObjDelete( "spr_forestthicket_zz_pointer_bridgeplanks" );
    ObjDelete( "txt_forestthicket_zz_pointer_text1" );
    ObjDelete( "txt_forestthicket_zz_pointer_text2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bridgeplanks1", get_bridgeplanks1_inv );
  cmn.AddSubscriber( "get_bridgeplanks1", get_bridgeplanks1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bridgeplanks2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bridgeplanks2" ] = {
      type = "get",
      get_obj = "obj_poinrter_bridgeplanks",
      room = private.room_objname,
      zz = "zz_poinrter",
      zz_gate = "gzz_forestthicket_poinrter"
  };
  --------------------------------------------------------------------------------------------
  local get_bridgeplanks2_inv = function ()
  
    interface.InventoryItemAdd( "inv_bridgeplanks", "spr_poinrter_bridgeplanks", function () cmn.GetMultyObject( 'bridgeplanks', 3 ); end );
  
  end;
  local get_bridgeplanks2_end = function ()
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bridgeplanks2", get_bridgeplanks2_inv );
  cmn.AddSubscriber( "get_bridgeplanks2", get_bridgeplanks2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bridgeplanks3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bridgeplanks3" ] = {
      type = "get",
      get_obj = "obj_poinrter_bridgeplanks",
      room = private.room_objname,
      zz = "zz_poinrter",
      zz_gate = "gzz_forestthicket_poinrter"
  };
  --------------------------------------------------------------------------------------------
  local get_bridgeplanks3_inv = function ()
  
    interface.InventoryItemAdd( "inv_bridgeplanks", "spr_poinrter_bridgeplanks_3", function () cmn.GetMultyObject( 'bridgeplanks', 3 ); end );
    int_map_impl.DecreaseRoomTasks("rm_forestthicket");
    
    ObjSet("inv_bridgebase_star_light",  { alp = 1 });
  
  end;
  local get_bridgeplanks3_end = function ()
    
    ObjDelete("gzz_forestthicket_poinrter");

    ObjDelete( "spr_forestthicket_zz_pointer_bridgeplanks2" );
    ObjDelete( "txt_forestthicket_zz_pointer_text3" );
    ObjDelete( "txt_forestthicket_zz_pointer_text4" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bridgeplanks3", get_bridgeplanks3_inv );
  cmn.AddSubscriber( "get_bridgeplanks3", get_bridgeplanks3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_shiningstone1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_shiningstone1" ] = {
      type = "get",
      get_obj = "spr_fencegates_shiningstone1",
      room = private.room_objname,
      zz = "zz_fencegates",
      zz_gate = "gzz_forestthicket_fencegates"
  };
  --------------------------------------------------------------------------------------------
  local get_shiningstone1_inv = function ()
  
    interface.InventoryItemAdd( "inv_shiningstone", "spr_fencegates_shiningstone1", function () cmn.GetMultyObject( 'shiningstone', 3 ); end );
  
  end;
  local get_shiningstone1_end = function ()
  
    ObjDelete( "gfx_fencegates_shiningstone1" );
    ObjDelete( "spr_fencegates_shiningstone1_sh" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_shiningstone1", get_shiningstone1_inv );
  cmn.AddSubscriber( "get_shiningstone1", get_shiningstone1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_acid () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_acid" ] = {
      type = "get",
      get_obj = "spr_fencegates_acid",
      room = private.room_objname,
      zz = "zz_fencegates",
      zz_gate = "gzz_forestthicket_fencegates"
  };
  --------------------------------------------------------------------------------------------
  local get_acid_inv = function ()
  
    interface.InventoryItemAdd( "inv_acid", "spr_fencegates_acid" );
    ObjSet("inv_rustyblade_star_light",  { alp = 1 });
  
  end;
  local get_acid_end = function ()
  
    ObjDelete( "gfx_fencegates_acid" );
    --ObjDelete( "gzz_forestthicket_fencegates" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_acid", get_acid_inv );
  cmn.AddSubscriber( "get_acid", get_acid_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_blade () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_blade" ] = {
      type = "use",
      inv_obj = "inv_blade",
      use_place = "obj_path_use_blade",
      room = private.room_objname,
      zz = "zz_path",
      zz_gate = "gzz_forestthicket_path"
  };
  --------------------------------------------------------------------------------------------
  local use_blade_inv = function ()
  
    interface.InventoryItemRemove( "inv_blade" );
  
  end;
  local use_blade_beg = function ()
  
    ObjDelete( "obj_path_use_blade" );
    ObjDelete( "anm_path_lianas_touch" );
    ObjDelete( "spr_path_grass" );
  
  end;
  local use_blade_end = function ()
  
    ObjSet( "grm_forestthicket_atshore", { input = 1, alp = 1 } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_forestthicket_atshore_focus");
    end;
    ObjDelete( "gzz_forestthicket_path" );
    ObjDelete( "spr_forestthicket_zz_path_branch" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_blade", use_blade_beg, private.room_objname );
  cmn.AddSubscriber( "use_blade", use_blade_inv );
  cmn.AddSubscriber( "use_blade", use_blade_end, private.room_objname );
  cmn.AddSubscriber( "use_blade_inv", use_blade_inv, private.room_objname );
  cmn.AddSubscriber( "use_blade_beg", use_blade_beg, private.room_objname );
  cmn.AddSubscriber( "use_blade_end", use_blade_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shiningstone () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_shiningstone" ] = {
      type = "use",
      inv_obj = "inv_shiningstone",
      use_place = "obj_stoneoftales_use_shiningstone",
      room = private.room_objname,
      zz = "zz_stoneoftales",
      zz_gate = "gzz_forestthicket_stoneoftales"
  };
  --------------------------------------------------------------------------------------------
  local use_shiningstone_inv = function ()
  
    interface.InventoryItemRemove( "inv_shiningstone" );
  
  end;
  local use_shiningstone_beg = function ()
  
    ObjDelete( "obj_stoneoftales_use_shiningstone" );
  
  end;
  local use_shiningstone_end = function ()

    ObjMultiSet( { { "gmg_forestthicket_onmagicstone", { input = 1, alp = 1 } },
                   { "spr_forestthicket_mg_onmagicstone2", { alp = 1 } } } );
  
    ObjDelete( "gzz_forestthicket_stoneoftales" );
    ObjDelete( "spr_forestthicket_mg_onmagicstone1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_shiningstone", use_shiningstone_beg, private.room_objname );
  cmn.AddSubscriber( "use_shiningstone", use_shiningstone_inv );
  cmn.AddSubscriber( "use_shiningstone", use_shiningstone_end, private.room_objname );
  cmn.AddSubscriber( "use_shiningstone_inv", use_shiningstone_inv, private.room_objname );
  cmn.AddSubscriber( "use_shiningstone_beg", use_shiningstone_beg, private.room_objname );
  cmn.AddSubscriber( "use_shiningstone_end", use_shiningstone_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_file () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_file" ] = {
      type = "use",
      inv_obj = "inv_file",
      use_place = "obj_poinrter_use_file",
      room = private.room_objname,
      zz = "zz_poinrter",
      zz_gate = "gzz_forestthicket_poinrter"
  };
  --------------------------------------------------------------------------------------------
  local use_file_inv = function ()
  
    interface.InventoryItemRemove( "inv_file" );
  
  end;
  local use_file_beg = function ()
  
    ObjDelete( "obj_poinrter_use_file" );
    ObjDelete( "anm_poinrter_board_3_touch_1" );
    ObjDelete( "anm_poinrter_wolf_touch" );
  
  end;
  local use_file_end = function ()
  
    ObjDelete( "anm_poinrter_use_file" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_file", use_file_beg, private.room_objname );
  cmn.AddSubscriber( "use_file", use_file_inv );
  cmn.AddSubscriber( "use_file", use_file_end, private.room_objname );
  cmn.AddSubscriber( "use_file_inv", use_file_inv, private.room_objname );
  cmn.AddSubscriber( "use_file_beg", use_file_beg, private.room_objname );
  cmn.AddSubscriber( "use_file_end", use_file_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gnomeshammer () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_gnomeshammerpath1" ] = {
      type = "use",
      inv_obj = "inv_gnomeshammer",
      use_place = "obj_poinrter_use_gnomeshammer",
      room = private.room_objname,
      zz = "zz_poinrter",
      zz_gate = "gzz_forestthicket_poinrter"
  };
  game.hint[ "use_gnomeshammerpath2" ] = {
      type = "use",
      inv_obj = "inv_gnomeshammer",
      use_place = "obj_poinrter_use_hammer2",
      room = private.room_objname,
      zz = "zz_poinrter",
      zz_gate = "gzz_forestthicket_poinrter"
  };
  game.hint[ "use_gnomeshammerbridge" ] = {
      type = "use",
      inv_obj = "inv_gnomeshammer",
      use_place = "obj_complex_bridgebase_use_gnomeshammer",
      room = "int_complex_inv",
      zz = "inv_complex_bridgebase",
      zz_gate = "inv_bridgebase"
  };
  --------------------------------------------------------------------------------------------
  local use_gnomeshammer_inv = function ()
  
    interface.InventoryItemRemove( "inv_gnomeshammer" );
  
  end;
  local use_gnomeshammer_beg1 = function ()
    
    ObjDelete( "obj_poinrter_use_gnomeshammer" );
  
    ObjDelete( "anm_poinrter_board_1_touch" );
    ObjDelete( "anm_poinrter_board_2_touch" );
    ObjDelete( "spr_poinrter_wood_sh_1" );
    ObjDelete( "spr_poinrter_wood_sh_2" );
  
  end;
  local use_gnomeshammer_end1 = function ()
  
    ObjDelete( "anm_poinrter_use_hammer" );
    ObjSet("obj_poinrter_use_hammer2",  { input = 1 });
  
  end;
  
  local use_gnomeshammer_beg3 = function ()
  
    ObjDelete( "obj_poinrter_use_hammer2" );
    
    ObjDelete( "anm_poinrter_board_3_touch_2" );
    ObjDelete( "spr_poinrter_wood_sh_3" );
  
  end;
  local use_gnomeshammer_end3 = function ()
  
    ObjDelete( "anm_poinrter_use_hammer_2" );
  
  end;
  
  local use_gnomeshammer_beg2 = function ()
  
    ObjDelete( "obj_complex_bridgebase_use_gnomeshammer" );
    ObjDelete( "anm_complex_bridgebase_nails_touch" );
    ObjSet("anm_complex_bridgebase_planks_touch",  { alp = 1 });
  
  end;
  local use_gnomeshammer_end2 = function ()
  
    ObjMultiSet( { {"anm_complex_bridgebase_use_hammer", { alp = 1, frame = 300 }},
                   {"obj_complex_bridgebase_get_bridge", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gnomeshammerpath1", use_gnomeshammer_beg1, private.room_objname );
  cmn.AddSubscriber( "use_gnomeshammerpath1", use_gnomeshammer_end1, private.room_objname );
  cmn.AddSubscriber( "use_gnomeshammer_beg1", use_gnomeshammer_beg1, private.room_objname );
  cmn.AddSubscriber( "use_gnomeshammer_end1", use_gnomeshammer_end1, private.room_objname );
  cmn.AddSubscriber( "use_gnomeshammerpath2", use_gnomeshammer_beg3, private.room_objname );
  cmn.AddSubscriber( "use_gnomeshammerpath2", use_gnomeshammer_end3, private.room_objname );
  cmn.AddSubscriber( "use_gnomeshammer_beg3", use_gnomeshammer_beg3, private.room_objname );
  cmn.AddSubscriber( "use_gnomeshammer_end3", use_gnomeshammer_end3, private.room_objname );
  
  cmn.AddSubscriber( "use_gnomeshammerbridge", use_gnomeshammer_inv );
  cmn.AddSubscriber( "use_gnomeshammer_inv", use_gnomeshammer_inv, "inv_complex_bridgebase" );
  cmn.AddSubscriber( "use_gnomeshammerbridge", use_gnomeshammer_beg2, "inv_complex_bridgebase" );
  cmn.AddSubscriber( "use_gnomeshammerbridge", use_gnomeshammer_end2, "inv_complex_bridgebase" );
  cmn.AddSubscriber( "use_gnomeshammer_beg2", use_gnomeshammer_beg2, "inv_complex_bridgebase" );
  cmn.AddSubscriber( "use_gnomeshammer_end2", use_gnomeshammer_end2, "inv_complex_bridgebase" );
  --------------------------------------------------------------------------------------------
  -- function use_scull () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_scull" ] = {
      type = "use",
      inv_obj = "inv_scull",
      use_place = "obj_fencegates_use_scull",
      room = private.room_objname,
      zz = "zz_fencegates",
      zz_gate = "gzz_forestthicket_fencegates"
  };
  --------------------------------------------------------------------------------------------
  local use_scull_inv = function ()
  
    interface.InventoryItemRemove( "inv_scull" );
  
  end;
  local use_scull_beg = function ()
  
    ObjDelete( "obj_fencegates_use_scull" );
  
  end;
  local use_scull_end = function ()
  
    ObjDelete( "anm_fencegates_use_scull" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scull", use_scull_beg, private.room_objname );
  cmn.AddSubscriber( "use_scull", use_scull_inv );
  cmn.AddSubscriber( "use_scull", use_scull_end, private.room_objname );
  cmn.AddSubscriber( "use_scull_inv", use_scull_inv, private.room_objname );
  cmn.AddSubscriber( "use_scull_beg", use_scull_beg, private.room_objname );
  cmn.AddSubscriber( "use_scull_end", use_scull_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wolffaceemblem () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_wolffaceemblem" ] = {
      type = "use",
      inv_obj = "inv_wolffaceemblem",
      use_place = "obj_fencegates_use_wolffaceemblem",
      room = private.room_objname,
      zz = "zz_fencegates",
      zz_gate = "gzz_forestthicket_fencegates"
  };
  --------------------------------------------------------------------------------------------
  local use_wolffaceemblem_inv = function ()
  
    interface.InventoryItemRemove( "inv_wolffaceemblem" );
  
  end;
  local use_wolffaceemblem_beg = function ()
  
    ObjDelete( "obj_fencegates_use_wolffaceemblem" );
  
  end;
  local use_wolffaceemblem_end = function ()
    
    ObjDelete( "obj_fencegates_cap" );
    ObjDelete( "anm_fencegates_mmg_open" );
  
    ObjMultiSet( { {"gzz_fencegates_mmg", { alp = 1, input = 1, active = 1 }},
                   {"obj_fencegates_wolf", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wolffaceemblem", use_wolffaceemblem_beg, private.room_objname );
  cmn.AddSubscriber( "use_wolffaceemblem", use_wolffaceemblem_inv );
  cmn.AddSubscriber( "use_wolffaceemblem", use_wolffaceemblem_end, private.room_objname );
  cmn.AddSubscriber( "use_wolffaceemblem_inv", use_wolffaceemblem_inv, private.room_objname );
  cmn.AddSubscriber( "use_wolffaceemblem_beg", use_wolffaceemblem_beg, private.room_objname );
  cmn.AddSubscriber( "use_wolffaceemblem_end", use_wolffaceemblem_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function opn_forestthicket () end;
  --------------------------------------------------------------------------------------------
  local opn_forestthicket = function ()
  
    interface_impl.SetCurrentGlobalTask( 8 );
    common_impl.AddAvailibleMusic( 4 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_forestthicket", opn_forestthicket );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_fencegates" );
  
  function zz_fencegates.PreOpen()
    
    if ( not cmn.IsEventDone( "use_scull" ) ) then
      cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_fencegates_env");
    end;
    
    if cmn.IsEventDone( "use_wolffaceemblem" ) and not(cmn.IsEventDone( "win_fencegates" )) then
      private.zz_fencegates.DrawScene();
    end;

  end;

  function zz_fencegates.PreClose()
    
    cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_forestthicket_env");
    cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_forestthicket_env");
    
    if ( cmn.IsEventDone( "use_wolffaceemblem" ) and not(cmn.IsEventDone( "win_fencegates" )) ) then
      private.zz_fencegates.active = 0;
      cmn.MiniGameHide("fencegates");
    end;

  end;

  function zz_fencegates.Close()
    
    if ( cmn.IsEventDone( "use_wolffaceemblem" ) and not(cmn.IsEventDone( "win_fencegates" )) ) then
      ObjSet("obj_fencegates_game",  { alp = 0, input = 0 });
    end;
                   
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_fencegates" ].state) then 
    private.zz_fencegates.StartConditions();
  end;

  private.zz_fencegates.state = ng_global.progress[ ng_global.currentprogress ][ "win_fencegates" ].state;
  private.zz_fencegates.moves_made = ng_global.progress[ ng_global.currentprogress ][ "win_fencegates" ].moves_made;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_forestthicket();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_forestthicket_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_forestthicket_env");
  
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(4) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_blade()

  local item = "inv_blade";

  if cmn.ApplyObj( item, "gzz_forestthicket_path" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_path" );

  elseif ( cmn.ApplyObj( item, "obj_path_use_blade" ) ) then

    cmn.CallEventHandler( "use_blade_inv" );
    cmn.CallEventHandler( "use_blade_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_blade" );
      cmn.CallEventHandler( "use_blade_end" );
      
      common.CloseSubRoom();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_use_knife2");

    ObjSet("anm_path_lianas_cut",  { alp = 1, playing = 1, endtrig = func_after });
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_shiningstone()

  local item = "inv_shiningstone";

  if cmn.ApplyObj( item, "gzz_forestthicket_stoneoftales" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_stoneoftales" );

  elseif ( cmn.ApplyObj( item, "obj_stoneoftales_use_shiningstone" ) and cmn.CheckMultiObject( "shiningstone", 3 ) ) then

    cmn.CallEventHandler( "use_shiningstone_inv" );
    cmn.CallEventHandler( "use_shiningstone_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_shiningstone" );
      cmn.CallEventHandler( "use_shiningstone_end" );
      
      common.CloseSubRoom();
      cmn.GotoRoom("mg_onmagicstone");
    
    end;

    cmn.Lock( 1 );

    ObjAnimate( "obj_stoneoftales_shiningstones", "alp", 0, 0, func_after,
    {
      0.0, 0, 0, 
      0.3, 0, 1,
      0.6, 0, 1
    } );

    cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_xx_use_stones");

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_file()

  local item = "inv_file";

  if cmn.ApplyObj( item, "gzz_forestthicket_poinrter" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_poinrter" );

  elseif ( cmn.ApplyObj( item, "obj_poinrter_use_file" ) ) then

    cmn.CallEventHandler( "use_file_inv" );
    cmn.CallEventHandler( "use_file_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_file" );
      cmn.CallEventHandler( "use_file_end" );
      
      public.get_wolffaceemblem();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_use_file");

    ObjSet("anm_poinrter_use_file",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_gnomeshammer()

  local item = "inv_gnomeshammer";

  if cmn.ApplyObj( item, "gzz_forestthicket_poinrter" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_poinrter" );

  elseif ( cmn.ApplyObj( item, "obj_poinrter_use_gnomeshammer" ) and cmn.IsEventDone("use_file") and not cmn.IsEventDone("use_gnomeshammerpath1") ) then

    cmn.CallEventHandler( "use_gnomeshammer_beg1" );
    
    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_gnomeshammerpath1" );
      cmn.CallEventHandler( "use_gnomeshammer_end1" );
      cmn.SetEventDone( "use_gnomeshammerpath2" );
      cmn.CallEventHandler( "use_gnomeshammer_end3" );
      
      cmn.SetEventDone( "get_bridgeplanks1" );
      cmn.SetEventDone( "get_bridgeplanks2" );
      cmn.SetEventDone( "get_bridgeplanks3" );
      
      ObjSet( "spr_poinrter_bridgeplanks_3", { alp = 1 } );
      cmn.CallEventHandler( "get_bridgeplanks3" );
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
      
      common.CloseSubRoom();
      
    end;
    
    local anm_2 = function ()
      
      cmn.CallEventHandler( "use_gnomeshammer_beg3" );
      
      ObjSet( "spr_poinrter_bridgeplanks_2", { alp = 1 } );
      ObjSet( "spr_poinrter_bridgeplanks", { alp = 1 } );
      cmn.CallEventHandler( "get_bridgeplanks1" );
      cmn.CallEventHandler( "get_bridgeplanks2" );
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

      ObjDelete( "anm_poinrter_use_hammer" );
      
      cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_use_hammer2");
      ObjSet("anm_poinrter_use_hammer_2",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_use_hammer1");

    ObjSet("anm_poinrter_use_hammer",  { alp = 1, playing = 1, endtrig = anm_2 });
    
  elseif ( cmn.ApplyObj( item, "obj_poinrter_use_hammer2" ) and cmn.IsEventDone("use_file") and cmn.IsEventDone("use_gnomeshammerpath1") ) then

    cmn.CallEventHandler( "use_gnomeshammer_beg3" );
    
    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_gnomeshammerpath2" );
      cmn.CallEventHandler( "use_gnomeshammer_end3" );
      
      public.get_bridgeplanks3();
      
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_use_hammer2");
    
    ObjSet("anm_poinrter_use_hammer_2",  { alp = 1, playing = 1, endtrig = func_after });
    
  elseif ( cmn.ApplyObj( item, "obj_poinrter_use_gnomeshammer" ) and not cmn.IsEventDone("use_file") and not cmn.IsEventDone("use_gnomeshammerpath1") ) then

    cmn.CallEventHandler( "use_gnomeshammer_beg1" );
    
    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_gnomeshammerpath1" );
      cmn.CallEventHandler( "use_gnomeshammer_end1" );
      
      public.get_bridgeplanks1();
      public.get_bridgeplanks2();
      
    end;
    
    if not cmn.IsEventDone("get_scull") then
      public.get_scull();
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_use_hammer1");

    ObjSet("anm_poinrter_use_hammer",  { alp = 1, playing = 1, endtrig = func_after });
    
  elseif ( cmn.ObjIntersectCheck( item, "obj_complex_bridgebase_use_gnomeshammer" ) and cmn.IsEventDone("use_nails") ) then

    cmn.CallEventHandler( "use_gnomeshammer_inv", "inv_complex_bridgebase" );
    cmn.CallEventHandler( "use_gnomeshammer_beg2", "inv_complex_bridgebase" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_gnomeshammerbridge" );
      cmn.CallEventHandler( "use_gnomeshammer_end2", "inv_complex_bridgebase" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_bridgebase/audio/aud_use_hammer");

    ObjSet("anm_complex_bridgebase_use_hammer",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_scull()

  local item = "inv_scull";

  if cmn.ApplyObj( item, "gzz_forestthicket_fencegates" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_fencegates" );

  elseif ( cmn.ApplyObj( item, "obj_fencegates_use_scull" ) ) then

    cmn.CallEventHandler( "use_scull_inv" );
    cmn.CallEventHandler( "use_scull_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_forestthicket_env");
      cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_forestthicket_env");

      cmn.SetEventDone( "use_scull" );
      cmn.CallEventHandler( "use_scull_end" );
      
      public.get_acid();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_use_scull1");

    ObjSet("anm_fencegates_use_scull",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_wolffaceemblem()

  local item = "inv_wolffaceemblem";

  if cmn.ApplyObj( item, "gzz_forestthicket_fencegates" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_fencegates" );

  elseif ( cmn.ApplyObj( item, "obj_fencegates_use_wolffaceemblem" ) ) then
    
    if not cmn.IsEventDone("get_shiningstone1") then
      public.get_shiningstone1();
    end;
    
    cmn.CallEventHandler( "use_wolffaceemblem_inv" );
    cmn.CallEventHandler( "use_wolffaceemblem_beg" );

    local func_after = function ()

      --cmn.Lock( 0 );

      cmn.SetEventDone( "use_wolffaceemblem" );
      --cmn.CallEventHandler( "use_wolffaceemblem_end" );
      
      public.zz_fencegates.OpenMg(1);
    
    end;
    
    local anm_open_lock = function ()
      
      ObjDelete("obj_fencegates_cap");
      ObjMultiSet( { {"anm_fencegates_mmg_open", { alp = 1, playing = 1, endtrig = func_after }},
                     {"spr_fencegates_mmg_stage_1", { alp = 1 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_use_wolf_amulet");

    ObjAnimate( "obj_fencegates_wolf", "alp", 0, 0, anm_open_lock,
    {
      0.0, 0, 0, 
      0.3, 0, 1, 
      0.6, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_cloth()

  cmn.SetEventDone( "get_cloth" );
  cmn.CallEventHandler( "get_cloth" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_rustyblade()
  
  ObjSet("spr_stoneoftales_rustyblade_fly",  { alp = 1 });

  cmn.SetEventDone( "get_rustyblade" );
  cmn.CallEventHandler( "get_rustyblade" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_scull()
  
  ObjSet( "spr_poinrter_scull", { alp = 1 } );

  cmn.SetEventDone( "get_scull" );
  cmn.CallEventHandler( "get_scull" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
end;
--------------------------------------------------------------------------------------------
function public.get_wolffaceemblem()
  
  ObjSet( "spr_poinrter_wolffaceemblem", { alp = 1 } );

  cmn.SetEventDone( "get_wolffaceemblem" );
  cmn.CallEventHandler( "get_wolffaceemblem" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_bridgeplanks1()
  
  ObjSet( "spr_poinrter_bridgeplanks_2", { alp = 1 } );

  cmn.SetEventDone( "get_bridgeplanks1" );
  cmn.CallEventHandler( "get_bridgeplanks1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
end;
--------------------------------------------------------------------------------------------
function public.get_bridgeplanks2()
  
  ObjSet( "spr_poinrter_bridgeplanks", { alp = 1 } );

  cmn.SetEventDone( "get_bridgeplanks2" );
  cmn.CallEventHandler( "get_bridgeplanks2" );
  
end;
--------------------------------------------------------------------------------------------
function public.get_bridgeplanks3()
  
  ObjSet( "spr_poinrter_bridgeplanks_3", { alp = 1 } );

  cmn.SetEventDone( "get_bridgeplanks3" );
  cmn.CallEventHandler( "get_bridgeplanks3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common.CloseSubRoom();
  
end;
--------------------------------------------------------------------------------------------
function public.get_shiningstone1()

  cmn.SetEventDone( "get_shiningstone1" );
  cmn.CallEventHandler( "get_shiningstone1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_acid()
  
  ObjSet("spr_fencegates_acid",  { alp = 1 });

  cmn.SetEventDone( "get_acid" );
  cmn.CallEventHandler( "get_acid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_forestthicket()

  if not ( cmn.IsEventDone( "opn_forestthicket" ) ) then
    
    cmn.ShowBbt( "forestthicket_open" );
    
    cmn.SetEventDone( "opn_forestthicket" );
    cmn.CallEventHandler( "opn_forestthicket" );
    
    interface_impl.ShowGlobalTask();
    
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_boards()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_poinrter_use_gnomeshammer" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_xx_wood_mid");
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_poinrter_wolf_touch", { alp = 1 }},
                   {"anm_poinrter_board_3_touch_2", { alp = 1 }},
                   {"anm_poinrter_board_3_touch_1", { alp = 0 }} } );
    
  end;
  
  if cmn.IsEventDone("get_scull") and not cmn.IsEventDone("get_bridgeplanks1") then
    ObjSet("anm_poinrter_board_1_touch",  { playing = 1 });
  end;
  
  if not cmn.IsEventDone("get_bridgeplanks2") then
    ObjSet("anm_poinrter_board_2_touch",  { playing = 1 });
  end;
    
  if not cmn.IsEventDone("get_wolffaceemblem") then
    ObjMultiSet( { {"anm_poinrter_wolf_touch", { alp = 0 }},
                   {"anm_poinrter_board_3_touch_2", { alp = 0 }},
                   {"anm_poinrter_board_3_touch_1", { alp = 1, playing = 1, endtrig = func_after }} } );
  else
    ObjSet("anm_poinrter_board_3_touch_2",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_wolfshead()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_poinrter_use_file" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_xx_metal_high");
  
  ObjSet("anm_poinrter_wolf_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_fencedoor()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_fencegates_use_wolffaceemblem" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_xx_clk_wood");
  
  ObjSet("anm_fencegates_door_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
  if not cmn.IsEventDone("get_shiningstone1") then
    public.get_shiningstone1();
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_path()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_path_use_blade" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_xx_clk_rustle");
  
  ObjSet("anm_path_lianas_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_4_1", { alp = 1 }},
                 {"spr_col_4_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_4_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_4_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_4_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_4_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_4_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_4_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Fencegates *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_fencegates = {};
public.zz_fencegates = {};

function private.Init_Fencegates()
  
  private.zz_fencegates.active = 0;
  private.zz_fencegates.cur_wolf = 0;
  
  private.zz_fencegates.stages_pos = {0, -500, -1000};
  
  --pos_xy for wolfs
  private.zz_fencegates.grid_pos = { 
    { {-195, -130}, {-131, -130}, {-66, -130}, {-3, -130}, {60, -130}, {123, -130}, {185, -130} },
    { {-195, -68}, {-131, -68}, {-66, -68}, {-3, -68}, {60, -68}, {123, -68}, {185, -68} },
    { {-195, -5}, {-131, -5}, {-66, -5}, {-3, -5}, {60, -5}, {123, -5}, {185, -5} },
    { {-195, 60}, {-131, 60}, {-66, 60}, {-3, 60}, {60, 60}, {123, 60}, {185, 60} },
    { {-195, 125}, {-131, 125}, {-66, 125}, {-3, 125}, {60, 125}, {123, 125}, {185, 125} }
  };
  --start state for wolfs
  private.zz_fencegates.start = { 
    { {2, 1}, {2, 2}, {3, 3}, {4, 2}, {5, 2}, {5, 4}, {6, 3}, {7, 1}, {7, 2} },
    { {3, 1}, {3, 2}, {3, 3}, {3, 4}, {4, 1}, {4, 2}, {4, 3}, {5, 1}, {5, 2}, {5, 3}, {5, 4} },
    { {2, 1}, {2, 2}, {3, 2}, {3, 3}, {3, 4}, {3, 5}, {4, 1}, {4, 2}, {4, 3}, {4, 4}, {5, 1}, {5, 2}, {5, 3}, {5, 4} }
  };
  --forbidden places for each stage
  private.zz_fencegates.forbidden = { 
    { {3, 1}, {4, 1}, {5, 1}, {1, 2}, {3, 2}, {1, 3}, {5, 3}, {3, 4}, {1, 5}, {2, 5}, {3, 5}, {4, 5}, {5, 5}, {6, 5}, {7, 5} },
    { {2, 2}, {6, 2}, {2, 3}, {6, 3}, {4, 4}, {1, 5}, {2, 5}, {3, 5}, {4, 5}, {5, 5}, {6, 5}, {7, 5} },
    { {1, 1}, {6, 1}, {7, 1}, {1, 2}, {6, 2}, {7, 2}, {1, 3}, {2, 3}, {7, 3}, {1, 4}, {2, 4}, {6, 4}, {7, 4}, {1, 5}, {2, 5}, {4, 5}, {5, 5}, {6, 5}, {7, 5}}
  };
  
  --pos for round anim
  private.zz_fencegates.rounds_pos = { 484, 35 };
  --grid size
  private.zz_fencegates.grid_max = { 7, 5 };
  --deviation from wolf - places for move
  private.zz_fencegates.move_dev = { {-2, 0}, {0, -2}, {2, 0}, {0, 2} };
  private.zz_fencegates.move_track = { {-1, 0}, {0, -1}, {1, 0}, {0, 1} };
  
  -------------------------------------------------------------------------------------------
  game.hint[ "win_fencegates" ] = {

      type = "click",
      use_place = "gzz_fencegates_mmg",
      room = "rm_forestthicket",
      zz = "zz_fencegates",
      zz_gate = "gzz_forestthicket_fencegates"
  };
  -----------------------------------------------------------------------------------
  local win_fencegates_loc = function ()

    if cmn.IsEventDone( "win_fencegates" ) then

      ObjMultiSet( { { "grm_forestthicket_foresthouse", { input = 1, alp = 1 } },
                     { "spr_forestthicket_zz_fencegates", { alp = 1 } } } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_forestthicket_foresthouse_focus");
      end;
      ObjDelete( "gzz_forestthicket_fencegates" );

    end;

  end;
  local win_fencegates_task = function ()

    if cmn.IsEventDone( "win_fencegates" ) then

      int_map_impl.DecreaseRoomTasks("rm_forestthicket");

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_fencegates", win_fencegates_loc, "rm_forestthicket" );
  cmn.AddSubscriber( "win_fencegates", win_fencegates_task );

end;
--*********************************************************************************************************************
function public.zz_fencegates.OpenMg( num )

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_zoom_mg");

  local func_after = function ()

    if num == 1 then
      cmn.CallEventHandler( "use_wolffaceemblem_end" );
      cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_xx_mech_lock");
      private.zz_fencegates.AnimStage( 1 );
    else 
      private.zz_fencegates.CheckWin();
    end;

    cmn.MiniGameShow();
    
    ObjMultiSet( { {"obj_fencegates_game", { alp = 1, input = 1 }},
                   {"obj_fencegates_back", { pos_x = 0, pos_y = 0, scale_x = 1, scale_y = 1 }} } );

  end;
  
  local show_mmg = function ()
  
    ObjAnimate( "obj_fencegates_game", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 } );
  
  end;

  private.zz_fencegates.active = 1;

  ObjAnimate( "obj_fencegates_back", "scale_xy", 0, 0, "", { 0,0,1,1,   0.3,0,1,1,    1.5,0,1.5,1.5 } );
  ObjAnimate( "obj_fencegates_back", "pos_xy",   0, 0, show_mmg, { 0,0,0,0,   0.3,0,0,0,    1.5,0,-80,-5 } );

end;
-----------------------------------------------------------------------------------
function private.zz_fencegates.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_fencegates" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_fencegates" ].state = {
    { {2, 1}, {2, 2}, {3, 3}, {4, 2}, {5, 2}, {5, 4}, {6, 3}, {7, 1}, {7, 2} },
    { {3, 1}, {3, 2}, {3, 3}, {3, 4}, {4, 1}, {4, 2}, {4, 3}, {5, 1}, {5, 2}, {5, 3}, {5, 4} },
    { {2, 1}, {2, 2}, {3, 2}, {3, 3}, {3, 4}, {3, 5}, {4, 1}, {4, 2}, {4, 3}, {4, 4}, {5, 1}, {5, 2}, {5, 3}, {5, 4} },
    1
  }; --[1-3] - wolf positions in each stage, [4] - current stage

  --remember moves in stage [1] - eaten wolf, [2] - moved wolf, [3] - index of each
  ng_global.progress[ ng_global.currentprogress ][ "win_fencegates" ].moves_made = {};
  
end;
-----------------------------------------------------------------------------------
function public.zz_fencegates.Reset()
  
  local need_r = false;
  local stage = private.zz_fencegates.state[4];
  
  local cur_state = {};
  
  for i = 1, #private.zz_fencegates.state[ stage ], 1 do
    
    if not ng_global.progress[ ng_global.currentprogress ][ "win_fencegates" ].state[ stage ][i] then
      cur_state[i] = false;
      ng_global.progress[ ng_global.currentprogress ][ "win_fencegates" ].state[ stage ][i] = {0, 0};
    else 
      cur_state[i] = {0, 0};
      cur_state[i][1] = private.zz_fencegates.state[ stage ][i][1];
      cur_state[i][2] = private.zz_fencegates.state[ stage ][i][2];
    end;
    
    if ng_global.progress[ ng_global.currentprogress ][ "win_fencegates" ].state[ stage ][i][1] ~= private.zz_fencegates.start[ stage ][i][1] then
      ng_global.progress[ ng_global.currentprogress ][ "win_fencegates" ].state[ stage ][i][1] = private.zz_fencegates.start[ stage ][i][1];
    end;
    
    if ng_global.progress[ ng_global.currentprogress ][ "win_fencegates" ].state[ stage ][i][2] ~= private.zz_fencegates.start[ stage ][i][2] then
      ng_global.progress[ ng_global.currentprogress ][ "win_fencegates" ].state[ stage ][i][2] = private.zz_fencegates.start[ stage ][i][2];
    end;
    
  end;
  
  local count = 0;
  
  for i = 1, #cur_state, 1 do
    
    local start_pos_x = private.zz_fencegates.grid_pos[ private.zz_fencegates.start[ stage ][i][2] ][ private.zz_fencegates.start[ stage ][i][1] ][1];
    local start_pos_y = private.zz_fencegates.grid_pos[ private.zz_fencegates.start[ stage ][i][2] ][ private.zz_fencegates.start[ stage ][i][1] ][2];
    
    if not cur_state[i] then
      
      count = count+1;
      
      if not need_r then
        need_r = true;
      end;
      
      ObjSet("spr_fencegates_wolf_"..stage.."_"..i,  { pos_x = start_pos_x, pos_y = start_pos_y });
      ObjAnimate("spr_fencegates_wolf_"..stage.."_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,   1, 0, 1 });
      
    elseif cur_state[i][1] ~= private.zz_fencegates.start[ stage ][i][1] or cur_state[i][2] ~= private.zz_fencegates.start[ stage ][i][2] then
      
      if not need_r then
        need_r = true;
      end;
      
      local func_set = function ()
        ObjSet("spr_fencegates_wolf_"..stage.."_"..i,  { pos_x = start_pos_x, pos_y = start_pos_y });
        ObjAnimate("spr_fencegates_wolf_"..stage.."_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      end;
      
      ObjAnimate("spr_fencegates_wolf_"..stage.."_"..i, "alp", 0, 0, func_set, { 0, 0, 1,   0.5, 0, 0 });
      
    end;
    
  end;
  
  for i = 1, count, 1 do
    ObjAnimate("spr_fencegates_eaten_"..stage.."_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  end;
  
  if need_r then
    
    cmn.Lock(1);
    private.zz_fencegates.moves_made = {};
    
    if private.zz_fencegates.cur_wolf > 0 then
      local wol = private.zz_fencegates.cur_wolf;
      private.zz_fencegates.cur_wolf = 0;
      ObjAnimate("spr_fencegates_wolf_"..stage.."_"..wol.."_on", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 });
    end;
    
    --private.zz_fencegates.state = ng_global.progress[ ng_global.currentprogress ][ "win_fencegates" ].state;
    
    ObjSet("tmr_fencegates_timer",  { time = 1, playing = 1, endtrig = function() private.zz_fencegates.DrawScene(); cmn.Lock(0); end });

    cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_xx_reverse");
    
  elseif private.zz_fencegates.cur_wolf > 0 then
    
    public.zz_fencegates.ChooseWolf( stage, private.zz_fencegates.cur_wolf );
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_fencegates.Skip()
  
  cmn.Lock(1);
  
  ng_global.progress[ ng_global.currentprogress ][ "win_fencegates" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_fencegates" ].state = {
    { {2, 1}, false, false, false, false, false, false, false, false },
    { {3, 1}, false, false, false, false, false, false, false, false, false, false },
    { {2, 1}, false, false, false, false, false, false, false, false, false, false, false, false, false },
    4
  };
  
  local ind = 0;
  local stage = private.zz_fencegates.state[4];
  
  for i = 1, #private.zz_fencegates.state[ stage ], 1 do
    
    if private.zz_fencegates.state[ stage ][i] then
      ind = i;
      break;
    end;
    
  end;
  
  local count = 0;
  
  for i = 1, #private.zz_fencegates.state[ stage ], 1 do
    
    if not private.zz_fencegates.state[ stage ][i] then
      count = count+1;
    end;
    
  end;
  
  if private.zz_fencegates.cur_wolf > 0 then
    ObjAnimate("spr_fencegates_wolf_"..stage.."_"..private.zz_fencegates.cur_wolf.."_on", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 });
  end;
  
  for i = count+1, #private.zz_fencegates.state[ stage ]-1, 1 do
    ObjAnimate("spr_fencegates_eaten_"..stage.."_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
  end;
  
  for i = 1, #private.zz_fencegates.state[ stage ], 1 do
    
    if i ~= ind and private.zz_fencegates.state[ stage ][i] then
      ObjAnimate("spr_fencegates_wolf_"..stage.."_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    end;
    
  end;
  
  local func_after = function ()
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_xx_opn_gate");
    
    cmn.MiniGameHide("fencegates");
    private.zz_fencegates.AnimStage( false, stage );
    
  end;
  
  ObjSet("tmr_fencegates_timer",  { time = 0.5, playing = 1, endtrig = func_after });
  
end;
-----------------------------------------------------------------------------------
function private.zz_fencegates.DrawScene()
  
  for i = 1, 3, 1 do
    
    if i == private.zz_fencegates.state[4] then
      ObjMultiSet( { {"spr_fencegates_round_"..i,  { pos_x = private.zz_fencegates.rounds_pos[2] }},
                     {"obj_fencegates_stage_"..i, { input = 1 }},
                     {"spr_fencegates_mmg_stage_"..i, { alp = 1 }} } );
    else 
      ObjMultiSet( { {"spr_fencegates_round_"..i,  { pos_x = private.zz_fencegates.rounds_pos[1] }},
                     {"obj_fencegates_stage_"..i, { input = 0 }},
                     {"spr_fencegates_mmg_stage_"..i, { alp = 0 }} } );
    end;
    
  end;
                 
  for i = 1, private.zz_fencegates.state[4], 1 do
    ObjSet("spr_fencegates_stage_num_"..i,  { alp = 1 });
  end;
  for i = private.zz_fencegates.state[4]+1, 3, 1 do
    ObjSet("spr_fencegates_stage_num_"..i,  { alp = 0 });
  end;
  
  if private.zz_fencegates.state[4] < 4 then
    
    ObjSet("obj_fencegates_stages",  { pos_x = private.zz_fencegates.stages_pos[ private.zz_fencegates.state[4] ] });  
    
    local count = 0;
    
    if private.zz_fencegates.cur_wolf == 0 then
      for i = 1, #private.zz_fencegates.state[ private.zz_fencegates.state[4] ], 1 do
        ObjSet("spr_fencegates_wolf_"..private.zz_fencegates.state[4].."_"..i,  { input = 1 });
      end;  
    end;
    
    for i = 1, #private.zz_fencegates.state[ private.zz_fencegates.state[4] ], 1 do
      
      if private.zz_fencegates.state[ private.zz_fencegates.state[4] ][i] then
        
        ObjSet("spr_fencegates_wolf_"..private.zz_fencegates.state[4].."_"..i,  { 
          pos_x = private.zz_fencegates.grid_pos[ private.zz_fencegates.state[ private.zz_fencegates.state[4] ][i][2] ][ private.zz_fencegates.state[ private.zz_fencegates.state[4] ][i][1] ][1], 
          pos_y = private.zz_fencegates.grid_pos[ private.zz_fencegates.state[ private.zz_fencegates.state[4] ][i][2] ][ private.zz_fencegates.state[ private.zz_fencegates.state[4] ][i][1] ][2] 
        });
        
      else 
        count = count + 1;
        ObjSet("spr_fencegates_wolf_"..private.zz_fencegates.state[4].."_"..i,  { alp = 0, input = 0 });
      end;
      
    end;
    
    for i = 1, count, 1 do
      ObjSet("spr_fencegates_eaten_"..private.zz_fencegates.state[4].."_"..i,  { alp = 1 });
    end;
    
  else 
    
    ObjMultiSet( { {"obj_fencegates_stages",  { pos_x = private.zz_fencegates.stages_pos[ 3 ] }},
                   {"spr_fencegates_mmg_stage_3", { alp = 1 }} } );
    
    for i = 1, #private.zz_fencegates.state[ 3 ]-1, 1 do
      ObjSet("spr_fencegates_eaten_3_"..i,  { alp = 1 });
    end;
    
    for i = 1, #private.zz_fencegates.state[ 3 ], 1 do
      
      ObjSet("spr_fencegates_wolf_3_"..i,  { input = 0 });
      
      if private.zz_fencegates.state[ 3 ][i] then
        
        ObjSet("spr_fencegates_wolf_3_"..i,  { 
          pos_x = private.zz_fencegates.grid_pos[ private.zz_fencegates.state[ 3 ][i][2] ][ private.zz_fencegates.state[ 3 ][i][1] ][1], 
          pos_y = private.zz_fencegates.grid_pos[ private.zz_fencegates.state[ 3 ][i][2] ][ private.zz_fencegates.state[ 3 ][i][1] ][2] 
        });
        
      else 
        ObjSet("spr_fencegates_wolf_3_"..i,  { alp = 0 });
      end;
      
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_fencegates.FocusWolf( num1, num2, inout )
  
  local obj = "spr_fencegates_wolf_"..num1.."_"..num2.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_menter1");
    end;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
--anim change stage
function private.zz_fencegates.AnimStage( new, old )
  
  old = old or false;
  
  if old then
    
    if new then
      
      local func_after = function ()
        
        for i = 1, 3, 1 do
          
          if i == new then
            ObjSet("obj_fencegates_stage_"..i, { input = 1 });
          else 
            ObjSet("obj_fencegates_stage_"..i, { input = 0 });
          end;
          
        end;
        
        ObjAnimate("obj_fencegates_stages", "pos_x", 0, 0, "", { 0, 0, private.zz_fencegates.stages_pos[ old ],   1, 0, private.zz_fencegates.stages_pos[ new ] });
        ObjAnimate("spr_fencegates_stage_num_"..new, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
        
        ObjSet("anm_fencegates_gear",  { animfunc = "func_gear_back", frame = 0, playing = 1, endtrig = function() cmn.Lock(0); end });
        ObjAnimate("spr_fencegates_round_"..new, "pos_x", 0, 0, "", { 0, 0, private.zz_fencegates.rounds_pos[1],   1, 0, private.zz_fencegates.rounds_pos[2] });
        
      end;
      
      ObjSet("anm_fencegates_gear",  { animfunc = "func_gear", playing = 1, endtrig = func_after });
      ObjAnimate("spr_fencegates_round_"..old, "pos_x", 0, 0, "", { 0, 0, private.zz_fencegates.rounds_pos[2],   1, 0, private.zz_fencegates.rounds_pos[1] });
      
    else 
      
      ObjSet("anm_fencegates_gear",  { animfunc = "func_gear", frame = 0, playing = 1, endtrig = private.zz_fencegates.Win });
      ObjAnimate("spr_fencegates_round_"..old, "pos_x", 0, 0, "", { 0, 0, private.zz_fencegates.rounds_pos[2],   1, 0, private.zz_fencegates.rounds_pos[1] });
      
    end;
    
  else
    
    ObjSet("anm_fencegates_gear",  { animfunc = "func_gear_back", frame = 0, playing = 1, endtrig = function() cmn.Lock(0); end });
    ObjAnimate("spr_fencegates_round_"..new, "pos_x", 0, 0, "", { 0, 0, private.zz_fencegates.rounds_pos[1],   1, 0, private.zz_fencegates.rounds_pos[2] });
    
  end;
  
end;
-----------------------------------------------------------------------------------
--choose wolf to move
function public.zz_fencegates.ChooseWolf( num1, num2 )
  
  cmn.Lock( 1 );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menter_ho");
  
  if private.zz_fencegates.cur_wolf == 0 then
  
    private.zz_fencegates.cur_wolf = num2;
    
    local func_after = function ()
      
      ObjSet("obj_fencegates_game_move",  { 
        input = 1, 
        pos_x = private.zz_fencegates.grid_pos[ private.zz_fencegates.state[ num1 ][ num2 ][2] ][ private.zz_fencegates.state[ num1 ][ num2 ][1] ][1],
        pos_y = private.zz_fencegates.grid_pos[ private.zz_fencegates.state[ num1 ][ num2 ][2] ][ private.zz_fencegates.state[ num1 ][ num2 ][1] ][2] 
      });
      
      private.zz_fencegates.CheckAvailibleNow();
      
      for i = 1, #private.zz_fencegates.state[ num1 ], 1 do
        if i ~= num2 then
          ObjSet("spr_fencegates_wolf_"..num1.."_"..i,  { input = 0 });
        end;
      end;
      
      cmn.Lock( 0 );
      
    end;
    
    ObjAnimate("spr_fencegates_wolf_"..num1.."_"..num2.."_on", "alp", 0, 0, func_after, { 0, 0, 0,   0.2, 0, 1 });
    
  elseif private.zz_fencegates.cur_wolf == num2 then
    
    local func_after = function ()
      
      ObjSet("obj_fencegates_game_move",  { input = 0 });
      
      for i = 1, #private.zz_fencegates.state[ num1 ], 1 do
        if private.zz_fencegates.state[ num1 ][i] then
          ObjSet("spr_fencegates_wolf_"..num1.."_"..i,  { input = 1 });
        end;
      end;
      
      cmn.Lock( 0 );
      
    end;
    
    private.zz_fencegates.cur_wolf = 0;
    ObjAnimate("spr_fencegates_wolf_"..num1.."_"..num2.."_on", "alp", 0, 0, func_after, { 0, 0, 1,   0.2, 0, 0 });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_fencegates.FocusMove( num, inout )
  
  local obj = "spr_fencegates_game_move_"..num.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      --cmn.PlayAudio("snd", "assets/levels/level1/mg_memories/audio/aud_cloud_menter");
    end;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.zz_fencegates.FocusReset( inout )
  
  local obj = "spr_fencegates_game_reset_move_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_menter1");
    end;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
--reset move
function public.zz_fencegates.ResetMove()
  
  local move_count = #private.zz_fencegates.moves_made;
  
  if move_count > 0 then
  
    cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_xx_reverse");

    cmn.Lock( 1 );
    
    local stage = private.zz_fencegates.state[4];
    
    local wolf_1 = private.zz_fencegates.moves_made[ move_count ][3][1];
    local wolf_2 = private.zz_fencegates.moves_made[ move_count ][3][2];
    
    private.zz_fencegates.state[ stage ][ wolf_1 ] = {};
    private.zz_fencegates.state[ stage ][ wolf_1 ][1] = private.zz_fencegates.moves_made[ move_count ][1][1];
    private.zz_fencegates.state[ stage ][ wolf_1 ][2] = private.zz_fencegates.moves_made[ move_count ][1][2];
    
    private.zz_fencegates.state[ stage ][ wolf_2 ][1] = private.zz_fencegates.moves_made[ move_count ][2][1];
    private.zz_fencegates.state[ stage ][ wolf_2 ][2] = private.zz_fencegates.moves_made[ move_count ][2][2];
    
    local new_x = private.zz_fencegates.grid_pos[ private.zz_fencegates.state[ stage ][wolf_2][2] ][ private.zz_fencegates.state[ stage ][wolf_2][1] ][1];
    local new_y = private.zz_fencegates.grid_pos[ private.zz_fencegates.state[ stage ][wolf_2][2] ][ private.zz_fencegates.state[ stage ][wolf_2][1] ][2]; 
    
    table.remove(private.zz_fencegates.moves_made, move_count);
    
    local func_after = function ()
      
      ObjSet("spr_fencegates_wolf_"..stage.."_"..wolf_2,  { pos_x = new_x, pos_y = new_y });
      
      ObjAnimate("spr_fencegates_wolf_"..stage.."_"..wolf_2, "alp", 0, 0, function() cmn.Lock(0); private.zz_fencegates.DrawScene(); end, { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_fencegates_wolf_"..stage.."_"..wolf_1, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    ObjAnimate("spr_fencegates_eaten_"..stage.."_"..move_count, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    
    ObjAnimate("spr_fencegates_wolf_"..stage.."_"..wolf_2, "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });
    
  end;
  
end;
-----------------------------------------------------------------------------------
--make move - eat someone
function public.zz_fencegates.ChooseMove( num )
  
  cmn.Lock( 1 );

  cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_xx_move_head");
  
  local stage = private.zz_fencegates.state[4];
  
  local old_x = private.zz_fencegates.grid_pos[ private.zz_fencegates.state[ stage ][private.zz_fencegates.cur_wolf][2] ][ private.zz_fencegates.state[ stage ][private.zz_fencegates.cur_wolf][1] ][1];
  local old_y = private.zz_fencegates.grid_pos[ private.zz_fencegates.state[ stage ][private.zz_fencegates.cur_wolf][2] ][ private.zz_fencegates.state[ stage ][private.zz_fencegates.cur_wolf][1] ][2];
  
  local a1 = private.zz_fencegates.state[ stage ][ private.zz_fencegates.cur_wolf ][1] + private.zz_fencegates.move_dev[num][1];
  local b1 = private.zz_fencegates.state[ stage ][ private.zz_fencegates.cur_wolf ][2] + private.zz_fencegates.move_dev[num][2];
  
  local a2 = private.zz_fencegates.state[ stage ][ private.zz_fencegates.cur_wolf ][1] + private.zz_fencegates.move_track[num][1];
  local b2 = private.zz_fencegates.state[ stage ][ private.zz_fencegates.cur_wolf ][2] + private.zz_fencegates.move_track[num][2];
  
  local new_x = private.zz_fencegates.grid_pos[ b1 ][ a1 ][1];
  local new_y = private.zz_fencegates.grid_pos[ b1 ][ a1 ][2];
  
  local eaten = 0;
  
  local move_count = #private.zz_fencegates.moves_made+1;
  private.zz_fencegates.moves_made[ move_count ] = { {0, 0}, {0, 0}, {0, 0} };
  
  for i = 1, #private.zz_fencegates.state[ stage ], 1 do
    
    if private.zz_fencegates.state[ stage ][i] and private.zz_fencegates.state[ stage ][i][1] == a2 
    and private.zz_fencegates.state[ stage ][i][2] == b2 then
    
      eaten = i;
      private.zz_fencegates.moves_made[ move_count ][3][1] = eaten;
      private.zz_fencegates.moves_made[ move_count ][1][1] = private.zz_fencegates.state[ stage ][i][1];
      private.zz_fencegates.moves_made[ move_count ][1][2] = private.zz_fencegates.state[ stage ][i][2];
      private.zz_fencegates.state[ stage ][i] = false;
      break;
    
    end;
    
  end;
  
  local wolf = private.zz_fencegates.cur_wolf;
  
  private.zz_fencegates.moves_made[ move_count ][3][2] = wolf;
  private.zz_fencegates.moves_made[ move_count ][2][1] = private.zz_fencegates.state[ stage ][ wolf ][1];
  private.zz_fencegates.moves_made[ move_count ][2][2] = private.zz_fencegates.state[ stage ][ wolf ][2];
  
  private.zz_fencegates.cur_wolf = 0;
  
  private.zz_fencegates.state[ stage ][ wolf ][1] = a1;
  private.zz_fencegates.state[ stage ][ wolf ][2] = b1;
  
  local func_after = function ()
      
    ObjSet("obj_fencegates_game_move",  { input = 0 });
    ObjAttach("spr_fencegates_wolf_"..stage.."_"..wolf, "obj_fencegates_stage_"..stage);
    
    for i = 1, #private.zz_fencegates.state[ stage ], 1 do
      if private.zz_fencegates.state[ stage ][i] then
        ObjSet("spr_fencegates_wolf_"..stage.."_"..i,  { input = 1 });
      end;
    end;
    
    private.zz_fencegates.CheckWin();
    
  end;

  ObjAnimate("spr_fencegates_wolf_"..stage.."_"..wolf.."_on", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 });
  
  local count = 0;
  
  for i = 1, #private.zz_fencegates.state[ stage ], 1 do
    
    if not private.zz_fencegates.state[ stage ][i] then
      count = count+1;
    end;
    
  end;
  
  ObjAnimate("spr_fencegates_eaten_"..stage.."_"..count, "alp", 0, 0, "", { 0, 0, 0,   0.7, 0, 0,    1.2, 0, 1 });
  
  if eaten > 0 then
    ObjAnimate("spr_fencegates_wolf_"..stage.."_"..eaten, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 1,    0.9, 0, 0 });
  end;
  
  ObjAttach("spr_fencegates_wolf_"..stage.."_"..wolf, "obj_fencegates_game_fly_"..stage);
  
  ObjAnimate("spr_fencegates_wolf_"..stage.."_"..wolf, "scale_xy", 0, 0, func_after, { 0, 0, 1, 1,   0.2, 0, 1.1, 1.1,    1.2, 0, 1.1, 1.1,   1.4, 0, 1, 1 });
  ObjAnimate("spr_fencegates_wolf_"..stage.."_"..wolf, "pos_xy", 0, 0, "", { 0, 0, old_x, old_y,   0.2, 0, old_x, old_y,    1.2, 0, new_x, new_y });
  
end;
-----------------------------------------------------------------------------------
--check availible moves for current wolf
function private.zz_fencegates.CheckAvailibleNow()
  
  local a1, b1, a2, b2;
  local stage = private.zz_fencegates.state[ 4 ];
  
  for i = 1, 4, 1 do
    
    a1 = private.zz_fencegates.state[ stage ][ private.zz_fencegates.cur_wolf ][1] + private.zz_fencegates.move_dev[i][1];
    b1 = private.zz_fencegates.state[ stage ][ private.zz_fencegates.cur_wolf ][2] + private.zz_fencegates.move_dev[i][2];
    
    a2 = private.zz_fencegates.state[ stage ][ private.zz_fencegates.cur_wolf ][1] + private.zz_fencegates.move_track[i][1];
    b2 = private.zz_fencegates.state[ stage ][ private.zz_fencegates.cur_wolf ][2] + private.zz_fencegates.move_track[i][2];
    
    if private.zz_fencegates.CheckForTaken( stage, a1, b1 ) then
      ObjSet("obj_fencegates_game_move_"..i,  { input = 0 });
    elseif private.zz_fencegates.CheckForMove( stage, a2, b2 ) then
      ObjSet("obj_fencegates_game_move_"..i,  { input = 1 });
    else 
      ObjSet("obj_fencegates_game_move_"..i,  { input = 0 });
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
--check moves for block
function private.zz_fencegates.CheckForBlock( wolf )
  
  local a1, b1, a2, b2;
  local stage = private.zz_fencegates.state[ 4 ];
  local check = true;
  
  for i = 1, 4, 1 do
    
    a1 = private.zz_fencegates.state[ stage ][ wolf ][1] + private.zz_fencegates.move_dev[i][1];
    b1 = private.zz_fencegates.state[ stage ][ wolf ][2] + private.zz_fencegates.move_dev[i][2];
    
    a2 = private.zz_fencegates.state[ stage ][ wolf ][1] + private.zz_fencegates.move_track[i][1];
    b2 = private.zz_fencegates.state[ stage ][ wolf ][2] + private.zz_fencegates.move_track[i][2];
    
    if not private.zz_fencegates.CheckForTaken( stage, a1, b1 ) and private.zz_fencegates.CheckForMove( stage, a2, b2 ) then
      check = false;
      break;
    end;
    
  end;
  
  return check;
  
end;
-----------------------------------------------------------------------------------
--check if move availible - can eat someone
function private.zz_fencegates.CheckForMove( stage, pos1, pos2 )
  
  local check = false;
  
  for i = 1, #private.zz_fencegates.state[stage], 1 do
      
    if private.zz_fencegates.state[stage][i] and pos1 == private.zz_fencegates.state[stage][i][1] and pos2 == private.zz_fencegates.state[stage][i][2] then
      check = true;
      break;
    end;
      
  end;
  
  return check;
  
end;
-----------------------------------------------------------------------------------
--check forbidden and taken places
function private.zz_fencegates.CheckForTaken( stage, pos1, pos2 )
  
  local check = false;
  
  if pos1 > 0 and pos1 <= private.zz_fencegates.grid_max[1] and pos2 > 0 and pos2 <= private.zz_fencegates.grid_max[2] then
  
    for i = 1, #private.zz_fencegates.forbidden[stage], 1 do
      
      if pos1 == private.zz_fencegates.forbidden[stage][i][1] and pos2 == private.zz_fencegates.forbidden[stage][i][2] then
        check = true;
        break;
      end;
        
    end;
    
    if not check then
      
      for i = 1, #private.zz_fencegates.state[stage], 1 do
        
        if private.zz_fencegates.state[stage][i] and pos1 == private.zz_fencegates.state[stage][i][1] and pos2 == private.zz_fencegates.state[stage][i][2] then
          check = true;
          break;
        end;
          
      end;
      
    end;
    
  else 
    check = true;
  end;
  
  return check;
  
end;
-----------------------------------------------------------------------------------
function private.zz_fencegates.CheckWin()
  
  local count = 0;
  local stage = private.zz_fencegates.state[ 4 ];
  
  if stage < 4 then
    
    for i = 1, #private.zz_fencegates.state[stage], 1 do
      
      if private.zz_fencegates.state[stage][i] then
        count = count + 1;
      end;
      
    end;
    
  end;
    
  --change stage
  if count == 1 or stage > 3 then
    
    private.zz_fencegates.moves_made = {};
    
    if count == 1 then
      private.zz_fencegates.state[ 4 ] = private.zz_fencegates.state[ 4 ] + 1;
    end;
    
    if stage < 3 then
      cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_xx_next_lock");
      private.zz_fencegates.AnimStage( stage+1, stage );
    else 
      
      cmn.Lock( 1 );
      common_impl.PauseAchiev(1);
      cmn.MiniGameHide("fencegates");
      
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
      
      cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_xx_opn_gate");
      private.zz_fencegates.AnimStage( false, stage );
      
    end;
  
  --check for block  
  else 
    
    local block = 0;
    local count = 0;
    
    for i = 1, #private.zz_fencegates.state[ stage ], 1 do
      
      if private.zz_fencegates.state[ stage ][i] then
        count = count + 1;
        if private.zz_fencegates.CheckForBlock( i ) then
          --DbgTrace(i);
          block = block + 1;
        end;
      end;
      
    end;
    
    if block < count then
      cmn.Lock( 0 );
    else 
      public.zz_fencegates.Reset();
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_fencegates.Win()
  
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_fencegates" );
  cmn.CallEventHandler( "win_fencegates" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_fencegates" ].skip == 0 and ng_global.noskipgames[ "win_fencegates" ] == nil then

    ng_global.noskipgames[ "win_fencegates" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

  cmn.Lock( 0 );
  common.CloseSubRoom();
  
end;
--*********************************************************************************************************