-- name=rm_mermaidsward
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_mermaidsward";
  --------------------------------------------------------------------------------------------
  private.dlg_lipsync = "";
  private.Init_Subroom();
  private.Init_Wardwindow();
  --------------------------------------------------------------------------------------------
  -- function get_cutters () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_cutters" ] = {
      type = "get",
      get_obj = "spr_wardwindow_cutters",
      room = private.room_objname,
      zz = "zz_wardwindow",
      zz_gate = "gzz_mermaidsward_wardwindow"
  };
  --------------------------------------------------------------------------------------------
  local get_cutters_inv = function ()
  
    interface.InventoryItemAdd( "inv_cutters", "spr_wardwindow_cutters" );
  
  end;
  local get_cutters_end = function ()
  
    ObjDelete( "gfx_wardwindow_cutters" );
    ObjDelete( "spr_mermaidsward_zz_wardwindow_cutter" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_cutters", get_cutters_inv );
  cmn.AddSubscriber( "get_cutters", get_cutters_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cosmeticsbag () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_cosmeticsbag" ] = {
      type = "get",
      get_obj = "spr_wardwindow_cosmeticsbag",
      room = private.room_objname,
      zz = "zz_wardwindow",
      zz_gate = "gzz_mermaidsward_wardwindow"
  };
  --------------------------------------------------------------------------------------------
  local get_cosmeticsbag_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_cosmeticsbag", "spr_wardwindow_cosmeticsbag" );
  
  end;
  local get_cosmeticsbag_end = function ()
  
    ObjDelete( "gfx_wardwindow_cosmeticsbag" );
    ObjDelete( "spr_mermaidsward_zz_wardwindow_cosmeticsbag" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_cosmeticsbag", get_cosmeticsbag_inv );
  cmn.AddSubscriber( "get_cosmeticsbag", get_cosmeticsbag_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_puzzlepiece4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_puzzlepiece4" ] = {
      type = "get",
      get_obj = "spr_wardwindow_puzzlepiece4",
      room = private.room_objname,
      zz = "zz_wardwindow",
      zz_gate = "gzz_mermaidsward_wardwindow"
  };
  --------------------------------------------------------------------------------------------
  local get_puzzlepiece4_inv = function ()
  
    interface.InventoryItemAdd( "inv_puzzlepiece4", "spr_wardwindow_puzzlepiece4" );
  
  end;
  local get_puzzlepiece4_end = function ()
  
    ObjDelete( "gfx_wardwindow_puzzlepiece4" );
    ObjDelete( "spr_wardwindow_puzzlepiece4_sh" );
    ObjDelete( "gzz_mermaidsward_wardwindow" );
    ObjDelete( "spr_mermaidsward_zz_wardwindow_puzzle_4" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_puzzlepiece4", get_puzzlepiece4_inv );
  cmn.AddSubscriber( "get_puzzlepiece4", get_puzzlepiece4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mermaidfigurine () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_mermaidfigurine" ] = {
      type = "get",
      get_obj = "spr_chestofdrawers_mermaidfigurine",
      room = private.room_objname,
      zz = "zz_chestofdrawers",
      zz_gate = "gzz_mermaidsward_chestofdrawers"
  };
  --------------------------------------------------------------------------------------------
  local get_mermaidfigurine_inv = function ()
  
    interface.InventoryItemAdd( "inv_mermaidfigurine", "spr_chestofdrawers_mermaidfigurine" );
  
  end;
  local get_mermaidfigurine_end = function ()
  
    ObjDelete( "gfx_chestofdrawers_mermaidfigurine" );
    ObjDelete( "spr_chestofdrawers_mermaidfigurine_sh" );
    
    ObjSet("gzz_mermaidsward_chestofdrawers",  { alp = 0, active = 0 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_mermaidfigurine", get_mermaidfigurine_inv );
  cmn.AddSubscriber( "get_mermaidfigurine", get_mermaidfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mermaidmedallion () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_mermaidmedallion" ] = {
      type = "get",
      get_obj = "spr_mermaidsward_mermaidmedallion",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_mermaidmedallion_inv = function ()
  
    interface.InventoryItemAdd( "inv_mermaidmedallion", "spr_mermaidsward_mermaidmedallion" );
    ObjSet("inv_notebook_star_light",  { alp = 1 });
  
  end;
  local get_mermaidmedallion_mid = function ()
  
    ObjDelete( "gfx_mermaidsward_mermaidmedallion" );
    ObjDelete( "spr_mermaidsward_mermaidmedallion_sh" );
    ObjDelete( "spr_mermaidsward_mermaidmedallion_sh_2" );
    ObjDelete( "spr_mermaidsward_mermaidmedallion_chain" );
    
  end;
  local get_mermaidmedallion_end = function ()
  
    ObjDelete( "obj_mermaidsward_dialog_mermaid" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_mermaidmedallion", get_mermaidmedallion_inv );
  cmn.AddSubscriber( "get_mermaidmedallion_inv", get_mermaidmedallion_inv, private.room_objname );
  cmn.AddSubscriber( "get_mermaidmedallion", get_mermaidmedallion_mid, private.room_objname );
  cmn.AddSubscriber( "get_mermaidmedallion_mid", get_mermaidmedallion_mid, private.room_objname );
  cmn.AddSubscriber( "get_mermaidmedallion", get_mermaidmedallion_end, private.room_objname );
  cmn.AddSubscriber( "get_mermaidmedallion_end", get_mermaidmedallion_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_puzzlepiece1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_puzzlepiece1" ] = {
      type = "use",
      inv_obj = "inv_puzzlepiece1",
      use_place = "obj_ecoposter_use_puzzlepieces",
      room = private.room_objname,
      zz = "zz_ecoposter",
      zz_gate = "gzz_mermaidsward_ecoposter"
  };
  --------------------------------------------------------------------------------------------
  local use_puzzlepiece1_inv = function ()
  
    interface.InventoryItemRemove( "inv_puzzlepiece1" );
  
  end;
  local use_puzzlepiece1_beg = function ()
  
    if cmn.IsEventDone("use_puzzlepiece2") and cmn.IsEventDone("use_puzzlepiece3") and cmn.IsEventDone("use_puzzlepiece4") then
      ObjDelete( "obj_ecoposter_use_puzzlepieces" );
    end;
  
  end;
  local use_puzzlepiece1_end = function ()
    
    ObjSet("spr_ecoposter_puzzlepiece_1",  { alp = 1 });
  
    if cmn.IsEventDone("use_puzzlepiece2") and cmn.IsEventDone("use_puzzlepiece3") and cmn.IsEventDone("use_puzzlepiece4") then
      ObjDelete( "gzz_mermaidsward_ecoposter" );
      ObjSet("gmg_mermaidsward_onposter",  { alp = 1, input = 1, active = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_puzzlepiece1", use_puzzlepiece1_beg, private.room_objname );
  cmn.AddSubscriber( "use_puzzlepiece1", use_puzzlepiece1_inv );
  cmn.AddSubscriber( "use_puzzlepiece1", use_puzzlepiece1_end, private.room_objname );
  cmn.AddSubscriber( "use_puzzlepiece1_inv", use_puzzlepiece1_inv, private.room_objname );
  cmn.AddSubscriber( "use_puzzlepiece1_beg", use_puzzlepiece1_beg, private.room_objname );
  cmn.AddSubscriber( "use_puzzlepiece1_end", use_puzzlepiece1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_puzzlepiece2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_puzzlepiece2" ] = {
      type = "use",
      inv_obj = "inv_puzzlepiece2",
      use_place = "obj_ecoposter_use_puzzlepieces",
      room = private.room_objname,
      zz = "zz_ecoposter",
      zz_gate = "gzz_mermaidsward_ecoposter"
  };
  --------------------------------------------------------------------------------------------
  local use_puzzlepiece2_inv = function ()
  
    interface.InventoryItemRemove( "inv_puzzlepiece2" );
  
  end;
  local use_puzzlepiece2_beg = function ()
  
    if cmn.IsEventDone("use_puzzlepiece1") and cmn.IsEventDone("use_puzzlepiece3") and cmn.IsEventDone("use_puzzlepiece4") then
      ObjDelete( "obj_ecoposter_use_puzzlepieces" );
    end;
  
  end;
  local use_puzzlepiece2_end = function ()
    
    ObjSet("spr_ecoposter_puzzlepiece_2",  { alp = 1 });
  
    if cmn.IsEventDone("use_puzzlepiece1") and cmn.IsEventDone("use_puzzlepiece3") and cmn.IsEventDone("use_puzzlepiece4") then
      ObjDelete( "gzz_mermaidsward_ecoposter" );
      ObjSet("gmg_mermaidsward_onposter",  { alp = 1, input = 1, active = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_puzzlepiece2", use_puzzlepiece2_beg, private.room_objname );
  cmn.AddSubscriber( "use_puzzlepiece2", use_puzzlepiece2_inv );
  cmn.AddSubscriber( "use_puzzlepiece2", use_puzzlepiece2_end, private.room_objname );
  cmn.AddSubscriber( "use_puzzlepiece2_inv", use_puzzlepiece2_inv, private.room_objname );
  cmn.AddSubscriber( "use_puzzlepiece2_beg", use_puzzlepiece2_beg, private.room_objname );
  cmn.AddSubscriber( "use_puzzlepiece2_end", use_puzzlepiece2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_puzzlepiece3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_puzzlepiece3" ] = {
      type = "use",
      inv_obj = "inv_puzzlepiece3",
      use_place = "obj_ecoposter_use_puzzlepieces",
      room = private.room_objname,
      zz = "zz_ecoposter",
      zz_gate = "gzz_mermaidsward_ecoposter"
  };
  --------------------------------------------------------------------------------------------
  local use_puzzlepiece3_inv = function ()
  
    interface.InventoryItemRemove( "inv_puzzlepiece3" );
  
  end;
  local use_puzzlepiece3_beg = function ()
  
    if cmn.IsEventDone("use_puzzlepiece1") and cmn.IsEventDone("use_puzzlepiece2") and cmn.IsEventDone("use_puzzlepiece4") then
      ObjDelete( "obj_ecoposter_use_puzzlepieces" );
    end;
  
  end;
  local use_puzzlepiece3_end = function ()
    
    ObjSet("spr_ecoposter_puzzlepiece_3",  { alp = 1 });
  
    if cmn.IsEventDone("use_puzzlepiece1") and cmn.IsEventDone("use_puzzlepiece2") and cmn.IsEventDone("use_puzzlepiece4") then
      ObjDelete( "gzz_mermaidsward_ecoposter" );
      ObjSet("gmg_mermaidsward_onposter",  { alp = 1, input = 1, active = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_puzzlepiece3", use_puzzlepiece3_beg, private.room_objname );
  cmn.AddSubscriber( "use_puzzlepiece3", use_puzzlepiece3_inv );
  cmn.AddSubscriber( "use_puzzlepiece3", use_puzzlepiece3_end, private.room_objname );
  cmn.AddSubscriber( "use_puzzlepiece3_inv", use_puzzlepiece3_inv, private.room_objname );
  cmn.AddSubscriber( "use_puzzlepiece3_beg", use_puzzlepiece3_beg, private.room_objname );
  cmn.AddSubscriber( "use_puzzlepiece3_end", use_puzzlepiece3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_puzzlepiece4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_puzzlepiece4" ] = {
      type = "use",
      inv_obj = "inv_puzzlepiece4",
      use_place = "obj_ecoposter_use_puzzlepieces",
      room = private.room_objname,
      zz = "zz_ecoposter",
      zz_gate = "gzz_mermaidsward_ecoposter"
  };
  --------------------------------------------------------------------------------------------
  local use_puzzlepiece4_inv = function ()
  
    interface.InventoryItemRemove( "inv_puzzlepiece4" );
  
  end;
  local use_puzzlepiece4_beg = function ()
  
    if cmn.IsEventDone("use_puzzlepiece1") and cmn.IsEventDone("use_puzzlepiece2") and cmn.IsEventDone("use_puzzlepiece3") then
      ObjDelete( "obj_ecoposter_use_puzzlepieces" );
    end;
  
  end;
  local use_puzzlepiece4_end = function ()
    
    ObjSet("spr_ecoposter_puzzlepiece_4",  { alp = 1 });
  
    if cmn.IsEventDone("use_puzzlepiece1") and cmn.IsEventDone("use_puzzlepiece2") and cmn.IsEventDone("use_puzzlepiece3") then
      ObjDelete( "gzz_mermaidsward_ecoposter" );
      ObjSet("gmg_mermaidsward_onposter",  { alp = 1, input = 1, active = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_puzzlepiece4", use_puzzlepiece4_beg, private.room_objname );
  cmn.AddSubscriber( "use_puzzlepiece4", use_puzzlepiece4_inv );
  cmn.AddSubscriber( "use_puzzlepiece4", use_puzzlepiece4_end, private.room_objname );
  cmn.AddSubscriber( "use_puzzlepiece4_inv", use_puzzlepiece4_inv, private.room_objname );
  cmn.AddSubscriber( "use_puzzlepiece4_beg", use_puzzlepiece4_beg, private.room_objname );
  cmn.AddSubscriber( "use_puzzlepiece4_end", use_puzzlepiece4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_knife () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_knife" ] = {
      type = "use",
      inv_obj = "inv_knife",
      use_place = "obj_wardwindow_use_knife",
      room = private.room_objname,
      zz = "zz_wardwindow",
      zz_gate = "gzz_mermaidsward_wardwindow"
  };
  --------------------------------------------------------------------------------------------
  local use_knife_inv = function ()
  
    interface.InventoryItemRemove( "inv_knife" );
  
  end;
  local use_knife_beg = function ()
  
    ObjDelete( "obj_wardwindow_use_knife" );
    ObjDelete( "anm_wardwindow_bag_touch" );
  
  end;
  local use_knife_end = function ()

    ObjDelete( "spr_mermaidsward_zz_wardwindow_bag_cover" );
  
    ObjMultiSet( { { "anm_wardwindow_use_knife",  { alp = 1, input = 1, frame = 300 } },
                   { "spr_mermaidsward_zz_wardwindow_bag_cover_open", { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_knife", use_knife_beg, private.room_objname );
  cmn.AddSubscriber( "use_knife", use_knife_inv );
  cmn.AddSubscriber( "use_knife", use_knife_end, private.room_objname );
  cmn.AddSubscriber( "use_knife_inv", use_knife_inv, private.room_objname );
  cmn.AddSubscriber( "use_knife_beg", use_knife_beg, private.room_objname );
  cmn.AddSubscriber( "use_knife_end", use_knife_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_windowhandle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_windowhandle" ] = {
      type = "use",
      inv_obj = "inv_windowhandle",
      use_place = "obj_wardwindow_use_windowhandle",
      room = private.room_objname,
      zz = "zz_wardwindow",
      zz_gate = "gzz_mermaidsward_wardwindow"
  };
  --------------------------------------------------------------------------------------------
  local use_windowhandle_inv = function ()
  
    interface.InventoryItemRemove( "inv_windowhandle" );
  
  end;
  local use_windowhandle_beg = function ()
  
    ObjDelete( "obj_wardwindow_use_windowhandle" );
    ObjDelete( "anm_wardwindow_window_touch" );
  
  end;
  local use_windowhandle_end = function ()
  
    ObjDelete( "anm_wardwindow_use_handle" );
    ObjDelete( "spr_mermaidsward_zz_wardwindow_window_frame1" );

    ObjMultiSet( { { "obj_wardwindow_use_nuts", { input = 1 } },
                   { "spr_mermaidsward_zz_wardwindow_window_frame2", { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_windowhandle", use_windowhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_windowhandle", use_windowhandle_inv );
  cmn.AddSubscriber( "use_windowhandle", use_windowhandle_end, private.room_objname );
  cmn.AddSubscriber( "use_windowhandle_inv", use_windowhandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_windowhandle_beg", use_windowhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_windowhandle_end", use_windowhandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_nuts () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_nuts" ] = {
      type = "use",
      inv_obj = "inv_nuts",
      use_place = "obj_wardwindow_use_nuts",
      room = private.room_objname,
      zz = "zz_wardwindow",
      zz_gate = "gzz_mermaidsward_wardwindow"
  };
  --------------------------------------------------------------------------------------------
  local use_nuts_inv = function ()
  
    interface.InventoryItemRemove( "inv_nuts" );
  
  end;
  local use_nuts_beg = function ()
  
    ObjDelete( "obj_wardwindow_use_nuts" );
  
  end;
  local use_nuts_end = function ()
  
    ObjMultiSet( { {"obj_wardwindow_game_nuts", { alp = 1 }},
                   {"obj_wardwindow_game", { input = 1 }},
                   {"spr_mermaidsward_zz_wardwindow_seed", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_nuts", use_nuts_beg, private.room_objname );
  cmn.AddSubscriber( "use_nuts", use_nuts_inv );
  cmn.AddSubscriber( "use_nuts", use_nuts_end, private.room_objname );
  cmn.AddSubscriber( "use_nuts_inv", use_nuts_inv, private.room_objname );
  cmn.AddSubscriber( "use_nuts_beg", use_nuts_beg, private.room_objname );
  cmn.AddSubscriber( "use_nuts_end", use_nuts_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pendandwithsucker () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_pendandwithsucker" ] = {
      type = "use",
      inv_obj = "inv_pendandwithsucker",
      use_place = "obj_chestofdrawers_use_pendandwithsucker",
      room = private.room_objname,
      zz = "zz_chestofdrawers",
      zz_gate = "gzz_mermaidsward_chestofdrawers"
  };
  --------------------------------------------------------------------------------------------
  local use_pendandwithsucker_inv = function ()
  
    interface.InventoryItemRemove( "inv_pendandwithsucker" );
  
  end;
  local use_pendandwithsucker_beg = function ()
  
    ObjDelete( "obj_chestofdrawers_use_pendandwithsucker" );
    ObjDelete( "anm_chestofdrawers_drawer_touch" );
  
  end;
  local use_pendandwithsucker_end = function ()
  
    ObjMultiSet( { { "anm_chestofdrawers_drawer_open", { input = 1, alp = 1, frame = 400 } },
                   { "spr_mermaidsward_zz_chestofdrawers_opened_shelf", { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pendandwithsucker", use_pendandwithsucker_beg, private.room_objname );
  cmn.AddSubscriber( "use_pendandwithsucker", use_pendandwithsucker_inv );
  cmn.AddSubscriber( "use_pendandwithsucker", use_pendandwithsucker_end, private.room_objname );
  cmn.AddSubscriber( "use_pendandwithsucker_inv", use_pendandwithsucker_inv, private.room_objname );
  cmn.AddSubscriber( "use_pendandwithsucker_beg", use_pendandwithsucker_beg, private.room_objname );
  cmn.AddSubscriber( "use_pendandwithsucker_end", use_pendandwithsucker_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magicpage () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_magicpage" ] = {
      type = "use",
      inv_obj = "inv_magicpage",
      use_place = "obj_mermaidsward_use_magicpage",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local use_magicpage_inv = function ()
  
    interface.InventoryItemRemove( "inv_magicpage" );
    int_map_impl.DecreaseRoomTasks("rm_mermaidsward");
  
  end;
  local use_magicpage_beg = function ()
  
    ObjDelete( "obj_mermaidsward_use_magicpage" );
  
  end;
  local use_magicpage_end = function ()
  
    --ObjSet( "spr_mermaidsward_", { input = 1, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magicpage", use_magicpage_beg, private.room_objname );
  cmn.AddSubscriber( "use_magicpage", use_magicpage_inv );
  cmn.AddSubscriber( "use_magicpage", use_magicpage_end, private.room_objname );
  cmn.AddSubscriber( "use_magicpage_inv", use_magicpage_inv, private.room_objname );
  cmn.AddSubscriber( "use_magicpage_beg", use_magicpage_beg, private.room_objname );
  cmn.AddSubscriber( "use_magicpage_end", use_magicpage_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_mermaidswardfirst () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_mermaidswardfirst" ] = {
    type = "click",
    use_place = "obj_mermaidsward_clk_mermaidswarfirst",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_mermaidswardfirst_task = function ()
    interface_impl.SetCurrentGlobalTask( 12 );
  end;
  local clk_mermaidswardfirst_loc = function ()
    
    ObjDelete("vid_mermaidsward_dialog_mermaid_lipsync1");
    ObjDelete("vid_mermaidsward_dialog_mermaid_lipsync2");
    ObjDelete("vid_mermaidsward_dialog_mermaid_lipsync3");
    ObjDelete("vid_mermaidsward_dialog_mermaid_lipsync4");
    
    ObjDelete("obj_mermaidsward_clk_mermaidswarfirst");
    ObjDelete("anm_mermaidsward_dialog_mermaid_medalion");
    
    ObjAttach("obj_mermaidsward_dialog_mermaid", "rm_mermaidsward");
    
    ObjMultiSet( { { "obj_mermaidsward_use_magicpage", { input = 1, alp = 1 } },
                   { "obj_mermaidsward_dialog_mermaid", { input = 1, alp = 1 } },
                   { "obj_mermaidsward_dialog_mermaid_hand", { input = 1, alp = 1 } },
                   {"anm_mermaidsward_dialog_mermaid_head", { alp = 1 }},
                   { "gzz_mermaidsward_ecoposter", { event_mdown = function() cmn.GotoSubRoomMDown( "mermaidsward_ecoposter" ); end, event_mup = function() cmn.GotoSubRoomMUp( "mermaidsward_ecoposter", "zz_ecoposter" ); end } },
                   { "gzz_mermaidsward_wardwindow", { event_mdown = function() cmn.GotoSubRoomMDown( "mermaidsward_wardwindow" ); end, event_mup = function() cmn.GotoSubRoomMUp( "mermaidsward_wardwindow", "zz_wardwindow" ); end } },
                   { "gzz_mermaidsward_chestofdrawers", { event_mdown = function() cmn.GotoSubRoomMDown( "mermaidsward_chestofdrawers" ); end, event_mup = function() cmn.GotoSubRoomMUp( "mermaidsward_chestofdrawers", "zz_chestofdrawers" ); end } } } );
                   
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_mermaidswardfirst", clk_mermaidswardfirst_loc, private.room_objname );
  cmn.AddSubscriber( "clk_mermaidswardfirst", clk_mermaidswardfirst_task );

  --------------------------------------------------------------------------------------------
  -- function opn_mermaidsward () end;
  --------------------------------------------------------------------------------------------
  local opn_mermaidsward = function ()
  
    int_map_impl.OpenRoom( "rm_mermaidsward" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_mermaidsward", opn_mermaidsward );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_wardwindow" );
  subroom.Define( "zz_chestofdrawers" );
  
  function zz_wardwindow.PreOpen()
    
    if cmn.IsEventDone( "use_nuts" ) then
      private.zz_wardwindow.DrawScene();
    end;
    if cmn.IsEventDone("win_wardwindow") then
      ObjSet("anm_wardwindow_squirrel_3_end",  { playing = 1 });
    end;
    
    if cmn.IsEventDone("use_windowhandle") then
      cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_window_env");
    end;

  end;
  
  function zz_wardwindow.Open()
    
    if not cmn.IsEventDone( "opn_wardwindow" ) then
      cmn.SetEventDone("opn_wardwindow");
      cmn.ShowDlgBbt( "wardwindow_open_voc" );
      cmn.PlayAudio("voc", "assets/levels/level2/rm_mermaidsward/audio/aud_mermaid_dlg2_voc");
    end;
    
    if cmn.IsEventDone( "use_nuts" ) and not(cmn.IsEventDone( "win_wardwindow" )) then
      cmn.MiniGameShow();
      private.zz_wardwindow.CheckWin();
    end;

  end;

  function zz_wardwindow.PreClose()
    
    if ( cmn.IsEventDone( "use_nuts" ) and not(cmn.IsEventDone( "win_wardwindow" )) ) then
      cmn.MiniGameHide("wardwindow");
    end;
    
    if cmn.IsEventDone("use_windowhandle") then
      cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_mermaidsward_env");
      cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_mermaidsward_env");
    end;

  end;
  
  function zz_chestofdrawers.Close()
    cmn.HideNote( 0 );
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_wardwindow" ].state) then 
    private.zz_wardwindow.StartConditions();
  end;

  private.zz_wardwindow.state = ng_global.progress[ ng_global.currentprogress ][ "win_wardwindow" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_mermaidsward();
  
  if cmn.IsEventDone("clk_mermaidswardfirst") and not cmn.IsEventDone("get_mermaidmedallion") then
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_mermaidsward_dialog_mermaid";
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_mermaidsward_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_mermaidsward_env");
  
  if cmn.IsEventDone("use_magicpage") then
    cmn.Lock( 1 );
  end;
  
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(6) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_puzzlepiece1()

  local item = "inv_puzzlepiece1";

  if cmn.ApplyObj( item, "gzz_mermaidsward_ecoposter" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_ecoposter" );

  elseif ( cmn.ApplyObj( item, "obj_ecoposter_use_puzzlepieces" ) ) then

    cmn.CallEventHandler( "use_puzzlepiece1_inv" );
    cmn.CallEventHandler( "use_puzzlepiece1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_puzzlepiece1" );
      cmn.CallEventHandler( "use_puzzlepiece1_end" );
      
      if cmn.IsEventDone("use_puzzlepiece2") and cmn.IsEventDone("use_puzzlepiece3") and cmn.IsEventDone("use_puzzlepiece4") then
        common.CloseSubRoom();
        cmn.GotoRoom("mg_onposter");
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");

    ObjAnimate( "spr_ecoposter_puzzlepiece_1", "alp", 0, 0, func_after,
    {
      0.0, 0, 0, 
      0.3, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_puzzlepiece2()

  local item = "inv_puzzlepiece2";

  if cmn.ApplyObj( item, "gzz_mermaidsward_ecoposter" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_ecoposter" );

  elseif ( cmn.ApplyObj( item, "obj_ecoposter_use_puzzlepieces" ) ) then

    cmn.CallEventHandler( "use_puzzlepiece2_inv" );
    cmn.CallEventHandler( "use_puzzlepiece2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_puzzlepiece2" );
      cmn.CallEventHandler( "use_puzzlepiece2_end" );
      
      if cmn.IsEventDone("use_puzzlepiece1") and cmn.IsEventDone("use_puzzlepiece3") and cmn.IsEventDone("use_puzzlepiece4") then
        common.CloseSubRoom();
        cmn.GotoRoom("mg_onposter");
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");

    ObjAnimate( "spr_ecoposter_puzzlepiece_2", "alp", 0, 0, func_after,
    {
      0.0, 0, 0, 
      0.3, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_puzzlepiece3()

  local item = "inv_puzzlepiece3";

  if cmn.ApplyObj( item, "gzz_mermaidsward_ecoposter" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_ecoposter" );

  elseif ( cmn.ApplyObj( item, "obj_ecoposter_use_puzzlepieces" ) ) then

    cmn.CallEventHandler( "use_puzzlepiece3_inv" );
    cmn.CallEventHandler( "use_puzzlepiece3_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_puzzlepiece3" );
      cmn.CallEventHandler( "use_puzzlepiece3_end" );
      
      if cmn.IsEventDone("use_puzzlepiece1") and cmn.IsEventDone("use_puzzlepiece2") and cmn.IsEventDone("use_puzzlepiece4") then
        common.CloseSubRoom();
        cmn.GotoRoom("mg_onposter");
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");

    ObjAnimate( "spr_ecoposter_puzzlepiece_3", "alp", 0, 0, func_after,
    {
      0.0, 0, 0, 
      0.3, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_puzzlepiece4()

  local item = "inv_puzzlepiece4";

  if cmn.ApplyObj( item, "gzz_mermaidsward_ecoposter" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_ecoposter" );

  elseif ( cmn.ApplyObj( item, "obj_ecoposter_use_puzzlepieces" ) ) then

    cmn.CallEventHandler( "use_puzzlepiece4_inv" );
    cmn.CallEventHandler( "use_puzzlepiece4_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_puzzlepiece4" );
      cmn.CallEventHandler( "use_puzzlepiece4_end" );
      
      if cmn.IsEventDone("use_puzzlepiece1") and cmn.IsEventDone("use_puzzlepiece2") and cmn.IsEventDone("use_puzzlepiece3") then
        common.CloseSubRoom();
        cmn.GotoRoom("mg_onposter");
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");

    ObjAnimate( "spr_ecoposter_puzzlepiece_4", "alp", 0, 0, func_after,
    {
      0.0, 0, 0, 
      0.3, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_knife()

  local item = "inv_knife";

  if cmn.ApplyObj( item, "gzz_mermaidsward_wardwindow" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_wardwindow" );

  elseif ( cmn.ApplyObj( item, "obj_wardwindow_use_knife" ) ) then

    cmn.CallEventHandler( "use_knife_inv" );
    cmn.CallEventHandler( "use_knife_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_knife" );
      cmn.CallEventHandler( "use_knife_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_mermaidsward/audio/aud_use_knife3");

    ObjSet("anm_wardwindow_use_knife",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_windowhandle()

  local item = "inv_windowhandle";

  if cmn.ApplyObj( item, "gzz_mermaidsward_wardwindow" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_wardwindow" );

  elseif ( cmn.ApplyObj( item, "obj_wardwindow_use_windowhandle" ) ) then

    cmn.CallEventHandler( "use_windowhandle_inv" );
    cmn.CallEventHandler( "use_windowhandle_beg" );

    local func_after = function ()

      cmn.Lock( 0 );
      cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_window_env");

      cmn.SetEventDone( "use_windowhandle" );
      cmn.CallEventHandler( "use_windowhandle_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_mermaidsward/audio/aud_use_handle_window");

    ObjSet("anm_wardwindow_use_handle",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_nuts()

  local item = "inv_nuts";

  if cmn.ApplyObj( item, "gzz_mermaidsward_wardwindow" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_wardwindow" );

  elseif ( cmn.ApplyObj( item, "obj_wardwindow_use_nuts" ) and cmn.IsEventDone("use_windowhandle") ) then

    cmn.CallEventHandler( "use_nuts_inv" );
    cmn.CallEventHandler( "use_nuts_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_nuts" );
      cmn.CallEventHandler( "use_nuts_end" );
      
      cmn.MiniGameShow();
    
    end;
    
    local anm_leaves = function ()
      
      ObjAnimate("obj_wardwindow_leaves_on", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1,     1.3, 0, 1,    1.6, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_mermaidsward/audio/aud_use_nuts");

    ObjAnimate( "obj_wardwindow_game_nuts", "alp", 0, 0, anm_leaves,
    {
      0.0, 0, 0, 
      0.5, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pendandwithsucker()

  local item = "inv_pendandwithsucker";

  if cmn.ApplyObj( item, "gzz_mermaidsward_chestofdrawers" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_chestofdrawers" );

  elseif ( cmn.ApplyObj( item, "obj_chestofdrawers_use_pendandwithsucker" ) ) then

    cmn.CallEventHandler( "use_pendandwithsucker_inv" );
    cmn.CallEventHandler( "use_pendandwithsucker_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pendandwithsucker" );
      cmn.CallEventHandler( "use_pendandwithsucker_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_mermaidsward/audio/aud_use_sucker");

    ObjSet("anm_chestofdrawers_drawer_open",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_magicpage()

  local item = "inv_magicpage";

  if ( cmn.ApplyObj( item, "obj_mermaidsward_use_magicpage" ) and cmn.CheckMultiObject( "magicpage", 6 ) ) then

    cmn.CallEventHandler( "use_magicpage_inv" );
    cmn.CallEventHandler( "use_magicpage_beg" );

    local func_after = function ()

      --cmn.Lock( 0 );

      --cmn.SetEventDone( "use_magicpage" );
      cmn.CallEventHandler( "use_magicpage_end" );
      
      ObjSet("rm_mermaidsward",  { color_r = 0, color_g = 0, color_b = 0 });
      cmn.GotoRoom("rm_atshore");
      cmn.CallEventHandler( "opn_atshoremagicpage_task" );
    
    end;

    cmn.SetEventDone( "use_magicpage" );
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level2/rm_mermaidsward/vid_totale", func_after, "assets/levels/level2/rm_mermaidsward/audio/aud_teleport2", "");

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_cutters()

  cmn.SetEventDone( "get_cutters" );
  cmn.CallEventHandler( "get_cutters" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_cosmeticsbag()
  
  ObjSet("spr_wardwindow_cosmeticsbag",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_cosmeticsbag" );
  cmn.CallEventHandler( "get_cosmeticsbag" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_puzzlepiece4()

  cmn.SetEventDone( "get_puzzlepiece4" );
  cmn.CallEventHandler( "get_puzzlepiece4" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_mermaidfigurine()

  cmn.SetEventDone( "get_mermaidfigurine" );
  cmn.CallEventHandler( "get_mermaidfigurine" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_mermaidmedallion()
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_mermaidmedallion_end" );
    
    common_impl.PlayBackgroundMusic();

  end;

  cmn.SetEventDone( "get_mermaidmedallion" );
  cmn.CallEventHandler( "get_mermaidmedallion_inv" );
  cmn.CallEventHandler( "get_mermaidmedallion_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  ObjAnimate("obj_mermaidsward_dialog_mermaid", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.5, 0, 0 });

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function public.clk_mermaidswardfirst()
  
  cmn.SetEventDone("clk_mermaidswardfirst");
  cmn.Lock( 1 );
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  
  ObjAttach("obj_mermaidsward_dialog_mermaid", "rm_mermaidsward");
  ObjAnimate("obj_mermaidsward_dialog_mermaid", "alp", 0, 0, private.dialog_mermaid_beg, { 0, 0, 0,   0.5, 0, 1 });
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_mermaidsward()

  if not ( cmn.IsEventDone( "opn_mermaidsward" ) ) then
    cmn.SetEventDone( "opn_mermaidsward" );
    cmn.CallEventHandler("opn_mermaidsward");
    cmn.ShowBbt( "mermaidsward_open" );
  end;
  
  if cmn.IsEventDone("use_magicpage") then
    
    local func_after = function ()

      ObjSet("rm_mermaidsward",  { color_r = 0, color_g = 0, color_b = 0 });
      cmn.GotoRoom("rm_atshore");
      cmn.CallEventHandler( "opn_atshoremagicpage_task" );
    
    end;

    cmn.Lock( 0 );
    
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level2/rm_mermaidsward/vid_totale", func_after, "assets/levels/level2/rm_mermaidsward/audio/aud_teleport2", "");
    
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_window_bag()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_wardwindow_use_knife" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_purse/audio/aud_xx_clk_cloth");
  
  ObjSet("anm_wardwindow_bag_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_window()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_wardwindow_use_windowhandle" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_mermaidsward/audio/aud_xx_opn_window");
  
  ObjSet("anm_wardwindow_window_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_drawer()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_chestofdrawers_use_pendandwithsucker" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_mermaidsward/audio/aud_xx_clk_drawer1");
  
  ObjSet("anm_chestofdrawers_drawer_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_squirrel()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_wardwindow_use_nuts" );
  cmn.PlayAudio("snd", "assets/levels/level2/rm_mermaidsward/audio/aud_xx_squirrel");
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_wardwindow_squirrel_1_touch", { alp = 0 }},
                   {"anm_wardwindow_squirrel_1_hand", { alp = 1, playing = 1 }} } );
    
  end;
  
  ObjMultiSet( { {"anm_wardwindow_squirrel_1_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_wardwindow_squirrel_1_hand", { alp = 0, playing = 0 }},
                 {"anm_wardwindow_squirrel_2_scratch", { playing = 1 }} } );
  
end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_6_1", { alp = 1 }},
                 {"spr_col_6_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_6_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_6_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_6_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_6_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_6_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_6_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_mermaid_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "mermaidsward", "mermaid", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "clk_mermaidswardfirst" );
    cmn.ShowBbt( "mermaidsward_after_dialog" );
    interface_impl.ShowGlobalTask();
    
  end;
  
  local anm_give = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_mermaidsward_dialog_mermaid_lipsync4");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_mermaidsward_dialog_mermaid_timer", { playing = 0 }},
                   {"anm_mermaidsward_dialog_mermaid_head", { alp = 1 }} } );
    
    ObjAnimate("obj_mermaidsward_dialog_mermaid_hand", "alp", 0, 0, dialog_end, { 0, 0, 0,   0.5, 0, 1 });
    ObjAnimate("anm_mermaidsward_dialog_mermaid_medalion", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    
  end;
  local mermaid_talks4 = function ()
  
    ObjDelete("vid_mermaidsward_dialog_mermaid_lipsync3");
    ObjAttach("vid_mermaidsward_dialog_mermaid_lipsync4", "obj_mermaidsward_dialog_mermaid");
  
    cmn.ShowDlgBbt( "dlg_mermaid_phrase_4" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level2/rm_mermaidsward/audio/aud_mermaid_dlg1_6_voc");
    private.dlg_lipsync = "vid_mermaidsward_dialog_mermaid_lipsync4";
    
    ObjMultiSet( { {"tmr_mermaidsward_dialog_mermaid_timer", { endtrig = anm_give, time = 7, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_give }},
                   {"obj_character_dialog_continue", { event_mup = anm_give }},
                   {"vid_mermaidsward_dialog_mermaid_lipsync4", { playing = 1 }} } );
  
  end;
                 
  local mermaid_talks3 = function ()
  
    ObjAttach("vid_mermaidsward_dialog_mermaid_lipsync3", "obj_mermaidsward_dialog_mermaid");
  
    cmn.ShowDlgBbt( "dlg_mermaid_phrase_3" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level2/rm_mermaidsward/audio/aud_mermaid_dlg1_5_voc");
    private.dlg_lipsync = "vid_mermaidsward_dialog_mermaid_lipsync3";
    
    ObjMultiSet( { {"tmr_mermaidsward_dialog_mermaid_timer", { endtrig = mermaid_talks4, time = 8.8, playing = 1 }},
                   {"vid_mermaidsward_dialog_mermaid_lipsync3", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = mermaid_talks4 }},
                   {"obj_character_dialog_continue", { event_mup = mermaid_talks4 }},
                   {"anm_mermaidsward_dialog_mermaid_head", { alp = 0 }} } );
  
  end;
                 
  local cindy_talks2 = function ()
  
    ObjDelete("vid_mermaidsward_dialog_mermaid_lipsync2");
  
    cmn.ShowDlgBbt( "dlg_mermaid_answer_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level2/rm_mermaidsward/audio/aud_mermaid_dlg1_4_voc");
    private.dlg_lipsync = "";
    
    ObjMultiSet( { {"tmr_mermaidsward_dialog_mermaid_timer", { endtrig = mermaid_talks3, time = 7.2, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = mermaid_talks3 }},
                   {"obj_character_dialog_continue", { event_mup = mermaid_talks3 }},
                   {"anm_mermaidsward_dialog_mermaid_head", { alp = 1 }} } );
  
  end;                
  
  local mermaid_talks2 = function ()
  
    ObjAttach("vid_mermaidsward_dialog_mermaid_lipsync2", "obj_mermaidsward_dialog_mermaid");
  
    cmn.ShowDlgBbt( "dlg_mermaid_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level2/rm_mermaidsward/audio/aud_mermaid_dlg1_3_voc");
    private.dlg_lipsync = "vid_mermaidsward_dialog_mermaid_lipsync2";
    
    ObjMultiSet( { {"tmr_mermaidsward_dialog_mermaid_timer", { endtrig = cindy_talks2, time = 7.2, playing = 1 }},
                   {"vid_mermaidsward_dialog_mermaid_lipsync2", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = cindy_talks2 }},
                   {"obj_character_dialog_continue", { event_mup = cindy_talks2 }},
                   {"anm_mermaidsward_dialog_mermaid_head", { alp = 0 }} } );
  
  end;
                 
  local cindy_talks1 = function ()
  
    ObjDelete("vid_mermaidsward_dialog_mermaid_lipsync1");
  
    cmn.ShowDlgBbt( "dlg_mermaid_answer_1" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level2/rm_mermaidsward/audio/aud_mermaid_dlg1_2_voc");
    private.dlg_lipsync = "";
    
    ObjMultiSet( { {"tmr_mermaidsward_dialog_mermaid_timer", { endtrig = mermaid_talks2, time = 2, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = mermaid_talks2 }},
                   {"obj_character_dialog_continue", { event_mup = mermaid_talks2 }},
                   {"anm_mermaidsward_dialog_mermaid_head", { alp = 1 }} } );
  
  end;               

  private.dlg_lipsync = "vid_mermaidsward_dialog_mermaid_lipsync1";

  cmn.ShowDlgBbt( "dlg_mermaid_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level2/rm_mermaidsward/audio/aud_mermaid_dlg1_1_voc");

  ObjMultiSet( { {"tmr_mermaidsward_dialog_mermaid_timer", { time = 3, playing = 1, endtrig = cindy_talks1 }},
                 {"vid_mermaidsward_dialog_mermaid_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = cindy_talks1 }},
                 {"obj_character_dialog_continue", { event_mup = cindy_talks1 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_mermaid()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  common_impl.current_dialog = "";

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "clk_mermaidswardfirst" );
    cmn.ShowBbt( "mermaidsward_after_dialog" );
    interface_impl.ShowGlobalTask();
    
  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  ObjMultiSet( { {"tmr_mermaidsward_dialog_mermaid_timer", { playing = 0 }},
                 {"anm_mermaidsward_dialog_mermaid_head", { alp = 1 }} } );
                 
  common_impl.CharacterDialogButtonsHide();
  ObjAnimate("obj_mermaidsward_dialog_mermaid_hand", "alp", 0, 0, func_after_dlg, { 0, 0, 0,   0.5, 0, 1 });
  ObjAnimate("anm_mermaidsward_dialog_mermaid_medalion", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Wardwindow *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_wardwindow = {};
public.zz_wardwindow = {};

function private.Init_Wardwindow()
  
  private.zz_wardwindow.nuts_pos_home = {
    { {-87, 197}, {-122, 205}, {-76, 217}, {-132, 224}, {-98, 232} },
    { {114, 192}, {133, 210} },
    { {26, 185}, {-7, 208}, {43, 212} }
  };
  private.zz_wardwindow.nuts_pos_leaves = {
    
    {
      { {-209, 69}, {-177, 59}, {-192, 64}, {-211, 54}, {-179, 52} },
      { {-213, 46}, {-218, 29} },
      { {-175, 20}, {-166, 41}, {-198, 18} }
    },
    
    {
      { {-144, -32}, {-88, -32}, {-71, -30}, {-121, -42}, {-89, -44} },
      { {-128, -59}, {-134, -44} },
      { {-96, -72}, {-87, -51}, {-111, -71} }
    },
    
    {
      { {-10, -79}, {4, -72}, {18, -88}, {24, -75}, {7, -83} },
      { {-36, -94}, {4, -96} },
      { {-5, -115}, {10, -108}, {-18, -96} }
    }
    
  };
  
  private.zz_wardwindow.win_state = { { 1, 2, 3, 3, 3 }, { 1, 2 }, { 1, 2, 3 } };
  -----------------------------------------------------------------------------------
  local win_wardwindow = function ()

    if cmn.IsEventDone( "win_wardwindow" ) then
      
      ObjDelete("anm_wardwindow_squirrel_3");
      ObjDelete("anm_wardwindow_squirrel_3_win");
      ObjDelete("anm_wardwindow_squirrel_3_win_2");
      ObjDelete("anm_wardwindow_squirrel_2");
      ObjDelete("anm_wardwindow_squirrel_2_angry");
      ObjDelete("anm_wardwindow_squirrel_2_scratch");
      ObjDelete("anm_wardwindow_squirrel_1");
      ObjDelete("anm_wardwindow_squirrel_1_angry");
      ObjDelete("anm_wardwindow_squirrel_1_hand");
      
      ObjDelete("spr_mermaidsward_zz_wardwindow_seed");
      ObjDelete("anm_mermaidsward_squirrels");

      ObjMultiSet( { {"anm_wardwindow_squirrel_3_end", { alp = 1 }},
                     {"anm_wardwindow_squirrel_2_end", { alp = 1 }},
                     {"anm_wardwindow_squirrel_1_end", { alp = 1 }},
                     {"obj_wardwindow_puzzlepiece4", { alp = 1, input = 1 }},
                     {"obj_wardwindow_game", { input = 0 }},
                     {"obj_wardwindow_squirrels", { input = 0 }},
                     {"spr_mermaidsward_zz_wardwindow_seed_winmmg", { alp = 1 }},
                     {"spr_mermaidsward_zz_wardwindow_puzzle_4", { alp = 1 }},
                     {"anm_mermaidsward_squirrels_2", { alp = 1 }} } );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_wardwindow", win_wardwindow, "rm_mermaidsward" );
  
end;
--*********************************************************************************************************************
function private.zz_wardwindow.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_wardwindow" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_wardwindow" ].state = { { 0, 0, 0, 0, 0 }, { 0, 0 }, { 0, 0, 0 } }; --pos of nuts 0 - window, 1-3 - leaves
  
end;
-----------------------------------------------------------------------------------
function public.zz_wardwindow.Reset()
  
  local need_r = false;
  
  for i = 1, #private.zz_wardwindow.state, 1 do
    for j = 1, #private.zz_wardwindow.state[i], 1 do
      
      if private.zz_wardwindow.state[i][j] > 0 then
        
        if not need_r then
          need_r = true;
        end;
        
        local leaf = private.zz_wardwindow.state[i][j];
        
        ObjAttach("spr_wardwindow_nut_"..i.."_"..j, "obj_wardwindow_game_nuts_fly");
        
        ObjAnimate("spr_wardwindow_nut_"..i.."_"..j.."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.4, 0, 0,    0.5, 0, 1 });
        ObjAnimate("spr_wardwindow_nut_"..i.."_"..j, "pos_xy", 0, 0, "", {
            0, 0, private.zz_wardwindow.nuts_pos_leaves[ leaf ][i][j][1], private.zz_wardwindow.nuts_pos_leaves[ leaf ][i][j][2],
          0.5, 0, private.zz_wardwindow.nuts_pos_home[i][j][1], private.zz_wardwindow.nuts_pos_home[i][j][2]
        });
        
      end;
      
    end;
  end;
    
  if need_r then
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
    
    private.zz_wardwindow.StartConditions();
    private.zz_wardwindow.state = ng_global.progress[ ng_global.currentprogress ][ "win_wardwindow" ].state;
    
    ObjSet("tmr_wardwindow_game_timer",  { time = 0.5, playing = 1, endtrig = function() cmn.Lock(0); private.zz_wardwindow.DrawScene(); end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_wardwindow.Skip()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_wardwindow" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_wardwindow" ].state = { { 1, 2, 3, 3, 3 }, { 1, 2 }, { 1, 2, 3 } };
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  
  for i = 1, #private.zz_wardwindow.state, 1 do
    for j = 1, #private.zz_wardwindow.state[i], 1 do
      
      if private.zz_wardwindow.state[i][j] ~= private.zz_wardwindow.win_state[i][j] then
        
        if not need_r then
          need_r = true;
        end;
        
        local leaf1 = private.zz_wardwindow.state[i][j];
        local leaf2 = private.zz_wardwindow.win_state[i][j];
        local start_pos_x = private.zz_wardwindow.nuts_pos_home[i][j][1];
        local start_pos_y = private.zz_wardwindow.nuts_pos_home[i][j][2];
  
        ObjAttach("spr_wardwindow_nut_"..i.."_"..j, "obj_wardwindow_game_nuts_fly");
        
        if leaf1 == 0 then
          ObjAnimate("spr_wardwindow_nut_"..i.."_"..j.."_sh", "alp", 0, 0, "", { 0, 0, 1,   0.1, 0, 0 });
        else 
          start_pos_x = private.zz_wardwindow.nuts_pos_leaves[ leaf1 ][i][j][1];
          start_pos_y = private.zz_wardwindow.nuts_pos_leaves[ leaf1 ][i][j][2];
        end;
        
        ObjAnimate("spr_wardwindow_nut_"..i.."_"..j, "pos_xy", 0, 0, "", {
            0, 0, start_pos_x, start_pos_y,
          0.5, 0, private.zz_wardwindow.nuts_pos_leaves[ leaf2 ][i][j][1], private.zz_wardwindow.nuts_pos_leaves[ leaf2 ][i][j][2]
        });
        
      end;
      
    end;
  end;
  
  private.zz_wardwindow.state = ng_global.progress[ ng_global.currentprogress ][ "win_wardwindow" ].state;
    
  ObjSet("tmr_wardwindow_game_timer",  { time = 0.5, playing = 1, endtrig = function() private.zz_wardwindow.DrawScene(); private.zz_wardwindow.CheckWin(); end });
  
end;
-----------------------------------------------------------------------------------
function private.zz_wardwindow.DrawScene()
  
  for i = 1, #private.zz_wardwindow.state, 1 do
    for j = 1, #private.zz_wardwindow.state[i], 1 do
      
      if private.zz_wardwindow.state[i][j] == 0 then
        ObjAttach("spr_wardwindow_nut_"..i.."_"..j, "obj_wardwindow_game_nuts");
        ObjMultiSet( { {"spr_wardwindow_nut_"..i.."_"..j, { pos_x = private.zz_wardwindow.nuts_pos_home[i][j][1], pos_y = private.zz_wardwindow.nuts_pos_home[i][j][2] }},
                       {"spr_wardwindow_nut_"..i.."_"..j.."_sh", { alp = 1 }} } );
      else       
        ObjAttach("spr_wardwindow_nut_"..i.."_"..j, "obj_wardwindow_leaf_nuts_"..private.zz_wardwindow.state[i][j]);               
        local leaf = private.zz_wardwindow.state[i][j];
        ObjMultiSet( { {"spr_wardwindow_nut_"..i.."_"..j, { pos_x = private.zz_wardwindow.nuts_pos_leaves[ leaf ][i][j][1], pos_y = private.zz_wardwindow.nuts_pos_leaves[ leaf ][i][j][2] }},
                       {"spr_wardwindow_nut_"..i.."_"..j.."_sh", { alp = 0 }} } );              
      end;
                     
    end;
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_wardwindow.FocusNut( typ, num, inout )
  
  local obj = "spr_wardwindow_nut_"..typ.."_"..num;
  local scale = ObjGet( obj ).scale_x;
  local tme = 0;
  local max_scale = 1.2;  
  local max_tme = 0.3;
  local end_scale = 1;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = ( ( scale - 1 ) * max_tme ) / ( max_scale - 1 );
  else 
    SetCursor(CURSOR_GET);
    end_scale = max_scale;
    tme = ( ( max_scale - scale ) * max_tme ) / ( max_scale - 1 );
    if tme > 0.15 then
      cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_menter1");
    end;
  end;

  ObjAnimate(obj, "scale_xy", 0, 0, "", { 0, 2, scale, scale,   tme, 2, end_scale, end_scale });
  
end;    
-----------------------------------------------------------------------------------
function public.zz_wardwindow.StartDrag( typ, num )
  
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  
  ObjAttach("spr_wardwindow_nut_"..typ.."_"..num, "obj_wardwindow_game_nuts_fly");
  
  if private.zz_wardwindow.state[typ][num] == 0 then
    ObjAnimate("spr_wardwindow_nut_"..typ.."_"..num.."_sh", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 });
  end;
  
end; 
-----------------------------------------------------------------------------------
function public.zz_wardwindow.DropNut( typ, num )
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menter_ho");
  
  local leaf = 0;
  local item = "spr_wardwindow_nut_"..typ.."_"..num;
  local curs = GetZoomCursorPos();
  curs[1] = curs[1] - ObjGet("zz_wardwindow").pos_x;
  curs[2] = curs[2] - ObjGet("zz_wardwindow").pos_y;
  
  for i = 3, 1, -1 do
    
    if cmn.ApplyObj( item, "spr_wardwindow_leaf_"..i ) then
      leaf = i;
      break;
    end;
    
  end;
  
  if private.zz_wardwindow.state[typ][num] ~= leaf then
    private.zz_wardwindow.state[typ][num] = leaf;
  end;
  
  local end_pos_x = private.zz_wardwindow.nuts_pos_home[typ][num][1];
  local end_pos_y = private.zz_wardwindow.nuts_pos_home[typ][num][2];
  
  if leaf > 0 then
    end_pos_x = private.zz_wardwindow.nuts_pos_leaves[ leaf ][typ][num][1];
    end_pos_y = private.zz_wardwindow.nuts_pos_leaves[ leaf ][typ][num][2];
  end;
  
  local point_a, point_b = {}, {};
  point_a[1] = curs[1];
  point_a[2] = curs[2];
  point_b[1] = end_pos_x;
  point_b[2] = end_pos_y;
  local len = common_impl.math.FindSegmentLength( point_a, point_b );
  local tme = 0.002 * len;
  
  if tme > 0.4 then
    tme = 0.4;
  end;
  
  local func_after = function ()
    
    if private.zz_wardwindow.state[typ][num] == 0 then
      ObjAttach(item, "obj_wardwindow_game_nuts");
    else 
      ObjAttach(item, "obj_wardwindow_leaf_nuts_"..private.zz_wardwindow.state[typ][num]);
    end;
    private.zz_wardwindow.CheckWin();
    
  end;

  ObjAnimate(item, "pos_xy", 0, 0, func_after, { 0, 0, curs[1], curs[2],   tme, 0, end_pos_x, end_pos_y });
  
  if leaf == 0 then
    if tme > 0.1 then
      ObjAnimate(item.."_sh", "alp", 0, 0, "", { 0, 0, 0,   tme-0.1, 0, 0,    tme, 0, 1 });
    else 
      ObjAnimate(item.."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.1, 0, 1 });
    end;
  end;
  
end;            
-----------------------------------------------------------------------------------
function private.zz_wardwindow.CheckWin()
  
  local nuts = {0, 0, 0};
  local win_flag = true;
  
  for i = 1, #private.zz_wardwindow.state, 1 do
    
    for j = 1, #private.zz_wardwindow.state[i], 1 do
      
      if private.zz_wardwindow.state[i][j] == 0 then
        win_flag = false;
        break;
      else 
        nuts[ private.zz_wardwindow.state[i][j] ] = nuts[ private.zz_wardwindow.state[i][j] ] + i;
      end;
      
    end;
    
    if not win_flag then
      break;
    end;
    
  end;
  
  if win_flag and nuts[1] == nuts[2] and nuts[3] == nuts[2] then
    
    cmn.Lock( 1 );
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("wardwindow");
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_mermaidsward/audio/aud_eat_squirrel");
    
    ObjDelete("anm_wardwindow_squirrel_3");

    ObjMultiSet( { {"anm_wardwindow_squirrel_3_win",  { alp = 1, playing = 1, endtrig = private.zz_wardwindow.Win_anim }},
                   {"anm_wardwindow_squirrel_3_win_2", { alp = 1, playing = 1 }} } );
    
  elseif win_flag then
                   
    cmn.Lock( 1 );      
    cmn.PlayAudio("snd", "assets/levels/level2/rm_mermaidsward/audio/aud_angry_squirrel");

    local func_after_2 = function ()
  
      ObjMultiSet( { {"anm_wardwindow_squirrel_1_angry", { alp = 0 }},
                     {"anm_wardwindow_squirrel_1", { alp = 1, playing = 1 }},
                     {"anm_wardwindow_squirrel_1_hand", { alp = 1, playing = 1 }} } );
  
    end;  
                 
    local func_after_1 = function ()
  
      ObjMultiSet( { {"anm_wardwindow_squirrel_2_angry", { alp = 0 }},
                     {"anm_wardwindow_squirrel_2", { alp = 1, playing = 1 }},
                     {"anm_wardwindow_squirrel_2_scratch", { alp = 1 }} } );
  
    end;               
                   
    local anm_2 = function ()

      ObjMultiSet( { {"tmr_wardwindow_game_timer",  { time = 0.3, playing = 1, endtrig = public.zz_wardwindow.Reset }},
                     {"anm_wardwindow_squirrel_1_angry", { alp = 1, playing = 1, endtrig = func_after_2 }},
                     {"anm_wardwindow_squirrel_1", { alp = 0, playing = 0 }},
                     {"anm_wardwindow_squirrel_1_hand", { alp = 0, playing = 0 }} } );

    end;  

    local anm_1 = function ()

      ObjMultiSet( { {"tmr_wardwindow_game_timer",  { time = 0.14, playing = 1, endtrig = anm_2 }},
                     {"anm_wardwindow_squirrel_2_angry", { alp = 1, playing = 1, endtrig = func_after_1}},
                     {"anm_wardwindow_squirrel_2", { alp = 0, playing = 0 }},
                     {"anm_wardwindow_squirrel_2_scratch", { alp = 0 }} } );

    end;    
    
    ObjSet("tmr_wardwindow_game_timer",  { time = 0.3, playing = 1, endtrig = anm_1 });
    
  else 
    
    cmn.Lock(0);
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_wardwindow.Win_anim()
  
  ObjAnimate("anm_wardwindow_squirrel_3_win", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  ObjAnimate("anm_wardwindow_squirrel_3_win_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  ObjAnimate("anm_wardwindow_squirrel_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  ObjAnimate("anm_wardwindow_squirrel_2_scratch", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  ObjAnimate("anm_wardwindow_squirrel_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  ObjAnimate("anm_wardwindow_squirrel_1_hand", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  ObjAnimate("anm_wardwindow_squirrel_1_end", "alp", 0, 0, private.zz_wardwindow.Win, { 0, 0, 0,   0.3, 0, 1 });
  ObjAnimate("anm_wardwindow_squirrel_2_end", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
  ObjAnimate("anm_wardwindow_squirrel_2_end", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
end;
-----------------------------------------------------------------------------------
function private.zz_wardwindow.Win()
  
  common_impl.PauseAchiev(0);
  
  ObjSet("anm_wardwindow_squirrel_3_end",  { playing = 1 });

  cmn.SetEventDone( "win_wardwindow" );
  cmn.CallEventHandler( "win_wardwindow" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_wardwindow" ].skip == 0 and ng_global.noskipgames[ "win_wardwindow" ] == nil then

    ng_global.noskipgames[ "win_wardwindow" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

  cmn.Lock( 0 );
  
end;
--******************************************************************************************************************