-- name=inventory3
--*********************************************************************************************************************
function public.Init()
  
  if port.isPortable() == 1 then
    port.InventoryPopupInit("inventory3_hub");
    port.VideoResizeInRoom("inventory3");
  end;
  --------------------------------------------------------------------------------------------
  -- function get_enchantedhorn () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_enchantedhorn" ] = {

      type = "get",
      get_obj = "obj_complex_brokenbugle_enchantedhorn",
      room = "int_complex_inv",
      zz = "inv_complex_brokenbugle",
      zz_gate = "inv_brokenbugle"
  };
  --------------------------------------------------------------------------------------------
  local get_enchantedhorn_inv = function ()

    interface.InventoryItemRemove( "inv_brokenbugle" );
    interface.InventoryItemAdd( "inv_enchantedhorn", "obj_complex_brokenbugle_enchantedhorn" );

    ObjDelete("gfx_complex_brokenbugle_enchantedhorn");

  end;
  cmn.AddSubscriber( "get_enchantedhorn", get_enchantedhorn_inv );
  --------------------------------------------------------------------------------------------
  -- function get_lockpick () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lockpick" ] = {

      type = "get",
      get_obj = "spr_complex_lvl3wire_lockpick",
      room = "int_complex_inv",
      zz = "inv_complex_lvl3wire",
      zz_gate = "inv_lvl3wire"
  };
  --------------------------------------------------------------------------------------------
  local get_lockpick_inv = function ()

    interface.InventoryItemRemove( "inv_lvl3wire" );
    interface.InventoryItemAdd( "inv_lockpick", "spr_complex_lvl3wire_lockpick" );

    ObjDelete("gfx_complex_lvl3wire_lockpick");

  end;
  cmn.AddSubscriber( "get_lockpick", get_lockpick_inv );
  --------------------------------------------------------------------------------------------
  -- function get_mirrorshard3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_mirrorshard3" ] = {

      type = "get",
      get_obj = "spr_complex_casket_mirrorshard3",
      room = "int_complex_inv",
      zz = "inv_complex_casket",
      zz_gate = "inv_casket"
  };
  --------------------------------------------------------------------------------------------
  local get_mirrorshard3_inv = function ()

    if cmn.IsEventDone("get_copperfeather2") then
      interface.InventoryItemRemove( "inv_casket" );
    end;
    
    interface.InventoryItemAdd( "inv_mirrorshard", "spr_complex_casket_mirrorshard3", function () cmn.GetMultyObject( 'mirrorshard', 3 ); end );

    ObjDelete("gfx_complex_casket_mirrorshard3");
    ObjDelete( "spr_complex_casket_shadow_mirrorshard3" );
    ObjDelete( "spr_complex_casket_mirrorshard3_shadow" );

  end;
  cmn.AddSubscriber( "get_mirrorshard3", get_mirrorshard3_inv );
  --------------------------------------------------------------------------------------------
  -- function get_copperfeather2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_copperfeather2" ] = {

      type = "get",
      get_obj = "spr_complex_casket_copperfeather2",
      room = "int_complex_inv",
      zz = "inv_complex_casket",
      zz_gate = "inv_casket"
  };
  --------------------------------------------------------------------------------------------
  local get_copperfeather2_inv = function ()

    if cmn.IsEventDone("get_mirrorshard3") then
      interface.InventoryItemRemove( "inv_casket" );
    end;
    
    interface.InventoryItemAdd( "inv_copperfeather", "spr_complex_casket_copperfeather2", function () cmn.GetMultyObject( 'copperfeather', 2 ); end );

    ObjDelete("gfx_complex_casket_copperfeather2");
    ObjDelete("spr_complex_casket_feather_shadow");

  end;
  cmn.AddSubscriber( "get_copperfeather2", get_copperfeather2_inv );
  --------------------------------------------------------------------------------------------
  -- function get_poisonedseeds () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_poisonedseeds" ] = {

      type = "get",
      get_obj = "obj_complex_juicyapple_poisonedseeds",
      room = "int_complex_inv",
      zz = "inv_complex_juicyapple",
      zz_gate = "inv_juicyapple"
  };
  --------------------------------------------------------------------------------------------
  local get_poisonedseeds_inv = function ()

    interface.InventoryItemRemove( "inv_juicyapple" );
    interface.InventoryItemAdd( "inv_poisonedseeds", "obj_complex_juicyapple_poisonedseeds" );

    ObjDelete("gfx_complex_juicyapple_poisonedseeds");

  end;
  cmn.AddSubscriber( "get_poisonedseeds", get_poisonedseeds_inv );
  --------------------------------------------------------------------------------------------
  -- function get_pruners () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_pruners" ] = {

      type = "get",
      get_obj = "obj_complex_oldpruners_pruners",
      room = "int_complex_inv",
      zz = "inv_complex_oldpruners",
      zz_gate = "inv_oldpruners"
  };
  --------------------------------------------------------------------------------------------
  local get_pruners_inv = function ()

    interface.InventoryItemRemove( "inv_oldpruners" );
    interface.InventoryItemAdd( "inv_pruners", "obj_complex_oldpruners_pruners" );

    ObjDelete("gfx_complex_oldpruners_pruners");

  end;
  cmn.AddSubscriber( "get_pruners", get_pruners_inv );
  --------------------------------------------------------------------------------------------
  -- function get_policebadge () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_policebadge" ] = {

      type = "get",
      get_obj = "spr_complex_policebadgebase_policebadge",
      room = "int_complex_inv",
      zz = "inv_complex_policebadgebase",
      zz_gate = "inv_policebadgebase"
  };
  --------------------------------------------------------------------------------------------
  local get_policebadge_inv = function ()

    interface.InventoryItemRemove( "inv_policebadgebase" );
    interface.InventoryItemAdd( "inv_policebadge", "spr_complex_policebadgebase_policebadge" );

    ObjDelete("gfx_complex_policebadgebase_policebadge");

  end;
  cmn.AddSubscriber( "get_policebadge", get_policebadge_inv );
  --------------------------------------------------------------------------------------------
  -- function get_themisface () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_themisface" ] = {

      type = "get",
      get_obj = "obj_complex_themisbrokenface_get_face",
      room = "int_complex_inv",
      zz = "inv_complex_themisbrokenface",
      zz_gate = "inv_themisbrokenface"
  };
  --------------------------------------------------------------------------------------------
  local get_themisface_inv = function ()

    interface.InventoryItemRemove( "inv_themisbrokenface" );
    interface.InventoryItemAdd( "inv_themisface", "obj_complex_themisbrokenface_complete_face" );

    ObjDelete("obj_complex_themisbrokenface_get_face");

  end;
  cmn.AddSubscriber( "get_themisface", get_themisface_inv );
  --------------------------------------------------------------------------------------------
  -- function get_token2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_token2" ] = {

      type = "get",
      get_obj = "spr_complex_redhatbackpack_token2",
      room = "int_complex_inv",
      zz = "inv_complex_redhatbackpack",
      zz_gate = "inv_redhatbackpack"
  };
  --------------------------------------------------------------------------------------------
  local get_token2_inv = function ()

    if cmn.IsEventDone("get_redhatpage2") then
      interface.InventoryItemRemove( "inv_redhatbackpack" );
    end;
    
    interface.InventoryItemAdd( "inv_token2", "spr_complex_redhatbackpack_token2" );

    ObjDelete("gfx_complex_redhatbackpack_token2");

  end;
  cmn.AddSubscriber( "get_token2", get_token2_inv );
  --------------------------------------------------------------------------------------------
  -- function get_redhatpage2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_redhatpage2" ] = {

      type = "get",
      get_obj = "spr_complex_redhatbackpack_redhatpage2",
      room = "int_complex_inv",
      zz = "inv_complex_redhatbackpack",
      zz_gate = "inv_redhatbackpack"
  };
  --------------------------------------------------------------------------------------------
  local get_redhatpage2_inv = function ()

    if cmn.IsEventDone("get_token2") then
      interface.InventoryItemRemove( "inv_redhatbackpack" );
    end;
    
    interface.InventoryItemAdd( "inv_redhatpage", "spr_complex_redhatbackpack_redhatpage2", function () cmn.GetMultyObject( 'redhatpage', 4 ); end );

    ObjDelete("gfx_complex_redhatbackpack_redhatpage2");
    ObjDelete("spr_complex_redhatbackpack_redhatpage2_sh");

  end;
  cmn.AddSubscriber( "get_redhatpage2", get_redhatpage2_inv );
  
  --------------------------------------------------------------------------------------------
  -- function use_leavewithstickydew () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_leavewithstickydew" ] = {

      type = "use",
      inv_obj = "inv_leavewithstickydew",
      use_place = "obj_complex_brokenbugle_use_leavewithstickydew",
      room = "int_complex_inv",
      zz = "inv_complex_brokenbugle",
      zz_gate = "inv_brokenbugle"
  };
  --------------------------------------------------------------------------------------------
  local use_leavewithstickydew_inv = function ()

    interface.InventoryItemRemove( "inv_leavewithstickydew" );

  end;
  local use_leavewithstickydew_beg = function ()

    ObjDelete( "obj_complex_brokenbugle_use_leavewithstickydew" );

  end;
  local use_leavewithstickydew_end = function ()

    ObjMultiSet( { { "obj_complex_brokenbugle_enchantedhorn", { input = true } },
                   { "gfx_complex_brokenbugle_enchantedhorn", { active = true } },
                   { "anm_complex_brokenbugle_enchantedhorn", { frame = 60 } } } );

  end;
  cmn.AddSubscriber( "use_leavewithstickydew", use_leavewithstickydew_inv );
  cmn.AddSubscriber( "use_leavewithstickydew", use_leavewithstickydew_beg, "inv_complex_brokenbugle" );
  cmn.AddSubscriber( "use_leavewithstickydew", use_leavewithstickydew_end, "inv_complex_brokenbugle" );
  cmn.AddSubscriber( "use_leavewithstickydew_inv", use_leavewithstickydew_inv );
  cmn.AddSubscriber( "use_leavewithstickydew_beg", use_leavewithstickydew_beg, "inv_complex_brokenbugle" );
  cmn.AddSubscriber( "use_leavewithstickydew_end", use_leavewithstickydew_end, "inv_complex_brokenbugle" );
  --------------------------------------------------------------------------------------------
  -- function use_amuletknot () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_amuletknot" ] = {

      type = "use",
      inv_obj = "inv_amuletknot",
      use_place = "obj_complex_casket_use_amuletknot",
      room = "int_complex_inv",
      zz = "inv_complex_casket",
      zz_gate = "inv_casket"
  };
  --------------------------------------------------------------------------------------------
  local use_amuletknot_inv = function ()

    interface.InventoryItemRemove( "inv_amuletknot" );

  end;
  local use_amuletknot_beg = function ()

    ObjDelete( "obj_complex_casket_use_amuletknot" );

  end;
  local use_amuletknot_end = function ()

    ObjMultiSet( { { "anm_complex_casket_casket", { animfunc = "func_use_amulet", frame = 60 } },
                   { "spr_complex_casket_mirrorshard3", { input = 1 } } } );

  end;
  cmn.AddSubscriber( "use_amuletknot", use_amuletknot_inv );
  cmn.AddSubscriber( "use_amuletknot", use_amuletknot_beg, "inv_complex_casket" );
  cmn.AddSubscriber( "use_amuletknot", use_amuletknot_end, "inv_complex_casket" );
  cmn.AddSubscriber( "use_amuletknot_inv", use_amuletknot_inv );
  cmn.AddSubscriber( "use_amuletknot_beg", use_amuletknot_beg, "inv_complex_casket" );
  cmn.AddSubscriber( "use_amuletknot_end", use_amuletknot_end, "inv_complex_casket" );
  --------------------------------------------------------------------------------------------
  -- function use_applecutter () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_applecutter" ] = {

      type = "use",
      inv_obj = "inv_applecutter",
      use_place = "obj_complex_juicyapple_use_applecutter",
      room = "int_complex_inv",
      zz = "inv_complex_juicyapple",
      zz_gate = "inv_juicyapple"
  };
  --------------------------------------------------------------------------------------------
  local use_applecutter_inv = function ()

    interface.InventoryItemRemove( "inv_applecutter" );

  end;
  local use_applecutter_beg = function ()

    ObjDelete( "obj_complex_juicyapple_use_applecutter" );

  end;
  local use_applecutter_end = function ()

    ObjDelete( "spr_complex_juicyapple_seed_02" );
    ObjDelete( "spr_complex_juicyapple_seed_01" );

    ObjMultiSet( { { "obj_complex_juicyapple_poisonedseeds", { alp = 1, input = 1 } },
                   { "anm_complex_juicyapple_use_apple_cutter", { frame = 36 } },
                   { "gfx_complex_juicyapple_poisonedseeds", { active = true } } } );

  end;
  cmn.AddSubscriber( "use_applecutter", use_applecutter_inv );
  cmn.AddSubscriber( "use_applecutter", use_applecutter_beg, "inv_complex_juicyapple" );
  cmn.AddSubscriber( "use_applecutter", use_applecutter_end, "inv_complex_juicyapple" );
  cmn.AddSubscriber( "use_applecutter_inv", use_applecutter_inv );
  cmn.AddSubscriber( "use_applecutter_beg", use_applecutter_beg, "inv_complex_juicyapple" );
  cmn.AddSubscriber( "use_applecutter_end", use_applecutter_end, "inv_complex_juicyapple" );
  --------------------------------------------------------------------------------------------
  -- function use_bluntblade () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_bluntblade" ] = {

      type = "use",
      inv_obj = "inv_bluntblade",
      use_place = "obj_complex_oldpruners_use_bluntblade",
      room = "int_complex_inv",
      zz = "inv_complex_oldpruners",
      zz_gate = "inv_oldpruners"
  };
  --------------------------------------------------------------------------------------------
  local use_bluntblade_inv = function ()

    interface.InventoryItemRemove( "inv_bluntblade" );
    
    if not cmn.IsEventDone("get_sharpeningstone") then
      ObjSet("inv_oldpruners_star_light",  { alp = 0 });
    end;

  end;
  local use_bluntblade_beg = function ()

    ObjDelete( "obj_complex_oldpruners_use_bluntblade" );

  end;
  local use_bluntblade_end = function ()
    
    ObjDelete( "anm_complex_oldpruners_use_blade" );

    if cmn.IsEventDone("use_sharpeningstone") then
      ObjMultiSet( { {"obj_complex_oldpruners_pruners", { input = 1 }},
                     {"anm_complex_oldpruners_use_stone", { alp = 1, frame = 400 }} } );
      ObjDelete( "spr_complex_oldpruners_stone" );
      ObjDelete( "anm_complex_oldpruners_touch" );
    else 
      ObjMultiSet( { {"anm_complex_oldpruners_touch",  { animfunc = "func_clk_oldpruners_complete" }},
                     {"obj_complex_oldpruners_use_sharpeningstone", { input = 1 }} } );
    end;

  end;
  cmn.AddSubscriber( "use_bluntblade", use_bluntblade_inv );
  cmn.AddSubscriber( "use_bluntblade", use_bluntblade_beg, "inv_complex_oldpruners" );
  cmn.AddSubscriber( "use_bluntblade", use_bluntblade_end, "inv_complex_oldpruners" );
  cmn.AddSubscriber( "use_bluntblade_inv", use_bluntblade_inv );
  cmn.AddSubscriber( "use_bluntblade_beg", use_bluntblade_beg, "inv_complex_oldpruners" );
  cmn.AddSubscriber( "use_bluntblade_end", use_bluntblade_end, "inv_complex_oldpruners" );
  --------------------------------------------------------------------------------------------
  -- function use_sharpeningstone () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_sharpeningstone" ] = {

      type = "use",
      inv_obj = "inv_sharpeningstone",
      use_place = "obj_complex_oldpruners_use_sharpeningstone",
      room = "int_complex_inv",
      zz = "inv_complex_oldpruners",
      zz_gate = "inv_oldpruners"
  };
  --------------------------------------------------------------------------------------------
  local use_sharpeningstone_inv = function ()

    interface.InventoryItemRemove( "inv_sharpeningstone" );
    
    if not cmn.IsEventDone("get_bluntblade") then
      ObjSet("inv_oldpruners_star_light",  { alp = 0 });
    end;

  end;
  local use_sharpeningstone_beg = function ()

    ObjDelete( "obj_complex_oldpruners_use_sharpeningstone" );

  end;
  local use_sharpeningstone_end = function ()

    if cmn.IsEventDone("use_bluntblade") then
      ObjMultiSet( { {"obj_complex_oldpruners_pruners", { input = 1 }},
                     {"anm_complex_oldpruners_use_stone", { alp = 1, frame = 400 }} } );
      ObjDelete( "spr_complex_oldpruners_stone" );
      ObjDelete( "anm_complex_oldpruners_touch" );
    else 
      ObjSet("spr_complex_oldpruners_stone",  { alp = 1 });
    end;

  end;
  cmn.AddSubscriber( "use_sharpeningstone", use_sharpeningstone_inv );
  cmn.AddSubscriber( "use_sharpeningstone", use_sharpeningstone_beg, "inv_complex_oldpruners" );
  cmn.AddSubscriber( "use_sharpeningstone", use_sharpeningstone_end, "inv_complex_oldpruners" );
  cmn.AddSubscriber( "use_sharpeningstone_inv", use_sharpeningstone_inv );
  cmn.AddSubscriber( "use_sharpeningstone_beg", use_sharpeningstone_beg, "inv_complex_oldpruners" );
  cmn.AddSubscriber( "use_sharpeningstone_end", use_sharpeningstone_end, "inv_complex_oldpruners" );
  --------------------------------------------------------------------------------------------
  -- function use_lvl3star () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl3star" ] = {

      type = "use",
      inv_obj = "inv_lvl3star",
      use_place = "obj_complex_policebadgebase_use_lvl3star",
      room = "int_complex_inv",
      zz = "inv_complex_policebadgebase",
      zz_gate = "inv_policebadgebase"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl3star_inv = function ()

    interface.InventoryItemRemove( "inv_lvl3star" );
    
    if not cmn.IsEventDone("get_eagle") then
      ObjSet("inv_policebadgebase_star_light",  { alp = 0 });
    end;

  end;
  local use_lvl3star_beg = function ()

    ObjDelete( "obj_complex_policebadgebase_use_lvl3star" );

  end;
  local use_lvl3star_end = function ()
    
    ObjDelete( "spr_complex_policebadgebase_policebadge_slot_2" );

    if cmn.IsEventDone("use_eagle") then
      ObjSet("spr_complex_policebadgebase_policebadge",  { input = 1 });
    end;

  end;
  cmn.AddSubscriber( "use_lvl3star", use_lvl3star_inv );
  cmn.AddSubscriber( "use_lvl3star", use_lvl3star_beg, "inv_complex_policebadgebase" );
  cmn.AddSubscriber( "use_lvl3star", use_lvl3star_end, "inv_complex_policebadgebase" );
  cmn.AddSubscriber( "use_lvl3star_inv", use_lvl3star_inv );
  cmn.AddSubscriber( "use_lvl3star_beg", use_lvl3star_beg, "inv_complex_policebadgebase" );
  cmn.AddSubscriber( "use_lvl3star_end", use_lvl3star_end, "inv_complex_policebadgebase" );
  --------------------------------------------------------------------------------------------
  -- function use_eagle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_eagle" ] = {

      type = "use",
      inv_obj = "inv_eagle",
      use_place = "obj_complex_policebadgebase_use_eagle",
      room = "int_complex_inv",
      zz = "inv_complex_policebadgebase",
      zz_gate = "inv_policebadgebase"
  };
  --------------------------------------------------------------------------------------------
  local use_eagle_inv = function ()

    interface.InventoryItemRemove( "inv_eagle" );
    
    if not cmn.IsEventDone("get_lvl3star") then
      ObjSet("inv_policebadgebase_star_light",  { alp = 0 });
    end;

  end;
  local use_eagle_beg = function ()

    ObjDelete( "obj_complex_policebadgebase_use_eagle" );

  end;
  local use_eagle_end = function ()
    
    ObjDelete( "spr_complex_policebadgebase_policebadge_slot_1" );

    if cmn.IsEventDone("use_lvl3star") then
      ObjSet("spr_complex_policebadgebase_policebadge",  { input = 1 });
    end;

  end;
  cmn.AddSubscriber( "use_eagle", use_eagle_inv );
  cmn.AddSubscriber( "use_eagle", use_eagle_beg, "inv_complex_policebadgebase" );
  cmn.AddSubscriber( "use_eagle", use_eagle_end, "inv_complex_policebadgebase" );
  cmn.AddSubscriber( "use_eagle_inv", use_eagle_inv );
  cmn.AddSubscriber( "use_eagle_beg", use_eagle_beg, "inv_complex_policebadgebase" );
  cmn.AddSubscriber( "use_eagle_end", use_eagle_end, "inv_complex_policebadgebase" );
  --------------------------------------------------------------------------------------------
  -- function use_facepart () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_facepart" ] = {

      type = "use",
      inv_obj = "inv_facepart",
      use_place = "obj_complex_themisbrokenface_use_facepart",
      room = "int_complex_inv",
      zz = "inv_complex_themisbrokenface",
      zz_gate = "inv_themisbrokenface"
  };
  --------------------------------------------------------------------------------------------
  local use_facepart_inv = function ()

    interface.InventoryItemRemove( "inv_facepart" );
    
    if not cmn.IsEventDone("get_glue") then
      ObjSet("inv_themisbrokenface_star_light",  { alp = 0 });
    end;

  end;
  local use_facepart_beg = function ()

    ObjDelete( "obj_complex_themisbrokenface_use_facepart" );

  end;
  local use_facepart_end = function ()
    
    ObjMultiSet( { {"spr_complex_themisbrokenface_facepart_1", { alp = 1 }},
                   {"spr_complex_themisbrokenface_facepart_2", { alp = 1 }} } );

    if cmn.IsEventDone("use_glue") then
      ObjMultiSet( { {"obj_complex_themisbrokenface_get_face",  { input = 1 }},
                     {"spr_complex_themisbrokenface_facepart_1", { pos_x = -33, pos_y = 8 }},
                     {"spr_complex_themisbrokenface_facepart_2", { pos_x = 31, pos_y = -117 }},
                     {"obj_complex_themisbrokenface_faceparts", { pos_z = 7 }} } );
    else 
      ObjSet("obj_complex_themisbrokenface_use_glue",  { input = 1 });
    end;

  end;
  cmn.AddSubscriber( "use_facepart", use_facepart_inv );
  cmn.AddSubscriber( "use_facepart", use_facepart_beg, "inv_complex_themisbrokenface" );
  cmn.AddSubscriber( "use_facepart", use_facepart_end, "inv_complex_themisbrokenface" );
  cmn.AddSubscriber( "use_facepart_inv", use_facepart_inv );
  cmn.AddSubscriber( "use_facepart_beg", use_facepart_beg, "inv_complex_themisbrokenface" );
  cmn.AddSubscriber( "use_facepart_end", use_facepart_end, "inv_complex_themisbrokenface" );
  --------------------------------------------------------------------------------------------
  -- function use_glue () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_glue" ] = {

      type = "use",
      inv_obj = "inv_glue",
      use_place = "obj_complex_themisbrokenface_use_glue",
      room = "int_complex_inv",
      zz = "inv_complex_themisbrokenface",
      zz_gate = "inv_themisbrokenface"
  };
  --------------------------------------------------------------------------------------------
  local use_glue_inv = function ()

    interface.InventoryItemRemove( "inv_glue" );
    
    if not cmn.CheckMultiObject( "facepart", 2 ) then
      ObjSet("inv_themisbrokenface_star_light",  { alp = 0 });
    end;

  end;
  local use_glue_beg = function ()

    ObjDelete( "obj_complex_themisbrokenface_use_glue" );

  end;
  local use_glue_end = function ()
    
    ObjSet("anm_complex_themisbrokenface_use_glue",  { frame= 300 });

    if cmn.IsEventDone("use_facepart") then
      ObjMultiSet( { {"obj_complex_themisbrokenface_get_face",  { input = 1 }},
                     {"spr_complex_themisbrokenface_facepart_1", { pos_x = -33, pos_y = 8 }},
                     {"spr_complex_themisbrokenface_facepart_2", { pos_x = 31, pos_y = -117 }},
                     {"obj_complex_themisbrokenface_faceparts", { pos_z = 7 }} } );
    end;

  end;
  cmn.AddSubscriber( "use_glue", use_glue_inv );
  cmn.AddSubscriber( "use_glue", use_glue_beg, "inv_complex_themisbrokenface" );
  cmn.AddSubscriber( "use_glue", use_glue_end, "inv_complex_themisbrokenface" );
  cmn.AddSubscriber( "use_glue_inv", use_glue_inv );
  cmn.AddSubscriber( "use_glue_beg", use_glue_beg, "inv_complex_themisbrokenface" );
  cmn.AddSubscriber( "use_glue_end", use_glue_end, "inv_complex_themisbrokenface" );
  --------------------------------------------------------------------------------------------
  -- function use_lvl3cinderellapage () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl3cinderellapage" ] = {

      type = "use",
      inv_obj = "inv_lvl3cinderellapage",
      use_place = "obj_complex_talebook_use_pages",
      room = "int_complex_inv",
      zz = "inv_complex_talebook",
      zz_gate = "inv_talebook"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl3cinderellapage_inv = function ()

    interface.InventoryItemRemove( "inv_lvl3cinderellapage" );
    level3.in_progress = false;

  end;
  local use_lvl3cinderellapage_beg = function ()

    if cmn.IsEventDone("use_mermaidpage") and cmn.IsEventDone("use_redhatpage") then
      ObjDelete( "obj_complex_talebook_use_pages" );
    end;

  end;
  local use_lvl3cinderellapage_end = function ()

  end;
  cmn.AddSubscriber( "use_lvl3cinderellapage", use_lvl3cinderellapage_inv );
  cmn.AddSubscriber( "use_lvl3cinderellapage", use_lvl3cinderellapage_beg, "inv_complex_talebook" );
  cmn.AddSubscriber( "use_lvl3cinderellapage", use_lvl3cinderellapage_end, "inv_complex_talebook" );
  cmn.AddSubscriber( "use_lvl3cinderellapage_inv", use_lvl3cinderellapage_inv );
  cmn.AddSubscriber( "use_lvl3cinderellapage_beg", use_lvl3cinderellapage_beg, "inv_complex_talebook" );
  cmn.AddSubscriber( "use_lvl3cinderellapage_end", use_lvl3cinderellapage_end, "inv_complex_talebook" );
  --------------------------------------------------------------------------------------------
  -- function use_mermaidpage () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_mermaidpage" ] = {

      type = "use",
      inv_obj = "inv_mermaidpage",
      use_place = "obj_complex_talebook_use_pages",
      room = "int_complex_inv",
      zz = "inv_complex_talebook",
      zz_gate = "inv_talebook"
  };
  --------------------------------------------------------------------------------------------
  local use_mermaidpage_inv = function ()

    interface.InventoryItemRemove( "inv_mermaidpage" );

  end;
  local use_mermaidpage_beg = function ()

    if cmn.IsEventDone("use_lvl3cinderellapage") and cmn.IsEventDone("use_redhatpage") then
      ObjDelete( "obj_complex_talebook_use_pages" );
    end;

  end;
  local use_mermaidpage_end = function ()
    
    ObjSet("anm_complex_talebook_book",  { frame = 0, animfunc = "func_use_paper_red_riding_hood" });

  end;
  cmn.AddSubscriber( "use_mermaidpage", use_mermaidpage_inv );
  cmn.AddSubscriber( "use_mermaidpage", use_mermaidpage_beg, "inv_complex_talebook" );
  cmn.AddSubscriber( "use_mermaidpage", use_mermaidpage_end, "inv_complex_talebook" );
  cmn.AddSubscriber( "use_mermaidpage_inv", use_mermaidpage_inv );
  cmn.AddSubscriber( "use_mermaidpage_beg", use_mermaidpage_beg, "inv_complex_talebook" );
  cmn.AddSubscriber( "use_mermaidpage_end", use_mermaidpage_end, "inv_complex_talebook" );
  --------------------------------------------------------------------------------------------
  -- function use_redhatpage () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_redhatpage" ] = {

      type = "use",
      inv_obj = "inv_fixedredhoodpage",
      use_place = "obj_complex_talebook_use_pages",
      room = "int_complex_inv",
      zz = "inv_complex_talebook",
      zz_gate = "inv_talebook"
  };
  --------------------------------------------------------------------------------------------
  local use_redhatpage_inv = function ()

    interface.InventoryItemRemove( "inv_fixedredhoodpage" );

  end;
  local use_redhatpage_beg = function ()

    if cmn.IsEventDone("use_lvl3cinderellapage") and cmn.IsEventDone("use_mermaidpage") then
      ObjDelete( "obj_complex_talebook_use_pages" );
    end;

  end;
  local use_redhatpage_end = function ()

    ObjSet("anm_complex_talebook_book",  { frame = 0, animfunc = "func_use_paper_cinderella" });
    
  end;
  cmn.AddSubscriber( "use_redhatpage", use_redhatpage_inv );
  cmn.AddSubscriber( "use_redhatpage", use_redhatpage_beg, "inv_complex_talebook" );
  cmn.AddSubscriber( "use_redhatpage", use_redhatpage_end, "inv_complex_talebook" );
  cmn.AddSubscriber( "use_redhatpage_inv", use_redhatpage_inv );
  cmn.AddSubscriber( "use_redhatpage_beg", use_redhatpage_beg, "inv_complex_talebook" );
  cmn.AddSubscriber( "use_redhatpage_end", use_redhatpage_end, "inv_complex_talebook" );
  
  --------------------------------------------------------------------------------------------
  -- function clk_makelockpick1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_makelockpick1" ] = {
      type = "click",
      use_place = "obj_complex_lvl3wire_clk_makelockpick1",
      room = "int_complex_inv",
      zz = "inv_complex_lvl3wire",
      zz_gate = "inv_lvl3wire"
  };
  --------------------------------------------------------------------------------------------
  local clk_makelockpick1_beg = function ()
  
    ObjDelete( "obj_complex_lvl3wire_clk_makelockpick1" );
  
  end;
  local clk_makelockpick1_end = function ()
    
    ObjDelete( "obj_complex_lvl3wire_pick1" );
  
    ObjMultiSet( { {"obj_complex_lvl3wire_clk_makelockpick2", { input = 1 }},
                   {"obj_complex_lvl3wire_pick2", { alp = 1 }} } );
    
  end;
  cmn.AddSubscriber( "clk_makelockpick1", clk_makelockpick1_beg, "inv_complex_lvl3wire" );
  cmn.AddSubscriber( "clk_makelockpick1", clk_makelockpick1_end, "inv_complex_lvl3wire" );
  cmn.AddSubscriber( "clk_makelockpick1_beg", clk_makelockpick1_beg, "inv_complex_lvl3wire" );
  cmn.AddSubscriber( "clk_makelockpick1_end", clk_makelockpick1_end, "inv_complex_lvl3wire" );
  --------------------------------------------------------------------------------------------
  -- function clk_makelockpick2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_makelockpick2" ] = {
      type = "click",
      use_place = "obj_complex_lvl3wire_clk_makelockpick2",
      room = "int_complex_inv",
      zz = "inv_complex_lvl3wire",
      zz_gate = "inv_lvl3wire"
  };
  --------------------------------------------------------------------------------------------
  local clk_makelockpick2_beg = function ()
  
    ObjDelete( "obj_complex_lvl3wire_clk_makelockpick2" );
  
  end;
  local clk_makelockpick2_end = function ()
  
    ObjDelete( "obj_complex_lvl3wire_pick2" );
  
    ObjMultiSet( { {"obj_complex_lvl3wire_clk_makelockpick3", { input = 1 }},
                   {"obj_complex_lvl3wire_pick3", { alp = 1 }} } );
    
  end;
  cmn.AddSubscriber( "clk_makelockpick2", clk_makelockpick2_beg, "inv_complex_lvl3wire" );
  cmn.AddSubscriber( "clk_makelockpick2", clk_makelockpick2_end, "inv_complex_lvl3wire" );
  cmn.AddSubscriber( "clk_makelockpick2_beg", clk_makelockpick2_beg, "inv_complex_lvl3wire" );
  cmn.AddSubscriber( "clk_makelockpick2_end", clk_makelockpick2_end, "inv_complex_lvl3wire" );
  --------------------------------------------------------------------------------------------
  -- function clk_makelockpick3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_makelockpick3" ] = {
      type = "click",
      use_place = "obj_complex_lvl3wire_clk_makelockpick3",
      room = "int_complex_inv",
      zz = "inv_complex_lvl3wire",
      zz_gate = "inv_lvl3wire"
  };
  --------------------------------------------------------------------------------------------
  local clk_makelockpick3_beg = function ()
  
    ObjDelete( "obj_complex_lvl3wire_clk_makelockpick3" );
  
  end;
  local clk_makelockpick3_end = function ()
    
    ObjDelete( "obj_complex_lvl3wire_pick3" );
  
    ObjSet("spr_complex_lvl3wire_lockpick",  { alp = 1, input = 1 });
    
  end;
  cmn.AddSubscriber( "clk_makelockpick3", clk_makelockpick3_beg, "inv_complex_lvl3wire" );
  cmn.AddSubscriber( "clk_makelockpick3", clk_makelockpick3_end, "inv_complex_lvl3wire" );
  cmn.AddSubscriber( "clk_makelockpick3_beg", clk_makelockpick3_beg, "inv_complex_lvl3wire" );
  cmn.AddSubscriber( "clk_makelockpick3_end", clk_makelockpick3_end, "inv_complex_lvl3wire" );
  --------------------------------------------------------------------------------------------
  -- function clk_openbackpack () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_openbackpack" ] = {
      type = "click",
      use_place = "obj_complex_redhatbackpack_clk_openbackpack",
      room = "int_complex_inv",
      zz = "inv_complex_redhatbackpack",
      zz_gate = "inv_redhatbackpack"
  };
  --------------------------------------------------------------------------------------------
  local clk_openbackpack_beg = function ()
  
    ObjDelete( "obj_complex_redhatbackpack_clk_openbackpack" );
  
  end;
  local clk_openbackpack_end = function ()
    
    ObjDelete( "spr_complex_redhatbackpack_bag_closed" );
  
    ObjMultiSet( { {"obj_complex_redhatbackpack_clk_takephone", { alp = 1, input = 1 }},
                   {"obj_complex_redhatbackpack_bag_open", { alp = 1 }} } );
    
  end;
  cmn.AddSubscriber( "clk_openbackpack", clk_openbackpack_beg, "inv_complex_redhatbackpack" );
  cmn.AddSubscriber( "clk_openbackpack", clk_openbackpack_end, "inv_complex_redhatbackpack" );
  cmn.AddSubscriber( "clk_openbackpack_beg", clk_openbackpack_beg, "inv_complex_redhatbackpack" );
  cmn.AddSubscriber( "clk_openbackpack_end", clk_openbackpack_end, "inv_complex_redhatbackpack" );
  --------------------------------------------------------------------------------------------
  -- function clk_takephone () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_takephone" ] = {
      type = "click",
      use_place = "obj_complex_redhatbackpack_clk_takephone",
      room = "int_complex_inv",
      zz = "inv_complex_redhatbackpack",
      zz_gate = "inv_redhatbackpack"
  };
  --------------------------------------------------------------------------------------------
  local clk_takephone_beg = function ()
  
    ObjDelete( "obj_complex_redhatbackpack_clk_takephone" );
  
  end;
  local clk_takephone_end = function ()
  
    ObjDelete( "spr_complex_redhatbackpack_phone_1" );
  
    ObjMultiSet( { {"obj_complex_redhatbackpack_clk_phoneon", { alp = 1, input = 1 }},
                   {"anm_complex_redhatbackpack_phone_2", { alp = 1 }} } );
    
  end;
  cmn.AddSubscriber( "clk_takephone", clk_takephone_beg, "inv_complex_redhatbackpack" );
  cmn.AddSubscriber( "clk_takephone", clk_takephone_end, "inv_complex_redhatbackpack" );
  cmn.AddSubscriber( "clk_takephone_beg", clk_takephone_beg, "inv_complex_redhatbackpack" );
  cmn.AddSubscriber( "clk_takephone_end", clk_takephone_end, "inv_complex_redhatbackpack" );
  --------------------------------------------------------------------------------------------
  -- function clk_phoneon () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_phoneon" ] = {
      type = "click",
      use_place = "obj_complex_redhatbackpack_clk_phoneon",
      room = "int_complex_inv",
      zz = "inv_complex_redhatbackpack",
      zz_gate = "inv_redhatbackpack"
  };
  --------------------------------------------------------------------------------------------
  local clk_phoneon_beg = function ()
  
    ObjDelete( "obj_complex_redhatbackpack_clk_phoneon" );
  
  end;
  local clk_phoneon_end = function ()
  
    ObjDelete( "anm_complex_redhatbackpack_phone_2" );
  
    ObjSet("obj_complex_redhatbackpack_bag_open",  { input = 1 });
    
  end;
  cmn.AddSubscriber( "clk_phoneon", clk_phoneon_beg, "inv_complex_redhatbackpack" );
  cmn.AddSubscriber( "clk_phoneon", clk_phoneon_end, "inv_complex_redhatbackpack" );
  cmn.AddSubscriber( "clk_phoneon_beg", clk_phoneon_beg, "inv_complex_redhatbackpack" );
  cmn.AddSubscriber( "clk_phoneon_end", clk_phoneon_end, "inv_complex_redhatbackpack" );
  --------------------------------------------------------------------------------------------
  -- function clk_opentalebook () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_opentalebook" ] = {
      type = "click",
      use_place = "obj_complex_talebook_clk_opentalebook",
      room = "int_complex_inv",
      zz = "inv_complex_talebook",
      zz_gate = "inv_talebook"
  };
  --------------------------------------------------------------------------------------------
  local clk_opentalebook_beg = function ()
  
    ObjDelete( "obj_complex_talebook_clk_opentalebook" );
  
  end;
  local clk_opentalebook_end = function ()
  
    ObjMultiSet( { {"obj_complex_talebook_use_pages", { input = 1 }},
                   {"anm_complex_talebook_book", { frame = 0, animfunc = "func_use_paper_little_mermaid" }} } );
    
  end;
  cmn.AddSubscriber( "clk_opentalebook", clk_opentalebook_beg, "inv_complex_talebook" );
  cmn.AddSubscriber( "clk_opentalebook", clk_opentalebook_end, "inv_complex_talebook" );
  cmn.AddSubscriber( "clk_opentalebook_beg", clk_opentalebook_beg, "inv_complex_talebook" );
  cmn.AddSubscriber( "clk_opentalebook_end", clk_opentalebook_end, "inv_complex_talebook" );

end;
--*********************************************************************************************************************
-- function *** CLOSE FUNC *** () end;
--*********************************************************************************************************************
function public.inv_complex_brokenbugle_close()

  if cmn.IsEventDone( "use_leavewithstickydew" ) and not cmn.IsEventDone( "get_enchantedhorn" ) then
    
    cmn.SetEventDone( "get_enchantedhorn" );
    cmn.CallEventHandler( "get_enchantedhorn", "inv_complex_brokenbugle" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_lvl3wire_close()

  if cmn.IsEventDone( "clk_makelockpick3" ) and not cmn.IsEventDone( "get_lockpick" ) then
    
    cmn.SetEventDone( "get_lockpick" );
    cmn.CallEventHandler( "get_lockpick", "inv_complex_lvl3wire" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_casket_close()
  
  if not cmn.IsEventDone( "get_copperfeather2" ) then

    cmn.SetEventDone( "get_copperfeather2" );
    cmn.CallEventHandler( "get_copperfeather2", "inv_complex_casket" );
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;

  if cmn.IsEventDone( "use_amuletknot" ) then

    if not cmn.IsEventDone( "get_mirrorshard3" ) then

      ObjSet( "spr_complex_casket_mirrorshard3", { alp = 1 } );

      cmn.SetEventDone( "get_mirrorshard3" );
      cmn.CallEventHandler( "get_mirrorshard3", "inv_complex_casket" );
      
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

    end;

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_juicyapple_close()

  if cmn.IsEventDone( "use_applecutter" ) and not cmn.IsEventDone( "get_poisonedseeds" ) then
    
    cmn.SetEventDone( "get_poisonedseeds" );
    cmn.CallEventHandler( "get_poisonedseeds", "inv_complex_juicyapple" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_oldpruners_close()

  if cmn.IsEventDone( "use_bluntblade" ) and cmn.IsEventDone( "use_sharpeningstone" ) and not cmn.IsEventDone( "get_pruners" ) then
    
    cmn.SetEventDone( "get_pruners" );
    cmn.CallEventHandler( "get_pruners", "inv_complex_oldpruners" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_policebadgebase_close()

  if cmn.IsEventDone( "use_lvl3star" ) and cmn.IsEventDone( "use_eagle" ) and not cmn.IsEventDone( "get_policebadge" ) then
    
    cmn.SetEventDone( "get_policebadge" );
    cmn.CallEventHandler( "get_policebadge", "inv_complex_policebadgebase" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_themisbrokenface_close()

  if cmn.IsEventDone( "use_facepart" ) and cmn.IsEventDone( "use_glue" ) and not cmn.IsEventDone( "get_themisface" ) then
    
    cmn.SetEventDone( "get_themisface" );
    cmn.CallEventHandler( "get_themisface", "inv_complex_themisbrokenface" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_redhatbackpack_close()
  
  if cmn.IsEventDone("clk_takephone") and not(cmn.IsEventDone("clk_phoneon")) then
    SndStop("assets/levels/level3/inv_complex/inv_redhatbackpack/audio/aud_cell_phone", 0.5);
  end;

  if cmn.IsEventDone( "clk_phoneon" ) then

    if not cmn.IsEventDone("get_token2") or not cmn.IsEventDone("get_redhatpage2") then
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
    end;

    if not cmn.IsEventDone( "get_token2" ) then

      cmn.SetEventDone( "get_token2" );
      cmn.CallEventHandler( "get_token2", "inv_complex_redhatbackpack" );

    end;

    if not cmn.IsEventDone( "get_redhatpage2" ) then

      cmn.SetEventDone( "get_redhatpage2" );
      cmn.CallEventHandler( "get_redhatpage2", "inv_complex_redhatbackpack" );

    end;

  end;
  
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_leavewithstickydew()

  local item = "inv_leavewithstickydew";

  if cmn.ObjIntersectCheck( item, "obj_complex_brokenbugle_use_leavewithstickydew" ) then

    cmn.CallEventHandler( "use_leavewithstickydew_inv", "inv_complex_brokenbugle" );
    cmn.CallEventHandler( "use_leavewithstickydew_beg", "inv_complex_brokenbugle" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_leavewithstickydew" );
      cmn.CallEventHandler( "use_leavewithstickydew_end", "inv_complex_brokenbugle" );
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_brokenbugle/audio/aud_use_leave");

    ObjSet( "anm_complex_brokenbugle_enchantedhorn", { endtrig = func_after, playing = true } );

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_amuletknot()

  local item = "inv_amuletknot";

  if cmn.ObjIntersectCheck( item, "obj_complex_casket_use_amuletknot" ) then

    cmn.CallEventHandler( "use_amuletknot_inv", "inv_complex_casket" );
    cmn.CallEventHandler( "use_amuletknot_beg", "inv_complex_casket" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_amuletknot" );
      cmn.CallEventHandler( "use_amuletknot_end", "inv_complex_casket" );
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_casket/audio/aud_use_amulet_box");

    ObjSet( "anm_complex_casket_casket", { animfunc = "func_use_amulet", endtrig = func_after, playing = true } );

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_applecutter()

  local item = "inv_applecutter";

  if cmn.ObjIntersectCheck( item, "obj_complex_juicyapple_use_applecutter" ) then

    cmn.CallEventHandler( "use_applecutter_inv", "inv_complex_juicyapple" );
    cmn.CallEventHandler( "use_applecutter_beg", "inv_complex_juicyapple" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_applecutter" );
      cmn.CallEventHandler( "use_applecutter_end", "inv_complex_juicyapple" );

    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_juicyapple/audio/aud_cut_apple");

    ObjSet( "anm_complex_juicyapple_use_apple_cutter", { endtrig = func_after, playing = true } );

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bluntblade()

  local item = "inv_bluntblade";

  if cmn.ObjIntersectCheck( item, "obj_complex_oldpruners_use_bluntblade" ) then

    cmn.CallEventHandler( "use_bluntblade_inv", "inv_complex_oldpruners" );
    cmn.CallEventHandler( "use_bluntblade_beg", "inv_complex_oldpruners" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_bluntblade" );
      cmn.CallEventHandler( "use_bluntblade_end", "inv_complex_oldpruners" );
      
      if not cmn.IsEventDone("use_sharpeningstone") then
        ObjSet("anm_complex_oldpruners_touch",  { alp = 1 });
      end;
      
    end;
    
    local anm_sharp = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_oldpruners/audio/aud_sharpen_cutters");
      
      ObjAnimate("spr_complex_oldpruners_stone", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
      ObjMultiSet( { {"anm_complex_oldpruners_use_stone", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_complex_oldpruners_use_blade", { alp = 0 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_oldpruners/audio/aud_use_part_cutters");

    if cmn.IsEventDone("use_sharpeningstone") then
      ObjMultiSet( { {"anm_complex_oldpruners_use_blade", { alp = 1, playing = 1, endtrig = anm_sharp }},
                     {"anm_complex_oldpruners_touch", { alp = 0 }} } );
    else 
      ObjMultiSet( { {"anm_complex_oldpruners_use_blade", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_complex_oldpruners_touch", { alp = 0 }} } );
    end;

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_sharpeningstone()

  local item = "inv_sharpeningstone";

  if cmn.ObjIntersectCheck( item, "obj_complex_oldpruners_use_sharpeningstone" ) then

    cmn.CallEventHandler( "use_sharpeningstone_inv", "inv_complex_oldpruners" );
    cmn.CallEventHandler( "use_sharpeningstone_beg", "inv_complex_oldpruners" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_sharpeningstone" );
      cmn.CallEventHandler( "use_sharpeningstone_end", "inv_complex_oldpruners" );
      
    end;
    
    local anm_sharp = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_oldpruners/audio/aud_sharpen_cutters");
      
      ObjMultiSet( { {"anm_complex_oldpruners_use_stone", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_complex_oldpruners_touch", { alp = 0 }} } );
      
    end;

    cmn.Lock( 1 );

    if cmn.IsEventDone("use_bluntblade") then
      anm_sharp();
    else 
      cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_oldpruners/audio/aud_use_part_cutters");
      ObjAnimate( "spr_complex_oldpruners_stone", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl3star()

  local item = "inv_lvl3star";

  if cmn.ObjIntersectCheck( item, "obj_complex_policebadgebase_use_lvl3star" ) then

    cmn.CallEventHandler( "use_lvl3star_inv", "inv_complex_policebadgebase" );
    cmn.CallEventHandler( "use_lvl3star_beg", "inv_complex_policebadgebase" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl3star" );
      cmn.CallEventHandler( "use_lvl3star_end", "inv_complex_policebadgebase" );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_nearhospital/audio/aud_xx_clk_scull2");

    ObjAnimate("spr_complex_policebadgebase_policebadge_slot_2", "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_eagle()

  local item = "inv_eagle";

  if cmn.ObjIntersectCheck( item, "obj_complex_policebadgebase_use_eagle" ) then

    cmn.CallEventHandler( "use_eagle_inv", "inv_complex_policebadgebase" );
    cmn.CallEventHandler( "use_eagle_beg", "inv_complex_policebadgebase" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_eagle" );
      cmn.CallEventHandler( "use_eagle_end", "inv_complex_policebadgebase" );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_nearhospital/audio/aud_xx_clk_scull2");

    ObjAnimate("spr_complex_policebadgebase_policebadge_slot_1", "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_facepart()

  local item = "inv_facepart";

  if cmn.ObjIntersectCheck( item, "obj_complex_themisbrokenface_use_facepart" ) and cmn.CheckMultiObject( "facepart", 2 ) then

    cmn.CallEventHandler( "use_facepart_inv", "inv_complex_themisbrokenface" );
    cmn.CallEventHandler( "use_facepart_beg", "inv_complex_themisbrokenface" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_facepart" );
      cmn.CallEventHandler( "use_facepart_end", "inv_complex_themisbrokenface" );
      
    end;
    
    local anm_parts = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_themisbrokenface/audio/aud_use_face_parts2");
      
      ObjSet("obj_complex_themisbrokenface_faceparts",  { pos_z = 7 });
      
      ObjAnimate("spr_complex_themisbrokenface_facepart_1", "pos_xy", 0, 0, "", { 0, 0, -56, 63,   0.5, 0, -33, 8 });
      ObjAnimate("spr_complex_themisbrokenface_facepart_2", "pos_xy", 0, 0, func_after, { 0, 0, 154, -117,   0.5, 0, 154, -117,   1, 0, 31, -117 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_themisbrokenface/audio/aud_use_face_parts");

    if cmn.IsEventDone("use_glue") then
      ObjAnimate("spr_complex_themisbrokenface_facepart_1", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_complex_themisbrokenface_facepart_2", "alp", 0, 0, anm_parts, { 0, 0, 0,   0.3, 0, 0,  0.6, 0, 1 });
    else 
      ObjAnimate("spr_complex_themisbrokenface_facepart_1", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_complex_themisbrokenface_facepart_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 0,  0.6, 0, 1 });
    end;

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_glue()

  local item = "inv_glue";

  if cmn.ObjIntersectCheck( item, "obj_complex_themisbrokenface_use_glue" ) then

    cmn.CallEventHandler( "use_glue_inv", "inv_complex_themisbrokenface" );
    cmn.CallEventHandler( "use_glue_beg", "inv_complex_themisbrokenface" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_glue" );
      cmn.CallEventHandler( "use_glue_end", "inv_complex_themisbrokenface" );
      
    end;
    
    local anm_parts = function ()
      
       cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_themisbrokenface/audio/aud_use_face_parts2");
      
      ObjSet("obj_complex_themisbrokenface_faceparts",  { pos_z = 7 });
      
      ObjAnimate("spr_complex_themisbrokenface_facepart_1", "pos_xy", 0, 0, "", { 0, 0, -56, 63,   0.5, 0, -33, 8 });
      ObjAnimate("spr_complex_themisbrokenface_facepart_2", "pos_xy", 0, 0, func_after, { 0, 0, 154, -117,   0.5, 0, 154, -117,   1, 0, 31, -117 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_themisbrokenface/audio/aud_use_glue");

    if cmn.IsEventDone("use_facepart") then
      ObjSet("anm_complex_themisbrokenface_use_glue",  { playing = 1, endtrig = anm_parts });
    else 
      ObjSet("anm_complex_themisbrokenface_use_glue",  { playing = 1, endtrig = func_after });
    end;

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl3cinderellapage()

  local item = "inv_lvl3cinderellapage";

  if cmn.ObjIntersectCheck( item, "obj_complex_talebook_use_pages" ) and cmn.IsEventDone("use_redhatpage") then

    cmn.CallEventHandler( "use_lvl3cinderellapage_inv", "inv_complex_talebook" );
    cmn.CallEventHandler( "use_lvl3cinderellapage_beg", "inv_complex_talebook" );

    local func_after = function ()

      cmn.CallEventHandler( "use_lvl3cinderellapage_end", "inv_complex_talebook" );
      
      if cmn.IsEventDone("use_redhatpage") and cmn.IsEventDone("use_mermaidpage") then
        
        ObjSet("mg_darkroom",  { color_r = 0, color_g = 0, color_b = 0 });

        interface.WidgetSetInput( InterfaceWidget_Inventory, false );
        interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
        interface.WidgetSetInput( InterfaceWidget_BtnGuide,  false );
        interface.WidgetSetInput( InterfaceWidget_BtnMap,    false );
        interface.WidgetSetInput( InterfaceWidget_BtnMenu,   false );

        interface.WidgetSetVisible( InterfaceWidget_Inventory, false, false );
        interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, false );
        interface.WidgetSetVisible( InterfaceWidget_BtnGuide,  false, false );
        interface.WidgetSetVisible( InterfaceWidget_BtnMap,    false, false );
        interface.WidgetSetVisible( InterfaceWidget_BtnMenu,   false, false );

        ng_global.progress[ "std" ].common.gamewin = true;
        
        --port. fix 
        iOS_RegisterGameplay("level_4"); 
        
        cmn.GotoRoom( "rm_credits", 0, true );
        
        --cmn.GotoRoom( "rm_endroom" );
        
      end;
      
    end;
    
    local play_outro = function ()
      
      cmn.Lock( 0 );
      cmn.StopAllEnv();
      common_impl.HideComplexItem();
      cmn.PlayFullscreenVideo( "assets/levels/level3/inv_complex/inv_talebook/vid_lvl3outro",
                               func_after,
                               "assets/levels/level3/inv_complex/inv_talebook/audio/aud_outro_lvl3",
                               "assets/levels/level3/inv_complex/inv_talebook/audio/aud_outro_lvl3_voc" );
      
    end;
                             
    local anm_book = function ()

      cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_talebook/audio/aud_close_book");
      ObjSet("anm_complex_talebook_book",  { frame = 0, animfunc = "func_final_book", playing = 1, endtrig = play_outro });

    end;      
    
    local play_aud2 = function ()
      cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_talebook/audio/aud_pages");
    end;
                             
    cmn.SetEventDone( "use_lvl3cinderellapage" );                         

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_talebook/audio/aud_use_pages");

    ObjMultiSet( { {"anm_complex_talebook_book",  { playing = 1, endtrig = anm_book }},
                   {"tmr_complex_talebook_timer", { time = 1.2, playing = 1, endtrig = play_aud2 }} } );

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_mermaidpage()

  local item = "inv_mermaidpage";

  if cmn.ObjIntersectCheck( item, "obj_complex_talebook_use_pages" ) and cmn.IsEventDone("clk_opentalebook") then

    cmn.CallEventHandler( "use_mermaidpage_inv", "inv_complex_talebook" );
    private.use_mermaidpage_end();
    
  elseif cmn.ObjIntersectCheck( item, "obj_complex_talebook_use_pages" ) and not cmn.IsEventDone("clk_opentalebook") then

    cmn.CallEventHandler( "use_mermaidpage_inv", "inv_complex_talebook" );
    public.clk_opentalebook( 2 );  

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function private.use_mermaidpage_end()

  cmn.CallEventHandler( "use_mermaidpage_beg", "inv_complex_talebook" );
  
  cmn.SetEventDone( "use_mermaidpage" );

  local func_after = function ()

    cmn.CallEventHandler( "use_mermaidpage_end", "inv_complex_talebook" );
    cmn.Lock( 0 );
    
  end;
  
  local play_aud2 = function ()
    cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_talebook/audio/aud_pages");
  end;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_talebook/audio/aud_use_pages");

  ObjMultiSet( { {"anm_complex_talebook_book",  { playing = 1, endtrig = func_after }},
                 {"tmr_complex_talebook_timer", { time = 1.2, playing = 1, endtrig = play_aud2 }} } );

end;
--------------------------------------------------------------------------------------------
function public.use_redhatpage()

  local item = "inv_fixedredhoodpage";

  if cmn.ObjIntersectCheck( item, "obj_complex_talebook_use_pages" ) and cmn.CheckMultiObject( "redhatpage", 4 ) and cmn.IsEventDone("use_mermaidpage") then

    cmn.CallEventHandler( "use_redhatpage_inv", "inv_complex_talebook" );
    cmn.CallEventHandler( "use_redhatpage_beg", "inv_complex_talebook" );
    
    cmn.SetEventDone( "use_redhatpage" );

    local func_after = function ()

      cmn.CallEventHandler( "use_redhatpage_end", "inv_complex_talebook" );
      cmn.Lock( 0 );
      
    end;
    
    local play_aud2 = function ()
      cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_talebook/audio/aud_pages");
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_talebook/audio/aud_use_pages");

    ObjMultiSet( { {"anm_complex_talebook_book",  { playing = 1, endtrig = func_after }},
                   {"tmr_complex_talebook_timer", { time = 1.2, playing = 1, endtrig = play_aud2 }} } );

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_enchantedhorn()
  
  cmn.SetEventDone( "get_enchantedhorn" );
  cmn.CallEventHandler( "get_enchantedhorn", "inv_complex_brokenbugle" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_lockpick()
  
  cmn.SetEventDone( "get_lockpick" );
  cmn.CallEventHandler( "get_lockpick", "inv_complex_lvl3wire" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_mirrorshard3()

  ObjSet( "spr_complex_casket_mirrorshard3", { alp = 1 } );
  
  cmn.SetEventDone( "get_mirrorshard3" );
  cmn.CallEventHandler( "get_mirrorshard3", "inv_complex_casket" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");
  
    if port.isPortable()==1 then
      iOS_RateMe();
    end;  

  if cmn.IsEventDone("get_copperfeather2") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_copperfeather2()
  
  cmn.SetEventDone( "get_copperfeather2" );
  cmn.CallEventHandler( "get_copperfeather2", "inv_complex_casket" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if cmn.IsEventDone("get_mirrorshard3") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_poisonedseeds()
  
  cmn.SetEventDone( "get_poisonedseeds" );
  cmn.CallEventHandler( "get_poisonedseeds", "inv_complex_juicyapple" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_pruners()
  
  cmn.SetEventDone( "get_pruners" );
  cmn.CallEventHandler( "get_pruners", "inv_complex_oldpruners" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_policebadge()
  
  cmn.SetEventDone( "get_policebadge" );
  cmn.CallEventHandler( "get_policebadge", "inv_complex_policebadgebase" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_themisface()
  
  cmn.SetEventDone( "get_themisface" );
  cmn.CallEventHandler( "get_themisface", "inv_complex_themisbrokenface" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_token2()
  
  cmn.SetEventDone( "get_token2" );
  cmn.CallEventHandler( "get_token2", "inv_complex_redhatbackpack" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if cmn.IsEventDone("get_redhatpage2") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_redhatpage2()
  
  cmn.SetEventDone( "get_redhatpage2" );
  cmn.CallEventHandler( "get_redhatpage2", "inv_complex_redhatbackpack" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if cmn.IsEventDone("get_token2") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_makelockpick( num )

  cmn.Lock(1);
  cmn.CallEventHandler( "clk_makelockpick"..num.."_beg", "inv_complex_lvl3wire" );

  local func_after = function ()

    cmn.SetEventDone( "clk_makelockpick"..num );
    cmn.CallEventHandler( "clk_makelockpick"..num.."_end", "inv_complex_lvl3wire" );

    cmn.Lock(0);

  end;
  
  cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_lvl3wire/audio/aud_xx_clk_pick");

  ObjAnimate("obj_complex_lvl3wire_pick"..num, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  
  if num < 3 then
    ObjAnimate("obj_complex_lvl3wire_pick"..(num+1), "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  else 
    ObjAnimate("spr_complex_lvl3wire_lockpick", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  end;

end;
--------------------------------------------------------------------------------------------
function public.clk_openbackpack()

  cmn.Lock(1);
  cmn.CallEventHandler( "clk_openbackpack_beg", "inv_complex_redhatbackpack" );

  local func_after = function ()

    cmn.SetEventDone( "clk_openbackpack" );
    cmn.CallEventHandler( "clk_openbackpack_end", "inv_complex_redhatbackpack" );

    cmn.Lock(0);

  end;
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_nearhospital/audio/aud_xx_bag2");

  ObjAnimate("obj_complex_redhatbackpack_bag_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  ObjAnimate("spr_complex_redhatbackpack_bag_closed", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });

end;
--------------------------------------------------------------------------------------------
function public.clk_takephone()

  cmn.Lock(1);
  cmn.CallEventHandler( "clk_takephone_beg", "inv_complex_redhatbackpack" );

  local func_after = function ()

    cmn.SetEventDone( "clk_takephone" );
    cmn.CallEventHandler( "clk_takephone_end", "inv_complex_redhatbackpack" );

    cmn.Lock(0);

  end;
  
  local anm_phone = function ()
    
    private.anm_phone_call();
    ObjAnimate("anm_complex_redhatbackpack_phone_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
    
  end;
  
  cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_redhatbackpack/audio/aud_on_phone");

  ObjAnimate("spr_complex_redhatbackpack_phone_1", "pos_xy", 0, 0, anm_phone, { 0, 0, 32, 26,   0.7, 0, 46, -45 });

end;
--------------------------------------------------------------------------------------------
function public.clk_phoneon()

  cmn.Lock(1);
  cmn.CallEventHandler( "clk_phoneon_beg", "inv_complex_redhatbackpack" );

  local func_after = function ()

    cmn.SetEventDone( "clk_phoneon" );
    cmn.CallEventHandler( "clk_phoneon_end", "inv_complex_redhatbackpack" );

    cmn.Lock(0);
    cmn.ShowBbt( "complex_redhatbackpack_after_phonecall" );

  end;
  
  local phone_away = function ()
    
    int_blackbartext.Hide();
    ObjAnimate("anm_complex_redhatbackpack_phone_2", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
    
  end;
  
  local anm_call = function ()
    
    local show_sub2 = function ()
      
      cmn.ShowDlgBbt( "complex_redhatbackpack_police_voc_2" );
      ObjSet("tmr_complex_redhatbackpack_call_timer", { time = 4.8, playing = 1, endtrig = phone_away });
      
    end;
    
    cmn.ShowDlgBbt( "complex_redhatbackpack_police_voc_1" );
    cmn.PlayAudio("voc", "assets/levels/level3/inv_complex/inv_redhatbackpack/audio/aud_officer_dlg1_voc");
    
    ObjMultiSet( { {"anm_complex_redhatbackpack_phone_3",  { playing = 1 }},
                   {"tmr_complex_redhatbackpack_call_timer", { time = 7.8, playing = 1, endtrig = show_sub2 }} } );
    
  end;
  
  SndStop("assets/levels/level3/inv_complex/inv_redhatbackpack/audio/aud_cell_phone", 1);
  --cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_redhatbackpack/audio/");
  
  ObjStopAnimate("txt_complex_redhatbackpack_call", "alp");
  ObjAnimate("txt_complex_redhatbackpack_call", "alp", 0, 0, "", { 0, 0, ObjGet("txt_complex_redhatbackpack_call").alp,   0.2, 0, 1 });

  ObjAnimate("anm_complex_redhatbackpack_phone_3", "alp", 0, 0, anm_call, { 0, 0, 0,   0.8, 0, 0,   1.2, 0, 1 });
  ObjAnimate("spr_complex_redhatbackpack_answer", "alp", 0, 0, "", { 0, 0, 1,   0.8, 0, 1,   1.2, 0, 0 });
  
  ObjAnimate("spr_complex_redhatbackpack_answer_ind", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate("spr_complex_redhatbackpack_decline", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  
  ObjAnimate("spr_complex_redhatbackpack_answer", "pos_xy", 0, 0, "", { 0, 0, 674, 335,   0.8, 0, 758, 341 });

end;
--------------------------------------------------------------------------------------------
function public.clk_opentalebook( num )

  cmn.Lock(1);
  cmn.CallEventHandler( "clk_opentalebook_beg", "inv_complex_talebook" );

  local func_after = function ()

    cmn.SetEventDone( "clk_opentalebook" );
    cmn.CallEventHandler( "clk_opentalebook_end", "inv_complex_talebook" );

    if num == 1 then
      cmn.Lock(0);
    else 
      private.use_mermaidpage_end();
    end;

  end;
  
  cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_talebook/audio/aud_opn_book2");

  ObjSet("anm_complex_talebook_book",  { playing = 1, endtrig = func_after });

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.open_redhatbackpack()
  
  if interface.GetCurrentComplexInv() == "" then

    if cmn.IsEventDone("clk_takephone") and not(cmn.IsEventDone("clk_phoneon")) then

      private.anm_phone_call();

    end;
    
  end;

  common_impl.ShowComplexItem('redhatbackpack');
  
end;
--------------------------------------------------------------------------------------------
function public.touch_prunerss( name )
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_complex_oldpruners_use_"..name );
  
  cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_oldpruners/audio/aud_xx_clk_cutters");
  
  ObjSet("anm_complex_oldpruners_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function private.anm_phone_call()
  
  PlaySfx("assets/levels/level3/inv_complex/inv_redhatbackpack/audio/aud_cell_phone", 1, "", 1);
  
  ObjSet("txt_complex_redhatbackpack_call",  { alp = 1 });
  ObjAnimate("txt_complex_redhatbackpack_call", "alp", 1, 0, "", { 0, 0, 1,   0.4, 0, 0,     0.8, 0, 0,    1.2, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_casket()
  
  cmn.Lock(1);

  cmn.ShowBbt( "obj_complex_casket_use_amuletknot" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_xx_clk_wood4");
  
  ObjSet( "anm_complex_casket_casket", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
