-- name=rm_castlehall
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_castlehall";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Keytobook();
  --------------------------------------------------------------------------------------------
  private.dlg_lipsync = "";
  --------------------------------------------------------------------------------------------
  -- function get_juicyapple () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_juicyapple" ] = {
        type = "get",
        get_obj = "spr_throne_juicyapple",
        room = private.room_objname,
        zz = "zz_throne",
        zz_gate = "gzz_castlehall_throne"
    };
    --------------------------------------------------------------------------------------------
  local get_juicyapple_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_juicyapple", "spr_throne_juicyapple" );
  
  end;
  
  local get_juicyapple_end = function ()
  
    ObjDelete( "gfx_throne_juicyapple" );
    ObjDelete( "spr_throne_juicyapple_sh" );
    
    ObjDelete( "spr_castlehall_throne_apple" );
  
  end;
  
  cmn.AddSubscriber( "get_juicyapple", get_juicyapple_inv );
  cmn.AddSubscriber( "get_juicyapple", get_juicyapple_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mirrorshard1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_mirrorshard1" ] = {
        type = "get",
        get_obj = "spr_throne_mirrorshard1",
        room = private.room_objname,
        zz = "zz_throne",
        zz_gate = "gzz_castlehall_throne"
    };
    --------------------------------------------------------------------------------------------
  local get_mirrorshard1_inv = function ()
  
    int_map_impl.DecreaseRoomTasks("rm_castlehall");
    interface.InventoryItemAdd( "inv_mirrorshard", "spr_throne_mirrorshard1", function () cmn.GetMultyObject( 'mirrorshard', 3 ); end );
  
  end;
  
  local get_mirrorshard1_end = function ()
  
    ObjDelete( "gfx_throne_mirrorshard1" );
    
    if cmn.IsEventDone("get_crystalkey") then
      ObjSet("gzz_castlehall_throne",  { alp = 0, active = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_mirrorshard1", get_mirrorshard1_inv );
  cmn.AddSubscriber( "get_mirrorshard1", get_mirrorshard1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crystalkey () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_crystalkey" ] = {
        type = "get",
        get_obj = "spr_throne_crystalkey",
        room = private.room_objname,
        zz = "zz_throne",
        zz_gate = "gzz_castlehall_throne"
    };
    --------------------------------------------------------------------------------------------
  local get_crystalkey_inv = function ()
  
    int_map_impl.DecreaseRoomTasks("rm_castlehall");
    interface.InventoryItemAdd( "inv_crystalkey", "spr_throne_crystalkey" );
  
  end;
  
  local get_crystalkey_end = function ()
  
    ObjDelete( "gfx_throne_crystalkey" );
    
    if cmn.IsEventDone("get_mirrorshard1") then
      ObjSet("gzz_castlehall_throne",  { alp = 0, active = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_crystalkey", get_crystalkey_inv );
  cmn.AddSubscriber( "get_crystalkey", get_crystalkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokenbugle () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_brokenbugle" ] = {
        type = "get",
        get_obj = "spr_basrelief_brokenbugle",
        room = private.room_objname,
        zz = "zz_basrelief",
        zz_gate = "gzz_castlehall_basrelief"
    };
    --------------------------------------------------------------------------------------------
  local get_brokenbugle_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_brokenbugle", "spr_basrelief_brokenbugle" );
  
  end;
  
  local get_brokenbugle_end = function ()
  
    ObjDelete( "anm_basrelief_brokenbugle" );
    ObjDelete( "spr_castlehall_basrelief_horn" );
  
  end;
  
  cmn.AddSubscriber( "get_brokenbugle", get_brokenbugle_inv );
  cmn.AddSubscriber( "get_brokenbugle", get_brokenbugle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_foxfigurine () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_foxfigurine" ] = {
        type = "get",
        get_obj = "spr_keytobook_foxfigurine",
        room = private.room_objname,
        zz = "zz_keytobook",
        zz_gate = "gzz_castlehall_keytobook"
    };
    --------------------------------------------------------------------------------------------
  local get_foxfigurine_inv = function ()
  
    interface.InventoryItemAdd( "inv_foxfigurine", "spr_keytobook_foxfigurine" );
  
  end;
  
  local get_foxfigurine_end = function ()
  
    ObjDelete( "gfx_keytobook_foxfigurine" );
    
    ObjDelete( "spr_castlehall_door_fox" );
  
  end;
  
  cmn.AddSubscriber( "get_foxfigurine", get_foxfigurine_inv );
  cmn.AddSubscriber( "get_foxfigurine", get_foxfigurine_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_goldcrown () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_goldcrown" ] = {
        type = "use",
        inv_obj = "inv_goldcrown",
        use_place = "obj_throne_use_goldcrown",
        room = private.room_objname,
        zz = "zz_throne",
        zz_gate = "gzz_castlehall_throne"
    };
  --------------------------------------------------------------------------------------------
  local use_goldcrown_inv = function ()
  
    interface.InventoryItemRemove( "inv_goldcrown" );
  
  end;
  local use_goldcrown_beg = function ()
  
    ObjDelete( "obj_throne_use_goldcrown" );
    
  end;
  local use_goldcrown_end = function ()
    
    ObjMultiSet( { {"anm_throne_use_crown", { alp = 1, frame = 300 }},
                   {"spr_castlehall_throne_crown", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_fleurdelis") then
      ObjDelete( "anm_throne_seat_touch" );
      ObjDelete( "obj_throne_seat_touch" );
      ObjMultiSet( { {"anm_throne_seat_open",  { alp = 1, input = 1, frame = 300 }},
                     {"spr_castlehall_throne_open", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_goldcrown", use_goldcrown_beg, private.room_objname );
  cmn.AddSubscriber( "use_goldcrown", use_goldcrown_inv );
  cmn.AddSubscriber( "use_goldcrown", use_goldcrown_end, private.room_objname );
  cmn.AddSubscriber( "use_goldcrown_inv", use_goldcrown_inv, private.room_objname );
  cmn.AddSubscriber( "use_goldcrown_beg", use_goldcrown_beg, private.room_objname );
  cmn.AddSubscriber( "use_goldcrown_end", use_goldcrown_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fleurdelis () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_fleurdelis" ] = {
        type = "use",
        inv_obj = "inv_fleurdelis",
        use_place = "obj_throne_use_fleurdelis",
        room = private.room_objname,
        zz = "zz_throne",
        zz_gate = "gzz_castlehall_throne"
    };
  --------------------------------------------------------------------------------------------
  local use_fleurdelis_inv = function ()
  
    interface.InventoryItemRemove( "inv_fleurdelis" );
  
  end;
  local use_fleurdelis_beg = function ()
  
    ObjDelete( "obj_throne_use_fleurdelis" );
  
  end;
  local use_fleurdelis_end = function ()
    
    ObjMultiSet( { {"anm_throne_use_lily", { alp = 1, frame = 300 }},
                   {"spr_castlehall_throne_lily", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_goldcrown") then
      ObjDelete( "anm_throne_seat_touch" );
      ObjDelete( "obj_throne_seat_touch" );
      ObjMultiSet( { {"anm_throne_seat_open",  { alp = 1, input = 1, frame = 300 }},
                     {"spr_castlehall_throne_open", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fleurdelis", use_fleurdelis_beg, private.room_objname );
  cmn.AddSubscriber( "use_fleurdelis", use_fleurdelis_inv );
  cmn.AddSubscriber( "use_fleurdelis", use_fleurdelis_end, private.room_objname );
  cmn.AddSubscriber( "use_fleurdelis_inv", use_fleurdelis_inv, private.room_objname );
  cmn.AddSubscriber( "use_fleurdelis_beg", use_fleurdelis_beg, private.room_objname );
  cmn.AddSubscriber( "use_fleurdelis_end", use_fleurdelis_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_basreliefpart () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_basreliefpart" ] = {
        type = "use",
        inv_obj = "inv_basreliefpart",
        use_place = "obj_basrelief_use_basreliefpart",
        room = private.room_objname,
        zz = "zz_basrelief",
        zz_gate = "gzz_castlehall_basrelief"
    };
  --------------------------------------------------------------------------------------------
  local use_basreliefpart_inv = function ()
  
    interface.InventoryItemRemove( "inv_basreliefpart" );
  
  end;
  local use_basreliefpart_beg = function ()
  
    ObjDelete( "obj_basrelief_use_basreliefpart" );
  
  end;
  local use_basreliefpart_end = function ()
  
    ObjMultiSet( { {"gho_castlehall_onbasrelief", { input = 1, alp = 1, active = 1 }},
                   {"spr_castlehall_basrelief_full", { alp = 1 }} } );
                   
    ObjDelete( "gzz_castlehall_basrelief" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_basreliefpart", use_basreliefpart_beg, private.room_objname );
  cmn.AddSubscriber( "use_basreliefpart", use_basreliefpart_inv );
  cmn.AddSubscriber( "use_basreliefpart", use_basreliefpart_end, private.room_objname );
  cmn.AddSubscriber( "use_basreliefpart_inv", use_basreliefpart_inv, private.room_objname );
  cmn.AddSubscriber( "use_basreliefpart_beg", use_basreliefpart_beg, private.room_objname );
  cmn.AddSubscriber( "use_basreliefpart_end", use_basreliefpart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_enchantedhorn () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_enchantedhorn" ] = {
        type = "use",
        inv_obj = "inv_enchantedhorn",
        use_place = "obj_keytobook_use_enchantedhorn",
        room = private.room_objname,
        zz = "zz_keytobook",
        zz_gate = "gzz_castlehall_keytobook"
    };
  --------------------------------------------------------------------------------------------
  local use_enchantedhorn_inv = function ()
  
    interface.InventoryItemRemove( "inv_enchantedhorn" );
  
  end;
  local use_enchantedhorn_beg = function ()
  
    ObjDelete( "obj_keytobook_use_enchantedhorn" );
  
  end;
  local use_enchantedhorn_end = function ()

    ObjMultiSet( { {"spr_keytobook_horn", { alp = 1 }},
                   {"spr_castlehall_door_horn", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_lvl3enchantedflute") then

      ObjDelete( "anm_keytobook_face" );
      ObjDelete( "anm_keytobook_notes_fall" );
      ObjDelete( "obj_keytobook_door_bbt" );

      ObjSet( "obj_keytobook_notes", { alp = 1, input = true } );
      
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_enchantedhorn", use_enchantedhorn_beg, private.room_objname );
  cmn.AddSubscriber( "use_enchantedhorn", use_enchantedhorn_inv );
  cmn.AddSubscriber( "use_enchantedhorn", use_enchantedhorn_end, private.room_objname );
  cmn.AddSubscriber( "use_enchantedhorn_inv", use_enchantedhorn_inv, private.room_objname );
  cmn.AddSubscriber( "use_enchantedhorn_beg", use_enchantedhorn_beg, private.room_objname );
  cmn.AddSubscriber( "use_enchantedhorn_end", use_enchantedhorn_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl3enchantedflute () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_lvl3enchantedflute" ] = {
        type = "use",
        inv_obj = "inv_lvl3enchantedflute",
        use_place = "obj_keytobook_use_lvl3enchantedflute",
        room = private.room_objname,
        zz = "zz_keytobook",
        zz_gate = "gzz_castlehall_keytobook"
    };
  --------------------------------------------------------------------------------------------
  local use_lvl3enchantedflute_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl3enchantedflute" );
  
  end;
  local use_lvl3enchantedflute_beg = function ()
  
    ObjDelete( "obj_keytobook_use_lvl3enchantedflute" );
  
  end;
  local use_lvl3enchantedflute_end = function ()
  
    ObjMultiSet( { {"spr_keytobook_flute", { alp = 1 }},
                   {"spr_castlehall_door_flute", { alp = 1 }} } );

    if cmn.IsEventDone("use_enchantedhorn") then

      ObjDelete( "anm_keytobook_face" );
      ObjDelete( "anm_keytobook_notes_fall" );
      ObjDelete( "obj_keytobook_door_bbt" );

      ObjSet( "obj_keytobook_notes", { alp = 1, input = true } );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl3enchantedflute", use_lvl3enchantedflute_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3enchantedflute", use_lvl3enchantedflute_inv );
  cmn.AddSubscriber( "use_lvl3enchantedflute", use_lvl3enchantedflute_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl3enchantedflute_inv", use_lvl3enchantedflute_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl3enchantedflute_beg", use_lvl3enchantedflute_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3enchantedflute_end", use_lvl3enchantedflute_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magiconion () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_magiconioncastle" ] = {
        type = "use",
        inv_obj = "inv_magiconion",
        use_place = "obj_castlehall_use_magiconion",
        room = private.room_objname
    };
      
    game.hint[ "use_magiconionguard" ] = {
        type = "use",
        inv_obj = "inv_magiconion",
        use_place = "obj_guard_use_magiconion",
        room = "rm_relicstorage",
        zz = "zz_guard",
        zz_gate = "gzz_relicstorage_guard"
    };
  --------------------------------------------------------------------------------------------
  local use_magiconion_beg1 = function ()
  
    ObjDelete( "obj_castlehall_use_magiconion" );
  
  end;
  local use_magiconion_end1 = function ()
  
    ObjSet("gmg_castlehall_fightingqueen",  { alp = 1, input = 1, active = 1 });
    
  end;               
   
  local use_magiconion_inv = function ()
  
    interface.InventoryItemRemove( "inv_magiconion" );
  
  end;
  local use_magiconion_beg2 = function ()
  
    ObjDelete( "obj_guard_use_magiconion" );
  
  end;
  local use_magiconion_end2 = function ()
    
    ObjSet("spr_relicstorage_guard_bow",  { alp = 1 });
  
    if cmn.IsEventDone("use_quiverofgoldarrows") then
      ObjMultiSet( { {"anm_guard_archer_use",  { alp = 1, input = 1, frame = 400 }},
                     {"spr_relicstorage_guard_bowstring_2", { alp = 1 }} } );
      ObjDelete( "anm_guard_archer_touch" );
      ObjDelete( "spr_relicstorage_guard_bowstring_1" );
    else 
      ObjMultiSet( { {"spr_guard_bow_string", { alp = 1 }},
                     {"spr_guard_bow", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magiconioncastle", use_magiconion_beg1, private.room_objname );
  cmn.AddSubscriber( "use_magiconioncastle", use_magiconion_end1, private.room_objname );
  cmn.AddSubscriber( "use_magiconion_beg1", use_magiconion_beg1, private.room_objname );
  cmn.AddSubscriber( "use_magiconion_end1", use_magiconion_end1, private.room_objname );

  cmn.AddSubscriber( "use_magiconionguard", use_magiconion_beg2, "rm_relicstorage" );
  cmn.AddSubscriber( "use_magiconionguard", use_magiconion_inv );
  cmn.AddSubscriber( "use_magiconionguard", use_magiconion_end2, "rm_relicstorage" );
  cmn.AddSubscriber( "use_magiconion_inv", use_magiconion_inv, "rm_relicstorage" );
  cmn.AddSubscriber( "use_magiconion_beg2", use_magiconion_beg2, "rm_relicstorage" );
  cmn.AddSubscriber( "use_magiconion_end2", use_magiconion_end2, "rm_relicstorage" );
  
  --------------------------------------------------------------------------------------------
  -- function opn_castlehall () end;
  --------------------------------------------------------------------------------------------
  local opn_castlehall = function ()
  
    int_map_impl.OpenRoom( "rm_castlehall" );
  
  end;
  ----------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_castlehall", opn_castlehall );
  --------------------------------------------------------------------------------------------
  -- function opn_castlehallaftermg () end;
  --------------------------------------------------------------------------------------------
  local opn_castlehallaftermg_task = function ()

    int_map_impl.OpenRoom( "rm_witchhouse" );
    int_map_impl.OpenRoom( "rm_housegarden" );

    interface_impl.SetCurrentGlobalTask(19);

  end;
  local opn_castlehallaftermg_mid = function ()
    
    ObjDelete("anm_castlehall_queen_static");
  
    ObjMultiSet( { {"gzz_castlehall_throne", { alp = 1, input = 1, active = 1 }},
                   {"gzz_castlehall_basrelief", { alp = 1, input = 1, active = 1 }},
                   {"gzz_castlehall_keytobook", { alp = 1, input = 1, active = 1 }} } );
  
  end;
  local opn_castlehallaftermg_end = function ()
  
    ObjDelete("obj_castlehall_dialog_queen");
    ObjDelete("vid_castlehall_queen_disappear");
    
  end;
  local opn_castlehallaftermg_loc = function ()

    ObjSet( "anm_housegarden_portal", { animfunc = "func_rm_castlehall_portal2" } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_castlehallaftermg", opn_castlehallaftermg_mid, private.room_objname );
  cmn.AddSubscriber( "opn_castlehallaftermg", opn_castlehallaftermg_end, private.room_objname );
  cmn.AddSubscriber( "opn_castlehallaftermg_mid", opn_castlehallaftermg_mid, private.room_objname );
  cmn.AddSubscriber( "opn_castlehallaftermg_end", opn_castlehallaftermg_end, private.room_objname );
  cmn.AddSubscriber( "opn_castlehallaftermg", opn_castlehallaftermg_task );
  cmn.AddSubscriber( "opn_castlehallaftermg_task", opn_castlehallaftermg_task );
  cmn.AddSubscriber( "opn_castlehallaftermg", opn_castlehallaftermg_loc, "rm_housegarden" );
  cmn.AddSubscriber( "opn_castlehallaftermg_loc", opn_castlehallaftermg_loc, "rm_housegarden" );

end;
--********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_keytobook" );
  subroom.Define( "zz_throne" );

  function zz_keytobook.PreOpen()

    if cmn.IsEventDone( "use_enchantedhorn" ) and cmn.IsEventDone( "use_lvl3enchantedflute" ) and not cmn.IsEventDone( "win_keytobook" ) then
      cmn.MiniGameShow();
      private.zz_keytobook.DrawScene();
      private.zz_keytobook.CheckWin();
    end;

  end;

  function zz_keytobook.PreClose()

    if cmn.IsEventDone( "use_enchantedhorn" ) and cmn.IsEventDone( "use_lvl3enchantedflute" ) and not cmn.IsEventDone( "win_keytobook" ) then
      cmn.MiniGameHide("keytobook");
    end;

  end;
  
  function zz_throne.Close()
    cmn.HideNote( 0 );
  end;

end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_keytobook" ].state then 
    private.zz_keytobook.StartConditions();
  end;
  private.zz_keytobook.state = ng_global.progress[ ng_global.currentprogress ][ "win_keytobook" ].state;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_castlehall();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio3/aud_castlehall_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio3/aud_castlehall_env");
  
  if cmn.IsEventDone("win_fightingqueen") and not cmn.IsEventDone( "opn_castlehallaftermg" ) then
    cmn.Lock(1);
  end;
  
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(9) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_goldcrown()

  local item = "inv_goldcrown";

  if cmn.ApplyObj( item, "gzz_castlehall_throne" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_throne" );

  elseif ( cmn.ApplyObj( item, "obj_throne_use_goldcrown" ) ) then

    cmn.CallEventHandler( "use_goldcrown_inv" );
    cmn.CallEventHandler( "use_goldcrown_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_goldcrown" );
      cmn.CallEventHandler( "use_goldcrown_end" );
      
      if not cmn.IsEventDone("use_fleurdelis") then
        cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_panel_metal");
      end;

    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/rm_castlehall/audio/aud_chair_move");
      
      ObjMultiSet( { {"anm_throne_seat_open", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_throne_seat_touch", { alp = 0 }} } );
      
    end;

    cmn.Lock( 1 );

    if cmn.IsEventDone("use_fleurdelis") then
      ObjSet("anm_throne_use_crown",  { alp = 1, playing = 1, endtrig = anm_open });
    else 
      ObjSet("anm_throne_use_crown",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fleurdelis()

  local item = "inv_fleurdelis";

  if cmn.ApplyObj( item, "gzz_castlehall_throne" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_throne" );

  elseif ( cmn.ApplyObj( item, "obj_throne_use_fleurdelis" ) ) then

    cmn.CallEventHandler( "use_fleurdelis_inv" );
    cmn.CallEventHandler( "use_fleurdelis_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_fleurdelis" );
      cmn.CallEventHandler( "use_fleurdelis_end" );
      
      if not cmn.IsEventDone("use_goldcrown") then
        cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_panel_metal");
      end;

    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/rm_castlehall/audio/aud_chair_move");
      
      ObjMultiSet( { {"anm_throne_seat_open", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_throne_seat_touch", { alp = 0 }} } );
      
    end;

    cmn.Lock( 1 );

    if cmn.IsEventDone("use_goldcrown") then
      ObjSet("anm_throne_use_lily",  { alp = 1, playing = 1, endtrig = anm_open });
    else 
      ObjSet("anm_throne_use_lily",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_basreliefpart()

  local item = "inv_basreliefpart";

  if cmn.ApplyObj( item, "gzz_castlehall_basrelief" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_basrelief" );

  elseif ( cmn.ApplyObj( item, "obj_basrelief_use_basreliefpart" ) and cmn.CheckMultiObject( "basreliefpart", 2 ) ) then

    cmn.CallEventHandler( "use_basreliefpart_inv" );
    cmn.CallEventHandler( "use_basreliefpart_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_basreliefpart" );
      cmn.CallEventHandler( "use_basreliefpart_end" );
      
      common.CloseSubRoom();

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_castlehall/audio/aud_stones_part_use");

    ObjAnimate( "spr_basrelief_basreliefpart_1", "alp", 0, 0, "",
    {
      0.0, 0, 0, 
      0.3, 0, 1
    } );
    
    ObjAnimate( "spr_basrelief_basreliefpart_2", "alp", 0, 0, func_after,
    {
      0.0, 0, 0, 
      0.4, 0, 0,
      0.7, 0, 1,
        1, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_enchantedhorn()

  local item = "inv_enchantedhorn";

  if cmn.ApplyObj( item, "gzz_castlehall_keytobook" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_keytobook" );

  elseif ( cmn.ApplyObj( item, "obj_keytobook_use_enchantedhorn" ) ) then

    cmn.CallEventHandler( "use_enchantedhorn_inv" );
    cmn.CallEventHandler( "use_enchantedhorn_beg" );

    local func_after2 = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_enchantedhorn" );
      cmn.CallEventHandler( "use_enchantedhorn_end" );
      
      if cmn.IsEventDone("use_lvl3enchantedflute") then

        cmn.MiniGameShow();

        if not cmn.IsEventDone("get_foxfigurine") then
          public.get_foxfigurine();
        end;

      end;

    end;

    local func_after = function ()
      ObjAnimate( "anm_keytobook_face", "alp", 0, 0, function ()
        cmn.PlayAudio("snd", "assets/levels/level3/rm_castlehall/audio/aud_drop_stones");
        ObjSet( "anm_keytobook_notes_fall", { pos_z = 26, endtrig = func_after2, playing = true } );
      end, { 0, 0, 1,    0.5, 0, 0,    1.5, 0, 0 } );
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_castlehall/audio/aud_use_horn2");

    ObjAnimate( "spr_keytobook_horn", "alp", 0, 0, ( cmn.IsEventDone( "use_lvl3enchantedflute" ) and func_after or func_after2 ), 
      { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl3enchantedflute()

  local item = "inv_lvl3enchantedflute";

  if cmn.ApplyObj( item, "gzz_castlehall_keytobook" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_keytobook" );

  elseif ( cmn.ApplyObj( item, "obj_keytobook_use_lvl3enchantedflute" ) ) then

    cmn.CallEventHandler( "use_lvl3enchantedflute_inv" );
    cmn.CallEventHandler( "use_lvl3enchantedflute_beg" );

    local func_after2 = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl3enchantedflute" );
      cmn.CallEventHandler( "use_lvl3enchantedflute_end" );
      
      if cmn.IsEventDone("use_enchantedhorn") then

        cmn.MiniGameShow();

        if not cmn.IsEventDone("get_foxfigurine") then
          public.get_foxfigurine();
        end;

      end;

    end;

    local func_after = function ()
      ObjAnimate( "anm_keytobook_face", "alp", 0, 0, function ()
        cmn.PlayAudio("snd", "assets/levels/level3/rm_castlehall/audio/aud_drop_stones");
        ObjSet( "anm_keytobook_notes_fall", { pos_z = 26, endtrig = func_after2, playing = true } );
      end, { 0, 0, 1,    0.5, 0, 0,    1.5, 0, 0 } );
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_castlehall/audio/aud_use_flute");

    ObjAnimate( "spr_keytobook_flute", "alp", 0, 0, ( cmn.IsEventDone( "use_enchantedhorn" ) and func_after or func_after2 ), 
      { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_magiconion()

  local item = "inv_magiconion";

  if ( cmn.ApplyObj( item, "obj_castlehall_use_magiconion" ) ) then

    cmn.CallEventHandler( "use_magiconion_beg1" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_magiconioncastle" );
      cmn.CallEventHandler( "use_magiconion_end1" );
      
      cmn.GotoRoom("mg_fightingqueen");

    end;

    cmn.Lock( 1 );

    func_after();

    --ObjAnimate( "spr_castlehall_", "alp", 0, 0, func_after,
    --{
    --  0.0, 0, 0, 
    --  0.3, 0, 1
    --} );
  
  elseif cmn.ApplyObj( item, "gzz_relicstorage_guard" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_guard" );

  elseif ( cmn.ApplyObj( item, "obj_guard_use_magiconion" ) ) then

    cmn.CallEventHandler( "use_magiconion_inv" );
    cmn.CallEventHandler( "use_magiconion_beg2" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_magiconionguard" );
      cmn.CallEventHandler( "use_magiconion_end2" );

    end;
    
    local anm_archer = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/rm_relicstorage/audio/aud_use_quiver");
      
      ObjMultiSet( { {"anm_guard_archer_touch", { alp = 0 }},
                     {"anm_guard_archer_use", { alp = 1, playing = 1, endtrig = func_after }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_relicstorage/audio/aud_use_bow");

    if cmn.IsEventDone("use_quiverofgoldarrows") then
      ObjAnimate("spr_guard_bow", "alp", 0, 0, anm_archer, { 0, 0, 0,   0.3, 0, 1,  0.6, 0, 1 });
      ObjAnimate("spr_guard_bow_string", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    else 
      ObjAnimate("spr_guard_bow", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_guard_bow_string", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_juicyapple()

  cmn.SetEventDone( "get_juicyapple" );
  cmn.CallEventHandler( "get_juicyapple" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_mirrorshard1()
  
  ObjSet("spr_throne_mirrorshard1",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_mirrorshard1" );
  cmn.CallEventHandler( "get_mirrorshard1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_crystalkey") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_crystalkey()
  
  ObjSet("spr_throne_crystalkey",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_crystalkey" );
  cmn.CallEventHandler( "get_crystalkey" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_mirrorshard1") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_brokenbugle()
  
  ObjSet("spr_basrelief_brokenbugle",  { alp = 1 });

  cmn.SetEventDone( "get_brokenbugle" );
  cmn.CallEventHandler( "get_brokenbugle" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_foxfigurine()

  cmn.SetEventDone( "get_foxfigurine" );
  cmn.CallEventHandler( "get_foxfigurine" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_castlehall()

  if not cmn.IsEventDone( "opn_castlehall" ) then

    cmn.SetEventDone( "opn_castlehall" );
    cmn.CallEventHandler("opn_castlehall");

    cmn.ShowBbt( "castlehall_open" );

  end;
  
  if cmn.IsEventDone("win_fightingqueen") and not cmn.IsEventDone( "opn_castlehallaftermg" ) then
    
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);

    cmn.SetEventDone( "opn_castlehallaftermg" );
    cmn.CallEventHandler("opn_castlehallaftermg_task");
    ObjAttach("obj_castlehall_dialog_queen", "rm_castlehall");
    ObjAnimate("obj_castlehall_dialog_queen", "alp", 0, 0, private.dialog_queen_beg, { 0, 0, 0,   0.5, 0, 1 });

  end;

end;
--------------------------------------------------------------------------------------------
function private.dialog_queen_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "castlehall", "queen", 2 );
  
  local dialog_end = function ()
    
    cmn.Lock(0);
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "opn_castlehallaftermg_end" );
    
    cmn.ShowBbt( "castlehall_after_dialog" );
    interface_impl.ShowGlobalTask();
    int_map_impl.AddDiarypage( 10 );
    
  end;
  
  local anm_queen = function ()
    
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level3/rm_castlehall/audio/aud_queen_disappearance");
    cmn.PlayAudio("env", "assets/levels/common/audio/audio3/aud_castlehall_env");
    
    ObjDelete("obj_castlehall_dialog_queen");
    
    ObjAttach("vid_castlehall_queen_disappear", "rm_castlehall");
    VidPlay("vid_castlehall_queen_disappear", dialog_end)
    
  end;
  
  local play_flashback = function ()
    
    cmn.CallEventHandler( "opn_castlehallaftermg_mid" );
    cmn.CallEventHandler("opn_castlehallaftermg_loc");
      
    private.dlg_lipsync = "";
    common_impl.current_dialog = "";
    
    interface.InterfaceSetInput( true );
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjSet("tmr_castlehall_dialog_queen_timer",  { playing = 0 });
    
    common_impl.PlayBackgroundMusic();
    
    cmn.StopAllEnv();
    
    cmn.PlayCutScene( "queenflashback",
                      "assets/levels/level3/rm_castlehall/flashback_queen/anm_flashback_queen",
                      { 0, 9.2, 22 },
                      anm_queen, 
                      "assets/levels/level3/rm_castlehall/audio/aud_queen_flashback",
                      "assets/levels/level3/rm_castlehall/audio/aud_queen_flashback_voc" );
    
  end;
  
  private.dlg_lipsync = "vid_castlehall_dialog_queen_lipsync1";

  cmn.ShowDlgBbt( "dlg_queen_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level3/rm_castlehall/audio/aud_queen_dlg1_voc");

  ObjMultiSet( { {"tmr_castlehall_dialog_queen_timer", { time = 12, playing = 1, endtrig = play_flashback }},
                 {"vid_castlehall_dialog_queen_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = play_flashback }},
                 {"obj_character_dialog_continue", { event_mup = play_flashback }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_queen()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  --cmn.Lock(1);
  common_impl.current_dialog = "";
  
  cmn.CallEventHandler( "opn_castlehallaftermg_mid" );
  cmn.CallEventHandler("opn_castlehallaftermg_loc");

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "opn_castlehallaftermg_end" );
    
    cmn.ShowBbt( "castlehall_after_dialog" );
    interface_impl.ShowGlobalTask();
    int_map_impl.AddDiarypage( 10 );
    
  end;
  
  local anm_queen = function ()
    
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level3/rm_castlehall/audio/aud_queen_disappearance");
    cmn.PlayAudio("env", "assets/levels/common/audio/audio3/aud_castlehall_env");
    
    ObjDelete("obj_castlehall_dialog_queen");
    
    ObjAttach("vid_castlehall_queen_disappear", "rm_castlehall");
    VidPlay("vid_castlehall_queen_disappear", func_after_dlg)
    
  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    --ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  ObjSet("tmr_castlehall_dialog_queen_timer",  { playing = 0 });
  common_impl.CharacterDialogButtonsHide();
  
  common_impl.PlayBackgroundMusic();
  
  cmn.StopAllEnv();
  
  cmn.PlayCutScene( "queenflashback",
                    "assets/levels/level3/rm_castlehall/flashback_queen/anm_flashback_queen",
                    { 0, 9.2, 22 },
                    anm_queen, 
                    "assets/levels/level3/rm_castlehall/audio/aud_queen_flashback",
                    "assets/levels/level3/rm_castlehall/audio/aud_queen_flashback_voc" );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_face()
  
  cmn.Lock(1);

  local func_after = function ()
    ObjSet( "anm_keytobook_face", { animfunc = "func_face", endtrig = "", playing = true } );
    cmn.Lock(0);
  end;

  cmn.ShowBbt( "keytobook_door" );

  cmn.PlayAudio("snd", "assets/levels/level3/rm_castlehall/audio/aud_xx_head_laugh");

  ObjSet( "anm_keytobook_face", { animfunc = "func_touch_face", endtrig = func_after, playing = true } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_throne()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_throne_use_goldcrown" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_atshore/audio/aud_xx_wood_sand");
  
  ObjSet("anm_throne_seat_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
  if not cmn.IsEventDone("get_juicyapple") then
    public.get_juicyapple();
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_9_1", { alp = 1 }},
                 {"spr_col_9_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_9_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_9_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_9_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_9_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_9_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_9_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--*********************************************************************************************************************
-- function *** MMG_Keytobook *** () end;
--*********************************************************************************************************************
private.zz_keytobook = {};
public.zz_keytobook = {};

function private.Init_Keytobook()

  private.zz_keytobook.notes_start_pos = { --x, y, ang
    { 53, 224, -0.2618 }, {  -89, 230,  0 },      {  84, 197, 0.2618 }, { -48, 200, 0.7854 },
    { 32, 186,  0.2618 }, { -100, 170, -0.5236 }, { 114, 172, 0.2618 }
  };

  private.zz_keytobook.notes_win_pos = {
    { 53, 119 }, { -63, -132 }, {  65, -145 }, { -68, 117 },
    { 66, -44 }, { -87,   17 }, { 101,   41 }
  };
  -------------------------------------------------------------------------------------------
  game.hint[ "win_keytobook" ] = {
    type = "win",
    room = "rm_castlehall",
    zz = "zz_keytobook",
    zz_gate = "gzz_castlehall_keytobook"
  };
  -----------------------------------------------------------------------------------
  local win_keytobook = function ()

    if cmn.IsEventDone( "win_keytobook" ) then
      ObjMultiSet( { {"grm_castlehall_relicstorage", { input = 1, alp = 1 }},
                     {"spr_castlehall_door_open", { alp = 1 }} } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_castlehall_relicstorage_focus");
      end;
      ObjDelete( "gzz_castlehall_keytobook" );
      ObjDelete( "spr_castlehall_door_horn" );
      ObjDelete( "spr_castlehall_door_flute" );
    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_keytobook", win_keytobook, "rm_castlehall" );

end;
-----------------------------------------------------------------------------------
function private.zz_keytobook.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_keytobook" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_keytobook" ].state = {  --[слот] = нота
    0, 0, 0, 0, 0, 0, 0
  };

end;
-----------------------------------------------------------------------------------
function public.zz_keytobook.Reset()

  --DbgTrace( "***Reset" );

  local go_reset = false;
  local note_name;
  local note_num;

  for i = 1, 7, 1 do

    if ( private.zz_keytobook.state[i] ~= 0 ) then

      go_reset = true;

      note_num = private.zz_keytobook.state[i];
      note_name = "spr_keytobook_note_"..note_num;

      ObjAttach( note_name, "obj_keytobook_notes" );

      ObjAnimate( note_name, "pos_xy", 0, 0, "", {
        0,   0, private.zz_keytobook.notes_win_pos[i][1],            private.zz_keytobook.notes_win_pos[i][2],
        0.3, 0, private.zz_keytobook.notes_start_pos[ note_num ][1], private.zz_keytobook.notes_start_pos[ note_num ][2]
      } );

      ObjAnimate( note_name, "ang", 0, 0, "", { 0, 0, 0,     0.3, 0, private.zz_keytobook.notes_start_pos[ note_num ][3] } );

      if ( private.zz_keytobook.state[i] == i ) then

        ObjAnimate( "spr_keytobook_note_light_"..i, "alp", 0, 0, "", { 0, 0, ObjGet( "spr_keytobook_note_light_"..i ).alp,    0.3, 0, 0 } );

        ObjSet( note_name, { input = true } );

      end;

      private.zz_keytobook.state[i] = 0;

    end;

  end;

  if ( go_reset ) then
    cmn.Lock( 1 );
    ObjSet( "tmr_keytobook_animlock", { time = 0.3, endtrig = function () cmn.Lock( 0 ); end, playing = true } );
  end;

end;
-----------------------------------------------------------------------------------
function public.zz_keytobook.Skip()

  --DbgTrace( "***Skip" );

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/rm_castlehall/audio/aud_use_notes"..math.random(1, 3));
  cmn.PlayAudio("snd", "assets/levels/level2/mg_onmagicstone/audio/aud_xx_use_stone2");

  ng_global.progress[ ng_global.currentprogress ][ "win_keytobook" ].skip = 1;

  local note_name;
  local note_pos;

  for i = 1, 7, 1 do
    if ( private.zz_keytobook.state[i] ~= i ) then

      note_name = "spr_keytobook_note_"..i;
      note_pos = 0;

      for j = 1, 7, 1 do  --ищем где стоит
        if ( private.zz_keytobook.state[j] == i ) then
          note_pos = j;
          private.zz_keytobook.state[j] = 0;
          break;
        end;
      end;
      --DbgTrace( i..", note_pos = "..note_pos );

      local start_pos_xy = ( note_pos == 0 ) and private.zz_keytobook.notes_start_pos[i] or private.zz_keytobook.notes_win_pos[note_pos];

      local func_after = function ()
        ObjAttach( "spr_keytobook_note_"..i, "obj_keytobook_door" );
        ObjAnimate( "spr_keytobook_note_light_"..i, "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
      end;

      ObjSet( note_name, { input = false } );

      ObjAnimate( note_name, "pos_xy", 0, 0, func_after, {
        0,   0, start_pos_xy[1],                          start_pos_xy[2],
        0.3, 0, private.zz_keytobook.notes_win_pos[i][1], private.zz_keytobook.notes_win_pos[i][2]
      } );

      if ( note_pos == 0 ) then
        ObjAnimate( note_name, "ang", 0, 0, "", {
          0,   0, private.zz_keytobook.notes_start_pos[i][3],
          0.3, 0, 0
        } );
      end;

    end;
  end;

  for i = 1, 7, 1 do
    private.zz_keytobook.state[i] = i;
  end;

  ObjSet( "tmr_keytobook_animlock", { time = 0.3, endtrig = private.zz_keytobook.CheckWin, playing = true } );

end;
-----------------------------------------------------------------------------------
function private.zz_keytobook.DrawScene()

  --DbgTrace( "***DrawScene" );

  local note_name;

  for i = 1, 7, 1 do
    if ( private.zz_keytobook.state[i] ~= 0 ) then

      note_name = "spr_keytobook_note_"..private.zz_keytobook.state[i];

      ObjAttach( note_name, "obj_keytobook_door" );
      ObjSet( note_name, { ang = 0, pos_x = private.zz_keytobook.notes_win_pos[i][1], pos_y = private.zz_keytobook.notes_win_pos[i][2] } );

      if ( private.zz_keytobook.state[i] == i ) then

        ObjStopAnimate( "spr_keytobook_note_light_"..i, "alp" );

        ObjMultiSet( { 
          { "spr_keytobook_note_light_"..i, { alp = 1 } },
          { note_name, { input = false } } 
        } );

      end;

    end;
  end;

end;
-----------------------------------------------------------------------------------
function private.zz_keytobook.CheckWin()

  for i = 1, 7, 1 do
    if ( private.zz_keytobook.state[i] ~= i ) then
      return;
    end;
  end;

  cmn.Lock( 1 );
  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
  cmn.PlayAudio("snd", "assets/levels/level3/rm_castlehall/audio/aud_opn_storage");

  ObjSet( "tmr_keytobook_animlock", { time = 1.3, playing = true, endtrig = function ()
    ObjMultiSet( { 
      { "obj_keytobook_door", { alp = 0 } },
      { "obj_keytobook_notes", { alp = 0 } },
      { "anm_keytobook_door_open", { endtrig = private.zz_keytobook.Win, playing = true } } 
    } );
  end } );

end;
-----------------------------------------------------------------------------------
function private.zz_keytobook.Win()

  cmn.MiniGameHide("keytobook");

  cmn.SetEventDone( "win_keytobook" );
  cmn.CallEventHandler( "win_keytobook" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_keytobook" ].skip == 0 and ng_global.noskipgames[ "win_keytobook" ] == nil then
    ng_global.noskipgames[ "win_keytobook" ] = 1;
    common_impl.CheckAchiev("mg");
  end;

  common.CloseSubRoom();

  cmn.Lock( 0 );

end;
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
function public.zz_keytobook.StartDragNote( num )

  --DbgTrace( "" );
  --DbgTrace( "***StartDragNote "..num );
  public.zz_keytobook.FocusNote( num, 1 );
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");

  ObjSet( "spr_keytobook_note_"..num, { pos_z = 20, ang = 0 } );
  ObjAttach( "spr_keytobook_note_"..num, "obj_keytobook_notes" );

  for i = 1, 7, 1 do
    if ( private.zz_keytobook.state[i] == num ) then  --если была в какомто слоте - убираем оттуда
      private.zz_keytobook.state[i] = 0;
      --DbgTrace( "нота была в слоте "..i );
      break;
    end;
  end;

end;
-----------------------------------------------------------------------------------
function public.zz_keytobook.DropDragNote( num )

  --DbgTrace( "" );
  --DbgTrace( "***DropDragNote "..num );

  cmn.Lock( 1 );
  public.zz_keytobook.FocusNote( num, 0 );
  local note_name = "spr_keytobook_note_"..num;
  local curspos = GetObjPosByObj( note_name, "obj_keytobook_notes" );--GetZoomCursorPos();
  local new_pos = 0;          --новая позиция ноты, 0 - кинули в левое место - падает на пол
  local start_drag_note = 0;  --если в новой позиции была нота, начнем ее тоскать

  --DbgTrace( curspos[1].." "..curspos[2] );

  for i = 1, 7, 1 do
    if  ( private.zz_keytobook.notes_win_pos[i][1] - 40 < curspos[1] ) and ( private.zz_keytobook.notes_win_pos[i][1] + 40 > curspos[1] )
    and ( private.zz_keytobook.notes_win_pos[i][2] - 30 < curspos[2] ) and ( private.zz_keytobook.notes_win_pos[i][2] + 30 > curspos[2] ) then

      if  ( private.zz_keytobook.state[i] ~= i ) then --уже стоит правильная нота

        --DbgTrace( "note "..num.." -> pos "..i );
        new_pos = i;

        ObjAttach( note_name, "obj_keytobook_door" );

        if ( private.zz_keytobook.state[i] ~= num ) then
          start_drag_note = private.zz_keytobook.state[i];
          private.zz_keytobook.state[i] = num;
        end;

      end;

      break;

    end;
  end;

  local end_pos_xy = ( new_pos == 0 ) and private.zz_keytobook.notes_start_pos[num] or private.zz_keytobook.notes_win_pos[new_pos];
  local len = common_impl.math.FindSegmentLength( curspos, end_pos_xy );
  local tme = 0.002 * len;
  tme = ( tme <= 0.3 ) and tme or 0.3;

  if ( new_pos == 0 ) then
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_wrong_apply");
    ObjAnimate( note_name, "ang", 0, 0, "", { 0, 0, 0,    tme, 0, private.zz_keytobook.notes_start_pos[num][3] } );
  else 
    cmn.PlayAudio("snd", "assets/levels/level2/mg_onmagicstone/audio/aud_xx_use_stone2");
  end;

  local func_after = function()

    cmn.Lock( 0 );

    ObjSet( note_name, { pos_z = 8 - num } );

    if ( start_drag_note ~= 0 ) then
      ObjStartDrag( "spr_keytobook_note_"..start_drag_note ); --начинаем таскать ноту которую заменили
      --DbgTrace( "start drag note "..start_drag_note );
    end;

    if ( new_pos == num ) then  --если поставили ноту в свой слот
      cmn.PlayAudio("snd", "assets/levels/level3/rm_castlehall/audio/aud_use_notes"..math.random(1, 3));
      ObjSet( note_name, { input = false } );
      ObjAnimate( "spr_keytobook_note_light_"..num, "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
      private.zz_keytobook.CheckWin();
    end;

  end;
  
  ObjAnimate( note_name, "pos_xy", 0, 0, func_after, { 0, 0, curspos[1], curspos[2],   tme, 0, end_pos_xy[1], end_pos_xy[2] } );

end;
-----------------------------------------------------------------------------------
function public.zz_keytobook.FocusNote( num, inout )--анимация фокуса

  local obj = "spr_keytobook_note_focus_"..num;
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_GET);
    tme = ( 1 - alf ) * 0.3;
  end;

  ObjAnimate( obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout } );

end;
--*********************************************************************************************************************