-- name=rm_nearpolicedepartment
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_nearpolicedepartment";
  --------------------------------------------------------------------------------------------

  --------------------------------------------------------------------------------------------
  -- function get_bearspear () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_bearspear" ] = {
        type = "get",
        get_obj = "spr_policedoor_bearspear",
        room = private.room_objname,
        zz = "zz_policedoor",
        zz_gate = "gzz_nearpolicedepartment_policedoor"
    };
    --------------------------------------------------------------------------------------------
  local get_bearspear_inv = function ()
  
    interface.InventoryItemAdd( "inv_bearspear", "spr_policedoor_bearspear" );
  
  end;
  
  local get_bearspear_end = function ()
  
    ObjDelete( "obj_policedoor_bearspear_get" );
    ObjDelete( "spr_policedoor_bearspear_sh" );
    ObjDelete( "spr_policedoor_bearspear_sh_2" );
    
    ObjDelete( "spr_nearpolicedepartment_door_stick" );
  
  end;
  
  cmn.AddSubscriber( "get_bearspear", get_bearspear_inv );
  cmn.AddSubscriber( "get_bearspear", get_bearspear_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wolffigurine () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_wolffigurine" ] = {
        type = "get",
        get_obj = "spr_policewindow_wolffigurine",
        room = private.room_objname,
        zz = "zz_policewindow",
        zz_gate = "gzz_nearpolicedepartment_policewindow"
    };
    --------------------------------------------------------------------------------------------
  local get_wolffigurine_inv = function ()
  
    interface.InventoryItemAdd( "inv_wolffigurine", "spr_policewindow_wolffigurine" );
  
  end;
  
  local get_wolffigurine_end = function ()
  
    ObjDelete( "gfx_policewindow_wolffigurine" );
    ObjDelete( "spr_policewindow_wolffigurine_sh" );
    
    if cmn.IsEventDone("get_revolver1") and cmn.IsEventDone("get_carkey") then
      ObjDelete( "gzz_nearpolicedepartment_policewindow" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_wolffigurine", get_wolffigurine_inv );
  cmn.AddSubscriber( "get_wolffigurine", get_wolffigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_casebutton () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_casebutton" ] = {
        type = "get",
        get_obj = "spr_policewindow_casebutton",
        room = private.room_objname,
        zz = "zz_policewindow",
        zz_gate = "gzz_nearpolicedepartment_policewindow"
    };
    --------------------------------------------------------------------------------------------
  local get_casebutton_inv = function ()
  
    interface.InventoryItemAdd( "inv_casebutton", "spr_policewindow_casebutton" );
  
  end;
  
  local get_casebutton_end = function ()
  
    ObjDelete( "gfx_policewindow_casebutton" );
    ObjDelete( "spr_policewindow_casebutton_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_casebutton", get_casebutton_inv );
  cmn.AddSubscriber( "get_casebutton", get_casebutton_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_carkey () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_carkey" ] = {
        type = "get",
        get_obj = "spr_policewindow_carkey",
        room = private.room_objname,
        zz = "zz_policewindow",
        zz_gate = "gzz_nearpolicedepartment_policewindow"
    };
    --------------------------------------------------------------------------------------------
  local get_carkey_inv = function ()
  
    int_map_impl.DecreaseRoomTasks("rm_nearpolicedepartment");
    interface.InventoryItemAdd( "inv_carkey", "spr_policewindow_carkey" );
  
  end;
  
  local get_carkey_end = function ()
  
    ObjDelete( "gfx_policewindow_carkey" );
    ObjDelete( "spr_policewindow_carkey_sh" );
    
    ObjSet("spr_policewindow_revolver1",  { input = 1 });
    
    if cmn.IsEventDone("get_revolver1") and cmn.IsEventDone("get_wolffigurine") then
      ObjDelete( "gzz_nearpolicedepartment_policewindow" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_carkey", get_carkey_inv );
  cmn.AddSubscriber( "get_carkey", get_carkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl3star () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_lvl3star" ] = {
        type = "get",
        get_obj = "spr_policewindow_lvl3star",
        room = private.room_objname,
        zz = "zz_policewindow",
        zz_gate = "gzz_nearpolicedepartment_policewindow"
    };
    --------------------------------------------------------------------------------------------
  local get_lvl3star_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl3star", "spr_policewindow_lvl3star" );
    ObjSet("inv_policebadgebase_star_light",  { alp = 1 });
  
  end;
  
  local get_lvl3star_end = function ()
  
    ObjDelete( "gfx_policewindow_lvl3star" );
    ObjDelete( "spr_policewindow_lvl3star_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_lvl3star", get_lvl3star_inv );
  cmn.AddSubscriber( "get_lvl3star", get_lvl3star_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_torch () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_torch" ] = {
        type = "get",
        get_obj = "spr_policewindow_torch",
        room = private.room_objname,
        zz = "zz_policewindow",
        zz_gate = "gzz_nearpolicedepartment_policewindow"
    };
    --------------------------------------------------------------------------------------------
  local get_torch_inv = function ()
  
    interface.InventoryItemAdd( "inv_torch", "spr_policewindow_torch" );
  
  end;
  
  local get_torch_end = function ()
  
    ObjDelete( "gfx_policewindow_torch" );
    ObjDelete( "spr_policewindow_torch_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_torch", get_torch_inv );
  cmn.AddSubscriber( "get_torch", get_torch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_revolver1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_revolver1" ] = {
        type = "get",
        get_obj = "spr_policewindow_revolver1",
        room = private.room_objname,
        zz = "zz_policewindow",
        zz_gate = "gzz_nearpolicedepartment_policewindow"
    };
    --------------------------------------------------------------------------------------------
  local get_revolver1_inv = function ()
  
    int_map_impl.DecreaseRoomTasks("rm_nearpolicedepartment");
    interface.InventoryItemAdd( "inv_revolver1", "spr_policewindow_revolver1" );
  
  end;
  
  local get_revolver1_end = function ()
  
    ObjDelete( "gfx_policewindow_revolver1" );
    ObjDelete( "spr_policewindow_revolver1_sh" );
    
    if cmn.IsEventDone("get_carkey") and cmn.IsEventDone("get_wolffigurine") then
      ObjDelete( "gzz_nearpolicedepartment_policewindow" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_revolver1", get_revolver1_inv );
  cmn.AddSubscriber( "get_revolver1", get_revolver1_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_policebadge () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_policebadge" ] = {
        type = "use",
        inv_obj = "inv_policebadge",
        use_place = "obj_policedoor_use_policebadge",
        room = private.room_objname,
        zz = "zz_policedoor",
        zz_gate = "gzz_nearpolicedepartment_policedoor"
    };
  --------------------------------------------------------------------------------------------
  local use_policebadge_inv = function ()
  
    interface.InventoryItemRemove( "inv_policebadge" );
  
  end;
  local use_policebadge_beg = function ()
  
    ObjDelete( "obj_policedoor_use_policebadge" );
    ObjDelete( "anm_policedoor_door_touch" );
  
  end;
  local use_policebadge_end = function ()
    
    ObjDelete("anm_nearpolicedepartment_wolf");
    ObjDelete("obj_nearpolicedepartment_wolf_touch");
  
    ObjDelete( "gzz_nearpolicedepartment_policedoor" );
    ObjDelete( "obj_nearpolicedepartment_door_closed" );

    ObjMultiSet( { { "grm_nearpolicedepartment_policedepartment", { input = 1, alp = 1 } },
                   { "spr_nearpolicedepartment_door_open", { alp = 1 } } } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_nearpolicedepartment_policedepartment_focus");
    end;
  end;
  local use_policebadge_preloc = function ()
  
    ObjSet("spr_street_police_open",  { alp = 1 });
    ObjDelete("spr_street_police_wolf");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_policebadge", use_policebadge_beg, private.room_objname );
  cmn.AddSubscriber( "use_policebadge", use_policebadge_inv );
  cmn.AddSubscriber( "use_policebadge", use_policebadge_end, private.room_objname );
  cmn.AddSubscriber( "use_policebadge_inv", use_policebadge_inv, private.room_objname );
  cmn.AddSubscriber( "use_policebadge_beg", use_policebadge_beg, private.room_objname );
  cmn.AddSubscriber( "use_policebadge_end", use_policebadge_end, private.room_objname );
  cmn.AddSubscriber( "use_policebadge", use_policebadge_preloc, "rm_street" );
  cmn.AddSubscriber( "use_policebadge_preloc", use_policebadge_preloc, "rm_street" );
  --------------------------------------------------------------------------------------------
  -- function use_bearspear () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_bearspear" ] = {
        type = "use",
        inv_obj = "inv_bearspear",
        use_place = "obj_policewindow_use_bearspear",
        room = private.room_objname,
        zz = "zz_policewindow",
        zz_gate = "gzz_nearpolicedepartment_policewindow"
    };
  --------------------------------------------------------------------------------------------
  local use_bearspear_inv = function ()
  
    interface.InventoryItemRemove( "inv_bearspear" );
  
  end;
  local use_bearspear_beg = function ()
  
    ObjDelete( "obj_policewindow_use_bearspear" );
    ObjDelete( "anm_policewindow_window_touch" );
  
  end;
  local use_bearspear_end = function ()
    
    ObjDelete( "spr_nearpolicedepartment_window_closed" );
  
    ObjMultiSet( { {"obj_policewindow_window", { input = 1 }},
                   {"anm_policewindow_window_open", { alp = 1, frame = 300 }},
                   {"obj_policewindow_back", { scale_x = 1, scale_y = 1 }},
                   {"spr_nearpolicedepartment_window_open", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bearspear", use_bearspear_beg, private.room_objname );
  cmn.AddSubscriber( "use_bearspear", use_bearspear_inv );
  cmn.AddSubscriber( "use_bearspear", use_bearspear_end, private.room_objname );
  cmn.AddSubscriber( "use_bearspear_inv", use_bearspear_inv, private.room_objname );
  cmn.AddSubscriber( "use_bearspear_beg", use_bearspear_beg, private.room_objname );
  cmn.AddSubscriber( "use_bearspear_end", use_bearspear_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_scalepan () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_scalepan" ] = {
        type = "use",
        inv_obj = "inv_scalepan",
        use_place = "obj_policewindow_use_scalepan",
        room = private.room_objname,
        zz = "zz_policewindow",
        zz_gate = "gzz_nearpolicedepartment_policewindow"
    };
  --------------------------------------------------------------------------------------------
  local use_scalepan_inv = function ()
  
    interface.InventoryItemRemove( "inv_scalepan" );
  
  end;
  local use_scalepan_beg = function ()
  
    ObjDelete( "obj_policewindow_use_scalepan" );
  
  end;
  local use_scalepan_end = function ()
    
    ObjDelete( "obj_policewindow_safe_scale" );
    ObjDelete( "anm_policewindow_safe_touch" );
  
    ObjSet("obj_policewindow_safe_open",  { alp = 1, input = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scalepan", use_scalepan_beg, private.room_objname );
  cmn.AddSubscriber( "use_scalepan", use_scalepan_inv );
  cmn.AddSubscriber( "use_scalepan", use_scalepan_end, private.room_objname );
  cmn.AddSubscriber( "use_scalepan_inv", use_scalepan_inv, private.room_objname );
  cmn.AddSubscriber( "use_scalepan_beg", use_scalepan_beg, private.room_objname );
  cmn.AddSubscriber( "use_scalepan_end", use_scalepan_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_rewardpen () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_rewardpen" ] = {
        type = "use",
        inv_obj = "inv_rewardpen",
        use_place = "obj_policewindow_use_rewardpen",
        room = private.room_objname,
        zz = "zz_policewindow",
        zz_gate = "gzz_nearpolicedepartment_policewindow"
    };
  --------------------------------------------------------------------------------------------
  local use_rewardpen_inv = function ()
  
    interface.InventoryItemRemove( "inv_rewardpen" );
  
  end;
  local use_rewardpen_beg = function ()
  
    ObjDelete( "obj_policewindow_use_rewardpen" );
  
  end;
  local use_rewardpen_end = function ()
  
    ObjDelete( "anm_policewindow_box_closed" );
  
    ObjSet("obj_policewindow_box_open",  { alp = 1, input = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_rewardpen", use_rewardpen_beg, private.room_objname );
  cmn.AddSubscriber( "use_rewardpen", use_rewardpen_inv );
  cmn.AddSubscriber( "use_rewardpen", use_rewardpen_end, private.room_objname );
  cmn.AddSubscriber( "use_rewardpen_inv", use_rewardpen_inv, private.room_objname );
  cmn.AddSubscriber( "use_rewardpen_beg", use_rewardpen_beg, private.room_objname );
  cmn.AddSubscriber( "use_rewardpen_end", use_rewardpen_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_themisface () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_themisface" ] = {
        type = "use",
        inv_obj = "inv_themisface",
        use_place = "obj_themisstatuette_use_themisface",
        room = private.room_objname,
        zz = "zz_themisstatuette",
        zz_gate = "gzz_nearpolicedepartment_themisstatuette"
    };
  --------------------------------------------------------------------------------------------
  local use_themisface_inv = function ()
  
    interface.InventoryItemRemove( "inv_themisface" );
  
  end;
  local use_themisface_beg = function ()
  
    ObjDelete( "obj_themisstatuette_use_themisface" );
    ObjDelete( "anm_themisstatuette_statue_touch" );
  
  end;
  local use_themisface_end = function ()
  
    ObjDelete( "gzz_nearpolicedepartment_themisstatuette" );
    ObjDelete( "spr_nearpolicedepartment_statue_noface" );

    ObjMultiSet( { {"gmg_nearpolicedepartment_onscroll", { input = 1, alp = 1, active = 1 }},
                   {"spr_nearpolicedepartment_statue_scroll", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_themisface", use_themisface_beg, private.room_objname );
  cmn.AddSubscriber( "use_themisface", use_themisface_inv );
  cmn.AddSubscriber( "use_themisface", use_themisface_end, private.room_objname );
  cmn.AddSubscriber( "use_themisface_inv", use_themisface_inv, private.room_objname );
  cmn.AddSubscriber( "use_themisface_beg", use_themisface_beg, private.room_objname );
  cmn.AddSubscriber( "use_themisface_end", use_themisface_end, private.room_objname );


  --------------------------------------------------------------------------------------------
  -- function opn_nearpolicedepartment () end;
  --------------------------------------------------------------------------------------------
  local opn_nearpolicedepartment = function ()
  
    int_map_impl.OpenRoom( "rm_nearpolicedepartment" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_nearpolicedepartment", opn_nearpolicedepartment );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_nearpolicedepartment();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_nearhospital_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_nearhospital_env");
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_policebadge()

  local item = "inv_policebadge";

  if cmn.ApplyObj( item, "gzz_nearpolicedepartment_policedoor" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_policedoor" );

  elseif ( cmn.ApplyObj( item, "obj_policedoor_use_policebadge" ) ) then

    cmn.CallEventHandler( "use_policebadge_inv" );
    cmn.CallEventHandler( "use_policebadge_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_policebadge" );
      cmn.CallEventHandler( "use_policebadge_end" );
      cmn.CallEventHandler( "use_policebadge_preloc" );
      
      common.CloseSubRoom();

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_nearpolicedepartment/audio/aud_use_police_amulet");

    ObjSet("anm_policedoor_use_badge",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bearspear()

  local item = "inv_bearspear";

  if cmn.ApplyObj( item, "gzz_nearpolicedepartment_policewindow" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_policewindow" );

  elseif ( cmn.ApplyObj( item, "obj_policewindow_use_bearspear" ) ) then

    cmn.CallEventHandler( "use_bearspear_inv" );
    cmn.CallEventHandler( "use_bearspear_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_bearspear" );
      cmn.CallEventHandler( "use_bearspear_end" );

    end;
    
    local anm_zoom = function ()
      
      ObjAnimate("obj_policewindow_back", "scale_xy", 0, 0, func_after, { 0, 0, 0.72, 0.72,   1, 0, 1, 1 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_nearpolicedepartment/audio/aud_use_stick");

    ObjSet("anm_policewindow_window_open",  { alp = 1, playing = 1, endtrig = anm_zoom });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_scalepan()

  local item = "inv_scalepan";

  if cmn.ApplyObj( item, "gzz_nearpolicedepartment_policewindow" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_policewindow" );

  elseif ( cmn.ApplyObj( item, "obj_policewindow_use_scalepan" ) and cmn.IsEventDone("use_bearspear") ) then

    cmn.CallEventHandler( "use_scalepan_inv" );
    cmn.CallEventHandler( "use_scalepan_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_scalepan" );
      cmn.CallEventHandler( "use_scalepan_end" );

    end;
    
    local anm_open = function ()
      
      ObjAnimate("obj_policewindow_safe_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_nearpolicedepartment/audio/aud_use_scales2");

    ObjAnimate( "obj_policewindow_safe_scale", "alp", 0, 0, anm_open,
    {
      0.0, 0, 0, 
      0.3, 0, 1,
      0.6, 0, 1
    } );
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_rewardpen()

  local item = "inv_rewardpen";

  if cmn.ApplyObj( item, "gzz_nearpolicedepartment_policewindow" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_policewindow" );

  elseif ( cmn.ApplyObj( item, "obj_policewindow_use_rewardpen" ) and cmn.IsEventDone("use_bearspear") ) then

    cmn.CallEventHandler( "use_rewardpen_inv" );
    cmn.CallEventHandler( "use_rewardpen_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_rewardpen" );
      cmn.CallEventHandler( "use_rewardpen_end" );

    end;

    local anm_open = function ()
      
      ObjAnimate("obj_policewindow_box_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_policewindow_box_closed", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_nearpolicedepartment/audio/aud_use_pen");
    
    ObjAnimate("spr_policewindow_box_holder_bl", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });

    ObjAnimate( "spr_policewindow_box_pen", "alp", 0, 0, anm_open,
    {
      0.0, 0, 0, 
      0.3, 0, 1,
      0.6, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_themisface()

  local item = "inv_themisface";

  if cmn.ApplyObj( item, "gzz_nearpolicedepartment_themisstatuette" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_themisstatuette" );

  elseif ( cmn.ApplyObj( item, "obj_themisstatuette_use_themisface" ) ) then

    cmn.CallEventHandler( "use_themisface_inv" );
    cmn.CallEventHandler( "use_themisface_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_themisface" );
      cmn.CallEventHandler( "use_themisface_end" );
      
      common.CloseSubRoom();
      cmn.GotoRoom( "mg_onscroll" );

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_nearpolicedepartment/audio/aud_use_face");

    ObjSet("anm_themisstatuette_use_themisface",  { alp = 1, playing = 1, endtrig = func_after });
    
  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_bearspear()

  cmn.SetEventDone( "get_bearspear" );
  cmn.CallEventHandler( "get_bearspear" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_wolffigurine()

  cmn.SetEventDone( "get_wolffigurine" );
  cmn.CallEventHandler( "get_wolffigurine" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_carkey") and cmn.IsEventDone("get_revolver1") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_casebutton()

  cmn.SetEventDone( "get_casebutton" );
  cmn.CallEventHandler( "get_casebutton" );
  
  if not cmn.IsEventDone("get_wolffigurine") then
    cmn.SetEventDone( "get_wolffigurine" );
    cmn.CallEventHandler( "get_wolffigurine" );
  end;

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_carkey()

  cmn.SetEventDone( "get_carkey" );
  cmn.CallEventHandler( "get_carkey" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_revolver1") and cmn.IsEventDone("get_wolffigurine") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_lvl3star()

  cmn.SetEventDone( "get_lvl3star" );
  cmn.CallEventHandler( "get_lvl3star" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_torch()

  cmn.SetEventDone( "get_torch" );
  cmn.CallEventHandler( "get_torch" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_revolver1()

  cmn.SetEventDone( "get_revolver1" );
  cmn.CallEventHandler( "get_revolver1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_carkey") and cmn.IsEventDone("get_wolffigurine") then
    common.CloseSubRoom();
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_nearpolicedepartment()

  if not ( cmn.IsEventDone( "opn_nearpolicedepartment" ) ) then
    cmn.SetEventDone( "opn_nearpolicedepartment" );
    cmn.CallEventHandler("opn_nearpolicedepartment");
    cmn.ShowBbt( "nearpolicedepartment_open" );
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_policedoor()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_policedoor_use_policebadge" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_xx_door");
  
  ObjSet("anm_policedoor_door_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_themis()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_themisstatuette_use_themisface" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_xx_stone");
  
  ObjSet("anm_themisstatuette_statue_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_wolf()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "nearpolicedepartment_wolf" );
  
  local anim_funcs = { "anm_wolf_nearpolicedepartment_click", "clk_wolf_howling", "clk_wolf_scratching" };
  local func_num = math.random(1, 3);
  
  if func_num == 1 then
    cmn.PlayAudio("snd", "assets/levels/level3/rm_nearpolicedepartment/audio/aud_xx_clk_wolf2");
  elseif func_num == 2 then
    cmn.PlayAudio("snd", "assets/levels/level3/rm_housegarden/audio/aud_wolf_clk");
  end;
  
  ObjSet( "anm_nearpolicedepartment_wolf", { 
    animfunc = anim_funcs[func_num], 
    playing = true, endtrig = function()
    ObjSet( "anm_nearpolicedepartment_wolf", { animfunc = "anm_wolf_nearpolicedepartment", endtrig = "", playing = true } );
    cmn.Lock(0);
  end } );

end;
--------------------------------------------------------------------------------------------
function public.touch_window()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_policewindow_use_bearspear" );
  
  cmn.PlayAudio("snd", "assets/levels/level3/rm_nearpolicedepartment/audio/aud_xx_clk_grill");
  
  ObjSet("anm_policewindow_window_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_safe()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_policewindow_use_scalepan" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_clk_door_small1");
  
  ObjSet("anm_policewindow_safe_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_box()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_policewindow_use_rewardpen" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_xx_clk_wood4");
  
  ObjSet("anm_policewindow_box_closed",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--*********************************************************************************************************************
