-- name=rm_policedepartment
--*********************************************************************************************************************
function public.Init()

  if port.ios_lang() == "ru" then
    ObjSet("txt_stand_case_text_7",{ fontsize = 12 });
  end;
  
  if port.ios_lang() == "ja" then
    ObjSet("txt_stand_case_text_1",{ fontsize = 18 });
    ObjSet("txt_stand_case_text_2",{ fontsize = 18 });
    ObjSet("txt_stand_case_text_3",{ fontsize = 18 });
    ObjSet("txt_stand_case_text_4",{ fontsize = 18 });
    ObjSet("txt_stand_case_text_5",{ fontsize = 18 });
    ObjSet("txt_stand_case_text_6",{ fontsize = 18 });
  end;
  
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_policedepartment";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.dlg_lipsync = "";
  
  --------------------------------------------------------------------------------------------
  -- function get_rewardpen () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_rewardpen" ] = {
      type = "get",
      get_obj = "spr_policedepartment_rewardpen",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_rewardpen_inv = function ()
  
    interface.InventoryItemAdd( "inv_rewardpen", "spr_policedepartment_rewardpen" );
    
  end;
  local get_rewardpen_mid = function ()
  
    ObjDelete( "gfx_policedepartment_rewardpen" );
    ObjDelete( "spr_policedepartment_rewardpen_sh" );
    
  end;
  local get_rewardpen_end = function ()
  
    ObjDelete( "obj_policedepartment_dialog_redhood1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_rewardpen", get_rewardpen_inv );
  cmn.AddSubscriber( "get_rewardpen_inv", get_rewardpen_inv, private.room_objname );
  cmn.AddSubscriber( "get_rewardpen", get_rewardpen_mid, private.room_objname );
  cmn.AddSubscriber( "get_rewardpen_mid", get_rewardpen_mid, private.room_objname );
  cmn.AddSubscriber( "get_rewardpen", get_rewardpen_end, private.room_objname );
  cmn.AddSubscriber( "get_rewardpen_end", get_rewardpen_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_redhatpage4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_redhatpage4" ] = {
      type = "get",
      get_obj = "spr_policedepartment_redhatpage4",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_redhatpage4_inv = function ()
  
    interface.InventoryItemAdd( "inv_redhatpage", "spr_policedepartment_redhatpage4", function () cmn.GetMultyObject( 'redhatpage', 4 ); end );
  
  end;
  local get_redhatpage4_mid = function ()
  
    ObjDelete( "gfx_policedepartment_redhatpage4" );
    ObjDelete( "spr_policedepartment_redhatpage4_sh" );
  
  end;
  local get_redhatpage4_end = function ()
  
    ObjDelete( "obj_policedepartment_dialog_redhood2" );
  
  end;
  local get_redhatpage4_loc = function ()

    ObjMultiSet( { { "anm_housegarden_redhood", { alp = 1 } },
                   { "anm_housegarden_wolf",    { alp = 1 } },
                   { "obj_housegarden_wolf_touch", { input = true } } } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_redhatpage4", get_redhatpage4_inv );
  cmn.AddSubscriber( "get_redhatpage4_inv", get_redhatpage4_inv, private.room_objname );
  cmn.AddSubscriber( "get_redhatpage4", get_redhatpage4_mid, private.room_objname );
  cmn.AddSubscriber( "get_redhatpage4_mid", get_redhatpage4_mid, private.room_objname );
  cmn.AddSubscriber( "get_redhatpage4", get_redhatpage4_end, private.room_objname );
  cmn.AddSubscriber( "get_redhatpage4_end", get_redhatpage4_end, private.room_objname );
  cmn.AddSubscriber( "get_redhatpage4", get_redhatpage4_loc, "rm_housegarden" );
  cmn.AddSubscriber( "get_redhatpage4_loc", get_redhatpage4_loc, "rm_housegarden" );
  
  --------------------------------------------------------------------------------------------
  -- function use_revolver2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_revolver2" ] = {
        type = "use",
        inv_obj = "inv_revolver2",
        use_place = "obj_stand_use_revolver2",
        room = private.room_objname,
        zz = "zz_stand",
        zz_gate = "gzz_policedepartment_stand"
    };
  --------------------------------------------------------------------------------------------
  local use_revolver2_inv = function ()
  
    interface.InventoryItemRemove( "inv_revolver2" );
  
  end;
  local use_revolver2_beg = function ()
  
    ObjDelete( "obj_stand_use_revolver2" );
  
  end;
  local use_revolver2_end = function ()
  
    if cmn.IsEventDone("use_revolver1") then
      ObjDelete( "spr_stand_closed" );
      ObjDelete( "obj_policedepartment_safe_closed" );
      ObjMultiSet( { {"obj_stand_clk_seeredhatcse", { alp = 1, input = 1 }},
                     {"obj_stand_open", { alp = 1 }},
                     {"spr_stand_open", { alp = 1 }},
                     {"spr_policedepartment_safe_open", { alp = 1 }} } );
    else 
      ObjMultiSet( { {"spr_stand_revolver_2", { alp = 1 }},
                     {"spr_policedepartment_safe_revolver_2", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_revolver2", use_revolver2_beg, private.room_objname );
  cmn.AddSubscriber( "use_revolver2", use_revolver2_inv );
  cmn.AddSubscriber( "use_revolver2", use_revolver2_end, private.room_objname );
  cmn.AddSubscriber( "use_revolver2_inv", use_revolver2_inv, private.room_objname );
  cmn.AddSubscriber( "use_revolver2_beg", use_revolver2_beg, private.room_objname );
  cmn.AddSubscriber( "use_revolver2_end", use_revolver2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_revolver1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_revolver1" ] = {
        type = "use",
        inv_obj = "inv_revolver1",
        use_place = "obj_stand_use_revolver1",
        room = private.room_objname,
        zz = "zz_stand",
        zz_gate = "gzz_policedepartment_stand"
    };
  --------------------------------------------------------------------------------------------
  local use_revolver1_inv = function ()
  
    interface.InventoryItemRemove( "inv_revolver1" );
  
  end;
  local use_revolver1_beg = function ()
  
    ObjDelete( "obj_stand_use_revolver1" );
  
  end;
  local use_revolver1_end = function ()
  
    if cmn.IsEventDone("use_revolver2") then
      ObjDelete( "spr_stand_closed" );
      ObjDelete( "obj_policedepartment_safe_closed" );
      ObjMultiSet( { {"obj_stand_clk_seeredhatcse", { alp = 1, input = 1 }},
                     {"obj_stand_open", { alp = 1 }},
                     {"spr_stand_open", { alp = 1 }},
                     {"spr_policedepartment_safe_open", { alp = 1 }} } );
    else 
      ObjMultiSet( { {"spr_stand_revolver_1", { alp = 1 }},
                     {"spr_policedepartment_safe_revolver_1", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_revolver1", use_revolver1_beg, private.room_objname );
  cmn.AddSubscriber( "use_revolver1", use_revolver1_inv );
  cmn.AddSubscriber( "use_revolver1", use_revolver1_end, private.room_objname );
  cmn.AddSubscriber( "use_revolver1_inv", use_revolver1_inv, private.room_objname );
  cmn.AddSubscriber( "use_revolver1_beg", use_revolver1_beg, private.room_objname );
  cmn.AddSubscriber( "use_revolver1_end", use_revolver1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl3stetoscope () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_lvl3stetoscope" ] = {
        type = "use",
        inv_obj = "inv_lvl3stetoscope",
        use_place = "obj_stand_use_lvl3stetoscope",
        room = private.room_objname,
        zz = "zz_stand",
        zz_gate = "gzz_policedepartment_stand"
    };
  --------------------------------------------------------------------------------------------
  local use_lvl3stetoscope_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl3stetoscope" );
  
  end;
  local use_lvl3stetoscope_beg = function ()
  
    ObjDelete( "obj_stand_use_lvl3stetoscope" );
  
  end;
  local use_lvl3stetoscope_end = function ()
  
    ObjMultiSet( { {"gmg_policedepartment_safe", { input = 1, alp = 1, active = 1 }},
                   {"spr_policedepartment_safe_stethoscope", { alp = 1 }} } );
    
    ObjDelete( "gzz_policedepartment_stand" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl3stetoscope", use_lvl3stetoscope_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3stetoscope", use_lvl3stetoscope_inv );
  cmn.AddSubscriber( "use_lvl3stetoscope", use_lvl3stetoscope_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl3stetoscope_inv", use_lvl3stetoscope_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl3stetoscope_beg", use_lvl3stetoscope_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3stetoscope_end", use_lvl3stetoscope_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cellkey () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_cellkey" ] = {
        type = "use",
        inv_obj = "inv_cellkey",
        use_place = "obj_celldoor_use_cellkey",
        room = private.room_objname,
        zz = "zz_celldoor",
        zz_gate = "gzz_policedepartment_celldoor"
    };
  --------------------------------------------------------------------------------------------
  local use_cellkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_cellkey" );
  
  end;
  local use_cellkey_beg = function ()
  
    ObjDelete( "obj_celldoor_use_cellkey" );
    ObjDelete( "anm_celldoor_door_touch" );
    
    ObjDelete("obj_policedepartment_cell_closed");
    ObjSet("obj_policedepartment_cell_open",  { alp = 1 });
  
  end;
  local use_cellkey_end = function ()
  
    ObjDelete( "gzz_policedepartment_celldoor" );
    ObjDelete("anm_policedepartment_dialog_redhood2_hand_1");
    ObjDelete("anm_policedepartment_dialog_redhood2_hand_give");
    
    ObjDelete("vid_policedepartment_dialog_redhood2_lipsync1");
    ObjDelete("vid_policedepartment_dialog_redhood2_lipsync2");
    ObjDelete("spr_policedepartment_dialog_redhood2_hair");
    
    ObjAttach("obj_policedepartment_dialog_redhood2", "rm_policedepartment");
    
    ObjMultiSet( { { "obj_policedepartment_dialog_redhood2", { input = 1, alp = 1 }},
                   { "obj_policedepartment_dialog_redhood2_hand_2", { input = 1, alp = 1 }},
                   { "obj_policedepartment_dialog_redhood2_head", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cellkey", use_cellkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_cellkey", use_cellkey_inv );
  cmn.AddSubscriber( "use_cellkey", use_cellkey_end, private.room_objname );
  cmn.AddSubscriber( "use_cellkey_inv", use_cellkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_cellkey_beg", use_cellkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_cellkey_end", use_cellkey_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_seeredhatcse () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_seeredhatcse" ] = {
    type = "click",
    use_place = "obj_stand_clk_seeredhatcse",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_policedepartment_stand"
  };
  --------------------------------------------------------------------------------------------
  local clk_seeredhatcse_beg = function ()
  
    ObjDelete( "obj_stand_clk_seeredhatcse" );
  
  end;
  local clk_seeredhatcse_end = function ()
  
    ObjDelete( "spr_stand_case_sh" );
    ObjDelete( "spr_stand_case" );
    ObjSet("obj_stand_clk_putaside",  { alp = 1, input = 1 });
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_seeredhatcse", clk_seeredhatcse_beg, private.room_objname );
  cmn.AddSubscriber( "clk_seeredhatcse", clk_seeredhatcse_end, private.room_objname );
  cmn.AddSubscriber( "clk_seeredhatcse_beg", clk_seeredhatcse_beg, private.room_objname );
  cmn.AddSubscriber( "clk_seeredhatcse_end", clk_seeredhatcse_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_putaside () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_putaside" ] = {
    type = "click",
    use_place = "obj_stand_clk_putaside",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_policedepartment_stand"
  };
  --------------------------------------------------------------------------------------------
  local clk_putaside_beg = function ()
    ObjSet("spr_stand_case_2",  { alp = 1 });
  end;
  local clk_putaside_end = function ()
  
    ObjDelete( "obj_stand_clk_putaside" );
    ObjDelete( "spr_policedepartment_safe_case_1" );
    
    ObjMultiSet( { {"obj_stand_use_lvl3stetoscope", { alp = 1, input = 1 }},
                   {"spr_policedepartment_safe_case_2", { alp = 1 }} } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_putaside", clk_putaside_beg, private.room_objname );
  cmn.AddSubscriber( "clk_putaside", clk_putaside_end, private.room_objname );
  cmn.AddSubscriber( "clk_putaside_beg", clk_putaside_beg, private.room_objname );
  cmn.AddSubscriber( "clk_putaside_end", clk_putaside_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_policedepartmentfirst () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_policedepartmentfirst" ] = {
    type = "click",
    use_place = "obj_policedepartment_clk_policedepartmentfirst",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_policedepartmentfirst_task = function ()
    interface_impl.SetCurrentGlobalTask( 17 );
  end;
  local clk_policedepartmentfirst_loc = function ()
    
    ObjDelete("obj_policedepartment_clk_policedepartmentfirst");
    ObjDelete("anm_policedepartment_dialog_redhood1_hand_1");
    ObjDelete("anm_policedepartment_dialog_redhood1_hand_give");
    
    ObjDelete("vid_policedepartment_dialog_redhood1_lipsync1");
    ObjDelete("vid_policedepartment_dialog_redhood1_lipsync2");
    ObjDelete("spr_policedepartment_dialog_redhood1_hair");
    
    ObjAttach("obj_policedepartment_dialog_redhood1", "rm_policedepartment");
    
    ObjMultiSet( { { "obj_policedepartment_dialog_redhood1", { input = 1, alp = 1 } },
                   { "obj_policedepartment_dialog_redhood1_hand_2", { input = 1, alp = 1 } },
                   { "obj_policedepartment_policeman_bbt", { input = 1 } },
                   { "obj_policedepartment_dialog_redhood1_head", { alp = 1 }},

                   { "gzz_policedepartment_stand", { event_mdown = function() cmn.GotoSubRoomMDown( "policedepartment_stand" ); end, event_mup = function() cmn.GotoSubRoomMUp( "policedepartment_stand", "zz_stand" ); end } },
                   { "gzz_policedepartment_celldoor", { event_mdown = function() cmn.GotoSubRoomMDown( "policedepartment_celldoor" ); end, event_mup = function() cmn.GotoSubRoomMUp( "policedepartment_celldoor", "zz_celldoor" ); end } } } );
                   
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_policedepartmentfirst", clk_policedepartmentfirst_loc, private.room_objname );
  cmn.AddSubscriber( "clk_policedepartmentfirst", clk_policedepartmentfirst_task );
  
  --------------------------------------------------------------------------------------------
  -- function opn_policedepartment () end;
  --------------------------------------------------------------------------------------------
  local opn_policedepartment_map = function ()
  
    int_map_impl.OpenRoom( "rm_policedepartment" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_policedepartment", opn_policedepartment_map );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_celldoor" );
  
  function zz_celldoor.Close()
    
    if cmn.IsEventDone( "use_cellkey" ) then
      private.dialog_redhood_open( 2 );
    end;
                   
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_policedepartment();
  
  if cmn.IsEventDone("clk_policedepartmentfirst") and not cmn.IsEventDone("get_rewardpen") then
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  end;
  if cmn.IsEventDone("use_cellkey") and not cmn.IsEventDone("get_redhatpage4") then
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio3/aud_policedepartment_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio3/aud_policedepartment_env");
  
  if cmn.IsEventDone("clk_policedepartmentfirst") and not cmn.IsEventDone("get_rewardpen") then
    common_impl.current_dialog = "obj_policedepartment_dialog_redhood1";
    ObjSet("anm_policedepartment_dialog_redhood1_hand_2",  { playing = 1 });
  end;
  if cmn.IsEventDone("use_cellkey") and not cmn.IsEventDone("get_redhatpage4") then
    common_impl.current_dialog = "obj_policedepartment_dialog_redhood2";
    ObjSet("anm_policedepartment_dialog_redhood2_hand_2",  { playing = 1 });
  end;
  
  if cmn.IsEventDone("get_redhatpage4") and not cmn.IsEventDone("opn_housegardenwithred") then
    cmn.Lock( 1 );
  end;
  
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(8) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_revolver2()

  local item = "inv_revolver2";

  if cmn.ApplyObj( item, "gzz_policedepartment_stand" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_stand" );

  elseif ( cmn.ApplyObj( item, "obj_stand_use_revolver2" ) ) then

    cmn.CallEventHandler( "use_revolver2_inv" );
    cmn.CallEventHandler( "use_revolver2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_revolver2" );
      cmn.CallEventHandler( "use_revolver2_end" );

    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/ho_medical/audio/aud_opn_box");
      
      ObjSet("obj_stand_open",  { alp = 1 });
      ObjAnimate("spr_stand_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("spr_stand_closed", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_xx_button_lock");

    if cmn.IsEventDone("use_revolver1") then
      ObjAnimate("spr_stand_revolver_2", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });
      ObjAnimate("spr_stand_revolver_2_2", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    else 
      ObjAnimate("spr_stand_revolver_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_revolver1()

  local item = "inv_revolver1";

  if cmn.ApplyObj( item, "gzz_policedepartment_stand" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_stand" );

  elseif ( cmn.ApplyObj( item, "obj_stand_use_revolver1" ) ) then

    cmn.CallEventHandler( "use_revolver1_inv" );
    cmn.CallEventHandler( "use_revolver1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_revolver1" );
      cmn.CallEventHandler( "use_revolver1_end" );

    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/ho_medical/audio/aud_opn_box");
      
      ObjSet("obj_stand_open",  { alp = 1 });
      ObjAnimate("spr_stand_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("spr_stand_closed", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_xx_button_lock");

    if cmn.IsEventDone("use_revolver2") then
      ObjAnimate("spr_stand_revolver_1", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });
      ObjAnimate("spr_stand_revolver_2_2", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    else 
      ObjAnimate("spr_stand_revolver_1", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl3stetoscope()

  local item = "inv_lvl3stetoscope";

  if cmn.ApplyObj( item, "gzz_policedepartment_stand" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_stand" );

  elseif ( cmn.ApplyObj( item, "obj_stand_use_lvl3stetoscope" ) and cmn.IsEventDone("clk_putaside") ) then

    cmn.CallEventHandler( "use_lvl3stetoscope_inv" );
    cmn.CallEventHandler( "use_lvl3stetoscope_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl3stetoscope" );
      cmn.CallEventHandler( "use_lvl3stetoscope_end" );
      
      common.CloseSubRoom();
      cmn.GotoRoom("mg_safe");

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_policedepartment/audio/aud_use_stetoscope");

    ObjAnimate( "obj_stand_stethoscope", "alp", 0, 0, func_after,
    {
      0.0, 0, 0, 
      0.3, 0, 1,
      0.6, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_cellkey()

  local item = "inv_cellkey";

  if cmn.ApplyObj( item, "gzz_policedepartment_celldoor" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_celldoor" );

  elseif ( cmn.ApplyObj( item, "obj_celldoor_use_cellkey" ) ) then

    cmn.CallEventHandler( "use_cellkey_inv" );
    cmn.CallEventHandler( "use_cellkey_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_cellkey" );
      
      common.CloseSubRoom();

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_policedepartment/audio/aud_opn_lock4");

    ObjSet("anm_celldoor_use_key",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_rewardpen()
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_rewardpen_end" );

  end;

  cmn.SetEventDone( "get_rewardpen" );
  cmn.CallEventHandler( "get_rewardpen_inv" );
  cmn.CallEventHandler( "get_rewardpen_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  common_impl.PlayBackgroundMusic();
  
  ObjAnimate("obj_policedepartment_dialog_redhood1", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.5, 0, 0 });

end;
--------------------------------------------------------------------------------------------
function public.get_redhatpage4()
  
  local func_after_dlg = function ()

    --cmn.Lock(0);
    cmn.CallEventHandler( "get_redhatpage4_end" );
    cmn.CallEventHandler( "get_redhatpage4_loc" );
    
    cmn.CallEventHandler("opn_housegardenwithred_task");

    ObjSet("rm_policedepartment",  { color_r = 0, color_g = 0, color_b = 0 });
    cmn.GotoRoom("rm_housegarden");

  end;

  cmn.SetEventDone( "get_redhatpage4" );
  cmn.CallEventHandler( "get_redhatpage4_inv" );
  cmn.CallEventHandler( "get_redhatpage4_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common_impl.current_dialog = "";
  
  cmn.StopAllEnv();
  cmn.PlayFullscreenVideo( "assets/levels/level3/rm_policedepartment/vid_backtotale", func_after_dlg, "assets/levels/level2/rm_mermaidsward/audio/aud_teleport2", "");

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_seeredhatcse()

  cmn.CallEventHandler( "clk_seeredhatcse_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_seeredhatcse" );
    cmn.CallEventHandler( "clk_seeredhatcse_end" );

    cmn.Lock( 0 );
    cmn.ShowBbt( "stand_after_read_case" );

  end;

  ObjAnimate( "obj_stand_clk_putaside", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 0, 
    0.5, 0, 1
  } );

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_clk_paper");

end;
--------------------------------------------------------------------------------------------
function public.clk_putaside()

  cmn.CallEventHandler( "clk_putaside_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_putaside" );
    cmn.CallEventHandler( "clk_putaside_end" );

    cmn.Lock( 0 );

  end;

  ObjAnimate( "obj_stand_clk_putaside", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1, 
    0.5, 0, 0
  } );

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_clk_paper");

end;
--------------------------------------------------------------------------------------------
function public.clk_policedepartmentfirst()
  
  cmn.SetEventDone("clk_policedepartmentfirst");
  private.dialog_redhood_open( 1 );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_policedepartment()

  if not ( cmn.IsEventDone( "opn_policedepartment" ) ) then
    cmn.SetEventDone( "opn_policedepartment" );
    cmn.CallEventHandler("opn_policedepartment");
    cmn.ShowBbt( "policedepartment_open" );
  end;
  
  if cmn.IsEventDone("get_redhatpage4") and not cmn.IsEventDone("opn_housegardenwithred") then
    
    local func_after_dlg = function ()

      cmn.CallEventHandler("opn_housegardenwithred_task");
      ObjSet("rm_policedepartment",  { color_r = 0, color_g = 0, color_b = 0 });
      cmn.GotoRoom("rm_housegarden");

    end;
    
    cmn.Lock( 0 );
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level3/rm_policedepartment/vid_backtotale", func_after_dlg, "assets/levels/level2/rm_mermaidsward/audio/aud_teleport2", "");
    
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_celldoor()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_celldoor_use_cellkey" );
  
  cmn.PlayAudio("snd", "assets/levels/level3/rm_policedepartment/audio/aud_xx_clk_grill2");
  
  ObjSet("anm_celldoor_door_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_standdoor()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_stand_use_revolver" );
  
  cmn.PlayAudio("snd", "assets/levels/level3/rm_policedepartment/audio/aud_xx_clk_wood3lvl");
  
  ObjSet("anm_stand_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  ObjAnimate("obj_stand_revolvers", "scale_x", 0, 0, "", { 0, 0, 1,   0.15, 0, 0.99,   0.3, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_wolf()
  
  cmn.Lock(1);
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_policedepartment_wolf_touch", { alp = 0 }},
                   {"anm_policedepartment_wolf", { playing = 1, alp = 1 }} } );
    
  end;
  
  cmn.ShowBbt( "policedepartment_wolf" );
  
  cmn.PlayAudio("snd", "assets/levels/level3/rm_nearpolicedepartment/audio/aud_xx_clk_wolf2");
  
  ObjMultiSet( { {"anm_policedepartment_wolf_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_policedepartment_wolf", { playing = 0, alp = 0 }} } );
  
end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_8_1", { alp = 1 }},
                 {"spr_col_8_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_8_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_8_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_8_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_8_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_8_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_8_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_redhood_open( num )
  
  private.dlg_finished = false;
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  
  local func_after = function() private.dialog_redhood1_beg(); end;
  if num == 2 then
    func_after = function() private.dialog_redhood2_beg(); end;
  end;
  
  ObjAttach("obj_policedepartment_dialog_redhood"..num, "rm_policedepartment");
  ObjAnimate("obj_policedepartment_dialog_redhood"..num, "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_redhood1_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "policedepartment", "redhood1", 2 );
  
  local dialog_end = function ()
    
    cmn.ShowBbt( "policedepartment_after_dialog1" );
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "clk_policedepartmentfirst" );
    interface_impl.ShowGlobalTask();
    
    ObjSet("anm_policedepartment_dialog_redhood1_hand_2",  { playing = 1 });
    
  end;
  
  local anm_give = function ()
    
    ObjDelete("vid_policedepartment_dialog_redhood1_lipsync2");
    ObjDelete("spr_policedepartment_dialog_redhood1_hair");
    private.dlg_lipsync = "";
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_policedepartment_dialog_redhood1_timer",  { playing = 0 }},
                   {"anm_policedepartment_dialog_redhood1_hand_1",  { alp = 0, playing = 0 }},
                   {"anm_policedepartment_dialog_redhood1_hand_give",  { alp = 1, playing = 1, endtrig = dialog_end }},
                   {"obj_policedepartment_dialog_redhood1_head",  { alp = 1 }} } );
    
  end;
  
  local redhood_talks2 = function ()
  
    ObjAttach("vid_policedepartment_dialog_redhood1_lipsync2", "obj_policedepartment_dialog_redhood1");
  
    cmn.ShowDlgBbt( "dlg_redhood1_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level3/rm_policedepartment/audio/aud_red_riding_hood_dlg1_3_voc");
    private.dlg_lipsync = "vid_policedepartment_dialog_redhood1_lipsync2";
    
    ObjMultiSet( { {"tmr_policedepartment_dialog_redhood1_timer", { endtrig = anm_give, time = 6.6, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_give }},
                   {"obj_character_dialog_continue", { event_mup = anm_give }},
                   {"vid_policedepartment_dialog_redhood1_lipsync2", { playing = 1 }},
                   {"obj_policedepartment_dialog_redhood1_head",  { alp = 0 }},
                   {"spr_policedepartment_dialog_redhood1_hair",  { alp = 1 }} } );
  
  end;
                 
  local cindy_talks = function ()
  
    ObjDelete("vid_policedepartment_dialog_redhood1_lipsync1");
  
    cmn.ShowDlgBbt( "dlg_redhood1_answer_1" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level3/rm_policedepartment/audio/aud_red_riding_hood_dlg1_2_voc");
    private.dlg_lipsync = "";
    
    ObjMultiSet( { {"tmr_policedepartment_dialog_redhood1_timer", { endtrig = redhood_talks2, time = 2.6, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = redhood_talks2 }},
                   {"obj_character_dialog_continue", { event_mup = redhood_talks2 }},
                   {"obj_policedepartment_dialog_redhood1_head",  { alp = 1 }},
                   {"spr_policedepartment_dialog_redhood1_hair",  { alp = 0 }} } );
  
  end;               

  private.dlg_lipsync = "vid_policedepartment_dialog_redhood1_lipsync1";

  cmn.ShowDlgBbt( "dlg_redhood1_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level3/rm_policedepartment/audio/aud_red_riding_hood_dlg1_1_voc");

  ObjMultiSet( { {"tmr_policedepartment_dialog_redhood1_timer", { time = 7.8, playing = 1, endtrig = cindy_talks }},
                 {"vid_policedepartment_dialog_redhood1_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = cindy_talks }},
                 {"obj_character_dialog_continue", { event_mup = cindy_talks }} } );
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_redhood2_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "policedepartment", "redhood2", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "use_cellkey_end" );
    
    ObjSet("anm_policedepartment_dialog_redhood2_hand_2",  { playing = 1 });
    
  end;
  
  local anm_give = function ()
    
    ObjDelete("vid_policedepartment_dialog_redhood2_lipsync2");
    ObjDelete("spr_policedepartment_dialog_redhood2_hair");
    private.dlg_lipsync = "";
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_policedepartment_dialog_redhood2_timer",  { playing = 0 }},
                   {"anm_policedepartment_dialog_redhood2_hand_1",  { alp = 0, playing = 0 }},
                   {"anm_policedepartment_dialog_redhood2_hand_give",  { alp = 1, playing = 1, endtrig = dialog_end }},
                   {"obj_policedepartment_dialog_redhood2_head",  { alp = 1 }} } );
    
  end;
  
  local redhood_talks2 = function ()
  
    ObjAttach("vid_policedepartment_dialog_redhood2_lipsync2", "obj_policedepartment_dialog_redhood2");
  
    cmn.ShowDlgBbt( "dlg_redhood2_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level3/rm_policedepartment/audio/aud_red_riding_hood_dlg2_3_voc");
    private.dlg_lipsync = "vid_policedepartment_dialog_redhood2_lipsync2";
    
    ObjMultiSet( { {"tmr_policedepartment_dialog_redhood2_timer", { endtrig = anm_give, time = 9.2, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_give }},
                   {"obj_character_dialog_continue", { event_mup = anm_give }},
                   {"vid_policedepartment_dialog_redhood2_lipsync2", { playing = 1 }},
                   {"obj_policedepartment_dialog_redhood2_head",  { alp = 0 }},
                   {"spr_policedepartment_dialog_redhood2_hair",  { alp = 1 }} } );
  
  end;
                 
  local cindy_talks = function ()
  
    ObjDelete("vid_policedepartment_dialog_redhood2_lipsync1");
  
    cmn.ShowDlgBbt( "dlg_redhood2_answer_1" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level3/rm_policedepartment/audio/aud_red_riding_hood_dlg2_2_voc");
    private.dlg_lipsync = "";
    
    ObjMultiSet( { {"tmr_policedepartment_dialog_redhood2_timer", { endtrig = redhood_talks2, time = 5.2, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = redhood_talks2 }},
                   {"obj_character_dialog_continue", { event_mup = redhood_talks2 }},
                   {"obj_policedepartment_dialog_redhood2_head",  { alp = 1 }},
                   {"spr_policedepartment_dialog_redhood2_hair",  { alp = 0 }} } );
  
  end;                

  private.dlg_lipsync = "vid_policedepartment_dialog_redhood2_lipsync1";

  cmn.ShowDlgBbt( "dlg_redhood2_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level3/rm_policedepartment/audio/aud_red_riding_hood_dlg2_1_voc");

  ObjMultiSet( { {"tmr_policedepartment_dialog_redhood2_timer", { time = 5.3, playing = 1, endtrig = cindy_talks }},
                 {"vid_policedepartment_dialog_redhood2_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = cindy_talks }},
                 {"obj_character_dialog_continue", { event_mup = cindy_talks }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_redhood1()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.ShowBbt( "policedepartment_after_dialog1" );
    cmn.CallEventHandler( "clk_policedepartmentfirst" );
    interface_impl.ShowGlobalTask();
    
    ObjSet("anm_policedepartment_dialog_redhood1_hand_2",  { playing = 1 });
    
  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  ObjMultiSet( { {"tmr_policedepartment_dialog_redhood1_timer",  { playing = 0 }},
                 {"anm_policedepartment_dialog_redhood1_hand_1",  { alp = 0, playing = 0 }},
                 {"anm_policedepartment_dialog_redhood1_hand_give",  { alp = 1, playing = 1, endtrig = func_after_dlg }},
                 {"obj_policedepartment_dialog_redhood1_head",  { alp = 1 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function public.skip_dlg_redhood2()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "use_cellkey_end" );
    
    ObjSet("anm_policedepartment_dialog_redhood2_hand_2",  { playing = 1 });
    
  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  ObjMultiSet( { {"tmr_policedepartment_dialog_redhood2_timer",  { playing = 0 }},
                 {"anm_policedepartment_dialog_redhood2_hand_1",  { alp = 0, playing = 0 }},
                 {"anm_policedepartment_dialog_redhood2_hand_give",  { alp = 1, playing = 1, endtrig = func_after_dlg }},
                 {"obj_policedepartment_dialog_redhood2_head",  { alp = 1 }} } );
  
end; 
--*********************************************************************************************************************
