-- name=inventory4
--*********************************************************************************************************************
function public.Init()

  if port.isPortable() == 1 then
    port.InventoryPopupInit("inventory4_hub");
    port.VideoResizeInRoom("inventory4");
  end;
  
  private.Init_Keybunch();
  private.Init_Burntnewspaper();
  private.Init_Tornoffpatch();
  --------------------------------------------------------------------------------------------
  -- function get_sculptorsset () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_sculptorsset" ] = {
    type = "get",
    get_obj = "obj_complex_travelersbag_sculptorsset",
    room = "int_complex_inv",
    zz = "inv_complex_travelersbag",
    zz_gate = "inv_travelersbag"
  };
  --------------------------------------------------------------------------------------------
  local get_sculptorsset_inv = function ()

    interface.InventoryItemRemove( "inv_travelersbag" );
    interface.InventoryItemAdd( "inv_sculptorsset", "obj_complex_travelersbag_sculptorsset" );

    ObjDelete("gfx_complex_travelersbag_sculptorsset");

  end;
  cmn.AddSubscriber( "get_sculptorsset", get_sculptorsset_inv );

  --------------------------------------------------------------------------------------------
  -- function get_lvl4torch () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl4torch" ] = {
    type = "get",
    get_obj = "obj_complex_dirtytorch_lvl4torch",
    room = "int_complex_inv",
    zz = "inv_complex_dirtytorch",
    zz_gate = "inv_dirtytorch"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl4torch_inv = function ()

    interface.InventoryItemRemove( "inv_dirtytorch" );
    interface.InventoryItemAdd( "inv_lvl4torch", "obj_complex_dirtytorch_lvl4torch" );

    ObjDelete("gfx_complex_dirtytorch_lvl4torch");

  end;
  cmn.AddSubscriber( "get_lvl4torch", get_lvl4torch_inv );
  --------------------------------------------------------------------------------------------
  -- function get_cagekey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_cagekey" ] = {
    type = "get",
    get_obj = "spr_complex_keybunch_key_4",
    room = "int_complex_inv",
    zz = "inv_complex_keybunch",
    zz_gate = "inv_keybunch"
  };
  --------------------------------------------------------------------------------------------
  local get_cagekey_inv = function ()

    interface.InventoryItemRemove( "inv_keybunch" );
    interface.InventoryItemAdd( "inv_cagekey", "spr_complex_keybunch_key_4" );

    ObjDelete("gfx_complex_keybunch_cagekey");

  end;
  cmn.AddSubscriber( "get_cagekey", get_cagekey_inv );
  --------------------------------------------------------------------------------------------
  -- function get_charitypicture () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_charitypicture" ] = {
    type = "get",
    get_obj = "spr_complex_pictureinframe_charitypicture",
    room = "int_complex_inv",
    zz = "inv_complex_pictureinframe",
    zz_gate = "inv_pictureinframe"
  };
  --------------------------------------------------------------------------------------------
  local get_charitypicture_inv = function ()
    
    interface_impl.SetCurrentGlobalTask( 25 );
    
    if ( cmn.IsEventDone( "get_lvl4button" ) ) then
      interface.InventoryItemRemove( "inv_pictureinframe" );
    end;

    interface.InventoryItemAdd( "inv_charitypicture", "spr_complex_pictureinframe_charitypicture" );

    ObjDelete("gfx_complex_pictureinframe_charitypicture");

  end;
  local get_charitypicture_clues = function ()
    interface_impl.SetCompleteClues( {1} );
  end;
  cmn.AddSubscriber( "get_charitypicture", get_charitypicture_inv );
  cmn.AddSubscriber( "get_charitypicture_inv", get_charitypicture_inv );
  cmn.AddSubscriber( "get_charitypicture", get_charitypicture_clues );
  cmn.AddSubscriber( "get_charitypicture_clues", get_charitypicture_clues );
  --------------------------------------------------------------------------------------------
  -- function get_lvl4button () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl4button" ] = {
    type = "get",
    get_obj = "spr_complex_pictureinframe_lvl4button",
    room = "int_complex_inv",
    zz = "inv_complex_pictureinframe",
    zz_gate = "inv_pictureinframe"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl4button_inv = function ()

    if ( cmn.IsEventDone( "get_charitypicture" ) ) then
      interface.InventoryItemRemove( "inv_pictureinframe" );
    end;

    interface.InventoryItemAdd( "inv_lvl4button", "spr_complex_pictureinframe_lvl4button" );

    ObjDelete("gfx_complex_pictureinframe_lvl4button");
    ObjDelete("spr_complex_pictureinframe_lvl4button_sh");

  end;
  cmn.AddSubscriber( "get_lvl4button", get_lvl4button_inv );
  --------------------------------------------------------------------------------------------
  -- function get_syringewithneedle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_syringewithneedle" ] = {
    type = "get",
    get_obj = "obj_complex_bigsyringe_syringewithneedle",
    room = "int_complex_inv",
    zz = "inv_complex_bigsyringe",
    zz_gate = "inv_bigsyringe"
  };
  --------------------------------------------------------------------------------------------
  local get_syringewithneedle_inv = function ()

    interface.InventoryItemRemove( "inv_bigsyringe" );
    interface.InventoryItemAdd( "inv_syringewithneedle", "obj_complex_bigsyringe_syringewithneedle" );

    ObjDelete("gfx_complex_bigsyringe_syringewithneedle");

  end;
  cmn.AddSubscriber( "get_syringewithneedle", get_syringewithneedle_inv );
  --------------------------------------------------------------------------------------------
  -- function get_volunteersign () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_volunteersign" ] = {
    type = "get",
    get_obj = "spr_complex_tornoffpatch_volunteersign",
    room = "int_complex_inv",
    zz = "inv_complex_tornoffpatch",
    zz_gate = "inv_tornoffpatch"
  };
  --------------------------------------------------------------------------------------------
  local get_volunteersign_inv = function ()

    interface.InventoryItemRemove( "inv_tornoffpatch" );
    interface.InventoryItemAdd( "inv_volunteersign", "obj_complex_tornoffpatch_volunteersign" );

    ObjDelete("gfx_complex_tornoffpatch_volunteersign");
    ObjDelete("spr_complex_tornoffpatch_volunteersign");

  end;
  cmn.AddSubscriber( "get_volunteersign", get_volunteersign_inv );
  --------------------------------------------------------------------------------------------
  -- function get_selfmadepen () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_selfmadepen" ] = {
    type = "get",
    get_obj = "spr_complex_thickwire_selfmadepen_fly",
    room = "int_complex_inv",
    zz = "inv_complex_thickwire",
    zz_gate = "inv_thickwire"
  };
  --------------------------------------------------------------------------------------------
  local get_selfmadepen_inv = function ()

    interface.InventoryItemRemove( "inv_thickwire" );
    interface.InventoryItemAdd( "inv_selfmadepen", "spr_complex_thickwire_selfmadepen_fly" );

    ObjDelete("anm_complex_thickwire_use_pliers");

  end;
  cmn.AddSubscriber( "get_selfmadepen", get_selfmadepen_inv );
  --------------------------------------------------------------------------------------------
  -- function get_homekeys () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_homekeys" ] = {
    type = "get",
    get_obj = "spr_complex_keyholder_homekeys",
    room = "int_complex_inv",
    zz = "inv_complex_keyholder",
    zz_gate = "inv_keyholder"
  };
  --------------------------------------------------------------------------------------------
  local get_homekeys_inv = function ()

    if ( cmn.IsEventDone( "get_nursekeys" ) ) then
      interface.InventoryItemRemove( "inv_keyholder" );
    end;

    interface.InventoryItemAdd( "inv_homekeys", "spr_complex_keyholder_homekeys" );

    ObjDelete( "gfx_complex_keyholder_homekeys" );
    ObjDelete( "spr_complex_keyholder_shadow_all_keys" );

  end;
  cmn.AddSubscriber( "get_homekeys", get_homekeys_inv );
  --------------------------------------------------------------------------------------------
  -- function get_nursekeys () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_nursekeys" ] = {
    type = "get",
    get_obj = "spr_complex_keyholder_nursekeys",
    room = "int_complex_inv",
    zz = "inv_complex_keyholder",
    zz_gate = "inv_keyholder"
  };
  --------------------------------------------------------------------------------------------
  local get_nursekeys_inv = function ()

    if ( cmn.IsEventDone( "get_homekeys" ) ) then
      interface.InventoryItemRemove( "inv_keyholder" );
    end;

    interface.InventoryItemAdd( "inv_nursekeys", "spr_complex_keyholder_nursekeys" );

    ObjDelete( "gfx_complex_keyholder_nursekeys" );
    ObjDelete( "spr_complex_keyholder_shadow_amulet" );
    ObjDelete( "spr_complex_keyholder_shadow_amulet1" );

  end;
  cmn.AddSubscriber( "get_nursekeys", get_nursekeys_inv );
  --------------------------------------------------------------------------------------------
  -- function get_devilfigurine () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_devilfigurine" ] = {
    type = "get",
    get_obj = "spr_complex_brokenfigurine_devilfigurine",
    room = "int_complex_inv",
    zz = "inv_complex_brokenfigurine",
    zz_gate = "inv_brokenfigurine"
  };
  --------------------------------------------------------------------------------------------
  local get_devilfigurine_inv = function ()

    interface.InventoryItemRemove( "inv_brokenfigurine" );
    interface.InventoryItemAdd( "inv_devilfigurine", "obj_complex_brokenfigurine_devilfigurine" );

    ObjDelete("gfx_complex_brokenfigurine_devilfigurine");

  end;
  cmn.AddSubscriber( "get_devilfigurine", get_devilfigurine_inv );
  --------------------------------------------------------------------------------------------
  -- function get_shipmodel () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_shipmodel" ] = {
    type = "get",
    get_obj = "spr_complex_ship_shipmodel",
    room = "int_complex_inv",
    zz = "inv_complex_ship",
    zz_gate = "inv_ship"
  };
  --------------------------------------------------------------------------------------------
  local get_shipmodel_inv = function ()

    interface.InventoryItemRemove( "inv_ship" );
    interface.InventoryItemAdd( "inv_shipmodel", "spr_complex_ship_shipmodel" );

    ObjDelete("gfx_complex_ship_shipmodel");

  end;
  cmn.AddSubscriber( "get_shipmodel", get_shipmodel_inv );
  --------------------------------------------------------------------------------------------
  -- function get_lvl4clockhands () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl4clockhands" ] = {
    type = "get",
    get_obj = "spr_complex_brokenalarmclock_lvl4clockhands",
    room = "int_complex_inv",
    zz = "inv_complex_brokenalarmclock",
    zz_gate = "inv_brokenalarmclock"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl4clockhands_inv = function ()

    if ( cmn.IsEventDone( "get_lvl4bolt1" ) ) then
      interface.InventoryItemRemove( "inv_brokenalarmclock" );
    end;

    ObjAttach( "spr_complex_brokenalarmclock_hour_arrow1", "spr_complex_brokenalarmclock_lvl4clockhands" );

    interface.InventoryItemAdd( "inv_lvl4clockhands", "spr_complex_brokenalarmclock_lvl4clockhands" );

    ObjDelete("gfx_complex_brokenalarmclock_lvl4clockhands");
    ObjDelete( "spr_complex_brokenalarmclock_shadow_on_hour_arrow" );
    ObjDelete( "spr_complex_brokenalarmclock_min_arrow_holder_overlap" );

    ObjDelete( "spr_complex_brokenalarmclock_min_arrow" );
    ObjDelete( "spr_complex_brokenalarmclock_shadow_on_hour_arrow2" );
    ObjDelete( "spr_complex_brokenalarmclock_hour_arrow1_2" );
    ObjDelete( "spr_complex_brokenalarmclock_min_arrow_holder_overlap2" );

  end;
  cmn.AddSubscriber( "get_lvl4clockhands", get_lvl4clockhands_inv );
  --------------------------------------------------------------------------------------------
  -- function get_lvl4bolt1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl4bolt1" ] = {
    type = "get",
    get_obj = "spr_complex_brokenalarmclock_lvl4bolt1",
    room = "int_complex_inv",
    zz = "inv_complex_brokenalarmclock",
    zz_gate = "inv_brokenalarmclock"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl4bolt1_inv = function ()

    if ( cmn.IsEventDone( "get_lvl4clockhands" ) ) then
      interface.InventoryItemRemove( "inv_brokenalarmclock" );
    end;

    interface.InventoryItemAdd(
      "inv_lvl4bolt",
      "spr_complex_brokenalarmclock_lvl4bolt1",
      function () cmn.GetMultyObject( 'lvl4bolt', 2 ); end
    );
    
      
    if cmn.CheckMultiObject( "lvl4bolt", 2 ) then
      ObjSet("inv_brokendogcase_star_light",  { alp = 1 });
    end;

    ObjDelete( "gfx_complex_brokenalarmclock_lvl4bolt1" );
    ObjDelete( "spr_complex_brokenalarmclock_bolt_holder_overlap" );

    ObjDelete( "spr_complex_brokenalarmclock_bolt" );
    ObjDelete( "spr_complex_brokenalarmclock_bolt_holder_overlap2" );

  end;
  cmn.AddSubscriber( "get_lvl4bolt1", get_lvl4bolt1_inv );
  --------------------------------------------------------------------------------------------
  -- function get_dogname () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_dogname" ] = {
    type = "get",
    get_obj = "obj_complex_burntnewspaper_dogname",
    room = "int_complex_inv",
    zz = "inv_complex_burntnewspaper",
    zz_gate = "inv_burntnewspaper"
  };
  --------------------------------------------------------------------------------------------
  local get_dogname_inv = function ()

    interface.InventoryItemRemove( "inv_burntnewspaper" );
    interface.InventoryItemAdd( "inv_dogname", "obj_complex_burntnewspaper_dogname" );
    
    ObjSet("inv_brokendogcase_star_light",  { alp = 1 });

    ObjDelete("gfx_complex_burntnewspaper_dogname");
    ObjDelete("obj_complex_burntnewspaper_back");
    ObjDelete("obj_complex_burntnewspaper_game");

  end;
  cmn.AddSubscriber( "get_dogname", get_dogname_inv );
  --------------------------------------------------------------------------------------------
  -- function get_dogcage () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_dogcage" ] = {
    type = "get",
    get_obj = "spr_complex_brokendogcase_dogcage",
    room = "int_complex_inv",
    zz = "inv_complex_brokendogcase",
    zz_gate = "inv_brokendogcase"
  };
  --------------------------------------------------------------------------------------------
  local get_dogcage_inv = function ()

    interface.InventoryItemRemove( "inv_brokendogcase" );
    interface.InventoryItemAdd( "inv_dogcage", "spr_complex_brokendogcase_dogcage" );

    ObjDelete("gfx_complex_brokendogcase_dogcage");

  end;
  cmn.AddSubscriber( "get_dogcage", get_dogcage_inv );

  --------------------------------------------------------------------------------------------
  -- function use_sharpstone () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_sharpstonetravelersbag" ] = {
    type = "use",
    inv_obj = "inv_sharpstone",
    use_place = "obj_complex_travelersbag_use_sharpstonetravelersbag",
    room = "int_complex_inv",
    zz = "inv_complex_travelersbag",
    zz_gate = "inv_travelersbag"
  };
  --------------------------------------------------------------------------------------------
  local use_sharpstonetravelersbag_inv = function ()

    if ( cmn.IsEventDone( "use_sharpstonedirtytorch" ) ) then
      interface.InventoryItemRemove( "inv_sharpstone" );
    end;

  end;
  local use_sharpstonetravelersbag_beg = function ()

    ObjDelete( "obj_complex_travelersbag_use_sharpstonetravelersbag" );
    ObjDelete( "anm_complex_travelersbag_bag_touch" );

  end;
  local use_sharpstonetravelersbag_end = function ()

    ObjSet("obj_complex_travelersbag_bag_open",  { alp = 1, input = 1 });
    ObjDelete( "anm_complex_travelersbag_use_stone" );

  end;
  cmn.AddSubscriber( "use_sharpstonetravelersbag", use_sharpstonetravelersbag_inv );
  cmn.AddSubscriber( "use_sharpstonetravelersbag", use_sharpstonetravelersbag_beg, "inv_complex_travelersbag" );
  cmn.AddSubscriber( "use_sharpstonetravelersbag", use_sharpstonetravelersbag_end, "inv_complex_travelersbag" );
  cmn.AddSubscriber( "use_sharpstonetravelersbag_inv", use_sharpstonetravelersbag_inv );
  cmn.AddSubscriber( "use_sharpstonetravelersbag_beg", use_sharpstonetravelersbag_beg, "inv_complex_travelersbag" );
  cmn.AddSubscriber( "use_sharpstonetravelersbag_end", use_sharpstonetravelersbag_end, "inv_complex_travelersbag" );
  --------------------------------------------------------------------------------------------
  game.hint[ "use_sharpstonedirtytorch" ] = {
    type = "use",
    inv_obj = "inv_sharpstone",
    use_place = "obj_complex_dirtytorch_use_sharpstonedirtytorch",
    room = "int_complex_inv",
    zz = "inv_complex_dirtytorch",
    zz_gate = "inv_dirtytorch"
  };
  --------------------------------------------------------------------------------------------
  local use_sharpstonedirtytorch_inv = function ()

    if ( cmn.IsEventDone( "use_sharpstonetravelersbag" ) ) then
      interface.InventoryItemRemove( "inv_sharpstone" );
      
      if not cmn.IsEventDone("get_firestone") then
        ObjSet("inv_dirtytorch_star_light",  { alp = 0 });
      end;
      
    end;

  end;
  local use_sharpstonedirtytorch_beg = function ()

    ObjDelete( "obj_complex_dirtytorch_use_sharpstonedirtytorch" );

  end;
  local use_sharpstonedirtytorch_end = function ()
    
    if cmn.IsEventDone("use_firestone") then
      ObjDelete( "obj_complex_dirtytorch_tools" );
      ObjMultiSet( { {"anm_complex_dirtytorch_use_firestone", { frame = 400 }},
                     {"obj_complex_dirtytorch_lvl4torch", { input = 1 }},
                     {"gfx_complex_dirtytorch_lvl4torch", { alp = 1 }},
                     {"fx_complex_dirtytorch_fire", { alp = 1 }} } );
    else 
      ObjMultiSet( { {"spr_complex_dirtytorch_sharpstone", { alp = 1 }},
                     {"obj_complex_dirtytorch_use_firestone", { input = 1 }} } );
    end;

  end;
  cmn.AddSubscriber( "use_sharpstonedirtytorch", use_sharpstonedirtytorch_inv );
  cmn.AddSubscriber( "use_sharpstonedirtytorch", use_sharpstonedirtytorch_beg, "inv_complex_dirtytorch" );
  cmn.AddSubscriber( "use_sharpstonedirtytorch", use_sharpstonedirtytorch_end, "inv_complex_dirtytorch" );
  cmn.AddSubscriber( "use_sharpstonedirtytorch_inv", use_sharpstonedirtytorch_inv );
  cmn.AddSubscriber( "use_sharpstonedirtytorch_beg", use_sharpstonedirtytorch_beg, "inv_complex_dirtytorch" );
  cmn.AddSubscriber( "use_sharpstonedirtytorch_end", use_sharpstonedirtytorch_end, "inv_complex_dirtytorch" );

  --------------------------------------------------------------------------------------------
  -- function use_firestone () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_firestone" ] = {

      type = "use",
      inv_obj = "inv_firestone",
      use_place = "obj_complex_dirtytorch_use_firestone",
      room = "int_complex_inv",
      zz = "inv_complex_dirtytorch",
      zz_gate = "inv_dirtytorch"
  };
  --------------------------------------------------------------------------------------------
  local use_firestone_inv = function ()

    interface.InventoryItemRemove( "inv_firestone" );
    
    if not cmn.IsEventDone("get_sharpstone") then
      ObjSet("inv_dirtytorch_star_light",  { alp = 0 });
    end;

  end;
  local use_firestone_beg = function ()

    ObjDelete( "obj_complex_dirtytorch_use_firestone" );

  end;
  local use_firestone_end = function ()

    if cmn.IsEventDone("use_sharpstonedirtytorch") then
      ObjDelete( "obj_complex_dirtytorch_tools" );
      ObjMultiSet( { {"anm_complex_dirtytorch_use_firestone", { frame = 400 }},
                     {"obj_complex_dirtytorch_lvl4torch", { input = 1 }},
                     {"gfx_complex_dirtytorch_lvl4torch", { alp = 1 }},
                     {"fx_complex_dirtytorch_fire", { alp = 1 }} } );
    else 
      ObjSet("spr_complex_dirtytorch_firestone",  { alp = 1 });
    end;

  end;
  cmn.AddSubscriber( "use_firestone", use_firestone_inv );
  cmn.AddSubscriber( "use_firestone", use_firestone_beg, "inv_complex_dirtytorch" );
  cmn.AddSubscriber( "use_firestone", use_firestone_end, "inv_complex_dirtytorch" );
  cmn.AddSubscriber( "use_firestone_inv", use_firestone_inv );
  cmn.AddSubscriber( "use_firestone_beg", use_firestone_beg, "inv_complex_dirtytorch" );
  cmn.AddSubscriber( "use_firestone_end", use_firestone_end, "inv_complex_dirtytorch" );

  --------------------------------------------------------------------------------------------
  -- function use_yellowthread () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_yellowthread" ] = {
    type = "use",
    inv_obj = "inv_yellowthread",
    use_place = "obj_complex_tornoffpatch_use_yellowthread",
    room = "int_complex_inv",
    zz = "inv_complex_tornoffpatch",
    zz_gate = "inv_tornoffpatch"
  };
  --------------------------------------------------------------------------------------------
  local use_yellowthread_inv = function ()

    interface.InventoryItemRemove( "inv_yellowthread" );
    
    if not cmn.IsEventDone("get_needle") then
      ObjSet("inv_tornoffpatch_star_light",  { alp = 0 });
    end;

  end;
  local use_yellowthread_beg = function ()

    ObjDelete( "obj_complex_tornoffpatch_use_yellowthread" );
    
  end;
  local use_yellowthread_end = function ()
    
    ObjSet("spr_complex_tornoffpatch_thread",  { alp = 1 });

    if ( cmn.IsEventDone( "use_needle" ) ) then
      ObjDelete( "spr_complex_tornoffpatch_needle_1" );
      ObjMultiSet( { {"obj_complex_tornoffpatch_game", { alp = 1, input = 1 }},
                     {"spr_complex_tornoffpatch_needle", { alp = 1 }},
                     {"spr_complex_tornoffpatch_needle_bl", { alp = 1 }} } );
    end;

  end;
  cmn.AddSubscriber( "use_yellowthread", use_yellowthread_inv );
  cmn.AddSubscriber( "use_yellowthread", use_yellowthread_beg, "inv_complex_tornoffpatch" );
  cmn.AddSubscriber( "use_yellowthread", use_yellowthread_end, "inv_complex_tornoffpatch" );
  cmn.AddSubscriber( "use_yellowthread_inv", use_yellowthread_inv );
  cmn.AddSubscriber( "use_yellowthread_beg", use_yellowthread_beg, "inv_complex_tornoffpatch" );
  cmn.AddSubscriber( "use_yellowthread_end", use_yellowthread_end, "inv_complex_tornoffpatch" );

  --------------------------------------------------------------------------------------------
  -- function use_needle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_needle" ] = {
    type = "use",
    inv_obj = "inv_needle",
    use_place = "obj_complex_tornoffpatch_use_needle",
    room = "int_complex_inv",
    zz = "inv_complex_tornoffpatch",
    zz_gate = "inv_tornoffpatch"
  };
  --------------------------------------------------------------------------------------------
  local use_needle_inv = function ()

    interface.InventoryItemRemove( "inv_needle" );
    
    if not cmn.IsEventDone("get_yellowthread") then
      ObjSet("inv_tornoffpatch_star_light",  { alp = 0 });
    end;

  end;
  local use_needle_beg = function ()

    ObjDelete( "obj_complex_tornoffpatch_use_needle" );
    
  end;
  local use_needle_end = function ()

    if ( cmn.IsEventDone( "use_yellowthread" ) ) then
      ObjDelete( "spr_complex_tornoffpatch_needle_1" );
      ObjMultiSet( { {"obj_complex_tornoffpatch_game", { alp = 1, input = 1 }},
                     {"spr_complex_tornoffpatch_needle", { alp = 1 }},
                     {"spr_complex_tornoffpatch_needle_bl", { alp = 1 }} } );
    else 
      ObjSet("spr_complex_tornoffpatch_needle_1",  { alp = 1 });               
    end;

  end;
  cmn.AddSubscriber( "use_needle", use_needle_inv );
  cmn.AddSubscriber( "use_needle", use_needle_beg, "inv_complex_tornoffpatch" );
  cmn.AddSubscriber( "use_needle", use_needle_end, "inv_complex_tornoffpatch" );
  cmn.AddSubscriber( "use_needle_inv", use_needle_inv );
  cmn.AddSubscriber( "use_needle_beg", use_needle_beg, "inv_complex_tornoffpatch" );
  cmn.AddSubscriber( "use_needle_end", use_needle_end, "inv_complex_tornoffpatch" );

  --------------------------------------------------------------------------------------------
  -- function use_pliers () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_pliers" ] = {
    type = "use",
    inv_obj = "inv_pliers",
    use_place = "obj_complex_thickwire_use_pliers",
    room = "int_complex_inv",
    zz = "inv_complex_thickwire",
    zz_gate = "inv_thickwire"
  };
  --------------------------------------------------------------------------------------------
  local use_pliers_inv = function ()

    interface.InventoryItemRemove( "inv_pliers" );

  end;
  local use_pliers_beg = function ()

    ObjDelete( "obj_complex_thickwire_use_pliers" );

  end;
  local use_pliers_end = function ()

    ObjSet( "anm_complex_thickwire_use_pliers", { alp = 1, input = true, frame = 400 } );

  end;
  cmn.AddSubscriber( "use_pliers", use_pliers_inv );
  cmn.AddSubscriber( "use_pliers", use_pliers_beg, "inv_complex_thickwire" );
  cmn.AddSubscriber( "use_pliers", use_pliers_end, "inv_complex_thickwire" );
  cmn.AddSubscriber( "use_pliers_inv", use_pliers_inv );
  cmn.AddSubscriber( "use_pliers_beg", use_pliers_beg, "inv_complex_thickwire" );
  cmn.AddSubscriber( "use_pliers_end", use_pliers_end, "inv_complex_thickwire" );

  --------------------------------------------------------------------------------------------
  -- function use_shellpart () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_shellpart" ] = {
    type = "use",
    inv_obj = "inv_shellpart",
    use_place = "obj_complex_keyholder_use_shellpart",
    room = "int_complex_inv",
    zz = "inv_complex_keyholder",
    zz_gate = "inv_keyholder"
  };
  --------------------------------------------------------------------------------------------
  local use_shellpart_inv = function ()

    interface.InventoryItemRemove( "inv_shellpart" );

  end;
  local use_shellpart_beg = function ()

    ObjDelete( "obj_complex_keyholder_use_shellpart" );

  end;
  local use_shellpart_end = function ()

    ObjMultiSet( { { "anm_complex_keyholder_keyholder", { animfunc = "func_use_shells", frame = 102 } },
                   { "spr_complex_keyholder_homekeys", { input = true } },
                   { "spr_complex_keyholder_nursekeys", { input = true } } } );

  end;
  cmn.AddSubscriber( "use_shellpart", use_shellpart_inv );
  cmn.AddSubscriber( "use_shellpart", use_shellpart_beg, "inv_complex_keyholder" );
  cmn.AddSubscriber( "use_shellpart", use_shellpart_end, "inv_complex_keyholder" );
  cmn.AddSubscriber( "use_shellpart_inv", use_shellpart_inv );
  cmn.AddSubscriber( "use_shellpart_beg", use_shellpart_beg, "inv_complex_keyholder" );
  cmn.AddSubscriber( "use_shellpart_end", use_shellpart_end, "inv_complex_keyholder" );

  --------------------------------------------------------------------------------------------
  -- function use_lvl4wings () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl4wings" ] = {
    type = "use",
    inv_obj = "inv_lvl4wings",
    use_place = "obj_complex_brokenfigurine_use_lvl4wings",
    room = "int_complex_inv",
    zz = "inv_complex_brokenfigurine",
    zz_gate = "inv_brokenfigurine"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl4wings_inv = function ()

    interface.InventoryItemRemove( "inv_lvl4wings" );
    
    if (not cmn.IsEventDone("get_horns") or cmn.IsEventDone("use_horns")) and 
       (not cmn.IsEventDone("get_clawedpaw") or cmn.IsEventDone("use_clawedpaw")) and
        not(cmn.IsEventDone("use_horns") and cmn.IsEventDone("use_clawedpaw"))  then
      ObjSet("inv_brokenfigurine_star_light",  { alp = 0 });
    end;

  end;
  local use_lvl4wings_beg = function ()
    
    ObjDelete( "obj_complex_brokenfigurine_use_lvl4wings" );

  end;
  local use_lvl4wings_end = function ()
    
    ObjSet("obj_complex_brokenfigurine_wing",  { alp = 1 });

    if ( cmn.IsEventDone( "use_horns" ) and cmn.IsEventDone( "use_clawedpaw" ) ) then
      ObjSet( "obj_complex_brokenfigurine_devilfigurine", { input = 1 } );
    end;

  end;
  cmn.AddSubscriber( "use_lvl4wings", use_lvl4wings_inv );
  cmn.AddSubscriber( "use_lvl4wings", use_lvl4wings_beg, "inv_complex_brokenfigurine" );
  cmn.AddSubscriber( "use_lvl4wings", use_lvl4wings_end, "inv_complex_brokenfigurine" );
  cmn.AddSubscriber( "use_lvl4wings_inv", use_lvl4wings_inv );
  cmn.AddSubscriber( "use_lvl4wings_beg", use_lvl4wings_beg, "inv_complex_brokenfigurine" );
  cmn.AddSubscriber( "use_lvl4wings_end", use_lvl4wings_end, "inv_complex_brokenfigurine" );

  --------------------------------------------------------------------------------------------
  -- function use_horns () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_horns" ] = {
    type = "use",
    inv_obj = "inv_horns",
    use_place = "obj_complex_brokenfigurine_use_horns",
    room = "int_complex_inv",
    zz = "inv_complex_brokenfigurine",
    zz_gate = "inv_brokenfigurine"
  };
  --------------------------------------------------------------------------------------------
  local use_horns_inv = function ()

    interface.InventoryItemRemove( "inv_horns" );
    
    if (not cmn.IsEventDone("get_lvl4wings") or cmn.IsEventDone("use_lvl4wings")) and 
       (not cmn.IsEventDone("get_clawedpaw") or cmn.IsEventDone("use_clawedpaw")) and
        not(cmn.IsEventDone("use_lvl4wings") and cmn.IsEventDone("use_clawedpaw"))  then
      ObjSet("inv_brokenfigurine_star_light",  { alp = 0 });
    end;

  end;
  local use_horns_beg = function ()
  
    ObjDelete( "obj_complex_brokenfigurine_use_horns" );

  end;
  local use_horns_end = function ()

    ObjSet("obj_complex_brokenfigurine_horns",  { alp = 1 });

    if ( cmn.IsEventDone( "use_lvl4wings" ) and cmn.IsEventDone( "use_clawedpaw" ) ) then
      ObjSet( "obj_complex_brokenfigurine_devilfigurine", { input = 1 } );
    end;

  end;
  cmn.AddSubscriber( "use_horns", use_horns_inv );
  cmn.AddSubscriber( "use_horns", use_horns_beg, "inv_complex_brokenfigurine" );
  cmn.AddSubscriber( "use_horns", use_horns_end, "inv_complex_brokenfigurine" );
  cmn.AddSubscriber( "use_horns_inv", use_horns_inv );
  cmn.AddSubscriber( "use_horns_beg", use_horns_beg, "inv_complex_brokenfigurine" );
  cmn.AddSubscriber( "use_horns_end", use_horns_end, "inv_complex_brokenfigurine" );

  --------------------------------------------------------------------------------------------
  -- function use_clawedpaw () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_clawedpaw" ] = {
    type = "use",
    inv_obj = "inv_clawedpaw",
    use_place = "obj_complex_brokenfigurine_use_clawedpaw",
    room = "int_complex_inv",
    zz = "inv_complex_brokenfigurine",
    zz_gate = "inv_brokenfigurine"
  };
  --------------------------------------------------------------------------------------------
  local use_clawedpaw_inv = function ()

    interface.InventoryItemRemove( "inv_clawedpaw" );
    
    if (not cmn.IsEventDone("get_lvl4wings") or cmn.IsEventDone("use_lvl4wings")) and 
       (not cmn.IsEventDone("get_horns") or cmn.IsEventDone("use_horns")) and
        not(cmn.IsEventDone("use_lvl4wings") and cmn.IsEventDone("use_horns"))  then
      ObjSet("inv_brokenfigurine_star_light",  { alp = 0 });
    end;

  end;
  local use_clawedpaw_beg = function ()

    ObjDelete( "obj_complex_brokenfigurine_use_clawedpaw" );

  end;
  local use_clawedpaw_end = function ()

    ObjSet("obj_complex_brokenfigurine_paw",  { alp = 1 });

    if ( cmn.IsEventDone( "use_lvl4wings" ) and cmn.IsEventDone( "use_horns" ) ) then
      ObjSet( "obj_complex_brokenfigurine_devilfigurine", { input = 1 } );
    end;

  end;
  cmn.AddSubscriber( "use_clawedpaw", use_clawedpaw_inv );
  cmn.AddSubscriber( "use_clawedpaw", use_clawedpaw_beg, "inv_complex_brokenfigurine" );
  cmn.AddSubscriber( "use_clawedpaw", use_clawedpaw_end, "inv_complex_brokenfigurine" );
  cmn.AddSubscriber( "use_clawedpaw_inv", use_clawedpaw_inv );
  cmn.AddSubscriber( "use_clawedpaw_beg", use_clawedpaw_beg, "inv_complex_brokenfigurine" );
  cmn.AddSubscriber( "use_clawedpaw_end", use_clawedpaw_end, "inv_complex_brokenfigurine" );

  --------------------------------------------------------------------------------------------
  -- function use_sails () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_sails" ] = {
    type = "use",
    inv_obj = "inv_sails",
    use_place = "obj_complex_ship_use_sails",
    room = "int_complex_inv",
    zz = "inv_complex_ship",
    zz_gate = "inv_ship"
  };
  --------------------------------------------------------------------------------------------
  local use_sails_inv = function ()

    interface.InventoryItemRemove( "inv_sails" );
    
    if (not cmn.IsEventDone("get_fishingline") or cmn.IsEventDone("use_fishingline")) and 
       (not cmn.IsEventDone("get_figurehead") or cmn.IsEventDone("use_figurehead")) and
        not(cmn.IsEventDone("use_fishingline") and cmn.IsEventDone("use_figurehead"))  then
      ObjSet("inv_ship_star_light",  { alp = 0 });
    end;

  end;
  local use_sails_beg = function ()

    ObjDelete( "obj_complex_ship_use_sails" );

  end;
  local use_sails_end = function ()

    ObjDelete( "spr_complex_ship_sails_slot" );

    ObjSet( "obj_complex_ship_sails", { alp = 1 } );

    if ( cmn.IsEventDone( "use_fishingline" ) and cmn.IsEventDone( "use_figurehead" ) ) then
      ObjMultiSet( { { "spr_complex_ship_shipmodel", { input = true } },
                     { "gfx_complex_ship_shipmodel", { active = true } } } );
    end;

  end;
  cmn.AddSubscriber( "use_sails", use_sails_inv );
  cmn.AddSubscriber( "use_sails", use_sails_beg, "inv_complex_ship" );
  cmn.AddSubscriber( "use_sails", use_sails_end, "inv_complex_ship" );
  cmn.AddSubscriber( "use_sails_inv", use_sails_inv );
  cmn.AddSubscriber( "use_sails_beg", use_sails_beg, "inv_complex_ship" );
  cmn.AddSubscriber( "use_sails_end", use_sails_end, "inv_complex_ship" );

  --------------------------------------------------------------------------------------------
  -- function use_fishingline () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_fishingline" ] = {
    type = "use",
    inv_obj = "inv_fishingline",
    use_place = "obj_complex_ship_use_fishingline",
    room = "int_complex_inv",
    zz = "inv_complex_ship",
    zz_gate = "inv_ship"
  };
  --------------------------------------------------------------------------------------------
  local use_fishingline_inv = function ()

    interface.InventoryItemRemove( "inv_fishingline" );
    
    if (not cmn.IsEventDone("get_sails") or cmn.IsEventDone("use_sails")) and 
       (not cmn.IsEventDone("get_figurehead") or cmn.IsEventDone("use_figurehead")) and
        not(cmn.IsEventDone("use_sails") and cmn.IsEventDone("use_figurehead"))  then
      ObjSet("inv_ship_star_light",  { alp = 0 });
    end;

  end;
  local use_fishingline_beg = function ()

    ObjDelete( "obj_complex_ship_use_fishingline" );

  end;
  local use_fishingline_end = function ()

    ObjDelete( "spr_complex_ship_fishingline_slot" );

    ObjSet( "spr_complex_ship_fishingline", { alp = 1 } );

    if ( cmn.IsEventDone( "use_sails" ) and cmn.IsEventDone( "use_figurehead" ) ) then
      ObjMultiSet( { { "spr_complex_ship_shipmodel", { input = true } },
                     { "gfx_complex_ship_shipmodel", { active = true } } } );
    end;

  end;
  cmn.AddSubscriber( "use_fishingline", use_fishingline_inv );
  cmn.AddSubscriber( "use_fishingline", use_fishingline_beg, "inv_complex_ship" );
  cmn.AddSubscriber( "use_fishingline", use_fishingline_end, "inv_complex_ship" );
  cmn.AddSubscriber( "use_fishingline_inv", use_fishingline_inv );
  cmn.AddSubscriber( "use_fishingline_beg", use_fishingline_beg, "inv_complex_ship" );
  cmn.AddSubscriber( "use_fishingline_end", use_fishingline_end, "inv_complex_ship" );

  --------------------------------------------------------------------------------------------
  -- function use_figurehead () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_figurehead" ] = {
    type = "use",
    inv_obj = "inv_figurehead",
    use_place = "obj_complex_ship_use_figurehead",
    room = "int_complex_inv",
    zz = "inv_complex_ship",
    zz_gate = "inv_ship"
  };
  --------------------------------------------------------------------------------------------
  local use_figurehead_inv = function ()

    interface.InventoryItemRemove( "inv_figurehead" );
    
    if (not cmn.IsEventDone("get_sails") or cmn.IsEventDone("use_sails")) and 
       (not cmn.IsEventDone("get_fishingline") or cmn.IsEventDone("use_fishingline")) and
        not(cmn.IsEventDone("use_sails") and cmn.IsEventDone("use_fishingline"))  then
      ObjSet("inv_ship_star_light",  { alp = 0 });
    end;

  end;
  local use_figurehead_beg = function ()

    ObjDelete( "obj_complex_ship_use_figurehead" );

  end;
  local use_figurehead_end = function ()

    ObjDelete( "spr_complex_ship_figurehead_slot" );

    ObjSet( "spr_complex_ship_figurehead", { alp = 1 } );

    if ( cmn.IsEventDone( "use_sails" ) and cmn.IsEventDone( "use_fishingline" ) ) then
      ObjMultiSet( { { "spr_complex_ship_shipmodel", { input = true } },
                     { "gfx_complex_ship_shipmodel", { active = true } } } );
    end;

  end;
  cmn.AddSubscriber( "use_figurehead", use_figurehead_inv );
  cmn.AddSubscriber( "use_figurehead", use_figurehead_beg, "inv_complex_ship" );
  cmn.AddSubscriber( "use_figurehead", use_figurehead_end, "inv_complex_ship" );
  cmn.AddSubscriber( "use_figurehead_inv", use_figurehead_inv );
  cmn.AddSubscriber( "use_figurehead_beg", use_figurehead_beg, "inv_complex_ship" );
  cmn.AddSubscriber( "use_figurehead_end", use_figurehead_end, "inv_complex_ship" );

  --------------------------------------------------------------------------------------------
  -- function use_newspaperpiece () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_newspaperpiece" ] = {
    type = "use",
    inv_obj = "inv_newspaperpiece",
    use_place = "obj_complex_burntnewspaper_use_newspaperpiece",
    room = "int_complex_inv",
    zz = "inv_complex_burntnewspaper",
    zz_gate = "inv_burntnewspaper"
  };
  --------------------------------------------------------------------------------------------
  local use_newspaperpiece_inv = function ()

    interface.InventoryItemRemove( "inv_newspaperpiece" );
    
    if not cmn.IsEventDone("get_tape") then
      ObjSet("inv_burntnewspaper_star_light",  { alp = 0 });
    end;

  end;
  local use_newspaperpiece_beg = function ()

    ObjDelete( "obj_complex_burntnewspaper_use_newspaperpiece" );

  end;
  local use_newspaperpiece_end = function ()

    if cmn.IsEventDone("use_tape") then
      ObjDelete("obj_complex_burntnewspaper_pieces");
      ObjMultiSet( { {"obj_complex_burntnewspaper_game", { input = 1 }},
                     {"obj_complex_burntnewspaper_tape_crop", { alp = 1 }},
                     {"anm_complex_burntnewspaper_tape_open", { frame = 300 }} } );
    else
      ObjMultiSet( { {"obj_complex_burntnewspaper_use_tape", { alp = 1, input = 1 }},
                     {"obj_complex_burntnewspaper_pieces", { alp = 1 }} } );
    end;

  end;
  cmn.AddSubscriber( "use_newspaperpiece", use_newspaperpiece_inv );
  cmn.AddSubscriber( "use_newspaperpiece", use_newspaperpiece_beg, "inv_complex_burntnewspaper" );
  cmn.AddSubscriber( "use_newspaperpiece", use_newspaperpiece_end, "inv_complex_burntnewspaper" );
  cmn.AddSubscriber( "use_newspaperpiece_inv", use_newspaperpiece_inv );
  cmn.AddSubscriber( "use_newspaperpiece_beg", use_newspaperpiece_beg, "inv_complex_burntnewspaper" );
  cmn.AddSubscriber( "use_newspaperpiece_end", use_newspaperpiece_end, "inv_complex_burntnewspaper" );

  --------------------------------------------------------------------------------------------
  -- function use_tape () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_tape" ] = {
    type = "use",
    inv_obj = "inv_tape",
    use_place = "obj_complex_burntnewspaper_use_tape",
    room = "int_complex_inv",
    zz = "inv_complex_burntnewspaper",
    zz_gate = "inv_burntnewspaper"
  };
  --------------------------------------------------------------------------------------------
  local use_tape_inv = function ()

    interface.InventoryItemRemove( "inv_tape" );
    
    if not cmn.CheckMultiObject( "newspaperpiece", 4 ) then
      ObjSet("inv_burntnewspaper_star_light",  { alp = 0 });
    end;

  end;
  local use_tape_beg = function ()

    ObjDelete( "obj_complex_burntnewspaper_use_tape" );

  end;
  local use_tape_end = function ()

    ObjSet( "spr_complex_burntnewspaper_tape", { alp = 1 } );
    
    if cmn.IsEventDone("use_newspaperpiece") then
      ObjDelete("obj_complex_burntnewspaper_pieces");
      ObjMultiSet( { {"obj_complex_burntnewspaper_game", { input = 1 }},
                     {"obj_complex_burntnewspaper_tape_crop", { alp = 1 }},
                     {"anm_complex_burntnewspaper_tape_open", { frame = 300 }} } );
    end;

  end;
  cmn.AddSubscriber( "use_tape", use_tape_inv );
  cmn.AddSubscriber( "use_tape", use_tape_beg, "inv_complex_burntnewspaper" );
  cmn.AddSubscriber( "use_tape", use_tape_end, "inv_complex_burntnewspaper" );
  cmn.AddSubscriber( "use_tape_inv", use_tape_inv );
  cmn.AddSubscriber( "use_tape_beg", use_tape_beg, "inv_complex_burntnewspaper" );
  cmn.AddSubscriber( "use_tape_end", use_tape_end, "inv_complex_burntnewspaper" );

  --------------------------------------------------------------------------------------------
  -- function use_longrod () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_longrod" ] = {
    type = "use",
    inv_obj = "inv_longrod",
    use_place = "obj_complex_brokendogcase_use_longrod",
    room = "int_complex_inv",
    zz = "inv_complex_brokendogcase",
    zz_gate = "inv_brokendogcase"
  };
  --------------------------------------------------------------------------------------------
  local use_longrod_inv = function ()

    interface.InventoryItemRemove( "inv_longrod" );
    
    if not public.check_brokendogcase_for_action( "longrod" ) and not cmn.CheckMultiObject( "lvl4bolt", 2 ) then
      ObjSet("inv_brokendogcase_star_light",  { alp = 0 });
    end;

  end;
  local use_longrod_beg = function ()

    ObjDelete( "obj_complex_brokendogcase_use_longrod" );

  end;
  local use_longrod_end = function ()

    if cmn.IsEventDone("use_sophiaspullover") and cmn.IsEventDone("use_bone") then
      
      if cmn.IsEventDone("use_lvl4bolt") then
        ObjMultiSet( { {"spr_complex_brokendogcase_bolt_1_1", { alp = 1 }},
                       {"spr_complex_brokendogcase_bolt_1_2", { alp = 1 }},
                       {"spr_complex_brokendogcase_bolt_2_1", { alp = 1 }},
                       {"obj_complex_brokendogcase_use_wrench", { input = 1 }} } );
        ObjDelete("obj_complex_brokendogcase_bolts_1");
      else 
        ObjSet("obj_complex_brokendogcase_use_lvl4bolt",  { input = 1 });
      end;
      
      ObjDelete( "spr_complex_brokendogcase_door_1" );
      ObjMultiSet( { {"anm_complex_brokendogcase_use_wrench", { alp = 1 }},
                     {"obj_complex_brokendogcase_use_dogname", { pos_x = -150, pos_y = -36 }} } );
    else 
      ObjSet("spr_complex_brokendogcase_rod_1",  { alp = 1 });
    end;
    
  end;
  cmn.AddSubscriber( "use_longrod", use_longrod_inv );
  cmn.AddSubscriber( "use_longrod", use_longrod_beg, "inv_complex_brokendogcase" );
  cmn.AddSubscriber( "use_longrod", use_longrod_end, "inv_complex_brokendogcase" );
  cmn.AddSubscriber( "use_longrod_inv", use_longrod_inv );
  cmn.AddSubscriber( "use_longrod_beg", use_longrod_beg, "inv_complex_brokendogcase" );
  cmn.AddSubscriber( "use_longrod_end", use_longrod_end, "inv_complex_brokendogcase" );

  --------------------------------------------------------------------------------------------
  -- function use_lvl4bolt () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl4bolt" ] = {
    type = "use",
    inv_obj = "inv_lvl4bolt",
    use_place = "obj_complex_brokendogcase_use_lvl4bolt",
    room = "int_complex_inv",
    zz = "inv_complex_brokendogcase",
    zz_gate = "inv_brokendogcase"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl4bolt_inv = function ()

    interface.InventoryItemRemove( "inv_lvl4bolt" );
    
    if not cmn.IsEventDone("get_wrench") then
      ObjSet("inv_brokendogcase_star_light",  { alp = 0 });
    end;

  end;
  local use_lvl4bolt_beg = function ()

    ObjDelete( "obj_complex_brokendogcase_use_lvl4bolt" );

  end;
  local use_lvl4bolt_end = function ()

    if cmn.IsEventDone( "use_longrod" ) and cmn.IsEventDone("use_sophiaspullover") and cmn.IsEventDone("use_bone") then
      ObjMultiSet( { {"spr_complex_brokendogcase_bolt_1_1", { alp = 1 }},
                     {"spr_complex_brokendogcase_bolt_1_2", { alp = 1 }},
                     {"spr_complex_brokendogcase_bolt_2_1", { alp = 1 }},
                     {"obj_complex_brokendogcase_use_wrench", { input = 1 }} } );
    else 
      ObjSet("obj_complex_brokendogcase_bolts_1",  { alp = 1 });
    end;
    
  end;
  cmn.AddSubscriber( "use_lvl4bolt", use_lvl4bolt_inv );
  cmn.AddSubscriber( "use_lvl4bolt", use_lvl4bolt_beg, "inv_complex_brokendogcase" );
  cmn.AddSubscriber( "use_lvl4bolt", use_lvl4bolt_end, "inv_complex_brokendogcase" );
  cmn.AddSubscriber( "use_lvl4bolt_inv", use_lvl4bolt_inv );
  cmn.AddSubscriber( "use_lvl4bolt_beg", use_lvl4bolt_beg, "inv_complex_brokendogcase" );
  cmn.AddSubscriber( "use_lvl4bolt_end", use_lvl4bolt_end, "inv_complex_brokendogcase" );

  --------------------------------------------------------------------------------------------
  -- function use_sophiaspullover () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_sophiaspullover" ] = {
    type = "use",
    inv_obj = "inv_sophiaspullover",
    use_place = "obj_complex_brokendogcase_use_sophiaspullover",
    room = "int_complex_inv",
    zz = "inv_complex_brokendogcase",
    zz_gate = "inv_brokendogcase"
  };
  --------------------------------------------------------------------------------------------
  local use_sophiaspullover_inv = function ()

    interface.InventoryItemRemove( "inv_sophiaspullover" );
    
    if not public.check_brokendogcase_for_action( "sophiaspullover" ) and not cmn.CheckMultiObject( "lvl4bolt", 2 ) then
      ObjSet("inv_brokendogcase_star_light",  { alp = 0 });
    end;

  end;
  local use_sophiaspullover_beg = function ()

    ObjDelete( "obj_complex_brokendogcase_use_sophiaspullover" );

  end;
  local use_sophiaspullover_end = function ()
    
    ObjSet("spr_complex_brokendogcase_clothes",  { alp = 1 });

    if cmn.IsEventDone("use_longrod") and cmn.IsEventDone("use_bone") then
            
      if cmn.IsEventDone("use_lvl4bolt") then
        ObjMultiSet( { {"spr_complex_brokendogcase_bolt_1_1", { alp = 1 }},
                       {"spr_complex_brokendogcase_bolt_1_2", { alp = 1 }},
                       {"spr_complex_brokendogcase_bolt_2_1", { alp = 1 }},
                       {"obj_complex_brokendogcase_use_wrench", { input = 1 }} } );
        ObjDelete("obj_complex_brokendogcase_bolts_1");
      else 
        ObjSet("obj_complex_brokendogcase_use_lvl4bolt",  { input = 1 });
      end;
      
      ObjDelete( "spr_complex_brokendogcase_door_1" );
      ObjMultiSet( { {"anm_complex_brokendogcase_use_wrench", { alp = 1 }},
                     {"obj_complex_brokendogcase_use_dogname", { pos_x = -150, pos_y = -36 }} } );
    end;
                   
  end;
  cmn.AddSubscriber( "use_sophiaspullover", use_sophiaspullover_inv );
  cmn.AddSubscriber( "use_sophiaspullover", use_sophiaspullover_beg, "inv_complex_brokendogcase" );
  cmn.AddSubscriber( "use_sophiaspullover", use_sophiaspullover_end, "inv_complex_brokendogcase" );
  cmn.AddSubscriber( "use_sophiaspullover_inv", use_sophiaspullover_inv );
  cmn.AddSubscriber( "use_sophiaspullover_beg", use_sophiaspullover_beg, "inv_complex_brokendogcase" );
  cmn.AddSubscriber( "use_sophiaspullover_end", use_sophiaspullover_end, "inv_complex_brokendogcase" );

  --------------------------------------------------------------------------------------------
  -- function use_bone () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_bone" ] = {
    type = "use",
    inv_obj = "inv_bone",
    use_place = "obj_complex_brokendogcase_use_bone",
    room = "int_complex_inv",
    zz = "inv_complex_brokendogcase",
    zz_gate = "inv_brokendogcase"
  };
  --------------------------------------------------------------------------------------------
  local use_bone_inv = function ()

    interface.InventoryItemRemove( "inv_bone" );
    
    if not public.check_brokendogcase_for_action( "bone" ) and not cmn.CheckMultiObject( "lvl4bolt", 2 ) then
      ObjSet("inv_brokendogcase_star_light",  { alp = 0 });
    end;

  end;
  local use_bone_beg = function ()

    ObjDelete( "obj_complex_brokendogcase_use_bone" );

  end;
  local use_bone_end = function ()

    ObjSet("obj_complex_brokendogcase_bone",  { alp = 1 });

    if cmn.IsEventDone("use_longrod") and cmn.IsEventDone("use_sophiaspullover") then
            
      if cmn.IsEventDone("use_lvl4bolt") then
        ObjMultiSet( { {"spr_complex_brokendogcase_bolt_1_1", { alp = 1 }},
                       {"spr_complex_brokendogcase_bolt_1_2", { alp = 1 }},
                       {"spr_complex_brokendogcase_bolt_2_1", { alp = 1 }},
                       {"obj_complex_brokendogcase_use_wrench", { input = 1 }} } );
        ObjDelete("obj_complex_brokendogcase_bolts_1");
      else 
        ObjSet("obj_complex_brokendogcase_use_lvl4bolt",  { input = 1 });
      end;
      
      ObjDelete( "spr_complex_brokendogcase_door_1" );
      ObjMultiSet( { {"anm_complex_brokendogcase_use_wrench", { alp = 1 }},
                     {"obj_complex_brokendogcase_use_dogname", { pos_x = -150, pos_y = -36 }} } );
    end;
                   
  end;
  cmn.AddSubscriber( "use_bone", use_bone_inv );
  cmn.AddSubscriber( "use_bone", use_bone_beg, "inv_complex_brokendogcase" );
  cmn.AddSubscriber( "use_bone", use_bone_end, "inv_complex_brokendogcase" );
  cmn.AddSubscriber( "use_bone_inv", use_bone_inv );
  cmn.AddSubscriber( "use_bone_beg", use_bone_beg, "inv_complex_brokendogcase" );
  cmn.AddSubscriber( "use_bone_end", use_bone_end, "inv_complex_brokendogcase" );

  --------------------------------------------------------------------------------------------
  -- function use_dogname () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_dogname" ] = {
    type = "use",
    inv_obj = "inv_dogname",
    use_place = "obj_complex_brokendogcase_use_dogname",
    room = "int_complex_inv",
    zz = "inv_complex_brokendogcase",
    zz_gate = "inv_brokendogcase"
  };
  --------------------------------------------------------------------------------------------
  local use_dogname_inv = function ()

    interface.InventoryItemRemove( "inv_dogname" );
    
    if not public.check_brokendogcase_for_action( "dogname" ) and not cmn.IsEventDone("get_wrench") then
      ObjSet("inv_brokendogcase_star_light",  { alp = 0 });
    end;

  end;
  local use_dogname_beg = function ()

    ObjDelete( "obj_complex_brokendogcase_use_dogname" );

  end;
  local use_dogname_end = function ()
    
    ObjMultiSet( { {"spr_complex_brokendogcase_name_1", { alp = 1 }},
                   {"spr_complex_brokendogcase_name", { alp = 1 }} } );

    if cmn.IsEventDone("use_wrenchdogcase") then
      ObjSet("spr_complex_brokendogcase_dogcage",  { input = 1 });
    end;

  end;
  cmn.AddSubscriber( "use_dogname", use_dogname_inv );
  cmn.AddSubscriber( "use_dogname", use_dogname_beg, "inv_complex_brokendogcase" );
  cmn.AddSubscriber( "use_dogname", use_dogname_end, "inv_complex_brokendogcase" );
  cmn.AddSubscriber( "use_dogname_inv", use_dogname_inv );
  cmn.AddSubscriber( "use_dogname_beg", use_dogname_beg, "inv_complex_brokendogcase" );
  cmn.AddSubscriber( "use_dogname_end", use_dogname_end, "inv_complex_brokendogcase" );

  --------------------------------------------------------------------------------------------
  -- function clk_openpackage () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_openpackage" ] = {
    type = "click",
    use_place = "obj_complex_bigsyringe_clk_openpackage",
    room = "int_complex_inv",
    zz = "inv_complex_bigsyringe",
    zz_gate = "inv_bigsyringe"
  };
  --------------------------------------------------------------------------------------------
  local clk_openpackage_beg = function ()

    ObjDelete( "obj_complex_bigsyringe_clk_openpackage" );

  end;
  local clk_openpackage_end = function ()

    ObjMultiSet( { { "anm_complex_bigsyringe_bigsyringe_opn", { endtrig = "", frame = 24 } },
                   { "obj_complex_bigsyringe_clk_removeneedlecover", { input = true } } } );

  end;
  cmn.AddSubscriber( "clk_openpackage", clk_openpackage_beg, "inv_complex_bigsyringe" );
  cmn.AddSubscriber( "clk_openpackage", clk_openpackage_end, "inv_complex_bigsyringe" );
  cmn.AddSubscriber( "clk_openpackage_beg", clk_openpackage_beg, "inv_complex_bigsyringe" );
  cmn.AddSubscriber( "clk_openpackage_end", clk_openpackage_end, "inv_complex_bigsyringe" );
  --------------------------------------------------------------------------------------------
  -- function clk_removeneedlecover () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_removeneedlecover" ] = {
    type = "click",
    use_place = "obj_complex_bigsyringe_clk_removeneedlecover",
    room = "int_complex_inv",
    zz = "inv_complex_bigsyringe",
    zz_gate = "inv_bigsyringe"
  };
  --------------------------------------------------------------------------------------------
  local clk_removeneedlecover_beg = function ()
    ObjDelete( "obj_complex_bigsyringe_clk_removeneedlecover" );
  end;
  local clk_removeneedlecover_end = function ()

    ObjDelete( "spr_complex_bigsyringe_capneedle" );

    ObjMultiSet( { { "obj_complex_bigsyringe_clk_putneedleontosyringe", { input = true } },
                   { "anm_complex_bigsyringe_syringewithneedle", { alp = 1 } } } );

  end;
  cmn.AddSubscriber( "clk_removeneedlecover", clk_removeneedlecover_beg, "inv_complex_bigsyringe" );
  cmn.AddSubscriber( "clk_removeneedlecover", clk_removeneedlecover_end, "inv_complex_bigsyringe" );
  cmn.AddSubscriber( "clk_removeneedlecover_beg", clk_removeneedlecover_beg, "inv_complex_bigsyringe" );
  cmn.AddSubscriber( "clk_removeneedlecover_end", clk_removeneedlecover_end, "inv_complex_bigsyringe" );
  --------------------------------------------------------------------------------------------
  -- function clk_putneedleontosyringe () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_putneedleontosyringe" ] = {
    type = "click",
    use_place = "obj_complex_bigsyringe_clk_putneedleontosyringe",
    room = "int_complex_inv",
    zz = "inv_complex_bigsyringe",
    zz_gate = "inv_bigsyringe"
  };
  --------------------------------------------------------------------------------------------
  local clk_putneedleontosyringe_beg = function ()

    ObjDelete( "obj_complex_bigsyringe_clk_putneedleontosyringe" );
    ObjDelete( "anm_complex_bigsyringe_bigsyringe_opn" );

    ObjSet( "anm_complex_bigsyringe_syringewithneedle", { croprect_init = false } );

  end;
  local clk_putneedleontosyringe_end = function ()

    ObjMultiSet( { { "obj_complex_bigsyringe_syringewithneedle", { input = true } },
                   { "anm_complex_bigsyringe_syringewithneedle", { frame = 30 } },
                   { "gfx_complex_bigsyringe_syringewithneedle", { active = true } } } );

  end;
  cmn.AddSubscriber( "clk_putneedleontosyringe", clk_putneedleontosyringe_beg, "inv_complex_bigsyringe" );
  cmn.AddSubscriber( "clk_putneedleontosyringe", clk_putneedleontosyringe_end, "inv_complex_bigsyringe" );
  cmn.AddSubscriber( "clk_putneedleontosyringe_beg", clk_putneedleontosyringe_beg, "inv_complex_bigsyringe" );
  cmn.AddSubscriber( "clk_putneedleontosyringe_end", clk_putneedleontosyringe_end, "inv_complex_bigsyringe" );
  --------------------------------------------------------------------------------------------
  -- function clk_dirtytorchopen () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_dirtytorchopen" ] = {
    type = "click",
    use_place = "obj_complex_dirtytorch_clk_dirtytorchopen",
    room = "int_complex_inv",
    zz = "inv_complex_dirtytorch",
    zz_gate = "inv_dirtytorch"
  };
  --------------------------------------------------------------------------------------------
  local clk_dirtytorchopen_beg = function ()
    
    ObjDelete( "obj_complex_dirtytorch_clk_dirtytorchopen" );
    
  end;
  local clk_dirtytorchopen_end = function ()

    ObjDelete( "anm_complex_dirtytorch_open" );
    
    ObjMultiSet( { {"anm_complex_dirtytorch_use_firestone", { alp = 1 }},
                   {"obj_complex_dirtytorch_use_sharpstonedirtytorch", { input = 1 }} } );

  end;
  cmn.AddSubscriber( "clk_dirtytorchopen", clk_dirtytorchopen_beg, "inv_complex_dirtytorch" );
  cmn.AddSubscriber( "clk_dirtytorchopen", clk_dirtytorchopen_end, "inv_complex_dirtytorch" );
  cmn.AddSubscriber( "clk_dirtytorchopen_beg", clk_dirtytorchopen_beg, "inv_complex_dirtytorch" );
  cmn.AddSubscriber( "clk_dirtytorchopen_end", clk_dirtytorchopen_end, "inv_complex_dirtytorch" );

end;
--*********************************************************************************************************************
-- function *** CLOSE FUNC *** () end;
--*********************************************************************************************************************
function public.inv_complex_bigsyringe_close()

  if cmn.IsEventDone( "clk_putneedleontosyringe" ) and not cmn.IsEventDone( "get_syringewithneedle" ) then
    cmn.SetEventDone( "get_syringewithneedle" );
    cmn.CallEventHandler( "get_syringewithneedle", "inv_complex_bigsyringe" );
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  end;

end;
--------------------------------------------------------------------------------------------
function public.inv_complex_brokenalarmclock_close()

  if not cmn.IsEventDone( "get_lvl4clockhands" ) or not cmn.IsEventDone( "get_lvl4bolt1" ) then

    if ( not cmn.IsEventDone( "get_lvl4clockhands" ) ) then
      cmn.SetEventDone( "get_lvl4clockhands" );
      cmn.CallEventHandler( "get_lvl4clockhands", "inv_complex_brokenalarmclock" );
    end;

    if ( not cmn.IsEventDone( "get_lvl4bolt1" ) ) then
      cmn.SetEventDone( "get_lvl4bolt1" );
      cmn.CallEventHandler( "get_lvl4bolt1", "inv_complex_brokenalarmclock" );
    end;

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;

end;
--------------------------------------------------------------------------------------------
function public.inv_complex_brokendogcase_close()

  if cmn.IsEventDone( "use_dogname" ) and cmn.IsEventDone("use_longrod") and cmn.IsEventDone("use_sophiaspullover") 
  and cmn.IsEventDone( "use_bone" ) and cmn.IsEventDone("use_wrenchdogcase") and not cmn.IsEventDone( "get_dogcage" ) then
    cmn.SetEventDone( "get_dogcage" );
    cmn.CallEventHandler( "get_dogcage", "inv_complex_brokendogcase" );
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  end;

end;
--------------------------------------------------------------------------------------------
function public.inv_complex_brokenfigurine_close()

  if  cmn.IsEventDone( "use_lvl4wings" ) and cmn.IsEventDone( "use_horns" )
  and cmn.IsEventDone( "use_clawedpaw" ) and not cmn.IsEventDone( "get_devilfigurine" ) then
    cmn.SetEventDone( "get_devilfigurine" );
    cmn.CallEventHandler( "get_devilfigurine", "inv_complex_brokenfigurine" );
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  end;

end;
--------------------------------------------------------------------------------------------
function public.inv_complex_burntnewspaper_close()

  if cmn.IsEventDone( "win_burntnewspaper" ) and not cmn.IsEventDone( "get_dogname" ) then
    
    ObjSet("obj_complex_burntnewspaper_dogname",  { alp = 1 });
    
    cmn.SetEventDone( "get_dogname" );
    cmn.CallEventHandler( "get_dogname", "inv_complex_burntnewspaper" );
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
    
  end;
  
  if cmn.IsEventDone("use_newspaperpiece") and cmn.IsEventDone("use_tape") and not cmn.IsEventDone("win_burntnewspaper") then
    cmn.MiniGameHide("burntnewspaper");
  end;

end;
--------------------------------------------------------------------------------------------
function public.inv_complex_dirtytorch_close()

  if cmn.IsEventDone( "use_sharpstonedirtytorch" ) and cmn.IsEventDone( "use_firestone" ) and not cmn.IsEventDone( "get_lvl4torch" ) then
    cmn.SetEventDone( "get_lvl4torch" );
    cmn.CallEventHandler( "get_lvl4torch", "inv_complex_dirtytorch" );
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  end;

end;
--------------------------------------------------------------------------------------------
function public.inv_complex_keybunch_close()

  if cmn.IsEventDone( "win_keybunch" ) and not cmn.IsEventDone( "get_cagekey" ) then
    cmn.SetEventDone( "get_cagekey" );
    cmn.CallEventHandler( "get_cagekey", "inv_complex_keybunch" );
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  end;

end;
--------------------------------------------------------------------------------------------
function public.inv_complex_keyholder_close()

  if cmn.IsEventDone( "use_shellpart" ) and ( not cmn.IsEventDone( "get_homekeys" ) or not cmn.IsEventDone( "get_nursekeys" ) ) then

    if ( not cmn.IsEventDone( "get_homekeys" ) ) then
      cmn.SetEventDone( "get_homekeys" );
      cmn.CallEventHandler( "get_homekeys", "inv_complex_keyholder" );
    end;

    if ( not cmn.IsEventDone( "get_nursekeys" ) ) then
      cmn.SetEventDone( "get_nursekeys" );
      cmn.CallEventHandler( "get_nursekeys", "inv_complex_keyholder" );
    end;

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;

end;
--------------------------------------------------------------------------------------------
function public.inv_complex_pictureinframe_close()

  if not cmn.IsEventDone( "get_charitypicture" ) or not cmn.IsEventDone( "get_lvl4button" ) then

    if ( not cmn.IsEventDone( "get_charitypicture" ) ) then
      cmn.SetEventDone( "get_charitypicture" );
      cmn.CallEventHandler( "get_charitypicture", "inv_complex_pictureinframe" );
      interface_impl.CompleteClues( {1} );
      interface_impl.ShowGlobalTask();
    end;

    if ( not cmn.IsEventDone( "get_lvl4button" ) ) then
      cmn.SetEventDone( "get_lvl4button" );
      cmn.CallEventHandler( "get_lvl4button", "inv_complex_pictureinframe" );
    end;

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;

end;
--------------------------------------------------------------------------------------------
function public.inv_complex_ship_close()

  if  cmn.IsEventDone( "use_sails" )      and cmn.IsEventDone( "use_fishingline" )
  and cmn.IsEventDone( "use_figurehead" ) and not cmn.IsEventDone( "get_shipmodel" ) then

    cmn.SetEventDone( "get_shipmodel" );
    cmn.CallEventHandler( "get_shipmodel", "inv_complex_ship" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;

end;
--------------------------------------------------------------------------------------------
function public.inv_complex_thickwire_close()

  if cmn.IsEventDone( "use_pliers" ) and not cmn.IsEventDone( "get_selfmadepen" ) then
    
    ObjSet( "spr_complex_thickwire_selfmadepen_fly", { alp = 1 } );
    
    cmn.SetEventDone( "get_selfmadepen" );
    cmn.CallEventHandler( "get_selfmadepen", "inv_complex_thickwire" );
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
    
  end;

end;
--------------------------------------------------------------------------------------------
function public.inv_complex_tornoffpatch_close()

  if cmn.IsEventDone( "win_tornoffpatch" ) and not cmn.IsEventDone( "get_volunteersign" ) then
    
    cmn.SetEventDone( "get_volunteersign" );
    cmn.CallEventHandler( "get_volunteersign", "inv_complex_tornoffpatch" );
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
    
  end;
  
  if cmn.IsEventDone("use_yellowthread") and cmn.IsEventDone("use_needle") and not cmn.IsEventDone("win_tornoffpatch") then
    cmn.MiniGameHide("tornoffpatch");
  end;

end;
--------------------------------------------------------------------------------------------
function public.inv_complex_travelersbag_close()

  if cmn.IsEventDone( "use_sharpstonetravelersbag" ) and not cmn.IsEventDone( "get_sculptorsset" ) then
    cmn.SetEventDone( "get_sculptorsset" );
    cmn.CallEventHandler( "get_sculptorsset", "inv_complex_travelersbag" );
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
function public.use_sharpstone()

  local item = "inv_sharpstone";

  if cmn.ObjIntersectCheck( item, "obj_complex_travelersbag_use_sharpstonetravelersbag" ) then

    cmn.CallEventHandler( "use_sharpstonetravelersbag_inv", "inv_complex_travelersbag" );
    cmn.CallEventHandler( "use_sharpstonetravelersbag_beg", "inv_complex_travelersbag" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_sharpstonetravelersbag" );
      cmn.CallEventHandler( "use_sharpstonetravelersbag_end", "inv_complex_travelersbag" );
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_travelersbag/audio/aud_tear_cloth");

    ObjSet("anm_complex_travelersbag_use_stone",  { alp = 1, playing = 1, endtrig = func_after });

  elseif cmn.ObjIntersectCheck( item, "obj_complex_dirtytorch_use_sharpstonedirtytorch" ) and cmn.IsEventDone( "use_firestone" ) then

    cmn.CallEventHandler( "use_sharpstonedirtytorch_inv", "inv_complex_dirtytorch" );

    if cmn.IsEventDone("clk_dirtytorchopen") then
      private.use_sharpstone_end();
    else 
      public.clk_dirtytorchopen( 3 );
    end;
    
  elseif cmn.ObjIntersectCheck( item, "obj_complex_dirtytorch_use_sharpstonedirtytorch" ) and not cmn.IsEventDone( "use_firestone" ) then
    
    cmn.CallEventHandler( "use_sharpstonedirtytorch_inv", "inv_complex_dirtytorch" );
    private.use_sharpstone_end();

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function private.use_sharpstone_end()
  
  cmn.CallEventHandler( "use_sharpstonedirtytorch_beg", "inv_complex_dirtytorch" );

  local func_after = function ()

    cmn.Lock( 0 );

    cmn.SetEventDone( "use_sharpstonedirtytorch" );
    cmn.CallEventHandler( "use_sharpstonedirtytorch_end", "inv_complex_dirtytorch" );
    
  end;
  
  local anm_fire = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_dirtytorch/audio/aud_use_flint");
    
    ObjAnimate("gfx_complex_dirtytorch_lvl4torch", "alp", 0, 0, "", { 0, 0, 0,   1.8, 0, 0,   2, 0, 1 });
    ObjAnimate("fx_complex_dirtytorch_fire", "alp", 0, 0, "", { 0, 0, 0,   1.8, 0, 0,   2, 0, 1 });
    ObjSet("anm_complex_dirtytorch_use_firestone",  { alp = 1, playing = 1, endtrig = func_after });
    
  end;

  cmn.Lock( 1 );

  if cmn.IsEventDone("use_firestone") then
    ObjAnimate("obj_complex_dirtytorch_tools", "alp", 0, 0, anm_fire, { 0, 0, 1,   0.3, 0, 0 });
  else 
    cmn.PlayAudio("snd", "assets/levels/level3/ho_onbasrelief/audio/aud_xx_use_stone3");
    ObjAnimate("spr_complex_dirtytorch_sharpstone", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.use_firestone()

  local item = "inv_firestone";

  if cmn.ObjIntersectCheck( item, "obj_complex_dirtytorch_use_firestone" ) and cmn.IsEventDone( "use_sharpstonedirtytorch" ) then

    cmn.CallEventHandler( "use_firestone_inv", "inv_complex_dirtytorch" );
    
    if cmn.IsEventDone("clk_dirtytorchopen") then
      private.use_firestone_end();
    else 
      public.clk_dirtytorchopen( 2 );
    end;
    
  elseif cmn.ObjIntersectCheck( item, "obj_complex_dirtytorch_use_firestone" ) and not cmn.IsEventDone( "use_sharpstonedirtytorch" ) then
    
    cmn.CallEventHandler( "use_firestone_inv", "inv_complex_dirtytorch" );
    private.use_firestone_end();

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function private.use_firestone_end()
  
  cmn.CallEventHandler( "use_firestone_beg", "inv_complex_dirtytorch" );

  local func_after = function ()

    cmn.Lock( 0 );

    cmn.SetEventDone( "use_firestone" );
    cmn.CallEventHandler( "use_firestone_end", "inv_complex_dirtytorch" );
    
  end;
  
  local anm_fire = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_dirtytorch/audio/aud_use_flint");
    
    ObjAnimate("fx_complex_dirtytorch_fire", "alp", 0, 0, "", { 0, 0, 0,   1.8, 0, 0,   2, 0, 1 });
    ObjAnimate("gfx_complex_dirtytorch_lvl4torch", "alp", 0, 0, "", { 0, 0, 0,   1.8, 0, 0,   2, 0, 1 });
    ObjSet("anm_complex_dirtytorch_use_firestone",  { alp = 1, playing = 1, endtrig = func_after });
    
  end;

  cmn.Lock( 1 );

  if cmn.IsEventDone("use_sharpstonedirtytorch") then
    ObjAnimate("obj_complex_dirtytorch_tools", "alp", 0, 0, anm_fire, { 0, 0, 1,   0.3, 0, 0 });
  else 
    cmn.PlayAudio("snd", "assets/levels/level3/ho_onbasrelief/audio/aud_xx_use_stone3");
    ObjAnimate("spr_complex_dirtytorch_firestone", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.use_yellowthread()

  local item = "inv_yellowthread";

  if cmn.ObjIntersectCheck( item, "obj_complex_tornoffpatch_use_yellowthread" ) then

    cmn.CallEventHandler( "use_yellowthread_inv", "inv_complex_tornoffpatch" );
    cmn.CallEventHandler( "use_yellowthread_beg", "inv_complex_tornoffpatch" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_yellowthread" );
      cmn.CallEventHandler( "use_yellowthread_end", "inv_complex_tornoffpatch" );
      
      if cmn.IsEventDone("use_needle") then
        cmn.MiniGameShow('tornoffpatch');
      end;
      
    end;
    
    local anm_game = function ()
      
      ObjAnimate("obj_complex_tornoffpatch_game", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");

    if cmn.IsEventDone("use_needle") then
      ObjAnimate("spr_complex_tornoffpatch_needle", "alp", 0, 0, anm_game, { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_complex_tornoffpatch_needle_bl", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_complex_tornoffpatch_thread", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_complex_tornoffpatch_needle_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    else 
      ObjAnimate("spr_complex_tornoffpatch_thread", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    end;

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_needle()

  local item = "inv_needle";

  if cmn.ObjIntersectCheck( item, "obj_complex_tornoffpatch_use_needle" ) then

    cmn.CallEventHandler( "use_needle_inv", "inv_complex_tornoffpatch" );
    cmn.CallEventHandler( "use_needle_beg", "inv_complex_tornoffpatch" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_needle" );
      cmn.CallEventHandler( "use_needle_end", "inv_complex_tornoffpatch" );
      
      if cmn.IsEventDone("use_yellowthread") then
        cmn.MiniGameShow('tornoffpatch');
      end;
      
    end;
    
    local anm_game = function ()
      
      ObjAnimate("obj_complex_tornoffpatch_game", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");

    if cmn.IsEventDone("use_yellowthread") then
      ObjAnimate("spr_complex_tornoffpatch_needle", "alp", 0, 0, anm_game, { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_complex_tornoffpatch_needle_bl", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    else 
      ObjAnimate("spr_complex_tornoffpatch_needle_1", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    end;

  else
    
    cmn.WrongApply();

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pliers()

  local item = "inv_pliers";

  if cmn.ObjIntersectCheck( item, "obj_complex_thickwire_use_pliers" ) then

    cmn.CallEventHandler( "use_pliers_inv", "inv_complex_thickwire" );
    cmn.CallEventHandler( "use_pliers_beg", "inv_complex_thickwire" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pliers" );
      cmn.CallEventHandler( "use_pliers_end", "inv_complex_thickwire" );
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_thickwire/audio/aud_use_pliers4");

    ObjSet("anm_complex_thickwire_use_pliers",  { alp = 1, playing = 1, endtrig = func_after });

  else
    
    cmn.WrongApply();

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_shellpart()

  local item = "inv_shellpart";

  if cmn.ObjIntersectCheck( item, "obj_complex_keyholder_use_shellpart" ) and cmn.CheckMultiObject( "shellpart", 3 ) then

    cmn.CallEventHandler( "use_shellpart_inv", "inv_complex_keyholder" );
    cmn.CallEventHandler( "use_shellpart_beg", "inv_complex_keyholder" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_shellpart" );
      cmn.CallEventHandler( "use_shellpart_end", "inv_complex_keyholder" );
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_keyholder/audio/aud_opn_wallet4");

    ObjSet( "anm_complex_keyholder_keyholder", { animfunc = "func_use_shells", endtrig = func_after, playing = true } );

  else
    
    cmn.WrongApply();

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl4wings()

  local item = "inv_lvl4wings";

  if cmn.ObjIntersectCheck( item, "obj_complex_brokenfigurine_use_lvl4wings" ) then

    cmn.CallEventHandler( "use_lvl4wings_inv", "inv_complex_brokenfigurine" );
    cmn.CallEventHandler( "use_lvl4wings_beg", "inv_complex_brokenfigurine" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl4wings" );
      cmn.CallEventHandler( "use_lvl4wings_end", "inv_complex_brokenfigurine" );
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_brokenfigurine/audio/aud_use_parts_gargoyle");

    ObjAnimate( "obj_complex_brokenfigurine_wing",  "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else
    
    cmn.WrongApply();

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_horns()

  local item = "inv_horns";

  if cmn.ObjIntersectCheck( item, "obj_complex_brokenfigurine_use_horns" ) then

    cmn.CallEventHandler( "use_horns_inv", "inv_complex_brokenfigurine" );
    cmn.CallEventHandler( "use_horns_beg", "inv_complex_brokenfigurine" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_horns" );
      cmn.CallEventHandler( "use_horns_end", "inv_complex_brokenfigurine" );
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_brokenfigurine/audio/aud_use_parts_gargoyle");

    ObjAnimate( "obj_complex_brokenfigurine_horns",  "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else
    
    cmn.WrongApply();

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_clawedpaw()

  local item = "inv_clawedpaw";

  if cmn.ObjIntersectCheck( item, "obj_complex_brokenfigurine_use_clawedpaw" ) then

    cmn.CallEventHandler( "use_clawedpaw_inv", "inv_complex_brokenfigurine" );
    cmn.CallEventHandler( "use_clawedpaw_beg", "inv_complex_brokenfigurine" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_clawedpaw" );
      cmn.CallEventHandler( "use_clawedpaw_end", "inv_complex_brokenfigurine" );
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_brokenfigurine/audio/aud_use_parts_gargoyle");

    ObjAnimate( "obj_complex_brokenfigurine_paw",  "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else
    
    cmn.WrongApply();

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_sails()

  local item = "inv_sails";

  if cmn.ObjIntersectCheck( item, "obj_complex_ship_use_sails" ) then

    cmn.CallEventHandler( "use_sails_inv", "inv_complex_ship" );
    cmn.CallEventHandler( "use_sails_beg", "inv_complex_ship" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_sails" );
      cmn.CallEventHandler( "use_sails_end", "inv_complex_ship" );
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_slippers");

    ObjAnimate( "spr_complex_ship_sails_slot",  "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "obj_complex_ship_sails",  "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else
    
    cmn.WrongApply();

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fishingline()

  local item = "inv_fishingline";

  if cmn.ObjIntersectCheck( item, "obj_complex_ship_use_fishingline" ) then

    cmn.CallEventHandler( "use_fishingline_inv", "inv_complex_ship" );
    cmn.CallEventHandler( "use_fishingline_beg", "inv_complex_ship" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_fishingline" );
      cmn.CallEventHandler( "use_fishingline_end", "inv_complex_ship" );
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_slippers");

    ObjAnimate( "spr_complex_ship_fishingline_slot",  "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "spr_complex_ship_fishingline",  "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else
    
    cmn.WrongApply();

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_figurehead()

  local item = "inv_figurehead";

  if cmn.ObjIntersectCheck( item, "obj_complex_ship_use_figurehead" ) then

    cmn.CallEventHandler( "use_figurehead_inv", "inv_complex_ship" );
    cmn.CallEventHandler( "use_figurehead_beg", "inv_complex_ship" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_figurehead" );
      cmn.CallEventHandler( "use_figurehead_end", "inv_complex_ship" );
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_slippers");

    ObjAnimate( "spr_complex_ship_figurehead_slot",  "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "spr_complex_ship_figurehead",  "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else
    
    cmn.WrongApply();

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_newspaperpiece()

  local item = "inv_newspaperpiece";

  if cmn.ObjIntersectCheck( item, "obj_complex_burntnewspaper_use_newspaperpiece" ) and cmn.CheckMultiObject( "newspaperpiece", 4 ) then

    cmn.CallEventHandler( "use_newspaperpiece_inv", "inv_complex_burntnewspaper" );
    cmn.CallEventHandler( "use_newspaperpiece_beg", "inv_complex_burntnewspaper" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_newspaperpiece" );
      cmn.CallEventHandler( "use_newspaperpiece_end", "inv_complex_burntnewspaper" );
      
      if cmn.IsEventDone("use_tape") then
        cmn.MiniGameShow('burntnewspaper');
      end;
      
    end;
    
    local anm_start = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_burntnewspaper/audio/aud_clk_tape");
      
      ObjMultiSet( { {"anm_complex_burntnewspaper_tape_open",  { playing = 1, endtrig = func_after }},
                     {"obj_complex_burntnewspaper_tape_crop", { alp = 1 }} } );
      
    end;

    cmn.Lock( 1 );

    if cmn.IsEventDone("use_tape") then
      --ObjAnimate( "obj_complex_burntnewspaper_pieces", "alp", 0, 0, anm_start, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 0 } );
      anm_start();
    else
      cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_clk_paper2");
      ObjAnimate( "obj_complex_burntnewspaper_pieces", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else
    
    cmn.WrongApply();

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_tape()

  local item = "inv_tape";

  if cmn.ObjIntersectCheck( item, "obj_complex_burntnewspaper_use_tape" ) then

    cmn.CallEventHandler( "use_tape_inv", "inv_complex_burntnewspaper" );
    cmn.CallEventHandler( "use_tape_beg", "inv_complex_burntnewspaper" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_tape" );
      cmn.CallEventHandler( "use_tape_end", "inv_complex_burntnewspaper" );
      
      if cmn.IsEventDone("use_newspaperpiece") then
        cmn.MiniGameShow('burntnewspaper');
      end;
      
    end;
    
    local anm_start = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_burntnewspaper/audio/aud_clk_tape");
      
      ObjMultiSet( { {"anm_complex_burntnewspaper_tape_open",  { playing = 1, endtrig = func_after }},
                     {"obj_complex_burntnewspaper_tape_crop", { alp = 1 }} } );
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level3/mg_darkroom/audio/aud_snowball1");

    if cmn.IsEventDone("use_newspaperpiece") then
      ObjAnimate( "spr_complex_burntnewspaper_tape", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "obj_complex_burntnewspaper_pieces", "alp", 0, 0, anm_start, { 0, 0, 1,    0.3, 0, 1,    0.6, 0, 0 } );
    else
      ObjAnimate( "spr_complex_burntnewspaper_tape", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else
    
    cmn.WrongApply();

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_longrod()

  local item = "inv_longrod";

  if cmn.ObjIntersectCheck( item, "obj_complex_brokendogcase_use_longrod" ) then

    cmn.CallEventHandler( "use_longrod_inv", "inv_complex_brokendogcase" );
    cmn.CallEventHandler( "use_longrod_beg", "inv_complex_brokendogcase" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_longrod" );
      cmn.CallEventHandler( "use_longrod_end", "inv_complex_brokendogcase" );
      
    end;
    
    local anm_bolts = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_brokendogcase/audio/aud_use_nut4");
      
      ObjAnimate( "spr_complex_brokendogcase_bolt_1_1", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "spr_complex_brokendogcase_bolt_2_1", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
      
      ObjAnimate( "obj_complex_brokendogcase_bolts_1", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
      
    end;
    
    local anm_door = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_brokendogcase/audio/aud_use_stick2");
      
      ObjAnimate("spr_complex_brokendogcase_door_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
      if cmn.IsEventDone("use_lvl4bolt") then
        ObjAnimate("anm_complex_brokendogcase_use_wrench", "alp", 0, 0, anm_bolts, { 0, 0, 0,   0.5, 0, 1 });
      else 
        ObjAnimate("anm_complex_brokendogcase_use_wrench", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      end;
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_brokendogcase/audio/aud_use_stick");

    if cmn.IsEventDone("use_sophiaspullover") and cmn.IsEventDone("use_bone") then
      ObjAnimate( "spr_complex_brokendogcase_rod_1", "alp", 0, 0, anm_door, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );
    else
      ObjAnimate( "spr_complex_brokendogcase_rod_1", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;
    
  else
    
    cmn.WrongApply();

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl4bolt()

  local item = "inv_lvl4bolt";

  if  cmn.ObjIntersectCheck( item, "obj_complex_brokendogcase_use_lvl4bolt" )
  and cmn.CheckMultiObject( "lvl4bolt", 2 ) then

    cmn.CallEventHandler( "use_lvl4bolt_inv", "inv_complex_brokendogcase" );
    cmn.CallEventHandler( "use_lvl4bolt_beg", "inv_complex_brokendogcase" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl4bolt" );
      cmn.CallEventHandler( "use_lvl4bolt_end", "inv_complex_brokendogcase" );
      
    end;

    cmn.Lock( 1 );

    if cmn.IsEventDone( "use_longrod" ) and cmn.IsEventDone("use_sophiaspullover") and cmn.IsEventDone("use_bone") then
      
      cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_brokendogcase/audio/aud_use_nut4");

      ObjAnimate( "spr_complex_brokendogcase_bolt_1_1", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "spr_complex_brokendogcase_bolt_2_1", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
      
    else 
      
      cmn.PlayAudio("snd", "assets/levels/level3/mg_darkroom/audio/aud_snowball1");
      ObjAnimate( "obj_complex_brokendogcase_bolts_1", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
      
    end;

  else
    
    cmn.WrongApply();

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_sophiaspullover()

  local item = "inv_sophiaspullover";

  if cmn.ObjIntersectCheck( item, "obj_complex_brokendogcase_use_sophiaspullover" ) then

    cmn.CallEventHandler( "use_sophiaspullover_inv", "inv_complex_brokendogcase" );
    cmn.CallEventHandler( "use_sophiaspullover_beg", "inv_complex_brokendogcase" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_sophiaspullover" );
      cmn.CallEventHandler( "use_sophiaspullover_end", "inv_complex_brokendogcase" );
      
    end;
    
    local anm_bolts = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_brokendogcase/audio/aud_use_nut4");
      
      ObjAnimate( "spr_complex_brokendogcase_bolt_1_1", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "spr_complex_brokendogcase_bolt_2_1", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
      
      ObjAnimate( "obj_complex_brokendogcase_bolts_1", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
      
    end;
    
    local anm_door = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_brokendogcase/audio/aud_use_stick2");
      
      ObjAnimate("spr_complex_brokendogcase_door_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
      if cmn.IsEventDone("use_lvl4bolt") then
        ObjAnimate("anm_complex_brokendogcase_use_wrench", "alp", 0, 0, anm_bolts, { 0, 0, 0,   0.5, 0, 1 });
      else 
        ObjAnimate("anm_complex_brokendogcase_use_wrench", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      end;
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_purse/audio/aud_xx_clk_cloth");

    if cmn.IsEventDone("use_longrod") and cmn.IsEventDone("use_bone") then
      ObjAnimate( "spr_complex_brokendogcase_clothes", "alp", 0, 0, anm_door, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );
    else
      ObjAnimate( "spr_complex_brokendogcase_clothes", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else
    
    cmn.WrongApply();

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bone()

  local item = "inv_bone";

  if cmn.ObjIntersectCheck( item, "obj_complex_brokendogcase_use_bone" ) then

    cmn.CallEventHandler( "use_bone_inv", "inv_complex_brokendogcase" );
    cmn.CallEventHandler( "use_bone_beg", "inv_complex_brokendogcase" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_bone" );
      cmn.CallEventHandler( "use_bone_end", "inv_complex_brokendogcase" );
      
    end;
    
    local anm_bolts = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_brokendogcase/audio/aud_use_nut4");
      
      ObjAnimate( "spr_complex_brokendogcase_bolt_1_1", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "spr_complex_brokendogcase_bolt_2_1", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
      
      ObjAnimate( "obj_complex_brokendogcase_bolts_1", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
      
    end;
    
    local anm_door = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_brokendogcase/audio/aud_use_stick2");
      
      ObjAnimate("spr_complex_brokendogcase_door_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
      if cmn.IsEventDone("use_lvl4bolt") then
        ObjAnimate("anm_complex_brokendogcase_use_wrench", "alp", 0, 0, anm_bolts, { 0, 0, 0,   0.5, 0, 1 });
      else 
        ObjAnimate("anm_complex_brokendogcase_use_wrench", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      end;
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level3/mg_darkroom/audio/aud_snowball1");

    if cmn.IsEventDone("use_longrod") and cmn.IsEventDone("use_sophiaspullover") then
      ObjAnimate( "obj_complex_brokendogcase_bone", "alp", 0, 0, anm_door, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );
    else
      ObjAnimate( "obj_complex_brokendogcase_bone", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else
    
    cmn.WrongApply();

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_dogname()

  local item = "inv_dogname";

  if cmn.ObjIntersectCheck( item, "obj_complex_brokendogcase_use_dogname" ) then

    cmn.CallEventHandler( "use_dogname_inv", "inv_complex_brokendogcase" );
    cmn.CallEventHandler( "use_dogname_beg", "inv_complex_brokendogcase" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_dogname" );
      cmn.CallEventHandler( "use_dogname_end", "inv_complex_brokendogcase" );
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_use_small_paper");

    ObjAnimate( "spr_complex_brokendogcase_name", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    ObjAnimate( "spr_complex_brokendogcase_name_1", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

  else
    
    cmn.WrongApply();

  end;

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function public.get_sculptorsset()
  
  cmn.SetEventDone( "get_sculptorsset" );
  cmn.CallEventHandler( "get_sculptorsset", "inv_complex_travelersbag" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_lvl4torch()
  
  cmn.SetEventDone( "get_lvl4torch" );
  cmn.CallEventHandler( "get_lvl4torch", "inv_complex_dirtytorch" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_cagekey()
  
  cmn.SetEventDone( "get_cagekey" );
  cmn.CallEventHandler( "get_cagekey", "inv_complex_keybunch" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_charitypicture()
  
  cmn.SetEventDone( "get_charitypicture" );
  cmn.CallEventHandler( "get_charitypicture_inv", "inv_complex_pictureinframe" );
  
  cmn.SetEventDone( "get_lvl4button" );
  cmn.CallEventHandler( "get_lvl4button", "inv_complex_pictureinframe" );
  
  interface_impl.CompleteClues( {1} );
  interface_impl.ShowGlobalTask();
  
  int_map_impl.AddDiarypage( 13 );
  
  cmn.ShowBbt( "complex_pictureinframe_after_get_photo" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  --if ( cmn.IsEventDone( "get_lvl4button" ) ) then
    common_impl.HideComplexItem();
  --end;

end;
--------------------------------------------------------------------------------------------
function public.get_lvl4button()
  
  cmn.SetEventDone( "get_charitypicture" );
  cmn.CallEventHandler( "get_charitypicture_inv", "inv_complex_pictureinframe" );
  
  cmn.SetEventDone( "get_lvl4button" );
  cmn.CallEventHandler( "get_lvl4button", "inv_complex_pictureinframe" );
  
  interface_impl.CompleteClues( {1} );
  interface_impl.ShowGlobalTask();

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  --if ( cmn.IsEventDone( "get_charitypicture" ) ) then
    common_impl.HideComplexItem();
  --end;

end;
--------------------------------------------------------------------------------------------
function public.get_syringewithneedle()
  
  cmn.SetEventDone( "get_syringewithneedle" );
  cmn.CallEventHandler( "get_syringewithneedle", "inv_complex_bigsyringe" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_volunteersign()
  
  cmn.SetEventDone( "get_volunteersign" );
  cmn.CallEventHandler( "get_volunteersign", "inv_complex_tornoffpatch" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_selfmadepen()
  
  ObjSet( "spr_complex_thickwire_selfmadepen_fly", { alp = 1 } );
  
  cmn.SetEventDone( "get_selfmadepen" );
  cmn.CallEventHandler( "get_selfmadepen", "inv_complex_thickwire" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_homekeys()
  
  cmn.SetEventDone( "get_homekeys" );
  cmn.CallEventHandler( "get_homekeys", "inv_complex_keyholder" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if ( cmn.IsEventDone( "get_nursekeys" ) ) then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_nursekeys()
  
  ObjSet("spr_complex_keyholder_nursekeys",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });
  
  cmn.SetEventDone( "get_nursekeys" );
  cmn.CallEventHandler( "get_nursekeys", "inv_complex_keyholder" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if ( cmn.IsEventDone( "get_homekeys" ) ) then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_devilfigurine()
  
  cmn.SetEventDone( "get_devilfigurine" );
  cmn.CallEventHandler( "get_devilfigurine", "inv_complex_brokenfigurine" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_shipmodel()
  
  cmn.SetEventDone( "get_shipmodel" );
  cmn.CallEventHandler( "get_shipmodel", "inv_complex_ship" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_lvl4clockhands()

  ObjMultiSet( { { "spr_complex_brokenalarmclock_hour_arrow1", { ang = -0.7478 } },
                 { "spr_complex_brokenalarmclock_lvl4clockhands", { ang = -0.6981 } } } );
  
  cmn.SetEventDone( "get_lvl4clockhands" );
  cmn.CallEventHandler( "get_lvl4clockhands", "inv_complex_brokenalarmclock" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if ( cmn.IsEventDone( "get_lvl4bolt1" ) ) then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_lvl4bolt1()
  
  cmn.SetEventDone( "get_lvl4bolt1" );
  cmn.CallEventHandler( "get_lvl4bolt1", "inv_complex_brokenalarmclock" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if ( cmn.IsEventDone( "get_lvl4clockhands" ) ) then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_dogname()
  
  ObjSet("obj_complex_burntnewspaper_dogname",  { alp = 1 });
  
  cmn.SetEventDone( "get_dogname" );
  cmn.CallEventHandler( "get_dogname", "inv_complex_burntnewspaper" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_dogcage()
  
  cmn.SetEventDone( "get_dogcage" );
  cmn.CallEventHandler( "get_dogcage", "inv_complex_brokendogcase" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_openpackage()

  cmn.Lock(1);
  cmn.CallEventHandler( "clk_openpackage_beg", "inv_complex_bigsyringe" );

  local func_after = function ()

    cmn.SetEventDone( "clk_openpackage" );
    cmn.CallEventHandler( "clk_openpackage_end", "inv_complex_bigsyringe" );

    cmn.Lock(0);

  end;
  
  cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_bigsyringe/audio/aud_clk_pack");

  ObjSet( "anm_complex_bigsyringe_bigsyringe_opn", { endtrig = func_after, playing = true } );

end;
--------------------------------------------------------------------------------------------
function public.clk_removeneedlecover()

  cmn.Lock(1);
  cmn.CallEventHandler( "clk_removeneedlecover_beg", "inv_complex_bigsyringe" );

  local func_after = function ()

    cmn.SetEventDone( "clk_removeneedlecover" );
    cmn.CallEventHandler( "clk_removeneedlecover_end", "inv_complex_bigsyringe" );

    cmn.Lock(0);

  end;
  
  cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_bigsyringe/audio/aud_clk_needle");

  ObjAnimate( "anm_complex_bigsyringe_syringewithneedle", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
  ObjAnimate( "spr_complex_bigsyringe_capneedle", "alp", 0, 0, func_after, { 0, 0, 1,    0.3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function public.clk_putneedleontosyringe()

  cmn.Lock(1);
  cmn.CallEventHandler( "clk_putneedleontosyringe_beg", "inv_complex_bigsyringe" );

  local func_after = function ()

    cmn.SetEventDone( "clk_putneedleontosyringe" );
    cmn.CallEventHandler( "clk_putneedleontosyringe_end", "inv_complex_bigsyringe" );

    cmn.Lock(0);

  end;
  
  cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_bigsyringe/audio/aud_clk_needle2");

  ObjSet( "anm_complex_bigsyringe_syringewithneedle", { endtrig = func_after, playing = true } );

end;
--------------------------------------------------------------------------------------------
function public.clk_dirtytorchopen( num )

  cmn.Lock(1);
  cmn.CallEventHandler( "clk_dirtytorchopen_beg", "inv_complex_dirtytorch" );

  local func_after = function ()

    cmn.SetEventDone( "clk_dirtytorchopen" );
    cmn.CallEventHandler( "clk_dirtytorchopen_end", "inv_complex_dirtytorch" );

    if num == 1 then
      cmn.Lock(0);
    elseif num == 2 then
      private.use_firestone_end();
    else 
      private.use_sharpstone_end();
    end;

  end;
  
  cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_dirtytorch/audio/aud_opn_lamp");

  ObjSet("anm_complex_dirtytorch_open",  { playing = 1, endtrig = func_after });

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.opn_burntnewspaper()
  
  --for mmg
  if not( ng_global.progress[ "ext" ][ "win_burntnewspaper" ].state ) then
    private.complex_burntnewspaper.StartConditions();
  end;
  private.complex_burntnewspaper.state = ng_global.progress[ "ext" ][ "win_burntnewspaper" ].state;
  
  private.complex_burntnewspaper.DrawScene();

  if cmn.IsEventDone("use_newspaperpiece") and cmn.IsEventDone("use_tape") and not cmn.IsEventDone("win_burntnewspaper") then
    cmn.MiniGameShow('burntnewspaper');
    private.complex_burntnewspaper.CheckWin();
  end;
  
  common_impl.ShowComplexItem( 'burntnewspaper' );

end;
--------------------------------------------------------------------------------------------
function public.opn_tornoffpatch()
  
  --for mmg
  if not( ng_global.progress[ "ext" ][ "win_tornoffpatch" ].state ) then
    private.complex_tornoffpatch.StartConditions();
  end;
  private.complex_tornoffpatch.state = ng_global.progress[ "ext" ][ "win_tornoffpatch" ].state;
  
  private.complex_tornoffpatch.DrawScene();

  if cmn.IsEventDone("use_yellowthread") and cmn.IsEventDone("use_needle") and not cmn.IsEventDone("win_tornoffpatch") then
    cmn.MiniGameShow('tornoffpatch');
    private.complex_tornoffpatch.CheckWin();
  end;
  
  common_impl.ShowComplexItem( 'tornoffpatch' );

end;
--------------------------------------------------------------------------------------------
function public.check_brokendogcase_for_action( name )
  
  local items = {"longrod", "sophiaspullover", "bone", "dogname"};
  local vacant = false;
  
  for i = 1, 4, 1 do
    
    if name ~= items[i] and cmn.IsEventDone("get_"..items[i]) and not cmn.IsEventDone("use_"..items[i]) then
      vacant = true;
      break;
    end;
    
  end;
  
  return vacant;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_keyholder()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_complex_keyholder_use_shellpart" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_ingingerbreadhouse/audio/aud_xx_pick");
  
  ObjSet( "anm_complex_keyholder_keyholder", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_travelers_bag()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_complex_travelersbag_use_sharpstonetravelersbag" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_purse/audio/aud_xx_clk_cloth");
  
  ObjSet( "anm_complex_travelersbag_bag_touch", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_alarmclock()
  
  cmn.Lock(1);
  
  cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_brokenalarmclock/audio/aud_xx_clk_alarm");

  ObjSet( "obj_complex_brokenalarmclock_alarmclock", { alp = 0 } );
  
  ObjSet( "anm_complex_brokenalarmclock_alarmclock_touch", {
    alp = 1,
    playing = true,
    endtrig = function()
      ObjMultiSet( { { "obj_complex_brokenalarmclock_alarmclock", { alp = 1 } },
                     { "anm_complex_brokenalarmclock_alarmclock_touch", { alp = 0 } },
                     { "anm_complex_brokenalarmclock_bolt", { frame = 0 } },
                     { "anm_complex_brokenalarmclock_arrow", { frame = 0 } } } );
      cmn.Lock(0);
    end
  } );
  
end;
--*********************************************************************************************************************
-- function *** MMG_Keybunch *** () end;
--*********************************************************************************************************************
private.complex_keybunch = {};
public.complex_keybunch = {};

function private.Init_Keybunch()

  private.complex_keybunch.key_hint = { {1,3}, {2,9}, false, false, {5,7}, {6,8} };

  ---------------------------------------------------------------------------------
  game.hint[ "win_keybunch" ] = {
    type = "use",
    inv_obj = "spr_complex_keybunch_key_1",
    use_place = "spr_complex_keybunch_key_3",
    room = "int_complex_inv",
    zz = "inv_complex_keybunch",
    zz_gate = "inv_keybunch"
  };
  ---------------------------------------------------------------------------------
  local win_keybunch = function ()

    if cmn.IsEventDone( "win_keybunch" ) then

      ObjMultiSet( { 
        { "spr_complex_keybunch_key_4", { 
          event_mup = "inventory4.get_cagekey();",
          event_menter = "cmn.ShowCursor( CURSOR_GET );",
          event_mleave = "SetCursor( CURSOR_DEFAULT );"
        } },
        { "gfx_complex_keybunch_cagekey", { active = true } }
      } );

    end;

  end;

  ---------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_keybunch", win_keybunch, "inv_complex_keybunch" );

end;
-----------------------------------------------------------------------------------
function public.OpenKeybunch()

  --DbgTrace( "***OpenKeybunch" );

  if not ng_global.progress[ "ext" ][ "win_keybunch" ].state then
    ng_global.progress[ "ext" ][ "win_keybunch" ].state = {
      selected_key = { 0, 0 },
      keys = { true, true, true, true, true, true, true, true, true }
    };
  end;
  private.complex_keybunch.state = ng_global.progress[ "ext" ][ "win_keybunch" ].state;

  private.complex_keybunch.DrawScene();

  if ( not cmn.IsEventDone( "win_keybunch" ) ) then
    private.complex_keybunch.CheckWin();
  end;

  common_impl.ShowComplexItem( "keybunch" );

end;
-----------------------------------------------------------------------------------
function private.complex_keybunch.DrawScene()

  for i = 1, 9, 1 do
    if not private.complex_keybunch.state.keys[i] then
      ObjMultiSet( { { "spr_complex_keybunch_key_"..i, { alp = 0, input = false } },
                     { "spr_complex_keybunch_key_shadow_"..i,       { alp = 0 } },
                     { "spr_complex_keybunch_key_shadow_"..(i + 1), { alp = 0 } } } );
    end;
  end;

  if private.complex_keybunch.state.selected_key[1] ~= 0 then

    local selected_key_ind = private.complex_keybunch.state.selected_key[1];

    ObjMultiSet( { { "spr_complex_keybunch_key_"..selected_key_ind, { scale_x = 1.1, scale_y  = 1.1 } },
                   { "spr_complex_keybunch_key_select_"..selected_key_ind, { alp = 1 } },
                   { "spr_complex_keybunch_key_shadow_"..selected_key_ind,       { alp = 0 } },
                   { "spr_complex_keybunch_key_shadow_"..(selected_key_ind + 1), { alp = 0 } } } );
  end;

end;
-----------------------------------------------------------------------------------
function private.complex_keybunch.CheckWin()

  --DbgTrace( "***CheckWin" );

  cmn.Lock( 0 );

  local win_flag = true;

  for i = 1, 9, 1 do
    if private.complex_keybunch.state.keys[i] and i ~= 4 then

      game.hint[ "win_keybunch" ].inv_obj = "spr_complex_keybunch_key_"..private.complex_keybunch.key_hint[i][1];
      game.hint[ "win_keybunch" ].use_place = "spr_complex_keybunch_key_"..private.complex_keybunch.key_hint[i][2];

      return;

    end;
  end;

  --DbgTrace( "WWWWIIINNNN" );

  private.complex_keybunch.Win();

end;
-----------------------------------------------------------------------------------
function private.complex_keybunch.Win()

  cmn.SetEventDone( "win_keybunch" );
  cmn.CallEventHandler( "win_keybunch", "inv_complex_keybunch" );

end;
-----------------------------------------------------------------------------------
function public.Choosekey( ind, num )

  --DbgTrace( "***Choosekey" );

  cmn.Lock( 1 );

  local key_name = "spr_complex_keybunch_key_"..ind;

  if private.complex_keybunch.state.selected_key[1] ~= 0 then

    if private.complex_keybunch.state.selected_key[2] ~= num then

      --DbgTrace( "pair don't match" );
      cmn.PlayAudio("snd", "assets/levels/common/audio/aud_wrong_apply");

      local last_key_ind = private.complex_keybunch.state.selected_key[1];
      private.complex_keybunch.state.selected_key = { 0, 0 };

      if ( private.complex_keybunch.state.keys[last_key_ind - 1] ) then
        ObjAnimate( "spr_complex_keybunch_key_shadow_"..last_key_ind,       "alp", 0, 0, "", { 0, 0, 0,    0.55, 0, 0,    0.6, 0, 1 } );
      end;
      if ( private.complex_keybunch.state.keys[last_key_ind + 1] ) then
        ObjAnimate( "spr_complex_keybunch_key_shadow_"..(last_key_ind + 1), "alp", 0, 0, "", { 0, 0, 0,    0.55, 0, 0,    0.6, 0, 1 } );
      end;

      ObjAnimate( "spr_complex_keybunch_key_wrong_"..ind,          "alp", 0, 0, "", 
        { 0, 0, 0,    0.15, 0, 1,    0.3, 0, 0,    0.45, 0, 1,    0.6, 0, 0 } );
      ObjAnimate( "spr_complex_keybunch_key_wrong_"..last_key_ind, "alp", 0, 0, "", 
        { 0, 0, 0,    0.15, 0, 1,    0.3, 0, 0,    0.45, 0, 1,    0.6, 0, 0 } );

      ObjAnimate( "spr_complex_keybunch_key_"..last_key_ind, "scale_xy", 0, 0,
        function ()
          ObjAttach( "spr_complex_keybunch_key_"..last_key_ind, "obj_complex_keybunch_keys" );
          cmn.Lock( 0 );
        end,
        { 0, 0, 1.1, 1.1,    0.3, 0, 1.1, 1.1,    0.6, 0, 1, 1 }
      );

      public.FocusKey( last_key_ind, 0 );

    elseif private.complex_keybunch.state.selected_key[2] == num
    and    private.complex_keybunch.state.selected_key[1] ~= ind then

      --DbgTrace( "found right pair" );
      cmn.PlayAudio("snd", "assets/levels/common/audio/aud_clk_ho_sfx2");

      local last_key_ind = private.complex_keybunch.state.selected_key[1];

      private.complex_keybunch.state.keys[ind] = false;
      private.complex_keybunch.state.keys[last_key_ind] = false;
      private.complex_keybunch.state.selected_key = { 0, 0 };

      ObjMultiSet( { { key_name, { input = false } },
                     { "spr_complex_keybunch_key_"..last_key_ind, { input = false } } } );

      if ( private.complex_keybunch.state.keys[ind - 1] ) then
        ObjAnimate( "spr_complex_keybunch_key_shadow_"..ind,       "alp", 0, 0, "", { 0, 0, 1,    0.05, 0, 0 } );
      end;
      if ( private.complex_keybunch.state.keys[ind + 1] ) then
        ObjAnimate( "spr_complex_keybunch_key_shadow_"..(ind + 1), "alp", 0, 0, "", { 0, 0, 1,    0.05, 0, 0 } );
      end;

      ObjAttach( key_name, "obj_complex_keybunch_key_select" );
      ObjAnimate( key_name, "scale_xy", 0, 0, function () private.FounPairAnim( ind, last_key_ind ); end, { 0, 0, 1, 1,    0.3, 0, 1.1, 1.1 } );

      public.FocusKey( last_key_ind, 0 );

    elseif private.complex_keybunch.state.selected_key[2] == num
    and    private.complex_keybunch.state.selected_key[1] == ind then

      --DbgTrace( "cancel selection" );

      private.complex_keybunch.state.selected_key = { 0, 0 };

      if ( private.complex_keybunch.state.keys[ind - 1] ) then
        ObjAnimate( "spr_complex_keybunch_key_shadow_"..ind,       "alp", 0, 0, "", { 0, 0, 0,    0.25, 0, 0,    0.3, 0, 1 } );
      end;
      if ( private.complex_keybunch.state.keys[ind + 1] ) then
        ObjAnimate( "spr_complex_keybunch_key_shadow_"..(ind + 1), "alp", 0, 0, "", { 0, 0, 0,    0.25, 0, 0,    0.3, 0, 1 } );
      end;

      ObjAnimate( key_name, "scale_xy", 0, 0,
        function ()
          ObjAttach( key_name, "obj_complex_keybunch_keys" );
          cmn.Lock( 0 );
        end,
        { 0, 0, 1.1, 1.1,    0.3, 0, 1, 1 }
      );

    end;

  else

    --DbgTrace( "first selected" );
    private.complex_keybunch.state.selected_key = { ind, num };

    if ( private.complex_keybunch.state.keys[ind - 1] ) then
      ObjAnimate( "spr_complex_keybunch_key_shadow_"..ind,       "alp", 0, 0, "", { 0, 0, 1,    0.05, 0, 0 } );
    end;
    if ( private.complex_keybunch.state.keys[ind + 1] ) then
      ObjAnimate( "spr_complex_keybunch_key_shadow_"..(ind + 1), "alp", 0, 0, "", { 0, 0, 1,    0.05, 0, 0 } );
    end;

    ObjAttach( key_name, "obj_complex_keybunch_key_select" );
    ObjAnimate( key_name, "scale_xy", 0, 0, function () cmn.Lock( 0 ); end, { 0, 0, 1, 1,    0.3, 0, 1.1, 1.1 } );

  end;

end;
-----------------------------------------------------------------------------------
function private.FounPairAnim( ind1, ind2 )

  --DbgTrace( "***FounPairAnim "..ind1.." "..ind2 );

  local obj1 = "spr_complex_keybunch_key_"..ind1;
  local obj2 = "spr_complex_keybunch_key_"..ind2;

  local obj1_pos = { ObjGet( obj1 ).pos_x, ObjGet( obj1 ).pos_y };
  local obj2_pos = { ObjGet( obj2 ).pos_x, ObjGet( obj2 ).pos_y };
  local end_pos = common_impl.math.FindSegmentPoint( obj1_pos, obj2_pos, 1 );

  ObjAnimate(obj1, "pos_xy", 0, 0, "", {
    0,   0, obj1_pos[1], obj1_pos[2],
    0.5, 0, end_pos[1],  end_pos[2]
  } );

  ObjAnimate(obj2, "pos_xy", 0, 0, "", {
    0,   0, obj2_pos[1], obj2_pos[2],
    0.5, 0, end_pos[1],  end_pos[2]
  } );

  ObjAnimate(obj1, "alp", 0, 0, "", { 0, 0, 1,  0.4, 0, 1,    0.6, 0, 0 });
  ObjAnimate(obj2, "alp", 0, 0, private.complex_keybunch.CheckWin, { 0, 0, 1,  0.4, 0, 1,    0.6, 0, 0 });

end;
-----------------------------------------------------------------------------------
function public.FocusKey( ind, inout )--анимация фокуса

  --DbgTrace( "***FocusKey "..inout );

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
  else
    SetCursor(CURSOR_HAND);
  end;

  if private.complex_keybunch.state.selected_key[1] == ind then  --выделие остаетса при выборе
    return;
  end;

  local obj = "spr_complex_keybunch_key_select_"..ind;
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    tme = alf * 0.3;
  else
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      cmn.PlayAudio("snd", "assets/levels/level1/mg_memories/audio/aud_cloud_menter");
    end;
  end;

  ObjAnimate( obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Burntnewspaper *** () end;
--*********************************************************************************************************************
--********************************************************************************************************************
private.complex_burntnewspaper = {};
public.complex_burntnewspaper = {};

function private.Init_Burntnewspaper()
  
  private.complex_burntnewspaper.pic_pos = {
    {-187, -193}, {-91, -202}, {5, -209}, {98, -219}, {194, -226},
    {-180, -107}, {-83, -116}, {10, -124}, {106, -130}, {202, -141},
    {-172, -19}, {-78, -29}, {19, -37}, {113, -45}, {210, -53},
    {-166, 67}, {-69, 58}, {27, 50}, {122, 41}, {218, 33}
  };
  
  private.complex_burntnewspaper.pic_pull = {
    {3, 6, 9}, {1, 4, 11}, {2, 7, 15}, {5, 10, 18}, {8, 12, 14}, {13, 16, 20}, {0, 17, 19}
  };
  -----------------------------------------------------------------------------------
  local win_burntnewspaper = function ()

    if cmn.IsEventDone( "win_burntnewspaper" ) then
      
      ObjDelete("obj_complex_burntnewspaper_tape_crop");
      ObjDelete("spr_complex_burntnewspaper_tape");

      ObjMultiSet( { {"obj_complex_burntnewspaper_game", { input = 0 }},
                     {"obj_complex_burntnewspaper_dogname", { input = 1 }},
                     {"gfx_complex_burntnewspaper_dogname", { alp = 1, active = 1 }} } );
                     
    end;

  end;

  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_burntnewspaper", win_burntnewspaper, "inv_complex_burntnewspaper" );

end;
--********************************************************************************************************************
function private.complex_burntnewspaper.StartConditions()

  ng_global.progress[ "ext" ][ "win_burntnewspaper" ].skip = 0;
  ng_global.progress[ "ext" ][ "win_burntnewspaper" ].state = { {3, 6, 9}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 1 }; 

end;
-----------------------------------------------------------------------------------
function public.complex_burntnewspaper.Reset()
  
  local need_r = false;
  local need_anm = {0, 0, 0};
  
  for i = 1, 20, 1 do
    
    if private.complex_burntnewspaper.state[2][i] ~= 0 then
      
      if not need_r then
        need_r = true;
      end;
      
      ObjAnimate("spr_complex_burntnewspaper_puzlle_"..private.complex_burntnewspaper.state[2][i], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
      if private.complex_burntnewspaper.state[2][i] == i then
        ObjSet("spr_complex_burntnewspaper_puzlle_"..i,  { input = 1 });
        ObjAnimate("spr_complex_burntnewspaper_puzlle_"..i.."_win", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      end;
      
    end;
    
  end;
  
  local func_after = function ()
    for i = 1, 20, 1 do
      if private.complex_burntnewspaper.pic_pull[1][i] ~= i then
        ObjAttach( "spr_complex_burntnewspaper_puzlle_"..i, "obj_complex_burntnewspaper_puzlles_pull" );
        ObjSet("spr_complex_burntnewspaper_puzlle_"..i,  { alp = 1 });
      end;
    end;
    private.complex_burntnewspaper.DrawScene();
    cmn.Lock(0);
  end;
  
  local anm_pics = function ()
    
    for i = 1, 3, 1 do
      
      if need_anm[i] == 1 then
    
        ObjAttach( "spr_complex_burntnewspaper_puzlle_"..private.complex_burntnewspaper.pic_pull[1][i] , "obj_complex_burntnewspaper_puzlle_"..i );
        ObjSet("spr_complex_burntnewspaper_puzlle_"..private.complex_burntnewspaper.pic_pull[1][i],  { 
          pos_x = 0, 
          pos_y = 0,
          alp = 0 });
        ObjAnimate("spr_complex_burntnewspaper_puzlle_"..private.complex_burntnewspaper.pic_pull[1][i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
        
      end;
        
    end;
    
    ObjSet("tmr_complex_burntnewspaper_timer",  { time = 0.3, playing = 1, endtrig = func_after });
    
  end;
  
  if private.complex_burntnewspaper.state[3] > 1 then
    
    need_anm = {1, 1, 1};
    
    if private.complex_burntnewspaper.state[3] > 7 then
      ObjSet("anm_complex_burntnewspaper_tape_open",  { alp = 0, frame = 300 });
      ObjAnimate("anm_complex_burntnewspaper_tape_open", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    end;
    
    for i = 1, 3, 1 do
        
      if private.complex_burntnewspaper.state[1][i] ~= 0 then
        ObjAnimate("spr_complex_burntnewspaper_puzlle_"..private.complex_burntnewspaper.state[1][i], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      end;
      
    end;
    
  else 
    
    for i = 1, 3, 1 do
        
      if private.complex_burntnewspaper.state[1][i] ~= private.complex_burntnewspaper.pic_pull[1][i] and private.complex_burntnewspaper.state[1][i] ~= 0 then
        need_anm[i] = 1;
        ObjAnimate("spr_complex_burntnewspaper_puzlle_"..private.complex_burntnewspaper.state[1][i], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      elseif private.complex_burntnewspaper.state[1][i] == 0 then
        need_anm[i] = 1;
      end;
      
    end;
    
  end;
  
  if need_r then
    
    cmn.Lock(1);
    private.complex_burntnewspaper.StartConditions();
    private.complex_burntnewspaper.state = ng_global.progress[ "ext" ][ "win_burntnewspaper" ].state;
    ObjSet("tmr_complex_burntnewspaper_timer",  { time = 0.3, playing = 1, endtrig = anm_pics });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.complex_burntnewspaper.Skip()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_use_small_paper");
  
  local need_anm = {};
  local empty = {};
  
  ng_global.progress[ "ext" ][ "win_burntnewspaper" ].skip = 1;
  ng_global.progress[ "ext" ][ "win_burntnewspaper" ].state = { {0, 0, 0}, {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20}, 8 }; 
  
  for i = 1, 20, 1 do
    
    if private.complex_burntnewspaper.state[2][i] ~= i and private.complex_burntnewspaper.state[2][i] ~= 0 then
      
      local ind = private.complex_burntnewspaper.state[2][i];
      
      table.insert( need_anm, private.complex_burntnewspaper.state[2][i] );
      
      if private.complex_burntnewspaper.FindInd( i ) == 0 then
        table.insert( empty, i );
        table.insert( need_anm, i );
      end;
      
      ObjAnimate("spr_complex_burntnewspaper_puzlle_"..private.complex_burntnewspaper.state[2][i], "pos_xy", 0, 0, "", {
      0, 0, private.complex_burntnewspaper.pic_pos[i][1], private.complex_burntnewspaper.pic_pos[i][2],   
      0.5, 0, private.complex_burntnewspaper.pic_pos[ind][1], private.complex_burntnewspaper.pic_pos[ind][2] });
    
    elseif private.complex_burntnewspaper.state[2][i] == 0 then
      table.insert( empty, i );
      table.insert( need_anm, i );
    end;
    
  end;

  local anm_win = function ()
    
    for i = 1, #need_anm, 1 do
      
      ObjAnimate("spr_complex_burntnewspaper_puzlle_"..need_anm[i].."_win", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    ObjSet("tmr_complex_burntnewspaper_timer",  { time = 0.3, playing = 1, endtrig = private.complex_burntnewspaper.ChangeStage });
    
  end;

  local anm_pics = function ()
    
    for i = 1, #empty, 1 do
      
      ObjAttach( "spr_complex_burntnewspaper_puzlle_"..empty[i], "obj_complex_burntnewspaper_puzlle_on" );
      ObjSet("spr_complex_burntnewspaper_puzlle_"..empty[i],  { 
        pos_x = private.complex_burntnewspaper.pic_pos[ empty[i] ][1], 
        pos_y = private.complex_burntnewspaper.pic_pos[ empty[i] ][2],
        alp = 0 });
      ObjAnimate("spr_complex_burntnewspaper_puzlle_"..empty[i], "alp", 0, 0, "", { 0, 0, 0,   0.25, 0, 1 });
        
    end;
    
    ObjSet("tmr_complex_burntnewspaper_timer",  { time = 0.25, playing = 1, endtrig = anm_win });
    
  end;

  for i = 1, 3, 1 do
        
    if private.complex_burntnewspaper.state[1][i] ~= 0 then
      ObjAnimate("spr_complex_burntnewspaper_puzlle_"..private.complex_burntnewspaper.state[1][i], "alp", 0, 0, "", { 0, 0, 1,   0.25, 0, 0 });
    end;
    
  end;
  
  private.complex_burntnewspaper.state = ng_global.progress[ "ext" ][ "win_burntnewspaper" ].state;
  ObjSet("tmr_complex_burntnewspaper_timer",  { time = 0.25, playing = 1, endtrig = anm_pics });
  
end;
-----------------------------------------------------------------------------------
function private.complex_burntnewspaper.DrawScene()
  
  if private.complex_burntnewspaper.state[3] <= 7 then
  
    for i = 1, 3, 1 do
        
      if private.complex_burntnewspaper.state[1][i] ~= 0 then
        ObjSet("spr_complex_burntnewspaper_puzlle_"..private.complex_burntnewspaper.state[1][i],  { pos_x = 0, pos_y = 0 });
        ObjAttach( "spr_complex_burntnewspaper_puzlle_"..private.complex_burntnewspaper.state[1][i], "obj_complex_burntnewspaper_puzlle_"..i );
      end;
      
    end;
    
  end;
  
  for i = 1, 20, 1 do
    
    if private.complex_burntnewspaper.state[2][i] ~= 0 then
      ObjAttach( "spr_complex_burntnewspaper_puzlle_"..private.complex_burntnewspaper.state[2][i] , "obj_complex_burntnewspaper_puzlle_on" );
      ObjSet("spr_complex_burntnewspaper_puzlle_"..private.complex_burntnewspaper.state[2][i],  { 
        pos_x = private.complex_burntnewspaper.pic_pos[i][1], 
        pos_y = private.complex_burntnewspaper.pic_pos[i][2] });
    end;
    
    if private.complex_burntnewspaper.state[2][i] == i then
      ObjMultiSet( { {"spr_complex_burntnewspaper_puzlle_"..i.."_win", { alp = 1 }},
                     {"spr_complex_burntnewspaper_puzlle_"..i, { input = 0 }} } );
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.complex_burntnewspaper.FocusPuzzle( num, inout )
  
  local obj_name = "spr_complex_burntnewspaper_puzlle_"..num.."_focus";

  local alf = ObjGet( obj_name ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
    ObjSet(obj_name,  { pos_z = 0 });
  else 
    SetCursor(CURSOR_GET);
    tme = ( 1 - alf ) * 0.3;
    ObjSet(obj_name,  { pos_z = 2 });
    if tme > 0.13 then
      cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_menter1");
    end;
  end;

  ObjAnimate(obj_name, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.complex_burntnewspaper.ChoosePuzzle( num )
  
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  ObjAttach( "spr_complex_burntnewspaper_puzlle_"..num, "obj_complex_burntnewspaper_fly" );
  public.complex_burntnewspaper.FocusPuzzle( num, 1 );
end;
-----------------------------------------------------------------------------------
function public.complex_burntnewspaper.DropPuzzle( num )
  
  public.complex_burntnewspaper.FocusPuzzle( num, 0 );
  
  local px = GetZoomCursorPos()[1] - 512;
  local py = GetZoomCursorPos()[2] - 384;
  --port feature
    if  tostring(GetPlatform()) == "android" then
    py = py - 100;
  elseif tostring(GetPlatform()) == "ios" then
    if port.isTablet() == 0 then
      py = py - 75;
    else
      py = py - 50;
    end;
  end;
  --
  
  local place = 0;
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_use_small_paper");
  
  for i = 1, 20, 1 do
    
    if private.complex_burntnewspaper.CheckHit(px, py, i) then
      place = i;
      break;
    end;
    
  end;
  
  local ind = 0;
  local old_place = private.complex_burntnewspaper.FindInd( num );
    
  for i = 1, 3, 1 do
    
    if private.complex_burntnewspaper.state[1][i] == num then
      ind = i;
      break;
    end;
    
  end;
  
  --ставим в пустое место на газете
  if place > 0 and private.complex_burntnewspaper.state[2][place] == 0 then
    
    private.complex_burntnewspaper.state[2][place] = num;
    
    if old_place > 0 then
      private.complex_burntnewspaper.state[2][old_place] = 0;
    else 
      private.complex_burntnewspaper.state[1][ind] = 0;
    end;
    
    ObjAttach( "spr_complex_burntnewspaper_puzlle_"..num, "obj_complex_burntnewspaper_puzlle_on" );
    ObjSet("spr_complex_burntnewspaper_puzlle_"..num,  { pos_x = private.complex_burntnewspaper.pic_pos[place][1], pos_y = private.complex_burntnewspaper.pic_pos[place][2] });
    
    if place == num then
      cmn.Lock( 1 );
      ObjSet("spr_complex_burntnewspaper_puzlle_"..num,  { input = 0 });
      ObjAnimate("spr_complex_burntnewspaper_puzlle_"..num.."_win", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    end;
    
    if private.complex_burntnewspaper.CheckStage() then
      
      private.complex_burntnewspaper.state[3] = private.complex_burntnewspaper.state[3] + 1;
      if private.complex_burntnewspaper.state[3] <= 7 then
        for i = 1, 3, 1 do
          private.complex_burntnewspaper.state[1][i] = private.complex_burntnewspaper.pic_pull[ private.complex_burntnewspaper.state[3] ][i];
        end;
      end;
      
      if place == num then
        ObjSet("tmr_complex_burntnewspaper_timer",  { time = 0.3, playing = 1, endtrig = private.complex_burntnewspaper.ChangeStage });
      else 
        private.complex_burntnewspaper.ChangeStage();
      end;
      
    else 
      
      if place == num then
        ObjSet("tmr_complex_burntnewspaper_timer",  { time = 0.3, playing = 1, endtrig = private.complex_burntnewspaper.CheckWin });
      else 
        private.complex_burntnewspaper.CheckWin();
      end;
      
    end;
    
  --ставим в занятое правильным куском место или сбросили в пустую
  elseif place == 0 or private.complex_burntnewspaper.state[2][place] == place then
  
    cmn.Lock( 1 );
    
    if ind == 0 and private.complex_burntnewspaper.state[3] <= 7 then
      
      for i = 1, 3, 1 do
        
        if private.complex_burntnewspaper.state[1][i] == 0 then
          ind = i;
          private.complex_burntnewspaper.state[2][old_place] = 0;
          private.complex_burntnewspaper.state[1][i] = num;
          break;
        end;
        
      end;
      
    end;
  
    local point_a, point_b = {}, {};
    point_a[1] = px;
    point_a[2] = py;
    
    if ind == 0 or private.complex_burntnewspaper.state[3] > 7 then
      point_b[1] = private.complex_burntnewspaper.pic_pos[old_place][1];
      point_b[2] = private.complex_burntnewspaper.pic_pos[old_place][2];
    else 
      point_b[1] = GetObjPosByObj("obj_complex_burntnewspaper_puzlle_"..ind )[1] - 512;
      point_b[2] = GetObjPosByObj("obj_complex_burntnewspaper_puzlle_"..ind )[2] - 384;
    end;
    
    local len = common_impl.math.FindSegmentLength( point_a, point_b );
    local tme = 0.001 * len;
    
    if tme > 0.4 then
      tme = 0.4;
    elseif tme < 0.1 then
      tme = 0.1;
    end;
    
    local func_after = function ()
      
      cmn.Lock( 0 );
    
      if ind > 0 and private.complex_burntnewspaper.state[3] <= 7 then
        ObjSet("spr_complex_burntnewspaper_puzlle_"..num,  { pos_x = 0, pos_y = 0 });
        ObjAttach( "spr_complex_burntnewspaper_puzlle_"..num, "obj_complex_burntnewspaper_puzlle_"..ind );
      else 
        ObjAttach( "spr_complex_burntnewspaper_puzlle_"..num, "obj_complex_burntnewspaper_puzlle_on" );
      end;
      
    end;
    
    ObjAnimate("spr_complex_burntnewspaper_puzlle_"..num, "pos_xy", 0, 0, func_after, { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] });
  
  --меняем куски местами  
  else
  
    local old = private.complex_burntnewspaper.state[2][place];
    local point_a, point_b = {}, {};
    
    if old_place > 0 then
      private.complex_burntnewspaper.state[2][old_place] = old;
      point_b[1] = private.complex_burntnewspaper.pic_pos[old_place][1];
      point_b[2] = private.complex_burntnewspaper.pic_pos[old_place][2];
    else 
      private.complex_burntnewspaper.state[1][ind] = old;
      point_b[1] = GetObjPosByObj("obj_complex_burntnewspaper_puzlle_"..ind )[1] - 512;
      point_b[2] = GetObjPosByObj("obj_complex_burntnewspaper_puzlle_"..ind )[2] - 384;
    end;
    
    private.complex_burntnewspaper.state[2][place] = num;
    
    cmn.Lock( 1 );
    
    point_a[1] = private.complex_burntnewspaper.pic_pos[place][1];
    point_a[2] = private.complex_burntnewspaper.pic_pos[place][2];
    local len = common_impl.math.FindSegmentLength( point_a, point_b );
    local tme = 0.001 * len;
    
    if tme > 0.4 then
      tme = 0.4;
    elseif tme < 0.1 then
      tme = 0.1;
    end;
    
    local func_after = function ()
      
      if old_place == 0 then
        ObjSet("spr_complex_burntnewspaper_puzlle_"..old,  { pos_x = 0, pos_y = 0 });
        ObjAttach( "spr_complex_burntnewspaper_puzlle_"..old, "obj_complex_burntnewspaper_puzlle_"..ind );
      else 
        
        ObjAttach( "spr_complex_burntnewspaper_puzlle_"..old, "obj_complex_burntnewspaper_puzlle_on" );
        
        if old_place == old then
          ObjSet("spr_complex_burntnewspaper_puzlle_"..old,  { input = 0 });
          ObjAnimate("spr_complex_burntnewspaper_puzlle_"..old.."_win", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
        end;
        
      end;
      
      if private.complex_burntnewspaper.CheckStage() and private.complex_burntnewspaper.state[3] <= 7 then
        
        private.complex_burntnewspaper.state[3] = private.complex_burntnewspaper.state[3] + 1;
        if private.complex_burntnewspaper.state[3] <= 7 then
          for i = 1, 3, 1 do
            private.complex_burntnewspaper.state[1][i] = private.complex_burntnewspaper.pic_pull[ private.complex_burntnewspaper.state[3] ][i];
          end;
        end;
        
        if old_place == old then
          ObjSet("tmr_complex_burntnewspaper_timer",  { time = 0.3, playing = 1, endtrig = private.complex_burntnewspaper.ChangeStage });
        else
          private.complex_burntnewspaper.ChangeStage();
        end;
        
      else 
        
        if old_place == old then
          ObjSet("tmr_complex_burntnewspaper_timer",  { time = 0.3, playing = 1, endtrig = private.complex_burntnewspaper.CheckWin });
        else
          private.complex_burntnewspaper.CheckWin();
        end;
        
      end;
      
    end;
    
    ObjAttach( "spr_complex_burntnewspaper_puzlle_"..num, "obj_complex_burntnewspaper_puzlle_on" );
    ObjSet("spr_complex_burntnewspaper_puzlle_"..num,  { pos_x = private.complex_burntnewspaper.pic_pos[place][1], pos_y = private.complex_burntnewspaper.pic_pos[place][2] });
    
    if place == num then
      ObjSet("spr_complex_burntnewspaper_puzlle_"..num,  { input = 0 });
      ObjAnimate("spr_complex_burntnewspaper_puzlle_"..num.."_win", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    end;
    
    ObjAttach( "spr_complex_burntnewspaper_puzlle_"..old, "obj_complex_burntnewspaper_fly" );
    ObjAnimate("spr_complex_burntnewspaper_puzlle_"..old, "pos_xy", 0, 0, func_after, { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.complex_burntnewspaper.ChangeStage()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_burntnewspaper/audio/aud_clk_tape");
  
  local func_after = function () 
    
    for i = 1, 3, 1 do
      
      if private.complex_burntnewspaper.state[1][i] ~= 0 then
        ObjSet("spr_complex_burntnewspaper_puzlle_"..private.complex_burntnewspaper.state[1][i],  { pos_x = 0, pos_y = 0 });
        ObjAttach( "spr_complex_burntnewspaper_puzlle_"..private.complex_burntnewspaper.state[1][i] , "obj_complex_burntnewspaper_puzlle_"..i );
      end;
      
    end;
    
    ObjMultiSet( { {"anm_complex_burntnewspaper_tape_open", { alp = 1, playing = 1, endtrig = function () cmn.Lock(0); end }},
                   {"anm_complex_burntnewspaper_tape_torn", { alp = 0, frame = 0 }} } );
    
  end;
    
  if private.complex_burntnewspaper.state[3] > 7 then
    func_after = private.complex_burntnewspaper.CheckWin;
  end;
  
  ObjMultiSet( { {"anm_complex_burntnewspaper_tape_open", { alp = 0, frame = 0 }},
                 {"anm_complex_burntnewspaper_tape_torn", { alp = 1, playing = 1, endtrig = func_after }} } );
  
end;
------------------------------------------------------------------------------
function private.complex_burntnewspaper.FindInd( num )
  
  local ind = 0;
  
  for i = 1, 20, 1 do
    
    if private.complex_burntnewspaper.state[2][i] == num then
      ind = i;
      break;
    end;
    
  end;
  
  return ind;
  
end;
------------------------------------------------------------------------------
function private.complex_burntnewspaper.CheckHit( px, py, num )

  local centr = {0, 0}; 
  local accuracy = 50;

  centr[1] = private.complex_burntnewspaper.pic_pos[num][1];
  centr[2] = private.complex_burntnewspaper.pic_pos[num][2];

  if ( (px - centr[1])^2 + (py - centr[2])^2 ) <= accuracy^2 then 

    return true;

  else

    return false;

  end; 

end;
-----------------------------------------------------------------------------------
function private.complex_burntnewspaper.CheckStage()
  
  local check = true;
  
  for i = 1, 3, 1 do
    
    if private.complex_burntnewspaper.state[1][i] ~= 0 then
      check = false;
      break;
    end;
    
  end;
  
  return check;
  
end;
-----------------------------------------------------------------------------------
function private.complex_burntnewspaper.CheckWin()
  
  local win_flag = true;
  
  for i = 1, 20, 1 do
    
    if private.complex_burntnewspaper.state[2][i] ~= i then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("burntnewspaper");
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
    
    ObjAnimate("obj_complex_burntnewspaper_tape_crop", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 1,     1, 0, 0 });
    ObjAnimate("spr_complex_burntnewspaper_tape", "alp", 0, 0, private.complex_burntnewspaper.Win, { 0, 0, 1,   0.5, 0, 1,     1, 0, 0 });
    
  else 
    cmn.Lock( 0 );
  end;
  
end;
-----------------------------------------------------------------------------------
function private.complex_burntnewspaper.Win()
  
  common_impl.PauseAchiev(0);
  
  cmn.SetEventDone( "win_burntnewspaper" );
  cmn.CallEventHandler( "win_burntnewspaper", "inv_complex_burntnewspaper" );

  if ng_global.progress[ "ext" ][ "win_burntnewspaper" ].skip == 0 and ng_global.noskipgames[ "win_burntnewspaper" ] == nil then

    ng_global.noskipgames[ "win_burntnewspaper" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

  cmn.Lock(0);
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Tornoffpatch *** () end;
--*********************************************************************************************************************
--********************************************************************************************************************
private.complex_tornoffpatch = {};
public.complex_tornoffpatch = {};

function private.Init_Tornoffpatch()
  
  private.complex_tornoffpatch.win_state = { {1, 5}, {6, 2, 4}, {4, 1, 7, 8} };
  private.complex_tornoffpatch.symbol_pos = {
    { {-420, -287}, {-271, -287}, {-442, 55}, {-338, 146}, {-208, 59}, {-104, 152}, {20, 152} },
    { {-420, -287}, {-270, -281}, {-434, 76}, {-315, 45}, {-315, 150}, {-174, 101}, {-31, 135} }, 
    { {-420, -270}, {-253, -292}, {-438, 64}, {-294, 104}, {-130, 123}, {30, 136}, {187, -295}, {-1, -332} }
  };
  private.complex_tornoffpatch.skip_inprogress = false;
  -----------------------------------------------------------------------------------
  local win_tornoffpatch = function ()

    if cmn.IsEventDone( "win_tornoffpatch" ) then
      
      ObjDelete("obj_complex_tornoffpatch_game");
      ObjDelete("anm_complex_tornoffpatch_sew_1");
      ObjDelete("anm_complex_tornoffpatch_sew_2");
      ObjDelete("obj_complex_tornoffpatch_game_fly");

      ObjMultiSet( { {"obj_complex_tornoffpatch_volunteersign", { input = 1 }},
                     {"anm_complex_tornoffpatch_sew_3", { alp = 1, frame = 300 }} } );
                     
    end;

  end;

  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_tornoffpatch", win_tornoffpatch, "inv_complex_tornoffpatch" );

end;
--********************************************************************************************************************
function private.complex_tornoffpatch.StartConditions()

  ng_global.progress[ "ext" ][ "win_tornoffpatch" ].skip = 0;
  ng_global.progress[ "ext" ][ "win_tornoffpatch" ].state = { 1, { 0, 0, 0, 0 } }; 

end;
-----------------------------------------------------------------------------------
function public.complex_tornoffpatch.Reset()
  
  local need_r = false;
  local stage = private.complex_tornoffpatch.state[1];
  local old = {};
  
  for i = 1, #private.complex_tornoffpatch.win_state[ stage ], 1 do
    
    if private.complex_tornoffpatch.state[2][i] ~= 0 then
      
      if not need_r then
        need_r = true;
      end;
      
      local num = private.complex_tornoffpatch.state[2][i];
      local point_b = {};
      point_b[1] = private.complex_tornoffpatch.symbol_pos[ stage ][ num ][1];
      point_b[2] = private.complex_tornoffpatch.symbol_pos[ stage ][ num ][2];
      
      table.insert( old, num );
      
      ObjAnimate("spr_complex_tornoffpatch_symbol_"..stage.."_"..num, "pos_xy", 0, 0, "", { 0, 0, 300, -120,   0.4, 0, point_b[1], point_b[2] });
      
    end;
    
  end;
  
  local func_after = function ()
    
    cmn.Lock( 0 );
    
    for i = 1, #old, 1 do
      
      ObjAttach( "spr_complex_tornoffpatch_symbol_"..stage.."_"..old[i], "obj_complex_tornoffpatch_stage_"..stage );
      ObjSet("spr_complex_tornoffpatch_symbol_"..stage.."_"..old[i],  { pos_z = 2 });
      
    end;
    
  end;
  
  if need_r then
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/mg_darkroom/audio/aud_xx_menter_darkroom");
    
    for i = 1, #private.complex_tornoffpatch.win_state[ stage ], 1 do
      private.complex_tornoffpatch.state[2][i] = 0;
    end;
    
    ObjSet("tmr_complex_tornoffpatch_timer",  { time = 0.5, playing = 1, endtrig = func_after });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.complex_tornoffpatch.Skip()
  
  cmn.Lock( 1 );
  cmn.MiniGameHide("tornoffpatch");
  
  cmn.PlayAudio("snd", "assets/levels/level3/mg_darkroom/audio/aud_xx_menter_darkroom");
  
  private.complex_tornoffpatch.skip_inprogress = true;
  
  ng_global.progress[ "ext" ][ "win_tornoffpatch" ].skip = 1;
  ng_global.progress[ "ext" ][ "win_tornoffpatch" ].state = { 3, { 4, 1, 7, 8 } }; 
  
  local stage = private.complex_tornoffpatch.state[1];
  local old = {};
  
  for i = 1, #private.complex_tornoffpatch.win_state[ stage ], 1 do
    
    if private.complex_tornoffpatch.state[2][i] == 0 then
      
      local num = private.complex_tornoffpatch.win_state[ stage ][i];
      local point_a = {};
      point_a[1] = private.complex_tornoffpatch.symbol_pos[ stage ][ num ][1];
      point_a[2] = private.complex_tornoffpatch.symbol_pos[ stage ][ num ][2];
      
      ObjAttach( "spr_complex_tornoffpatch_symbol_"..stage.."_"..num, "obj_complex_tornoffpatch_game_fly" );
      ObjSet("spr_complex_tornoffpatch_symbol_"..stage.."_"..num,  { pos_z = i });
      ObjAnimate("spr_complex_tornoffpatch_symbol_"..stage.."_"..num, "pos_xy", 0, 0, "", { 0, 0, point_a[1], point_a[2],   0.4, 0, 300, -120 });
      
    elseif private.complex_tornoffpatch.state[2][i] ~= private.complex_tornoffpatch.win_state[ stage ][i] then
      
      local num = private.complex_tornoffpatch.win_state[ stage ][i];
      local num2 = private.complex_tornoffpatch.state[2][i];
      local point_a, point_b = {}, {};
      point_a[1] = private.complex_tornoffpatch.symbol_pos[ stage ][ num ][1];
      point_a[2] = private.complex_tornoffpatch.symbol_pos[ stage ][ num ][2];
      point_b[1] = private.complex_tornoffpatch.symbol_pos[ stage ][ num2 ][1];
      point_b[2] = private.complex_tornoffpatch.symbol_pos[ stage ][ num2 ][2];
      
      table.insert( old, num2 );
      
      ObjAttach( "spr_complex_tornoffpatch_symbol_"..stage.."_"..num, "obj_complex_tornoffpatch_game_fly" );
      ObjSet("spr_complex_tornoffpatch_symbol_"..stage.."_"..num,  { pos_z = i });
      ObjAnimate("spr_complex_tornoffpatch_symbol_"..stage.."_"..num, "pos_xy", 0, 0, "", { 0, 0, point_a[1], point_a[2],   0.4, 0, 300, -120 });
      
      ObjAnimate("spr_complex_tornoffpatch_symbol_"..stage.."_"..num2, "pos_xy", 0, 0, "", { 0, 0, 300, -120,   0.4, 0, point_b[1], point_b[2] });
      
    end;
    
  end;
  
  local func_after = function ()
    
    private.complex_tornoffpatch.AnimSewing( stage );
    
    for i = 1, #old, 1 do
      
      ObjAttach( "spr_complex_tornoffpatch_symbol_"..stage.."_"..old[i], "obj_complex_tornoffpatch_stage_"..stage );
      ObjSet("spr_complex_tornoffpatch_symbol_"..stage.."_"..old[i],  { pos_z = 2 });
      
    end;
    
  end;
  
  private.complex_tornoffpatch.state = ng_global.progress[ "ext" ][ "win_tornoffpatch" ].state;
  ObjSet("tmr_complex_tornoffpatch_timer",  { time = 0.5, playing = 1, endtrig = func_after });
  
end;
-----------------------------------------------------------------------------------
function private.complex_tornoffpatch.Skip_end( stage )
  
  local func_after = "";
  
  if stage == 3 then
    
    func_after = function ()
      
      ObjAnimate("obj_complex_tornoffpatch_game", "alp", 0, 0, private.complex_tornoffpatch.Win, { 0, 0, 1,   0.5, 0, 0 });
      
    end;
    
  else
    func_after = function() private.complex_tornoffpatch.Skip_end(stage+1); end;
  end;
    
  cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_tornoffpatch/audio/aud_use_needle");
  
  ObjMultiSet( { {"anm_complex_tornoffpatch_sew_"..stage,  { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_complex_tornoffpatch_sew_"..(stage-1), { alp = 0 }} } );
  
end;
-----------------------------------------------------------------------------------
function private.complex_tornoffpatch.DrawScene()
  
  local stage = private.complex_tornoffpatch.state[1];
  
  for i = 1, 3, 1 do
    
    if stage == i then
      ObjMultiSet( { {"obj_complex_tornoffpatch_stage_"..i, { alp = 1, input = 1 }},
                     {"anm_complex_tornoffpatch_sew_"..i, { alp = 1 }} } );
    else 
      ObjMultiSet( { {"obj_complex_tornoffpatch_stage_"..i, { alp = 0, input = 0 }},
                     {"anm_complex_tornoffpatch_sew_"..i, { alp = 0 }} } );
    end;
    
  end;
  
  for i = 1, #private.complex_tornoffpatch.win_state[ stage ], 1 do
    
    if private.complex_tornoffpatch.state[2][i] == 0 then
      break;
    else 
      ObjAttach( "spr_complex_tornoffpatch_symbol_"..stage.."_"..private.complex_tornoffpatch.state[2][i], "obj_complex_tornoffpatch_game_fly" );
      ObjSet("spr_complex_tornoffpatch_symbol_"..stage.."_"..private.complex_tornoffpatch.state[2][i],  { pos_x = 300, pos_y = -120, pos_z = i });
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.complex_tornoffpatch.FocusSymbol( name, inout )
  
  local obj_name = "spr_complex_tornoffpatch_symbol_"..name.."_focus";

  local alf = ObjGet( obj_name ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.13 then
      cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_menter1");
    end;
  end;

  ObjAnimate(obj_name, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.complex_tornoffpatch.ChooseSymbol( num )
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/mg_darkroom/audio/aud_xx_menter_darkroom");
  
  local cur = private.complex_tornoffpatch.GetCurrent();
  local stage = private.complex_tornoffpatch.state[1];
  
  private.complex_tornoffpatch.state[2][cur] = num;
  
  local func_after = function () cmn.Lock( 0 ); end;
  if cur == #private.complex_tornoffpatch.win_state[ stage ] then
    func_after = private.complex_tornoffpatch.CheckWin;
  end;
  
  local point_a, point_b = {}, {};
  point_a[1] = private.complex_tornoffpatch.symbol_pos[ stage ][ num ][1];
  point_a[2] = private.complex_tornoffpatch.symbol_pos[ stage ][ num ][2];
  
  point_b[1] = 300;
  point_b[2] = -120;
  
  local len = common_impl.math.FindSegmentLength( point_a, point_b );
  local tme = 0.001 * len;
  
  if tme > 0.4 then
    tme = 0.4;
  elseif tme < 0.1 then
    tme = 0.1;
  end;
  
  ObjAttach( "spr_complex_tornoffpatch_symbol_"..stage.."_"..num, "obj_complex_tornoffpatch_game_fly" );
  ObjSet("spr_complex_tornoffpatch_symbol_"..stage.."_"..num,  { pos_z = cur });
  ObjAnimate("spr_complex_tornoffpatch_symbol_"..stage.."_"..num, "pos_xy", 0, 0, func_after, { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] });
  
end;
-----------------------------------------------------------------------------------
function public.complex_tornoffpatch.DeleteLast()
  
  local cur = 0;
  for i = #private.complex_tornoffpatch.state[2], 1, -1 do
    
    if private.complex_tornoffpatch.state[2][i] ~= 0 then
      cur = i;
      break;
    end;
    
  end;
  
  if cur > 0 then
  
    cmn.Lock( 1 );
    
    local stage = private.complex_tornoffpatch.state[1];
    
    local num = private.complex_tornoffpatch.state[2][cur];
    private.complex_tornoffpatch.state[2][cur] = 0;
    
    local func_after = function () 
      cmn.Lock( 0 );
      ObjAttach( "spr_complex_tornoffpatch_symbol_"..stage.."_"..num, "obj_complex_tornoffpatch_stage_"..stage );
      ObjSet("spr_complex_tornoffpatch_symbol_"..stage.."_"..num,  { pos_z = 2 });
    end;
    
    local point_a, point_b = {}, {};
    point_b[1] = private.complex_tornoffpatch.symbol_pos[ stage ][ num ][1];
    point_b[2] = private.complex_tornoffpatch.symbol_pos[ stage ][ num ][2];
    
    point_a[1] = 300;
    point_a[2] = -120;
    
    local len = common_impl.math.FindSegmentLength( point_a, point_b );
    local tme = 0.001 * len;
    
    if tme > 0.4 then
      tme = 0.4;
    elseif tme < 0.1 then
      tme = 0.1;
    end;
    
    ObjAnimate("spr_complex_tornoffpatch_symbol_"..stage.."_"..num, "pos_xy", 0, 0, func_after, { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.complex_tornoffpatch.GetCurrent()
  
  local cur = 5;
  
  for i = 1, #private.complex_tornoffpatch.state[2], 1 do
    
    if private.complex_tornoffpatch.state[2][i] == 0 then
      cur = i;
      break;
    end;
    
  end;
  
  return cur;
  
end;
-----------------------------------------------------------------------------------
function private.complex_tornoffpatch.AnimSewing( stage )
  
  local func_after = function()
    
    ObjAnimate("spr_complex_tornoffpatch_needle", "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 1 });
    
    ObjAnimate("obj_complex_tornoffpatch_stage_"..(stage+1), "alp", 0, 0, function() cmn.Lock( 0 ); end, { 0, 0, 0,   0.5, 0, 1 });
    
    ObjMultiSet( { {"obj_complex_tornoffpatch_stage_"..(stage+1), { input = 1 }},
                   {"anm_complex_tornoffpatch_sew_"..stage, { alp = 0 }},
                   {"anm_complex_tornoffpatch_sew_"..(stage+1), { alp = 1 }} } );
    
  end;
                 
  if stage == 3 then
    
    func_after = function ()
      
      ObjAnimate("obj_complex_tornoffpatch_game", "alp", 0, 0, private.complex_tornoffpatch.Win, { 0, 0, 1,   0.5, 0, 0 });
      
    end;
    
  elseif private.complex_tornoffpatch.skip_inprogress then
    func_after = function() private.complex_tornoffpatch.Skip_end(stage+1); end;
  end;
  
  local anm_sew = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_tornoffpatch/audio/aud_use_needle");
    
    ObjAnimate("spr_complex_tornoffpatch_needle", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 });
    ObjSet("anm_complex_tornoffpatch_sew_"..stage,  { playing = 1, endtrig = func_after });
    
  end;
  
  for i = 1, #private.complex_tornoffpatch.win_state[ stage ], 1 do
    
    ObjSet("spr_complex_tornoffpatch_symbol_"..stage.."_"..private.complex_tornoffpatch.win_state[stage][i],  { pos_x = 0, pos_y = 0 });
    ObjAttach("spr_complex_tornoffpatch_symbol_"..stage.."_"..private.complex_tornoffpatch.win_state[stage][i], "obj_complex_tornoffpatch_ready_"..stage);
    
  end;
  
  ObjAnimate("obj_complex_tornoffpatch_stage_"..stage, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  
  local fx_item = "fx_complex_tornoffpatch_ready";
  
  cmn.PlayAudio("snd", "assets/levels/level3/rm_relicstorage/audio/aud_mirror");
  
  ObjCreate( fx_item, "partsys" );
  ObjSet( fx_item, { res = "assets/interface/resources/fx/ho_get_obj" } );
  ObjAttach(fx_item, "obj_complex_tornoffpatch_ready_"..stage);
  
  local fx_item2 = "fx_complex_tornoffpatch_hint";
  
  ObjCreate( fx_item2, "partsys" );
  ObjSet( fx_item2, { res = "assets/interface/resources/fx/ho_get_obj" } );
  ObjAttach(fx_item2, "obj_complex_tornoffpatch_hint_"..stage);
  
  SendMessage( Command_Transporter_MoveObject,
  {
    type       = Trans_HintFly,
    obj_name   = fx_item,
    toobj_name = "obj_complex_tornoffpatch_stage_fly_"..stage,
    end_trig   = function () ObjDelete( fx_item ); end,
  } );
  
  SendMessage( Command_Transporter_MoveObject,
  {
    type       = Trans_HintFly,
    obj_name   = "obj_complex_tornoffpatch_ready_"..stage,
    toobj_name = "obj_complex_tornoffpatch_stage_fly_"..stage,
    end_trig   = anm_sew,
  } );
  
  SendMessage( Command_Transporter_MoveObject,
  {
    type       = Trans_HintFly,
    obj_name   = fx_item2,
    toobj_name = "obj_complex_tornoffpatch_stage_fly_"..stage,
    end_trig   = function () ObjDelete( fx_item2 ); end,
  } );
  
  SendMessage( Command_Transporter_MoveObject,
  {
    type       = Trans_HintFly,
    obj_name   = "obj_complex_tornoffpatch_hint_"..stage,
    toobj_name = "obj_complex_tornoffpatch_stage_fly_"..stage,
    end_trig   = "",
  } );
  
end;
-----------------------------------------------------------------------------------
function private.complex_tornoffpatch.CheckWin()
  
  local win_flag = true;
  local stage = private.complex_tornoffpatch.state[1];
  
  for i = 1, #private.complex_tornoffpatch.win_state[ stage ], 1 do
    
    if private.complex_tornoffpatch.state[2][i] ~= private.complex_tornoffpatch.win_state[ stage ][i] then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag and stage == 3 then
    
    cmn.Lock( 1 );
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("tornoffpatch");
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
    
    private.complex_tornoffpatch.AnimSewing( stage );
    
  elseif win_flag then
    
    cmn.Lock( 1 );
    
    private.complex_tornoffpatch.state[1] = private.complex_tornoffpatch.state[1] + 1;
    
    for i = 1, #private.complex_tornoffpatch.win_state[ stage ], 1 do
      private.complex_tornoffpatch.state[2][i] = 0;
    end;
    
    private.complex_tornoffpatch.AnimSewing( stage );
    
  elseif private.complex_tornoffpatch.GetCurrent() > #private.complex_tornoffpatch.win_state[ stage ] then
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_wrong_apply");
    ObjSet("tmr_complex_tornoffpatch_timer",  { time = 1, playing = 1, endtrig = public.complex_tornoffpatch.Reset });
  end;
  
end;
-----------------------------------------------------------------------------------
function private.complex_tornoffpatch.Win()
  
  common_impl.PauseAchiev(0);
  
  cmn.SetEventDone( "win_tornoffpatch" );
  cmn.CallEventHandler( "win_tornoffpatch", "inv_complex_tornoffpatch" );

  if ng_global.progress[ "ext" ][ "win_tornoffpatch" ].skip == 0 and ng_global.noskipgames[ "win_tornoffpatch" ] == nil then

    ng_global.noskipgames[ "win_tornoffpatch" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

  cmn.Lock(0);
  
end;
--*****************************************************************************************************************