-- name=rm_ingingerbreadhouse
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_ingingerbreadhouse";
  --------------------------------------------------------------------------------------------
  private.dlg_lipsync = "";
  private.dlg_finished = true;
  private.Init_Subroom();
  private.clues_pos = { {210, 360}, {400, 460}, {598, 460}, {790, 360} };
  --------------------------------------------------------------------------------------------
  -- function get_keybunch () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_keybunch" ] = {
        type = "get",
        get_obj = "spr_ingingerbreadhouse_keybunch",
        room = private.room_objname
    };
    --------------------------------------------------------------------------------------------
  local get_keybunch_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_keybunch", "spr_ingingerbreadhouse_keybunch" );
  
  end;
  
  local get_keybunch_end = function ()
  
    ObjDelete( "gfx_ingingerbreadhouse_keybunch" );
    --ObjDelete( "gzz_ingingerbreadhouse_ingingerbreadhouse" );
  
  end;
  
  cmn.AddSubscriber( "get_keybunch", get_keybunch_inv );
  cmn.AddSubscriber( "get_keybunch", get_keybunch_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_runestone3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_runestone3" ] = {
      type = "get",
      get_obj = "spr_ingingerbreadhouse_runestone3",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_runestone3_inv = function ()
  
    interface.InventoryItemAdd( "inv_runestone", "spr_ingingerbreadhouse_runestone3", function () cmn.GetMultyObject( 'runestone', 3 ); end );
  
  end;
  local get_runestone3_mid = function ()
  
    ObjDelete( "gfx_ingingerbreadhouse_runestone3" );
    ObjDelete( "spr_ingingerbreadhouse_runestone3_sh" );
  
  end;
  local get_runestone3_end = function ()
  
    ObjDelete( "obj_ingingerbreadhouse_dialog_faerie1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_runestone3", get_runestone3_inv );
  cmn.AddSubscriber( "get_runestone3_inv", get_runestone3_inv, private.room_objname );
  cmn.AddSubscriber( "get_runestone3", get_runestone3_mid, private.room_objname );
  cmn.AddSubscriber( "get_runestone3_mid", get_runestone3_mid, private.room_objname );
  cmn.AddSubscriber( "get_runestone3", get_runestone3_end, private.room_objname );
  cmn.AddSubscriber( "get_runestone3_end", get_runestone3_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_cagekey () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_cagekey" ] = {
        type = "use",
        inv_obj = "inv_cagekey",
        use_place = "obj_magiccrib_use_cagekey",
        room = private.room_objname,
        zz = "zz_magiccrib",
        zz_gate = "gzz_ingingerbreadhouse_magiccrib"
    };
  --------------------------------------------------------------------------------------------
  local use_cagekey_inv = function ()
  
    interface.InventoryItemRemove( "inv_cagekey" );
    interface_impl.AddNewClues( {1, 2, 3, 4} );
  
  end;
  local use_cagekey_clues = function ()
  
    int_clues_panel.SetCluesPanelActive();
  
  end;
  local use_cagekey_beg = function ()
  
    ObjDelete( "obj_magiccrib_use_cagekey" );
    ObjDelete( "anm_magiccrib_door_touch" );
  
  end;
  local use_cagekey_mid = function ()
  
    ObjDelete( "anm_ingingerbreadhouse_cage_closed" );
    ObjDelete( "gzz_ingingerbreadhouse_magiccrib" );
    
    ObjSet("anm_ingingerbreadhouse_cage_open",  { alp = 1 });
  
  end;
  local use_cagekey_end = function ()
  
    ObjDelete( "obj_ingingerbreadhouse_dialog_faerie2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cagekey", use_cagekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_cagekey", use_cagekey_inv );
  cmn.AddSubscriber( "use_cagekey", use_cagekey_end, private.room_objname );
  cmn.AddSubscriber( "use_cagekey_inv", use_cagekey_inv, private.room_objname );
  cmn.AddSubscriber( "use_cagekey_beg", use_cagekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_cagekey_end", use_cagekey_end, private.room_objname );
  cmn.AddSubscriber( "use_cagekey", use_cagekey_mid, private.room_objname );
  cmn.AddSubscriber( "use_cagekey_mid", use_cagekey_mid, private.room_objname );
  cmn.AddSubscriber( "use_cagekey", use_cagekey_clues );
  cmn.AddSubscriber( "use_cagekey_clues", use_cagekey_clues );
  --------------------------------------------------------------------------------------------
  -- function use_gargoylecuffs () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_gargoylecuffs" ] = {
        type = "use",
        inv_obj = "inv_gargoylecuffs",
        use_place = "obj_ingingerbreadhouse_use_gargoylecuffs",
        room = private.room_objname
    };
  --------------------------------------------------------------------------------------------
  local use_gargoylecuffs_inv = function ()
  
    interface.InventoryItemRemove( "inv_gargoylecuffs" );
  
  end;
  local use_gargoylecuffs_beg = function ()
  
    ObjDelete( "obj_ingingerbreadhouse_use_gargoylecuffs" );
  
  end;
  local use_gargoylecuffs_end = function ()
  
    ObjSet( "spr_ingingerbreadhouse_gargoyle_hands_open", { alp = 1 } );
    ObjDelete( "anm_ingingerbreadhouse_keybunch_touch" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gargoylecuffs", use_gargoylecuffs_beg, private.room_objname );
  cmn.AddSubscriber( "use_gargoylecuffs", use_gargoylecuffs_inv );
  cmn.AddSubscriber( "use_gargoylecuffs", use_gargoylecuffs_end, private.room_objname );
  cmn.AddSubscriber( "use_gargoylecuffs_inv", use_gargoylecuffs_inv, private.room_objname );
  cmn.AddSubscriber( "use_gargoylecuffs_beg", use_gargoylecuffs_beg, private.room_objname );
  cmn.AddSubscriber( "use_gargoylecuffs_end", use_gargoylecuffs_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function use_charitypicture () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_charitypicture" ] = {
        type = "use",
        inv_obj = "inv_charitypicture",
        use_place = "obj_ingingerbreadhouse_use_charitypicture",
        room = private.room_objname
    };
  --------------------------------------------------------------------------------------------
  local use_charitypicture_inv = function ()
  
    interface.InventoryItemRemove( "inv_charitypicture" );
  
  end;
  local use_charitypicture_beg = function ()
  
    ObjDelete( "obj_ingingerbreadhouse_use_charitypicture" );
  
  end;
  local use_charitypicture_end = function ()
  
    if cmn.IsEventDone("use_socksforsophia") and cmn.IsEventDone("use_donationcheque") and cmn.IsEventDone("use_rescueddog") then
      ObjDelete( "obj_ingingerbreadhouse_dialog_sophia1" );
      ObjSet("gho_ingingerbreadhouse_lvl4memories",  { active = 1, input = 1, alp = 1 });
    else 
      ObjSet("spr_ingingerbreadhouse_clue_2_done",  { alp = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_charitypicture", use_charitypicture_beg, private.room_objname );
  cmn.AddSubscriber( "use_charitypicture", use_charitypicture_inv );
  cmn.AddSubscriber( "use_charitypicture", use_charitypicture_end, private.room_objname );
  cmn.AddSubscriber( "use_charitypicture_inv", use_charitypicture_inv, private.room_objname );
  cmn.AddSubscriber( "use_charitypicture_beg", use_charitypicture_beg, private.room_objname );
  cmn.AddSubscriber( "use_charitypicture_end", use_charitypicture_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_socksforsophia () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_socksforsophia" ] = {
        type = "use",
        inv_obj = "inv_socksforsophia",
        use_place = "obj_ingingerbreadhouse_use_socksforsophia",
        room = private.room_objname
    };
  --------------------------------------------------------------------------------------------
  local use_socksforsophia_inv = function ()
  
    interface.InventoryItemRemove( "inv_socksforsophia" );
  
  end;
  local use_socksforsophia_beg = function ()
  
    ObjDelete( "obj_ingingerbreadhouse_use_socksforsophia" );
  
  end;
  local use_socksforsophia_end = function ()
  
    if cmn.IsEventDone("use_charitypicture") and cmn.IsEventDone("use_donationcheque") and cmn.IsEventDone("use_rescueddog") then
      ObjDelete( "obj_ingingerbreadhouse_dialog_sophia1" );
      ObjSet("gho_ingingerbreadhouse_lvl4memories",  { active = 1, input = 1, alp = 1 });
    else 
      ObjSet("spr_ingingerbreadhouse_clue_3_done",  { alp = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_socksforsophia", use_socksforsophia_beg, private.room_objname );
  cmn.AddSubscriber( "use_socksforsophia", use_socksforsophia_inv );
  cmn.AddSubscriber( "use_socksforsophia", use_socksforsophia_end, private.room_objname );
  cmn.AddSubscriber( "use_socksforsophia_inv", use_socksforsophia_inv, private.room_objname );
  cmn.AddSubscriber( "use_socksforsophia_beg", use_socksforsophia_beg, private.room_objname );
  cmn.AddSubscriber( "use_socksforsophia_end", use_socksforsophia_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_donationcheque () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_donationcheque" ] = {
        type = "use",
        inv_obj = "inv_donationcheque",
        use_place = "obj_ingingerbreadhouse_use_donationcheque",
        room = private.room_objname
    };
  --------------------------------------------------------------------------------------------
  local use_donationcheque_inv = function ()
  
    interface.InventoryItemRemove( "inv_donationcheque" );
  
  end;
  local use_donationcheque_beg = function ()
  
    ObjDelete( "obj_ingingerbreadhouse_use_donationcheque" );
  
  end;
  local use_donationcheque_end = function ()
  
    if cmn.IsEventDone("use_charitypicture") and cmn.IsEventDone("use_socksforsophia") and cmn.IsEventDone("use_rescueddog") then
      ObjDelete( "obj_ingingerbreadhouse_dialog_sophia1" );
      ObjSet("gho_ingingerbreadhouse_lvl4memories",  { active = 1, input = 1, alp = 1 });
    else 
      ObjSet("spr_ingingerbreadhouse_clue_1_done",  { alp = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_donationcheque", use_donationcheque_beg, private.room_objname );
  cmn.AddSubscriber( "use_donationcheque", use_donationcheque_inv );
  cmn.AddSubscriber( "use_donationcheque", use_donationcheque_end, private.room_objname );
  cmn.AddSubscriber( "use_donationcheque_inv", use_donationcheque_inv, private.room_objname );
  cmn.AddSubscriber( "use_donationcheque_beg", use_donationcheque_beg, private.room_objname );
  cmn.AddSubscriber( "use_donationcheque_end", use_donationcheque_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_rescueddog () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_rescueddog" ] = {
        type = "use",
        inv_obj = "inv_rescueddog",
        use_place = "obj_ingingerbreadhouse_use_rescueddog",
        room = private.room_objname
    };
  --------------------------------------------------------------------------------------------
  local use_rescueddog_inv = function ()
  
    interface.InventoryItemRemove( "inv_rescueddog" );
  
  end;
  local use_rescueddog_beg = function ()
  
    ObjDelete( "obj_ingingerbreadhouse_use_rescueddog" );
  
  end;
  local use_rescueddog_end = function ()
  
    if cmn.IsEventDone("use_charitypicture") and cmn.IsEventDone("use_socksforsophia") and cmn.IsEventDone("use_donationcheque") then
      ObjDelete( "obj_ingingerbreadhouse_dialog_sophia1" );
      ObjSet("gho_ingingerbreadhouse_lvl4memories",  { active = 1, input = 1, alp = 1 });
    else 
      ObjSet("spr_ingingerbreadhouse_clue_4_done",  { alp = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_rescueddog", use_rescueddog_beg, private.room_objname );
  cmn.AddSubscriber( "use_rescueddog", use_rescueddog_inv );
  cmn.AddSubscriber( "use_rescueddog", use_rescueddog_end, private.room_objname );
  cmn.AddSubscriber( "use_rescueddog_inv", use_rescueddog_inv, private.room_objname );
  cmn.AddSubscriber( "use_rescueddog_beg", use_rescueddog_beg, private.room_objname );
  cmn.AddSubscriber( "use_rescueddog_end", use_rescueddog_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_ingingerbreadhouse () end;
  --------------------------------------------------------------------------------------------
  local opn_ingingerbreadhouse = function ()
  
    int_map_impl.OpenRoom( "rm_ingingerbreadhouse" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_ingingerbreadhouse", opn_ingingerbreadhouse );
  --------------------------------------------------------------------------------------------
  -- function opn_magiccrib () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "opn_magiccrib" ] = {
    type = "click",
    use_place = "gzz_ingingerbreadhouse_magiccrib",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local opn_magiccrib_task = function ()
    interface_impl.SetCurrentGlobalTask( 23 );
  end;
  local opn_magiccrib = function ()
    
    ObjDelete("vid_ingingerbreadhouse_dialog_faerie1_lipsync1");
  
    ObjDelete("anm_ingingerbreadhouse_dialog_faerie1_hand_1");
    ObjDelete("anm_ingingerbreadhouse_dialog_faerie1_hand_1_give");
    ObjDelete("anm_ingingerbreadhouse_dialog_faerie1_hand_1_give_2");
    
    ObjAttach("obj_ingingerbreadhouse_dialog_faerie1", "rm_ingingerbreadhouse");
    
    ObjMultiSet( { { "obj_ingingerbreadhouse_dialog_faerie1", { input = 1, alp = 1 } },
                   { "anm_ingingerbreadhouse_dialog_faerie1_hand_1_out", { input = 1, alp = 1 } },
                   { "obj_ingingerbreadhouse_dialog_faerie1_head", { alp = 1 } },

                   { "gzz_ingingerbreadhouse_magiccrib", { event_mdown = function() cmn.GotoSubRoomMDown( "ingingerbreadhouse_magiccrib" ); end, event_mup = function() cmn.GotoSubRoomMUp( "ingingerbreadhouse_magiccrib", "zz_magiccrib" ); end }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_magiccrib", opn_magiccrib, private.room_objname );
  cmn.AddSubscriber( "opn_magiccrib", opn_magiccrib_task );
  --------------------------------------------------------------------------------------------
  -- function opn_ingingerbreadhousewithclues () end;
  --------------------------------------------------------------------------------------------
  local opn_ingingerbreadhousewithclues_task = function ()

    int_map_impl.BlockRoom( "rm_lvl4nearhospital" );
    int_map_impl.BlockRoom( "rm_lvl4corridor" );
    int_map_impl.BlockRoom( "rm_serviceroom" );
    int_map_impl.BlockRoom( "rm_ward" );
    int_map_impl.BlockRoom( "rm_nearnurseshouse" );
    int_map_impl.BlockRoom( "rm_insophiashouse" );

    int_map_impl.OpenRoom( "rm_ingingerbreadhouse" );

    interface_impl.SetCurrentGlobalTask( 29 );

  end;
  local opn_ingingerbreadhousewithclues_loc = function ()
    
    ObjDelete("vid_ingingerbreadhouse_dialog_sophia1_lipsync1");
    ObjAttach("obj_ingingerbreadhouse_dialog_sophia1", "rm_ingingerbreadhouse");
  
    ObjMultiSet( { {"obj_ingingerbreadhouse_dialog_sophia1", { alp = 1, input = 1 }},
                   {"obj_ingingerbreadhouse_dialog_sophia1_uses", { alp = 1, input = 1 }},
                   {"anm_ingingerbreadhouse_dialog_sophia1_head", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_ingingerbreadhousewithclues", opn_ingingerbreadhousewithclues_loc, private.room_objname );
  cmn.AddSubscriber( "opn_ingingerbreadhousewithclues", opn_ingingerbreadhousewithclues_task );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_magiccrib" );
  
  function zz_magiccrib.Close()
    
    if cmn.IsEventDone( "use_cagekey" ) then
      private.dialog_faerie_open( 2 );
    end;

  end;
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_ingingerbreadhouse();
  
  if cmn.IsEventDone("opn_magiccrib") and not cmn.IsEventDone("get_runestone3") then
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_ingingerbreadhouse_dialog_faerie1";
    ObjSet("anm_ingingerbreadhouse_dialog_faerie1_hand_1_out",  { playing = 1 });
  end;
  
  if cmn.IsEventDone("opn_ingingerbreadhousewithclues") and ( not cmn.IsEventDone("use_charitypicture")
  or cmn.IsEventDone("use_socksforsophia") or cmn.IsEventDone("use_donationcheque") or cmn.IsEventDone("use_rescueddog") ) then
  
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "";
    
    for i = 1, 4, 1 do
      private.AnimateDlgClues( i );
    end;
    
  end;
  
  if cmn.IsEventDone("get_rescueddog") and not ( cmn.IsEventDone( "opn_ingingerbreadhousewithclues" ) ) then
    cmn.Lock( 1 );
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio4/aud_ingingerbreadhouse_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio4/aud_ingingerbreadhouse_env");
  
  ObjSet("rm_ingingerbreadhouse",  { color_r = 1, color_g = 1, color_b = 1 });
  
  if cmn.IsEventDone("use_cagekey") and not cmn.IsEventDone("opn_lvl4nearhospital") then
    cmn.Lock( 1 );
  end;
  
  if cmn.IsEventDone("get_rescueddog") and not ( cmn.IsEventDone( "opn_ingingerbreadhousewithclues" ) ) then
    cmn.Lock( 1 );
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_cagekey()

  local item = "inv_cagekey";

  if cmn.ApplyObj( item, "gzz_ingingerbreadhouse_magiccrib" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_magiccrib" );

  elseif ( cmn.ApplyObj( item, "obj_magiccrib_use_cagekey" ) ) then

    cmn.CallEventHandler( "use_cagekey_inv" );
    cmn.CallEventHandler( "use_cagekey_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_cagekey" );
      cmn.CallEventHandler( "use_cagekey_mid" );
      
      common.CloseSubRoom();
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_ingingerbreadhouse/audio/aud_use_key4lvl");

    ObjSet("anm_magiccrib_use_key",  { alp = 1, playing = 1, endtrig = func_after });
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_gargoylecuffs()

  local item = "inv_gargoylecuffs";

  if ( cmn.ApplyObj( item, "obj_ingingerbreadhouse_use_gargoylecuffs" ) ) then

    cmn.CallEventHandler( "use_gargoylecuffs_inv" );
    cmn.CallEventHandler( "use_gargoylecuffs_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_gargoylecuffs" );
      cmn.CallEventHandler( "use_gargoylecuffs_end" );
      
      public.get_keybunch();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_ingingerbreadhouse/audio/aud_use_handcuffs");

    ObjAnimate("spr_ingingerbreadhouse_gargoyle_hands_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
    ObjAnimate("anm_ingingerbreadhouse_keybunch_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    ObjAnimate("spr_ingingerbreadhouse_keybunch", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_charitypicture()

  local item = "inv_charitypicture";

  if ( cmn.ApplyObj( item, "obj_ingingerbreadhouse_use_charitypicture" ) ) then

    cmn.CallEventHandler( "use_charitypicture_inv" );
    cmn.CallEventHandler( "use_charitypicture_beg" );

    local func_after = function ()

      cmn.Lock( 0 );
      cmn.SetEventDone( "use_charitypicture" );
      
      if cmn.IsEventDone("use_socksforsophia") and cmn.IsEventDone("use_donationcheque") and cmn.IsEventDone("use_rescueddog") then
        common_impl.PlayBackgroundMusic();
        cmn.GotoRoom("ho_lvl4memories");
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_relicstorage/audio/aud_mirror");

    ObjAnimate("spr_ingingerbreadhouse_clue_2_done", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_socksforsophia()

  local item = "inv_socksforsophia";

  if ( cmn.ApplyObj( item, "obj_ingingerbreadhouse_use_socksforsophia" ) ) then

    cmn.CallEventHandler( "use_socksforsophia_inv" );
    cmn.CallEventHandler( "use_socksforsophia_beg" );

    local func_after = function ()

      cmn.Lock( 0 );
      cmn.SetEventDone( "use_socksforsophia" );
      
      if cmn.IsEventDone("use_charitypicture") and cmn.IsEventDone("use_donationcheque") and cmn.IsEventDone("use_rescueddog") then
        common_impl.PlayBackgroundMusic();
        cmn.GotoRoom("ho_lvl4memories");
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_relicstorage/audio/aud_mirror");

    ObjAnimate("spr_ingingerbreadhouse_clue_3_done", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_donationcheque()

  local item = "inv_donationcheque";

  if ( cmn.ApplyObj( item, "obj_ingingerbreadhouse_use_donationcheque" ) ) then

    cmn.CallEventHandler( "use_donationcheque_inv" );
    cmn.CallEventHandler( "use_donationcheque_beg" );

    local func_after = function ()

      cmn.Lock( 0 );
      cmn.SetEventDone( "use_donationcheque" );
      
      if cmn.IsEventDone("use_charitypicture") and cmn.IsEventDone("use_socksforsophia") and cmn.IsEventDone("use_rescueddog") then
        common_impl.PlayBackgroundMusic();
        cmn.GotoRoom("ho_lvl4memories");
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_relicstorage/audio/aud_mirror");

    ObjAnimate("spr_ingingerbreadhouse_clue_1_done", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_rescueddog()

  local item = "inv_rescueddog";

  if ( cmn.ApplyObj( item, "obj_ingingerbreadhouse_use_rescueddog" ) ) then

    cmn.CallEventHandler( "use_rescueddog_inv" );
    cmn.CallEventHandler( "use_rescueddog_beg" );

    local func_after = function ()

      cmn.Lock( 0 );
      cmn.SetEventDone( "use_rescueddog" );
      
      if cmn.IsEventDone("use_charitypicture") and cmn.IsEventDone("use_socksforsophia") and cmn.IsEventDone("use_donationcheque") then
        common_impl.PlayBackgroundMusic();
        cmn.GotoRoom("ho_lvl4memories");
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_relicstorage/audio/aud_mirror");

    ObjAnimate("spr_ingingerbreadhouse_clue_4_done", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_keybunch()

  cmn.SetEventDone( "get_keybunch" );
  cmn.CallEventHandler( "get_keybunch" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_runestone3()
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_runestone3_end" );
    
    common_impl.PlayBackgroundMusic();

  end;

  cmn.SetEventDone( "get_runestone3" );
  cmn.CallEventHandler( "get_runestone3_inv" );
  cmn.CallEventHandler( "get_runestone3_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  ObjAnimate("obj_ingingerbreadhouse_dialog_faerie1", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.5, 0, 0 });

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_ingingerbreadhouse()

  if not ( cmn.IsEventDone( "opn_ingingerbreadhouse" ) ) then
    cmn.SetEventDone( "opn_ingingerbreadhouse" );
    cmn.CallEventHandler("opn_ingingerbreadhouse");
    cmn.ShowBbt( "ingingerbreadhouse_open" );
  end;
  
  if cmn.IsEventDone("get_rescueddog") and not ( cmn.IsEventDone( "opn_ingingerbreadhousewithclues" ) ) then
    
    cmn.SetEventDone( "opn_ingingerbreadhousewithclues" );
    
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    ObjAttach("obj_ingingerbreadhouse_dialog_sophia1", "rm_ingingerbreadhouse");
    ObjAnimate("obj_ingingerbreadhouse_dialog_sophia1", "alp", 0, 0, private.dialog_sophia1_beg, { 0, 0, 0,   0.5, 0, 1 });
    
  end;
  
  if cmn.IsEventDone("use_cagekey") and not cmn.IsEventDone("opn_lvl4nearhospital") then
    
    local func_after_dlg = function ()

      ObjSet("rm_ingingerbreadhouse",  { color_r = 0, color_g = 0, color_b = 0 });
      cmn.GotoRoom("rm_lvl4nearhospital");
      
    end;
    
    cmn.Lock( 0 );
    cmn.StopAllEnv();
    
    cmn.PlayFullscreenVideo( "assets/levels/level4/rm_ingingerbreadhouse/vid_lvl4toreality", func_after_dlg, "assets/levels/level4/rm_ingingerbreadhouse/audio/aud_lvl4_toreality", "");
    
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_cagee()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_magiccrib_use_cagekey" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_ingingerbreadhouse/audio/aud_xx_clk_grill4");
  
  ObjSet("anm_magiccrib_door_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_gargoyle()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_ingingerbreadhouse_use_gargoylecuffs" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_ingingerbreadhouse/audio/aud_xx_pick");
  
  ObjSet("anm_ingingerbreadhouse_keybunch_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
-----------------------------------------------------------------------------------
function private.AnimateDlgClues( num )
  
  local range_y = math.random(2, 8);
  local range_x = math.random(1, 6);
  local dir_y = math.random(1, 2);
  local dir_x = math.random(1, 2);
  if dir_y == 2 then
    dir_y = -1;
  end;
  if dir_x == 2 then
    dir_x = -1;
  end;
  
  ObjAnimate("spr_ingingerbreadhouse_clue_"..num, "pos_y", 1, 0, "", { 
    0, 2, private.clues_pos[num][2],     
    1, 2, private.clues_pos[num][2] + range_y*dir_y,    
    3, 3, private.clues_pos[num][2] - range_y*dir_y,    
    4, 1, private.clues_pos[num][2] 
  });
  ObjAnimate("spr_ingingerbreadhouse_clue_"..num, "pos_x", 1, 0, "", { 
    0, 2, private.clues_pos[num][1],     
    1, 2, private.clues_pos[num][1] + range_x*dir_x,    
    3, 3, private.clues_pos[num][1] - range_x*dir_x,    
    4, 1, private.clues_pos[num][1] 
  });
  
end;
--------------------------------------------------------------------------------------------
function public.opn_magiccrib()
  
  cmn.SetEventDone("opn_magiccrib");
  private.dialog_faerie_open( 1 );
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_faerie_open( num )
  
  private.dlg_finished = false;
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  
  local func_after = function() private.dialog_faerie1_beg(); end;
  if num == 2 then
    func_after = function() private.dialog_faerie2_beg(); end;
  end;
  
  ObjAttach("obj_ingingerbreadhouse_dialog_faerie"..num, "rm_ingingerbreadhouse");
  ObjAnimate("obj_ingingerbreadhouse_dialog_faerie"..num, "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_faerie1_beg()
  
  cmn.Lock(0);
  private.dlg_finished = false;
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "ingingerbreadhouse", "faerie1", 2 );
  
  local dialog_end = function ()
    
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "opn_magiccrib" );
    private.dlg_finished = true;
    
    cmn.ShowBbt( "ingingerbreadhouse_after_dialog_1" );
    interface_impl.ShowGlobalTask();
    
    ObjSet("anm_ingingerbreadhouse_dialog_faerie1_hand_1_out",  { playing = 1 });
    
  end;
  
  local anm_give = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_ingingerbreadhouse_dialog_faerie1_lipsync1");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_ingingerbreadhouse_dialog_faerie1_timer",  { playing = 0 }},
                   {"anm_ingingerbreadhouse_dialog_faerie1_hand_1_give", { alp = 1, playing = 1 }},
                   {"anm_ingingerbreadhouse_dialog_faerie1_hand_1_give_2", { alp = 1, playing = 1, endtrig = dialog_end }},
                   {"anm_ingingerbreadhouse_dialog_faerie1_hand_1", { alp = 0 }},
                   {"obj_ingingerbreadhouse_dialog_faerie1_head", { alp = 1 }} } );
    
  end;
  
  private.dlg_lipsync = "vid_ingingerbreadhouse_dialog_faerie1_lipsync1";

  cmn.ShowDlgBbt( "dlg_faerie1_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level4/rm_ingingerbreadhouse/audio/aud_dlg_fairy1_voc");

  ObjMultiSet( { {"tmr_ingingerbreadhouse_dialog_faerie1_timer", { time = 10, playing = 1, endtrig = anm_give }},
                 {"vid_ingingerbreadhouse_dialog_faerie1_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = anm_give }},
                 {"obj_character_dialog_continue", { event_mup = anm_give }} } );
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_faerie2_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "ingingerbreadhouse", "faerie2", 2 );
  
  local dialog_end = function ()
    
    cmn.CallEventHandler( "use_cagekey_end" );
    
    ObjSet("rm_ingingerbreadhouse",  { color_r = 0, color_g = 0, color_b = 0 });
    cmn.GotoRoom("rm_lvl4nearhospital");
    
  end;
  
  local play_vid = function ()
    
    cmn.Lock(0);
    cmn.StopAllEnv();
    
    cmn.PlayFullscreenVideo( "assets/levels/level4/rm_ingingerbreadhouse/vid_lvl4toreality", dialog_end, "assets/levels/level4/rm_ingingerbreadhouse/audio/aud_lvl4_toreality", "");
    
  end;
  
  local show_clues = function ()
    
    common_impl.current_dialog = "";
    private.dlg_lipsync = "";
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_ingingerbreadhouse_dialog_faerie2_timer",  { playing = 0 }},
                   {"vid_ingingerbreadhouse_dialog_faerie2_lipsync2",  { playing = 0 }} } );
    
    interface.InterfaceSetInput( true );
    cmn.Lock(1);
    
    interface_impl.CluesPanelActivate( function() interface_impl.ShowNewClues( play_vid ); cmn.CallEventHandler("use_cagekey_clues"); end );
    
  end;
  
  local faerie_talks2 = function ()
    
    ObjDelete("vid_ingingerbreadhouse_dialog_faerie2_lipsync1");
    ObjAttach("vid_ingingerbreadhouse_dialog_faerie2_lipsync2", "obj_ingingerbreadhouse_dialog_faerie2_fairy");
    
    cmn.ShowDlgBbt( "dlg_faerie2_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level4/rm_ingingerbreadhouse/audio/aud_dlg_fairy2_2_voc");
    private.dlg_lipsync = "vid_ingingerbreadhouse_dialog_faerie2_lipsync2";
    
    ObjMultiSet( { {"tmr_ingingerbreadhouse_dialog_faerie2_timer", { endtrig = show_clues, time = 11.3, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = show_clues }},
                   {"obj_character_dialog_continue", { event_mup = show_clues }},
                   {"vid_ingingerbreadhouse_dialog_faerie2_lipsync2", { playing = 1 }} } );
    
  end;
  
  private.dlg_lipsync = "vid_ingingerbreadhouse_dialog_faerie2_lipsync1";

  cmn.ShowDlgBbt( "dlg_faerie2_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level4/rm_ingingerbreadhouse/audio/aud_dlg_fairy2_1_voc");

  ObjMultiSet( { {"tmr_ingingerbreadhouse_dialog_faerie2_timer", { time = 9, playing = 1, endtrig = faerie_talks2 }},
                 {"vid_ingingerbreadhouse_dialog_faerie2_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = faerie_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = faerie_talks2 }} } );
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_sophia1_beg()
  
  cmn.Lock(0);
  private.dlg_finished = false;
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "ingingerbreadhouse", "sophia1", 2 );
  
  local dialog_end = function ()
    
    common_impl.current_dialog = "";
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "opn_ingingerbreadhousewithclues" );
    private.dlg_finished = true;
    
    cmn.ShowBbt( "ingingerbreadhouse_after_dialog_3" );
    interface_impl.ShowGlobalTask();
    
  end;
  
  local anm_give = function ()
    
    for i = 1, 4, 1 do
      private.AnimateDlgClues( i );
    end;
    
    ObjDelete("vid_ingingerbreadhouse_dialog_sophia1_lipsync1");
    private.dlg_lipsync = "";
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_ingingerbreadhouse_dialog_sophia1_timer",  { playing = 0 }},
                   {"anm_ingingerbreadhouse_dialog_sophia1_head", { alp = 1 }} } );
    
    ObjAnimate("obj_ingingerbreadhouse_dialog_sophia1_uses", "alp", 0, 0, dialog_end, { 0, 0, 0,   0.5, 0, 1 });
    
  end;
  
  private.dlg_lipsync = "vid_ingingerbreadhouse_dialog_sophia1_lipsync1";

  cmn.ShowDlgBbt( "dlg_sophia1_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level4/rm_ingingerbreadhouse/audio/aud_dlg_sofia1_voc");

  ObjMultiSet( { {"tmr_ingingerbreadhouse_dialog_sophia1_timer", { time = 10.7, playing = 1, endtrig = anm_give }},
                 {"vid_ingingerbreadhouse_dialog_sophia1_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = anm_give }},
                 {"obj_character_dialog_continue", { event_mup = anm_give }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_faerie1()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  private.dlg_finished = true;

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "opn_magiccrib" );
    cmn.ShowBbt( "ingingerbreadhouse_after_dialog_1" );
    interface_impl.ShowGlobalTask();
    
    ObjSet("anm_ingingerbreadhouse_dialog_faerie1_hand_1_out",  { playing = 1 });
    
  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  ObjMultiSet( { {"tmr_ingingerbreadhouse_dialog_faerie1_timer",  { playing = 0 }},
                 {"anm_ingingerbreadhouse_dialog_faerie1_hand_1_give", { alp = 1, playing = 1 }},
                 {"anm_ingingerbreadhouse_dialog_faerie1_hand_1_give_2", { alp = 1, playing = 1, endtrig = func_after_dlg }},
                 {"anm_ingingerbreadhouse_dialog_faerie1_hand_1", { alp = 0 }},
                 {"obj_ingingerbreadhouse_dialog_faerie1_head", { alp = 1 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function public.skip_dlg_faerie2()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  private.dlg_finished = true;
  
  common_impl.current_dialog = "";

  local func_after_dlg = function ()

    --cmn.Lock(0);
    cmn.CallEventHandler( "use_cagekey_end" );
    
    ObjSet("rm_ingingerbreadhouse",  { color_r = 0, color_g = 0, color_b = 0 });
    cmn.GotoRoom("rm_lvl4nearhospital");
    
  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjSet(private.dlg_lipsync,  { playing = 0 });
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  ObjSet("tmr_ingingerbreadhouse_dialog_faerie2_timer",  { playing = 0 });
  
  local play_vid = function ()
    
    cmn.Lock(0);
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level4/rm_ingingerbreadhouse/vid_lvl4toreality", func_after_dlg, "assets/levels/level4/rm_ingingerbreadhouse/audio/aud_lvl4_toreality", "");
    
  end;
  
  interface_impl.CluesPanelActivate( function() interface_impl.ShowNewClues( play_vid ); cmn.CallEventHandler("use_cagekey_clues"); end );
  
end; 
--------------------------------------------------------------------------------------------
function public.skip_dlg_sophia1()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  private.dlg_finished = true;
  common_impl.current_dialog = "";

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "opn_ingingerbreadhousewithclues" );
    cmn.ShowBbt( "ingingerbreadhouse_after_dialog_3" );
    interface_impl.ShowGlobalTask();
    
  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  for i = 1, 4, 1 do
    private.AnimateDlgClues( i );
  end;
  
  ObjMultiSet( { {"tmr_ingingerbreadhouse_dialog_sophia1_timer",  { playing = 0 }},
                 {"anm_ingingerbreadhouse_dialog_sophia1_head", { alp = 1 }} } );
    
  ObjAnimate("obj_ingingerbreadhouse_dialog_sophia1_uses", "alp", 0, 0, func_after_dlg, { 0, 0, 0,   0.5, 0, 1 });
  
end; 
--********************************************************************************************************************