-- name=rm_insophiashouse
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_insophiashouse";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Lvl4chest();
  private.Init_Abovefireplace();
  --------------------------------------------------------------------------------------------
  -- function get_heartsign () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_heartsign" ] = {
        type = "get",
        get_obj = "spr_abovefireplace_heartsign",
        room = private.room_objname,
        zz = "zz_abovefireplace",
        zz_gate = "gzz_insophiashouse_abovefireplace"
    };
    --------------------------------------------------------------------------------------------
  local get_heartsign_inv = function ()
  
    interface.InventoryItemAdd( "inv_heartsign", "spr_abovefireplace_heartsign" );
  
  end;
  
  local get_heartsign_end = function ()
  
    ObjDelete( "gfx_abovefireplace_heartsign" );
    ObjDelete( "spr_abovefireplace_heartsign_sh" );

    ObjDelete( "spr_insophiashouse_abovefireplace_volunteer_sign" );
  
  end;
  
  cmn.AddSubscriber( "get_heartsign", get_heartsign_inv );
  cmn.AddSubscriber( "get_heartsign", get_heartsign_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_newspaperpiece4 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_newspaperpiece4" ] = {
        type = "get",
        get_obj = "spr_abovefireplace_newspaperpiece4",
        room = private.room_objname,
        zz = "zz_abovefireplace",
        zz_gate = "gzz_insophiashouse_abovefireplace"
    };
    --------------------------------------------------------------------------------------------
  local get_newspaperpiece4_inv = function ()
  
    interface.InventoryItemAdd( "inv_newspaperpiece", "spr_abovefireplace_newspaperpiece4", function () cmn.GetMultyObject( 'newspaperpiece', 4 ); end );
      
    if cmn.CheckMultiObject( "newspaperpiece", 4 ) then
      ObjSet("inv_burntnewspaper_star_light",  { alp = 1 });
    end;
  
  end;
  
  local get_newspaperpiece4_end = function ()
  
    ObjDelete( "gfx_abovefireplace_newspaperpiece4" );
    ObjDelete( "spr_abovefireplace_newspaperpiece4_sh" );
    
    if cmn.IsEventDone("get_curtaintieback2") then
      ObjSet("gzz_insophiashouse_abovefireplace",  { active = 0, alp = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_newspaperpiece4", get_newspaperpiece4_inv );
  cmn.AddSubscriber( "get_newspaperpiece4", get_newspaperpiece4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pinkbow () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_pinkbow" ] = {
        type = "get",
        get_obj = "spr_abovefireplace_pinkbow",
        room = private.room_objname,
        zz = "zz_abovefireplace",
        zz_gate = "gzz_insophiashouse_abovefireplace"
    };
    --------------------------------------------------------------------------------------------
  local get_pinkbow_inv = function ()
  
    interface.InventoryItemAdd( "inv_pinkbow", "spr_abovefireplace_pinkbow" );
  
  end;
  
  local get_pinkbow_end = function ()
  
    ObjDelete( "gfx_abovefireplace_pinkbow" );
    ObjDelete( "spr_abovefireplace_pinkbow_sh" );

    ObjDelete( "spr_insophiashouse_abovefireplace_pinkbow" );
  
  end;
  
  cmn.AddSubscriber( "get_pinkbow", get_pinkbow_inv );
  cmn.AddSubscriber( "get_pinkbow", get_pinkbow_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_curtaintieback2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_curtaintieback2" ] = {
        type = "get",
        get_obj = "spr_abovefireplace_curtaintieback2",
        room = private.room_objname,
        zz = "zz_abovefireplace",
        zz_gate = "gzz_insophiashouse_abovefireplace"
    };
    --------------------------------------------------------------------------------------------
  local get_curtaintieback2_inv = function ()
  
    interface.InventoryItemAdd( "inv_curtaintieback2", "spr_abovefireplace_curtaintieback2" );
  
  end;
  
  local get_curtaintieback2_end = function ()
  
    ObjDelete( "gfx_abovefireplace_curtaintieback2" );
    ObjDelete( "spr_abovefireplace_curtaintieback2_sh" );
    
    if cmn.IsEventDone("get_newspaperpiece4") then
      ObjSet("gzz_insophiashouse_abovefireplace",  { active = 0, alp = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_curtaintieback2", get_curtaintieback2_inv );
  cmn.AddSubscriber( "get_curtaintieback2", get_curtaintieback2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_clawedpaw () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_clawedpaw" ] = {
        type = "get",
        get_obj = "spr_abovefireplace_clawedpaw",
        room = private.room_objname,
        zz = "zz_abovefireplace",
        zz_gate = "gzz_insophiashouse_abovefireplace"
    };
    --------------------------------------------------------------------------------------------
  local get_clawedpaw_inv = function ()
  
    interface.InventoryItemAdd( "inv_clawedpaw", "spr_abovefireplace_clawedpaw" );
    ObjSet("inv_brokenfigurine_star_light",  { alp = 1 });
  
  end;
  
  local get_clawedpaw_end = function ()
  
    ObjDelete( "gfx_abovefireplace_clawedpaw" );
    ObjDelete( "spr_abovefireplace_clawedpaw_sh" );

    ObjDelete( "spr_insophiashouse_abovefireplace_paw" );
  
  end;
  
  cmn.AddSubscriber( "get_clawedpaw", get_clawedpaw_inv );
  cmn.AddSubscriber( "get_clawedpaw", get_clawedpaw_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stetoscopeamulet () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_stetoscopeamulet" ] = {
        type = "get",
        get_obj = "spr_phonetable_stetoscopeamulet",
        room = private.room_objname,
        zz = "zz_phonetable",
        zz_gate = "gzz_insophiashouse_phonetable"
    };
    --------------------------------------------------------------------------------------------
  local get_stetoscopeamulet_inv = function ()
  
    interface.InventoryItemAdd( "inv_stetoscopeamulet", "spr_phonetable_stetoscopeamulet" );
  
  end;
  
  local get_stetoscopeamulet_end = function ()
  
    ObjDelete( "gfx_phonetable_stetoscopeamulet" );
    ObjDelete( "spr_phonetable_stetoscopeamulet_sh" );

    ObjDelete( "spr_insophiashouse_phonetable_stetoscopeamulet" );
  
  end;
  
  cmn.AddSubscriber( "get_stetoscopeamulet", get_stetoscopeamulet_inv );
  cmn.AddSubscriber( "get_stetoscopeamulet", get_stetoscopeamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_honeyspoon () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_honeyspoon" ] = {
        type = "get",
        get_obj = "spr_phonetable_honeyspoon",
        room = private.room_objname,
        zz = "zz_phonetable",
        zz_gate = "gzz_insophiashouse_phonetable"
    };
    --------------------------------------------------------------------------------------------
  local get_honeyspoon_inv = function ()
  
    interface.InventoryItemAdd( "inv_honeyspoon", "spr_phonetable_honeyspoon" );
  
  end;
  
  local get_honeyspoon_end = function ()
  
    ObjDelete( "gfx_phonetable_honeyspoon" );
    ObjDelete( "spr_phonetable_honeyspoon_sh" );

    ObjDelete( "spr_insophiashouse_phonetable_honey_spoon" );
    
    if cmn.IsEventDone("get_tape") and cmn.IsEventDone("get_newspaperpiece3") then
      ObjDelete( "gzz_insophiashouse_phonetable" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_honeyspoon", get_honeyspoon_inv );
  cmn.AddSubscriber( "get_honeyspoon", get_honeyspoon_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crosskey () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_crosskey" ] = {
        type = "get",
        get_obj = "spr_phonetable_crosskey",
        room = private.room_objname,
        zz = "zz_phonetable",
        zz_gate = "gzz_insophiashouse_phonetable"
    };
    --------------------------------------------------------------------------------------------
  local get_crosskey_inv = function ()
  
    interface.InventoryItemAdd( "inv_crosskey", "spr_phonetable_crosskey" );
  
  end;
  
  local get_crosskey_end = function ()
  
    ObjDelete( "gfx_phonetable_crosskey" );
    ObjDelete( "spr_phonetable_crosskey_sh" );

    ObjDelete( "spr_insophiashouse_phonetable_key" );
  
  end;
  
  cmn.AddSubscriber( "get_crosskey", get_crosskey_inv );
  cmn.AddSubscriber( "get_crosskey", get_crosskey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tape () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_tape" ] = {
        type = "get",
        get_obj = "spr_phonetable_tape",
        room = private.room_objname,
        zz = "zz_phonetable",
        zz_gate = "gzz_insophiashouse_phonetable"
    };
    --------------------------------------------------------------------------------------------
  local get_tape_inv = function ()
  
    interface.InventoryItemAdd( "inv_tape", "spr_phonetable_tape" );
    ObjSet("inv_burntnewspaper_star_light",  { alp = 1 });
  
  end;
  
  local get_tape_end = function ()
  
    ObjDelete( "gfx_phonetable_tape" );
    ObjDelete( "spr_phonetable_tape_sh" );

    ObjDelete( "spr_insophiashouse_phonetable_scotchtape" );
    
    if cmn.IsEventDone("get_honeyspoon") and cmn.IsEventDone("get_newspaperpiece3") then
      ObjDelete( "gzz_insophiashouse_phonetable" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_tape", get_tape_inv );
  cmn.AddSubscriber( "get_tape", get_tape_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bluebow () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_bluebow" ] = {
        type = "get",
        get_obj = "spr_phonetable_bluebow",
        room = private.room_objname,
        zz = "zz_phonetable",
        zz_gate = "gzz_insophiashouse_phonetable"
    };
    --------------------------------------------------------------------------------------------
  local get_bluebow_inv = function ()
  
    interface.InventoryItemAdd( "inv_bluebow", "spr_phonetable_bluebow" );
  
  end;
  
  local get_bluebow_end = function ()
  
    ObjDelete( "gfx_phonetable_bluebow" );
    ObjDelete( "spr_phonetable_bluebow_sh" );

    ObjDelete( "spr_insophiashouse_phonetable_bluebow" );
  
  end;
  
  cmn.AddSubscriber( "get_bluebow", get_bluebow_inv );
  cmn.AddSubscriber( "get_bluebow", get_bluebow_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_newspaperpiece3 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_newspaperpiece3" ] = {
        type = "get",
        get_obj = "spr_phonetable_newspaperpiece3",
        room = private.room_objname,
        zz = "zz_phonetable",
        zz_gate = "gzz_insophiashouse_phonetable"
    };
    --------------------------------------------------------------------------------------------
  local get_newspaperpiece3_inv = function ()
  
    interface.InventoryItemAdd( "inv_newspaperpiece", "spr_phonetable_newspaperpiece3", function () cmn.GetMultyObject( 'newspaperpiece', 4 ); end );
    
    if cmn.CheckMultiObject( "newspaperpiece", 4 ) then
      ObjSet("inv_burntnewspaper_star_light",  { alp = 1 });
    end;
      
  end;
  
  local get_newspaperpiece3_end = function ()
  
    ObjDelete( "gfx_phonetable_newspaperpiece3" );
    ObjDelete( "spr_phonetable_newspaperpiece3_sh" );

    ObjDelete( "spr_insophiashouse_phonetable_neespaper_3" );
    
    if cmn.IsEventDone("get_honeyspoon") and cmn.IsEventDone("get_tape") then
      ObjDelete( "gzz_insophiashouse_phonetable" );
    end;

  end;
  
  cmn.AddSubscriber( "get_newspaperpiece3", get_newspaperpiece3_inv );
  cmn.AddSubscriber( "get_newspaperpiece3", get_newspaperpiece3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rescueddog () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_rescueddog" ] = {
        type = "get",
        get_obj = "spr_undersofa_rescueddog",
        room = private.room_objname,
        zz = "zz_undersofa",
        zz_gate = "gzz_insophiashouse_undersofa"
    };
    --------------------------------------------------------------------------------------------
  local get_rescueddog_inv = function ()
  
    interface.InventoryItemAdd( "inv_rescueddog", "spr_undersofa_rescueddog" );
    
  end;
  local get_rescueddog_clues = function ()
  
    interface_impl.SetCompleteClues( {4} );
    
  end;
  local get_rescueddog_end = function ()
  
    ObjDelete( "gfx_undersofa_rescueddog" );
    ObjDelete( "gzz_insophiashouse_undersofa" );
    ObjDelete( "spr_insophiashouse_undersofa_dog_incage" );
  
  end;
  
  cmn.AddSubscriber( "get_rescueddog", get_rescueddog_inv );
  cmn.AddSubscriber( "get_rescueddog", get_rescueddog_clues );
  cmn.AddSubscriber( "get_rescueddog", get_rescueddog_end, private.room_objname );
  cmn.AddSubscriber( "get_rescueddog_inv", get_rescueddog_inv );
  cmn.AddSubscriber( "get_rescueddog_clues", get_rescueddog_clues );
  cmn.AddSubscriber( "get_rescueddog_end", get_rescueddog_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokenfigurine () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_brokenfigurine" ] = {
        type = "get",
        get_obj = "spr_undersofa_brokenfigurine",
        room = private.room_objname,
        zz = "zz_undersofa",
        zz_gate = "gzz_insophiashouse_undersofa"
    };
    --------------------------------------------------------------------------------------------
  local get_brokenfigurine_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_brokenfigurine", "spr_undersofa_brokenfigurine" );
  
  end;
  
  local get_brokenfigurine_end = function ()
  
    ObjDelete( "gfx_undersofa_brokenfigurine" );
    ObjDelete( "spr_undersofa_brokenfigurine_sh" );

    ObjDelete( "spr_insophiashouse_undersofa_brokenfigurine" );
  
  end;
  
  cmn.AddSubscriber( "get_brokenfigurine", get_brokenfigurine_inv );
  cmn.AddSubscriber( "get_brokenfigurine", get_brokenfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl4spade () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_lvl4spade" ] = {
        type = "get",
        get_obj = "spr_lvl4chest_lvl4spade",
        room = private.room_objname,
        zz = "zz_lvl4chest",
        zz_gate = "gzz_insophiashouse_lvl4chest"
    };
    --------------------------------------------------------------------------------------------
  local get_lvl4spade_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl4spade", "spr_lvl4chest_lvl4spade" );
  
  end;
  
  local get_lvl4spade_end = function ()
  
    ObjDelete( "gfx_lvl4chest_lvl4spade" );
    
    if cmn.IsEventDone("get_collectionstamp1") and cmn.IsEventDone("get_nailpuller") then
      ObjDelete( "gzz_insophiashouse_lvl4chest" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_lvl4spade", get_lvl4spade_inv );
  cmn.AddSubscriber( "get_lvl4spade", get_lvl4spade_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collectionstamp1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_collectionstamp1" ] = {
        type = "get",
        get_obj = "spr_lvl4chest_collectionstamp1",
        room = private.room_objname,
        zz = "zz_lvl4chest",
        zz_gate = "gzz_insophiashouse_lvl4chest"
    };
    --------------------------------------------------------------------------------------------
  local get_collectionstamp1_inv = function ()
  
    interface.InventoryItemAdd( "inv_collectionstamp1", "spr_lvl4chest_collectionstamp1" );
  
  end;
  
  local get_collectionstamp1_end = function ()
  
    ObjDelete( "gfx_lvl4chest_collectionstamp1" );
    
    if cmn.IsEventDone("get_lvl4spade") and cmn.IsEventDone("get_nailpuller") then
      ObjDelete( "gzz_insophiashouse_lvl4chest" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_collectionstamp1", get_collectionstamp1_inv );
  cmn.AddSubscriber( "get_collectionstamp1", get_collectionstamp1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_oldglasses () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_oldglasses" ] = {
        type = "get",
        get_obj = "spr_lvl4chest_oldglasses",
        room = private.room_objname,
        zz = "zz_lvl4chest",
        zz_gate = "gzz_insophiashouse_lvl4chest"
    };
    --------------------------------------------------------------------------------------------
  local get_oldglasses_inv = function ()
  
    interface.InventoryItemAdd( "inv_oldglasses", "spr_lvl4chest_oldglasses" );
  
  end;
  
  local get_oldglasses_end = function ()
  
    ObjDelete( "gfx_lvl4chest_oldglasses" );
    ObjDelete( "spr_lvl4chest_oldglasses_sh" );
    
  end;
  
  cmn.AddSubscriber( "get_oldglasses", get_oldglasses_inv );
  cmn.AddSubscriber( "get_oldglasses", get_oldglasses_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_nailpuller () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_nailpuller" ] = {
        type = "get",
        get_obj = "spr_lvl4chest_nailpuller",
        room = private.room_objname,
        zz = "zz_lvl4chest",
        zz_gate = "gzz_insophiashouse_lvl4chest"
    };
    --------------------------------------------------------------------------------------------
  local get_nailpuller_inv = function ()
  
    interface.InventoryItemAdd( "inv_nailpuller", "spr_lvl4chest_nailpuller" );
  
  end;
  
  local get_nailpuller_end = function ()
  
    ObjDelete( "gfx_lvl4chest_nailpuller" );
    
    if cmn.IsEventDone("get_lvl4spade") and cmn.IsEventDone("get_collectionstamp1") then
      ObjDelete( "gzz_insophiashouse_lvl4chest" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_nailpuller", get_nailpuller_inv );
  cmn.AddSubscriber( "get_nailpuller", get_nailpuller_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokendogcase () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_brokendogcase" ] = {
        type = "get",
        get_obj = "spr_lvl4chest_brokendogcase",
        room = private.room_objname,
        zz = "zz_lvl4chest",
        zz_gate = "gzz_insophiashouse_lvl4chest"
    };
    --------------------------------------------------------------------------------------------
  local get_brokendogcase_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_brokendogcase", "spr_lvl4chest_brokendogcase" );
    interface_impl.SetCurrentGlobalTask( 28 );
  
  end;
  
  local get_brokendogcase_end = function ()
  
    ObjDelete( "gfx_lvl4chest_brokendogcase" );
    ObjDelete( "spr_lvl4chest_brokendogcase_sh" );
    
    ObjSet("obj_lvl4chest_use_woodensquare",  { input = 1 });
  
  end;
  
  cmn.AddSubscriber( "get_brokendogcase", get_brokendogcase_inv );
  cmn.AddSubscriber( "get_brokendogcase", get_brokendogcase_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_eaglefeather () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_eaglefeather" ] = {
        type = "use",
        inv_obj = "inv_eaglefeather",
        use_place = "obj_abovefireplace_use_eaglefeather",
        room = private.room_objname,
        zz = "zz_abovefireplace",
        zz_gate = "gzz_insophiashouse_abovefireplace"
    };
  --------------------------------------------------------------------------------------------
  local use_eaglefeather_inv = function ()
  
    interface.InventoryItemRemove( "inv_eaglefeather" );
  
  end;
  local use_eaglefeather_beg = function ()
  
    ObjDelete( "obj_abovefireplace_use_eaglefeather" );
    ObjDelete( "anm_abovefireplace_eagle_touch" );
    ObjDelete( "spr_abovefireplace_eagle_1" );
    ObjDelete( "spr_abovefireplace_eagle_1_sh" );
  
  end;
  local use_eaglefeather_end = function ()
    
    ObjSet("anm_abovefireplace_eagle_feather",  { alp = 1, frame = 300 });
    ObjAttach("anm_abovefireplace_eagle_feather", "obj_abovefireplace_birds_open");
  
    if cmn.IsEventDone("use_crowfeather") then
      ObjDelete( "spr_insophiashouse_abovefireplace_clock" );
      ObjMultiSet( { {"obj_abovefireplace_birds_open", { alp = 1 }},
                     {"spr_insophiashouse_abovefireplace_clock_opn", { alp = 1 }},
                     {"gzz_abovefireplace_mmg", { alp = 1, input = 1, active = 1 }},
                     {"spr_insophiashouse_abovefireplace_clock_game", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_eaglefeather", use_eaglefeather_beg, private.room_objname );
  cmn.AddSubscriber( "use_eaglefeather", use_eaglefeather_inv );
  cmn.AddSubscriber( "use_eaglefeather", use_eaglefeather_end, private.room_objname );
  cmn.AddSubscriber( "use_eaglefeather_inv", use_eaglefeather_inv, private.room_objname );
  cmn.AddSubscriber( "use_eaglefeather_beg", use_eaglefeather_beg, private.room_objname );
  cmn.AddSubscriber( "use_eaglefeather_end", use_eaglefeather_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crowfeather () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_crowfeather" ] = {
        type = "use",
        inv_obj = "inv_crowfeather",
        use_place = "obj_abovefireplace_use_crowfeather",
        room = private.room_objname,
        zz = "zz_abovefireplace",
        zz_gate = "gzz_insophiashouse_abovefireplace"
    };
  --------------------------------------------------------------------------------------------
  local use_crowfeather_inv = function ()
  
    interface.InventoryItemRemove( "inv_crowfeather" );
  
  end;
  local use_crowfeather_beg = function ()
  
    ObjDelete( "obj_abovefireplace_use_crowfeather" );
    ObjDelete( "anm_abovefireplace_crow_touch" );
    ObjDelete( "spr_abovefireplace_crow_1" );
    ObjDelete( "spr_abovefireplace_crow_1_sh" );
  
  end;
  local use_crowfeather_end = function ()
    
    ObjSet("anm_abovefireplace_crow_feather",  { alp = 1, frame = 300 });
    ObjAttach("anm_abovefireplace_crow_feather", "obj_abovefireplace_birds_open");
  
    if cmn.IsEventDone("use_eaglefeather") then
      ObjDelete( "spr_insophiashouse_abovefireplace_clock" );
      ObjMultiSet( { {"obj_abovefireplace_birds_open", { alp = 1 }},
                     {"spr_insophiashouse_abovefireplace_clock_opn", { alp = 1 }},
                     {"gzz_abovefireplace_mmg", { alp = 1, input = 1, active = 1 }},
                     {"spr_insophiashouse_abovefireplace_clock_game", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crowfeather", use_crowfeather_beg, private.room_objname );
  cmn.AddSubscriber( "use_crowfeather", use_crowfeather_inv );
  cmn.AddSubscriber( "use_crowfeather", use_crowfeather_end, private.room_objname );
  cmn.AddSubscriber( "use_crowfeather_inv", use_crowfeather_inv, private.room_objname );
  cmn.AddSubscriber( "use_crowfeather_beg", use_crowfeather_beg, private.room_objname );
  cmn.AddSubscriber( "use_crowfeather_end", use_crowfeather_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shipmodel () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_shipmodel" ] = {
        type = "use",
        inv_obj = "inv_shipmodel",
        use_place = "obj_abovefireplace_use_shipmodel",
        room = private.room_objname,
        zz = "zz_abovefireplace",
        zz_gate = "gzz_insophiashouse_abovefireplace"
    };
  --------------------------------------------------------------------------------------------
  local use_shipmodel_inv = function ()
  
    interface.InventoryItemRemove( "inv_shipmodel" );
  
  end;
  local use_shipmodel_beg = function ()
  
    ObjDelete( "obj_abovefireplace_use_shipmodel" );
  
  end;
  local use_shipmodel_end = function ()
    
    ObjDelete( "anm_abovefireplace_casket_touch" );
  
    ObjMultiSet( { {"obj_abovefireplace_casket_open", { alp = 1, input = 1 }},
                   {"spr_abovefireplace_casket_open", { alp = 1 }},
                   {"spr_insophiashouse_abovefireplace_opened_cup", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_shipmodel", use_shipmodel_beg, private.room_objname );
  cmn.AddSubscriber( "use_shipmodel", use_shipmodel_inv );
  cmn.AddSubscriber( "use_shipmodel", use_shipmodel_end, private.room_objname );
  cmn.AddSubscriber( "use_shipmodel_inv", use_shipmodel_inv, private.room_objname );
  cmn.AddSubscriber( "use_shipmodel_beg", use_shipmodel_beg, private.room_objname );
  cmn.AddSubscriber( "use_shipmodel_end", use_shipmodel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_nursekeys () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_nursekeys" ] = {
        type = "use",
        inv_obj = "inv_nursekeys",
        use_place = "obj_phonetable_use_nursekeys",
        room = private.room_objname,
        zz = "zz_phonetable",
        zz_gate = "gzz_insophiashouse_phonetable"
    };
  --------------------------------------------------------------------------------------------
  local use_nursekeys_inv = function ()
  
    interface.InventoryItemRemove( "inv_nursekeys" );
  
  end;
  local use_nursekeys_beg = function ()
  
    ObjDelete( "obj_phonetable_use_nursekeys" );
    ObjDelete( "anm_phonetable_drawer_1_touch" );
  
  end;
  local use_nursekeys_end = function ()

    ObjDelete( "spr_insophiashouse_phonetable_box1door" );
  
    ObjMultiSet( { { "anm_phonetable_use_ring", { alp = 1, input = 1, frame = 300 } },
                   { "obj_insophiashouse_phonetable_box1_opn", { alp = 1 } } } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_nursekeys", use_nursekeys_beg, private.room_objname );
  cmn.AddSubscriber( "use_nursekeys", use_nursekeys_inv );
  cmn.AddSubscriber( "use_nursekeys", use_nursekeys_end, private.room_objname );
  cmn.AddSubscriber( "use_nursekeys_inv", use_nursekeys_inv, private.room_objname );
  cmn.AddSubscriber( "use_nursekeys_beg", use_nursekeys_beg, private.room_objname );
  cmn.AddSubscriber( "use_nursekeys_end", use_nursekeys_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ballerina () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_ballerina" ] = {
        type = "use",
        inv_obj = "inv_ballerina",
        use_place = "obj_phonetable_use_ballerina",
        room = private.room_objname,
        zz = "zz_phonetable",
        zz_gate = "gzz_insophiashouse_phonetable"
    };
  --------------------------------------------------------------------------------------------
  local use_ballerina_inv = function ()
  
    interface.InventoryItemRemove( "inv_ballerina" );
  
  end;
  local use_ballerina_beg = function ()
  
    ObjDelete( "obj_phonetable_use_ballerina" );
    ObjDelete( "anm_phonetable_musicbox_touch" );
    ObjSet("obj_phonetable_musicbox",  { alp = 1 });
  
  end;
  local use_ballerina_end = function ()
  
    ObjDelete( "spr_insophiashouse_phonetable_musicbox_closed" );

    ObjMultiSet( { { "anm_phonetable_use_ballerina",  { alp = 1, input = 1, frame = 300 } },
                   { "obj_insophiashouse_phonetable_musicbox_opn", { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ballerina", use_ballerina_beg, private.room_objname );
  cmn.AddSubscriber( "use_ballerina", use_ballerina_inv );
  cmn.AddSubscriber( "use_ballerina", use_ballerina_end, private.room_objname );
  cmn.AddSubscriber( "use_ballerina_inv", use_ballerina_inv, private.room_objname );
  cmn.AddSubscriber( "use_ballerina_beg", use_ballerina_beg, private.room_objname );
  cmn.AddSubscriber( "use_ballerina_end", use_ballerina_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lockpart () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_lockpart" ] = {
        type = "use",
        inv_obj = "inv_lockpart",
        use_place = "obj_phonetable_use_lockpart",
        room = private.room_objname,
        zz = "zz_phonetable",
        zz_gate = "gzz_insophiashouse_phonetable"
    };
  --------------------------------------------------------------------------------------------
  local use_lockpart_inv = function ()
  
    interface.InventoryItemRemove( "inv_lockpart" );
  
  end;
  local use_lockpart_beg = function ()
  
    ObjDelete( "obj_phonetable_use_lockpart" );
    ObjDelete( "anm_phonetable_drawer_2_touch" );
  
  end;
  local use_lockpart_end = function ()
  
    ObjDelete( "spr_insophiashouse_phonetable_box2door" );

    ObjMultiSet( { { "anm_phonetable_use_lockparts",  { alp = 1, input = 1, frame = 300 } },
                   { "obj_insophiashouse_phonetable_box2_opn", { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lockpart", use_lockpart_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockpart", use_lockpart_inv );
  cmn.AddSubscriber( "use_lockpart", use_lockpart_end, private.room_objname );
  cmn.AddSubscriber( "use_lockpart_inv", use_lockpart_inv, private.room_objname );
  cmn.AddSubscriber( "use_lockpart_beg", use_lockpart_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockpart_end", use_lockpart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_twotoothedfork () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_twotoothedfork" ] = {
        type = "use",
        inv_obj = "inv_twotoothedfork",
        use_place = "obj_undersofa_use_twotoothedfork",
        room = private.room_objname,
        zz = "zz_undersofa",
        zz_gate = "gzz_insophiashouse_undersofa"
    };
  --------------------------------------------------------------------------------------------
  local use_twotoothedfork_inv = function ()
  
    interface.InventoryItemRemove( "inv_twotoothedfork" );
  
  end;
  local use_twotoothedfork_beg = function ()
  
    ObjDelete( "obj_undersofa_use_twotoothedfork" );
    ObjDelete( "obj_undersofa_sofa_1" );
    
    ObjMultiSet( { {"spr_undersofa_brokenfigurine", { alp = 1, input = 1 }},
                   {"spr_undersofa_brokenfigurine_sh", { alp = 1 }} } );
  
  end;
  local use_twotoothedfork_end = function ()
  
    ObjSet( "anm_undersofa_use_fork", { frame = 300, alp = 1 } );

    ObjDelete( "spr_insophiashouse_undersofa_cover" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_twotoothedfork", use_twotoothedfork_beg, private.room_objname );
  cmn.AddSubscriber( "use_twotoothedfork", use_twotoothedfork_inv );
  cmn.AddSubscriber( "use_twotoothedfork", use_twotoothedfork_end, private.room_objname );
  cmn.AddSubscriber( "use_twotoothedfork_inv", use_twotoothedfork_inv, private.room_objname );
  cmn.AddSubscriber( "use_twotoothedfork_beg", use_twotoothedfork_beg, private.room_objname );
  cmn.AddSubscriber( "use_twotoothedfork_end", use_twotoothedfork_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_dogcage () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_dogcage" ] = {
        type = "use",
        inv_obj = "inv_dogcage",
        use_place = "obj_undersofa_use_dogcage",
        room = private.room_objname,
        zz = "zz_undersofa",
        zz_gate = "gzz_insophiashouse_undersofa"
    };
  --------------------------------------------------------------------------------------------
  local use_dogcage_inv = function ()
  
    interface.InventoryItemRemove( "inv_dogcage" );
  
  end;
  local use_dogcage_beg = function ()
  
    ObjDelete( "obj_undersofa_use_dogcage" );
    
  end;
  local use_dogcage_end = function ()
    
    ObjDelete( "anm_undersofa_use_cage" );
    ObjDelete( "anm_undersofa_dog_go" );
    ObjDelete( "anm_undersofa_dog" );
    ObjDelete( "anm_undersofa_dog_touch" );

    ObjDelete( "anm_insophiashouse_dog" );
  
    ObjMultiSet( { {"spr_undersofa_rescueddog", { alp = 1, input = 1 }},
                   {"spr_insophiashouse_undersofa_dog_incage", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_dogcage", use_dogcage_beg, private.room_objname );
  cmn.AddSubscriber( "use_dogcage", use_dogcage_inv );
  cmn.AddSubscriber( "use_dogcage", use_dogcage_end, private.room_objname );
  cmn.AddSubscriber( "use_dogcage_inv", use_dogcage_inv, private.room_objname );
  cmn.AddSubscriber( "use_dogcage_beg", use_dogcage_beg, private.room_objname );
  cmn.AddSubscriber( "use_dogcage_end", use_dogcage_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_woodensquare () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_woodensquare" ] = {
        type = "use",
        inv_obj = "inv_woodensquare",
        use_place = "obj_lvl4chest_use_woodensquare",
        room = private.room_objname,
        zz = "zz_lvl4chest",
        zz_gate = "gzz_insophiashouse_lvl4chest"
    };
  --------------------------------------------------------------------------------------------
  local use_woodensquare_inv = function ()
  
    interface.InventoryItemRemove( "inv_woodensquare" );
  
  end;
  local use_woodensquare_beg = function ()
  
    ObjDelete( "obj_lvl4chest_use_woodensquare" );
  
  end;
  local use_woodensquare_end = function ()
  
    ObjSet("obj_lvl4chest_game", { alp = 1, input = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_woodensquare", use_woodensquare_beg, private.room_objname );
  cmn.AddSubscriber( "use_woodensquare", use_woodensquare_inv );
  cmn.AddSubscriber( "use_woodensquare", use_woodensquare_end, private.room_objname );
  cmn.AddSubscriber( "use_woodensquare_inv", use_woodensquare_inv, private.room_objname );
  cmn.AddSubscriber( "use_woodensquare_beg", use_woodensquare_beg, private.room_objname );
  cmn.AddSubscriber( "use_woodensquare_end", use_woodensquare_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ornament1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_ornament1" ] = {
        type = "use",
        inv_obj = "inv_ornament1",
        use_place = "obj_lvl4chest_use_ornament1",
        room = private.room_objname,
        zz = "zz_lvl4chest",
        zz_gate = "gzz_insophiashouse_lvl4chest"
    };
  --------------------------------------------------------------------------------------------
  local use_ornament1_inv = function ()
  
    interface.InventoryItemRemove( "inv_ornament1" );
  
  end;
  local use_ornament1_beg = function ()
  
    ObjDelete( "obj_lvl4chest_use_ornament1" );
  
  end;
  local use_ornament1_end = function ()

    ObjSet( "spr_insophiashouse_lvl4chest_ornament1", { alp = 1 } );
  
    if cmn.IsEventDone("use_ornament2") then

      ObjDelete( "anm_lvl4chest_chest_touch" );
      ObjDelete( "anm_lvl4chest_chest_open" );

      ObjDelete( "spr_insophiashouse_lvl4chest_lock" );
      ObjDelete( "spr_insophiashouse_lvl4chest_boxclosed" );

      ObjMultiSet( { { "obj_lvl4chest_inside_chest",  { alp = 1, input = 1 } },
                     { "spr_insophiashouse_lvl4chest_box_opn", { alp = 1 } } } );

    else 
      ObjSet("spr_lvl4chest_ornament1",  { alp = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ornament1", use_ornament1_beg, private.room_objname );
  cmn.AddSubscriber( "use_ornament1", use_ornament1_inv );
  cmn.AddSubscriber( "use_ornament1", use_ornament1_end, private.room_objname );
  cmn.AddSubscriber( "use_ornament1_inv", use_ornament1_inv, private.room_objname );
  cmn.AddSubscriber( "use_ornament1_beg", use_ornament1_beg, private.room_objname );
  cmn.AddSubscriber( "use_ornament1_end", use_ornament1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ornament2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_ornament2" ] = {
        type = "use",
        inv_obj = "inv_ornament2",
        use_place = "obj_lvl4chest_use_ornament2",
        room = private.room_objname,
        zz = "zz_lvl4chest",
        zz_gate = "gzz_insophiashouse_lvl4chest"
    };
  --------------------------------------------------------------------------------------------
  local use_ornament2_inv = function ()
  
    interface.InventoryItemRemove( "inv_ornament2" );
  
  end;
  local use_ornament2_beg = function ()
  
    ObjDelete( "obj_lvl4chest_use_ornament2" );
  
  end;
  local use_ornament2_end = function ()

    ObjSet( "spr_insophiashouse_lvl4chest_ornament2", { alp = 1 } );
  
    if cmn.IsEventDone("use_ornament1") then

      ObjDelete( "anm_lvl4chest_chest_touch" );
      ObjDelete( "anm_lvl4chest_chest_open" );
      ObjDelete( "spr_insophiashouse_lvl4chest_lock" );
      ObjDelete( "spr_insophiashouse_lvl4chest_boxclosed" );

      ObjMultiSet( { { "obj_lvl4chest_inside_chest",  { alp = 1, input = 1 } },
                     { "spr_insophiashouse_lvl4chest_box_opn", { alp = 1 } } } );

    else 
      ObjSet("spr_lvl4chest_ornament2",  { alp = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ornament2", use_ornament2_beg, private.room_objname );
  cmn.AddSubscriber( "use_ornament2", use_ornament2_inv );
  cmn.AddSubscriber( "use_ornament2", use_ornament2_end, private.room_objname );
  cmn.AddSubscriber( "use_ornament2_inv", use_ornament2_inv, private.room_objname );
  cmn.AddSubscriber( "use_ornament2_beg", use_ornament2_beg, private.room_objname );
  cmn.AddSubscriber( "use_ornament2_end", use_ornament2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_curtaintieback1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_curtaintieback1" ] = {
        type = "use",
        inv_obj = "inv_curtaintieback1",
        use_place = "obj_insophiashouse_use_curtaintieback1",
        room = private.room_objname
    };
  --------------------------------------------------------------------------------------------
  local use_curtaintieback1_inv = function ()
  
    interface.InventoryItemRemove( "inv_curtaintieback1" );
  
  end;
  local use_curtaintieback1_beg = function ()
  
    ObjDelete( "obj_insophiashouse_use_curtaintieback1" );
  
  end;
  local use_curtaintieback1_end = function ()

    ObjDelete( "anm_insophiashouse_curtain1" );
    ObjSet( "anm_insophiashouse_curtain_opn1", { alp = 1 } );
  
    if cmn.IsEventDone("use_curtaintieback2") then
      ObjSet( "gho_insophiashouse_dogarea", { input = 1, alp = 1, active = 1 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_curtaintieback1", use_curtaintieback1_beg, private.room_objname );
  cmn.AddSubscriber( "use_curtaintieback1", use_curtaintieback1_inv );
  cmn.AddSubscriber( "use_curtaintieback1", use_curtaintieback1_end, private.room_objname );
  cmn.AddSubscriber( "use_curtaintieback1_inv", use_curtaintieback1_inv, private.room_objname );
  cmn.AddSubscriber( "use_curtaintieback1_beg", use_curtaintieback1_beg, private.room_objname );
  cmn.AddSubscriber( "use_curtaintieback1_end", use_curtaintieback1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_curtaintieback2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_curtaintieback2" ] = {
        type = "use",
        inv_obj = "inv_curtaintieback2",
        use_place = "obj_insophiashouse_use_curtaintieback2",
        room = private.room_objname
    };
  --------------------------------------------------------------------------------------------
  local use_curtaintieback2_inv = function ()
  
    interface.InventoryItemRemove( "inv_curtaintieback2" );
  
  end;
  local use_curtaintieback2_beg = function ()
  
    ObjDelete( "obj_insophiashouse_use_curtaintieback2" );
  
  end;
  local use_curtaintieback2_end = function ()

    ObjDelete( "anm_insophiashouse_curtain2" );
    ObjSet( "anm_insophiashouse_curtain_opn2", { alp = 1 } );
  
    if cmn.IsEventDone("use_curtaintieback1") then
      ObjSet( "gho_insophiashouse_dogarea", { input = 1, alp = 1, active = 1 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_curtaintieback2", use_curtaintieback2_beg, private.room_objname );
  cmn.AddSubscriber( "use_curtaintieback2", use_curtaintieback2_inv );
  cmn.AddSubscriber( "use_curtaintieback2", use_curtaintieback2_end, private.room_objname );
  cmn.AddSubscriber( "use_curtaintieback2_inv", use_curtaintieback2_inv, private.room_objname );
  cmn.AddSubscriber( "use_curtaintieback2_beg", use_curtaintieback2_beg, private.room_objname );
  cmn.AddSubscriber( "use_curtaintieback2_end", use_curtaintieback2_end, private.room_objname );


  --------------------------------------------------------------------------------------------
  -- function opn_insophiashouse () end;
  --------------------------------------------------------------------------------------------
  local opn_insophiashouse = function ()
  
    int_map_impl.OpenRoom( "rm_insophiashouse" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_insophiashouse", opn_insophiashouse );

end;
--********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_abovefireplace" );
  subroom.Define( "zz_lvl4chest" );

  function zz_lvl4chest.PreOpen()
    if ( cmn.IsEventDone( "use_woodensquare" ) and not cmn.IsEventDone( "win_lvl4chest" ) ) then
      private.zz_lvl4chest.DrawScene();
      cmn.MiniGameShow();
      private.zz_lvl4chest.CheckForceQuite();
    end;
  end;

  function zz_lvl4chest.PreClose()
    if ( cmn.IsEventDone( "use_woodensquare" ) and not cmn.IsEventDone( "win_lvl4chest" ) ) then
      cmn.MiniGameHide("lvl4chest");
    end;
  end;
  
  function zz_abovefireplace.PreOpen()
    
    if not(cmn.IsEventDone( "win_abovefireplace" )) then
      private.zz_abovefireplace.DrawScene();
    end;

  end;

  function zz_abovefireplace.PreClose()
    
    if ( cmn.IsEventDone( "use_eaglefeather" ) and cmn.IsEventDone( "use_crowfeather" ) and not(cmn.IsEventDone( "win_abovefireplace" )) )
    and private.zz_abovefireplace.active == 1 then
      private.zz_abovefireplace.active = 0;
      cmn.MiniGameHide("abovefireplace");
    end;

  end;

  function zz_abovefireplace.Close()
    
    cmn.HideNote( 0 );
    
    if ( cmn.IsEventDone( "use_eaglefeather" ) and cmn.IsEventDone( "use_crowfeather" ) and not(cmn.IsEventDone( "win_abovefireplace" )) ) then
      ObjSet("obj_abovefireplace_game",  { alp = 0, input = 0 });
    end;
                   
  end;

end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_lvl4chest" ].state then 
    private.zz_lvl4chest.StartConditions();
  end;
  private.zz_lvl4chest.state = ng_global.progress[ ng_global.currentprogress ][ "win_lvl4chest" ].state;
  
  if not ng_global.progress[ ng_global.currentprogress ][ "win_abovefireplace" ].state then 
    private.zz_abovefireplace.StartConditions();
  end;
  private.zz_abovefireplace.state = ng_global.progress[ ng_global.currentprogress ][ "win_abovefireplace" ].state;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_insophiashouse();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/aud_bedroom_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/aud_bedroom_env");
  
  if cmn.IsEventDone("get_rescueddog") and not cmn.IsEventDone("opn_ingingerbreadhousewithclues") then
    cmn.Lock( 1 );
  end;
  
  if not cmn.IsEventDone("use_dogcage") then
    cmn.PlayAudio("env", "assets/levels/common/audio/audio4/aud_dog_env");
  end;
  
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(12) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_eaglefeather()

  local item = "inv_eaglefeather";

  if cmn.ApplyObj( item, "gzz_insophiashouse_abovefireplace" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_abovefireplace" );

  elseif ( cmn.ApplyObj( item, "obj_abovefireplace_use_eaglefeather" ) ) then

    cmn.CallEventHandler( "use_eaglefeather_inv" );
    cmn.CallEventHandler( "use_eaglefeather_beg" );

    local func_after = function ()


      cmn.SetEventDone( "use_eaglefeather" );
      
      if cmn.IsEventDone("use_crowfeather") then
        public.zz_abovefireplace.OpenMg( 1, "use_eaglefeather_end" )
      else 
        cmn.Lock( 0 );
        cmn.CallEventHandler( "use_eaglefeather_end" );
      end;
      
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_insophiashouse/audio/aud_use_feather4");

    ObjSet("anm_abovefireplace_eagle_feather",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_crowfeather()

  local item = "inv_crowfeather";

  if cmn.ApplyObj( item, "gzz_insophiashouse_abovefireplace" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_abovefireplace" );

  elseif ( cmn.ApplyObj( item, "obj_abovefireplace_use_crowfeather" ) ) then

    cmn.CallEventHandler( "use_crowfeather_inv" );
    cmn.CallEventHandler( "use_crowfeather_beg" );

    local func_after = function ()

      cmn.SetEventDone( "use_crowfeather" );
      
      if cmn.IsEventDone("use_eaglefeather") then
        public.zz_abovefireplace.OpenMg( 1, "use_crowfeather_end" )
      else 
        cmn.Lock( 0 );
        cmn.CallEventHandler( "use_crowfeather_end" );
      end;
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_insophiashouse/audio/aud_use_feather4");

    ObjSet("anm_abovefireplace_crow_feather",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_shipmodel()

  local item = "inv_shipmodel";

  if cmn.ApplyObj( item, "gzz_insophiashouse_abovefireplace" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_abovefireplace" );

  elseif ( cmn.ApplyObj( item, "obj_abovefireplace_use_shipmodel" ) ) then

    cmn.CallEventHandler( "use_shipmodel_inv" );
    cmn.CallEventHandler( "use_shipmodel_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_shipmodel" );
      cmn.CallEventHandler( "use_shipmodel_end" );
    
    end;
    
    local anm_open = function ()
      
      ObjSet("obj_abovefireplace_casket_open",  { alp = 1 });
      
      ObjAnimate("spr_abovefireplace_casket_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_abovefireplace_casket_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_insophiashouse/audio/aud_use_ship");

    ObjAnimate("obj_abovefireplace_ship", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_nursekeys()

  local item = "inv_nursekeys";

  if cmn.ApplyObj( item, "gzz_insophiashouse_phonetable" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_phonetable" );

  elseif ( cmn.ApplyObj( item, "obj_phonetable_use_nursekeys" ) ) then

    cmn.CallEventHandler( "use_nursekeys_inv" );
    cmn.CallEventHandler( "use_nursekeys_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_nursekeys" );
      cmn.CallEventHandler( "use_nursekeys_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_insophiashouse/audio/aud_use_ring4");

    ObjSet("anm_phonetable_use_ring",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ballerina()

  local item = "inv_ballerina";

  if cmn.ApplyObj( item, "gzz_insophiashouse_phonetable" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_phonetable" );

  elseif ( cmn.ApplyObj( item, "obj_phonetable_use_ballerina" ) ) then

    cmn.CallEventHandler( "use_ballerina_inv" );
    cmn.CallEventHandler( "use_ballerina_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_ballerina" );
      cmn.CallEventHandler( "use_ballerina_end" );
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_nearnurseshouse/audio/aud_opn_box4");

    ObjSet("anm_phonetable_use_ballerina",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lockpart()

  local item = "inv_lockpart";

  if cmn.ApplyObj( item, "gzz_insophiashouse_phonetable" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_phonetable" );

  elseif ( cmn.ApplyObj( item, "obj_phonetable_use_lockpart" ) and cmn.CheckMultiObject( "lockpart", 2 ) ) then

    cmn.CallEventHandler( "use_lockpart_inv" );
    cmn.CallEventHandler( "use_lockpart_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lockpart" );
      cmn.CallEventHandler( "use_lockpart_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_insophiashouse/audio/aud_use_gears");

    ObjSet("anm_phonetable_use_lockparts",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_twotoothedfork()

  local item = "inv_twotoothedfork";

  if cmn.ApplyObj( item, "gzz_insophiashouse_undersofa" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_undersofa" );

  elseif ( cmn.ApplyObj( item, "obj_undersofa_use_twotoothedfork" ) ) then

    cmn.CallEventHandler( "use_twotoothedfork_inv" );
    cmn.CallEventHandler( "use_twotoothedfork_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_twotoothedfork" );
      cmn.CallEventHandler( "use_twotoothedfork_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_insophiashouse/audio/aud_use_fork");

    ObjSet("anm_undersofa_use_fork",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_dogcage()

  local item = "inv_dogcage";

  if cmn.ApplyObj( item, "gzz_insophiashouse_undersofa" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_undersofa" );

  elseif ( cmn.ApplyObj( item, "obj_undersofa_use_dogcage" ) ) then

    cmn.CallEventHandler( "use_dogcage_inv" );
    cmn.CallEventHandler( "use_dogcage_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_dogcage" );
      cmn.CallEventHandler( "use_dogcage_end" );
      
      cmn.StopAllEnv("assets/levels/common/audio/aud_bedroom_env");
      cmn.PlayAudio("env", "assets/levels/common/audio/aud_bedroom_env");
    
    end;
    
    local anm_go = function ()
      
      ObjDelete("anm_undersofa_use_cage");
      ObjDelete( "anm_undersofa_dog" );
      ObjDelete( "anm_undersofa_dog_touch" );
      
      ObjMultiSet( { {"anm_undersofa_dog_go",  { alp = 1, playing = 1, endtrig = func_after }},
                     {"spr_undersofa_rescueddog", { alp = 1 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_insophiashouse/audio/aud_use_dog_home");

    ObjSet("anm_undersofa_use_cage",  { alp = 1, playing = 1, endtrig = anm_go });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_woodensquare()

  local item = "inv_woodensquare";

  if cmn.ApplyObj( item, "gzz_insophiashouse_lvl4chest" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_lvl4chest" );

  elseif cmn.ApplyObj( item, "obj_lvl4chest_use_woodensquare" ) and cmn.IsEventDone("use_ornament1") and cmn.IsEventDone("use_ornament2") then

    cmn.CallEventHandler( "use_woodensquare_inv" );
    cmn.CallEventHandler( "use_woodensquare_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_woodensquare" );
      cmn.CallEventHandler( "use_woodensquare_end" );

      cmn.MiniGameShow();
    
    end;
    
    local anm_game = function ()

      private.zz_lvl4chest.DrawScene();
      
      ObjAnimate("obj_lvl4chest_game", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
    local anm_zoom = function ()
      
      ObjAnimate("obj_lvl4chest_back", "scale_xy", 0, 0, anm_game, { 0, 0, 1, 1,   1, 0, 1.5, 1.5 });
      ObjAnimate("obj_lvl4chest_back", "pos_xy", 0, 0, "", { 0, 0, 0, 0,   1, 0, 25, -120 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_insophiashouse/audio/aud_use_cube");

    ObjSet("anm_lvl4chest_use_woodensquare", { alp = 1, playing = 1, endtrig = anm_zoom });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ornament1()

  local item = "inv_ornament1";

  if cmn.ApplyObj( item, "gzz_insophiashouse_lvl4chest" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_lvl4chest" );

  elseif ( cmn.ApplyObj( item, "obj_lvl4chest_use_ornament1" ) ) then

    cmn.CallEventHandler( "use_ornament1_inv" );
    cmn.CallEventHandler( "use_ornament1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_ornament1" );
      cmn.CallEventHandler( "use_ornament1_end" );
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/rm_insophiashouse/audio/aud_opn_basket");
      
      ObjMultiSet( { {"anm_lvl4chest_chest_open", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_lvl4chest_chest_touch", { alp = 0 }},
                     {"obj_lvl4chest_inside_chest", { alp = 1 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_insophiashouse/audio/aud_use_parts_box");

    if cmn.IsEventDone("use_ornament2") then
      ObjAnimate("spr_lvl4chest_ornament1", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });
    else 
      ObjAnimate("spr_lvl4chest_ornament1", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ornament2()

  local item = "inv_ornament2";

  if cmn.ApplyObj( item, "gzz_insophiashouse_lvl4chest" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_lvl4chest" );

  elseif ( cmn.ApplyObj( item, "obj_lvl4chest_use_ornament2" ) ) then

    cmn.CallEventHandler( "use_ornament2_inv" );
    cmn.CallEventHandler( "use_ornament2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_ornament2" );
      cmn.CallEventHandler( "use_ornament2_end" );
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/rm_insophiashouse/audio/aud_opn_basket");
      
      ObjMultiSet( { {"anm_lvl4chest_chest_open", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_lvl4chest_chest_touch", { alp = 0 }},
                     {"obj_lvl4chest_inside_chest", { alp = 1 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_insophiashouse/audio/aud_use_parts_box");

    if cmn.IsEventDone("use_ornament1") then
      ObjAnimate("spr_lvl4chest_ornament2", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });
    else 
      ObjAnimate("spr_lvl4chest_ornament2", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_curtaintieback1()

  local item = "inv_curtaintieback1";

  if ( cmn.ApplyObj( item, "obj_insophiashouse_use_curtaintieback1" ) ) then

    cmn.CallEventHandler( "use_curtaintieback1_inv" );
    cmn.CallEventHandler( "use_curtaintieback1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_curtaintieback1" );
      cmn.CallEventHandler( "use_curtaintieback1_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_insophiashouse/audio/aud_node");

    ObjAnimate( "anm_insophiashouse_curtain1",     "alp", 0, 0, "",         { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "anm_insophiashouse_curtain_opn1", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_curtaintieback2()

  local item = "inv_curtaintieback2";

  if ( cmn.ApplyObj( item, "obj_insophiashouse_use_curtaintieback2" ) ) then

    cmn.CallEventHandler( "use_curtaintieback2_inv" );
    cmn.CallEventHandler( "use_curtaintieback2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_curtaintieback2" );
      cmn.CallEventHandler( "use_curtaintieback2_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_insophiashouse/audio/aud_node");

    ObjAnimate( "anm_insophiashouse_curtain2",     "alp", 0, 0, "",         { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "anm_insophiashouse_curtain_opn2", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_heartsign()

  cmn.SetEventDone( "get_heartsign" );
  cmn.CallEventHandler( "get_heartsign" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_newspaperpiece4()

  cmn.SetEventDone( "get_newspaperpiece4" );
  cmn.CallEventHandler( "get_newspaperpiece4" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_curtaintieback2") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_pinkbow()

  cmn.SetEventDone( "get_pinkbow" );
  cmn.CallEventHandler( "get_pinkbow" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
end;
--------------------------------------------------------------------------------------------
function public.get_curtaintieback2()

  cmn.SetEventDone( "get_curtaintieback2" );
  cmn.CallEventHandler( "get_curtaintieback2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_newspaperpiece4") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_clawedpaw()

  cmn.SetEventDone( "get_clawedpaw" );
  cmn.CallEventHandler( "get_clawedpaw" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_stetoscopeamulet()

  cmn.SetEventDone( "get_stetoscopeamulet" );
  cmn.CallEventHandler( "get_stetoscopeamulet" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_honeyspoon()

  cmn.SetEventDone( "get_honeyspoon" );
  cmn.CallEventHandler( "get_honeyspoon" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_tape") and cmn.IsEventDone("get_newspaperpiece3") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_crosskey()

  cmn.SetEventDone( "get_crosskey" );
  cmn.CallEventHandler( "get_crosskey" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_tape()

  cmn.SetEventDone( "get_tape" );
  cmn.CallEventHandler( "get_tape" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_honeyspoon") and cmn.IsEventDone("get_newspaperpiece3") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_bluebow()

  cmn.SetEventDone( "get_bluebow" );
  cmn.CallEventHandler( "get_bluebow" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_newspaperpiece3()

  cmn.SetEventDone( "get_newspaperpiece3" );
  cmn.CallEventHandler( "get_newspaperpiece3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_honeyspoon") and cmn.IsEventDone("get_tape") then
    common.CloseSubRoom();
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.get_rescueddog()
  
  local func_after = function ()
    ObjSet("rm_insophiashouse",  { color_r = 0, color_g = 0, color_b = 0 });
    cmn.GotoRoom("rm_ingingerbreadhouse");
  end;

  cmn.SetEventDone( "get_rescueddog" );
  cmn.CallEventHandler( "get_rescueddog_inv" );
  cmn.CallEventHandler( "get_rescueddog_end" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  local play_vid = function ()
  
    cmn.Lock( 0 );
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level4/rm_insophiashouse/vid_lvl4totales", func_after, "assets/levels/level4/rm_ingingerbreadhouse/audio/aud_lvl4_toreality", "");
    
  end;
  
  cmn.Lock( 1 );
  common.CloseSubRoom();
  interface_impl.CompleteClues( {4}, play_vid );

end;
--------------------------------------------------------------------------------------------
function public.get_brokenfigurine()

  cmn.SetEventDone( "get_brokenfigurine" );
  cmn.CallEventHandler( "get_brokenfigurine" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_lvl4spade()

  cmn.SetEventDone( "get_lvl4spade" );
  cmn.CallEventHandler( "get_lvl4spade" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_nailpuller") and cmn.IsEventDone("get_collectionstamp1") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_collectionstamp1()

  cmn.SetEventDone( "get_collectionstamp1" );
  cmn.CallEventHandler( "get_collectionstamp1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_lvl4spade") and cmn.IsEventDone("get_nailpuller") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_oldglasses()

  cmn.SetEventDone( "get_oldglasses" );
  cmn.CallEventHandler( "get_oldglasses" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_nailpuller()

  cmn.SetEventDone( "get_nailpuller" );
  cmn.CallEventHandler( "get_nailpuller" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_lvl4spade") and cmn.IsEventDone("get_collectionstamp1") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_brokendogcase()

  cmn.SetEventDone( "get_brokendogcase" );
  cmn.CallEventHandler( "get_brokendogcase" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  interface_impl.ShowGlobalTask();

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_insophiashouse()

  if not ( cmn.IsEventDone( "opn_insophiashouse" ) ) then
    cmn.SetEventDone( "opn_insophiashouse" );
    cmn.CallEventHandler("opn_insophiashouse");
    cmn.ShowBbt( "insophiashouse_open" );
  end;

  if cmn.IsEventDone("get_rescueddog") and not cmn.IsEventDone("opn_ingingerbreadhousewithclues") then
    
    local func_after = function ()

      ObjSet("rm_insophiashouse",  { color_r = 0, color_g = 0, color_b = 0 });
      cmn.GotoRoom("rm_ingingerbreadhouse");
      
    end;
    
    cmn.Lock( 0 );
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level4/rm_insophiashouse/vid_lvl4totales", func_after, "assets/levels/level4/rm_ingingerbreadhouse/audio/aud_lvl4_toreality", "");
    
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_chest()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_lvl4chest_use_ornament" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_clk_handle");
  
  ObjSet("anm_lvl4chest_chest_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_ship_box()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_abovefireplace_use_shipmodel" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_bedroom/audio/aud_xx_use_detail");
  
  ObjSet("anm_abovefireplace_casket_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_birds()
  
  cmn.Lock(1);
  
  local func_after = function ()
    cmn.Lock(0);
  end;
  
  cmn.ShowBbt( "obj_abovefireplace_use_crowfeather" );
  
  cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_oldpruners/audio/aud_xx_clk_cutters");
  
  if not cmn.IsEventDone("use_eaglefeather") then
    ObjSet("anm_abovefireplace_eagle_touch",  { playing = 1 });
  end;
  if not cmn.IsEventDone("use_crowfeather") then
    ObjSet("anm_abovefireplace_crow_touch",  { playing = 1 });
  end;
  
  ObjSet("tmr_abovefireplace_timer",  { time = 0.3, playing = 1, endtrig = func_after });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_sofa_box()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_undersofa_use_twotoothedfork" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_xx_clk_wood2");
  
  ObjSet("anm_undersofa_door_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_sofa_dog()
  
  cmn.Lock(1);
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_undersofa_dog_touch", { alp = 0 }},
                   {"anm_undersofa_dog", { alp = 1, playing = 1 }} } );
    
  end;
  
  cmn.ShowBbt( "obj_undersofa_use_dogcage" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_insophiashouse/audio/aud_xx_clk_dog");
  
  ObjMultiSet( { {"anm_undersofa_dog_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_undersofa_dog", { alp = 0, playing = 0 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_table_drawer( num )
  
  cmn.Lock(1);
  
  if num == 1 then
    cmn.ShowBbt( "obj_phonetable_use_nursekeys" );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_clk_xx_drawer");
  else 
    cmn.PlayAudio("snd", "assets/levels/level2/rm_mermaidsward/audio/aud_xx_clk_drawer1");
    cmn.ShowBbt( "obj_phonetable_use_lockpart" );
  end;
  
  ObjSet("anm_phonetable_drawer_"..num.."_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_ballerina_box()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_phonetable_use_ballerina" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_opn_small_box2");
  
  ObjSet("anm_phonetable_musicbox_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_12_1", { alp = 1 }},
                 {"spr_col_12_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_12_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_12_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_12_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_12_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_12_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_12_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--*********************************************************************************************************************
-- function *** MMG_Lvl4chest *** () end;
--*********************************************************************************************************************
private.zz_lvl4chest = {};
public.zz_lvl4chest = {};

function private.Init_Lvl4chest()

  private.zz_lvl4chest.blocks_offset_x = -238;
  private.zz_lvl4chest.blocks_offset_y = -225;

  --0 - пусто, 1 - блок, {номер_обьекта, цвет}
  --1 - кр, 2 - жел, 3 - фио, 4 - зел
  private.zz_lvl4chest.start_map_stage_1 = {
    { 0,     0,     0,     0,     0,     0     },
    { 0,     0,     {1,1}, 0,     0,     {2,2} },
    { {3,3}, 0,     1,     0,     0,     1     },
    { 1,     0,     1,     0,     {4,4}, 1     },
    { 1,     {5,1}, {6,3}, {7,4}, {8,2}, 1     },
    { 1,     1,     1,     1,     1,     1     }
  };
  private.zz_lvl4chest.start_map_stage_2 = {
    { {1,3},  0,  0,     0,      0,  {2,1} },
    { 1,      0,  {3,1}, 1,      0,  1     },
    { {4,3},  0,  1,     {5,1},  0,  {6,1} },
    { 1,      0,  0,     1,      0,  1     },
    { {7,1},  0,  0,     0,      0,  {8,3} },
    { 1,      1,  0,     1,      1,  1     }
  };
  private.zz_lvl4chest.start_map_stage_3 = {
    { 0,     0,     {1,4}, 0,      0,  {2,2} },
    { 0,     0,     1,     {3,2},  1,  {4,3} },
    { {5,1}, 0,     1,     {6,4},  0,  {7,4} },
    { 1,     0,     0,     1,      0,  1     },
    { {8,3}, 0,     0,     0,      0,  1     },
    { 1,     {9,1}, 1,     0,      0,  0     }
  };

  private.zz_lvl4chest.frame_pos = { -48, 3, 57 };

  -------------------------------------------------------------------------------------------
  game.hint[ "win_lvl4chest" ] = {
    type = "win",
    room = "rm_insophiashouse",
    zz = "zz_lvl4chest",
    zz_gate = "gzz_insophiashouse_lvl4chest"
  };
  -----------------------------------------------------------------------------------
  local win_lvl4chest = function ()

    if cmn.IsEventDone( "win_lvl4chest" ) then

      ObjMultiSet( { { "obj_lvl4chest_game_niche", { alp = 1, input = true } },
                     { "spr_lvl4chest_door", { alp = 0 } },
                     { "spr_lvl4chest_frame", { pos_x = 57 } },
                     { "obj_lvl4chest_stages", { alp = 0, input = false } } } );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_lvl4chest", win_lvl4chest, "rm_insophiashouse" );

end;
-----------------------------------------------------------------------------------
function private.zz_lvl4chest.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_lvl4chest" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_lvl4chest" ].state = {
    stage = 1,
    cur_block = 0,
    --0 - пусто, 1 - блок, {номер_обьекта, цвет}
    --1 - кр, 2 - жел, 3 - фио, 4 - зел
    map = {
      { 0,     0,     0,     0,     0,     0     },
      { 0,     0,     {1,1}, 0,     0,     {2,2} },
      { {3,3}, 0,     1,     0,     0,     1     },
      { 1,     0,     1,     0,     {4,4}, 1     },
      { 1,     {5,1}, {6,3}, {7,4}, {8,2}, 1     },
      { 1,     1,     1,     1,     1,     1     }
    }
  };

end;
-----------------------------------------------------------------------------------
function public.zz_lvl4chest.Reset()

  --DbgTrace( "***Reset" );

  cmn.Lock( 1 );

  local map = private.zz_lvl4chest.state.map;
  local start_map_stage_name = "start_map_stage_"..private.zz_lvl4chest.state.stage;

  for i = 1, 6, 1 do
    for j = 1, 6, 1 do
      if  private.zz_lvl4chest[ start_map_stage_name ][i][j] ~= 0
      and private.zz_lvl4chest[ start_map_stage_name ][i][j] ~= 1 then
        map[i][j] = { private.zz_lvl4chest[ start_map_stage_name ][i][j][1], private.zz_lvl4chest[ start_map_stage_name ][i][j][2] };
      else
        map[i][j] = private.zz_lvl4chest[ start_map_stage_name ][i][j];
      end;
    end;
  end;

  local func_after = function ()

    if ( private.zz_lvl4chest.state.cur_block ~= 0 ) then

      local block_num = private.zz_lvl4chest.state.cur_block;

      ObjMultiSet( { { "obj_lvl4chest_block_arrow", { input = false, alp = 0 } },
                     { "spr_lvl4chest_block_stage_focus_"..private.zz_lvl4chest.state.stage..block_num, { alp = 0 } },
                     { "spr_lvl4chest_block_stage_"..private.zz_lvl4chest.state.stage..block_num, { pos_z = 0 } } } );

      private.zz_lvl4chest.state.cur_block = 0;

    end;

    private.zz_lvl4chest.DrawScene( true );

    ObjAnimate( "obj_lvl4chest_block_stage_"..private.zz_lvl4chest.state.stage, "alp", 0, 0,
      function ()
        cmn.Lock( 0 );
      end,
      { 0, 0, 0,    0.3, 0, 1 }
    );

  end;

  ObjAnimate( "obj_lvl4chest_block_stage_"..private.zz_lvl4chest.state.stage, "alp", 0, 0, func_after, { 0, 0, 1,    0.3, 0, 0 } );

end;
-----------------------------------------------------------------------------------
function public.zz_lvl4chest.Skip()

  --DbgTrace( "***Skip" );

  ng_global.progress[ ng_global.currentprogress ][ "win_lvl4chest" ].skip = 1;

  ObjAnimate( "spr_lvl4chest_frame", "pos_x", 0, 0, "", {
    0,   0, private.zz_lvl4chest.frame_pos[private.zz_lvl4chest.state.stage],
    0.3, 0, private.zz_lvl4chest.frame_pos[3]
  } );

  private.zz_lvl4chest.CheckWin();

end;
-----------------------------------------------------------------------------------
function private.zz_lvl4chest.DrawScene( from_check_win )

  --DbgTrace( "***DrawScene" );

  for i = 1, 3, 1 do
    if i == private.zz_lvl4chest.state.stage then
      ObjSet( "obj_lvl4chest_block_stage_"..i, { alp = (from_check_win and 0 or 1), input = true } );
    else
      ObjSet( "obj_lvl4chest_block_stage_"..i, { alp = 0, input = false } );
    end;
  end;

  ObjSet( "spr_lvl4chest_frame", { pos_x = private.zz_lvl4chest.frame_pos[private.zz_lvl4chest.state.stage] } );

  local cell;

  for i = 1, 6, 1 do
    for j = 1, 6, 1 do

      cell = private.zz_lvl4chest.state.map[i][j];

      if     ( cell == 0 ) then

        ObjSet( "spr_lvl4chest_block_tree_"..i..j, { alp = 0 } );

      elseif ( cell == 1 ) then

        --DbgTrace( i..j.." == 1" );
        ObjSet( "spr_lvl4chest_block_tree_"..i..j, { alp = 1 } );

      else

        --DbgTrace( i..j.." == {"..cell[1]..","..cell[2].."}" );
        ObjSet( "spr_lvl4chest_block_stage_"..private.zz_lvl4chest.state.stage..cell[1], {
          alp = 1,
          input = true,
          pos_x = j*68+private.zz_lvl4chest.blocks_offset_x,
          pos_y = i*68+private.zz_lvl4chest.blocks_offset_y
        } );
        ObjSet( "spr_lvl4chest_block_tree_"..i..j, { alp = 0 } );

      end;

    end;
  end;

  if ( private.zz_lvl4chest.state.cur_block ~= 0 ) then

    local block_num = private.zz_lvl4chest.state.cur_block;
    local map = private.zz_lvl4chest.state.map;
    local cell = private.zz_lvl4chest.FindBlock( block_num );

    if ( cell[2] - 1 > 0 ) and ( map[ cell[1] ][ cell[2] - 1 ] == 0 ) then
      ObjSet( "spr_lvl4chest_block_arrow_1", { alp = 1, input = true } );
    else
      ObjSet( "spr_lvl4chest_block_arrow_1", { alp = 0, input = false } );
    end;

    if ( cell[2] + 1 < 7 ) and ( map[ cell[1] ][ cell[2] + 1 ] == 0 ) then
      ObjSet( "spr_lvl4chest_block_arrow_2", { alp = 1, input = true } );
    else
      ObjSet( "spr_lvl4chest_block_arrow_2", { alp = 0, input = false } );
    end;

    ObjAttach( "obj_lvl4chest_block_arrow", "spr_lvl4chest_block_stage_"..private.zz_lvl4chest.state.stage..block_num );

    ObjMultiSet( { { "obj_lvl4chest_block_arrow", { input = true, alp = 1 } },
                   { "spr_lvl4chest_block_stage_focus_"..private.zz_lvl4chest.state.stage..block_num, { alp = 1 } },
                   { "spr_lvl4chest_block_stage_"..private.zz_lvl4chest.state.stage..block_num, { pos_z = 2 } } } );

  end;

end;
-----------------------------------------------------------------------------------
function private.zz_lvl4chest.CheckForceQuite()

  --DbgTrace( "***CheckForceQuite" );

  if ( ng_global.progress[ ng_global.currentprogress ][ "win_lvl4chest" ].skip == 1 ) then
    ObjAnimate( "spr_lvl4chest_frame", "pos_x", 0, 0, "", {
      0,   0, private.zz_lvl4chest.frame_pos[private.zz_lvl4chest.state.stage],
      0.3, 0, private.zz_lvl4chest.frame_pos[3]
    } );
  end;

  local is_anim_pos_y = false;
  local map = private.zz_lvl4chest.state.map;

  for j = 6, 1, -1 do
    for i = 5, 1, -1 do
      if  ( map[ i ][ j ] ~= 0 ) and ( map[ i ][ j ] ~= 1 )
      and ( map[ i+1 ][ j ] == 0 ) then

        --DbgTrace( "block "..map[ i ][ j ][ 1 ].." cell "..i.." "..j.." -> "..(i+1).." "..j );
        is_anim_pos_y = true;

        ObjAnimate( "spr_lvl4chest_block_stage_"..private.zz_lvl4chest.state.stage..map[ i ][ j ][ 1 ], "pos_y", 0, 0, "", {
          0,   0, i*68+private.zz_lvl4chest.blocks_offset_y,
          0.3, 0, (i+1)*68+private.zz_lvl4chest.blocks_offset_y
        } );

        map[ i+1 ][ j ] = map[ i ][ j ];
        map[ i ][ j ] = 0;

      end;
    end;
  end;

  if ( is_anim_pos_y ) then
    cmn.Lock( 1 );
    ObjSet( "tmr_lvl4chest_locktimer", { time = 0.3, endtrig = function () private.zz_lvl4chest.CheckWin(); end, playing = true } );
  else
    private.zz_lvl4chest.CheckWin();
  end;


end;
-----------------------------------------------------------------------------------
function private.zz_lvl4chest.CheckWin( is_skip )

  --DbgTrace( "***CheckWin" );

  cmn.Lock( 1 );

  local locktimer_tme = 0.05;
  local is_win = true;
  local map = private.zz_lvl4chest.state.map;
  local del_blocks = {};

  for i = 1, 6, 1 do
    for j = 1, 6, 1 do
      if map[i][j] ~= 0 and map[i][j] ~= 1 then

        if ( j+1 < 7 ) and map[i][j+1] ~= 0 and map[i][j+1] ~= 1 and map[i][j][2] == map[i][j+1][2] then
          table.insert( del_blocks, {i,j} );
          table.insert( del_blocks, {i,j+1} );
        end;

        if ( i+1 < 7 ) and map[i+1][j] ~= 0 and map[i+1][j] ~= 1 and map[i][j][2] == map[i+1][j][2] then
          table.insert( del_blocks, {i,j} );
          table.insert( del_blocks, {i+1,j} );
        end;

      end;
    end;
  end;

  for i = #del_blocks, 2, -1 do --убираем одинаковые
    for j = i-1, 1, -1 do
      if ( del_blocks[i][1] == del_blocks[j][1] ) and ( del_blocks[i][2] == del_blocks[j][2] ) then
        table.remove( del_blocks, i );
        break;
      end;
    end;
  end;

  if ( #del_blocks ~= 0 ) then
    cmn.PlayAudio("snd", "assets/levels/level3/rm_relicstorage/audio/aud_mirror_clk");
  end;

  for i = #del_blocks, 1, -1 do

    locktimer_tme = 0.3;

    --DbgTrace( "del block "..del_blocks[i][1].." "..del_blocks[i][2] );
    
    ObjAnimate(
      "spr_lvl4chest_block_stage_"..private.zz_lvl4chest.state.stage..map[ del_blocks[i][1] ][ del_blocks[i][2] ][ 1 ], 
      "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 }
    );

    ObjSet("spr_lvl4chest_block_stage_"..private.zz_lvl4chest.state.stage..map[ del_blocks[i][1] ][ del_blocks[i][2] ][ 1 ], { input = false });

    map[ del_blocks[i][1] ][ del_blocks[i][2] ] = 0;

  end;

  for j = #del_blocks, 1, -1 do
    for i = del_blocks[j][1]-1, 1, -1 do
      if ( map[ i ][ del_blocks[j][2] ] ~= 0 ) and ( map[ i ][ del_blocks[j][2] ] ~= 1 ) then

        local new_block_pos = ( (i+2<7) and (map[ i+2 ][ del_blocks[j][2] ] == 0) ) and i+2 or i+1;

        --DbgTrace("block "..map[ i ][ del_blocks[j][2] ][ 1 ].." cell "..i.." "..del_blocks[j][2].." -> "..new_block_pos.." "..del_blocks[j][2]);

        ObjAnimate( "spr_lvl4chest_block_stage_"..private.zz_lvl4chest.state.stage..map[ i ][ del_blocks[j][2] ][ 1 ], "pos_y", 0, 0, "", {
          0,   0, i*68+private.zz_lvl4chest.blocks_offset_y,
          0.3, 0, i*68+private.zz_lvl4chest.blocks_offset_y,
          0.6, 0, new_block_pos*68+private.zz_lvl4chest.blocks_offset_y
        } );

        map[ new_block_pos ][ del_blocks[j][2] ] = map[ i ][ del_blocks[j][2] ];
        map[ i ][ del_blocks[j][2] ] = 0;

        locktimer_tme = 0.6;

      else
        break;
      end;
    end;
  end;

  --------------------

  for i = 1, 6, 1 do
    for j = 1, 6, 1 do
      if map[i][j] ~= 0 and map[i][j] ~= 1 then
        is_win = false;
        --DbgTrace( "есть "..i.." "..j );
        break;
      end;
    end;
  end;

  if is_win and private.zz_lvl4chest.state.stage ~= 3
  and ng_global.progress[ ng_global.currentprogress ][ "win_lvl4chest" ].skip ~= 1 then

    private.zz_lvl4chest.state.stage = private.zz_lvl4chest.state.stage + 1;

    --DbgTrace( "stage = "..private.zz_lvl4chest.state.stage );

    local start_map_stage_name = "start_map_stage_"..private.zz_lvl4chest.state.stage;

    for i = 1, 6, 1 do
      for j = 1, 6, 1 do
        if  private.zz_lvl4chest[ start_map_stage_name ][i][j] ~= 0
        and private.zz_lvl4chest[ start_map_stage_name ][i][j] ~= 1 then
          map[i][j] = { private.zz_lvl4chest[ start_map_stage_name ][i][j][1], private.zz_lvl4chest[ start_map_stage_name ][i][j][2] };
        else
          map[i][j] = private.zz_lvl4chest[ start_map_stage_name ][i][j];
        end;
      end;
    end;

    ObjAnimate( "obj_lvl4chest_block_tree", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 1,    0.6, 0, 0,    0.9, 0, 1 } );

    ObjSet( "tmr_lvl4chest_locktimer", { time = 0.6, endtrig =
      function ()

        private.zz_lvl4chest.DrawScene( true );

        ObjAnimate( "spr_lvl4chest_frame", "pos_x", 0, 0, "", {
          0,   0, private.zz_lvl4chest.frame_pos[private.zz_lvl4chest.state.stage-1],
          0.3, 0, private.zz_lvl4chest.frame_pos[private.zz_lvl4chest.state.stage]
        } );

        ObjAnimate( "obj_lvl4chest_block_stage_"..private.zz_lvl4chest.state.stage, "alp", 0, 0,
          function ()
            cmn.Lock( 0 );
          end,
          { 0, 0, 0,    0.3, 0, 1 }
        );

      end,
      playing = true 
    } );

  elseif ( is_win and private.zz_lvl4chest.state.stage == 3 )
  or ng_global.progress[ ng_global.currentprogress ][ "win_lvl4chest" ].skip == 1 then

    --DbgTrace( "WWWWIIIIIINNNNNN" );
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_insophiashouse/audio/aud_xx_break_wood");

    ObjSet( "obj_lvl4chest_game_niche", { alp = 1 } );

    ObjAnimate( "spr_lvl4chest_door",   "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 1,    1, 0, 0 } );
    ObjAnimate( "obj_lvl4chest_stages", "alp", 0, 0, function () private.zz_lvl4chest.Win(); end, { 0, 0, 1,    0.5, 0, 1,    1, 0, 0 } );

  else

    ObjSet( "tmr_lvl4chest_locktimer", { time = locktimer_tme, endtrig = function () 
      if ( locktimer_tme == 0.6 ) then
        private.zz_lvl4chest.CheckWin();
      else 
        cmn.Lock( 0 );
      end;
    end, playing = true } );

  end;

end;
-----------------------------------------------------------------------------------
function private.zz_lvl4chest.Win()

  cmn.Lock( 0 );

  cmn.MiniGameHide("lvl4chest");

  cmn.SetEventDone( "win_lvl4chest" );
  cmn.CallEventHandler( "win_lvl4chest" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_lvl4chest" ].skip == 0 and ng_global.noskipgames[ "win_lvl4chest" ] == nil then

    ng_global.noskipgames[ "win_lvl4chest" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

end;
-----------------------------------------------------------------------------------
function public.zz_lvl4chest.ClickArrow( side )

  --DbgTrace( "***ClickArrow "..side );

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");

  local map = private.zz_lvl4chest.state.map;
  local cur_block = private.zz_lvl4chest.state.cur_block;

  public.zz_lvl4chest.ClickBlock( cur_block, true );
  public.zz_lvl4chest.FocusBlock( cur_block, 0 );

  local cell = private.zz_lvl4chest.FindBlock( cur_block );
  local new_cel = { 6, cell[2] + side };

  for l = cell[1], 6, 1 do
    if ( map[l][cell[2] + side] ~= 0 ) then
      new_cel = { l-1, cell[2]+side };
      break;
    end;
  end;

  --DbgTrace( "block "..cur_block.." cell "..cell[1].." "..cell[2].." -> "..new_cel[1].." "..new_cel[2] );

  local anim_pos_y = function ()

    --DbgTrace( "***anim_pos_y" );

    local is_anim_pos_y = false;

    if ( cell[1] ~= new_cel[1] ) then
      is_anim_pos_y = true;
      ObjAnimate( "spr_lvl4chest_block_stage_"..private.zz_lvl4chest.state.stage..cur_block, "pos_y", 0, 0, "", {
        0,   0, cell[1]*68+private.zz_lvl4chest.blocks_offset_y,
        0.3, 0, new_cel[1]*68+private.zz_lvl4chest.blocks_offset_y
      } );
    end;

    for i = cell[1]-1, 1, -1 do
      if ( map[ i ][ cell[2] ] ~= 0 ) and ( map[ i ][ cell[2] ] ~= 1 ) then

        --DbgTrace( "block "..map[ i ][ cell[2] ][ 1 ].." cell "..i.." "..cell[2].." -> "..(i+1).." "..cell[2] );
        is_anim_pos_y = true;

        ObjAnimate( "spr_lvl4chest_block_stage_"..private.zz_lvl4chest.state.stage..map[ i ][ cell[2] ][ 1 ], "pos_y", 0, 0, "", {
          0,   0, i*68+private.zz_lvl4chest.blocks_offset_y,
          0.3, 0, (i+1)*68+private.zz_lvl4chest.blocks_offset_y
        } );

        map[ i+1 ][ cell[2] ] = map[ i ][ cell[2] ];
        map[ i ][ cell[2] ] = 0;

      else
        break;
      end;
    end;

    if ( is_anim_pos_y ) then
      ObjSet( "tmr_lvl4chest_locktimer", { time = 0.3, endtrig = function () cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_clk_small_part"); private.zz_lvl4chest.CheckWin(); end, playing = true } );
    else
      cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_clk_small_part");
      private.zz_lvl4chest.CheckWin();
    end;

  end;

  ObjAnimate( "spr_lvl4chest_block_stage_"..private.zz_lvl4chest.state.stage..cur_block, "pos_x", 0, 0, anim_pos_y, {
    0,   0, cell[2]*68+private.zz_lvl4chest.blocks_offset_x,
    0.3, 0, new_cel[2]*68+private.zz_lvl4chest.blocks_offset_x
  } );

  map[ new_cel[1] ][ new_cel[2] ] = map[ cell[1] ][ cell[2] ];
  map[ cell[1] ][ cell[2] ] = 0;

end;
-----------------------------------------------------------------------------------
function public.zz_lvl4chest.FocusArrow( num, inout )--анимация фокуса

  local obj = "spr_lvl4chest_block_arrow_"..num;
  local scale = ObjGet( obj ).scale_x;
  local end_scale;

  if inout == 0 then
    end_scale = 1;
    SetCursor(CURSOR_DEFAULT);
  else
    end_scale = 1.2;
    SetCursor(CURSOR_HAND);
  end;

  ObjAnimate( obj, "scale_xy", 0, 0, "", { 0, 0, scale, scale,   0.1, 0, end_scale, end_scale } );

end;
-----------------------------------------------------------------------------------
function private.zz_lvl4chest.FindBlock( num )  --ищем позицию блока

  --DbgTrace( "***FindBlock "..num );

  local map = private.zz_lvl4chest.state.map;

  for i = 1, 6, 1 do
    for j = 1, 6, 1 do
      if map[i][j] ~= 0 and map[i][j] ~= 1 and map[i][j][1] == num then
        return {i,j};
      end;
    end;
  end;

end;
-----------------------------------------------------------------------------------
function public.zz_lvl4chest.ClickBlock( num, not_change_lock )

  --DbgTrace( "***ClickBlock "..num );

  if ( private.zz_lvl4chest.state.cur_block ~= num ) then
    
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_mainmenu_menter");

    local last_block = private.zz_lvl4chest.state.cur_block;
    private.zz_lvl4chest.state.cur_block = num;

    if ( last_block ~= 0 ) then
      ObjSet( "spr_lvl4chest_block_stage_"..private.zz_lvl4chest.state.stage..last_block, { pos_z = 0 } );
      public.zz_lvl4chest.FocusBlock( last_block, 0, true );
    end;

    local map = private.zz_lvl4chest.state.map;
    local cell = private.zz_lvl4chest.FindBlock( num );
    local show_arrow = false;
    --DbgTrace( "cell "..cell[1].." "..cell[2] );

    if ( cell[2] - 1 > 0 ) and ( map[ cell[1] ][ cell[2] - 1 ] == 0 ) then
      show_arrow = true;
      ObjSet( "spr_lvl4chest_block_arrow_1", { alp = 1, input = true } );
    else
      ObjSet( "spr_lvl4chest_block_arrow_1", { alp = 0, input = false } );
    end;

    if ( cell[2] + 1 < 7 ) and ( map[ cell[1] ][ cell[2] + 1 ] == 0 ) then
      show_arrow = true;
      ObjSet( "spr_lvl4chest_block_arrow_2", { alp = 1, input = true } );
    else
      ObjSet( "spr_lvl4chest_block_arrow_2", { alp = 0, input = false } );
    end;

    if ( not show_arrow ) then
      private.zz_lvl4chest.state.cur_block = 0;
      return;
    end;

    cmn.Lock( 1 );

    ObjAttach( "obj_lvl4chest_block_arrow", "spr_lvl4chest_block_stage_"..private.zz_lvl4chest.state.stage..num );

    ObjMultiSet( { { "obj_lvl4chest_block_arrow", { input = true } },
                   { "spr_lvl4chest_block_stage_"..private.zz_lvl4chest.state.stage..num, { pos_z = 2 } } } );

    ObjAnimate( "obj_lvl4chest_block_arrow", "alp", 0, 0, function () cmn.Lock( 0 ); end, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.Lock( 1 );

    private.zz_lvl4chest.state.cur_block = 0;

    ObjAnimate( "obj_lvl4chest_block_arrow", "alp", 0, 0, function ()
      ObjMultiSet( { 
        { "obj_lvl4chest_block_arrow", { input = false } },
        { "spr_lvl4chest_block_stage_"..private.zz_lvl4chest.state.stage..num, { pos_z = 0 } }
      } );
      if ( not not_change_lock ) then
        cmn.Lock( 0 );
      end;
    end, { 0, 0, 1,    0.3, 0, 0 } );

  end;

end;
-----------------------------------------------------------------------------------
function public.zz_lvl4chest.FocusBlock( num, inout, not_change_cursor )--анимация фокуса

  --DbgTrace( "***FocusBlock "..num );

  if ( not not_change_cursor ) then
    if inout == 0 then
      SetCursor(CURSOR_DEFAULT);
    else 
      SetCursor(CURSOR_HAND);
    end;
  end;

  if ( private.zz_lvl4chest.state.cur_block == num ) then
    return;
  end;

  local obj = "spr_lvl4chest_block_stage_focus_"..private.zz_lvl4chest.state.stage..num;
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    tme = alf * 0.3;
  else 
    tme = ( 1 - alf ) * 0.3;
  end;

  ObjAnimate( obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Abovefireplace *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_abovefireplace = {};
public.zz_abovefireplace = {};

function private.Init_Abovefireplace()
  
  private.zz_abovefireplace.active = 0;
  private.zz_abovefireplace.win_state = { 11, 21, 31, 12, 22, 32, 13, 23, 33 };
  private.zz_abovefireplace.start_state = { 22, 33, 21, 32, 11, 23, 31, 12, 13 };
  
  private.zz_abovefireplace.chosen = 0;
  
  private.zz_abovefireplace.pos = {
    {-67, -89}, {59, -89}, {183, -88},
    {-67, 40}, {59, 40}, {183, 40},
    {-67, 174}, {59, 174}, {183, 174}
  };
  -------------------------------------------------------------------------------------------
  game.hint[ "win_abovefireplace" ] = {

      type = "click",
      use_place = "gzz_abovefireplace_mmg",
      room = "rm_insophiashouse",
      zz = "zz_abovefireplace",
      zz_gate = "gzz_insophiashouse_abovefireplace"
  };
  -----------------------------------------------------------------------------------
  local win_abovefireplace = function ()

    if cmn.IsEventDone( "win_abovefireplace" ) then

      ObjMultiSet( { {"obj_abovefireplace_birds_open", { input = 1 }},
                     {"obj_abovefireplace_birds_inside", { alp = 1 }},
                     {"spr_insophiashouse_abovefireplace_paw", { alp = 1 }},
                     {"spr_insophiashouse_abovefireplace_volunteer_sign", { alp = 1 }},
                     {"spr_abovefireplace_birds_open", { alp = 1 }} } );
      
      ObjDelete( "spr_abovefireplace_birds_closed" );
      ObjDelete( "gzz_abovefireplace_mmg" );
      ObjDelete( "obj_abovefireplace_game" );
      ObjDelete( "spr_insophiashouse_abovefireplace_clock_game" );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_abovefireplace", win_abovefireplace, "rm_insophiashouse" );

end;
--*********************************************************************************************************************
function public.zz_abovefireplace.OpenMg( num, event )
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_zoom_mg");

  local func_after = function ()

    if num == 1 then
      cmn.Lock( 0 );
      cmn.CallEventHandler( event );
    else 
      private.zz_abovefireplace.CheckWin();
    end;

    cmn.MiniGameShow();
    
    ObjMultiSet( { {"obj_abovefireplace_game", { alp = 1, input = 1 }},
                   {"obj_abovefireplace_back", { pos_x = 0, pos_y = 0, scale_x = 1, scale_y = 1 }} } );

  end;
  
  local show_mmg = function ()
  
    ObjAnimate( "obj_abovefireplace_game", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 } );
  
  end;

  private.zz_abovefireplace.active = 1;

  ObjAnimate( "obj_abovefireplace_back", "scale_xy", 0, 0, "", { 0,0,1,1,   0.3,0,1,1,    1.5,0,1.5,1.5 } );
  ObjAnimate( "obj_abovefireplace_back", "pos_xy",   0, 0, show_mmg, { 0,0,0,0,   0.3,0,0,0,    1.5,0,107,99 } );

end;
-----------------------------------------------------------------------------------
function private.zz_abovefireplace.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_abovefireplace" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_abovefireplace" ].state = { 22, 33, 21, 32, 11, 23, 31, 12, 13 };
  
end;
-----------------------------------------------------------------------------------
function public.zz_abovefireplace.Reset()
  
  local need_r = false;
  
  for i = 1, #private.zz_abovefireplace.state, 1 do
    
    if private.zz_abovefireplace.state[i] ~= private.zz_abovefireplace.start_state[i] then
      
      if not need_r then
        need_r = true;
      end;
      
      local new_pos = 0;
      for j = 1, #private.zz_abovefireplace.state, 1 do
        
        if private.zz_abovefireplace.start_state[j] == private.zz_abovefireplace.state[i] then
          new_pos = j;
          break;
        end;
        
      end;
      
      ObjAnimate("spr_abovefireplace_part_"..private.zz_abovefireplace.state[i], "pos_xy", 0, 0, "", 
      {   0, 0, private.zz_abovefireplace.pos[i][1], private.zz_abovefireplace.pos[i][2],
        0.5, 0, private.zz_abovefireplace.pos[new_pos][1], private.zz_abovefireplace.pos[new_pos][2] });
      
    end;
    
  end;
  
  if need_r then
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");
    
    private.zz_abovefireplace.StartConditions();
    private.zz_abovefireplace.state = ng_global.progress[ ng_global.currentprogress ][ "win_abovefireplace" ].state;
    
    ObjSet("tmr_abovefireplace_timer",  { time = 0.5, playing = 1, endtrig = function () cmn.Lock( 0 ); cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_clk_small_part"); end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_abovefireplace.Skip()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");
  
  ng_global.progress[ ng_global.currentprogress ][ "win_abovefireplace" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_abovefireplace" ].state = { 11, 21, 31, 12, 22, 32, 13, 23, 33 };
  
  for i = 1, #private.zz_abovefireplace.state, 1 do
    
    if private.zz_abovefireplace.state[i] ~= private.zz_abovefireplace.win_state[i] then
      
      local new_pos = 0;
      for j = 1, #private.zz_abovefireplace.state, 1 do
        
        if private.zz_abovefireplace.win_state[j] == private.zz_abovefireplace.state[i] then
          new_pos = j;
          break;
        end;
        
      end;
      
      ObjAnimate("spr_abovefireplace_part_"..private.zz_abovefireplace.state[i], "pos_xy", 0, 0, "", 
      {   0, 0, private.zz_abovefireplace.pos[i][1], private.zz_abovefireplace.pos[i][2],
        0.5, 0, private.zz_abovefireplace.pos[new_pos][1], private.zz_abovefireplace.pos[new_pos][2] });
      
    end;
    
  end;
  
  private.zz_abovefireplace.state = ng_global.progress[ ng_global.currentprogress ][ "win_abovefireplace" ].state;
  ObjSet("tmr_abovefireplace_timer",  { time = 0.5, playing = 1, endtrig = function() cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_clk_small_part"); private.zz_abovefireplace.CheckWin(); end });
  
end;
-----------------------------------------------------------------------------------
function private.zz_abovefireplace.DrawScene()
  
  for i = 1, #private.zz_abovefireplace.state, 1 do
    
    ObjSet("spr_abovefireplace_part_"..private.zz_abovefireplace.state[i],  { pos_x = private.zz_abovefireplace.pos[i][1], pos_y = private.zz_abovefireplace.pos[i][2] });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_abovefireplace.FocusPart( part, inout )

  local obj = "spr_abovefireplace_part_"..part;
  local scale = ObjGet( obj ).scale_x;
  local tme = 0;
  
  local max_scale = 1.05; 
  local max_tme = 0.3;
  local end_scale = 1;
  
  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = ( ( scale - 1 ) * max_tme ) / ( max_scale - 1 );
  else 
    SetCursor(CURSOR_HAND);
    end_scale = max_scale;
    tme = ( ( max_scale - scale ) * max_tme ) / ( max_scale - 1 );
    if tme > 0.13 then
      cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_menter1");
    end;
  end;
  
  ObjAnimate(obj, "scale_xy", 0, 0, "", { 0, 2, scale, scale,   tme, 2, end_scale, end_scale });

end;
-----------------------------------------------------------------------------------
function public.zz_abovefireplace.ChoosePart( num )
  
  if private.zz_abovefireplace.chosen ~= 0 then

    --cancel selection
    if private.zz_abovefireplace.chosen == num then

      private.zz_abovefireplace.chosen = 0;
      private.zz_abovefireplace.SelectAnim( num, 0 );

    --switch items
    else

      local old = private.zz_abovefireplace.chosen;
      private.zz_abovefireplace.chosen = 0;
      private.zz_abovefireplace.SwitchAnim( old, num  );

    end;

  --first selected
  else 
  
    cmn.PlayAudio("snd", "assets/levels/level2/mg_invendingmachine/audio/aud_menter3");

    private.zz_abovefireplace.chosen = num;
    private.zz_abovefireplace.SelectAnim( num, 1 );

  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_abovefireplace.SwitchAnim( num1, num2 )
  
  private.zz_abovefireplace.in_fly = true;

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");

  private.zz_abovefireplace.SelectAnim( num1, 0 );

  local ind1 = private.zz_abovefireplace.FindIndex(num1);
  local ind2 = private.zz_abovefireplace.FindIndex(num2);

  local temp = private.zz_abovefireplace.state[ind1];
  private.zz_abovefireplace.state[ind1] = private.zz_abovefireplace.state[ind2];
  private.zz_abovefireplace.state[ind2] = temp;
  
  local func_after = function ()
  
    ObjAttach("spr_abovefireplace_part_"..num1, "obj_abovefireplace_game");
    ObjAttach("spr_abovefireplace_part_"..num2, "obj_abovefireplace_game");
    
  end;

  ObjAttach("spr_abovefireplace_part_"..num1, "obj_abovefireplace_game_fly");
  ObjAttach("spr_abovefireplace_part_"..num2, "obj_abovefireplace_game_fly");
  
  ObjAnimate("spr_abovefireplace_part_"..num1, "pos_xy", 0, 0, func_after, { 0, 0, private.zz_abovefireplace.pos[ind1][1], private.zz_abovefireplace.pos[ind1][2], 
                                                                           0.5, 0, private.zz_abovefireplace.pos[ind2][1], private.zz_abovefireplace.pos[ind2][2] });

  ObjAnimate("spr_abovefireplace_part_"..num2, "pos_xy", 0, 0, "", { 0, 0, private.zz_abovefireplace.pos[ind2][1], private.zz_abovefireplace.pos[ind2][2], 
                                                                   0.5, 0, private.zz_abovefireplace.pos[ind1][1], private.zz_abovefireplace.pos[ind1][2] });

  ObjSet("tmr_abovefireplace_timer",  { time = 0.5, playing = 1, endtrig = function() cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_clk_small_part"); private.zz_abovefireplace.CheckWin(); end });

end;
-----------------------------------------------------------------------------------
function private.zz_abovefireplace.FindIndex( num )

  local ind = 0;

  for i = 1, #private.zz_abovefireplace.state, 1 do
  
    if private.zz_abovefireplace.state[i] == num then
      ind =  i;
      break;
    end;
    
  end;

  return ind;

end;
-----------------------------------------------------------------------------
function private.zz_abovefireplace.SelectAnim( num, inout )

  local name = "spr_abovefireplace_part_"..num.."_select";
  local cur_alp = ObjGet(name).alp;

  local ind = private.zz_abovefireplace.FindIndex( num );

  if inout == 1 then

    ObjAnimate( name, "alp", 0, 0, "", { 0, 2, 0,   0.2, 2, 1 });

  elseif inout == 0 then

    ObjAnimate( name, "alp", 0, 0, "", { 0, 0, cur_alp,   0.2, 0, 0 });

  end;

end;
-----------------------------------------------------------------------------------
function private.zz_abovefireplace.CheckWin()
  
  private.zz_abovefireplace.in_fly = false;
  local win_flag = true;
  
  for i = 1, #private.zz_abovefireplace.state, 1 do
    
    if private.zz_abovefireplace.state[i] ~= private.zz_abovefireplace.win_state[i] then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("abovefireplace");
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/rm_nearnurseshouse/audio/aud_opn_box4");
      
      ObjSet("obj_abovefireplace_birds_inside",  { alp = 1 });
      ObjAnimate("spr_abovefireplace_birds_open", "alp", 0, 0, private.zz_abovefireplace.Win, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("spr_abovefireplace_birds_closed", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;
    
    ObjAnimate("obj_abovefireplace_game", "alp", 0, 0, anm_open, { 0, 0, 1,   1, 0, 1,   1.5, 0, 0 });
    
  else 
    cmn.Lock( 0 );
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_abovefireplace.Win()
  
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_abovefireplace" );
  cmn.CallEventHandler( "win_abovefireplace" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_abovefireplace" ].skip == 0 and ng_global.noskipgames[ "win_abovefireplace" ] == nil then

    ng_global.noskipgames[ "win_abovefireplace" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

  cmn.Lock( 0 );
  
end;
--*******************************************************************************************************************