-- name=rm_lvl4corridor
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_lvl4corridor";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Tvsetunit();
  --------------------------------------------------------------------------------------------
  -- function get_brush () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_brush" ] = {
        type = "get",
        get_obj = "spr_tvsetunit_brush",
        room = private.room_objname,
        zz = "zz_tvsetunit",
        zz_gate = "gzz_lvl4corridor_tvsetunit"
    };
    --------------------------------------------------------------------------------------------
  local get_brush_inv = function ()
  
    interface.InventoryItemAdd( "inv_brush", "spr_tvsetunit_brush" );
  
  end;
  
  local get_brush_end = function ()
  
    ObjDelete( "gfx_tvsetunit_brush" );
    ObjDelete( "spr_tvsetunit_brush_shadow" );
    ObjDelete( "spr_lvl4corridor_tv_brush" );
  
  end;
  
  cmn.AddSubscriber( "get_brush", get_brush_inv );
  cmn.AddSubscriber( "get_brush", get_brush_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_puzzlepart3 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_puzzlepart3" ] = {
        type = "get",
        get_obj = "spr_tvsetunit_puzzlepart3",
        room = private.room_objname,
        zz = "zz_tvsetunit",
        zz_gate = "gzz_lvl4corridor_tvsetunit"
    };
    --------------------------------------------------------------------------------------------
  local get_puzzlepart3_inv = function ()
  
    interface.InventoryItemAdd( "inv_puzzlepart", "spr_tvsetunit_puzzlepart3", function () cmn.GetMultyObject( 'puzzlepart', 4 ); end );
    int_map_impl.DecreaseRoomTasks("rm_lvl4corridor");
  
  end;
  
  local get_puzzlepart3_end = function ()
  
    ObjDelete( "gfx_tvsetunit_puzzlepart3" );
    ObjDelete( "spr_tvsetunit_puzzlepart3_shadow" );
    
    if cmn.IsEventDone("get_badgepart2") then
      ObjDelete( "gzz_lvl4corridor_tvsetunit" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_puzzlepart3", get_puzzlepart3_inv );
  cmn.AddSubscriber( "get_puzzlepart3", get_puzzlepart3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pandaseye1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_pandaseye1" ] = {
        type = "get",
        get_obj = "spr_tvsetunit_pandaseye1",
        room = private.room_objname,
        zz = "zz_tvsetunit",
        zz_gate = "gzz_lvl4corridor_tvsetunit"
    };
    --------------------------------------------------------------------------------------------
  local get_pandaseye1_inv = function ()
  
    interface.InventoryItemAdd( "inv_pandaseye1", "spr_tvsetunit_pandaseye1" );
  
  end;
  
  local get_pandaseye1_end = function ()
  
    ObjDelete( "gfx_tvsetunit_pandaseye1" );
    ObjDelete( "spr_tvsetunit_pandaseye1_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_pandaseye1", get_pandaseye1_inv );
  cmn.AddSubscriber( "get_pandaseye1", get_pandaseye1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_badgepart2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_badgepart2" ] = {
        type = "get",
        get_obj = "spr_tvsetunit_badgepart2",
        room = private.room_objname,
        zz = "zz_tvsetunit",
        zz_gate = "gzz_lvl4corridor_tvsetunit"
    };
    --------------------------------------------------------------------------------------------
  local get_badgepart2_inv = function ()
  
    interface.InventoryItemAdd( "inv_badgepart", "spr_tvsetunit_badgepart2", function () cmn.GetMultyObject( 'badgepart', 2 ); end );
    int_map_impl.DecreaseRoomTasks("rm_lvl4corridor");
  
  end;
  
  local get_badgepart2_end = function ()
  
    ObjDelete( "gfx_tvsetunit_badgepart2" );
    ObjDelete( "spr_tvsetunit_badgepart2_shadow" );
    ObjDelete( "spr_lvl4corridor_tv_card" );
    
    if cmn.IsEventDone("get_puzzlepart3") then
      ObjDelete( "gzz_lvl4corridor_tvsetunit" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_badgepart2", get_badgepart2_inv );
  cmn.AddSubscriber( "get_badgepart2", get_badgepart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_jackshead () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_jackshead" ] = {
        type = "get",
        get_obj = "spr_serviceroomdoor_jackshead",
        room = private.room_objname,
        zz = "zz_serviceroomdoor",
        zz_gate = "gzz_lvl4corridor_serviceroomdoor"
    };
    --------------------------------------------------------------------------------------------
  local get_jackshead_inv = function ()
  
    interface.InventoryItemAdd( "inv_jackshead", "spr_serviceroomdoor_jackshead" );
  
  end;
  
  local get_jackshead_end = function ()
  
    ObjDelete( "gfx_serviceroomdoor_jackshead" );
    ObjDelete( "spr_serviceroomdoor_jackshead_sh" );
    
    ObjDelete( "spr_lvl4corridor_service_pumpkin" );
  
  end;
  
  cmn.AddSubscriber( "get_jackshead", get_jackshead_inv );
  cmn.AddSubscriber( "get_jackshead", get_jackshead_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_umbrella () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_umbrella" ] = {
        type = "get",
        get_obj = "obj_walloffame_umbrella_get",
        room = private.room_objname,
        zz = "zz_walloffame",
        zz_gate = "gzz_lvl4corridor_walloffame"
    };
    --------------------------------------------------------------------------------------------
  local get_umbrella_inv = function ()
  
    interface.InventoryItemAdd( "inv_umbrella", "spr_walloffame_umbrella" );
  
  end;
  
  local get_umbrella_end = function ()
  
    ObjDelete( "obj_walloffame_umbrella_get" );
    ObjDelete( "spr_walloffame_umbrella_sh" );
    ObjDelete( "spr_walloffame_umbrella_sh_2" );
    ObjDelete( "spr_walloffame_umbrella_bl" );
    
    ObjDelete( "spr_lvl4corridor_wall_umbrella" );
  
  end;
  
  cmn.AddSubscriber( "get_umbrella", get_umbrella_inv );
  cmn.AddSubscriber( "get_umbrella", get_umbrella_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_jackshead () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_jackshead" ] = {
        type = "use",
        inv_obj = "inv_jackshead",
        use_place = "obj_tvsetunit_use_jackshead",
        room = private.room_objname,
        zz = "zz_tvsetunit",
        zz_gate = "gzz_lvl4corridor_tvsetunit"
    };
  --------------------------------------------------------------------------------------------
  local use_jackshead_inv = function ()
  
    interface.InventoryItemRemove( "inv_jackshead" );
  
  end;
  local use_jackshead_beg = function ()
  
    ObjDelete( "obj_tvsetunit_use_jackshead" );
  
  end;
  local use_jackshead_end = function ()

    ObjMultiSet( { {"anm_tvsetunit_jacks_head", { alp = 1 }},
                   {"spr_lvl4corridor_tv_jackhead", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_catshead") then
      ObjDelete( "anm_tvsetunit_cup" );
      ObjMultiSet( { { "obj_tvsetunit_figures", { alp = 1, input = true } },
                     { "obj_tvsetunit_closed_cup2", { alp = 1 } } } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_jackshead", use_jackshead_beg, private.room_objname );
  cmn.AddSubscriber( "use_jackshead", use_jackshead_inv );
  cmn.AddSubscriber( "use_jackshead", use_jackshead_end, private.room_objname );
  cmn.AddSubscriber( "use_jackshead_inv", use_jackshead_inv, private.room_objname );
  cmn.AddSubscriber( "use_jackshead_beg", use_jackshead_beg, private.room_objname );
  cmn.AddSubscriber( "use_jackshead_end", use_jackshead_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_catshead () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_catshead" ] = {
        type = "use",
        inv_obj = "inv_catshead",
        use_place = "obj_tvsetunit_use_catshead",
        room = private.room_objname,
        zz = "zz_tvsetunit",
        zz_gate = "gzz_lvl4corridor_tvsetunit"
    };
  --------------------------------------------------------------------------------------------
  local use_catshead_inv = function ()
  
    interface.InventoryItemRemove( "inv_catshead" );
  
  end;
  local use_catshead_beg = function ()
  
    ObjDelete( "obj_tvsetunit_use_catshead" );
  
  end;
  local use_catshead_end = function ()

    ObjMultiSet( { {"anm_tvsetunit_cats_head", { alp = 1 }},
                   {"spr_lvl4corridor_tv_cathead", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_jackshead") then
      ObjDelete( "anm_tvsetunit_cup" );
      ObjMultiSet( { { "obj_tvsetunit_figures", { alp = 1, input = true } },
                     { "obj_tvsetunit_closed_cup2", { alp = 1 } } } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_catshead", use_catshead_beg, private.room_objname );
  cmn.AddSubscriber( "use_catshead", use_catshead_inv );
  cmn.AddSubscriber( "use_catshead", use_catshead_end, private.room_objname );
  cmn.AddSubscriber( "use_catshead_inv", use_catshead_inv, private.room_objname );
  cmn.AddSubscriber( "use_catshead_beg", use_catshead_beg, private.room_objname );
  cmn.AddSubscriber( "use_catshead_end", use_catshead_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_rubbergloves () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_rubbergloves" ] = {
        type = "use",
        inv_obj = "inv_rubbergloves",
        use_place = "obj_tvsetunit_use_rubbergloves",
        room = private.room_objname,
        zz = "zz_tvsetunit",
        zz_gate = "gzz_lvl4corridor_tvsetunit"
    };
  --------------------------------------------------------------------------------------------
  local use_rubbergloves_inv = function ()
  
    interface.InventoryItemRemove( "inv_rubbergloves" );
  
  end;
  local use_rubbergloves_beg = function ()
  
    ObjDelete( "obj_tvsetunit_use_rubbergloves" );
  
  end;
  local use_rubbergloves_end = function ()

    ObjDelete( "fx_tvsetunit_elecricity" );

    ObjMultiSet( { { "spr_tvsetunit_badgepart2", { input = true } },
                   { "anm_tvsetunit_use_gloves", { endtrig = "", frame = 99 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_rubbergloves", use_rubbergloves_beg, private.room_objname );
  cmn.AddSubscriber( "use_rubbergloves", use_rubbergloves_inv );
  cmn.AddSubscriber( "use_rubbergloves", use_rubbergloves_end, private.room_objname );
  cmn.AddSubscriber( "use_rubbergloves_inv", use_rubbergloves_inv, private.room_objname );
  cmn.AddSubscriber( "use_rubbergloves_beg", use_rubbergloves_beg, private.room_objname );
  cmn.AddSubscriber( "use_rubbergloves_end", use_rubbergloves_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_syringewithneedle () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_syringewithneedle" ] = {
        type = "use",
        inv_obj = "inv_syringewithneedle",
        use_place = "obj_lvl4warddoor_use_syringewithneedle",
        room = private.room_objname,
        zz = "zz_lvl4warddoor",
        zz_gate = "gzz_lvl4corridor_lvl4warddoor"
    };
  --------------------------------------------------------------------------------------------
  local use_syringewithneedle_inv = function ()
  
    interface.InventoryItemRemove( "inv_syringewithneedle" );
  
  end;
  local use_syringewithneedle_beg = function ()
  
    ObjDelete( "obj_lvl4warddoor_use_syringewithneedle" );
    ObjDelete( "anm_lvl4warddoor_door_touch" );
  
  end;
  local use_syringewithneedle_end = function ()
  
    ObjDelete( "gzz_lvl4corridor_lvl4warddoor" );
    
    ObjMultiSet( { {"grm_lvl4corridor_ward", { alp = 1, input = 1 }},
                   {"spr_lvl4corridor_ward_open", { alp = 1 }} } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_lvl4corridor_ward_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_syringewithneedle", use_syringewithneedle_beg, private.room_objname );
  cmn.AddSubscriber( "use_syringewithneedle", use_syringewithneedle_inv );
  cmn.AddSubscriber( "use_syringewithneedle", use_syringewithneedle_end, private.room_objname );
  cmn.AddSubscriber( "use_syringewithneedle_inv", use_syringewithneedle_inv, private.room_objname );
  cmn.AddSubscriber( "use_syringewithneedle_beg", use_syringewithneedle_beg, private.room_objname );
  cmn.AddSubscriber( "use_syringewithneedle_end", use_syringewithneedle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl4wire () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_lvl4wire" ] = {
        type = "use",
        inv_obj = "inv_lvl4wire",
        use_place = "obj_serviceroomdoor_use_lvl4wire",
        room = private.room_objname,
        zz = "zz_serviceroomdoor",
        zz_gate = "gzz_lvl4corridor_serviceroomdoor"
    };
  --------------------------------------------------------------------------------------------
  local use_lvl4wire_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl4wire" );
  
  end;
  local use_lvl4wire_beg = function ()
  
    ObjDelete( "obj_serviceroomdoor_use_lvl4wire" );
    ObjDelete( "anm_serviceroomdoor_wire_touch" );
  
  end;
  local use_lvl4wire_end = function ()
    
    ObjMultiSet( { {"anm_serviceroomdoor_use_wire", { alp = 1, frame = 300 }},
                   {"spr_lvl4corridor_service_wire", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_lvl4button") then
      ObjSet( "obj_serviceroomdoor_clk_lvl4button", { input = 1 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl4wire", use_lvl4wire_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4wire", use_lvl4wire_inv );
  cmn.AddSubscriber( "use_lvl4wire", use_lvl4wire_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl4wire_inv", use_lvl4wire_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl4wire_beg", use_lvl4wire_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4wire_end", use_lvl4wire_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl4button () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_lvl4button" ] = {
        type = "use",
        inv_obj = "inv_lvl4button",
        use_place = "obj_serviceroomdoor_use_lvl4button",
        room = private.room_objname,
        zz = "zz_serviceroomdoor",
        zz_gate = "gzz_lvl4corridor_serviceroomdoor"
    };
  --------------------------------------------------------------------------------------------
  local use_lvl4button_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl4button" );
  
  end;
  local use_lvl4button_beg = function ()
  
    ObjDelete( "obj_serviceroomdoor_use_lvl4button" );
  
  end;
  local use_lvl4button_end = function ()
    
    ObjMultiSet( { {"spr_serviceroomdoor_button", { alp = 1 }},
                   {"spr_serviceroomdoor_button_2", { alp = 1 }},
                   {"spr_lvl4corridor_service_button", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_lvl4wire") then
      ObjSet( "obj_serviceroomdoor_clk_lvl4button", { input = 1 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl4button", use_lvl4button_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4button", use_lvl4button_inv );
  cmn.AddSubscriber( "use_lvl4button", use_lvl4button_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl4button_inv", use_lvl4button_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl4button_beg", use_lvl4button_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4button_end", use_lvl4button_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_smallkey () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_smallkey" ] = {
        type = "use",
        inv_obj = "inv_smallkey",
        use_place = "obj_walloffame_use_smallkey",
        room = private.room_objname,
        zz = "zz_walloffame",
        zz_gate = "gzz_lvl4corridor_walloffame"
    };
  --------------------------------------------------------------------------------------------
  local use_smallkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_smallkey" );
  
  end;
  local use_smallkey_beg = function ()
  
    ObjDelete( "obj_walloffame_use_smallkey" );
    ObjDelete( "anm_walloffame_web_touch" );
  
  end;
  local use_smallkey_end = function ()
  
    ObjDelete( "spr_lvl4corridor_wall_net" );
    ObjDelete( "gzz_lvl4corridor_walloffame" );
    ObjSet( "gho_lvl4corridor_honorary", { input = 1, alp = 1, active = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_smallkey", use_smallkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_smallkey", use_smallkey_inv );
  cmn.AddSubscriber( "use_smallkey", use_smallkey_end, private.room_objname );
  cmn.AddSubscriber( "use_smallkey_inv", use_smallkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_smallkey_beg", use_smallkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_smallkey_end", use_smallkey_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_lvl4button () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_lvl4button" ] = {
    type = "click",
    use_place = "obj_serviceroomdoor_clk_lvl4button",
    room = private.room_objname,
    zz = "zz_serviceroomdoor",
    zz_gate = "gzz_lvl4corridor_serviceroomdoor"
  };
  --------------------------------------------------------------------------------------------
  local clk_lvl4button_beg = function ()
    
    ObjDelete( "obj_serviceroomdoor_clk_lvl4button" );
    
  end;
  local clk_lvl4button_end = function ()
  
    ObjDelete( "spr_serviceroomdoor_button" );
    ObjDelete( "anm_serviceroomdoor_lock_touch" );
    
    ObjDelete( "gzz_lvl4corridor_serviceroomdoor" );
    
    ObjMultiSet( { {"spr_serviceroomdoor_lock_open", { alp = 1 }},
                   {"grm_lvl4corridor_serviceroom", { alp = 1, input = 1 }},
                   {"spr_lvl4corridor_service_open", { alp = 1 }} } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_lvl4corridor_serviceroom_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_lvl4button", clk_lvl4button_beg, private.room_objname );
  cmn.AddSubscriber( "clk_lvl4button", clk_lvl4button_end, private.room_objname );
  cmn.AddSubscriber( "clk_lvl4button_beg", clk_lvl4button_beg, private.room_objname );
  cmn.AddSubscriber( "clk_lvl4button_end", clk_lvl4button_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_lvl4corridor () end;
  --------------------------------------------------------------------------------------------
  local opn_lvl4corridor = function ()
  
    int_map_impl.OpenRoom( "rm_lvl4corridor" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_lvl4corridor", opn_lvl4corridor );

end;
--********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_tvsetunit" );

  function zz_tvsetunit.PreOpen()

    if ( cmn.IsEventDone( "use_jackshead" ) and cmn.IsEventDone( "use_catshead" ) and not cmn.IsEventDone( "win_tvsetunit" ) ) then
      private.zz_tvsetunit.DrawScene();
      cmn.MiniGameShow();
      private.zz_tvsetunit.CheckWin();
    end;
    
    if not cmn.IsEventDone("use_rubbergloves") then
      cmn.PlayAudio("env", "assets/levels/common/audio/audio4/aud_wires_env");
    end;

  end;

  function zz_tvsetunit.PreClose()
    
    if ( cmn.IsEventDone( "use_jackshead" ) and cmn.IsEventDone( "use_catshead" ) and not cmn.IsEventDone( "win_tvsetunit" ) ) then
      cmn.MiniGameHide("tvsetunit");
    end;
    
    if not cmn.IsEventDone("use_rubbergloves") then
      cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_corridor_env");
      cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_corridor_env");
    end;
    
  end;

end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_tvsetunit" ].state then 
    private.zz_tvsetunit.StartConditions();
  end;
  private.zz_tvsetunit.state = ng_global.progress[ ng_global.currentprogress ][ "win_tvsetunit" ].state;
  private.zz_tvsetunit.current = ng_global.progress[ ng_global.currentprogress ][ "win_tvsetunit" ].current;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_lvl4corridor();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_corridor_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_corridor_env");
  
  if not ( cmn.IsEventDone( "opn_lvl4corridor" ) ) then
    cmn.Lock(1);
  end;
  
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(10) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
  cmn.HideNote( 0 );
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_jackshead()

  local item = "inv_jackshead";

  if cmn.ApplyObj( item, "gzz_lvl4corridor_tvsetunit" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_tvsetunit" );

  elseif ( cmn.ApplyObj( item, "obj_tvsetunit_use_jackshead" ) ) then

    cmn.CallEventHandler( "use_jackshead_inv" );
    cmn.CallEventHandler( "use_jackshead_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_jackshead" );
      cmn.CallEventHandler( "use_jackshead_end" );
    
      if cmn.IsEventDone("use_catshead") then
        public.zz_tvsetunit.Reset( true );
        cmn.MiniGameShow();
      end;

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");

    ObjAnimate( "anm_tvsetunit_jacks_head", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_catshead()

  local item = "inv_catshead";

  if cmn.ApplyObj( item, "gzz_lvl4corridor_tvsetunit" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_tvsetunit" );

  elseif ( cmn.ApplyObj( item, "obj_tvsetunit_use_catshead" ) ) then

    cmn.CallEventHandler( "use_catshead_inv" );
    cmn.CallEventHandler( "use_catshead_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_catshead" );
      cmn.CallEventHandler( "use_catshead_end" );

      if cmn.IsEventDone("use_jackshead") then
        public.zz_tvsetunit.Reset( true );
        cmn.MiniGameShow();
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");

    ObjAnimate( "anm_tvsetunit_cats_head", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_rubbergloves()

  local item = "inv_rubbergloves";

  if cmn.ApplyObj( item, "gzz_lvl4corridor_tvsetunit" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_tvsetunit" );

  elseif ( cmn.ApplyObj( item, "obj_tvsetunit_use_rubbergloves" ) ) then

    cmn.CallEventHandler( "use_rubbergloves_inv" );
    cmn.CallEventHandler( "use_rubbergloves_beg" );

    local func_after2 = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_rubbergloves" );
      cmn.CallEventHandler( "use_rubbergloves_end" );
    
    end;

    local func_after = function ()
      
      cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_corridor_env");
      cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_corridor_env");

      ObjAnimate( "fx_tvsetunit_elecricity", "alp", 0, 0, func_after2, { 0, 0, 1,    0.3, 0, 0 } );

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4corridor/audio/aud_use_glove");

    ObjSet( "anm_tvsetunit_use_gloves", { endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_syringewithneedle()

  local item = "inv_syringewithneedle";

  if cmn.ApplyObj( item, "gzz_lvl4corridor_lvl4warddoor" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_lvl4warddoor" );

  elseif ( cmn.ApplyObj( item, "obj_lvl4warddoor_use_syringewithneedle" ) ) then

    cmn.CallEventHandler( "use_syringewithneedle_inv" );
    cmn.CallEventHandler( "use_syringewithneedle_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_syringewithneedle" );
      cmn.CallEventHandler( "use_syringewithneedle_end" );
      
      common.CloseSubRoom();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4corridor/audio/aud_use_syringe");

    ObjSet("anm_lvl4warddoor_use_syringewithneedle",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl4wire()

  local item = "inv_lvl4wire";

  if cmn.ApplyObj( item, "gzz_lvl4corridor_serviceroomdoor" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_serviceroomdoor" );

  elseif ( cmn.ApplyObj( item, "obj_serviceroomdoor_use_lvl4wire" ) ) then

    cmn.CallEventHandler( "use_lvl4wire_inv" );
    cmn.CallEventHandler( "use_lvl4wire_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl4wire" );
      cmn.CallEventHandler( "use_lvl4wire_end" );
      
    end;
    
    if not cmn.IsEventDone("get_jackshead") then
      public.get_jackshead();
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/mg_invendingmachine/audio/aud_xx_button2");

    ObjSet("anm_serviceroomdoor_use_wire",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl4button()

  local item = "inv_lvl4button";

  if cmn.ApplyObj( item, "gzz_lvl4corridor_serviceroomdoor" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_serviceroomdoor" );

  elseif ( cmn.ApplyObj( item, "obj_serviceroomdoor_use_lvl4button" ) ) then

    cmn.CallEventHandler( "use_lvl4button_inv" );
    cmn.CallEventHandler( "use_lvl4button_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl4button" );
      cmn.CallEventHandler( "use_lvl4button_end" );
      
    end;
    
    if not cmn.IsEventDone("get_jackshead") then
      public.get_jackshead();
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");

    ObjAnimate( "spr_serviceroomdoor_button", "alp", 0, 0, func_after,
    {
      0.0, 0, 0, 
      0.3, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_smallkey()

  local item = "inv_smallkey";

  if cmn.ApplyObj( item, "gzz_lvl4corridor_walloffame" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_walloffame" );

  elseif ( cmn.ApplyObj( item, "obj_walloffame_use_smallkey" ) ) then

    cmn.CallEventHandler( "use_smallkey_inv" );
    cmn.CallEventHandler( "use_smallkey_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_smallkey" );
      cmn.CallEventHandler( "use_smallkey_end" );
      
      common.CloseSubRoom();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4corridor/audio/aud_use_scissors");

    ObjSet("anm_walloffame_use_scissors",  { alp = 1, playing = 1, endtrig = func_after });
    
  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_brush()

  cmn.SetEventDone( "get_brush" );
  cmn.CallEventHandler( "get_brush" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_puzzlepart3()

  cmn.SetEventDone( "get_puzzlepart3" );
  cmn.CallEventHandler( "get_puzzlepart3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_badgepart2") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_pandaseye1()

  cmn.SetEventDone( "get_pandaseye1" );
  cmn.CallEventHandler( "get_pandaseye1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_badgepart2()

  cmn.SetEventDone( "get_badgepart2" );
  cmn.CallEventHandler( "get_badgepart2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_puzzlepart3") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_jackshead()

  cmn.SetEventDone( "get_jackshead" );
  cmn.CallEventHandler( "get_jackshead" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_umbrella()

  cmn.SetEventDone( "get_umbrella" );
  cmn.CallEventHandler( "get_umbrella" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function public.clk_lvl4button()
  
  cmn.CallEventHandler( "clk_lvl4button_beg" );
  
  local func_after = function ()
    
    cmn.Lock( 0 );
    
    cmn.SetEventDone("clk_lvl4button");
    cmn.CallEventHandler( "clk_lvl4button_end" );
    
    common.CloseSubRoom();
    
  end;
  
  local anm_lock = function ()
    
    ObjAnimate("spr_serviceroomdoor_lock_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1,  1, 0, 1 });
    ObjAnimate("anm_serviceroomdoor_lock_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    
  end;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_opn_door2");
  
  ObjAnimate("spr_serviceroomdoor_button", "alp", 0, 0, anm_lock, { 0, 0, 1,   0.3, 0, 0,   0.5, 0, 0 });
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_lvl4corridor()

  if not ( cmn.IsEventDone( "opn_lvl4corridor" ) ) then
    
    local func_after = function ()
      
      cmn.ShowBbt( "lvl4corridor_open" );
      
      cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_corridor_env");
      
    end;
    
    cmn.Lock(0);
    cmn.StopAllEnv();
    
    cmn.SetEventDone( "opn_lvl4corridor" );
    cmn.CallEventHandler("opn_lvl4corridor");
    
    cmn.PlayFullscreenVideo( "assets/levels/level4/rm_lvl4corridor/vid_news", func_after, "assets/levels/level4/rm_lvl4corridor/audio/aud_news", "assets/levels/level4/rm_lvl4corridor/audio/aud_news_voc");
    
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_serviceroom_door( num )
  
  cmn.Lock(1);
  
  if num == 1 then
    cmn.ShowBbt( "obj_serviceroomdoor_use_lvl4wire" );
  else 
    cmn.ShowBbt( "obj_serviceroomdoor_use_lvl4button" );
  end;
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_clk_beep");
  
  ObjSet("anm_serviceroomdoor_lock_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
  if not cmn.IsEventDone("use_lvl4wire") then
    cmn.PlayAudio("snd", "assets/levels/level2/mg_invendingmachine/audio/aud_xx_button2");
    ObjSet("anm_serviceroomdoor_wire_touch",  { playing = 1 });
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_ward_door()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_lvl4warddoor_use_syringewithneedle" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_clk_handle");
  
  ObjSet("anm_lvl4warddoor_door_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_web()
  
  cmn.ShowBbt( "obj_walloffame_use_smallkey" );
  
  if cmn.IsEventDone("get_umbrella") then
  
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4corridor/audio/aud_xx_clk_rope4");
    
    ObjSet("anm_walloffame_web_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
      
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_closed_cup( num )
  
  cmn.Lock(1);
  
  if ( num == 1 ) then
    cmn.ShowBbt( "obj_tvsetunit_use_jackshead" );
  else
    cmn.ShowBbt( "obj_tvsetunit_use_catshead" );
  end;

  cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_xx_clk_wood4");

  ObjSet( "anm_tvsetunit_cats_head", { playing = true } );
  ObjSet( "anm_tvsetunit_jacks_head", { playing = true } );
  ObjSet( "anm_tvsetunit_cup", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_10_1", { alp = 1 }},
                 {"spr_col_10_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_10_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_10_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_10_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_10_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_10_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_10_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--*********************************************************************************************************************
-- function *** MMG_Tvsetunit *** () end;
--*********************************************************************************************************************
private.zz_tvsetunit = {};
public.zz_tvsetunit = {};

function private.Init_Tvsetunit()

  private.zz_tvsetunit.body_pos = {
    --поз  1              2               3           тело
    { { 44, -164 }, { -52, -165 }, { -137, -170 } },  --1
    { { 41, -159 }, { -59, -144 }, { -145, -156 } },  --2
    { { 42, -156 }, { -59, -142 }, { -145, -150 } }   --3
  };

  private.zz_tvsetunit.head_offset = {
    --тело 1            2             3          голова
    { { -5, -48 }, { 16, -39 }, { -2, -42 } },   --1
    { { -5, -55 }, { 15, -41 }, { -4, -51 } },   --2
    { { -5, -57 }, { 14, -46 }, {  2, -52 } }    --3
  };

  private.zz_tvsetunit.fig_pos = { { 41, -168 }, { -60, -149 }, { -146, -148 } };

  private.zz_tvsetunit.start_fig_pos = {
    body = { 3, 1, 2 },   --тела
    head = { 2, 3, 1 }    --головы
  };
  
  -------------------------------------------------------------------------------------------
  game.hint[ "win_tvsetunit" ] = {
      type = "win",
      room = "rm_lvl4corridor",
      zz = "zz_tvsetunit",
      zz_gate = "gzz_lvl4corridor_tvsetunit"
  };
  -----------------------------------------------------------------------------------
  local win_tvsetunit = function ()

    if cmn.IsEventDone( "win_tvsetunit" ) then

      ObjDelete( "obj_tvsetunit_closed_cup2" );
      ObjDelete( "obj_tvsetunit_figures" );
      ObjDelete( "spr_lvl4corridor_tv_box_closed" );

      ObjMultiSet( { { "spr_tvsetunit_opened_cup", { alp = 1 } },
                     { "obj_tvsetunit_casket_opn_items", { alp = 1, input = true } },
                     { "spr_lvl4corridor_tv_box_open", { alp = 1 } } } );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_tvsetunit", win_tvsetunit, "rm_lvl4corridor" );

end;
-----------------------------------------------------------------------------------
function private.zz_tvsetunit.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_tvsetunit" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_tvsetunit" ].state = {
    body = { 3, 1, 2 },   --тела
    head = { 2, 3, 1 }    --головы
  };
  
  ng_global.progress[ ng_global.currentprogress ][ "win_tvsetunit" ].current = {0, 0, 0};

end;
-----------------------------------------------------------------------------------
function public.zz_tvsetunit.Reset( first_start )

  --DbgTrace( "***Reset" );

  if ( not first_start ) then

    local go_reset = false;

    for i = 1, 3, 1 do
      if ( private.zz_tvsetunit.state.body[i] ~= private.zz_tvsetunit.start_fig_pos.body[i] )
      or ( private.zz_tvsetunit.state.head[i] ~= private.zz_tvsetunit.start_fig_pos.head[i] ) then
        go_reset = true;
        break;
      end;
    end;

    if ( not go_reset ) then
      return;
    end;

  end;

  cmn.Lock( 1 );

  private.zz_tvsetunit.StartConditions();
  private.zz_tvsetunit.state = ng_global.progress[ ng_global.currentprogress ][ "win_tvsetunit" ].state;
  private.zz_tvsetunit.current = ng_global.progress[ ng_global.currentprogress ][ "win_tvsetunit" ].current;

  local func_after = function ()

    private.zz_tvsetunit.DrawScene();

    ObjAnimate( "obj_tvsetunit_figures", "alp", 0, 0, function () cmn.Lock( 0 ); end, { 0, 0, 0,    0.3, 0, 1 } );

  end;

  ObjAnimate( "obj_tvsetunit_figures", "alp", 0, 0, func_after, { 0, 0, 1,    0.3, 0, 0 } );

end;
-----------------------------------------------------------------------------------
function public.zz_tvsetunit.Skip()

  --DbgTrace( "***Skip" );

  ng_global.progress[ ng_global.currentprogress ][ "win_tvsetunit" ].skip = 1;

  cmn.Lock( 1 );

  for i = 1, 3, 1 do
    private.zz_tvsetunit.state.body[i] = i;
    private.zz_tvsetunit.state.head[i] = i;
  end;

  local func_after = function ()

    private.zz_tvsetunit.DrawScene();

    ObjAnimate( "obj_tvsetunit_figures", "alp", 0, 0, private.zz_tvsetunit.CheckWin, { 0, 0, 0,    0.3, 0, 1 } );

  end;

  ObjAnimate( "obj_tvsetunit_figures", "alp", 0, 0, func_after, { 0, 0, 1,    0.3, 0, 0 } );

end;
-----------------------------------------------------------------------------------
function private.zz_tvsetunit.DrawScene()

  --DbgTrace( "***DrawScene" );

  local body_num;
  local head_num;

  local body_pos;
  local head_offset;
  
  --check for forcequit
  if private.zz_tvsetunit.current[1] ~= 0 then
    
    for i = 1, 3, 1 do
      
      if private.zz_tvsetunit.state[ private.zz_tvsetunit.current[1] ][i] == 0 then
        private.zz_tvsetunit.state[ private.zz_tvsetunit.current[1] ][i] = private.zz_tvsetunit.current[2];
        private.zz_tvsetunit.current[1] = 0;
        private.zz_tvsetunit.current[2] = 0;
        private.zz_tvsetunit.current[3] = 0;
        break;
      end;
      
    end;
    
  end;

  ObjMultiSet( { { "spr_tvsetunit_head_shadow2", { alp = 0 } },
                 { "spr_tvsetunit_head_shadow3", { alp = 0 } } } );

  for i = 1, 3, 1 do

    body_num = private.zz_tvsetunit.state.body[i];
    head_num = private.zz_tvsetunit.state.head[i];

    body_pos =    private.zz_tvsetunit.body_pos[ body_num ][ i ];
    head_offset = private.zz_tvsetunit.head_offset[ head_num ][ body_num ]

    ObjSet( "spr_tvsetunit_body"..body_num, {
      pos_x = body_pos[1],
      pos_y = body_pos[2],
      pos_z = i*3
    } );

    ObjSet( "spr_tvsetunit_head"..head_num, {
      pos_x = body_pos[1] + head_offset[1],
      pos_y = body_pos[2] + head_offset[2],
      pos_z = (i*3)+2
    } );

    if ( body_num == head_num ) then
      --DbgTrace( "fig head_shadow "..body_num );
      ObjSet( "spr_tvsetunit_head_shadow"..body_num, { alp = 1 } );
    end;

  end;

end;
-----------------------------------------------------------------------------------
function private.zz_tvsetunit.CheckWin()

  --DbgTrace( "***CheckWin" );

  for i = 1, 3, 1 do
    if ( private.zz_tvsetunit.state.body[i] ~= i )
    or ( private.zz_tvsetunit.state.head[i] ~= i ) then
      --DbgTrace( "wrong fig "..i );
      cmn.Lock( 0 );
      return;
    end;
  end;

  cmn.Lock( 1 );

  --DbgTrace( "WWWWWWWWWIIIIIIIIINNNNNNNN" );
  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
  cmn.PlayAudio("snd", "assets/levels/level2/ho_medical/audio/aud_opn_box");

  ObjSet( "obj_tvsetunit_casket_opn_items", { alp = 1 } );

  ObjAnimate( "obj_tvsetunit_closed_cup2", "alp", 0, 0, "", { 0, 0, 1,    1, 0, 1,    1.5, 0, 0 } );
  ObjAnimate( "obj_tvsetunit_figures",     "alp", 0, 0, "", { 0, 0, 1,    1, 0, 1,    1.5, 0, 0 } );
  ObjAnimate( "spr_tvsetunit_opened_cup",  "alp", 0, 0, private.zz_tvsetunit.Win, { 0, 0, 0,    1, 0, 0,    1.5, 0, 1 } );

end;
-----------------------------------------------------------------------------------
function private.zz_tvsetunit.Win()

  cmn.Lock( 0 );

  cmn.MiniGameHide("tvsetunit");

  cmn.SetEventDone( "win_tvsetunit" );
  cmn.CallEventHandler( "win_tvsetunit" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_tvsetunit" ].skip == 0 and ng_global.noskipgames[ "win_tvsetunit" ] == nil then

    ng_global.noskipgames[ "win_tvsetunit" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

end;
-----------------------------------------------------------------------------------
function public.zz_tvsetunit.StartDragFig( num, kind )

  --DbgTrace( "***StartDragFig "..kind.." "..num );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  ObjAttach( "spr_tvsetunit_"..kind..num, "obj_tvsetunit_figures_drag" );
  
  private.zz_tvsetunit.current[1] = kind;
  private.zz_tvsetunit.current[2] = num;

  for i = 1, 3, 1 do
    if ( private.zz_tvsetunit.state[kind][i] == num ) then

      if ( private.zz_tvsetunit.state.body[i] == private.zz_tvsetunit.state.head[i] ) then
        --DbgTrace( "fig head_shadow "..num.." off" );
        ObjSet( "spr_tvsetunit_head_shadow"..num, { alp = 0 } );
      end;

      private.zz_tvsetunit.current[3] = i;
      private.zz_tvsetunit.state[kind][i] = 0;
      --DbgTrace( "была в слоте "..i );
      break;

    end;
  end;

end;
-----------------------------------------------------------------------------------
function public.zz_tvsetunit.DropDragFig( num, kind )

  --DbgTrace( "***DropDragFig "..kind.." "..num );

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");
  
  private.zz_tvsetunit.current[1] = 0;
  private.zz_tvsetunit.current[2] = 0;
  private.zz_tvsetunit.current[3] = 0;

  local fig_name = "spr_tvsetunit_"..kind..num;
  local curspos = GetObjPosByObj( fig_name, "obj_tvsetunit_figures" );
  local new_pos = 0;         --новая позиция
  local start_drag_fig = 0;  --если в новой позиции была фигура, начнем ее тоскать

  --DbgTrace( curspos[1].." "..curspos[2] );

  for i = 1, 3, 1 do
    if  ( private.zz_tvsetunit.fig_pos[i][1] - 35 < curspos[1] ) and ( private.zz_tvsetunit.fig_pos[i][1] + 35 > curspos[1] )
    and ( private.zz_tvsetunit.fig_pos[i][2] - 85 < curspos[2] ) and ( private.zz_tvsetunit.fig_pos[i][2] + 85 > curspos[2] ) then

      --DbgTrace( "fig "..kind.." "..num.." -> pos "..i );
      new_pos = i;

      if ( private.zz_tvsetunit.state[kind][i] ~= num ) then
        start_drag_fig = private.zz_tvsetunit.state[kind][i];
        private.zz_tvsetunit.state[kind][i] = num;
      end;

      break;

    end;
  end;

  if ( new_pos == 0 ) then    --выбросили в левое место, летит в пустой слот
    for i = 1, 3, 1 do
      if ( private.zz_tvsetunit.state[kind][i] == 0 ) then
        --DbgTrace( "fig "..kind.." "..num.." -> pos "..i );
        new_pos = i;
        private.zz_tvsetunit.state[kind][i] = num;
      end;
    end;
  end;

  local end_pos_xy;

  if ( kind == "head" ) then

    local body_num = private.zz_tvsetunit.state.body[new_pos];

    end_pos_xy = {
      private.zz_tvsetunit.body_pos[ body_num ][ new_pos ][1] + private.zz_tvsetunit.head_offset[ num ][ body_num ][1],
      private.zz_tvsetunit.body_pos[ body_num ][ new_pos ][2] + private.zz_tvsetunit.head_offset[ num ][ body_num ][2]
    };

    --DbgTrace(
    --  "body_pos "..
    --  private.zz_tvsetunit.body_pos[ body_num ][ new_pos ][1].." "..
    --  private.zz_tvsetunit.body_pos[ body_num ][ new_pos ][2]
    --);
    --DbgTrace(
    --  "head_offset "..
    --  private.zz_tvsetunit.head_offset[ num ][ body_num ][1].." "..
    --  private.zz_tvsetunit.head_offset[ num ][ body_num ][2]
    --);

  else

    end_pos_xy = { private.zz_tvsetunit.body_pos[ num ][ new_pos ][1], private.zz_tvsetunit.body_pos[ num ][ new_pos ][2] };
    --DbgTrace( "body_pos "..end_pos_xy[1].." "..end_pos_xy[2] );

  end;

  local len = common_impl.math.FindSegmentLength( curspos, end_pos_xy );
  local tme = 0.002 * len;
  tme = ( tme <= 0.3 ) and tme or 0.3;

  if ( kind == "body" ) then

    local head_num = private.zz_tvsetunit.state.head[new_pos];
    local head_name = "spr_tvsetunit_head"..head_num;

    local head_end_pos_xy = {
      end_pos_xy[1] + private.zz_tvsetunit.head_offset[ head_num ][ num ][1],
      end_pos_xy[2] + private.zz_tvsetunit.head_offset[ head_num ][ num ][2]
    };

    --DbgTrace(
    --  "fig head "..head_num.." "..
    --  ObjGet( head_name ).pos_x.." "..ObjGet( head_name ).pos_y.." -> "..
    --  private.zz_tvsetunit.head_offset[ head_num ][ num ][1].." "..
    --  private.zz_tvsetunit.head_offset[ head_num ][ num ][2]
    --);

    ObjAnimate( head_name, "pos_xy", 0, 0, "", {
      0,   0, ObjGet( head_name ).pos_x, ObjGet( head_name ).pos_y,
      tme, 0, head_end_pos_xy[1], head_end_pos_xy[2]
    } );

  end;

  local func_after = function()

    ObjSet( fig_name, { pos_z = (kind == "head") and (new_pos * 3)+2 or (new_pos * 3) } );
    ObjAttach( fig_name, "obj_tvsetunit_figures" );
    --DbgTrace( "fig pos_z = "..( (kind == "head") and (new_pos * 3)+2 or (new_pos * 3) ) );

    if ( private.zz_tvsetunit.state.body[new_pos] == private.zz_tvsetunit.state.head[new_pos] ) then
      --DbgTrace( "fig head_shadow "..num );
      ObjSet( "spr_tvsetunit_head_shadow"..num, { alp = 1 } );
    else
      --DbgTrace( "fig head_shadow "..private.zz_tvsetunit.state.body[new_pos].." off" );
      ObjSet( "spr_tvsetunit_head_shadow"..private.zz_tvsetunit.state.body[new_pos], { alp = 0 } );
    end;

    if ( start_drag_fig ~= 0 ) then
      ObjSet("tmr_tvsetunit_mg",{ time = 0.1, playing = true, endtrig = function()
        ObjSet("spr_tvsetunit_"..kind..start_drag_fig,{ pos_x = -1000, pos_y = -1000});
        public.zz_tvsetunit.DropDragFig( start_drag_fig, kind );
      end });
      --ObjStartDrag( "spr_tvsetunit_"..kind..start_drag_fig ); --начинаем таскать фигуру которую заменили
    end;

    if ( new_pos == num ) then  --если поставили в свой слот
      private.zz_tvsetunit.CheckWin();
    else
      cmn.Lock( 0 );
    end;

  end;

  ObjAnimate( fig_name, "pos_xy", 0, 0, func_after, { 0, 0, curspos[1], curspos[2],   tme, 0, end_pos_xy[1], end_pos_xy[2] } );

end;
--********************************************************************************************************************