-- name=rm_lvl4nearhospital
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_lvl4nearhospital";
  --------------------------------------------------------------------------------------------

  --------------------------------------------------------------------------------------------
  -- function get_salammoniac () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_salammoniac" ] = {
        type = "get",
        get_obj = "spr_emergencycarcab_salammoniac",
        room = private.room_objname,
        zz = "zz_emergencycarcab",
        zz_gate = "gzz_lvl4nearhospital_emergencycarcab"
    };
    --------------------------------------------------------------------------------------------
  local get_salammoniac_inv = function ()
  
    interface.InventoryItemAdd( "inv_salammoniac", "spr_emergencycarcab_salammoniac" );
  
  end;
  
  local get_salammoniac_end = function ()
  
    ObjDelete( "gfx_emergencycarcab_salammoniac" );
    ObjDelete( "spr_emergencycarcab_salammoniac_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_salammoniac", get_salammoniac_inv );
  cmn.AddSubscriber( "get_salammoniac", get_salammoniac_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl4coin () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_lvl4coin" ] = {
        type = "get",
        get_obj = "spr_emergencycarcab_lvl4coin",
        room = private.room_objname,
        zz = "zz_emergencycarcab",
        zz_gate = "gzz_lvl4nearhospital_emergencycarcab"
    };
    --------------------------------------------------------------------------------------------
  local get_lvl4coin_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl4coin", "spr_emergencycarcab_lvl4coin" );
  
  end;
  
  local get_lvl4coin_end = function ()
  
    ObjDelete( "gfx_emergencycarcab_lvl4coin" );
    --ObjDelete( "gzz_lvl4nearhospital_emergencycarcab" );
  
  end;
  
  cmn.AddSubscriber( "get_lvl4coin", get_lvl4coin_inv );
  cmn.AddSubscriber( "get_lvl4coin", get_lvl4coin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_medicalhammer () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_medicalhammer" ] = {
        type = "get",
        get_obj = "spr_emergencycarcab_medicalhammer",
        room = private.room_objname,
        zz = "zz_emergencycarcab",
        zz_gate = "gzz_lvl4nearhospital_emergencycarcab"
    };
    --------------------------------------------------------------------------------------------
  local get_medicalhammer_inv = function ()
  
    interface.InventoryItemAdd( "inv_medicalhammer", "spr_emergencycarcab_medicalhammer" );
  
  end;
  
  local get_medicalhammer_end = function ()
  
    ObjDelete( "gfx_emergencycarcab_medicalhammer" );
    ObjDelete( "spr_emergencycarcab_medicalhammer_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_medicalhammer", get_medicalhammer_inv );
  cmn.AddSubscriber( "get_medicalhammer", get_medicalhammer_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_puzzlepart1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_puzzlepart1" ] = {
        type = "get",
        get_obj = "spr_emergencycarcab_puzzlepart1",
        room = private.room_objname,
        zz = "zz_emergencycarcab",
        zz_gate = "gzz_lvl4nearhospital_emergencycarcab"
    };
    --------------------------------------------------------------------------------------------
  local get_puzzlepart1_inv = function ()
  
    interface.InventoryItemAdd( "inv_puzzlepart", "spr_emergencycarcab_puzzlepart1", function () cmn.GetMultyObject( 'puzzlepart', 4 ); end );
  
  end;
  
  local get_puzzlepart1_end = function ()
  
    ObjDelete( "gfx_emergencycarcab_puzzlepart1" );
    ObjDelete( "spr_emergencycarcab_puzzlepart1_sh" );
    
    if cmn.IsEventDone("get_badgepart1") and cmn.IsEventDone("get_bigsyringe") then
      ObjDelete( "gzz_lvl4nearhospital_emergencycarcab" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_puzzlepart1", get_puzzlepart1_inv );
  cmn.AddSubscriber( "get_puzzlepart1", get_puzzlepart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bigsyringe () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_bigsyringe" ] = {
        type = "get",
        get_obj = "spr_emergencycarcab_bigsyringe",
        room = private.room_objname,
        zz = "zz_emergencycarcab",
        zz_gate = "gzz_lvl4nearhospital_emergencycarcab"
    };
    --------------------------------------------------------------------------------------------
  local get_bigsyringe_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_bigsyringe", "spr_emergencycarcab_bigsyringe" );
  
  end;
  
  local get_bigsyringe_end = function ()
  
    ObjDelete( "gfx_emergencycarcab_bigsyringe" );
    ObjDelete( "spr_emergencycarcab_bigsyringe_sh" );
    
    if cmn.IsEventDone("get_badgepart1") and cmn.IsEventDone("get_puzzlepart1") then
      ObjDelete( "gzz_lvl4nearhospital_emergencycarcab" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_bigsyringe", get_bigsyringe_inv );
  cmn.AddSubscriber( "get_bigsyringe", get_bigsyringe_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_badgepart1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_badgepart1" ] = {
        type = "get",
        get_obj = "spr_emergencycarcab_badgepart1",
        room = private.room_objname,
        zz = "zz_emergencycarcab",
        zz_gate = "gzz_lvl4nearhospital_emergencycarcab"
    };
    --------------------------------------------------------------------------------------------
  local get_badgepart1_inv = function ()
  
    interface.InventoryItemAdd( "inv_badgepart", "spr_emergencycarcab_badgepart1", function () cmn.GetMultyObject( 'badgepart', 2 ); end );
  
  end;
  
  local get_badgepart1_end = function ()
  
    ObjDelete( "gfx_emergencycarcab_badgepart1" );
    ObjDelete( "spr_emergencycarcab_badgepart1_sh" );
    
    if cmn.IsEventDone("get_bigsyringe") and cmn.IsEventDone("get_puzzlepart1") then
      ObjDelete( "gzz_lvl4nearhospital_emergencycarcab" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_badgepart1", get_badgepart1_inv );
  cmn.AddSubscriber( "get_badgepart1", get_badgepart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_float () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_float" ] = {
        type = "get",
        get_obj = "spr_nest_float",
        room = private.room_objname,
        zz = "zz_nest",
        zz_gate = "gzz_lvl4nearhospital_nest"
    };
    --------------------------------------------------------------------------------------------
  local get_float_inv = function ()
  
    interface.InventoryItemAdd( "inv_float", "spr_nest_float" );
  
  end;
  
  local get_float_end = function ()
  
    ObjDelete( "gfx_nest_float" );
    ObjDelete( "spr_nest_float_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_float", get_float_inv );
  cmn.AddSubscriber( "get_float", get_float_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl4screws () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_lvl4screws" ] = {
        type = "get",
        get_obj = "spr_nest_lvl4screws",
        room = private.room_objname,
        zz = "zz_nest",
        zz_gate = "gzz_lvl4nearhospital_nest"
    };
    --------------------------------------------------------------------------------------------
  local get_lvl4screws_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl4screws", "spr_nest_lvl4screws" );
  
  end;
  
  local get_lvl4screws_end = function ()
  
    ObjDelete( "gfx_nest_lvl4screws" );
    ObjDelete( "spr_nest_lvl4screws_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_lvl4screws", get_lvl4screws_inv );
  cmn.AddSubscriber( "get_lvl4screws", get_lvl4screws_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_needle () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_needle" ] = {
        type = "get",
        get_obj = "spr_nest_needle",
        room = private.room_objname,
        zz = "zz_nest",
        zz_gate = "gzz_lvl4nearhospital_nest"
    };
    --------------------------------------------------------------------------------------------
  local get_needle_inv = function ()
  
    interface.InventoryItemAdd( "inv_needle", "spr_nest_needle" );
    ObjSet("inv_tornoffpatch_star_light",  { alp = 1 });
  
  end;
  
  local get_needle_end = function ()
  
    ObjDelete( "gfx_nest_needle" );
    ObjDelete( "spr_nest_needle_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_needle", get_needle_inv );
  cmn.AddSubscriber( "get_needle", get_needle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_smallkey () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_smallkey" ] = {
        type = "get",
        get_obj = "spr_nest_smallkey",
        room = private.room_objname,
        zz = "zz_nest",
        zz_gate = "gzz_lvl4nearhospital_nest"
    };
    --------------------------------------------------------------------------------------------
  local get_smallkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_smallkey", "spr_nest_smallkey" );
  
  end;
  
  local get_smallkey_end = function ()
  
    ObjDelete( "gfx_nest_smallkey" );
    ObjDelete( "spr_nest_smallkey_sh" );
    
    if cmn.IsEventDone("get_lvl4wire") then
      ObjDelete( "gzz_lvl4nearhospital_nest" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_smallkey", get_smallkey_inv );
  cmn.AddSubscriber( "get_smallkey", get_smallkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl4wire () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_lvl4wire" ] = {
        type = "get",
        get_obj = "spr_nest_lvl4wire",
        room = private.room_objname,
        zz = "zz_nest",
        zz_gate = "gzz_lvl4nearhospital_nest"
    };
    --------------------------------------------------------------------------------------------
  local get_lvl4wire_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl4wire", "spr_nest_lvl4wire" );
  
  end;
  
  local get_lvl4wire_end = function ()
  
    ObjDelete( "gfx_nest_lvl4wire" );
    
    if cmn.IsEventDone("get_smallkey") then
      ObjDelete( "gzz_lvl4nearhospital_nest" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_lvl4wire", get_lvl4wire_inv );
  cmn.AddSubscriber( "get_lvl4wire", get_lvl4wire_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lifestaramulet () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_lifestaramulet" ] = {
        type = "get",
        get_obj = "spr_staging_lifestaramulet",
        room = private.room_objname,
        zz = "zz_staging",
        zz_gate = "gzz_lvl4nearhospital_staging"
    };
    --------------------------------------------------------------------------------------------
  local get_lifestaramulet_inv = function ()
  
    interface.InventoryItemAdd( "inv_lifestaramulet", "spr_staging_lifestaramulet" );
  
  end;
  
  local get_lifestaramulet_end = function ()
  
    ObjDelete( "gfx_staging_lifestaramulet" );
    ObjDelete( "anm_staging_use_float" );

    ObjDelete( "spr_lvl4nearhospital_staging_staroflife" );
  
  end;
  
  cmn.AddSubscriber( "get_lifestaramulet", get_lifestaramulet_inv );
  cmn.AddSubscriber( "get_lifestaramulet", get_lifestaramulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bone () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_bone" ] = {
        type = "get",
        get_obj = "spr_lvl4flowerbed_bone",
        room = private.room_objname,
        zz = "zz_lvl4flowerbed",
        zz_gate = "gzz_lvl4nearhospital_lvl4flowerbed"
    };
    --------------------------------------------------------------------------------------------
  local get_bone_inv = function ()
  
    interface.InventoryItemAdd( "inv_bone", "spr_lvl4flowerbed_bone" );
    ObjSet("inv_brokendogcase_star_light",  { alp = 1 });
  
  end;
  
  local get_bone_end = function ()
  
    ObjDelete( "gfx_lvl4flowerbed_bone" );
    ObjDelete( "spr_lvl4flowerbed_bone_sh" );
    
    if cmn.IsEventDone("get_fishingline") and cmn.IsEventDone("get_wrench") then
      ObjDelete( "gzz_lvl4nearhospital_lvl4flowerbed" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_bone", get_bone_inv );
  cmn.AddSubscriber( "get_bone", get_bone_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fishingline () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_fishingline" ] = {
        type = "get",
        get_obj = "spr_lvl4flowerbed_fishingline",
        room = private.room_objname,
        zz = "zz_lvl4flowerbed",
        zz_gate = "gzz_lvl4nearhospital_lvl4flowerbed"
    };
    --------------------------------------------------------------------------------------------
  local get_fishingline_inv = function ()
  
    interface.InventoryItemAdd( "inv_fishingline", "spr_lvl4flowerbed_fishingline" );
    ObjSet("inv_ship_star_light",  { alp = 1 });
  
  end;
  
  local get_fishingline_end = function ()
  
    ObjDelete( "gfx_lvl4flowerbed_fishingline" );
    
    if cmn.IsEventDone("get_bone") and cmn.IsEventDone("get_wrench") then
      ObjDelete( "gzz_lvl4nearhospital_lvl4flowerbed" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_fishingline", get_fishingline_inv );
  cmn.AddSubscriber( "get_fishingline", get_fishingline_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wrench () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_wrench" ] = {
        type = "get",
        get_obj = "spr_lvl4flowerbed_wrench",
        room = private.room_objname,
        zz = "zz_lvl4flowerbed",
        zz_gate = "gzz_lvl4nearhospital_lvl4flowerbed"
    };
    --------------------------------------------------------------------------------------------
  local get_wrench_inv = function ()
  
    interface.InventoryItemAdd( "inv_wrench", "spr_lvl4flowerbed_wrench" );
    int_map_impl.DecreaseRoomTasks("rm_lvl4nearhospital");
    
    if cmn.IsEventDone("use_lvl4bolt") then
      ObjSet("inv_brokendogcase_star_light",  { alp = 1 });
    end;
  
  end;
  
  local get_wrench_end = function ()
  
    ObjDelete( "gfx_lvl4flowerbed_wrench" );
    ObjDelete( "spr_lvl4flowerbed_wrench_sh" );
    ObjDelete( "spr_lvl4nearhospital_flowerbed_wranch" );
    
    if cmn.IsEventDone("get_fishingline") and cmn.IsEventDone("get_bone") then
      ObjDelete( "gzz_lvl4nearhospital_lvl4flowerbed" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_wrench", get_wrench_inv );
  cmn.AddSubscriber( "get_wrench", get_wrench_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_lifestaramulet () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_lifestaramulet" ] = {
        type = "use",
        inv_obj = "inv_lifestaramulet",
        use_place = "obj_emergencycarcab_use_lifestaramulet",
        room = private.room_objname,
        zz = "zz_emergencycarcab",
        zz_gate = "gzz_lvl4nearhospital_emergencycarcab"
    };
  --------------------------------------------------------------------------------------------
  local use_lifestaramulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_lifestaramulet" );
  
  end;
  local use_lifestaramulet_beg = function ()
  
    ObjDelete( "obj_emergencycarcab_use_lifestaramulet" );
    ObjDelete( "anm_emergencycarcab_door_touch" );
  
  end;
  local use_lifestaramulet_end = function ()
  
    ObjDelete( "anm_emergencycarcab_use_star" );
    
    ObjMultiSet( { { "obj_emergencycarcab_inside", { input = 1, alp = 1 } },
                   { "spr_lvl4nearhospital_emergencycarcab", { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lifestaramulet", use_lifestaramulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_lifestaramulet", use_lifestaramulet_inv );
  cmn.AddSubscriber( "use_lifestaramulet", use_lifestaramulet_end, private.room_objname );
  cmn.AddSubscriber( "use_lifestaramulet_inv", use_lifestaramulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_lifestaramulet_beg", use_lifestaramulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_lifestaramulet_end", use_lifestaramulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_umbrella () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_umbrella" ] = {
        type = "use",
        inv_obj = "inv_umbrella",
        use_place = "obj_emergencycarcab_use_umbrella",
        room = private.room_objname,
        zz = "zz_emergencycarcab",
        zz_gate = "gzz_lvl4nearhospital_emergencycarcab"
    };
  --------------------------------------------------------------------------------------------
  local use_umbrella_inv = function ()
  
    interface.InventoryItemRemove( "inv_umbrella" );
  
  end;
  local use_umbrella_beg = function ()
  
    ObjDelete( "obj_emergencycarcab_use_umbrella" );
    ObjDelete( "anm_emergencycarcab_box_touch" );
  
  end;
  local use_umbrella_end = function ()
  
    ObjMultiSet( { {"anm_emergencycarcab_use_umbrella", { alp = 1, frame = 300 }},
                   {"obj_emergencycarcab_medkit", { alp = 1, input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_umbrella", use_umbrella_beg, private.room_objname );
  cmn.AddSubscriber( "use_umbrella", use_umbrella_inv );
  cmn.AddSubscriber( "use_umbrella", use_umbrella_end, private.room_objname );
  cmn.AddSubscriber( "use_umbrella_inv", use_umbrella_inv, private.room_objname );
  cmn.AddSubscriber( "use_umbrella_beg", use_umbrella_beg, private.room_objname );
  cmn.AddSubscriber( "use_umbrella_end", use_umbrella_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_antirust () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_antirust" ] = {
        type = "use",
        inv_obj = "inv_antirust",
        use_place = "obj_emergencycarcab_use_antirust",
        room = private.room_objname,
        zz = "zz_emergencycarcab",
        zz_gate = "gzz_lvl4nearhospital_emergencycarcab"
    };
  --------------------------------------------------------------------------------------------
  local use_antirust_inv = function ()
  
    interface.InventoryItemRemove( "inv_antirust" );
  
  end;
  local use_antirust_beg = function ()
  
    ObjDelete( "obj_emergencycarcab_use_antirust" );
    ObjDelete( "anm_emergencycarcab_rust_touch" );
  
  end;
  local use_antirust_end = function ()
    
    ObjDelete( "anm_emergencycarcab_use_antirust" );
  
    ObjMultiSet( { {"obj_emergencycarcab_medkit2", { alp = 1, input = 1 }},
                   {"spr_emergencycarcab_medkit_open2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_antirust", use_antirust_beg, private.room_objname );
  cmn.AddSubscriber( "use_antirust", use_antirust_inv );
  cmn.AddSubscriber( "use_antirust", use_antirust_end, private.room_objname );
  cmn.AddSubscriber( "use_antirust_inv", use_antirust_inv, private.room_objname );
  cmn.AddSubscriber( "use_antirust_beg", use_antirust_beg, private.room_objname );
  cmn.AddSubscriber( "use_antirust_end", use_antirust_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_salammoniac () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_salammoniac" ] = {
        type = "use",
        inv_obj = "inv_salammoniac",
        use_place = "obj_nest_use_salammoniac",
        room = private.room_objname,
        zz = "zz_nest",
        zz_gate = "gzz_lvl4nearhospital_nest"
    };
  --------------------------------------------------------------------------------------------
  local use_salammoniac_inv = function ()
  
    interface.InventoryItemRemove( "inv_salammoniac" );
  
  end;
  local use_salammoniac_beg = function ()
  
    ObjDelete( "obj_nest_use_salammoniac" );
    ObjDelete( "anm_nest_crow" );
    ObjDelete( "anm_nest_crow_touch" );
  
  end;
  local use_salammoniac_end = function ()
    
    ObjDelete( "anm_nest_use_salammoniac" );
    ObjDelete( "anm_lvl4nearhospital_crow" );
  
    ObjMultiSet( { {"obj_nest_nest", { alp = 1, input = 1 }},
                   {"obj_nest_use_brush", { input = 1 }},
                   {"spr_lvl4nearhospital_nest", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_salammoniac", use_salammoniac_beg, private.room_objname );
  cmn.AddSubscriber( "use_salammoniac", use_salammoniac_inv );
  cmn.AddSubscriber( "use_salammoniac", use_salammoniac_end, private.room_objname );
  cmn.AddSubscriber( "use_salammoniac_inv", use_salammoniac_inv, private.room_objname );
  cmn.AddSubscriber( "use_salammoniac_beg", use_salammoniac_beg, private.room_objname );
  cmn.AddSubscriber( "use_salammoniac_end", use_salammoniac_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_medicalhammer () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_medicalhammer" ] = {
        type = "use",
        inv_obj = "inv_medicalhammer",
        use_place = "obj_nest_use_medicalhammer",
        room = private.room_objname,
        zz = "zz_nest",
        zz_gate = "gzz_lvl4nearhospital_nest"
    };
  --------------------------------------------------------------------------------------------
  local use_medicalhammer_inv = function ()
  
    interface.InventoryItemRemove( "inv_medicalhammer" );
  
  end;
  local use_medicalhammer_beg = function ()
  
    ObjDelete( "obj_nest_use_medicalhammer" );
    ObjDelete( "anm_nest_wall_touch" );
  
  end;
  local use_medicalhammer_end = function ()
  
    ObjSet( "anm_nest_use_hammer", { input = 1, alp = 1, frame = 400 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_medicalhammer", use_medicalhammer_beg, private.room_objname );
  cmn.AddSubscriber( "use_medicalhammer", use_medicalhammer_inv );
  cmn.AddSubscriber( "use_medicalhammer", use_medicalhammer_end, private.room_objname );
  cmn.AddSubscriber( "use_medicalhammer_inv", use_medicalhammer_inv, private.room_objname );
  cmn.AddSubscriber( "use_medicalhammer_beg", use_medicalhammer_beg, private.room_objname );
  cmn.AddSubscriber( "use_medicalhammer_end", use_medicalhammer_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_brush () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_brush" ] = {
        type = "use",
        inv_obj = "inv_brush",
        use_place = "obj_nest_use_brush",
        room = private.room_objname,
        zz = "zz_nest",
        zz_gate = "gzz_lvl4nearhospital_nest"
    };
  --------------------------------------------------------------------------------------------
  local use_brush_inv = function ()
  
    interface.InventoryItemRemove( "inv_brush" );
  
  end;
  local use_brush_beg = function ()
  
    ObjDelete( "obj_nest_use_brush" );
    ObjDelete( "anm_nest_nest_touch" );
    ObjDelete( "spr_nest_dust" );
    ObjDelete( "spr_nest_branch" );
  
  end;
  local use_brush_end = function ()
  
    ObjMultiSet( { {"obj_nest_use_medicalhammer", { input = 1 }},
                   {"anm_nest_use_brush", { alp = 1, frame = 300, pos_z = 0 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_brush", use_brush_beg, private.room_objname );
  cmn.AddSubscriber( "use_brush", use_brush_inv );
  cmn.AddSubscriber( "use_brush", use_brush_end, private.room_objname );
  cmn.AddSubscriber( "use_brush_inv", use_brush_inv, private.room_objname );
  cmn.AddSubscriber( "use_brush_beg", use_brush_beg, private.room_objname );
  cmn.AddSubscriber( "use_brush_end", use_brush_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl4coin () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_lvl4coin" ] = {
        type = "use",
        inv_obj = "inv_lvl4coin",
        use_place = "obj_staging_use_lvl4coin",
        room = private.room_objname,
        zz = "zz_staging",
        zz_gate = "gzz_lvl4nearhospital_staging"
    };
  --------------------------------------------------------------------------------------------
  local use_lvl4coin_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl4coin" );
  
  end;
  local use_lvl4coin_beg = function ()
  
    ObjDelete( "obj_staging_use_lvl4coin" );
    ObjDelete( "anm_staging_screws_touch" );
  
  end;
  local use_lvl4coin_end = function ()
  
    ObjDelete( "gzz_lvl4nearhospital_staging" );
    ObjSet( "grm_lvl4nearhospital_lvl4corridor", { input = 1, alp = 1 } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_lvl4nearhospital_lvl4corridor_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl4coin", use_lvl4coin_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4coin", use_lvl4coin_inv );
  cmn.AddSubscriber( "use_lvl4coin", use_lvl4coin_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl4coin_inv", use_lvl4coin_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl4coin_beg", use_lvl4coin_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4coin_end", use_lvl4coin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_float () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_float" ] = {
        type = "use",
        inv_obj = "inv_float",
        use_place = "obj_staging_use_float",
        room = private.room_objname,
        zz = "zz_staging",
        zz_gate = "gzz_lvl4nearhospital_staging"
    };
  --------------------------------------------------------------------------------------------
  local use_float_inv = function ()
  
    interface.InventoryItemRemove( "inv_float" );
  
  end;
  local use_float_beg = function ()
  
    ObjDelete( "obj_staging_use_float" );
    ObjDelete( "anm_staging_amulet_touch" );
  
  end;
  local use_float_end = function ()
  
    --ObjSet( "spr_staging_lifestaramulet", { input = 1, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_float", use_float_beg, private.room_objname );
  cmn.AddSubscriber( "use_float", use_float_inv );
  cmn.AddSubscriber( "use_float", use_float_end, private.room_objname );
  cmn.AddSubscriber( "use_float_inv", use_float_inv, private.room_objname );
  cmn.AddSubscriber( "use_float_beg", use_float_beg, private.room_objname );
  cmn.AddSubscriber( "use_float_end", use_float_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl4screws () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_lvl4screws" ] = {
        type = "use",
        inv_obj = "inv_lvl4screws",
        use_place = "obj_staging_use_lvl4screws",
        room = private.room_objname,
        zz = "zz_staging",
        zz_gate = "gzz_lvl4nearhospital_staging"
    };
  --------------------------------------------------------------------------------------------
  local use_lvl4screws_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl4screws" );
  
  end;
  local use_lvl4screws_beg = function ()
  
    ObjDelete( "obj_staging_use_lvl4screws" );
    ObjSet("spr_staging_screws_bl",  { alp = 1 });
  
  end;
  local use_lvl4screws_end = function ()
  
    ObjMultiSet( { {"anm_staging_screws_touch", { alp = 1 }},
                   {"obj_staging_use_lvl4coin", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl4screws", use_lvl4screws_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4screws", use_lvl4screws_inv );
  cmn.AddSubscriber( "use_lvl4screws", use_lvl4screws_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl4screws_inv", use_lvl4screws_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl4screws_beg", use_lvl4screws_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4screws_end", use_lvl4screws_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl4spade () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_lvl4spade" ] = {
        type = "use",
        inv_obj = "inv_lvl4spade",
        use_place = "obj_lvl4flowerbed_use_lvl4spade",
        room = private.room_objname,
        zz = "zz_lvl4flowerbed",
        zz_gate = "gzz_lvl4nearhospital_lvl4flowerbed"
    };
  --------------------------------------------------------------------------------------------
  local use_lvl4spade_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl4spade" );
  
  end;
  local use_lvl4spade_beg = function ()
  
    ObjDelete( "obj_lvl4flowerbed_use_lvl4spade" );
    ObjDelete( "anm_lvl4flowerbed_ground_touch" );
  
  end;
  local use_lvl4spade_end = function ()
  
    ObjSet("anm_lvl4flowerbed_use_spade",  { alp = 1, input = 1, frame = 400 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl4spade", use_lvl4spade_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4spade", use_lvl4spade_inv );
  cmn.AddSubscriber( "use_lvl4spade", use_lvl4spade_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl4spade_inv", use_lvl4spade_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl4spade_beg", use_lvl4spade_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4spade_end", use_lvl4spade_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_honey () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_honey" ] = {
        type = "use",
        inv_obj = "inv_honey",
        use_place = "obj_lvl4flowerbed_use_honey",
        room = private.room_objname,
        zz = "zz_lvl4flowerbed",
        zz_gate = "gzz_lvl4nearhospital_lvl4flowerbed"
    };
  --------------------------------------------------------------------------------------------
  local use_honey_inv = function ()
  
    interface.InventoryItemRemove( "inv_honey" );
  
  end;
  local use_honey_beg = function ()
  
    ObjDelete( "obj_lvl4flowerbed_use_honey" );
  
  end;
  local use_honey_end = function ()
    
    ObjDelete( "anm_lvl4flowerbed_ants" );
    ObjDelete( "anm_lvl4flowerbed_ants_leave" );
  
    ObjMultiSet( { {"obj_lvl4flowerbed_honey", { alp = 1 }},
                   {"anm_lvl4flowerbed_ants_2", { alp = 1 }},
                   {"spr_lvl4flowerbed_wrench", { input = 1 }},
                   {"spr_lvl4nearhospital_flowerbed_honey_spoon", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_honey", use_honey_beg, private.room_objname );
  cmn.AddSubscriber( "use_honey", use_honey_inv );
  cmn.AddSubscriber( "use_honey", use_honey_end, private.room_objname );
  cmn.AddSubscriber( "use_honey_inv", use_honey_inv, private.room_objname );
  cmn.AddSubscriber( "use_honey_beg", use_honey_beg, private.room_objname );
  cmn.AddSubscriber( "use_honey_end", use_honey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sophiasaddress () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_sophiasaddress" ] = {
        type = "use",
        inv_obj = "inv_sophiasaddress",
        use_place = "obj_lvl4nearhospital_use_sophiasaddress",
        room = private.room_objname
    };
  --------------------------------------------------------------------------------------------
  local use_sophiasaddress_inv = function ()
  
    interface.InventoryItemRemove( "inv_sophiasaddress" );
  
  end;
  local use_sophiasaddress_beg = function ()
  
    ObjDelete( "obj_lvl4nearhospital_use_sophiasaddress" );
  
  end;
  local use_sophiasaddress_end = function ()
  
    ObjSet( "grm_lvl4nearhospital_nearnurseshouse", { input = 1, alp = 1 } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_lvl4nearhospital_nearnurseshouse_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sophiasaddress", use_sophiasaddress_beg, private.room_objname );
  cmn.AddSubscriber( "use_sophiasaddress", use_sophiasaddress_inv );
  cmn.AddSubscriber( "use_sophiasaddress", use_sophiasaddress_end, private.room_objname );
  cmn.AddSubscriber( "use_sophiasaddress_inv", use_sophiasaddress_inv, private.room_objname );
  cmn.AddSubscriber( "use_sophiasaddress_beg", use_sophiasaddress_beg, private.room_objname );
  cmn.AddSubscriber( "use_sophiasaddress_end", use_sophiasaddress_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_boxestomachine1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_boxestomachine1" ] = {
    type = "click",
    use_place = "obj_lvl4nearhospital_clk_boxestomachine1",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_boxestomachine1_beg = function ()
  
    ObjDelete( "obj_lvl4nearhospital_clk_boxestomachine1" );
  
  end;
  local clk_boxestomachine1_end = function ()
  
    ObjDelete( "obj_lvl4nearhospital_box_1_1" );
    
    ObjMultiSet( { {"obj_lvl4nearhospital_box_1_2", { alp = 1 }},
                   {"obj_lvl4nearhospital_clk_boxestomachine2", { input = 1 }} } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_boxestomachine1", clk_boxestomachine1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_boxestomachine1", clk_boxestomachine1_end, private.room_objname );
  cmn.AddSubscriber( "clk_boxestomachine1_beg", clk_boxestomachine1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_boxestomachine1_end", clk_boxestomachine1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_boxestomachine2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_boxestomachine2" ] = {
    type = "click",
    use_place = "obj_lvl4nearhospital_clk_boxestomachine2",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_boxestomachine2_beg = function ()
  
    ObjDelete( "obj_lvl4nearhospital_clk_boxestomachine2" );
  
  end;
  local clk_boxestomachine2_end = function ()
  
    ObjDelete( "obj_lvl4nearhospital_box_2_1" );
    
    ObjMultiSet( { {"obj_lvl4nearhospital_box_2_2", { alp = 1 }},
                   {"obj_lvl4nearhospital_clk_boxestomachine3", { input = 1 }} } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_boxestomachine2", clk_boxestomachine2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_boxestomachine2", clk_boxestomachine2_end, private.room_objname );
  cmn.AddSubscriber( "clk_boxestomachine2_beg", clk_boxestomachine2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_boxestomachine2_end", clk_boxestomachine2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_boxestomachine3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_boxestomachine3" ] = {
    type = "click",
    use_place = "obj_lvl4nearhospital_clk_boxestomachine3",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_boxestomachine3_beg = function ()
  
    ObjDelete( "obj_lvl4nearhospital_clk_boxestomachine3" );
  
  end;
  local clk_boxestomachine3_end = function ()
  
    ObjDelete( "obj_lvl4nearhospital_box_3_1" );
    ObjDelete( "obj_lvl4nearhospital_nest_bbt" );
    
    ObjMultiSet( { {"obj_lvl4nearhospital_box_3_2", { alp = 1 }},
                   {"gzz_lvl4nearhospital_nest", { alp = 1, input = 1, active = 1 }} } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_boxestomachine3", clk_boxestomachine3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_boxestomachine3", clk_boxestomachine3_end, private.room_objname );
  cmn.AddSubscriber( "clk_boxestomachine3_beg", clk_boxestomachine3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_boxestomachine3_end", clk_boxestomachine3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_medkitopen () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_medkitopen" ] = {
    type = "click",
    use_place = "spr_emergencycarcab_medkit_closed",
    room = private.room_objname,
    zz = "zz_emergencycarcab",
    zz_gate = "gzz_lvl4nearhospital_emergencycarcab"
  };
  --------------------------------------------------------------------------------------------
  local clk_medkitopen = function ()
  
    ObjDelete( "spr_emergencycarcab_medkit_closed" );
    
    ObjMultiSet( { {"spr_emergencycarcab_medkit_open1", { alp = 1 }},
                   {"obj_emergencycarcab_medkit1", { alp = 1, input = 1 }} } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_medkitopen", clk_medkitopen, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_leaflet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_leaflet" ] = {
    type = "click",
    use_place = "obj_lvl4nearhospital_clk_leaflet",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_leaflet = function ()
  
    ObjDelete( "obj_lvl4nearhospital_clk_leaflet" );
    
    ObjSet("obj_lvl4nearhospital_clk_boxestomachine1",  { input = 1 });
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_leaflet", clk_leaflet, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_lvl4nearhospital () end;
  --------------------------------------------------------------------------------------------
  local opn_lvl4nearhospital_loc = function ()
    
    ObjSet("obj_lvl4nearhospital_clk_leaflet",  { alp = 1, input = 1 });
    
  end;
  local opn_lvl4nearhospital_map = function ()
  
    int_map_impl.BlockRoom( "mg_trollrift" );
    int_map_impl.BlockRoom( "rm_neargingerbreadhouse" );
    int_map_impl.BlockRoom( "rm_ingingerbreadhouse" );
    int_map_impl.OpenRoom( "rm_lvl4nearhospital" );

    interface_impl.SetCurrentGlobalTask( 24 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_lvl4nearhospital", opn_lvl4nearhospital_map );
  cmn.AddSubscriber( "opn_lvl4nearhospital_map", opn_lvl4nearhospital_map );
  cmn.AddSubscriber( "opn_lvl4nearhospital", opn_lvl4nearhospital_loc, private.room_objname );
  cmn.AddSubscriber( "opn_lvl4nearhospital_loc", opn_lvl4nearhospital_loc, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_lvl4nearhospital();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio4/aud_lvl4nearhospital_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio4/aud_lvl4nearhospital_env");
  
  if not ( cmn.IsEventDone( "opn_lvl4nearhospital" ) ) then
    cmn.Lock(1);
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
  cmn.HideNote( 0 );
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_lifestaramulet()

  local item = "inv_lifestaramulet";

  if cmn.ApplyObj( item, "gzz_lvl4nearhospital_emergencycarcab" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_emergencycarcab" );

  elseif ( cmn.ApplyObj( item, "obj_emergencycarcab_use_lifestaramulet" ) ) then

    cmn.CallEventHandler( "use_lifestaramulet_inv" );
    cmn.CallEventHandler( "use_lifestaramulet_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lifestaramulet" );
      cmn.CallEventHandler( "use_lifestaramulet_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_opn_car_door");

    ObjMultiSet( { {"anm_emergencycarcab_use_star", { alp = 1, playing = 1, endtrig = func_after }},
                   {"obj_emergencycarcab_inside", { alp = 1 }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_umbrella()

  local item = "inv_umbrella";

  if cmn.ApplyObj( item, "gzz_lvl4nearhospital_emergencycarcab" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_emergencycarcab" );

  elseif ( cmn.ApplyObj( item, "obj_emergencycarcab_use_umbrella" ) and cmn.IsEventDone("use_lifestaramulet") ) then

    cmn.CallEventHandler( "use_umbrella_inv" );
    cmn.CallEventHandler( "use_umbrella_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_umbrella" );
      cmn.CallEventHandler( "use_umbrella_end" );
    
    end;
    
    local anm_zoom = function ()
      
      ObjAnimate("obj_emergencycarcab_medkit", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_use_umbrella");

    ObjSet("anm_emergencycarcab_use_umbrella",  { alp = 1, playing = 1, endtrig = anm_zoom });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_antirust()

  local item = "inv_antirust";

  if cmn.ApplyObj( item, "gzz_lvl4nearhospital_emergencycarcab" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_emergencycarcab" );

  elseif ( cmn.ApplyObj( item, "obj_emergencycarcab_use_antirust" ) and cmn.IsEventDone("clk_medkitopen") ) then

    cmn.CallEventHandler( "use_antirust_inv" );
    cmn.CallEventHandler( "use_antirust_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_antirust" );
      cmn.CallEventHandler( "use_antirust_end" );
    
    end;

    local anm_open = function ()
      
      ObjSet("obj_emergencycarcab_medkit2",  { alp = 1 });
      
      ObjAnimate("spr_emergencycarcab_medkit_open2", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_emergencycarcab_use_antirust", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_use_spray");

    ObjSet("anm_emergencycarcab_use_antirust",  { alp = 1, playing = 1, endtrig = anm_open });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_salammoniac()

  local item = "inv_salammoniac";

  if cmn.ApplyObj( item, "gzz_lvl4nearhospital_nest" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_nest" );

  elseif ( cmn.ApplyObj( item, "obj_nest_use_salammoniac" ) ) then

    cmn.CallEventHandler( "use_salammoniac_inv" );
    cmn.CallEventHandler( "use_salammoniac_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_salammoniac" );
      cmn.CallEventHandler( "use_salammoniac_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_use_ammoniac");

    ObjMultiSet( { {"obj_nest_nest", { alp = 1 }},
                   {"anm_nest_use_salammoniac",  { alp = 1, playing = 1, endtrig = func_after }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_medicalhammer()

  local item = "inv_medicalhammer";

  if cmn.ApplyObj( item, "gzz_lvl4nearhospital_nest" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_nest" );

  elseif ( cmn.ApplyObj( item, "obj_nest_use_medicalhammer" ) and cmn.IsEventDone("use_brush") ) then

    cmn.CallEventHandler( "use_medicalhammer_inv" );
    cmn.CallEventHandler( "use_medicalhammer_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_medicalhammer" );
      cmn.CallEventHandler( "use_medicalhammer_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_use_hammer4");

    ObjSet("anm_nest_use_hammer",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_brush()

  local item = "inv_brush";

  if cmn.ApplyObj( item, "gzz_lvl4nearhospital_nest" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_nest" );

  elseif ( cmn.ApplyObj( item, "obj_nest_use_brush" ) and cmn.IsEventDone("use_salammoniac") ) then

    cmn.CallEventHandler( "use_brush_inv" );
    cmn.CallEventHandler( "use_brush_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_brush" );
      cmn.CallEventHandler( "use_brush_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_use_brush");
    
    if not cmn.IsEventDone("get_lvl4screws") then
      public.get_lvl4screws()
    end;
    if not cmn.IsEventDone("get_needle") then
      public.get_needle();
    end;

    ObjSet("anm_nest_use_brush",  { alp = 1, playing = 1, endtrig = func_after });
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl4coin()

  local item = "inv_lvl4coin";

  if cmn.ApplyObj( item, "gzz_lvl4nearhospital_staging" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_staging" );

  elseif ( cmn.ApplyObj( item, "obj_staging_use_lvl4coin" ) and cmn.IsEventDone("use_lvl4screws") ) then

    cmn.CallEventHandler( "use_lvl4coin_inv" );
    cmn.CallEventHandler( "use_lvl4coin_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl4coin" );
      cmn.CallEventHandler( "use_lvl4coin_end" );
      
      common.CloseSubRoom();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_use_coin4");

    ObjSet("anm_staging_use_coin",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_float()

  local item = "inv_float";

  if cmn.ApplyObj( item, "gzz_lvl4nearhospital_staging" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_staging" );

  elseif ( cmn.ApplyObj( item, "obj_staging_use_float" ) ) then

    cmn.CallEventHandler( "use_float_inv" );
    cmn.CallEventHandler( "use_float_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_float" );
      cmn.CallEventHandler( "use_float_end" );
      
      public.get_lifestaramulet();
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_use_float");

    ObjSet("anm_staging_use_float",  { alp = 1, playing = 1, endtrig = func_after });
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl4screws()

  local item = "inv_lvl4screws";

  if cmn.ApplyObj( item, "gzz_lvl4nearhospital_staging" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_staging" );

  elseif ( cmn.ApplyObj( item, "obj_staging_use_lvl4screws" ) ) then

    cmn.CallEventHandler( "use_lvl4screws_inv" );
    cmn.CallEventHandler( "use_lvl4screws_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl4screws" );
      cmn.CallEventHandler( "use_lvl4screws_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_use_screws");

    ObjAnimate("anm_staging_screws_touch", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl4spade()

  local item = "inv_lvl4spade";

  if cmn.ApplyObj( item, "gzz_lvl4nearhospital_lvl4flowerbed" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_lvl4flowerbed" );

  elseif ( cmn.ApplyObj( item, "obj_lvl4flowerbed_use_lvl4spade" ) ) then

    cmn.CallEventHandler( "use_lvl4spade_inv" );
    cmn.CallEventHandler( "use_lvl4spade_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl4spade" );
      cmn.CallEventHandler( "use_lvl4spade_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_use_shovel_5");

    ObjSet("anm_lvl4flowerbed_use_spade",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_honey()

  local item = "inv_honey";

  if cmn.ApplyObj( item, "gzz_lvl4nearhospital_lvl4flowerbed" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_lvl4flowerbed" );

  elseif ( cmn.ApplyObj( item, "obj_lvl4flowerbed_use_honey" ) ) then

    cmn.CallEventHandler( "use_honey_inv" );
    cmn.CallEventHandler( "use_honey_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_honey" );
      cmn.CallEventHandler( "use_honey_end" );
    
    end;
    
    local anm_ants2 = function ()
      
      ObjAnimate("anm_lvl4flowerbed_ants_leave", "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });
      ObjAnimate("anm_lvl4flowerbed_ants_2", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    local anm_ants = function ()
      
      ObjSet("anm_lvl4flowerbed_ants_leave",  { playing = 1, endtrig = anm_ants2 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_use_honey");

    ObjAnimate("obj_lvl4flowerbed_honey", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    ObjAnimate("anm_lvl4flowerbed_ants", "alp", 0, 0, anm_ants, { 0, 0, 1,   0.3, 0, 1,   0.6, 0, 0 });
    ObjAnimate("anm_lvl4flowerbed_ants_leave", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_sophiasaddress()

  local item = "inv_sophiasaddress";

  if ( cmn.ApplyObj( item, "obj_lvl4nearhospital_use_sophiasaddress" ) ) then

    cmn.CallEventHandler( "use_sophiasaddress_inv" );
    cmn.CallEventHandler( "use_sophiasaddress_beg" );

    local func_after = function ()

      --cmn.Lock( 0 );

      cmn.SetEventDone( "use_sophiasaddress" );
      cmn.CallEventHandler( "use_sophiasaddress_end" );
    
    end;

    --cmn.Lock( 1 );

    func_after();

    --ObjAnimate( "spr_lvl4nearhospital_", "alp", 0, 0, func_after,
    --{
    --  0.0, 0, 0, 
    --  0.3, 0, 1
    --} );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_salammoniac()

  cmn.SetEventDone( "get_salammoniac" );
  cmn.CallEventHandler( "get_salammoniac" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_lvl4coin()

  cmn.SetEventDone( "get_lvl4coin" );
  cmn.CallEventHandler( "get_lvl4coin" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_medicalhammer()

  cmn.SetEventDone( "get_medicalhammer" );
  cmn.CallEventHandler( "get_medicalhammer" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_puzzlepart1()

  cmn.SetEventDone( "get_puzzlepart1" );
  cmn.CallEventHandler( "get_puzzlepart1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_badgepart1") and cmn.IsEventDone("get_bigsyringe") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_bigsyringe()

  cmn.SetEventDone( "get_bigsyringe" );
  cmn.CallEventHandler( "get_bigsyringe" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_badgepart1") and cmn.IsEventDone("get_puzzlepart1") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_badgepart1()

  cmn.SetEventDone( "get_badgepart1" );
  cmn.CallEventHandler( "get_badgepart1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_puzzlepart1") and cmn.IsEventDone("get_bigsyringe") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_float()

  cmn.SetEventDone( "get_float" );
  cmn.CallEventHandler( "get_float" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_lvl4screws()

  cmn.SetEventDone( "get_lvl4screws" );
  cmn.CallEventHandler( "get_lvl4screws" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_needle()

  cmn.SetEventDone( "get_needle" );
  cmn.CallEventHandler( "get_needle" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_smallkey()

  cmn.SetEventDone( "get_smallkey" );
  cmn.CallEventHandler( "get_smallkey" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_lvl4wire") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_lvl4wire()

  cmn.SetEventDone( "get_lvl4wire" );
  cmn.CallEventHandler( "get_lvl4wire" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_smallkey") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_lifestaramulet()
  
  ObjSet("spr_staging_lifestaramulet",  { ang = 0.0563, pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_lifestaramulet" );
  cmn.CallEventHandler( "get_lifestaramulet" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_bone()

  cmn.SetEventDone( "get_bone" );
  cmn.CallEventHandler( "get_bone" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_fishingline") and cmn.IsEventDone("get_wrench") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_fishingline()

  cmn.SetEventDone( "get_fishingline" );
  cmn.CallEventHandler( "get_fishingline" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_bone") and cmn.IsEventDone("get_wrench") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_wrench()

  cmn.SetEventDone( "get_wrench" );
  cmn.CallEventHandler( "get_wrench" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_fishingline") and cmn.IsEventDone("get_bone") then
    common.CloseSubRoom();
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_boxestomachine1()

  cmn.CallEventHandler( "clk_boxestomachine1_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_boxestomachine1" );
    cmn.CallEventHandler( "clk_boxestomachine1_end" );

    cmn.Lock( 0 );
  
  end;

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_clk_wood_box");
  
  ObjAnimate("obj_lvl4nearhospital_box_1_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  ObjAnimate("obj_lvl4nearhospital_box_1_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 0,    0.6, 0, 1 });

end;
--------------------------------------------------------------------------------------------
function public.clk_boxestomachine2()

  cmn.CallEventHandler( "clk_boxestomachine2_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_boxestomachine2" );
    cmn.CallEventHandler( "clk_boxestomachine2_end" );

    cmn.Lock( 0 );
  
  end;

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_clk_wood_box");
  
  ObjAnimate("obj_lvl4nearhospital_box_2_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  ObjAnimate("obj_lvl4nearhospital_box_2_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 0,    0.6, 0, 1 });

end;
--------------------------------------------------------------------------------------------
function public.clk_boxestomachine3()

  cmn.CallEventHandler( "clk_boxestomachine3_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_boxestomachine3" );
    cmn.CallEventHandler( "clk_boxestomachine3_end" );

    cmn.Lock( 0 );
  
  end;

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_clk_wood_box");
  
  ObjAnimate("obj_lvl4nearhospital_box_3_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  ObjAnimate("obj_lvl4nearhospital_box_3_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 0,    0.6, 0, 1 });

end;
--------------------------------------------------------------------------------------------
function public.clk_medkitopen()

  local func_after = function ()

    cmn.SetEventDone( "clk_medkitopen" );
    cmn.CallEventHandler( "clk_medkitopen" );

    cmn.Lock( 0 );
  
  end;

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_opn_chest4");
  ObjSet("obj_emergencycarcab_medkit1",  { alp = 1 });
  
  ObjAnimate("spr_emergencycarcab_medkit_closed", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate("spr_emergencycarcab_medkit_open1", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });

end;
--------------------------------------------------------------------------------------------
function public.clk_leaflet()

  local func_after = function ()

    cmn.SetEventDone( "clk_leaflet" );
    cmn.CallEventHandler( "clk_leaflet" );

    cmn.Lock( 0 );
  
  end;

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_clk_paper");
  
  ObjAnimate("spr_lvl4nearhospital_leaflet", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_lvl4nearhospital()

  if not ( cmn.IsEventDone( "opn_lvl4nearhospital" ) ) then
    
    local func_after = function ()
      
      cmn.ShowBbt( "lvl4nearhospital_open" );
      interface_impl.ShowGlobalTask();
      
      cmn.CallEventHandler("opn_lvl4nearhospital_loc");
      
      int_map_impl.AddDiarypage( 12 );
      
      cmn.PlayAudio("env", "assets/levels/common/audio/audio4/aud_lvl4nearhospital_env");
      
    end;
    
    cmn.Lock(0);
    cmn.StopAllEnv();
    
    cmn.SetEventDone( "opn_lvl4nearhospital" );
    cmn.CallEventHandler("opn_lvl4nearhospital_map");
    
    cmn.PlayFullscreenVideo( "assets/levels/level4/rm_lvl4nearhospital/vid_leaflet", func_after, "assets/levels/level4/rm_lvl4nearhospital/audio/aud_leaflet", "");
    
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_flowerpot()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_lvl4flowerbed_use_lvl4spade" );
  
  cmn.PlayAudio("snd", "assets/levels/level3/rm_housegarden/audio/aud_xx_clk_ground");
  
  ObjSet("anm_lvl4flowerbed_ground_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_nest_wall()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_nest_use_medicalhammer" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_xx_clk_wall");
  
  ObjSet("anm_nest_wall_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_nest()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_nest_use_brush" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_xx_clk_nest");
  
  ObjSet("anm_nest_nest_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
  if not cmn.IsEventDone("get_lvl4screws") or not cmn.IsEventDone("get_needle") then
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
    
    if not cmn.IsEventDone("get_lvl4screws") then
    
      cmn.SetEventDone( "get_lvl4screws" );
      cmn.CallEventHandler( "get_lvl4screws" );

    end;
    
    
    if not cmn.IsEventDone("get_needle") then
    
      cmn.SetEventDone( "get_needle" );
      cmn.CallEventHandler( "get_needle" );

    end;

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_nest_crow()
  
  cmn.Lock(1);
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_nest_crow_touch", { alp = 0 }},
                   {"anm_nest_crow", { playing = 1, alp = 1 }} } );
    
  end;
  
  cmn.ShowBbt( "obj_nest_use_salammoniac" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_xx_clk_crow4");
  
  ObjMultiSet( { {"anm_nest_crow_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_nest_crow", { playing = 0, alp = 0 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_car_doors()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_emergencycarcab_use_lifestaramulet" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_xx_clk_car");
  
  ObjSet("anm_emergencycarcab_door_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_medkit()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_emergencycarcab_use_umbrella" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_xx_suitcase");
  
  ObjSet("anm_emergencycarcab_box_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_rust()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_emergencycarcab_use_antirust" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_xx_clk_metal4lvl");
  
  ObjSet("anm_emergencycarcab_rust_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_staging()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_staging_use_lvl4screws" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_xx_clk_frame");
  
  ObjSet("anm_staging_stageing_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_staging_screws()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_staging_use_lvl4coin" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_xx_clk_frame");
  
  ObjSet("anm_staging_screws_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_staging_amulet()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_staging_use_float" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_xx_paint");
  
  ObjSet("anm_staging_amulet_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--*********************************************************************************************************************
