-- name=rm_serviceroom
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_serviceroom";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Cardindex();
  --------------------------------------------------------------------------------------------
  -- function get_catshead () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_catshead" ] = {
        type = "get",
        get_obj = "spr_volunteersstuff_catshead",
        room = private.room_objname,
        zz = "zz_volunteersstuff",
        zz_gate = "gzz_serviceroom_volunteersstuff"
    };
    --------------------------------------------------------------------------------------------
  local get_catshead_inv = function ()
  
    interface.InventoryItemAdd( "inv_catshead", "spr_volunteersstuff_catshead" );
  
  end;
  
  local get_catshead_end = function ()
  
    ObjDelete( "gfx_volunteersstuff_catshead" );
    ObjDelete( "spr_volunteersstuff_catshead_sh" );
    ObjDelete( "spr_serviceroom_stuff_cathead" );

    if private.IsAllVolunteersstuffItemsGet() then
      ObjDelete( "gzz_serviceroom_volunteersstuff" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_catshead", get_catshead_inv );
  cmn.AddSubscriber( "get_catshead", get_catshead_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rubbergloves () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_rubbergloves" ] = {
        type = "get",
        get_obj = "obj_volunteersstuff_rubbergloves_hint",
        room = private.room_objname,
        zz = "zz_volunteersstuff",
        zz_gate = "gzz_serviceroom_volunteersstuff"
    };
    --------------------------------------------------------------------------------------------
  local get_rubbergloves_inv = function ()
  
    interface.InventoryItemAdd( "inv_rubbergloves", "spr_volunteersstuff_rubbergloves" );
  
  end;
  
  local get_rubbergloves_end = function ()
  
    ObjDelete( "gfx_volunteersstuff_rubbergloves" );
    ObjDelete( "spr_volunteersstuff_rubbergloves_sh" );
    ObjDelete( "spr_volunteersstuff_rubbergloves_sh_2" );
    ObjDelete( "obj_volunteersstuff_rubbergloves_hint" );
    
    ObjDelete( "spr_serviceroom_stuff_gloves" );

    if private.IsAllVolunteersstuffItemsGet() then
      ObjDelete( "gzz_serviceroom_volunteersstuff" );
    end;
    
    if cmn.IsEventDone("get_tornoffpatch") then
      ObjMultiSet( { {"obj_volunteersstuff_use_collectionstamp1", { input = 1 }},
                     {"obj_volunteersstuff_use_collectionstamp2", { input = 1 }} } );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_rubbergloves", get_rubbergloves_inv );
  cmn.AddSubscriber( "get_rubbergloves", get_rubbergloves_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tornoffpatch () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_tornoffpatch" ] = {
        type = "get",
        get_obj = "obj_volunteersstuff_tornoffpatch_hint",
        room = private.room_objname,
        zz = "zz_volunteersstuff",
        zz_gate = "gzz_serviceroom_volunteersstuff"
    };
    --------------------------------------------------------------------------------------------
  local get_tornoffpatch_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_tornoffpatch", "spr_volunteersstuff_tornoffpatch" );
  
  end;
  
  local get_tornoffpatch_end = function ()
  
    ObjDelete( "gfx_volunteersstuff_tornoffpatch" );
    ObjDelete( "spr_volunteersstuff_tornoffpatch_sh" );
    ObjDelete( "spr_volunteersstuff_tornoffpatch_sh_2" );
    ObjDelete( "obj_volunteersstuff_tornoffpatch_hint" );
    
    ObjDelete( "spr_serviceroom_stuff_patch" );

    if private.IsAllVolunteersstuffItemsGet() then
      ObjDelete( "gzz_serviceroom_volunteersstuff" );
    end;
    
    if cmn.IsEventDone("get_rubbergloves") then
      ObjMultiSet( { {"obj_volunteersstuff_use_collectionstamp1", { input = 1 }},
                     {"obj_volunteersstuff_use_collectionstamp2", { input = 1 }} } );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_tornoffpatch", get_tornoffpatch_inv );
  cmn.AddSubscriber( "get_tornoffpatch", get_tornoffpatch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_angelfigurine () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_angelfigurine" ] = {
        type = "get",
        get_obj = "spr_volunteersstuff_angelfigurine",
        room = private.room_objname,
        zz = "zz_volunteersstuff",
        zz_gate = "gzz_serviceroom_volunteersstuff"
    };
    --------------------------------------------------------------------------------------------
  local get_angelfigurine_inv = function ()
  
    interface.InventoryItemAdd( "inv_angelfigurine", "spr_volunteersstuff_angelfigurine" );
  
  end;
  
  local get_angelfigurine_end = function ()
  
    ObjDelete( "gfx_volunteersstuff_angelfigurine" );
    ObjDelete( "spr_volunteersstuff_angelfigurine_sh" );
    ObjDelete( "spr_serviceroom_stuff_angel" );

    if private.IsAllVolunteersstuffItemsGet() then
      ObjDelete( "gzz_serviceroom_volunteersstuff" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_angelfigurine", get_angelfigurine_inv );
  cmn.AddSubscriber( "get_angelfigurine", get_angelfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_newspaperpiece1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_newspaperpiece1" ] = {
        type = "get",
        get_obj = "spr_volunteersstuff_newspaperpiece1",
        room = private.room_objname,
        zz = "zz_volunteersstuff",
        zz_gate = "gzz_serviceroom_volunteersstuff"
    };
    --------------------------------------------------------------------------------------------
  local get_newspaperpiece1_inv = function ()
  
    interface.InventoryItemAdd(
      "inv_newspaperpiece",
      "spr_volunteersstuff_newspaperpiece1",
      function () cmn.GetMultyObject( 'newspaperpiece', 4 ); end
    );
    
    if cmn.CheckMultiObject( "newspaperpiece", 4 ) then
      ObjSet("inv_burntnewspaper_star_light",  { alp = 1 });
    end;

  end;
  
  local get_newspaperpiece1_end = function ()
  
    ObjDelete( "gfx_volunteersstuff_newspaperpiece1" );
    ObjDelete( "spr_volunteersstuff_newspaperpiece1_sh" );
    ObjDelete( "spr_serviceroom_stuff_paper" );
    
    if private.IsAllVolunteersstuffItemsGet() then
      ObjDelete( "gzz_serviceroom_volunteersstuff" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_newspaperpiece1", get_newspaperpiece1_inv );
  cmn.AddSubscriber( "get_newspaperpiece1", get_newspaperpiece1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sails () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_sails" ] = {
        type = "get",
        get_obj = "spr_volunteersstuff_sails",
        room = private.room_objname,
        zz = "zz_volunteersstuff",
        zz_gate = "gzz_serviceroom_volunteersstuff"
    };
    --------------------------------------------------------------------------------------------
  local get_sails_inv = function ()
  
    interface.InventoryItemAdd( "inv_sails", "spr_volunteersstuff_sails" );
    int_map_impl.DecreaseRoomTasks("rm_serviceroom");
    ObjSet("inv_ship_star_light",  { alp = 1 });
  
  end;
  
  local get_sails_end = function ()
  
    ObjDelete( "gfx_volunteersstuff_sails" );
    ObjDelete( "spr_volunteersstuff_sails_sh" );
    ObjDelete( "spr_serviceroom_stuff_sails" );

    if private.IsAllVolunteersstuffItemsGet() then
      ObjDelete( "gzz_serviceroom_volunteersstuff" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_sails", get_sails_inv );
  cmn.AddSubscriber( "get_sails", get_sails_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_curtaintieback1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_curtaintieback1" ] = {
        type = "get",
        get_obj = "spr_volunteersstuff_curtaintieback1",
        room = private.room_objname,
        zz = "zz_volunteersstuff",
        zz_gate = "gzz_serviceroom_volunteersstuff"
    };
    --------------------------------------------------------------------------------------------
  local get_curtaintieback1_inv = function ()
  
    interface.InventoryItemAdd( "inv_curtaintieback1", "spr_volunteersstuff_curtaintieback1" );
    int_map_impl.DecreaseRoomTasks("rm_serviceroom");
  
  end;
  
  local get_curtaintieback1_end = function ()
  
    ObjDelete( "gfx_volunteersstuff_curtaintieback1" );
    ObjDelete( "spr_volunteersstuff_curtaintieback1_sh" );
    ObjDelete( "spr_serviceroom_stuff_tieback" );
    
    ObjSet("spr_volunteersstuff_sails",  { input = 1 });

    if private.IsAllVolunteersstuffItemsGet() then
      ObjDelete( "gzz_serviceroom_volunteersstuff" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_curtaintieback1", get_curtaintieback1_inv );
  cmn.AddSubscriber( "get_curtaintieback1", get_curtaintieback1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_donationcheque () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_donationcheque" ] = {
        type = "get",
        get_obj = "spr_sophiesbox_donationcheque",
        room = private.room_objname,
        zz = "zz_sophiesbox",
        zz_gate = "gzz_serviceroom_sophiesbox"
    };
    --------------------------------------------------------------------------------------------
  local get_donationcheque_inv = function ()
  
    interface.InventoryItemAdd( "inv_donationcheque", "spr_sophiesbox_donationcheque" );
    int_map_impl.DecreaseRoomTasks("rm_serviceroom");
    
  end;
  local get_donationcheque_clues = function ()
  
    interface_impl.SetCompleteClues( {3} );
    
  end;
  local get_donationcheque_end = function ()
  
    ObjDelete( "gfx_sophiesbox_donationcheque" );
    ObjDelete( "spr_sophiesbox_donationcheque_shadow" );
    ObjDelete( "spr_serviceroom_box_check" );

    if private.IsAllSophiesboxItemsGet() then
      ObjDelete( "gzz_serviceroom_sophiesbox" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_donationcheque", get_donationcheque_inv );
  cmn.AddSubscriber( "get_donationcheque", get_donationcheque_clues );
  cmn.AddSubscriber( "get_donationcheque", get_donationcheque_end, private.room_objname );
  cmn.AddSubscriber( "get_donationcheque_inv", get_donationcheque_inv );
  cmn.AddSubscriber( "get_donationcheque_clues", get_donationcheque_clues );
  cmn.AddSubscriber( "get_donationcheque_end", get_donationcheque_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_puzzlepart2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_puzzlepart2" ] = {
        type = "get",
        get_obj = "spr_sophiesbox_puzzlepart2",
        room = private.room_objname,
        zz = "zz_sophiesbox",
        zz_gate = "gzz_serviceroom_sophiesbox"
    };
    --------------------------------------------------------------------------------------------
  local get_puzzlepart2_inv = function ()
  
    interface.InventoryItemAdd( "inv_puzzlepart", "spr_sophiesbox_puzzlepart2", function () cmn.GetMultyObject( 'puzzlepart', 4 ); end );

  end;
  
  local get_puzzlepart2_end = function ()
  
    ObjDelete( "gfx_sophiesbox_puzzlepart2" );
    ObjDelete( "spr_sophiesbox_puzzlepart2_shadow" );
    ObjDelete( "spr_serviceroom_box_puzzle" );
  
  end;
  
  cmn.AddSubscriber( "get_puzzlepart2", get_puzzlepart2_inv );
  cmn.AddSubscriber( "get_puzzlepart2", get_puzzlepart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_woolball () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_woolball" ] = {
        type = "get",
        get_obj = "spr_sophiesbox_woolball",
        room = private.room_objname,
        zz = "zz_sophiesbox",
        zz_gate = "gzz_serviceroom_sophiesbox"
    };
    --------------------------------------------------------------------------------------------
  local get_woolball_inv = function ()
  
    interface.InventoryItemAdd( "inv_woolball", "spr_sophiesbox_woolball" );
  
  end;
  
  local get_woolball_end = function ()
  
    ObjDelete( "gfx_sophiesbox_woolball" );
    ObjDelete( "spr_sophiesbox_woolball_shadow" );
    ObjDelete( "spr_serviceroom_box_ball" );

    if private.IsAllSophiesboxItemsGet() then
      ObjDelete( "gzz_serviceroom_sophiesbox" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_woolball", get_woolball_inv );
  cmn.AddSubscriber( "get_woolball", get_woolball_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_matches () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_matches" ] = {
        type = "get",
        get_obj = "spr_sophiesbox_matches",
        room = private.room_objname,
        zz = "zz_sophiesbox",
        zz_gate = "gzz_serviceroom_sophiesbox"
    };
    --------------------------------------------------------------------------------------------
  local get_matches_inv = function ()
  
    interface.InventoryItemAdd( "inv_matches", "spr_sophiesbox_matches" );
  
  end;
  
  local get_matches_end = function ()
  
    ObjDelete( "gfx_sophiesbox_matches" );
    ObjDelete( "spr_sophiesbox_matches_shadow" );

    if private.IsAllSophiesboxItemsGet() then
      ObjDelete( "gzz_serviceroom_sophiesbox" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_matches", get_matches_inv );
  cmn.AddSubscriber( "get_matches", get_matches_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cakeamulet () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_cakeamulet" ] = {
        type = "get",
        get_obj = "spr_sophiesbox_cakeamulet",
        room = private.room_objname,
        zz = "zz_sophiesbox",
        zz_gate = "gzz_serviceroom_sophiesbox"
    };
    --------------------------------------------------------------------------------------------
  local get_cakeamulet_inv = function ()
  
    interface.InventoryItemAdd( "inv_cakeamulet", "spr_sophiesbox_cakeamulet" );
  
  end;
  
  local get_cakeamulet_end = function ()
  
    ObjDelete( "gfx_sophiesbox_cakeamulet" );
    ObjDelete( "spr_sophiesbox_cakeamulet_shadow" );

    if private.IsAllSophiesboxItemsGet() then
      ObjDelete( "gzz_serviceroom_sophiesbox" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_cakeamulet", get_cakeamulet_inv );
  cmn.AddSubscriber( "get_cakeamulet", get_cakeamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_keyholder () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_keyholder" ] = {
        type = "get",
        get_obj = "spr_sophiesbox_keyholder",
        room = private.room_objname,
        zz = "zz_sophiesbox",
        zz_gate = "gzz_serviceroom_sophiesbox"
    };
    --------------------------------------------------------------------------------------------
  local get_keyholder_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_keyholder", "spr_sophiesbox_keyholder" );
  
  end;
  
  local get_keyholder_end = function ()
  
    ObjDelete( "gfx_sophiesbox_keyholder" );
    ObjDelete( "spr_sophiesbox_keyholder_shadow" );

    if private.IsAllSophiesboxItemsGet() then
      ObjDelete( "gzz_serviceroom_sophiesbox" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_keyholder", get_keyholder_inv );
  cmn.AddSubscriber( "get_keyholder", get_keyholder_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sophiaspullover () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_sophiaspullover" ] = {
        type = "get",
        get_obj = "spr_sophiesbox_sophiaspullover",
        room = private.room_objname,
        zz = "zz_sophiesbox",
        zz_gate = "gzz_serviceroom_sophiesbox"
    };
    --------------------------------------------------------------------------------------------
  local get_sophiaspullover_inv = function ()
  
    interface.InventoryItemAdd( "inv_sophiaspullover", "spr_sophiesbox_sophiaspullover" );
    int_map_impl.DecreaseRoomTasks("rm_serviceroom");
    ObjSet("inv_brokendogcase_star_light",  { alp = 1 });
  
  end;
  
  local get_sophiaspullover_end = function ()
  
    ObjDelete( "gfx_sophiesbox_sophiaspullover" );
    ObjDelete( "spr_serviceroom_box_pullover" );

    if private.IsAllSophiesboxItemsGet() then
      ObjDelete( "gzz_serviceroom_sophiesbox" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_sophiaspullover", get_sophiaspullover_inv );
  cmn.AddSubscriber( "get_sophiaspullover", get_sophiaspullover_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_woodensquare () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_woodensquare" ] = {
        type = "get",
        get_obj = "spr_sophiesbox_woodensquare",
        room = private.room_objname,
        zz = "zz_sophiesbox",
        zz_gate = "gzz_serviceroom_sophiesbox"
    };
    --------------------------------------------------------------------------------------------
  local get_woodensquare_inv = function ()
  
    interface.InventoryItemAdd( "inv_woodensquare", "spr_sophiesbox_woodensquare" );
    int_map_impl.DecreaseRoomTasks("rm_serviceroom");
  
  end;
  
  local get_woodensquare_end = function ()
  
    ObjDelete( "gfx_sophiesbox_woodensquare" );

    if private.IsAllSophiesboxItemsGet() then
      ObjDelete( "gzz_serviceroom_sophiesbox" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_woodensquare", get_woodensquare_inv );
  cmn.AddSubscriber( "get_woodensquare", get_woodensquare_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_antirust () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_antirust" ] = {
        type = "get",
        get_obj = "spr_cardindex_antirust",
        room = private.room_objname,
        zz = "zz_cardindex",
        zz_gate = "gzz_serviceroom_cardindex"
    };
    --------------------------------------------------------------------------------------------
  local get_antirust_inv = function ()
  
    interface.InventoryItemAdd( "inv_antirust", "spr_cardindex_antirust" );
  
  end;
  
  local get_antirust_end = function ()
  
    ObjDelete( "gfx_cardindex_antirust" );
    ObjDelete( "spr_cardindex_antirust_sh" );
    ObjDelete( "spr_serviceroom_card_antirust" );

    if private.IsAllCardindexItemsGet() then
      ObjDelete( "gzz_serviceroom_cardindex" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_antirust", get_antirust_inv );
  cmn.AddSubscriber( "get_antirust", get_antirust_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_yellowthread () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_yellowthread" ] = {
        type = "get",
        get_obj = "spr_cardindex_yellowthread",
        room = private.room_objname,
        zz = "zz_cardindex",
        zz_gate = "gzz_serviceroom_cardindex"
    };
    --------------------------------------------------------------------------------------------
  local get_yellowthread_inv = function ()
  
    interface.InventoryItemAdd( "inv_yellowthread", "spr_cardindex_yellowthread" );
    ObjSet("inv_tornoffpatch_star_light",  { alp = 1 });
  
  end;
  
  local get_yellowthread_end = function ()
  
    ObjDelete( "gfx_cardindex_yellowthread" );
    ObjDelete( "spr_cardindex_yellowthread_sh" );
    ObjDelete( "spr_serviceroom_card_thread" );

    if private.IsAllCardindexItemsGet() then
      ObjDelete( "gzz_serviceroom_cardindex" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_yellowthread", get_yellowthread_inv );
  cmn.AddSubscriber( "get_yellowthread", get_yellowthread_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl4pen () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_lvl4pen" ] = {
        type = "get",
        get_obj = "spr_cardindex_lvl4pen",
        room = private.room_objname,
        zz = "zz_cardindex",
        zz_gate = "gzz_serviceroom_cardindex"
    };
    --------------------------------------------------------------------------------------------
  local get_lvl4pen_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl4pen", "spr_cardindex_lvl4pen" );
  
  end;
  
  local get_lvl4pen_end = function ()
  
    ObjDelete( "gfx_cardindex_lvl4pen" );
    ObjDelete( "spr_cardindex_lvl4pen_sh" );
    ObjDelete( "spr_serviceroom_card_pen" );

    if private.IsAllCardindexItemsGet() then
      ObjDelete( "gzz_serviceroom_cardindex" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_lvl4pen", get_lvl4pen_inv );
  cmn.AddSubscriber( "get_lvl4pen", get_lvl4pen_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_knittingneedles () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_knittingneedles" ] = {
        type = "get",
        get_obj = "spr_cardindex_knittingneedles",
        room = private.room_objname,
        zz = "zz_cardindex",
        zz_gate = "gzz_serviceroom_cardindex"
    };
    --------------------------------------------------------------------------------------------
  local get_knittingneedles_inv = function ()
  
    interface.InventoryItemAdd( "inv_knittingneedles", "spr_cardindex_knittingneedles" );
  
  end;
  
  local get_knittingneedles_end = function ()
  
    ObjDelete( "gfx_cardindex_knittingneedles" );
    ObjDelete( "spr_serviceroom_card_knitting" );

    if private.IsAllCardindexItemsGet() then
      ObjDelete( "gzz_serviceroom_cardindex" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_knittingneedles", get_knittingneedles_inv );
  cmn.AddSubscriber( "get_knittingneedles", get_knittingneedles_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl4notebook () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_lvl4notebook" ] = {
        type = "get",
        get_obj = "spr_cardindex_lvl4notebook",
        room = private.room_objname,
        zz = "zz_cardindex",
        zz_gate = "gzz_serviceroom_cardindex"
    };
    --------------------------------------------------------------------------------------------
  local get_lvl4notebook_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl4notebook", "spr_cardindex_lvl4notebook" );
  
  end;
  
  local get_lvl4notebook_end = function ()
  
    ObjDelete( "gfx_cardindex_lvl4notebook" );
    ObjDelete( "spr_cardindex_lvl4notebook_sh" );
    ObjDelete( "spr_serviceroom_card_notebook" );

    if private.IsAllCardindexItemsGet() then
      ObjDelete( "gzz_serviceroom_cardindex" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_lvl4notebook", get_lvl4notebook_inv );
  cmn.AddSubscriber( "get_lvl4notebook", get_lvl4notebook_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tongs () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_tongs" ] = {
        type = "get",
        get_obj = "spr_cardindex_tongs",
        room = private.room_objname,
        zz = "zz_cardindex",
        zz_gate = "gzz_serviceroom_cardindex"
    };
    --------------------------------------------------------------------------------------------
  local get_tongs_inv = function ()
  
    interface.InventoryItemAdd( "inv_tongs", "spr_cardindex_tongs" );
  
  end;
  
  local get_tongs_end = function ()
  
    ObjDelete( "gfx_cardindex_tongs" );

    if private.IsAllCardindexItemsGet() then
      ObjDelete( "gzz_serviceroom_cardindex" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_tongs", get_tongs_inv );
  cmn.AddSubscriber( "get_tongs", get_tongs_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lockpart1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_lockpart1" ] = {
        type = "get",
        get_obj = "spr_cardindex_lockpart1",
        room = private.room_objname,
        zz = "zz_cardindex",
        zz_gate = "gzz_serviceroom_cardindex"
    };
    --------------------------------------------------------------------------------------------
  local get_lockpart1_inv = function ()
  
    interface.InventoryItemAdd( "inv_lockpart", "spr_cardindex_lockpart1", function () cmn.GetMultyObject( 'lockpart', 2 ); end );

  end;
  
  local get_lockpart1_end = function ()
  
    ObjDelete( "gfx_cardindex_lockpart1" );

    if private.IsAllCardindexItemsGet() then
      ObjDelete( "gzz_serviceroom_cardindex" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_lockpart1", get_lockpart1_inv );
  cmn.AddSubscriber( "get_lockpart1", get_lockpart1_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_pandaseye1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_pandaseye1" ] = {
        type = "use",
        inv_obj = "inv_pandaseye1",
        use_place = "obj_volunteersstuff_use_pandaseye1",
        room = private.room_objname,
        zz = "zz_volunteersstuff",
        zz_gate = "gzz_serviceroom_volunteersstuff"
    };
  --------------------------------------------------------------------------------------------
  local use_pandaseye1_inv = function ()
  
    interface.InventoryItemRemove( "inv_pandaseye1" );
  
  end;
  local use_pandaseye1_beg = function ()
    
    ObjDelete( "obj_volunteersstuff_use_pandaseye1" );
    
  end;
  local use_pandaseye1_end = function ()

    if ( cmn.IsEventDone( "use_pandaseye2" ) ) then
      ObjMultiSet( { {"anm_volunteersstuff_bag_open", { alp = 1, input = 1, frame = 300 }},
                     {"anm_volunteersstuff_bag_open_2", { alp = 1, frame = 300 }},
                     {"spr_serviceroom_stuff_bag_2", { alp = 1 }} } );
      ObjDelete( "anm_volunteersstuff_bag_touch" );
      ObjDelete( "spr_volunteersstuff_bag_sh" );
      ObjDelete( "anm_volunteersstuff_bag_eye_1" );
      ObjDelete( "anm_volunteersstuff_bag_eye_2" );
      ObjDelete( "spr_serviceroom_stuff_bag_1" );
    else 
      ObjMultiSet( { {"anm_volunteersstuff_bag_eye_1", { alp = 1 }},
                     {"spr_serviceroom_stuff_bag_eye_1", { alp = 1 }} } );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pandaseye1", use_pandaseye1_beg, private.room_objname );
  cmn.AddSubscriber( "use_pandaseye1", use_pandaseye1_inv );
  cmn.AddSubscriber( "use_pandaseye1", use_pandaseye1_end, private.room_objname );
  cmn.AddSubscriber( "use_pandaseye1_inv", use_pandaseye1_inv, private.room_objname );
  cmn.AddSubscriber( "use_pandaseye1_beg", use_pandaseye1_beg, private.room_objname );
  cmn.AddSubscriber( "use_pandaseye1_end", use_pandaseye1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pandaseye2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_pandaseye2" ] = {
        type = "use",
        inv_obj = "inv_pandaseye2",
        use_place = "obj_volunteersstuff_use_pandaseye2",
        room = private.room_objname,
        zz = "zz_volunteersstuff",
        zz_gate = "gzz_serviceroom_volunteersstuff"
    };
  --------------------------------------------------------------------------------------------
  local use_pandaseye2_inv = function ()
  
    interface.InventoryItemRemove( "inv_pandaseye2" );
  
  end;
  local use_pandaseye2_beg = function ()
    
    ObjDelete( "obj_volunteersstuff_use_pandaseye2" );
  
  end;
  local use_pandaseye2_end = function ()

    if ( cmn.IsEventDone( "use_pandaseye1" ) ) then
      ObjMultiSet( { {"anm_volunteersstuff_bag_open", { alp = 1, input = 1, frame = 300 }},
                     {"anm_volunteersstuff_bag_open_2", { alp = 1, frame = 300 }},
                     {"spr_serviceroom_stuff_bag_2", { alp = 1 }} } );
      ObjDelete( "anm_volunteersstuff_bag_touch" );
      ObjDelete( "spr_volunteersstuff_bag_sh" );
      ObjDelete( "anm_volunteersstuff_bag_eye_1" );
      ObjDelete( "anm_volunteersstuff_bag_eye_2" );
      ObjDelete( "spr_serviceroom_stuff_bag_1" );
    else 
      ObjMultiSet( { {"anm_volunteersstuff_bag_eye_2", { alp = 1 }},
                     {"spr_serviceroom_stuff_bag_eye_2", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pandaseye2", use_pandaseye2_beg, private.room_objname );
  cmn.AddSubscriber( "use_pandaseye2", use_pandaseye2_inv );
  cmn.AddSubscriber( "use_pandaseye2", use_pandaseye2_end, private.room_objname );
  cmn.AddSubscriber( "use_pandaseye2_inv", use_pandaseye2_inv, private.room_objname );
  cmn.AddSubscriber( "use_pandaseye2_beg", use_pandaseye2_beg, private.room_objname );
  cmn.AddSubscriber( "use_pandaseye2_end", use_pandaseye2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_heartsign () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_heartsign" ] = {
        type = "use",
        inv_obj = "inv_heartsign",
        use_place = "obj_volunteersstuff_use_heartsign",
        room = private.room_objname,
        zz = "zz_volunteersstuff",
        zz_gate = "gzz_serviceroom_volunteersstuff"
    };
  --------------------------------------------------------------------------------------------
  local use_heartsign_inv = function ()
  
    interface.InventoryItemRemove( "inv_heartsign" );
  
  end;
  local use_heartsign_beg = function ()
  
    ObjDelete( "obj_volunteersstuff_use_heartsign" );
    ObjDelete( "anm_volunteersstuff_pocket_touch" );
    
  end;
  local use_heartsign_end = function ()

    ObjDelete( "anm_volunteersstuff_use_heart" );
  
    ObjMultiSet( { {"obj_volunteersstuff_pocket_open", { alp = 1, input = 1 }},
                   {"spr_serviceroom_stuff_bag_pocket", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_heartsign", use_heartsign_beg, private.room_objname );
  cmn.AddSubscriber( "use_heartsign", use_heartsign_inv );
  cmn.AddSubscriber( "use_heartsign", use_heartsign_end, private.room_objname );
  cmn.AddSubscriber( "use_heartsign_inv", use_heartsign_inv, private.room_objname );
  cmn.AddSubscriber( "use_heartsign_beg", use_heartsign_beg, private.room_objname );
  cmn.AddSubscriber( "use_heartsign_end", use_heartsign_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_collectionstamp1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_collectionstamp1" ] = {
        type = "use",
        inv_obj = "inv_collectionstamp1",
        use_place = "obj_volunteersstuff_use_collectionstamp1",
        room = private.room_objname,
        zz = "zz_volunteersstuff",
        zz_gate = "gzz_serviceroom_volunteersstuff"
    };
  --------------------------------------------------------------------------------------------
  local use_collectionstamp1_inv = function ()
  
    interface.InventoryItemRemove( "inv_collectionstamp1" );
  
  end;
  local use_collectionstamp1_beg = function ()
  
    ObjDelete( "obj_volunteersstuff_use_collectionstamp1" );
  
  end;
  local use_collectionstamp1_end = function ()
    
    if ( cmn.IsEventDone( "use_collectionstamp2" ) ) then
      ObjDelete("spr_volunteersstuff_mark_1");
      ObjDelete("spr_volunteersstuff_mark_2");
      ObjAttach("anm_volunteersstuff_casket_open", "obj_volunteersstuff_casket_open");
      ObjMultiSet( { {"anm_volunteersstuff_casket_open", { frame = 300, input = 1, pos_x = 0, pos_y = 0 }},
                     {"spr_serviceroom_stuff_box_open", { alp = 1 }} } );
    else 
      ObjMultiSet( { {"spr_volunteersstuff_mark_1", { alp = 1 }},
                     {"spr_serviceroom_stuff_mark_1", { alp = 1 }} } );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_collectionstamp1", use_collectionstamp1_beg, private.room_objname );
  cmn.AddSubscriber( "use_collectionstamp1", use_collectionstamp1_inv );
  cmn.AddSubscriber( "use_collectionstamp1", use_collectionstamp1_end, private.room_objname );
  cmn.AddSubscriber( "use_collectionstamp1_inv", use_collectionstamp1_inv, private.room_objname );
  cmn.AddSubscriber( "use_collectionstamp1_beg", use_collectionstamp1_beg, private.room_objname );
  cmn.AddSubscriber( "use_collectionstamp1_end", use_collectionstamp1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_collectionstamp2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_collectionstamp2" ] = {
        type = "use",
        inv_obj = "inv_collectionstamp2",
        use_place = "obj_volunteersstuff_use_collectionstamp2",
        room = private.room_objname,
        zz = "zz_volunteersstuff",
        zz_gate = "gzz_serviceroom_volunteersstuff"
    };
  --------------------------------------------------------------------------------------------
  local use_collectionstamp2_inv = function ()
  
    interface.InventoryItemRemove( "inv_collectionstamp2" );
  
  end;
  local use_collectionstamp2_beg = function ()
  
    ObjDelete( "obj_volunteersstuff_use_collectionstamp2" );
    
  end;
  local use_collectionstamp2_end = function ()
  
    if ( cmn.IsEventDone( "use_collectionstamp1" ) ) then
      ObjDelete("spr_volunteersstuff_mark_1");
      ObjDelete("spr_volunteersstuff_mark_2");
      ObjAttach("anm_volunteersstuff_casket_open", "obj_volunteersstuff_casket_open");
      ObjMultiSet( { {"anm_volunteersstuff_casket_open", { frame = 300, input = 1, pos_x = 0, pos_y = 0 }},
                     {"spr_serviceroom_stuff_box_open", { alp = 1 }} } );
    else 
      ObjMultiSet( { {"spr_volunteersstuff_mark_2", { alp = 1 }},
                     {"spr_serviceroom_stuff_mark_2", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_collectionstamp2", use_collectionstamp2_beg, private.room_objname );
  cmn.AddSubscriber( "use_collectionstamp2", use_collectionstamp2_inv );
  cmn.AddSubscriber( "use_collectionstamp2", use_collectionstamp2_end, private.room_objname );
  cmn.AddSubscriber( "use_collectionstamp2_inv", use_collectionstamp2_inv, private.room_objname );
  cmn.AddSubscriber( "use_collectionstamp2_beg", use_collectionstamp2_beg, private.room_objname );
  cmn.AddSubscriber( "use_collectionstamp2_end", use_collectionstamp2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_boxkey () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_boxkey" ] = {
        type = "use",
        inv_obj = "inv_boxkey",
        use_place = "obj_sophiesbox_use_boxkey",
        room = private.room_objname,
        zz = "zz_sophiesbox",
        zz_gate = "gzz_serviceroom_sophiesbox"
    };
  --------------------------------------------------------------------------------------------
  local use_boxkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_boxkey" );
  
  end;
  local use_boxkey_beg = function ()
  
    ObjDelete( "obj_sophiesbox_use_boxkey" );
    ObjSet( "anm_sophiesbox_bag", { alp = 1, input = true } );
  
  end;
  local use_boxkey_end = function ()
    
    ObjDelete( "spr_serviceroom_box_name" );
  
    ObjMultiSet( { { "obj_sophiesbox_use_zipperrunner", { input = true } },
                   { "obj_sophiesbox_use_stetoscopeamulet", { input = true } },
                   { "anm_sophiesbox_door", { animfunc = "func_boxkey_use", endtrig = "", frame = 103 } },
                   { "spr_serviceroom_box_open", { alp = 1 } } } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_boxkey", use_boxkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_boxkey", use_boxkey_inv );
  cmn.AddSubscriber( "use_boxkey", use_boxkey_end, private.room_objname );
  cmn.AddSubscriber( "use_boxkey_inv", use_boxkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_boxkey_beg", use_boxkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_boxkey_end", use_boxkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_zipperrunner () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_zipperrunner" ] = {
        type = "use",
        inv_obj = "inv_zipperrunner",
        use_place = "obj_sophiesbox_use_zipperrunner",
        room = private.room_objname,
        zz = "zz_sophiesbox",
        zz_gate = "gzz_serviceroom_sophiesbox"
    };
  --------------------------------------------------------------------------------------------
  local use_zipperrunner_inv = function ()
  
    interface.InventoryItemRemove( "inv_zipperrunner" );
  
  end;
  local use_zipperrunner_beg = function ()
  
    ObjDelete( "obj_sophiesbox_use_zipperrunner" );
  
  end;
  local use_zipperrunner_end = function ()

    ObjMultiSet( { { "anm_sophiesbox_bag", { animfunc = "func_zipper_runner_use", endtrig = "", frame = 72 } },
                   { "spr_sophiesbox_cakeamulet", { input = true } },
                   { "spr_sophiesbox_keyholder",  { input = true } },
                   { "spr_serviceroom_box_pocket",  { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_zipperrunner", use_zipperrunner_beg, private.room_objname );
  cmn.AddSubscriber( "use_zipperrunner", use_zipperrunner_inv );
  cmn.AddSubscriber( "use_zipperrunner", use_zipperrunner_end, private.room_objname );
  cmn.AddSubscriber( "use_zipperrunner_inv", use_zipperrunner_inv, private.room_objname );
  cmn.AddSubscriber( "use_zipperrunner_beg", use_zipperrunner_beg, private.room_objname );
  cmn.AddSubscriber( "use_zipperrunner_end", use_zipperrunner_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_stetoscopeamulet () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_stetoscopeamulet" ] = {
        type = "use",
        inv_obj = "inv_stetoscopeamulet",
        use_place = "obj_sophiesbox_use_stetoscopeamulet",
        room = private.room_objname,
        zz = "zz_sophiesbox",
        zz_gate = "gzz_serviceroom_sophiesbox"
    };
  --------------------------------------------------------------------------------------------
  local use_stetoscopeamulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_stetoscopeamulet" );
  
  end;
  local use_stetoscopeamulet_beg = function ()
  
    ObjDelete( "obj_sophiesbox_use_stetoscopeamulet" );
    ObjSet( "obj_sophiesbox_items", { alp = 1, input = true } );
  
  end;
  local use_stetoscopeamulet_end = function ()

    ObjDelete( "anm_sophiesbox_door2" );
    ObjDelete( "spr_serviceroom_box_safe_closed" );

    ObjMultiSet( { {"spr_sophiesbox_door2_opn", { alp = 1 }},
                   {"spr_serviceroom_box_safe_open", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stetoscopeamulet", use_stetoscopeamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_stetoscopeamulet", use_stetoscopeamulet_inv );
  cmn.AddSubscriber( "use_stetoscopeamulet", use_stetoscopeamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_stetoscopeamulet_inv", use_stetoscopeamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_stetoscopeamulet_beg", use_stetoscopeamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_stetoscopeamulet_end", use_stetoscopeamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_badgepart () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_badgepart" ] = {
        type = "use",
        inv_obj = "inv_badgepart",
        use_place = "obj_cardindex_use_badgepart",
        room = private.room_objname,
        zz = "zz_cardindex",
        zz_gate = "gzz_serviceroom_cardindex"
    };
  --------------------------------------------------------------------------------------------
  local use_badgepart_inv = function ()
  
    interface.InventoryItemRemove( "inv_badgepart" );
  
  end;
  local use_badgepart_beg = function ()
  
    ObjDelete( "obj_cardindex_use_badgepart" );
  
  end;
  local use_badgepart_end = function ()
    
    ObjDelete( "anm_cardindex_drawer1_touch" );
  
    ObjMultiSet( { {"obj_cardindex_box_1_open", { alp = 1, input = 1 }},
                   {"spr_serviceroom_card_box_1", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_badgepart", use_badgepart_beg, private.room_objname );
  cmn.AddSubscriber( "use_badgepart", use_badgepart_inv );
  cmn.AddSubscriber( "use_badgepart", use_badgepart_end, private.room_objname );
  cmn.AddSubscriber( "use_badgepart_inv", use_badgepart_inv, private.room_objname );
  cmn.AddSubscriber( "use_badgepart_beg", use_badgepart_beg, private.room_objname );
  cmn.AddSubscriber( "use_badgepart_end", use_badgepart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_matches () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_matches" ] = {
        type = "use",
        inv_obj = "inv_matches",
        use_place = "obj_cardindex_use_matches",
        room = private.room_objname,
        zz = "zz_cardindex",
        zz_gate = "gzz_serviceroom_cardindex"
    };
  --------------------------------------------------------------------------------------------
  local use_matches_inv = function ()
  
    interface.InventoryItemRemove( "inv_matches" );
  
  end;
  local use_matches_beg = function ()
  
    ObjDelete( "obj_cardindex_use_matches" );
    ObjDelete( "obj_cardindex_drawer2_touch" );
  
  end;
  local use_matches_end = function ()
  
    ObjMultiSet( { {"anm_cardindex_use_matches", { alp = 1, frame = 300 }},
                   {"obj_cardindex_code", { input = 1 }},
                   {"fx_cardindex_fire", { active = 1, visible = 1 }},
                   {"spr_serviceroom_card_light", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_matches", use_matches_beg, private.room_objname );
  cmn.AddSubscriber( "use_matches", use_matches_inv );
  cmn.AddSubscriber( "use_matches", use_matches_end, private.room_objname );
  cmn.AddSubscriber( "use_matches_inv", use_matches_inv, private.room_objname );
  cmn.AddSubscriber( "use_matches_beg", use_matches_beg, private.room_objname );
  cmn.AddSubscriber( "use_matches_end", use_matches_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_oldglasses () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_oldglasses" ] = {
        type = "use",
        inv_obj = "inv_oldglasses",
        use_place = "obj_cardindex_use_oldglasses",
        room = private.room_objname,
        zz = "zz_cardindex",
        zz_gate = "gzz_serviceroom_cardindex"
    };
  --------------------------------------------------------------------------------------------
  local use_oldglasses_inv = function ()
  
    interface.InventoryItemRemove( "inv_oldglasses" );
  
  end;
  local use_oldglasses_beg = function ()
  
    ObjDelete( "obj_cardindex_use_oldglasses" );
    ObjDelete( "anm_cardindex_owl_touch" );
  
  end;
  local use_oldglasses_end = function ()
    
    ObjDelete( "spr_serviceroom_card_owl_1" );

    ObjMultiSet( { {"anm_cardindex_use_glasses",  { alp = 1, input = 1, frame = 300 }},
                   {"spr_serviceroom_card_owl_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_oldglasses", use_oldglasses_beg, private.room_objname );
  cmn.AddSubscriber( "use_oldglasses", use_oldglasses_inv );
  cmn.AddSubscriber( "use_oldglasses", use_oldglasses_end, private.room_objname );
  cmn.AddSubscriber( "use_oldglasses_inv", use_oldglasses_inv, private.room_objname );
  cmn.AddSubscriber( "use_oldglasses_beg", use_oldglasses_beg, private.room_objname );
  cmn.AddSubscriber( "use_oldglasses_end", use_oldglasses_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_serviceroom () end;
  --------------------------------------------------------------------------------------------
  local opn_serviceroom = function ()
  
    int_map_impl.OpenRoom( "rm_serviceroom" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_serviceroom", opn_serviceroom );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_volunteersstuff" );
  subroom.Define( "zz_cardindex" );
  
  function zz_volunteersstuff.Open()
    
    if not cmn.IsEventDone("opn_volunteersstuff") then
      cmn.SetEventDone("opn_volunteersstuff");
      cmn.ShowBbt( "volunteersstuff_open" );
    end;

  end;
  
  function zz_cardindex.PreOpen()

    if cmn.IsEventDone("use_matches") and not cmn.IsEventDone("win_cardindex") then
      private.zz_cardindex.DrawScene();
    end;

  end;
  
  function zz_cardindex.Open()

    if cmn.IsEventDone("use_matches") and not cmn.IsEventDone("win_cardindex") then
      private.zz_cardindex.CheckWin();
    end;

  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_cardindex" ].state) then 
    private.zz_cardindex.StartConditions();
  end;

  private.zz_cardindex.state = ng_global.progress[ ng_global.currentprogress ][ "win_cardindex" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_serviceroom();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_hospitalroom_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_hospitalroom_env");
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_pandaseye1()

  local item = "inv_pandaseye1";

  if cmn.ApplyObj( item, "gzz_serviceroom_volunteersstuff" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_volunteersstuff" );

  elseif ( cmn.ApplyObj( item, "obj_volunteersstuff_use_pandaseye1" ) ) then

    cmn.CallEventHandler( "use_pandaseye1_inv" );
    cmn.CallEventHandler( "use_pandaseye1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pandaseye1" );
      cmn.CallEventHandler( "use_pandaseye1_end" );

      if ( cmn.IsEventDone( "use_pandaseye2" ) ) then
        cmn.SetEventDone( "use_pandaseye" );
      end;
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/rm_nearhospital/audio/aud_xx_bag2");
      
      ObjMultiSet( { {"anm_volunteersstuff_bag_open", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_volunteersstuff_bag_open_2", { alp = 1, playing = 1 }},
                     {"anm_volunteersstuff_bag_touch", { alp = 0 }},
                     {"anm_volunteersstuff_bag_eye_1", { alp = 0 }},
                     {"anm_volunteersstuff_bag_eye_2", { alp = 0 }},
                     {"spr_volunteersstuff_bag_sh", { alp = 0 }} } );
               
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");

    if cmn.IsEventDone("use_pandaseye2") then
      ObjAnimate("anm_volunteersstuff_bag_eye_1", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });
    else 
      ObjAnimate("anm_volunteersstuff_bag_eye_1", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pandaseye2()

  local item = "inv_pandaseye2";

  if cmn.ApplyObj( item, "gzz_serviceroom_volunteersstuff" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_volunteersstuff" );

  elseif ( cmn.ApplyObj( item, "obj_volunteersstuff_use_pandaseye2" ) ) then

    cmn.CallEventHandler( "use_pandaseye2_inv" );
    cmn.CallEventHandler( "use_pandaseye2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pandaseye2" );
      cmn.CallEventHandler( "use_pandaseye2_end" );

      if ( cmn.IsEventDone( "use_pandaseye1" ) ) then
        cmn.SetEventDone( "use_pandaseye" );
      end;

    end;

    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/rm_nearhospital/audio/aud_xx_bag2");
      
      ObjMultiSet( { {"anm_volunteersstuff_bag_open", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_volunteersstuff_bag_open_2", { alp = 1, playing = 1 }},
                     {"anm_volunteersstuff_bag_touch", { alp = 0 }},
                     {"anm_volunteersstuff_bag_eye_1", { alp = 0 }},
                     {"anm_volunteersstuff_bag_eye_2", { alp = 0 }},
                     {"spr_volunteersstuff_bag_sh", { alp = 0 }} } );
               
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");

    if cmn.IsEventDone("use_pandaseye1") then
      ObjAnimate("anm_volunteersstuff_bag_eye_2", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });
    else 
      ObjAnimate("anm_volunteersstuff_bag_eye_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_heartsign()

  local item = "inv_heartsign";

  if cmn.ApplyObj( item, "gzz_serviceroom_volunteersstuff" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_volunteersstuff" );

  elseif ( cmn.ApplyObj( item, "obj_volunteersstuff_use_heartsign" ) ) then

    cmn.CallEventHandler( "use_heartsign_inv" );
    cmn.CallEventHandler( "use_heartsign_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_heartsign" );
      cmn.CallEventHandler( "use_heartsign_end" );
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/ho_inwardrobe/audio/aud_xx_bag");

    ObjSet("anm_volunteersstuff_use_heart",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_collectionstamp1()

  local item = "inv_collectionstamp1";

  if cmn.ApplyObj( item, "gzz_serviceroom_volunteersstuff" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_volunteersstuff" );

  elseif cmn.ApplyObj( item, "obj_volunteersstuff_use_collectionstamp1" )
  and    cmn.IsEventDone( "use_pandaseye1" ) and cmn.IsEventDone( "use_pandaseye2" ) then

    cmn.CallEventHandler( "use_collectionstamp1_inv" );
    cmn.CallEventHandler( "use_collectionstamp1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_collectionstamp1" );
      cmn.CallEventHandler( "use_collectionstamp1_end" );
    
    end;
    
    local change_z = function ()
      ObjAttach("anm_volunteersstuff_casket_open", "obj_volunteersstuff_casket_open");
      ObjSet("anm_volunteersstuff_casket_open",  { pos_x = 0, pos_y = 0 });
    end;

    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/rm_serviceroom/audio/aud_opn_casket");
      
      ObjMultiSet( { {"anm_volunteersstuff_casket_open", { playing = 1, endtrig = func_after }},
                     {"tmr_volunteersstuff_timer", { time = 0.3, playing = 1, endtrig = change_z }} } );
               
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_serviceroom/audio/aud_use_stamps");

    if cmn.IsEventDone("use_collectionstamp2") then
      ObjAnimate("spr_volunteersstuff_mark_1", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });
    else 
      ObjAnimate("spr_volunteersstuff_mark_1", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_collectionstamp2()

  local item = "inv_collectionstamp2";

  if cmn.ApplyObj( item, "gzz_serviceroom_volunteersstuff" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_volunteersstuff" );

  elseif cmn.ApplyObj( item, "obj_volunteersstuff_use_collectionstamp2" )
  and    cmn.IsEventDone( "use_pandaseye1" ) and cmn.IsEventDone( "use_pandaseye2" ) then

    cmn.CallEventHandler( "use_collectionstamp2_inv" );
    cmn.CallEventHandler( "use_collectionstamp2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_collectionstamp2" );
      cmn.CallEventHandler( "use_collectionstamp2_end" );
    
    end;

    local change_z = function ()
      ObjAttach("anm_volunteersstuff_casket_open", "obj_volunteersstuff_casket_open");
      ObjSet("anm_volunteersstuff_casket_open",  { pos_x = 0, pos_y = 0 });
    end;

    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/rm_serviceroom/audio/aud_opn_casket");
      
      ObjMultiSet( { {"anm_volunteersstuff_casket_open", { playing = 1, endtrig = func_after }},
                     {"tmr_volunteersstuff_timer", { time = 0.3, playing = 1, endtrig = change_z }} } );
               
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_serviceroom/audio/aud_use_stamps");

    if cmn.IsEventDone("use_collectionstamp1") then
      ObjAnimate("spr_volunteersstuff_mark_2", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });
    else 
      ObjAnimate("spr_volunteersstuff_mark_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_boxkey()

  local item = "inv_boxkey";

  if cmn.ApplyObj( item, "gzz_serviceroom_sophiesbox" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_sophiesbox" );

  elseif ( cmn.ApplyObj( item, "obj_sophiesbox_use_boxkey" ) ) then

    cmn.CallEventHandler( "use_boxkey_inv" );
    cmn.CallEventHandler( "use_boxkey_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_boxkey" );
      cmn.CallEventHandler( "use_boxkey_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_serviceroom/audio/aud_use_key_safe_sofia");

    ObjMultiSet( { { "txt_sophiesbox_door_text", { anim_tag = "tag_text1" } },
                   { "anm_sophiesbox_door", { animfunc = "func_boxkey_use", endtrig = func_after, playing = true } } } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_zipperrunner()

  local item = "inv_zipperrunner";

  if cmn.ApplyObj( item, "gzz_serviceroom_sophiesbox" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_sophiesbox" );

  elseif ( cmn.ApplyObj( item, "obj_sophiesbox_use_zipperrunner" ) and cmn.IsEventDone( "use_boxkey" ) ) then

    cmn.CallEventHandler( "use_zipperrunner_inv" );
    cmn.CallEventHandler( "use_zipperrunner_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_zipperrunner" );
      cmn.CallEventHandler( "use_zipperrunner_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_serviceroom/audio/aud_use_zipper");

    ObjSet( "anm_sophiesbox_bag", { animfunc = "func_zipper_runner_use", endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_stetoscopeamulet()

  local item = "inv_stetoscopeamulet";

  if cmn.ApplyObj( item, "gzz_serviceroom_sophiesbox" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_sophiesbox" );

  elseif ( cmn.ApplyObj( item, "obj_sophiesbox_use_stetoscopeamulet" ) and cmn.IsEventDone( "use_boxkey" ) ) then

    cmn.CallEventHandler( "use_stetoscopeamulet_inv" );
    cmn.CallEventHandler( "use_stetoscopeamulet_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_stetoscopeamulet" );
      cmn.CallEventHandler( "use_stetoscopeamulet_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_serviceroom/audio/aud_use_stetoscopeamulet");

    ObjAnimate( "spr_sophiesbox_stetoscopeamulet", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    ObjAnimate( "anm_sophiesbox_door2",            "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 1,    0.8, 0, 0 } );
    ObjAnimate( "spr_sophiesbox_door2_opn",        "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 0,    0.8, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_badgepart()

  local item = "inv_badgepart";

  if cmn.ApplyObj( item, "gzz_serviceroom_cardindex" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cardindex" );

  elseif ( cmn.ApplyObj( item, "obj_cardindex_use_badgepart" ) and cmn.CheckMultiObject( "badgepart", 2 ) ) then

    cmn.CallEventHandler( "use_badgepart_inv" );
    cmn.CallEventHandler( "use_badgepart_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_badgepart" );
      cmn.CallEventHandler( "use_badgepart_end" );
    
    end;
    
    local anm_open = function ()
      
      ObjAnimate("obj_cardindex_box_1_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_cardindex_drawer1_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_serviceroom/audio/aud_opn_safe4");

    ObjAnimate( "spr_cardindex_badgepart", "alp", 0, 0, anm_open,
    {
      0.0, 0, 0, 
      0.3, 0, 1,
      0.6, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_matches()

  local item = "inv_matches";

  if cmn.ApplyObj( item, "gzz_serviceroom_cardindex" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cardindex" );

  elseif ( cmn.ApplyObj( item, "obj_cardindex_use_matches" ) ) then

    cmn.CallEventHandler( "use_matches_inv" );
    cmn.CallEventHandler( "use_matches_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_matches" );
      cmn.CallEventHandler( "use_matches_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_serviceroom/audio/aud_use_matches");

    ObjSet("anm_cardindex_use_matches",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_oldglasses()

  local item = "inv_oldglasses";

  if cmn.ApplyObj( item, "gzz_serviceroom_cardindex" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cardindex" );

  elseif ( cmn.ApplyObj( item, "obj_cardindex_use_oldglasses" ) ) then

    cmn.CallEventHandler( "use_oldglasses_inv" );
    cmn.CallEventHandler( "use_oldglasses_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_oldglasses" );
      cmn.CallEventHandler( "use_oldglasses_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_serviceroom/audio/aud_opn_owl");

    ObjSet("anm_cardindex_use_glasses",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_catshead()

  cmn.SetEventDone( "get_catshead" );
  cmn.CallEventHandler( "get_catshead" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if private.IsAllVolunteersstuffItemsGet() then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_rubbergloves()
  
  cmn.SetEventDone( "get_rubbergloves" );
  cmn.CallEventHandler( "get_rubbergloves" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if private.IsAllVolunteersstuffItemsGet() then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_tornoffpatch()
  
  cmn.SetEventDone( "get_tornoffpatch" );
  cmn.CallEventHandler( "get_tornoffpatch" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if private.IsAllVolunteersstuffItemsGet() then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_angelfigurine()

  cmn.SetEventDone( "get_angelfigurine" );
  cmn.CallEventHandler( "get_angelfigurine" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if private.IsAllVolunteersstuffItemsGet() then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_newspaperpiece1()

  cmn.SetEventDone( "get_newspaperpiece1" );
  cmn.CallEventHandler( "get_newspaperpiece1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if private.IsAllVolunteersstuffItemsGet() then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_sails()

  cmn.SetEventDone( "get_sails" );
  cmn.CallEventHandler( "get_sails" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if private.IsAllVolunteersstuffItemsGet() then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_curtaintieback1()

  cmn.SetEventDone( "get_curtaintieback1" );
  cmn.CallEventHandler( "get_curtaintieback1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if private.IsAllVolunteersstuffItemsGet() then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_donationcheque()

  cmn.SetEventDone( "get_donationcheque" );
  cmn.CallEventHandler( "get_donationcheque_inv" );
  cmn.CallEventHandler( "get_donationcheque_end" );
  
  interface_impl.CompleteClues( {3} );
  
  cmn.ShowBbt( "serviceroom_after_get_check" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if private.IsAllSophiesboxItemsGet() then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_puzzlepart2()

  cmn.SetEventDone( "get_puzzlepart2" );
  cmn.CallEventHandler( "get_puzzlepart2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_woolball()

  cmn.SetEventDone( "get_woolball" );
  cmn.CallEventHandler( "get_woolball" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if private.IsAllSophiesboxItemsGet() then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_matches()

  cmn.SetEventDone( "get_matches" );
  cmn.CallEventHandler( "get_matches" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if private.IsAllSophiesboxItemsGet() then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_cakeamulet()

  cmn.SetEventDone( "get_cakeamulet" );
  cmn.CallEventHandler( "get_cakeamulet" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if private.IsAllSophiesboxItemsGet() then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_keyholder()

  cmn.SetEventDone( "get_keyholder" );
  cmn.CallEventHandler( "get_keyholder" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if private.IsAllSophiesboxItemsGet() then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_sophiaspullover()

  cmn.SetEventDone( "get_sophiaspullover" );
  cmn.CallEventHandler( "get_sophiaspullover" );

  if private.IsAllSophiesboxItemsGet() then
    common.CloseSubRoom();
  end;

  if ( not cmn.IsEventDone( "get_woodensquare" ) ) then
    public.get_woodensquare();
  else
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_woodensquare()

  cmn.SetEventDone( "get_woodensquare" );
  cmn.CallEventHandler( "get_woodensquare" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if private.IsAllSophiesboxItemsGet() then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_antirust()

  cmn.SetEventDone( "get_antirust" );
  cmn.CallEventHandler( "get_antirust" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if private.IsAllCardindexItemsGet() then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_yellowthread()

  cmn.SetEventDone( "get_yellowthread" );
  cmn.CallEventHandler( "get_yellowthread" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if private.IsAllCardindexItemsGet() then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_lvl4pen()

  cmn.SetEventDone( "get_lvl4pen" );
  cmn.CallEventHandler( "get_lvl4pen" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if private.IsAllCardindexItemsGet() then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_knittingneedles()

  cmn.SetEventDone( "get_knittingneedles" );
  cmn.CallEventHandler( "get_knittingneedles" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if private.IsAllCardindexItemsGet() then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_lvl4notebook()

  cmn.SetEventDone( "get_lvl4notebook" );
  cmn.CallEventHandler( "get_lvl4notebook" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if private.IsAllCardindexItemsGet() then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_tongs()
  
  ObjSet("spr_cardindex_tongs",  { ang = 2.1065 });

  cmn.SetEventDone( "get_tongs" );
  cmn.CallEventHandler( "get_tongs" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if private.IsAllCardindexItemsGet() then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_lockpart1()

  cmn.SetEventDone( "get_lockpart1" );
  cmn.CallEventHandler( "get_lockpart1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if private.IsAllCardindexItemsGet() then
    common.CloseSubRoom();
  end;

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_serviceroom()

  if not ( cmn.IsEventDone( "opn_serviceroom" ) ) then
    cmn.SetEventDone( "opn_serviceroom" );
    cmn.CallEventHandler("opn_serviceroom");
    cmn.ShowBbt( "serviceroom_open" );
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_carddrawer_1()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_cardindex_use_badgepart" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/ho_medical/audio/aud_cls_box");
  
  ObjSet("anm_cardindex_drawer1_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_carddrawer_2()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "cardindex_need_code" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/ho_medical/audio/aud_opn_box");
  
  ObjSet("anm_cardindex_drawer2_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  ObjAnimate("obj_cardindex_code", "pos_xy", 0, 0, "", { 0, 0, 0, 0,   0.25, 0, -2, 1,   0.5, 0, 0, 0 });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_owl()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_cardindex_use_oldglasses" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_serviceroom/audio/aud_xx_owl");
  
  ObjSet("anm_cardindex_owl_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_panda_bag()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_volunteersstuff_use_pandaseye" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_purse/audio/aud_xx_clk_cloth");
  
  ObjMultiSet( { {"anm_volunteersstuff_bag_touch", { playing = 1, endtrig = function() cmn.Lock(0); end }},
                 {"anm_volunteersstuff_bag_eye_1", { playing = 1 }},
                 {"anm_volunteersstuff_bag_eye_2", { playing = 1 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_panda_pocket()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_volunteersstuff_use_heartsign" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_purse/audio/aud_xx_clk_cloth");
  
  ObjSet("anm_volunteersstuff_pocket_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_sophiesbox_door()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_sophiesbox_use_boxkey" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_xx_clk_metal_door");
  
  ObjSet( "anm_sophiesbox_door", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_sophiesbox_door2()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_sophiesbox_use_stetoscopeamulet" );
  
  cmn.PlayAudio("snd", "assets/levels/level3/rm_policedepartment/audio/aud_xx_clk_grill2");
  
  ObjSet( "anm_sophiesbox_door2", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_sophiesbox_bag()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_sophiesbox_use_zipperrunner" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_purse/audio/aud_xx_clk_cloth");
  
  ObjSet( "anm_sophiesbox_bag", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function private.IsAllVolunteersstuffItemsGet()
  --ОСТОРОЖНО! применяетса в прогрессовских функциях

  if  cmn.IsEventDone( "get_catshead" ) and cmn.IsEventDone( "get_tornoffpatch" ) and cmn.IsEventDone( "get_rubbergloves" )
  and cmn.IsEventDone( "get_angelfigurine" ) and cmn.IsEventDone( "get_newspaperpiece1" ) 
  and cmn.IsEventDone( "get_sails" ) and cmn.IsEventDone( "get_curtaintieback1" ) then
    return true;
  else
    return false;
  end;

end;
--------------------------------------------------------------------------------------------
function private.IsAllCardindexItemsGet()
  --ОСТОРОЖНО! применяетса в прогрессовских функциях

  if  cmn.IsEventDone( "get_antirust" ) and cmn.IsEventDone( "get_yellowthread" ) and cmn.IsEventDone( "get_lvl4pen" )
  and cmn.IsEventDone( "get_knittingneedles" ) and cmn.IsEventDone( "get_lvl4notebook" ) 
  and cmn.IsEventDone( "get_tongs" ) and cmn.IsEventDone( "get_lockpart1" ) then
    return true;
  else
    return false;
  end;

end;
--------------------------------------------------------------------------------------------
function private.IsAllSophiesboxItemsGet()
  --ОСТОРОЖНО! применяетса в прогрессовских функциях

  if  cmn.IsEventDone( "get_woolball" ) and cmn.IsEventDone( "get_matches" )
  and cmn.IsEventDone( "get_cakeamulet" ) and cmn.IsEventDone( "get_keyholder" ) 
  and cmn.IsEventDone( "get_sophiaspullover" ) and cmn.IsEventDone( "get_donationcheque" ) and cmn.IsEventDone( "get_woodensquare" ) then
    return true;
  else
    return false;
  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Cardindex *** () end;
--*********************************************************************************************************************
--********************************************************************************************************************
private.zz_cardindex = {};
public.zz_cardindex = {};

function private.Init_Cardindex()

  private.right_code = { 3, 3, 6 };
  --------------------------------------------------------------------------------------------
  game.hint[ "win_cardindex" ] = {
    type = "click",
    use_place = "obj_cardindex_clk_code_1",
    room = "rm_serviceroom",
    zz = "zz_cardindex",
    zz_gate = "gzz_serviceroom_cardindex"
  };
  -----------------------------------------------------------------------------------
  local win_cardindex = function ()

    if cmn.IsEventDone( "win_cardindex" ) then

      ObjDelete( "obj_cardindex_code" );
      ObjDelete( "anm_cardindex_drawer2_touch" );
      ObjDelete( "spr_serviceroom_card_box_2_code" );
      
      ObjMultiSet( { {"obj_cardindex_box_2_open", { alp = 1, input = 1 }},
                     {"spr_serviceroom_card_box_2", { alp = 1 }} } );

    end;

  end;

  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_cardindex", win_cardindex, "rm_serviceroom" );

end;
--********************************************************************************************************************
function private.zz_cardindex.StartConditions()

  ng_global.progress[ "ext" ][ "win_cardindex" ].state = { 1, 1, 1 }; --current code

end;
-----------------------------------------------------------------------------------
function private.zz_cardindex.DrawScene()

  for i = 1, 3, 1 do
    for j = 1, private.right_code[i], 1 do
      
      if private.zz_cardindex.state[i] == j then
        ObjSet("spr_cardindex_code_"..i.."_"..j,  { alp = 1 });
      else 
        ObjSet("spr_cardindex_code_"..i.."_"..j,  { alp = 0 });
      end;
      
    end;
  end;

end;
-----------------------------------------------------------------------------------
function public.zz_cardindex.ClickCode( num )

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level2/rm_clothesroom/audio/aud_xx_button_lock");
  
  private.zz_cardindex.state[num] = private.zz_cardindex.state[num] + 1;
  
  ObjAnimate("spr_cardindex_code_"..num.."_"..private.zz_cardindex.state[num], "alp", 0, 0, private.zz_cardindex.CheckWin, { 0, 0, 0,   0.3, 0, 1 });
  ObjAnimate("spr_cardindex_code_"..num.."_"..(private.zz_cardindex.state[num]-1), "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });

end;
-----------------------------------------------------------------------------------
function private.zz_cardindex.CheckWin()
  
  local win_flag = true;
  
  for i = 1, 3, 1 do
    
    if private.zz_cardindex.state[i] == private.right_code[i] then
      ObjSet("obj_cardindex_clk_code_"..i,  { input = 0 });
    end;
    
  end;
  
  for i = 1, 3, 1 do
    
    if private.zz_cardindex.state[i] ~= private.right_code[i] then
      win_flag = false;
      game.hint[ "win_cardindex" ].use_place = "obj_cardindex_clk_code_"..i;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    private.zz_cardindex.Win();
    
  else 
    cmn.Lock( 0 );
  end;

end;
-----------------------------------------------------------------------------------
function private.zz_cardindex.Win()

  cmn.SetEventDone( "win_cardindex" );

  local func_after = function ()

    cmn.CallEventHandler( "win_cardindex" );

    cmn.Lock(0);

  end;

  cmn.PlayAudio("snd", "assets/levels/level4/rm_serviceroom/audio/aud_opn_safe4");

  ObjAnimate("obj_cardindex_box_2_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  ObjAnimate("anm_cardindex_drawer2_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate("obj_cardindex_code", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });

end;
---------------------------------------------------------------------
--****************************************************************************************
--*******************************************************************************************************************