-- name=rm_achievements
--******************************************************************************************
function public.Init()

  game.rm_achievements_array = {
    "one_ho_without_hint",
    "three_ho_without_hint",
    "five_ho_without_hint",
    "ten_ho_without_hint",
    "all_ho_without_hint",

    "three_ho_three_min",
    "five_ho_three_min",
    "ten_ho_three_min",

    "three_item_ho",
    "five_item_ho",
    "ten_item_ho",

    "one_ho_less_one_min",
    "one_ho_more_ten_min",

    "one_mg_without_skip",
    "three_mg_without_skip",
    "seven_mg_without_skip",
    "fifteen_mg_without_skip",
    "all_mg_without_skip",

    "one_mg_less_one_min",

    "collect_1_flower",
    "collect_5_flowers",
    "collect_15_flowers",
    "collect_30_flowers",
    "collect_100_flowers",
    "collect_200_flowers"--,
    --"collector"
    };


  game.rm_acievements_state = {
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  };


  private.achievements = {};
  public.in_rm_acievements = false;
  
  --становится true если зашли в ачивки из виджета цветов
  public.from_int_bonus = false;

end;
--******************************************************************************************
function public.PreOpen()

  public.in_rm_acievements = true;

  interface_impl.DialogHintHide();
  
  interface_impl.ShowBonus();

  cmn.StopAllEnv();
  cmn.PlayAudio( "env", "assets/levels/common/audio/aud_achivementsroom_env" );
  -------------------------------------------------------------------------
  if  ( not cmn.is_inmenunow ) then
    
    interface.WidgetSetInput( InterfaceWidget_Achiev, false );
    interface.WidgetSetInput( InterfaceWidget_Bonus,  false );

    interface.WidgetSetInput( InterfaceWidget_Inventory, false );
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   false );
    interface.WidgetSetInput( InterfaceWidget_BtnGuide,  false );
    interface.WidgetSetInput( InterfaceWidget_BtnMap,    false );
    interface.WidgetSetInput( InterfaceWidget_BtnMenu,   false );

    interface.WidgetSetVisible( InterfaceWidget_Inventory, false, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   false, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnGuide,  false, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnMap,    false, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnMenu,   false, true );

    ObjSet( "int_inventory_impl",        { input = 0 } );
    --ObjSet( "int_button_hint",      { input = 0, alp = 0 } );
    --ObjSet( "obj_int_button_guide", { input = 0, alp = 0 } );
    --ObjSet( "int_button_map",       { input = 0, alp = 0 } );
    --ObjSet( "int_button_menu",      { input = 0, alp = 0 } );

    --cmn.PlayAudio( "mus", "assets/levels/common/audio/aud_surf8_main_mus", 1 );

  end;

  game.rm_acievements_state = {
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  };

  local local_arr = game.rm_achievements_array;

  for i = 1, #local_arr, 1 do
        ObjStopAnimate("spr_achievements_"..i.."_out", 8);
        ObjSet("anm_achievements_"..i, {alp = 0});
        ObjSet("spr_achievements_"..i.."_out",{alp = 0});
  end;
  -------------------------------------------------------------------------
  private.DrawRoom();
  
  int_popup_achievements.enable_popup_achivements = false;
  ObjSet("tmr_achievements_input",{ time = 3, playing = true, endtrig = function() 
    int_popup_achievements.enable_popup_achivements = true;
  end });
  
end;
--******************************************************************************************
function public.Open()
  
  --interface_impl.PopupAchievementHide();
  private.NewAchievementsAnm();
  
--  if  ( not cmn.is_inmenunow ) then
--
--    interface.WidgetSetInput( InterfaceWidget_Inventory, false );    
--    ObjSet( "int_inventory_impl",        { input = 0 } );
--    
--  end;

  --если зашли в ачивки из виджета бонуса - подсвечиваем фх следующую ачивку по цветам
  if public.from_int_bonus then
    --DbgTrace("from_int_bonus");
    private.AnimNextBonusAchieve();
  end;

end;
--******************************************************************************************
function public.PreClose()

  interface_impl.PopupAchievementHide();
  
  interface_impl.HideBonus();

  if  ( not cmn.is_inmenunow ) then

    --cmn.StopAllMus();
    --common_impl.PlayBackgroundMusic();

    --interface.WidgetSetInput( InterfaceWidget_Achiev,    true );
    --interface.WidgetSetInput( InterfaceWidget_Bonus,     true );
    --
    --interface.WidgetSetInput( InterfaceWidget_Inventory, true );
    --interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    --interface.WidgetSetInput( InterfaceWidget_BtnGuide,  true );
    --interface.WidgetSetInput( InterfaceWidget_BtnMap,    true );
    --interface.WidgetSetInput( InterfaceWidget_BtnMenu,   true );
    
    interface.WidgetSetVisible( InterfaceWidget_Inventory, true, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnHint,   true, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnGuide,  true, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnMap,    true, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnMenu,   true, true );
    
    --ObjSet("int_inventory_impl", {input = 1});
    --ObjSet("int_button_hint", {input = 1, alp = 1});
    --ObjSet("obj_int_button_guide", {alp = 1, input = 1});
    --ObjSet("int_button_map", {input = 1, alp = 1});
    --ObjSet("int_button_menu", {input = 1, alp = 1});

  end;

end;
--******************************************************************************************
function public.Close()

  common_impl.go_acievements = false;
  public.from_int_bonus = false;

  --костыль - чтобы снимался блок в комнате из который мы вошли в ачивки при открытом сложном предмете
  if  ( not cmn.is_inmenunow ) then

    cmn.Lock( 0 );
    
    interface.WidgetSetInput( InterfaceWidget_Achiev,    true );
    interface.WidgetSetInput( InterfaceWidget_Bonus,     true );

    interface.WidgetSetInput( InterfaceWidget_Inventory, true );
    interface.WidgetSetInput( InterfaceWidget_BtnHint,   true );
    interface.WidgetSetInput( InterfaceWidget_BtnGuide,  true );
    interface.WidgetSetInput( InterfaceWidget_BtnMap,    true );
    interface.WidgetSetInput( InterfaceWidget_BtnMenu,   true );

    ObjSet("int_inventory_impl", {input = 1});

  end;
  
end;
--******************************************************************************************
--port.
function public.Hide()
  public.Exit(); --  public. or private.
end;
--******************************************************************************************
-------------------------------------------------------------------------
--выход из комнат ачивок
function public.Exit()
  
  if cmn.is_inmenunow then
    room.Switch("rm_extra");
    --room.Switch("rm_menu");
  else
    public.in_rm_acievements = false;
    room.Switch(common.GetCurrentRoom());
  end;

end;

-------------------------------------------------------------------------
--вывод попапа и подсветка места ачивки
function public.AreaEnter( num, num1 )   --num-номер ачивки в списке, num1-состояние курсора мыши (1-в области, 0-вне области)

  local param = game.rm_achievements_array[num];

  if num1 == 1 then

    local loc_table = { { str_1 = "ce_ach_"..param, str_2 = "ce_ach_"..param.."_text", color_r_1 = 1, color_g_1 = 1, color_b_1 = 1, color_r_2 = 1, color_g_2 = 1, color_b_2 = 1 } };

    interface_impl.PopupAchievementShow( loc_table );

  else
    interface_impl.PopupAchievementHide();
  end;

  --if game.rm_acievements_state[num] == 0 then
  --  ObjAnimate("spr_achievements_"..num.."_out", "alp", 0, 0, "", {0, 0, ObjGet("spr_achievements_"..num.."_out").alp,   1.2, 0, num1 * 0.5});
  --end;

end;

------------------------------------------------------------------------------------
function public.MouseEnterBack()

  local alp = ObjGet( "spr_achievements_exit_focus" ).alp;
  ObjAnimate( "spr_achievements_exit_focus", 8,0,0, "", {0,0,alp, 0.3,0,1});
  SetCursor(CURSOR_HAND);

end;

function public.MouseLeaveBack()

  local alp = ObjGet( "spr_achievements_exit_focus" ).alp;
  ObjAnimate( "spr_achievements_exit_focus", 8,0,0, "", {0,0,alp, 0.3,0,0});
  SetCursor(CURSOR_DEFAULT);

end;

-------------------------------------------------------------------------
--отрисовка комнаты
--второй столбец в массиве ачивок здесь используется для определения первый раз мы видим ачивку или нет
function private.DrawRoom()

  --ObjSet("obj_achievements_1", { alp = 1, input = 1 });
  --ObjSet("obj_achievements_2", { alp = 0, input = 0 });
  --ObjSet("obj_achievements_3", { alp = 0, input = 0 });
  --ObjSet("obj_achievements_4", { alp = 0, input = 0 });
  --ObjSet("obj_achievements_5", { alp = 0, input = 0 });

  local local_arr = game.rm_achievements_array;
  local state = 0;

  for i = 1, #local_arr, 1 do
    
    if ng_global.achiev[""..local_arr[i]..""][1] >= ng_global.achiev[""..local_arr[i]..""][3] then
      game.rm_acievements_state[i] = 1;
      ObjSet("anm_achievements_"..i, {alp = 1, playing = 1});
    else
      ObjSet("spr_achievements_"..i.."_out", { alp = 1 });
    end;

  end;
  
  --особый случай - ачивка за все ачивки
  --if ng_global.achiev[""..local_arr[26]..""][1] >= ng_global.achiev[""..local_arr[26]..""][3] then
  --  if ng_global.achiev[""..local_arr[26]..""][2] == 1 then
  --    game.rm_acievements_state[26] = 1;
  --    ObjMultiSet( { {"anm_achievements_26_appear", { alp = 0, playing = 0 }},
  --                   {"spr_achievements_26", { alp = 1 }},
  --                   {"anm_achievements_26_reflection", { alp = 1, playing = 1 }} } );
  --  end;
  --else 
  --  ObjMultiSet( { {"anm_achievements_26_appear", { alp = 0, playing = 0 }},
  --                 {"anm_achievements_26_reflection", { alp = 0, playing = 0 }} } );
  --end;

end;
-------------------------------------------------------------------------
--появление ачивок
function private.NewAchievementsAnm()

  local local_arr = game.rm_achievements_array;
  local state = 0;
  local new = false;

  for i = 1, #local_arr, 1 do

    if ng_global.achiev[""..local_arr[i]..""][1] >= ng_global.achiev[""..local_arr[i]..""][3] then

      if ng_global.achiev[""..local_arr[i]..""][2] == 0 then

        ng_global.achiev[""..local_arr[i]..""][2] = 1;
        ObjSet("fx_achievements_"..i, {playing = true, active = true});
        
        new = true;
        
        --PartSysRestart("fx_achievements_"..i);

      end;

    end;

  end;
  
  --особое появление ачивки за все ачивки
--  if ng_global.achiev[""..local_arr[26]..""][1] >= ng_global.achiev[""..local_arr[26]..""][3] then
--
--    if ng_global.achiev[""..local_arr[26]..""][2] == 0 then
--      
--      local fx_show = function()
--      
--        cmn.Lock(0);
--        game.rm_acievements_state[26] = 1;
--        
--        ObjMultiSet( { {"spr_achievements_26", { alp = 1 }},
--                       {"anm_achievements_26_appear", { alp = 0 }},
--                       {"anm_achievements_26_reflection", { alp = 1, playing = 1 }} } );
--        
--        ng_global.achiev[""..local_arr[26]..""][2] = 1;
--        ObjSet("fx_achievements_26", {playing = true, active = true});
--        new = true;
--        
--      end;
--      
--      cmn.Lock(1);
--      ObjSet("anm_achievements_26_appear",  { alp = 1, playing = 1, endtrig = fx_show });
--      
--    end;
--    
--  end;
  
  if new then
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_achive_new" );
  end;

end;
-------------------------------------------------------------------------
--подсвечиваем фх следующую ачивку по цветам
function private.AnimNextBonusAchieve()

  local local_arr = game.rm_achievements_array;
  local state = 0;

  for i = 20, 25, 1 do

    if ng_global.achiev[""..local_arr[i]..""][1] < ng_global.achiev[""..local_arr[i]..""][3] then
      
        --DbgTrace("anim "..i);

        ObjSet("fx_achievements_"..i, {playing = true, active = true});
        cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_achive_new" );
        --PartSysRestart("fx_achievements_"..i);
        
        break;

    end;

  end;

end;
--******************************************************************************************
