-- name=int_button_guide
--******************************************************************************************
function public.Init( pos_z )

  private.event_anim_end = {};
  interface.LoadImplementation( "button_guide" );
  ObjAttach( "int_button_guide", interface.originhub );
  ObjSet( "int_button_guide", { pos_z = pos_z } );
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
function public.Destroy()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
function public.MouseDown()

 --port.
 if tostring(GetPlatform()) == "ios" then
    iOS_LogEvents(206,"");
    iOS_LaunchGameApp();
    iOS_LogEvents(201,"");
  else
    if iOS_IsBought() == 0 then
      SaveProfiles();
      SaveSettings();
      common.LevelSwitch("menu","unlock");
    else
      MsgSend( Event_ButtonGuide_Click, {} );
    end;
  end;

end;
--******************************************************************************************
function private.WideScreenUpdate()

  interface.WideScreenUpdate( "button_guide" );

end;
--******************************************************************************************