-- name=int_blackbartext_impl
--******************************************************************************************
function public.Init()

  public.DIRECTION = 0;

  private.SHOW_ANIM_TIME = 0.3;
  private.HIDE_ANIM_TIME = 0.3;
  
  public.characters = 1;
  public.character_shown = false;

  ObjSet( "obj_int_blackbartext_transpanent", {
    event_mdown = function () int_blackbartext.MouseDown(); end
  } );

end;
--******************************************************************************************
function public.ShowAnim( event_id )
  
  local character = public.character_shown;
  
  --показываем иконку персонажа
  if public.character_shown then
    
    public.character_shown = false;
    
    local pic_width = ObjGet("spr_int_blackbartext_character_"..character).draw_width;
    ObjSet( "txt_int_blackbartext", { maxwidth = 1024-pic_width, text = bbt_text } );
    
    local text_width = ObjGet("txt_int_blackbartext").draw_width;
    local dev_x = math.floor(pic_width/2);
    
    ObjMultiSet( { {"spr_int_blackbartext_character_"..character, { alp = 1, pos_x = -math.floor(text_width/2) }},
                   {"txt_int_blackbartext", { pos_x = dev_x }} } );
    
  else
    
    for i = 1, public.characters, 1 do
      ObjSet("spr_int_blackbartext_character_"..i,  { alp = 0 });
    end;
    ObjSet("txt_int_blackbartext",  { maxwidth = 1024, pos_x = 0 });
    
  end;
  
  local trg = function () int_blackbartext.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;
  ObjAnimate( "int_blackbartext_impl", "alp", 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

end;
--******************************************************************************************
function public.HideAnim( event_id )
  
  local trg = function () 
    int_blackbartext.EventAnimEnd( event_id );
  end;
  
  local tme = private.HIDE_ANIM_TIME;
  ObjAnimate( "int_blackbartext_impl", "alp", 0, 0, trg,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

end;
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then

    --

  else

    --

  end;

end;
--******************************************************************************************