-- name=int_button_menu_impl
--******************************************************************************************
function public.Init ()

  public.DIRECTION = 0;

  private.MOUSE_OVER_ANIM_TIME = 0.3;

  ObjSet("obj_int_button_menu", {
    event_mdown = function () int_button_menu.MouseDown(); cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk"); end,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  });

end;
--******************************************************************************************
function public.Destroy()
end;
--******************************************************************************************
function public.WideScreenUpdate()

  --if ( not GetWideScreen() ) then
  --  ObjSet( "spr_int_button_menu_back", { active = false, visible = false } );
  --else
  --  ObjSet( "spr_int_button_menu_back", { active = false, visible = true } );
  --end;

end;
--******************************************************************************************
function private.MouseEnterAnim()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_menu_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.MouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_button_menu_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );


end;
--******************************************************************************************
