-- name=mg_key
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_key";
  --------------------------------------------------------------------------------------------
  --узлы лабиритна
  private.key_points = { 
    {143, 570}, {235, 604}, {345, 644}, {89, 345}, {203, 296}, {190, 353}, {315, 392}, {359, 291}, {292, 265}, {263, 218},
    {494, 325}, {541, 204}, {427, 237}, {391, 176}, {690, 261}, {746, 232}, {617, 183}, {757, 299}, {643, 364}, {683, 435},
    {789, 406}, {977, 337}, {360, 562}, {559, 628}, {649, 590}, {468, 522}, {345, 479}, {538, 401}, {571, 492}, {723, 549},
    {806, 578}, {883, 463}, {1112, 379}, {1075, 473}, {978, 511}, {1270, 401}, {1143, 611}, {1209, 292}, {1042, 249}, {1262, 166},
    {1374, 361}, {1476, 324}, {1380, 147}, {1653, 261}, {1358, 542}, {1628, 454}, {1666, 392}, {1605, 531}, {1857, 617}, {1930, 498},
    {1772, 442}, {1827, 343}, {1899, 206}, {1946, 392}, {2118, 455}, {2004, 664}, {2066, 570}, {2216, 626}, {2296, 536}, {2360, 649},
    {2435, 573}, {2498, 472}, {2307, 388}, {2473, 325}, {2224, 417}, {2162, 301}, {2044, 338}, {2096, 214}, {2028, 230}, {1995, 180}, {2351, 238}
  };
  --[1] - направление (магнитная стрелка), [2] - следующая точка
  private.connections = { 
    { {1, 2} }, { {1, 3}, {2, 1}, {4, 4}, {7, 23} }, { {2, 2} }, { {3, 2}, {7, 5} }, { {8, 4}, {6, 6} }, 
    { {5, 5}, {1, 7} }, { {2, 6}, {5, 8}, {7, 11} }, { {6, 7}, {2, 9} }, { {1, 8}, {4, 10} }, { {3, 9} },
    { {8, 7}, {5, 12}, {7, 15} }, { {6, 11}, {8, 13} }, { {7, 12}, {4, 14} }, { {3, 13} }, { {8, 11}, {7, 16}, {1, 18} }, 
    { {8, 15}, {2, 17} }, { {1, 16} }, { {2, 15}, {8, 19} }, { {7, 18}, {3, 20} }, { {4, 19}, {7, 21} },
    { {8, 20}, {7, 22}, {6, 30} }, { {1, 33} }, { {8, 2}, {1, 24} }, { {2, 23}, {7, 25} }, { {8, 24}, {2, 26} }, 
    { {1, 25}, {2, 27}, {5, 28} }, { {1, 26} }, { {6, 26}, {3, 29} }, { {4, 28}, {1, 30} }, { {2, 29}, {1, 31}, {5, 21} },
    { {2, 30}, {5, 32} }, { {6, 31} }, { {2, 22}, {6, 34}, {4, 39} }, { {5, 33}, {3, 37} }, {}, 
    { {6, 37}, {4, 38}, {3, 45} }, { {4, 34}, {5, 36} }, { {3, 36} }, { {3, 33} }, { {3, 41} }, 
    { {4, 40} }, { {4, 43}, {6, 45}, {1, 47} }, { {3, 42} }, {}, { {4, 36}, {5, 42} }, 
    { {5, 47}, {6, 48} }, { {2, 42}, {6, 46} }, { {5, 46}, {1, 49} }, { {5, 50} }, { {6, 49}, {2, 51} }, 
    { {1, 50}, {5, 52} }, { {5, 53}, {6, 51}, {1, 54} }, { {6, 52} }, { {2, 52}, {1, 55} }, { {2, 54}, {6, 57} }, 
    { {5, 57} }, { {6, 56}, {5, 55}, {1, 58} }, { {2, 57}, {5, 59} }, { {6, 58}, {1, 61} }, {}, 
    { {4, 59}, {5, 62} }, { {2, 63}, {6, 61} }, { {1, 62}, {5, 71} }, {}, { {3, 59}, {4, 66} }, 
    { {3, 65} }, { {5, 68} }, { {6, 67} }, { {4, 70} }, { {3, 69} }, {}
  };
  private.stage_pos = { 0, -832, -1626 };
  private.new_stage = { 22, 49, 71 };
  private.magnet_fall = { 4, 2 };
  
  private.move = false;
  private.old_point = 0;
  --------------------------------------------------------------------------------------------
  -- function get_wingedkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_wingedkey" ] = {
      type = "get",
      get_obj = "obj_key_wingedkey",
      room = "rm_entrancehall",
      zz = "mg_key",
      zz_gate = "gmg_entrancehall_key"
  };
  --------------------------------------------------------------------------------------------
  local get_wingedkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_wingedkey", "obj_key_wingedkey" );
  
  end;
  local get_wingedkey_end = function ()
  
    ObjDelete( "gfx_key_wingedkey" );
    ObjDelete( "spr_key_wingedkey_sh" );
  
  end;
  local get_wingedkey_loc = function ()
  
    ObjDelete( "gmg_entrancehall_key" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_wingedkey", get_wingedkey_inv );
  cmn.AddSubscriber( "get_wingedkey", get_wingedkey_end, private.room_objname );
  cmn.AddSubscriber( "get_wingedkey", get_wingedkey_loc, "rm_entrancehall" );

  --------------------------------------------------------------------------------------------
  -- function win_key () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_key" ] = {
    type = "win",
    room = "rm_entrancehall",
    zz = "mg_key",
    zz_gate = "gmg_entrancehall_key"
  };
  --------------------------------------------------------------------------------------------
  local win_key = function ()
    
    if cmn.IsEventDone( "win_key" ) then
      ObjDelete("spr_key_wingedkey");
      ObjMultiSet( { {"obj_key_wingedkey", { event_mup = mg_key.get_wingedkey, event_menter = function() cmn.ShowCursor( CURSOR_GET ); end }},
                     {"obj_key_magnets", { input = 0 }},
                     {"anm_key_win", { frame = 200 }},
                     {"spr_key_wingedkey_2", { alp = 1 }} } );
    end;

  end;
  local win_key_loc = function ()

    if cmn.IsEventDone( "win_key" ) then
      ObjSet("obj_entrancehall_magnets",  { pos_x = 72, pos_y = 32 });
      ObjDelete("spr_entrancehall_tank_magnet_2");
      ObjDelete("spr_entrancehall_tank_magnet_4");
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_key", win_key, "mg_key" );
  cmn.AddSubscriber( "win_key", win_key_loc, "rm_entrancehall" );
  
end;
--*********************************************************************************************************************
function public.Load()

  if ng_global.currentprogress == "std" and not ng_global.progress[ ng_global.currentprogress ][ "win_key" ].state then
    private.StartConditions();
  elseif ng_global.currentprogress == "secret" then
    private.StartConditions();  
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_key" ].state;

end;
--*********************************************************************************************************************
function public.Open() 
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_mg_mus_env", 1);

  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_key" )) then
    cmn.MiniGameShow();
    cmn.StartTimePassing("mg_key");
  elseif ng_global.currentprogress == "secret" then 
    rm_extra.MiniGameShow();
  end;
  
  if ng_global.currentprogress == "std" and not cmn.IsEventDone("opn_key") then
    cmn.SetEventDone("opn_key");
    ObjAnimate("mg_key", "scale_xy", 0, 0, function() cmn.Lock(0); end, { 0, 0, 1, 1,   0.7, 0, 1.5, 1.5,   1.5, 0, 1.5, 1.5,    2.2, 0, 1, 1 });
    ObjAnimate("mg_key", "pos_xy", 0, 0, "", { 0, 0, 0, 0,   0.7, 0, 86, -385,   1.5, 0, 86, -385,    2.2, 0, 0, 0 });
    ObjAnimate("obj_key_wingedkey", "ang", 0, 0, "", { 0, 0, 0,   0.6, 0, 0,   0.7, 0, -0.1,   0.9, 0, 0.1,  1.1, 0, -0.1,   1.3, 0, 0.1,   1.5, 0, 0 });
  else 
    private.CheckWin();
  end;
    
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/aud_entrancehall_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/aud_entrancehall_env");

  if ng_global.currentprogress == "std" then
    common.SetPreviousRoom( "rm_entrancehall" );
  else 
    
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_key" ].state;
    
    ObjSet("grm_key_entrancehall",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                      event_menter = function () rm_extra.GateMouseEnter( "key_entrancehall", CURSOR_DOWN, "extra" ); end, 
                                      event_mleave = function () common_impl.GateMouseLeave( "key_entrancehall" ); end });
                                     
  end;
    
  private.DrawScene();
  
  if ng_global.currentprogress == "std" and not cmn.IsEventDone("opn_key") then
    cmn.Lock( 1 );
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  
  cmn.StopAllMus();
  if ng_global.currentprogress == "std" then
    common_impl.PlayBackgroundMusic();
  end;

  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_key" )) then
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_key" )) then
    rm_extra.MiniGameHide();
  end;
  
  if ng_global.currentprogress == "secret" then
    ObjMultiSet( { {"grm_key_entrancehall", { input = 0 }},
                   {"obj_key_wingedkey", { input = 0 }} } );
  end;
  
end;
--*********************************************************************************************************************
function public.Reset()
  
  if private.state[2] > 1 then
    
    cmn.Lock(1);
    
    private.StartConditions();
    
    local tme = 0.5;
  
    local set_key = function ()
      ObjSet("obj_key_wingedkey",  { pos_x = private.key_points[1][1], pos_y = private.key_points[1][2] });
      ObjAnimate("obj_key_wingedkey", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    end;
    
    ObjAnimate("obj_key_wingedkey", "alp", 0, 0, set_key, { 0, 0, 1,   0.5, 0, 0 });
    
    if private.state[1] > 1 then
      
      tme = (private.state[1]-1)*2;
      ObjAnimate("obj_key_back", "pos_x", 0, 0, "", { 0, 0, private.stage_pos[ private.state[1] ],   tme, 0, private.stage_pos[1] });
      ObjAnimate("obj_key_magnet_"..private.magnet_fall[1], "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
      if private.state[1] == 3 then
        ObjAnimate("obj_key_magnet_"..private.magnet_fall[2], "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
        ObjAnimate("obj_key_magnets", "pos_x", 0, 0, "", { 0, 0, -107,   tme, 0, 0 });
      end;
      
    end;
    
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_key" ].state;
    ObjSet("tmr_key_timer",  { time = tme, playing = 1, endtrig = function() private.DrawScene(); cmn.Lock(0); end; });
    
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  
  cmn.Lock(1);
  
  ng_global.progress[ ng_global.currentprogress ][ "win_key" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_key" ].state = { 3, 71 };
  
  local tme = 0.5;
  
  local set_key = function ()
    ObjSet("obj_key_wingedkey",  { pos_x = private.key_points[71][1], pos_y = private.key_points[71][2] });
    ObjAnimate("obj_key_wingedkey", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
  end;
  
  ObjAnimate("obj_key_wingedkey", "alp", 0, 0, set_key, { 0, 0, 1,   0.5, 0, 0 });
  
  if private.state[1] < 3 then
    
    tme = (3-private.state[1])*2;
    ObjAnimate("obj_key_back", "pos_x", 0, 0, "", { 0, 0, private.stage_pos[ private.state[1] ],   tme, 0, private.stage_pos[3] });
    ObjAnimate("obj_key_magnets", "pos_x", 0, 0, "", { 0, 0, 0,   tme, 0, -107 });
    
  end;
  
  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_key" ].state;
  ObjSet("tmr_key_timer",  { time = tme, playing = 1, endtrig = private.Win });

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_wingedkey()

  cmn.SetEventDone( "get_wingedkey" );
  cmn.CallEventHandler( "get_wingedkey" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  cmn.GotoRoom("rm_entrancehall");

end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_key" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_key" ].state = { 1, 1 }; --[1] - этап, [2] - точка, где находится ключ

end;
-----------------------------------------------------------------------------------
function private.DrawScene()
  
  ObjMultiSet( { {"obj_key_back", { pos_x = private.stage_pos[ private.state[1] ] }},
                 {"obj_key_wingedkey", { pos_x = private.key_points[ private.state[2] ][1], pos_y = private.key_points[ private.state[2] ][2] }},
                 {"obj_key_wingedkey_arrows", { pos_x = private.key_points[ private.state[2] ][1], pos_y = private.key_points[ private.state[2] ][2] }} } );
                 
  if private.state[1] == 2 then
    ObjSet("obj_key_magnet_"..private.magnet_fall[1],  { alp = 0, input = 0 });
  elseif private.state[1] == 3 then
    ObjMultiSet( { {"obj_key_magnet_"..private.magnet_fall[1], { alp = 0, input = 0 }},
                   {"obj_key_magnet_"..private.magnet_fall[2], { alp = 0, input = 0 }} } );
  else
    ObjMultiSet( { {"obj_key_magnet_"..private.magnet_fall[1], { alp = 1, input = 1 }},
                   {"obj_key_magnet_"..private.magnet_fall[2], { alp = 1, input = 1 }} } );
  end;
                 
  if private.state[1] == 3 then
    ObjSet("obj_key_magnets",  { pos_x = -107 });
  else 
    ObjSet("obj_key_magnets",  { pos_x = 0 });
  end;
  
  if ng_global.currentprogress == "secret" then
    ObjMultiSet( { {"spr_key_wingedkey_2", { alp = 0 }},
                   {"obj_key_wingedkey", { input = 1 }},
                   {"spr_key_wingedkey", { alp = 1 }} } );
  end;

end;
-----------------------------------------------------------------------------------
function public.SetMagnetsPreLoc()
  
  if private.state[1] == 2 then
    ObjMultiSet( { {"spr_entrancehall_tank_magnet_4", { alp = 0 }},
                   {"obj_entrancehall_magnets", { pos_x = 36, pos_y = 10 }} } );
  elseif private.state[1] == 3 then
    ObjMultiSet( { {"spr_entrancehall_tank_magnet_4", { alp = 0 }},
                   {"spr_entrancehall_tank_magnet_2", { alp = 0 }},
                   {"obj_entrancehall_magnets", { pos_x = 72, pos_y = 32 }} } );
  else 
    ObjMultiSet( { {"spr_entrancehall_tank_magnet_4", { alp = 1 }},
                   {"spr_entrancehall_tank_magnet_2", { alp = 1 }},
                   {"obj_entrancehall_magnets", { pos_x = 0, pos_y = 0 }} } );
  end;
                   
end;
-----------------------------------------------------------------------------------
function public.FocusArrow( arrow, inout )
  
  local obj = "spr_key_arrow_"..arrow.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;
  local new_point = private.CheckDirection( arrow );

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.13 then
      cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_menter1");
    end;
  end;
  
  if private.move then
    
    local t = private.old_point;
    
    if new_point == 71 then
      t = 63;
    end;
    
    for i = 1, #private.connections[ t ], 1 do
    
      if private.connections[ t ][i][1] == arrow then
        new_point = private.connections[ t ][i][2];
        break;
      end;
      
    end;
    
  end;
  
  if new_point > 0 then
    ObjAnimate("spr_key_wingedkey_arrow_"..arrow.."_right", "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  else 
    ObjAnimate("spr_key_wingedkey_arrow_"..arrow.."_wrong", "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  end;
    
  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.ClickArrow( dir )
  
  private.move = true;
  private.old_point = private.state[2];
  
  cmn.Lock(1);
  
  local new_point = private.CheckDirection( dir );
  
  --availible direction - move key
  if new_point > 0 then
    
    cmn.PlayAudio("snd", "assets/levels/level1/mg_key/audio/aud_click1");
    
    local point_a, point_b = {}, {};
    point_a[1] = private.key_points[ private.state[2] ][1];
    point_a[2] = private.key_points[ private.state[2] ][2];
    private.state[2] = new_point;
    point_b[1] = private.key_points[ private.state[2] ][1];
    point_b[2] = private.key_points[ private.state[2] ][2];
    local len = common_impl.math.FindSegmentLength( point_a, point_b );
    local tme = 0.005 * len;
    
    ObjAnimate("obj_key_wingedkey", "ang", 0, 0, "", { 0, 0, 0,   tme/3, 0, -0.1,   tme/3*2, 0, 0.1,  tme, 0, 0 });
    ObjAnimate("obj_key_wingedkey", "pos_xy", 0, 0, function() private.CheckWin(); cmn.PlayAudio("snd", "assets/levels/level1/mg_key/audio/aud_click2"); end, { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] });
    ObjAnimate("obj_key_wingedkey_arrows", "pos_xy", 0, 0, "", { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] });
  
  --unavailible direction - shake key
  else 
  
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_wrong_apply");
    
    ObjAnimate("obj_key_wingedkey", "ang", 0, 0, function() cmn.Lock(0); private.move = false; end, { 0, 0, 0,   0.2, 0, -0.1,   0.4, 0, 0.1,  0.6, 0, 0 });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.CheckDirection( dir )
  
  local new_point = 0;
  
  for i = 1, #private.connections[ private.state[2] ], 1 do
    
    if private.connections[ private.state[2] ][i][1] == dir then
      new_point = private.connections[ private.state[2] ][i][2];
      break;
    end;
    
  end;
  
  return new_point;
  
end;
-----------------------------------------------------------------------------------
function private.CheckWin()
  
  private.move = false;
  private.old_point = 0;
  
  --пришли в нужной для перехода далее узел
  if private.state[2] == private.new_stage[ private.state[1] ] then
    
    if private.state[1] < 3 then
      
      cmn.PlayAudio("snd", "assets/levels/level1/mg_key/audio/aud_move_magnet");
      
      private.state[1] = private.state[1] + 1;
      
      local set_magnet = function ()
        ObjSet("obj_key_magnet_"..private.magnet_fall[ private.state[1]-1 ],  { alp = 0, input = 0, pos_y = 0 });
      end;
      
      ObjAnimate("obj_key_magnet_"..private.magnet_fall[ private.state[1]-1 ], "pos_y", 0, 0, set_magnet, { 0, 1, 0,     1, 1, 0,     2, 1, 840  });
      ObjAnimate("spr_key_magnet_"..private.magnet_fall[ private.state[1]-1 ], "ang", 0, 0, "", { 0, 0, 0,   0.2, 0, -0.1,   0.4, 0, 0.1,  0.6, 0, 0,   0.8, 0, -0.1,  1.2, 0, 0.1,   1.4, 0, 0  });
      ObjAnimate("spr_key_magnet_"..private.magnet_fall[ private.state[1]-1 ].."_sh", "ang", 0, 0, "", { 0, 0, 0,   0.2, 0, -0.1,   0.4, 0, 0.1,  0.6, 0, 0,   0.8, 0, -0.1,  1.2, 0, 0.1,   1.4, 0, 0  });
      
      ObjAnimate("obj_key_back", "pos_x", 0, 0, function() cmn.Lock(0); end, { 0, 0, private.stage_pos[ private.state[1]-1 ],   2, 0, private.stage_pos[ private.state[1] ] });
        
      if private.state[1] == 3 then
        ObjAnimate("obj_key_magnets", "pos_x", 0, 0, "", { 0, 0, 0,   2, 0, -107 });
      end;
      
    else 
      
      private.Win();

    end;
      
  else 
    
    cmn.Lock(0);
      
  end;

end;
-----------------------------------------------------------------------------------
function private.WinEnd()
  
  cmn.Lock(0);

  cmn.SetEventDone( "win_key" );
  
  if ng_global.currentprogress == "std" then
  
    cmn.CallEventHandler( "win_key" );

    if ng_global.progress[ ng_global.currentprogress ][ "win_key" ].skip == 0 and not ng_global.noskipgames[ "win_key" ] then

      ng_global.noskipgames[ "win_key" ] = 1;
      common_impl.CheckAchiev("mg");

    end;
    
    if ng_global.playedgames and not ng_global.playedgames[ "win_key" ] then
      ng_global.playedgames[ "win_key" ] = 1;
    end;


    common_impl.PauseAchiev( 0 );
    
  else 
    
    interface_impl.ShowStarsWindow();
    
  end;

end;
-----------------------------------------------------------------------------------
function private.Win()
  
  cmn.Lock(1);
  
  if ng_global.currentprogress == "std" then

    cmn.MiniGameHide();
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_win_mg");

    common_impl.PauseAchiev( 1 );
    cmn.EndTimePassing( "mg_key" );
    
  else 
    
    ObjSet("obj_key_wingedkey",  { input = 0 });
    rm_extra.MiniGameHide();
    int_dialog_secretroom.StopTimer();
    
  end;

  ObjMultiSet( { {"anm_key_win",  { playing = 1, endtrig = private.WinEnd }},
                 {"spr_key_wingedkey_2", { alp = 1 }},
                 {"spr_key_wingedkey", { alp = 0 }} } );

end;
--********************************************************************************************************************