-- name=inventory1
--*********************************************************************************************************************
function public.Init()
  
  if port.isPortable() == 1 then
    port.InventoryPopupInit("inventory1_hub");
    port.VideoResizeInRoom("inventory1");
  end;
  
  if port.ios_lang() == "ja" then
    ObjSet("txt_complex_folder_name",{ fontsize = 14 });
    ObjSet("txt_complex_folder_name_closed",{ fontsize = 12 });
    ObjSet("txt_complex_folder_name_2",{ fontsize = 14 });
    ObjSet("txt_complex_folder_case_name_desc",{ fontsize = 10 });
  end;
  
  if port.ios_lang() == "ru" then
    ObjSet("txt_complex_folder_name",{ fontsize = 18 });
    ObjSet("txt_complex_folder_name_closed",{ fontsize = 16 });
    ObjSet("txt_complex_folder_text_closed",{ fontsize = 8 });
  end;
  
  private.Init_Brokenscoopnet();
  --------------------------------------------------------------------------------------------
  -- function get_scoopnet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_scoopnet" ] = {

      type = "get",
      get_obj = "spr_complex_brokenscoopnet_scoopnet",
      room = "int_complex_inv",
      zz = "inv_complex_brokenscoopnet",
      zz_gate = "inv_brokenscoopnet"
  };
  --------------------------------------------------------------------------------------------
  local get_scoopnet_inv = function ()

    interface.InventoryItemRemove( "inv_brokenscoopnet" );
    interface.InventoryItemAdd( "inv_scoopnet", "spr_complex_brokenscoopnet_scoopnet" );

    ObjDelete("obj_complex_brokenscoopnet_scoopnet");
    ObjDelete("obj_complex_brokenscoopnet_scoopnet_get");

  end;
  cmn.AddSubscriber( "get_scoopnet", get_scoopnet_inv );
  --------------------------------------------------------------------------------------------
  -- function get_broomamulet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_broomamulet" ] = {

      type = "get",
      get_obj = "spr_complex_diary_broomamulet",
      room = "int_complex_inv",
      zz = "inv_complex_diary",
      zz_gate = "inv_diary"
  };
  --------------------------------------------------------------------------------------------
  local get_broomamulet_inv = function ()

    if cmn.IsEventDone("get_magicpagepiece3") then
      interface.InventoryItemRemove( "inv_diary" );
    end;
    
    interface.InventoryItemAdd( "inv_broomamulet", "spr_complex_diary_broomamulet" );

    ObjDelete("gfx_complex_diary_broomamulet");
    ObjDelete("spr_complex_diary_broomamulet_sh");
    ObjDelete("spr_complex_diary_broomamulet_sh_2");

  end;
  cmn.AddSubscriber( "get_broomamulet", get_broomamulet_inv );
  --------------------------------------------------------------------------------------------
  -- function get_magicpagepiece3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_magicpagepiece3" ] = {

      type = "get",
      get_obj = "spr_complex_diary_magicpagepiece3",
      room = "int_complex_inv",
      zz = "inv_complex_diary",
      zz_gate = "inv_diary"
  };
  --------------------------------------------------------------------------------------------
  local get_magicpagepiece3_inv = function ()

    if cmn.IsEventDone("get_broomamulet") then
      interface.InventoryItemRemove( "inv_diary" );
    end;
    
    interface.InventoryItemAdd( "inv_magicpagepiece", "spr_complex_diary_magicpagepiece3", function () cmn.GetMultyObject( 'magicpagepiece', 4 ); end );

    ObjDelete("gfx_complex_diary_magicpagepiece3");
    ObjDelete("spr_complex_diary_magicpagepiece3_sh");

  end;
  cmn.AddSubscriber( "get_magicpagepiece3", get_magicpagepiece3_inv );
  --------------------------------------------------------------------------------------------
  -- function get_closetroom () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_closetroom" ] = {

      type = "get",
      get_obj = "spr_complex_folder_closetroom",
      room = "int_complex_inv",
      zz = "inv_complex_folder",
      zz_gate = "inv_folder"
  };
  --------------------------------------------------------------------------------------------
  local get_closetroom_inv = function ()

    if cmn.IsEventDone("get_pencil") then
      interface.InventoryItemRemove( "inv_folder" );
    end;
    
    interface.InventoryItemAdd( "inv_closetroom", "spr_complex_folder_closetroom" );

    ObjDelete("gfx_complex_folder_closetroom");
    ObjDelete("spr_complex_folder_closetroom_sh");

  end;
  cmn.AddSubscriber( "get_closetroom", get_closetroom_inv );
  --------------------------------------------------------------------------------------------
  -- function get_pencil () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_pencil" ] = {

      type = "get",
      get_obj = "spr_complex_folder_pencil",
      room = "int_complex_inv",
      zz = "inv_complex_folder",
      zz_gate = "inv_folder"
  };
  --------------------------------------------------------------------------------------------
  local get_pencil_inv = function ()

    if cmn.IsEventDone("get_closetroom") then
      interface.InventoryItemRemove( "inv_folder" );
    end;
    
    interface.InventoryItemAdd( "inv_pencil", "spr_complex_folder_pencil" );

    ObjDelete("gfx_complex_folder_pencil");
    ObjDelete("spr_complex_folder_pencil_sh");

  end;
  cmn.AddSubscriber( "get_pencil", get_pencil_inv );
  --------------------------------------------------------------------------------------------
  -- function get_lovesymbol () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lovesymbol" ] = {

      type = "get",
      get_obj = "spr_complex_heartmedallion_lovesymbol",
      room = "int_complex_inv",
      zz = "inv_complex_heartmedallion",
      zz_gate = "inv_heartmedallion"
  };
  --------------------------------------------------------------------------------------------
  local get_lovesymbol_inv = function ()

    interface.InventoryItemRemove( "inv_heartmedallion" );
    interface.InventoryItemAdd( "inv_lovesymbol", "spr_complex_heartmedallion_lovesymbol" );

    ObjDelete("gfx_complex_heartmedallion_lovesymbol");

  end;
  cmn.AddSubscriber( "get_lovesymbol", get_lovesymbol_inv );
  --------------------------------------------------------------------------------------------
  -- function get_laceandhook () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_laceandhook" ] = {

      type = "get",
      get_obj = "spr_complex_line_laceandhook",
      room = "int_complex_inv",
      zz = "inv_complex_line",
      zz_gate = "inv_line"
  };
  --------------------------------------------------------------------------------------------
  local get_laceandhook_inv = function ()

    interface.InventoryItemRemove( "inv_line" );
    interface.InventoryItemAdd( "inv_laceandhook", "obj_complex_line_laceandhook" );
    
    ObjSet("inv_stick_star_light",  { alp = 1 });

    ObjDelete("gfx_complex_line_laceandhook");

  end;
  cmn.AddSubscriber( "get_laceandhook", get_laceandhook_inv );
  -------------------------------------------------------------------------------------------
  -- function get_beanwrapping () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_beanwrapping" ] = {

      type = "get",
      get_obj = "spr_complex_note_beanwrapping",
      room = "int_complex_inv",
      zz = "inv_complex_note",
      zz_gate = "inv_note"
  };
  --------------------------------------------------------------------------------------------
  local get_beanwrapping_inv = function ()

    if cmn.IsEventDone("get_mosaicpart2") and cmn.IsEventDone("get_silverring") then
      interface.InventoryItemRemove( "inv_note" );
    end;
    
    interface.InventoryItemAdd( "inv_beanwrapping", "spr_complex_note_beanwrapping" );

    ObjDelete("gfx_complex_note_beanwrapping");
    ObjDelete("spr_complex_note_beanwrapping_shadow");

  end;
  cmn.AddSubscriber( "get_beanwrapping", get_beanwrapping_inv );
  -------------------------------------------------------------------------------------------
  -- function get_mosaicpart2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_mosaicpart2" ] = {

      type = "get",
      get_obj = "spr_complex_note_mosaicpart2",
      room = "int_complex_inv",
      zz = "inv_complex_note",
      zz_gate = "inv_note"
  };
  --------------------------------------------------------------------------------------------
  local get_mosaicpart2_inv = function ()

    if cmn.IsEventDone("get_beanwrapping") and cmn.IsEventDone("get_silverring") then
      interface.InventoryItemRemove( "inv_note" );
    end;
    
    interface.InventoryItemAdd( "inv_mosaicpart", "spr_complex_note_mosaicpart2", function () cmn.GetMultyObject( 'mosaicpart', 3 ); end );

    ObjDelete("gfx_complex_note_mosaicpart2");
    ObjDelete("spr_complex_note_mosaicpart2_shadow");

  end;
  cmn.AddSubscriber( "get_mosaicpart2", get_mosaicpart2_inv );
  -------------------------------------------------------------------------------------------
  -- function get_silverring () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_silverring" ] = {

      type = "get",
      get_obj = "spr_complex_note_silverring",
      room = "int_complex_inv",
      zz = "inv_complex_note",
      zz_gate = "inv_note"
  };
  --------------------------------------------------------------------------------------------
  local get_silverring_inv = function ()

    if cmn.IsEventDone("get_beanwrapping") and cmn.IsEventDone("get_mosaicpart2") then
      interface.InventoryItemRemove( "inv_note" );
    end;
    
    interface.InventoryItemAdd( "inv_silverring", "spr_complex_note_silverring" );

    ObjDelete("gfx_complex_note_silverring");
    ObjDelete("spr_complex_note_silverring_shadow");

  end;
  cmn.AddSubscriber( "get_silverring", get_silverring_inv );
  --------------------------------------------------------------------------------------------
  -- function get_gem () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_gem" ] = {

      type = "get",
      get_obj = "spr_complex_purse_gem",
      room = "int_complex_inv",
      zz = "inv_complex_purse",
      zz_gate = "inv_purse"
  };
  --------------------------------------------------------------------------------------------
  local get_gem_inv = function ()

    if cmn.IsEventDone("get_hintletter") then
      interface.InventoryItemRemove( "inv_purse" );
    end;
    
    interface.InventoryItemAdd( "inv_gem", "spr_complex_purse_gem" );
    ObjSet("inv_heartmedallion_star_light",  { alp = 1 });

    ObjDelete("gfx_complex_purse_gem");
    ObjDelete("spr_complex_purse_gem_sh");

  end;
  cmn.AddSubscriber( "get_gem", get_gem_inv );
  --------------------------------------------------------------------------------------------
  -- function get_hintletter () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_hintletter" ] = {

      type = "get",
      get_obj = "spr_complex_purse_hintletter",
      room = "int_complex_inv",
      zz = "inv_complex_purse",
      zz_gate = "inv_purse"
  };
  --------------------------------------------------------------------------------------------
  local get_hintletter_inv = function ()

    if cmn.IsEventDone("get_gem") then
      interface.InventoryItemRemove( "inv_purse" );
    end;
    
    interface.InventoryItemAdd( "inv_hintletter", "spr_complex_purse_hintletter" );

    ObjDelete("gfx_complex_purse_hintletter");
    ObjDelete("spr_complex_purse_hintletter_sh");

  end;
  cmn.AddSubscriber( "get_hintletter", get_hintletter_inv );
  --------------------------------------------------------------------------------------------
  -- function get_gnomehat () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_gnomehat" ] = {

      type = "get",
      get_obj = "spr_complex_secretparcel_gnomehat",
      room = "int_complex_inv",
      zz = "inv_complex_secretparcel",
      zz_gate = "inv_secretparcel"
  };
  --------------------------------------------------------------------------------------------
  local get_gnomehat_inv = function ()

    if cmn.IsEventDone("get_goldenbone") then
      interface.InventoryItemRemove( "inv_secretparcel" );
    end;
    
    interface.InventoryItemAdd( "inv_gnomehat", "spr_complex_secretparcel_gnomehat" );

    ObjDelete("gfx_complex_secretparcel_gnomehat");
    ObjDelete("spr_complex_secretparcel_gnomehat_shadow");

  end;
  cmn.AddSubscriber( "get_gnomehat", get_gnomehat_inv );
  --------------------------------------------------------------------------------------------
  -- function get_goldenbone () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_goldenbone" ] = {

      type = "get",
      get_obj = "spr_complex_secretparcel_goldenbone",
      room = "int_complex_inv",
      zz = "inv_complex_secretparcel",
      zz_gate = "inv_secretparcel"
  };
  --------------------------------------------------------------------------------------------
  local get_goldenbone_inv = function ()

    if cmn.IsEventDone("get_gnomehat") then
      interface.InventoryItemRemove( "inv_secretparcel" );
    end;
    
    interface.InventoryItemAdd( "inv_goldenbone", "spr_complex_secretparcel_goldenbone" );

    ObjDelete("gfx_complex_secretparcel_goldenbone");
    ObjDelete("spr_complex_secretparcel_bone_shadow");

  end;
  cmn.AddSubscriber( "get_goldenbone", get_goldenbone_inv );
  --------------------------------------------------------------------------------------------
  -- function get_fishingrod () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_fishingrod" ] = {

      type = "get",
      get_obj = "spr_complex_stick_fishingrod",
      room = "int_complex_inv",
      zz = "inv_complex_stick",
      zz_gate = "inv_stick"
  };
  --------------------------------------------------------------------------------------------
  local get_fishingrod_inv = function ()

    interface.InventoryItemRemove( "inv_stick" );
    interface.InventoryItemAdd( "inv_fishingrod", "spr_complex_stick_fishingrod" );

    ObjDelete("gfx_complex_stick_fishingrod");

  end;
  cmn.AddSubscriber( "get_fishingrod", get_fishingrod_inv );
  
  --------------------------------------------------------------------------------------------
  -- function use_scissors () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_scissors" ] = {

      type = "use",
      inv_obj = "inv_scissors",
      use_place = "obj_complex_brokenscoopnet_use_scissors",
      room = "int_complex_inv",
      zz = "inv_complex_brokenscoopnet",
      zz_gate = "inv_brokenscoopnet"
  };
  --------------------------------------------------------------------------------------------
  local use_scissors_inv = function ()

    interface.InventoryItemRemove( "inv_scissors" );

    if not cmn.IsEventDone("get_yarnspindle") then
      ObjSet("inv_brokenscoopnet_star_light",  { alp = 0 });
    end;

  end;
  local use_scissors_beg = function ()

    if cmn.IsEventDone("use_yarnspindle") then
      ObjDelete( "obj_complex_brokenscoopnet_use_scissors" );
    end;

  end;
  local use_scissors_end = function ()

    if cmn.IsEventDone("use_yarnspindle") then
      ObjMultiSet( { {"obj_complex_brokenscoopnet_game", { alp = 1, input = 1 }},
                     {"spr_complex_brokenscoopnet_handle", { alp = 1 }} } );
      ObjDelete( "obj_complex_brokenscoopnet_tools" );
      ObjDelete( "anm_complex_brokenscoopnet_touch" );
    else 
      ObjSet( "spr_complex_brokenscoopnet_scissors", { alp = 1 } );
    end;

  end;
  cmn.AddSubscriber( "use_scissors", use_scissors_inv );
  cmn.AddSubscriber( "use_scissors", use_scissors_beg, "inv_complex_brokenscoopnet" );
  cmn.AddSubscriber( "use_scissors", use_scissors_end, "inv_complex_brokenscoopnet" );
  cmn.AddSubscriber( "use_scissors_inv", use_scissors_inv );
  cmn.AddSubscriber( "use_scissors_beg", use_scissors_beg, "inv_complex_brokenscoopnet" );
  cmn.AddSubscriber( "use_scissors_end", use_scissors_end, "inv_complex_brokenscoopnet" );
  --------------------------------------------------------------------------------------------
  -- function use_yarnspindle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_yarnspindle" ] = {

      type = "use",
      inv_obj = "inv_yarnspindle",
      use_place = "obj_complex_brokenscoopnet_use_scissors",
      room = "int_complex_inv",
      zz = "inv_complex_brokenscoopnet",
      zz_gate = "inv_brokenscoopnet"
  };
  --------------------------------------------------------------------------------------------
  local use_yarnspindle_inv = function ()

    interface.InventoryItemRemove( "inv_yarnspindle" );

    if not cmn.IsEventDone("get_scissors") then
      ObjSet("inv_brokenscoopnet_star_light",  { alp = 0 });
    end;

  end;
  local use_yarnspindle_beg = function ()

    if cmn.IsEventDone("use_scissors") then
      ObjDelete( "obj_complex_brokenscoopnet_use_scissors" );
    end;

  end;
  local use_yarnspindle_end = function ()

    if cmn.IsEventDone("use_scissors") then
      ObjMultiSet( { {"obj_complex_brokenscoopnet_game", { alp = 1, input = 1 }},
                     {"spr_complex_brokenscoopnet_handle", { alp = 1 }} } );
      ObjDelete( "obj_complex_brokenscoopnet_tools" );
      ObjDelete( "anm_complex_brokenscoopnet_touch" );
    else 
      ObjSet( "spr_complex_brokenscoopnet_yarn", { alp = 1 } );
    end;

  end;
  cmn.AddSubscriber( "use_yarnspindle", use_yarnspindle_inv );
  cmn.AddSubscriber( "use_yarnspindle", use_yarnspindle_beg, "inv_complex_brokenscoopnet" );
  cmn.AddSubscriber( "use_yarnspindle", use_yarnspindle_end, "inv_complex_brokenscoopnet" );
  cmn.AddSubscriber( "use_yarnspindle_inv", use_yarnspindle_inv );
  cmn.AddSubscriber( "use_yarnspindle_beg", use_yarnspindle_beg, "inv_complex_brokenscoopnet" );
  cmn.AddSubscriber( "use_yarnspindle_end", use_yarnspindle_end, "inv_complex_brokenscoopnet" );
  --------------------------------------------------------------------------------------------
  -- function use_lettera () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lettera" ] = {

      type = "use",
      inv_obj = "inv_lettera",
      use_place = "obj_complex_diary_use_lettera",
      room = "int_complex_inv",
      zz = "inv_complex_diary",
      zz_gate = "inv_diary"
  };
  --------------------------------------------------------------------------------------------
  local use_lettera_inv = function ()

    interface.InventoryItemRemove( "inv_lettera" );

  end;
  local use_lettera_beg = function ()

    ObjDelete( "obj_complex_diary_use_lettera" );

  end;
  local use_lettera_end = function ()

    ObjSet("obj_complex_diary_open",  { alp = 1, input = 1 });
    
    ObjDelete( "anm_complex_diary_touch" );

  end;
  cmn.AddSubscriber( "use_lettera", use_lettera_inv );
  cmn.AddSubscriber( "use_lettera", use_lettera_beg, "inv_complex_diary" );
  cmn.AddSubscriber( "use_lettera", use_lettera_end, "inv_complex_diary" );
  cmn.AddSubscriber( "use_lettera_inv", use_lettera_inv );
  cmn.AddSubscriber( "use_lettera_beg", use_lettera_beg, "inv_complex_diary" );
  cmn.AddSubscriber( "use_lettera_end", use_lettera_end, "inv_complex_diary" );
  --------------------------------------------------------------------------------------------
  -- function use_hook () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hook" ] = {

      type = "use",
      inv_obj = "inv_hook",
      use_place = "obj_complex_line_use_hook",
      room = "int_complex_inv",
      zz = "inv_complex_line",
      zz_gate = "inv_line"
  };
  --------------------------------------------------------------------------------------------
  local use_hook_inv = function ()

    interface.InventoryItemRemove( "inv_hook" );

  end;
  local use_hook_beg = function ()

    ObjDelete( "obj_complex_line_use_hook" );

  end;
  local use_hook_end = function ()

    ObjMultiSet( { {"spr_complex_line_laceandhook", { input = 1 }},
                   {"spr_complex_line_hook_line", { alp = 1 }},
                   {"spr_complex_line_hook", { alp = 1 }} } );

  end;
  cmn.AddSubscriber( "use_hook", use_hook_inv );
  cmn.AddSubscriber( "use_hook", use_hook_beg, "inv_complex_line" );
  cmn.AddSubscriber( "use_hook", use_hook_end, "inv_complex_line" );
  cmn.AddSubscriber( "use_hook_inv", use_hook_inv );
  cmn.AddSubscriber( "use_hook_beg", use_hook_beg, "inv_complex_line" );
  cmn.AddSubscriber( "use_hook_end", use_hook_end, "inv_complex_line" );
  --------------------------------------------------------------------------------------------
  -- function use_gem () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_gem" ] = {

      type = "use",
      inv_obj = "inv_gem",
      use_place = "obj_complex_heartmedallion_use_gem",
      room = "int_complex_inv",
      zz = "inv_complex_heartmedallion",
      zz_gate = "inv_heartmedallion"
  };
  --------------------------------------------------------------------------------------------
  local use_gem_inv = function ()

    interface.InventoryItemRemove( "inv_gem" );

    if (not cmn.IsEventDone("get_wings") or cmn.IsEventDone("use_wings")) and 
       (not cmn.IsEventDone("get_rubyheart") or cmn.IsEventDone("use_rubyheart")) and
        not(cmn.IsEventDone("use_wings") and cmn.IsEventDone("use_rubyheart"))  then
      ObjSet("inv_heartmedallion_star_light",  { alp = 0 });
    end;

  end;
  local use_gem_beg = function ()

    ObjDelete( "obj_complex_heartmedallion_use_gem" );

  end;
  local use_gem_end = function ()
    
    ObjSet("spr_complex_heartmedallion_gem",  { alp = 1 });

    if cmn.IsEventDone("use_wings") and cmn.IsEventDone("use_rubyheart") then
      ObjMultiSet( { {"spr_complex_heartmedallion_lovesymbol", { alp = 1, input = 1 }},
                     {"anm_complex_heartmedallion_use_wings", { alp = 1, frame = 300 }} } );
      ObjDelete( "anm_complex_heartmedallion_wings" );
    end;

  end;
  cmn.AddSubscriber( "use_gem", use_gem_inv );
  cmn.AddSubscriber( "use_gem", use_gem_beg, "inv_complex_heartmedallion" );
  cmn.AddSubscriber( "use_gem", use_gem_end, "inv_complex_heartmedallion" );
  cmn.AddSubscriber( "use_gem_inv", use_gem_inv );
  cmn.AddSubscriber( "use_gem_beg", use_gem_beg, "inv_complex_heartmedallion" );
  cmn.AddSubscriber( "use_gem_end", use_gem_end, "inv_complex_heartmedallion" );
  --------------------------------------------------------------------------------------------
  -- function use_wings () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_wings" ] = {

      type = "use",
      inv_obj = "inv_wings",
      use_place = "obj_complex_heartmedallion_use_wings",
      room = "int_complex_inv",
      zz = "inv_complex_heartmedallion",
      zz_gate = "inv_heartmedallion"
  };
  --------------------------------------------------------------------------------------------
  local use_wings_inv = function ()

    interface.InventoryItemRemove( "inv_wings" );

    if (not cmn.IsEventDone("get_gem") or cmn.IsEventDone("use_gem")) and 
       (not cmn.IsEventDone("get_rubyheart") or cmn.IsEventDone("use_rubyheart")) and
        not(cmn.IsEventDone("use_gem") and cmn.IsEventDone("use_rubyheart"))  then
      ObjSet("inv_heartmedallion_star_light",  { alp = 0 });
    end;

  end;
  local use_wings_beg = function ()

    ObjDelete( "obj_complex_heartmedallion_use_wings" );

  end;
  local use_wings_end = function ()

    if cmn.IsEventDone("use_gem") and cmn.IsEventDone("use_rubyheart") then
      ObjMultiSet( { {"spr_complex_heartmedallion_lovesymbol", { alp = 1, input = 1 }},
                     {"anm_complex_heartmedallion_use_wings", { alp = 1, frame = 300 }} } );
      ObjDelete( "anm_complex_heartmedallion_wings" );
    else 
      ObjSet("anm_complex_heartmedallion_use_wings",  { alp = 1, frame = 300 });
    end;

  end;
  cmn.AddSubscriber( "use_wings", use_wings_inv );
  cmn.AddSubscriber( "use_wings", use_wings_beg, "inv_complex_heartmedallion" );
  cmn.AddSubscriber( "use_wings", use_wings_end, "inv_complex_heartmedallion" );
  cmn.AddSubscriber( "use_wings_inv", use_wings_inv );
  cmn.AddSubscriber( "use_wings_beg", use_wings_beg, "inv_complex_heartmedallion" );
  cmn.AddSubscriber( "use_wings_end", use_wings_end, "inv_complex_heartmedallion" );
  --------------------------------------------------------------------------------------------
  -- function use_rubyheart () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_rubyheart" ] = {

      type = "use",
      inv_obj = "inv_rubyheart",
      use_place = "obj_complex_heartmedallion_use_rubyheart",
      room = "int_complex_inv",
      zz = "inv_complex_heartmedallion",
      zz_gate = "inv_heartmedallion"
  };
  --------------------------------------------------------------------------------------------
  local use_rubyheart_inv = function ()

    interface.InventoryItemRemove( "inv_rubyheart" );

    if (not cmn.IsEventDone("get_gem") or cmn.IsEventDone("use_gem")) and 
       (not cmn.IsEventDone("get_wings") or cmn.IsEventDone("use_wings")) and
        not(cmn.IsEventDone("use_gem") and cmn.IsEventDone("use_wings"))  then
      ObjSet("inv_heartmedallion_star_light",  { alp = 0 });
    end;

  end;
  local use_rubyheart_beg = function ()

    ObjDelete( "obj_complex_heartmedallion_use_rubyheart" );

  end;
  local use_rubyheart_end = function ()
    
    if cmn.IsEventDone("use_gem") and cmn.IsEventDone("use_wings") then
      ObjMultiSet( { {"spr_complex_heartmedallion_lovesymbol", { alp = 1, input = 1 }},
                     {"anm_complex_heartmedallion_use_wings", { alp = 1, frame = 300 }} } );
      ObjDelete( "anm_complex_heartmedallion_wings" );
    else 
      ObjMultiSet( { {"obj_complex_heartmedallion_use_wings", { input = 1 }},
                     {"spr_complex_heartmedallion_heart", { alp = 1 }} } );
    end;

  end;
  cmn.AddSubscriber( "use_rubyheart", use_rubyheart_inv );
  cmn.AddSubscriber( "use_rubyheart", use_rubyheart_beg, "inv_complex_heartmedallion" );
  cmn.AddSubscriber( "use_rubyheart", use_rubyheart_end, "inv_complex_heartmedallion" );
  cmn.AddSubscriber( "use_rubyheart_inv", use_rubyheart_inv );
  cmn.AddSubscriber( "use_rubyheart_beg", use_rubyheart_beg, "inv_complex_heartmedallion" );
  cmn.AddSubscriber( "use_rubyheart_end", use_rubyheart_end, "inv_complex_heartmedallion" );
  
  --------------------------------------------------------------------------------------------
  -- function clk_opencase () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_opencase" ] = {
      type = "click",
      use_place = "obj_complex_folder_clk_opencase",
      room = "int_complex_inv",
      zz = "inv_complex_folder",
      zz_gate = "inv_folder"
  };
  --------------------------------------------------------------------------------------------
  local clk_opencase_beg = function ()
  
    ObjDelete( "obj_complex_folder_clk_opencase" );
  
  end;
  local clk_opencase_end = function ()
  
    ObjSet("obj_complex_folder_open",  { alp = 1, input = 1 });
    
    ObjDelete( "spr_complex_folder_closed" );

  end;
  cmn.AddSubscriber( "clk_opencase", clk_opencase_beg, "inv_complex_folder" );
  cmn.AddSubscriber( "clk_opencase", clk_opencase_end, "inv_complex_folder" );
  cmn.AddSubscriber( "clk_opencase_beg", clk_opencase_beg, "inv_complex_folder" );
  cmn.AddSubscriber( "clk_opencase_end", clk_opencase_end, "inv_complex_folder" );
  --------------------------------------------------------------------------------------------
  -- function clk_unwrapparcel () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_unwrapparcel" ] = {
      type = "click",
      use_place = "spr_complex_secretparcel_parcel_closed",
      room = "int_complex_inv",
      zz = "inv_complex_secretparcel",
      zz_gate = "inv_secretparcel"
  };
  --------------------------------------------------------------------------------------------
  local clk_unwrapparcel_beg = function ()
  end;
  local clk_unwrapparcel_end = function ()

    ObjDelete( "spr_complex_secretparcel_parcel_closed" );

    ObjSet( "obj_complex_secretparcel_parcel_opened", { alp = 1, input = true } );

  end;
  cmn.AddSubscriber( "clk_unwrapparcel", clk_unwrapparcel_beg, "inv_complex_secretparcel" );
  cmn.AddSubscriber( "clk_unwrapparcel", clk_unwrapparcel_end, "inv_complex_secretparcel" );
  cmn.AddSubscriber( "clk_unwrapparcel_beg", clk_unwrapparcel_beg, "inv_complex_secretparcel" );
  cmn.AddSubscriber( "clk_unwrapparcel_end", clk_unwrapparcel_end, "inv_complex_secretparcel" );
  --------------------------------------------------------------------------------------------
  -- function clk_unwrapnote () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_unwrapnote" ] = {
      type = "click",
      use_place = "spr_complex_note_closed_note",
      room = "int_complex_inv",
      zz = "inv_complex_note",
      zz_gate = "inv_note"
  };
  --------------------------------------------------------------------------------------------
  local clk_unwrapnote_beg = function ()
  end;
  local clk_unwrapnote_end = function ()
  
    ObjDelete( "spr_complex_note_closed_note" );

    ObjSet( "obj_complex_note_opened_note", { alp = 1, input = true } );
  
  end;
  cmn.AddSubscriber( "clk_unwrapnote", clk_unwrapnote_beg, "inv_complex_note" );
  cmn.AddSubscriber( "clk_unwrapnote", clk_unwrapnote_end, "inv_complex_note" );
  cmn.AddSubscriber( "clk_unwrapnote_beg", clk_unwrapnote_beg, "inv_complex_note" );
  cmn.AddSubscriber( "clk_unwrapnote_end", clk_unwrapnote_end, "inv_complex_note" );

end;
--*********************************************************************************************************************
-- function *** CLOSE FUNC *** () end;
--*********************************************************************************************************************
function public.inv_complex_brokenscoopnet_close()

  if cmn.IsEventDone( "win_brokenscoopnet") and not cmn.IsEventDone( "get_scoopnet" ) then
    
    ObjSet("spr_complex_brokenscoopnet_scoopnet",  { alp = 1 });

    cmn.SetEventDone( "get_scoopnet" );
    cmn.CallEventHandler( "get_scoopnet", "inv_complex_brokenscoopnet" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;
  
  if cmn.IsEventDone("use_scissors") and cmn.IsEventDone("use_yarnspindle") and not cmn.IsEventDone("win_brokenscoopnet") then
    cmn.MiniGameHide("brokenscoopnet");
    ObjSet("obj_int_button_reset",{ pos_y = 0 });
    ObjSet("obj_int_button_info",{ pos_y = 0 });
  end;

end;
--------------------------------------------------------------------------------------------
function public.inv_complex_diary_close()

  if cmn.IsEventDone( "use_lettera" ) then

    if not cmn.IsEventDone("get_broomamulet") or not cmn.IsEventDone("get_magicpagepiece3") then
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
    end;

    if not cmn.IsEventDone( "get_broomamulet" ) then

      cmn.SetEventDone( "get_broomamulet" );
      cmn.CallEventHandler( "get_broomamulet", "inv_complex_diary" );

    end;

    if not cmn.IsEventDone( "get_magicpagepiece3" ) then

      cmn.SetEventDone( "get_magicpagepiece3" );
      cmn.CallEventHandler( "get_magicpagepiece3", "inv_complex_diary" );

    end;

  end;

end;
--------------------------------------------------------------------------------------------
function public.inv_complex_folder_close()

  if cmn.IsEventDone( "clk_opencase" ) then

    if not cmn.IsEventDone("get_closetroom") or not cmn.IsEventDone("get_pencil") then
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
    end;

    if not cmn.IsEventDone( "get_closetroom" ) then

      cmn.SetEventDone( "get_closetroom" );
      cmn.CallEventHandler( "get_closetroom", "inv_complex_folder" );

    end;

    if not cmn.IsEventDone( "get_pencil" ) then

      cmn.SetEventDone( "get_pencil" );
      cmn.CallEventHandler( "get_pencil", "inv_complex_folder" );

    end;

  end;

end;
--------------------------------------------------------------------------------------------
function public.inv_complex_heartmedallion_close()

  if cmn.IsEventDone( "use_gem" ) and cmn.IsEventDone("use_wings") and cmn.IsEventDone("use_rubyheart") and not cmn.IsEventDone( "get_lovesymbol" ) then

    cmn.SetEventDone( "get_lovesymbol" );
    cmn.CallEventHandler( "get_lovesymbol", "inv_complex_heartmedallion" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;

end;
--------------------------------------------------------------------------------------------
function public.inv_complex_line_close()

  if cmn.IsEventDone( "use_hook" ) and not cmn.IsEventDone( "get_laceandhook" ) then

    cmn.SetEventDone( "get_laceandhook" );
    cmn.CallEventHandler( "get_laceandhook", "inv_complex_line" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;

end;
--------------------------------------------------------------------------------------------
function public.inv_complex_note_close()
  
  if common_impl.GetCurrentNote() == "spr_complex_note_note" then
    cmn.HideNote( 1 );
  end;

  if cmn.IsEventDone( "clk_unwrapnote" ) then

    if not cmn.IsEventDone("get_beanwrapping") or not cmn.IsEventDone("get_mosaicpart2") or not cmn.IsEventDone("get_silverring") then
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
    end;

    if not cmn.IsEventDone( "get_beanwrapping" ) then

      cmn.SetEventDone( "get_beanwrapping" );
      cmn.CallEventHandler( "get_beanwrapping", "inv_complex_note" );

    end;

    if not cmn.IsEventDone( "get_mosaicpart2" ) then

      cmn.SetEventDone( "get_mosaicpart2" );
      cmn.CallEventHandler( "get_mosaicpart2", "inv_complex_note" );

    end;
    
    if not cmn.IsEventDone( "get_silverring" ) then

      cmn.SetEventDone( "get_silverring" );
      cmn.CallEventHandler( "get_silverring", "inv_complex_note" );

    end;

  end;

end;
--------------------------------------------------------------------------------------------
function public.inv_complex_purse_close()

  if cmn.IsEventDone( "use_shardpurse" ) then

    if not cmn.IsEventDone("get_gem") or not cmn.IsEventDone("get_hintletter") then
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
    end;

    if not cmn.IsEventDone( "get_gem" ) then

      cmn.SetEventDone( "get_gem" );
      cmn.CallEventHandler( "get_gem", "inv_complex_purse" );

    end;

    if not cmn.IsEventDone( "get_hintletter" ) then

      cmn.SetEventDone( "get_hintletter" );
      cmn.CallEventHandler( "get_hintletter", "inv_complex_purse" );

    end;

  end;

end;
--------------------------------------------------------------------------------------------
function public.inv_complex_secretparcel_close()

  if cmn.IsEventDone( "clk_unwrapparcel" ) then

    if not cmn.IsEventDone("get_gnomehat") or not cmn.IsEventDone("get_goldenbone") then
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
    end;

    if not cmn.IsEventDone( "get_gnomehat" ) then

      cmn.SetEventDone( "get_gnomehat" );
      cmn.CallEventHandler( "get_gnomehat", "inv_complex_secretparcel" );

    end;

    if not cmn.IsEventDone( "get_goldenbone" ) then

      cmn.SetEventDone( "get_goldenbone" );
      cmn.CallEventHandler( "get_goldenbone", "inv_complex_secretparcel" );

    end;

  end;

end;
--------------------------------------------------------------------------------------------
function public.inv_complex_stick_close()

  if cmn.IsEventDone( "use_laceandhookstick" ) and not cmn.IsEventDone( "get_fishingrod" ) then

    cmn.SetEventDone( "get_fishingrod" );
    cmn.CallEventHandler( "get_fishingrod", "inv_complex_stick" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  end;

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_scissors()

  local item = "inv_scissors";

  if cmn.ObjIntersectCheck( item, "obj_complex_brokenscoopnet_use_scissors" ) then

    cmn.CallEventHandler( "use_scissors_inv", "inv_complex_brokenscoopnet" );
    cmn.CallEventHandler( "use_scissors_beg", "inv_complex_brokenscoopnet" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_scissors" );
      cmn.CallEventHandler( "use_scissors_end", "inv_complex_brokenscoopnet" );
      
      if cmn.IsEventDone("use_yarnspindle") then
        cmn.MiniGameShow('brokenscoopnet');
        ObjSet("obj_int_button_reset",{ pos_y = -430 });
        ObjSet("obj_int_button_info",{ pos_y = -400 });
      end;
      
    end;
    
    local anm_game = function ()
      
      ObjAnimate("obj_complex_brokenscoopnet_tools", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("obj_complex_brokenscoopnet_game", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_brokenscoopnet/audio/aud_single_clk");
    
    if cmn.IsEventDone("use_yarnspindle") then
      ObjAnimate( "spr_complex_brokenscoopnet_scissors", "alp", 0, 0, anm_game, { 0, 0, 0,   0.3, 0, 1,     0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_complex_brokenscoopnet_scissors", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_yarnspindle()

  local item = "inv_yarnspindle";

  if cmn.ObjIntersectCheck( item, "obj_complex_brokenscoopnet_use_scissors" ) then

    cmn.CallEventHandler( "use_yarnspindle_inv", "inv_complex_brokenscoopnet" );
    cmn.CallEventHandler( "use_yarnspindle_beg", "inv_complex_brokenscoopnet" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_yarnspindle" );
      cmn.CallEventHandler( "use_yarnspindle_end", "inv_complex_brokenscoopnet" );
      
      if cmn.IsEventDone("use_scissors") then
        cmn.MiniGameShow('brokenscoopnet');
        ObjSet("obj_int_button_reset",{ pos_y = -430 });
        ObjSet("obj_int_button_info",{ pos_y = -400 });
      end;
      
    end;
    
    local anm_game = function ()
      
      ObjAnimate("obj_complex_brokenscoopnet_tools", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("obj_complex_brokenscoopnet_game", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_brokenscoopnet/audio/aud_single_clk");
    
    if cmn.IsEventDone("use_scissors") then
      ObjAnimate( "spr_complex_brokenscoopnet_yarn", "alp", 0, 0, anm_game, { 0, 0, 0,   0.3, 0, 1,     0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_complex_brokenscoopnet_yarn", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lettera()

  local item = "inv_lettera";

  if cmn.ObjIntersectCheck( item, "obj_complex_diary_use_lettera" ) then

    cmn.CallEventHandler( "use_lettera_inv", "inv_complex_diary" );
    cmn.CallEventHandler( "use_lettera_beg", "inv_complex_diary" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lettera" );
      cmn.CallEventHandler( "use_lettera_end", "inv_complex_diary" );
      
      cmn.PlayCutScene( "flashback",
                        "assets/levels/level1/inv_complex/inv_diary/cs/anm_flashback",
                        { 0.4, 8.8, 15.4 },
                        function() cmn.ShowBbt( "bedroom_after_flashback" ); end, 
                        "assets/levels/level1/inv_complex/inv_diary/audio/aud_flashback",
                        "assets/levels/level1/inv_complex/inv_diary/audio/aud_flashback_voc" );
      
    end;
    
    local anm_open = function ()

      ObjAnimate("anm_complex_diary_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("obj_complex_diary_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_diary/audio/aud_opn_book");

    ObjAnimate("spr_complex_diary_letter", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_gem()

  local item = "inv_gem";

  if cmn.ObjIntersectCheck( item, "obj_complex_heartmedallion_use_gem" ) then

    cmn.CallEventHandler( "use_gem_inv", "inv_complex_heartmedallion" );
    cmn.CallEventHandler( "use_gem_beg", "inv_complex_heartmedallion" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_gem" );
      cmn.CallEventHandler( "use_gem_end", "inv_complex_heartmedallion" );
      
    end;
    
    local anm_wings = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_heartmedallion/audio/aud_use_wings1");
      
      ObjMultiSet( { {"spr_complex_heartmedallion_lovesymbol", { alp = 0 }},
                     {"anm_complex_heartmedallion_wings", { alp = 1, playing = 1, endtrig = func_after }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_heartmedallion/audio/aud_use_part_jewelery");
    
    if cmn.IsEventDone("use_wings") and cmn.IsEventDone("use_rubyheart") then
      ObjAnimate( "spr_complex_heartmedallion_gem", "alp", 0, 0, anm_wings, { 0, 0, 0,   0.3, 0, 1,  0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_complex_heartmedallion_gem", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;
    
  elseif ( cmn.ApplyObj( item, "obj_nearhome_use_toygun" ) ) then
    
    cmn.Lock( 1 );
    cmn.ShowBbt( "nearhome_gem_wrong_apply" );
    ObjAnimate("obj_nearhome_use_toygun", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 1,   0.3, 0, 1 });

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_wings()

  local item = "inv_wings";

  if cmn.ObjIntersectCheck( item, "obj_complex_heartmedallion_use_wings" ) and cmn.IsEventDone("use_rubyheart") then

    cmn.CallEventHandler( "use_wings_inv", "inv_complex_heartmedallion" );
    cmn.CallEventHandler( "use_wings_beg", "inv_complex_heartmedallion" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_wings" );
      cmn.CallEventHandler( "use_wings_end", "inv_complex_heartmedallion" );
      
    end;
    
    local anm_wings = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_heartmedallion/audio/aud_use_wings1");
      
      ObjMultiSet( { {"spr_complex_heartmedallion_lovesymbol", { alp = 0 }},
                     {"anm_complex_heartmedallion_wings", { alp = 1, playing = 1, endtrig = func_after }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_heartmedallion/audio/aud_use_wings");
    
    if cmn.IsEventDone("use_gem") and cmn.IsEventDone("use_rubyheart") then
      ObjSet("anm_complex_heartmedallion_use_wings",  { alp = 1, playing = 1, endtrig = anm_wings });
    else 
      ObjSet("anm_complex_heartmedallion_use_wings",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_rubyheart()

  local item = "inv_rubyheart";

  if cmn.ObjIntersectCheck( item, "obj_complex_heartmedallion_use_rubyheart" ) then

    cmn.CallEventHandler( "use_rubyheart_inv", "inv_complex_heartmedallion" );
    cmn.CallEventHandler( "use_rubyheart_beg", "inv_complex_heartmedallion" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_rubyheart" );
      cmn.CallEventHandler( "use_rubyheart_end", "inv_complex_heartmedallion" );
      
    end;
    
    local anm_wings = function ()
      
      ObjMultiSet( { {"spr_complex_heartmedallion_lovesymbol", { alp = 0 }},
                     {"anm_complex_heartmedallion_wings", { alp = 1, playing = 1, endtrig = func_after }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_heartmedallion/audio/aud_use_part_jewelery");
    
    if cmn.IsEventDone("use_gem") and cmn.IsEventDone("use_wings") then
      ObjAnimate( "spr_complex_heartmedallion_heart", "alp", 0, 0, anm_wings, { 0, 0, 0,   0.3, 0, 1,  0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_complex_heartmedallion_heart", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hook()

  local item = "inv_hook";

  if cmn.ObjIntersectCheck( item, "obj_complex_line_use_hook" ) then

    cmn.CallEventHandler( "use_hook_inv", "inv_complex_line" );
    cmn.CallEventHandler( "use_hook_beg", "inv_complex_line" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_hook" );
      cmn.CallEventHandler( "use_hook_end", "inv_complex_line" );
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_line/audio/aud_clk_fishing_line");

    ObjAnimate( "spr_complex_line_hook", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 } );
    ObjAnimate( "spr_complex_line_hook_line", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1 } );

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_scoopnet()
  
  ObjSet("spr_complex_brokenscoopnet_scoopnet",  { alp = 1 });

  cmn.SetEventDone( "get_scoopnet" );
  cmn.CallEventHandler( "get_scoopnet", "inv_complex_brokenscoopnet" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_broomamulet()

  cmn.SetEventDone( "get_broomamulet" );
  cmn.CallEventHandler( "get_broomamulet", "inv_complex_diary" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if cmn.IsEventDone("get_magicpagepiece3") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_magicpagepiece3()

  cmn.SetEventDone( "get_magicpagepiece3" );
  cmn.CallEventHandler( "get_magicpagepiece3", "inv_complex_diary" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if cmn.IsEventDone("get_broomamulet") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_closetroom()

  cmn.SetEventDone( "get_closetroom" );
  cmn.CallEventHandler( "get_closetroom", "inv_complex_folder" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");
  
  if not cmn.IsEventDone("get_pencil") then
    cmn.SetEventDone( "get_pencil" );
    cmn.CallEventHandler( "get_pencil", "inv_complex_folder" );
  end;
  
  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_pencil()

  cmn.SetEventDone( "get_pencil" );
  cmn.CallEventHandler( "get_pencil", "inv_complex_folder" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if cmn.IsEventDone("get_closetroom") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_lovesymbol()

  cmn.SetEventDone( "get_lovesymbol" );
  cmn.CallEventHandler( "get_lovesymbol", "inv_complex_heartmedallion" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_laceandhook()

  cmn.SetEventDone( "get_laceandhook" );
  cmn.CallEventHandler( "get_laceandhook", "inv_complex_line" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_beanwrapping()

  cmn.SetEventDone( "get_beanwrapping" );
  cmn.CallEventHandler( "get_beanwrapping", "inv_complex_note" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if cmn.IsEventDone("get_mosaicpart2") and cmn.IsEventDone("get_silverring") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_mosaicpart2()

  cmn.SetEventDone( "get_mosaicpart2" );
  cmn.CallEventHandler( "get_mosaicpart2", "inv_complex_note" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if cmn.IsEventDone("get_beanwrapping") and cmn.IsEventDone("get_silverring") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_silverring()

  cmn.SetEventDone( "get_silverring" );
  cmn.CallEventHandler( "get_silverring", "inv_complex_note" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if cmn.IsEventDone("get_beanwrapping") and cmn.IsEventDone("get_mosaicpart2") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_gem()

  cmn.SetEventDone( "get_gem" );
  cmn.CallEventHandler( "get_gem", "inv_complex_purse" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if cmn.IsEventDone("get_hintletter") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_hintletter()

  cmn.SetEventDone( "get_hintletter" );
  cmn.CallEventHandler( "get_hintletter", "inv_complex_purse" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if cmn.IsEventDone("get_gem") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_gnomehat()

  --шапка заглушечная -> пока что не стал делать автоподбор кости, при сборе шапки первой

  cmn.SetEventDone( "get_gnomehat" );
  cmn.CallEventHandler( "get_gnomehat", "inv_complex_secretparcel" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if cmn.IsEventDone("get_goldenbone") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_goldenbone()

  cmn.SetEventDone( "get_goldenbone" );
  cmn.CallEventHandler( "get_goldenbone", "inv_complex_secretparcel" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  if cmn.IsEventDone("get_gnomehat") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_fishingrod()

  cmn.SetEventDone( "get_fishingrod" );
  cmn.CallEventHandler( "get_fishingrod", "inv_complex_stick" );

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_get_inv_sfx");

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function public.clk_opencase()

  cmn.Lock(1);
  cmn.CallEventHandler( "clk_opencase_beg", "inv_complex_folder" );

  local func_after = function ()

    cmn.SetEventDone( "clk_opencase" );
    cmn.CallEventHandler( "clk_opencase_end", "inv_complex_folder" );

    cmn.Lock(0);
    cmn.ShowBbt( "complex_folder_open" );

  end;
  
  cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_folder/audio/aud_opn_folder");

  ObjAnimate( "spr_complex_folder_closed", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1, 
    0.5, 0, 0
  } );
  
  ObjAnimate( "obj_complex_folder_open", "alp", 0, 0, "", 
  { 
    0.0, 0, 0, 
    0.5, 0, 1
  } );

end;
--------------------------------------------------------------------------------------------
function public.clk_unwrapparcel()

  cmn.Lock(1);
  cmn.CallEventHandler( "clk_unwrapparcel_beg", "inv_complex_secretparcel" );

  local func_after = function ()

    cmn.SetEventDone( "clk_unwrapparcel" );
    cmn.CallEventHandler( "clk_unwrapparcel_end", "inv_complex_secretparcel" );

    cmn.Lock(0);

  end;

  cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_secretparcel/audio/aud_bundle");

  ObjAnimate( "spr_complex_secretparcel_parcel_closed", "alp", 0, 0, "", 
  { 
    0.0, 0, 1, 
    0.5, 0, 0
  } );
  
  ObjAnimate( "obj_complex_secretparcel_parcel_opened", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 0, 
    0.5, 0, 1
  } );

end;
--------------------------------------------------------------------------------------------
function public.clk_unwrapnote()

  cmn.Lock(1);
  cmn.CallEventHandler( "clk_unwrapnote_beg", "inv_complex_note" );

  local func_after = function ()

    cmn.SetEventDone( "clk_unwrapnote" );
    cmn.CallEventHandler( "clk_unwrapnote_end", "inv_complex_note" );

    cmn.Lock(0);

  end;
  
  cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_secretparcel/audio/aud_bundle");

  ObjAnimate( "spr_complex_note_closed_note", "alp", 0, 0, "", 
  { 
    0.0, 0, 1, 
    0.5, 0, 0
  } );
  
  ObjAnimate( "obj_complex_note_opened_note", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 0, 
    0.5, 0, 1
  } );

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.open_folder()

  common_impl.ShowComplexItem('folder');

  if not(cmn.IsEventDone("tutor_9")) then

    ObjSet("obj_tutorial_tutor_8",  { input = 0 });

    interface.InventoryAutoHideLoad();

    if (int_inventory.GetAutohide()) then
      int_inventory.Hide( false );
    end;

    cmn.TutorialShow( "tutor_9", 0, 512, 384 );

  end;

end;
--------------------------------------------------------------------------------------------
function public.opn_brokenscoopnet()
  
  --for mmg
  if not( ng_global.progress[ "std" ][ "win_brokenscoopnet" ].state ) then
    private.complex_brokenscoopnet.StartConditions();
  end;
  private.complex_brokenscoopnet.state = ng_global.progress[ "std" ][ "win_brokenscoopnet" ].state;
  
  if cmn.IsEventDone("use_scissors") and cmn.IsEventDone("use_yarnspindle") then
    private.complex_brokenscoopnet.DrawScene();
  end;

  if cmn.IsEventDone("use_scissors") and cmn.IsEventDone("use_yarnspindle") and not cmn.IsEventDone("win_brokenscoopnet") then
    private.complex_brokenscoopnet.DrawScene();
    cmn.MiniGameShow('brokenscoopnet');
    ObjSet("obj_int_button_reset",{ pos_y = -430 });
    ObjSet("obj_int_button_info",{ pos_y = -400 });
    private.complex_brokenscoopnet.CheckWin();
  end;
  
  common_impl.ShowComplexItem( 'brokenscoopnet' );

end;
--------------------------------------------------------------------------------------------
function public.touch_purse()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_complex_purse_use_shard" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_purse/audio/aud_xx_clk_cloth");
  
  ObjSet("anm_complex_purse_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_diary()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_complex_diary_use_lettera" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_diary/audio/aud_xx_clk_small_belt");
  
  ObjSet("anm_complex_diary_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_scoopnet()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_complex_brokenscoopnet_use_scissors" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_brokenscoopnet/audio/aud_use_wood_box");
  
  ObjSet("anm_complex_brokenscoopnet_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Brokenscoopnet *** () end;
--*********************************************************************************************************************
--********************************************************************************************************************
private.complex_brokenscoopnet = {};
public.complex_brokenscoopnet = {};

function private.Init_Brokenscoopnet()
  
  private.complex_brokenscoopnet.win_patterns = { {3, 1, 5}, {10, 2, 9}, {9, 8, 4}, {2, 1, 7} };
  private.complex_brokenscoopnet.loupe_pos = { {-51, -69}, {72, -54}, {-62, 19}, {63, 75}, {63, 75} };
  -----------------------------------------------------------------------------------
  local win_brokenscoopnet = function ()

    if cmn.IsEventDone( "win_brokenscoopnet" ) then

      ObjSet("obj_complex_brokenscoopnet_scoopnet_get",  { input = 1, alp = 1 });
      ObjDelete( "obj_complex_brokenscoopnet_game" );
                     
    end;

  end;

  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_brokenscoopnet", win_brokenscoopnet, "inv_complex_brokenscoopnet" );

end;
--********************************************************************************************************************
function private.complex_brokenscoopnet.StartConditions()

  ng_global.progress[ "std" ][ "win_brokenscoopnet" ].skip = 0;
  ng_global.progress[ "std" ][ "win_brokenscoopnet" ].state = { 1, {0, 0, 0} }; --[1] - stage, [2] - chosen patterns

end;
-----------------------------------------------------------------------------------
function public.complex_brokenscoopnet.Reset()

  local need_r = false;
  local tme = 0.5;
  
  for i = 1, 3, 1 do
    
    if private.complex_brokenscoopnet.state[2][i] > 0 then
      if not need_r then
        need_r = true;
      end;
      ObjAnimate("spr_complex_brokenscoopnet_nod_"..private.complex_brokenscoopnet.state[2][i].."_focus", "alp", 0, 0, "", { 0, 0, 1,  0.5, 0, 0 }); 
    end;
    
  end;
  
  local patterns_count = private.complex_brokenscoopnet.CountPatterns();
  
  if patterns_count > 0 then
    ObjAnimate("spr_complex_brokenscoopnet_button_left_"..(3-patterns_count), "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    ObjAnimate("spr_complex_brokenscoopnet_button_left_3", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
  end;
  
  if private.complex_brokenscoopnet.state[1] > 1 then
    
    if not need_r then
      need_r = true;
    end;
    
    tme = 1;
    
    ObjAnimate("obj_complex_brokenscoopnet_loupe", "pos_xy", 0, 0, "", { 
      0, 0, private.complex_brokenscoopnet.loupe_pos[ private.complex_brokenscoopnet.state[1] ][1], private.complex_brokenscoopnet.loupe_pos[ private.complex_brokenscoopnet.state[1] ][2],
      1, 0, private.complex_brokenscoopnet.loupe_pos[1][1], private.complex_brokenscoopnet.loupe_pos[1][2]
    });
    
    ObjAnimate("spr_complex_brokenscoopnet_net_"..private.complex_brokenscoopnet.state[1], "alp", 0, 0, "", { 0, 0, 1,   1, 0, 0 });
    ObjAnimate("spr_complex_brokenscoopnet_net_1", "alp", 0, 0, "", { 0, 0, 0,   1, 0, 1 });
    
    ObjAnimate("obj_complex_brokenscoopnet_pattern_"..private.complex_brokenscoopnet.state[1], "alp", 0, 0, "", { 0, 0, 1,   1, 0, 0 });
    ObjAnimate("obj_complex_brokenscoopnet_pattern_1", "alp", 0, 0, "", { 0, 0, 0,   1, 0, 1 });
    
  end;
  
  if need_r then
    
    cmn.Lock(1);
    
    private.complex_brokenscoopnet.StartConditions();
    private.complex_brokenscoopnet.state = ng_global.progress[ "std" ][ "win_brokenscoopnet" ].state;
    
    ObjSet("tmr_complex_brokenscoopnet_timer",  { time = tme, playing = 1, endtrig = function() private.complex_brokenscoopnet.DrawScene(); cmn.Lock(0); end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.complex_brokenscoopnet.Skip()
  
  cmn.Lock(1);
  
  ng_global.progress[ "std" ][ "win_brokenscoopnet" ].skip = 1;
  ng_global.progress[ "std" ][ "win_brokenscoopnet" ].state = { 5, {0, 0, 0} };
  
  for i = 1, 3, 1 do
    
    if private.complex_brokenscoopnet.state[2][i] > 0 then
      ObjAnimate("spr_complex_brokenscoopnet_nod_"..private.complex_brokenscoopnet.state[2][i].."_focus", "alp", 0, 0, "", { 0, 0, 1,  0.5, 0, 0 }); 
    end;
    
  end;
  
  ObjAnimate("spr_complex_brokenscoopnet_net_"..private.complex_brokenscoopnet.state[1], "alp", 0, 0, "", { 0, 0, 1,   1, 0, 0 });
  ObjAnimate("spr_complex_brokenscoopnet_net_5", "alp", 0, 0, "", { 0, 0, 0,   1, 0, 1 });
  
  ObjAnimate("obj_complex_brokenscoopnet_pattern_"..private.complex_brokenscoopnet.state[1], "alp", 0, 0, "", { 0, 0, 1,   1, 0, 0 });
  
  private.complex_brokenscoopnet.state = ng_global.progress[ "std" ][ "win_brokenscoopnet" ].state;
  ObjSet("tmr_complex_brokenscoopnet_timer",  { time = 1, playing = 1, endtrig = private.complex_brokenscoopnet.CheckWin });
  
end;
-----------------------------------------------------------------------------------
function private.complex_brokenscoopnet.DrawScene()
  
  ObjSet("obj_complex_brokenscoopnet_loupe",  
  { 
    pos_x = private.complex_brokenscoopnet.loupe_pos[ private.complex_brokenscoopnet.state[1] ][1], 
    pos_y = private.complex_brokenscoopnet.loupe_pos[ private.complex_brokenscoopnet.state[1] ][2] 
  });
  
  for i = 1, 5, 1 do
    
    if private.complex_brokenscoopnet.state[1] == i then
      ObjSet("spr_complex_brokenscoopnet_net_"..i,  { alp = 1 });
    else 
      ObjSet("spr_complex_brokenscoopnet_net_"..i,  { alp = 0 });
    end;
                   
    if private.complex_brokenscoopnet.state[1] == i and i < 5 then
      ObjSet("obj_complex_brokenscoopnet_pattern_"..i,  { alp = 1 });
    elseif i < 5 then
      ObjSet("obj_complex_brokenscoopnet_pattern_"..i,  { alp = 0 });
    end;
    
  end;
  
  local patterns_count = private.complex_brokenscoopnet.CountPatterns();
  
  for i = 1, 3, 1 do
    
    if private.complex_brokenscoopnet.state[2][i] > 0 then
      ObjSet("spr_complex_brokenscoopnet_nod_"..private.complex_brokenscoopnet.state[2][i].."_focus",  { alp = 1 });
    else 
      break;
    end;
    
  end;
  
  local but_num = 3-patterns_count;
  
  for i = 0, 3, 1 do
    
    if but_num == i then
      ObjSet("spr_complex_brokenscoopnet_button_left_"..i,  { alp = 1 });
    else 
      ObjSet("spr_complex_brokenscoopnet_button_left_"..i,  { alp = 0 });
    end;
    
  end;
  
  private.complex_brokenscoopnet.CheckPatterns();
  
end;
-----------------------------------------------------------------------------------
function public.complex_brokenscoopnet.FocusStart( inout )
  
  local obj = "spr_complex_brokenscoopnet_button_start_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      cmn.PlayAudio("snd", "assets/levels/level1/mg_memories/audio/aud_cloud_menter");
    end;
  end;
    
  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.complex_brokenscoopnet.FocusNod( nod, inout )
  
  local obj = "spr_complex_brokenscoopnet_nod_"..nod.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
  end;
  
  if not private.complex_brokenscoopnet.CheckForChosen( nod ) then
    if tme > 0.2 and inout == 1 then
      cmn.PlayAudio("snd", "assets/levels/level1/mg_memories/audio/aud_cloud_menter");
    end;
    ObjAnimate(obj, "alp", 0, 0, "", {  0,   2, alf,   
                                        0.2, 2, 1, 
                                        0.4, 2, 0 });
  end;
  
end;
-----------------------------------------------------------------------------------
function public.complex_brokenscoopnet.ChooseNod( nod )
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menter_ho");
  
  local ind = private.complex_brokenscoopnet.CheckForChosen( nod );
  local count = private.complex_brokenscoopnet.CountPatterns();
  local dir = 1;
  
  local func_after = function ()
    
    private.complex_brokenscoopnet.CheckPatterns();
    
    if dir > 0 then
    
      ObjAnimate("spr_complex_brokenscoopnet_button_left_"..(3-count), "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      ObjAnimate("spr_complex_brokenscoopnet_button_left_"..(2-count), "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
      if count == 2 then
        ObjAnimate("spr_complex_brokenscoopnet_button_start_on", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 0,   0.3, 0, 1,     0.6, 0, 1,    0.9, 0, 0 });
      else 
        ObjSet("tmr_complex_brokenscoopnet_timer",  { time = 0.3, playing = 1, endtrig = function() cmn.Lock(0); end });
      end;
      
    else 
        
      
      ObjAnimate("spr_complex_brokenscoopnet_button_left_"..(3-count), "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 1,   0.3, 0, 0 });
      ObjAnimate("spr_complex_brokenscoopnet_button_left_"..(4-count), "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
  end;
  
  --cancel selection
  if ind then
    
    dir = -1;
    
    private.complex_brokenscoopnet.RemoveNod( ind );
    func_after();
    --ObjAnimate("spr_complex_brokenscoopnet_nod_"..nod.."_focus", "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });
    
  --select nod 
  else 
  
    local obj = "spr_complex_brokenscoopnet_nod_"..nod.."_focus";
    local alf = ObjGet( obj ).alp;
    
    if alf < 1 then
      local tme = ( 1 - alf ) * 0.3;
      ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, 1 });
    end;
    
    private.complex_brokenscoopnet.state[2][count+1] = nod;
    func_after();
    
    --ObjAnimate("spr_complex_brokenscoopnet_nod_"..nod.."_focus", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.complex_brokenscoopnet.RemoveNod( ind )
  
  for i = ind, 2, 1 do
    private.complex_brokenscoopnet.state[2][i] = private.complex_brokenscoopnet.state[2][i+1];
  end;
  private.complex_brokenscoopnet.state[2][3] = 0;
  
end;
-----------------------------------------------------------------------------------
function private.complex_brokenscoopnet.CheckForChosen( nod )
  
  local check = false;
  
  for i = 1, 3, 1 do
    
    if private.complex_brokenscoopnet.state[2][i] == nod then
      check = i;
      break;
    end;
    
  end;
  
  return check;
  
end;
-----------------------------------------------------------------------------------
function private.complex_brokenscoopnet.CountPatterns()
  
  local patterns_count = 0;
  
  for i = 1, 3, 1 do
    
    if private.complex_brokenscoopnet.state[2][i] > 0 then
      patterns_count = patterns_count + 1;
    else 
      break;
    end;
    
  end;
  
  return patterns_count;
  
end;
-----------------------------------------------------------------------------------
function private.complex_brokenscoopnet.CheckPatterns()
  
  local patterns_count = private.complex_brokenscoopnet.CountPatterns();
  
  if patterns_count == 3 then
    
    ObjSet("spr_complex_brokenscoopnet_button_start",  { input = 1 });
    
    for i = 1, 10, 1 do
      
      if private.complex_brokenscoopnet.CheckForChosen( i ) then
        ObjSet("spr_complex_brokenscoopnet_nod_"..i,  { input = 1 });
      else 
        ObjSet("spr_complex_brokenscoopnet_nod_"..i,  { input = 0 });
      end;
      
    end;
    
  else 
    
    ObjSet("spr_complex_brokenscoopnet_button_start",  { input = 0 });
    
    for i = 1, 10, 1 do
      ObjSet("spr_complex_brokenscoopnet_nod_"..i,  { input = 1 });
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.complex_brokenscoopnet.CheckSequence()
  
  cmn.Lock( 1 );
  
  local wrongs = {0, 0, 0};
  
  for i = 1, 3, 1 do
    
    local check = false;
    
    for j = 1, 3, 1 do
      
      if private.complex_brokenscoopnet.win_patterns[ private.complex_brokenscoopnet.state[1] ][i] == private.complex_brokenscoopnet.state[2][j] then
        check = true;
        break;
      end;
      
    end;
    
    if not check then
      wrongs[i] = 1;
    end;
    
  end;
  
  private.complex_brokenscoopnet.CheckSequenceCon( 1, wrongs );
  
end;
-----------------------------------------------------------------------------------
function private.complex_brokenscoopnet.CheckSequenceCon( ind, wrongs )
  
  local check = false;
  local table = {0, 0, 0};
  local table_ind = 0;
  
  for i = 1, 3, 1 do
    
    if private.complex_brokenscoopnet.state[2][ind] == private.complex_brokenscoopnet.win_patterns[ private.complex_brokenscoopnet.state[1] ][i] then
      table_ind = i;
      check = true;
      break;
    end;
    
  end;
  
  local check_stage = function ()
    
    local func_after = function ()
      
      cmn.Lock(0);
      
      for j = 1, 3, 1 do
        ObjSet("spr_complex_brokenscoopnet_pattern_"..(private.complex_brokenscoopnet.state[1]-1).."_"..j.."_right",  { alp = 0 });
      end;
      
    end;
    
    private.complex_brokenscoopnet.CheckPatterns();
    
    if private.complex_brokenscoopnet.state[1] < 5 then
      
      for i = 1, 3, 1 do
        
        ObjAnimate("spr_complex_brokenscoopnet_nod_"..table[i].."_focus", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
        ObjAnimate("spr_complex_brokenscoopnet_nod_"..table[i].."_right", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
        
      end;
      
      ObjAnimate("spr_complex_brokenscoopnet_button_left_3", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,    1, 0, 1 });
      ObjAnimate("spr_complex_brokenscoopnet_button_left_0", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 1,    1, 0, 0 });
      
      ObjAnimate("obj_complex_brokenscoopnet_pattern_"..(private.complex_brokenscoopnet.state[1]-1), "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 1,    1, 0, 0 });
      ObjAnimate("obj_complex_brokenscoopnet_pattern_"..private.complex_brokenscoopnet.state[1], "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,    1, 0, 1 });
      
      ObjAnimate("obj_complex_brokenscoopnet_loupe", "pos_xy", 0, 0, func_after, { 
        0, 0, private.complex_brokenscoopnet.loupe_pos[ private.complex_brokenscoopnet.state[1]-1 ][1], private.complex_brokenscoopnet.loupe_pos[ private.complex_brokenscoopnet.state[1]-1 ][2],
        1, 0, private.complex_brokenscoopnet.loupe_pos[ private.complex_brokenscoopnet.state[1] ][1], private.complex_brokenscoopnet.loupe_pos[ private.complex_brokenscoopnet.state[1] ][2]
      });
      
    else 

      --common_impl.PauseAchiev(1);
      --cmn.MiniGameHide("brokenscoopnet");
      --
      ----cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_brokenscoopnet/audio/");
      --
      --ObjAnimate("obj_complex_brokenscoopnet_game", "alp", 0, 0, private.complex_brokenscoopnet.Win, { 0, 0, 1,   1, 0, 1,   1.5, 0, 0 });
      --ObjAnimate("obj_complex_brokenscoopnet_scoopnet_get", "alp", 0, 0, "", { 0, 0, 0,   1, 0, 0,   1.5, 0, 1 });
      
      ObjAnimate("obj_complex_brokenscoopnet_pattern_"..(private.complex_brokenscoopnet.state[1]-1), "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 1,    1, 0, 0 });
      private.complex_brokenscoopnet.CheckWin();
      
    end;
      
  end;
  
  local func_right = function ()
    
    if ind < 3 then
      private.complex_brokenscoopnet.CheckSequenceCon( ind+1, wrongs );
    else 
      private.complex_brokenscoopnet.state[1] = private.complex_brokenscoopnet.state[1] + 1;
      for i = 1, 3, 1 do
        table[i] = private.complex_brokenscoopnet.state[2][i];
        private.complex_brokenscoopnet.state[2][i] = 0;
      end;
      cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_brokenscoopnet/audio/aud_right_combination");
      ObjAnimate("spr_complex_brokenscoopnet_net_"..private.complex_brokenscoopnet.state[1], "alp", 0, 0, check_stage, { 0, 0, 0,   1, 0, 1 });
      ObjAnimate("spr_complex_brokenscoopnet_net_"..(private.complex_brokenscoopnet.state[1]-1), "alp", 0, 0, "", { 0, 0, 1,   1, 0, 0 });
    end;
    
  end;
  
  local func_wrong = function ()
    
    local count = private.complex_brokenscoopnet.CountPatterns();
    
    for i = 1, 3, 1 do
      table[i] = private.complex_brokenscoopnet.state[2][i];
      private.complex_brokenscoopnet.state[2][i] = 0;
    end;
    
    private.complex_brokenscoopnet.CheckPatterns();
    
    for j = 1, 3, 1 do
      if wrongs[j] == 1 then
        ObjAnimate("spr_complex_brokenscoopnet_pattern_"..private.complex_brokenscoopnet.state[1].."_"..j.."_wrong", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      elseif wrongs[j] == 0 and ObjGet("spr_complex_brokenscoopnet_pattern_"..private.complex_brokenscoopnet.state[1].."_"..j.."_right").alp > 0 then
        ObjAnimate("spr_complex_brokenscoopnet_pattern_"..private.complex_brokenscoopnet.state[1].."_"..j.."_right", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      end;
    end;
    
    for i = 1, count, 1 do
        
      ObjAnimate("spr_complex_brokenscoopnet_nod_"..table[i].."_focus", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
      local check = false;
      for j = 1, 3, 1 do
        if table[i] == private.complex_brokenscoopnet.win_patterns[ private.complex_brokenscoopnet.state[1] ][j] then
          check = true;
          break;
        end;
      end;
      
      if check and i <= ind then
        ObjAnimate("spr_complex_brokenscoopnet_nod_"..table[i].."_right", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      elseif i <= ind then
        ObjAnimate("spr_complex_brokenscoopnet_nod_"..table[i].."_wrong", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      end;
      
    end;
    
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_wrong_apply");
    
    ObjAnimate("spr_complex_brokenscoopnet_button_left_3", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 0,   0.3, 0, 1 });
    ObjAnimate("spr_complex_brokenscoopnet_button_left_"..(3-count), "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    
  end;
  
  if check then
    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_brokenscoopnet/audio/aud_right");
    ObjAnimate("spr_complex_brokenscoopnet_nod_"..private.complex_brokenscoopnet.state[2][ind].."_right", "alp", 0, 0, func_right, { 0, 0, 0,   0.5, 0, 1,    1, 0, 1 });
    ObjAnimate("spr_complex_brokenscoopnet_pattern_"..private.complex_brokenscoopnet.state[1].."_"..table_ind.."_right", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
  else 
    ObjAnimate("spr_complex_brokenscoopnet_nod_"..private.complex_brokenscoopnet.state[2][ind].."_wrong", "alp", 0, 0, func_wrong, { 0, 0, 0,   0.5, 0, 1,    1, 0, 1 });
    for j = 1, 3, 1 do
      if wrongs[j] == 1 then
        ObjAnimate("spr_complex_brokenscoopnet_pattern_"..private.complex_brokenscoopnet.state[1].."_"..j.."_wrong", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      end;
    end;
  end;
  
end;
-----------------------------------------------------------------------------------
function private.complex_brokenscoopnet.CheckWin()
  
  if private.complex_brokenscoopnet.state[1] > 4 then
    
    cmn.Lock(1);
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("brokenscoopnet");
    ObjSet("obj_int_button_reset",{ pos_y = 0 });
    ObjSet("obj_int_button_info",{ pos_y = 0 });
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
    --cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_brokenscoopnet/audio/");
    
    ObjAnimate("obj_complex_brokenscoopnet_game", "alp", 0, 0, private.complex_brokenscoopnet.Win, { 0, 0, 1,   1, 0, 1,   1.5, 0, 0 });
    ObjAnimate("obj_complex_brokenscoopnet_scoopnet_get", "alp", 0, 0, "", { 0, 0, 0,   1, 0, 0,   1.5, 0, 1 });
    
  end; 
  
end;
-----------------------------------------------------------------------------------
function private.complex_brokenscoopnet.Win()

  common_impl.PauseAchiev(0);
  
  cmn.SetEventDone( "win_brokenscoopnet" );
  cmn.CallEventHandler( "win_brokenscoopnet", "inv_complex_brokenscoopnet" );

  if ng_global.progress[ "std" ][ "win_brokenscoopnet" ].skip == 0 and ng_global.noskipgames[ "win_brokenscoopnet" ] == nil then

    ng_global.noskipgames[ "win_brokenscoopnet" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

  cmn.Lock(0);

end;
-----------------------------------------------------------------------------------
--*******************************************************************************************