-- name=level1

function public.Start ( param )

  game.play_hint_aud = false;

  interface.WidgetAdd( InterfaceWidget_Pause, 1800 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 10 );
  interface.WidgetAdd( InterfaceWidget_BtnGuide, 6 );

  interface.WidgetAdd( InterfaceWidget_BtnHint, 4  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 5 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 6 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 7 );

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 0 );

  interface.WidgetAdd( InterfaceWidget_TaskHeader, 1 );
  interface.WidgetAdd( InterfaceWidget_Inventory, 2 );
  --interface.WidgetAdd( InterfaceWidget_TaskPanel );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 3, "assets/interface/int_taskpanel");

  interface.WidgetAdd( InterfaceWidget_Effects, 50 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 4 );

  interface.WidgetAdd( InterfaceWidget_DialogHo, 260 );

  interface.ButtonLockAdd();

  interface.WidgetAdd( InterfaceWidget_ItemPanel, 3, "assets/interface/int_itempanel" );
  interface.WidgetAdd( InterfaceWidget_Popup, 250 );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog );

  interface.WidgetAdd( InterfaceWidget_DialogVideo, 300 );
  --interface.WidgetAdd( InterfaceWidget_DialogStory );
  --interface.WidgetAdd( InterfaceWidget_DialogCharacter, 900 );

  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial, 310 );

  interface.WidgetAdd( InterfaceWidget_Map, 200 );

  interface.PanelNotificationAdd();
  interface.ComplexInvAdd();
  interface_impl.DialogHintAdd();
  
  interface_impl.GlobalTaskAdd();
  
  ------------------------------------------------------
  if IsCollectorsEdition() or IsSurveyEdition() then
  
    ModLoad( "assets/levels/menu/rm_achievements/mod_achievements" );
    rm_achievements.Init();
  
    ModLoad( "assets/levels/menu/rm_collectable/mod_collectable" );
    rm_collectable.Init();

    interface_impl.AchievAdd();
    interface_impl.PopupAchievementAdd();

    interface_impl.BonusAdd();
  
  end;
  ------------------------------------------------------
  if IsCollectorsEdition() then
  
    interface.WidgetAdd( InterfaceWidget_StrategyGuide );
  
  end;
  ------------------------------------------------------
  
  --переменная для того, чтобы из титров не выкидывало в меню
  public.in_progress = true;
  --
  private.Init();
  --
  int_map_impl.CreateRooms( "level1" );

  ModLoad( "assets/levels/level1/mod_inventory1" );
  inventory1.Init();
  
  ModLoad( "assets/levels/level1/rm_demoscreen/mod_demoscreen" );
  rm_demoscreen.Init();
  
  --ModLoad( "assets/levels/menu/rm_endroom/mod_endroom" );
  --rm_endroom.Init();
  
  ModLoad( "assets/levels/menu/rm_credits/mod_credits" );
  rm_credits.Init();

  common.LevelLoad( "level1", "std", "rm_doctorstudy", param );
  ng_global.progress[ "std" ].common.gamestart = true;
  
  common_impl.PlayBackgroundMusic();

  common_impl.DialogCustomUpdate();
  interface_impl.RemoveFlowersTotal();
  cmn.RemoveCollectable();

  game.play_hint_aud = true;

  common_impl.is_in_map = 0;

  if ( ng_global.new_hint ) then
    int_button_hint_impl.SetNewVid();
    int_button_skip_impl.SetNewVid();
  end;

end;
    
function private.Init ()


  
  game.room_names =
  {
     "rm_doctorstudy"
    ,"rm_nearhome"
    ,"rm_apartmentlivingroom"
    ,"rm_bedroom"
    ,"rm_kitchen"
    ,"rm_nearcastle"
    ,"rm_castlegate"
    ,"rm_entrancehall"
    
    ,"ho_debris"
    ,"ho_inwardrobe"
    ,"ho_infridge"
    ,"ho_intohollow"
    
    ,"mg_pursuit"
    ,"mg_memories"
    ,"mg_key"
  };

-- 1 - открыта
-- 2 - таски выполнены
-- 3 - кол-во тасков
-- 4 блокирована
-- 5 - кол-во collectibles
  game.map_rooms = {

    [ "rm_doctorstudy" ] =            { 1, 0, 99, 0, 2 },
    [ "rm_nearhome" ] =               { 0, 0, 3, 0, 3 },
    [ "rm_apartmentlivingroom" ]   =  { 0, 0, 99, 0, 2 },
    [ "rm_bedroom" ] =                { 0, 0, 3, 0, 2 },
    [ "rm_kitchen" ] =                { 0, 0, 1, 0, 1 },
    [ "rm_nearcastle" ] =             { 0, 0, 1, 0, 5 },
    [ "rm_castlegate" ] =             { 0, 0, 1, 0, 0 },
    [ "rm_entrancehall" ] =           { 0, 0, 99, 0, 2 }

  };
  
  --таблица с координатами открытия зз
  game.zz_end_pos = {

    [ "zz_hygeastatuette" ] = {400, 340},
    [ "zz_closetdoor" ] = {700, 360},
    [ "zz_cardregister" ] = {600, 350},
    
    [ "zz_housedoor" ] = {400, 320},
    [ "zz_coinciergeroomwindow" ] = {600, 340},
    [ "zz_carinterior" ] = {640, 360},
    [ "zz_clockatentrace" ] = {640, 320},
    
    [ "zz_bureau" ] = {500, 350},
    [ "zz_bedroomdoor" ] = {760, 260},
    [ "zz_woundedcat" ] = {370, 350},
    [ "zz_bookshelf" ] = {480, 320},
    [ "zz_kitchendoor" ] = {340, 320},
    [ "zz_hallway" ] = {600, 360},
    
    [ "zz_wardrobedoor" ] = {350, 330},
    [ "zz_wallmap" ] = {610, 320},
    [ "zz_bed" ] = {560, 360},
    
    [ "zz_fridgedoor" ] = {340, 330},
    [ "zz_sink" ] = {600, 360},
    
    [ "zz_pond" ] = {400, 350},
    [ "zz_treehollow" ] = {320, 320},
    [ "zz_gnome" ] = {600, 360},
    [ "zz_summerhouse" ] = {620, 340},
    
    [ "zz_castledoor" ] = {490, 330},
    [ "zz_snake" ] = {600, 360},
    
    [ "zz_halldoors" ] = {620, 340},
    [ "zz_aquarium" ] = {320, 340},
    [ "zz_couch" ] = {620, 360},
    [ "zz_princessstatuette" ] = {500, 320}
    
  };

  --таблицы для динамического хинта
  --таблица для юзов на предметы, получаемые в хо и мультиюзов
  game.progress_multyuse =
  {
    {"use_hoglove", "clk_closetroom"},
    {"use_hoknife", "clk_closetroom"},
    {"use_hoamulet", "clk_closetroom"},
    {"use_hobandage", "clk_closetroom"},
    {"use_hozip", "clk_closetroom"},
    {"use_hobottle", "clk_closetroom"},
    {"use_hook", "win_infridge"},
    {"use_laceandhookkitchen", "get_laceandhook"},
    {"use_laceandhookstick", "get_laceandhook"},
    {"use_shardhall", "get_shard"},
    {"use_shardpurse", "get_shard"},
    {"use_holvl1rag", "use_salamander"},
    {"use_holvl1hammer", "use_salamander"},
    {"use_holvl1seed", "use_salamander"}
  };

  --таблица на мультипредметы с количеством их частей
  game.progress_multyobj =
  {
    {"use_clockhand", 3},
    {"use_mosaicpart", 3}
  };

  --таблица на юзы, разблокирующиеся другими юзами или кликами
  game.progress_blockeduse =
  {
    {"clk_openfirstaidkit", "use_pin"},
    {"use_cleanhanky", "use_antiseptic"},
    {"use_valeriansolution", "use_cleanhanky"},
    {"use_coals", "use_fishingrod"},
    {"use_broomamulet", "use_cabinethandle"},
    {"use_nestling", "use_flower"},
    {"use_lovesymbol", "use_flower"},
    {"use_snowball", "clk_coinciergewindow"},
    {"use_easternprincess", "use_mappart"},
    {"use_scoopnet", "use_jug"},
    {"use_wings", "use_rubyheart"}
  };

  game.progress_names =
  {
    "beg_level1"
    ,"clk_hangerget"
    ,"clk_hunterhit1"
    ,"clk_hunterhit2"
    ,"clk_hanger"
    ,"get_cane"
    ,"opn_cardregister"
    ,"use_cane"
    ,"get_hygeacup"
    ,"use_hygeacup"
    ,"get_goldenring"
    ,"get_cardregistercypher"
    ,"use_cardregistercypher"
    ,"win_cardregister"
    ,"clk_folder1"
    ,"clk_folder2"
    ,"get_folder"
    ,"clk_opencase"
    ,"get_pencil"
    ,"get_closetroom"
    ,"use_closetroom"
    ,"clk_closetroom"
    ,"use_hoglove"
    ,"use_hoknife"
    ,"use_hoamulet"
    ,"use_hobandage"
    ,"use_hozip"
    ,"use_hobottle"
    ,"win_debris"
    ,"opn_doctorstudyafterho"
    ,"opn_pursuit"
    ,"win_pursuit"
    
    ,"opn_nearhome"
    ,"get_coin"
    ,"use_coin"
    ,"clk_coinciergewindow"
    ,"get_magnetkey"
    ,"use_magnetkey"
    
    ,"opn_apartmentlivingroom"
    ,"get_cleanhanky"
    ,"get_shard"
    ,"get_bell"
    ,"get_snowball"
    ,"use_snowball"
    ,"get_silversnake"
    ,"get_pin"
    ,"use_pin"
    ,"clk_openfirstaidkit"
    ,"get_antiseptic"
    ,"get_sleepingpills"
    ,"get_woodenring"
    ,"use_woodenring"
    ,"win_bookshelf"
    ,"get_bronzesnake"
    ,"get_clockhand1"
    ,"use_bronzesnake"
    ,"use_silversnake"
    ,"get_valeriansolution"
    ,"use_antiseptic"
    ,"use_cleanhanky"
    ,"use_valeriansolution"
    ,"get_magicpagepiece1"
    ,"get_clockhand2"
    ,"use_shardhall"
    ,"get_clockhand3"
    ,"clk_openglass"
    ,"use_clockhand"
    ,"win_clockatentrace"
    ,"get_wheel"
    ,"use_wheel"
    ,"get_bedroomkey"
    ,"use_bedroomkey"
    ,"clk_bedroomkey"
    
    ,"opn_bedroom"
    ,"get_diary"
    ,"get_huntsmanfigurine"
    ,"use_pencil"
    ,"win_inwardrobe"
    ,"use_shardpurse"
    ,"get_hintletter"
    ,"get_gem"
    ,"use_hintletter"
    ,"clk_parcelcode1"
    ,"clk_parcelcode2"
    ,"clk_parcelcode3"
    ,"clk_parcelcode4"
    ,"get_cinderellafigurine"
    ,"get_number12"
    ,"get_mappart"
    ,"use_number12"
    ,"opn_memories"
    ,"win_memories"
    ,"opn_clockatentraceaftermg"
    ,"get_magicpagepiece2"
    ,"get_unicornhorn"
    ,"use_unicornhorn"
    ,"get_cabinethandle"
    ,"get_crystaltie"
    ,"use_cabinethandle"
    ,"get_shoehorn"
    ,"use_shoehorn"
    
    ,"opn_kitchen"
    ,"clk_sinkfirst"
    ,"get_toygun"
    ,"use_toygun"
    ,"get_easternprincess"
    ,"use_mappart"
    ,"use_easternprincess"
    ,"win_wallmap"
    ,"get_crystalshoeheel"
    ,"get_evilqueenfigurine"
    
    ,"opn_apartmenthuntsman"
    ,"use_evilqueenfigurine"
    ,"use_huntsmanfigurine"
    ,"use_cinderellafigurine"
    ,"get_lettera"
    ,"use_lettera"
    ,"get_magicpagepiece3"
    ,"get_broomamulet"
    ,"use_broomamulet"
    ,"get_hairdryer"
    ,"get_line"
    ,"use_hairdryer"
    ,"win_fridgedoor"
    ,"win_infridge"
    ,"use_hook"
    ,"get_laceandhook"
    ,"use_laceandhookkitchen"
    ,"get_pumpkinbranch"
    ,"use_pumpkinbranch"
    ,"get_crystalshoetip"
    ,"use_crystalshoetip"
    ,"use_crystalshoeheel"
    ,"use_crystaltie"
    ,"get_crystalshoe"
    ,"get_magicpagepiece4"
    
    ,"opn_nearcastle"
    ,"clk_nearcastlefirst"
    ,"opn_gnome"
    ,"get_stick"
    ,"use_laceandhookstick"
    ,"get_fishingrod"
    ,"opn_castlegate"
    ,"get_coals"
    ,"use_fishingrod"
    ,"use_coals"
    ,"get_salamander"
    ,"use_salamander"
    ,"use_holvl1rag"
    ,"use_holvl1hammer"
    ,"use_holvl1seed"
    ,"win_intohollow"
    ,"clk_unwrapparcel"
    ,"get_goldenbone"
    ,"get_gnomehat"
    ,"use_goldenbone"
    
    ,"opn_entrancehall"
    ,"clk_assemblingscales1"
    ,"clk_assemblingscales2"
    ,"clk_assemblingscales3"
    ,"clk_assemblingscales4"
    ,"clk_assemblingscales5"
    ,"get_scales"
    ,"opn_princessstatuette"
    ,"get_apple"
    ,"use_scales"
    ,"use_apple"
    ,"get_sharpfang"
    ,"clk_sharpfang"
    ,"use_sharpfang"
    ,"get_woodenwolf"
    ,"use_gnomehat"
    ,"get_brokenscoopnet"
    ,"use_woodenwolf"
    ,"get_bracelet"
    ,"use_bracelet"
    ,"get_flower"
    ,"get_mosaicpart1"
    ,"use_flower"
    ,"get_lionhead"
    ,"get_scissors"
    ,"use_lionhead"
    ,"get_note"
    ,"clk_unwrapnote"
    ,"get_beanwrapping"
    ,"get_silverring"
    ,"get_mosaicpart2"
    ,"use_silverring"
    ,"use_goldenring"
    ,"get_yarnspindle"
    ,"get_heartmedallion"
    ,"use_scissors"
    ,"use_yarnspindle"
    ,"win_brokenscoopnet"
    ,"get_scoopnet"
    ,"use_beanwrapping"
    ,"get_nestling"
    ,"use_nestling"
    ,"get_jug"
    ,"get_mosaicpart3"
    ,"use_jug"
    ,"use_scoopnet"
    ,"get_yingyangfish"
    ,"use_yingyangfish"
    ,"get_rubyheart"
    ,"use_mosaicpart"
    ,"get_wings"
    ,"use_rubyheart"
    ,"use_gem"
    ,"use_wings"
    ,"get_lovesymbol"
    ,"use_lovesymbol"
    ,"get_gnomegirlfigurine"
    ,"use_gnomegirlfigurine"
    ,"get_gnomehammer"
    ,"get_magnet"
    ,"use_magnet"
    ,"opn_key"
    ,"win_key"
    ,"get_wingedkey"
    ,"use_wingedkey"
    ,"opn_eventhall"
    
    ,"opn_maptutor"
    ,"tutor_enable"
    ,"tutor_1"
    ,"tutor_2"
    ,"tutor_3"
    ,"tutor_4"
    ,"tutor_5"
    ,"tutor_6"
    ,"tutor_7"
    ,"tutor_8"
    ,"tutor_9"
    ,"tutor_10"
    ,"tutor_11"
    ,"tutor_12"
    ,"tutor_13"
    ,"tutor_14"
    ,"tutor_15"
    ,"tutor_16"
    ,"tutor_17"
    ,"tutor_18"
    ,"tutor_19"
  
  };
  
  game.relations = {};

end;

function Test ()
    
  local profiles = GetProfileList();

  local cheater = false;

  for i = 1, #profiles, 1 do

    if ( profiles[ i ] == "CHEATER" ) then

      cheater = true;

    end;

  end;

  AddProfile( "CHEATER" );
  SetCurrentProfile( "CHEATER" );

  if ( not cheater ) then

    ng_global.gamemode = 0;
    ng_global.currentprogress = "std";
    ng_global.progress = {};
    ng_global.progress[ "std" ] = {};
    ng_global.progress[ "std" ].common = {};
    ng_global.progress[ "std" ].common.hinttimer = 0;

    SaveProfiles();

  end;

end;
