-- name=rm_apartmentlivingroom
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_apartmentlivingroom";
  private.dlg_event = "";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Bookshelf();
  --------------------------------------------------------------------------------------------
  -- function get_snowball () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_snowball" ] = {
      type = "get",
      get_obj = "spr_bureau_snowball",
      room = private.room_objname,
      zz = "zz_bureau",
      zz_gate = "gzz_apartmentlivingroom_bureau"
  };
  --------------------------------------------------------------------------------------------
  local get_snowball_inv = function ()
  
    interface.InventoryItemAdd( "inv_snowball", "spr_bureau_snowball" );
  
  end;
  local get_snowball_end = function ()
  
    ObjDelete( "gfx_bureau_snowball" );
    ObjDelete( "spr_bureau_snowball_sh" );
    ObjDelete( "fx_bureau_p_snowball" );
    
    ObjDelete( "spr_apartmentlivingroom_table_globe" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_snowball", get_snowball_inv );
  cmn.AddSubscriber( "get_snowball", get_snowball_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_valeriansolution () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_valeriansolution" ] = {
      type = "get",
      get_obj = "spr_bureau_valeriansolution",
      room = private.room_objname,
      zz = "zz_bureau",
      zz_gate = "gzz_apartmentlivingroom_bureau"
  };
  --------------------------------------------------------------------------------------------
  local get_valeriansolution_inv = function ()
  
    interface.InventoryItemAdd( "inv_valeriansolution", "spr_bureau_valeriansolution" );
  
  end;
  local get_valeriansolution_end = function ()
  
    ObjDelete( "gfx_bureau_valeriansolution" );
    ObjDelete( "spr_bureau_valeriansolution_sh" );
    
    ObjDelete( "spr_apartmentlivingroom_table_valerian" );
    
    if cmn.IsEventDone("get_lettera") then
      ObjDelete( "gzz_apartmentlivingroom_bureau" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_valeriansolution", get_valeriansolution_inv );
  cmn.AddSubscriber( "get_valeriansolution", get_valeriansolution_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lettera () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lettera" ] = {
      type = "get",
      get_obj = "spr_bureau_lettera",
      room = private.room_objname,
      zz = "zz_bureau",
      zz_gate = "gzz_apartmentlivingroom_bureau"
  };
  --------------------------------------------------------------------------------------------
  local get_lettera_inv = function ()
  
    interface.InventoryItemAdd( "inv_lettera", "spr_bureau_lettera" );
    ObjSet("inv_diary_star_light",  { alp = 1 });
  
  end;
  local get_lettera_end = function ()
  
    ObjDelete( "gfx_bureau_lettera" );
    ObjDelete( "spr_bureau_lettera_sh" );
    
    ObjDelete( "spr_apartmentlivingroom_table_letter" );
    
    if cmn.IsEventDone("get_valeriansolution") then
      ObjDelete( "gzz_apartmentlivingroom_bureau" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_lettera", get_lettera_inv );
  cmn.AddSubscriber( "get_lettera", get_lettera_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_shard () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_shard" ] = {
      type = "get",
      get_obj = "spr_woundedcat_shard",
      room = private.room_objname,
      zz = "zz_woundedcat",
      zz_gate = "gzz_apartmentlivingroom_woundedcat"
  };
  --------------------------------------------------------------------------------------------
  local get_shard_inv = function ()
  
    interface.InventoryItemAdd( "inv_shard", "spr_woundedcat_shard" );
    ObjSet("inv_purse_star_light",  { alp = 1 });
  
  end;
  local get_shard_end = function ()
  
    ObjDelete( "gfx_woundedcat_shard" );
    ObjDelete( "spr_woundedcat_shard_sh" );
    
    ObjDelete( "spr_apartmentlivingroom_cat_shard" );
    
    if cmn.IsEventDone("get_magicpagepiece1") and cmn.IsEventDone("get_clockhand2") then
      ObjDelete( "gzz_apartmentlivingroom_woundedcat" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_shard", get_shard_inv );
  cmn.AddSubscriber( "get_shard", get_shard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magicpagepiece1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_magicpagepiece1" ] = {
      type = "get",
      get_obj = "spr_woundedcat_magicpagepiece1",
      room = private.room_objname,
      zz = "zz_woundedcat",
      zz_gate = "gzz_apartmentlivingroom_woundedcat"
  };
  --------------------------------------------------------------------------------------------
  local get_magicpagepiece1_inv = function ()
  
    interface.InventoryItemAdd( "inv_magicpagepiece", "spr_woundedcat_magicpagepiece1", function () cmn.GetMultyObject( 'magicpagepiece', 4 ); end );
  
  end;
  local get_magicpagepiece1_end = function ()
  
    ObjDelete( "gfx_woundedcat_magicpagepiece1" );
    ObjDelete( "spr_woundedcat_magicpagepiece1_sh" );
    
    ObjDelete( "spr_apartmentlivingroom_cat_page" );
    
    if cmn.IsEventDone("get_clockhand2") and cmn.IsEventDone("get_shard") then
      ObjDelete( "gzz_apartmentlivingroom_woundedcat" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_magicpagepiece1", get_magicpagepiece1_inv );
  cmn.AddSubscriber( "get_magicpagepiece1", get_magicpagepiece1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_clockhand2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_clockhand2" ] = {
      type = "get",
      get_obj = "spr_woundedcat_clockhand2",
      room = private.room_objname,
      zz = "zz_woundedcat",
      zz_gate = "gzz_apartmentlivingroom_woundedcat"
  };
  --------------------------------------------------------------------------------------------
  local get_clockhand2_inv = function ()
  
    interface.InventoryItemAdd( "inv_clockhand", "spr_woundedcat_clockhand2", function () cmn.GetMultyObject( 'clockhand', 3 ); end );
  
  end;
  local get_clockhand2_end = function ()
  
    ObjDelete( "gfx_woundedcat_clockhand2" );
    ObjDelete( "spr_woundedcat_clockhand2_sh" );
    
    ObjDelete( "spr_apartmentlivingroom_cat_clockhand" );
    
    if cmn.IsEventDone("get_magicpagepiece1") and cmn.IsEventDone("get_shard") then
      ObjDelete( "gzz_apartmentlivingroom_woundedcat" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_clockhand2", get_clockhand2_inv );
  cmn.AddSubscriber( "get_clockhand2", get_clockhand2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bell () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bell" ] = {
      type = "get",
      get_obj = "spr_bookshelf_bell",
      room = private.room_objname,
      zz = "zz_bookshelf",
      zz_gate = "gzz_apartmentlivingroom_bookshelf"
  };
  --------------------------------------------------------------------------------------------
  local get_bell_inv = function ()
  
    interface.InventoryItemAdd( "inv_bell", "spr_bookshelf_bell" );
  
  end;
  local get_bell_end = function ()
  
    ObjDelete( "gfx_bookshelf_bell" );
    ObjDelete( "spr_bookshelf_bell_sh" );
    
    ObjDelete( "spr_apartmentlivingroom_shelf_bell" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bell", get_bell_inv );
  cmn.AddSubscriber( "get_bell", get_bell_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bronzesnake () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bronzesnake" ] = {
      type = "get",
      get_obj = "spr_bookshelf_bronzesnake",
      room = private.room_objname,
      zz = "zz_bookshelf",
      zz_gate = "gzz_apartmentlivingroom_bookshelf"
  };
  --------------------------------------------------------------------------------------------
  local get_bronzesnake_inv = function ()
  
    interface.InventoryItemAdd( "inv_bronzesnake", "spr_bookshelf_bronzesnake" );
  
  end;
  local get_bronzesnake_end = function ()
  
    ObjDelete( "gfx_bookshelf_bronzesnake" );
    ObjDelete( "spr_bookshelf_bronzesnake_sh" );
  
    ObjDelete( "spr_apartmentlivingroom_shelf_snake" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bronzesnake", get_bronzesnake_inv );
  cmn.AddSubscriber( "get_bronzesnake", get_bronzesnake_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_clockhand1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_clockhand1" ] = {
      type = "get",
      get_obj = "spr_bookshelf_clockhand1",
      room = private.room_objname,
      zz = "zz_bookshelf",
      zz_gate = "gzz_apartmentlivingroom_bookshelf"
  };
  --------------------------------------------------------------------------------------------
  local get_clockhand1_inv = function ()
  
    interface.InventoryItemAdd( "inv_clockhand", "spr_bookshelf_clockhand1", function () cmn.GetMultyObject( 'clockhand', 3 ); end );
  
  end;
  local get_clockhand1_end = function ()
  
    ObjDelete( "gfx_bookshelf_clockhand1" );
    ObjDelete( "spr_bookshelf_clockhand1_sh" );
    
    ObjDelete( "spr_apartmentlivingroom_shelf_clockhand" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_clockhand1", get_clockhand1_inv );
  cmn.AddSubscriber( "get_clockhand1", get_clockhand1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bedroomkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bedroomkey" ] = {
      type = "get",
      get_obj = "spr_bookshelf_bedroomkey",
      room = private.room_objname,
      zz = "zz_bookshelf",
      zz_gate = "gzz_apartmentlivingroom_bookshelf"
  };
  --------------------------------------------------------------------------------------------
  local get_bedroomkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_bedroomkey", "spr_bookshelf_bedroomkey" );
  
  end;
  local get_bedroomkey_end = function ()
  
    ObjDelete( "gfx_bookshelf_bedroomkey" );
    ObjDelete( "spr_bookshelf_bedroomkey_sh" );
    
    ObjDelete( "spr_apartmentlivingroom_shelf_key" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bedroomkey", get_bedroomkey_inv );
  cmn.AddSubscriber( "get_bedroomkey", get_bedroomkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crystalshoe () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_crystalshoe" ] = {
      type = "get",
      get_obj = "spr_bookshelf_crystalshoe",
      room = private.room_objname,
      zz = "zz_bookshelf",
      zz_gate = "gzz_apartmentlivingroom_bookshelf"
  };
  --------------------------------------------------------------------------------------------
  local get_crystalshoe_inv = function ()
  
    interface.InventoryItemAdd( "inv_crystalshoe", "spr_bookshelf_crystalshoe" );
  
  end;
  local get_crystalshoe_end = function ()
  
    ObjDelete( "gfx_bookshelf_crystalshoe" );
    
    if cmn.IsEventDone("get_magicpagepiece4") then
      ObjDelete( "gzz_apartmentlivingroom_bookshelf" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_crystalshoe", get_crystalshoe_inv );
  cmn.AddSubscriber( "get_crystalshoe", get_crystalshoe_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magicpagepiece4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_magicpagepiece4" ] = {
      type = "get",
      get_obj = "spr_bookshelf_magicpagepiece4",
      room = private.room_objname,
      zz = "zz_bookshelf",
      zz_gate = "gzz_apartmentlivingroom_bookshelf"
  };
  --------------------------------------------------------------------------------------------
  local get_magicpagepiece4_inv = function ()
  
    interface.InventoryItemAdd( "inv_magicpagepiece", "spr_bookshelf_magicpagepiece4", function () cmn.GetMultyObject( 'magicpagepiece', 4 ); end );
  
  end;
  local get_magicpagepiece4_end = function ()
  
    ObjDelete( "gfx_bookshelf_magicpagepiece4" );
    ObjDelete( "spr_bookshelf_magicpagepiece4_sh" );
    
    ObjDelete( "spr_apartmentlivingroom_shelf_page" );
    
    if cmn.IsEventDone("get_crystalshoe") then
      ObjDelete( "gzz_apartmentlivingroom_bookshelf" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_magicpagepiece4", get_magicpagepiece4_inv );
  cmn.AddSubscriber( "get_magicpagepiece4", get_magicpagepiece4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_clockhand3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_clockhand3" ] = {
      type = "get",
      get_obj = "spr_hallway_clockhand3",
      room = private.room_objname,
      zz = "zz_hallway",
      zz_gate = "gzz_apartmentlivingroom_hallway"
  };
  --------------------------------------------------------------------------------------------
  local get_clockhand3_inv = function ()
  
    interface.InventoryItemAdd( "inv_clockhand", "spr_hallway_clockhand3", function () cmn.GetMultyObject( 'clockhand', 3 ); end );
  
  end;
  local get_clockhand3_end = function ()
  
    ObjDelete( "gfx_hallway_clockhand3" );
    ObjDelete( "spr_hallway_clockhand3_sh" );
    
    ObjDelete( "spr_apartmentlivingroom_hall_clockhand" );
    
    if cmn.IsEventDone("get_number12") and cmn.IsEventDone("get_cinderellafigurine") and cmn.IsEventDone("get_mappart")
    and cmn.IsEventDone("get_shoehorn") and cmn.IsEventDone("get_hairdryer") and cmn.IsEventDone("get_line") then
      ObjDelete( "gzz_apartmentlivingroom_hallway" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_clockhand3", get_clockhand3_inv );
  cmn.AddSubscriber( "get_clockhand3", get_clockhand3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_number12 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_number12" ] = {
      type = "get",
      get_obj = "spr_hallway_number12",
      room = private.room_objname,
      zz = "zz_hallway",
      zz_gate = "gzz_apartmentlivingroom_hallway"
  };
  --------------------------------------------------------------------------------------------
  local get_number12_inv = function ()
  
    interface.InventoryItemAdd( "inv_number12", "spr_hallway_number12" );
  
  end;
  local get_number12_end = function ()
  
    ObjDelete( "gfx_hallway_number12" );
    ObjDelete( "spr_hallway_number12_sh" );
    
    ObjDelete( "spr_apartmentlivingroom_hall_number" );
    
    if cmn.IsEventDone("get_clockhand3") and cmn.IsEventDone("get_cinderellafigurine") and cmn.IsEventDone("get_mappart")
    and cmn.IsEventDone("get_shoehorn") and cmn.IsEventDone("get_hairdryer") and cmn.IsEventDone("get_line") then
      ObjDelete( "gzz_apartmentlivingroom_hallway" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_number12", get_number12_inv );
  cmn.AddSubscriber( "get_number12", get_number12_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cinderellafigurine () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_cinderellafigurine" ] = {
      type = "get",
      get_obj = "spr_hallway_cinderellafigurine",
      room = private.room_objname,
      zz = "zz_hallway",
      zz_gate = "gzz_apartmentlivingroom_hallway"
  };
  --------------------------------------------------------------------------------------------
  local get_cinderellafigurine_inv = function ()
  
    interface.InventoryItemAdd( "inv_cinderellafigurine", "spr_hallway_cinderellafigurine" );
  
  end;
  local get_cinderellafigurine_end = function ()
  
    ObjDelete( "gfx_hallway_cinderellafigurine" );
    ObjDelete( "spr_hallway_cinderellafigurine_sh" );
    
    ObjDelete( "spr_apartmentlivingroom_hall_doll" );
    
    if cmn.IsEventDone("get_clockhand3") and cmn.IsEventDone("get_number12") and cmn.IsEventDone("get_mappart")
    and cmn.IsEventDone("get_shoehorn") and cmn.IsEventDone("get_hairdryer") and cmn.IsEventDone("get_line") then
      ObjDelete( "gzz_apartmentlivingroom_hallway" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_cinderellafigurine", get_cinderellafigurine_inv );
  cmn.AddSubscriber( "get_cinderellafigurine", get_cinderellafigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mappart () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_mappart" ] = {
      type = "get",
      get_obj = "spr_hallway_mappart",
      room = private.room_objname,
      zz = "zz_hallway",
      zz_gate = "gzz_apartmentlivingroom_hallway"
  };
  --------------------------------------------------------------------------------------------
  local get_mappart_inv = function ()
  
    interface.InventoryItemAdd( "inv_mappart", "spr_hallway_mappart" );
  
  end;
  local get_mappart_end = function ()
  
    ObjDelete( "gfx_hallway_mappart" );
    ObjDelete( "spr_hallway_mappart_sh" );
    
    ObjDelete( "spr_apartmentlivingroom_hall_map" );
    
    if cmn.IsEventDone("get_clockhand3") and cmn.IsEventDone("get_number12") and cmn.IsEventDone("get_cinderellafigurine")
    and cmn.IsEventDone("get_shoehorn") and cmn.IsEventDone("get_hairdryer") and cmn.IsEventDone("get_line") then
      ObjDelete( "gzz_apartmentlivingroom_hallway" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_mappart", get_mappart_inv );
  cmn.AddSubscriber( "get_mappart", get_mappart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_shoehorn () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_shoehorn" ] = {
      type = "get",
      get_obj = "spr_hallway_shoehorn",
      room = private.room_objname,
      zz = "zz_hallway",
      zz_gate = "gzz_apartmentlivingroom_hallway"
  };
  --------------------------------------------------------------------------------------------
  local get_shoehorn_inv = function ()
  
    interface.InventoryItemAdd( "inv_shoehorn", "spr_hallway_shoehorn" );
  
  end;
  local get_shoehorn_end = function ()
  
    ObjDelete( "gfx_hallway_shoehorn" );
    ObjDelete( "spr_hallway_shoehorn_sh" );
    
    ObjDelete( "spr_apartmentlivingroom_hall_shoehorn" );
    
    if cmn.IsEventDone("get_clockhand3") and cmn.IsEventDone("get_number12") and cmn.IsEventDone("get_cinderellafigurine")
    and cmn.IsEventDone("get_mappart") and cmn.IsEventDone("get_hairdryer") and cmn.IsEventDone("get_line") then
      ObjDelete( "gzz_apartmentlivingroom_hallway" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_shoehorn", get_shoehorn_inv );
  cmn.AddSubscriber( "get_shoehorn", get_shoehorn_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hairdryer () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_hairdryer" ] = {
      type = "get",
      get_obj = "spr_hallway_hairdryer",
      room = private.room_objname,
      zz = "zz_hallway",
      zz_gate = "gzz_apartmentlivingroom_hallway"
  };
  --------------------------------------------------------------------------------------------
  local get_hairdryer_inv = function ()
  
    interface.InventoryItemAdd( "inv_hairdryer", "spr_hallway_hairdryer" );
  
  end;
  local get_hairdryer_end = function ()
  
    ObjDelete( "gfx_hallway_hairdryer" );
    
    ObjDelete( "spr_apartmentlivingroom_hall_drier" );
    
    if cmn.IsEventDone("get_clockhand3") and cmn.IsEventDone("get_number12") and cmn.IsEventDone("get_cinderellafigurine")
    and cmn.IsEventDone("get_mappart") and cmn.IsEventDone("get_shoehorn") and cmn.IsEventDone("get_line") then
      ObjDelete( "gzz_apartmentlivingroom_hallway" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_hairdryer", get_hairdryer_inv );
  cmn.AddSubscriber( "get_hairdryer", get_hairdryer_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_line () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_line" ] = {
      type = "get",
      get_obj = "spr_hallway_line",
      room = private.room_objname,
      zz = "zz_hallway",
      zz_gate = "gzz_apartmentlivingroom_hallway"
  };
  --------------------------------------------------------------------------------------------
  local get_line_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_line", "spr_hallway_line" );
  
  end;
  local get_line_end = function ()
  
    ObjDelete( "gfx_hallway_line" );
    ObjDelete( "spr_hallway_line_sh" );
    
    ObjDelete( "spr_apartmentlivingroom_hall_line" );
    
    if cmn.IsEventDone("get_clockhand3") and cmn.IsEventDone("get_number12") and cmn.IsEventDone("get_cinderellafigurine")
    and cmn.IsEventDone("get_mappart") and cmn.IsEventDone("get_shoehorn") and cmn.IsEventDone("get_hairdryer") then
      ObjDelete( "gzz_apartmentlivingroom_hallway" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_line", get_line_inv );
  cmn.AddSubscriber( "get_line", get_line_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_silversnake () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_silversnake" ] = {
      type = "use",
      inv_obj = "inv_silversnake",
      use_place = "obj_bureau_use_silversnake",
      room = private.room_objname,
      zz = "zz_bureau",
      zz_gate = "gzz_apartmentlivingroom_bureau"
  };
  --------------------------------------------------------------------------------------------
  local use_silversnake_inv = function ()
  
    interface.InventoryItemRemove( "inv_silversnake" );
  
  end;
  local use_silversnake_beg = function ()
  
    if cmn.IsEventDone("use_bronzesnake") then
      ObjDelete( "obj_bureau_use_silversnake" );
    end;
  
  end;
  local use_silversnake_end = function ()
  
    if cmn.IsEventDone("use_bronzesnake") then
      ObjMultiSet( { {"spr_bureau_valeriansolution", { input = 1 }},
                     {"obj_bureau_box_open", { alp = 1 }},
                     {"spr_apartmentlivingroom_table_box_open", { alp = 1 }} } );
      ObjDelete( "anm_bureau_box_touch" );
      ObjDelete( "spr_apartmentlivingroom_table_box_closed" );
    else 
      ObjMultiSet( { {"spr_bureau_silversnake", { alp = 1 }},
                     {"spr_apartmentlivingroom_table_snake_silver", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_silversnake", use_silversnake_beg, private.room_objname );
  cmn.AddSubscriber( "use_silversnake", use_silversnake_inv );
  cmn.AddSubscriber( "use_silversnake", use_silversnake_end, private.room_objname );
  cmn.AddSubscriber( "use_silversnake_inv", use_silversnake_inv, private.room_objname );
  cmn.AddSubscriber( "use_silversnake_beg", use_silversnake_beg, private.room_objname );
  cmn.AddSubscriber( "use_silversnake_end", use_silversnake_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bronzesnake () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_bronzesnake" ] = {
      type = "use",
      inv_obj = "inv_bronzesnake",
      use_place = "obj_bureau_use_bronzesnake",
      room = private.room_objname,
      zz = "zz_bureau",
      zz_gate = "gzz_apartmentlivingroom_bureau"
  };
  --------------------------------------------------------------------------------------------
  local use_bronzesnake_inv = function ()
  
    interface.InventoryItemRemove( "inv_bronzesnake" );
  
  end;
  local use_bronzesnake_beg = function ()
  
    ObjDelete( "obj_bureau_use_bronzesnake" );
    
    if cmn.IsEventDone("use_silversnake") then
      ObjDelete( "obj_bureau_use_silversnake" );
    end;
  
  end;
  local use_bronzesnake_end = function ()
  
    if cmn.IsEventDone("use_silversnake") then
      ObjMultiSet( { {"spr_bureau_valeriansolution", { input = 1 }},
                     {"obj_bureau_box_open", { alp = 1 }},
                     {"spr_apartmentlivingroom_table_box_open", { alp = 1 }} } );
      ObjDelete( "anm_bureau_box_touch" );
      ObjDelete( "spr_apartmentlivingroom_table_box_closed" );
    else 
      ObjMultiSet( { {"spr_bureau_bronzesnake", { alp = 1 }},
                     {"spr_apartmentlivingroom_table_snake_bronze", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bronzesnake", use_bronzesnake_beg, private.room_objname );
  cmn.AddSubscriber( "use_bronzesnake", use_bronzesnake_inv );
  cmn.AddSubscriber( "use_bronzesnake", use_bronzesnake_end, private.room_objname );
  cmn.AddSubscriber( "use_bronzesnake_inv", use_bronzesnake_inv, private.room_objname );
  cmn.AddSubscriber( "use_bronzesnake_beg", use_bronzesnake_beg, private.room_objname );
  cmn.AddSubscriber( "use_bronzesnake_end", use_bronzesnake_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_evilqueenfigurine () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_evilqueenfigurine" ] = {
      type = "use",
      inv_obj = "inv_evilqueenfigurine",
      use_place = "obj_bureau_use_evilqueenfigurine",
      room = private.room_objname,
      zz = "zz_bureau",
      zz_gate = "gzz_apartmentlivingroom_bureau"
  };
  --------------------------------------------------------------------------------------------
  local use_evilqueenfigurine_inv = function ()
  
    interface.InventoryItemRemove( "inv_evilqueenfigurine" );
  
  end;
  local use_evilqueenfigurine_beg = function ()
  
    if cmn.IsEventDone("use_cinderellafigurine") and cmn.IsEventDone("use_huntsmanfigurine") then
      ObjDelete( "obj_bureau_use_evilqueenfigurine" );
    end;
  
  end;
  local use_evilqueenfigurine_end = function ()
  
    ObjMultiSet( { {"anm_bureau_queen_touch", { alp = 1 }},
                   {"spr_apartmentlivingroom_table_queen", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_huntsmanfigurine") and cmn.IsEventDone("use_cinderellafigurine") then
      ObjMultiSet( { {"obj_bureau_stash_open", { alp = 1, input = 1 }},
                     {"obj_bureau_touch_bubbleheads", { input = 1 }},
                     {"spr_apartmentlivingroom_table_stash_open", { alp = 1 }} } );
      ObjDelete( "anm_bureau_stash_open" );
      ObjDelete( "anm_bureau_stash_touch" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_evilqueenfigurine", use_evilqueenfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_evilqueenfigurine", use_evilqueenfigurine_inv );
  cmn.AddSubscriber( "use_evilqueenfigurine", use_evilqueenfigurine_end, private.room_objname );
  cmn.AddSubscriber( "use_evilqueenfigurine_inv", use_evilqueenfigurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_evilqueenfigurine_beg", use_evilqueenfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_evilqueenfigurine_end", use_evilqueenfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_huntsmanfigurine () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_huntsmanfigurine" ] = {
      type = "use",
      inv_obj = "inv_huntsmanfigurine",
      use_place = "obj_bureau_use_huntsmanfigurine",
      room = private.room_objname,
      zz = "zz_bureau",
      zz_gate = "gzz_apartmentlivingroom_bureau"
  };
  --------------------------------------------------------------------------------------------
  local use_huntsmanfigurine_inv = function ()
  
    interface.InventoryItemRemove( "inv_huntsmanfigurine" );
  
  end;
  local use_huntsmanfigurine_beg = function ()
  
    ObjDelete( "obj_bureau_use_huntsmanfigurine" );
    
    if cmn.IsEventDone("use_evilqueenfigurine") and cmn.IsEventDone("use_cinderellafigurine") then
      ObjDelete( "obj_bureau_use_evilqueenfigurine" );
    end;
  
  end;
  local use_huntsmanfigurine_end = function ()
  
    ObjMultiSet( { {"anm_bureau_hunter_touch", { alp = 1 }},
                   {"spr_apartmentlivingroom_table_hunter", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_evilqueenfigurine") and cmn.IsEventDone("use_cinderellafigurine") then
      ObjMultiSet( { {"obj_bureau_stash_open", { alp = 1, input = 1 }},
                     {"obj_bureau_touch_bubbleheads", { input = 1 }},
                     {"spr_apartmentlivingroom_table_stash_open", { alp = 1 }} } );
      ObjDelete( "anm_bureau_stash_open" );
      ObjDelete( "anm_bureau_stash_touch" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_huntsmanfigurine", use_huntsmanfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_huntsmanfigurine", use_huntsmanfigurine_inv );
  cmn.AddSubscriber( "use_huntsmanfigurine", use_huntsmanfigurine_end, private.room_objname );
  cmn.AddSubscriber( "use_huntsmanfigurine_inv", use_huntsmanfigurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_huntsmanfigurine_beg", use_huntsmanfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_huntsmanfigurine_end", use_huntsmanfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cinderellafigurine () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_cinderellafigurine" ] = {
      type = "use",
      inv_obj = "inv_cinderellafigurine",
      use_place = "obj_bureau_use_cinderellafigurine",
      room = private.room_objname,
      zz = "zz_bureau",
      zz_gate = "gzz_apartmentlivingroom_bureau"
  };
  --------------------------------------------------------------------------------------------
  local use_cinderellafigurine_inv = function ()
  
    interface.InventoryItemRemove( "inv_cinderellafigurine" );
  
  end;
  local use_cinderellafigurine_beg = function ()
  
    ObjDelete( "obj_bureau_use_cinderellafigurine" );
    
    if cmn.IsEventDone("use_evilqueenfigurine") and cmn.IsEventDone("use_huntsmanfigurine") then
      ObjDelete( "obj_bureau_use_evilqueenfigurine" );
    end;
  
  end;
  local use_cinderellafigurine_end = function ()
  
    ObjMultiSet( { {"anm_bureau_cindy_touch", { alp = 1 }},
                   {"spr_apartmentlivingroom_table_cindy", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_evilqueenfigurine") and cmn.IsEventDone("use_huntsmanfigurine") then
      ObjMultiSet( { {"obj_bureau_stash_open", { alp = 1, input = 1 }},
                     {"obj_bureau_touch_bubbleheads", { input = 1 }},
                     {"spr_apartmentlivingroom_table_stash_open", { alp = 1 }} } );
      ObjDelete( "anm_bureau_stash_open" );
      ObjDelete( "anm_bureau_stash_touch" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cinderellafigurine", use_cinderellafigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_cinderellafigurine", use_cinderellafigurine_inv );
  cmn.AddSubscriber( "use_cinderellafigurine", use_cinderellafigurine_end, private.room_objname );
  cmn.AddSubscriber( "use_cinderellafigurine_inv", use_cinderellafigurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_cinderellafigurine_beg", use_cinderellafigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_cinderellafigurine_end", use_cinderellafigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bedroomkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_bedroomkey" ] = {
      type = "use",
      inv_obj = "inv_bedroomkey",
      use_place = "obj_bedroomdoor_use_bedroomkey",
      room = private.room_objname,
      zz = "zz_bedroomdoor",
      zz_gate = "gzz_apartmentlivingroom_bedroomdoor"
  };
  --------------------------------------------------------------------------------------------
  local use_bedroomkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_bedroomkey" );
  
  end;
  local use_bedroomkey_beg = function ()
  
    ObjDelete( "obj_bedroomdoor_use_bedroomkey" );
    ObjDelete( "anm_bedroomdoor_door_touch" );
  
  end;
  local use_bedroomkey_end = function ()
  
    ObjDelete( "anm_bedroomdoor_use_key" );
  
    ObjMultiSet( { {"anm_bedroomdoor_clk_key", { alp = 1 }},
                   {"obj_bedroomdoor_clk_bedroomkey", { input = 1 }},
                   {"spr_apartmentlivingroom_bedroom_key", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bedroomkey", use_bedroomkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_bedroomkey", use_bedroomkey_inv );
  cmn.AddSubscriber( "use_bedroomkey", use_bedroomkey_end, private.room_objname );
  cmn.AddSubscriber( "use_bedroomkey_inv", use_bedroomkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_bedroomkey_beg", use_bedroomkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_bedroomkey_end", use_bedroomkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cleanhanky () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_cleanhanky" ] = {
      type = "use",
      inv_obj = "inv_cleanhanky",
      use_place = "obj_woundedcat_use_cleanhanky",
      room = private.room_objname,
      zz = "zz_woundedcat",
      zz_gate = "gzz_apartmentlivingroom_woundedcat"
  };
  --------------------------------------------------------------------------------------------
  local use_cleanhanky_inv = function ()
  
    interface.InventoryItemRemove( "inv_cleanhanky" );
  
  end;
  local use_cleanhanky_beg = function ()
  
    ObjDelete( "obj_woundedcat_use_cleanhanky" );
  
  end;
  local use_cleanhanky_end = function ()
  
    if cmn.IsEventDone("use_antiseptic") and not cmn.IsEventDone("use_valeriansolution") then
      ObjDelete( "spr_woundedcat_hanky_1" );
      ObjMultiSet( { {"obj_woundedcat_use_valeriansolution", { input = 1 }},
                     {"spr_woundedcat_cat_hanky", { alp = 1 }},
                     {"spr_apartmentlivingroom_cat_hanky", { alp = 1 }} } );
    else 
      ObjSet("spr_woundedcat_hanky_1",  { alp = 1 });
    end;
    
    if cmn.IsEventDone("use_valeriansolution") and cmn.IsEventDone("use_antiseptic") then
      ObjDelete( "obj_apartmentlivingroom_dialog_cat" );
      ObjDelete( "vid_apartmentlivingroom_dialog_cat_lipsync_1" );
      ObjDelete( "vid_apartmentlivingroom_dialog_cat_lipsync_2" );
      ObjDelete( "vid_apartmentlivingroom_dialog_cat_lipsync_3" );
      ObjDelete( "anm_woundedcat_use_valerian" );
      ObjDelete( "obj_woundedcat_cat" );
      
      ObjDelete( "anm_apartmentlivingroom_cat" );
    
      ObjMultiSet( { {"spr_woundedcat_magicpagepiece1", { alp = 1, input = 1 }},
                     {"spr_woundedcat_clockhand2", { alp = 1, input = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cleanhanky", use_cleanhanky_beg, private.room_objname );
  cmn.AddSubscriber( "use_cleanhanky", use_cleanhanky_inv );
  cmn.AddSubscriber( "use_cleanhanky", use_cleanhanky_end, private.room_objname );
  cmn.AddSubscriber( "use_cleanhanky_inv", use_cleanhanky_inv, private.room_objname );
  cmn.AddSubscriber( "use_cleanhanky_beg", use_cleanhanky_beg, private.room_objname );
  cmn.AddSubscriber( "use_cleanhanky_end", use_cleanhanky_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_antiseptic () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_antiseptic" ] = {
      type = "use",
      inv_obj = "inv_antiseptic",
      use_place = "obj_woundedcat_use_antiseptic",
      room = private.room_objname,
      zz = "zz_woundedcat",
      zz_gate = "gzz_apartmentlivingroom_woundedcat"
  };
  --------------------------------------------------------------------------------------------
  local use_antiseptic_inv = function ()
  
    interface.InventoryItemRemove( "inv_antiseptic" );
  
  end;
  local use_antiseptic_beg = function ()
  
    ObjDelete( "obj_woundedcat_use_antiseptic" );
  
  end;
  local use_antiseptic_end = function ()
    
    ObjDelete( "anm_woundedcat_use_antiseptic" );
    
    if not cmn.IsEventDone("use_cleanhanky") then           
                   
      ObjMultiSet( { {"obj_woundedcat_use_cleanhanky", { input = 1 }},
                     {"spr_woundedcat_cat_antiseptic", { alp = 1 }},
                     {"spr_apartmentlivingroom_cat_antiseptic", { alp = 1 }} } );
                     
    elseif cmn.IsEventDone("use_cleanhanky") and not cmn.IsEventDone("use_valeriansolution") then
                     
      ObjDelete( "spr_woundedcat_hanky_1" );
      ObjMultiSet( { {"obj_woundedcat_use_valeriansolution", { input = 1 }},
                     {"spr_woundedcat_cat_hanky", { alp = 1 }},
                     {"spr_apartmentlivingroom_cat_hanky", { alp = 1 }} } );
                     
    end;
                   
    if cmn.IsEventDone("use_valeriansolution") and cmn.IsEventDone("use_cleanhanky") then
      ObjDelete( "obj_apartmentlivingroom_dialog_cat" );
      ObjDelete( "vid_apartmentlivingroom_dialog_cat_lipsync_1" );
      ObjDelete( "vid_apartmentlivingroom_dialog_cat_lipsync_2" );
      ObjDelete( "vid_apartmentlivingroom_dialog_cat_lipsync_3" );
      ObjDelete( "anm_woundedcat_use_valerian" );
      ObjDelete( "obj_woundedcat_cat" );
      
      ObjDelete( "anm_apartmentlivingroom_cat" );
    
      ObjMultiSet( { {"spr_woundedcat_magicpagepiece1", { alp = 1, input = 1 }},
                     {"spr_woundedcat_clockhand2", { alp = 1, input = 1 }} } );
    end;  
      
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_antiseptic", use_antiseptic_beg, private.room_objname );
  cmn.AddSubscriber( "use_antiseptic", use_antiseptic_inv );
  cmn.AddSubscriber( "use_antiseptic", use_antiseptic_end, private.room_objname );
  cmn.AddSubscriber( "use_antiseptic_inv", use_antiseptic_inv, private.room_objname );
  cmn.AddSubscriber( "use_antiseptic_beg", use_antiseptic_beg, private.room_objname );
  cmn.AddSubscriber( "use_antiseptic_end", use_antiseptic_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_valeriansolution () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_valeriansolution" ] = {
      type = "use",
      inv_obj = "inv_valeriansolution",
      use_place = "obj_woundedcat_use_valeriansolution",
      room = private.room_objname,
      zz = "zz_woundedcat",
      zz_gate = "gzz_apartmentlivingroom_woundedcat"
  };
  --------------------------------------------------------------------------------------------
  local use_valeriansolution_inv = function ()
  
    interface.InventoryItemRemove( "inv_valeriansolution" );
    interface_impl.SetCurrentGlobalTask( 4 );
    ng_global.new_hint = true;
  
  end;
  local use_valeriansolution_beg = function ()
  
    ObjDelete( "obj_woundedcat_use_valeriansolution" );
  
  end;
  local use_valeriansolution_end = function ()
    
    if cmn.IsEventDone("use_cleanhanky") and cmn.IsEventDone("use_antiseptic") then
      ObjDelete( "obj_apartmentlivingroom_dialog_cat" );
      ObjDelete( "vid_apartmentlivingroom_dialog_cat_lipsync_1" );
      ObjDelete( "vid_apartmentlivingroom_dialog_cat_lipsync_2" );
      ObjDelete( "vid_apartmentlivingroom_dialog_cat_lipsync_3" );
      ObjDelete( "anm_woundedcat_use_valerian" );
      ObjDelete( "obj_woundedcat_cat" );
      
      ObjDelete( "anm_apartmentlivingroom_cat" );
    
      ObjMultiSet( { {"spr_woundedcat_magicpagepiece1", { alp = 1, input = 1 }},
                     {"spr_woundedcat_clockhand2", { alp = 1, input = 1 }} } );
    else
      ObjSet("spr_woundedcat_valerian_1",  { alp = 1 });   
    end;     
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_valeriansolution", use_valeriansolution_beg, private.room_objname );
  cmn.AddSubscriber( "use_valeriansolution", use_valeriansolution_inv );
  cmn.AddSubscriber( "use_valeriansolution", use_valeriansolution_end, private.room_objname );
  cmn.AddSubscriber( "use_valeriansolution_inv", use_valeriansolution_inv, private.room_objname );
  cmn.AddSubscriber( "use_valeriansolution_beg", use_valeriansolution_beg, private.room_objname );
  cmn.AddSubscriber( "use_valeriansolution_end", use_valeriansolution_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_woodenring () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_woodenring" ] = {
      type = "use",
      inv_obj = "inv_woodenring",
      use_place = "obj_bookshelf_use_woodenring",
      room = private.room_objname,
      zz = "zz_bookshelf",
      zz_gate = "gzz_apartmentlivingroom_bookshelf"
  };
  --------------------------------------------------------------------------------------------
  local use_woodenring_inv = function ()
  
    interface.InventoryItemRemove( "inv_woodenring" );
  
  end;
  local use_woodenring_beg = function ()
  
    ObjDelete( "obj_bookshelf_use_woodenring" );
  
  end;
  local use_woodenring_end = function ()
  
    ObjMultiSet( { {"gzz_bookshelf_mmg", { alp = 1, input = 1, active = 1 }},
                   {"spr_bookshelf_disk", { alp = 1 }},
                   {"spr_apartmentlivingroom_shelf_disk", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_woodenring", use_woodenring_beg, private.room_objname );
  cmn.AddSubscriber( "use_woodenring", use_woodenring_inv );
  cmn.AddSubscriber( "use_woodenring", use_woodenring_end, private.room_objname );
  cmn.AddSubscriber( "use_woodenring_inv", use_woodenring_inv, private.room_objname );
  cmn.AddSubscriber( "use_woodenring_beg", use_woodenring_beg, private.room_objname );
  cmn.AddSubscriber( "use_woodenring_end", use_woodenring_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wheel () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_wheel" ] = {
      type = "use",
      inv_obj = "inv_wheel",
      use_place = "obj_bookshelf_use_wheel",
      room = private.room_objname,
      zz = "zz_bookshelf",
      zz_gate = "gzz_apartmentlivingroom_bookshelf"
  };
  --------------------------------------------------------------------------------------------
  local use_wheel_inv = function ()
  
    interface.InventoryItemRemove( "inv_wheel" );
  
  end;
  local use_wheel_beg = function ()
  
    ObjDelete( "obj_bookshelf_use_wheel" );
  
  end;
  local use_wheel_end = function ()
  
    ObjDelete( "anm_bookshelf_touch_carriage" );
  
    ObjMultiSet( { {"spr_bookshelf_carriage_wheel", { alp = 1 }},
                   {"spr_bookshelf_carriage_open", { alp = 1 }},
                   {"spr_bookshelf_bedroomkey", { input = 1 }},
                   {"spr_apartmentlivingroom_shelf_carriage", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wheel", use_wheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_wheel", use_wheel_inv );
  cmn.AddSubscriber( "use_wheel", use_wheel_end, private.room_objname );
  cmn.AddSubscriber( "use_wheel_inv", use_wheel_inv, private.room_objname );
  cmn.AddSubscriber( "use_wheel_beg", use_wheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_wheel_end", use_wheel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crystalshoetip () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_crystalshoetip" ] = {
      type = "use",
      inv_obj = "inv_crystalshoetip",
      use_place = "obj_bookshelf_use_crystalshoetip",
      room = private.room_objname,
      zz = "zz_bookshelf",
      zz_gate = "gzz_apartmentlivingroom_bookshelf"
  };
  --------------------------------------------------------------------------------------------
  local use_crystalshoetip_inv = function ()
  
    interface.InventoryItemRemove( "inv_crystalshoetip" );
  
  end;
  local use_crystalshoetip_beg = function ()
  
    ObjDelete( "obj_bookshelf_use_crystalshoetip" );
    
    if cmn.IsEventDone("use_crystalshoeheel") and cmn.IsEventDone("use_crystaltie") then
      ObjDelete( "obj_bookshelf_use_crystaltie" );
    end;
  
  end;
  local use_crystalshoetip_end = function ()
  
    ObjMultiSet( { {"spr_bookshelf_shoe_tip", { alp = 1 }},
                   {"spr_apartmentlivingroom_shelf_shoetip", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_crystalshoeheel") and cmn.IsEventDone("use_crystaltie") then
      ObjMultiSet( { {"obj_bookshelf_shoebox", { alp = 1, input = 1 }},
                     {"spr_apartmentlivingroom_shelf_box_open", { alp = 1 }} } );
      ObjDelete( "anm_bookshelf_touch_shoebox" );
      ObjDelete( "spr_apartmentlivingroom_shelf_box_closed" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crystalshoetip", use_crystalshoetip_beg, private.room_objname );
  cmn.AddSubscriber( "use_crystalshoetip", use_crystalshoetip_inv );
  cmn.AddSubscriber( "use_crystalshoetip", use_crystalshoetip_end, private.room_objname );
  cmn.AddSubscriber( "use_crystalshoetip_inv", use_crystalshoetip_inv, private.room_objname );
  cmn.AddSubscriber( "use_crystalshoetip_beg", use_crystalshoetip_beg, private.room_objname );
  cmn.AddSubscriber( "use_crystalshoetip_end", use_crystalshoetip_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crystalshoeheel () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_crystalshoeheel" ] = {
      type = "use",
      inv_obj = "inv_crystalshoeheel",
      use_place = "obj_bookshelf_use_crystalshoeheel",
      room = private.room_objname,
      zz = "zz_bookshelf",
      zz_gate = "gzz_apartmentlivingroom_bookshelf"
  };
  --------------------------------------------------------------------------------------------
  local use_crystalshoeheel_inv = function ()
  
    interface.InventoryItemRemove( "inv_crystalshoeheel" );
  
  end;
  local use_crystalshoeheel_beg = function ()
  
    ObjDelete( "obj_bookshelf_use_crystalshoeheel" );
    
    if cmn.IsEventDone("use_crystalshoetip") and cmn.IsEventDone("use_crystaltie") then
      ObjDelete( "obj_bookshelf_use_crystaltie" );
    end;
  
  end;
  local use_crystalshoeheel_end = function ()
  
    ObjMultiSet( { {"spr_bookshelf_shoe_heel", { alp = 1 }},
                   {"spr_apartmentlivingroom_shelf_shoeheel", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_crystalshoetip") and cmn.IsEventDone("use_crystaltie") then
      ObjMultiSet( { {"obj_bookshelf_shoebox", { alp = 1, input = 1 }},
                     {"spr_apartmentlivingroom_shelf_box_open", { alp = 1 }} } );
      ObjDelete( "anm_bookshelf_touch_shoebox" );
      ObjDelete( "spr_apartmentlivingroom_shelf_box_closed" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crystalshoeheel", use_crystalshoeheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_crystalshoeheel", use_crystalshoeheel_inv );
  cmn.AddSubscriber( "use_crystalshoeheel", use_crystalshoeheel_end, private.room_objname );
  cmn.AddSubscriber( "use_crystalshoeheel_inv", use_crystalshoeheel_inv, private.room_objname );
  cmn.AddSubscriber( "use_crystalshoeheel_beg", use_crystalshoeheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_crystalshoeheel_end", use_crystalshoeheel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crystaltie () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_crystaltie" ] = {
      type = "use",
      inv_obj = "inv_crystaltie",
      use_place = "obj_bookshelf_use_crystaltie",
      room = private.room_objname,
      zz = "zz_bookshelf",
      zz_gate = "gzz_apartmentlivingroom_bookshelf"
  };
  --------------------------------------------------------------------------------------------
  local use_crystaltie_inv = function ()
  
    interface.InventoryItemRemove( "inv_crystaltie" );
  
  end;
  local use_crystaltie_beg = function ()
  
    if cmn.IsEventDone("use_crystalshoetip") and cmn.IsEventDone("use_crystalshoeheel") then
      ObjDelete( "obj_bookshelf_use_crystaltie" );
    end;
  
  end;
  local use_crystaltie_end = function ()
  
    ObjMultiSet( { {"spr_bookshelf_shoe_tie", { alp = 1 }},
                   {"spr_apartmentlivingroom_shelf_shoetie", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_crystalshoetip") and cmn.IsEventDone("use_crystalshoeheel") then
      ObjMultiSet( { {"obj_bookshelf_shoebox", { alp = 1, input = 1 }},
                     {"spr_apartmentlivingroom_shelf_box_open", { alp = 1 }} } );
      ObjDelete( "anm_bookshelf_touch_shoebox" );
      ObjDelete( "spr_apartmentlivingroom_shelf_box_closed" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crystaltie", use_crystaltie_beg, private.room_objname );
  cmn.AddSubscriber( "use_crystaltie", use_crystaltie_inv );
  cmn.AddSubscriber( "use_crystaltie", use_crystaltie_end, private.room_objname );
  cmn.AddSubscriber( "use_crystaltie_inv", use_crystaltie_inv, private.room_objname );
  cmn.AddSubscriber( "use_crystaltie_beg", use_crystaltie_beg, private.room_objname );
  cmn.AddSubscriber( "use_crystaltie_end", use_crystaltie_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shoehorn () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_shoehorn" ] = {
      type = "use",
      inv_obj = "inv_shoehorn",
      use_place = "obj_kitchendoor_use_shoehorn",
      room = private.room_objname,
      zz = "zz_kitchendoor",
      zz_gate = "gzz_apartmentlivingroom_kitchendoor"
  };
  --------------------------------------------------------------------------------------------
  local use_shoehorn_inv = function ()
  
    interface.InventoryItemRemove( "inv_shoehorn" );
  
  end;
  local use_shoehorn_beg = function ()
  
    ObjDelete( "obj_kitchendoor_use_shoehorn" );
    ObjDelete( "anm_kitchendoor_touch_door" );
  
  end;
  local use_shoehorn_end = function ()
  
    ObjMultiSet( { {"grm_apartmentlivingroom_kitchen",  { active = 1, input = 1, alp = 1 }},
                   {"spr_apartmentlivingroom_kitchen_open", { alp = 1 }} } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_apartmentlivingroom_kitchen_focus");
    end;
    ObjDelete( "gzz_apartmentlivingroom_kitchendoor" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_shoehorn", use_shoehorn_beg, private.room_objname );
  cmn.AddSubscriber( "use_shoehorn", use_shoehorn_inv );
  cmn.AddSubscriber( "use_shoehorn", use_shoehorn_end, private.room_objname );
  cmn.AddSubscriber( "use_shoehorn_inv", use_shoehorn_inv, private.room_objname );
  cmn.AddSubscriber( "use_shoehorn_beg", use_shoehorn_beg, private.room_objname );
  cmn.AddSubscriber( "use_shoehorn_end", use_shoehorn_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shard () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_shardhall" ] = {
      type = "use",
      inv_obj = "inv_shard",
      use_place = "obj_hallway_use_shard",
      room = private.room_objname,
      zz = "zz_hallway",
      zz_gate = "gzz_apartmentlivingroom_hallway"
  };
  
  game.hint[ "use_shardpurse" ] = {
      type = "use",
      inv_obj = "inv_shard",
      use_place = "obj_complex_purse_use_shard",
      room = "int_complex_inv",
      zz = "inv_complex_purse",
      zz_gate = "inv_purse"
  };
  --------------------------------------------------------------------------------------------
  local use_shard_inv1 = function ()
  
    if cmn.IsEventDone("use_shardpurse") then
      interface.InventoryItemRemove( "inv_shard" );
    end;
  
  end;
  local use_shard_beg1 = function ()
  
    ObjDelete( "obj_hallway_use_shard" );
    ObjDelete( "anm_hallway_slipper_touch" );
  
  end;
  local use_shard_end1 = function ()
  
    ObjSet( "obj_hallway_slipper", { input = 1, alp = 1 } );
    ObjDelete( "anm_hallway_use_shard" );
  
  end;
  
  local use_shard_inv2 = function ()
  
    if cmn.IsEventDone("use_shardhall") then
      interface.InventoryItemRemove( "inv_shard" );
    end;
  
  end;
  local use_shard_beg2 = function ()
  
    ObjDelete( "obj_complex_purse_use_shard" );
    ObjDelete( "anm_complex_purse_touch" );
  
  end;
  local use_shard_end2 = function ()
  
    ObjDelete( "anm_complex_purse_use_shard" );
  
    ObjSet("obj_complex_purse_open",  { alp = 1, input = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_shardhall", use_shard_beg1, private.room_objname );
  cmn.AddSubscriber( "use_shardhall", use_shard_inv1 );
  cmn.AddSubscriber( "use_shardhall", use_shard_end1, private.room_objname );
  cmn.AddSubscriber( "use_shard_inv1", use_shard_inv1, private.room_objname );
  cmn.AddSubscriber( "use_shard_beg1", use_shard_beg1, private.room_objname );
  cmn.AddSubscriber( "use_shard_end1", use_shard_end1, private.room_objname );
  
  cmn.AddSubscriber( "use_shardpurse", use_shard_beg2, "inv_complex_purse" );
  cmn.AddSubscriber( "use_shardpurse", use_shard_inv2 );
  cmn.AddSubscriber( "use_shardpurse", use_shard_end2, "inv_complex_purse" );
  cmn.AddSubscriber( "use_shard_inv2", use_shard_inv2 );
  cmn.AddSubscriber( "use_shard_beg2", use_shard_beg2, "inv_complex_purse" );
  cmn.AddSubscriber( "use_shard_end2", use_shard_end2, "inv_complex_purse" );
  --------------------------------------------------------------------------------------------
  -- function use_hintletter () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hintletter" ] = {
      type = "use",
      inv_obj = "inv_hintletter",
      use_place = "obj_hallway_use_hintletter",
      room = private.room_objname,
      zz = "zz_hallway",
      zz_gate = "gzz_apartmentlivingroom_hallway"
  };
  --------------------------------------------------------------------------------------------
  local use_hintletter_inv = function ()
  
    interface.InventoryItemRemove( "inv_hintletter" );
  
  end;
  local use_hintletter_beg = function ()
  
    ObjDelete( "obj_hallway_use_hintletter" );
  
  end;
  local use_hintletter_end = function ()
  
    ObjMultiSet( { {"spr_hallway_hintletter", { alp = 1 }},
                   {"obj_hallway_clk_parcelcode", { input = 1 }},
                   {"spr_apartmentlivingroom_hall_parcel_hint", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hintletter", use_hintletter_beg, private.room_objname );
  cmn.AddSubscriber( "use_hintletter", use_hintletter_inv );
  cmn.AddSubscriber( "use_hintletter", use_hintletter_end, private.room_objname );
  cmn.AddSubscriber( "use_hintletter_inv", use_hintletter_inv, private.room_objname );
  cmn.AddSubscriber( "use_hintletter_beg", use_hintletter_beg, private.room_objname );
  cmn.AddSubscriber( "use_hintletter_end", use_hintletter_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cabinethandle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_cabinethandle" ] = {
      type = "use",
      inv_obj = "inv_cabinethandle",
      use_place = "obj_hallway_use_cabinethandle",
      room = private.room_objname,
      zz = "zz_hallway",
      zz_gate = "gzz_apartmentlivingroom_hallway"
  };
  --------------------------------------------------------------------------------------------
  local use_cabinethandle_inv = function ()
  
    interface.InventoryItemRemove( "inv_cabinethandle" );
  
  end;
  local use_cabinethandle_beg = function ()
  
    ObjDelete( "obj_hallway_use_cabinethandle" );
  
  end;
  local use_cabinethandle_end = function ()
  
    ObjDelete( "anm_hallway_door_touch" );
  
    ObjMultiSet( { {"spr_hallway_shoehorn", { input = 1, alp = 1 }},
                   {"obj_hallway_use_broomamulet", { input = 1 }},
                   {"spr_hallway_stand_open", { alp = 1 }},
                   {"spr_apartmentlivingroom_hall_stand_open", { alp = 1 }},
                   {"spr_hallway_shoehorn_sh", { alp = 1 }},
                   {"anm_hallway_toolbox_touch", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cabinethandle", use_cabinethandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_cabinethandle", use_cabinethandle_inv );
  cmn.AddSubscriber( "use_cabinethandle", use_cabinethandle_end, private.room_objname );
  cmn.AddSubscriber( "use_cabinethandle_inv", use_cabinethandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_cabinethandle_beg", use_cabinethandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_cabinethandle_end", use_cabinethandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_broomamulet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_broomamulet" ] = {
      type = "use",
      inv_obj = "inv_broomamulet",
      use_place = "obj_hallway_use_broomamulet",
      room = private.room_objname,
      zz = "zz_hallway",
      zz_gate = "gzz_apartmentlivingroom_hallway"
  };
  --------------------------------------------------------------------------------------------
  local use_broomamulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_broomamulet" );
  
  end;
  local use_broomamulet_beg = function ()
  
    ObjDelete( "obj_hallway_use_broomamulet" );
  
  end;
  local use_broomamulet_end = function ()
  
    ObjMultiSet( { {"obj_hallway_toolbox", { alp = 1, input = 1 }},
                   {"spr_apartmentlivingroom_hall_box_open", { alp = 1 }} } );
    
    ObjDelete( "anm_hallway_toolbox_touch" );
    ObjDelete( "spr_apartmentlivingroom_hall_box_closed" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_broomamulet", use_broomamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_broomamulet", use_broomamulet_inv );
  cmn.AddSubscriber( "use_broomamulet", use_broomamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_broomamulet_inv", use_broomamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_broomamulet_beg", use_broomamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_broomamulet_end", use_broomamulet_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_bedroomkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_bedroomkey" ] = {
    type = "click",
    use_place = "obj_bedroomdoor_clk_bedroomkey",
    room = private.room_objname,
    zz = "zz_bedroomdoor",
    zz_gate = "gzz_apartmentlivingroom_bedroomdoor"
  };
  --------------------------------------------------------------------------------------------
  local clk_bedroomkey_beg = function ()
  
    ObjDelete( "obj_bedroomdoor_clk_bedroomkey" );
  
  end;
  local clk_bedroomkey_end = function ()
  
    ObjMultiSet( { {"grm_apartmentlivingroom_bedroom", { active = 1, alp = 1, input = 1 }},
                   {"spr_apartmentlivingroom_bedroom_open", { alp = 1 }} } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_apartmentlivingroom_bedroom_focus");
    end;
    ObjDelete( "gzz_apartmentlivingroom_bedroomdoor" );
    ObjDelete( "spr_apartmentlivingroom_bedroom_key" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_bedroomkey", clk_bedroomkey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bedroomkey", clk_bedroomkey_end, private.room_objname );
  cmn.AddSubscriber( "clk_bedroomkey_beg", clk_bedroomkey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bedroomkey_end", clk_bedroomkey_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_parcelcode1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_parcelcode1" ] = {
    type = "click",
    use_place = "obj_hallway_clk_parcelcode1",
    room = private.room_objname,
    zz = "zz_hallway",
    zz_gate = "gzz_apartmentlivingroom_hallway"
  };
  --------------------------------------------------------------------------------------------
  local clk_parcelcode1 = function ()
  
    ObjSet("spr_hallway_parcel_wheel_1",  { alp = 1 });
    ObjDelete( "obj_hallway_clk_parcelcode1" );
    
    if cmn.IsEventDone("clk_parcelcode4") and cmn.IsEventDone("clk_parcelcode2") and cmn.IsEventDone("clk_parcelcode3") then
      ObjMultiSet( { {"obj_hallway_parcel", { alp = 1, input = 1 }},
                     {"spr_apartmentlivingroom_hall_parcel_open", { alp = 1 }} } );
      ObjDelete( "anm_hallway_parcel_touch" );
      ObjDelete( "spr_apartmentlivingroom_hall_parcel_closed" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_parcelcode1", clk_parcelcode1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_parcelcode2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_parcelcode2" ] = {
    type = "click",
    use_place = "obj_hallway_clk_parcelcode2",
    room = private.room_objname,
    zz = "zz_hallway",
    zz_gate = "gzz_apartmentlivingroom_hallway"
  };
  --------------------------------------------------------------------------------------------
  local clk_parcelcode2 = function ()
  
    ObjSet("spr_hallway_parcel_wheel_2",  { alp = 1 });
    ObjDelete( "obj_hallway_clk_parcelcode2" );
    
    if cmn.IsEventDone("clk_parcelcode1") and cmn.IsEventDone("clk_parcelcode3") and cmn.IsEventDone("clk_parcelcode4") then
      ObjMultiSet( { {"obj_hallway_parcel", { alp = 1, input = 1 }},
                     {"spr_apartmentlivingroom_hall_parcel_open", { alp = 1 }} } );
      ObjDelete( "anm_hallway_parcel_touch" );
      ObjDelete( "spr_apartmentlivingroom_hall_parcel_closed" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_parcelcode2", clk_parcelcode2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_parcelcode3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_parcelcode3" ] = {
    type = "click",
    use_place = "obj_hallway_clk_parcelcode3",
    room = private.room_objname,
    zz = "zz_hallway",
    zz_gate = "gzz_apartmentlivingroom_hallway"
  };
  --------------------------------------------------------------------------------------------
  local clk_parcelcode3 = function ()
  
    ObjSet("spr_hallway_parcel_wheel_3_1",  { alp = 1 });
    
    if cmn.IsEventDone("clk_parcelcode1") and cmn.IsEventDone("clk_parcelcode2") and cmn.IsEventDone("clk_parcelcode4") then
      ObjMultiSet( { {"obj_hallway_parcel", { alp = 1, input = 1 }},
                     {"spr_apartmentlivingroom_hall_parcel_open", { alp = 1 }} } );
      ObjDelete( "anm_hallway_parcel_touch" );
      ObjDelete( "spr_apartmentlivingroom_hall_parcel_closed" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_parcelcode3", clk_parcelcode3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_parcelcode4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_parcelcode4" ] = {
    type = "click",
    use_place = "obj_hallway_clk_parcelcode4",
    room = private.room_objname,
    zz = "zz_hallway",
    zz_gate = "gzz_apartmentlivingroom_hallway"
  };
  --------------------------------------------------------------------------------------------
  local clk_parcelcode4 = function ()
  
    ObjSet("spr_hallway_parcel_wheel_3_2",  { alp = 1 });
    ObjDelete( "obj_hallway_clk_parcelcode3" );
    ObjDelete( "spr_hallway_parcel_wheel_3_1" );
    
    if cmn.IsEventDone("clk_parcelcode1") and cmn.IsEventDone("clk_parcelcode2") and cmn.IsEventDone("clk_parcelcode3") then
      ObjMultiSet( { {"obj_hallway_parcel", { alp = 1, input = 1 }},
                     {"spr_apartmentlivingroom_hall_parcel_open", { alp = 1 }} } );
      ObjDelete( "anm_hallway_parcel_touch" );
      ObjDelete( "spr_apartmentlivingroom_hall_parcel_closed" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_parcelcode4", clk_parcelcode4, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_apartmentlivingroom () end;
  --------------------------------------------------------------------------------------------
  local opn_apartmentlivingroom = function ()
  
    int_map_impl.OpenRoom( "rm_apartmentlivingroom" );
    common_impl.AddAvailibleMusic( 4 );
    interface_impl.SetCurrentGlobalTask( 3 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_apartmentlivingroom", opn_apartmentlivingroom );
  --------------------------------------------------------------------------------------------
  -- function opn_apartmenthuntsman () end;
  --------------------------------------------------------------------------------------------
  local opn_apartmenthuntsman_map = function ()
  
    int_map_impl.BlockRoom( "rm_nearhome" );
  
  end;
  local opn_apartmenthuntsman_loc = function ()
  
    --ObjDelete("grm_apartmentlivingroom_nearhome");
    ObjSet("grm_apartmentlivingroom_nearhome",  { event_mdown = "", event_mup = function() cmn.ShowBbt( "apartmentlivingroom_no_going_back" ); end });
  
    if port.isPortable() == 1 then
      port.GrmEventLightOff("grm_apartmentlivingroom_nearhome_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_apartmenthuntsman", opn_apartmenthuntsman_map );
  cmn.AddSubscriber( "opn_apartmenthuntsman", opn_apartmenthuntsman_loc, private.room_objname );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_bookshelf" );
  
  function zz_bookshelf.PreOpen()
    
    if not(cmn.IsEventDone( "win_bookshelf" )) then
      private.zz_bookshelf.DrawScene();
    end;

  end;

  function zz_bookshelf.PreClose()
    
    if ( cmn.IsEventDone( "use_woodenring" ) and not(cmn.IsEventDone( "win_bookshelf" )) ) then
      private.zz_bookshelf.active = 0;
      cmn.MiniGameHide("bookshelf");
    end;

  end;

  function zz_bookshelf.Close()
    
    if ( cmn.IsEventDone( "use_woodenring" ) and not(cmn.IsEventDone( "win_bookshelf" )) ) then
      ObjSet("obj_bookshelf_game",  { alp = 0, input = 0 });
    end;
                   
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_bookshelf" ].state) then 
    private.zz_bookshelf.StartConditions();
  end;

  private.zz_bookshelf.state = ng_global.progress[ ng_global.currentprogress ][ "win_bookshelf" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()
  
  private.opn_apartmentlivingroom();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/aud_apartmentlivingroom_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/aud_apartmentlivingroom_env");
  
  if not cmn.IsEventDone("opn_apartmentlivingroom") then
    cmn.Lock(1);
  end;
  
  if cmn.IsEventDone("get_magicpagepiece4") or ( cmn.IsEventDone("get_evilqueenfigurine") and not cmn.IsEventDone("opn_apartmenthuntsman") ) then
    cmn.Lock(1);
  end;
  
  if cmn.IsEventDone("use_valeriansolution") then
    common_impl.current_dialog = "";
  end;
  
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(2) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_silversnake()

  local item = "inv_silversnake";

  if cmn.ApplyObj( item, "gzz_apartmentlivingroom_bureau" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bureau" );

  elseif ( cmn.ApplyObj( item, "obj_bureau_use_silversnake" ) ) then

    cmn.CallEventHandler( "use_silversnake_inv" );
    cmn.CallEventHandler( "use_silversnake_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_silversnake" );
      cmn.CallEventHandler( "use_silversnake_end" );
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_opn_small_box");
    
      ObjAnimate("obj_bureau_box_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_bureau_box_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_use_metal_amulet");

    if cmn.IsEventDone("use_bronzesnake") then
      ObjAnimate( "spr_bureau_silversnake", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,    0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_bureau_silversnake", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bronzesnake()

  local item = "inv_bronzesnake";

  if cmn.ApplyObj( item, "gzz_apartmentlivingroom_bureau" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bureau" );

  elseif ( cmn.ApplyObj( item, "obj_bureau_use_silversnake" ) ) then

    cmn.CallEventHandler( "use_bronzesnake_inv" );
    cmn.CallEventHandler( "use_bronzesnake_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_bronzesnake" );
      cmn.CallEventHandler( "use_bronzesnake_end" );
    
    end;

    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_opn_small_box");
    
      ObjAnimate("obj_bureau_box_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_bureau_box_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_use_metal_amulet");

    if cmn.IsEventDone("use_silversnake") then
      ObjAnimate( "spr_bureau_bronzesnake", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,    0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_bureau_bronzesnake", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_evilqueenfigurine()

  local item = "inv_evilqueenfigurine";

  if cmn.ApplyObj( item, "gzz_apartmentlivingroom_bureau" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bureau" );

  elseif ( cmn.ApplyObj( item, "obj_bureau_use_evilqueenfigurine" ) ) then

    cmn.CallEventHandler( "use_evilqueenfigurine_inv" );
    cmn.CallEventHandler( "use_evilqueenfigurine_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_evilqueenfigurine" );
      cmn.CallEventHandler( "use_evilqueenfigurine_end" );
    
    end;

    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_slide_wood");
    
      ObjMultiSet( { {"anm_bureau_stash_open", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_bureau_stash_touch", { alp = 0 }} } );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_wood_small");

    if cmn.IsEventDone("use_huntsmanfigurine") and cmn.IsEventDone("use_cinderellafigurine") then
      ObjAnimate( "anm_bureau_queen_touch", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,    0.6, 0, 1 } );
    else 
      ObjAnimate( "anm_bureau_queen_touch", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_huntsmanfigurine()

  local item = "inv_huntsmanfigurine";

  if cmn.ApplyObj( item, "gzz_apartmentlivingroom_bureau" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bureau" );

  elseif ( cmn.ApplyObj( item, "obj_bureau_use_evilqueenfigurine" ) ) then

    cmn.CallEventHandler( "use_huntsmanfigurine_inv" );
    cmn.CallEventHandler( "use_huntsmanfigurine_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_huntsmanfigurine" );
      cmn.CallEventHandler( "use_huntsmanfigurine_end" );
    
    end;

    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_slide_wood");
    
      ObjMultiSet( { {"anm_bureau_stash_open", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_bureau_stash_touch", { alp = 0 }} } );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_wood_small");

    if cmn.IsEventDone("use_evilqueenfigurine") and cmn.IsEventDone("use_cinderellafigurine") then
      ObjAnimate( "anm_bureau_hunter_touch", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,    0.6, 0, 1 } );
    else 
      ObjAnimate( "anm_bureau_hunter_touch", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_cinderellafigurine()

  local item = "inv_cinderellafigurine";

  if cmn.ApplyObj( item, "gzz_apartmentlivingroom_bureau" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bureau" );

  elseif ( cmn.ApplyObj( item, "obj_bureau_use_evilqueenfigurine" ) ) then

    cmn.CallEventHandler( "use_cinderellafigurine_inv" );
    cmn.CallEventHandler( "use_cinderellafigurine_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_cinderellafigurine" );
      cmn.CallEventHandler( "use_cinderellafigurine_end" );
    
    end;

    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_slide_wood");
    
      ObjMultiSet( { {"anm_bureau_stash_open", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_bureau_stash_touch", { alp = 0 }} } );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_wood_small");

    if cmn.IsEventDone("use_evilqueenfigurine") and cmn.IsEventDone("use_huntsmanfigurine") then
      ObjAnimate( "anm_bureau_cindy_touch", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,    0.6, 0, 1 } );
    else 
      ObjAnimate( "anm_bureau_cindy_touch", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bedroomkey()

  local item = "inv_bedroomkey";

  if cmn.ApplyObj( item, "gzz_apartmentlivingroom_bedroomdoor" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bedroomdoor" );

  elseif ( cmn.ApplyObj( item, "obj_bedroomdoor_use_bedroomkey" ) ) then

    cmn.CallEventHandler( "use_bedroomkey_inv" );
    cmn.CallEventHandler( "use_bedroomkey_beg" );

    local func_after = function ()

      cmn.Lock( 0 );
      cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_use_key_doctorstudy");

      cmn.SetEventDone( "use_bedroomkey" );
      cmn.CallEventHandler( "use_bedroomkey_end" );
      
    end;

    cmn.Lock( 1 );
    --cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_use_key_doctorstudy");

    ObjSet("anm_bedroomdoor_use_key",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_cleanhanky()

  local item = "inv_cleanhanky";

  if cmn.ApplyObj( item, "gzz_apartmentlivingroom_woundedcat" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_woundedcat" );

  elseif ( cmn.ApplyObj( item, "obj_woundedcat_use_cleanhanky" ) ) then

    cmn.CallEventHandler( "use_cleanhanky_inv" );
    cmn.CallEventHandler( "use_cleanhanky_beg" );

    local func_after = function ()

      cmn.SetEventDone( "use_cleanhanky" );
      
      if not cmn.IsEventDone("use_antiseptic") then
        cmn.ShowBbt( "obj_woundedcat_use_antiseptic" );
      end;
      
      if cmn.IsEventDone("use_antiseptic") and cmn.IsEventDone("use_valeriansolution") then
        private.dialog_cat_open( "use_cleanhanky_end" );
      else 
        cmn.Lock(0);
        cmn.CallEventHandler( "use_cleanhanky_end" );
      end;
    
    end;
    
    local anm_valerian = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_use_valerian");
      
      ObjSet("anm_woundedcat_use_valerian",  { alp = 1, playing = 1, endtrig = func_after });
      ObjAnimate( "spr_woundedcat_valerian_1", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_use_bandage");

    if cmn.IsEventDone("use_antiseptic") then
      if cmn.IsEventDone("use_valeriansolution") then
        ObjAnimate( "spr_woundedcat_cat_hanky", "alp", 0, 0, anm_valerian, { 0, 0, 0,   0.5, 0, 1 } );
      else
        ObjAnimate( "spr_woundedcat_cat_hanky", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 } );
      end;
    else 
      ObjAnimate( "spr_woundedcat_hanky_1", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_antiseptic()

  local item = "inv_antiseptic";

  if cmn.ApplyObj( item, "gzz_apartmentlivingroom_woundedcat" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_woundedcat" );

  elseif ( cmn.ApplyObj( item, "obj_woundedcat_use_antiseptic" ) ) then

    cmn.CallEventHandler( "use_antiseptic_inv" );
    cmn.CallEventHandler( "use_antiseptic_beg" );

    local func_after = function ()

      cmn.SetEventDone( "use_antiseptic" );
      
      if cmn.IsEventDone("use_cleanhanky") and cmn.IsEventDone("use_valeriansolution") then
        private.dialog_cat_open( "use_antiseptic_end" );
      else 
        cmn.Lock(0);
        cmn.CallEventHandler( "use_antiseptic_end" );
      end;
    
    end;
    
    local anm_valerian = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_use_valerian");
      
      ObjSet("anm_woundedcat_use_valerian",  { alp = 1, playing = 1, endtrig = func_after });
      ObjAnimate( "spr_woundedcat_valerian_1", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 } );
      
    end;
    
    local anm_hanky = function ()
      
      ObjDelete( "anm_woundedcat_use_antiseptic" );
      ObjSet("spr_woundedcat_cat_antiseptic",  { alp = 1 });
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_use_bandage");
      
      if cmn.IsEventDone("use_valeriansolution") then
        ObjAnimate( "spr_woundedcat_cat_hanky", "alp", 0, 0, anm_valerian, { 0, 0, 0,   0.5, 0, 1 } );
        ObjAnimate( "spr_woundedcat_hanky_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 } );
      else 
        ObjAnimate( "spr_woundedcat_cat_hanky", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 } );
        ObjAnimate( "spr_woundedcat_hanky_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 } );
      end;
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_use_antiseptic");

    if cmn.IsEventDone("use_cleanhanky") then
      ObjSet("anm_woundedcat_use_antiseptic",  { alp = 1, playing = 1, endtrig = anm_hanky });
    else 
      ObjSet("anm_woundedcat_use_antiseptic",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_valeriansolution()

  local item = "inv_valeriansolution";

  if cmn.ApplyObj( item, "gzz_apartmentlivingroom_woundedcat" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_woundedcat" );

  elseif ( cmn.ApplyObj( item, "obj_woundedcat_use_valeriansolution" ) ) then

    cmn.CallEventHandler( "use_valeriansolution_inv" );
    cmn.CallEventHandler( "use_valeriansolution_beg" );

    local func_after = function ()
    
      cmn.SetEventDone( "use_valeriansolution" );
      
      if cmn.IsEventDone("use_cleanhanky") and cmn.IsEventDone("use_antiseptic") then
        private.dialog_cat_open( "use_valeriansolution_end" );
      else 
        cmn.Lock(0);
        cmn.CallEventHandler( "use_valeriansolution_end" );
      end;
    
    end;

    cmn.Lock( 1 );
    
    if cmn.IsEventDone("use_cleanhanky") and cmn.IsEventDone("use_antiseptic") then
      cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_use_valerian");
      ObjSet("anm_woundedcat_use_valerian",  { alp = 1, playing = 1, endtrig = func_after });
    else 
      ObjAnimate("spr_woundedcat_valerian_1", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_woodenring()

  local item = "inv_woodenring";

  if cmn.ApplyObj( item, "gzz_apartmentlivingroom_bookshelf" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bookshelf" );

  elseif ( cmn.ApplyObj( item, "obj_bookshelf_use_woodenring" ) ) then

    cmn.CallEventHandler( "use_woodenring_inv" );
    cmn.CallEventHandler( "use_woodenring_beg" );

    local func_after = function ()

      --cmn.Lock( 0 );

      cmn.SetEventDone( "use_woodenring" );
      --cmn.CallEventHandler( "use_woodenring_end" );
      
      public.zz_bookshelf.OpenMg(1);
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_use_disk");

    ObjAnimate( "spr_bookshelf_disk", "alp", 0, 0, func_after,
    {
      0.0, 0, 0, 
      0.3, 0, 1,
      0.6, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_wheel()

  local item = "inv_wheel";

  if cmn.ApplyObj( item, "gzz_apartmentlivingroom_bookshelf" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bookshelf" );

  elseif ( cmn.ApplyObj( item, "obj_bookshelf_use_wheel" ) ) then

    cmn.CallEventHandler( "use_wheel_inv" );
    cmn.CallEventHandler( "use_wheel_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_wheel" );
      cmn.CallEventHandler( "use_wheel_end" );
    
    end;
    
    if not cmn.IsEventDone("get_bell") then
      public.get_bell();
    end;

    local anm_open = function ()
      
      ObjAnimate("anm_bookshelf_touch_carriage", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_bookshelf_carriage_open", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_use_wheel");

    ObjAnimate( "spr_bookshelf_carriage_wheel", "alp", 0, 0, anm_open,
    {
      0.0, 0, 0, 
      0.3, 0, 1,
      0.6, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_crystalshoetip()

  local item = "inv_crystalshoetip";

  if cmn.ApplyObj( item, "gzz_apartmentlivingroom_bookshelf" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bookshelf" );

  elseif ( cmn.ApplyObj( item, "obj_bookshelf_use_crystaltie" ) ) then

    cmn.CallEventHandler( "use_crystalshoetip_inv" );
    cmn.CallEventHandler( "use_crystalshoetip_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_crystalshoetip" );
      cmn.CallEventHandler( "use_crystalshoetip_end" );
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_opn_small_box2");

      ObjAnimate("anm_bookshelf_touch_shoebox", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("obj_bookshelf_shoebox", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_clk_small_part");

    if cmn.IsEventDone("use_crystalshoeheel") and cmn.IsEventDone("use_crystaltie") then
      ObjAnimate( "spr_bookshelf_shoe_tip", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_bookshelf_shoe_tip", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_crystalshoeheel()

  local item = "inv_crystalshoeheel";

  if cmn.ApplyObj( item, "gzz_apartmentlivingroom_bookshelf" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bookshelf" );

  elseif ( cmn.ApplyObj( item, "obj_bookshelf_use_crystaltie" ) ) then

    cmn.CallEventHandler( "use_crystalshoeheel_inv" );
    cmn.CallEventHandler( "use_crystalshoeheel_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_crystalshoeheel" );
      cmn.CallEventHandler( "use_crystalshoeheel_end" );
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_opn_small_box2");

      ObjAnimate("anm_bookshelf_touch_shoebox", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("obj_bookshelf_shoebox", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_clk_small_part");

    if cmn.IsEventDone("use_crystalshoetip") and cmn.IsEventDone("use_crystaltie") then
      ObjAnimate( "spr_bookshelf_shoe_heel", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_bookshelf_shoe_heel", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_crystaltie()

  local item = "inv_crystaltie";

  if cmn.ApplyObj( item, "gzz_apartmentlivingroom_bookshelf" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bookshelf" );

  elseif ( cmn.ApplyObj( item, "obj_bookshelf_use_crystaltie" ) ) then

    cmn.CallEventHandler( "use_crystaltie_inv" );
    cmn.CallEventHandler( "use_crystaltie_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_crystaltie" );
      cmn.CallEventHandler( "use_crystaltie_end" );
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_opn_small_box2");

      ObjAnimate("anm_bookshelf_touch_shoebox", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("obj_bookshelf_shoebox", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_clk_small_part");

    if cmn.IsEventDone("use_crystalshoetip") and cmn.IsEventDone("use_crystalshoeheel") then
      ObjAnimate( "spr_bookshelf_shoe_tie", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_bookshelf_shoe_tie", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_shoehorn()

  local item = "inv_shoehorn";

  if cmn.ApplyObj( item, "gzz_apartmentlivingroom_kitchendoor" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_kitchendoor" );

  elseif ( cmn.ApplyObj( item, "obj_kitchendoor_use_shoehorn" ) ) then

    cmn.CallEventHandler( "use_shoehorn_inv" );
    cmn.CallEventHandler( "use_shoehorn_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_shoehorn" );
      cmn.CallEventHandler( "use_shoehorn_end" );
      
      common.CloseSubRoom();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_opn_kitchen");

    ObjSet("anm_kitchendoor_use_shoehorn",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_shard()

  local item = "inv_shard";

  if cmn.ApplyObj( item, "gzz_apartmentlivingroom_hallway" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_hallway" );

  elseif ( cmn.ApplyObj( item, "obj_hallway_use_shard" ) ) then

    cmn.CallEventHandler( "use_shard_inv1" );
    cmn.CallEventHandler( "use_shard_beg1" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_shardhall" );
      cmn.CallEventHandler( "use_shard_end1" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_use_splinter");

    ObjSet("anm_hallway_use_shard",  { alp = 1, playing = 1, endtrig = func_after });
    
  elseif cmn.ObjIntersectCheck( item, "obj_complex_purse_use_shard" )  then

    cmn.CallEventHandler( "use_shard_inv2", "inv_complex_purse" );
    cmn.CallEventHandler( "use_shard_beg2", "inv_complex_purse" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_shardpurse" );
      cmn.CallEventHandler( "use_shard_end2", "inv_complex_purse" );
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_purse/audio/aud_use_splinter1");

    ObjSet("anm_complex_purse_use_shard",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hintletter()

  local item = "inv_hintletter";

  if cmn.ApplyObj( item, "gzz_apartmentlivingroom_hallway" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_hallway" );

  elseif ( cmn.ApplyObj( item, "obj_hallway_use_hintletter" ) ) then

    cmn.CallEventHandler( "use_hintletter_inv" );
    cmn.CallEventHandler( "use_hintletter_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_hintletter" );
      cmn.CallEventHandler( "use_hintletter_end" );
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_use_small_paper");

    ObjAnimate( "spr_hallway_hintletter", "alp", 0, 0, func_after,
    {
      0.0, 0, 0, 
      0.3, 0, 1
    } );
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_cabinethandle()

  local item = "inv_cabinethandle";

  if cmn.ApplyObj( item, "gzz_apartmentlivingroom_hallway" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_hallway" );

  elseif ( cmn.ApplyObj( item, "obj_hallway_use_cabinethandle" ) ) then

    cmn.CallEventHandler( "use_cabinethandle_inv" );
    cmn.CallEventHandler( "use_cabinethandle_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_cabinethandle" );
      cmn.CallEventHandler( "use_cabinethandle_end" );
    
    end;

    local anm_open_door = function ()
    
      ObjAnimate("anm_hallway_door_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_hallway_stand_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_use_handle_safe");
    
    ObjMultiSet( { {"spr_hallway_shoehorn", { alp = 1 }},
                   {"spr_hallway_shoehorn_sh", { alp = 1 }},
                   {"anm_hallway_toolbox_touch", { alp = 1 }} } );

    ObjAnimate( "spr_hallway_stand_handle", "alp", 0, 0, anm_open_door,
    {
      0.0, 0, 0, 
      0.3, 0, 1,
      0.6, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_broomamulet()

  local item = "inv_broomamulet";

  if cmn.ApplyObj( item, "gzz_apartmentlivingroom_hallway" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_hallway" );

  elseif ( cmn.ApplyObj( item, "obj_hallway_use_broomamulet" ) and cmn.IsEventDone("use_cabinethandle") ) then

    cmn.CallEventHandler( "use_broomamulet_inv" );
    cmn.CallEventHandler( "use_broomamulet_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_broomamulet" );
      cmn.CallEventHandler( "use_broomamulet_end" );
    
    end;

    local anm_open_box = function ()
    
      ObjAnimate("anm_hallway_toolbox_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("obj_hallway_toolbox", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_opn_small_box");

    ObjAnimate( "spr_hallway_toolbox_broom", "alp", 0, 0, anm_open_box,
    {
      0.0, 0, 0, 
      0.3, 0, 1,
      0.6, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_snowball()

  cmn.SetEventDone( "get_snowball" );
  cmn.CallEventHandler( "get_snowball" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_valeriansolution()

  cmn.SetEventDone( "get_valeriansolution" );
  cmn.CallEventHandler( "get_valeriansolution" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_lettera") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_lettera()

  cmn.SetEventDone( "get_lettera" );
  cmn.CallEventHandler( "get_lettera" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_valeriansolution") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_shard()

  cmn.SetEventDone( "get_shard" );
  cmn.CallEventHandler( "get_shard" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_magicpagepiece1") and cmn.IsEventDone("get_clockhand2") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_magicpagepiece1()

  cmn.SetEventDone( "get_magicpagepiece1" );
  cmn.CallEventHandler( "get_magicpagepiece1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_shard") and cmn.IsEventDone("get_clockhand2") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_clockhand2()

  cmn.SetEventDone( "get_clockhand2" );
  cmn.CallEventHandler( "get_clockhand2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_shard") then
    common.CloseSubRoom();
  end;
  
  if not cmn.IsEventDone("get_magicpagepiece1") then
    cmn.SetEventDone( "get_magicpagepiece1" );
    cmn.CallEventHandler( "get_magicpagepiece1" );
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_bell()

  cmn.SetEventDone( "get_bell" );
  cmn.CallEventHandler( "get_bell" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_bronzesnake()

  cmn.SetEventDone( "get_bronzesnake" );
  cmn.CallEventHandler( "get_bronzesnake" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_clockhand1()

  cmn.SetEventDone( "get_clockhand1" );
  cmn.CallEventHandler( "get_clockhand1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_bedroomkey()

  cmn.SetEventDone( "get_bedroomkey" );
  cmn.CallEventHandler( "get_bedroomkey" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  cmn.ShowDlgBbt( "chesire_voice_zz", 1 );
  cmn.PlayAudio("voc", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_cat_dlg_2_1_voc");

end;
--------------------------------------------------------------------------------------------
function public.get_crystalshoe()

  cmn.SetEventDone( "get_crystalshoe" );
  cmn.CallEventHandler( "get_crystalshoe" );
  
  local func_after = function ()
    ObjSet("rm_apartmentlivingroom",  { color_r = 0, color_g = 0, color_b = 0 });
    cmn.GotoRoom("rm_nearcastle");
  end;

  if not cmn.IsEventDone("get_magicpagepiece4") then
    public.get_magicpagepiece4();
  else 
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
    common.CloseSubRoom();
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level1/rm_apartmentlivingroom/vid_teleport", func_after, "assets/levels/level1/rm_apartmentlivingroom/audio/aud_teleport", "");
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_magicpagepiece4()

  cmn.SetEventDone( "get_magicpagepiece4" );
  cmn.CallEventHandler( "get_magicpagepiece4" );
  
  local func_after = function ()
    ObjSet("rm_apartmentlivingroom",  { color_r = 0, color_g = 0, color_b = 0 });
    cmn.GotoRoom("rm_nearcastle");
    cmn.CallEventHandler("opn_nearcastle");
  end;

  if not cmn.IsEventDone("get_crystalshoe") then
    public.get_crystalshoe();
  else 
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
    common.CloseSubRoom();
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level1/rm_apartmentlivingroom/vid_teleport", func_after, "assets/levels/level1/rm_apartmentlivingroom/audio/aud_teleport", "");
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_clockhand3()

  cmn.SetEventDone( "get_clockhand3" );
  cmn.CallEventHandler( "get_clockhand3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_number12") and cmn.IsEventDone("get_cinderellafigurine") and cmn.IsEventDone("get_mappart")
  and cmn.IsEventDone("get_shoehorn") and cmn.IsEventDone("get_hairdryer") and cmn.IsEventDone("get_line") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_number12()

  cmn.SetEventDone( "get_number12" );
  cmn.CallEventHandler( "get_number12" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_clockhand3") and cmn.IsEventDone("get_cinderellafigurine") and cmn.IsEventDone("get_mappart")
  and cmn.IsEventDone("get_shoehorn") and cmn.IsEventDone("get_hairdryer") and cmn.IsEventDone("get_line") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_cinderellafigurine()

  cmn.SetEventDone( "get_cinderellafigurine" );
  cmn.CallEventHandler( "get_cinderellafigurine" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_clockhand3") and cmn.IsEventDone("get_number12") and cmn.IsEventDone("get_mappart")
  and cmn.IsEventDone("get_shoehorn") and cmn.IsEventDone("get_hairdryer") and cmn.IsEventDone("get_line") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_mappart()

  cmn.SetEventDone( "get_mappart" );
  cmn.CallEventHandler( "get_mappart" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_clockhand3") and cmn.IsEventDone("get_number12") and cmn.IsEventDone("get_cinderellafigurine")
  and cmn.IsEventDone("get_shoehorn") and cmn.IsEventDone("get_hairdryer") and cmn.IsEventDone("get_line") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_shoehorn()

  cmn.SetEventDone( "get_shoehorn" );
  cmn.CallEventHandler( "get_shoehorn" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_clockhand3") and cmn.IsEventDone("get_number12") and cmn.IsEventDone("get_cinderellafigurine")
  and cmn.IsEventDone("get_mappart") and cmn.IsEventDone("get_hairdryer") and cmn.IsEventDone("get_line") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_hairdryer()

  cmn.SetEventDone( "get_hairdryer" );
  cmn.CallEventHandler( "get_hairdryer" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_clockhand3") and cmn.IsEventDone("get_number12") and cmn.IsEventDone("get_cinderellafigurine")
  and cmn.IsEventDone("get_mappart") and cmn.IsEventDone("get_shoehorn") and cmn.IsEventDone("get_line") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_line()

  cmn.SetEventDone( "get_line" );
  cmn.CallEventHandler( "get_line" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_clockhand3") and cmn.IsEventDone("get_number12") and cmn.IsEventDone("get_cinderellafigurine")
  and cmn.IsEventDone("get_mappart") and cmn.IsEventDone("get_shoehorn") and cmn.IsEventDone("get_hairdryer") then
    common.CloseSubRoom();
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_bedroomkey()

  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_opn_bedroom");

  local func_after = function ()
  
    cmn.Lock( 0 );

    cmn.SetEventDone( "clk_bedroomkey" );
    cmn.CallEventHandler( "clk_bedroomkey" );

    common.CloseSubRoom();

  end;
  
  ObjSet("anm_bedroomdoor_clk_key",  { playing = 1, endtrig = func_after });
  
end;
--------------------------------------------------------------------------------------------
function public.clk_parcelcode( num )
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_clk_button");
  
  if num == 3 and cmn.IsEventDone("clk_parcelcode3") then
    num = 4;
  end;
  
  local func_after = function ()
  
    cmn.Lock( 0 );

    cmn.SetEventDone( "clk_parcelcode"..num );
    cmn.CallEventHandler( "clk_parcelcode"..num  );

  end;
  
  local anm_win = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_opn_box1");
  
    ObjAnimate("anm_hallway_parcel_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 1,   1, 0, 0 });
    ObjAnimate("obj_hallway_parcel", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 0,   1, 0, 1 });

  end;
  
  local final_func = func_after;
  local check = 0;
  
  for i = 1, 4, 1 do
    
    if num ~= i and cmn.IsEventDone("clk_parcelcode"..i) then
      check = check+1;
    end;
    
  end;
  
  if check == 3 then
    final_func =  anm_win;
  end;
  
  if num < 3 then
    ObjAnimate("spr_hallway_parcel_wheel_"..num, "alp", 0, 0, final_func, { 0, 0, 0,   0.3, 0, 1 });
  elseif num == 3 then
    ObjAnimate("spr_hallway_parcel_wheel_3_1", "alp", 0, 0, final_func, { 0, 0, 0,   0.3, 0, 1 });
  else
    ObjAnimate("spr_hallway_parcel_wheel_3_2", "alp", 0, 0, final_func, { 0, 0, 0,   0.3, 0, 1 });
    ObjAnimate("spr_hallway_parcel_wheel_3_1", "alp", 0, 0, final_func, { 0, 0, 1,   0.3, 0, 0 });
  end;
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_apartmentlivingroom()

  if not ( cmn.IsEventDone( "opn_apartmentlivingroom" ) ) then
    
    local func_after = function ()
    
      cmn.Lock(0);
      cmn.CallEventHandler("opn_apartmentlivingroom");
      --cmn.ShowBbt( "apartmentlivingroom_open_voice" );
      --cmn.PlayAudio("voc", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_zoom_voc");
      interface_impl.ShowGlobalTask();
      int_blackbartext.Hide();
      
      local arrows = { { pos_x = -310, pos_y = 220, ang = 2.6 } };
      cmn.TutorialShow( "tutor_10", 0, 450, 384, arrows );
      
    end;
    
    local play_voice = function ()
    
      cmn.ShowDlgBbt( "apartmentlivingroom_open_voice" );
      cmn.PlayAudio("voc", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_zoom_voc");
      
    end;
    
    ObjSet("tmr_apartmentlivingroom_timer",  { time = 2.5, playing = 1, endtrig = play_voice });
    
    cmn.SetEventDone( "opn_apartmentlivingroom" );
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_track4_mus_env");
    
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_zoom");
    
    ObjAnimate("rm_apartmentlivingroom", "pos_xy", 0, 0, "", { 0, 2, 0, 0,   1, 2, 0, -93,   1.6, 1, -5, -93,   2.2, 1, 0, -88,   3, 1, -5, -88,   
     4, 2, -962, -289,   4.6, 2, -950, -289,    5.2, 1, -950, -284,   6, 1, -968, -284,    
     7, 2, 0, -653,   7.6, 2, -10, -653,    8.2, 2, 0, -647,   9, 1, -5, -647,    10, 0, 0, 0 });
    ObjAnimate( "rm_apartmentlivingroom", "scale_xy", 0, 0, func_after, { 0, 1, 1, 1,   1, 1, 2, 2,   3, 1, 2, 2,   3.5, 1, 1.7, 1.7,
     4, 2, 2, 2,    6, 2, 2, 2,    6.5, 2, 1.7, 1.7,   7, 2, 2, 2,    9, 1, 2, 2,    10, 1, 1, 1 } );
    
  end;
  
  if cmn.IsEventDone("get_evilqueenfigurine") and not cmn.IsEventDone("opn_apartmenthuntsman") then
    
    local func_after = function ()
      cmn.CallEventHandler("opn_apartmenthuntsman");
      cmn.ShowBbt( "apartmentlivingroom_after_huntsman" );
      cmn.PlayAudio("mus", "assets/levels/common/audio/aud_danger_track1_mus_env");
      cmn.PlayAudio("env", "assets/levels/common/audio/aud_apartmentlivingroom_env");
    end;
    
    cmn.Lock(0);
    cmn.SetEventDone( "opn_apartmenthuntsman" );
    
    cmn.StopAllEnv();
    
    cmn.PlayFullscreenVideo( "assets/levels/level1/rm_apartmentlivingroom/vid_huntsman", func_after, "assets/levels/level1/rm_apartmentlivingroom/audio/aud_huntsman", "");
    
  end;
  
  if cmn.IsEventDone("get_magicpagepiece4") then
    
    local func_after = function ()
      ObjSet("rm_apartmentlivingroom",  { color_r = 0, color_g = 0, color_b = 0 });
      cmn.GotoRoom("rm_nearcastle");
      cmn.CallEventHandler("opn_nearcastle");
    end;
    
    cmn.Lock(0);
    cmn.StopAllEnv();
    
    cmn.PlayFullscreenVideo( "assets/levels/level1/rm_apartmentlivingroom/vid_teleport", func_after, "assets/levels/level1/rm_apartmentlivingroom/audio/aud_teleport", "");
    
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_snake_box()
  
  cmn.ShowBbt( "obj_bureau_use_silversnake" );
  
  if not cmn.IsEventDone("use_silversnake") and not cmn.IsEventDone("use_bronzesnake") then
  
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_clk_small_door");
    
    ObjSet("anm_bureau_box_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_fables_box()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_bureau_use_evilqueenfigurine" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_clk_box2");
  
  ObjMultiSet( { {"anm_bureau_stash_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end }},
                 {"anm_bureau_prince_touch", { playing = 1 }} } );
  
  if cmn.IsEventDone("use_evilqueenfigurine") then
    ObjSet("anm_bureau_queen_touch",  { playing = 1 });
  end;
  
  if cmn.IsEventDone("use_huntsmanfigurine") then
    ObjSet("anm_bureau_hunter_touch",  { playing = 1 });
  end;
  
  if cmn.IsEventDone("use_cinderellafigurine") then
    ObjSet("anm_bureau_cindy_touch",  { playing = 1 });
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_fables()
  
  cmn.Lock(1);
  
  --cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/");
  
  ObjMultiSet( { {"anm_bureau_queen_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end }},
                 {"anm_bureau_hunter_touch", { playing = 1 }},
                 {"anm_bureau_cindy_touch", { playing = 1 }},
                 {"anm_bureau_prince_touch", { playing = 1 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_bedroom_door()
  
  cmn.ShowBbt( "obj_bedroomdoor_use_bedroomkey" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_clk_card");
  
  ObjSet("anm_bedroomdoor_door_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_bookshelf_door()
  
  cmn.ShowBbt( "obj_bookshelf_use_woodenring" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_door_cabinet_small");
  
  ObjSet("anm_bookshelf_touch_door",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_bookshelf_carriage()
  
  cmn.ShowBbt( "obj_bookshelf_use_wheel" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_clk_coach");
  
  ObjSet("anm_bookshelf_touch_carriage",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_bookshelf_box()
  
  cmn.ShowBbt( "obj_bookshelf_use_crystaltie" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_small_box1");
  
  ObjSet("anm_bookshelf_touch_shoebox",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_hallway_slipper()
  
  cmn.ShowBbt( "obj_hallway_use_shard" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_slippers");
  
  ObjSet("anm_hallway_slipper_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_hallway_parcel()
  
  cmn.ShowBbt( "obj_hallway_use_hintletter" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_clk_chest");
  
  ObjSet("anm_hallway_parcel_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_hallway_stand()
  
  cmn.ShowBbt( "obj_hallway_use_cabinethandle" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_door_bollard");
  
  ObjSet("anm_hallway_door_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_hallway_box()
  
  cmn.ShowBbt( "obj_hallway_use_broomamulet" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_clk_box4");
  
  ObjSet("anm_hallway_toolbox_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_kitchen_door()
  
  cmn.ShowBbt( "obj_kitchendoor_use_shoehorn" );
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_door1");
  
  ObjSet("anm_kitchendoor_touch_door",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_2_1", { alp = 1 }},
                 {"spr_col_2_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_2_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_2_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_2_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_2_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_2_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_2_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_cat_open( event )
  
  private.dlg_event = event;
  
  common.CloseSubRoom();
  
  local func_after = function ()
    
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    
    ObjSet("obj_apartmentlivingroom_dialog_cat_cheshire_2",  { alp = 1 });
    ObjAnimate("vid_apartmentlivingroom_dialog_cat_cheshire_morph", "alp", 0, 0, private.dialog_cat_beg, { 0, 0, 1,   0.3, 0, 0 });
    
  end;
  
  local anim_cat = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_catmorph");    
    VidPlay("vid_apartmentlivingroom_dialog_cat_cheshire_morph", func_after);
    
  end;
      
  ObjAttach("obj_apartmentlivingroom_dialog_cat", "rm_apartmentlivingroom");
  ObjAnimate("obj_apartmentlivingroom_dialog_cat", "alp", 0, 0, anim_cat, { 0, 0, 0,   0.5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_cat_beg()
  
  ObjDelete("vid_apartmentlivingroom_dialog_cat_cheshire_morph");
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "apartmentlivingroom", "cat", 2 );

  local dialog_end = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( private.dlg_event );
    
    common.GotoSubRoom( "zz_woundedcat", { 219, 526 } );
    interface_impl.ShowGlobalTask();
    int_map_impl.AddDiarypage( 3 );
    
    common_impl.PlayBackgroundMusic();
    
  end;
  
  local dialog_hide = function ()
  
    ObjDelete( "anm_apartmentlivingroom_cat" );

    common_impl.current_dialog = "";
    
    int_button_hint_impl.ChangeVidAnim();

    ObjAnimate( "obj_apartmentlivingroom_dialog_cat", "alp", 0, 0, dialog_end, { 0, 0, 1,   0.5, 0, 0 } );
    
  end;
  
  local anm_cat = function ()
    
    common_impl.CharacterDialogButtonsHide();
    
    private.dlg_lipsync = "";
    interface.InterfaceSetInput( true );
    int_blackbartext.Hide();
    cmn.Lock(1);
    SndStop( common_impl.audio.voc, 0.5 );
    
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_object_fly");
    
    ObjMultiSet( { {"anm_apartmentlivingroom_dialog_cat_dissapear", { alp = 1, playing = 1, endtrig = dialog_hide }},
                   {"obj_apartmentlivingroom_dialog_cat_cheshire_2", { alp = 0 }} } );
    
  end;
  
  local cat_talks3 = function ()
  
    ObjDelete("vid_apartmentlivingroom_dialog_cat_lipsync_2");
    ObjAttach("vid_apartmentlivingroom_dialog_cat_lipsync_3", "obj_apartmentlivingroom_dialog_cat_cheshire_2");
  
    cmn.ShowDlgBbt( "dlg_cat_phrase_3" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_cat_dlg_1_3_voc");
    private.dlg_lipsync = "vid_apartmentlivingroom_dialog_cat_lipsync_3";

    ObjMultiSet( { {"tmr_apartmentlivingroom_dialog_cat_timer", { endtrig = anm_cat, time = 11.9, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_cat }},
                   {"obj_character_dialog_continue", { event_mup = anm_cat }},
                   {"vid_apartmentlivingroom_dialog_cat_lipsync_3", { playing = 1 }} } );
  
  end;
                 
  local cat_talks2 = function ()
  
    ObjDelete("vid_apartmentlivingroom_dialog_cat_lipsync_1");
    ObjAttach("vid_apartmentlivingroom_dialog_cat_lipsync_2", "obj_apartmentlivingroom_dialog_cat_cheshire_2");
  
    cmn.ShowDlgBbt( "dlg_cat_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_cat_dlg_1_2_voc");
    private.dlg_lipsync = "vid_apartmentlivingroom_dialog_cat_lipsync_2";

    ObjMultiSet( { {"tmr_apartmentlivingroom_dialog_cat_timer", { endtrig = cat_talks3, time = 11.3, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = cat_talks3 }},
                   {"obj_character_dialog_continue", { event_mup = cat_talks3 }},
                   {"vid_apartmentlivingroom_dialog_cat_lipsync_2", { playing = 1 }} } );
  
  end;

  private.dlg_lipsync = "vid_apartmentlivingroom_dialog_cat_lipsync_1";

  cmn.ShowDlgBbt( "dlg_cat_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_cat_dlg_1_1_voc");

  ObjMultiSet( { {"tmr_apartmentlivingroom_dialog_cat_timer", { time = 11.8, playing = 1, endtrig = cat_talks2 }},
                 {"vid_apartmentlivingroom_dialog_cat_lipsync_1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = cat_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = cat_talks2 }} } );

end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_cat()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  ObjDelete( "anm_apartmentlivingroom_cat" );

  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  common_impl.current_dialog = "";

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( private.dlg_event );
    
    common.GotoSubRoom( "zz_woundedcat", { 219, 526 } );
    interface_impl.ShowGlobalTask();
    int_map_impl.AddDiarypage( 3 );
    
    common_impl.PlayBackgroundMusic();

  end;
  
  local dlg_hide = function ()
    
    int_button_hint_impl.ChangeVidAnim();
    ObjAnimate("obj_apartmentlivingroom_dialog_cat", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.5, 0, 0 });
    
  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjSet(private.dlg_lipsync,  { endtrig = "" });
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_object_fly");
  
  ObjMultiSet( { {"anm_apartmentlivingroom_dialog_cat_dissapear", { alp = 1, playing = 1, endtrig = dlg_hide }},
                 {"tmr_apartmentlivingroom_dialog_cat_timer", { playing = 0 }},
                 {"obj_apartmentlivingroom_dialog_cat_cheshire_2", { alp = 0 }} } );
  
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Bookshelf *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_bookshelf = {};
public.zz_bookshelf = {};

function private.Init_Bookshelf()
  
  private.zz_bookshelf.active = 0;
  private.zz_bookshelf.win_state = { {2, 1, 2, 2}, {2, 2}, {1}, {4, 3, 4, 2} };
  private.zz_bookshelf.bush_pos = { {-99, 22}, {-192, -362}, {203, 276}, {240, 332}, {225, 335} };
  
  private.zz_bookshelf.clothes_anm = { 2, 2, 2, 3 };
  --------------------------------------------------------------------------------------------
  game.hint[ "win_bookshelf" ] = {

      type = "click",
      use_place = "gzz_bookshelf_mmg",
      room = "rm_apartmentlivingroom",
      zz = "zz_bookshelf",
      zz_gate = "gzz_apartmentlivingroom_bookshelf"
  };
  -----------------------------------------------------------------------------------
  local win_bookshelf = function ()

    if cmn.IsEventDone( "win_bookshelf" ) then

      ObjDelete( "anm_bookshelf_touch_door" );
      ObjDelete( "obj_bookshelf_game" );
      ObjDelete( "gzz_bookshelf_mmg" );
      ObjDelete( "spr_apartmentlivingroom_shelf_closed" );
  
      ObjMultiSet( { {"spr_bookshelf_bronzesnake", { input = 1 }},
                     {"spr_bookshelf_clockhand1", { input = 1 }},
                     {"spr_apartmentlivingroom_shelf_open", { alp = 1 }} } );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_bookshelf", win_bookshelf, "rm_apartmentlivingroom" );

end;
--*********************************************************************************************************************
function public.zz_bookshelf.OpenMg( num )

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_zoom_mg");

  local func_after = function ()

    if num == 1 then
      cmn.CallEventHandler( "use_woodenring_end" );
    end;

    cmn.MiniGameShow();
    
    private.zz_bookshelf.CheckWin();

    ObjMultiSet( { {"obj_bookshelf_game", { alp = 1, input = 1 }},
                   {"obj_bookshelf_back", { pos_x = 0, scale_x = 1, scale_y = 1 }} } );

  end;
  
  local show_mmg = function ()
  
    ObjAnimate( "obj_bookshelf_game", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 } );
  
  end;

  private.zz_bookshelf.active = 1;

  ObjAnimate( "obj_bookshelf_back", "scale_xy", 0, 0, "", { 0,0,1,1,   0.3,0,1,1,    1.5,0,1.5,1.5 } );
  ObjAnimate( "obj_bookshelf_back", "pos_x",   0, 0, show_mmg, { 0,0,0,   0.3,0,0,    1.5,0,-151 } );

end;
-----------------------------------------------------------------------------------
function private.zz_bookshelf.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_bookshelf" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_bookshelf" ].state = { 1, { {0, 0, 0, 0}, {0, 0}, {0}, {1, 1, 1, 1} } };

end;
-----------------------------------------------------------------------------------
function public.zz_bookshelf.Reset()
  
  local need_r = false;
  
  for i = 1, 4, 1 do
    
    if private.zz_bookshelf.state[2][1][i] > 0 then
      if not need_r then
        need_r = true;
      end;
      ObjAnimate("anm_bookshelf_bush_"..i, "pos_x", 0, 0, "", { 0, 0, private.zz_bookshelf.bush_pos[i][2],   0.5, 0, private.zz_bookshelf.bush_pos[i][1] });
    end;
    
    if private.zz_bookshelf.state[2][1][i] == 2 and i ~= 2 then
      if not need_r then
        need_r = true;
      end;
      ObjAnimate("spr_bookshelf_mouse_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("spr_bookshelf_rat_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    end;
    
    if private.zz_bookshelf.state[2][4][i] ~= 1 then
      if not need_r then
        need_r = true;
      end;
      ObjAnimate("spr_bookshelf_clothes_"..i.."_"..private.zz_bookshelf.state[2][4][i], "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_bookshelf_clothes_"..i.."_1", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    end;
    
  end;
  
  for i = 1, 2, 1 do
    
    if private.zz_bookshelf.state[2][2][i] == 2 then
      if not need_r then
        need_r = true;
      end;
      ObjAnimate("spr_bookshelf_lizard_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_bookshelf_lackey_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    end;
    
  end;
  
  if private.zz_bookshelf.state[2][2][1] > 0 then   
    ObjAnimate("anm_bookshelf_hideout_1", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    ObjAnimate("spr_bookshelf_hideout_1_open", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });   
  end;
                 
  if private.zz_bookshelf.state[2][2][2] > 0 then   
    ObjAnimate("anm_bookshelf_hideout_2", "pos_x", 0, 0, "", { 0, 0, private.zz_bookshelf.bush_pos[5][2],   0.5, 0, private.zz_bookshelf.bush_pos[5][1] });
  end;
  
  if private.zz_bookshelf.state[2][3][1] == 1 then
    ObjAnimate("spr_bookshelf_game_star", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    ObjAnimate("spr_bookshelf_fey_star", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    ObjMultiSet( { {"anm_bookshelf_fey_1", { alp = 1 }},
                   {"anm_bookshelf_fey_2", { alp = 0 }} } );
  end;
                 
  if private.zz_bookshelf.state[1] > 1 then
    if not need_r then
      need_r = true;
    end;
    ObjAnimate("obj_bookshelf_carriage", "pos_x", 0, 0, "", { 0, 0, -226,   0.5, 0, 0 });
    ObjAnimate("anm_bookshelf_horses", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    ObjAnimate("obj_bookshelf_rats", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
  end;
  
  if private.zz_bookshelf.state[1] > 2 then
    ObjAnimate("spr_bookshelf_game_carriage_door_2", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    ObjAnimate("spr_bookshelf_game_carriage_door_1", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
  end;
  
  if need_r then
    
    cmn.Lock(1);
    
    private.zz_bookshelf.StartConditions();
    private.zz_bookshelf.state = ng_global.progress[ ng_global.currentprogress ][ "win_bookshelf" ].state;
    
    ObjSet("tmr_bookshelf_game_timer",  { time = 0.5, playing = 1, endtrig = function() cmn.Lock(0); private.zz_bookshelf.DrawScene(); end; });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_bookshelf.Skip()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_bookshelf" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_bookshelf" ].state = { 4, { {2, 1, 2, 2}, {2, 2}, 1, {4, 3, 4, 2} } };
  
  cmn.Lock(1);
  
  if private.zz_bookshelf.state[1] == 1 then
    private.zz_bookshelf.Skip_1();
  elseif private.zz_bookshelf.state[1] == 2 then
    private.zz_bookshelf.Skip_2();
  elseif private.zz_bookshelf.state[1] == 3 then
    private.zz_bookshelf.Skip_3();
  elseif private.zz_bookshelf.state[1] == 4 then
    private.zz_bookshelf.Skip_4();
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_bookshelf.Skip_1()
  
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menter_ho");
  
  for i = 1, 4, 1 do
    
    if private.zz_bookshelf.state[2][1][i] == 0 then
      ObjAnimate("anm_bookshelf_bush_"..i, "pos_x", 0, 0, "", { 0, 0, private.zz_bookshelf.bush_pos[i][1],   0.5, 0, private.zz_bookshelf.bush_pos[i][2] });
    end;
    
    if private.zz_bookshelf.state[2][1][i] < 2 then
      ObjAnimate("spr_bookshelf_mouse_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_bookshelf_rat_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    end;
    
  end;
  
  local carriage_move = function ()
    
    ObjAnimate("obj_bookshelf_carriage", "pos_x", 0, 0, private.zz_bookshelf.Skip_2, { 0, 0, 0,   1, 0, -226 });
  
  end;
  
  local anm_carriage = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_magic_wand");
    
    ObjMultiSet( { {"anm_bookshelf_fey_1", { playing = 1 }},
                   {"anm_bookshelf_horses", { alp = 1, playing = 1, endtrig = carriage_move }},
                   {"obj_bookshelf_rats", { alp = 0 }} } ); 
  
  end;
  
  ObjSet("tmr_bookshelf_game_timer",  { time = 0.5, playing = 1, endtrig = anm_carriage });
  
end;
-----------------------------------------------------------------------------------
function private.zz_bookshelf.Skip_2()
  
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menter_ho");
  
  for i = 1, 2, 1 do
    
    if private.zz_bookshelf.state[2][2][i] < 2 then
      ObjAnimate("spr_bookshelf_lizard_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("anm_bookshelf_lackey_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    end;
    
  end;
  
  if private.zz_bookshelf.state[2][2][1] == 0 then   
    ObjAnimate("anm_bookshelf_hideout_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    ObjAnimate("spr_bookshelf_hideout_1_open", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });   
  end;
                 
  if private.zz_bookshelf.state[2][2][2] == 0 then   
    ObjAnimate("anm_bookshelf_hideout_2", "pos_x", 0, 0, "", { 0, 0, private.zz_bookshelf.bush_pos[5][1],   0.5, 0, private.zz_bookshelf.bush_pos[5][2] });
  end;
  
  local open_carriage = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_mg_door");
    
    ObjAnimate("spr_bookshelf_game_carriage_door_2", "alp", 0, 0, private.zz_bookshelf.Skip_3, { 0, 0, 0,   0.5, 0, 1 });
    ObjAnimate("spr_bookshelf_game_carriage_door_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  
  end;
  
  local anm_carriage = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_magic_wand");
    
    ObjMultiSet( { {"anm_bookshelf_fey_1", { playing = 1 }},
                   {"anm_bookshelf_lackey_1", { playing = 1, endtrig = open_carriage }},
                   {"anm_bookshelf_lackey_2", { playing = 1 }} } );
  
  end;
  
  ObjSet("tmr_bookshelf_game_timer",  { time = 0.5, playing = 1, endtrig = anm_carriage });
  
end;
-----------------------------------------------------------------------------------
function private.zz_bookshelf.Skip_3()
  
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menter_ho");
  
  local anm_fey = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_magic_wand1");
    
    ObjMultiSet( { {"anm_bookshelf_fey_1", { alp = 0 }},
                   {"anm_bookshelf_fey_2", { alp = 1, playing = 1, endtrig = private.zz_bookshelf.Skip_4 }} } );
  
  end;
  
  ObjAnimate("spr_bookshelf_game_star", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  ObjAnimate("spr_bookshelf_fey_star", "alp", 0, 0, anm_fey, { 0, 0, 0,   0.3, 0, 1 });
  
end;
-----------------------------------------------------------------------------------
function private.zz_bookshelf.Skip_4()
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_mg_click");
  
  for i = 1, 4, 1 do
    
    if private.zz_bookshelf.state[2][4][i] ~= private.zz_bookshelf.win_state[4][i] then
      ObjAnimate("spr_bookshelf_clothes_"..i.."_"..private.zz_bookshelf.state[2][4][i], "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_bookshelf_clothes_"..i.."_"..private.zz_bookshelf.win_state[4][i], "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    end;
    
  end;
  
  private.zz_bookshelf.state = ng_global.progress[ ng_global.currentprogress ][ "win_bookshelf" ].state;
  
  ObjSet("tmr_bookshelf_game_timer",  { time = 0.5, playing = 1, endtrig = private.zz_bookshelf.CheckWin });
  
end;
-----------------------------------------------------------------------------------
function private.zz_bookshelf.DrawScene()
    
  for i = 1, 4, 1 do
    
    if private.zz_bookshelf.state[2][1][i] > 0 then
      ObjSet("anm_bookshelf_bush_"..i,  { pos_x = private.zz_bookshelf.bush_pos[i][2], input = 0, playing = 0 });
    else 
      ObjSet("anm_bookshelf_bush_"..i,  { pos_x = private.zz_bookshelf.bush_pos[i][1], input = 1, playing = 1 });
    end;
    
    if private.zz_bookshelf.state[2][1][i] == 1 and i ~= 2 then
      ObjSet("spr_bookshelf_mouse_"..i,  { alp = 1, input = 1 });
    elseif private.zz_bookshelf.state[2][1][i] == 2 and i ~= 2 then
      ObjMultiSet( { {"spr_bookshelf_mouse_"..i,  { alp = 0, input = 0 }},
                     {"spr_bookshelf_rat_"..i, { alp = 1 }} } );
    end;
    
  end;
                 
  if private.zz_bookshelf.state[1] > 2 then
    ObjMultiSet( { {"anm_bookshelf_lackey_1", { alp = 1, frame = 400 }},
                   {"anm_bookshelf_lackey_2", { alp = 1, frame = 400 }} } );
  else 
    ObjMultiSet( { {"anm_bookshelf_lackey_1", { alp = 0, frame = 0 }},
                   {"anm_bookshelf_lackey_2", { alp = 0, frame = 0 }} } );
  end;                
                 
  for i = 1, 2, 1 do
    
    if private.zz_bookshelf.state[2][2][i] == 1 then
      ObjSet("spr_bookshelf_lizard_"..i,  { alp = 1, input = 1 });
    elseif private.zz_bookshelf.state[2][2][i] == 2 then
      ObjMultiSet( { {"spr_bookshelf_lizard_"..i,  { alp = 0, input = 0 }},
                     {"anm_bookshelf_lackey_"..i, { alp = 1 }} } );
    end;
    
  end;
                 
  if private.zz_bookshelf.state[2][2][1] > 0 then      
    ObjMultiSet( { {"anm_bookshelf_hideout_1", { alp = 0, input = 0, playing = 0 }},
                   {"spr_bookshelf_hideout_1_open", { alp = 1 }} } );    
  else 
    ObjMultiSet( { {"anm_bookshelf_hideout_1", { alp = 1, input = 0, playing = 0 }},
                   {"spr_bookshelf_hideout_1_open", { alp = 0 }} } );  
  end;
                 
  if private.zz_bookshelf.state[2][2][1] == 0 and private.zz_bookshelf.state[1] == 2 then       
    ObjSet("anm_bookshelf_hideout_1",  { input = 1, playing = 1 });    
  end;
  
  if private.zz_bookshelf.state[2][2][2] > 0 then   
    ObjSet("anm_bookshelf_hideout_2",  { pos_x = private.zz_bookshelf.bush_pos[5][2], input = 0, playing = 0 });
  else 
    ObjSet("anm_bookshelf_hideout_2",  { pos_x = private.zz_bookshelf.bush_pos[5][1], input = 0, playing = 0 });
  end;
  
  if private.zz_bookshelf.state[2][2][2] == 0 and private.zz_bookshelf.state[1] == 2 then       
    ObjSet("anm_bookshelf_hideout_2",  { input = 1, playing = 1 });    
  end;
  
  if private.zz_bookshelf.state[1] >= 3 then
    ObjMultiSet( { {"spr_bookshelf_game_carriage_door_2", { alp = 1 }},
                   {"spr_bookshelf_game_carriage_door_1", { alp = 0 }} } );
  end;
  
  if private.zz_bookshelf.state[2][3][1] == 1 then
    ObjMultiSet( { {"spr_bookshelf_game_star", { alp = 0, input = 0 }},
                   {"anm_bookshelf_fey_1", { alp = 0 }},
                   {"anm_bookshelf_fey_2", { alp = 1 }},
                   {"spr_bookshelf_fey_star", { alp = 1 }} } );
  else 
    ObjMultiSet( { {"spr_bookshelf_game_star", { alp = 1, input = 0 }},
                   {"anm_bookshelf_fey_1", { alp = 1 }},
                   {"anm_bookshelf_fey_2", { alp = 0 }},
                   {"spr_bookshelf_fey_star", { alp = 0 }} } );
  end;
                 
  for i = 1, 4, 1 do
    for j = 1, 4, 1 do
      
      if private.zz_bookshelf.state[2][4][i] == j then
        ObjSet("spr_bookshelf_clothes_"..i.."_"..j,  { alp = 1 });
      else 
        ObjSet("spr_bookshelf_clothes_"..i.."_"..j,  { alp = 0 });
      end;
      
    end;
  end;
  
  if private.zz_bookshelf.state[1] > 1 then
    ObjMultiSet( { {"obj_bookshelf_carriage",  { pos_x = -226 }},
                   {"anm_bookshelf_horses", { alp = 1, frame = 400 }},
                   {"obj_bookshelf_rats", { alp = 0 }} } );
  else 
    ObjMultiSet( { {"obj_bookshelf_carriage",  { pos_x = 0 }},
                   {"anm_bookshelf_horses", { alp = 0, frame = 0 }},
                   {"obj_bookshelf_rats", { alp = 1 }} } );                
  end;
  
  if private.zz_bookshelf.state[1] == 3 and private.zz_bookshelf.state[2][3][1] == 0 then
    ObjSet("spr_bookshelf_game_star",  { input = 1 });    
  end;
  
  if private.zz_bookshelf.state[1] == 2 then
    for i = 1, 2, 1 do
      
      if private.zz_bookshelf.state[2][2][i] == 0 then
        ObjSet("anm_bookshelf_hideout_"..i,  { input = 1 }); 
      end;
        
    end;
  end;
  
  if private.zz_bookshelf.state[1] == 4 then
    ObjSet("obj_bookshelf_cinderella",  { input = 1 });
  else 
    ObjSet("obj_bookshelf_cinderella",  { input = 0 });
  end;
                 
end;
-----------------------------------------------------------------------------------
function public.zz_bookshelf.ClickBush( num )
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_move_card");
  
  --private.zz_bookshelf.state[2][1][num] = 1;
  
  if num == 2 then
    private.zz_bookshelf.state[2][1][num] = 1;
  else 
    private.zz_bookshelf.state[2][1][num] = 2;
  end;
  
  local func_after = function ()
  
    if num == 2 then
      ObjSet("anm_bookshelf_bush_"..num,  { input = 0 });
      private.zz_bookshelf.CheckWin();
    else 
      
      --cmn.Lock(0);
      ObjMultiSet( { {"spr_bookshelf_mouse_"..num, { input = 1 }},
                     {"anm_bookshelf_bush_"..num, { input = 0 }} } );
                     
      public.zz_bookshelf.MouseFound( num );  
      
    end;
  
  end;
  
  ObjSet("anm_bookshelf_bush_"..num,  { playing = 0 });               
  ObjAnimate("anm_bookshelf_bush_"..num, "pos_x", 0, 0, func_after, { 0, 0, private.zz_bookshelf.bush_pos[num][1],   0.5, 0, private.zz_bookshelf.bush_pos[num][2] });
  
end;
-----------------------------------------------------------------------------------
function public.zz_bookshelf.ClickLizardHideOut( num )
  
  cmn.Lock(1);
  
  --private.zz_bookshelf.state[2][2][num] = 1;
  private.zz_bookshelf.state[2][2][num] = 2;
  
  local func_after = function ()
  
    --cmn.Lock(0);

    ObjMultiSet( { {"spr_bookshelf_lizard_"..num, { input = 1 }},
                   {"anm_bookshelf_hideout_"..num, { input = 0 }} } );
                   
    public.zz_bookshelf.ClickLizard( num );               
  
  end;
  
  ObjSet("anm_bookshelf_hideout_"..num,  { playing = 0 });  
                 
  if num == 2 then
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_move_card");
    ObjAnimate("anm_bookshelf_hideout_"..num, "pos_x", 0, 0, func_after, { 0, 0, private.zz_bookshelf.bush_pos[5][1],   0.5, 0, private.zz_bookshelf.bush_pos[5][2] });
  else 
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_mg_door");
    ObjAnimate("spr_bookshelf_hideout_"..num.."_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
    ObjAnimate("anm_bookshelf_hideout_"..num, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_bookshelf.MouseFound( num )
  
  cmn.Lock(1);
  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_right_act" );
  
  --private.zz_bookshelf.state[2][1][num] = 2;
  
  local func_after = function ()
  
    private.zz_bookshelf.CheckWin();
    ObjSet("spr_bookshelf_mouse_"..num,  { input = 0 });
  
  end;
  
  local anim_mouse = function ()
  
    ObjAnimate("spr_bookshelf_rat_"..num, "scale_xy", 0, 0, func_after, { 0, 2, 1, 1,   0.5, 2, 1.3, 1.3,   1, 1, 1, 1 });
  
  end;
  
  ObjAnimate("spr_bookshelf_mouse_"..num, "alp", 0, 0, anim_mouse, { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate("spr_bookshelf_rat_"..num, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
  
end;
-----------------------------------------------------------------------------------
function public.zz_bookshelf.ClickLizard( num )
  
  cmn.Lock(1);
  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_right_act" );
  
  --private.zz_bookshelf.state[2][2][num] = 2;
  
  local func_after = function ()
  
    private.zz_bookshelf.CheckWin();
    ObjSet("spr_bookshelf_lizard_"..num,  { input = 0 });
  
  end;
  
  local anim_lizard = function ()
  
    ObjAnimate("obj_bookshelf_lackey_"..num, "scale_xy", 0, 0, func_after, { 0, 2, 1, 1,   0.5, 2, 1.3, 1.3,   1, 1, 1, 1 });
  
  end;
  
  ObjAnimate("spr_bookshelf_lizard_"..num, "alp", 0, 0, anim_lizard, { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate("anm_bookshelf_lackey_"..num, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
  
end;
-----------------------------------------------------------------------------------
function public.zz_bookshelf.StartDragStar()
  
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  ObjAttach("spr_bookshelf_game_star", "obj_bookshelf_drag");
  
end;
-----------------------------------------------------------------------------------
function public.zz_bookshelf.UseStar()
  
  ObjAttach("spr_bookshelf_game_star", "obj_bookshelf_carriage");
  
  if cmn.ApplyObj( "spr_bookshelf_game_star", "obj_bookshelf_apply_star" ) then
    
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menter_ho");
    
    private.zz_bookshelf.state[1] = private.zz_bookshelf.state[1] + 1;
    private.zz_bookshelf.state[2][3][1] = 1;
    
    for i = 1, 4, 1 do
      private.zz_bookshelf.state[2][4][i] = private.zz_bookshelf.clothes_anm[i];
    end;
    
    local func_after = function ()
    
      cmn.Lock(0);
      ObjSet("obj_bookshelf_cinderella",  { input = 1 });
    
    end;
    
    local anm_clothes = function ()
    
      ObjSet("tmr_bookshelf_game_timer",  { time = 0.3, playing = 1, endtrig = func_after });
    
      for i = 1, 4, 1 do
        
        ObjAnimate("spr_bookshelf_clothes_"..i.."_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
        ObjAnimate("spr_bookshelf_clothes_"..i.."_"..private.zz_bookshelf.clothes_anm[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
        
      end;
    
    end;
    
    local anm_fey = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_magic_wand1");
    
      ObjMultiSet( { {"anm_bookshelf_fey_1", { alp = 0 }},
                     {"anm_bookshelf_fey_2", { alp = 1, playing = 1, endtrig = anm_clothes }} } );
    
    end;
    
    ObjSet("spr_bookshelf_game_star",  { alp = 0, input = 0 });
    ObjAnimate("spr_bookshelf_fey_star", "alp", 0, 0, anm_fey, { 0, 0, 0,   0.3, 0, 1 });
    
  else 
    
    cmn.WrongApply(); 
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_bookshelf.ChangeClothes( typ )
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_mg_click");
  
  local num1 = private.zz_bookshelf.state[2][4][typ];
  local num2 = num1 + 1;
  
  if num2 > 4 then
    num2 = 1;
  end;
  
  private.zz_bookshelf.state[2][4][typ] = num2;
  
  ObjAnimate("spr_bookshelf_clothes_"..typ.."_"..num1, "alp", 0, 0, private.zz_bookshelf.CheckWin, { 0, 0, 1,   0.3, 0, 0 });
  ObjAnimate("spr_bookshelf_clothes_"..typ.."_"..num2, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
  
end;
-----------------------------------------------------------------------------------
function private.zz_bookshelf.CheckWin()
  
  local win_flag = true;
  
  for i = 1, #private.zz_bookshelf.state[2][ private.zz_bookshelf.state[1] ], 1 do
    
    if private.zz_bookshelf.state[2][ private.zz_bookshelf.state[1] ][i] ~= private.zz_bookshelf.win_state[ private.zz_bookshelf.state[1] ][i] then
      win_flag = false;
      break;
    end;
    
  end;
  
  if private.zz_bookshelf.state[1] == 4 and win_flag then

    cmn.Lock(1);
    common_impl.PauseAchiev(1);
    
    cmn.MiniGameHide("bookshelf");

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_anm_win");
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/common/audio/aud_use_amulet_ho");

      ObjAnimate("anm_bookshelf_touch_door", "alp", 0, 0, private.zz_bookshelf.Win, { 0, 0, 1,   0.5, 0, 0 });
    
    end;
    
    local close_mmg = function ()
    
      ObjSet("gzz_bookshelf_mmg",  { alp = 0 });

      ObjAnimate("obj_bookshelf_game", "alp", 0, 0, anm_open, { 0, 0, 1,   1, 0, 1,   1.5, 0, 0 });
      
    end;
    
    local anm_win = function ()
    
      ObjAnimate("anm_bookshelf_fey_2", "alp", 0, 0, "", { 0, 0, 1,   0.7, 0, 0 });
    
      ObjMultiSet( { {"anm_bookshelf_win", { alp = 1, playing = 1, endtrig = close_mmg }},
                     {"obj_bookshelf_carriage", { alp = 0 }},
                     {"spr_bookshelf_castle", { alp = 0 }},
                     {"spr_bookshelf_house", { alp = 0 }},
                     {"spr_bookshelf_house_bl", { alp = 0 }},
                     {"spr_bookshelf_hideout_1_open", { alp = 0 }},
                     {"anm_bookshelf_bush_1", { alp = 0 }},
                     {"spr_bookshelf_tree_4", { alp = 0 }} } );
                     
    end;
                   
    ObjAnimate("obj_bookshelf_cinderella", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 1,   1, 0, 0 });
    ObjAnimate("spr_bookshelf_carriage_cindy", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,   1, 0, 1 });
    ObjAnimate("spr_bookshelf_game_carriage_door_2", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 1,   1, 0, 0 });
    ObjAnimate("spr_bookshelf_game_carriage_door_1", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,   1, 0, 1 });
    
    ObjAnimate("anm_bookshelf_lackey_2", "alp", 0, 0, anm_win, { 0, 0, 1,   1.5, 0, 1,   2, 0, 0 });
    
  elseif private.zz_bookshelf.state[1] == 2 and win_flag then
    
    private.zz_bookshelf.state[1] = private.zz_bookshelf.state[1] + 1;
    
    local func_after = function ()
    
      cmn.Lock( 0 );
      ObjSet("spr_bookshelf_game_star",  { input = 1 });
    
    end;
    
    local open_carriage = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_mg_door");
    
      ObjAnimate("spr_bookshelf_game_carriage_door_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("spr_bookshelf_game_carriage_door_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    
    end;
    
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_magic_wand");
    
    ObjMultiSet( { {"anm_bookshelf_fey_1", { playing = 1 }},
                   {"anm_bookshelf_lackey_1", { playing = 1, endtrig = open_carriage }},
                   {"anm_bookshelf_lackey_2", { playing = 1 }} } );
                   
  elseif private.zz_bookshelf.state[1] == 1 and win_flag then   
           
    private.zz_bookshelf.state[1] = private.zz_bookshelf.state[1] + 1;

    local func_after = function ()
    
      cmn.Lock( 0 );
      ObjMultiSet( { {"anm_bookshelf_hideout_1", { input = 1, playing = 1 }},
                     {"anm_bookshelf_hideout_2", { input = 1, playing = 1 }} } );
    
    end;
    
    local carriage_move = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_move_card");
    
      ObjAnimate("obj_bookshelf_carriage", "pos_x", 0, 0, func_after, { 0, 0, 0,   1.5, 0, -226 });
    
    end;
    
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_magic_wand");
    
    ObjMultiSet( { {"anm_bookshelf_fey_1", { playing = 1 }},
                   {"anm_bookshelf_horses", { alp = 1, playing = 1, endtrig = carriage_move }},
                   {"obj_bookshelf_rats", { alp = 0 }} } );    

  else

    cmn.Lock( 0 );

  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_bookshelf.Win()

  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_bookshelf" );
  cmn.CallEventHandler( "win_bookshelf" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_bookshelf" ].skip == 0 and ng_global.noskipgames[ "win_bookshelf" ] == nil then

    ng_global.noskipgames[ "win_bookshelf" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

  cmn.Lock( 0 );
  --cmn.PlayAudio("mus", "assets/levels/common/audio/");

end;
--**************************************************************************************************************