-- name=mg_onposter
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_onposter";
  --------------------------------------------------------------------------------------------
  private.start_state = {1, 5, 6, 7, 0, 2, 7, 4, 3, 1, 5, 2, 3, 0, 3, 7, 5, 4, 4, 2, 1, 6};
  private.pos_restrictions = { {50, 974}, {50, 576} };

  private.pic_pos = { 
    { {976, 118}, {509, 53}, {910, 435}, {745, 87}, {177, 468}, {77, 167}, {258, 69}, {926, 284}, {619, 95}, {145, 349}, {859, 106},
      {361, 159}, {605, 535}, {371, 513}, {201, 187}, {270, 509}, {785, 492}, {488, 507}, {91, 295}, {696, 473}, {463, 97}, {874, 351} },
    { {160, 402}, {188, 213}, {274, 152}, {246, 338}, {474, 111}, {404, 231}, {361, 310}, {300, 528}, {361, 405}, {595, 532}, {441, 438},
      {538, 468}, {565, 137}, {516, 318}, {740, 457}, {757, 170}, {865, 193}, {833, 319}, {635, 405}, {551, 230}, {733, 293}, {634, 274} }
  };
  --------------------------------------------------------------------------------------------
  -- function get_magicpage6 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_magicpage6" ] = {
      type = "get",
      get_obj = "spr_onposter_magicpage6",
      room = "rm_mermaidsward",
      zz = "mg_onposter",
      zz_gate = "gmg_mermaidsward_onposter"
  };
  --------------------------------------------------------------------------------------------
  local get_magicpage6_inv = function ()
  
    interface.InventoryItemAdd( "inv_magicpage", "spr_onposter_magicpage6", function () cmn.GetMultyObject( 'magicpage', 6 ); end );
  
  end;
  local get_magicpage6_end = function ()
  
    ObjDelete( "gfx_onposter_magicpage6" );
    ObjDelete( "spr_onposter_magicpage6_sh" );
  
  end;
  local get_magicpage6_loc = function ()
  
    ObjDelete( "gmg_mermaidsward_onposter" );
    ObjDelete( "spr_mermaidsward_mg_onposter_magicpage6" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_magicpage6", get_magicpage6_inv );
  cmn.AddSubscriber( "get_magicpage6", get_magicpage6_end, private.room_objname );
  cmn.AddSubscriber( "get_magicpage6", get_magicpage6_loc, "rm_mermaidsward" );
  --------------------------------------------------------------------------------------------
  -- function get_bearfigurine () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bearfigurine" ] = {
      type = "get",
      get_obj = "spr_onposter_bearfigurine",
      room = "rm_mermaidsward",
      zz = "mg_onposter",
      zz_gate = "gmg_mermaidsward_onposter"
  };
  --------------------------------------------------------------------------------------------
  local get_bearfigurine_inv = function ()
  
    interface.InventoryItemAdd( "inv_bearfigurine", "spr_onposter_bearfigurine" );
  
  end;
  local get_bearfigurine_end = function ()
  
    ObjDelete( "gfx_onposter_bearfigurine" );
    ObjDelete( "spr_onposter_bearfigurine_sh" );
  
  end;
  local get_bearfigurine_loc = function ()

    ObjDelete( "spr_mermaidsward_mg_onposter_bearfigurine" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bearfigurine", get_bearfigurine_inv );
  cmn.AddSubscriber( "get_bearfigurine", get_bearfigurine_end, private.room_objname );
  cmn.AddSubscriber( "get_bearfigurine", get_bearfigurine_loc, "rm_mermaidsward" );

  --------------------------------------------------------------------------------------------
  -- function get_stetoscope () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_stetoscope" ] = {
      type = "get",
      get_obj = "spr_onposter_stetoscope",
      room = "rm_mermaidsward",
      zz = "mg_onposter",
      zz_gate = "gmg_mermaidsward_onposter"
  };
  --------------------------------------------------------------------------------------------
  local get_stetoscope_inv = function ()
  
    interface.InventoryItemAdd( "inv_stetoscope", "spr_onposter_stetoscope" );
  
  end;
  local get_stetoscope_end = function ()
  
    ObjDelete( "gfx_onposter_stetoscope" );
    ObjDelete( "spr_onposter_stetoscope_sh" );
  
  end;
  local get_stetoscope_loc = function ()

    ObjDelete( "spr_mermaidsward_mg_onposter_stetoscope" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_stetoscope", get_stetoscope_inv );
  cmn.AddSubscriber( "get_stetoscope", get_stetoscope_end, private.room_objname );
  cmn.AddSubscriber( "get_stetoscope", get_stetoscope_loc, "rm_mermaidsward" );

  --------------------------------------------------------------------------------------------
  -- function win_onposter () end;
  --------------------------------------------------------------------------------------------
  --game.hint[ "win_onposter" ] = {
  --  type = "win",
  --  room = "rm_mermaidsward",
  --  zz = "mg_onposter",
  --  zz_gate = "gmg_mermaidsward_onposter"
  --};
  --------------------------------------------------------------------------------------------
  local win_onposter = function ()

    if cmn.IsEventDone( "win_onposter" ) then
      ObjSet("obj_onposter_niche",  { input = 1 });
      ObjDelete("obj_onposter_game");
    end;

  end;
  local win_onposter_loc = function ()

    ObjDelete( "spr_mermaidsward_zz_ecoposter_poster_hole" );

    ObjSet( "spr_mermaidsward_zz_ecoposter_poster", { pos_y = 130, ang = -0.035 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_onposter", win_onposter, "mg_onposter" );
  cmn.AddSubscriber( "win_onposter", win_onposter_loc, "rm_mermaidsward" );
  
end;
--*********************************************************************************************************************
function public.Load()

  if ng_global.currentprogress == "std" and not ng_global.progress[ ng_global.currentprogress ][ "win_onposter" ].state then
    private.StartConditions();
  elseif ng_global.currentprogress == "secret" then
    private.StartConditions(); 
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_onposter" ].state;
  private.state_pos = ng_global.progress[ ng_global.currentprogress ][ "win_onposter" ].state_pos;

end;
--*********************************************************************************************************************
function public.Open() 
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_mg_mus_env", 1);

  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_onposter" )) and cmn.IsEventDone("opn_onposter") then
    cmn.MiniGameShow();
    private.CheckWin();
    cmn.StartTimePassing("mg_onposter");
  end;
  
  if not cmn.IsEventDone("opn_onposter") then
    private.AnimStartGame();
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_mermaidsward_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_mermaidsward_env");

  if ng_global.currentprogress == "std" then
    common.SetPreviousRoom( "rm_mermaidsward" );
  else 
    
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_onposter" ].state;
    private.state_pos = ng_global.progress[ ng_global.currentprogress ][ "win_onposter" ].state_pos;
    
    ng_global.progress[ ng_global.currentprogress ][ "opn_onposter" ].done = 0;
    ng_global.progress[ ng_global.currentprogress ][ "opn_onposter" ].start = 0;
    
    ObjSet("grm_onposter_mermaidsward",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                           event_menter = function () rm_extra.GateMouseEnter( "onposter_mermaidsward", CURSOR_DOWN, "extra" ); end, 
                                           event_mleave = function () common_impl.GateMouseLeave( "onposter_mermaidsward" ); end });
    
  end;
  
  private.DrawScene();
  
  if not cmn.IsEventDone("opn_onposter") then
    cmn.Lock(1);
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  
  cmn.StopAllMus();
  if ng_global.currentprogress == "std" then
    common_impl.PlayBackgroundMusic();
  end;

  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_onposter" )) then
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_onposter" )) then
    rm_extra.MiniGameHide();
  end;
  
end;
--*********************************************************************************************************************
function public.Reset()
  
  local need_r = false;
  local k_ang = 0.785;

  for i = 1, #private.state[1], 1 do

    if (private.state_pos[i][1] ~= private.pic_pos[1][i][1]) or (private.state_pos[i][2] ~= private.pic_pos[1][i][2]) then

      if not need_r then
        need_r = true;
      end;

      ObjAnimate("spr_onposter_picture_"..i, "pos_xy", 0, 0, "", { 0, 0, private.state_pos[i][1], private.state_pos[i][2],
                                                                 0.5, 0, private.pic_pos[1][i][1], private.pic_pos[1][i][2] });

    end;

    if (private.state[2][i] ~= private.start_state[i]) then

      if not need_r then
        need_r = true;
      end;

      local old_ang = -k_ang*private.state[2][i];
      local new_ang = -k_ang*private.start_state[i];

      ObjAnimate("spr_onposter_picture_"..i, "ang", 0, 0, "", { 0, 0, old_ang,   0.5, 0, new_ang });

    end;

  end;

  if need_r then

    cmn.Lock( 1 );
    --cmn.PlayAudio("snd", "assets/levels/level2/mg_onposter/audio/");

    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_onposter" ].state;
    private.state_pos = ng_global.progress[ ng_global.currentprogress ][ "win_onposter" ].state_pos;

    ObjSet("tmr_onposter_timer",  { time = 0.5, playing = 1, endtrig = function () cmn.Lock( 0 ); private.DrawScene(); cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button"); end });

  end;

end;
--*********************************************************************************************************************
function public.Skip()
  
  cmn.Lock( 1 );
  --cmn.PlayAudio("snd", "assets/levels/level2/mg_onposter/audio/");

  local k_ang = 0.785;

  ng_global.progress[ ng_global.currentprogress ][ "win_onposter" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_onposter" ].state = { 
    { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22 }, 
    { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 } 
  };

  ng_global.progress[ ng_global.currentprogress ][ "win_onposter" ].state_pos = { {9, -11}, {97, -29}, {126, -83}, {125, -174}, {33, -187}, {-30, -174}, {-91, -188}, {-112, -141}, {-122, -46} } ; 

  for i = 1, #private.state[1], 1 do

    if (private.state[1][i] ~= i) then

      ObjAnimate("spr_onposter_picture_"..i, "pos_xy", 0, 0, "", { 0, 0, private.state_pos[i][1], private.state_pos[i][2],
                                                                 0.5, 0, private.pic_pos[2][i][1], private.pic_pos[2][i][2] });

    end;

    if (private.state[2][i] ~= 0) then

      local old_ang = -k_ang*private.state[2][i];
      local new_ang = 0;

      ObjAnimate("spr_onposter_picture_"..i, "ang", 0, 0, "", { 0, 0, old_ang,   0.5, 0, new_ang });

    end;

  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_onposter" ].state;
  private.state_pos = ng_global.progress[ ng_global.currentprogress ][ "win_onposter" ].state_pos;

  ObjSet("tmr_onposter_timer",  { time = 0.5, playing = 1, endtrig = function() private.CheckWin(); cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button"); end });

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_magicpage6()

  cmn.SetEventDone( "get_magicpage6" );
  cmn.CallEventHandler( "get_magicpage6" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if not cmn.IsEventDone("get_bearfigurine") then
    cmn.SetEventDone( "get_bearfigurine" );
    cmn.CallEventHandler( "get_bearfigurine" );
  end;
  
  if not cmn.IsEventDone("get_stetoscope") then
    cmn.SetEventDone( "get_stetoscope" );
    cmn.CallEventHandler( "get_stetoscope" );
  end;
  
  cmn.GotoRoom("rm_mermaidsward");

end;
--------------------------------------------------------------------------------------------
function public.get_bearfigurine()

  cmn.SetEventDone( "get_bearfigurine" );
  cmn.CallEventHandler( "get_bearfigurine" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_stetoscope()

  cmn.SetEventDone( "get_stetoscope" );
  cmn.CallEventHandler( "get_stetoscope" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_onposter" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_onposter" ].state = { { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }, 
                                                                              { 1, 5, 6, 7, 0, 2, 7, 4, 3, 1, 5, 2, 3, 0, 3, 7, 5, 4, 4, 2, 1, 6 } };
                                                                              
  ng_global.progress[ ng_global.currentprogress ][ "win_onposter" ].state_pos = { 
    {976, 118}, {509, 53}, {910, 435}, {745, 87}, {177, 468}, {77, 167}, {258, 69}, {926, 284}, {619, 95}, {145, 349}, {859, 106},
    {361, 159}, {605, 535}, {371, 513}, {201, 187}, {270, 509}, {785, 492}, {488, 507}, {91, 295}, {696, 473}, {463, 97}, {874, 351}
  };                                                                             

end;
-----------------------------------------------------------------------------------
function private.AnimStartGame()
  
  local k_ang = 0.785;
  
  local func_after = function ()

    if ng_global.currentprogress == "std" then
      cmn.MiniGameShow();
      cmn.StartTimePassing("mg_onposter");
    elseif ng_global.currentprogress == "secret" then 
      rm_extra.MiniGameShow();
    end;
    
    cmn.Lock(0);

    private.DrawScene();

  end;
  
  local anm_pieces = function ()
  
    for i = 1, #private.state[1], 1 do

      local new_ang = -k_ang*private.start_state[i];
      local old_ang = 0;

      ObjAnimate("spr_onposter_picture_"..i, "pos_xy", 0, 0, "", { 0, 0, private.pic_pos[2][i][1], private.pic_pos[2][i][2],
                                                                 0.5, 0, private.pic_pos[1][i][1], private.pic_pos[1][i][2] });

      ObjAnimate("spr_onposter_picture_"..i, "ang", 0, 0, "", { 0, 0, old_ang,   0.5, 0, new_ang });

    end;
    
    cmn.PlayAudio("snd", "assets/levels/level2/mg_onposter/audio/aud_crash_picture");
    ObjSet("tmr_onposter_timer",  { time = 0.5, playing = 1, endtrig = func_after });
    
  end;
  
  cmn.SetEventDone("opn_onposter");

  ObjSet("tmr_onposter_timer",  { time = 1, playing = 1, endtrig = anm_pieces });
  
end;
-----------------------------------------------------------------------------------
function private.DrawScene()
  
  local k_ang = 0.785;

  if cmn.IsEventDone("opn_onposter") then

    for i = 1, #private.state[1], 1 do
    
      ObjMultiSet( { {"spr_onposter_picture_"..i, { ang = -k_ang*private.state[2][i] }},
                     {"spr_onposter_picture_"..i.."_focus", { ang = -k_ang*private.state[2][i] }} } );

      if (private.state[1][i] == i) then
        ObjMultiSet( { {"spr_onposter_picture_"..i, { pos_x = private.pic_pos[2][i][1],  pos_y = private.pic_pos[2][i][2] }},
                       {"spr_onposter_picture_"..i.."_focus", { pos_x = private.pic_pos[2][i][1],  pos_y = private.pic_pos[2][i][2] }} } );
      else 
        ObjMultiSet( { {"spr_onposter_picture_"..i, { pos_x = private.state_pos[i][1],  pos_y = private.state_pos[i][2] }},
                       {"spr_onposter_picture_"..i.."_focus", { pos_x = private.state_pos[i][1],  pos_y = private.state_pos[i][2] }} } );
      end;

      if (private.state[1][i] == i) and (private.state[2][i] == 0) then

        ObjSet("spr_onposter_picture_"..i,  { input = 0 });
        ObjAttach("spr_onposter_picture_"..i, "obj_onposter_rihgt_place");

      else 

        ObjSet("spr_onposter_picture_"..i,  { input = 1 });
        ObjAttach("spr_onposter_picture_"..i, "obj_onposter_mosaic_parts");

      end;

    end;

  else 

    for i = 1, #private.state[1], 1 do

      ObjSet("spr_onposter_picture_"..i,  { ang = 0, pos_x = private.pic_pos[2][i][1],  pos_y = private.pic_pos[2][i][2] });

    end;

  end;

end;
-----------------------------------------------------------------------------------
function public.FocusPic( num, inout )
  
  local obj = "spr_onposter_picture_"..num.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_GET);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menter_ho");
    end;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });

end;
------------------------------------------------------------------------------
function public.StartDrag( num )

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  ObjAttach("spr_onposter_picture_"..num,  "obj_onposter_game_fly");

end;
------------------------------------------------------------------------------
function public.OnDrag( num )
  
  local curspos = GetZoomCursorPos();
  curspos[1] = math.floor(curspos[1]);
  curspos[2] = math.floor(curspos[2]);
  
  ObjSet("spr_onposter_picture_"..num.."_focus",  { pos_x = curspos[1], pos_y = curspos[2] });
  
end;
------------------------------------------------------------------------------
function public.DropPic( num )

  --cmn.PlayAudio("snd", "assets/levels/level2/mg_onposter/audio/");

  ObjAttach("spr_onposter_picture_"..num,  "obj_onposter_mosaic_parts");

  local px = GetZoomCursorPos()[1];
  local py = GetZoomCursorPos()[2];
   if  tostring(GetPlatform()) == "android" then
      py = py - 100;
    elseif tostring(GetPlatform()) == "ios" then
      if port.isTablet() == 0 then
        py = py - 75;
      else
        py = py - 50;
      end;
    end;
  
  local old_place = 0;

  --если деталь где то стояла - освобождаем место
  for j = 1, #private.state[1], 1 do

    if private.state[1][j] == num then
       private.state[1][j] = 0;
      old_place = j;
      break;
    end;

  end;

  if (private.CheckHit(px, py, num)) then

    --ставим на занятое место
    if (private.state[1][num] ~= 0) and ((private.state[1][num] ~= num) or (private.state[2][num] ~= 0)) then

      --DbgTrace("right occup");

      local old_pic = private.state[1][num];
      private.state[1][num] = num;

      if (old_place ~= 0) then
        private.state[1][old_place] = old_pic;
      end;
      
      ObjSet("spr_onposter_picture_"..old_pic.."_focus", { pos_x = private.state_pos[num][1],  pos_y = private.state_pos[num][2] });

      --ObjMultiSet( { {"spr_onposter_picture_"..num.."_focus", { pos_x = private.pic_pos[2][num][1],  pos_y = private.pic_pos[2][num][2] }},
      --               {"spr_onposter_picture_"..old_pic.."_focus", { pos_x = private.state_pos[num][1],  pos_y = private.state_pos[num][2] }} } );

      cmn.Lock(1);  

      local func_after = function ()
        cmn.Lock(0);
        cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");
      end;

      --DbgTrace(private.state[2][num]);

      if private.state[2][num] == 0 then
        func_after = "";
      end;

      ObjAnimate("spr_onposter_picture_"..old_pic, "pos_xy", 0, 0, func_after, { 0, 0, private.state_pos[old_pic][1], private.state_pos[old_pic][2],   0.3, 0, private.state_pos[num][1], private.state_pos[num][2] });
      ObjAnimate("spr_onposter_picture_"..num, "pos_xy", 0, 0, "", { 0, 0, px, py,   0.3, 0, private.pic_pos[2][num][1], private.pic_pos[2][num][2] });
      ObjAnimate("spr_onposter_picture_"..num.."_focus", "pos_xy", 0, 0, "", { 0, 0, px, py,   0.3, 0, private.pic_pos[2][num][1], private.pic_pos[2][num][2] });
      
      if (old_pic == i) and (private.state[2][old_pic] == 0) then
        ObjAttach("spr_onposter_picture_"..old_pic, "obj_onposter_mosaic_parts");
      end;

      private.state_pos[old_pic][1] = private.state_pos[num][1];
      private.state_pos[old_pic][2] = private.state_pos[num][2];

      private.state_pos[num][1] = private.pic_pos[2][num][1];
      private.state_pos[num][2] = private.pic_pos[2][num][2];

    --ставим на верное место
    elseif (private.state[1][num] == 0) then

      --DbgTrace("right vacant");

      local func_after = function ()
        cmn.Lock(0);
        cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");
      end;
      
      if private.state[2][num] == 0 then
        func_after = "";
      end;
      
      cmn.Lock(1); 
      
      private.state[1][num] = num;
      
      private.state_pos[num][1] = private.pic_pos[2][num][1];
      private.state_pos[num][2] = private.pic_pos[2][num][2];
      
      --ObjMultiSet( { {"spr_onposter_picture_"..num, { pos_x = private.pic_pos[2][num][1],  pos_y = private.pic_pos[2][num][2] }},
      --               {"spr_onposter_picture_"..num.."_focus", { pos_x = private.pic_pos[2][num][1],  pos_y = private.pic_pos[2][num][2] }} } );
                     
      ObjAnimate("spr_onposter_picture_"..num, "pos_xy", 0, 0, func_after, { 0, 0, px, py,   0.3, 0, private.pic_pos[2][num][1], private.pic_pos[2][num][2] });
      ObjAnimate("spr_onposter_picture_"..num.."_focus", "pos_xy", 0, 0, "", { 0, 0, px, py,   0.3, 0, private.pic_pos[2][num][1], private.pic_pos[2][num][2] });
      
    end;

    if (private.state[2][num] == 0) then
      
      cmn.PlayAudio("snd", "assets/levels/level2/mg_invendingmachine/audio/aud_menter3");

      ObjSet("tmr_onposter_timer",  { time = 0.5, playing = 1, endtrig = private.CheckWin });
      ObjSet("spr_onposter_picture_"..num,  { input = 0 });
      ObjAttach("spr_onposter_picture_"..num, "obj_onposter_rihgt_place");

    end;

  else 

    local found = false;

    for i = 1, #private.state[1], 1 do
  
      if (private.CheckHit(px, py, i)) then

        found = true;

        --ставим на занятое место
        if (private.state[1][i] ~= 0) and ((private.state[1][i] ~= i) or (private.state[2][i] ~= 0)) then
        --if (private.state[1][i] ~= 0) then

          --DbgTrace("wrong occup "..i);

          local old_pic = private.state[1][i];
          private.state[1][i] = num;

          if (old_place ~= 0) then
            private.state[1][old_place] = old_pic;
          end;
          
          ObjSet("spr_onposter_picture_"..old_pic.."_focus", { pos_x = private.state_pos[num][1],  pos_y = private.state_pos[num][2] });

          --ObjMultiSet( { {"spr_onposter_picture_"..num.."_focus", { pos_x = private.pic_pos[2][i][1],  pos_y = private.pic_pos[2][i][2] }},
          --               {"spr_onposter_picture_"..old_pic.."_focus", { pos_x = private.state_pos[num][1],  pos_y = private.state_pos[num][2] }} } );

          cmn.Lock(1); 
         
          ObjAnimate("spr_onposter_picture_"..old_pic, "pos_xy", 0, 0, function () cmn.Lock(0); cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button"); end, { 0, 0, private.state_pos[old_pic][1], private.state_pos[old_pic][2],   0.3, 0, private.state_pos[num][1], private.state_pos[num][2] });
          ObjAnimate("spr_onposter_picture_"..num, "pos_xy", 0, 0, "", { 0, 0, px, py,   0.3, 0, private.pic_pos[2][i][1], private.pic_pos[2][i][2] });
          ObjAnimate("spr_onposter_picture_"..num.."_focus", "pos_xy", 0, 0, "", { 0, 0, px, py,   0.3, 0, private.pic_pos[2][i][1], private.pic_pos[2][i][2] });
          
          if (old_pic == i) and (private.state[2][old_pic] == 0) then
            ObjAttach("spr_onposter_picture_"..old_pic, "obj_onposter_mosaic_parts");
          end;

          private.state_pos[old_pic][1] = private.state_pos[num][1];
          private.state_pos[old_pic][2] = private.state_pos[num][2];

          --DbgTrace("x "..private.state_pos[num][1].." y "..private.state_pos[num][2]);

          private.state_pos[num][1] = private.pic_pos[2][i][1];
          private.state_pos[num][2] = private.pic_pos[2][i][2];

          --DbgTrace("x "..private.state_pos[num][1].." y "..private.state_pos[num][2]);

        elseif (private.state[1][i] ~= 0) then
          
          cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");

          ObjMultiSet( { {"spr_onposter_picture_"..num, { pos_x = private.state_pos[num][1],  pos_y = private.state_pos[num][2] }},
                         {"spr_onposter_picture_"..num.."_focus", { pos_x = private.state_pos[num][1],  pos_y = private.state_pos[num][2] }} } );

          ObjAttach("spr_onposter_picture_"..num, "obj_onposter_mosaic_parts");          

        --ставим на пустое неверное место
        elseif (private.state[1][i] == 0) then

          --DbgTrace("wrong vacant");
          
          cmn.Lock(1); 

          local func_after = function ()
            cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");
            cmn.Lock(0);
          end;
          
          private.state[1][i] = num;
          
          private.state_pos[num][1] = private.pic_pos[2][i][1];
          private.state_pos[num][2] = private.pic_pos[2][i][2];
          
          --ObjMultiSet( { {"spr_onposter_picture_"..num, { pos_x = private.pic_pos[2][i][1],  pos_y = private.pic_pos[2][i][2] }},
          --               {"spr_onposter_picture_"..num.."_focus", { pos_x = private.pic_pos[2][i][1],  pos_y = private.pic_pos[2][i][2] }} } );
                         
          ObjAnimate("spr_onposter_picture_"..num, "pos_xy", 0, 0, func_after, { 0, 0, px, py,   0.3, 0, private.pic_pos[2][i][1], private.pic_pos[2][i][2] });
          ObjAnimate("spr_onposter_picture_"..num.."_focus", "pos_xy", 0, 0, func_after, { 0, 0, px, py,   0.3, 0, private.pic_pos[2][i][1], private.pic_pos[2][i][2] });

        end;

        break;

      end;
      
    end;

    --ставим куда попало
    if not(found) then
  
      local occup = false;

      local curspos = GetZoomCursorPos();
      if  tostring(GetPlatform()) == "android" then
        curspos[2] = curspos[2] - 100;
      elseif tostring(GetPlatform()) == "ios" then
        if port.isTablet() == 0 then
          curspos[2] = curspos[2] - 75;
        else
          curspos[2] = curspos[2] - 50;
        end;
      end;
      
      curspos[1] = math.floor(curspos[1]);
      curspos[2] = math.floor(curspos[2]);

      local new_x = curspos[1];
      local new_y = curspos[2];

      if (new_x < private.pos_restrictions[1][1]) then
        new_x = private.pos_restrictions[1][1];
      elseif (new_x > private.pos_restrictions[1][2]) then
        new_x = private.pos_restrictions[1][2];
      end;

      if (new_y < private.pos_restrictions[2][1]) then
        new_y = private.pos_restrictions[2][1];
      elseif (new_y > private.pos_restrictions[2][2]) then
        new_y = private.pos_restrictions[2][2];
      end;

--      for i = 1, 9, 1 do
--  
--        --попали на другую деталь
--        if ( ( (new_x - private.state_pos[i][1])2 + (new_y - private.state_pos[i][2])2 ) <= 3600 ) then
--
--          occup = true;
--          cmn.Lock(1);  
--
--          --DbgTrace("empty occup");
--
--          local x2, y2;
--
--          if (new_x < 512) then
--            new_x = new_x - 40;
--            x2 = 40;
--          else
--            new_x = new_x + 40;
--            x2 = -40;
--          end;
--
--          if (new_y > 384) then
--            new_y = new_y - 40;
--            y2 = 40;
--          else
--            new_y = new_y + 40;
--            y2 = -40;
--          end;
--
--          private.state_pos[num][1] = new_x;
--          private.state_pos[num][2] = new_y;
--
--          ObjAnimate("spr_onposter_picture_"..num, "pos_xy", 0, 0, "", { 0, 0, curspos[1], curspos[2],   0.3, 0, new_x, new_y });
--          ObjAnimate("spr_onposter_picture_"..i, "pos_xy", 0, 0, function () cmn.Lock(0); end, { 0, 0, private.state_pos[i][1], private.state_pos[i][2],   0.3, 0, private.state_pos[i][1]+x2, private.state_pos[i][2]+y2 });
--
--          private.state_pos[i][1] = private.state_pos[i][1]+x2;
--          private.state_pos[i][2] = private.state_pos[i][2]+y2;
--
--          break;
--
--        end;
--        
--      end;

      --пустое место
      --if not(occup) then

        --DbgTrace("empty vacant");

        private.state_pos[num][1] = new_x;
        private.state_pos[num][2] = new_y;
        
        cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_clk_button");

        ObjMultiSet( { {"spr_onposter_picture_"..num, { pos_x = new_x,  pos_y = new_y }},
                       {"spr_onposter_picture_"..num.."_focus", { pos_x = new_x,  pos_y = new_y }} } );

      --end;

    end;

  end;

end;
-----------------------------------------------------------------------------------
function public.RotatePic( num )

  cmn.Lock(1);   
  cmn.PlayAudio("snd", "assets/levels/level2/mg_onmagicstone/audio/aud_xx_menter_stone");
  
  ObjAttach("spr_onposter_picture_"..num,  "obj_onposter_game_fly");

  local new_ang = private.state[2][num] + 1;
  local old_ang = private.state[2][num];

  if (new_ang == 8) then
    private.state[2][num] = 0;
  else 
    private.state[2][num] = new_ang;
  end;

  local func_after = function ()
    
    if (private.state[1][num] == num) and (private.state[2][num] == 0) then
      cmn.PlayAudio("snd", "assets/levels/level2/mg_invendingmachine/audio/aud_menter3");
      ObjAttach("spr_onposter_picture_"..num,  "obj_onposter_rihgt_place");
      ObjSet("spr_onposter_picture_"..num,  { input = 0 });
    else 
      ObjAttach("spr_onposter_picture_"..num,  "obj_onposter_mosaic_parts");
    end;
    
    private.CheckWin();

  end;

  local k_ang = 0.785;

  ObjAnimate("spr_onposter_picture_"..num, "ang", 0, 0, func_after, { 0, 0, -k_ang*old_ang,   0.3, 0, -k_ang*new_ang });
  ObjAnimate("spr_onposter_picture_"..num.."_focus", "ang", 0, 0, func_after, { 0, 0, -k_ang*old_ang,   0.3, 0, -k_ang*new_ang });

end;
------------------------------------------------------------------------------
function private.CheckHit( px, py, num )

  local centr = {0, 0}; 
  local accuracy = 70;

  centr[1] = private.pic_pos[2][num][1];
  centr[2] = private.pic_pos[2][num][2];

  if ( (px - centr[1])^2 + (py - centr[2])^2 ) <= accuracy^2 then 

    return true;

  else

    return false;

  end; 

end;
-----------------------------------------------------------------------------------
function private.CheckWin()
  
  local win_flag = true;

  for i = 1, #private.state[1], 1 do

    if (private.state[1][i] ~= i) or (private.state[2][i] ~= 0) then

      win_flag = false;
      break;

    end;

  end;

  if win_flag then

    cmn.Lock(1);

    if ng_global.currentprogress == "std" then
      cmn.PlayAudio("snd", "assets/levels/common/audio/aud_win_mg");
      ObjSet("tmr_onposter_timer",  { time = 1, playing = 1, endtrig = private.Win });
    else 
      rm_extra.MiniGameHide();
      int_dialog_secretroom.StopTimer();
      ObjSet("tmr_onposter_timer",  { time = 1, playing = 1, endtrig = private.WinEnd });
    end;

  else

    cmn.Lock( 0 );

  end;

end;
-----------------------------------------------------------------------------------
function private.WinEnd()

  cmn.Lock( 0 );
  cmn.SetEventDone( "win_onposter" );
  
  if ng_global.currentprogress == "std" then
  
    cmn.CallEventHandler( "win_onposter" );

    if ng_global.progress[ ng_global.currentprogress ][ "win_onposter" ].skip == 0 and not ng_global.noskipgames[ "win_onposter" ] then

      ng_global.noskipgames[ "win_onposter" ] = 1;
      common_impl.CheckAchiev("mg");

    end;
    
    if ng_global.playedgames and not ng_global.playedgames[ "win_onposter" ] then
      ng_global.playedgames[ "win_onposter" ] = 1;
    end;

    common_impl.PauseAchiev( 0 );
    
  else 
    interface_impl.ShowStarsWindow();
  end;

end;
-----------------------------------------------------------------------------------
function private.Win()

  cmn.MiniGameHide();

  common_impl.PauseAchiev( 1 );
  cmn.EndTimePassing( "mg_onposter" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/mg_onposter/audio/aud_slide_picture");

  ObjAnimate("obj_onposter_game", "alp", 0, 0, private.WinEnd, { 0, 0, 1,   0.5, 0, 0 });

end;
--*********************************************************************************************************************