-- name=rm_atshore
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_atshore";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  
  private.dlg_lipsync = "";
  private.dlg_finished = true;
  --------------------------------------------------------------------------------------------
  -- function get_shiningstone2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_shiningstone2" ] = {
      type = "get",
      get_obj = "spr_shore_shiningstone2",
      room = private.room_objname,
      zz = "zz_shore",
      zz_gate = "gzz_atshore_shore"
  };
  --------------------------------------------------------------------------------------------
  local get_shiningstone2_inv = function ()
  
    interface.InventoryItemAdd( "inv_shiningstone", "spr_shore_shiningstone2", function () cmn.GetMultyObject( 'shiningstone', 3 ); end );
  
  end;
  local get_shiningstone2_end = function ()
  
    ObjDelete( "gfx_shore_shiningstone2" );
    ObjDelete( "spr_atshore_shore_stone" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_shiningstone2", get_shiningstone2_inv );
  cmn.AddSubscriber( "get_shiningstone2", get_shiningstone2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_file () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_file" ] = {
      type = "get",
      get_obj = "spr_shipwreck_file",
      room = private.room_objname,
      zz = "zz_shipwreck",
      zz_gate = "gzz_atshore_shipwreck"
  };
  --------------------------------------------------------------------------------------------
  local get_file_inv = function ()
  
    interface.InventoryItemAdd( "inv_file", "spr_shipwreck_file" );
  
  end;
  local get_file_end = function ()
  
    ObjDelete( "gfx_shipwreck_file" );
    ObjDelete( "spr_shipwreck_file_sh" );
    
    ObjDelete( "spr_atshore_ship_file" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_file", get_file_inv );
  cmn.AddSubscriber( "get_file", get_file_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bell3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bell3" ] = {
      type = "get",
      get_obj = "spr_shipwreck_bell3",
      room = private.room_objname,
      zz = "zz_shipwreck",
      zz_gate = "gzz_atshore_shipwreck"
  };
  --------------------------------------------------------------------------------------------
  local get_bell3_inv = function ()
  
    interface.InventoryItemAdd( "inv_bell3", "spr_shipwreck_bell3" );
  
  end;
  local get_bell3_end = function ()
  
    ObjDelete( "gfx_shipwreck_bell3" );
    ObjDelete( "spr_shipwreck_bell3_sh" );
    
    ObjDelete( "spr_atshore_ship_bell" );
    
    if cmn.IsEventDone("get_nails") and cmn.IsEventDone("get_graplinghook") then
      ObjDelete( "gzz_atshore_shipwreck" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bell3", get_bell3_inv );
  cmn.AddSubscriber( "get_bell3", get_bell3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_nails () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_nails" ] = {
      type = "get",
      get_obj = "spr_shipwreck_nails",
      room = private.room_objname,
      zz = "zz_shipwreck",
      zz_gate = "gzz_atshore_shipwreck"
  };
  --------------------------------------------------------------------------------------------
  local get_nails_inv = function ()
  
    interface.InventoryItemAdd( "inv_nails", "spr_shipwreck_nails" );
    
    if cmn.IsEventDone("use_bridgeplanks") then
      ObjSet("inv_bridgebase_star_light",  { alp = 1 });
    end;
  
  end;
  local get_nails_end = function ()
  
    ObjDelete( "spr_shipwreck_nails_sh" );
    
    ObjDelete( "spr_atshore_ship_nails" );
    
    if cmn.IsEventDone("get_bell3") and cmn.IsEventDone("get_graplinghook") then
      ObjDelete( "gzz_atshore_shipwreck" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_nails", get_nails_inv );
  cmn.AddSubscriber( "get_nails", get_nails_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_graplinghook () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_graplinghook" ] = {
      type = "get",
      get_obj = "spr_shipwreck_graplinghook",
      room = private.room_objname,
      zz = "zz_shipwreck",
      zz_gate = "gzz_atshore_shipwreck"
  };
  --------------------------------------------------------------------------------------------
  local get_graplinghook_inv = function ()
  
    interface.InventoryItemAdd( "inv_graplinghook", "spr_shipwreck_graplinghook" );
  
  end;
  local get_graplinghook_end = function ()
  
    ObjDelete( "gfx_shipwreck_graplinghook" );
    ObjDelete( "spr_shipwreck_graplinghook_sh" );
    
    ObjDelete( "spr_atshore_ship_hook" );
    
    if cmn.IsEventDone("get_nails") and cmn.IsEventDone("get_bell3") then
      ObjDelete( "gzz_atshore_shipwreck" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_graplinghook", get_graplinghook_inv );
  cmn.AddSubscriber( "get_graplinghook", get_graplinghook_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bridgebase () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bridgebase" ] = {
      type = "get",
      get_obj = "spr_atshore_bridgefounding",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_bridgebase_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_bridgebase", "spr_atshore_bridgefounding" );
  
  end;
  local get_bridgebase_end = function ()
  
    ObjDelete( "gfx_atshore_bridgefounding" );
    ObjDelete( "spr_atshore_bridgefounding_sh" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bridgebase", get_bridgebase_inv );
  cmn.AddSubscriber( "get_bridgebase", get_bridgebase_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magicpage1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_magicpage1" ] = {
      type = "get",
      get_obj = "spr_atshore_magicpage1",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_magicpage1_inv = function ()
  
    interface.InventoryItemAdd( "inv_magicpage", "spr_atshore_magicpage1", function () cmn.GetMultyObject( 'magicpage', 6 ); end );
  
  end;
  local get_magicpage1_mid = function ()
  
    ObjDelete( "gfx_atshore_magicpage1" );
    ObjDelete( "spr_atshore_magicpage1_sh" );
  
  end;
  local get_magicpage1_end = function ()
  
    ObjDelete( "obj_atshore_dialog_veronica1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_magicpage1", get_magicpage1_inv );
  cmn.AddSubscriber( "get_magicpage1_inv", get_magicpage1_inv, private.room_objname );
  cmn.AddSubscriber( "get_magicpage1", get_magicpage1_mid, private.room_objname );
  cmn.AddSubscriber( "get_magicpage1_mid", get_magicpage1_mid, private.room_objname );
  cmn.AddSubscriber( "get_magicpage1", get_magicpage1_end, private.room_objname );
  cmn.AddSubscriber( "get_magicpage1_end", get_magicpage1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bellknot () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bellknot" ] = {
      type = "get",
      get_obj = "spr_atshore_bellknot",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_bellknot_inv = function ()
  
    interface.InventoryItemAdd( "inv_bellknot", "spr_atshore_bellknot" );
    int_map_impl.DecreaseRoomTasks("rm_atshore");
  
  end;
  local get_bellknot_mid = function ()
  
    ObjDelete( "gfx_atshore_bellknot" );
    ObjDelete( "spr_atshore_bellknot_sh" );
  
  end;
  local get_bellknot_end = function ()
  
    ObjDelete( "obj_atshore_dialog_veronica3" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bellknot", get_bellknot_inv );
  cmn.AddSubscriber( "get_bellknot_inv", get_bellknot_inv, private.room_objname );
  cmn.AddSubscriber( "get_bellknot", get_bellknot_mid, private.room_objname );
  cmn.AddSubscriber( "get_bellknot_mid", get_bellknot_mid, private.room_objname );
  cmn.AddSubscriber( "get_bellknot", get_bellknot_end, private.room_objname );
  cmn.AddSubscriber( "get_bellknot_end", get_bellknot_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_selfmadebridgre () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_selfmadebridgre" ] = {
      type = "use",
      inv_obj = "inv_selfmadebridgre",
      use_place = "obj_shore_use_selfmadebridgre",
      room = private.room_objname,
      zz = "zz_shore",
      zz_gate = "gzz_atshore_shore"
  };
  --------------------------------------------------------------------------------------------
  local use_selfmadebridgre_inv = function ()
  
    interface.InventoryItemRemove( "inv_selfmadebridgre" );
  
  end;
  local use_selfmadebridgre_beg = function ()
  
    ObjDelete( "obj_shore_use_selfmadebridgre" );
    ObjDelete( "anm_atshore_shark" );
    ObjSet("anm_atshore_shark_2",  { alp = 1 });
  
  end;
  local use_selfmadebridgre_end = function ()
    
    ObjDelete( "gzz_atshore_shore" );
    ObjDelete( "vid_atshore_dialog_veronica1_lipsync1" );
    
    ObjAttach("obj_atshore_dialog_veronica1", "rm_atshore");
  
    ObjMultiSet( { {"obj_atshore_dialog_veronica1", { alp = 1, input = 1 }},
                   {"obj_atshore_use_lvl2crystalshoe", { alp = 1, input = 1 }},
                   {"anm_atshore_dialog_veronica_head", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_selfmadebridgre", use_selfmadebridgre_beg, private.room_objname );
  cmn.AddSubscriber( "use_selfmadebridgre", use_selfmadebridgre_inv );
  cmn.AddSubscriber( "use_selfmadebridgre", use_selfmadebridgre_end, private.room_objname );
  cmn.AddSubscriber( "use_selfmadebridgre_inv", use_selfmadebridgre_inv, private.room_objname );
  cmn.AddSubscriber( "use_selfmadebridgre_beg", use_selfmadebridgre_beg, private.room_objname );
  cmn.AddSubscriber( "use_selfmadebridgre_end", use_selfmadebridgre_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_staff () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_staff" ] = {
      type = "use",
      inv_obj = "inv_staff",
      use_place = "obj_shipwreck_use_staff",
      room = private.room_objname,
      zz = "zz_shipwreck",
      zz_gate = "gzz_atshore_shipwreck"
  };
  --------------------------------------------------------------------------------------------
  local use_staff_inv = function ()
  
    interface.InventoryItemRemove( "inv_staff" );
  
  end;
  local use_staff_beg = function ()
  
    ObjDelete( "obj_shipwreck_use_staff" );
  
  end;
  local use_staff_end = function ()
  
    ObjSet( "obj_shipwreck_ship_open", { input = 1, alp = 1 } );
    ObjDelete( "obj_shipwreck_crabs" );
    
    ObjDelete( "anm_atshore_crabs" );

    ObjDelete( "vid_shipwreck_use_staff" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_staff", use_staff_beg, private.room_objname );
  cmn.AddSubscriber( "use_staff", use_staff_inv );
  cmn.AddSubscriber( "use_staff", use_staff_end, private.room_objname );
  cmn.AddSubscriber( "use_staff_inv", use_staff_inv, private.room_objname );
  cmn.AddSubscriber( "use_staff_beg", use_staff_beg, private.room_objname );
  cmn.AddSubscriber( "use_staff_end", use_staff_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spade () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_spade" ] = {
      type = "use",
      inv_obj = "inv_spade",
      use_place = "obj_atshore_use_spade",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local use_spade_inv = function ()
  
    interface.InventoryItemRemove( "inv_spade" );
  
  end;
  local use_spade_beg = function ()
  
    ObjDelete( "obj_atshore_use_spade" );
    ObjDelete( "anm_atshore_wood_touch" );
  
  end;
  local use_spade_end = function ()
  
    ObjSet( "anm_atshore_use_shovel", { input = 1, alp = 1, frame = 400 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_spade", use_spade_beg, private.room_objname );
  cmn.AddSubscriber( "use_spade", use_spade_inv );
  cmn.AddSubscriber( "use_spade", use_spade_end, private.room_objname );
  cmn.AddSubscriber( "use_spade_inv", use_spade_inv, private.room_objname );
  cmn.AddSubscriber( "use_spade_beg", use_spade_beg, private.room_objname );
  cmn.AddSubscriber( "use_spade_end", use_spade_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl2crystalshoe () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl2crystalshoe" ] = {
      type = "use",
      inv_obj = "inv_lvl2crystalshoe",
      use_place = "obj_atshore_use_lvl2crystalshoe",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local use_lvl2crystalshoe_inv = function ()
  
    --interface.InventoryItemRemove( "inv_lvl2crystalshoe" );
  
  end;
  local use_lvl2crystalshoe_beg = function ()
  
    ObjDelete( "obj_atshore_use_lvl2crystalshoe" );
  
  end;
  local use_lvl2crystalshoe_end = function ()
    
    ObjDelete( "vid_atshore_dialog_veronica1_lipsync2" );
    ObjDelete( "vid_atshore_dialog_veronica1_lipsync3" );
    ObjDelete( "vid_atshore_dialog_veronica1_lipsync4" );
  
    ObjSet("obj_atshore_dialog_veronica_hand_2",  { alp = 1, input = 1 });
    ObjDelete( "anm_atshore_dialog_veronica_hand_1" );
    ObjDelete( "anm_atshore_dialog_veronica_hand_shoe" );
    ObjDelete( "anm_atshore_dialog_veronica_hand_shoe_end" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl2crystalshoe", use_lvl2crystalshoe_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl2crystalshoe", use_lvl2crystalshoe_inv );
  cmn.AddSubscriber( "use_lvl2crystalshoe", use_lvl2crystalshoe_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl2crystalshoe_inv", use_lvl2crystalshoe_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl2crystalshoe_beg", use_lvl2crystalshoe_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl2crystalshoe_end", use_lvl2crystalshoe_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_atshore () end;
  --------------------------------------------------------------------------------------------
  local opn_atshore_map = function ()
  
    int_map_impl.OpenRoom( "rm_atshore" );
    interface_impl.SetCurrentGlobalTask( 9 );
  
  end;
  local opn_atshore_loc = function ()
  
    ObjSet("anm_atshore_veronica",  { alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_atshore", opn_atshore_map );
  cmn.AddSubscriber( "opn_atshore", opn_atshore_loc, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_atshoremagicpage () end;
  --------------------------------------------------------------------------------------------
  local opn_atshoremagicpage_task = function ()
    
    interface_impl.SetCurrentGlobalTask( 13 );
    
    int_map_impl.OpenRoom( "rm_forestthicket" );
    int_map_impl.OpenRoom( "rm_atshore" );
    int_map_impl.OpenRoom( "rm_foresthouse" );
    
    int_map_impl.BlockRoom( "rm_nearhospital" );
    int_map_impl.BlockRoom( "rm_corridor" );
    int_map_impl.BlockRoom( "rm_clothesroom" );
    int_map_impl.BlockRoom( "rm_mermaidsward" );
    
    interface.InventoryItemAdd( "inv_lvl2mermaidpage" );
    --interface.InventoryItemRemove( "inv_magicpage" );
    
  end;
  local opn_atshoremagicpage_loc = function ()
  
    ObjDelete( "anm_atshore_dialog_veronica3_hand_1" );
    
    ObjDelete( "vid_atshore_dialog_veronica3_lipsync1" );
    ObjDelete( "vid_atshore_dialog_veronica3_lipsync2" );
    
    ObjAttach("obj_atshore_dialog_veronica3", "rm_atshore");
  
    ObjMultiSet( { {"obj_atshore_dialog_veronica3", { alp = 1, input = 1 }},
                   {"obj_atshore_dialog_veronica_hand_3", { alp = 1, input = 1 }},
                   {"anm_atshore_mermaid", { alp = 1 }},
                   {"anm_atshore_dialog_veronica3_head", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_atshoremagicpage", opn_atshoremagicpage_loc, private.room_objname );
  cmn.AddSubscriber( "opn_atshoremagicpage", opn_atshoremagicpage_task );
  cmn.AddSubscriber( "opn_atshoremagicpage_loc", opn_atshoremagicpage_loc, private.room_objname );
  cmn.AddSubscriber( "opn_atshoremagicpage_task", opn_atshoremagicpage_task );
  --------------------------------------------------------------------------------------------
  -- function opn_shipwreck () end;
  --------------------------------------------------------------------------------------------
  local opn_shipwreck = function ()
  
    ObjDelete("vid_shipwreck_shadow");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_shipwreck", opn_shipwreck, private.room_objname );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_shipwreck" );
  
  function zz_shipwreck.PreOpen()
    
    if not cmn.IsEventDone("opn_shipwreck") then
      cmn.Lock( 1 );
    end;
    
  end;
  
  function zz_shipwreck.Open()
    
    if not cmn.IsEventDone("opn_shipwreck") then
      
      local func_after = function ()
        
        cmn.Lock( 0 );
        cmn.CallEventHandler("opn_shipwreck");
        
      end;
      
      local anm_vid = function ()
        ObjAnimate("vid_shipwreck_shadow", "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });
      end;
      
      cmn.SetEventDone("opn_shipwreck");
      cmn.PlayAudio( "snd", "assets/levels/level2/rm_atshore/audio/aud_shadowgull" );
      ObjSet("vid_shipwreck_shadow",  { playing = 1, endtrig = anm_vid });
      
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_atshore();
  
  if cmn.IsEventDone("use_selfmadebridgre") and not cmn.IsEventDone("use_lvl2crystalshoe") then
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  end;
  if cmn.IsEventDone("use_lvl2crystalshoe") and not cmn.IsEventDone("get_magicpage1") then
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_atshore_dialog_veronica2";
  end;
  if cmn.IsEventDone("opn_atshoremagicpage") and not cmn.IsEventDone("get_bellknot") then
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_atshore_dialog_veronica3";
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_atshore_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_atshore_env");
  
  if not cmn.IsEventDone("opn_atshore") then
    cmn.Lock(1);
  end;
  
  if cmn.IsEventDone("get_magicpage1") and private.dlg_finished and not cmn.IsEventDone("use_magicpage") then
    common_impl.current_dialog = "";
    cmn.Lock(1);
  end;
  
  if cmn.IsEventDone("use_magicpage") and not cmn.IsEventDone("opn_atshoremagicpage") then
    cmn.Lock(1);
    --cmn.CallEventHandler( "opn_atshoremagicpage_task" );
    ObjSet("anm_atshore_mermaid",  { alp = 1 });
  end;
  
  ObjSet("rm_atshore",  { color_r = 1, color_g = 1, color_b = 1 });
  
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(5) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_selfmadebridgre()

  local item = "inv_selfmadebridgre";

  if cmn.ApplyObj( item, "gzz_atshore_shore" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_shore" );

  elseif ( cmn.ApplyObj( item, "obj_shore_use_selfmadebridgre" ) ) then

    cmn.CallEventHandler( "use_selfmadebridgre_inv" );
    cmn.CallEventHandler( "use_selfmadebridgre_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_selfmadebridgre" );
      --cmn.CallEventHandler( "use_selfmadebridgre_end" );
      
      common.CloseSubRoom();
      private.dialog_veronica_open(1);
    
    end;

    cmn.Lock( 1 );

    ObjAnimate( "obj_shore_selfmadebridgre", "alp", 0, 0, func_after,
    {
      0.0, 0, 0, 
      0.5, 0, 1,
      0.8, 0, 1
    } );

    cmn.PlayAudio( "snd", "assets/levels/level2/rm_atshore/audio/aud_use_bridge" );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_staff()

  local item = "inv_staff";

  if cmn.ApplyObj( item, "gzz_atshore_shipwreck" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_shipwreck" );

  elseif ( cmn.ApplyObj( item, "obj_shipwreck_use_staff" ) ) then

    cmn.CallEventHandler( "use_staff_inv" );
    cmn.CallEventHandler( "use_staff_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_staff" );
      cmn.CallEventHandler( "use_staff_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio( "snd", "assets/levels/level2/rm_atshore/audio/aud_use_staff" );

    ObjAttach("vid_shipwreck_use_staff", "zz_shipwreck");
    ObjAnimate("vid_shipwreck_use_staff", "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 1 });
    VidPlay("vid_shipwreck_use_staff", func_after);

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_spade()

  local item = "inv_spade";

  if ( cmn.ApplyObj( item, "obj_atshore_use_spade" ) ) then

    cmn.CallEventHandler( "use_spade_inv" );
    cmn.CallEventHandler( "use_spade_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_spade" );
      cmn.CallEventHandler( "use_spade_end" );
    
    end;

    cmn.Lock( 1 );

    ObjSet("anm_atshore_use_shovel",  { alp = 1, playing = 1, endtrig = func_after });

    cmn.PlayAudio( "snd", "assets/levels/level2/rm_atshore/audio/aud_use_shovel" );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl2crystalshoe()

  local item = "inv_lvl2crystalshoe";

  if cmn.ApplyObj( item, "obj_atshore_use_lvl2crystalshoe" ) and cmn.IsEventDone("use_selfmadebridgre") then

    cmn.CallEventHandler( "use_lvl2crystalshoe_inv" );
    cmn.CallEventHandler( "use_lvl2crystalshoe_beg" );

    local func_after = function ()

      --cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl2crystalshoe" );
      
      private.dialog_veronica2_beg();
    
    end;
    
    cmn.Lock( 1 );

    ObjMultiSet( { {"anm_atshore_dialog_veronica_hand_shoe", { animfunc = "func_shoe", alp = 1, playing = 1, endtrig = func_after }},
                   {"anm_atshore_dialog_veronica_hand_shoe_end", { animfunc = "func_shoe_2" }} } );
    

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_shiningstone2()

  cmn.SetEventDone( "get_shiningstone2" );
  cmn.CallEventHandler( "get_shiningstone2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_file()

  cmn.SetEventDone( "get_file" );
  cmn.CallEventHandler( "get_file" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_bell3()

  cmn.SetEventDone( "get_bell3" );
  cmn.CallEventHandler( "get_bell3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_nails") then
    common.CloseSubRoom();
    if not cmn.IsEventDone("get_graplinghook") then
      cmn.SetEventDone( "get_graplinghook" );
      cmn.CallEventHandler( "get_graplinghook" );
    end;
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_nails()

  cmn.SetEventDone( "get_nails" );
  cmn.CallEventHandler( "get_nails" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_bell3") then
    common.CloseSubRoom();
    if not cmn.IsEventDone("get_graplinghook") then
      cmn.SetEventDone( "get_graplinghook" );
      cmn.CallEventHandler( "get_graplinghook" );
    end;
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_graplinghook()

  cmn.SetEventDone( "get_graplinghook" );
  cmn.CallEventHandler( "get_graplinghook" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_bridgefounding()
  
  ObjSet("spr_atshore_bridgefounding",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_bridgebase" );
  cmn.CallEventHandler( "get_bridgebase" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_magicpage1()
  
  local func_after_dlg = function ()

    --cmn.Lock(0);
    cmn.CallEventHandler( "get_magicpage1_end" );

    ObjSet("rm_atshore",  { color_r = 0, color_g = 0, color_b = 0 });
    cmn.GotoRoom("rm_nearhospital");

  end;

  cmn.SetEventDone( "get_magicpage1" );
  cmn.CallEventHandler( "get_magicpage1_inv" );
  cmn.CallEventHandler( "get_magicpage1_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common_impl.current_dialog = "";
  
  cmn.StopAllEnv();
  
  cmn.PlayFullscreenVideo( "assets/levels/level2/rm_atshore/vid_backtoreality", func_after_dlg, 
    "assets/levels/level2/rm_atshore/audio/aud_backtoreality", ""
  );

end;
--------------------------------------------------------------------------------------------
function public.get_bellknot()
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_bellknot_end" );
    
    common_impl.PlayBackgroundMusic();

  end;

  cmn.SetEventDone( "get_bellknot" );
  cmn.CallEventHandler( "get_bellknot_inv" );
  cmn.CallEventHandler( "get_bellknot_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  ObjAnimate("obj_atshore_dialog_veronica3", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.5, 0, 0 });

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_atshore()

  if not ( cmn.IsEventDone( "opn_atshore" ) ) then
    
    local func_after = function ()
      cmn.ShowBbt( "atshore_open" );
      cmn.CallEventHandler("opn_atshore");
      interface_impl.ShowGlobalTask();
      int_map_impl.AddDiarypage( 5 );
      cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_atshore_env");
    end;
    
    cmn.SetEventDone( "opn_atshore" );
    cmn.Lock(0);
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level2/rm_atshore/vid_mermaid_splash", func_after, "assets/levels/level2/rm_atshore/audio/aud_appearance_mermaid", "");

  end;
  
  if cmn.IsEventDone("get_magicpage1") and private.dlg_finished and not cmn.IsEventDone("use_magicpage") then
    
    local func_after = function ()
      ObjSet("rm_atshore",  { color_r = 0, color_g = 0, color_b = 0 });
      cmn.GotoRoom("rm_nearhospital");
    end;
    
    cmn.Lock(0);
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level2/rm_atshore/vid_backtoreality", func_after, "assets/levels/level2/rm_atshore/audio/aud_backtoreality", "");
    
  end;
  
  if cmn.IsEventDone("use_magicpage") and not cmn.IsEventDone("opn_atshoremagicpage") then
    cmn.SetEventDone("opn_atshoremagicpage");
    private.dialog_veronica_open( 3 );
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_wood_planks()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_atshore_use_spade" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_atshore/audio/aud_xx_wood_sand");
  
  ObjSet("anm_atshore_wood_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_crabs()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_shipwreck_use_staff" );
  cmn.PlayAudio("snd", "assets/levels/level2/rm_atshore/audio/aud_xx_clk_crab");
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_shipwreck_crab_1_touch", { alp = 0 }},
                   {"anm_shipwreck_crab_1", { alp = 1, playing = 1 }},
                   {"anm_shipwreck_crab_2_touch", { alp = 0 }},
                   {"anm_shipwreck_crab_2", { alp = 1, playing = 1 }},
                   {"anm_shipwreck_crab_3_touch", { alp = 0 }},
                   {"anm_shipwreck_crab_3", { alp = 1, playing = 1 }} } );
    
  end;
  
  ObjMultiSet( { {"anm_shipwreck_crab_1_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_shipwreck_crab_1", { alp = 0, playing = 0 }},
                 {"anm_shipwreck_crab_2_touch", { alp = 1, playing = 1 }},
                 {"anm_shipwreck_crab_2", { alp = 0, playing = 0 }},
                 {"anm_shipwreck_crab_3_touch", { alp = 1, playing = 1 }},
                 {"anm_shipwreck_crab_3", { alp = 0, playing = 0 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_shark()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_shore_use_selfmadebridgre" );
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_shore_shark_touch", { alp = 0 }},
                   {"anm_shore_shark", { frame = 0, alp = 1, playing = 1 }} } );
    
  end;
  
  local anm_shark = function ()
    
    ObjMultiSet( { {"anm_shore_shark_touch", { playing = 1, endtrig = func_after }},
                   {"anm_shore_shark", { playing = 0 }} } );
      
  end;
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_atshore/audio/aud_xx_clk_shark");
  
  ObjAnimate("anm_shore_shark", "alp", 0, 0, anm_shark, { 0, 0, 1,   0.3, 0, 0 });
  ObjAnimate("anm_shore_shark_touch", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_5_1", { alp = 1 }},
                 {"spr_col_5_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_5_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_5_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_5_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_5_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_5_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_5_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_veronica_open( num )
  
  private.dlg_finished = false;
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  
  local func_after = function() private.dialog_veronica1_beg(); end;
  if num == 2 then
    func_after = function() private.dialog_veronica2_beg(); end;
  elseif num == 3 then
    func_after = function() private.dialog_veronica3_beg(); end;
  end;
  
  ObjAttach("obj_atshore_dialog_veronica"..num, "rm_atshore");
  ObjAnimate("obj_atshore_dialog_veronica"..num, "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_veronica1_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "atshore", "veronica1", 2 );
  
  local dialog_end = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "use_selfmadebridgre_end" );
    private.dlg_finished = true;
    
  end;
  
  local dialog_hide = function ()
    
    ObjDelete("vid_atshore_dialog_veronica1_lipsync1");

    private.dlg_lipsync = "";
    interface.InterfaceSetInput( true );
    int_blackbartext.Hide();
    cmn.Lock(1);
    common_impl.current_dialog = "";
    common_impl.CharacterDialogButtonsHide();
    
    SndStop( common_impl.audio.voc, 0.5 );

    ObjMultiSet( { {"tmr_atshore_dialog_veronica1_timer", { playing = 0 }},
                   {"anm_atshore_dialog_veronica_head", { alp = 1 }} } );

    ObjAnimate( "obj_atshore_use_lvl2crystalshoe", "alp", 0, 0, dialog_end, { 0, 0, 0,   0.3, 0, 1 } );
    
  end;
  
  private.dlg_lipsync = "vid_atshore_dialog_veronica1_lipsync1";

  cmn.ShowDlgBbt( "dlg_veronica1_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level2/rm_atshore/audio/aud_veronica_dlg1_voc");

  ObjMultiSet( { {"tmr_atshore_dialog_veronica1_timer", { time = 7.2, playing = 1, endtrig = dialog_hide }},
                 {"vid_atshore_dialog_veronica1_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = dialog_hide }},
                 {"obj_character_dialog_continue", { event_mup = dialog_hide }} } );
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_veronica2_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "atshore", "veronica1", 2 );
  
  local dialog_end = function ()
  
    private.dlg_lipsync = "";
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "use_lvl2crystalshoe_end" );
    private.dlg_finished = true;
    
  end;
  
  local anm_give = function ()
    
    private.dlg_lipsync = "";
    
    ObjDelete("vid_atshore_dialog_veronica1_lipsync4");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_atshore_dialog_veronica1_timer", { playing = 0 }},
                   {"anm_atshore_dialog_veronica_head", { alp = 1 }} } );
    
    ObjAnimate("obj_atshore_dialog_veronica_hand_2", "alp", 0, 0, dialog_end, { 0, 0, 0,   0.5, 0, 1 });
    ObjAnimate("anm_atshore_dialog_veronica_hand_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    
  end;
  
  local veronica_talks3 = function ()
  
    ObjDelete("vid_atshore_dialog_veronica1_lipsync3");
    ObjAttach("vid_atshore_dialog_veronica1_lipsync4", "obj_atshore_dialog_veronica1");
  
    cmn.ShowDlgBbt( "dlg_veronica2_phrase_3" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level2/rm_atshore/audio/aud_veronica_dlg2_3_voc");
    private.dlg_lipsync = "vid_atshore_dialog_veronica1_lipsync4";
    
    ObjMultiSet( { {"tmr_atshore_dialog_veronica1_timer", { endtrig = anm_give, time = 8.7, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_give }},
                   {"obj_character_dialog_continue", { event_mup = anm_give }},
                   {"vid_atshore_dialog_veronica1_lipsync4", { playing = 1 }} } );
  
  end;
  
  local veronica_talks2 = function ()
  
    ObjDelete("vid_atshore_dialog_veronica1_lipsync2");
    ObjAttach("vid_atshore_dialog_veronica1_lipsync3", "obj_atshore_dialog_veronica1");
  
    cmn.ShowDlgBbt( "dlg_veronica2_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level2/rm_atshore/audio/aud_veronica_dlg2_2_voc");
    private.dlg_lipsync = "vid_atshore_dialog_veronica1_lipsync3";
    
    ObjMultiSet( { {"tmr_atshore_dialog_veronica1_timer", { endtrig = veronica_talks3, time = 10.7, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = veronica_talks3 }},
                   {"obj_character_dialog_continue", { event_mup = veronica_talks3 }},
                   {"vid_atshore_dialog_veronica1_lipsync3", { playing = 1 }},
                   {"anm_atshore_dialog_veronica_hand_shoe_end", { alp = 1, playing = 1 }},
                   {"anm_atshore_dialog_veronica_hand_shoe", { alp = 0 }} } );
  
  end;
                 
  ObjAttach("vid_atshore_dialog_veronica1_lipsync2", "obj_atshore_dialog_veronica1");

  private.dlg_lipsync = "vid_atshore_dialog_veronica1_lipsync2";

  cmn.ShowDlgBbt( "dlg_veronica2_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level2/rm_atshore/audio/aud_veronica_dlg2_1_voc");

  ObjMultiSet( { {"tmr_atshore_dialog_veronica1_timer", { time = 7.5, playing = 1, endtrig = veronica_talks2 }},
                 {"vid_atshore_dialog_veronica1_lipsync2", { playing = 1 }},
                 {"anm_atshore_dialog_veronica_head", { alp = 0 }},
                 {"spr_character_dialog_continue", { event_mup = veronica_talks2 }},
                 {"spr_character_dialog_skip", { event_mup = public.skip_dlg_veronica2 }},
                 {"obj_character_dialog_continue", { event_mup = veronica_talks2 }} } );
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_veronica3_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "atshore", "veronica3", 2 );
  
  local dialog_end = function ()
  
    private.dlg_lipsync = "";
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "opn_atshoremagicpage_loc" );
    private.dlg_finished = true;
    
    cmn.ShowBbt( "atshore_after_return" );
    interface_impl.ShowGlobalTask();
    int_map_impl.AddDiarypage( 7 );
    
  end;
  
  local anm_give = function ()
    
    private.dlg_lipsync = "";
    
    ObjDelete("vid_atshore_dialog_veronica3_lipsync2");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );

    ObjMultiSet( { {"tmr_atshore_dialog_veronica3_timer", { playing = 0 }},
                   {"anm_atshore_dialog_veronica3_head", { alp = 1 }} } );
    
    ObjAnimate("obj_atshore_dialog_veronica_hand_3", "alp", 0, 0, dialog_end, { 0, 0, 0,   0.5, 0, 1 });
    ObjAnimate("anm_atshore_dialog_veronica3_hand_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    
  end;
  
  local veronica_talks2 = function ()
  
    ObjDelete("vid_atshore_dialog_veronica3_lipsync1");
    ObjAttach("vid_atshore_dialog_veronica3_lipsync2", "obj_atshore_dialog_veronica3");
  
    cmn.ShowDlgBbt( "dlg_veronica3_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level2/rm_atshore/audio/aud_veronica_dlg3_2_voc");
    private.dlg_lipsync = "vid_atshore_dialog_veronica3_lipsync2";
    
    ObjMultiSet( { {"tmr_atshore_dialog_veronica3_timer", { endtrig = anm_give, time = 7.6, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_give }},
                   {"obj_character_dialog_continue", { event_mup = anm_give }},
                   {"vid_atshore_dialog_veronica3_lipsync2", { playing = 1 }} } );
  
  end;

  private.dlg_lipsync = "vid_atshore_dialog_veronica3_lipsync1";

  cmn.ShowDlgBbt( "dlg_veronica3_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level2/rm_atshore/audio/aud_veronica_dlg3_1_voc");

  ObjMultiSet( { {"tmr_atshore_dialog_veronica3_timer", { time = 7.5, playing = 1, endtrig = veronica_talks2 }},
                 {"vid_atshore_dialog_veronica3_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = veronica_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = veronica_talks2 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_veronica1()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  common_impl.current_dialog = "";
  private.dlg_finished = true;
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "use_selfmadebridgre_end" );
    
  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  ObjMultiSet( { {"tmr_atshore_dialog_veronica1_timer", { playing = 0 }},
                 {"anm_atshore_dialog_veronica_head", { alp = 1 }} } );
                   
  common_impl.CharacterDialogButtonsHide();
  ObjAnimate("obj_atshore_use_lvl2crystalshoe", "alp", 0, 0, func_after_dlg, { 0, 0, 0,   0.5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_veronica2()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  common_impl.current_dialog = "";
  private.dlg_finished = true;

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "use_lvl2crystalshoe_end" );
    
  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  ObjMultiSet( { {"tmr_atshore_dialog_veronica1_timer", { playing = 0 }},
                 {"anm_atshore_dialog_veronica_head", { alp = 1 }} } );
                 
  common_impl.CharacterDialogButtonsHide();
  ObjAnimate("obj_atshore_dialog_veronica_hand_2", "alp", 0, 0, func_after_dlg, { 0, 0, 0,   0.5, 0, 1 });
  ObjAnimate("anm_atshore_dialog_veronica_hand_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_veronica3()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  common_impl.current_dialog = "";
  private.dlg_finished = true;

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "opn_atshoremagicpage_loc" );
    
    cmn.ShowBbt( "atshore_after_return" );
    interface_impl.ShowGlobalTask();
    int_map_impl.AddDiarypage( 7 );
    
  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  ObjMultiSet( { {"tmr_atshore_dialog_veronica3_timer", { playing = 0 }},
                 {"anm_atshore_dialog_veronica3_head", { alp = 1 }} } );
                 
  common_impl.CharacterDialogButtonsHide();
  ObjAnimate("obj_atshore_dialog_veronica_hand_3", "alp", 0, 0, func_after_dlg, { 0, 0, 0,   0.5, 0, 1 });
  ObjAnimate("anm_atshore_dialog_veronica3_hand_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  
end;
--*********************************************************************************************************************
