-- name=rm_nearhospital
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_nearhospital";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  --------------------------------------------------------------------------------------------
  -- function get_bulb () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bulb" ] = {
      type = "get",
      get_obj = "spr_motorcycle_bulb",
      room = private.room_objname,
      zz = "zz_motorcycle",
      zz_gate = "gzz_nearhospital_motorcycle"
  };
  --------------------------------------------------------------------------------------------
  local get_bulb_inv = function ()
  
    interface.InventoryItemAdd( "inv_bulb", "spr_motorcycle_bulb" );
  
  end;
  local get_bulb_end = function ()
  
    ObjDelete( "gfx_motorcycle_bulb" );
    ObjDelete( "spr_motorcycle_bulb_sh" );
    
    ObjDelete( "spr_nearhospital_moto_bulb" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bulb", get_bulb_inv );
  cmn.AddSubscriber( "get_bulb", get_bulb_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_screwdriver () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_screwdriver" ] = {
      type = "get",
      get_obj = "spr_motorcycle_screwdriver",
      room = private.room_objname,
      zz = "zz_motorcycle",
      zz_gate = "gzz_nearhospital_motorcycle"
  };
  --------------------------------------------------------------------------------------------
  local get_screwdriver_inv = function ()
  
    interface.InventoryItemAdd( "inv_screwdriver", "spr_motorcycle_screwdriver" );
  
  end;
  local get_screwdriver_end = function ()
  
    ObjDelete( "gfx_motorcycle_screwdriver" );
    ObjDelete( "spr_motorcycle_screwdriver_sh" );
    
    ObjDelete( "spr_nearhospital_moto_screwdriver" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_screwdriver", get_screwdriver_inv );
  cmn.AddSubscriber( "get_screwdriver", get_screwdriver_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_token () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_token" ] = {
      type = "get",
      get_obj = "spr_motorcycle_token",
      room = private.room_objname,
      zz = "zz_motorcycle",
      zz_gate = "gzz_nearhospital_motorcycle"
  };
  --------------------------------------------------------------------------------------------
  local get_token_inv = function ()
  
    interface.InventoryItemAdd( "inv_token", "spr_motorcycle_token" );
  
  end;
  local get_token_end = function ()
  
    ObjDelete( "gfx_motorcycle_token" );
    ObjDelete( "spr_nearhospital_moto_token" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_token", get_token_inv );
  cmn.AddSubscriber( "get_token", get_token_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magicpage4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_magicpage4" ] = {
      type = "get",
      get_obj = "spr_motorcycle_magicpage4",
      room = private.room_objname,
      zz = "zz_motorcycle",
      zz_gate = "gzz_nearhospital_motorcycle"
  };
  --------------------------------------------------------------------------------------------
  local get_magicpage4_inv = function ()
  
    interface.InventoryItemAdd( "inv_magicpage", "spr_motorcycle_magicpage4", function () cmn.GetMultyObject( 'magicpage', 6 ); end );
    int_map_impl.DecreaseRoomTasks("rm_nearhospital");
  
  end;
  local get_magicpage4_end = function ()
  
    ObjDelete( "gfx_motorcycle_magicpage4" );
    ObjDelete( "spr_nearhospital_moto_page" );
    
    if cmn.IsEventDone("get_puzzlepiece2") and cmn.IsEventDone("get_knife") then
      ObjDelete( "gzz_nearhospital_motorcycle" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_magicpage4", get_magicpage4_inv );
  cmn.AddSubscriber( "get_magicpage4", get_magicpage4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_knife () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_knife" ] = {
      type = "get",
      get_obj = "spr_motorcycle_knife",
      room = private.room_objname,
      zz = "zz_motorcycle",
      zz_gate = "gzz_nearhospital_motorcycle"
  };
  --------------------------------------------------------------------------------------------
  local get_knife_inv = function ()
  
    interface.InventoryItemAdd( "inv_knife", "spr_motorcycle_knife" );
    int_map_impl.DecreaseRoomTasks("rm_nearhospital");
  
  end;
  local get_knife_end = function ()
  
    ObjDelete( "gfx_motorcycle_knife" );
    ObjDelete( "spr_nearhospital_moto_knife" );
    
    if cmn.IsEventDone("get_puzzlepiece2") and cmn.IsEventDone("get_magicpage4") then
      ObjDelete( "gzz_nearhospital_motorcycle" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_knife", get_knife_inv );
  cmn.AddSubscriber( "get_knife", get_knife_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_puzzlepiece2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_puzzlepiece2" ] = {
      type = "get",
      get_obj = "spr_motorcycle_puzzlepiece2",
      room = private.room_objname,
      zz = "zz_motorcycle",
      zz_gate = "gzz_nearhospital_motorcycle"
  };
  --------------------------------------------------------------------------------------------
  local get_puzzlepiece2_inv = function ()
  
    interface.InventoryItemAdd( "inv_puzzlepiece2", "spr_motorcycle_puzzlepiece2" );
    int_map_impl.DecreaseRoomTasks("rm_nearhospital");
  
  end;
  local get_puzzlepiece2_end = function ()
  
    ObjDelete( "gfx_motorcycle_puzzlepiece2" );
    ObjDelete( "spr_nearhospital_moto_puzzle" );
    
    if cmn.IsEventDone("get_knife") and cmn.IsEventDone("get_magicpage4") then
      ObjDelete( "gzz_nearhospital_motorcycle" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_puzzlepiece2", get_puzzlepiece2_inv );
  cmn.AddSubscriber( "get_puzzlepiece2", get_puzzlepiece2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_scarf () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_scarf" ] = {
      type = "get",
      get_obj = "spr_vendingmachine_scarf",
      room = private.room_objname,
      zz = "zz_vendingmachine",
      zz_gate = "gzz_nearhospital_vendingmachine"
  };
  --------------------------------------------------------------------------------------------
  local get_scarf_inv = function ()
  
    interface.InventoryItemAdd( "inv_scarf", "spr_vendingmachine_scarf" );
  
  end;
  local get_scarf_mid = function ()
  
    ObjDelete( "anm_vendingmachine_scarf" );
    ObjDelete( "spr_nearhospital_vend_scarf" );
  
  end;
  local get_scarf_end = function ()
  
    ObjDelete( "anm_vendingmachine_glass_close" );
    ObjSet("anm_vendingmachine_glass_touch",  { alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_scarf", get_scarf_inv );
  cmn.AddSubscriber( "get_scarf_inv", get_scarf_inv );
  cmn.AddSubscriber( "get_scarf", get_scarf_mid, private.room_objname );
  cmn.AddSubscriber( "get_scarf_mid", get_scarf_mid, private.room_objname );
  cmn.AddSubscriber( "get_scarf", get_scarf_end, private.room_objname );
  cmn.AddSubscriber( "get_scarf_end", get_scarf_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokenspider () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_brokenspider" ] = {
      type = "get",
      get_obj = "spr_hospitalwindow_brokenspider",
      room = private.room_objname,
      zz = "zz_hospitalwindow",
      zz_gate = "gzz_nearhospital_hospitalwindow"
  };
  --------------------------------------------------------------------------------------------
  local get_brokenspider_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_brokenspider", "spr_hospitalwindow_brokenspider" );
  
  end;
  local get_brokenspider_end = function ()
  
    ObjDelete( "gfx_hospitalwindow_brokenspider" );
    ObjDelete( "spr_hospitalwindow_brokenspider_sh" );
    
    ObjDelete( "spr_nearhospital_window_spider" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_brokenspider", get_brokenspider_inv );
  cmn.AddSubscriber( "get_brokenspider", get_brokenspider_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_bulldogkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_bulldogkey" ] = {
      type = "use",
      inv_obj = "inv_bulldogkey",
      use_place = "obj_motorcycle_use_bulldogkey",
      room = private.room_objname,
      zz = "zz_motorcycle",
      zz_gate = "gzz_nearhospital_motorcycle"
  };
  --------------------------------------------------------------------------------------------
  local use_bulldogkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_bulldogkey" );
  
  end;
  local use_bulldogkey_beg = function ()
  
    ObjDelete( "obj_motorcycle_use_bulldogkey" );
    ObjDelete( "anm_motorcycle_skull_touch" );
    
    ObjSet("obj_motorcycle_skull",  { alp = 1 });
  
  end;
  local use_bulldogkey_end = function ()
    
    ObjDelete( "spr_nearhospital_moto_skull_closed" );
  
    ObjMultiSet( { {"obj_motorcycle_skull", { input = 1 }},
                   {"obj_motorcycle_open_jaw", { alp = 1 }},
                   {"spr_motorcycle_bulldog", { alp = 1 }},
                   {"spr_motorcycle_skull_jaw", { pos_x = -149, pos_y = -49, ang = 0.39 }},
                   {"spr_motorcycle_skull_sh", { pos_x = -97, pos_y = -57, ang = 0.39 }},
                   {"spr_nearhospital_moto_skull_open", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bulldogkey", use_bulldogkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_bulldogkey", use_bulldogkey_inv );
  cmn.AddSubscriber( "use_bulldogkey", use_bulldogkey_end, private.room_objname );
  cmn.AddSubscriber( "use_bulldogkey_inv", use_bulldogkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_bulldogkey_beg", use_bulldogkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_bulldogkey_end", use_bulldogkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spider () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_spider" ] = {
      type = "use",
      inv_obj = "inv_spider",
      use_place = "obj_motorcycle_use_spider",
      room = private.room_objname,
      zz = "zz_motorcycle",
      zz_gate = "gzz_nearhospital_motorcycle"
  };
  --------------------------------------------------------------------------------------------
  local use_spider_inv = function ()
  
    interface.InventoryItemRemove( "inv_spider" );
  
  end;
  local use_spider_beg = function ()
  
    ObjDelete( "obj_motorcycle_use_spider" );
  
  end;
  local use_spider_end = function ()
  
    ObjMultiSet( { {"obj_motorcycle_bag_open", { alp = 1, input = 1 }},
                   {"spr_nearhospital_moto_bag_open", { alp = 1 }} } );
    
    ObjDelete( "anm_motorcycle_bag_touch" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_spider", use_spider_beg, private.room_objname );
  cmn.AddSubscriber( "use_spider", use_spider_inv );
  cmn.AddSubscriber( "use_spider", use_spider_end, private.room_objname );
  cmn.AddSubscriber( "use_spider_inv", use_spider_inv, private.room_objname );
  cmn.AddSubscriber( "use_spider_beg", use_spider_beg, private.room_objname );
  cmn.AddSubscriber( "use_spider_end", use_spider_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_dollar1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_dollar1" ] = {
      type = "use",
      inv_obj = "inv_dollar1",
      use_place = "obj_vendingmachine_use_dollars",
      room = private.room_objname,
      zz = "zz_vendingmachine",
      zz_gate = "gzz_nearhospital_vendingmachine"
  };
  --------------------------------------------------------------------------------------------
  local use_dollar1_inv = function ()
  
    interface.InventoryItemRemove( "inv_dollar1" );
  
  end;
  local use_dollar1_beg = function ()
  
    if cmn.IsEventDone("use_dollar2") then
      ObjDelete( "obj_vendingmachine_use_dollars" );
    end;
  
  end;
  local use_dollar1_end = function ()
  
    if cmn.IsEventDone("use_dollar2") then
      ObjSet( "gmg_nearhospital_invendingmachine", { input = 1, alp = 1, active = 1 } );
      ObjDelete( "gzz_nearhospital_vendingmachine" );
    else 
      ObjMultiSet( { {"spr_vendingmachine_green_1", { alp = 1 }},
                     {"anm_vendingmachine_dollar_use", { frame = 0 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_dollar1", use_dollar1_beg, private.room_objname );
  cmn.AddSubscriber( "use_dollar1", use_dollar1_inv );
  cmn.AddSubscriber( "use_dollar1", use_dollar1_end, private.room_objname );
  cmn.AddSubscriber( "use_dollar1_inv", use_dollar1_inv, private.room_objname );
  cmn.AddSubscriber( "use_dollar1_beg", use_dollar1_beg, private.room_objname );
  cmn.AddSubscriber( "use_dollar1_end", use_dollar1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_dollar2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_dollar2" ] = {
      type = "use",
      inv_obj = "inv_dollar2",
      use_place = "obj_vendingmachine_use_dollars",
      room = private.room_objname,
      zz = "zz_vendingmachine",
      zz_gate = "gzz_nearhospital_vendingmachine"
  };
  --------------------------------------------------------------------------------------------
  local use_dollar2_inv = function ()
  
    interface.InventoryItemRemove( "inv_dollar2" );
  
  end;
  local use_dollar2_beg = function ()
  
    if cmn.IsEventDone("use_dollar1") then
      ObjDelete( "obj_vendingmachine_use_dollars" );
    end;
  
  end;
  local use_dollar2_end = function ()
  
    if cmn.IsEventDone("use_dollar1") then
      ObjSet( "gmg_nearhospital_invendingmachine", { input = 1, alp = 1, active = 1 } );
      ObjDelete( "gzz_nearhospital_vendingmachine" );
    else 
      ObjMultiSet( { {"spr_vendingmachine_green_1", { alp = 1 }},
                     {"anm_vendingmachine_dollar_use", { frame = 0 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_dollar2", use_dollar2_beg, private.room_objname );
  cmn.AddSubscriber( "use_dollar2", use_dollar2_inv );
  cmn.AddSubscriber( "use_dollar2", use_dollar2_end, private.room_objname );
  cmn.AddSubscriber( "use_dollar2_inv", use_dollar2_inv, private.room_objname );
  cmn.AddSubscriber( "use_dollar2_beg", use_dollar2_beg, private.room_objname );
  cmn.AddSubscriber( "use_dollar2_end", use_dollar2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_scarf () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_scarf" ] = {
      type = "use",
      inv_obj = "inv_scarf",
      use_place = "obj_hospitalwindow_use_scarf",
      room = private.room_objname,
      zz = "zz_hospitalwindow",
      zz_gate = "gzz_nearhospital_hospitalwindow"
  };
  --------------------------------------------------------------------------------------------
  local use_scarf_inv = function ()
  
    interface.InventoryItemRemove( "inv_scarf" );
  
  end;
  local use_scarf_beg = function ()
  
    ObjDelete( "obj_hospitalwindow_use_scarf" );
    ObjDelete( "anm_hospitalwindow_glass_touch" );
  
  end;
  local use_scarf_end = function ()
  
    ObjMultiSet( { {"gho_nearhospital_hospitalroom", { input = 1, alp = 1, active = 1 }},
                   {"spr_nearhospital_window_open", { alp = 1 }} } );
    
    ObjDelete( "gzz_nearhospital_hospitalwindow" );
    ObjDelete( "spr_nearhospital_window_glass" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scarf", use_scarf_beg, private.room_objname );
  cmn.AddSubscriber( "use_scarf", use_scarf_inv );
  cmn.AddSubscriber( "use_scarf", use_scarf_end, private.room_objname );
  cmn.AddSubscriber( "use_scarf_inv", use_scarf_inv, private.room_objname );
  cmn.AddSubscriber( "use_scarf_beg", use_scarf_beg, private.room_objname );
  cmn.AddSubscriber( "use_scarf_end", use_scarf_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hookwithrope () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hookwithrope" ] = {
      type = "use",
      inv_obj = "inv_hookwithrope",
      use_place = "obj_nearhospital_use_hookwithrope",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local use_hookwithrope_inv = function ()
  
    interface.InventoryItemRemove( "inv_hookwithrope" );
  
  end;
  local use_hookwithrope_beg = function ()
  
    ObjDelete( "obj_nearhospital_use_hookwithrope" );
  
  end;
  local use_hookwithrope_end = function ()
  
    ObjMultiSet( { {"grm_nearhospital_corridor", { input = 1, alp = 1 }},
                   {"spr_nearhospital_rope", { alp = 1 }} } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_nearhospital_corridor_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hookwithrope", use_hookwithrope_beg, private.room_objname );
  cmn.AddSubscriber( "use_hookwithrope", use_hookwithrope_inv );
  cmn.AddSubscriber( "use_hookwithrope", use_hookwithrope_end, private.room_objname );
  cmn.AddSubscriber( "use_hookwithrope_inv", use_hookwithrope_inv, private.room_objname );
  cmn.AddSubscriber( "use_hookwithrope_beg", use_hookwithrope_beg, private.room_objname );
  cmn.AddSubscriber( "use_hookwithrope_end", use_hookwithrope_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_nearhospitalfirst () end;
  --------------------------------------------------------------------------------------------
  local clk_nearhospitalfirst = function ()
    
    ObjDelete("obj_nearhospital_clk_nearhospitalfirst");
    ObjDelete("anm_nearhospital_bushes");
    ObjDelete("obj_nearhospital_hunter");
    
    ObjMultiSet( { { "obj_nearhospital_use_hookwithrope", { input = 1, alp = 1 } },
                   { "obj_nearhospital_doors_bbt", { input = 1 } },

                   { "gzz_nearhospital_motorcycle", { event_mdown = function() cmn.GotoSubRoomMDown( "nearhospital_motorcycle" ); end, event_mup = function() cmn.GotoSubRoomMUp( "nearhospital_motorcycle", "zz_motorcycle" ); end } },
                   { "gzz_nearhospital_vendingmachine", { event_mdown = function() cmn.GotoSubRoomMDown( "nearhospital_vendingmachine" ); end, event_mup = function() cmn.GotoSubRoomMUp( "nearhospital_vendingmachine", "zz_vendingmachine" ); end } },
                   { "gzz_nearhospital_hospitalwindow", { event_mdown = function() cmn.GotoSubRoomMDown( "nearhospital_hospitalwindow" ); end, event_mup = function() cmn.GotoSubRoomMUp( "nearhospital_hospitalwindow", "zz_hospitalwindow" ); end } } } );
                   
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_nearhospitalfirst", clk_nearhospitalfirst, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_nearhospital () end;
  --------------------------------------------------------------------------------------------
  local opn_nearhospital = function ()
  
    int_map_impl.OpenRoom( "rm_nearhospital" );
    int_map_impl.BlockRoom( "rm_forestthicket" );
    int_map_impl.BlockRoom( "rm_atshore" );
    int_map_impl.BlockRoom( "rm_foresthouse" );
    interface_impl.SetCurrentGlobalTask( 10 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_nearhospital", opn_nearhospital );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_motorcycle" );
  
  function zz_motorcycle.Open()
    
    if not cmn.IsEventDone( "opn_motorcycle" ) then
      cmn.SetEventDone("opn_motorcycle");
      cmn.ShowBbt( "motorcycle_open" );
    end;

  end;
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_nearhospital();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_nearhospital_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_nearhospital_env");
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_bulldogkey()

  local item = "inv_bulldogkey";

  if cmn.ApplyObj( item, "gzz_nearhospital_motorcycle" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_motorcycle" );

  elseif ( cmn.ApplyObj( item, "obj_motorcycle_use_bulldogkey" ) ) then

    cmn.CallEventHandler( "use_bulldogkey_inv" );
    cmn.CallEventHandler( "use_bulldogkey_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_bulldogkey" );
      cmn.CallEventHandler( "use_bulldogkey_end" );
    
    end;
    
    local anm_skull = function ()
      
      ObjAnimate("obj_motorcycle_open_jaw", "alp", 0, 0, func_after, { 0, 0, 0,   0.2, 0, 0,   0.5, 0, 1 });
      
      ObjAnimate("spr_motorcycle_skull_jaw", "pos_xy", 0, 0, "", { 0, 0, -147, -53,   0.5, 0, -149, -49 });
      ObjAnimate("spr_motorcycle_skull_sh", "pos_xy", 0, 0, "", { 0, 0, -96, -42,   0.5, 0, -97, -57 });
      
      ObjAnimate("spr_motorcycle_skull_jaw", "ang", 0, 0, "", { 0, 0, 0,   0.5, 0, 0.39 });
      ObjAnimate("spr_motorcycle_skull_sh", "ang", 0, 0, "", { 0, 0, 0,   0.5, 0, 0.39 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_nearhospital/audio/aud_use_dog_amulet");

    ObjAnimate("spr_motorcycle_bulldog", "alp", 0, 0, anm_skull, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_spider()

  local item = "inv_spider";

  if cmn.ApplyObj( item, "gzz_nearhospital_motorcycle" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_motorcycle" );

  elseif ( cmn.ApplyObj( item, "obj_motorcycle_use_spider" ) ) then

    cmn.CallEventHandler( "use_spider_inv" );
    cmn.CallEventHandler( "use_spider_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_spider" );
      cmn.CallEventHandler( "use_spider_end" );
    
    end;
    
    local anm_bag = function ()
      
      ObjAnimate("obj_motorcycle_bag_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
    local anm_spider = function ()
      
      ObjAnimate("spr_motorcycle_spider", "scale_xy", 0, 0, anm_bag, { 0, 0, 1, 1,   0.15, 0, 0.8, 0.8,    0.3, 0, 1, 1  });
      
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_nearhospital/audio/aud_use_spider");

    ObjAnimate("spr_motorcycle_spider", "alp", 0, 0, anm_spider, { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_dollar1()

  local item = "inv_dollar1";

  if cmn.ApplyObj( item, "gzz_nearhospital_vendingmachine" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_vendingmachine" );

  elseif ( cmn.ApplyObj( item, "obj_vendingmachine_use_dollars" ) ) then

    cmn.CallEventHandler( "use_dollar1_inv" );
    cmn.CallEventHandler( "use_dollar1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );
      ObjSet("anm_vendingmachine_dollar_use",  { alp = 0 });

     
      cmn.CallEventHandler( "use_dollar1_end" );
      
      if cmn.IsEventDone("use_dollar2") then
        common.CloseSubRoom();
        cmn.GotoRoom("mg_invendingmachine");
      end;
    
    end;
    
    local anm_lamp = function ()
      
      local num = 1;
      if cmn.IsEventDone("use_dollar2") then
        num = 2;
      end;
      
      ObjAnimate("spr_vendingmachine_green_"..num, "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1,   0.5, 0, 1 });
      
      ObjMultiSet( { {"anm_vendingmachine_dollar_use",  { alp = 0 }},
                     {"spr_vendingmachine_overlap", { alp = 1 }} } );
      
    end;
    
    if cmn.IsEventDone("use_dollar2") and not cmn.IsEventDone("get_scarf") then
      public.get_scarf();
    end;

    cmn.Lock( 1 );
    cmn.SetEventDone( "use_dollar1" );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_nearhospital/audio/aud_use_money");

    ObjMultiSet( { {"anm_vendingmachine_dollar_use",  { alp = 1, playing = 1, endtrig = anm_lamp }},
                   {"spr_vendingmachine_overlap", { alp = 0 }} } );
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_dollar2()

  local item = "inv_dollar2";

  if cmn.ApplyObj( item, "gzz_nearhospital_vendingmachine" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_vendingmachine" );

  elseif ( cmn.ApplyObj( item, "obj_vendingmachine_use_dollars" ) ) then

    cmn.CallEventHandler( "use_dollar2_inv" );
    cmn.CallEventHandler( "use_dollar2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );
      ObjSet("anm_vendingmachine_dollar_use",  { alp = 0 });

      
      cmn.CallEventHandler( "use_dollar2_end" );
      
      if cmn.IsEventDone("use_dollar1") then
        common.CloseSubRoom();
        cmn.GotoRoom("mg_invendingmachine");
      end;
    
    end;
    
    local anm_lamp = function ()
      
      local num = 1;
      if cmn.IsEventDone("use_dollar1") then
        num = 2;
      end;
      
      ObjAnimate("spr_vendingmachine_green_"..num, "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1,   0.5, 0, 1 });
      
      ObjMultiSet( { {"anm_vendingmachine_dollar_use",  { alp = 0 }},
                     {"spr_vendingmachine_overlap", { alp = 1 }} } );
      
    end;
    
    if cmn.IsEventDone("use_dollar1") and not cmn.IsEventDone("get_scarf") then
      public.get_scarf();
    end;

    cmn.Lock( 1 );
    cmn.SetEventDone( "use_dollar2" );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_nearhospital/audio/aud_use_money");

    ObjMultiSet( { {"anm_vendingmachine_dollar_use",  { alp = 1, playing = 1, endtrig = anm_lamp }},
                   {"spr_vendingmachine_overlap", { alp = 0 }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_scarf()

  local item = "inv_scarf";

  if cmn.ApplyObj( item, "gzz_nearhospital_hospitalwindow" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_hospitalwindow" );

  elseif ( cmn.ApplyObj( item, "obj_hospitalwindow_use_scarf" ) ) then

    cmn.CallEventHandler( "use_scarf_inv" );
    cmn.CallEventHandler( "use_scarf_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_scarf" );
      cmn.CallEventHandler( "use_scarf_end" );
      
      common.CloseSubRoom();
    
    end;
    
    local anm_open = function ()
      
      ObjSet("anm_hospitalwindow_handle_open",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
    
    if not cmn.IsEventDone("get_brokenspider") then
      public.get_brokenspider();
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_nearhospital/audio/aud_opn_window2");

    ObjSet("anm_hospitalwindow_use_scarf",  { alp = 1, playing = 1, endtrig = anm_open });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hookwithrope()

  local item = "inv_hookwithrope";

  if ( cmn.ApplyObj( item, "obj_nearhospital_use_hookwithrope" ) ) then

    cmn.CallEventHandler( "use_hookwithrope_inv" );
    cmn.CallEventHandler( "use_hookwithrope_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_hookwithrope" );
      cmn.CallEventHandler( "use_hookwithrope_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_nearhospital/audio/aud_use_hook2");

    ObjAnimate( "spr_nearhospital_rope", "alp", 0, 0, func_after,
    {
      0.0, 0, 0, 
      0.5, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_bulb()

  cmn.SetEventDone( "get_bulb" );
  cmn.CallEventHandler( "get_bulb" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_screwdriver()

  cmn.SetEventDone( "get_screwdriver" );
  cmn.CallEventHandler( "get_screwdriver" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if not cmn.IsEventDone("get_token") then
    cmn.SetEventDone( "get_token" );
    cmn.CallEventHandler( "get_token" );
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_token()

  cmn.SetEventDone( "get_token" );
  cmn.CallEventHandler( "get_token" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_magicpage4()

  cmn.SetEventDone( "get_magicpage4" );
  cmn.CallEventHandler( "get_magicpage4" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_knife") and cmn.IsEventDone("get_puzzlepiece2") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_knife()

  cmn.SetEventDone( "get_knife" );
  cmn.CallEventHandler( "get_knife" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_magicpage4") and cmn.IsEventDone("get_puzzlepiece2") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_puzzlepiece2()

  cmn.SetEventDone( "get_puzzlepiece2" );
  cmn.CallEventHandler( "get_puzzlepiece2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_knife") and cmn.IsEventDone("get_magicpage4") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_scarf()
  
  ObjSet("spr_vendingmachine_scarf",  { alp = 1 });

  cmn.SetEventDone( "get_scarf" );
  cmn.CallEventHandler( "get_scarf_inv" );
  cmn.CallEventHandler( "get_scarf_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  local func_after = function ()
    
    cmn.Lock(0);
    cmn.CallEventHandler( "get_scarf_end" );
    
  end;
  
  cmn.Lock(1);
  
  ObjSet("anm_vendingmachine_glass_close",  { alp = 1, playing = 1, endtrig = func_after });

end;
--------------------------------------------------------------------------------------------
function public.get_brokenspider()

  cmn.SetEventDone( "get_brokenspider" );
  cmn.CallEventHandler( "get_brokenspider" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function public.clk_nearhospitalfirst()
  
  local func_after = function ()
    
    cmn.CallEventHandler("clk_nearhospitalfirst");
    cmn.ShowBbt( "nearhospital_after_doctor" );
    int_map_impl.AddDiarypage( 6 );
    
    cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_nearhospital_env");
    
  end;
  
  SndStop( common_impl.audio.voc, 0.5 );
  
  cmn.SetEventDone("clk_nearhospitalfirst");
  
  cmn.StopAllEnv();
  
  cmn.PlayAudio("mus", "assets/levels/level2/rm_nearhospital/audio/aud_doctor_mus", 0, false, 18);
  cmn.PlayFullscreenVideo( "assets/levels/level2/rm_nearhospital/vid_doctor", func_after, "assets/levels/level2/rm_nearhospital/audio/aud_doctor", "", 1, 3.5, false, true, true);
  --cmn.PlayAudio("mus", "assets/levels/level2/rm_nearhospital/audio/aud_doctor_mus", 0, true, 18);
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_nearhospital()

  if not ( cmn.IsEventDone( "opn_nearhospital" ) ) then
    
    cmn.SetEventDone( "opn_nearhospital" );
    cmn.CallEventHandler("opn_nearhospital");
    
    cmn.ShowDlgBbt( "nearhospital_open_voice", 1 );
    cmn.PlayAudio("voc", "assets/levels/level2/rm_nearhospital/audio/aud_cheshire_dlg_lvl2_voc");
    
    interface_impl.ShowGlobalTask();
    
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_window()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_hospitalwindow_use_scarf" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_nearhospital/audio/aud_xx_clk_glass");
  
  ObjSet("anm_hospitalwindow_glass_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_vendingmachine()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_vendingmachine_use_dollars" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_nearhospital/audio/aud_xx_clk_market");
  
  --ObjSet("anm_vendingmachine_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  ObjMultiSet( { {"anm_vendingmachine_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end }},
                 {"anm_vendingmachine_glass_touch", { playing = 1 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_moto_bag()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_motorcycle_use_spider" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_nearhospital/audio/aud_xx_bag2");
  
  ObjSet("anm_motorcycle_bag_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_moto_skull()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_motorcycle_use_bulldogkey" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_nearhospital/audio/aud_xx_clk_scull2");
  
  ObjSet("anm_motorcycle_skull_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--*********************************************************************************************************************
