-- name=mg_safe
--*********************************************************************************************************************
function public.Init()

  private.map_pos = { --координаты точек карты
                    { -217, -300 },                 { 3, -300 },                 { 286, -300 },
    { -301, -203 }, { -217, -203 }, { -132, -199 }, { 2, -199 },  { 207, -199 }, { 286, -162 }, { 392, -162 },
                    { -239, -119 }, { -134, -121 },               { 205, -19 },  { 284, -46 },  { 391, -47 },
    { -299, -27 },  { -240, -26 },
    { -299, 128 },  { -138, 130 },                                { 79, 131 },   { 282, 129 },
                    { -137, 218 },                                { 77, 218 }
  };

  private.map_dir = { --куда можно двигатся с точек карты {направление, точка}
                { {1,2}, {2,5} },                      { {1,3}, {2,7}, {3,1} },                    { {2,9}, {3,2} },
    { {1,5} },  { {3,4}, {4,1} },   { {1,7}, {2,12} }, { {1,8}, {3,6}, {4,2} }, { {2,13}, {3,7} }, { {1,10}, {4,3} },  { {2,15}, {3,9} },
                { {1,12}, {2,17} }, { {3,11}, {4,6} },                          { {4,8} },         { {1,15}, {2,21} }, { {3,14}, {4,10} },
    { {1,17} }, { {3,16}, {4,11} },
    { {1,19} }, { {2,22}, {3,18} },                                             { {1,21}, {2,23} }, { {3,20}, {4,14} },
                { {1,23}, {4,19} },                                             { {3,22}, {4,20} }
  };

  private.triangle_dir_ang = { 0, -1.57, -3.14, -4.71 };  --углы направлений стрелки

  private.gear_ang = 0; --угол шестеренок

  private.pin_locker_win_pos_x =   { -394, -384, -390 };
  private.pin_locker_start_pos_x = { -453, -443, -449 };
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_safe";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_cellkey () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_cellkey" ] = {
        type = "get",
        get_obj = "spr_safe_cellkey",
        room = "rm_policedepartment",
        zz = "mg_safe",
        zz_gate = "gmg_policedepartment_safe"
    };
    --------------------------------------------------------------------------------------------
  local get_cellkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_cellkey", "spr_safe_cellkey" );
  
  end;
  local get_cellkey_end = function ()
  
    ObjDelete( "gfx_safe_cellkey" );
    ObjDelete( "spr_safe_cellkey_shadow" );
  
  end;
  local get_cellkey_loc = function ()
  
    ObjDelete( "gmg_policedepartment_safe" );
    ObjDelete( "spr_policedepartment_safe_key" );
  
  end;
  
  cmn.AddSubscriber( "get_cellkey", get_cellkey_inv );
  cmn.AddSubscriber( "get_cellkey", get_cellkey_end, private.room_objname );
  cmn.AddSubscriber( "get_cellkey", get_cellkey_loc, "rm_policedepartment" );

  --------------------------------------------------------------------------------------------
  -- function clk_lvl3folder3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_lvl3folder3" ] = {
    type = "click",
    use_place = "obj_safe_3_folder",
    room = "rm_policedepartment",
    zz = "mg_safe",
    zz_gate = "gmg_policedepartment_safe"
  };
  --------------------------------------------------------------------------------------------
  local clk_lvl3folder3_beg = function ()
  
    ObjDelete( "obj_safe_3_folder" );
  
  end;
  local clk_lvl3folder3_end = function ()
  
    ObjMultiSet( { { "spr_safe_3_folder_shadow", { pos_x = 744, pos_y = 548, ang = -0.11 } },
                   { "spr_safe_3_folder", { pos_x = 741, pos_y = 578, ang = -0.11 } },
                   { "obj_safe_2_folder", { input = true } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_lvl3folder3", clk_lvl3folder3_beg, "mg_safe" );
  cmn.AddSubscriber( "clk_lvl3folder3", clk_lvl3folder3_end, "mg_safe" );
  cmn.AddSubscriber( "clk_lvl3folder3_beg", clk_lvl3folder3_beg, "mg_safe" );
  cmn.AddSubscriber( "clk_lvl3folder3_end", clk_lvl3folder3_end, "mg_safe" );

  --------------------------------------------------------------------------------------------
  -- function clk_lvl3folder2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_lvl3folder2" ] = {
    type = "click",
    use_place = "obj_safe_2_folder",
    room = "rm_policedepartment",
    zz = "mg_safe",
    zz_gate = "gmg_policedepartment_safe"
  };
  --------------------------------------------------------------------------------------------
  local clk_lvl3folder2_beg = function ()
  
    ObjDelete( "obj_safe_2_folder" );
  
  end;
  local clk_lvl3folder2_end = function ()
  
    ObjMultiSet( { { "spr_safe_2_folder_shadow", { pos_x = 689, pos_y = 452, ang = -0.1 } },
                   { "spr_safe_2_folder", { pos_x = 719, pos_y = 495, ang = -0.1 } },
                   { "obj_safe_1_folder", { input = true } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_lvl3folder2", clk_lvl3folder2_beg, "mg_safe" );
  cmn.AddSubscriber( "clk_lvl3folder2", clk_lvl3folder2_end, "mg_safe" );
  cmn.AddSubscriber( "clk_lvl3folder2_beg", clk_lvl3folder2_beg, "mg_safe" );
  cmn.AddSubscriber( "clk_lvl3folder2_end", clk_lvl3folder2_end, "mg_safe" );

  --------------------------------------------------------------------------------------------
  -- function clk_lvl3folder1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_lvl3folder1" ] = {
    type = "click",
    use_place = "obj_safe_1_folder",
    room = "rm_policedepartment",
    zz = "mg_safe",
    zz_gate = "gmg_policedepartment_safe"
  };
  --------------------------------------------------------------------------------------------
  local clk_lvl3folder1_beg = function ()
  
    ObjDelete( "obj_safe_1_folder" );
  
  end;
  local clk_lvl3folder1_end = function ()
  
    ObjMultiSet( { { "spr_safe_1_folder_shadow", { pos_x = 628, pos_y = 443, ang = -0.01 } },
                   { "spr_safe_1_folder", { pos_x = 701, pos_y = 460, ang = -0.01 } },
                   { "spr_safe_cellkey", { input = true } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_lvl3folder1", clk_lvl3folder1_beg, "mg_safe" );
  cmn.AddSubscriber( "clk_lvl3folder1", clk_lvl3folder1_end, "mg_safe" );
  cmn.AddSubscriber( "clk_lvl3folder1_beg", clk_lvl3folder1_beg, "mg_safe" );
  cmn.AddSubscriber( "clk_lvl3folder1_end", clk_lvl3folder1_end, "mg_safe" );

  --------------------------------------------------------------------------------------------
  -- function win_safe () end;
  --------------------------------------------------------------------------------------------
  --game.hint[ "win_safe" ] = {
  --  type = "win",
  --  room = "rm_policedepartment",
  --  zz = "mg_safe",
  --  zz_gate = "gmg_policedepartment_safe"
  --};
  --------------------------------------------------------------------------------------------
  local win_safe = function ()

    if cmn.IsEventDone( "win_safe" ) then

      ObjDelete( "spr_safe_back_2" );
      ObjDelete( "obj_safe_locker" );
      ObjDelete( "obj_safe_stethoscope" );
      ObjDelete( "obj_safe_drag_stethoscope" );

      ObjSet( "obj_safe_3_folder", { input = true } );

    end;

  end;
  local win_safe_loc = function ()
    
    if cmn.IsEventDone( "win_safe" ) then
      ObjDelete( "spr_policedepartment_safe_stethoscope" );
      ObjSet("spr_policedepartment_safe_open_2",  { alp = 1 });
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_safe", win_safe, "mg_safe" );
  cmn.AddSubscriber( "win_safe", win_safe_loc, "rm_policedepartment" );
  
end;
--*********************************************************************************************************************
function public.Load()

  if ng_global.currentprogress == "std" and not ng_global.progress[ ng_global.currentprogress ][ "win_safe" ].state then
    private.StartConditions();
  elseif ng_global.currentprogress == "secret" then
    private.StartConditions(); 
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_safe" ].state;

end;
--*********************************************************************************************************************
function public.Open() 
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_mg_mus_env", 1);

  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_safe" )) then
    cmn.MiniGameShow();
    private.CheckWin();
    cmn.StartTimePassing("mg_safe");
  elseif ng_global.currentprogress == "secret" then 
    rm_extra.MiniGameShow();
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  if ng_global.currentprogress == "std" then
  
    cmn.StopAllEnv("assets/levels/common/audio/audio3/aud_policedepartment_env");
    cmn.PlayAudio("env", "assets/levels/common/audio/audio3/aud_policedepartment_env");

    common.SetPreviousRoom( "rm_policedepartment" );

    if not(cmn.IsEventDone( "win_safe" )) then
      private.DrawScene();
    end;
    
  else 
    
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_safe" ].state;
    
    private.DrawScene();
    
    ObjMultiSet( { {"obj_safe_locker", { input = 1 }},
                   {"obj_safe_drag_stethoscope", { input = 1 }} } );
    
    ObjSet("grm_safe_policedepartment",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                           event_menter = function () rm_extra.GateMouseEnter( "safe_policedepartment", CURSOR_DOWN, "extra" ); end, 
                                           event_mleave = function () common_impl.GateMouseLeave( "safe_policedepartment" ); end });
    
  end;

end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  
  cmn.StopAllMus();
  if ng_global.currentprogress == "std" then
    common_impl.PlayBackgroundMusic();
  end;

  if ng_global.currentprogress == "std" and not(cmn.IsEventDone( "win_safe" )) then
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_safe" )) then
    rm_extra.MiniGameHide();
  end;
  
end;
--*********************************************************************************************************************
function public.Reset()

  --DbgTrace( "***Reset" );

  if  not private.state.point_1 and not private.state.point_2 and not private.state.point_3 
  and private.state.stethoscope_pos[1] == 748 and private.state.stethoscope_pos[2] == 360
  and private.state.triangle_dir == 4 and private.state.triangle_pos == 13 then
    return; --все на стартовых позициях
  end;

  cmn.Lock( 1 );

  local func_after = function ()

    ObjMultiSet( {
      { "obj_safe_drag_stethoscope", { pos_x =  private.state.stethoscope_pos[1],       pos_y =  private.state.stethoscope_pos[2] } },
      { "spr_safe_safeback",         { pos_x = -private.state.stethoscope_pos[1] + 512, pos_y = -private.state.stethoscope_pos[2] + 384 } },
      { "spr_safe_triangle", { 
        ang = private.triangle_dir_ang[ private.state.triangle_dir ],
        pos_x = private.map_pos[ private.state.triangle_pos ][ 1 ],
        pos_y = private.map_pos[ private.state.triangle_pos ][ 2 ]
      } }
    } );

    cmn.Lock( 0 );

  end;

  for i = 1, 3, 1 do
    if ( private.state[ "point_"..i ] ) then
      --DbgTrace( "point_"..i.." = true" );
      ObjSet( "spr_safe_pin_locker_"..i, { pos_x = private.pin_locker_start_pos_x[ i ] } );
      ObjAnimate( "spr_safe_pin_"..i, "pos_x", 0, 0, "", { 0, 0, -340,    0.3, 0, -431 } );
    end;
  end;

  local old_stethoscope_pos_x = private.state.stethoscope_pos[1];
  local old_stethoscope_pos_y = private.state.stethoscope_pos[2];

  --DbgTrace( "old_stethoscope_pos = "..old_stethoscope_pos_x.." "..old_stethoscope_pos_y );

  private.StartConditions();
  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_safe" ].state;

  --DbgTrace( "stethoscope_pos = "..private.state.stethoscope_pos[1].." "..private.state.stethoscope_pos[2] );

  ObjAnimate( "obj_safe_stethoscope", "pos_xy", 0, 0, func_after, { 
    0,   0, old_stethoscope_pos_x,            old_stethoscope_pos_y,
    0.3, 0, private.state.stethoscope_pos[1], private.state.stethoscope_pos[2]  
  } );

end;
--*********************************************************************************************************************
function public.Skip()

  --DbgTrace( "***Skip" );

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/mg_safe/audio/aud_opn_lock3");

  ng_global.progress[ ng_global.currentprogress ][ "win_safe" ].skip = 1;

  for i = 1, 3, 1 do
    if ( not private.state[ "point_"..i ] ) then
      --DbgTrace( "point_"..i.." = false" );
      private.state[ "point_"..i ] = true;
      ObjAnimate( "spr_safe_pin_"..i, "pos_x", 0, 0, "", { 0, 0, -431,    0.3, 0, -340 } );
    end;
  end;

  ObjSet( "tmr_safe_animlock", { time = 0.3, endtrig = private.CheckWin, playing = true } );

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_cellkey()

  cmn.SetEventDone( "get_cellkey" );
  cmn.CallEventHandler( "get_cellkey" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  cmn.GotoRoom("rm_policedepartment");

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function public.clk_lvl3folder3()

  cmn.SetEventDone( "clk_lvl3folder3" );
  cmn.CallEventHandler( "clk_lvl3folder3_beg" );

  local func_after = function ()

    cmn.Lock( 0 );
    cmn.CallEventHandler( "clk_lvl3folder3_end" );

  end;
  
  cmn.Lock( 1 );
  --cmn.PlayAudio("snd", "assets/levels/level3///audio/");

  ObjAnimate( "spr_safe_3_folder_shadow", "pos_xy", 0, 0, "", { 0, 0, 526, 500,    0.5, 0, 744, 548 } );
  ObjAnimate( "spr_safe_3_folder_shadow", "ang", 0, 0, "", { 0, 0, 0,    0.5, 0, -0.11 } );

  ObjAnimate( "spr_safe_3_folder", "pos_xy", 0, 0, "", { 0, 0, 525, 531,    0.5, 0, 741, 578 } );
  ObjAnimate( "spr_safe_3_folder", "ang", 0, 0, func_after, { 0, 0, 0,    0.5, 0, -0.11 } );

end;
--------------------------------------------------------------------------------------------
function public.clk_lvl3folder2()

  cmn.SetEventDone( "clk_lvl3folder2" );
  cmn.CallEventHandler( "clk_lvl3folder2_beg" );

  local func_after = function ()

    cmn.Lock( 0 );
    cmn.CallEventHandler( "clk_lvl3folder2_end" );

  end;
  
  cmn.Lock( 1 );
  --cmn.PlayAudio("snd", "assets/levels/level3///audio/");

  ObjAnimate( "spr_safe_2_folder_shadow", "pos_xy", 0, 0, "", { 0, 0, 607, 456,    0.5, 0, 689, 452 } );
  ObjAnimate( "spr_safe_2_folder_shadow", "ang", 0, 0, "", { 0, 0, 0,    0.5, 0, -0.1 } );

  ObjAnimate( "spr_safe_2_folder", "pos_xy", 0, 0, "", { 0, 0, 641, 498,    0.5, 0, 719, 495 } );
  ObjAnimate( "spr_safe_2_folder", "ang", 0, 0, func_after, { 0, 0, 0,    0.5, 0, -0.1 } );

end;
--------------------------------------------------------------------------------------------
function public.clk_lvl3folder1()

  cmn.SetEventDone( "clk_lvl3folder1" );
  cmn.CallEventHandler( "clk_lvl3folder1_beg" );

  local func_after = function ()

    cmn.Lock( 0 );
    cmn.CallEventHandler( "clk_lvl3folder1_end" );

  end;
  
  cmn.Lock( 1 );
  --cmn.PlayAudio("snd", "assets/levels/level3///audio/");

  ObjAnimate( "spr_safe_1_folder_shadow", "pos_xy", 0, 0, "", { 0, 0, 277, 438,    0.5, 0, 628, 443 } );
  ObjAnimate( "spr_safe_1_folder_shadow", "ang", 0, 0, "", { 0, 0, 0,    0.5, 0, -0.01 } );

  ObjAnimate( "spr_safe_1_folder", "pos_xy", 0, 0, "", { 0, 0, 358, 457,    0.5, 0, 701, 460 } );
  ObjAnimate( "spr_safe_1_folder", "ang", 0, 0, func_after, { 0, 0, 0,    0.5, 0, -0.01 } );

end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_safe" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_safe" ].state = {
    point_1 = false,  --точки которые до которых над добраться
    point_2 = false,
    point_3 = false,
    stethoscope_pos = { 748, 360 }, --стартовые координаты стетоскопа
    triangle_pos = 13,  --стартовая точка стрелки
    triangle_dir = 4 --1 - вправо, 2 - вниз, 3 - влево, 4 - вверх --направление стрелки
  };

end;
-----------------------------------------------------------------------------------
function private.DrawScene()

  --DbgTrace( "stethoscope_pos = "..private.state.stethoscope_pos[1].." "..private.state.stethoscope_pos[2] );
  --DbgTrace( "triangle_dir = "..private.state.triangle_dir );
  --DbgTrace( "triangle_pos = "..private.state.triangle_pos );

  ObjMultiSet( { 
    { "obj_safe_stethoscope",      { pos_x =  private.state.stethoscope_pos[1],       pos_y =  private.state.stethoscope_pos[2] } },
    { "obj_safe_drag_stethoscope", { pos_x =  private.state.stethoscope_pos[1],       pos_y =  private.state.stethoscope_pos[2] } },
    { "spr_safe_safeback",         { pos_x = -private.state.stethoscope_pos[1] + 512, pos_y = -private.state.stethoscope_pos[2] + 384 } },
    { "spr_safe_triangle", { 
      ang = private.triangle_dir_ang[ private.state.triangle_dir ],
      pos_x = private.map_pos[ private.state.triangle_pos ][ 1 ],
      pos_y = private.map_pos[ private.state.triangle_pos ][ 2 ]
    } }
  } );

  for i = 1, 3, 1 do
    if ( private.state[ "point_"..i ] ) then
      --DbgTrace( "point_"..i.." = true" );
      ObjMultiSet( { { "spr_safe_pin_locker_"..i, { pos_x = private.pin_locker_win_pos_x[ i ] } },
                     { "spr_safe_pin_"..i, { pos_x = -340 } } } );
    else 
      ObjMultiSet( { { "spr_safe_pin_locker_"..i, { pos_x = private.pin_locker_start_pos_x[ i ] } },
                     { "spr_safe_pin_"..i, { pos_x = -431 } } } );               
    end;
  end;

end;
-----------------------------------------------------------------------------------
function private.CheckWin()

  if ( private.state.point_1 and private.state.point_2 and private.state.point_3 ) then

    cmn.Lock( 1 );
    --DbgTrace( "WWWWWWIIIIIIIIINNNNNNNN" );
    
    private.Win();

  else

    cmn.Lock( 0 );

  end;

end;
-----------------------------------------------------------------------------------
function private.WinEnd()

  cmn.Lock( 0 );

  cmn.SetEventDone( "win_safe" );
  
  if ng_global.currentprogress == "std" then
  
    cmn.CallEventHandler( "win_safe" );

    if ng_global.progress[ ng_global.currentprogress ][ "win_safe" ].skip == 0 and not ng_global.noskipgames[ "win_safe" ] then

      ng_global.noskipgames[ "win_safe" ] = 1;
      common_impl.CheckAchiev("mg");

    end;

    if ng_global.playedgames and not ng_global.playedgames[ "win_safe" ] then
      ng_global.playedgames[ "win_safe" ] = 1;
    end;

    common_impl.PauseAchiev( 0 );
    
  else 
    interface_impl.ShowStarsWindow();
  end;
  
end;
-----------------------------------------------------------------------------------
function private.Win()
  
  if ng_global.currentprogress == "std" then
  
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_win_mg");

    cmn.MiniGameHide();

    common_impl.PauseAchiev( 1 );
    cmn.EndTimePassing( "mg_safe" );
    
    cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_opn_safe");

    ObjAnimate( "spr_safe_back_2",      "alp", 0, 0, "",             { 0, 0, 1,    0.5, 0, 0 } );
    ObjAnimate( "obj_safe_locker",      "alp", 0, 0, "",             { 0, 0, 1,    0.5, 0, 0 } );
    ObjAnimate( "obj_safe_stethoscope", "alp", 0, 0, private.WinEnd, { 0, 0, 1,    0.5, 0, 0 } );
    
  else 
    ObjMultiSet( { {"obj_safe_locker", { input = 0 }},
                   {"obj_safe_drag_stethoscope", { input = 0 }} } );
    rm_extra.MiniGameHide();
    int_dialog_secretroom.StopTimer();
    private.WinEnd();
  end;

end;
--------------------------------------------------------------------------------------------
function public.DragStartStethoscope()

  --DbgTrace( "***DragStartStethoscope" );
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");

  SetCursor( CURSOR_NULL );

  local curspos = GetZoomCursorPos();

  private.stethoscope_offset_x = curspos[1] - private.state.stethoscope_pos[1]; --смещение от координаты мышки до центра стетоскопа
  private.stethoscope_offset_y = curspos[2] - private.state.stethoscope_pos[2];

  --DbgTrace( private.stethoscope_offset_x.." "..private.stethoscope_offset_y );

  ObjSet( "obj_safe_safeback_crop", { alp = 1 } );

end;
--------------------------------------------------------------------------------------------
function public.DragStethoscope()

  --DbgTrace( "***DragStethoscope" );

  local curspos = GetZoomCursorPos();

  --DbgTrace( curspos[1].." "..curspos[2] );

  curspos[1] = curspos[1] - private.stethoscope_offset_x;
  curspos[2] = curspos[2] - private.stethoscope_offset_y;

  if ( curspos[1] < 165 ) then  --ограничение движения стетоскопа
    curspos[1] = 165;
  elseif ( curspos[1] > 866 ) then
    curspos[1] = 866;
  end;

  if ( curspos[2] < 123 ) then
    curspos[2] = 123;
  elseif ( curspos[2] > 550 ) then--606
    curspos[2] = 550;
  end;

  ObjMultiSet( { { "obj_safe_stethoscope", { pos_x = curspos[1],        pos_y = curspos[2] } },
                 { "spr_safe_safeback",    { pos_x = -curspos[1] + 512, pos_y = -curspos[2] + 384 } } } );  --второй бэк двигаем в другую сторону

end;
--------------------------------------------------------------------------------------------
function public.DragDropStethoscope()

  --DbgTrace( "***DragDropStethoscope" );

  private.state.stethoscope_pos[1] = ObjGet( "obj_safe_stethoscope" ).pos_x;
  private.state.stethoscope_pos[2] = ObjGet( "obj_safe_stethoscope" ).pos_y;

  --обьект который драгаем перемещаем на координаты стетоскопа
  ObjMultiSet( { { "obj_safe_drag_stethoscope", { pos_x = private.state.stethoscope_pos[1], pos_y = private.state.stethoscope_pos[2] } },
                 { "obj_safe_safeback_crop", { alp = 0 } } } );

  --DbgTrace( "stethoscope_pos = "..private.state.stethoscope_pos[1].." "..private.state.stethoscope_pos[2] );

end;
--------------------------------------------------------------------------------------------
function public.MoveTriangle()

  --DbgTrace( "***MoveTriangle" );
  
  local found_way = false;

  for i = 1, #private.map_dir[ private.state.triangle_pos ], 1 do

    --DbgTrace( private.map_dir[ private.state.triangle_pos ][ i ][ 1 ].." - "..private.map_dir[ private.state.triangle_pos ][ i ][ 2 ] );

    --проверка на возможность перехода из текущей коодинаты стрелки по текущему направлению
    if ( private.map_dir[ private.state.triangle_pos ][ i ][ 1 ] == private.state.triangle_dir ) then

      cmn.Lock( 1 );
      
      found_way = true;

      private.state.triangle_pos = private.map_dir[ private.state.triangle_pos ][ i ][ 2 ];

      --DbgTrace( "triangle_pos = "..private.state.triangle_pos );

      ObjSet( "spr_safe_triangle", { 
        pos_x = private.map_pos[ private.state.triangle_pos ][ 1 ],
        pos_y = private.map_pos[ private.state.triangle_pos ][ 2 ]
      } );

      private.GearAnim();

      local animlock_tme = 0.3;
      local point_unlock = 0;

      --дошли до нужных точек
      if     ( private.state.triangle_pos == 4  and not private.state.point_1 ) then
        point_unlock = 1;
      elseif ( private.state.triangle_pos == 16 and not private.state.point_2 ) then
        point_unlock = 2;
      elseif ( private.state.triangle_pos == 18 and not private.state.point_3 ) then
        point_unlock = 3;
      end;

      if ( point_unlock ~= 0 ) then
        private.state[ "point_"..point_unlock ] = true;
        --DbgTrace( "point_"..point_unlock.." = true" );
        animlock_tme = 0.6;
        cmn.PlayAudio("snd", "assets/levels/level3/mg_safe/audio/aud_opn_lock3");
        ObjSet( "spr_safe_pin_locker_"..point_unlock, { pos_x = private.pin_locker_win_pos_x[ point_unlock ] } );
        ObjAnimate( "spr_safe_pin_"..point_unlock, "pos_x", 0, 0, "", { 0, 0, -431,    0.3, 0, -431,    0.6, 0, -340 } );
      end;

      ObjAnimate( "spr_safe_move_btn", "alp", 0, 0, "", { 0, 0, 1,    0.15, 0, 0,    0.3, 0, 1 } );

      ObjSet( "tmr_safe_animlock", { time = animlock_tme, endtrig = private.CheckWin, playing = true } );

      break;
      
    end;

  end;

  if not found_way then
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_wrong_apply");
  end;

end;
--------------------------------------------------------------------------------------------
function public.TurnTriangle( dir )

  --DbgTrace( "***TurnTriangle: dir = "..dir );

  cmn.Lock( 1 );

  private.state.triangle_dir = private.state.triangle_dir + dir;

  if ( private.state.triangle_dir > 4 ) then
    private.state.triangle_dir = 1;
  elseif private.state.triangle_dir < 1 then
    private.state.triangle_dir = 4;
  end;

  ObjSet( "spr_safe_triangle", { ang = private.triangle_dir_ang[ private.state.triangle_dir ] } );

  --DbgTrace( "triangle_dir = "..private.state.triangle_dir );

  private.GearAnim();

  if ( dir == 1 ) then
    ObjAnimate( "spr_safe_turn_btn1", "alp", 0, 0, "", { 0, 0, 1,    0.15, 0, 0,    0.3, 0, 1 } );
  else
    ObjAnimate( "spr_safe_turn_btn2", "alp", 0, 0, "", { 0, 0, 1,    0.15, 0, 0,    0.3, 0, 1 } );
  end;

  ObjSet( "tmr_safe_animlock", { time = 0.3, endtrig = function () cmn.Lock( 0 ); end, playing = true } );

end;
--------------------------------------------------------------------------------------------
function private.GearAnim()--анимация вращения шестеренок
  
  cmn.PlayAudio("snd", "assets/levels/level3/mg_safe/audio/aud_clk_mechanism");

  if ( private.gear_ang >= 6.28 ) then
    private.gear_ang = 0;
  end;

  local side = -1;

  for g = 1, 3, 1 do
    side = -side;
    ObjAnimate( "spr_safe_gear_"..g, "ang", 0, 0, "", { 
      0,   0, side * private.gear_ang,
      0.3, 0, side * ( private.gear_ang + 1.57 )
    } );
  end;

  private.gear_ang = private.gear_ang + 1.57;

  --DbgTrace( "gear ang "..private.gear_ang );

end;
-----------------------------------------------------------------------------------
function public.FocusBtn( obj, inout )--анимация фокуса кнопок
  
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.13 then
      cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_menter1");
    end;
  end;

  ObjAnimate( obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout } );

end;
--*********************************************************************************************************************