-- name=level3

function public.Start ( param )

  game.play_hint_aud = false;
  ng_global.new_hint = true;

  interface.WidgetAdd( InterfaceWidget_Pause, 1800 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 10 );
  interface.WidgetAdd( InterfaceWidget_BtnGuide, 6 );

  interface.WidgetAdd( InterfaceWidget_BtnHint, 4  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 5 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 6 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 7 );

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 0 );

  interface.WidgetAdd( InterfaceWidget_TaskHeader, 1 );
  interface.WidgetAdd( InterfaceWidget_Inventory, 2 );
  --interface.WidgetAdd( InterfaceWidget_TaskPanel );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 3, "assets/interface/int_taskpanel");

  interface.WidgetAdd( InterfaceWidget_Effects, 50 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 4 );

  interface.WidgetAdd( InterfaceWidget_DialogHo, 260 );

  interface.ButtonLockAdd();

  interface.WidgetAdd( InterfaceWidget_ItemPanel, 3, "assets/interface/int_itempanel" );
  interface.WidgetAdd( InterfaceWidget_Popup, 250 );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog );

  interface.WidgetAdd( InterfaceWidget_DialogVideo, 300 );
  --interface.WidgetAdd( InterfaceWidget_DialogStory );
  --interface.WidgetAdd( InterfaceWidget_DialogCharacter, 900 );

  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial, 310 );

  interface.WidgetAdd( InterfaceWidget_Map, 200 );

  interface.PanelNotificationAdd();
  interface.ComplexInvAdd();
  interface_impl.DialogHintAdd();
  
  interface_impl.GlobalTaskAdd();
  
  ------------------------------------------------------
  if IsCollectorsEdition() or IsSurveyEdition() then
  
    ModLoad( "assets/levels/menu/rm_achievements/mod_achievements" );
    rm_achievements.Init();
  
    ModLoad( "assets/levels/menu/rm_collectable/mod_collectable" );
    rm_collectable.Init();

    interface_impl.AchievAdd();
    interface_impl.PopupAchievementAdd();

    interface_impl.BonusAdd();
  
  end;
  ------------------------------------------------------
  if IsCollectorsEdition() then
  
    interface.WidgetAdd( InterfaceWidget_StrategyGuide );
  
  end;
  ------------------------------------------------------
  
  --переменная для того, чтобы из титров не выкидывало в меню
  public.in_progress = true;
  --
  private.Init();
  --
  int_map_impl.CreateRooms( "level3" );

  ModLoad( "assets/levels/level3/mod_inventory3" );
  inventory3.Init();
  
  ModLoad( "assets/levels/menu/rm_endroom/mod_endroom" );
  rm_endroom.Init();
  
  ModLoad( "assets/levels/menu/rm_credits/mod_credits" );
  rm_credits.Init();

  common.LevelLoad( "level3", "std", "rm_witchhouse", param );
  ng_global.progress[ "std" ].common.gamestart = true;
  
  common_impl.PlayBackgroundMusic();

  common_impl.DialogCustomUpdate();
  interface_impl.RemoveFlowersTotal();
  cmn.RemoveCollectable();

  game.play_hint_aud = true;

  common_impl.is_in_map = 0;
  
  int_button_hint_impl.SetNewVid();
  int_button_skip_impl.SetNewVid();

end;
    
function private.Init ()

  game.room_names =
  {
     "rm_witchhouse"
    ,"rm_housegarden"
    ,"rm_street"
    ,"rm_nearpolicedepartment"
    ,"rm_policedepartment"
    ,"rm_castlehall"
    ,"rm_relicstorage"
    ,"mg_darkroom"
    
    ,"ho_fishermans"
    ,"ho_charmonlock"
    ,"ho_onbasrelief"
    
    ,"mg_onscroll"
    ,"mg_safe"
    ,"mg_fightingqueen"
  };
  
  --имена диалогов с подбором предмета (для удаления gfx в кастом моде)
  game.dlg_witems_names =
  {
    "obj_housegarden_dialog_granny1",
    "obj_housegarden_dialog_granny2",
    "obj_housegarden_dialog_granny3",
    "obj_policedepartment_dialog_redhood1",
    "obj_policedepartment_dialog_redhood2"
  };
  
  --таблица с координатами открытия зз
  game.zz_end_pos = {

    [ "zz_table" ] = {440, 360},
    [ "zz_fireplace" ] = {600, 370},
    [ "zz_shelves" ] = {580, 330},
    [ "zz_gardendoor" ] = {560, 330},
    [ "zz_cupboard" ] = {430, 320},
    
    [ "zz_flowerbed" ] = {620, 350},
    [ "zz_robinstatuette" ] = {380, 350},
    
    [ "zz_gateway" ] = {340, 330},
    [ "zz_barrier" ] = {650, 360},
    [ "zz_shopwindow" ] = {440, 330},
    [ "zz_policecar" ] = {590, 360},
    
    [ "zz_policewindow" ] = {590, 360},
    [ "zz_themisstatuette" ] = {600, 320},
    [ "zz_policedoor" ] = {440, 340},
    
    [ "zz_stand" ] = {600, 330},
    [ "zz_celldoor" ] = {300, 340},
    
    [ "zz_basrelief" ] = {620, 320},
    [ "zz_throne" ] = {460, 320},
    [ "zz_keytobook" ] = {360, 340},
    
    [ "zz_magicmirror" ] = {600, 360},
    [ "zz_guard" ] = {440, 320}
    
  };

-- 1 - открыта
-- 2 - таски выполнены
-- 3 - кол-во тасков
-- 4 блокирована
-- 5 цветочки
  game.map_rooms = {

    [ "rm_witchhouse" ] =           { 1, 0, 1, 0, 3 },
    [ "rm_housegarden" ] =          { 0, 0, 2, 0, 2 },
    [ "rm_street" ]   =             { 0, 0, 1, 0, 2 },
    [ "rm_nearpolicedepartment" ] = { 0, 0, 2, 0, 1 },
    [ "rm_policedepartment" ] =     { 0, 0, 99, 0, 2 },
    [ "rm_castlehall" ] =           { 0, 0, 2, 0, 4 },
    [ "rm_relicstorage" ] =         { 0, 0, 99, 0, 3 },
    [ "mg_darkroom" ] =             { 0, 0, 99, 0, 1 }
  
  };

  --таблицы для динамического хинта
  --таблица для юзов на предметы, получаемые в хо и мультиюзов
  game.progress_multyuse =
  {
   
    {"use_sidecuttersgate", "win_fishermans"},
    {"use_sidecutterscar", "win_fishermans"},
    
    {"use_lvl3bearfigurine", "beg_level3"},
    {"use_shell", "beg_level3"},
    {"use_lvl3enchantedflute", "beg_level3"},
    {"use_lvl3crystalshoe", "beg_level3"},
    {"use_lvl3cinderellapage", "beg_level3"},
    {"use_mermaidpage", "beg_level3"},
    {"use_token1", "beg_level3"},
    {"use_lvl3stetoscope", "beg_level3"},
    
    {"use_magiconioncastle", "get_magiconion"},
    {"use_magiconionguard", "get_magiconion"},
    
    {"win_magicmirror", "use_mirrorshard"}
    
  };

  --таблица на мультипредметы с количеством их частей
  game.progress_multyobj =
  {
    
    {"use_copperfeather", 2},
    {"use_facepart", 2},
    {"use_basreliefpart", 2},
    {"use_mirrorshard", 3},
    {"use_petal", 3},
    {"use_redhatpage", 4},
    
  };

  --таблица на юзы, разблокирующиеся другими юзами или кликами
  game.progress_blockeduse =
  {

    {"use_lvl3stetoscope", "clk_putaside"},
    {"use_lvl3crystalshoe", "use_crystalkey"},
    {"use_crystalkey", "get_pocketwatch"},
    {"clk_openburger", "use_sidecutterscar"},
    {"use_casebutton", "use_sidecutterscar"},
    {"use_sidecutterscar", "use_lockpick"},
    {"use_carkey", "use_lockpick"},
    {"use_cauldronwtihfertilizer", "use_poisonedseeds"},
    {"use_runescoop", "use_pruners"},
    {"use_poisonedseeds", "use_runescoop"},
    {"use_torch", "use_burger"},
    {"use_burger", "use_sidecuttersgate"}
    
  };

  game.progress_names =
  {
  
    "beg_level3"
    ,"get_petal1"
    ,"get_lvl3scarf"
    ,"use_lvl3bearfigurine"
    ,"get_petal2"
    ,"get_sharpeningstone"
    ,"use_lvl3scarf"
    ,"get_hotrod"
    ,"use_hotrod"
    ,"get_petal3"
    ,"use_petal"
    ,"win_gardendoor"
    
    ,"opn_housegarden"
    ,"clk_housegardenfirst"
    ,"get_redhatpage1"

    ,"opn_street"
    ,"clk_streetfirst"
    ,"get_lvl3wire"
    ,"clk_makelockpick1"
    ,"clk_makelockpick2"
    ,"clk_makelockpick3"
    ,"get_lockpick"
    
    ,"use_lockpick"
    ,"get_glasscutter"
    ,"get_themisbrokenface"
    ,"use_glasscutter"
    ,"win_fishermans"
    ,"use_sidecuttersgate"
    ,"get_facepart1"
    ,"use_sidecutterscar"
    ,"clk_openburger"
    ,"get_burger"
    ,"get_facepart2"
    ,"use_burger"
    ,"get_redhatbackpack"
    ,"clk_openbackpack"
    ,"clk_takephone"
    ,"clk_phoneon"
    ,"get_token2"
    ,"get_redhatpage2"
    ,"use_token1"
    ,"use_token2"
    
    ,"opn_nearpolicedepartment"
    ,"get_bearspear"
    ,"use_bearspear"
    ,"get_casebutton"
    ,"get_wolffigurine"
    ,"use_casebutton"
    ,"win_policecar"
    ,"get_glue"
    ,"get_policebadgebase"
    ,"use_facepart"
    ,"use_glue"
    ,"get_themisface"
    ,"use_themisface"
    ,"win_onscroll" 
    ,"get_redhatpage3"
    ,"get_scalepan"
    ,"use_scalepan"
    ,"get_torch"
    ,"get_lvl3star"
    ,"use_torch"
    ,"get_eagle"
    ,"get_oldpruners"
    ,"use_lvl3star"
    ,"use_eagle"
    ,"get_policebadge"
    ,"use_policebadge"
    
    ,"opn_policedepartment"
    ,"clk_policedepartmentfirst"
    ,"get_rewardpen"
    ,"use_rewardpen"
    ,"get_carkey"
    ,"get_revolver1"
    ,"use_carkey"
    ,"get_revolver2"
    ,"use_revolver1"
    ,"use_revolver2"
    ,"clk_seeredhatcse"
    ,"clk_putaside"
    ,"use_lvl3stetoscope"
    ,"win_safe"
    ,"clk_lvl3folder3"
    ,"clk_lvl3folder2"
    ,"clk_lvl3folder1"
    ,"get_cellkey"
    ,"use_cellkey"
    ,"get_redhatpage4"
    
    ,"opn_housegardenwithred"
    ,"get_magicamuletrecipe"
    ,"use_wolffigurine"
    ,"get_bluntblade"
    ,"get_moonblossomhoney"
    ,"use_bluntblade"
    ,"use_sharpeningstone"
    ,"get_pruners"
    ,"use_pruners"
    ,"win_flowerbed"
    ,"get_fernflower"
    ,"get_pearl"
    ,"use_pearl"
    ,"use_shell"
    ,"get_swanbowl"
    ,"get_copperfeather1"
    ,"get_applecutter"
    ,"use_swanbowl"
    ,"get_crystalwater"
    ,"use_magicamuletrecipe"
    ,"use_crystalwater"
    ,"use_fernflower"
    ,"use_moonblossomhoney"
    ,"win_table"
    ,"get_teleportamulet"
    ,"use_teleportamulet"
    ,"get_magiconion"
    
    ,"win_charmonlock"
    
    ,"opn_castlehall"
    ,"use_magiconioncastle"
    ,"opn_fightingqueen"
    ,"win_fightingqueen"
    ,"opn_castlehallaftermg"
    
    ,"get_juicyapple"
    ,"get_foxfigurine"
    ,"get_brokenbugle"
    ,"use_applecutter"
    ,"get_poisonedseeds"
    ,"use_foxfigurine"
    ,"get_magicfertilizer"
    ,"get_runescoop"
    ,"get_basreliefpart1"
    ,"use_magicfertilizer"
    ,"get_cauldronwtihfertilizer"
    ,"use_runescoop"
    ,"use_poisonedseeds"
    ,"use_cauldronwtihfertilizer"
    ,"get_leavewithstickydew"
    ,"get_goldcrown"
    ,"use_leavewithstickydew"
    ,"get_enchantedhorn"
    ,"use_enchantedhorn"
    ,"use_lvl3enchantedflute"
    ,"win_keytobook"
    
    ,"opn_relicstorage"
    ,"opn_magicmirror"
    ,"get_basreliefpart2"
    ,"use_basreliefpart"
    ,"win_onbasrelief"
    ,"get_copperfeather2"
    ,"use_copperfeather"
    ,"get_quiverofgoldarrows"
    ,"get_fleurdelis"
    ,"use_fleurdelis"
    ,"use_goldcrown"
    ,"get_mirrorshard1"
    ,"get_crystalkey"
    ,"use_magiconionguard"
    ,"use_quiverofgoldarrows"
    ,"get_pocketwatch"
    ,"use_crystalkey"
    ,"use_lvl3crystalshoe"
    ,"get_mirrorshard2"
    ,"get_pincenez"
    ,"use_pocketwatch"
    ,"use_pincenez"
    ,"get_amuletknot"
    ,"use_amuletknot"
    ,"get_mirrorshard3"
    ,"use_mirrorshard"
    ,"win_magicmirror"
    ,"clk_mirrorchange1"
    ,"clk_mirrorchange2"
    
    ,"opn_darkroom"
    ,"clk_darkroomfirst"
    ,"win_darkroom"
    ,"get_talebook"
    ,"clk_opentalebook"
    ,"use_mermaidpage"
    ,"use_redhatpage"
    ,"use_lvl3cinderellapage"
    
    ,"tutor_20"
    ,"tutor_24"
    ,"tutor_25"
    ,"tutor_26"
  
  };
  
  game.relations = {};

end;
