-- name=rm_relicstorage
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_relicstorage";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Magicmirror();
  --------------------------------------------------------------------------------------------
  -- function get_basreliefpart2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_basreliefpart2" ] = {
        type = "get",
        get_obj = "spr_magicmirror_basreliefpart2",
        room = private.room_objname,
        zz = "zz_magicmirror",
        zz_gate = "gzz_relicstorage_magicmirror"
    };
    --------------------------------------------------------------------------------------------
  local get_basreliefpart2_inv = function ()
  
    interface.InventoryItemAdd( "inv_basreliefpart", "spr_magicmirror_basreliefpart2", function () cmn.GetMultyObject( 'basreliefpart', 2 ); end );
  
  end;
  
  local get_basreliefpart2_end = function ()
  
    ObjDelete( "gfx_magicmirror_basreliefpart2" );
    ObjDelete( "spr_magicmirror_basreliefpart2_sh" );
    ObjDelete( "spr_relicstorage_mirror_basrelief" );
  
  end;
  
  cmn.AddSubscriber( "get_basreliefpart2", get_basreliefpart2_inv );
  cmn.AddSubscriber( "get_basreliefpart2", get_basreliefpart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pocketwatch () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_pocketwatch" ] = {
        type = "get",
        get_obj = "obj_guard_pocketwatch_hint",
        room = private.room_objname,
        zz = "zz_guard",
        zz_gate = "gzz_relicstorage_guard"
    };
    --------------------------------------------------------------------------------------------
  local get_pocketwatch_inv = function ()
  
    interface.InventoryItemAdd( "inv_pocketwatch", "spr_guard_pocketwatch" );
  
  end;
  local get_pocketwatch_mid = function ()
  
    ObjDelete( "anm_guard_archer_use" );
    ObjDelete( "obj_guard_pocketwatch_hint" );
    ObjDelete( "gfx_guard_pocketwatch" );

  end;
  local get_pocketwatch_end = function ()
    
    ObjDelete( "spr_relicstorage_guard_1" );
    
    ObjMultiSet( { {"anm_guard_archer_move", { alp = 1, frame = 400 }},
                   {"anm_guard_table_move", { pos_z = 7, frame = 400 }},
                   {"obj_guard_use_crystalkey", { input = 1 }},
                   {"spr_relicstorage_guard_2", { alp = 1 }} } );

  end;
  
  cmn.AddSubscriber( "get_pocketwatch", get_pocketwatch_inv );
  cmn.AddSubscriber( "get_pocketwatch", get_pocketwatch_mid, private.room_objname );
  cmn.AddSubscriber( "get_pocketwatch", get_pocketwatch_end, private.room_objname );
  cmn.AddSubscriber( "get_pocketwatch_inv", get_pocketwatch_inv );
  cmn.AddSubscriber( "get_pocketwatch_mid", get_pocketwatch_mid, private.room_objname );
  cmn.AddSubscriber( "get_pocketwatch_end", get_pocketwatch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pincenez () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_pincenez" ] = {
        type = "get",
        get_obj = "spr_guard_pincenez",
        room = private.room_objname,
        zz = "zz_guard",
        zz_gate = "gzz_relicstorage_guard"
    };
    --------------------------------------------------------------------------------------------
  local get_pincenez_inv = function ()
  
    interface.InventoryItemAdd( "inv_pincenez", "spr_guard_pincenez" );
  
  end;
  
  local get_pincenez_end = function ()
  
    ObjDelete( "gfx_guard_pincenez" );
    ObjDelete( "spr_guard_pincenez_sh" );
    
    ObjDelete( "spr_relicstorage_guard_pincenez" );

    if ( cmn.IsEventDone( "get_pocketwatch" ) and cmn.IsEventDone( "get_mirrorshard2" ) ) then
      ObjDelete( "gzz_relicstorage_guard" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_pincenez", get_pincenez_inv );
  cmn.AddSubscriber( "get_pincenez", get_pincenez_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mirrorshard2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_mirrorshard2" ] = {
        type = "get",
        get_obj = "spr_guard_mirrorshard2",
        room = private.room_objname,
        zz = "zz_guard",
        zz_gate = "gzz_relicstorage_guard"
    };
    --------------------------------------------------------------------------------------------
  local get_mirrorshard2_inv = function ()
  
    interface.InventoryItemAdd( "inv_mirrorshard", "spr_guard_mirrorshard2", function () cmn.GetMultyObject( 'mirrorshard', 3 ); end );
  
  end;
  
  local get_mirrorshard2_end = function ()
  
    ObjDelete( "gfx_guard_mirrorshard2" );
    
    ObjDelete( "spr_relicstorage_guard_shard" );

    if ( cmn.IsEventDone( "get_pocketwatch" ) and cmn.IsEventDone( "get_pincenez" ) ) then
      ObjDelete( "gzz_relicstorage_guard" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_mirrorshard2", get_mirrorshard2_inv );
  cmn.AddSubscriber( "get_mirrorshard2", get_mirrorshard2_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_mirrorshard () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_mirrorshard" ] = {
        type = "use",
        inv_obj = "inv_mirrorshard",
        use_place = "obj_magicmirror_use_mirrorshard",
        room = private.room_objname,
        zz = "zz_magicmirror",
        zz_gate = "gzz_relicstorage_magicmirror"
    };
  --------------------------------------------------------------------------------------------
  local use_mirrorshard_inv = function ()
  
    interface.InventoryItemRemove( "inv_mirrorshard" );
  
  end;
  local use_mirrorshard_beg = function ()
  
    ObjDelete( "obj_magicmirror_use_mirrorshard" );
  
  end;
  local use_mirrorshard_end = function ()
    
    ObjDelete( "spr_magicmirror_mirror_hint" );
    ObjDelete( "anm_magicmirror_mirror_touch" );

    ObjSet("obj_magicmirror_mirrorshards",  { alp = 1, input = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mirrorshard", use_mirrorshard_beg, private.room_objname );
  cmn.AddSubscriber( "use_mirrorshard", use_mirrorshard_inv );
  cmn.AddSubscriber( "use_mirrorshard", use_mirrorshard_end, private.room_objname );
  cmn.AddSubscriber( "use_mirrorshard_inv", use_mirrorshard_inv, private.room_objname );
  cmn.AddSubscriber( "use_mirrorshard_beg", use_mirrorshard_beg, private.room_objname );
  cmn.AddSubscriber( "use_mirrorshard_end", use_mirrorshard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_quiverofgoldarrows () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_quiverofgoldarrows" ] = {
        type = "use",
        inv_obj = "inv_quiverofgoldarrows",
        use_place = "obj_guard_use_quiverofgoldarrows",
        room = private.room_objname,
        zz = "zz_guard",
        zz_gate = "gzz_relicstorage_guard"
    };
  --------------------------------------------------------------------------------------------
  local use_quiverofgoldarrows_inv = function ()
  
    interface.InventoryItemRemove( "inv_quiverofgoldarrows" );
  
  end;
  local use_quiverofgoldarrows_beg = function ()
  
    ObjDelete( "obj_guard_use_quiverofgoldarrows" );
  
  end;
  local use_quiverofgoldarrows_end = function ()
    
    ObjSet("spr_relicstorage_guard_quiver",  { alp = 1 });
  
    if cmn.IsEventDone("use_magiconionguard") then
      ObjMultiSet( { {"anm_guard_archer_use",  { alp = 1, input = 1, frame = 400 }},
                     {"spr_relicstorage_guard_bowstring_2", { alp = 1 }} } );
      ObjDelete( "anm_guard_archer_touch" );
      ObjDelete( "spr_relicstorage_guard_bowstring_1" );
    else 
      ObjSet("spr_guard_quiver",  { alp = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_quiverofgoldarrows", use_quiverofgoldarrows_beg, private.room_objname );
  cmn.AddSubscriber( "use_quiverofgoldarrows", use_quiverofgoldarrows_inv );
  cmn.AddSubscriber( "use_quiverofgoldarrows", use_quiverofgoldarrows_end, private.room_objname );
  cmn.AddSubscriber( "use_quiverofgoldarrows_inv", use_quiverofgoldarrows_inv, private.room_objname );
  cmn.AddSubscriber( "use_quiverofgoldarrows_beg", use_quiverofgoldarrows_beg, private.room_objname );
  cmn.AddSubscriber( "use_quiverofgoldarrows_end", use_quiverofgoldarrows_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crystalkey () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_crystalkey" ] = {
        type = "use",
        inv_obj = "inv_crystalkey",
        use_place = "obj_guard_use_crystalkey",
        room = private.room_objname,
        zz = "zz_guard",
        zz_gate = "gzz_relicstorage_guard"
    };
  --------------------------------------------------------------------------------------------
  local use_crystalkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_crystalkey" );
  
  end;
  local use_crystalkey_beg = function ()
  
    ObjDelete( "obj_guard_use_crystalkey" );
    ObjDelete( "anm_guard_table_move" );
  
  end;
  local use_crystalkey_end = function ()
    
    ObjDelete( "anm_guard_table_use_key" );
    ObjDelete( "spr_relicstorage_guard_cover" );
  
    ObjMultiSet( { {"anm_guard_table_use_shoe", { alp = 1 }},
                   {"obj_guard_use_lvl3crystalshoe", { input = 1 }},
                   {"spr_relicstorage_guard_key", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crystalkey", use_crystalkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_crystalkey", use_crystalkey_inv );
  cmn.AddSubscriber( "use_crystalkey", use_crystalkey_end, private.room_objname );
  cmn.AddSubscriber( "use_crystalkey_inv", use_crystalkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_crystalkey_beg", use_crystalkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_crystalkey_end", use_crystalkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl3crystalshoe () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_lvl3crystalshoe" ] = {
        type = "use",
        inv_obj = "inv_lvl3crystalshoe",
        use_place = "obj_guard_use_lvl3crystalshoe",
        room = private.room_objname,
        zz = "zz_guard",
        zz_gate = "gzz_relicstorage_guard"
    };
  --------------------------------------------------------------------------------------------
  local use_lvl3crystalshoe_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl3crystalshoe" );
  
  end;
  local use_lvl3crystalshoe_beg = function ()
  
    ObjDelete( "obj_guard_use_lvl3crystalshoe" );
  
  end;
  local use_lvl3crystalshoe_end = function ()
    
    ObjDelete( "spr_relicstorage_guard_shoe_1" );
  
    ObjMultiSet( { {"spr_guard_table_shoe", { alp = 1 }},
                   {"anm_guard_table_use_shoe", { input = 1, frame = 400 }},
                   {"spr_relicstorage_guard_shoe_open", { alp = 1 }} } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl3crystalshoe", use_lvl3crystalshoe_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3crystalshoe", use_lvl3crystalshoe_inv );
  cmn.AddSubscriber( "use_lvl3crystalshoe", use_lvl3crystalshoe_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl3crystalshoe_inv", use_lvl3crystalshoe_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl3crystalshoe_beg", use_lvl3crystalshoe_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3crystalshoe_end", use_lvl3crystalshoe_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_mirrorchange1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_mirrorchange1" ] = {
    type = "click",
    use_place = "spr_magicmirror_mirror_fixed",
    room = private.room_objname,
    zz = "zz_magicmirror",
    zz_gate = "gzz_relicstorage_magicmirror"
  };
  --------------------------------------------------------------------------------------------
  local clk_mirrorchange1 = function ()
    
    ObjDelete("spr_magicmirror_loc_1");
    ObjDelete( "spr_relicstorage_mirror_1" );
  
    ObjMultiSet( { {"spr_magicmirror_loc_2",  { alp = 1 }},
                   {"spr_magicmirror_mirror_fixed", { event_mup = function() rm_relicstorage.clk_mirrorchange( 2 ); end }},
                   {"spr_relicstorage_mirror_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_mirrorchange1", clk_mirrorchange1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_mirrorchange1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_mirrorchange2" ] = {
    type = "click",
    use_place = "spr_magicmirror_mirror_fixed",
    room = private.room_objname,
    zz = "zz_magicmirror",
    zz_gate = "gzz_relicstorage_magicmirror"
  };
  --------------------------------------------------------------------------------------------
  local clk_mirrorchange2 = function ()
    
    ObjDelete("spr_magicmirror_loc_2");
    ObjDelete( "gzz_relicstorage_magicmirror" );
    ObjDelete( "spr_relicstorage_mirror_2" );
  
    ObjMultiSet( { {"spr_magicmirror_loc_3",  { alp = 1 }},
                   {"spr_magicmirror_mirror_fixed", { input = 0 }},
                   {"grm_relicstorage_darkroom", { input = 1, alp = 1 }},
                   {"spr_relicstorage_mirror_3", { alp = 1 }} } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_relicstorage_darkroom_focus");
    end;                
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_mirrorchange2", clk_mirrorchange2, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_relicstorage () end;
  --------------------------------------------------------------------------------------------
  local opn_relicstorage = function ()
  
    int_map_impl.OpenRoom( "rm_relicstorage" );
    interface_impl.SetCurrentGlobalTask( 20 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_relicstorage", opn_relicstorage );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_magicmirror" );
  
  function zz_magicmirror.PreOpen()

    if cmn.IsEventDone("use_mirrorshard") and not cmn.IsEventDone("win_magicmirror") then
      private.zz_magicmirror.DrawScene();
    end;

  end;
  
  function zz_magicmirror.Open()
    
    if not cmn.IsEventDone("opn_magicmirror") then
      cmn.SetEventDone("opn_magicmirror");
      cmn.ShowDlgBbt( "magicmirror_open_voice", 1 );
      cmn.PlayAudio("voc", "assets/levels/level3/rm_relicstorage/audio/aud_cheshire_dlg_lvl3_2_voc");
    end;

    if cmn.IsEventDone("use_mirrorshard") and not cmn.IsEventDone("win_magicmirror") then
      private.zz_magicmirror.CheckWin();
    end;

  end;
  
  function zz_magicmirror.Close()
    cmn.HideNote( 0 );
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_magicmirror" ].state) then 
    private.zz_magicmirror.StartConditions();
  end;

  private.zz_magicmirror.state = ng_global.progress[ ng_global.currentprogress ][ "win_magicmirror" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_relicstorage();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio3/aud_relicstorage_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio3/aud_relicstorage_env");
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_mirrorshard()

  local item = "inv_mirrorshard";

  if cmn.ApplyObj( item, "gzz_relicstorage_magicmirror" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_magicmirror" );

  elseif ( cmn.ApplyObj( item, "obj_magicmirror_use_mirrorshard" ) and cmn.CheckMultiObject( "mirrorshard", 3 ) ) then

    cmn.CallEventHandler( "use_mirrorshard_inv" );
    cmn.CallEventHandler( "use_mirrorshard_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_mirrorshard" );
      cmn.CallEventHandler( "use_mirrorshard_end" );

    end;
    
    local anm_hint = function ()
      
      ObjAnimate("spr_magicmirror_mirror_hint", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1,    1.5, 0, 1,    2, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_relicstorage/audio/aud_use_mirrors_parts");
    
    ObjAnimate("obj_magicmirror_mirrorshards", "alp", 0, 0, anm_hint, { 0, 0, 0,   0.5, 0, 1 });
    ObjAnimate("anm_magicmirror_mirror_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_quiverofgoldarrows()

  local item = "inv_quiverofgoldarrows";

  if cmn.ApplyObj( item, "gzz_relicstorage_guard" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_guard" );

  elseif ( cmn.ApplyObj( item, "obj_guard_use_quiverofgoldarrows" ) ) then

    cmn.CallEventHandler( "use_quiverofgoldarrows_inv" );
    cmn.CallEventHandler( "use_quiverofgoldarrows_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_quiverofgoldarrows" );
      cmn.CallEventHandler( "use_quiverofgoldarrows_end" );

    end;

    local anm_archer = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/rm_relicstorage/audio/aud_use_quiver");
      
      ObjMultiSet( { {"anm_guard_archer_touch", { alp = 0 }},
                     {"anm_guard_archer_use", { alp = 1, playing = 1, endtrig = func_after }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_relicstorage/audio/aud_use_bow");
    
    if cmn.IsEventDone("use_magiconionguard") then
      ObjAnimate("spr_guard_quiver", "alp", 0, 0, anm_archer, { 0, 0, 0,   0.3, 0, 1,  0.6, 0, 1 });
    else 
      ObjAnimate("spr_guard_quiver", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_crystalkey()

  local item = "inv_crystalkey";

  if cmn.ApplyObj( item, "gzz_relicstorage_guard" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_guard" );

  elseif ( cmn.ApplyObj( item, "obj_guard_use_crystalkey" ) and cmn.IsEventDone("get_pocketwatch") ) then

    cmn.CallEventHandler( "use_crystalkey_inv" );
    cmn.CallEventHandler( "use_crystalkey_beg" );

    local func_after = function ()

      cmn.Lock( 0 );
      
      cmn.SetEventDone( "use_crystalkey" );
      cmn.CallEventHandler( "use_crystalkey_end" );

    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_relicstorage/audio/aud_use_key_dome");

    ObjSet("anm_guard_table_use_key",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl3crystalshoe()

  local item = "inv_lvl3crystalshoe";

  if cmn.ApplyObj( item, "gzz_relicstorage_guard" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_guard" );

  elseif ( cmn.ApplyObj( item, "obj_guard_use_lvl3crystalshoe" ) and cmn.IsEventDone( "use_crystalkey" ) ) then

    cmn.CallEventHandler( "use_lvl3crystalshoe_inv" );
    cmn.CallEventHandler( "use_lvl3crystalshoe_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl3crystalshoe" );
      cmn.CallEventHandler( "use_lvl3crystalshoe_end" );

    end;
    
    local anm_open = function ()
      
      ObjSet("anm_guard_table_use_shoe",  { playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_relicstorage/audio/aud_use_foot");

    ObjAnimate( "spr_guard_table_shoe", "alp", 0, 0, anm_open,
    {
      0.0, 0, 0, 
      0.3, 0, 1, 
      0.6, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_basreliefpart2()

  cmn.SetEventDone( "get_basreliefpart2" );
  cmn.CallEventHandler( "get_basreliefpart2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_pocketwatch()
  
  ObjSet("spr_guard_pocketwatch",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_pocketwatch" );
  cmn.CallEventHandler( "get_pocketwatch_inv" );
  cmn.CallEventHandler( "get_pocketwatch_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/rm_relicstorage/audio/aud_robin_move");
  
  local func_after = function ()
    
    cmn.Lock( 0 );
    cmn.CallEventHandler( "get_pocketwatch_end" );
    
  end;
  
  local change_z = function ()
    
    ObjSet("anm_guard_table_move",  { pos_z = 7 });
    
  end;
  
  ObjMultiSet( { {"anm_guard_archer_move",  { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_guard_table_move",  { alp = 1, playing = 1 }},
                 {"tmr_guard_timer",  { time = 0.6, playing = 1, endtrig = change_z }} } );

end;
--------------------------------------------------------------------------------------------
function public.get_pincenez()

  cmn.SetEventDone( "get_pincenez" );
  cmn.CallEventHandler( "get_pincenez" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if ( cmn.IsEventDone( "get_pocketwatch" ) and cmn.IsEventDone( "get_mirrorshard2" ) ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_mirrorshard2()

  cmn.SetEventDone( "get_mirrorshard2" );
  cmn.CallEventHandler( "get_mirrorshard2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if ( cmn.IsEventDone( "get_pocketwatch" ) and cmn.IsEventDone( "get_pincenez" ) ) then
    common.CloseSubRoom();
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_mirrorchange( num )

  local func_after = function ()

    cmn.SetEventDone( "clk_mirrorchange"..num );
    cmn.CallEventHandler( "clk_mirrorchange"..num );

    cmn.Lock( 0 );
    
    if num == 2 then
      ObjSet("rm_relicstorage",  { color_r = 0, color_g = 0, color_b = 0 });
      cmn.GotoRoom( "mg_darkroom" );
    else 
      cmn.ShowBbt( "magicmirror_world_2" );
    end;
  
  end;
  
  local go_trough = function ()
    
    ObjSet("tmr_magicmirror_timer",  { time = 0.5, playing = 1, endtrig = function() common.CloseSubRoom(); end });
    
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level3/rm_relicstorage/vid_throughmirror", func_after, "assets/levels/level3/rm_relicstorage/audio/aud_troughmirror", "" );
    
  end;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/rm_relicstorage/audio/aud_mirror_clk");
  
  if num == 1 then
    ObjAnimate("spr_magicmirror_loc_2", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,    1, 0, 1 });
    ObjSet("anm_magicmirror_mirror_effect",  { alp = 1, playing = 1, endtrig = func_after });
  else 
    ObjAnimate("spr_magicmirror_loc_3", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,    1, 0, 1 });
    ObjSet("anm_magicmirror_mirror_effect",  { alp = 1, playing = 1, endtrig = go_trough });
  end;

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_relicstorage()

  if not ( cmn.IsEventDone( "opn_relicstorage" ) ) then
    cmn.SetEventDone( "opn_relicstorage" );
    cmn.CallEventHandler("opn_relicstorage");
    cmn.ShowBbt( "relicstorage_open" );
    interface_impl.ShowGlobalTask();
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_archer()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_guard_use_magiconion" );
  
  cmn.PlayAudio("snd", "assets/levels/level3/rm_relicstorage/audio/aud_xx_clk_stones");
  
  ObjSet("anm_guard_archer_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_showcase()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_guard_use_crystalkey" );
  
  cmn.PlayAudio("snd", "assets/levels/level3/rm_relicstorage/audio/aud_xx_clk_dome");
  
  ObjSet("anm_guard_table_touch",  { alp = 1, playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_mirror()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_magicmirror_use_mirrorshard" );
  
  cmn.PlayAudio("snd", "assets/levels/level3/rm_relicstorage/audio/aud_xx_clk_debris");
  
  ObjSet("anm_magicmirror_mirror_touch",  { alp = 1, playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Magicmirror *** () end;
--*********************************************************************************************************************
--********************************************************************************************************************
private.zz_magicmirror = {};
public.zz_magicmirror = {};

function private.Init_Magicmirror()

  private.zz_magicmirror.chosen = 0;
  private.zz_magicmirror.parts_pos = { {-73, 17}, {-3, 6}, {29, -35}, {-94, -28}, {-29, -114} };
  private.zz_magicmirror.parts_pos_start = { {180, 121}, {-203, -141}, {170, -133}, {179, -2}, {-207, 49} };
  --------------------------------------------------------------------------------------------
  game.hint[ "win_magicmirror" ] = {
    type = "use",
    inv_obj = "spr_magicmirror_mirrorshard_1",
    use_place = "obj_magicmirror_mirror_hint_1",
    room = "rm_relicstorage",
    zz = "zz_magicmirror",
    zz_gate = "gzz_relicstorage_magicmirror"
  };
  -----------------------------------------------------------------------------------
  local win_magicmirror_zz = function ()

    if cmn.IsEventDone( "win_magicmirror" ) then

      ObjDelete( "obj_magicmirror_mirror" );
      ObjDelete( "spr_magicmirror_mirror_bl" );
      ObjDelete( "spr_magicmirror_mirror_bl_2" );
      ObjDelete( "obj_magicmirror_mirrorshards" );
      
      ObjMultiSet( { {"spr_magicmirror_mirror_fixed", { alp = 1, input = 1 }},
                     {"spr_relicstorage_mirror_whole", { alp = 1 }},
                     {"spr_relicstorage_mirror_1", { alp = 1 }} } );

    end;

  end;
  local win_magicmirror_task = function ()
  
    if cmn.IsEventDone( "win_magicmirror" ) then
      interface_impl.SetCurrentGlobalTask( 21 );
    end;
    
  end;

  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_magicmirror", win_magicmirror_zz, "rm_relicstorage" );
  cmn.AddSubscriber( "win_magicmirror", win_magicmirror_task );

end;
--********************************************************************************************************************
function private.zz_magicmirror.StartConditions()

  ng_global.progress[ "std" ][ "win_magicmirror" ].state = { 0, 0, 0, 0, 0 }; --mirror parts put in

end;
-----------------------------------------------------------------------------------
function private.zz_magicmirror.DrawScene()
  
  for i = 1, 5, 1 do
    
    if private.zz_magicmirror.state[i] == 1 then
      
      ObjAttach("spr_magicmirror_mirrorshard_"..i, "obj_magicmirror_mirror");
      ObjSet("spr_magicmirror_mirrorshard_"..i,  { input = 0, pos_x = private.zz_magicmirror.parts_pos[i][1], pos_y = private.zz_magicmirror.parts_pos[i][2] });
      
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_magicmirror.ChooseMirror( num )
  
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  
  private.zz_magicmirror.chosen = num;
  SetCursor( CURSOR_DEFAULT );
  
  ObjAttach("spr_magicmirror_mirrorshard_"..num, "obj_magicmirror_mirrorshards_fly");
  ObjStartDrag("obj_magicmirror_mirrorshards_drag");
  
end;
-----------------------------------------------------------------------------------
function public.zz_magicmirror.DragMirror()
  
  local curspos = GetZoomCursorPos();
  curspos[1] = math.floor(curspos[1] - ObjGet("zz_magicmirror").pos_x);
  curspos[2] = math.floor(curspos[2] - ObjGet("zz_magicmirror").pos_y);
  
  if curspos[1] < -250 then
    curspos[1] = -250;
  elseif curspos[1] > 250 then
    curspos[1] = 250;
  end;
  
  if curspos[2] < -250 then
    curspos[2] = -250;
  elseif curspos[2] > 250 then
    curspos[2] = 250;
  end;
  
  ObjSet("spr_magicmirror_mirrorshard_"..private.zz_magicmirror.chosen,  { pos_x = curspos[1], pos_y = curspos[2] });
  
end;
-----------------------------------------------------------------------------------
function public.zz_magicmirror.DropMirror()
  
  cmn.Lock( 1 );
  
  local num = private.zz_magicmirror.chosen;
  private.zz_magicmirror.chosen = 0;
  
  local curspos = GetZoomCursorPos();
  if  tostring(GetPlatform()) == "android" then
    curspos[2] = curspos[2] - 100;
  elseif tostring(GetPlatform()) == "ios" then
    if port.isTablet() == 0 then
      curspos[2] = curspos[2] - 75;
    else
      curspos[2] = curspos[2] - 50;
    end;
  end;
  curspos[1] = math.floor(curspos[1] - ObjGet("zz_magicmirror").pos_x);
  curspos[2] = math.floor(curspos[2] - ObjGet("zz_magicmirror").pos_y);
  
  if curspos[1] < -250 then
    curspos[1] = -250;
  elseif curspos[1] > 250 then
    curspos[1] = 250;
  end;
  
  if curspos[2] < -250 then
    curspos[2] = -250;
  elseif curspos[2] > 250 then
    curspos[2] = 250;
  end;
  
  if private.zz_magicmirror.CheckHit( curspos[1], curspos[2], num ) then
    
    private.zz_magicmirror.state[num] = 1;
    
    local point_a, point_b = {}, {};
    point_a[1] = curspos[1];
    point_a[2] = curspos[2];
    point_b[1] = private.zz_magicmirror.parts_pos[ num ][1];
    point_b[2] = private.zz_magicmirror.parts_pos[ num ][2];
    local len = common_impl.math.FindSegmentLength( point_a, point_b );
    local tme = 0.005 * len;
    
    if tme > 0.4 then
      tme = 0.4;
    elseif tme < 0.1 then
      tme = 0.1;
    end;
    
    cmn.PlayAudio("snd", "assets/levels/level3/rm_relicstorage/audio/aud_use_mirrors_parts2");
    
    ObjAttach("spr_magicmirror_mirrorshard_"..num, "obj_magicmirror_mirror");
    ObjSet("spr_magicmirror_mirrorshard_"..num,  { input = 0 });
    ObjAnimate("spr_magicmirror_mirrorshard_"..num, "pos_xy", 0, 0, private.zz_magicmirror.CheckWin, { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] });
    
  else 
    
    local point_a, point_b = {}, {};
    point_a[1] = curspos[1];
    point_a[2] = curspos[2];
    point_b[1] = private.zz_magicmirror.parts_pos_start[ num ][1];
    point_b[2] = private.zz_magicmirror.parts_pos_start[ num ][2];
    local len = common_impl.math.FindSegmentLength( point_a, point_b );
    local tme = 0.002 * len;
    
    if tme > 0.4 then
      tme = 0.4;
    elseif tme < 0.1 then
      tme = 0.1;
    end;
    
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_wrong_apply");
    
    ObjAnimate("spr_magicmirror_mirrorshard_"..num, "pos_xy", 0, 0, function() cmn.Lock(0); ObjAttach("spr_magicmirror_mirrorshard_"..num, "obj_magicmirror_mirrorshards"); end, { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_magicmirror.CheckHit( px, py, num )
  
  local centr = {0, 0}; 
  local accuracy = 30;

  centr[1] = private.zz_magicmirror.parts_pos[num][1];
  centr[2] = private.zz_magicmirror.parts_pos[num][2];

  if ( (px - centr[1])^2 + (py - centr[2])^2 ) <= accuracy^2 then 

    return true;

  else

    return false;

  end; 
  
end;
-----------------------------------------------------------------------------------
function private.zz_magicmirror.CheckWin()
  
  local hint, win_flag = 1, true;
  
  for i = 1, 5, 1 do
    
    if private.zz_magicmirror.state[i] == 0 then
      hint = i;
      win_flag = false;
      break;
    end;
    
  end;
  
  game.hint[ "win_magicmirror" ].inv_obj = "spr_magicmirror_mirrorshard_"..hint;
  game.hint[ "win_magicmirror" ].use_place = "obj_magicmirror_mirror_hint_"..hint;
  
  if win_flag then
    
    cmn.Lock( 1 );
    private.zz_magicmirror.Win();
    
  else 
    
    cmn.Lock( 0 );
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_magicmirror.Win()

  local func_after = function ()

    cmn.SetEventDone( "win_magicmirror" );
    cmn.CallEventHandler( "win_magicmirror" );

    cmn.Lock(0);
    cmn.ShowBbt( "magicmirror_world_1" );
    interface_impl.ShowGlobalTask();

  end;
  
  cmn.PlayAudio("snd", "assets/levels/level3/rm_relicstorage/audio/aud_mirror");
  
  ObjSet("anm_magicmirror_mirror_effect",  { alp = 1, playing = 1, endtrig = func_after });
  ObjAnimate("spr_magicmirror_mirror_fixed", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,    1, 0, 1 });
  
end;
--********************************************************************************************************************