-- name=rm_street
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_street";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Policecar();
  --------------------------------------------------------------------------------------------
  -- function get_glasscutter () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_glasscutter" ] = {
        type = "get",
        get_obj = "spr_policecar_glasscutter",
        room = private.room_objname,
        zz = "zz_policecar",
        zz_gate = "gzz_street_policecar"
    };
    --------------------------------------------------------------------------------------------
  local get_glasscutter_inv = function ()
  
    interface.InventoryItemAdd( "inv_glasscutter", "spr_policecar_glasscutter" );
  
  end;
  
  local get_glasscutter_end = function ()
  
    ObjDelete( "gfx_policecar_glasscutter" );
    ObjDelete( "spr_policecar_glasscutter_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_glasscutter", get_glasscutter_inv );
  cmn.AddSubscriber( "get_glasscutter", get_glasscutter_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_themisbrokenface () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_themisbrokenface" ] = {
        type = "get",
        get_obj = "spr_policecar_themisbrokenface",
        room = private.room_objname,
        zz = "zz_policecar",
        zz_gate = "gzz_street_policecar"
    };
    --------------------------------------------------------------------------------------------
  local get_themisbrokenface_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_themisbrokenface", "spr_policecar_themisbrokenface" );
  
  end;
  
  local get_themisbrokenface_end = function ()
  
    ObjDelete( "gfx_policecar_themisbrokenface" );
    ObjDelete( "spr_policecar_themisbrokenface_sh" );

    if ( private.IsAllPolicecarItemGet() ) then
      ObjDelete( "gzz_street_policecar" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_themisbrokenface", get_themisbrokenface_inv );
  cmn.AddSubscriber( "get_themisbrokenface", get_themisbrokenface_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_burger () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_burger" ] = {
        type = "get",
        get_obj = "spr_policecar_burger",
        room = private.room_objname,
        zz = "zz_policecar",
        zz_gate = "gzz_street_policecar"
    };
    --------------------------------------------------------------------------------------------
  local get_burger_inv = function ()
  
    interface.InventoryItemAdd( "inv_burger", "spr_policecar_burger" );
  
  end;
  
  local get_burger_end = function ()
  
    ObjDelete( "gfx_policecar_burger" );

    if ( private.IsAllPolicecarItemGet() ) then
      ObjDelete( "gzz_street_policecar" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_burger", get_burger_inv );
  cmn.AddSubscriber( "get_burger", get_burger_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_facepart2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_facepart2" ] = {
        type = "get",
        get_obj = "spr_policecar_facepart2",
        room = private.room_objname,
        zz = "zz_policecar",
        zz_gate = "gzz_street_policecar"
    };
    --------------------------------------------------------------------------------------------
  local get_facepart2_inv = function ()
  
    interface.InventoryItemAdd( "inv_facepart", "spr_policecar_facepart2", function () cmn.GetMultyObject( 'facepart', 2 ); end );
    if cmn.IsEventDone("get_facepart1") then
      ObjSet("inv_themisbrokenface_star_light",  { alp = 1 });
    end;
  
  end;
  
  local get_facepart2_end = function ()
  
    ObjDelete( "gfx_policecar_facepart2" );
    ObjDelete( "spr_policecar_facepart2_sh" );

    if ( private.IsAllPolicecarItemGet() ) then
      ObjDelete( "gzz_street_policecar" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_facepart2", get_facepart2_inv );
  cmn.AddSubscriber( "get_facepart2", get_facepart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_glue () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_glue" ] = {
        type = "get",
        get_obj = "spr_policecar_glue",
        room = private.room_objname,
        zz = "zz_policecar",
        zz_gate = "gzz_street_policecar"
    };
    --------------------------------------------------------------------------------------------
  local get_glue_inv = function ()
  
    interface.InventoryItemAdd( "inv_glue", "spr_policecar_glue" );
    ObjSet("inv_themisbrokenface_star_light",  { alp = 1 });
  
  end;
  
  local get_glue_end = function ()
  
    ObjDelete( "gfx_policecar_glue" );
    ObjDelete( "spr_policecar_glue_sh" );
    
    ObjSet("spr_policecar_policebadgebase",  { input = 1 });

    if ( private.IsAllPolicecarItemGet() ) then
      ObjDelete( "gzz_street_policecar" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_glue", get_glue_inv );
  cmn.AddSubscriber( "get_glue", get_glue_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_policebadgebase () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_policebadgebase" ] = {
        type = "get",
        get_obj = "spr_policecar_policebadgebase",
        room = private.room_objname,
        zz = "zz_policecar",
        zz_gate = "gzz_street_policecar"
    };
    --------------------------------------------------------------------------------------------
  local get_policebadgebase_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_policebadgebase", "spr_policecar_policebadgebase" );
  
  end;
  
  local get_policebadgebase_end = function ()
  
    ObjDelete( "gfx_policecar_policebadgebase" );

    if ( private.IsAllPolicecarItemGet() ) then
      ObjDelete( "gzz_street_policecar" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_policebadgebase", get_policebadgebase_inv );
  cmn.AddSubscriber( "get_policebadgebase", get_policebadgebase_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_revolver2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_revolver2" ] = {
        type = "get",
        get_obj = "spr_policecar_revolver2",
        room = private.room_objname,
        zz = "zz_policecar",
        zz_gate = "gzz_street_policecar"
    };
    --------------------------------------------------------------------------------------------
  local get_revolver2_inv = function ()
  
    int_map_impl.DecreaseRoomTasks("rm_street");
    interface.InventoryItemAdd( "inv_revolver2", "spr_policecar_revolver2" );
  
  end;
  
  local get_revolver2_end = function ()
  
    ObjDelete( "gfx_policecar_revolver2" );
    ObjDelete( "spr_street_car_revolver" );

    if ( private.IsAllPolicecarItemGet() ) then
      ObjDelete( "gzz_street_policecar" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_revolver2", get_revolver2_inv );
  cmn.AddSubscriber( "get_revolver2", get_revolver2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_eagle () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_eagle" ] = {
        type = "get",
        get_obj = "spr_gateway_eagle",
        room = private.room_objname,
        zz = "zz_gateway",
        zz_gate = "gzz_street_gateway"
    };
    --------------------------------------------------------------------------------------------
  local get_eagle_inv = function ()
  
    interface.InventoryItemAdd( "inv_eagle", "spr_gateway_eagle" );
    ObjSet("inv_policebadgebase_star_light",  { alp = 1 });
  
  end;
  
  local get_eagle_end = function ()
  
    ObjDelete( "gfx_gateway_eagle" );
    ObjDelete( "spr_gateway_eagle_sh" );

    if ( private.IsAllGatewayItemGet() ) then
      ObjDelete( "gzz_street_gateway" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_eagle", get_eagle_inv );
  cmn.AddSubscriber( "get_eagle", get_eagle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl3wire () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_lvl3wire" ] = {
        type = "get",
        get_obj = "spr_gateway_lvl3wire",
        room = private.room_objname,
        zz = "zz_gateway",
        zz_gate = "gzz_street_gateway"
    };
    --------------------------------------------------------------------------------------------
  local get_lvl3wire_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_lvl3wire", "spr_gateway_lvl3wire" );
  
  end;
  
  local get_lvl3wire_end = function ()
  
    ObjDelete( "gfx_gateway_lvl3wire" );
    ObjDelete( "spr_gateway_lvl3wire_sh" );
    ObjDelete( "spr_gateway_lvl3wire_bl" );
  
  end;
  
  cmn.AddSubscriber( "get_lvl3wire", get_lvl3wire_inv );
  cmn.AddSubscriber( "get_lvl3wire", get_lvl3wire_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_facepart1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_facepart1" ] = {
        type = "get",
        get_obj = "spr_gateway_facepart1",
        room = private.room_objname,
        zz = "zz_gateway",
        zz_gate = "gzz_street_gateway"
    };
    --------------------------------------------------------------------------------------------
  local get_facepart1_inv = function ()
  
    interface.InventoryItemAdd( "inv_facepart", "spr_gateway_facepart1", function () cmn.GetMultyObject( 'facepart', 2 ); end );
    if cmn.IsEventDone("get_facepart2") then
      ObjSet("inv_themisbrokenface_star_light",  { alp = 1 });
    end;
  
  end;
  
  local get_facepart1_end = function ()
  
    ObjDelete( "gfx_gateway_facepart1" );
    ObjDelete( "spr_gateway_facepart1_sh" );
    ObjDelete( "spr_street_gateway_basrelief" );

    if ( private.IsAllGatewayItemGet() ) then
      ObjDelete( "gzz_street_gateway" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_facepart1", get_facepart1_inv );
  cmn.AddSubscriber( "get_facepart1", get_facepart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_redhatbackpack () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_redhatbackpack" ] = {
        type = "get",
        get_obj = "spr_gateway_redhatbackpack",
        room = private.room_objname,
        zz = "zz_gateway",
        zz_gate = "gzz_street_gateway"
    };
    --------------------------------------------------------------------------------------------
  local get_redhatbackpack_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_redhatbackpack", "spr_gateway_redhatbackpack" );
  
  end;
  
  local get_redhatbackpack_end = function ()
  
    ObjDelete( "gfx_gateway_redhatbackpack" );
    ObjDelete( "spr_gateway_redhatbackpack_sh" );
    ObjDelete( "spr_gateway_grid_3" );
    
    ObjDelete( "spr_street_gateway_bag" );

    if ( private.IsAllGatewayItemGet() ) then
      ObjDelete( "gzz_street_gateway" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_redhatbackpack", get_redhatbackpack_inv );
  cmn.AddSubscriber( "get_redhatbackpack", get_redhatbackpack_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_oldpruners () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_oldpruners" ] = {
        type = "get",
        get_obj = "spr_gateway_oldpruners",
        room = private.room_objname,
        zz = "zz_gateway",
        zz_gate = "gzz_street_gateway"
    };
    --------------------------------------------------------------------------------------------
  local get_oldpruners_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_oldpruners", "spr_gateway_oldpruners" );
  
  end;
  
  local get_oldpruners_end = function ()
  
    ObjDelete( "gfx_gateway_oldpruners" );
    ObjDelete( "spr_gateway_oldpruners_sh" );

    if ( private.IsAllGatewayItemGet() ) then
      ObjDelete( "gzz_street_gateway" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_oldpruners", get_oldpruners_inv );
  cmn.AddSubscriber( "get_oldpruners", get_oldpruners_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_lockpick () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_lockpick" ] = {
        type = "use",
        inv_obj = "inv_lockpick",
        use_place = "obj_policecar_use_lockpick",
        room = private.room_objname,
        zz = "zz_policecar",
        zz_gate = "gzz_street_policecar"
    };
  --------------------------------------------------------------------------------------------
  local use_lockpick_inv = function ()
  
    interface.InventoryItemRemove( "inv_lockpick" );
  
  end;
  local use_lockpick_beg = function ()
  
    ObjDelete( "obj_policecar_use_lockpick" );
    ObjDelete( "anm_policecar_door_touch" );
    
    ObjSet("obj_policecar_inside_car",  { alp = 1 });
  
  end;
  local use_lockpick_end = function ()
  
    ObjMultiSet( { { "anm_policecar_use_lockpick", { alp = 1, frame = 300 } },
                   { "obj_policecar_inside_car", { input = 1 } },
                   { "spr_street_car_open", { alp = 1 } } } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lockpick", use_lockpick_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockpick", use_lockpick_inv );
  cmn.AddSubscriber( "use_lockpick", use_lockpick_end, private.room_objname );
  cmn.AddSubscriber( "use_lockpick_inv", use_lockpick_inv, private.room_objname );
  cmn.AddSubscriber( "use_lockpick_beg", use_lockpick_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockpick_end", use_lockpick_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sidecutterscar () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_sidecutterscar" ] = {
        type = "use",
        inv_obj = "inv_sidecutters",
        use_place = "obj_policecar_use_sidecutters",
        room = private.room_objname,
        zz = "zz_policecar",
        zz_gate = "gzz_street_policecar"
    };
  --------------------------------------------------------------------------------------------
  local use_sidecutters_inv1 = function ()
  
    if cmn.IsEventDone("use_sidecuttersgate") then
      interface.InventoryItemRemove( "inv_sidecutters" );
    end;
  
  end;
  local use_sidecutters_beg1 = function ()
  
    ObjDelete( "obj_policecar_use_sidecutters" );
    ObjDelete( "anm_policecar_bag_touch" );
  
  end;
  local use_sidecutters_end1 = function ()
  
    ObjSet("obj_policecar_bag_open",  { alp = 1, input = 1 });
    
    ObjDelete( "anm_policecar_use_cutters" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sidecutterscar", use_sidecutters_beg1, private.room_objname );
  cmn.AddSubscriber( "use_sidecutterscar", use_sidecutters_inv1 );
  cmn.AddSubscriber( "use_sidecutterscar", use_sidecutters_end1, private.room_objname );
  cmn.AddSubscriber( "use_sidecutters_inv1", use_sidecutters_inv1, private.room_objname );
  cmn.AddSubscriber( "use_sidecutters_beg1", use_sidecutters_beg1, private.room_objname );
  cmn.AddSubscriber( "use_sidecutters_end1", use_sidecutters_end1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_casebutton () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_casebutton" ] = {
        type = "use",
        inv_obj = "inv_casebutton",
        use_place = "obj_policecar_use_casebutton",
        room = private.room_objname,
        zz = "zz_policecar",
        zz_gate = "gzz_street_policecar"
    };
  --------------------------------------------------------------------------------------------
  local use_casebutton_inv = function ()
  
    interface.InventoryItemRemove( "inv_casebutton" );
  
  end;
  local use_casebutton_beg = function ()
  
    ObjDelete( "obj_policecar_use_casebutton" );
  
  end;
  local use_casebutton_end = function ()
    
    ObjMultiSet( { {"spr_policecar_wallet_button", { alp = 1 }},
                   {"gzz_policecar_mmg", { alp = 1, input = 1, active = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_casebutton", use_casebutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_casebutton", use_casebutton_inv );
  cmn.AddSubscriber( "use_casebutton", use_casebutton_end, private.room_objname );
  cmn.AddSubscriber( "use_casebutton_inv", use_casebutton_inv, private.room_objname );
  cmn.AddSubscriber( "use_casebutton_beg", use_casebutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_casebutton_end", use_casebutton_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_carkey () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_carkey" ] = {
        type = "use",
        inv_obj = "inv_carkey",
        use_place = "obj_policecar_use_carkey",
        room = private.room_objname,
        zz = "zz_policecar",
        zz_gate = "gzz_street_policecar"
    };
  --------------------------------------------------------------------------------------------
  local use_carkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_carkey" );
  
  end;
  local use_carkey_beg = function ()
  
    ObjDelete( "obj_policecar_use_carkey" );
    ObjDelete( "anm_policecar_glovebox_touch" );
  
  end;
  local use_carkey_end = function ()
  
    ObjMultiSet( { { "anm_policecar_use_keys", { input = 1, alp = 1, frame = 300 } },
                   { "spr_street_car_glove_open", { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_carkey", use_carkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_carkey", use_carkey_inv );
  cmn.AddSubscriber( "use_carkey", use_carkey_end, private.room_objname );
  cmn.AddSubscriber( "use_carkey_inv", use_carkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_carkey_beg", use_carkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_carkey_end", use_carkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_glasscutter () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_glasscutter" ] = {
        type = "use",
        inv_obj = "inv_glasscutter",
        use_place = "obj_shopwindow_use_glasscutter",
        room = private.room_objname,
        zz = "zz_shopwindow",
        zz_gate = "gzz_street_shopwindow"
    };
  --------------------------------------------------------------------------------------------
  local use_glasscutter_inv = function ()
  
    interface.InventoryItemRemove( "inv_glasscutter" );
  
  end;
  local use_glasscutter_beg = function ()
  
    ObjDelete( "obj_shopwindow_use_glasscutter" );
  
  end;
  local use_glasscutter_end = function ()

    ObjDelete( "gzz_street_shopwindow" );
  
    ObjMultiSet( { { "gho_street_fishermans", { active = true, input = true, alp = 1 } },
                   { "spr_street_ho_fishermans_glass1", { alp = 1 } } } );
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_glasscutter", use_glasscutter_beg, private.room_objname );
  cmn.AddSubscriber( "use_glasscutter", use_glasscutter_inv );
  cmn.AddSubscriber( "use_glasscutter", use_glasscutter_end, private.room_objname );
  cmn.AddSubscriber( "use_glasscutter_inv", use_glasscutter_inv, private.room_objname );
  cmn.AddSubscriber( "use_glasscutter_beg", use_glasscutter_beg, private.room_objname );
  cmn.AddSubscriber( "use_glasscutter_end", use_glasscutter_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sidecuttersgate () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_sidecuttersgate" ] = {
        type = "use",
        inv_obj = "inv_sidecutters",
        use_place = "obj_gateway_use_sidecutters",
        room = private.room_objname,
        zz = "zz_gateway",
        zz_gate = "gzz_street_gateway"
    };
  --------------------------------------------------------------------------------------------
  local use_sidecutters_inv2 = function ()
  
    if cmn.IsEventDone("use_sidecutterscar") then
      interface.InventoryItemRemove( "inv_sidecutters" );
    end;
  
  end;
  local use_sidecutters_beg2 = function ()
  
    ObjDelete( "obj_gateway_use_sidecutters" );
    ObjDelete( "anm_gateway_grid_touch" );
  
  end;
  local use_sidecutters_end2 = function ()
    
    ObjDelete( "obj_gateway_grid_out" );
    ObjDelete( "anm_gateway_dog_out" );
    
    ObjDelete( "spr_street_gateway_grid_1" );
  
    ObjMultiSet( { { "spr_gateway_facepart1", { input = 1 } },
                   { "obj_gateway_use_burger", { input = 1 } },
                   { "spr_gateway_grid_3", { alp = 1 } },
                   { "obj_gateway_dog", { alp = 1 } },
                   { "spr_street_gateway_grid_2", { alp = 1 } },
                   { "anm_street_wolf", { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sidecuttersgate", use_sidecutters_beg2, private.room_objname );
  cmn.AddSubscriber( "use_sidecuttersgate", use_sidecutters_inv2 );
  cmn.AddSubscriber( "use_sidecuttersgate", use_sidecutters_end2, private.room_objname );
  cmn.AddSubscriber( "use_sidecutters_inv2", use_sidecutters_inv2, private.room_objname );
  cmn.AddSubscriber( "use_sidecutters_beg2", use_sidecutters_beg2, private.room_objname );
  cmn.AddSubscriber( "use_sidecutters_end2", use_sidecutters_end2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_burger () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_burger" ] = {
        type = "use",
        inv_obj = "inv_burger",
        use_place = "obj_gateway_use_burger",
        room = private.room_objname,
        zz = "zz_gateway",
        zz_gate = "gzz_street_gateway"
    };
  --------------------------------------------------------------------------------------------
  local use_burger_inv = function ()
  
    interface.InventoryItemRemove( "inv_burger" );
  
  end;
  local use_burger_beg = function ()
  
    ObjDelete( "obj_gateway_use_burger" );
    ObjDelete( "anm_gateway_dog" );
    ObjDelete( "anm_gateway_dog_touch" );
  
  end;
  local use_burger_end = function ()
    
    ObjDelete( "obj_gateway_dog" );
    ObjDelete( "anm_street_wolf" );
  
    ObjMultiSet( { { "spr_gateway_redhatbackpack", { input = 1 } },
                   { "obj_gateway_use_torch", { input = 1 } },
                   { "spr_street_police_wolf", { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_burger", use_burger_beg, private.room_objname );
  cmn.AddSubscriber( "use_burger", use_burger_inv );
  cmn.AddSubscriber( "use_burger", use_burger_end, private.room_objname );
  cmn.AddSubscriber( "use_burger_inv", use_burger_inv, private.room_objname );
  cmn.AddSubscriber( "use_burger_beg", use_burger_beg, private.room_objname );
  cmn.AddSubscriber( "use_burger_end", use_burger_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_torch () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_torch" ] = {
        type = "use",
        inv_obj = "inv_torch",
        use_place = "obj_gateway_use_torch",
        room = private.room_objname,
        zz = "zz_gateway",
        zz_gate = "gzz_street_gateway"
    };
  --------------------------------------------------------------------------------------------
  local use_torch_inv = function ()
  
    interface.InventoryItemRemove( "inv_torch" );
  
  end;
  local use_torch_beg = function ()
  
    ObjDelete( "obj_gateway_use_torch" );
  
  end;
  local use_torch_end = function ()
    
    ObjDelete( "obj_gateway_dark" );
  
    ObjMultiSet( { { "obj_gateway_light", { alp = 1, input = 1 } },
                   { "obj_gateway_flashlight", { alp = 1 } },
                   { "spr_street_gateway_flashlight", { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_torch", use_torch_beg, private.room_objname );
  cmn.AddSubscriber( "use_torch", use_torch_inv );
  cmn.AddSubscriber( "use_torch", use_torch_end, private.room_objname );
  cmn.AddSubscriber( "use_torch_inv", use_torch_inv, private.room_objname );
  cmn.AddSubscriber( "use_torch_beg", use_torch_beg, private.room_objname );
  cmn.AddSubscriber( "use_torch_end", use_torch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_token2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_token2" ] = {
        type = "use",
        inv_obj = "inv_token2",
        use_place = "obj_barrier_use_token2",
        room = private.room_objname,
        zz = "zz_barrier",
        zz_gate = "gzz_street_barrier"
    };
  --------------------------------------------------------------------------------------------
  local use_token2_inv = function ()
  
    interface.InventoryItemRemove( "inv_token2" );
  
  end;
  local use_token2_beg = function ()
  
    ObjDelete( "obj_barrier_use_token2" );
  
  end;
  local use_token2_end = function ()

    ObjMultiSet( { { "spr_barrier_greenlamp", { alp = 1 } },
                   { "spr_barrier_greenlamp1", { alp = 1 } } } );
  
    if ( cmn.IsEventDone( "use_token1" ) ) then

      ObjDelete( "gzz_street_barrier" );

      ObjMultiSet( { { "grm_street_nearpolicedepartment", { active = true, alp = 1, input = true } },
                     { "spr_street_barrier2", { alp = 1 } } } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_street_nearpolicedepartment_focus");
      end;
      ObjDelete( "spr_street_gate" );
      ObjDelete( "spr_street_barrier1" );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_token2", use_token2_beg, private.room_objname );
  cmn.AddSubscriber( "use_token2", use_token2_inv );
  cmn.AddSubscriber( "use_token2", use_token2_end, private.room_objname );
  cmn.AddSubscriber( "use_token2_inv", use_token2_inv, private.room_objname );
  cmn.AddSubscriber( "use_token2_beg", use_token2_beg, private.room_objname );
  cmn.AddSubscriber( "use_token2_end", use_token2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_token1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_token1" ] = {
        type = "use",
        inv_obj = "inv_token1",
        use_place = "obj_barrier_use_token1",
        room = private.room_objname,
        zz = "zz_barrier",
        zz_gate = "gzz_street_barrier"
    };
  --------------------------------------------------------------------------------------------
  local use_token1_inv = function ()
  
    interface.InventoryItemRemove( "inv_token1" );
  
  end;
  local use_token1_beg = function ()
  
    ObjDelete( "obj_barrier_use_token1" );
  
  end;
  local use_token1_end = function ()

    ObjMultiSet( { { "spr_barrier_greenlamp", { alp = 1 } },
                   { "spr_barrier_greenlamp1", { alp = 1 } } } );
  
    if ( cmn.IsEventDone( "use_token2" ) ) then

      ObjDelete( "gzz_street_barrier" );

      ObjMultiSet( { { "grm_street_nearpolicedepartment", { active = true, alp = 1, input = true } },
                     { "spr_street_barrier2", { alp = 1 } } } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_street_nearpolicedepartment_focus");
      end;
      ObjDelete( "spr_street_gate" );
      ObjDelete( "spr_street_barrier1" );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_token1", use_token1_beg, private.room_objname );
  cmn.AddSubscriber( "use_token1", use_token1_inv );
  cmn.AddSubscriber( "use_token1", use_token1_end, private.room_objname );
  cmn.AddSubscriber( "use_token1_inv", use_token1_inv, private.room_objname );
  cmn.AddSubscriber( "use_token1_beg", use_token1_beg, private.room_objname );
  cmn.AddSubscriber( "use_token1_end", use_token1_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_streetfirst () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_streetfirst" ] = {
    type = "click",
    use_place = "obj_street_firstclick",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_streetfirst_beg = function ()
  
    ObjDelete( "obj_street_firstclick" );
  
  end;
  local clk_streetfirst_end = function ()

    ObjMultiSet( {
      { "gzz_street_policecar", {
        event_mdown = 'cmn.GotoSubRoomMDown( "street_policecar" );',
        event_mup = 'cmn.GotoSubRoomMUp( "street_policecar", "zz_policecar" );'
      } },
      { "gzz_street_shopwindow", {
        event_mdown = 'cmn.GotoSubRoomMDown( "street_shopwindow" );',
        event_mup = 'cmn.GotoSubRoomMUp( "street_shopwindow", "zz_shopwindow" );'
      } },
      { "gzz_street_gateway", {
        event_mdown = 'cmn.GotoSubRoomMDown( "street_gateway" );',
        event_mup = 'cmn.GotoSubRoomMUp( "street_gateway", "zz_gateway" );'
      } },
      { "gzz_street_barrier", {
        event_mdown = 'cmn.GotoSubRoomMDown( "street_barrier" );',
        event_mup = 'cmn.GotoSubRoomMUp( "street_barrier", "zz_barrier" );'
      } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_streetfirst", clk_streetfirst_beg, private.room_objname );
  cmn.AddSubscriber( "clk_streetfirst", clk_streetfirst_end, private.room_objname );
  cmn.AddSubscriber( "clk_streetfirst_beg", clk_streetfirst_beg, private.room_objname );
  cmn.AddSubscriber( "clk_streetfirst_end", clk_streetfirst_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_openburger () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_openburger" ] = {
    type = "click",
    use_place = "obj_policecar_clk_openburger",
    room = private.room_objname,
    zz = "zz_policecar",
    zz_gate = "gzz_street_policecar"
  };
  --------------------------------------------------------------------------------------------
  local clk_openburger_beg = function ()
  
    ObjDelete( "obj_policecar_clk_openburger" );
  
  end;
  local clk_openburger_end = function ()
  
    ObjSet("anm_policecar_can_open",  { frame = 300, input = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_openburger", clk_openburger_beg, private.room_objname );
  cmn.AddSubscriber( "clk_openburger", clk_openburger_end, private.room_objname );
  cmn.AddSubscriber( "clk_openburger_beg", clk_openburger_beg, private.room_objname );
  cmn.AddSubscriber( "clk_openburger_end", clk_openburger_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_street () end;
  --------------------------------------------------------------------------------------------
  local opn_street = function ()
  
    int_map_impl.BlockRoom( "rm_witchhouse" );
    int_map_impl.BlockRoom( "rm_housegarden" );
    int_map_impl.OpenRoom( "rm_street" );
    interface_impl.SetCurrentGlobalTask( 16 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_street", opn_street );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_policecar" );
  
  function zz_policecar.PreOpen()
    
    if not(cmn.IsEventDone( "win_policecar" )) then
      private.zz_policecar.DrawScene();
    end;

  end;

  function zz_policecar.PreClose()
    
    if ( cmn.IsEventDone( "use_casebutton" ) and not(cmn.IsEventDone( "win_policecar" )) ) then
      private.zz_policecar.active = 0;
      cmn.MiniGameHide("policecar");
    end;

  end;

  function zz_policecar.Close()
    
    if ( cmn.IsEventDone( "use_casebutton" ) and not(cmn.IsEventDone( "win_policecar" )) ) then
      ObjSet("obj_policecar_game",  { alp = 0, input = 0 });
    end;
                   
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_policecar" ].state) then 
    private.zz_policecar.StartConditions();
  end;

  private.zz_policecar.state = ng_global.progress[ ng_global.currentprogress ][ "win_policecar" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_street();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_nearhospital_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_nearhospital_env");
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_lockpick()

  local item = "inv_lockpick";

  if cmn.ApplyObj( item, "gzz_street_policecar" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_policecar" );

  elseif ( cmn.ApplyObj( item, "obj_policecar_use_lockpick" ) ) then

    cmn.CallEventHandler( "use_lockpick_inv" );
    cmn.CallEventHandler( "use_lockpick_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lockpick" );
      cmn.CallEventHandler( "use_lockpick_end" );

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_street/audio/aud_opn_car_door");

    ObjSet("anm_policecar_use_lockpick",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_sidecutters()

  local item = "inv_sidecutters";

  if cmn.ApplyObj( item, "gzz_street_policecar" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_policecar" );

  elseif ( cmn.ApplyObj( item, "obj_policecar_use_sidecutters" ) and cmn.IsEventDone( "use_lockpick" ) ) then

    cmn.CallEventHandler( "use_sidecutters_inv1" );
    cmn.CallEventHandler( "use_sidecutters_beg1" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_sidecutterscar" );
      cmn.CallEventHandler( "use_sidecutters_end1" );

    end;
    
    if not cmn.IsEventDone("get_themisbrokenface") then
      public.get_themisbrokenface();
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_street/audio/aud_use_cutter_belt");

    ObjSet("anm_policecar_use_cutters",  { alp = 1, playing = 1, endtrig = func_after });
  
  elseif cmn.ApplyObj( item, "gzz_street_gateway" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_gateway" );

  elseif ( cmn.ApplyObj( item, "obj_gateway_use_sidecutters" ) ) then

    cmn.CallEventHandler( "use_sidecutters_inv2" );
    cmn.CallEventHandler( "use_sidecutters_beg2" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_sidecuttersgate" );
      cmn.CallEventHandler( "use_sidecutters_end2" );
      
      cmn.ShowBbt( "gateway_after_wolf1" );
      
      ObjSet("spr_gateway_grid_1",  { alp = 1 });

    end;
    
    local anm_wolf = function ()
      
      ObjDelete("anm_gateway_grid_cut");
      ObjSet("anm_gateway_dog_out",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_street/audio/aud_use_cutter_cell");
    
    ObjMultiSet( { {"anm_gateway_grid_cut", { alp = 1, playing = 1, endtrig = anm_wolf }},
                   {"spr_gateway_grid_1", { alp = 0 }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_casebutton()

  local item = "inv_casebutton";

  if cmn.ApplyObj( item, "gzz_street_policecar" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_policecar" );

  elseif ( cmn.ApplyObj( item, "obj_policecar_use_casebutton" ) and cmn.IsEventDone( "use_sidecutterscar" ) ) then

    cmn.CallEventHandler( "use_casebutton_inv" );
    cmn.CallEventHandler( "use_casebutton_beg" );

    local func_after = function ()

      --cmn.Lock( 0 );

      cmn.SetEventDone( "use_casebutton" );
      --cmn.CallEventHandler( "use_casebutton_end" );
      
      public.zz_policecar.OpenMg(1);

    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_brokenscoopnet/audio/aud_single_clk");

    ObjAnimate( "spr_policecar_wallet_button", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_carkey()

  local item = "inv_carkey";

  if cmn.ApplyObj( item, "gzz_street_policecar" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_policecar" );

  elseif ( cmn.ApplyObj( item, "obj_policecar_use_carkey" ) and cmn.IsEventDone( "use_lockpick" ) ) then

    cmn.CallEventHandler( "use_carkey_inv" );
    cmn.CallEventHandler( "use_carkey_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_carkey" );
      cmn.CallEventHandler( "use_carkey_end" );

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_street/audio/aud_opn_trunksmall");

    ObjSet("anm_policecar_use_keys",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_glasscutter()

  local item = "inv_glasscutter";

  if cmn.ApplyObj( item, "gzz_street_shopwindow" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_shopwindow" );

  elseif ( cmn.ApplyObj( item, "obj_shopwindow_use_glasscutter" ) ) then

    cmn.CallEventHandler( "use_glasscutter_inv" );
    cmn.CallEventHandler( "use_glasscutter_beg" );

    local func_after = function ()
      
      cmn.Lock( 0 );

      cmn.SetEventDone( "use_glasscutter" );
      cmn.CallEventHandler( "use_glasscutter_end" );

      common.CloseSubRoom();

    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_street/audio/aud_use_glasscutter");

    ObjSet("anm_shopwindow_use_glasscutter",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_burger()

  local item = "inv_burger";

  if cmn.ApplyObj( item, "gzz_street_gateway" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_gateway" );

  elseif ( cmn.ApplyObj( item, "obj_gateway_use_burger" ) and cmn.IsEventDone( "use_sidecuttersgate" ) ) then

    cmn.CallEventHandler( "use_burger_inv" );
    cmn.CallEventHandler( "use_burger_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_burger" );
      cmn.CallEventHandler( "use_burger_end" );
      
      cmn.ShowBbt( "gateway_after_wolf2" );
      
      ObjSet("spr_gateway_grid_1",  { alp = 1 });

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_street/audio/aud_use_burger");

    ObjMultiSet( { {"anm_gateway_use_burger", { alp = 1, playing = 1, endtrig = func_after }},
                   {"spr_gateway_grid_1", { alp = 0 }} } );
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_torch()

  local item = "inv_torch";

  if cmn.ApplyObj( item, "gzz_street_gateway" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_gateway" );

  elseif ( cmn.ApplyObj( item, "obj_gateway_use_torch" ) and cmn.IsEventDone( "use_burger" ) ) then

    cmn.CallEventHandler( "use_torch_inv" );
    cmn.CallEventHandler( "use_torch_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_torch" );
      cmn.CallEventHandler( "use_torch_end" );

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_street/audio/aud_use_lamp2");

    ObjAnimate( "obj_gateway_light", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 0,   0.5, 0, 0.5,   0.8, 0, 0.2,  1.1, 0, 0.8,  1.4, 0, 0.7,  1.7, 0, 1  } );
    ObjAnimate( "obj_gateway_flashlight", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_token2()

  local item = "inv_token2";

  if cmn.ApplyObj( item, "gzz_street_barrier" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_barrier" );

  elseif ( cmn.ApplyObj( item, "obj_barrier_use_token2" ) ) then

    cmn.CallEventHandler( "use_token2_inv" );
    cmn.CallEventHandler( "use_token2_beg" );

    local func_after3 = function ()
      cmn.SetEventDone( "use_token2" );
      cmn.CallEventHandler( "use_token2_end" );
      cmn.Lock( 0 );
    end;

    local func_after2 = function ()

      if ( cmn.IsEventDone( "use_token1" ) ) then
        cmn.PlayAudio("snd", "assets/levels/level3/rm_street/audio/aud_movement_barier");
        ObjSet( "anm_barrier_barrier_opn", { endtrig = function () func_after3(); common.CloseSubRoom(); end, playing = true } );
      else
        ObjMultiSet( { { "anm_barrier_touch_barrier", { alp = 1 } },
                       { "anm_barrier_use_token", { alp = 0, frame = 0 } } } );
        func_after3();
      end;

    end;

    local func_after = function ()

      ObjAnimate( "spr_barrier_greenlamp"..( cmn.IsEventDone( "use_token1" ) and 2 or 1 ), "alp", 0, 0, func_after2, { 0, 0, 0,    0.3, 0, 1 } );

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_street/audio/aud_use_coin2");

    ObjMultiSet( { { "anm_barrier_touch_barrier", { alp = 0 } },
                   { "anm_barrier_use_token", { alp = 1, endtrig = func_after, playing = true } } } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_token1()

  local item = "inv_token1";

  if cmn.ApplyObj( item, "gzz_street_barrier" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_barrier" );

  elseif ( cmn.ApplyObj( item, "obj_barrier_use_token1" ) ) then

    cmn.CallEventHandler( "use_token1_inv" );
    cmn.CallEventHandler( "use_token1_beg" );

    local func_after3 = function ()
      cmn.SetEventDone( "use_token1" );
      cmn.CallEventHandler( "use_token1_end" );
      cmn.Lock( 0 );
    end;

    local func_after2 = function ()

      if ( cmn.IsEventDone( "use_token2" ) ) then
        cmn.PlayAudio("snd", "assets/levels/level3/rm_street/audio/aud_movement_barier");
        ObjSet( "anm_barrier_barrier_opn", { endtrig = function () func_after3(); common.CloseSubRoom(); end, playing = true } );
      else
        ObjMultiSet( { { "anm_barrier_touch_barrier", { alp = 1 } },
                       { "anm_barrier_use_token", { alp = 0, frame = 0 } } } );
        func_after3();
      end;

    end;

    local func_after = function ()

      ObjAnimate( "spr_barrier_greenlamp"..( cmn.IsEventDone( "use_token2" ) and 2 or 1 ), "alp", 0, 0, func_after2, { 0, 0, 0,    0.3, 0, 1 } );

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_street/audio/aud_use_coin2");

    ObjMultiSet( { { "anm_barrier_touch_barrier", { alp = 0 } },
                   { "anm_barrier_use_token", { alp = 1, endtrig = func_after, playing = true } } } );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_glasscutter()

  cmn.SetEventDone( "get_glasscutter" );
  cmn.CallEventHandler( "get_glasscutter" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_themisbrokenface()

  cmn.SetEventDone( "get_themisbrokenface" );
  cmn.CallEventHandler( "get_themisbrokenface" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if ( private.IsAllPolicecarItemGet() ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_burger()

  cmn.SetEventDone( "get_burger" );
  cmn.CallEventHandler( "get_burger" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if ( private.IsAllPolicecarItemGet() ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_facepart2()

  cmn.SetEventDone( "get_facepart2" );
  cmn.CallEventHandler( "get_facepart2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if ( private.IsAllPolicecarItemGet() ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_glue()

  cmn.SetEventDone( "get_glue" );
  cmn.CallEventHandler( "get_glue" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if ( private.IsAllPolicecarItemGet() ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_policebadgebase()

  cmn.SetEventDone( "get_policebadgebase" );
  cmn.CallEventHandler( "get_policebadgebase" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if ( private.IsAllPolicecarItemGet() ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_revolver2()
  
  ObjSet("spr_policecar_revolver2",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_revolver2" );
  cmn.CallEventHandler( "get_revolver2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if ( private.IsAllPolicecarItemGet() ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_eagle()

  cmn.SetEventDone( "get_eagle" );
  cmn.CallEventHandler( "get_eagle" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if not cmn.IsEventDone("get_oldpruners") then
    cmn.SetEventDone( "get_oldpruners" );
    cmn.CallEventHandler( "get_oldpruners" );
  end;

  if ( private.IsAllGatewayItemGet() ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_lvl3wire()

  cmn.SetEventDone( "get_lvl3wire" );
  cmn.CallEventHandler( "get_lvl3wire" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_facepart1()

  cmn.SetEventDone( "get_facepart1" );
  cmn.CallEventHandler( "get_facepart1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if ( private.IsAllGatewayItemGet() ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_redhatbackpack()

  cmn.SetEventDone( "get_redhatbackpack" );
  cmn.CallEventHandler( "get_redhatbackpack" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if ( private.IsAllGatewayItemGet() ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_oldpruners()

  cmn.SetEventDone( "get_oldpruners" );
  cmn.CallEventHandler( "get_oldpruners" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if ( private.IsAllGatewayItemGet() ) then
    common.CloseSubRoom();
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function public.clk_streetfirst()

  cmn.SetEventDone( "clk_streetfirst" );
  cmn.CallEventHandler( "clk_streetfirst_beg" );

  local func_after = function ()

    cmn.CallEventHandler( "clk_streetfirst_end" );
    cmn.ShowBbt( "street_after_ingateway" );
    
    cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_nearhospital_env");

  end;
  
  cmn.StopAllEnv();
  cmn.PlayFullscreenVideo( "assets/levels/level3/rm_street/vid_ingateway", func_after, "assets/levels/level3/rm_street/audio/aud_ingateway", "" );

end;
--------------------------------------------------------------------------------------------
function public.clk_openburger()

  cmn.SetEventDone( "clk_openburger" );
  cmn.CallEventHandler( "clk_openburger_beg" );

  local func_after = function ()

    cmn.Lock( 0 );
    cmn.CallEventHandler( "clk_openburger_end" );

  end;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_giftegg/audio/aud_opn_plastic");

  ObjSet("anm_policecar_can_open",  { playing = 1, endtrig = func_after });

end;
--------------------------------------------------------------------------------------------
function private.IsAllPolicecarItemGet()

  --ОСТОРОЖНО! используется в прогрессовских функциях

  if ( cmn.IsEventDone( "get_themisbrokenface" ) and cmn.IsEventDone( "get_burger" )          and cmn.IsEventDone( "get_facepart2" )
  and  cmn.IsEventDone( "get_glue" )             and cmn.IsEventDone( "get_policebadgebase" ) and cmn.IsEventDone( "get_revolver2" ) ) then
    return true;
  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function private.IsAllGatewayItemGet()

  --ОСТОРОЖНО! используется в прогрессовских функциях

  if ( cmn.IsEventDone( "get_facepart1" ) and cmn.IsEventDone( "get_redhatbackpack" ) and cmn.IsEventDone( "get_eagle" )
  and  cmn.IsEventDone( "get_oldpruners" ) ) then
    return true;
  end;

  return false;

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_street()

  if not ( cmn.IsEventDone( "opn_street" ) ) then
    cmn.SetEventDone( "opn_street" );
    cmn.CallEventHandler("opn_street");
    cmn.ShowBbt( "street_open" );
    interface_impl.ShowGlobalTask();
    int_map_impl.AddDiarypage( 8 );
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_car_door()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_policecar_use_lockpick" );
  
  cmn.PlayAudio("snd", "assets/levels/level3/rm_street/audio/aud_xx_car_door2");
  
  ObjSet("anm_policecar_door_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_car_glovebox()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_policecar_use_carkey" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_xx_compartment");
  
  ObjSet("anm_policecar_glovebox_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_car_bag()
  
  cmn.Lock(1);
  
  if not cmn.IsEventDone("get_themisbrokenface") then
    public.get_themisbrokenface();
  end;
  
  cmn.ShowBbt( "obj_policecar_use_sidecutters" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/ho_inwardrobe/audio/aud_xx_bag");
  
  ObjSet("anm_policecar_bag_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_car_wallet()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_policecar_use_casebutton" );
  
  cmn.PlayAudio("snd", "assets/levels/level3/rm_street/audio/aud_xx_clk_wallet");
  
  ObjSet("anm_policecar_wallet_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_barrier()
  
  cmn.Lock(1);

  cmn.ShowBbt( "obj_barrier_use_token" );
  
  cmn.PlayAudio("snd", "assets/levels/level3/rm_street/audio/aud_xx_clk_barrier");
  
  ObjSet("anm_barrier_touch_barrier", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_gateway()
  
  cmn.Lock(1);

  cmn.ShowBbt( "obj_gateway_use_sidecutters" );
  
  cmn.PlayAudio("snd", "assets/levels/level3/rm_street/audio/aud_xx_clk_cell");
  
  ObjSet("anm_gateway_grid_touch", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_dog()
  
  cmn.Lock(1);

  cmn.ShowBbt( "obj_gateway_use_burger" );
  
  cmn.PlayAudio("snd", "assets/levels/level3/rm_street/audio/aud_xx_clk_wolf");
  
  ObjSet("anm_gateway_dog_touch", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Policecar *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_policecar = {};
public.zz_policecar = {};

function private.Init_Policecar()
  
  private.zz_policecar.active = 0;
  
  private.zz_policecar.start = { 3, 2, 4, 3 };

  --меняющиеся картинки для каждой кнопки
  private.zz_policecar.change = { {1, 2}, {2, 4}, {3, 4}, {1, 3} };
  
  -------------------------------------------------------------------------------------------
  game.hint[ "win_policecar" ] = {

      type = "click",
      use_place = "gzz_policecar_mmg",
      room = "rm_forestthicket",
      zz = "zz_policecar",
      zz_gate = "gzz_street_policecar"
  };
  -----------------------------------------------------------------------------------
  local win_policecar_loc = function ()

    if cmn.IsEventDone( "win_policecar" ) then

      ObjSet("obj_policecar_wallet_open",  { alp = 1, input = 1 });

      ObjDelete( "gzz_policecar_mmg" );
      ObjDelete( "obj_policecar_game" );
      ObjDelete( "anm_policecar_wallet_touch" );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_policecar", win_policecar_loc, "rm_street" );
  
end;
--*********************************************************************************************************************
function public.zz_policecar.OpenMg( num )

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_zoom_mg");

  local func_after = function ()

    if num == 1 then
      cmn.CallEventHandler( "use_casebutton_end" );
      cmn.Lock( 0 );
    else 
      private.zz_policecar.CheckWin();
    end;

    cmn.MiniGameShow();
    
    ObjMultiSet( { {"obj_policecar_game", { alp = 1, input = 1 }},
                   {"obj_policecar_back", { pos_x = 0, pos_y = 0, scale_x = 1, scale_y = 1 }} } );

  end;
  
  local show_mmg = function ()
  
    ObjAnimate( "obj_policecar_game", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 } );
  
  end;

  private.zz_policecar.active = 1;

  ObjAnimate( "obj_policecar_back", "scale_xy", 0, 0, "", { 0,0,1,1,   0.3,0,1,1,    1.5,0,1.5,1.5 } );
  ObjAnimate( "obj_policecar_back", "pos_xy",   0, 0, show_mmg, { 0,0,0,0,   0.3,0,0,0,    1.5,0,-2,-126 } );

end;
-----------------------------------------------------------------------------------
function private.zz_policecar.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_policecar" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_policecar" ].state = { 3, 2, 4, 3 }; --текущая картинка в каждом квадрате
  
end;
-----------------------------------------------------------------------------------
function public.zz_policecar.Reset()
  
  local need_r = false;

  for i = 1, 4, 1 do

    if (private.zz_policecar.state[i] ~= private.zz_policecar.start[i]) then

      if not need_r then
        need_r = true;
      end;

      ObjAnimate("spr_policecar_game_lily_"..i.."_"..private.zz_policecar.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_policecar_game_lily_"..i.."_"..private.zz_policecar.start[i], "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });

    end;

  end;

  if need_r then

    cmn.Lock(1);
    cmn.PlayAudio( "snd", "assets/levels/level2/mg_invendingmachine/audio/aud_xx_button2");
    
    private.zz_policecar.StartConditions();
    private.zz_policecar.state = ng_global.progress[ ng_global.currentprogress ][ "win_policecar" ].state;
    
    ObjSet("tmr_policecar_game_timer", { playing = 1, time = 0.5, endtrig = function() cmn.Lock(0); end });

  end; 
  
end;
-----------------------------------------------------------------------------------
function public.zz_policecar.Skip()
  
  cmn.Lock(1);
  cmn.PlayAudio( "snd", "assets/levels/level2/mg_invendingmachine/audio/aud_xx_button2");
  
  ng_global.progress[ ng_global.currentprogress ][ "win_policecar" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_policecar" ].state = { 1, 1, 1, 1 };
  
  for i = 1, 4, 1 do

    if (private.zz_policecar.state[i] ~= 1) then

      if not need_r then
        need_r = true;
      end;

      ObjAnimate("spr_policecar_game_lily_"..i.."_"..private.zz_policecar.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_policecar_game_lily_"..i.."_1", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });

    end;

  end;
  
  private.zz_policecar.state = ng_global.progress[ ng_global.currentprogress ][ "win_policecar" ].state;
    
  ObjSet("tmr_policecar_game_timer", { playing = 1, time = 0.5, endtrig = private.zz_policecar.CheckWin });
  
end;
-----------------------------------------------------------------------------------
function private.zz_policecar.DrawScene()
  
  for i = 1, 4, 1 do

    ObjSet("spr_policecar_game_lily_"..i.."_"..private.zz_policecar.state[i], { alp = 1 });

  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_policecar.FocusButton( num, inout )
  
  local obj = "spr_policecar_game_button_"..num.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_menter1");
    end;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-------------------------------------------------------------------------------
function public.zz_policecar.ClkButton( but )

  cmn.Lock(1);
  local old;

  cmn.PlayAudio( "snd", "assets/levels/level2/mg_invendingmachine/audio/aud_xx_button2");

  --поворачиваем картинки
  for i = 1, 2, 1 do

    old = private.zz_policecar.state[ private.zz_policecar.change[but][i] ];
    private.zz_policecar.state[ private.zz_policecar.change[but][i] ] = private.zz_policecar.state[ private.zz_policecar.change[but][i] ] + 1;

    if private.zz_policecar.state[ private.zz_policecar.change[but][i] ] == 5 then
      private.zz_policecar.state[ private.zz_policecar.change[but][i] ] = 1;
    end;

    ObjAnimate("spr_policecar_game_lily_"..private.zz_policecar.change[but][i].."_"..old, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    ObjAnimate("spr_policecar_game_lily_"..private.zz_policecar.change[but][i].."_"..private.zz_policecar.state[ private.zz_policecar.change[but][i] ], "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });

  end;

  ObjAnimate("spr_policecar_game_button_"..but, "alp", 0, 0, private.zz_policecar.CheckWin, { 0, 0, 1,  0.25, 0, 0,   0.5, 0, 1 });

end;
-----------------------------------------------------------------------------------
function private.zz_policecar.CheckWin()
  
  local win_flag = true;
  
  for i = 1, 4, 1 do

    if private.zz_policecar.state[i] ~= 1 then
      win_flag = false;
      break;
    end;

  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("policecar");
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/rm_street/audio/aud_xx_opn_wallet");
      
      ObjAnimate("anm_policecar_wallet_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("obj_policecar_wallet_open", "alp", 0, 0, private.zz_policecar.Win, { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
    ObjAnimate("obj_policecar_game", "alp", 0, 0, anm_open, { 0, 0, 1,   1, 0, 1,   1.5, 0, 0 });
    
  else 
    
    cmn.Lock( 0 );
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_policecar.Win()
  
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_policecar" );
  cmn.CallEventHandler( "win_policecar" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_policecar" ].skip == 0 and ng_global.noskipgames[ "win_policecar" ] == nil then

    ng_global.noskipgames[ "win_policecar" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

  cmn.Lock( 0 );
  
end;
--*********************************************************************************************************************
