-- name=rm_witchhouse
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_witchhouse";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Table();
  private.Init_Gardendoor();
  --------------------------------------------------------------------------------------------
  -- function get_petal1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_petal1" ] = {
        type = "get",
        get_obj = "spr_fireplace_petal1",
        room = private.room_objname,
        zz = "zz_fireplace",
        zz_gate = "gzz_witchhouse_fireplace"
    };
    --------------------------------------------------------------------------------------------
  local get_petal1_inv = function ()
  
    interface.InventoryItemAdd( "inv_petal", "spr_fireplace_petal1", function () cmn.GetMultyObject( 'petal', 3 ); end );
  
  end;
  
  local get_petal1_end = function ()
  
    ObjDelete( "gfx_fireplace_petal1" );
    ObjDelete( "spr_fireplace_petal1_shadow" );
    
    ObjDelete( "spr_witchhouse_fireplace_petal" );
  
  end;
  
  cmn.AddSubscriber( "get_petal1", get_petal1_inv );
  cmn.AddSubscriber( "get_petal1", get_petal1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hotrod () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_hotrod" ] = {
        type = "get",
        get_obj = "obj_fireplace_hotrod",
        room = private.room_objname,
        zz = "zz_fireplace",
        zz_gate = "gzz_witchhouse_fireplace"
    };
    --------------------------------------------------------------------------------------------
  local get_hotrod_inv = function ()
  
    interface.InventoryItemAdd( "inv_hotrod", "obj_fireplace_hotrod" );
  
  end;
  
  local get_hotrod_end = function ()
  
    ObjDelete( "gfx_fireplace_hotrod" );
    ObjDelete( "spr_witchhouse_fireplace_hotrod" );
  
  end;
  
  cmn.AddSubscriber( "get_hotrod", get_hotrod_inv );
  cmn.AddSubscriber( "get_hotrod", get_hotrod_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crystalwater () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_crystalwater" ] = {
        type = "get",
        get_obj = "spr_fireplace_crystalwater",
        room = private.room_objname,
        zz = "zz_fireplace",
        zz_gate = "gzz_witchhouse_fireplace"
    };
    --------------------------------------------------------------------------------------------
  local get_crystalwater_inv = function ()
  
    interface.InventoryItemAdd( "inv_crystalwater", "spr_fireplace_crystalwater" );
  
  end;
  
  local get_crystalwater_end = function ()
  
    ObjDelete( "spr_witchhouse_fireplace_water_1" );
    ObjSet("spr_witchhouse_fireplace_water_2",  { alp = 1 });
    
  end;
  
  cmn.AddSubscriber( "get_crystalwater", get_crystalwater_inv );
  cmn.AddSubscriber( "get_crystalwater", get_crystalwater_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cauldronwtihfertilizer () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_cauldronwtihfertilizer" ] = {
        type = "get",
        get_obj = "obj_fireplace_bowler",
        room = private.room_objname,
        zz = "zz_fireplace",
        zz_gate = "gzz_witchhouse_fireplace"
    };
    --------------------------------------------------------------------------------------------
  local get_cauldronwtihfertilizer_inv = function ()
  
    interface.InventoryItemAdd( "inv_cauldronwtihfertilizer", "obj_fireplace_bowler" );
  
  end;
  
  local get_cauldronwtihfertilizer_end = function ()
  
    ObjDelete( "gfx_fireplace_cauldronwtihfertilizer" );
    ObjDelete( "spr_fireplace_shadow_bowler" );
    
    ObjDelete( "gzz_witchhouse_fireplace" );
    ObjDelete( "spr_witchhouse_fireplace_cauldron" );
  
  end;
  
  cmn.AddSubscriber( "get_cauldronwtihfertilizer", get_cauldronwtihfertilizer_inv );
  cmn.AddSubscriber( "get_cauldronwtihfertilizer", get_cauldronwtihfertilizer_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl3scarf () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_lvl3scarf" ] = {
        type = "get",
        get_obj = "spr_gardendoor_lvl3scarf",
        room = private.room_objname,
        zz = "zz_gardendoor",
        zz_gate = "gzz_witchhouse_gardendoor"
    };
    --------------------------------------------------------------------------------------------
  local get_lvl3scarf_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl3scarf", "spr_gardendoor_lvl3scarf" );
  
  end;
  
  local get_lvl3scarf_end = function ()
  
    ObjDelete( "gfx_gardendoor_lvl3scarf" );
    ObjDelete( "spr_gardendoor_lvl3scarf_sh" );
    
    ObjDelete( "spr_witchhouse_door_scarf" );
  
  end;
  
  cmn.AddSubscriber( "get_lvl3scarf", get_lvl3scarf_inv );
  cmn.AddSubscriber( "get_lvl3scarf", get_lvl3scarf_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magicfertilizer () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_magicfertilizer" ] = {
        type = "get",
        get_obj = "spr_shelves_magicfertilizer",
        room = private.room_objname,
        zz = "zz_shelves",
        zz_gate = "gzz_witchhouse_shelves"
    };
    --------------------------------------------------------------------------------------------
  local get_magicfertilizer_inv = function ()
  
    interface.InventoryItemAdd( "inv_magicfertilizer", "spr_shelves_magicfertilizer" );
  
  end;
  
  local get_magicfertilizer_end = function ()
  
    ObjDelete( "gfx_shelves_magicfertilizer" );
    ObjDelete( "spr_shelves_magicfertilizer_shadow" );
    
    ObjDelete( "spr_witchhouse_shelves_fertilizer" );

    if ( private.IfShelvesAllItemGet() ) then
      ObjSet("gzz_witchhouse_shelves",  { alp = 0, active = 0 });
    end;

  end;
  
  cmn.AddSubscriber( "get_magicfertilizer", get_magicfertilizer_inv );
  cmn.AddSubscriber( "get_magicfertilizer", get_magicfertilizer_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_petal2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_petal2" ] = {
        type = "get",
        get_obj = "spr_shelves_petal2",
        room = private.room_objname,
        zz = "zz_shelves",
        zz_gate = "gzz_witchhouse_shelves"
    };
    --------------------------------------------------------------------------------------------
  local get_petal2_inv = function ()
  
    interface.InventoryItemAdd( "inv_petal", "spr_shelves_petal2", function () cmn.GetMultyObject( 'petal', 3 ); end );
  
  end;
  
  local get_petal2_end = function ()
  
    ObjDelete( "gfx_shelves_petal2" );
    ObjDelete( "spr_shelves_petal2_shadow" );
    
    ObjDelete( "spr_witchhouse_shelves_petal" );
  
  end;
  
  cmn.AddSubscriber( "get_petal2", get_petal2_inv );
  cmn.AddSubscriber( "get_petal2", get_petal2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sharpeningstone () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_sharpeningstone" ] = {
        type = "get",
        get_obj = "spr_shelves_sharpeningstone",
        room = private.room_objname,
        zz = "zz_shelves",
        zz_gate = "gzz_witchhouse_shelves"
    };
    --------------------------------------------------------------------------------------------
  local get_sharpeningstone_inv = function ()
  
    interface.InventoryItemAdd( "inv_sharpeningstone", "spr_shelves_sharpeningstone" );
    ObjSet("inv_oldpruners_star_light",  { alp = 1 });
  
  end;
  
  local get_sharpeningstone_end = function ()
  
    ObjDelete( "gfx_shelves_sharpeningstone" );
    ObjDelete( "spr_shelves_sharpeningstone_shadow" );
    
    ObjDelete( "spr_witchhouse_shelves_stone" );
  
  end;
  
  cmn.AddSubscriber( "get_sharpeningstone", get_sharpeningstone_inv );
  cmn.AddSubscriber( "get_sharpeningstone", get_sharpeningstone_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bluntblade () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_bluntblade" ] = {
        type = "get",
        get_obj = "spr_shelves_bluntblade",
        room = private.room_objname,
        zz = "zz_shelves",
        zz_gate = "gzz_witchhouse_shelves"
    };
    --------------------------------------------------------------------------------------------
  local get_bluntblade_inv = function ()
  
    interface.InventoryItemAdd( "inv_bluntblade", "spr_shelves_bluntblade" );
    ObjSet("inv_oldpruners_star_light",  { alp = 1 });
  
  end;
  
  local get_bluntblade_end = function ()
  
    ObjDelete( "gfx_shelves_bluntblade" );
    ObjDelete( "spr_shelves_bluntblade_shadow" );
    
    ObjDelete( "spr_witchhouse_shelves_blade" );

    if ( private.IfShelvesAllItemGet() ) then
      ObjSet("gzz_witchhouse_shelves",  { alp = 0, active = 0 });
    end;

  end;
  
  cmn.AddSubscriber( "get_bluntblade", get_bluntblade_inv );
  cmn.AddSubscriber( "get_bluntblade", get_bluntblade_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_moonblossomhoney () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_moonblossomhoney" ] = {
        type = "get",
        get_obj = "spr_shelves_moonblossomhoney",
        room = private.room_objname,
        zz = "zz_shelves",
        zz_gate = "gzz_witchhouse_shelves"
    };
    --------------------------------------------------------------------------------------------
  local get_moonblossomhoney_inv = function ()
  
    interface.InventoryItemAdd( "inv_moonblossomhoney", "spr_shelves_moonblossomhoney" );
  
  end;
  
  local get_moonblossomhoney_end = function ()
  
    ObjDelete( "gfx_shelves_moonblossomhoney" );
    ObjDelete( "spr_shelves_moonblossomhoney_shadow" );
    
    ObjDelete( "spr_witchhouse_shelves_honey" );

    if ( private.IfShelvesAllItemGet() ) then
      ObjSet("gzz_witchhouse_shelves",  { alp = 0, active = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_moonblossomhoney", get_moonblossomhoney_inv );
  cmn.AddSubscriber( "get_moonblossomhoney", get_moonblossomhoney_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_runescoop () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_runescoop" ] = {
        type = "get",
        get_obj = "spr_shelves_runescoop",
        room = private.room_objname,
        zz = "zz_shelves",
        zz_gate = "gzz_witchhouse_shelves"
    };
    --------------------------------------------------------------------------------------------
  local get_runescoop_inv = function ()
  
    interface.InventoryItemAdd( "inv_runescoop", "spr_shelves_runescoop" );
  
  end;
  
  local get_runescoop_end = function ()
  
    ObjDelete( "gfx_shelves_runescoop" );
    ObjDelete( "spr_shelves_runescoop_shadow" );
    
    ObjDelete( "spr_witchhouse_shelves_scoop" );

    if ( private.IfShelvesAllItemGet() ) then
      ObjSet("gzz_witchhouse_shelves",  { alp = 0, active = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_runescoop", get_runescoop_inv );
  cmn.AddSubscriber( "get_runescoop", get_runescoop_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_basreliefpart1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_basreliefpart1" ] = {
        type = "get",
        get_obj = "spr_shelves_basreliefpart1",
        room = private.room_objname,
        zz = "zz_shelves",
        zz_gate = "gzz_witchhouse_shelves"
    };
    --------------------------------------------------------------------------------------------
  local get_basreliefpart1_inv = function ()
  
    interface.InventoryItemAdd( "inv_basreliefpart", "spr_shelves_basreliefpart1", function () cmn.GetMultyObject( 'basreliefpart', 2 ); end );
  
  end;
  
  local get_basreliefpart1_end = function ()
  
    ObjDelete( "gfx_shelves_basreliefpart1" );
    ObjDelete( "spr_shelves_basreliefpart1_shadow" );
    
    ObjDelete( "spr_witchhouse_shelves_basrelief" );

    if ( private.IfShelvesAllItemGet() ) then
      ObjSet("gzz_witchhouse_shelves",  { alp = 0, active = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_basreliefpart1", get_basreliefpart1_inv );
  cmn.AddSubscriber( "get_basreliefpart1", get_basreliefpart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_teleportamulet () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_teleportamulet" ] = {
        type = "get",
        get_obj = "obj_table_amulet",
        room = private.room_objname,
        zz = "zz_table",
        zz_gate = "gzz_witchhouse_table"
    };
    --------------------------------------------------------------------------------------------
  local get_teleportamulet_inv = function ()
  
    interface.InventoryItemAdd( "inv_teleportamulet", "obj_table_amulet" );
  
  end;
  
  local get_teleportamulet_end = function ()
  
    ObjDelete( "gfx_table_teleportamulet" );
    
    ObjDelete( "spr_witchhouse_table_amulet" );
    ObjDelete( "gzz_witchhouse_table" );
  
  end;
  
  cmn.AddSubscriber( "get_teleportamulet", get_teleportamulet_inv );
  cmn.AddSubscriber( "get_teleportamulet", get_teleportamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_petal3 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_petal3" ] = {
        type = "get",
        get_obj = "spr_table_petal3",
        room = private.room_objname,
        zz = "zz_table",
        zz_gate = "gzz_witchhouse_table"
    };
    --------------------------------------------------------------------------------------------
  local get_petal3_inv = function ()
  
    interface.InventoryItemAdd( "inv_petal", "spr_table_petal3", function () cmn.GetMultyObject( 'petal', 3 ); end );
  
  end;
  
  local get_petal3_end = function ()
  
    ObjDelete( "gfx_table_petal3" );
    ObjDelete( "spr_table_petal3_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_petal3", get_petal3_inv );
  cmn.AddSubscriber( "get_petal3", get_petal3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_swanbowl () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_swanbowl" ] = {
        type = "get",
        get_obj = "spr_cupboard_swanbowl",
        room = private.room_objname,
        zz = "zz_cupboard",
        zz_gate = "gzz_witchhouse_cupboard"
    };
    --------------------------------------------------------------------------------------------
  local get_swanbowl_inv = function ()
  
    interface.InventoryItemAdd( "inv_swanbowl", "spr_cupboard_swanbowl" );
  
  end;
  
  local get_swanbowl_end = function ()
  
    ObjDelete( "gfx_cupboard_swanbowl" );
    ObjDelete( "spr_cupboard_swanbowl_shadow" );
    
    ObjDelete( "spr_witchhouse_cupboard_swan" );
  
  end;
  
  cmn.AddSubscriber( "get_swanbowl", get_swanbowl_inv );
  cmn.AddSubscriber( "get_swanbowl", get_swanbowl_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_copperfeather1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_copperfeather1" ] = {
        type = "get",
        get_obj = "spr_cupboard_copperfeather1",
        room = private.room_objname,
        zz = "zz_cupboard",
        zz_gate = "gzz_witchhouse_cupboard"
    };
    --------------------------------------------------------------------------------------------
  local get_copperfeather1_inv = function ()
  
    interface.InventoryItemAdd( "inv_copperfeather", "spr_cupboard_copperfeather1", function () cmn.GetMultyObject( 'copperfeather', 2 ); end );
  
  end;
  
  local get_copperfeather1_end = function ()
  
    ObjDelete( "gfx_cupboard_copperfeather1" );
    ObjDelete( "spr_cupboard_feather_shadow" );
    
    ObjDelete( "spr_witchhouse_cupboard_feather" );
  
  end;
  
  cmn.AddSubscriber( "get_copperfeather1", get_copperfeather1_inv );
  cmn.AddSubscriber( "get_copperfeather1", get_copperfeather1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_applecutter () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_applecutter" ] = {
        type = "get",
        get_obj = "spr_cupboard_applecutter",
        room = private.room_objname,
        zz = "zz_cupboard",
        zz_gate = "gzz_witchhouse_cupboard"
    };
    --------------------------------------------------------------------------------------------
  local get_applecutter_inv = function ()
  
    interface.InventoryItemAdd( "inv_applecutter", "spr_cupboard_applecutter" );
    ObjSet("inv_juicyapple_star_light",  { alp = 1 });
  
  end;
  
  local get_applecutter_end = function ()
  
    ObjDelete( "gfx_cupboard_applecutter" );
    ObjDelete( "spr_cupboard_applecutter_shadow" );
    
    ObjDelete( "spr_witchhouse_cupboard_applecutter" );
  
  end;
  
  cmn.AddSubscriber( "get_applecutter", get_applecutter_inv );
  cmn.AddSubscriber( "get_applecutter", get_applecutter_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletknot () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_amuletknot" ] = {
        type = "get",
        get_obj = "spr_cupboard_amuletknot",
        room = private.room_objname,
        zz = "zz_cupboard",
        zz_gate = "gzz_witchhouse_cupboard"
    };
    --------------------------------------------------------------------------------------------
  local get_amuletknot_inv = function ()
  
    int_map_impl.DecreaseRoomTasks("rm_witchhouse");
    interface.InventoryItemAdd( "inv_amuletknot", "spr_cupboard_amuletknot" );
    ObjSet("inv_casket_star_light",  { alp = 1 });
  
  end;
  
  local get_amuletknot_end = function ()
  
    ObjDelete( "gfx_cupboard_amuletknot" );
    
    ObjDelete( "spr_witchhouse_cupboard_amulet" );
    ObjDelete( "gzz_witchhouse_cupboard" );
  
  end;
  
  cmn.AddSubscriber( "get_amuletknot", get_amuletknot_inv );
  cmn.AddSubscriber( "get_amuletknot", get_amuletknot_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_lvl3scarf () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_lvl3scarf" ] = {
        type = "use",
        inv_obj = "inv_lvl3scarf",
        use_place = "obj_fireplace_use_lvl3scarf",
        room = private.room_objname,
        zz = "zz_fireplace",
        zz_gate = "gzz_witchhouse_fireplace"
    };
  --------------------------------------------------------------------------------------------
  local use_lvl3scarf_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl3scarf" );
  
  end;
  local use_lvl3scarf_beg = function ()
  
    ObjDelete( "obj_fireplace_use_lvl3scarf" );
  
  end;
  local use_lvl3scarf_end = function ()
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl3scarf", use_lvl3scarf_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3scarf", use_lvl3scarf_inv );
  cmn.AddSubscriber( "use_lvl3scarf", use_lvl3scarf_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl3scarf_inv", use_lvl3scarf_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl3scarf_beg", use_lvl3scarf_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3scarf_end", use_lvl3scarf_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_swanbowl () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_swanbowl" ] = {
        type = "use",
        inv_obj = "inv_swanbowl",
        use_place = "obj_fireplace_use_swanbowl",
        room = private.room_objname,
        zz = "zz_fireplace",
        zz_gate = "gzz_witchhouse_fireplace"
    };
  --------------------------------------------------------------------------------------------
  local use_swanbowl_inv = function ()
  
    interface.InventoryItemRemove( "inv_swanbowl" );
  
  end;
  local use_swanbowl_beg = function ()
  
    ObjDelete( "obj_fireplace_use_swanbowl" );
  
  end;
  local use_swanbowl_end = function ()

    ObjMultiSet( { { "anm_fireplace_bowler", { frame = 72 } },
                   { "obj_fireplace_use_magicfertilizer", { input = true } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_swanbowl", use_swanbowl_beg, private.room_objname );
  cmn.AddSubscriber( "use_swanbowl", use_swanbowl_inv );
  cmn.AddSubscriber( "use_swanbowl", use_swanbowl_end, private.room_objname );
  cmn.AddSubscriber( "use_swanbowl_inv", use_swanbowl_inv, private.room_objname );
  cmn.AddSubscriber( "use_swanbowl_beg", use_swanbowl_beg, private.room_objname );
  cmn.AddSubscriber( "use_swanbowl_end", use_swanbowl_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magicfertilizer () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_magicfertilizer" ] = {
        type = "use",
        inv_obj = "inv_magicfertilizer",
        use_place = "obj_fireplace_use_magicfertilizer",
        room = private.room_objname,
        zz = "zz_fireplace",
        zz_gate = "gzz_witchhouse_fireplace"
    };
  --------------------------------------------------------------------------------------------
  local use_magicfertilizer_inv = function ()
  
    interface.InventoryItemRemove( "inv_magicfertilizer" );
  
  end;
  local use_magicfertilizer_beg = function ()
  
    ObjDelete( "obj_fireplace_use_magicfertilizer" );
  
  end;
  local use_magicfertilizer_end = function ()
    
    ObjDelete( "spr_witchhouse_fireplace_water_2" );
  
    ObjMultiSet( { { "anm_fireplace_bowler", { animfunc = "func_use_bottle", frame = 210 } },
                   { "obj_fireplace_bowler", { input = true } },
                   { "gfx_fireplace_cauldronwtihfertilizer", { active = true } },
                   { "spr_witchhouse_fireplace_water_3", { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magicfertilizer", use_magicfertilizer_beg, private.room_objname );
  cmn.AddSubscriber( "use_magicfertilizer", use_magicfertilizer_inv );
  cmn.AddSubscriber( "use_magicfertilizer", use_magicfertilizer_end, private.room_objname );
  cmn.AddSubscriber( "use_magicfertilizer_inv", use_magicfertilizer_inv, private.room_objname );
  cmn.AddSubscriber( "use_magicfertilizer_beg", use_magicfertilizer_beg, private.room_objname );
  cmn.AddSubscriber( "use_magicfertilizer_end", use_magicfertilizer_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_petal () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_petal" ] = {
        type = "use",
        inv_obj = "inv_petal",
        use_place = "obj_gardendoor_use_petal",
        room = private.room_objname,
        zz = "zz_gardendoor",
        zz_gate = "gzz_witchhouse_gardendoor"
    };
  --------------------------------------------------------------------------------------------
  local use_petal_inv = function ()
  
    interface.InventoryItemRemove( "inv_petal" );
  
  end;
  local use_petal_beg = function ()
  
    ObjDelete( "obj_gardendoor_use_petal" );
  
  end;
  local use_petal_end = function ()
    
    ObjDelete( "anm_gardendoor_door_touch" );
    ObjDelete( "spr_witchhouse_door_closed" );

    ObjMultiSet( { {"obj_gardendoor_game", { input = 1 }},
                   {"obj_gardendoor_back", { pos_x = -54, pos_y = -15, scale_x = 1.05, scale_y = 1.05 }},
                   { "spr_witchhouse_door_game", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_petal", use_petal_beg, private.room_objname );
  cmn.AddSubscriber( "use_petal", use_petal_inv );
  cmn.AddSubscriber( "use_petal", use_petal_end, private.room_objname );
  cmn.AddSubscriber( "use_petal_inv", use_petal_inv, private.room_objname );
  cmn.AddSubscriber( "use_petal_beg", use_petal_beg, private.room_objname );
  cmn.AddSubscriber( "use_petal_end", use_petal_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl3bearfigurine () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_lvl3bearfigurine" ] = {
        type = "use",
        inv_obj = "inv_lvl3bearfigurine",
        use_place = "obj_shelves_use_lvl3bearfigurine",
        room = private.room_objname,
        zz = "zz_shelves",
        zz_gate = "gzz_witchhouse_shelves"
    };
  --------------------------------------------------------------------------------------------
  local use_lvl3bearfigurine_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl3bearfigurine" );
  
  end;
  local use_lvl3bearfigurine_beg = function ()
  
    ObjDelete( "obj_shelves_use_lvl3bearfigurine" );
  
  end;
  local use_lvl3bearfigurine_end = function ()

    ObjDelete( "anm_shelves_bearshelves" );
  
    ObjMultiSet( { { "spr_shelves_petal2", { input = true } },
                   { "spr_shelves_sharpeningstone", { input = true } },
                   { "spr_shelves_bearfigurine_shadow", { alp = 1 } },
                   { "spr_shelves_bearfigurine", { alp = 1 } },
                   { "spr_shelves_bearfshelves_opn_shadow", { alp = 1 } },
                   { "obj_shelves_bearshelves", { alp = 1 } },
                   { "spr_witchhouse_shelves_bear", { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl3bearfigurine", use_lvl3bearfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3bearfigurine", use_lvl3bearfigurine_inv );
  cmn.AddSubscriber( "use_lvl3bearfigurine", use_lvl3bearfigurine_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl3bearfigurine_inv", use_lvl3bearfigurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl3bearfigurine_beg", use_lvl3bearfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3bearfigurine_end", use_lvl3bearfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wolffigurine () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_wolffigurine" ] = {
        type = "use",
        inv_obj = "inv_wolffigurine",
        use_place = "obj_shelves_use_wolffigurine",
        room = private.room_objname,
        zz = "zz_shelves",
        zz_gate = "gzz_witchhouse_shelves"
    };
  --------------------------------------------------------------------------------------------
  local use_wolffigurine_inv = function ()
  
    interface.InventoryItemRemove( "inv_wolffigurine" );
  
  end;
  local use_wolffigurine_beg = function ()
  
    ObjDelete( "obj_shelves_use_wolffigurine" );
  
  end;
  local use_wolffigurine_end = function ()

    ObjDelete( "anm_shelves_wolfshelves" );
  
    ObjMultiSet( { { "spr_shelves_bluntblade", { input = true } },
                   { "spr_shelves_moonblossomhoney", { input = true } },
                   { "spr_shelves_wolffigurine_shadow", { alp = 1 } },
                   { "spr_shelves_wolffigurine", { alp = 1 } },
                   { "spr_shelves_wolfrshelves_opn_shadow", { alp = 1 } },
                   { "obj_shelves_wolfrshelves", { alp = 1 } },
                   { "spr_witchhouse_shelves_wolf", { alp = 1 } } } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wolffigurine", use_wolffigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_wolffigurine", use_wolffigurine_inv );
  cmn.AddSubscriber( "use_wolffigurine", use_wolffigurine_end, private.room_objname );
  cmn.AddSubscriber( "use_wolffigurine_inv", use_wolffigurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_wolffigurine_beg", use_wolffigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_wolffigurine_end", use_wolffigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_foxfigurine () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_foxfigurine" ] = {
        type = "use",
        inv_obj = "inv_foxfigurine",
        use_place = "obj_shelves_use_foxfigurine",
        room = private.room_objname,
        zz = "zz_shelves",
        zz_gate = "gzz_witchhouse_shelves"
    };
  --------------------------------------------------------------------------------------------
  local use_foxfigurine_inv = function ()
  
    interface.InventoryItemRemove( "inv_foxfigurine" );
  
  end;
  local use_foxfigurine_beg = function ()
  
    ObjDelete( "obj_shelves_use_foxfigurine" );
  
  end;
  local use_foxfigurine_end = function ()

    ObjDelete( "anm_shelves_foxshelves" );
  
    ObjMultiSet( { { "spr_shelves_magicfertilizer", { input = true } },
                   { "spr_shelves_runescoop", { input = true } },
                   { "spr_shelves_basreliefpart1", { input = true } },
                   { "spr_shelves_foxfigurine_shadow", { alp = 1 } },
                   { "spr_shelves_foxfigurine", { alp = 1 } },
                   { "spr_shelves_foxshelves_opn_shadow", { alp = 1 } },
                   { "obj_shelves_foxshelves", { alp = 1 } },
                   { "spr_witchhouse_shelves_fox", { alp = 1 } } } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_foxfigurine", use_foxfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_foxfigurine", use_foxfigurine_inv );
  cmn.AddSubscriber( "use_foxfigurine", use_foxfigurine_end, private.room_objname );
  cmn.AddSubscriber( "use_foxfigurine_inv", use_foxfigurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_foxfigurine_beg", use_foxfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_foxfigurine_end", use_foxfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hotrod () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_hotrod" ] = {
        type = "use",
        inv_obj = "inv_hotrod",
        use_place = "obj_table_use_hotrod",
        room = private.room_objname,
        zz = "zz_table",
        zz_gate = "gzz_witchhouse_table"
    };
  --------------------------------------------------------------------------------------------
  local use_hotrod_inv = function ()
  
    interface.InventoryItemRemove( "inv_hotrod" );
  
  end;
  local use_hotrod_beg = function ()
  
    ObjDelete( "obj_table_use_hotrod" );
  
  end;
  local use_hotrod_end = function ()
    
    ObjDelete( "spr_witchhouse_table_drawer_closed" );
  
    ObjMultiSet( { { "anm_table_shelf", { animfunc = "func_open_shelf", frame = 49 } },
                   { "spr_table_petal3", { input = true } },
                   { "spr_witchhouse_table_drawer_open", { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hotrod", use_hotrod_beg, private.room_objname );
  cmn.AddSubscriber( "use_hotrod", use_hotrod_inv );
  cmn.AddSubscriber( "use_hotrod", use_hotrod_end, private.room_objname );
  cmn.AddSubscriber( "use_hotrod_inv", use_hotrod_inv, private.room_objname );
  cmn.AddSubscriber( "use_hotrod_beg", use_hotrod_beg, private.room_objname );
  cmn.AddSubscriber( "use_hotrod_end", use_hotrod_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crystalwater () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_crystalwater" ] = {
        type = "use",
        inv_obj = "inv_crystalwater",
        use_place = "obj_table_use_crystalwater",
        room = private.room_objname,
        zz = "zz_table",
        zz_gate = "gzz_witchhouse_table"
    };
  --------------------------------------------------------------------------------------------
  local use_crystalwater_inv = function ()
  
    interface.InventoryItemRemove( "inv_crystalwater" );
  
  end;
  local use_crystalwater_beg = function ()
  
    ObjDelete( "obj_table_use_crystalwater" );
  
  end;
  local use_crystalwater_end = function ()

    ObjMultiSet( { { "spr_table_bottle", { alp = 1 } },
                   { "spr_table_bottle_shadow", { alp = 1 } },
                   { "spr_witchhouse_table_bottle", { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crystalwater", use_crystalwater_beg, private.room_objname );
  cmn.AddSubscriber( "use_crystalwater", use_crystalwater_inv );
  cmn.AddSubscriber( "use_crystalwater", use_crystalwater_end, private.room_objname );
  cmn.AddSubscriber( "use_crystalwater_inv", use_crystalwater_inv, private.room_objname );
  cmn.AddSubscriber( "use_crystalwater_beg", use_crystalwater_beg, private.room_objname );
  cmn.AddSubscriber( "use_crystalwater_end", use_crystalwater_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_moonblossomhoney () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_moonblossomhoney" ] = {
        type = "use",
        inv_obj = "inv_moonblossomhoney",
        use_place = "obj_table_use_moonblossomhoney",
        room = private.room_objname,
        zz = "zz_table",
        zz_gate = "gzz_witchhouse_table"
    };
  --------------------------------------------------------------------------------------------
  local use_moonblossomhoney_inv = function ()
  
    interface.InventoryItemRemove( "inv_moonblossomhoney" );
  
  end;
  local use_moonblossomhoney_beg = function ()
  
    ObjDelete( "obj_table_use_moonblossomhoney" );
  
  end;
  local use_moonblossomhoney_end = function ()

    ObjMultiSet( { { "anm_table_jar", { alp = 1 } },
                   { "spr_witchhouse_table_honey", { alp = 1 } },
                   { "spr_witchhouse_table_honey_jar", { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_moonblossomhoney", use_moonblossomhoney_beg, private.room_objname );
  cmn.AddSubscriber( "use_moonblossomhoney", use_moonblossomhoney_inv );
  cmn.AddSubscriber( "use_moonblossomhoney", use_moonblossomhoney_end, private.room_objname );
  cmn.AddSubscriber( "use_moonblossomhoney_inv", use_moonblossomhoney_inv, private.room_objname );
  cmn.AddSubscriber( "use_moonblossomhoney_beg", use_moonblossomhoney_beg, private.room_objname );
  cmn.AddSubscriber( "use_moonblossomhoney_end", use_moonblossomhoney_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magicamuletrecipe () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_magicamuletrecipe" ] = {
        type = "use",
        inv_obj = "inv_magicamuletrecipe",
        use_place = "obj_table_use_magicamuletrecipe",
        room = private.room_objname,
        zz = "zz_table",
        zz_gate = "gzz_witchhouse_table"
    };
  --------------------------------------------------------------------------------------------
  local use_magicamuletrecipe_inv = function ()
  
    interface.InventoryItemRemove( "inv_magicamuletrecipe" );
  
  end;
  local use_magicamuletrecipe_beg = function ()
  
    ObjDelete( "obj_table_use_magicamuletrecipe" );
  
  end;
  local use_magicamuletrecipe_end = function ()

    ObjMultiSet( { {"spr_table_paper_small", { alp = 1, input = true } },
                   {"spr_witchhouse_table_recipe", { alp = 1 } } } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magicamuletrecipe", use_magicamuletrecipe_beg, private.room_objname );
  cmn.AddSubscriber( "use_magicamuletrecipe", use_magicamuletrecipe_inv );
  cmn.AddSubscriber( "use_magicamuletrecipe", use_magicamuletrecipe_end, private.room_objname );
  cmn.AddSubscriber( "use_magicamuletrecipe_inv", use_magicamuletrecipe_inv, private.room_objname );
  cmn.AddSubscriber( "use_magicamuletrecipe_beg", use_magicamuletrecipe_beg, private.room_objname );
  cmn.AddSubscriber( "use_magicamuletrecipe_end", use_magicamuletrecipe_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fernflower () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_fernflower" ] = {
        type = "use",
        inv_obj = "inv_fernflower",
        use_place = "obj_table_use_fernflower",
        room = private.room_objname,
        zz = "zz_table",
        zz_gate = "gzz_witchhouse_table"
    };
  --------------------------------------------------------------------------------------------
  local use_fernflower_inv = function ()
  
    interface.InventoryItemRemove( "inv_fernflower" );
  
  end;
  local use_fernflower_beg = function ()
  
    ObjDelete( "obj_table_use_fernflower" );
  
  end;
  local use_fernflower_end = function ()

    ObjMultiSet( { { "spr_table_flower", { alp = 1 } },
                   { "spr_table_flower_shadow", { alp = 1 } },
                   { "spr_witchhouse_table_flower", { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fernflower", use_fernflower_beg, private.room_objname );
  cmn.AddSubscriber( "use_fernflower", use_fernflower_inv );
  cmn.AddSubscriber( "use_fernflower", use_fernflower_end, private.room_objname );
  cmn.AddSubscriber( "use_fernflower_inv", use_fernflower_inv, private.room_objname );
  cmn.AddSubscriber( "use_fernflower_beg", use_fernflower_beg, private.room_objname );
  cmn.AddSubscriber( "use_fernflower_end", use_fernflower_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pearl () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_pearl" ] = {
        type = "use",
        inv_obj = "inv_pearl",
        use_place = "obj_cupboard_use_pearl",
        room = private.room_objname,
        zz = "zz_cupboard",
        zz_gate = "gzz_witchhouse_cupboard"
    };
  --------------------------------------------------------------------------------------------
  local use_pearl_inv = function ()
  
    interface.InventoryItemRemove( "inv_pearl" );
  
  end;
  local use_pearl_beg = function ()
  
    ObjDelete( "obj_cupboard_use_pearl" );
  
  end;
  local use_pearl_end = function ()
  
    if ( cmn.IsEventDone( "use_shell" ) ) then

      ObjDelete( "anm_cupboard_door" );
      ObjDelete( "spr_witchhouse_cupboard_closed" );

      ObjMultiSet( { { "spr_cupboard_swanbowl", { input = true } },
                     { "spr_cupboard_copperfeather1", { input = true } },
                     { "spr_cupboard_applecutter", { input = true } },
                     { "obj_cupboard_use_pocketwatch", { input = true } },
                     { "obj_cupboard_use_pincenez", { input = true } },
                     { "obj_cupboard_paper_bbt", { input = true } },
                     { "obj_witchhouse_cupboard_open", { alp = 1 } } } );
                     
    else
      ObjSet("spr_witchhouse_cupboard_pearl",  { alp = 1 });
    end;

    ObjMultiSet( { { "obj_cupboard_use_shell", { inputrect_y = -216, inputrect_h = 512 } },
                   { "spr_cupboard_pearl", { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pearl", use_pearl_beg, private.room_objname );
  cmn.AddSubscriber( "use_pearl", use_pearl_inv );
  cmn.AddSubscriber( "use_pearl", use_pearl_end, private.room_objname );
  cmn.AddSubscriber( "use_pearl_inv", use_pearl_inv, private.room_objname );
  cmn.AddSubscriber( "use_pearl_beg", use_pearl_beg, private.room_objname );
  cmn.AddSubscriber( "use_pearl_end", use_pearl_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shell () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_shell" ] = {
        type = "use",
        inv_obj = "inv_shell",
        use_place = "obj_cupboard_use_shell",
        room = private.room_objname,
        zz = "zz_cupboard",
        zz_gate = "gzz_witchhouse_cupboard"
    };
  --------------------------------------------------------------------------------------------
  local use_shell_inv = function ()
  
    interface.InventoryItemRemove( "inv_shell" );
  
  end;
  local use_shell_beg = function ()
  
    ObjDelete( "obj_cupboard_use_shell" );
  
  end;
  local use_shell_end = function ()
  
    if ( cmn.IsEventDone( "use_pearl" ) ) then

      ObjDelete( "anm_cupboard_door" );
      ObjDelete( "spr_witchhouse_cupboard_closed" );

      ObjMultiSet( { { "spr_cupboard_swanbowl", { input = true } },
                     { "spr_cupboard_copperfeather1", { input = true } },
                     { "spr_cupboard_applecutter", { input = true } },
                     { "obj_cupboard_use_pocketwatch", { input = true } },
                     { "obj_cupboard_use_pincenez", { input = true } },
                     { "obj_cupboard_paper_bbt", { input = true } },
                     { "obj_witchhouse_cupboard_open", { alp = 1 } } } );

    else
      ObjSet("spr_witchhouse_cupboard_shell",  { alp = 1 });                 
    end;

    ObjSet( "spr_cupboard_seashell", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_shell", use_shell_beg, private.room_objname );
  cmn.AddSubscriber( "use_shell", use_shell_inv );
  cmn.AddSubscriber( "use_shell", use_shell_end, private.room_objname );
  cmn.AddSubscriber( "use_shell_inv", use_shell_inv, private.room_objname );
  cmn.AddSubscriber( "use_shell_beg", use_shell_beg, private.room_objname );
  cmn.AddSubscriber( "use_shell_end", use_shell_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pocketwatch () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_pocketwatch" ] = {
        type = "use",
        inv_obj = "inv_pocketwatch",
        use_place = "obj_cupboard_use_pocketwatch",
        room = private.room_objname,
        zz = "zz_cupboard",
        zz_gate = "gzz_witchhouse_cupboard"
    };
  --------------------------------------------------------------------------------------------
  local use_pocketwatch_inv = function ()
  
    interface.InventoryItemRemove( "inv_pocketwatch" );
  
  end;
  local use_pocketwatch_beg = function ()
  
    ObjDelete( "obj_cupboard_use_pocketwatch" );
  
  end;
  local use_pocketwatch_end = function ()
  
    if ( cmn.IsEventDone( "use_pincenez" ) ) then
      ObjMultiSet( { { "anm_cupboard_amuletknot", { frame = 54 } },
                     { "spr_cupboard_amuletknot", { input = true } },
                     {"spr_witchhouse_cupboard_paw", { alp = 1 }} } );
    end;

    ObjMultiSet( { {"spr_cupboard_clock", { alp = 1 }},
                   {"spr_witchhouse_cupboard_watch", { alp = 1 }} } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pocketwatch", use_pocketwatch_beg, private.room_objname );
  cmn.AddSubscriber( "use_pocketwatch", use_pocketwatch_inv );
  cmn.AddSubscriber( "use_pocketwatch", use_pocketwatch_end, private.room_objname );
  cmn.AddSubscriber( "use_pocketwatch_inv", use_pocketwatch_inv, private.room_objname );
  cmn.AddSubscriber( "use_pocketwatch_beg", use_pocketwatch_beg, private.room_objname );
  cmn.AddSubscriber( "use_pocketwatch_end", use_pocketwatch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pincenez () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_pincenez" ] = {
        type = "use",
        inv_obj = "inv_pincenez",
        use_place = "obj_cupboard_use_pincenez",
        room = private.room_objname,
        zz = "zz_cupboard",
        zz_gate = "gzz_witchhouse_cupboard"
    };
  --------------------------------------------------------------------------------------------
  local use_pincenez_inv = function ()
  
    interface.InventoryItemRemove( "inv_pincenez" );
  
  end;
  local use_pincenez_beg = function ()
  
    ObjDelete( "obj_cupboard_use_pincenez" );
  
  end;
  local use_pincenez_end = function ()
  
    if ( cmn.IsEventDone( "use_pocketwatch" ) ) then
      ObjMultiSet( { { "anm_cupboard_amuletknot", { frame = 54 } },
                     { "spr_cupboard_amuletknot", { input = true } },
                     {"spr_witchhouse_cupboard_paw", { alp = 1 }} } );
    end;

    ObjMultiSet( { { "spr_cupboard_pincenez_shadow", { alp = 1 } },
                   { "spr_cupboard_pincenez", { alp = 1 } },
                   { "spr_witchhouse_cupboard_glasses", { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pincenez", use_pincenez_beg, private.room_objname );
  cmn.AddSubscriber( "use_pincenez", use_pincenez_inv );
  cmn.AddSubscriber( "use_pincenez", use_pincenez_end, private.room_objname );
  cmn.AddSubscriber( "use_pincenez_inv", use_pincenez_inv, private.room_objname );
  cmn.AddSubscriber( "use_pincenez_beg", use_pincenez_beg, private.room_objname );
  cmn.AddSubscriber( "use_pincenez_end", use_pincenez_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function beg_level3 () end;
  --------------------------------------------------------------------------------------------
  local beg_level3 = function ()
  
    int_map_impl.OpenRoom( "rm_witchhouse" );
    
    interface.InventoryItemAdd( "inv_lvl3crystalshoe" );
    interface.InventoryItemAdd( "inv_lvl3cinderellapage" );
    interface.InventoryItemAdd( "inv_lvl3enchantedflute" );
    interface.InventoryItemAdd( "inv_token1" );
    interface.InventoryItemAdd( "inv_shell" );
    interface.InventoryItemAdd( "inv_lvl3bearfigurine" );
    interface.InventoryItemAdd( "inv_lvl3stetoscope" );
    interface.InventoryItemAdd( "inv_mermaidpage" );
    
    interface_impl.SetCurrentGlobalTask( 15 );
    common_impl.AddAvailibleMusic( 4 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "beg_level3", beg_level3 );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_table" );
  subroom.Define( "zz_gardendoor" );
  subroom.Define( "zz_shelves" );
  subroom.Define( "zz_fireplace" );

  function zz_table.PreOpen()
    if  cmn.IsEventDone( "use_magicamuletrecipe" ) and cmn.IsEventDone( "use_fernflower" )
    and cmn.IsEventDone( "use_moonblossomhoney" ) and cmn.IsEventDone( "use_crystalwater" ) and not cmn.IsEventDone( "win_table" ) then
      cmn.MiniGameShow();
      if ( private.zz_table.state.events.use_table_saucepan ) then  --форс квит во время последнего применения
        private.zz_table.Win();
      end;
    end;
    if  cmn.IsEventDone( "use_magicamuletrecipe" ) and cmn.IsEventDone( "use_fernflower" )
    and cmn.IsEventDone( "use_moonblossomhoney" ) and cmn.IsEventDone( "use_crystalwater" ) then
      private.zz_table.DrawScene();
    end;
  end;

  function zz_table.PreClose()
    if  cmn.IsEventDone( "use_magicamuletrecipe" ) and cmn.IsEventDone( "use_fernflower" )
    and cmn.IsEventDone( "use_moonblossomhoney" ) and cmn.IsEventDone( "use_crystalwater" ) and not cmn.IsEventDone( "win_table" ) then
      cmn.MiniGameHide("table");
    end;
  end;

  function zz_table.Close()
    cmn.HideNote( 0 );
  end;
  
  function zz_gardendoor.PreOpen()
    
    if not(cmn.IsEventDone( "win_gardendoor" )) then
      private.zz_gardendoor.DrawScene();
    end;

  end;
  
  function zz_gardendoor.Open()
    
    if cmn.IsEventDone( "use_petal" ) and not(cmn.IsEventDone( "win_gardendoor" )) then
      cmn.MiniGameShow();
      private.zz_gardendoor.CheckWin();
    end;

  end;

  function zz_gardendoor.PreClose()
    
    if ( cmn.IsEventDone( "use_petal" ) and not(cmn.IsEventDone( "win_gardendoor" )) ) then
      cmn.MiniGameHide("gardendoor");
    end;

  end;
  
  function zz_shelves.Close()
    cmn.HideNote( 0 );
  end;
  
  function zz_fireplace.PreOpen()
    
    cmn.PlayAudio("env", "assets/levels/common/audio/audio3/aud_fireplace_env");

  end;
  
  function zz_fireplace.PreClose()
    
    cmn.StopAllEnv("assets/levels/common/audio/audio3/aud_witchhouse_env");
    cmn.PlayAudio("env", "assets/levels/common/audio/audio3/aud_witchhouse_env");

  end;

end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_table" ].state then 
    private.zz_table.StartConditions();
  end;
  private.zz_table.state = ng_global.progress[ ng_global.currentprogress ][ "win_table" ].state;
  
  if not ng_global.progress[ ng_global.currentprogress ][ "win_gardendoor" ].state then 
    private.zz_gardendoor.StartConditions();
  end;
  private.zz_gardendoor.state = ng_global.progress[ ng_global.currentprogress ][ "win_gardendoor" ].state;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_witchhouse();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio3/aud_witchhouse_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio3/aud_witchhouse_env");
  
  if ( cmn.IsEventDone( "use_crystalwater" ) and cmn.IsEventDone( "use_magicamuletrecipe" ) and cmn.IsEventDone( "use_fernflower" )
  and cmn.IsEventDone( "use_moonblossomhoney" ) ) and not cmn.IsEventDone("win_table") then
    private.SetTableGameStateLoc();
  end;
  
  if not ( cmn.IsEventDone( "beg_level3" ) ) then
    cmn.CallEventHandler("beg_level3");
  end;
  
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(7) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_lvl3scarf()

  local item = "inv_lvl3scarf";

  if cmn.ApplyObj( item, "gzz_witchhouse_fireplace" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_fireplace" );

  elseif ( cmn.ApplyObj( item, "obj_fireplace_use_lvl3scarf" ) ) then

    cmn.CallEventHandler( "use_lvl3scarf_inv" );
    cmn.CallEventHandler( "use_lvl3scarf_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl3scarf" );
      cmn.CallEventHandler( "use_lvl3scarf_end" );

      rm_witchhouse.get_hotrod();

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_use_scarf");

    ObjSet( "anm_fireplace_hotrod", { endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_swanbowl()

  local item = "inv_swanbowl";

  if cmn.ApplyObj( item, "gzz_witchhouse_fireplace" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_fireplace" );

  elseif ( cmn.ApplyObj( item, "obj_fireplace_use_swanbowl" ) ) then

    cmn.CallEventHandler( "use_swanbowl_inv" );
    cmn.CallEventHandler( "use_swanbowl_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_swanbowl" );
      cmn.CallEventHandler( "use_swanbowl_end" );

      public.get_crystalwater();

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_xx_clk_water3");

    ObjSet( "anm_fireplace_bowler", { endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_magicfertilizer()

  local item = "inv_magicfertilizer";

  if cmn.ApplyObj( item, "gzz_witchhouse_fireplace" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_fireplace" );

  elseif ( cmn.ApplyObj( item, "obj_fireplace_use_magicfertilizer" ) and cmn.IsEventDone( "use_swanbowl" ) ) then

    cmn.CallEventHandler( "use_magicfertilizer_inv" );
    cmn.CallEventHandler( "use_magicfertilizer_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_magicfertilizer" );
      cmn.CallEventHandler( "use_magicfertilizer_end" );

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_use_bottle");

    ObjSet( "anm_fireplace_bowler", { animfunc = "func_use_bottle", endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_petal()

  local item = "inv_petal";

  if cmn.ApplyObj( item, "gzz_witchhouse_gardendoor" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_gardendoor" );

  elseif ( cmn.ApplyObj( item, "obj_gardendoor_use_petal" ) and cmn.CheckMultiObject( "petal", 3 ) ) then

    cmn.CallEventHandler( "use_petal_inv" );
    cmn.CallEventHandler( "use_petal_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_petal" );
      cmn.CallEventHandler( "use_petal_end" );
      
      cmn.MiniGameShow();

    end;
    
    local anm_zoom = function ()
      
      ObjAnimate("obj_gardendoor_back", "pos_xy", 0, 0, func_after, { 0, 0, 0, 0,   0.7, 0, -54, -15 });
      ObjAnimate("obj_gardendoor_back", "scale_xy", 0, 0, "", { 0, 0, 1, 1,   0.7, 0, 1.05, 1.05 });
      
    end;
    
    local anm_open = function ()
      
      ObjAnimate("anm_gardendoor_door_touch", "pos_x", 0, 0, anm_zoom, { 0, 0, 13,   1.3, 0, 394 });
      
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_use_petal");

    ObjAnimate( "spr_gardendoor_door_petal_1", "alp", 0, 0, "",
    {
      0.0, 0, 0, 
      0.3, 0, 1
    } );
    
    ObjAnimate( "spr_gardendoor_door_petal_2", "alp", 0, 0, "",
    {
      0.0, 0, 0, 
      0.3, 0, 0,
      0.6, 0, 1
    } );
    
    ObjAnimate( "spr_gardendoor_door_petal_3", "alp", 0, 0, anm_open,
    {
      0.0, 0, 0, 
      0.6, 0, 0,
      0.9, 0, 1,
      1.2, 0, 1
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl3bearfigurine()

  local item = "inv_lvl3bearfigurine";

  if cmn.ApplyObj( item, "gzz_witchhouse_shelves" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_shelves" );

  elseif ( cmn.ApplyObj( item, "obj_shelves_use_lvl3bearfigurine" ) ) then

    cmn.CallEventHandler( "use_lvl3bearfigurine_inv" );
    cmn.CallEventHandler( "use_lvl3bearfigurine_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl3bearfigurine" );
      cmn.CallEventHandler( "use_lvl3bearfigurine_end" );

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_xx_opn_wood");

    ObjAnimate( "spr_shelves_bearfigurine_shadow",     "alp", 0, 0, "",         { 0, 0, 0,    0.3, 0, 1 } );
    ObjAnimate( "spr_shelves_bearfigurine",            "alp", 0, 0, "",         { 0, 0, 0,    0.3, 0, 1 } );
    ObjAnimate( "anm_shelves_bearshelves",             "alp", 0, 0, "",         { 0, 0, 1,    0.3, 0, 1,    0.6, 0, 0 } );
    ObjAnimate( "spr_shelves_bearfshelves_opn_shadow", "alp", 0, 0, "",         { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );
    ObjAnimate( "obj_shelves_bearshelves",             "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_wolffigurine()

  local item = "inv_wolffigurine";

  if cmn.ApplyObj( item, "gzz_witchhouse_shelves" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_shelves" );

  elseif ( cmn.ApplyObj( item, "obj_shelves_use_wolffigurine" ) ) then

    cmn.CallEventHandler( "use_wolffigurine_inv" );
    cmn.CallEventHandler( "use_wolffigurine_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_wolffigurine" );
      cmn.CallEventHandler( "use_wolffigurine_end" );

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_xx_opn_wood");

    ObjAnimate( "spr_shelves_wolffigurine_shadow",     "alp", 0, 0, "",         { 0, 0, 0,    0.3, 0, 1 } );
    ObjAnimate( "spr_shelves_wolffigurine",            "alp", 0, 0, "",         { 0, 0, 0,    0.3, 0, 1 } );
    ObjAnimate( "anm_shelves_wolfshelves",             "alp", 0, 0, "",         { 0, 0, 1,    0.3, 0, 1,    0.6, 0, 0 } );
    ObjAnimate( "spr_shelves_wolfrshelves_opn_shadow", "alp", 0, 0, "",         { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );
    ObjAnimate( "obj_shelves_wolfrshelves",            "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_foxfigurine()

  local item = "inv_foxfigurine";

  if cmn.ApplyObj( item, "gzz_witchhouse_shelves" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_shelves" );

  elseif ( cmn.ApplyObj( item, "obj_shelves_use_foxfigurine" ) ) then

    cmn.CallEventHandler( "use_foxfigurine_inv" );
    cmn.CallEventHandler( "use_foxfigurine_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_foxfigurine" );
      cmn.CallEventHandler( "use_foxfigurine_end" );

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_xx_opn_wood");

    ObjAnimate( "spr_shelves_foxfigurine_shadow",     "alp", 0, 0, "",         { 0, 0, 0,    0.3, 0, 1 } );
    ObjAnimate( "spr_shelves_foxfigurine",            "alp", 0, 0, "",         { 0, 0, 0,    0.3, 0, 1 } );
    ObjAnimate( "anm_shelves_foxshelves",             "alp", 0, 0, "",         { 0, 0, 1,    0.3, 0, 1,    0.6, 0, 0 } );
    ObjAnimate( "spr_shelves_foxshelves_opn_shadow",  "alp", 0, 0, "",         { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );
    ObjAnimate( "obj_shelves_foxshelves",             "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hotrod()

  local item = "inv_hotrod";

  if cmn.ApplyObj( item, "gzz_witchhouse_table" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_table" );

  elseif ( cmn.ApplyObj( item, "obj_table_use_hotrod" ) ) then

    cmn.CallEventHandler( "use_hotrod_inv" );
    cmn.CallEventHandler( "use_hotrod_beg" );

    local func_after2 = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_hotrod" );
      cmn.CallEventHandler( "use_hotrod_end" );

    end;

    local func_after1 = function ()
      ObjSet( "anm_table_shelf", { animfunc = "func_open_shelf", endtrig = func_after2, playing = true } );
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_use_poker");

    ObjSet( "anm_table_shelf", { animfunc = "func_use_hotrod", endtrig = func_after1, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_crystalwater()

  local item = "inv_crystalwater";

  if cmn.ApplyObj( item, "gzz_witchhouse_table" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_table" );

  elseif ( cmn.ApplyObj( item, "obj_table_use_crystalwater" ) ) then

    cmn.CallEventHandler( "use_crystalwater_inv" );
    cmn.CallEventHandler( "use_crystalwater_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_crystalwater" );
      cmn.CallEventHandler( "use_crystalwater_end" );

      if ( cmn.IsEventDone( "use_magicamuletrecipe" ) and cmn.IsEventDone( "use_fernflower" ) and cmn.IsEventDone( "use_moonblossomhoney" ) ) then
        cmn.MiniGameShow();
        private.zz_table.DrawScene();
      end;

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_xx_put_ladle");

    ObjAnimate( "spr_table_bottle_shadow", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    ObjAnimate( "spr_table_bottle", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_moonblossomhoney()

  local item = "inv_moonblossomhoney";

  if cmn.ApplyObj( item, "gzz_witchhouse_table" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_table" );

  elseif ( cmn.ApplyObj( item, "obj_table_use_moonblossomhoney" ) ) then

    cmn.CallEventHandler( "use_moonblossomhoney_inv" );
    cmn.CallEventHandler( "use_moonblossomhoney_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_moonblossomhoney" );
      cmn.CallEventHandler( "use_moonblossomhoney_end" );

      if ( cmn.IsEventDone( "use_crystalwater" ) and cmn.IsEventDone( "use_fernflower" ) and cmn.IsEventDone( "use_magicamuletrecipe" ) ) then
        cmn.MiniGameShow();
        private.zz_table.DrawScene();
      end;

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_xx_put_ladle");

    ObjAnimate( "anm_table_jar", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_magicamuletrecipe()

  local item = "inv_magicamuletrecipe";

  if cmn.ApplyObj( item, "gzz_witchhouse_table" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_table" );

  elseif ( cmn.ApplyObj( item, "obj_table_use_magicamuletrecipe" ) ) then

    cmn.CallEventHandler( "use_magicamuletrecipe_inv" );
    cmn.CallEventHandler( "use_magicamuletrecipe_beg" );

    local func_after = function ()

      cmn.Lock( 0 );
      
      cmn.SetEventDone( "use_magicamuletrecipe" );
      cmn.CallEventHandler( "use_magicamuletrecipe_end" );

      if ( cmn.IsEventDone( "use_crystalwater" ) and cmn.IsEventDone( "use_fernflower" ) and cmn.IsEventDone( "use_moonblossomhoney" ) ) then
        cmn.MiniGameShow();
        private.zz_table.DrawScene();
      end;

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_clk_paper");

    ObjAnimate( "spr_table_paper_small", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fernflower()

  local item = "inv_fernflower";

  if cmn.ApplyObj( item, "gzz_witchhouse_table" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_table" );

  elseif ( cmn.ApplyObj( item, "obj_table_use_fernflower" ) ) then

    cmn.CallEventHandler( "use_fernflower_inv" );
    cmn.CallEventHandler( "use_fernflower_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_fernflower" );
      cmn.CallEventHandler( "use_fernflower_end" );

      if ( cmn.IsEventDone( "use_crystalwater" ) and cmn.IsEventDone( "use_magicamuletrecipe" )
      and cmn.IsEventDone( "use_moonblossomhoney" ) ) then
        cmn.MiniGameShow();
        private.zz_table.DrawScene();
      end;

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_xx_clk_rabbit");

    ObjAnimate( "spr_table_flower", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    ObjAnimate( "spr_table_flower_shadow", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pearl()

  local item = "inv_pearl";

  if cmn.ApplyObj( item, "gzz_witchhouse_cupboard" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cupboard" );

  elseif ( cmn.ApplyObj( item, "obj_cupboard_use_pearl" ) ) then

    cmn.CallEventHandler( "use_pearl_inv" );
    cmn.CallEventHandler( "use_pearl_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pearl" );
      cmn.CallEventHandler( "use_pearl_end" );

    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_opn_cabinet");
      ObjAnimate( "anm_cupboard_door", "alp", 0, 0, func_after, { 0, 0, 1,    0.5, 0, 0 } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_use_shell");

    if ( cmn.IsEventDone( "use_shell" ) ) then
      ObjAnimate( "spr_cupboard_pearl", "alp", 0, 0, anm_open,   { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );
    else
      ObjAnimate( "spr_cupboard_pearl", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;


  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_shell()

  local item = "inv_shell";

  if cmn.ApplyObj( item, "gzz_witchhouse_cupboard" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cupboard" );

  elseif ( cmn.ApplyObj( item, "obj_cupboard_use_shell" ) ) then

    cmn.CallEventHandler( "use_shell_inv" );
    cmn.CallEventHandler( "use_shell_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_shell" );
      cmn.CallEventHandler( "use_shell_end" );

    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_opn_cabinet");
      ObjAnimate( "anm_cupboard_door", "alp", 0, 0, func_after, { 0, 0, 1,    0.5, 0, 0 } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_use_shell");

    if ( cmn.IsEventDone( "use_pearl" ) ) then
      ObjAnimate( "spr_cupboard_seashell", "alp", 0, 0, anm_open,   { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );
    else
      ObjAnimate( "spr_cupboard_seashell", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pocketwatch()

  local item = "inv_pocketwatch";

  if cmn.ApplyObj( item, "gzz_witchhouse_cupboard" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cupboard" );

  elseif ( cmn.ApplyObj( item, "obj_cupboard_use_pocketwatch" ) ) then

    cmn.CallEventHandler( "use_pocketwatch_inv" );
    cmn.CallEventHandler( "use_pocketwatch_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pocketwatch" );
      cmn.CallEventHandler( "use_pocketwatch_end" );

    end;

    local func_amuletknot_get = function ()
      cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_oldpruners/audio/aud_xx_clk_cutters");
      ObjSet( "anm_cupboard_amuletknot", { endtrig = func_after, playing = true } );
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_slippers");

    if ( cmn.IsEventDone( "use_pincenez" ) ) then
      ObjAnimate( "spr_cupboard_clock", "alp", 0, 0, func_amuletknot_get, { 0, 0, 0,    0.3, 0, 1 } );
    else
      ObjAnimate( "spr_cupboard_clock", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pincenez()

  local item = "inv_pincenez";

  if cmn.ApplyObj( item, "gzz_witchhouse_cupboard" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cupboard" );

  elseif ( cmn.ApplyObj( item, "obj_cupboard_use_pincenez" ) ) then

    cmn.CallEventHandler( "use_pincenez_inv" );
    cmn.CallEventHandler( "use_pincenez_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pincenez" );
      cmn.CallEventHandler( "use_pincenez_end" );

    end;

    local func_amuletknot_get = function ()
      cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_oldpruners/audio/aud_xx_clk_cutters");
      ObjSet( "anm_cupboard_amuletknot", { endtrig = func_after, playing = true } );
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_slippers");

    if ( cmn.IsEventDone( "use_pocketwatch" ) ) then
      ObjAnimate( "spr_cupboard_pincenez_shadow", "alp", 0, 0, "",                  { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "spr_cupboard_pincenez",        "alp", 0, 0, func_amuletknot_get, { 0, 0, 0,    0.3, 0, 1 } );
    else
      ObjAnimate( "spr_cupboard_pincenez_shadow", "alp", 0, 0, "",         { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "spr_cupboard_pincenez",        "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_petal1()

  cmn.SetEventDone( "get_petal1" );
  cmn.CallEventHandler( "get_petal1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_hotrod()

  cmn.SetEventDone( "get_hotrod" );
  cmn.CallEventHandler( "get_hotrod" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_crystalwater()

  cmn.SetEventDone( "get_crystalwater" );
  cmn.CallEventHandler( "get_crystalwater" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_cauldronwtihfertilizer()

  cmn.SetEventDone( "get_cauldronwtihfertilizer" );
  cmn.CallEventHandler( "get_cauldronwtihfertilizer" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_lvl3scarf()

  cmn.SetEventDone( "get_lvl3scarf" );
  cmn.CallEventHandler( "get_lvl3scarf" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_magicfertilizer()

  cmn.SetEventDone( "get_magicfertilizer" );
  cmn.CallEventHandler( "get_magicfertilizer" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if ( private.IfShelvesAllItemGet() ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_petal2()

  cmn.SetEventDone( "get_petal2" );
  cmn.CallEventHandler( "get_petal2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_sharpeningstone()

  cmn.SetEventDone( "get_sharpeningstone" );
  cmn.CallEventHandler( "get_sharpeningstone" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_bluntblade()

  cmn.SetEventDone( "get_bluntblade" );
  cmn.CallEventHandler( "get_bluntblade" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if ( private.IfShelvesAllItemGet() ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_moonblossomhoney()

  cmn.SetEventDone( "get_moonblossomhoney" );
  cmn.CallEventHandler( "get_moonblossomhoney" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if ( private.IfShelvesAllItemGet() ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_runescoop()

  cmn.SetEventDone( "get_runescoop" );
  cmn.CallEventHandler( "get_runescoop" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if ( private.IfShelvesAllItemGet() ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_basreliefpart1()

  cmn.SetEventDone( "get_basreliefpart1" );
  cmn.CallEventHandler( "get_basreliefpart1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  if ( private.IfShelvesAllItemGet() ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_teleportamulet()

  cmn.SetEventDone( "get_teleportamulet" );
  cmn.CallEventHandler( "get_teleportamulet" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_petal3()

  cmn.SetEventDone( "get_petal3" );
  cmn.CallEventHandler( "get_petal3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_swanbowl()

  cmn.SetEventDone( "get_swanbowl" );
  cmn.CallEventHandler( "get_swanbowl" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_copperfeather1()

  cmn.SetEventDone( "get_copperfeather1" );
  cmn.CallEventHandler( "get_copperfeather1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_applecutter()

  cmn.SetEventDone( "get_applecutter" );
  cmn.CallEventHandler( "get_applecutter" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_amuletknot()

  cmn.SetEventDone( "get_amuletknot" );
  cmn.CallEventHandler( "get_amuletknot" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

  common.CloseSubRoom();

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_witchhouse()

  if not ( cmn.IsEventDone( "beg_level3" ) ) then
    
    cmn.SetEventDone( "beg_level3" );
    
    cmn.ShowDlgBbt( "witchhouse_open_voice", 1 );
    cmn.PlayAudio("voc", "assets/levels/level3/rm_witchhouse/audio/aud_cheshire_dlg_lvl3_1_voc");
    
    interface_impl.ShowGlobalTask();
  end;

end;
--------------------------------------------------------------------------------------------
function private.IfShelvesAllItemGet()

  --ОСТОРОЖНО! используется в прогрессовских функциях

  if ( cmn.IsEventDone( "get_bluntblade" )      and cmn.IsEventDone( "get_moonblossomhoney" )
  and  cmn.IsEventDone( "get_magicfertilizer" ) and cmn.IsEventDone( "get_runescoop" ) and cmn.IsEventDone( "get_basreliefpart1" ) ) then
    return true;
  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.touch_cupboard_door( num )
  
  cmn.Lock(1);
  
  if ( num == 1 ) then
    cmn.ShowBbt( "obj_cupboard_use_pearl" );
  else
    cmn.ShowBbt( "obj_cupboard_use_shell" );
  end;

  cmn.PlayAudio("snd", "assets/levels/level2/rm_mermaidsward/audio/aud_xx_opn_window");
  
  ObjSet( "anm_cupboard_door", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_rabbit( num )
  
  cmn.Lock(1);
  
  if ( num == 1 ) then
    cmn.ShowBbt( "obj_cupboard_use_pincenez" );
  else
    cmn.ShowBbt( "obj_cupboard_use_pocketwatch" );
  end;

  cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_xx_clk_rabbit");
  
  ObjSet( "anm_cupboard_rabbit", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_shelf()
  
  cmn.Lock(1);

  cmn.ShowBbt( "obj_table_use_hotrod" );

  cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_clk_xx_drawer");
  
  ObjSet( "anm_table_shelf", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_bearshelves()
  
  cmn.Lock(1);

  cmn.ShowBbt( "obj_shelves_use_lvl3bearfigurine" );

  cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_bridgebase/audio/aud_xx_wood_mid2");
  
  ObjSet( "anm_shelves_bearshelves", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_wolfshelves()
  
  cmn.Lock(1);

  cmn.ShowBbt( "obj_shelves_use_wolffigurine" );

  cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_bridgebase/audio/aud_xx_wood_mid2");
  
  ObjSet( "anm_shelves_wolfshelves", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_foxshelves()
  
  cmn.Lock(1);

  cmn.ShowBbt( "obj_shelves_use_foxfigurine" );

  cmn.PlayAudio("snd", "assets/levels/level2/inv_complex/inv_bridgebase/audio/aud_xx_wood_mid2");
  
  ObjSet( "anm_shelves_foxshelves", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_bowler( num )
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_clk_water");

  if ( num == 1 ) then

    cmn.ShowBbt( "obj_fireplace_use_swanbowl" );

    ObjSet("anm_fireplace_bowler", { animfunc = "func_clk_full_bowler_with_cristalwater", playing = true, endtrig = function()
      ObjSet( "anm_fireplace_bowler", { animfunc = "func_get_cristalwater", endtrig = "", frame = 0 } );
      cmn.Lock(0);
    end });

  else

    cmn.ShowBbt( "obj_fireplace_use_magicfertilizer" );

    ObjSet("anm_fireplace_bowler", { animfunc = "func_clk_taken_cristalwater", playing = true, endtrig = function()
      ObjSet( "anm_fireplace_bowler", { animfunc = "func_get_cristalwater", endtrig = "", frame = 72 } );
      cmn.Lock(0);
    end });

  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_petal_door()
  
  cmn.Lock(1);

  cmn.ShowBbt( "obj_gardendoor_use_petal" );

  cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_xx_wood_mid");
  
  ObjSet( "anm_gardendoor_door_touch", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_7_1", { alp = 1 }},
                 {"spr_col_7_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_7_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_7_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_7_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_7_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_7_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_7_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.SetTableGameStateLoc()

  if private.zz_table.state.events.use_table_flower then
    
    ObjSet("spr_witchhouse_table_flower",  { alp = 0 });
    if private.zz_table.state.events.use_table_plate then
      ObjSet("spr_witchhouse_table_flower_2",  { alp = 0 });
    else
      ObjSet("spr_witchhouse_table_flower_2",  { alp = 1 });
    end;
    
  else 
    ObjMultiSet( { {"spr_witchhouse_table_flower", { alp = 1 }},
                   {"spr_witchhouse_table_flower_2", { alp = 0 }} } );
  end;
  
  if private.zz_table.state.events.clk_table_jar then
    ObjMultiSet( { {"spr_witchhouse_table_honey_jar_open", { alp = 1 }},
                   {"spr_witchhouse_table_honey_jar_closed", { alp = 0 }} } );
  else
    ObjMultiSet( { {"spr_witchhouse_table_honey_jar_closed", { alp = 1 }},
                   {"spr_witchhouse_table_honey_jar_open", { alp = 0 }} } );
  end;
                 
  if private.zz_table.state.events.use_table_tweezers then
    
    ObjMultiSet( { {"spr_witchhouse_table_honey", { alp = 0 }},
                   {"spr_witchhouse_table_mill_open", { alp = 1 }} } );
    
    if private.zz_table.state.events.use_table_honey then
      ObjSet("spr_witchhouse_table_mill_honey",  { alp = 0 });
    else
      ObjSet("spr_witchhouse_table_mill_honey",  { alp = 1 });
    end;
    
  else
    ObjMultiSet( { {"spr_witchhouse_table_honey", { alp = 1 }},
                   {"spr_witchhouse_table_mill_open", { alp = 0 }},
                   {"spr_witchhouse_table_mill_honey", { alp = 1 }} } );
  end;    

  if private.zz_table.state.events.use_table_bottle then
    
    ObjSet("spr_witchhouse_table_bottle_water",  { alp = 0 });
    
    if private.zz_table.state.events.use_table_spoon then
      ObjMultiSet( { {"spr_witchhouse_table_mix_2", { alp = 1 }},
                     {"spr_witchhouse_table_mix_1", { alp = 0 }} } );
    else
      ObjMultiSet( { {"spr_witchhouse_table_mix_1", { alp = 1 }},
                     {"spr_witchhouse_table_mix_2", { alp = 0 }} } );
    end;
                   
  else
    ObjMultiSet( { {"spr_witchhouse_table_bottle_water", { alp = 1 }},
                   {"spr_witchhouse_table_mix_2", { alp = 0 }},
                   {"spr_witchhouse_table_mix_1", { alp = 0 }} } );
  end;  
                 
  if not cmn.IsEventDone("win_table") then
                 
    if private.zz_table.state.events.use_table_funnel then
      
      ObjMultiSet( { {"spr_witchhouse_table_amulet_funnel", { alp = 1 }},
                     {"spr_witchhouse_table_amulet_cover", { alp = 0 }} } );
                     
    else
      ObjMultiSet( { {"spr_witchhouse_table_amulet_funnel", { alp = 0 }},
                     {"spr_witchhouse_table_amulet_cover", { alp = 1 }} } );
    end;
                   
  end;
  
end;
--*********************************************************************************************************************
-- function *** MMG_Table *** () end;
--*********************************************************************************************************************
private.zz_table = {};
public.zz_table = {};

function private.Init_Table()

  private.zz_table.table_progress = {
    "use_table_flower",   --оспользование цветка на тарелку
    "use_table_pestle",   --ипользование ступки на тарелку

    "clk_table_jar",      --открываем банку с медом
    "use_table_tweezers", --использование пинцетов со взятым медом на кофемолку

    "use_table_bottle",   --юз бутылки на сковородку

    "use_table_plate",    --юз торелки на сковородку
    "use_table_honey",    --юз измельчонного меда на сковородку
    "use_table_spoon",    --юз ложки на сковородку

    "use_table_funnel",   --юз воронки на амулет
    "use_table_saucepan"  --юз сковородки на амулет
  };

  private.zz_table.get_honey = false;

  -------------------------------------------------------------------------------------------
  game.hint[ "win_table" ] = {

      type = "win",
      room = "rm_witchhouse",
      zz = "zz_table",
      zz_gate = "gzz_witchhouse_table"
  };
  -----------------------------------------------------------------------------------
  local win_table = function ()

    if cmn.IsEventDone( "win_table" ) then
      
      ObjDelete("spr_witchhouse_table_mill_open");
      ObjDelete("spr_witchhouse_table_mix_1");
      ObjDelete("spr_witchhouse_table_mix_2");
      ObjDelete("spr_witchhouse_table_amulet_funnel");
      ObjDelete("spr_witchhouse_table_honey");
      ObjDelete("spr_witchhouse_table_honey_jar_closed");
      ObjDelete("spr_witchhouse_table_flower");
      ObjDelete("spr_witchhouse_table_bottle_water");
      
      ObjMultiSet( { { "obj_table_amulet", { input = true } },
                     { "gfx_table_teleportamulet", { active = true } },
                     { "spr_witchhouse_table_amulet_cover", { alp = 1 } },
                     { "spr_witchhouse_table_amulet_water", { alp = 1 } },
                     { "spr_witchhouse_table_honey_jar_open", { alp = 1 } } } );
                     
    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_table", win_table, "rm_witchhouse" );

end;
-----------------------------------------------------------------------------------
function private.zz_table.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_table" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_table" ].state = {
    events = {  --события
      use_table_flower = false, --оспользование цветка на тарелку
      use_table_pestle = false, --ипользование ступки на тарелку

      clk_table_jar = false,      --открываем банку с медом
      use_table_tweezers = false, --использование пинцетов со взятым медом на кофемолку

      use_table_bottle = false,   --юз бутылки на сковородку

      use_table_plate = false,    --юз торелки на сковородку
      use_table_honey = false,    --юз измельчонного меда на сковородку
      use_table_spoon = false,    --юз ложки на сковородку

      use_table_funnel = false,   --юз воронки на амулет
      use_table_saucepan = false  --юз сковородки на амулет
    }
  };

end;
-----------------------------------------------------------------------------------
function public.zz_table.Reset()

  --DbgTrace( "***Reset" );

  local go_reset = false;

  if ( private.zz_table.state.events.use_table_funnel ) then

    private.zz_table.state.events.use_table_funnel = false;
    go_reset = true;

    ObjSet( "spr_table_funnel", { input = true } );

    ObjAnimate( "spr_table_funnel",        "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );
    ObjAnimate( "spr_table_funnel_shadow", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );

    ObjAnimate( "anm_table_amulet", "alp", 0, 0, 
    function () 
      ObjSet( "anm_table_amulet", { animfunc = "func_use_funnel", frame = 0 } );
      ObjAnimate( "anm_table_amulet", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    end, { 0, 0, 1,    0.3, 0, 0 } );

  end;

  if ( private.zz_table.state.events.use_table_bottle ) then

    private.zz_table.state.events.use_table_bottle = false;
    go_reset = true;

    ObjSet( "spr_table_bottle", { input = true } );

    ObjAnimate( "spr_table_bottle", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );
    ObjAnimate( "spr_table_bottle_shadow", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );
    ObjAnimate( "obj_table_saucepan", "alp", 0, 0, 
    function ()
      ObjSet( "anm_table_saucepan", { animfunc = "func_use_bottle", frame = 0, playing = false } );
      ObjAnimate( "obj_table_saucepan", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    end, { 0, 0, 1,    0.3, 0, 0 } );

    if ( private.zz_table.state.events.use_table_spoon ) then

      private.zz_table.state.events.use_table_spoon = false;

      ObjSet( "obj_table_spoon", { input = true } );
      ObjAnimate( "obj_table_spoon", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );
      ObjAnimate( "spr_table_spoon_shadow", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );

    end;

  end;

  if ( private.zz_table.state.events.clk_table_jar ) then

    private.zz_table.state.events.clk_table_jar = false;
    go_reset = true;

    ObjAnimate( "anm_table_jar", "alp", 0, 0, 
    function ()
      ObjSet( "anm_table_jar", { input = true, frame = 0 } );
      ObjAnimate( "anm_table_jar", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    end, { 0, 0, 1,    0.3, 0, 0 } );

    if ( private.zz_table.state.events.use_table_tweezers ) then

      private.zz_table.state.events.use_table_tweezers = false;

      ObjMultiSet( { { "spr_table_tweezers_honey", { alp = 0 } },
                     { "obj_table_tweezers", { input = true, ang = 0 } } } );

      ObjAnimate( "spr_table_honey", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );
      ObjAnimate( "anm_table_mill", "alp", 0, 0, 
      function ()
        ObjMultiSet( { { "anm_table_mill", { frame = 0 } },
                       { "spr_table_mill_box", { alp = 1, input = false } } } );
        ObjAnimate( "anm_table_mill", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
      end, { 0, 0, 1,    0.3, 0, 0 } );
      ObjAnimate( "obj_table_tweezers", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );
      ObjAnimate( "spr_table_tweezers_shadow", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );

      if ( private.zz_table.state.events.use_table_honey ) then
        private.zz_table.state.events.use_table_honey = false;
      end;

    end;

  end;

  if ( private.zz_table.state.events.use_table_flower ) then

    private.zz_table.state.events.use_table_flower = false;
    go_reset = true;

    ObjSet( "spr_table_flower", { input = true } );

    ObjAnimate( "spr_table_flower", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );
    ObjAnimate( "spr_table_flower_shadow", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );

    ObjAnimate( "obj_table_plate", "alp", 0, 0, 
    function () 
      ObjSet( "anm_table_plate", { animfunc = "func_use_flower", frame = 0 } );
      ObjAnimate( "obj_table_plate", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    end, { 0, 0, ( private.zz_table.state.events.use_table_plate and 0 or 1 ),    0.3, 0, 0 } );

    if ( private.zz_table.state.events.use_table_pestle ) then

      private.zz_table.state.events.use_table_pestle = false;

      ObjSet( "spr_table_pestle", { input = true } );
      ObjAnimate( "spr_table_pestle", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );
      ObjAnimate( "spr_table_pestle_shadow", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );

      if ( private.zz_table.state.events.use_table_plate ) then
        private.zz_table.state.events.use_table_plate = false;
        ObjSet( "obj_table_plate", { input = true } );
        ObjAnimate( "spr_table_plate_shadow", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );
      end;

    end;

  end;

  if ( go_reset ) then
    cmn.Lock( 1 );
    private.SetTableGameStateLoc();
    ObjSet( "tmr_table_animlock", { time = 0.6, endtrig = function () cmn.Lock( 0 ); end, playing = true } );
  end;

end;
-----------------------------------------------------------------------------------
function public.zz_table.Skip()

  --DbgTrace( "***Skip" );

  ng_global.progress[ ng_global.currentprogress ][ "win_table" ].skip = 1;

  if ( not private.zz_table.state.events.use_table_saucepan ) then

    private.zz_table.state.events.use_table_saucepan = true;

    ObjSet( "obj_table_saucepan", { input = false } );

    ObjAnimate( "obj_table_saucepan", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "anm_table_amulet", "alp", 0, 0, 
    function () 
      ObjSet( "anm_table_amulet", { animfunc = "func_use_pot", frame = 268 } );
      ObjAnimate( "anm_table_amulet", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    end, { 0, 0, 1,    0.3, 0, 0 } );

  end;

  if ( not private.zz_table.state.events.use_table_funnel ) then

    private.zz_table.state.events.use_table_funnel = true;

    ObjSet( "spr_table_funnel", { input = false } );

    ObjAnimate( "spr_table_funnel",        "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "spr_table_funnel_shadow", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

  end;

  if ( not private.zz_table.state.events.use_table_spoon ) then

    private.zz_table.state.events.use_table_spoon = true;

    ObjSet( "obj_table_spoon", { input = false } );
    ObjAnimate( "obj_table_spoon", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "spr_table_spoon_shadow", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

  end;

  if ( not private.zz_table.state.events.use_table_bottle ) then

    private.zz_table.state.events.use_table_bottle = true;

    ObjSet( "spr_table_bottle", { input = false } );

    ObjAnimate( "spr_table_bottle", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "spr_table_bottle_shadow", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

  end;

  if ( not private.zz_table.state.events.use_table_plate ) then

    private.zz_table.state.events.use_table_plate = true;

    ObjSet( "obj_table_plate", { input = false } );
    ObjAnimate( "spr_table_plate_shadow", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "obj_table_plate", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

  end;

  if ( not private.zz_table.state.events.use_table_honey ) then

    private.zz_table.state.events.use_table_honey = true;

    ObjAnimate( "anm_table_mill", "alp", 0, 0, 
    function ()
      ObjMultiSet( { { "anm_table_mill", { frame = 267 } },
                     { "spr_table_mill_box", { alp = 0, input = false } } } );
      ObjAnimate( "anm_table_mill", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    end, { 0, 0, 1,    0.3, 0, 0 } );

  end;

  if ( not private.zz_table.state.events.use_table_tweezers ) then

    private.zz_table.state.events.use_table_tweezers = true;

    ObjMultiSet( { { "spr_table_tweezers_honey", { alp = 0 } },
                   { "obj_table_tweezers", { input = false, ang = 0 } } } );

    ObjAnimate( "spr_table_honey", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "obj_table_tweezers", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "spr_table_tweezers_shadow", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

  end;

  if ( not private.zz_table.state.events.clk_table_jar ) then

    private.zz_table.state.events.clk_table_jar = true;

    ObjAnimate( "anm_table_jar", "alp", 0, 0, 
    function ()
      ObjSet( "anm_table_jar", { input = false, frame = 84 } );
      ObjAnimate( "anm_table_jar", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    end, { 0, 0, 1,    0.3, 0, 0 } );

  end;

  if ( not private.zz_table.state.events.use_table_pestle ) then

    private.zz_table.state.events.use_table_pestle = true;

    ObjSet( "spr_table_pestle", { input = false } );
    ObjAnimate( "spr_table_pestle", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "spr_table_pestle_shadow", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

  end;

  if ( not private.zz_table.state.events.use_table_flower ) then

    private.zz_table.state.events.use_table_flower = true;

    ObjSet( "spr_table_flower", { input = false } );
    ObjAnimate( "spr_table_flower", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "spr_table_flower_shadow", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

  end;

  cmn.Lock( 1 );
  ObjSet( "tmr_table_animlock", { time = 0.6, endtrig = function () cmn.Lock( 0 ); private.zz_table.Win(); end, playing = true } );

end;
-----------------------------------------------------------------------------------
function private.zz_table.DrawScene()

  --DbgTrace( "***DrawScene" );

  ObjMultiSet( { { "spr_table_paper_small", { input = true } },
                 { "anm_table_mill", { input = true } } } );

  for i = 1, #private.zz_table.table_progress, 1 do

    --DbgTrace( private.zz_table.table_progress[i].." == "..tostring(private.zz_table.state.events[ private.zz_table.table_progress[i] ]) );

    if ( private.zz_table.state.events[ private.zz_table.table_progress[i] ] ) then
      if ( private.zz_table[ private.zz_table.table_progress[i].."_end"] ) then
        private.zz_table[ private.zz_table.table_progress[i].."_end"]();
      end;
    else
      if ( private.zz_table[ private.zz_table.table_progress[i].."_start"] ) then
        private.zz_table[ private.zz_table.table_progress[i].."_start"]();
      end;
    end;

  end;

end;
-----------------------------------------------------------------------------------
function private.zz_table.CheckWin()

end;
-----------------------------------------------------------------------------------
function private.zz_table.Win()

  cmn.MiniGameHide("table");
  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );

  cmn.SetEventDone( "win_table" );
  cmn.CallEventHandler( "win_table" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_table" ].skip == 0 and ng_global.noskipgames[ "win_table" ] == nil then

    ng_global.noskipgames[ "win_table" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

end;
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
function public.zz_table.OpenPaper()

  ObjSet( "spr_table_line_1", { 
    alp = ( private.zz_table.state.events.use_table_flower and 1 or 0 ),
    scale_x = ( private.zz_table.state.events.use_table_pestle and 1 or 0.4 )
  } );

  ObjSet( "spr_table_line_2", { 
    alp = ( private.zz_table.state.events.use_table_tweezers and 1 or 0 )
  } );

  ObjSet( "spr_table_line_3", { 
    alp = ( private.zz_table.state.events.use_table_bottle and 1 or 0 )
  } );

  ObjSet( "spr_table_line_4", { 
    alp = ( ( private.zz_table.state.events.use_table_plate and private.zz_table.state.events.use_table_honey ) and 1 or 0 ),
    scale_x = ( private.zz_table.state.events.use_table_spoon and 1.25 or 0.8 )
  } );

  ObjSet( "spr_table_line_5", { 
    alp = ( ( private.zz_table.state.events.use_table_funnel and private.zz_table.state.events.use_table_saucepan ) and 1 or 0 )
  } );

  cmn.ShowNote( "spr_table_note" );

end;
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
function private.zz_table.ItemDropFlyBackAnim( item )

  cmn.Lock( 1 );

  local func_after = function () 
    ObjAttach( item, "zz_table" ); 
    cmn.Lock( 0 );
  end;

  local curspos = GetObjPosByObj( item, "obj_table_draghub" );
  local item_pos = { ObjGet( item ).pos_x, ObjGet( item ).pos_y };

  --DbgTrace( curspos[1].." "..curspos[2].." -> "..item_pos[1].." "..item_pos[2] );

  ObjAnimate( "spr_"..cmn.GetObjectName( item ).."_shadow", "alp", 0, 0, "", { 0, 0, 0,    0.25, 0, 0,    0.3, 0, 1 } );
  ObjAnimate( item, "pos_xy", 0, 0, func_after, { 
    0,   0, curspos[1],  curspos[2],    
    0.3, 0, item_pos[1], item_pos[2] 
  } );

end;
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
function public.zz_table.use_table_flower_start_drag()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  ObjSet( "spr_table_flower_shadow", { alp = 0 } );
  ObjAttach( "spr_table_flower", "obj_table_draghub" );
end;
function private.zz_table.use_table_flower_start()
  --DbgTrace( "***use_table_flower_start" );
  ObjMultiSet( { { "spr_table_flower", { alp = 1, input = true } },
                 { "anm_table_plate", { animfunc = "func_use_flower", frame = 0 } },
                 { "spr_table_flower_shadow", { alp = 1 } } } );
end;
function public.zz_table.use_table_flower()

  --DbgTrace( "***use_table_flower" );

  if ( cmn.ApplyObj( "spr_table_flower", "obj_table_plate" ) ) then

    private.zz_table.state.events.use_table_flower = true;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_xx_clk_rabbit");
    
    ObjAttach( "spr_table_flower", "zz_table" );
    ObjSet( "spr_table_flower", { alp = 0, input = false } );
    ObjSet( "anm_table_plate", { animfunc = "func_use_flower", endtrig = function () cmn.Lock( 0 ); end, playing = true } );
      
    private.SetTableGameStateLoc();

  else
    cmn.WrongApply();  
    private.zz_table.ItemDropFlyBackAnim( "spr_table_flower" );
  end;

end;
function private.zz_table.use_table_flower_end()
  --DbgTrace( "***use_table_flower_end" );
  ObjMultiSet( { { "spr_table_flower", { alp = 0, input = false } },
                 { "anm_table_plate", { animfunc = "func_use_flower", frame = 43 } },
                 { "spr_table_flower_shadow", { alp = 0 } } } );
end;
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
function public.zz_table.use_table_pestle_start_drag()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  ObjSet( "spr_table_pestle_shadow", { alp = 0 } );
  ObjAttach( "spr_table_pestle", "obj_table_draghub" );
end;
function private.zz_table.use_table_pestle_start()
  --DbgTrace( "***use_table_pestle_start" );
  ObjMultiSet( { { "spr_table_pestle", { alp = 1, input = true } },
                 { "spr_table_pestle_shadow", { alp = 1 } } } );
end;
function public.zz_table.use_table_pestle()

  --DbgTrace( "***use_table_pestle" );

  if ( cmn.ApplyObj( "spr_table_pestle", "obj_table_use_pestle" ) and private.zz_table.state.events.use_table_flower ) then

    private.zz_table.state.events.use_table_pestle = true;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_mill_flower");
    
    ObjAttach( "spr_table_pestle", "zz_table" );
    ObjSet( "spr_table_pestle", { alp = 0, input = false } );
    ObjSet( "anm_table_plate", { animfunc = "func_use_pestle", endtrig = function () cmn.Lock( 0 ); end, playing = true } );
      
    private.SetTableGameStateLoc();

  else
    private.zz_table.ItemDropFlyBackAnim( "spr_table_pestle" );
    cmn.WrongApply();  
  end;

end;
function private.zz_table.use_table_pestle_end()
  --DbgTrace( "***use_table_pestle_end" );
  ObjMultiSet( { { "spr_table_pestle", { alp = 0, input = false } },
                 { "anm_table_plate", { animfunc = "func_use_pestle", frame = 165 } },
                 { "spr_table_pestle_shadow", { alp = 0 } } } );
end;
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
function private.zz_table.clk_table_jar_start()
  --DbgTrace( "***clk_table_jar_start" );
  ObjSet( "anm_table_jar", { input = true, frame = 0 } );
end;
function public.zz_table.clk_table_jar()

  --DbgTrace( "***clk_table_jar" );

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_opn_bank3");

  private.zz_table.state.events.clk_table_jar = true;

  ObjSet( "anm_table_jar", { animfunc = "func_open_jar", endtrig = 
    function () cmn.Lock( 0 ); private.zz_table.clk_table_jar_end() end, playing = true } );

end;
function private.zz_table.clk_table_jar_end()
  --DbgTrace( "***clk_table_jar_end" );
  private.SetTableGameStateLoc();
  ObjSet( "anm_table_jar", { input = false, frame = 84 } );
end;
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
function public.zz_table.use_table_tweezers_start_drag()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  ObjMultiSet( { { "spr_table_tweezers_shadow", { alp = 0 } },
                 { "obj_table_tweezers", { ang = -1.61 } } } );
  ObjAttach( "obj_table_tweezers", "obj_table_draghub" );
end;
function private.zz_table.use_table_tweezers_start()
  --DbgTrace( "***use_table_tweezers_start" );
  ObjMultiSet( { { "spr_table_honey", { alp = 1 } },
                 { "anm_table_mill", { frame = 0 } },
                 { "spr_table_tweezers_honey", { alp = 0 } },
                 { "obj_table_tweezers", { alp = 1, input = true, ang = 0 } },
                 { "spr_table_tweezers_shadow", { alp = 1 } },
                 { "spr_table_mill_box", { alp = 1, input = false } } } );
end;
function public.zz_table.use_table_tweezers()

  --DbgTrace( "***use_table_tweezers" );

  if  cmn.ApplyObj( "obj_table_tweezers", "anm_table_jar" ) and private.zz_table.state.events.clk_table_jar
  and not private.zz_table.get_honey then

    private.zz_table.get_honey = true;

    --ObjDoNotDrop();
    ObjSet( "obj_table_draghub", { input = true } );
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");

    ObjAnimate( "spr_table_honey",          "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "spr_table_tweezers_honey", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

  elseif ( cmn.ApplyObj( "obj_table_tweezers", "anm_table_mill" ) and private.zz_table.get_honey ) then

    private.zz_table.state.events.use_table_tweezers = true;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_mill_honeycomb");

    ObjAttach( "obj_table_tweezers", "zz_table" );
    --ObjSet( "obj_table_tweezers", { alp = 0, input = false } );

    ObjSet( "anm_table_mill", { endtrig = function () cmn.Lock( 0 ); private.zz_table.use_table_tweezers_end() end, playing = true } );
      ObjAnimate( "spr_table_tweezers_honey", "alp", 0, 0, "", { 0, 0, ObjGet( "spr_table_tweezers_honey" ).alp,    0.3, 0, 0 } );
  else

    if ( private.zz_table.get_honey ) then

      private.zz_table.get_honey = false;

      ObjStopAnimate( "spr_table_honey", 8 );
      ObjStopAnimate( "spr_table_tweezers_honey", 8 );

      ObjAnimate( "spr_table_honey",          "alp", 0, 0, "", { 0, 0, ObjGet( "spr_table_honey" ).alp,             0.3, 0, 1 } );
      ObjAnimate( "spr_table_tweezers_honey", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

    end;

    ObjAnimate( "obj_table_tweezers", "ang", 0, 0, "", { 0, 0, -1.61,    0.3, 0, 0 } );

    private.zz_table.ItemDropFlyBackAnim( "obj_table_tweezers" );
    cmn.WrongApply();  

  end;

end;
function private.zz_table.use_table_tweezers_end()
  --DbgTrace( "***use_table_tweezers_end" );
  private.SetTableGameStateLoc();
  ObjMultiSet( { { "obj_table_tweezers", { alp = 0, input = false } },
                 { "anm_table_mill", { frame = 267 } },
                 { "spr_table_tweezers_shadow", { alp = 0 } },
                 { "spr_table_honey", { alp = 0 } },
                 { "spr_table_mill_box", { input = true } } } );
end;
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
function public.zz_table.use_table_bottle_start_drag()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  ObjSet( "spr_table_bottle_shadow", { alp = 0 } );
  ObjAttach( "spr_table_bottle", "obj_table_draghub" );
end;
function private.zz_table.use_table_bottle_start()
  --DbgTrace( "***use_table_bottle_start" );
  ObjMultiSet( { { "spr_table_bottle", { alp = 1, input = true } },
                 { "anm_table_saucepan", { animfunc = "func_use_bottle", frame = 0, playing = false } },
                 { "spr_table_bottle_shadow", { alp = 1 } } } );
end;
function public.zz_table.use_table_bottle()

  --DbgTrace( "***use_table_bottle" );

  if ( cmn.ApplyObj( "spr_table_bottle", "obj_table_use_bottle" ) ) then

    private.zz_table.state.events.use_table_bottle = true;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_boilin_water");

    ObjAttach( "spr_table_bottle", "zz_table" );
    ObjSet( "spr_table_bottle", { alp = 0, input = false } );
    ObjSet( "anm_table_saucepan", { animfunc = "func_use_bottle", endtrig = 
      function () cmn.Lock( 0 ); private.zz_table.use_table_bottle_end() end, playing = true } );

  else
    private.zz_table.ItemDropFlyBackAnim( "spr_table_bottle" );
    cmn.WrongApply();  
  end;

end;
function private.zz_table.use_table_bottle_end()
  --DbgTrace( "***use_table_bottle_end" );
  private.SetTableGameStateLoc();
  ObjMultiSet( { { "spr_table_bottle", { alp = 0, input = false } },
                 { "anm_table_saucepan", { animfunc = "func_water", playing = true } },
                 { "spr_table_bottle_shadow", { alp = 0 } } } );
end;
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
function public.zz_table.use_table_plate_start_drag()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  ObjSet( "spr_table_plate_shadow", { alp = 0 } );
  ObjAttach( "obj_table_plate", "obj_table_draghub" );
end;
function private.zz_table.use_table_plate_start()
  --DbgTrace( "***use_table_plate_start" );
  ObjMultiSet( { { "obj_table_plate", { alp = 1, input = true } },
                 { "spr_table_plate_shadow", { alp = 1 } } } );
end;
function public.zz_table.use_table_plate()

  --DbgTrace( "***use_table_plate" );

  if  cmn.ApplyObj( "obj_table_plate", "obj_table_use_bottle" ) 
  and private.zz_table.state.events.use_table_pestle
  and private.zz_table.state.events.use_table_bottle then

    private.zz_table.state.events.use_table_plate = true;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_pour");
    
    ObjAttach( "obj_table_plate", "zz_table" );
    ObjSet( "obj_table_plate", { alp = 0, input = false } );
    ObjSet( "anm_table_use_plate", { alp = 1, endtrig = function () cmn.Lock( 0 ); end, playing = true } );
      
    private.SetTableGameStateLoc();

  else
    private.zz_table.ItemDropFlyBackAnim( "obj_table_plate" );
    cmn.WrongApply();  
  end;

end;
function private.zz_table.use_table_plate_end()
  --DbgTrace( "***use_table_plate_end" );
  ObjMultiSet( { { "obj_table_plate", { alp = 0, input = false } },
                 { "spr_table_plate_shadow", { alp = 0 } } } );
end;
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
function public.zz_table.use_table_honey_start_drag()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  ObjAttach( "spr_table_mill_box", "obj_table_draghub" );
end;
function private.zz_table.use_table_honey_start()
  --DbgTrace( "***use_table_honey_start" );
end;
function public.zz_table.use_table_honey()

  --DbgTrace( "***use_table_honey" );

  cmn.Lock( 1 );

  if  cmn.ApplyObj( "spr_table_mill_box", "obj_table_use_bottle" ) 
  and private.zz_table.state.events.use_table_tweezers
  and private.zz_table.state.events.use_table_bottle then

    private.zz_table.state.events.use_table_honey = true;
    
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_pour");

    ObjAttach( "spr_table_mill_box", "obj_table_mill_box" );
    ObjSet( "spr_table_mill_box", { alp = 0, input = false } );
    ObjSet( "anm_table_use_mill_box", { endtrig = function () cmn.Lock( 0 ); end, playing = true } );
      
    private.SetTableGameStateLoc();

  else

    cmn.WrongApply();  

    local func_after = function ()
      ObjSet( "spr_table_mill_box", { pos_x = 0, pos_y = 0 } );
      ObjAttach( "spr_table_mill_box", "obj_table_mill_box" );
      cmn.Lock( 0 );
    end;

    local curspos = GetObjPosByObj( "spr_table_mill_box", "obj_table_draghub" );

    ObjAnimate( "spr_table_mill_box", "pos_xy", 0, 0, func_after, { 
      0,   0, curspos[1],  curspos[2],    
      0.3, 0, 196, -38
    } );

  end;

end;
function private.zz_table.use_table_honey_end()
  --DbgTrace( "***use_table_honey_end" );
  ObjSet( "spr_table_mill_box", { alp = 0, input = false } );
end;
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
function public.zz_table.use_table_spoon_start_drag()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  ObjSet( "spr_table_spoon_shadow", { alp = 0 } );
  ObjAttach( "obj_table_spoon", "obj_table_draghub" );
end;
function private.zz_table.use_table_spoon_start()
  --DbgTrace( "***use_table_spoon_start" );
  ObjMultiSet( { { "obj_table_spoon", { alp = 1, input = true } },
                 { "spr_table_spoon_shadow", { alp = 1 } } } );
end;
function public.zz_table.use_table_spoon()

  --DbgTrace( "***use_table_spoon" );

  if cmn.ApplyObj( "obj_table_spoon", "obj_table_use_bottle" ) 
  and private.zz_table.state.events.use_table_plate
  and private.zz_table.state.events.use_table_honey then

    private.zz_table.state.events.use_table_spoon = true;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_use_spoon");

    ObjAttach( "obj_table_spoon", "zz_table" );
    ObjSet( "obj_table_spoon", { alp = 0, input = false } );
    ObjSet( "anm_table_saucepan", { animfunc = "func_use_spoon", endtrig = 
      function () cmn.Lock( 0 ); private.zz_table.use_table_spoon_end() end, playing = true } );
        
    private.SetTableGameStateLoc();

  else
    private.zz_table.ItemDropFlyBackAnim( "obj_table_spoon" );
    cmn.WrongApply();  
  end;

end;
function private.zz_table.use_table_spoon_end()
  --DbgTrace( "***use_table_spoon_end" );
  ObjMultiSet( { { "obj_table_spoon", { alp = 0, input = false } },
                 { "anm_table_saucepan", { animfunc = "func_water_pink", playing = true } },
                 { "spr_table_spoon_shadow", { alp = 0 } } } );
end;
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
function public.zz_table.use_table_funnel_start_drag()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  ObjSet( "spr_table_funnel_shadow", { alp = 0 } );
  ObjAttach( "spr_table_funnel", "obj_table_draghub" );
end;
function private.zz_table.use_table_funnel_start()
  --DbgTrace( "***use_table_funnel_start" );
  ObjMultiSet( { { "spr_table_funnel", { alp = 1, input = true } },
                 { "spr_table_funnel_shadow", { alp = 1 } },
                 { "anm_table_amulet", { animfunc = "func_use_funnel", frame = 0 } } } );
end;
function public.zz_table.use_table_funnel()

  --DbgTrace( "***use_table_funnel" );

  if cmn.ApplyObj( "spr_table_funnel", "obj_table_amulet" ) then

    private.zz_table.state.events.use_table_funnel = true;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_use_funnel");

    ObjAttach( "spr_table_funnel", "zz_table" );
    ObjSet( "spr_table_funnel", { alp = 0, input = false } );
    ObjSet( "anm_table_amulet", { animfunc = "func_use_funnel", endtrig = function () cmn.Lock( 0 ); end, playing = true } );
      
    private.SetTableGameStateLoc();

  else
    private.zz_table.ItemDropFlyBackAnim( "spr_table_funnel" );
    cmn.WrongApply();  
  end;

end;
function private.zz_table.use_table_funnel_end()
  --DbgTrace( "***use_table_funnel_end" );
  ObjMultiSet( { { "spr_table_funnel", { alp = 0, input = false } },
                 { "anm_table_amulet", { animfunc = "func_use_funnel", frame = 72 } },
                 { "spr_table_funnel_shadow", { alp = 0 } } } );
end;
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
function public.zz_table.use_table_saucepan_start_drag()
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  ObjAttach( "obj_table_saucepan", "obj_table_draghub" );
end;
function private.zz_table.use_table_saucepan_start()
  --DbgTrace( "***use_table_saucepan_start" );
  ObjSet( "obj_table_saucepan", { alp = 1, input = true } );
end;
function public.zz_table.use_table_saucepan()

  --DbgTrace( "***use_table_saucepan" );

  if cmn.ApplyObj( "obj_table_saucepan", "obj_table_use_saucepan" ) 
  and private.zz_table.state.events.use_table_funnel
  and private.zz_table.state.events.use_table_spoon then

    private.zz_table.state.events.use_table_saucepan = true;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_use_pan");

    ObjAttach( "obj_table_saucepan", "zz_table" );
    ObjSet( "obj_table_saucepan", { alp = 0, input = false } );
    ObjSet( "anm_table_amulet", { animfunc = "func_use_pot", endtrig = 
      function () cmn.Lock( 0 ); private.zz_table.Win(); end, playing = true } );

  else
    private.zz_table.ItemDropFlyBackAnim( "obj_table_saucepan" );
    cmn.WrongApply();  
  end;

end;
function private.zz_table.use_table_saucepan_end()
  --DbgTrace( "***use_table_saucepan_end" );
  ObjMultiSet( { { "obj_table_saucepan", { alp = 0, input = false } },
                 { "anm_table_amulet", { animfunc = "func_use_pot", frame = 268 } } } );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Gardendoor *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_gardendoor = {};
public.zz_gardendoor = {};

function private.Init_Gardendoor()
  
  --gems pos in grid
  private.zz_gardendoor.gems_start = { { {2, 4}, -1 }, { {3, 4}, -1 }, { {4, 4}, 1 }, { {5, 4}, -1 } };
  private.zz_gardendoor.gems_end = { 7, 1, 6, 2 };
  
  --mirrors types - directions on x and y
  private.zz_gardendoor.mirrors_type = { 1, 2, 1, 2, 3, 2, 1, 4, 1, 4 };
  private.zz_gardendoor.mirrors_dir = { {1, -1}, {-1, 1}, {1, 1}, {-1, -1} };
  
  private.zz_gardendoor.mirrors_dev = { {9, -9}, {-9, 9}, {9, 9}, {-9, -9} };
  private.zz_gardendoor.mirrors_forbidden = { {2, 4}, {3, 4}, {4, 4}, {5, 4} };
  
  private.zz_gardendoor.mirrors_start = { {1, 2}, {6, 1}, {3, 2}, {7, 1}, {7, 5}, {2, 3}, {2, 5}, {7, 2}, {3, 5}, {5, 6} };
  private.zz_gardendoor.mirrors_win = { {2, 1}, {5, 1}, {1, 2}, {3, 2}, {1, 3}, {2, 3}, {4, 5}, {6, 5}, {1, 6}, {7, 6} };
  
  --points in grid
  private.zz_gardendoor.grid_pos = { 
    { -74, -18, 37, 96, 151, 208, 263 },
    { -111, -51, 4, 59, 111, 170 }
  };
  
  private.zz_gardendoor.current_mirror = 0;
  private.zz_gardendoor.vacant_place = {0, 0};
  
  private.zz_gardendoor.borders = { {-170, 290}, {-230, 240} };
  
  --rays params
  private.zz_gardendoor.ray_scale = 0.7;
  private.zz_gardendoor.ray_alp = 0.8;
  private.zz_gardendoor.ray_color = { {1, 0.29, 0.25}, {0.196, 1, 0.5725}, {1, 0.847, 0}, {0, 0.3412, 1} };
  
  private.zz_gardendoor.lights_on = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  private.zz_gardendoor.gems_checked = {0, 0, 0, 0};
  private.zz_gardendoor.end_pos = { {-95, 280}, {-156, 190} };
  
  private.zz_gardendoor.current_rays = {};
  --------------------------------------------------------------------------------------------
  game.hint[ "win_gardendoor" ] = {
    type = "win",
    room = "rm_witchhouse",
    zz = "zz_gardendoor",
    zz_gate = "gzz_witchhouse_gardendoor"
  };
  -----------------------------------------------------------------------------------
  local win_gardendoor = function ()

    if cmn.IsEventDone( "win_gardendoor" ) then
      
      ObjDelete("obj_gardendoor_game");
      ObjDelete("gzz_witchhouse_gardendoor");
      ObjDelete("spr_witchhouse_door_game");
      
      ObjMultiSet( { {"grm_witchhouse_housegarden", { alp = 1, input = 1 }},
                     {"spr_witchhouse_door_open", { alp = 1 }} } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_witchhouse_housegarden_focus");
      end;
    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_gardendoor", win_gardendoor, "rm_witchhouse" );

end;
--*********************************************************************************************************************
function private.zz_gardendoor.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_gardendoor" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_gardendoor" ].state = { 
    { {1, 2}, {6, 1}, {3, 2}, {7, 1}, {7, 5}, {2, 3}, {2, 5}, {7, 2}, {3, 5}, {5, 6} }, {0, 0, 0, 0}
  }; --[1] - positions of mirrors, [2] - state of end gems
  
end;
-----------------------------------------------------------------------------------
function public.zz_gardendoor.Reset()
  
  local need_r = false;
  local mir = {};
  
  for i = 1, #private.zz_gardendoor.state[1], 1 do
    
    if private.zz_gardendoor.state[1][i][1] ~= private.zz_gardendoor.mirrors_start[i][1] then
      
      if not need_r then
        need_r = true;
      end;
      
      mir[ #mir+1 ] = i;
    
      ObjAnimate("spr_gardendoor_mirror_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;
    
  end;
  
  local count = 0;
  
  for i = 1, 4, 1 do
    
    if private.zz_gardendoor.state[2][i] == 1 then
      count = count + 1;
      ObjAnimate("spr_gardendoor_gem_"..i.."_on", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    end;
    
  end;
  
  for i = 1, count, 1 do
    
    ObjAnimate("spr_gardendoor_lock_"..i, "pos_x", 0, 0, "", { 0, 0, -148,   0.5, 0, -172 });
    
  end;
  
  if need_r then
    
    local anm_end = function ()
      
      private.zz_gardendoor.DrawScene( true );
      ObjAnimate("obj_gardendoor_game_lights", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 0,   0.5, 0, 1 });
        
      for i = 1, #mir, 1 do
        
        ObjAnimate("spr_gardendoor_mirror_"..mir[i], "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
        
      end;
      
    end;
    
    cmn.Lock( 1 );
    private.zz_gardendoor.StartConditions();
    private.zz_gardendoor.state = ng_global.progress[ ng_global.currentprogress ][ "win_gardendoor" ].state;
    
    ObjAnimate("obj_gardendoor_game_lights", "alp", 0, 0, anm_end, { 0, 0, 1,   0.5, 0, 0 });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_gardendoor.Skip()
  
  cmn.Lock( 1 );
  ng_global.progress[ ng_global.currentprogress ][ "win_gardendoor" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_gardendoor" ].state = { 
    { {2, 1}, {5, 1}, {1, 2}, {3, 2}, {1, 3}, {2, 3}, {4, 5}, {6, 5}, {1, 6}, {7, 6} }, {1, 1, 1, 1}
  };
  
  local mir = {};
  
  for i = 1, #private.zz_gardendoor.state[1], 1 do
    
    if private.zz_gardendoor.state[1][i][1] ~= private.zz_gardendoor.mirrors_win[i][1] then
      
      mir[ #mir+1 ] = i;
    
      ObjAnimate("spr_gardendoor_mirror_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;
    
  end;
  
  local count = 0;
  
  for i = 1, 4, 1 do
    
    if private.zz_gardendoor.state[2][i] == 0 then
      count = count + 1;
      ObjAnimate("spr_gardendoor_gem_"..i.."_on", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,    1, 0, 1 });
    end;
    
  end;
  
  for i = 1, count, 1 do
    
    ObjAnimate("spr_gardendoor_lock_"..i, "pos_x", 0, 0, "", { 0, 0, -172,   0.5, 0, -172,   1, 0, -148 });
    
  end;
  
  local anm_end = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level1/mg_memories/audio/aud_cloud_menter");
    cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_xx_compartment");
    
    private.zz_gardendoor.DrawScene( true );
    ObjAnimate("obj_gardendoor_game_lights", "alp", 0, 0, private.zz_gardendoor.CheckWin, { 0, 0, 0,   0.5, 0, 1 });
      
    for i = 1, #mir, 1 do
      
      ObjAnimate("spr_gardendoor_mirror_"..mir[i], "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
  end;
  
  private.zz_gardendoor.state = ng_global.progress[ ng_global.currentprogress ][ "win_gardendoor" ].state;
  
  ObjAnimate("obj_gardendoor_game_lights", "alp", 0, 0, anm_end, { 0, 0, 1,   0.5, 0, 0 });
    
end;
-----------------------------------------------------------------------------------
function private.zz_gardendoor.DrawScene( rew )
  
  rew = rew or false;
  
  for i = 1, #private.zz_gardendoor.state[2], 1 do
    
    if private.zz_gardendoor.state[2][i] == 1 then
      ObjSet("spr_gardendoor_gem_"..i.."_on",  { alp = 1 });
    end;
    
  end;
  
  for i = 1, #private.zz_gardendoor.state[1], 1 do
    
    local px = private.zz_gardendoor.grid_pos[1][ private.zz_gardendoor.state[1][i][1] ];
    local py = private.zz_gardendoor.grid_pos[2][ private.zz_gardendoor.state[1][i][2] ];
    
    ObjSet("spr_gardendoor_mirror_"..i,  { pos_x = px, pos_y = py });
    
  end;
  
  private.zz_gardendoor.ConstructRays();
  
  if not rew then
    
    local count = 0;
  
    for i = 1, 4, 1 do
        
      if private.zz_gardendoor.gems_checked[i] ~= private.zz_gardendoor.state[2][i] then
        private.zz_gardendoor.state[2][i] = private.zz_gardendoor.gems_checked[i];
        ObjSet("spr_gardendoor_gem_"..i.."_on",  { alp = private.zz_gardendoor.state[2][i] });
      end;
      
      if private.zz_gardendoor.state[2][i] == 1 then
        count = count + 1;
      end;
      
    end;
    
    for i = 1, count, 1 do
      
      ObjSet("spr_gardendoor_lock_"..i,  { pos_x = -148 });
      
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_gardendoor.FocusMirror( num, inout )
  
  if inout == 0 then
    SetCursor( CURSOR_DEFAULT );
  else 
    SetCursor( CURSOR_GET );
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_gardendoor.ChooseMirror( num, need_c )
  
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_take_inventory");
  
  need_c = need_c or false;
  
  if private.zz_gardendoor.current_mirror == 0 then
    
    private.zz_gardendoor.vacant_place[1] = private.zz_gardendoor.state[1][num][1];
    private.zz_gardendoor.vacant_place[2] = private.zz_gardendoor.state[1][num][2];
    
  end;
  
  public.zz_gardendoor.FocusMirror( num, 0 );
  
  private.zz_gardendoor.current_mirror = num;
  
  if not need_c then
    
    private.zz_gardendoor.ConstructRays();
    
    local count, count2 = 0, 0;
    
    for i = 1, 4, 1 do
      if private.zz_gardendoor.state[2][i] == 1 then
        count = count + 1;
      end;
    end;
    
    count2 = count;
    
    for i = 1, 4, 1 do
      
      if private.zz_gardendoor.gems_checked[i] == 1 and private.zz_gardendoor.state[2][i] == 0 then
        private.zz_gardendoor.state[2][i] = 1;
        count2 = count2 + 1;
        ObjAnimate("spr_gardendoor_gem_"..i.."_on", "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 1 });
      elseif private.zz_gardendoor.gems_checked[i] == 0 and private.zz_gardendoor.state[2][i] == 1 then
        private.zz_gardendoor.state[2][i] = 0;
        count2 = count2 - 1;
        ObjAnimate("spr_gardendoor_gem_"..i.."_on", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 });
      end;
      
    end;
    
    if count2 < count then
      
      for i = count, count2+1, -1 do
        
        ObjAnimate("spr_gardendoor_lock_"..i, "pos_x", 0, 0, "", { 0, 0, -148,   0.2, 0, -172 });
        
      end;
      
    elseif count2 > count then
      
      for i = count+1, count2, 1 do
        
        ObjAnimate("spr_gardendoor_lock_"..i, "pos_x", 0, 0, "", { 0, 0, -172,   0.2, 0, -148 });
        
      end;
      
    end;
    
  end;
  
  ObjStartDrag("obj_gardendoor_game_drag");
  
  ObjAttach("spr_gardendoor_mirror_"..num, "obj_gardendoor_game_fly");
  
end;
-----------------------------------------------------------------------------------
function public.zz_gardendoor.DragMirror()
  
  local curspos = GetZoomCursorPos();
  curspos[1] = math.floor(curspos[1] - ObjGet("zz_gardendoor").pos_x + 54);
  curspos[2] = math.floor(curspos[2] - ObjGet("zz_gardendoor").pos_y + 15);
  
  if curspos[1] < private.zz_gardendoor.borders[1][1] then
    curspos[1] = private.zz_gardendoor.borders[1][1];
  elseif curspos[1] > private.zz_gardendoor.borders[1][2] then
    curspos[1] = private.zz_gardendoor.borders[1][2];
  end;
  
  if curspos[2] < private.zz_gardendoor.borders[2][1] then
    curspos[2] = private.zz_gardendoor.borders[2][1];
  elseif curspos[2] > private.zz_gardendoor.borders[2][2] then
    curspos[2] = private.zz_gardendoor.borders[2][2];
  end;
  
  curspos[1] = curspos[1]+private.zz_gardendoor.mirrors_dev[ private.zz_gardendoor.mirrors_type[ private.zz_gardendoor.current_mirror ] ][1];
  curspos[2] = curspos[2]+private.zz_gardendoor.mirrors_dev[ private.zz_gardendoor.mirrors_type[ private.zz_gardendoor.current_mirror ] ][2];
  
  ObjSet("spr_gardendoor_mirror_"..private.zz_gardendoor.current_mirror,  { pos_x = curspos[1], pos_y = curspos[2] });
  
end;
-----------------------------------------------------------------------------------
function public.zz_gardendoor.DropMirror()
  
  cmn.Lock(1);
  
  local num = private.zz_gardendoor.current_mirror;
  
  local curspos = GetZoomCursorPos();
  -- port feature
  if  tostring(GetPlatform()) == "android" then
    curspos[2] = curspos[2] - 100;
  elseif tostring(GetPlatform()) == "ios" then
    if port.isTablet() == 0 then
      curspos[2] = curspos[2] - 75;
    else
      curspos[2] = curspos[2] - 50;
    end;
  end;
  
  curspos[1] = math.floor(curspos[1] - ObjGet("zz_gardendoor").pos_x + 54);
  curspos[2] = math.floor(curspos[2] - ObjGet("zz_gardendoor").pos_y + 15);
  
  if curspos[1] < private.zz_gardendoor.borders[1][1] then
    curspos[1] = private.zz_gardendoor.borders[1][1];
  elseif curspos[1] > private.zz_gardendoor.borders[1][2] then
    curspos[1] = private.zz_gardendoor.borders[1][2];
  end;
  
  if curspos[2] < private.zz_gardendoor.borders[2][1] then
    curspos[2] = private.zz_gardendoor.borders[2][1];
  elseif curspos[2] > private.zz_gardendoor.borders[2][2] then
    curspos[2] = private.zz_gardendoor.borders[2][2];
  end;
  
  local pos = {0, 0};
  
  local mir_pos = {0, 0};
  mir_pos[1] = curspos[1]+private.zz_gardendoor.mirrors_dev[ private.zz_gardendoor.mirrors_type[ private.zz_gardendoor.current_mirror ] ][1];
  mir_pos[2] = curspos[2]+private.zz_gardendoor.mirrors_dev[ private.zz_gardendoor.mirrors_type[ private.zz_gardendoor.current_mirror ] ][2];
  
  for i = 1, #private.zz_gardendoor.grid_pos[1], 1 do
    for j = 1, #private.zz_gardendoor.grid_pos[2], 1 do

      if (curspos[1] > private.zz_gardendoor.grid_pos[1][i] - 30) and (curspos[1] < private.zz_gardendoor.grid_pos[1][i] + 30) and 
         (curspos[2] > private.zz_gardendoor.grid_pos[2][j] - 30) and (curspos[2] < private.zz_gardendoor.grid_pos[2][j] + 30) then

         pos[1] = i;
         pos[2] = j;
        break;
      end;

    end;
  end;
  
  local occup = 0;
  local forbid = false;
  
  if pos[1] ~= 0 then
    
    for i = 1, #private.zz_gardendoor.state[1], 1 do
      
      if private.zz_gardendoor.state[1][i][1] == pos[1] and private.zz_gardendoor.state[1][i][2] == pos[2] then
        occup = i;
        break;
      end;
      
    end;
    
    for i = 1, #private.zz_gardendoor.mirrors_forbidden, 1 do
      
      if private.zz_gardendoor.mirrors_forbidden[i][1] == pos[1] and private.zz_gardendoor.mirrors_forbidden[i][2] == pos[2] then
        forbid = true;
        break;
      end;
      
    end;
    
  end;
  
  --DbgTrace(pos[1].." "..pos[2].." "..occup);
  
  if pos[1] == 0 or ( pos[1] == private.zz_gardendoor.vacant_place[1] and pos[2] == private.zz_gardendoor.vacant_place[2] )
  or occup == 0 or forbid then
    
    if pos[1] == 0 or forbid then
      pos[1] = private.zz_gardendoor.vacant_place[1];
      pos[2] = private.zz_gardendoor.vacant_place[2];
    else 
      private.zz_gardendoor.state[1][num][1] = pos[1];
      private.zz_gardendoor.state[1][num][2] = pos[2];
    end;
    
    private.zz_gardendoor.current_mirror = 0;
    private.zz_gardendoor.vacant_place = {0, 0};
    
    local point_a, point_b = {}, {};
    point_a[1] = mir_pos[1];
    point_a[2] = mir_pos[2];
    point_b[1] = private.zz_gardendoor.grid_pos[1][ pos[1] ];
    point_b[2] = private.zz_gardendoor.grid_pos[2][ pos[2] ];
    local len = common_impl.math.FindSegmentLength( point_a, point_b );
    local tme = 0.002 * len;
    
    if tme > 0.4 then
      tme = 0.4;
    elseif tme < 0.1 then
      tme = 0.1;
    end;
    
    ObjAnimate("spr_gardendoor_mirror_"..num, "pos_xy", 0, 0, 
      function() 
        cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_part");
        private.zz_gardendoor.CheckStone( num, 0 ); 
      end, 
      { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] }
    );
    
  else 
    
    private.zz_gardendoor.current_mirror = occup;
    
    private.zz_gardendoor.state[1][ occup ][1] = private.zz_gardendoor.state[1][ num ][1];
    private.zz_gardendoor.state[1][ occup ][2] = private.zz_gardendoor.state[1][ num ][2];
    
    private.zz_gardendoor.state[1][ num ][1] = pos[1];
    private.zz_gardendoor.state[1][ num ][2] = pos[2];
    
    local point_a, point_b = {}, {};
    point_a[1] = mir_pos[1];
    point_a[2] = mir_pos[2];
    point_b[1] = private.zz_gardendoor.grid_pos[1][ pos[1] ];
    point_b[2] = private.zz_gardendoor.grid_pos[2][ pos[2] ];
    local len = common_impl.math.FindSegmentLength( point_a, point_b );
    local tme = 0.002 * len;
    
    if tme > 0.4 then
      tme = 0.4;
    elseif tme < 0.1 then
      tme = 0.1;
    end;
    
    ObjAnimate("spr_gardendoor_mirror_"..num, "pos_xy", 0, 0, 
      function() 
        cmn.PlayAudio("snd", "assets/levels/level1/rm_kitchen/audio/aud_xx_part");
        private.zz_gardendoor.CheckStone( num, private.zz_gardendoor.current_mirror ); 
      end, 
      { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] }
    );
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_gardendoor.CheckStone( num1, num2 )
  
  num2 = num2 or 0;
  local need_t = false;
  local anm_on = false;
  
  cmn.Lock(0); 
  ObjAttach("spr_gardendoor_mirror_"..num1, "obj_gardendoor_game_mirrors");
  
  if num2 > 0 then
    
    public.zz_gardendoor.ChooseMirror( num2, true );
    private.zz_gardendoor.ConstructRays();
    
    local count, count2 = 0, 0;
    
    for i = 1, 4, 1 do
      if private.zz_gardendoor.state[2][i] == 1 then
        count = count + 1;
      end;
    end;
    
    count2 = count;
    
    for i = 1, 4, 1 do
      
      if private.zz_gardendoor.gems_checked[i] == 1 and private.zz_gardendoor.state[2][i] == 0 then
        private.zz_gardendoor.state[2][i] = 1;
        count2 = count2 + 1;
        need_t = true;
        anm_on = true;
        ObjAnimate("spr_gardendoor_gem_"..i.."_on", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      elseif private.zz_gardendoor.gems_checked[i] == 0 and private.zz_gardendoor.state[2][i] == 1 then
        private.zz_gardendoor.state[2][i] = 0;
        count2 = count2 - 1;
        need_t = true;
        ObjAnimate("spr_gardendoor_gem_"..i.."_on", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      end;
      
    end;
    
    if count2 < count then
      
      for i = count, count2+1, -1 do
        
        ObjAnimate("spr_gardendoor_lock_"..i, "pos_x", 0, 0, "", { 0, 0, -148,   0.3, 0, -172 });
        
      end;
      
    elseif count2 > count then
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_xx_compartment");
      
      for i = count+1, count2, 1 do
        
        ObjAnimate("spr_gardendoor_lock_"..i, "pos_x", 0, 0, "", { 0, 0, -172,   0.3, 0, -148 });
        
      end;
      
    end;
    
    if anm_on then
      cmn.PlayAudio("snd", "assets/levels/level1/mg_memories/audio/aud_cloud_menter");
    end;
    
    if need_t then
      ObjSet("tmr_gardendoor_game_timer",  { time = 0.3, playing = 1, endtrig = function() cmn.Lock(0); end });
    else
      cmn.Lock(0);  
    end;
        
  else 
    
    private.zz_gardendoor.ConstructRays();
    
    local count, count2 = 0, 0;
    
    for i = 1, 4, 1 do
      if private.zz_gardendoor.state[2][i] == 1 then
        count = count + 1;
      end;
    end;
    
    count2 = count;
    
    for i = 1, 4, 1 do
      
      if private.zz_gardendoor.gems_checked[i] == 1 and private.zz_gardendoor.state[2][i] == 0 then
        private.zz_gardendoor.state[2][i] = 1;
        count2 = count2 + 1;
        need_t = true;
        anm_on = true;
        ObjAnimate("spr_gardendoor_gem_"..i.."_on", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      elseif private.zz_gardendoor.gems_checked[i] == 0 and private.zz_gardendoor.state[2][i] == 1 then
        private.zz_gardendoor.state[2][i] = 0;
        count2 = count2 - 1;
        need_t = true;
        ObjAnimate("spr_gardendoor_gem_"..i.."_on", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      end;
      
    end;
    
    if count2 < count then
      
      for i = count, count2+1, -1 do
        
        ObjAnimate("spr_gardendoor_lock_"..i, "pos_x", 0, 0, "", { 0, 0, -148,   0.3, 0, -172 });
        
      end;
      
    elseif count2 > count then
      
      cmn.PlayAudio("snd", "assets/levels/level1/rm_nearhome/audio/aud_xx_compartment");
      
      for i = count+1, count2, 1 do
        
        ObjAnimate("spr_gardendoor_lock_"..i, "pos_x", 0, 0, "", { 0, 0, -172,   0.3, 0, -148 });
        
      end;
      
    end;
    
    if anm_on then
      cmn.PlayAudio("snd", "assets/levels/level1/mg_memories/audio/aud_cloud_menter");
    end
    
    if need_t then
      ObjSet("tmr_gardendoor_game_timer",  { time = 0.3, playing = 1, endtrig = private.zz_gardendoor.CheckWin });
    else
      private.zz_gardendoor.CheckWin();  
    end;
    
  end;
  
  cmn.Lock(0); 
end;
-----------------------------------------------------------------------------------
function private.zz_gardendoor.ConstructRays()
  
  --DbgTrace("ConstructRays");
  
  private.zz_gardendoor.current_rays = {};
  
  private.zz_gardendoor.SearchRays();
  
  for i = 1, #private.zz_gardendoor.lights_on, 1 do
    
    if private.zz_gardendoor.lights_on[i] == 0 then
      ObjSet("spr_gardendoor_light_"..i,  { alp = 0 });
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_gardendoor.SearchRays()
  
  private.zz_gardendoor.lights_on = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  private.zz_gardendoor.gems_checked = {0, 0, 0, 0};
  
  --start searching from gems that are on
  for i = 1, #private.zz_gardendoor.gems_start, 1 do
    
    private.zz_gardendoor.SearchY( private.zz_gardendoor.gems_start[i], i );
    
  end;
  
end;
-----------------------------------------------------------------------------------
--dynamic search through mirrors
function private.zz_gardendoor.SearchY( point, color )
  
  local px, py, dir = point[1][1], point[1][2], point[2];
  local new_point = { {0, 0}, 0 };
  local mirrors = {};
  
  for i = 1, #private.zz_gardendoor.state[1], 1 do
    
    if px == private.zz_gardendoor.state[1][i][1] and private.zz_gardendoor.current_mirror ~= i
    and ( dir > 0 and py < private.zz_gardendoor.state[1][i][2] or dir < 0 and py > private.zz_gardendoor.state[1][i][2] ) then
    
      mirrors[ #mirrors+1 ] = i;
    
    end;
  
  end;
  
  local first, mir = 0, 0;
  
  if dir > 0 then
    first = 7;
  end;
  
  for i = 1, #mirrors, 1 do
    
    if ((dir > 0 and private.zz_gardendoor.state[1][ mirrors[i] ][2] < first) or (dir < 0 and private.zz_gardendoor.state[1][ mirrors[i] ][2] > first))
    and dir ~= private.zz_gardendoor.mirrors_dir[ private.zz_gardendoor.mirrors_type[ mirrors[i] ] ][2] then
      first = private.zz_gardendoor.state[1][ mirrors[i] ][2];
      mir = mirrors[i];
    end;
    
  end;
  
  local new_y = 0;
  
  --found mirror
  if first ~= 0 and first ~= 7 then
    
    new_y = private.zz_gardendoor.state[1][ mir ][2];
    
    new_point[1][1] = px;
    new_point[1][2] = private.zz_gardendoor.state[1][ mir ][2];
    new_point[2] = private.zz_gardendoor.mirrors_dir[ private.zz_gardendoor.mirrors_type[ mir ] ][1];
    
    --DbgTrace(first.." "..new_point[3]);
    
  end;
  
  if new_y == 0 and dir > 0 then
    new_y = 7;
  end;
  
  local loop_check = false;
  local check1, check2;
  if py < new_y then
    check1 = py;
    check2 = new_y;
  else 
    check1 = new_y;
    check2 = py;
  end;
  
  --проверяем параметры луча на существование - проверка на зацикленность
  for i = 1, #private.zz_gardendoor.current_rays, 1 do
    
    if private.zz_gardendoor.current_rays[i][1] == "y" and private.zz_gardendoor.current_rays[i][2] == check1 
    and private.zz_gardendoor.current_rays[i][3] == check2 and private.zz_gardendoor.current_rays[i][4] == px
    and private.zz_gardendoor.current_rays[i][5] == color  then
       loop_check = true;
       break;
    end;
    
  end;
   
  if not loop_check then
  
    local ray = 0;
    
    for i = 1, #private.zz_gardendoor.lights_on, 1 do
      
      if private.zz_gardendoor.lights_on[i] == 0 then
        ray = i;
        private.zz_gardendoor.lights_on[i] = 1;
        break;
      end;
      
    end;
    
    if ray > 0 then
      
      local end_py;
      if new_y == 0 then
        end_py = private.zz_gardendoor.end_pos[2][1];
      elseif new_y == 7 then
        end_py = private.zz_gardendoor.end_pos[2][2];
      else 
        end_py = private.zz_gardendoor.grid_pos[2][new_y];
      end;
      
      local r_scale = 1 + (math.abs(py - new_y)-1)*private.zz_gardendoor.ray_scale;
      local r_py = math.floor(math.abs( private.zz_gardendoor.grid_pos[2][py] - end_py )/2);
      if dir > 0 then
        r_py = private.zz_gardendoor.grid_pos[2][py] + r_py;
      else 
        r_py = end_py + r_py;
      end;
      
      --заносим параметры луча в таблицу
      local add_ray = {};
      add_ray[1] = "y";
      if py < new_y then
        add_ray[2] = py;
        add_ray[3] = new_y;
      else 
        add_ray[2] = new_y;
        add_ray[3] = py;
      end;
      add_ray[4] = px;
      add_ray[5] = color;
      
      table.insert( private.zz_gardendoor.current_rays, add_ray );
      
      --DbgTrace(color.." y "..r_py);
      
      ObjSet("spr_gardendoor_light_"..ray,  { 
        alp = private.zz_gardendoor.ray_alp, 
        color_r = private.zz_gardendoor.ray_color[color][1],
        color_g = private.zz_gardendoor.ray_color[color][2],
        color_b = private.zz_gardendoor.ray_color[color][3],
        scale_y = r_scale,
        pos_x = private.zz_gardendoor.grid_pos[1][px],
        pos_y = r_py,
        ang = 0
      });
      
    else 
      
      DbgTrace("rays out");
      return;
      
    end;
    
    if new_y == 0 or new_y == 7 then
      
      --DbgTrace(color.." "..new_y.. " "..private.zz_gardendoor.gems_end[ color ].." "..px);
      
      if new_y == 0 and private.zz_gardendoor.gems_end[ color ] == px then
        private.zz_gardendoor.gems_checked[ color ] = 1;
      end;
      
    else 
      
      private.zz_gardendoor.SearchX( new_point, color );
      
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
--dynamic search through mirrors
function private.zz_gardendoor.SearchX( point, color )
  
  local px, py, dir = point[1][1], point[1][2], point[2];
  local new_point = { {0, 0}, 0 };
  local mirrors = {};
  
  for i = 1, #private.zz_gardendoor.state[1], 1 do
    
    if py == private.zz_gardendoor.state[1][i][2] and private.zz_gardendoor.current_mirror ~= i
    and ( dir > 0 and px < private.zz_gardendoor.state[1][i][1] or dir < 0 and px > private.zz_gardendoor.state[1][i][1] ) then
    
      mirrors[ #mirrors+1 ] = i;
    
    end;
  
  end;
  
  local first, mir = 0, 0;
  
  if dir > 0 then
    first = 8;
  end;
  
  --DbgTrace(color.." "..#mirrors);
  
  for i = 1, #mirrors, 1 do
    
    --DbgTrace(color.." "..mirrors[i].." "..private.zz_gardendoor.mirrors_dir[ private.zz_gardendoor.mirrors_type[ mirrors[i] ] ][1].." "..dir);
    --DbgTrace(first.." "..private.zz_gardendoor.state[1][ mirrors[i] ][1]);
    
    if ((dir > 0 and private.zz_gardendoor.state[1][ mirrors[i] ][1] < first) or (dir < 0 and private.zz_gardendoor.state[1][ mirrors[i] ][1] > first))
    and dir ~= private.zz_gardendoor.mirrors_dir[ private.zz_gardendoor.mirrors_type[ mirrors[i] ] ][1] then
      --DbgTrace(color.." _1_ "..first);
      first = private.zz_gardendoor.state[1][ mirrors[i] ][1];
      mir = mirrors[i];
      --DbgTrace(color.." _2_ "..first);
    end;
    
  end;
  
  --DbgTrace(first);
  
  local new_x = 0;
  
  --found mirror
  if first ~= 0 and first ~= 8 then
    
    new_x = private.zz_gardendoor.state[1][ mir ][1];
    
    new_point[1][1] = private.zz_gardendoor.state[1][ mir ][1];
    new_point[1][2] = py;
    new_point[2] = private.zz_gardendoor.mirrors_dir[ private.zz_gardendoor.mirrors_type[ mir ] ][2];
    
  end;
  
  --DbgTrace(dir);
  
  if new_x == 0 and dir > 0 then
    new_x = 8;
  end;
  
  local loop_check = false;
  local check1, check2;
  if px < new_x then
    check1 = px;
    check2 = new_x;
  else 
    check1 = new_x;
    check2 = px;
  end;
  
  --проверяем параметры луча на существование - проверка на зацикленность
  for i = 1, #private.zz_gardendoor.current_rays, 1 do
    
    if private.zz_gardendoor.current_rays[i][1] == "x" and private.zz_gardendoor.current_rays[i][2] == check1 
    and private.zz_gardendoor.current_rays[i][3] == check2 and private.zz_gardendoor.current_rays[i][4] == py
    and private.zz_gardendoor.current_rays[i][5] == color then
       loop_check = true;
       break;
    end;
    
  end;
  
  if not loop_check then
  
    local ray = 0;
    
    for i = 1, #private.zz_gardendoor.lights_on, 1 do
      
      if private.zz_gardendoor.lights_on[i] == 0 then
        ray = i;
        private.zz_gardendoor.lights_on[i] = 1;
        break;
      end;
      
    end;
    
    if ray > 0 then
      
      --DbgTrace(color.." "..new_x);
      
      local end_px;
      if new_x == 0 then
        end_px = private.zz_gardendoor.end_pos[1][1];
      elseif new_x == 8 then
        end_px = private.zz_gardendoor.end_pos[1][2];
      else 
        end_px = private.zz_gardendoor.grid_pos[1][new_x];
      end;
      
      local r_scale = 1 + (math.abs(px - new_x)-1)*private.zz_gardendoor.ray_scale;
      local r_px = math.floor(math.abs( private.zz_gardendoor.grid_pos[1][px] - end_px )/2);
      if dir > 0 then
        r_px = private.zz_gardendoor.grid_pos[1][px] + r_px;
      else 
        r_px = end_px + r_px;
      end;
      
      --заносим параметры луча в таблицу
      local add_ray = {};
      add_ray[1] = "x";
      if px < new_x then
        add_ray[2] = px;
        add_ray[3] = new_x;
      else 
        add_ray[2] = new_x;
        add_ray[3] = px;
      end;
      add_ray[4] = py;
      add_ray[5] = color;
      
      table.insert( private.zz_gardendoor.current_rays, add_ray );
      
      ObjSet("spr_gardendoor_light_"..ray,  { 
        alp = private.zz_gardendoor.ray_alp, 
        color_r = private.zz_gardendoor.ray_color[color][1],
        color_g = private.zz_gardendoor.ray_color[color][2],
        color_b = private.zz_gardendoor.ray_color[color][3],
        scale_y = r_scale,
        pos_x = r_px,
        pos_y = private.zz_gardendoor.grid_pos[2][py],
        ang = 1.57
      });
      
    else 
      
      DbgTrace("rays out");
      return;
      
    end;
    
    if new_x ~= 0 and new_x ~= 8 then
      
      private.zz_gardendoor.SearchY( new_point, color );
      
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_gardendoor.CheckWin()
  
  local win_flag = true;
  
  for i = 1, #private.zz_gardendoor.state[2], 1 do
    
    if private.zz_gardendoor.state[2][i] == 0 then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("gardendoor");
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
    cmn.PlayAudio("snd", "assets/levels/level3/rm_witchhouse/audio/aud_xx_opn_door");
    
    ObjAnimate("obj_gardendoor_game", "alp", 0, 0, private.zz_gardendoor.Win, { 0, 0, 1,   1, 0, 1,    1.5, 0, 0 });
    ObjAnimate("obj_gardendoor_locks", "alp", 0, 0, "", { 0, 0, 1,   1, 0, 1,    1.5, 0, 0 });
    
  else 
    
    cmn.Lock( 0 );
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_gardendoor.Win()
  
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_gardendoor" );
  cmn.CallEventHandler( "win_gardendoor" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_gardendoor" ].skip == 0 and ng_global.noskipgames[ "win_gardendoor" ] == nil then

    ng_global.noskipgames[ "win_gardendoor" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

  cmn.Lock( 0 );
  common.CloseSubRoom();
  
end;
-----------------------------------------------------------------------------------
--**********************************************************************************************************