-- name=mg_angels
--*********************************************************************************************************************
function public.Init()

  --карта координат, слой, масштаб
  --первый прямоугольник
  private.map_1 = {
    { 529, 136, 1, 0.68 }, 
    { 461, 174, 2, 0.72 },
    { 399, 201, 3, 0.76 }, 
    { 323, 242, 4, 0.8  }, 
    { 245, 280, 5, 0.84 }, 
    { 157, 329, 6, 0.88 },
    { 224, 384, 7, 0.92 }, 
    { 297, 442, 8, 0.96 }, 
    { 374, 503, 9, 1    }, 
    { 464, 444, 8, 0.96 },
    { 552, 380, 7, 0.92 }, 
    { 616, 327, 6, 0.88 }, 
    { 685, 284, 5, 0.84 }, 
    { 745, 243, 4, 0.8  },
    { 670, 201, 3, 0.76 }, 
    { 597, 168, 2, 0.72 }
  };

  --второй прямоугольник
  private.map_2 = {
    { 403, 135, 1, 0.68 }, 
    { 461, 174, 2, 0.72 },
    { 534, 207, 3, 0.76 }, 
    { 610, 249, 4, 0.8  }, 
    { 685, 284, 5, 0.84 }, 
    { 774, 327, 6, 0.88 }, 
    { 709, 380, 7, 0.92 }, 
    { 637, 444, 8, 0.96 }, 
    { 555, 501, 9, 1    }, 
    { 464, 444, 8, 0.96 }, 
    { 384, 383, 7, 0.92 }, 
    { 316, 329, 6, 0.88 }, 
    { 245, 280, 5, 0.84 }, 
    { 183, 241, 4, 0.8  }, 
    { 264, 197, 3, 0.76 }, 
    { 336, 165, 2, 0.72 }
  };

  --карта выйгрыша, 1 - купидоны, 2 - импы
  private.win_map =   { 1, 2, 2, 2, 2, 1, 1, 1, 1, 2, 2, 2, 2, 1, 1, 1 };

  --начальная карта
  private.start_map = { 2, 1, 1, 1, 1, 2, 2, 2, 2, 1, 1, 1, 1, 2, 2, 2 };

  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_angels";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_ornament2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_ornament2" ] = {
        type = "get",
        get_obj = "spr_angels_ornament2",
        room = "rm_nearnurseshouse",
        zz = "mg_angels",
        zz_gate = "gmg_nearnurseshouse_angels"
    };
    --------------------------------------------------------------------------------------------
  local get_ornament2_inv = function ()
  
    interface.InventoryItemAdd( "inv_ornament2", "spr_angels_ornament2" );
  
  end;
  
  local get_ornament2_end = function ()
  
    ObjDelete( "gfx_angels_ornament2" );

  end;
  local get_ornament2_loc = function ()

    if cmn.IsEventDone("get_newspaperpiece2") then
      ObjDelete( "gmg_nearnurseshouse_angels" );
    end;

  end;
  cmn.AddSubscriber( "get_ornament2", get_ornament2_inv );
  cmn.AddSubscriber( "get_ornament2", get_ornament2_end, private.room_objname );
  cmn.AddSubscriber( "get_ornament2", get_ornament2_loc, "rm_nearnurseshouse" );
  --------------------------------------------------------------------------------------------
  -- function get_newspaperpiece2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_newspaperpiece2" ] = {
        type = "get",
        get_obj = "spr_angels_newspaperpiece2",
        room = "rm_nearnurseshouse",
        zz = "mg_angels",
        zz_gate = "gmg_nearnurseshouse_angels"
    };
    --------------------------------------------------------------------------------------------
  local get_newspaperpiece2_inv = function ()
  
    interface.InventoryItemAdd( "inv_newspaperpiece", "spr_angels_newspaperpiece2", function () cmn.GetMultyObject( 'newspaperpiece', 4 ); end );
    
    if cmn.CheckMultiObject( "newspaperpiece", 4 ) then
      ObjSet("inv_burntnewspaper_star_light",  { alp = 1 });
    end;
  
  end;
  
  local get_newspaperpiece2_end = function ()
  
    ObjDelete( "gfx_angels_newspaperpiece2" );

  end;
  local get_newspaperpiece2_loc = function ()

    if cmn.IsEventDone("get_ornament2") then
      ObjDelete( "gmg_nearnurseshouse_angels" );
    end;

  end;
  cmn.AddSubscriber( "get_newspaperpiece2", get_newspaperpiece2_inv );
  cmn.AddSubscriber( "get_newspaperpiece2", get_newspaperpiece2_end, private.room_objname );
  cmn.AddSubscriber( "get_newspaperpiece2", get_newspaperpiece2_loc, "rm_nearnurseshouse" );
  --------------------------------------------------------------------------------------------
  -- function win_angels () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_angels" ] = {
    type = "win",
    room = "rm_nearnurseshouse",
    zz = "mg_angels",
    zz_gate = "gmg_nearnurseshouse_angels"
  };
  --------------------------------------------------------------------------------------------
  local win_angels = function ()

    if cmn.IsEventDone( "win_angels" ) then

      ObjDelete( "obj_angels_btn_angel" );
      ObjDelete( "obj_angels_btn_demon" );
      ObjDelete( "obj_angels_btn_2" );
      ObjDelete( "obj_angels_btn_1" );

      ObjMultiSet( { { "spr_angels_ornament2", { input = true } },
                     { "spr_angels_newspaperpiece2", { input = true } },
                     { "anm_angels_open_cover", { frame = 120 } } } );

    end;

  end;
  local win_angels_loc = function ()

    if cmn.IsEventDone( "win_angels" ) then
      ObjSet("spr_nearnurseshouse_figurines_niche",  { alp = 1 });
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_angels", win_angels, "mg_angels" );
  cmn.AddSubscriber( "win_angels", win_angels_loc, "rm_nearnurseshouse" );
  
end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_angels" ].state or ng_global.currentprogress == "secret" then
    private.StartConditions();
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_angels" ].state;

end;
--*********************************************************************************************************************
function public.Open() 
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_mg_mus_env", 1);

  if ng_global.currentprogress == "ext" and not cmn.IsEventDone( "win_angels" ) then
    cmn.MiniGameShow();
    private.CheckWin();
    cmn.StartTimePassing("mg_angels");
  elseif ng_global.currentprogress == "secret" then 
    rm_extra.MiniGameShow();
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio4/aud_lvl4nearhospital_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio4/aud_lvl4nearhospital_env");

  if ng_global.currentprogress == "ext" then
    common.SetPreviousRoom( "rm_nearnurseshouse" );
  else 
    
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_angels" ].state;
    
    ObjSet("grm_angels_nearnurseshouse",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                            event_menter = function () rm_extra.GateMouseEnter( "angels_nearnurseshouse", CURSOR_DOWN, "extra" ); end, 
                                            event_mleave = function () common_impl.GateMouseLeave( "angels_nearnurseshouse" ); end });
    
  end;
  
  ObjSet("obj_int_button_info",{ pos_y = -400 });
  private.DrawScene();
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  
  ObjSet("obj_int_button_info",{ pos_y = 0 });
  
  cmn.StopAllMus();
  if ng_global.currentprogress == "ext" then
    common_impl.PlayBackgroundMusic();
  end;

  if ng_global.currentprogress == "ext" and not cmn.IsEventDone( "win_angels" ) then
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_boxdoors" )) then
    rm_extra.MiniGameHide();
  end;
  
end;
--*********************************************************************************************************************
function public.Reset()

  --DbgTrace( "***Reset" );

  local go_reset = false;

  local fig_animfunc;

  for j = 1, 2, 1 do

    for i = 1, 16, 1 do

      if ( private.state[j][i][2] ~= private.start_map[i] ) then  --если отличаетса от начальной карты

        --DbgTrace( private.state[j][i][1].." - "..private.state[j][i][2].." ~= "..private.start_map[i] );

        go_reset = true;

        fig_animfunc = (private.start_map[i] == 1) and "func_imp_transform_cupid" or "func_cupid_transform_imp";

        ObjSet( "anm_angels_fig_"..private.state[j][i][1], { animfunc = fig_animfunc, playing = true } );

        private.state[j][i][2] = private.start_map[i];

      end;

    end;

  end;

  if ( go_reset ) then

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/mg_angels/audio/aud_fire_angels");

    ObjSet( "tmr_angels_animlock", { time = 2.7, endtrig = function () cmn.Lock( 0 ); end, playing = true } );

  end;

end;
--*********************************************************************************************************************
function public.Skip()

  --DbgTrace( "***Skip" );

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/mg_angels/audio/aud_fire_angels");

  ng_global.progress[ ng_global.currentprogress ][ "win_angels" ].skip = 1;

  local fig_animfunc;

  for j = 1, 2, 1 do

    for i = 1, 16, 1 do

      if ( private.state[j][i][2] ~= private.win_map[i] ) then  --если отличаетса от выйгришной карты

        --DbgTrace( private.state[j][i][1].." - "..private.state[j][i][2].." ~= "..private.win_map[i] );

        fig_animfunc = (private.win_map[i] == 1) and "func_imp_transform_cupid" or "func_cupid_transform_imp";

        ObjSet( "anm_angels_fig_"..private.state[j][i][1], { animfunc = fig_animfunc, playing = true } );

        private.state[j][i][2] = private.win_map[i];

      end;

    end;

  end;

  ObjSet( "tmr_angels_animlock", { time = 2.7, endtrig = private.CheckWin, playing = true } );

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function public.get_ornament2()

  cmn.SetEventDone( "get_ornament2" );
  cmn.CallEventHandler( "get_ornament2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_newspaperpiece2") then
    cmn.GotoRoom("rm_nearnurseshouse");
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_newspaperpiece2()

  cmn.SetEventDone( "get_newspaperpiece2" );
  cmn.CallEventHandler( "get_newspaperpiece2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_ornament2") then
    cmn.GotoRoom("rm_nearnurseshouse");
  end;

end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_angels" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_angels" ].state = {

    --номер обьекта, 1 - купидоны, 2 - импы
    --первый прямоугольник
    { {  1, 2 }, { 14, 1 }, { 13, 1 }, { 12, 1 }, { 11, 1 }, { 24, 2 }, { 23, 2 }, { 22, 2 },
      { 21, 2 }, {  8, 1 }, {  7, 1 }, {  6, 1 }, {  5, 1 }, {  4, 2 }, {  3, 2 }, {  2, 2 }
    },

    --второй прямоугольник
    { { 28, 2 }, { 14, 1 }, { 15, 1 }, { 16, 1 }, {  5, 1 }, { 17, 2 }, { 18, 2 }, { 19, 2 },
      { 20, 2 }, {  8, 1 }, {  9, 1 }, { 10, 1 }, { 11, 1 }, { 25, 2 }, { 26, 2 }, { 27, 2 }
    }

  };

end;
-----------------------------------------------------------------------------------
function private.DrawScene()

  --DbgTrace( "***DrawScene" );

  local fig_name;
  local fig_animfunc;
  local map;

  for j = 1, 2, 1 do

    map = "map_"..j;

    for i = 1, 16, 1 do

      fig_name = "anm_angels_fig_"..private.state[j][i][1];
      fig_animfunc = (private.state[j][i][2] == 1) and "func_cupid_transform_cupid" or "func_imp_transform_imp";

      ObjSet( fig_name, {
        animfunc = fig_animfunc,
        pos_x = private[ map ][i][1],
        pos_y = private[ map ][i][2],
        pos_z = private[ map ][i][3],
        scale_x = private[ map ][i][4],
        scale_y = private[ map ][i][4]
      } );

      ObjAttach( fig_name, "obj_angels_figs" );

    end;

  end;

end;
-----------------------------------------------------------------------------------
function private.CheckWin()

  --DbgTrace( "***CheckWin" );

  cmn.Lock( 1 );

  for j = 1, 2, 1 do
    for i = 1, 16, 1 do
      if ( private.state[j][i][2] ~= private.win_map[i] ) then
        --DbgTrace( private.state[j][i][1].." - "..private.state[j][i][2].." ~= "..private.win_map[i] );
        cmn.Lock( 0 );
        return;
      end;
    end;
  end;

  --DbgTrace( "WWWWWWWIIIIIINNNNNNNNN" );
  private.Win();

end;
-----------------------------------------------------------------------------------
function private.WinEnd()

  cmn.Lock( 0 );
  cmn.SetEventDone( "win_angels" );
  
  if ng_global.currentprogress == "ext" then
  
    cmn.CallEventHandler( "win_angels" );

    if ng_global.progress[ ng_global.currentprogress ][ "win_angels" ].skip == 0 and not ng_global.noskipgames[ "win_angels" ] then

      ng_global.noskipgames[ "win_angels" ] = 1;
      common_impl.CheckAchiev("mg");

    end;

    if ng_global.playedgames and not ng_global.playedgames[ "win_angels" ] then
      ng_global.playedgames[ "win_angels" ] = 1;
    end;

    common_impl.PauseAchiev( 0 );
    
  else 
    interface_impl.ShowStarsWindow();
  end;

end;
-----------------------------------------------------------------------------------
function private.Win()
  
  if ng_global.currentprogress == "ext" then

    cmn.MiniGameHide();
    
    cmn.PlayAudio("snd", "assets/levels/common/audio/aud_win_mg");
    cmn.PlayAudio("snd", "assets/levels/level4/mg_angels/audio/aud_opn_angels_safe");

    common_impl.PauseAchiev( 1 );
    cmn.EndTimePassing( "mg_angels" );

    ObjSet( "anm_angels_open_cover", { endtrig = private.WinEnd, playing = true } );
    
  else 
    rm_extra.MiniGameHide();
    int_dialog_secretroom.StopTimer();
    private.WinEnd();
  end;

end;
-----------------------------------------------------------------------------------
function public.BtnClick( side )

  --DbgTrace( "***BtnClick "..side );

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/mg_angels/audio/aud_move_angels");

  ObjSet( "anm_angels_btn_"..side, { endtrig = private.CheckWin, playing = true } );

  local fig_name;

  local last_fig_num  = private.state[ side ][16][1];
  local last_fig_type = private.state[ side ][16][2];

  local map = "map_"..side;

  for i = 15, 1, -1 do

    fig_name = "anm_angels_fig_"..private.state[ side ][i][1];

    ObjSet( fig_name, { pos_z = private[ map ][i+1][3] } );
    ObjAnimate( fig_name, "pos_xy", 0, 0, "", {
      0  , 0, private[ map ][i][1],   private[ map ][i][2],
      0.4, 0, private[ map ][i+1][1], private[ map ][i+1][2]
    } );
    ObjAnimate( fig_name, "scale_xy", 0, 0, "", {
      0  , 0, private[ map ][i][4],   private[ map ][i][4],
      0.4, 0, private[ map ][i+1][4], private[ map ][i+1][4]
    } );

    private.state[ side ][i+1][1] = private.state[ side ][i][1];
    private.state[ side ][i+1][2] = private.state[ side ][i][2];

  end;

  private.state[ side ][1][1] = last_fig_num;
  private.state[ side ][1][2] = last_fig_type;

  fig_name = "anm_angels_fig_"..last_fig_num;

  ObjSet( fig_name, { pos_z = private[ map ][1][3] } ); --последняя фигурка идет на первое место
  ObjAnimate( fig_name, "pos_xy", 0, 0, "", {
    0  , 0, private[ map ][16][1], private[ map ][16][2],
    0.4, 0, private[ map ][1][1],  private[ map ][1][2]
  } );
  ObjAnimate( fig_name, "scale_xy", 0, 0, "", {
    0  , 0, private[ map ][16][4], private[ map ][16][4],
    0.4, 0, private[ map ][1][4],  private[ map ][1][4]
  } );

  local side_2 = ( side == 1 ) and 2 or 1;

  private.state[side_2][2][1]  = private.state[side][2][1]; --переносим значения для общих ячеек двух прямоугольников
  private.state[side_2][2][2]  = private.state[side][2][2];
  
  private.state[side_2][13][1] = private.state[side][5][1];
  private.state[side_2][13][2] = private.state[side][5][2];

  private.state[side_2][10][1] = private.state[side][10][1];
  private.state[side_2][10][2] = private.state[side][10][2];

  private.state[side_2][5][1]  = private.state[side][13][1];
  private.state[side_2][5][2]  = private.state[side][13][2];

end;
-----------------------------------------------------------------------------------
function public.StatueClick( num )

  --DbgTrace( "***StatueClick "..num );

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/mg_angels/audio/aud_fire_angels");

  local fig_animfunc;
  local changed_fig = {}; --таблица с фигурками, для которых меняем тип

  for i = 6, 9, 1 do

    if private.state[ num ][i][2] == num then
      fig_animfunc = (num == 1) and "func_cupid_transform_cupid" or "func_imp_transform_imp";
    else
      fig_animfunc = (num == 1) and "func_imp_transform_cupid" or "func_cupid_transform_imp";
    end;

    --DbgTrace( private.state[ num ][i][1].." - "..private.state[ num ][i][2] );

    table.insert( changed_fig, { private.state[ num ][i][1], fig_animfunc } );

    private.state[ num ][i][2] = num;

  end;

  ObjSet( "anm_angels_statue_"..num, { playing = true, endtrig = private.CheckWin } );
  ObjSet( "tmr_angels_animlock", { time = 1, endtrig = function () private.StatueClickEnd( changed_fig ); end, playing = true } );

end;
-----------------------------------------------------------------------------------
function private.StatueClickEnd( changed_fig )

  --DbgTrace( "***StatueClickEnd" );

  local fig_name;

  for i = 1, #changed_fig, 1 do

    fig_name = "anm_angels_fig_"..changed_fig[i][1];

    ObjSet( fig_name, { animfunc = changed_fig[i][2], playing = true } );

    --DbgTrace( changed_fig[i][1].." - "..changed_fig[i][2] );

  end;

end;
-----------------------------------------------------------------------------------
function public.FocusBtn( obj, inout )--анимация фокуса
  
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
  end;

  ObjAnimate( obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout } );

end;
--*********************************************************************************************************************