-- name=level4

function public.Start ( param )

  game.play_hint_aud = false;

  interface.WidgetAdd( InterfaceWidget_Pause, 1800 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 10 );
  interface.WidgetAdd( InterfaceWidget_BtnGuide, 6 );

  interface.WidgetAdd( InterfaceWidget_BtnHint, 4  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 5 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 6 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 7 );

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 0 );

  interface.WidgetAdd( InterfaceWidget_TaskHeader, 1 );
  interface.WidgetAdd( InterfaceWidget_Inventory, 2 );
  --interface.WidgetAdd( InterfaceWidget_TaskPanel );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 3, "assets/interface/int_taskpanel");

  interface.WidgetAdd( InterfaceWidget_Effects, 50 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 4 );

  interface.WidgetAdd( InterfaceWidget_DialogHo, 260 );

  interface.ButtonLockAdd();

  interface.WidgetAdd( InterfaceWidget_ItemPanel, 3, "assets/interface/int_itempanel" );
  interface.WidgetAdd( InterfaceWidget_Popup, 250 );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog );

  interface.WidgetAdd( InterfaceWidget_DialogVideo, 300 );
  --interface.WidgetAdd( InterfaceWidget_DialogStory );
  --interface.WidgetAdd( InterfaceWidget_DialogCharacter, 900 );

  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial, 310 );

  interface.WidgetAdd( InterfaceWidget_Map, 200 );

  interface.PanelNotificationAdd();
  interface.ComplexInvAdd();
  interface_impl.DialogHintAdd();
  
  interface_impl.GlobalTaskAdd();
  
  --уникальный виджет левела
  interface_impl.CluesPanelAdd();
  
  --обнуление списков добавленных и собранных улик
  ng_global.clues = {};
  ng_global.clues_found = {};
  
  ------------------------------------------------------
  if IsCollectorsEdition() or IsSurveyEdition() then
  
    ModLoad( "assets/levels/menu/rm_achievements/mod_achievements" );
    rm_achievements.Init();
  
    ModLoad( "assets/levels/menu/rm_collectable/mod_collectable" );
    rm_collectable.Init();

    interface_impl.AchievAdd();
    interface_impl.PopupAchievementAdd();

    interface_impl.BonusAdd();
  
  end;
  ------------------------------------------------------
  if IsCollectorsEdition() then
  
    interface.WidgetAdd( InterfaceWidget_StrategyGuide );
  
  end;
  ------------------------------------------------------
  
  --переменная для того, чтобы из титров не выкидывало в меню
  public.in_progress = true;
  --
  private.Init();
  --
  int_map_impl.CreateRooms( "level4" );

  ModLoad( "assets/levels/level4/mod_inventory4" );
  inventory4.Init();
  
  --ModLoad( "assets/levels/menu/rm_endroom/mod_endroom" );
  --rm_endroom.Init();
  
  ModLoad( "assets/levels/menu/rm_credits/mod_credits" );
  rm_credits.Init();

  common.LevelLoad( "level4", "ext", "mg_trollrift", param );
  ng_global.progress[ "ext" ].common.gamestart = true;
  
  common_impl.PlayBackgroundMusic();

  common_impl.DialogCustomUpdate();
  interface_impl.RemoveFlowersTotal();
  cmn.RemoveCollectable();

  game.play_hint_aud = true;

  common_impl.is_in_map = 0;

  ng_global.new_hint = false;

end;
    
function private.Init ()

  game.room_names =
  {
    
     "mg_trollrift"
    ,"rm_neargingerbreadhouse"
    ,"rm_ingingerbreadhouse"
    ,"rm_lvl4nearhospital"
    ,"rm_lvl4corridor" 
    ,"rm_serviceroom"
    ,"rm_ward"
    ,"rm_nearnurseshouse"
    ,"rm_insophiashouse"
    
    ,"ho_introllscave"
    ,"ho_honorary"
    ,"ho_pumpkins"
    ,"ho_dogarea"
    
    ,"mg_boxdoors"
    ,"mg_angels"
    ,"ho_lvl4memories"
    
  };
  
  --имена диалогов с подбором предмета (для удаления gfx в кастом моде)
  game.dlg_witems_names =
  {
    "obj_ingingerbreadhouse_dialog_faerie1",
    "obj_ward_dialog_anna1",
    "obj_ward_dialog_anna2",
    "obj_ward_dialog_anna3",
    "obj_ward_dialog_anna4"
  };
  
  --таблица с координатами открытия зз
  game.zz_end_pos = {

    [ "zz_trollstatue" ] = {450, 340},
    [ "zz_crystals" ] = {390, 360},
    [ "zz_housewindow" ] = {590, 330},
    [ "zz_skeleton" ] = {600, 370},
    
    [ "zz_spikedbush" ] = {390, 370},
    [ "zz_trollcave" ] = {590, 330},
    [ "zz_well" ] = {600, 360},
    
    [ "zz_magiccrib" ] = {400, 330},
    
    [ "zz_lvl4flowerbed" ] = {450, 360},
    [ "zz_emergencycarcab" ] = {390, 350},
    [ "zz_nest" ] = {590, 340},
    [ "zz_staging" ] = {600, 350},
    
    [ "zz_walloffame" ] = {280, 320},
    [ "zz_tvsetunit" ] = {520, 340},
    [ "zz_lvl4warddoor" ] = {670, 320},
    [ "zz_serviceroomdoor" ] = {620, 330},
    
    [ "zz_volunteersstuff" ] = {512, 360},
    [ "zz_sophiesbox" ] = {340, 330},
    [ "zz_cardindex" ] = {600, 320},
    
    [ "zz_lvl4clock" ] = {500, 320},
    [ "zz_foodtray" ] = {380, 340},
    [ "zz_drawerunit" ] = {600, 360},
    
    [ "zz_lvl4housedoor" ] = {420, 300},
    [ "zz_postbox" ] = {390, 360},
    [ "zz_bench" ] = {560, 340},
    [ "zz_jackpumpkin" ] = {600, 350},
    [ "zz_figurines" ] = {580, 320},
    
    [ "zz_abovefireplace" ] = {450, 320},
    [ "zz_undersofa" ] = {390, 360},
    [ "zz_lvl4chest" ] = {560, 340},
    [ "zz_phonetable" ] = {600, 370}
    
  };

-- 1 - открыта
-- 2 - таски выполнены
-- 3 - кол-во тасков
-- 4 блокирована
  game.map_rooms = {
    [ "mg_trollrift" ] =            { 1, 0, 2, 0, 2 },
    [ "rm_neargingerbreadhouse" ] = { 0, 0, 2, 0, 3 },
    [ "rm_ingingerbreadhouse" ]   = { 0, 0, 99, 0, 0 },
    [ "rm_lvl4nearhospital" ] =     { 0, 0, 1, 0, 2 },
    [ "rm_lvl4corridor" ] =         { 0, 0, 2, 0, 4 },
    [ "rm_serviceroom" ] =          { 0, 0, 5, 0, 1 },
    [ "rm_ward" ] =                 { 0, 0, 1, 0, 2 },
    [ "rm_nearnurseshouse" ] =      { 0, 0, 2, 0, 1 },
    [ "rm_insophiashouse" ] =       { 0, 0, 99, 0, 4 }
  };

  --таблицы для динамического хинта
  --таблица для юзов на предметы, получаемые в хо и мультиюзов
  game.progress_multyuse =
  {
   
    {"use_bucket", "win_introllscave"},
    {"use_pictureinframe", "win_honorary"},
    
    {"use_wrenchdogcase", "get_wrench"},
    {"use_wrenchclock", "get_wrench"},
    
    {"use_sharpstonetravelersbag", "get_sharpstone"},
    {"use_sharpstonedirtytorch", "get_sharpstone"},
    
    {"use_tongsfoodtray", "get_tongs"},
    {"use_tongsbench", "get_tongs"},
    
    {"use_hobone1", "use_curtaintieback2"},
    {"use_hobone2", "use_curtaintieback2"},
    {"use_hobone3", "use_curtaintieback2"},
    {"use_hobone4", "use_curtaintieback2"},
    {"use_hodogpart1", "use_curtaintieback2"},
    {"use_hodogpart2", "use_curtaintieback2"},
    {"use_hodogpart3", "use_curtaintieback2"},
    {"use_hodogpart4", "use_curtaintieback2"}
    
  };

  --таблица на мультипредметы с количеством их частей
  game.progress_multyobj =
  {
    {"use_lvl4bolt", 2},
    {"use_runestone", 3},
    {"use_newspaperpiece", 4},
    {"use_badgepart", 2},
    {"use_lockpart", 2},
    {"use_puzzlepart", 4},
    {"use_shellpart", 3}
  };

  --таблица на юзы, разблокирующиеся другими юзами или кликами
  game.progress_blockeduse =
  {
    
    {"use_lvl4coin", "use_lvl4screws"},
    {"use_medicalhammer", "use_brush"},
    {"use_brush", "use_salammoniac"},
    {"use_umbrella", "use_lifestaramulet"},
    {"clk_medkitopen", "use_umbrella"},
    {"use_antirust", "clk_medkitopen"},
    {"use_collectionstamp1", "use_pandaseye"},
    {"use_collectionstamp2", "use_pandaseye"},
    {"use_zipperrunner", "use_boxkey"},
    {"use_stetoscopeamulet", "use_boxkey"},
    {"win_cardindex", "use_matches"},
    {"use_unfinishedsocks", "get_puzzlepart4"},
    {"use_knittingneedles", "get_puzzlepart4"},
    {"use_woolball", "get_puzzlepart4"},
    {"use_lvl4pen", "get_socksforsophia"},
    {"use_lvl4notebook", "get_socksforsophia"},
    {"use_duster", "use_pegs"}

  };

  game.progress_names =
  {
    "beg_level4"
    ,"get_travelersbag"
    ,"get_runestone1"
    ,"get_sharpstone"
    ,"opn_trollstatue"
    ,"get_pegs"
    ,"use_sharpstonetravelersbag"
    ,"get_sculptorsset"
    ,"use_sculptorsset"
    ,"win_trollrift"
    
    ,"opn_neargingerbreadhouse"
    ,"get_duster"
    ,"get_firestone"
    ,"use_pegs"
    ,"use_duster"
    ,"get_dirtytorch"
    ,"clk_dirtytorchopen"
    ,"use_sharpstonedirtytorch"
    ,"use_firestone"
    ,"get_lvl4torch"
    ,"use_lvl4torch"
    ,"win_introllscave"
    ,"use_bucket"
    ,"get_fullwateringcan"
    ,"get_runestone2"
    ,"use_fullwateringcan"
    ,"get_hotwater"
    ,"use_hotwater"
    
    ,"opn_ingingerbreadhouse"
    ,"opn_magiccrib"
    ,"get_runestone3"
    ,"use_runestone"
    ,"win_trollstatue"
    ,"get_pyramid"
    ,"get_lvl4wings"
    ,"use_pyramid"
    ,"get_gargoylecuffs"
    ,"get_eaglefeather"
    ,"use_gargoylecuffs"
    ,"get_keybunch"
    ,"win_keybunch"
    ,"get_cagekey"
    ,"use_cagekey"
    
    ,"opn_lvl4nearhospital"
    ,"clk_leaflet"
    ,"clk_boxestomachine1"
    ,"clk_boxestomachine2"
    ,"clk_boxestomachine3"
    ,"get_float"
    ,"use_float"
    ,"get_lifestaramulet"
    ,"use_lifestaramulet"
    ,"get_salammoniac"
    ,"get_lvl4coin"
    ,"use_salammoniac"
    ,"get_lvl4screws"
    ,"get_needle"
    ,"use_lvl4screws"
    ,"use_lvl4coin"
    
    ,"opn_lvl4corridor"
    ,"get_umbrella"
    ,"get_jackshead"
    ,"get_brush"
    ,"use_umbrella"
    ,"clk_medkitopen"
    ,"get_medicalhammer"
    ,"get_puzzlepart1"
    ,"use_brush"
    ,"use_medicalhammer"
    ,"get_smallkey"
    ,"get_lvl4wire"
    ,"use_smallkey"
    ,"win_honorary"
    ,"get_lvl4button"
    ,"get_charitypicture"
    ,"use_lvl4wire"
    ,"use_lvl4button"
    ,"clk_lvl4button"
    
    ,"opn_serviceroom"
    ,"opn_volunteersstuff"
    ,"get_puzzlepart2"
    ,"get_antirust"
    ,"get_catshead"
    ,"use_jackshead"
    ,"use_catshead"
    ,"win_tvsetunit"
    ,"get_puzzlepart3"
    ,"get_pandaseye1"
    ,"use_antirust"
    ,"get_bigsyringe"
    ,"get_badgepart1"
    ,"clk_openpackage"
    ,"clk_removeneedlecover"
    ,"clk_putneedleontosyringe"
    ,"get_syringewithneedle"
    ,"use_syringewithneedle"
    
    ,"opn_ward"
    ,"clk_wardfirst"
    ,"get_pandaseye2"
    ,"use_pandaseye1"
    ,"use_pandaseye2"
    ,"use_pandaseye"
    ,"get_tornoffpatch"
    ,"get_rubbergloves"
    ,"use_rubbergloves"
    ,"get_badgepart2"
    ,"use_badgepart"
    ,"get_yellowthread"
    ,"get_lvl4pen"
    ,"use_yellowthread"
    ,"use_needle"
    ,"win_tornoffpatch"
    ,"get_volunteersign"
    ,"use_volunteersign"
    ,"get_puzzlepart4"
    ,"use_puzzlepart"
    ,"win_boxdoors"
    ,"get_unfinishedsocks"
    ,"get_boxkey"
    ,"use_boxkey"
    ,"get_woolball"
    ,"get_matches"
    ,"use_matches"
    ,"win_cardindex"
    ,"get_knittingneedles"
    ,"get_lvl4notebook"
    ,"use_unfinishedsocks"
    ,"use_woolball"
    ,"use_knittingneedles"
    ,"get_socksforsophia"
    ,"use_lvl4notebook"
    ,"use_lvl4pen"
    ,"get_sophiasaddress"
    ,"use_sophiasaddress"
    
    ,"opn_nearnurseshouse"
    ,"get_thickwire"
    ,"get_shellpart1"
    ,"get_pliers"
    ,"use_pliers"
    ,"get_selfmadepen"
    ,"use_selfmadepen"
    ,"clk_poursouptobowl"
    ,"get_fishsoup"
    ,"use_fishsoup"
    ,"get_zipperrunner"
    ,"get_shellpart2"
    ,"use_zipperrunner"
    ,"get_cakeamulet"
    ,"get_keyholder"
    ,"use_cakeamulet"
    ,"get_kitchenknife"
    ,"get_twotoothedfork"
    ,"use_kitchenknife"
    ,"win_jackpumpkin"
    ,"win_pumpkins"
    ,"get_shellpart3"
    ,"use_shellpart"
    ,"get_homekeys"
    ,"get_nursekeys"
    ,"use_homekeys"
    
    ,"opn_insophiashouse"
    ,"get_pinkbow"
    ,"use_nursekeys"
    ,"get_bluebow"
    ,"get_crosskey"
    ,"use_twotoothedfork"
    ,"get_brokenfigurine"
    ,"use_pinkbow"
    ,"use_bluebow"
    ,"get_horns"
    ,"get_ornament1"
    ,"use_crosskey"
    ,"get_burntnewspaper"
    ,"get_crowfeather"
    ,"use_eaglefeather"
    ,"use_crowfeather"
    ,"win_abovefireplace"
    ,"get_heartsign"
    ,"get_clawedpaw"
    ,"use_heartsign"
    ,"get_angelfigurine"
    ,"get_newspaperpiece1"
    ,"use_lvl4wings"
    ,"use_horns"
    ,"use_clawedpaw"
    ,"get_devilfigurine"
    ,"use_angelfigurine"
    ,"use_devilfigurine"
    ,"win_angels"
    ,"get_ornament2"
    ,"get_newspaperpiece2"
    ,"use_ornament1"
    ,"use_ornament2"
    ,"get_brokendogcase"
    ,"get_oldglasses"
    ,"use_oldglasses"
    ,"get_tongs"
    ,"get_lockpart1"
    ,"use_tongsfoodtray"
    ,"get_longrod"
    
    ,"use_tongsbench"
    ,"get_lockpart2"
    ,"get_figurehead"
    ,"use_lockpart"
    ,"get_stetoscopeamulet"
    ,"get_newspaperpiece3"
    ,"use_stetoscopeamulet"
    ,"get_sophiaspullover"
    ,"get_donationcheque"
    ,"get_woodensquare"
    ,"use_woodensquare"
    ,"win_lvl4chest"
    ,"get_nailpuller"
    ,"get_collectionstamp1"
    ,"get_lvl4spade"
    ,"use_nailpuller"
    ,"get_ship"
    ,"get_collectionstamp2"
    ,"use_collectionstamp1"
    ,"use_collectionstamp2"
    ,"get_sails"
    ,"get_curtaintieback1"
    ,"use_lvl4spade"
    ,"get_bone"
    ,"get_fishingline"
    ,"use_sails"
    ,"use_fishingline"
    ,"use_figurehead"
    ,"get_shipmodel"
    ,"use_shipmodel"
    ,"get_curtaintieback2"
    ,"get_newspaperpiece4"
    ,"use_curtaintieback1"
    ,"use_curtaintieback2"
    ,"use_hobone1"
    ,"use_hobone2"
    ,"use_hobone3"
    ,"use_hobone4"
    ,"use_hodogpart1"
    ,"use_hodogpart2"
    ,"use_hodogpart3"
    ,"use_hodogpart4"
    ,"win_dogarea"
    ,"get_lvl4clockhands"
    ,"get_lvl4bolt1"
    ,"use_lvl4clockhands"
    ,"get_ballerina"
    ,"use_ballerina"
    ,"get_tape"
    ,"get_honeyspoon"
    ,"use_honeyspoon"
    ,"get_honey"
    ,"use_honey"
    ,"get_wrench"
    ,"use_wrenchclock"
    ,"get_lvl4bolt2"
    ,"use_newspaperpiece"
    ,"use_tape"
    ,"win_burntnewspaper"
    ,"get_dogname"
    ,"use_sophiaspullover"
    ,"use_bone"
    ,"use_longrod"
    ,"use_lvl4bolt"
    ,"use_wrenchdogcase"
    ,"use_dogname"
    ,"get_dogcage"
    ,"use_dogcage"
    ,"get_rescueddog"
    
    ,"opn_ingingerbreadhousewithclues"
    ,"use_donationcheque"
    ,"use_charitypicture"
    ,"use_socksforsophia"
    ,"use_rescueddog"
    
    ,"opn_lvl4memories"
    ,"win_lvl4memories"

    ,"tutor_27"
    ,"tutor_28"
    ,"tutor_29"
    ,"tutor_30"
  };
  
  game.relations = {};

end;
