-- name=rm_neargingerbreadhouse
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_neargingerbreadhouse";
  --------------------------------------------------------------------------------------------

  --------------------------------------------------------------------------------------------
  -- function get_duster () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_duster" ] = {
        type = "get",
        get_obj = "obj_housewindow_duster",
        room = private.room_objname,
        zz = "zz_housewindow",
        zz_gate = "gzz_neargingerbreadhouse_housewindow"
    };
    --------------------------------------------------------------------------------------------
  local get_duster_inv = function ()
  
    interface.InventoryItemAdd( "inv_duster", "obj_housewindow_duster" );
  
  end;
  
  local get_duster_end = function ()
  
    ObjDelete( "spr_housewindow_duster_anim_1" );
    ObjDelete( "spr_housewindow_duster_anim_sh" );
    ObjDelete( "spr_housewindow_duster_anim_2" );
    
    ObjDelete( "spr_neargingerbreadhouse_housewindow_rag" );
  
  end;
  
  cmn.AddSubscriber( "get_duster", get_duster_inv );
  cmn.AddSubscriber( "get_duster", get_duster_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fullwateringcan () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_fullwateringcan" ] = {
        type = "get",
        get_obj = "spr_well_fullwateringcan",
        room = private.room_objname,
        zz = "zz_well",
        zz_gate = "gzz_neargingerbreadhouse_well"
    };
    --------------------------------------------------------------------------------------------
  local get_fullwateringcan_inv = function ()
  
    interface.InventoryItemAdd( "inv_fullwateringcan", "spr_well_fullwateringcan" );
  
  end;
  
  local get_fullwateringcan_end = function ()
  
    ObjDelete( "gfx_well_fullwateringcan" );
    ObjDelete( "spr_well_fullwateringcan_sh" );
    ObjDelete( "spr_neargingerbreadhouse_well_buket" );
    
    if cmn.IsEventDone("get_runestone2") then
      ObjDelete( "gzz_neargingerbreadhouse_well" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_fullwateringcan", get_fullwateringcan_inv );
  cmn.AddSubscriber( "get_fullwateringcan", get_fullwateringcan_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_firestone () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_firestone" ] = {
        type = "get",
        get_obj = "spr_well_firestone",
        room = private.room_objname,
        zz = "zz_well",
        zz_gate = "gzz_neargingerbreadhouse_well"
    };
    --------------------------------------------------------------------------------------------
  local get_firestone_inv = function ()
  
    interface.InventoryItemAdd( "inv_firestone", "spr_well_firestone" );
    ObjSet("inv_dirtytorch_star_light",  { alp = 1 });
  
  end;
  
  local get_firestone_end = function ()
  
    ObjDelete( "gfx_well_firestone" );
    ObjDelete( "spr_well_firestone_sh" );

    ObjDelete( "spr_neargingerbreadhouse_well_stone" );
  
  end;
  
  cmn.AddSubscriber( "get_firestone", get_firestone_inv );
  cmn.AddSubscriber( "get_firestone", get_firestone_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_runestone2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_runestone2" ] = {
        type = "get",
        get_obj = "spr_well_runestone2",
        room = private.room_objname,
        zz = "zz_well",
        zz_gate = "gzz_neargingerbreadhouse_well"
    };
    --------------------------------------------------------------------------------------------
  local get_runestone2_inv = function ()
  
    interface.InventoryItemAdd( "inv_runestone", "spr_well_runestone2", function () cmn.GetMultyObject( 'runestone', 3 ); end );
  
  end;
  
  local get_runestone2_end = function ()
  
    ObjDelete( "gfx_well_runestone2" );
    ObjDelete( "spr_well_runestone2_bl_2" );
    ObjDelete( "spr_well_runestone2_bl" );
    
    if cmn.IsEventDone("get_fullwateringcan") then
      ObjDelete( "gzz_neargingerbreadhouse_well" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_runestone2", get_runestone2_inv );
  cmn.AddSubscriber( "get_runestone2", get_runestone2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_dirtytorch () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_dirtytorch" ] = {
        type = "get",
        get_obj = "spr_spikedbush_dirtytorch",
        room = private.room_objname,
        zz = "zz_spikedbush",
        zz_gate = "gzz_neargingerbreadhouse_spikedbush"
    };
    --------------------------------------------------------------------------------------------
  local get_dirtytorch_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_dirtytorch", "spr_spikedbush_dirtytorch" );
  
  end;
  
  local get_dirtytorch_end = function ()
  
    ObjDelete( "gfx_spikedbush_dirtytorch" );
    ObjDelete( "spr_spikedbush_dirtytorch_sh" );

    ObjDelete( "spr_neargingerbreadhouse_spikerbush_torch" );
  
  end;
  
  cmn.AddSubscriber( "get_dirtytorch", get_dirtytorch_inv );
  cmn.AddSubscriber( "get_dirtytorch", get_dirtytorch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gargoylecuffs () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_gargoylecuffs" ] = {
        type = "get",
        get_obj = "spr_spikedbush_gargoylecuffs",
        room = private.room_objname,
        zz = "zz_spikedbush",
        zz_gate = "gzz_neargingerbreadhouse_spikedbush"
    };
    --------------------------------------------------------------------------------------------
  local get_gargoylecuffs_inv = function ()
  
    interface.InventoryItemAdd( "inv_gargoylecuffs", "spr_spikedbush_gargoylecuffs" );
    int_map_impl.DecreaseRoomTasks("rm_neargingerbreadhouse");
  
  end;
  
  local get_gargoylecuffs_end = function ()
  
    ObjDelete( "gfx_spikedbush_gargoylecuffs" );
    ObjDelete( "spr_spikedbush_gargoylecuffs_sh" );
    ObjDelete( "spr_neargingerbreadhouse_spikerbush_shackles" );
    
    if cmn.IsEventDone("get_eaglefeather") then
      ObjDelete( "gzz_neargingerbreadhouse_spikedbush" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_gargoylecuffs", get_gargoylecuffs_inv );
  cmn.AddSubscriber( "get_gargoylecuffs", get_gargoylecuffs_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_eaglefeather () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_eaglefeather" ] = {
        type = "get",
        get_obj = "spr_spikedbush_eaglefeather",
        room = private.room_objname,
        zz = "zz_spikedbush",
        zz_gate = "gzz_neargingerbreadhouse_spikedbush"
    };
    --------------------------------------------------------------------------------------------
  local get_eaglefeather_inv = function ()
  
    interface.InventoryItemAdd( "inv_eaglefeather", "spr_spikedbush_eaglefeather" );
    int_map_impl.DecreaseRoomTasks("rm_neargingerbreadhouse");
  
  end;
  
  local get_eaglefeather_end = function ()
  
    ObjDelete( "gfx_spikedbush_eaglefeather" );
    ObjDelete( "spr_spikedbush_eaglefeather_sh" );
    ObjDelete( "spr_neargingerbreadhouse_spikerbush_eagles_feather" );
    
    if cmn.IsEventDone("get_gargoylecuffs") then
      ObjDelete( "gzz_neargingerbreadhouse_spikedbush" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_eaglefeather", get_eaglefeather_inv );
  cmn.AddSubscriber( "get_eaglefeather", get_eaglefeather_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_hotwater () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_hotwater" ] = {
        type = "use",
        inv_obj = "inv_hotwater",
        use_place = "obj_housewindow_use_hotwater",
        room = private.room_objname,
        zz = "zz_housewindow",
        zz_gate = "gzz_neargingerbreadhouse_housewindow"
    };
  --------------------------------------------------------------------------------------------
  local use_hotwater_inv = function ()
  
    interface.InventoryItemRemove( "inv_hotwater" );
  
  end;
  local use_hotwater_beg = function ()
  
    ObjDelete( "obj_housewindow_use_hotwater" );
    ObjDelete( "anm_housewindow_plank_touch" );
  
  end;
  local use_hotwater_end = function ()
  
    ObjDelete( "gzz_neargingerbreadhouse_housewindow" );
    ObjDelete( "spr_neargingerbreadhouse_housewindow_chocolate" );

    ObjMultiSet( { { "grm_neargingerbreadhouse_ingingerbreadhouse", { input = 1, alp = 1 } },
                   { "spr_neargingerbreadhouse_housewindow_openedwindow", { alp = 1 } } } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_neargingerbreadhouse_ingingerbreadhouse_focus");
    end;
  end;
  local use_hotwater_preloc = function ()
    
    ObjMultiSet( { {"spr_trollrift_house_open",  { alp = 1 }},
                   {"grm_trollrift_neargingerbreadhouse_focus", { res = "assets/levels/level4/mg_trollrift/focus_rm_neargingerbreadhouse2" }} } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hotwater", use_hotwater_beg, private.room_objname );
  cmn.AddSubscriber( "use_hotwater", use_hotwater_inv );
  cmn.AddSubscriber( "use_hotwater", use_hotwater_end, private.room_objname );
  cmn.AddSubscriber( "use_hotwater_inv", use_hotwater_inv, private.room_objname );
  cmn.AddSubscriber( "use_hotwater_beg", use_hotwater_beg, private.room_objname );
  cmn.AddSubscriber( "use_hotwater_end", use_hotwater_end, private.room_objname );
  cmn.AddSubscriber( "use_hotwater", use_hotwater_preloc, "mg_trollrift" );
  cmn.AddSubscriber( "use_hotwater_preloc", use_hotwater_preloc, "mg_trollrift" );
  --------------------------------------------------------------------------------------------
  -- function use_bucket () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_bucket" ] = {
        type = "use",
        inv_obj = "inv_bucket",
        use_place = "obj_well_use_bucket",
        room = private.room_objname,
        zz = "zz_well",
        zz_gate = "gzz_neargingerbreadhouse_well"
    };
  --------------------------------------------------------------------------------------------
  local use_bucket_inv = function ()
  
    interface.InventoryItemRemove( "inv_bucket" );
  
  end;
  local use_bucket_beg = function ()
  
    ObjDelete( "obj_well_use_bucket" );
    ObjDelete( "anm_well_rope_touch" );
    ObjDelete( "spr_well_rune_in_water" );
  
  end;
  local use_bucket_end = function ()
    
    ObjDelete( "obj_well_buckect_1" );
    ObjDelete( "obj_well_in_buckect" );
  
    ObjMultiSet( { { "obj_well_bucket_out",  { alp = 1, input = 1 } },
                   { "spr_neargingerbreadhouse_well_buket", { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bucket", use_bucket_beg, private.room_objname );
  cmn.AddSubscriber( "use_bucket", use_bucket_inv );
  cmn.AddSubscriber( "use_bucket", use_bucket_end, private.room_objname );
  cmn.AddSubscriber( "use_bucket_inv", use_bucket_inv, private.room_objname );
  cmn.AddSubscriber( "use_bucket_beg", use_bucket_beg, private.room_objname );
  cmn.AddSubscriber( "use_bucket_end", use_bucket_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pegs () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_pegs" ] = {
        type = "use",
        inv_obj = "inv_pegs",
        use_place = "obj_spikedbush_use_pegs",
        room = private.room_objname,
        zz = "zz_spikedbush",
        zz_gate = "gzz_neargingerbreadhouse_spikedbush"
    };
  --------------------------------------------------------------------------------------------
  local use_pegs_inv = function ()
  
    interface.InventoryItemRemove( "inv_pegs" );
  
  end;
  local use_pegs_beg = function ()
  
    ObjDelete( "obj_spikedbush_use_pegs" );
  
  end;
  local use_pegs_end = function ()
    
    ObjMultiSet( { {"obj_spikedbush_use_duster", { input = 1 }},
                   {"anm_spikedbush_bush_action", { alp = 0, frame = 0, animfunc = "func_clk_bush_with_stakes" }},
                   {"anm_spikedbush_bush", { alp = 1, frame = 0, animfunc = "func_anm_with_stakes" }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pegs", use_pegs_beg, private.room_objname );
  cmn.AddSubscriber( "use_pegs", use_pegs_inv );
  cmn.AddSubscriber( "use_pegs", use_pegs_end, private.room_objname );
  cmn.AddSubscriber( "use_pegs_inv", use_pegs_inv, private.room_objname );
  cmn.AddSubscriber( "use_pegs_beg", use_pegs_beg, private.room_objname );
  cmn.AddSubscriber( "use_pegs_end", use_pegs_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pyramid () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_pyramid" ] = {
        type = "use",
        inv_obj = "inv_pyramid",
        use_place = "obj_spikedbush_use_pyramid",
        room = private.room_objname,
        zz = "zz_spikedbush",
        zz_gate = "gzz_neargingerbreadhouse_spikedbush"
    };
  --------------------------------------------------------------------------------------------
  local use_pyramid_inv = function ()
  
    interface.InventoryItemRemove( "inv_pyramid" );
  
  end;
  local use_pyramid_beg = function ()
  
    ObjDelete( "obj_spikedbush_use_pyramid" );
  
  end;
  local use_pyramid_end = function ()
    
    ObjDelete( "anm_spikedbush_pyramid_touch" );
    ObjDelete( "spr_neargingerbreadhouse_spikedbush_pyramid" );
  
    ObjMultiSet( { { "obj_spikedbush_pyramid_open",  { alp = 1, input = 1 } },
                   { "spr_neargingerbreadhouse_pyramid_open", { alp = 1 } },
                   { "spr_neargingerbreadhouse_spikerbush_shackles", { alp = 1 } },
                   { "spr_neargingerbreadhouse_spikerbush_eagles_feather", { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pyramid", use_pyramid_beg, private.room_objname );
  cmn.AddSubscriber( "use_pyramid", use_pyramid_inv );
  cmn.AddSubscriber( "use_pyramid", use_pyramid_end, private.room_objname );
  cmn.AddSubscriber( "use_pyramid_inv", use_pyramid_inv, private.room_objname );
  cmn.AddSubscriber( "use_pyramid_beg", use_pyramid_beg, private.room_objname );
  cmn.AddSubscriber( "use_pyramid_end", use_pyramid_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_duster () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_duster" ] = {
        type = "use",
        inv_obj = "inv_duster",
        use_place = "obj_spikedbush_use_duster",
        room = private.room_objname,
        zz = "zz_spikedbush",
        zz_gate = "gzz_neargingerbreadhouse_spikedbush"
    };
  --------------------------------------------------------------------------------------------
  local use_duster_inv = function ()
  
    interface.InventoryItemRemove( "inv_duster" );
  
  end;
  local use_duster_beg = function ()
  
    ObjDelete( "obj_spikedbush_use_duster" );
    ObjDelete( "anm_spikedbush_bush" );
  
  end;
  local use_duster_end = function ()
    
    ObjDelete( "anm_neargingerbreadhouse_spikedbush" );
    
    ObjMultiSet( { {"spr_spikedbush_dirtytorch", { input = 1 }},
                   {"obj_spikedbush_use_pyramid", { input = 1 }},
                   {"anm_spikedbush_bush_action", { frame = 400, pos_z = 0, animfunc = "func_use_dusterrag", alp = 1 }},
                   {"obj_neargingerbreadhouse_spikedbush_tied", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_duster", use_duster_beg, private.room_objname );
  cmn.AddSubscriber( "use_duster", use_duster_inv );
  cmn.AddSubscriber( "use_duster", use_duster_end, private.room_objname );
  cmn.AddSubscriber( "use_duster_inv", use_duster_inv, private.room_objname );
  cmn.AddSubscriber( "use_duster_beg", use_duster_beg, private.room_objname );
  cmn.AddSubscriber( "use_duster_end", use_duster_end, private.room_objname );


  --------------------------------------------------------------------------------------------
  -- function opn_neargingerbreadhouse () end;
  --------------------------------------------------------------------------------------------
  local opn_neargingerbreadhouse = function ()
  
    int_map_impl.OpenRoom( "rm_neargingerbreadhouse" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_neargingerbreadhouse", opn_neargingerbreadhouse );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_neargingerbreadhouse();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio4/aud_neargingerbreadhouse_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio4/aud_neargingerbreadhouse_env");
  
  if not ( cmn.IsEventDone( "opn_neargingerbreadhouse" ) ) then
    cmn.Lock(1);
  end;
  
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(11) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_hotwater()

  local item = "inv_hotwater";

  if cmn.ApplyObj( item, "gzz_neargingerbreadhouse_housewindow" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_housewindow" );

  elseif ( cmn.ApplyObj( item, "obj_housewindow_use_hotwater" ) ) then

    cmn.CallEventHandler( "use_hotwater_inv" );
    cmn.CallEventHandler( "use_hotwater_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_hotwater" );
      cmn.CallEventHandler( "use_hotwater_end" );
      
      common.CloseSubRoom();
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_neargingerbreadhouse/audio/aud_use_bucket3");

    ObjSet("anm_housewindow_use_water",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bucket()

  local item = "inv_bucket";

  if cmn.ApplyObj( item, "gzz_neargingerbreadhouse_well" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_well" );

  elseif ( cmn.ApplyObj( item, "obj_well_use_bucket" ) ) then

    cmn.CallEventHandler( "use_bucket_inv" );
    cmn.CallEventHandler( "use_bucket_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_bucket" );
      cmn.CallEventHandler( "use_bucket_end" );
    
    end;
    
    local anm_bucket_out = function ()
      
      ObjAnimate("anm_well_use_bucket", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("anm_well_rope", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_well_water", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("obj_well_bucket_out", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_neargingerbreadhouse/audio/aud_use_bucket");

    ObjMultiSet( { {"anm_well_use_bucket", { alp = 1, playing = 1, endtrig = anm_bucket_out }},
                   {"anm_well_rope", { alp = 0 }},
                   {"anm_well_water", { alp = 0 }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pegs()

  local item = "inv_pegs";

  if cmn.ApplyObj( item, "gzz_neargingerbreadhouse_spikedbush" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_spikedbush" );

  elseif ( cmn.ApplyObj( item, "obj_spikedbush_use_pegs" ) ) then

    cmn.CallEventHandler( "use_pegs_inv" );
    cmn.CallEventHandler( "use_pegs_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pegs" );
      cmn.CallEventHandler( "use_pegs_end" );
      
      ObjSet("anm_spikedbush_bush",  { alp = 1 });
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_neargingerbreadhouse/audio/aud_use_peg");

    ObjMultiSet( { {"anm_spikedbush_bush_action",  { frame = 0, animfunc = "func_use_stakes", alp = 1, playing = 1, endtrig = func_after }},
                   {"anm_spikedbush_bush", { alp = 0 }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pyramid()

  local item = "inv_pyramid";

  if cmn.ApplyObj( item, "gzz_neargingerbreadhouse_spikedbush" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_spikedbush" );

  elseif ( cmn.ApplyObj( item, "obj_spikedbush_use_pyramid" ) and cmn.IsEventDone("use_pegs") and cmn.IsEventDone("use_duster") ) then

    cmn.CallEventHandler( "use_pyramid_inv" );
    cmn.CallEventHandler( "use_pyramid_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pyramid" );
      cmn.CallEventHandler( "use_pyramid_end" );
    
    end;
    
    local anm_open = function ()
      
      ObjAnimate("obj_spikedbush_pyramid_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_spikedbush_pyramid_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_neargingerbreadhouse/audio/aud_use_pyramid");

    ObjAnimate("spr_spikedbush_pyramid_top", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_duster()

  local item = "inv_duster";

  if cmn.ApplyObj( item, "gzz_neargingerbreadhouse_spikedbush" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_spikedbush" );

  elseif ( cmn.ApplyObj( item, "obj_spikedbush_use_duster" ) and cmn.IsEventDone("use_pegs") ) then

    cmn.CallEventHandler( "use_duster_inv" );
    cmn.CallEventHandler( "use_duster_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_duster" );
      cmn.CallEventHandler( "use_duster_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_neargingerbreadhouse/audio/aud_use_cloth4");

    ObjSet("anm_spikedbush_bush_action",  { frame = 0, animfunc = "func_use_dusterrag", alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_duster()
  
  ObjSet("obj_housewindow_duster",  { alp = 1 });

  cmn.SetEventDone( "get_duster" );
  cmn.CallEventHandler( "get_duster" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_fullwateringcan()

  cmn.SetEventDone( "get_fullwateringcan" );
  cmn.CallEventHandler( "get_fullwateringcan" );
  
  cmn.SetEventDone( "get_runestone2" );
  cmn.CallEventHandler( "get_runestone2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  --if cmn.IsEventDone("get_runestone2") then
    common.CloseSubRoom();
  --end;

end;
--------------------------------------------------------------------------------------------
function public.get_firestone()

  cmn.SetEventDone( "get_firestone" );
  cmn.CallEventHandler( "get_firestone" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_runestone2()

  cmn.SetEventDone( "get_runestone2" );
  cmn.CallEventHandler( "get_runestone2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_fullwateringcan") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_dirtytorch()

  cmn.SetEventDone( "get_dirtytorch" );
  cmn.CallEventHandler( "get_dirtytorch" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_gargoylecuffs()

  cmn.SetEventDone( "get_gargoylecuffs" );
  cmn.CallEventHandler( "get_gargoylecuffs" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if not cmn.IsEventDone("get_eaglefeather") then
    cmn.SetEventDone( "get_eaglefeather" );
    cmn.CallEventHandler( "get_eaglefeather" );
  end;
  
  if cmn.IsEventDone("get_eaglefeather") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_eaglefeather()

  cmn.SetEventDone( "get_eaglefeather" );
  cmn.CallEventHandler( "get_eaglefeather" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_gargoylecuffs") then
    common.CloseSubRoom();
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_neargingerbreadhouse()

  if not ( cmn.IsEventDone( "opn_neargingerbreadhouse" ) ) then
    
    local func_after = function ()
      
      cmn.ShowBbt( "neargingerbreadhouse_open" );
      cmn.PlayAudio("env", "assets/levels/common/audio/audio4/aud_neargingerbreadhouse_env");
      
    end;
    
    cmn.Lock(0);
    
    cmn.SetEventDone( "opn_neargingerbreadhouse" );
    cmn.CallEventHandler("opn_neargingerbreadhouse");
    
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level4/rm_neargingerbreadhouse/vid_windowsilhouettes", func_after, "assets/levels/level4/rm_neargingerbreadhouse/audio/aud_windowsilhouettes", "");
    
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_well_rope()
  
  cmn.Lock(1);
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_well_rope_touch", { alp = 0 }},
                   {"anm_well_rope", { alp = 1, playing = 1 }} } );
    
  end;
  
  cmn.ShowBbt( "obj_well_use_bucket" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_neargingerbreadhouse/audio/aud_xx_clk_rope");
  
  ObjMultiSet( { {"anm_well_rope_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_well_rope", { alp = 0, playing = 0 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_housewindow()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_housewindow_use_hotwater" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_neargingerbreadhouse/audio/aud_xx_clk_window4");
  
  ObjSet("anm_housewindow_plank_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_pyramid()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_spikedbush_use_pyramid" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_neargingerbreadhouse/audio/aud_xx_clk_marble");
  
  ObjSet("anm_spikedbush_pyramid_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_bush( num )
  
  cmn.Lock(1);
  
  if num == 1 then
    cmn.ShowBbt( "obj_spikedbush_use_pegs" );
  else
    cmn.ShowBbt( "obj_spikedbush_use_duster" );
  end;
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_spikedbush_bush_action", { alp = 0 }},
                   {"anm_spikedbush_bush", { alp = 1, playing = 1 }} } );
    
  end;
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_forestthicket/audio/aud_xx_clk_rustle");
  
  ObjMultiSet( { {"anm_spikedbush_bush_action", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_spikedbush_bush", { alp = 0, playing = 0 }} } );
  
end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_11_1", { alp = 1 }},
                 {"spr_col_11_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_11_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_11_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_11_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_11_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_11_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_11_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--*********************************************************************************************************************
