-- name=rm_nearnurseshouse
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_nearnurseshouse";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Jackpumpkin();
  --------------------------------------------------------------------------------------------
  -- function get_collectionstamp2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_collectionstamp2" ] = {
        type = "get",
        get_obj = "spr_postbox_collectionstamp2",
        room = private.room_objname,
        zz = "zz_postbox",
        zz_gate = "gzz_nearnurseshouse_postbox"
    };
    --------------------------------------------------------------------------------------------
  local get_collectionstamp2_inv = function ()
  
    interface.InventoryItemAdd( "inv_collectionstamp2", "spr_postbox_collectionstamp2" );
    int_map_impl.DecreaseRoomTasks("rm_nearnurseshouse");
  
  end;
  
  local get_collectionstamp2_end = function ()
  
    ObjDelete( "gfx_postbox_collectionstamp2" );
    ObjDelete( "spr_postbox_collectionstamp2_sh" );
    ObjDelete( "spr_nearnurseshouse_postbox_mark" );
    
    if cmn.IsEventDone("get_burntnewspaper") and cmn.IsEventDone("get_ship") then
      ObjDelete( "gzz_nearnurseshouse_postbox" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_collectionstamp2", get_collectionstamp2_inv );
  cmn.AddSubscriber( "get_collectionstamp2", get_collectionstamp2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_shellpart1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_shellpart1" ] = {
        type = "get",
        get_obj = "spr_postbox_shellpart1",
        room = private.room_objname,
        zz = "zz_postbox",
        zz_gate = "gzz_nearnurseshouse_postbox"
    };
    --------------------------------------------------------------------------------------------
  local get_shellpart1_inv = function ()
  
    interface.InventoryItemAdd( "inv_shellpart", "spr_postbox_shellpart1", function () cmn.GetMultyObject( 'shellpart', 3 ); end );
    if cmn.IsEventDone("get_shellpart2") and cmn.IsEventDone("get_shellpart3") then
      ObjSet("inv_keyholder_star_light",  { alp = 1 });
    end;
  
  end;
  
  local get_shellpart1_end = function ()
  
    ObjDelete( "gfx_postbox_shellpart1" );
    ObjDelete( "spr_postbox_shellpart1_sh" );
    ObjDelete( "spr_nearnurseshouse_postbox_thing" );
  
  end;
  
  cmn.AddSubscriber( "get_shellpart1", get_shellpart1_inv );
  cmn.AddSubscriber( "get_shellpart1", get_shellpart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_burntnewspaper () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_burntnewspaper" ] = {
        type = "get",
        get_obj = "spr_postbox_burntnewspaper",
        room = private.room_objname,
        zz = "zz_postbox",
        zz_gate = "gzz_nearnurseshouse_postbox"
    };
    --------------------------------------------------------------------------------------------
  local get_burntnewspaper_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_burntnewspaper", "spr_postbox_burntnewspaper" );
  
  end;
  
  local get_burntnewspaper_end = function ()
  
    ObjDelete( "gfx_postbox_burntnewspaper" );
    ObjDelete( "spr_postbox_burntnewspaper_sh" );
    ObjDelete( "spr_nearnurseshouse_postbox_paper" );
    
    if cmn.IsEventDone("get_collectionstamp2") and cmn.IsEventDone("get_ship") then
      ObjDelete( "gzz_nearnurseshouse_postbox" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_burntnewspaper", get_burntnewspaper_inv );
  cmn.AddSubscriber( "get_burntnewspaper", get_burntnewspaper_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crowfeather () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_crowfeather" ] = {
        type = "get",
        get_obj = "spr_postbox_crowfeather",
        room = private.room_objname,
        zz = "zz_postbox",
        zz_gate = "gzz_nearnurseshouse_postbox"
    };
    --------------------------------------------------------------------------------------------
  local get_crowfeather_inv = function ()
  
    interface.InventoryItemAdd( "inv_crowfeather", "spr_postbox_crowfeather" );
  
  end;
  
  local get_crowfeather_end = function ()
  
    ObjDelete( "gfx_postbox_crowfeather" );
    ObjDelete( "spr_postbox_crowfeather_sh" );
    ObjDelete( "spr_nearnurseshouse_postbox_feather" );
  
  end;
  
  cmn.AddSubscriber( "get_crowfeather", get_crowfeather_inv );
  cmn.AddSubscriber( "get_crowfeather", get_crowfeather_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ship () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_ship" ] = {
        type = "get",
        get_obj = "spr_postbox_ship",
        room = private.room_objname,
        zz = "zz_postbox",
        zz_gate = "gzz_nearnurseshouse_postbox"
    };
    --------------------------------------------------------------------------------------------
  local get_ship_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_ship", "spr_postbox_ship" );
    int_map_impl.DecreaseRoomTasks("rm_nearnurseshouse");
  
  end;
  
  local get_ship_end = function ()
  
    ObjDelete( "gfx_postbox_ship" );
    ObjDelete( "anm_postbox_use_nailpuller" );
    ObjDelete( "spr_nearnurseshouse_postbox_ship" );
    
    if cmn.IsEventDone("get_collectionstamp2") and cmn.IsEventDone("get_burntnewspaper") then
      ObjDelete( "gzz_nearnurseshouse_postbox" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_ship", get_ship_inv );
  cmn.AddSubscriber( "get_ship", get_ship_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_zipperrunner () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_zipperrunner" ] = {
        type = "get",
        get_obj = "spr_bench_zipperrunner",
        room = private.room_objname,
        zz = "zz_bench",
        zz_gate = "gzz_nearnurseshouse_bench"
    };
    --------------------------------------------------------------------------------------------
  local get_zipperrunner_inv = function ()
  
    interface.InventoryItemAdd( "inv_zipperrunner", "spr_bench_zipperrunner" );
  
  end;
  
  local get_zipperrunner_end = function ()
  
    ObjDelete( "gfx_bench_zipperrunner" );
    ObjDelete( "spr_bench_zipperrunner_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_zipperrunner", get_zipperrunner_inv );
  cmn.AddSubscriber( "get_zipperrunner", get_zipperrunner_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_figurehead () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_figurehead" ] = {
        type = "get",
        get_obj = "spr_bench_figurehead",
        room = private.room_objname,
        zz = "zz_bench",
        zz_gate = "gzz_nearnurseshouse_bench"
    };
    --------------------------------------------------------------------------------------------
  local get_figurehead_inv = function ()
  
    interface.InventoryItemAdd( "inv_figurehead", "spr_bench_figurehead" );
    ObjSet("inv_ship_star_light",  { alp = 1 });
  
  end;
  
  local get_figurehead_end = function ()
  
    ObjDelete( "gfx_bench_figurehead" );
    
    if cmn.IsEventDone("get_lockpart2") then
      ObjDelete( "gzz_nearnurseshouse_bench" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_figurehead", get_figurehead_inv );
  cmn.AddSubscriber( "get_figurehead", get_figurehead_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_shellpart2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_shellpart2" ] = {
        type = "get",
        get_obj = "spr_bench_shellpart2",
        room = private.room_objname,
        zz = "zz_bench",
        zz_gate = "gzz_nearnurseshouse_bench"
    };
    --------------------------------------------------------------------------------------------
  local get_shellpart2_inv = function ()
  
    interface.InventoryItemAdd( "inv_shellpart", "spr_bench_shellpart2", function () cmn.GetMultyObject( 'shellpart', 3 ); end );
    if cmn.IsEventDone("get_shellpart1") and cmn.IsEventDone("get_shellpart3") then
      ObjSet("inv_keyholder_star_light",  { alp = 1 });
    end;
  
  end;
  
  local get_shellpart2_end = function ()
  
    ObjDelete( "gfx_bench_shellpart2" );
    ObjDelete( "spr_bench_shellpart2_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_shellpart2", get_shellpart2_inv );
  cmn.AddSubscriber( "get_shellpart2", get_shellpart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_horns () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_horns" ] = {
        type = "get",
        get_obj = "spr_bench_horns",
        room = private.room_objname,
        zz = "zz_bench",
        zz_gate = "gzz_nearnurseshouse_bench"
    };
    --------------------------------------------------------------------------------------------
  local get_horns_inv = function ()
  
    interface.InventoryItemAdd( "inv_horns", "spr_bench_horns" );
    ObjSet("inv_brokenfigurine_star_light",  { alp = 1 });
  
  end;
  
  local get_horns_end = function ()
  
    ObjDelete( "gfx_bench_horns" );
    ObjDelete( "spr_bench_horns_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_horns", get_horns_inv );
  cmn.AddSubscriber( "get_horns", get_horns_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ornament1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_ornament1" ] = {
        type = "get",
        get_obj = "spr_bench_ornament1",
        room = private.room_objname,
        zz = "zz_bench",
        zz_gate = "gzz_nearnurseshouse_bench"
    };
    --------------------------------------------------------------------------------------------
  local get_ornament1_inv = function ()
  
    interface.InventoryItemAdd( "inv_ornament1", "spr_bench_ornament1" );
  
  end;
  
  local get_ornament1_end = function ()
  
    ObjDelete( "gfx_bench_ornament1" );
    ObjDelete( "spr_bench_ornament1_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_ornament1", get_ornament1_inv );
  cmn.AddSubscriber( "get_ornament1", get_ornament1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lockpart2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_lockpart2" ] = {
        type = "get",
        get_obj = "spr_bench_lockpart2",
        room = private.room_objname,
        zz = "zz_bench",
        zz_gate = "gzz_nearnurseshouse_bench"
    };
    --------------------------------------------------------------------------------------------
  local get_lockpart2_inv = function ()
  
    interface.InventoryItemAdd( "inv_lockpart", "spr_bench_lockpart2", function () cmn.GetMultyObject( 'lockpart', 2 ); end );
  
  end;
  
  local get_lockpart2_end = function ()
  
    ObjDelete( "gfx_bench_lockpart2" );
    
    if cmn.IsEventDone("get_figurehead") then
      ObjDelete( "gzz_nearnurseshouse_bench" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_lockpart2", get_lockpart2_inv );
  cmn.AddSubscriber( "get_lockpart2", get_lockpart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pliers () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_pliers" ] = {
        type = "get",
        get_obj = "spr_jackpumpkin_pliers",
        room = private.room_objname,
        zz = "zz_jackpumpkin",
        zz_gate = "gzz_nearnurseshouse_jackpumpkin"
    };
    --------------------------------------------------------------------------------------------
  local get_pliers_inv = function ()
  
    interface.InventoryItemAdd( "inv_pliers", "spr_jackpumpkin_pliers" );
    ObjSet("inv_thickwire_star_light",  { alp = 1 });
  
  end;
  
  local get_pliers_end = function ()
  
    ObjDelete( "gfx_jackpumpkin_pliers" );
    ObjDelete( "spr_jackpumpkin_pliers_sh" );
    ObjDelete( "spr_jackpumpkin_pliers_bl" );
    
    ObjDelete( "spr_nearnurseshouse_jack_pliers" );
  
  end;
  
  cmn.AddSubscriber( "get_pliers", get_pliers_inv );
  cmn.AddSubscriber( "get_pliers", get_pliers_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_thickwire () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_thickwire" ] = {
        type = "get",
        get_obj = "spr_lvl4housedoor_thickwire",
        room = private.room_objname,
        zz = "zz_lvl4housedoor",
        zz_gate = "gzz_nearnurseshouse_lvl4housedoor"
    };
    --------------------------------------------------------------------------------------------
  local get_thickwire_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_thickwire", "spr_lvl4housedoor_thickwire" );
  
  end;
  
  local get_thickwire_end = function ()
  
    ObjDelete( "gfx_lvl4housedoor_thickwire" );
    ObjDelete( "spr_lvl4housedoor_thickwire_shadow" );
    
    ObjDelete( "spr_nearnurseshouse_door_wire" );
  
  end;
  
  cmn.AddSubscriber( "get_thickwire", get_thickwire_inv );
  cmn.AddSubscriber( "get_thickwire", get_thickwire_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_crosskey () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_crosskey" ] = {
        type = "use",
        inv_obj = "inv_crosskey",
        use_place = "obj_postbox_use_crosskey",
        room = private.room_objname,
        zz = "zz_postbox",
        zz_gate = "gzz_nearnurseshouse_postbox"
    };
  --------------------------------------------------------------------------------------------
  local use_crosskey_inv = function ()
  
    interface.InventoryItemRemove( "inv_crosskey" );
  
  end;
  local use_crosskey_beg = function ()
  
    ObjDelete( "obj_postbox_use_crosskey" );
    ObjDelete( "anm_postbox_mailbox_touch" );
  
  end;
  local use_crosskey_end = function ()
  
    ObjDelete( "anm_postbox_use_key" );
    ObjDelete( "spr_nearnurseshouse_postbox_cover1" );
    
    ObjMultiSet( { {"obj_postbox_mailbox_open", { alp = 1, input = 1 }},
                   {"spr_nearnurseshouse_postbox_cover2", { alp = 1 }},
                   {"anm_postbox_use_key_2", { frame = 300 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crosskey", use_crosskey_beg, private.room_objname );
  cmn.AddSubscriber( "use_crosskey", use_crosskey_inv );
  cmn.AddSubscriber( "use_crosskey", use_crosskey_end, private.room_objname );
  cmn.AddSubscriber( "use_crosskey_inv", use_crosskey_inv, private.room_objname );
  cmn.AddSubscriber( "use_crosskey_beg", use_crosskey_beg, private.room_objname );
  cmn.AddSubscriber( "use_crosskey_end", use_crosskey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_nailpuller () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_nailpuller" ] = {
        type = "use",
        inv_obj = "inv_nailpuller",
        use_place = "obj_postbox_use_nailpuller",
        room = private.room_objname,
        zz = "zz_postbox",
        zz_gate = "gzz_nearnurseshouse_postbox"
    };
  --------------------------------------------------------------------------------------------
  local use_nailpuller_inv = function ()
  
    interface.InventoryItemRemove( "inv_nailpuller" );
  
  end;
  local use_nailpuller_beg = function ()
  
    ObjDelete( "obj_postbox_use_nailpuller" );
    ObjDelete( "anm_postbox_ship_touch" );
  
  end;
  local use_nailpuller_end = function ()
  
    --ObjMultiSet( { {"spr_postbox_collectionstamp2", { alp = 1, input = 1 }},
    --               {"spr_postbox_ship", { alp = 1, input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_nailpuller", use_nailpuller_beg, private.room_objname );
  cmn.AddSubscriber( "use_nailpuller", use_nailpuller_inv );
  cmn.AddSubscriber( "use_nailpuller", use_nailpuller_end, private.room_objname );
  cmn.AddSubscriber( "use_nailpuller_inv", use_nailpuller_inv, private.room_objname );
  cmn.AddSubscriber( "use_nailpuller_beg", use_nailpuller_beg, private.room_objname );
  cmn.AddSubscriber( "use_nailpuller_end", use_nailpuller_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fishsoup () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_fishsoup" ] = {
        type = "use",
        inv_obj = "inv_fishsoup",
        use_place = "obj_bench_use_fishsoup",
        room = private.room_objname,
        zz = "zz_bench",
        zz_gate = "gzz_nearnurseshouse_bench"
    };
  --------------------------------------------------------------------------------------------
  local use_fishsoup_inv = function ()
  
    interface.InventoryItemRemove( "inv_fishsoup" );
  
  end;
  local use_fishsoup_beg = function ()
  
    ObjDelete( "obj_bench_use_fishsoup" );
  
  end;
  local use_fishsoup_end = function ()

    ObjDelete( "anm_bench_touch_cat" );
    ObjDelete( "anm_nearnurseshouse_cat_1" );

    ObjMultiSet( { {"spr_bench_zipperrunner", { alp = 1, input = 1 }},
                   {"spr_bench_shellpart2", { alp = 1, input = 1 }},
                   {"obj_bench_use_pinkbow", { input = 1 }},
                   {"obj_bench_use_bluebow", { input = 1 }},
                   {"anm_bench_cat", { animfunc = "func_cat_eating", endtrig = "" }},
                   {"anm_nearnurseshouse_cat_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fishsoup", use_fishsoup_beg, private.room_objname );
  cmn.AddSubscriber( "use_fishsoup", use_fishsoup_inv );
  cmn.AddSubscriber( "use_fishsoup", use_fishsoup_end, private.room_objname );
  cmn.AddSubscriber( "use_fishsoup_inv", use_fishsoup_inv, private.room_objname );
  cmn.AddSubscriber( "use_fishsoup_beg", use_fishsoup_beg, private.room_objname );
  cmn.AddSubscriber( "use_fishsoup_end", use_fishsoup_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pinkbow () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_pinkbow" ] = {
        type = "use",
        inv_obj = "inv_pinkbow",
        use_place = "obj_bench_use_pinkbow",
        room = private.room_objname,
        zz = "zz_bench",
        zz_gate = "gzz_nearnurseshouse_bench"
    };
  --------------------------------------------------------------------------------------------
  local use_pinkbow_inv = function ()
  
    interface.InventoryItemRemove( "inv_pinkbow" );
  
  end;
  local use_pinkbow_beg = function ()
  
    ObjDelete( "obj_bench_use_pinkbow" );
  
  end;
  local use_pinkbow_end = function ()

    ObjSet( "spr_bench_bow_pink", { alp = 1 } );
  
    if cmn.IsEventDone("use_bluebow") then

      ObjDelete( "obj_bench_bow_pink" );
      ObjDelete( "obj_bench_bow_blue" );

      ObjMultiSet( { {"spr_bench_horns", { input = 1 }},
                     {"anm_bench_cover", { animfunc = "func_open_cover", endtrig = "", frame = 30 }},
                     {"spr_bench_ornament1", { input = 1 }},
                     {"spr_nearnurseshouse_bench_box_open", { alp = 1 }} } );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pinkbow", use_pinkbow_beg, private.room_objname );
  cmn.AddSubscriber( "use_pinkbow", use_pinkbow_inv );
  cmn.AddSubscriber( "use_pinkbow", use_pinkbow_end, private.room_objname );
  cmn.AddSubscriber( "use_pinkbow_inv", use_pinkbow_inv, private.room_objname );
  cmn.AddSubscriber( "use_pinkbow_beg", use_pinkbow_beg, private.room_objname );
  cmn.AddSubscriber( "use_pinkbow_end", use_pinkbow_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bluebow () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_bluebow" ] = {
        type = "use",
        inv_obj = "inv_bluebow",
        use_place = "obj_bench_use_bluebow",
        room = private.room_objname,
        zz = "zz_bench",
        zz_gate = "gzz_nearnurseshouse_bench"
    };
  --------------------------------------------------------------------------------------------
  local use_bluebow_inv = function ()
  
    interface.InventoryItemRemove( "inv_bluebow" );
  
  end;
  local use_bluebow_beg = function ()
  
    ObjDelete( "obj_bench_use_bluebow" );
  
  end;
  local use_bluebow_end = function ()

    ObjSet( "spr_bench_bow_blue", { alp = 1 } );
  
    if cmn.IsEventDone("use_pinkbow") then

      ObjDelete( "obj_bench_bow_pink" );
      ObjDelete( "obj_bench_bow_blue" );

      ObjMultiSet( { {"spr_bench_horns", { input = 1 }},
                     {"anm_bench_cover", { animfunc = "func_open_cover", endtrig = "", frame = 30 }},
                     {"spr_bench_ornament1", { input = 1 }},
                     {"spr_nearnurseshouse_bench_box_open", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bluebow", use_bluebow_beg, private.room_objname );
  cmn.AddSubscriber( "use_bluebow", use_bluebow_inv );
  cmn.AddSubscriber( "use_bluebow", use_bluebow_end, private.room_objname );
  cmn.AddSubscriber( "use_bluebow_inv", use_bluebow_inv, private.room_objname );
  cmn.AddSubscriber( "use_bluebow_beg", use_bluebow_beg, private.room_objname );
  cmn.AddSubscriber( "use_bluebow_end", use_bluebow_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_kitchenknife () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_kitchenknife" ] = {
        type = "use",
        inv_obj = "inv_kitchenknife",
        use_place = "obj_jackpumpkin_use_kitchenknife",
        room = private.room_objname,
        zz = "zz_jackpumpkin",
        zz_gate = "gzz_nearnurseshouse_jackpumpkin"
    };
  --------------------------------------------------------------------------------------------
  local use_kitchenknife_inv = function ()
  
    interface.InventoryItemRemove( "inv_kitchenknife" );
  
  end;
  local use_kitchenknife_beg = function ()
  
    ObjDelete( "obj_jackpumpkin_use_kitchenknife" );
  
  end;
  local use_kitchenknife_end = function ()
  
    ObjDelete( "anm_jackpumpkin_use_knife" );
    ObjMultiSet( { {"obj_jackpumpkin_game", { alp = 1, input = 1 }},
                   {"spr_jackpumpkin_game_hint", { alp = 1 }},
                   {"spr_nearnurseshouse_jack_pumpkin", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_kitchenknife", use_kitchenknife_beg, private.room_objname );
  cmn.AddSubscriber( "use_kitchenknife", use_kitchenknife_inv );
  cmn.AddSubscriber( "use_kitchenknife", use_kitchenknife_end, private.room_objname );
  cmn.AddSubscriber( "use_kitchenknife_inv", use_kitchenknife_inv, private.room_objname );
  cmn.AddSubscriber( "use_kitchenknife_beg", use_kitchenknife_beg, private.room_objname );
  cmn.AddSubscriber( "use_kitchenknife_end", use_kitchenknife_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_homekeys () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_homekeys" ] = {
        type = "use",
        inv_obj = "inv_homekeys",
        use_place = "obj_lvl4housedoor_use_homekeys",
        room = private.room_objname,
        zz = "zz_lvl4housedoor",
        zz_gate = "gzz_nearnurseshouse_lvl4housedoor"
    };
  --------------------------------------------------------------------------------------------
  local use_homekeys_inv = function ()
  
    interface.InventoryItemRemove( "inv_homekeys" );
  
  end;
  local use_homekeys_beg = function ()
  
    ObjDelete( "obj_lvl4housedoor_use_homekeys" );
  
  end;
  local use_homekeys_end = function ()
  
    ObjDelete( "gzz_nearnurseshouse_lvl4housedoor" );

    ObjMultiSet( { { "grm_nearnurseshouse_insophiashouse", { input = 1, alp = 1 } },
                   { "spr_nearnurseshouse_lvl4housedoor_opened", { alp = 1 } } } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_nearnurseshouse_insophiashouse_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_homekeys", use_homekeys_beg, private.room_objname );
  cmn.AddSubscriber( "use_homekeys", use_homekeys_inv );
  cmn.AddSubscriber( "use_homekeys", use_homekeys_end, private.room_objname );
  cmn.AddSubscriber( "use_homekeys_inv", use_homekeys_inv, private.room_objname );
  cmn.AddSubscriber( "use_homekeys_beg", use_homekeys_beg, private.room_objname );
  cmn.AddSubscriber( "use_homekeys_end", use_homekeys_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_angelfigurine () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_angelfigurine" ] = {
        type = "use",
        inv_obj = "inv_angelfigurine",
        use_place = "obj_figurines_use_angelfigurine",
        room = private.room_objname,
        zz = "zz_figurines",
        zz_gate = "gzz_nearnurseshouse_figurines"
    };
  --------------------------------------------------------------------------------------------
  local use_angelfigurine_inv = function ()
  
    interface.InventoryItemRemove( "inv_angelfigurine" );
  
  end;
  local use_angelfigurine_beg = function ()
  
    ObjDelete( "obj_figurines_use_angelfigurine" );
  
  end;
  local use_angelfigurine_end = function ()
    
    ObjSet("anm_figurines_angel_touch",  { alp = 1 });
    ObjDelete( "anm_figurines_angel_use" );
  
    if cmn.IsEventDone("use_devilfigurine") then
      ObjDelete( "gzz_nearnurseshouse_figurines" );
      ObjDelete( "obj_nearnurseshouse_figurines_closed" );
      ObjMultiSet( { {"gmg_nearnurseshouse_angels", { alp = 1, input = 1, active = 1 }},
                     {"spr_nearnurseshouse_figurines_open", { alp = 1 }} } );
    else 
      ObjSet("spr_nearnurseshouse_figurines_angel",  { alp = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_angelfigurine", use_angelfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_angelfigurine", use_angelfigurine_inv );
  cmn.AddSubscriber( "use_angelfigurine", use_angelfigurine_end, private.room_objname );
  cmn.AddSubscriber( "use_angelfigurine_inv", use_angelfigurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_angelfigurine_beg", use_angelfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_angelfigurine_end", use_angelfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_devilfigurine () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_devilfigurine" ] = {
        type = "use",
        inv_obj = "inv_devilfigurine",
        use_place = "obj_figurines_use_devilfigurine",
        room = private.room_objname,
        zz = "zz_figurines",
        zz_gate = "gzz_nearnurseshouse_figurines"
    };
  --------------------------------------------------------------------------------------------
  local use_devilfigurine_inv = function ()
  
    interface.InventoryItemRemove( "inv_devilfigurine" );
  
  end;
  local use_devilfigurine_beg = function ()
  
    ObjDelete( "obj_figurines_use_devilfigurine" );
  
  end;
  local use_devilfigurine_end = function ()
    
    ObjSet("anm_figurines_devil_touch",  { alp = 1 });
    ObjDelete( "anm_figurines_devil_use" );
  
    if cmn.IsEventDone("use_angelfigurine") then
      ObjDelete( "gzz_nearnurseshouse_figurines" );
      ObjDelete( "obj_nearnurseshouse_figurines_closed" );
      ObjMultiSet( { {"gmg_nearnurseshouse_angels", { alp = 1, input = 1, active = 1 }},
                     {"spr_nearnurseshouse_figurines_open", { alp = 1 }} } );
    else 
      ObjSet("spr_nearnurseshouse_figurines_devil",  { alp = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_devilfigurine", use_devilfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_devilfigurine", use_devilfigurine_inv );
  cmn.AddSubscriber( "use_devilfigurine", use_devilfigurine_end, private.room_objname );
  cmn.AddSubscriber( "use_devilfigurine_inv", use_devilfigurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_devilfigurine_beg", use_devilfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_devilfigurine_end", use_devilfigurine_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_nearnurseshouse () end;
  --------------------------------------------------------------------------------------------
  local opn_nearnurseshouse = function ()
  
    int_map_impl.OpenRoom( "rm_nearnurseshouse" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_nearnurseshouse", opn_nearnurseshouse );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_jackpumpkin" );
  
  function zz_jackpumpkin.PreOpen()
    
    if not(cmn.IsEventDone( "win_jackpumpkin" )) then
      private.zz_jackpumpkin.DrawScene();
    end;

  end;
  
  function zz_jackpumpkin.Open()
    
    if cmn.IsEventDone( "use_kitchenknife" ) and not(cmn.IsEventDone( "win_jackpumpkin" )) then
      cmn.MiniGameShow();
      private.zz_jackpumpkin.CheckWin();
    end;

  end;

  function zz_jackpumpkin.PreClose()
    
    if ( cmn.IsEventDone( "use_kitchenknife" ) and not(cmn.IsEventDone( "win_jackpumpkin" )) ) then
      cmn.MiniGameHide("jackpumpkin");
    end;

  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not ng_global.progress[ ng_global.currentprogress ][ "win_jackpumpkin" ].state then 
    private.zz_jackpumpkin.StartConditions();
  end;
  
  private.zz_jackpumpkin.state = ng_global.progress[ ng_global.currentprogress ][ "win_jackpumpkin" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_nearnurseshouse();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio4/aud_lvl4nearhospital_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio4/aud_lvl4nearhospital_env");
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_crosskey()

  local item = "inv_crosskey";

  if cmn.ApplyObj( item, "gzz_nearnurseshouse_postbox" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_postbox" );

  elseif ( cmn.ApplyObj( item, "obj_postbox_use_crosskey" ) ) then

    cmn.CallEventHandler( "use_crosskey_inv" );
    cmn.CallEventHandler( "use_crosskey_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_crosskey" );
      cmn.CallEventHandler( "use_crosskey_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_nearnurseshouse/audio/aud_opn_postbox");

    ObjMultiSet( { {"anm_postbox_use_key", { alp = 1, playing = 1, endtrig = func_after }},
                   {"anm_postbox_use_key_2", { playing = 1 }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_nailpuller()

  local item = "inv_nailpuller";

  if cmn.ApplyObj( item, "gzz_nearnurseshouse_postbox" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_postbox" );

  elseif ( cmn.ApplyObj( item, "obj_postbox_use_nailpuller" ) ) then

    cmn.CallEventHandler( "use_nailpuller_inv" );
    cmn.CallEventHandler( "use_nailpuller_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_nailpuller" );
      cmn.CallEventHandler( "use_nailpuller_end" );
      
      public.get_ship();
      public.get_collectionstamp2();
      
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_nearnurseshouse/audio/aud_use_nailpuller");

    ObjMultiSet( { {"spr_postbox_collectionstamp2", { alp = 1 }},
                   {"spr_postbox_collectionstamp2_sh", { alp = 1 }},
                   {"anm_postbox_use_nailpuller", { alp = 1, playing = 1, endtrig = func_after }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fishsoup()

  local item = "inv_fishsoup";

  if cmn.ApplyObj( item, "gzz_nearnurseshouse_bench" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bench" );

  elseif ( cmn.ApplyObj( item, "obj_bench_use_fishsoup" ) ) then

    cmn.CallEventHandler( "use_fishsoup_inv" );
    cmn.CallEventHandler( "use_fishsoup_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_fishsoup" );
      cmn.CallEventHandler( "use_fishsoup_end" );

      ObjSet( "anm_bench_cat", { playing = true } );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_nearnurseshouse/audio/aud_use_fish");

    ObjSet( "anm_bench_cat", { animfunc = "func_use_plate", endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pinkbow()

  local item = "inv_pinkbow";

  if cmn.ApplyObj( item, "gzz_nearnurseshouse_bench" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bench" );

  elseif ( cmn.ApplyObj( item, "obj_bench_use_pinkbow" ) ) then

    cmn.CallEventHandler( "use_pinkbow_inv" );
    cmn.CallEventHandler( "use_pinkbow_beg" );

    local func_after2 = function ()

      cmn.Lock( 0 );

      cmn.CallEventHandler( "use_pinkbow_end" );
    
    end;

    local func_after = function ()

      cmn.SetEventDone( "use_pinkbow" );

      if cmn.IsEventDone("use_bluebow") then

        if ( not cmn.IsEventDone( "get_shellpart2" ) ) then
          rm_nearnurseshouse.get_shellpart2();
        end;

        if ( not cmn.IsEventDone( "get_zipperrunner" ) ) then
          rm_nearnurseshouse.get_zipperrunner();
        end;
        
        cmn.PlayAudio("snd", "assets/levels/level4/rm_nearnurseshouse/audio/aud_opn_box4");

        ObjSet( "anm_bench_cover", { animfunc = "func_open_cover", endtrig = func_after2, playing = true } );

      else 
        func_after2();
      end;

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_slippers");

    ObjAnimate( "spr_bench_bow_pink", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bluebow()

  local item = "inv_bluebow";

  if cmn.ApplyObj( item, "gzz_nearnurseshouse_bench" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bench" );

  elseif ( cmn.ApplyObj( item, "obj_bench_use_bluebow" ) ) then

    cmn.CallEventHandler( "use_bluebow_inv" );
    cmn.CallEventHandler( "use_bluebow_beg" );

    local func_after2 = function ()

      cmn.Lock( 0 );

      cmn.CallEventHandler( "use_bluebow_end" );
    
    end;

    local func_after = function ()

      cmn.SetEventDone( "use_bluebow" );

      if cmn.IsEventDone("use_pinkbow") then

        if ( not cmn.IsEventDone( "get_shellpart2" ) ) then
          rm_nearnurseshouse.get_shellpart2();
        end;

        if ( not cmn.IsEventDone( "get_zipperrunner" ) ) then
          rm_nearnurseshouse.get_zipperrunner();
        end;
        
        cmn.PlayAudio("snd", "assets/levels/level4/rm_nearnurseshouse/audio/aud_opn_box4");

        ObjSet( "anm_bench_cover", { animfunc = "func_open_cover", endtrig = func_after2, playing = true } );

      else 
        func_after2();
      end;

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_slippers");

    ObjAnimate( "spr_bench_bow_blue", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_kitchenknife()

  local item = "inv_kitchenknife";

  if cmn.ApplyObj( item, "gzz_nearnurseshouse_jackpumpkin" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_jackpumpkin" );

  elseif ( cmn.ApplyObj( item, "obj_jackpumpkin_use_kitchenknife" ) ) then

    cmn.CallEventHandler( "use_kitchenknife_inv" );
    cmn.CallEventHandler( "use_kitchenknife_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_kitchenknife" );
      cmn.CallEventHandler( "use_kitchenknife_end" );
      
      cmn.MiniGameShow();
      
    end;
    
    local anm_game = function ()
      
      ObjMultiSet( { {"obj_jackpumpkin_game", { alp = 1 }},
                     {"anm_jackpumpkin_use_knife", { alp = 0 }} } );
      ObjAnimate("spr_jackpumpkin_game_hint", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_nearnurseshouse/audio/aud_use_knife4lvl");

    ObjSet("anm_jackpumpkin_use_knife",  { alp = 1, playing = 1, endtrig = anm_game });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_homekeys()

  local item = "inv_homekeys";

  if cmn.ApplyObj( item, "gzz_nearnurseshouse_lvl4housedoor" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_lvl4housedoor" );

  elseif ( cmn.ApplyObj( item, "obj_lvl4housedoor_use_homekeys" ) ) then

    cmn.CallEventHandler( "use_homekeys_inv" );
    cmn.CallEventHandler( "use_homekeys_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_homekeys" );
      cmn.CallEventHandler( "use_homekeys_end" );
      
      common.CloseSubRoom();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_use_keydoor");
    
    ObjMultiSet( { { "anm_lvl4housedoor_door", { animfunc = "func_housekey_use", endtrig = func_after, playing = true } },
                   { "spr_lvl4housedoor_house", { alp = 1 } } } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_angelfigurine()

  local item = "inv_angelfigurine";

  if cmn.ApplyObj( item, "gzz_nearnurseshouse_figurines" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_figurines" );

  elseif ( cmn.ApplyObj( item, "obj_figurines_use_angelfigurine" ) ) then

    cmn.CallEventHandler( "use_angelfigurine_inv" );
    cmn.CallEventHandler( "use_angelfigurine_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_angelfigurine" );
      cmn.CallEventHandler( "use_angelfigurine_end" );

      if cmn.IsEventDone("use_devilfigurine") then
        common.CloseSubRoom();
        cmn.GotoRoom( "mg_angels" );
      else 
        cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_brokenfigurine/audio/aud_use_parts_gargoyle");
      end;
    
    end;
    
    local anm_open2 = function ()
      
      ObjAnimate("spr_figurines_cover_1_2", "pos_x", 0, 0, func_after, { 0, 0, -122,   1, 0, -254 });
      ObjAnimate("spr_figurines_cover_2_2", "pos_x", 0, 0, "", { 0, 0, 122,   1, 0, 254 });
      
      ObjAnimate("anm_figurines_devil_touch", "pos_x", 0, 0, "", { 0, 0, 0,   1, 0, 132 });
      ObjAnimate("anm_figurines_angel_touch", "pos_x", 0, 0, "", { 0, 0, 0,   1, 0, -132 });
      
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_brokenfigurine/audio/aud_use_parts_gargoyle");
      cmn.PlayAudio("snd", "assets/levels/level4/rm_nearnurseshouse/audio/aud_opn_angels");
      
      ObjDelete("anm_figurines_cover_touch");
      ObjDelete("anm_figurines_angel_use");
      
      ObjMultiSet( { {"anm_figurines_angel_touch", { alp = 1 }},
                     {"obj_figurines_cover_1", { alp = 1 }},
                     {"obj_figurines_cover_2", { alp = 1 }} } );
      
      ObjAnimate("spr_figurines_cover_1_1", "pos_x", 0, 0, anm_open2, { 0, 0, -17,   1, 0, -320 });
      ObjAnimate("spr_figurines_cover_2_1", "pos_x", 0, 0, "", { 0, 0, 2,   1, 0, 328 });
      
    end;

    cmn.Lock( 1 );

    if cmn.IsEventDone("use_devilfigurine") then
      ObjSet("anm_figurines_angel_use",  { alp = 1, playing = 1, endtrig = anm_open });
    else 
      ObjSet("anm_figurines_angel_use",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_devilfigurine()

  local item = "inv_devilfigurine";

  if cmn.ApplyObj( item, "gzz_nearnurseshouse_figurines" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_figurines" );

  elseif ( cmn.ApplyObj( item, "obj_figurines_use_devilfigurine" ) ) then

    cmn.CallEventHandler( "use_devilfigurine_inv" );
    cmn.CallEventHandler( "use_devilfigurine_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_devilfigurine" );
      cmn.CallEventHandler( "use_devilfigurine_end" );

      if cmn.IsEventDone("use_angelfigurine") then
        common.CloseSubRoom();
        cmn.GotoRoom( "mg_angels" );
      else 
        cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_brokenfigurine/audio/aud_use_parts_gargoyle");
      end;
    
    end;
    
    local anm_open2 = function ()
      
      ObjAnimate("spr_figurines_cover_1_2", "pos_x", 0, 0, func_after, { 0, 0, -122,   1, 0, -254 });
      ObjAnimate("spr_figurines_cover_2_2", "pos_x", 0, 0, "", { 0, 0, 122,   1, 0, 254 });
      
      ObjAnimate("anm_figurines_devil_touch", "pos_x", 0, 0, "", { 0, 0, 0,   1, 0, 132 });
      ObjAnimate("anm_figurines_angel_touch", "pos_x", 0, 0, "", { 0, 0, 0,   1, 0, -132 });
      
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_brokenfigurine/audio/aud_use_parts_gargoyle");
      cmn.PlayAudio("snd", "assets/levels/level4/rm_nearnurseshouse/audio/aud_opn_angels");
      
      ObjDelete("anm_figurines_cover_touch");
      ObjDelete("anm_figurines_devil_use");
      
      ObjMultiSet( { {"anm_figurines_devil_touch", { alp = 1 }},
                     {"obj_figurines_cover_1", { alp = 1 }},
                     {"obj_figurines_cover_2", { alp = 1 }} } );
      
      ObjAnimate("spr_figurines_cover_1_1", "pos_x", 0, 0, anm_open2, { 0, 0, -17,   1, 0, -320 });
      ObjAnimate("spr_figurines_cover_2_1", "pos_x", 0, 0, "", { 0, 0, 2,   1, 0, 328 });
      
    end;

    cmn.Lock( 1 );

    if cmn.IsEventDone("use_angelfigurine") then
      ObjSet("anm_figurines_devil_use",  { alp = 1, playing = 1, endtrig = anm_open });
    else 
      ObjSet("anm_figurines_devil_use",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_collectionstamp2()

  cmn.SetEventDone( "get_collectionstamp2" );
  cmn.CallEventHandler( "get_collectionstamp2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_burntnewspaper") and cmn.IsEventDone("get_ship") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_shellpart1()

  cmn.SetEventDone( "get_shellpart1" );
  cmn.CallEventHandler( "get_shellpart1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_burntnewspaper()

  cmn.SetEventDone( "get_burntnewspaper" );
  cmn.CallEventHandler( "get_burntnewspaper" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_collectionstamp2") and cmn.IsEventDone("get_ship") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_crowfeather()

  cmn.SetEventDone( "get_crowfeather" );
  cmn.CallEventHandler( "get_crowfeather" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_ship()

  cmn.SetEventDone( "get_ship" );
  cmn.CallEventHandler( "get_ship" );

  --cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_collectionstamp2") and cmn.IsEventDone("get_burntnewspaper") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_zipperrunner()

  cmn.SetEventDone( "get_zipperrunner" );
  cmn.CallEventHandler( "get_zipperrunner" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_figurehead()

  cmn.SetEventDone( "get_figurehead" );
  cmn.CallEventHandler( "get_figurehead" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_lockpart2") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_shellpart2()

  cmn.SetEventDone( "get_shellpart2" );
  cmn.CallEventHandler( "get_shellpart2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_horns()

  cmn.SetEventDone( "get_horns" );
  cmn.CallEventHandler( "get_horns" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_ornament1()

  cmn.SetEventDone( "get_ornament1" );
  cmn.CallEventHandler( "get_ornament1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_lockpart2()

  cmn.SetEventDone( "get_lockpart2" );
  cmn.CallEventHandler( "get_lockpart2" );

  --cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_figurehead") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_pliers()

  cmn.SetEventDone( "get_pliers" );
  cmn.CallEventHandler( "get_pliers" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_thickwire()

  cmn.SetEventDone( "get_thickwire" );
  cmn.CallEventHandler( "get_thickwire" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_nearnurseshouse()

  if not ( cmn.IsEventDone( "opn_nearnurseshouse" ) ) then
    cmn.SetEventDone( "opn_nearnurseshouse" );
    cmn.CallEventHandler("opn_nearnurseshouse");
    cmn.ShowBbt( "nearnurseshouse_open" );
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_lvl4housedoor()
  
  cmn.Lock(1);

  cmn.ShowBbt( "obj_lvl4housedoor_use_homekeys" );

  cmn.PlayAudio("snd", "assets/levels/level1/rm_entrancehall/audio/aud_xx_door2");
  
  if not cmn.IsEventDone("get_thickwire") then
    public.get_thickwire();
  end;
  
  ObjSet( "anm_lvl4housedoor_door", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_cat()
  
  cmn.Lock(1);

  cmn.ShowBbt( "obj_bench_use_fishsoup" );

  cmn.PlayAudio("snd", "assets/levels/level4/rm_nearnurseshouse/audio/aud_clk_cat");
  
  ObjSet( "anm_bench_touch_cat", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_tongs()
  
  cmn.Lock(1);

  cmn.ShowBbt( "obj_bench_use_tongs" );

  cmn.PlayAudio("snd", "assets/levels/level4/rm_ingingerbreadhouse/audio/aud_xx_pick");
  
  ObjSet( "anm_bench_tong", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_bench_cover()
  
  cmn.Lock(1);

  cmn.ShowBbt( "obj_bench_use_pinkbow" );

  cmn.PlayAudio("snd", "assets/levels/level2/rm_atshore/audio/aud_xx_wood_sand");
  
  ObjSet( "anm_bench_cover", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_ship()
  
  cmn.Lock(1);

  cmn.ShowBbt( "obj_postbox_use_nailpuller" );

  cmn.PlayAudio("snd", "assets/levels/level3/rm_policedepartment/audio/aud_xx_clk_grill2");
  
  ObjSet( "anm_postbox_ship_touch", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_mailbox()
  
  cmn.Lock(1);

  cmn.ShowBbt( "obj_postbox_use_crosskey" );

  cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_clk_door_small2");
  
  ObjSet( "anm_postbox_mailbox_touch", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_figurines_cover()
  
  cmn.Lock(1);

  cmn.ShowBbt( "obj_figurines_use_angelfigurine" );

  cmn.PlayAudio("snd", "assets/levels/level4/rm_neargingerbreadhouse/audio/aud_xx_clk_marble");
  
  ObjMultiSet( { {"anm_figurines_cover_touch", { playing = 1, endtrig = function() cmn.Lock(0); end }},
                 {"anm_figurines_angel_touch", { playing = 1 }},
                 {"anm_figurines_devil_touch", { playing = 1 }} } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Jackpumpkin *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_jackpumpkin = {};
public.zz_jackpumpkin = {};

function private.Init_Jackpumpkin()
  
  private.zz_jackpumpkin.start_state = { 2, 4, 4 };
  private.zz_jackpumpkin.win_state = { 1, 2, 3 };
  private.zz_jackpumpkin.in_progress = false;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_jackpumpkin" ] = {
    type = "win",
    room = "rm_nearnurseshouse",
    zz = "zz_jackpumpkin",
    zz_gate = "gzz_nearnurseshouse_jackpumpkin"
  };
  -----------------------------------------------------------------------------------
  local win_jackpumpkin = function ()

    if cmn.IsEventDone( "win_jackpumpkin" ) then
      
      ObjDelete( "gzz_nearnurseshouse_jackpumpkin" );
      ObjSet( "gho_nearnurseshouse_pumpkins", { input = 1, alp = 1, active = 1 } );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_jackpumpkin", win_jackpumpkin, "rm_nearnurseshouse" );

end;
--*********************************************************************************************************************
function private.zz_jackpumpkin.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_jackpumpkin" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_jackpumpkin" ].state = { 2, 4, 4 }; --собранное лицо
  
end;
-----------------------------------------------------------------------------------
function public.zz_jackpumpkin.Reset()
  
  local need_r = false;
  
  for i = 1, 3, 1 do
    
    if private.zz_jackpumpkin.state[i] ~= private.zz_jackpumpkin.start_state[i] then
      
      if not need_r then
        need_r = true;
      end;
      
      ObjAnimate("spr_jackpumpkin_part_"..i.."_"..private.zz_jackpumpkin.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_jackpumpkin_part_"..i.."_"..private.zz_jackpumpkin.start_state[i], "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
  end;
  
  if need_r then
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_nearnurseshouse/audio/aud_clk_pumpkin");
    
    private.zz_jackpumpkin.StartConditions();
    private.zz_jackpumpkin.state = ng_global.progress[ ng_global.currentprogress ][ "win_jackpumpkin" ].state;
    
    ObjSet("tmr_jackpumpkin_timer",  { time = 0.5, playing = 1, endtrig = function () cmn.Lock( 0 ); end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_jackpumpkin.Skip()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/rm_nearnurseshouse/audio/aud_clk_pumpkin");
  
  ng_global.progress[ ng_global.currentprogress ][ "win_jackpumpkin" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_jackpumpkin" ].state = { 1, 2, 3 };
  
  for i = 1, 3, 1 do
    
    if private.zz_jackpumpkin.state[i] ~= private.zz_jackpumpkin.win_state[i] then
      ObjAnimate("spr_jackpumpkin_part_"..i.."_"..private.zz_jackpumpkin.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_jackpumpkin_part_"..i.."_"..private.zz_jackpumpkin.win_state[i], "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    end;
    
  end;
  
  private.zz_jackpumpkin.state = ng_global.progress[ ng_global.currentprogress ][ "win_jackpumpkin" ].state;
  ObjSet("tmr_jackpumpkin_timer",  { time = 0.5, playing = 1, endtrig = private.zz_jackpumpkin.CheckWin });
  
end;
-----------------------------------------------------------------------------------
function private.zz_jackpumpkin.DrawScene()
  
  for i = 1, 3, 1 do
    for j = 1, 4, 1 do
      
      if private.zz_jackpumpkin.state[i] == j then
        ObjSet("spr_jackpumpkin_part_"..i.."_"..j,  { alp = 1 });
      else 
        ObjSet("spr_jackpumpkin_part_"..i.."_"..j,  { alp = 0 });
      end;
      
    end;
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_jackpumpkin.FocusHint( inout )
  
  local obj_name = "spr_jackpumpkin_game_hint_focus";

  local alf = ObjGet( obj_name ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.13 then
      cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_menter1");
    end;
  end;

  ObjAnimate(obj_name, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.zz_jackpumpkin.FocusPart( num, inout )
  
  local part = private.zz_jackpumpkin.state[num];
  
  if private.zz_jackpumpkin.in_progress then
    
    part = part - 1;
    
    if part < 1 then
      part = 4;
    end;
    
  end;
  
  local obj_name = "spr_jackpumpkin_part_"..num.."_"..part.."_focus";

  local alf = ObjGet( obj_name ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.13 then
      cmn.PlayAudio("snd", "assets/levels/level1/rm_doctorstudy/audio/aud_menter1");
    end;
  end;

  ObjAnimate(obj_name, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.zz_jackpumpkin.ChangePart( num )
  
  private.zz_jackpumpkin.in_progress = true;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/rm_nearnurseshouse/audio/aud_clk_pumpkin");
  
  local old = private.zz_jackpumpkin.state[num];
  local new = private.zz_jackpumpkin.state[num]+1;
  
  if new > 4 then
    new = 1;
  end;
  
  private.zz_jackpumpkin.state[num] = new;
  
  ObjAnimate("spr_jackpumpkin_part_"..num.."_"..old, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate("spr_jackpumpkin_part_"..num.."_"..new, "alp", 0, 0, private.zz_jackpumpkin.CheckWin, { 0, 0, 0,   0.5, 0, 1 });
  
end;
-----------------------------------------------------------------------------------
function public.zz_jackpumpkin.ShowHint()
  
  cmn.Lock( 1 );
  
  ObjAnimate("spr_jackpumpkin_pumpkin_hint", "alp", 0, 0, function () cmn.Lock( 0 ); end, { 0, 0, 0,   0.5, 0, 1,   2, 0, 1,   2.5, 0, 0 });
  
end;
-----------------------------------------------------------------------------------
function private.zz_jackpumpkin.CheckWin()
  
  private.zz_jackpumpkin.in_progress = false;
  
  local win_flag = true;
  
  for i = 1, 3, 1 do
    
    if private.zz_jackpumpkin.state[i] ~= private.zz_jackpumpkin.win_state[i] then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("jackpumpkin");
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
    
    ObjSet("tmr_jackpumpkin_timer",  { time = 1, playing = 1, endtrig = private.zz_jackpumpkin.Win });
    
  else 
    
    cmn.Lock( 0 );
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_jackpumpkin.Win()
  
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_jackpumpkin" );
  cmn.CallEventHandler( "win_jackpumpkin" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_jackpumpkin" ].skip == 0 and ng_global.noskipgames[ "win_jackpumpkin" ] == nil then

    ng_global.noskipgames[ "win_jackpumpkin" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

  cmn.Lock( 0 );
  common.CloseSubRoom();
  
end;
--*******************************************************************************************************************