-- name=rm_ward
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_ward";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.dlg_lipsync = "";
  private.dlg_start_func = "";
  --------------------------------------------------------------------------------------------
  -- function get_honey () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_honey" ] = {
        type = "get",
        get_obj = "spr_foodtray_honey",
        room = private.room_objname,
        zz = "zz_foodtray",
        zz_gate = "gzz_ward_foodtray"
    };
    --------------------------------------------------------------------------------------------
  local get_honey_inv = function ()
  
    interface.InventoryItemAdd( "inv_honey", "spr_foodtray_honey" );
  
  end;
  
  local get_honey_end = function ()
  
    if cmn.IsEventDone("get_longrod") then
      ObjDelete( "gzz_ward_foodtray" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_honey", get_honey_inv );
  cmn.AddSubscriber( "get_honey", get_honey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fishsoup () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_fishsoup" ] = {
        type = "get",
        get_obj = "spr_foodtray_fishsoup",
        room = private.room_objname,
        zz = "zz_foodtray",
        zz_gate = "gzz_ward_foodtray"
    };
    --------------------------------------------------------------------------------------------
  local get_fishsoup_inv = function ()
  
    interface.InventoryItemAdd( "inv_fishsoup", "spr_foodtray_fishsoup" );
  
  end;
  
  local get_fishsoup_end = function ()
  
    ObjDelete( "gfx_foodtray_fishsoup" );
    ObjDelete( "spr_foodtray_plate_sh" );
    ObjDelete( "spr_ward_tray_plate" );
    
    ObjSet("anm_foodtray_use_honeyspoon",  { pos_z = 6 });
  
  end;
  
  cmn.AddSubscriber( "get_fishsoup", get_fishsoup_inv );
  cmn.AddSubscriber( "get_fishsoup", get_fishsoup_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_kitchenknife () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_kitchenknife" ] = {
        type = "get",
        get_obj = "obj_foodtray_kitchenknife_get",
        room = private.room_objname,
        zz = "zz_foodtray",
        zz_gate = "gzz_ward_foodtray"
    };
    --------------------------------------------------------------------------------------------
  local get_kitchenknife_inv = function ()
  
    interface.InventoryItemAdd( "inv_kitchenknife", "spr_foodtray_kitchenknife" );
  
  end;
  
  local get_kitchenknife_end = function ()
  
    ObjDelete( "gfx_foodtray_kitchenknife" );
    ObjDelete( "spr_foodtray_kitchenknife_sh" );
    ObjDelete( "obj_foodtray_kitchenknife_get" );
  
  end;
  
  cmn.AddSubscriber( "get_kitchenknife", get_kitchenknife_inv );
  cmn.AddSubscriber( "get_kitchenknife", get_kitchenknife_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_twotoothedfork () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_twotoothedfork" ] = {
        type = "get",
        get_obj = "obj_foodtray_twotoothedfork_get",
        room = private.room_objname,
        zz = "zz_foodtray",
        zz_gate = "gzz_ward_foodtray"
    };
    --------------------------------------------------------------------------------------------
  local get_twotoothedfork_inv = function ()
  
    interface.InventoryItemAdd( "inv_twotoothedfork", "spr_foodtray_twotoothedfork" );
  
  end;
  
  local get_twotoothedfork_end = function ()
  
    ObjDelete( "gfx_foodtray_twotoothedfork" );
    ObjDelete( "spr_foodtray_twotoothedfork_sh" );
    ObjDelete( "obj_foodtray_twotoothedfork_get" );
  
  end;
  
  cmn.AddSubscriber( "get_twotoothedfork", get_twotoothedfork_inv );
  cmn.AddSubscriber( "get_twotoothedfork", get_twotoothedfork_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_longrod () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_longrod" ] = {
        type = "get",
        get_obj = "spr_foodtray_longrod",
        room = private.room_objname,
        zz = "zz_foodtray",
        zz_gate = "gzz_ward_foodtray"
    };
    --------------------------------------------------------------------------------------------
  local get_longrod_inv = function ()
  
    interface.InventoryItemAdd( "inv_longrod", "spr_foodtray_longrod" );
    ObjSet("inv_brokendogcase_star_light",  { alp = 1 });
  
  end;
  
  local get_longrod_end = function ()
  
    ObjDelete( "gfx_foodtray_longrod" );
    ObjDelete( "anm_foodtray_use_tongs" );
    
    if cmn.IsEventDone("get_honey") then
      ObjDelete( "gzz_ward_foodtray" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_longrod", get_longrod_inv );
  cmn.AddSubscriber( "get_longrod", get_longrod_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ballerina () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_ballerina" ] = {
        type = "get",
        get_obj = "spr_lvl4clock_ballerina",
        room = private.room_objname,
        zz = "zz_lvl4clock",
        zz_gate = "gzz_ward_lvl4clock"
    };
    --------------------------------------------------------------------------------------------
  local get_ballerina_inv = function ()
  
    interface.InventoryItemAdd( "inv_ballerina", "spr_lvl4clock_ballerina" );
  
  end;
  
  local get_ballerina_end = function ()
  
    ObjDelete( "gfx_lvl4clock_ballerina" );
    
    ObjDelete( "spr_ward_clock_open_1" );
    ObjSet("spr_ward_clock_open_2",  { alp = 1 });
    
    if cmn.IsEventDone("get_lvl4bolt2") then
      ObjDelete( "gzz_ward_lvl4clock" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_ballerina", get_ballerina_inv );
  cmn.AddSubscriber( "get_ballerina", get_ballerina_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl4bolt2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_lvl4bolt2" ] = {
        type = "get",
        get_obj = "spr_lvl4clock_lvl4bolt2",
        room = private.room_objname,
        zz = "zz_lvl4clock",
        zz_gate = "gzz_ward_lvl4clock"
    };
    --------------------------------------------------------------------------------------------
  local get_lvl4bolt2_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl4bolt", "spr_lvl4clock_lvl4bolt2", function () cmn.GetMultyObject( 'lvl4bolt', 2 ); end );
    int_map_impl.DecreaseRoomTasks("rm_ward");
      
    if cmn.CheckMultiObject( "lvl4bolt", 2 ) then
      ObjSet("inv_brokendogcase_star_light",  { alp = 1 });
    end;
  
  end;
  
  local get_lvl4bolt2_end = function ()
  
    ObjDelete( "gfx_lvl4clock_lvl4bolt2" );
    ObjDelete( "anm_lvl4clock_use_wrench" );
    
    ObjSet("spr_lvl4clock_clockpart",  { alp = 1 });
    
    if cmn.IsEventDone("get_ballerina") then
      ObjDelete( "gzz_ward_lvl4clock" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_lvl4bolt2", get_lvl4bolt2_inv );
  cmn.AddSubscriber( "get_lvl4bolt2", get_lvl4bolt2_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_pandaseye2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_pandaseye2" ] = {
      type = "get",
      get_obj = "spr_ward_pandaseye2",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_pandaseye2_inv = function ()
  
    interface.InventoryItemAdd( "inv_pandaseye2", "spr_ward_pandaseye2" );
  
  end;
  local get_pandaseye2_mid = function ()
  
    ObjDelete( "gfx_ward_pandaseye2" );
    ObjDelete( "spr_ward_pandaseye2_sh" );
    ObjDelete( "spr_ward_pandaseye2_sh_2" );
    
  end;
  local get_pandaseye2_end = function ()
  
    ObjDelete( "obj_ward_dialog_anna1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_pandaseye2", get_pandaseye2_inv );
  cmn.AddSubscriber( "get_pandaseye2_inv", get_pandaseye2_inv, private.room_objname );
  cmn.AddSubscriber( "get_pandaseye2", get_pandaseye2_mid, private.room_objname );
  cmn.AddSubscriber( "get_pandaseye2_mid", get_pandaseye2_mid, private.room_objname );
  cmn.AddSubscriber( "get_pandaseye2", get_pandaseye2_end, private.room_objname );
  cmn.AddSubscriber( "get_pandaseye2_end", get_pandaseye2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_puzzlepart4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_puzzlepart4" ] = {
      type = "get",
      get_obj = "spr_ward_puzzlepart4",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_puzzlepart4_inv = function ()
  
    interface.InventoryItemAdd( "inv_puzzlepart", "spr_ward_puzzlepart4", function () cmn.GetMultyObject( 'puzzlepart', 4 ); end );
  
  end;
  local get_puzzlepart4_mid = function ()
  
    ObjDelete( "gfx_ward_puzzlepart4" );
    ObjDelete( "spr_ward_puzzlepart4_sh" );
    ObjDelete( "spr_ward_puzzlepart4_sh_2" );
    
  end;
  local get_puzzlepart4_end = function ()
  
    ObjDelete( "obj_ward_dialog_anna2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_puzzlepart4", get_puzzlepart4_inv );
  cmn.AddSubscriber( "get_puzzlepart4_inv", get_puzzlepart4_inv, private.room_objname );
  cmn.AddSubscriber( "get_puzzlepart4", get_puzzlepart4_mid, private.room_objname );
  cmn.AddSubscriber( "get_puzzlepart4_mid", get_puzzlepart4_mid, private.room_objname );
  cmn.AddSubscriber( "get_puzzlepart4", get_puzzlepart4_end, private.room_objname );
  cmn.AddSubscriber( "get_puzzlepart4_end", get_puzzlepart4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_socksforsophia () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_socksforsophia" ] = {
      type = "get",
      get_obj = "spr_ward_socksforsophia",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_socksforsophia_inv = function ()
  
    interface.InventoryItemAdd( "inv_socksforsophia", "spr_ward_socksforsophia" );
    interface_impl.SetCurrentGlobalTask( 27 );
    
  end;
  local get_socksforsophia_clues = function ()
  
    interface_impl.SetCompleteClues( {2} );
    
  end;
  local get_socksforsophia_mid = function ()
  
    ObjDelete( "gfx_ward_socksforsophia" );
    ObjDelete( "spr_ward_socksforsophia_sh" );
    
  end;
  local get_socksforsophia_end = function ()
  
    ObjDelete( "obj_ward_dialog_anna3" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_socksforsophia", get_socksforsophia_inv );
  cmn.AddSubscriber( "get_socksforsophia_inv", get_socksforsophia_inv, private.room_objname );
  cmn.AddSubscriber( "get_socksforsophia", get_socksforsophia_mid, private.room_objname );
  cmn.AddSubscriber( "get_socksforsophia_mid", get_socksforsophia_mid, private.room_objname );
  cmn.AddSubscriber( "get_socksforsophia", get_socksforsophia_end, private.room_objname );
  cmn.AddSubscriber( "get_socksforsophia_end", get_socksforsophia_end, private.room_objname );
  cmn.AddSubscriber( "get_socksforsophia", get_socksforsophia_clues );
  cmn.AddSubscriber( "get_socksforsophia_clues", get_socksforsophia_clues );
  --------------------------------------------------------------------------------------------
  -- function get_sophiasaddress () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_sophiasaddress" ] = {
      type = "get",
      get_obj = "spr_ward_sophiasaddress",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_sophiasaddress_inv = function ()
  
    interface.InventoryItemAdd( "inv_sophiasaddress", "spr_ward_sophiasaddress" );
  
  end;
  local get_sophiasaddress_mid = function ()
  
    ObjDelete( "gfx_ward_sophiasaddress" );
    ObjDelete( "spr_ward_sophiasaddress_sh" );
    
  end;
  local get_sophiasaddress_end = function ()
  
    ObjDelete( "obj_ward_dialog_anna4" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_sophiasaddress", get_sophiasaddress_inv );
  cmn.AddSubscriber( "get_sophiasaddress_inv", get_sophiasaddress_inv, private.room_objname );
  cmn.AddSubscriber( "get_sophiasaddress", get_sophiasaddress_mid, private.room_objname );
  cmn.AddSubscriber( "get_sophiasaddress_mid", get_sophiasaddress_mid, private.room_objname );
  cmn.AddSubscriber( "get_sophiasaddress", get_sophiasaddress_end, private.room_objname );
  cmn.AddSubscriber( "get_sophiasaddress_end", get_sophiasaddress_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_puzzlepart () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_puzzlepart" ] = {
        type = "use",
        inv_obj = "inv_puzzlepart",
        use_place = "obj_drawerunit_use_puzzlepart",
        room = private.room_objname,
        zz = "zz_drawerunit",
        zz_gate = "gzz_ward_drawerunit"
    };
  --------------------------------------------------------------------------------------------
  local use_puzzlepart_inv = function ()
  
    interface.InventoryItemRemove( "inv_puzzlepart" );
  
  end;
  local use_puzzlepart_beg = function ()
  
    ObjDelete( "obj_drawerunit_use_puzzlepart" );
  
  end;
  local use_puzzlepart_end = function ()
  
    ObjDelete( "gzz_ward_drawerunit" );
    ObjMultiSet( { {"gmg_ward_boxdoors", { input = 1, alp = 1, active = 1 }},
                   {"spr_ward_drawers_closed", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_puzzlepart", use_puzzlepart_beg, private.room_objname );
  cmn.AddSubscriber( "use_puzzlepart", use_puzzlepart_inv );
  cmn.AddSubscriber( "use_puzzlepart", use_puzzlepart_end, private.room_objname );
  cmn.AddSubscriber( "use_puzzlepart_inv", use_puzzlepart_inv, private.room_objname );
  cmn.AddSubscriber( "use_puzzlepart_beg", use_puzzlepart_beg, private.room_objname );
  cmn.AddSubscriber( "use_puzzlepart_end", use_puzzlepart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cakeamulet () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_cakeamulet" ] = {
        type = "use",
        inv_obj = "inv_cakeamulet",
        use_place = "obj_foodtray_use_cakeamulet",
        room = private.room_objname,
        zz = "zz_foodtray",
        zz_gate = "gzz_ward_foodtray"
    };
  --------------------------------------------------------------------------------------------
  local use_cakeamulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_cakeamulet" );
  
  end;
  local use_cakeamulet_beg = function ()
  
    ObjDelete( "obj_foodtray_use_cakeamulet" );
    ObjDelete( "anm_foodtray_drawer_touch" );
  
  end;
  local use_cakeamulet_end = function ()
    
    ObjDelete( "spr_foodtray_rod" );
    ObjDelete( "spr_foodtray_rod_sh" );
  
    ObjMultiSet( { {"anm_foodtray_drawer_open", { alp = 1, frame = 300 }},
                   {"obj_foodtray_drawer", { input = 1 }},
                   {"obj_foodtray_use_tongs", { input = 1 }},
                   {"anm_foodtray_rod_touch", { alp = 1 }},
                   {"spr_ward_tray_drawer_open", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cakeamulet", use_cakeamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_cakeamulet", use_cakeamulet_inv );
  cmn.AddSubscriber( "use_cakeamulet", use_cakeamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_cakeamulet_inv", use_cakeamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_cakeamulet_beg", use_cakeamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_cakeamulet_end", use_cakeamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tongs () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_tongsfoodtray" ] = {
        type = "use",
        inv_obj = "inv_tongs",
        use_place = "obj_foodtray_use_tongs",
        room = private.room_objname,
        zz = "zz_foodtray",
        zz_gate = "gzz_ward_foodtray"
    };
    game.hint[ "use_tongsbench" ] = {
        type = "use",
        inv_obj = "inv_tongs",
        use_place = "obj_bench_use_tongs",
        room = "rm_nearnurseshouse",
        zz = "zz_bench",
        zz_gate = "gzz_nearnurseshouse_bench"
    };
  --------------------------------------------------------------------------------------------
  local use_tongs_inv1 = function ()
  
    if cmn.IsEventDone("use_tongsbench") then
      interface.InventoryItemRemove( "inv_tongs" );
    end;
  
  end;
  local use_tongs_beg1 = function ()
  
    ObjDelete( "obj_foodtray_use_tongs" );
    ObjDelete( "anm_foodtray_rod_touch" );
  
  end;
  local use_tongs_end1 = function ()
    
    ObjDelete( "anm_foodtray_use_tongs_2" );
  
    ObjSet( "spr_foodtray_longrod", { alp = 1 } );
  
  end;
   
  local use_tongs_inv2 = function ()
  
    if cmn.IsEventDone("use_tongsfoodtray") then
      interface.InventoryItemRemove( "inv_tongs" );
    end;
  
  end;
  local use_tongs_beg2 = function ()
  
    ObjDelete( "obj_bench_use_tongs" );
  
  end;
  local use_tongs_end2 = function ()
  
    ObjDelete( "anm_bench_tong" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tongsfoodtray", use_tongs_beg1, private.room_objname );
  cmn.AddSubscriber( "use_tongsfoodtray", use_tongs_inv1 );
  cmn.AddSubscriber( "use_tongsfoodtray", use_tongs_end1, private.room_objname );
  cmn.AddSubscriber( "use_tongs_inv1", use_tongs_inv1, private.room_objname );
  cmn.AddSubscriber( "use_tongs_beg1", use_tongs_beg1, private.room_objname );
  cmn.AddSubscriber( "use_tongs_end1", use_tongs_end1, private.room_objname );
  
  cmn.AddSubscriber( "use_tongsbench", use_tongs_beg2, "rm_nearnurseshouse" );
  cmn.AddSubscriber( "use_tongsbench", use_tongs_inv2 );
  cmn.AddSubscriber( "use_tongsbench", use_tongs_end2, "rm_nearnurseshouse" );
  cmn.AddSubscriber( "use_tongs_inv2", use_tongs_inv2, "rm_nearnurseshouse" );
  cmn.AddSubscriber( "use_tongs_beg2", use_tongs_beg2, "rm_nearnurseshouse" );
  cmn.AddSubscriber( "use_tongs_end2", use_tongs_end2, "rm_nearnurseshouse" );
  --------------------------------------------------------------------------------------------
  -- function use_selfmadepen () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_selfmadepen" ] = {
        type = "use",
        inv_obj = "inv_selfmadepen",
        use_place = "obj_foodtray_use_selfmadepen",
        room = private.room_objname,
        zz = "zz_foodtray",
        zz_gate = "gzz_ward_foodtray"
    };
  --------------------------------------------------------------------------------------------
  local use_selfmadepen_inv = function ()
  
    interface.InventoryItemRemove( "inv_selfmadepen" );
  
  end;
  local use_selfmadepen_beg = function ()
  
    ObjDelete( "obj_foodtray_use_selfmadepen" );
  
  end;
  local use_selfmadepen_end = function ()
    
    ObjDelete( "anm_foodtray_pan_open" );
    ObjDelete( "obj_foodtray_pan_cover" );
    
    ObjDelete( "spr_ward_tray_pan_cover" );
  
    ObjSet("obj_foodtray_clk_poursouptobowl",  { input = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_selfmadepen", use_selfmadepen_beg, private.room_objname );
  cmn.AddSubscriber( "use_selfmadepen", use_selfmadepen_inv );
  cmn.AddSubscriber( "use_selfmadepen", use_selfmadepen_end, private.room_objname );
  cmn.AddSubscriber( "use_selfmadepen_inv", use_selfmadepen_inv, private.room_objname );
  cmn.AddSubscriber( "use_selfmadepen_beg", use_selfmadepen_beg, private.room_objname );
  cmn.AddSubscriber( "use_selfmadepen_end", use_selfmadepen_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_honeyspoon () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_honeyspoon" ] = {
        type = "use",
        inv_obj = "inv_honeyspoon",
        use_place = "obj_foodtray_use_honeyspoon",
        room = private.room_objname,
        zz = "zz_foodtray",
        zz_gate = "gzz_ward_foodtray"
    };
  --------------------------------------------------------------------------------------------
  local use_honeyspoon_inv = function ()
  
    interface.InventoryItemRemove( "inv_honeyspoon" );
  
  end;
  local use_honeyspoon_beg = function ()
  
    ObjDelete( "obj_foodtray_use_honeyspoon" );
    ObjDelete( "anm_foodtray_honey_touch" );
  
  end;
  local use_honeyspoon_end = function ()
  
    ObjSet( "anm_foodtray_use_honeyspoon", { alp = 1, frame = 300 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_honeyspoon", use_honeyspoon_beg, private.room_objname );
  cmn.AddSubscriber( "use_honeyspoon", use_honeyspoon_inv );
  cmn.AddSubscriber( "use_honeyspoon", use_honeyspoon_end, private.room_objname );
  cmn.AddSubscriber( "use_honeyspoon_inv", use_honeyspoon_inv, private.room_objname );
  cmn.AddSubscriber( "use_honeyspoon_beg", use_honeyspoon_beg, private.room_objname );
  cmn.AddSubscriber( "use_honeyspoon_end", use_honeyspoon_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wrench () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_wrenchclock" ] = {
        type = "use",
        inv_obj = "inv_wrench",
        use_place = "obj_lvl4clock_use_wrench",
        room = "rm_ward",
        zz = "zz_lvl4clock",
        zz_gate = "gzz_ward_lvl4clock"
    };
    game.hint[ "use_wrenchdogcase" ] = {
        type = "use",
        inv_obj = "inv_wrench",
        use_place = "obj_complex_brokendogcase_use_wrench",
        room = "int_complex_inv",
        zz = "inv_complex_brokendogcase",
        zz_gate = "inv_brokendogcase"
    };
  --------------------------------------------------------------------------------------------
  local use_wrench_beg1 = function ()
  
    ObjDelete( "obj_lvl4clock_use_wrench" );
    ObjDelete( "anm_lvl4clock_bolt_touch" );
  
  end;
  local use_wrench_end1 = function ()
  
    --ObjSet( "spr_lvl4clock_lvl4bolt2", { input = 1, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wrenchclock", use_wrench_beg1, "rm_ward" );
  cmn.AddSubscriber( "use_wrenchclock", use_wrench_end1, "rm_ward" );
  cmn.AddSubscriber( "use_wrench_beg1", use_wrench_beg1, "rm_ward" );
  cmn.AddSubscriber( "use_wrench_end1", use_wrench_end1, "rm_ward" );
  --------------------------------------------------------------------------------------------
  local use_wrench_inv2 = function ()

    if ( cmn.IsEventDone( "use_wrenchclock" ) ) then
      interface.InventoryItemRemove( "inv_wrench" );
    end;
    
    if not cmn.IsEventDone("get_dogname") then
      ObjSet("inv_brokendogcase_star_light",  { alp = 0 });
    end;

  end;
  local use_wrench_beg2 = function ()

    ObjDelete( "obj_complex_brokendogcase_use_wrench" );

  end;
  local use_wrench_end2 = function ()
    
    ObjSet("anm_complex_brokendogcase_use_wrench",  { alp = 1, frame = 300 });
                   
    if cmn.IsEventDone("use_dogname") then
      ObjSet("spr_complex_brokendogcase_dogcage",  { input = 1 });
    else
      ObjSet("obj_complex_brokendogcase_use_dogname",  { input = 1 });
    end;

  end;
  cmn.AddSubscriber( "use_wrenchdogcase", use_wrench_inv2 );
  cmn.AddSubscriber( "use_wrenchdogcase", use_wrench_beg2, "inv_complex_brokendogcase" );
  cmn.AddSubscriber( "use_wrenchdogcase", use_wrench_end2, "inv_complex_brokendogcase" );
  cmn.AddSubscriber( "use_wrench_inv2", use_wrench_inv2 );
  cmn.AddSubscriber( "use_wrench_beg2", use_wrench_beg2, "inv_complex_brokendogcase" );
  cmn.AddSubscriber( "use_wrench_end2", use_wrench_end2, "inv_complex_brokendogcase" );
  --------------------------------------------------------------------------------------------
  -- function use_lvl4clockhands () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_lvl4clockhands" ] = {
        type = "use",
        inv_obj = "inv_lvl4clockhands",
        use_place = "obj_lvl4clock_use_lvl4clockhands",
        room = private.room_objname,
        zz = "zz_lvl4clock",
        zz_gate = "gzz_ward_lvl4clock"
    };
  --------------------------------------------------------------------------------------------
  local use_lvl4clockhands_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl4clockhands" );
  
  end;
  local use_lvl4clockhands_beg = function ()
  
    ObjDelete( "obj_lvl4clock_use_lvl4clockhands" );
    ObjDelete( "anm_lvl4clock_door_touch" );
  
  end;
  local use_lvl4clockhands_end = function ()
  
    ObjMultiSet( { {"anm_lvl4clock_use_lvl4clockhands", { input = 1, alp = 1, frame = 300 }},
                   {"spr_ward_clock_open_1", { alp = 1 }},
                   {"spr_ward_clock_hands", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl4clockhands", use_lvl4clockhands_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4clockhands", use_lvl4clockhands_inv );
  cmn.AddSubscriber( "use_lvl4clockhands", use_lvl4clockhands_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl4clockhands_inv", use_lvl4clockhands_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl4clockhands_beg", use_lvl4clockhands_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4clockhands_end", use_lvl4clockhands_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_volunteersign () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_volunteersign" ] = {
        type = "use",
        inv_obj = "inv_volunteersign",
        use_place = "obj_ward_use_volunteersign",
        room = private.room_objname
    };
  --------------------------------------------------------------------------------------------
  local use_volunteersign_inv = function ()
  
    interface.InventoryItemRemove( "inv_volunteersign" );
    interface_impl.SetCurrentGlobalTask( 26 );
  
  end;
  local use_volunteersign_beg = function ()
  
    ObjDelete( "obj_ward_use_volunteersign" );
  
  end;
  local use_volunteersign_end = function ()
    
    ObjDelete("vid_ward_dialog_anna2_lipsync1");
    ObjDelete("vid_ward_dialog_anna2_lipsync2");
    ObjDelete("vid_ward_dialog_anna2_lipsync3");
    ObjDelete("spr_ward_dialog_anna2_glasses");
    
    ObjDelete("anm_ward_dialog_anna2_hands_1");
  
    ObjAttach("obj_ward_dialog_anna2", "rm_ward");
    
    ObjMultiSet( { { "obj_ward_dialog_anna2", { input = 1, alp = 1 } },
                   { "anm_ward_dialog_anna2_give", { input = 1, alp = 1, frame = 300 } },
                   { "obj_ward_use_knittingneedles", { input = 1, alp = 1 } },
                   { "obj_ward_use_unfinishedsocks", { input = 1, alp = 1 } },
                   { "obj_ward_use_woolball", { input = 1, alp = 1 } },
                   { "anm_ward_dialog_anna2_head", { alp = 1 } },
                   { "spr_ward_bed_sign", { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_volunteersign", use_volunteersign_beg, private.room_objname );
  cmn.AddSubscriber( "use_volunteersign", use_volunteersign_inv );
  cmn.AddSubscriber( "use_volunteersign", use_volunteersign_end, private.room_objname );
  cmn.AddSubscriber( "use_volunteersign_inv", use_volunteersign_inv, private.room_objname );
  cmn.AddSubscriber( "use_volunteersign_beg", use_volunteersign_beg, private.room_objname );
  cmn.AddSubscriber( "use_volunteersign_end", use_volunteersign_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_woolball () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_woolball" ] = {
        type = "use",
        inv_obj = "inv_woolball",
        use_place = "obj_ward_use_woolball",
        room = private.room_objname
    };
  --------------------------------------------------------------------------------------------
  local use_woolball_inv = function ()
  
    interface.InventoryItemRemove( "inv_woolball" );
  
  end;
  local use_woolball_beg = function ()
  
    ObjDelete( "obj_ward_use_woolball" );
  
  end;
  local use_woolball_end = function ()
    
    ObjSet("spr_ward_bed_wool",  { alp = 1 });
    
    if cmn.IsEventDone("use_unfinishedsocks") and cmn.IsEventDone("use_knittingneedles") then
  
      ObjDelete("anm_ward_dialog_anna3_hands_1");
      ObjAttach("obj_ward_dialog_anna3", "rm_ward");
      
      ObjDelete("vid_ward_dialog_anna3_lipsync1");
      ObjDelete("vid_ward_dialog_anna3_lipsync2");
      ObjDelete("spr_ward_dialog_anna3_glasses");
      
      ObjMultiSet( { { "obj_ward_dialog_anna3", { input = 1, alp = 1 } },
                     { "anm_ward_dialog_anna3_give", { input = 1, alp = 1, frame = 300 } },
                     { "obj_ward_use_lvl4pen", { input = 1, alp = 1 } },
                     { "obj_ward_use_lvl4notebook", { input = 1, alp = 1 } },
                     { "anm_ward_dialog_anna3_head", { alp = 1 } } } );
                     
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_woolball", use_woolball_beg, private.room_objname );
  cmn.AddSubscriber( "use_woolball", use_woolball_inv );
  cmn.AddSubscriber( "use_woolball", use_woolball_end, private.room_objname );
  cmn.AddSubscriber( "use_woolball_inv", use_woolball_inv, private.room_objname );
  cmn.AddSubscriber( "use_woolball_beg", use_woolball_beg, private.room_objname );
  cmn.AddSubscriber( "use_woolball_end", use_woolball_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl4pen () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_lvl4pen" ] = {
        type = "use",
        inv_obj = "inv_lvl4pen",
        use_place = "obj_ward_use_lvl4pen",
        room = private.room_objname
    };
  --------------------------------------------------------------------------------------------
  local use_lvl4pen_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl4pen" );
  
  end;
  local use_lvl4pen_beg = function ()
  
    ObjDelete( "obj_ward_use_lvl4pen" );
  
  end;
  local use_lvl4pen_end = function ()
    
    ObjSet("spr_ward_bed_pen",  { alp = 1 });
  
    if cmn.IsEventDone("use_lvl4notebook") then
  
      ObjDelete("anm_ward_dialog_anna4_hands_1");
      ObjAttach("obj_ward_dialog_anna4", "rm_ward");
      
      ObjDelete("vid_ward_dialog_anna4_lipsync1");
      ObjDelete("spr_ward_dialog_anna4_glasses");
      
      ObjMultiSet( { { "obj_ward_dialog_anna4", { input = 1, alp = 1 } },
                     { "anm_ward_dialog_anna4_give", { input = 1, alp = 1, frame = 300 } },
                     { "anm_ward_dialog_anna4_head", { alp = 1 } } } );
                     
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl4pen", use_lvl4pen_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4pen", use_lvl4pen_inv );
  cmn.AddSubscriber( "use_lvl4pen", use_lvl4pen_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl4pen_inv", use_lvl4pen_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl4pen_beg", use_lvl4pen_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4pen_end", use_lvl4pen_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_knittingneedles () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_knittingneedles" ] = {
        type = "use",
        inv_obj = "inv_knittingneedles",
        use_place = "obj_ward_use_knittingneedles",
        room = private.room_objname
    };
  --------------------------------------------------------------------------------------------
  local use_knittingneedles_inv = function ()
  
    interface.InventoryItemRemove( "inv_knittingneedles" );
  
  end;
  local use_knittingneedles_beg = function ()
  
    ObjDelete( "obj_ward_use_knittingneedles" );
  
  end;
  local use_knittingneedles_end = function ()
    
    ObjSet("spr_ward_bed_needles",  { alp = 1 });
  
    if cmn.IsEventDone("use_unfinishedsocks") and cmn.IsEventDone("use_woolball") then
  
      ObjDelete("anm_ward_dialog_anna3_hands_1");
      ObjAttach("obj_ward_dialog_anna3", "rm_ward");
      
      ObjDelete("vid_ward_dialog_anna3_lipsync1");
      ObjDelete("vid_ward_dialog_anna3_lipsync2");
      ObjDelete("spr_ward_dialog_anna3_glasses");
      
      ObjMultiSet( { { "obj_ward_dialog_anna3", { input = 1, alp = 1 } },
                     { "anm_ward_dialog_anna3_give", { input = 1, alp = 1, frame = 300 } },
                     { "obj_ward_use_lvl4pen", { input = 1, alp = 1 } },
                     { "obj_ward_use_lvl4notebook", { input = 1, alp = 1 } },
                     { "anm_ward_dialog_anna3_head", { alp = 1 } } } );
                     
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_knittingneedles", use_knittingneedles_beg, private.room_objname );
  cmn.AddSubscriber( "use_knittingneedles", use_knittingneedles_inv );
  cmn.AddSubscriber( "use_knittingneedles", use_knittingneedles_end, private.room_objname );
  cmn.AddSubscriber( "use_knittingneedles_inv", use_knittingneedles_inv, private.room_objname );
  cmn.AddSubscriber( "use_knittingneedles_beg", use_knittingneedles_beg, private.room_objname );
  cmn.AddSubscriber( "use_knittingneedles_end", use_knittingneedles_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl4notebook () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_lvl4notebook" ] = {
        type = "use",
        inv_obj = "inv_lvl4notebook",
        use_place = "obj_ward_use_lvl4notebook",
        room = private.room_objname
    };
  --------------------------------------------------------------------------------------------
  local use_lvl4notebook_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl4notebook" );
  
  end;
  local use_lvl4notebook_beg = function ()
  
    ObjDelete( "obj_ward_use_lvl4notebook" );
  
  end;
  local use_lvl4notebook_end = function ()
    
    ObjSet("spr_ward_bed_notebook",  { alp = 1 });
  
    if cmn.IsEventDone("use_lvl4pen") then
  
      ObjDelete("anm_ward_dialog_anna4_hands_1");
      ObjAttach("obj_ward_dialog_anna4", "rm_ward");
      
      ObjDelete("vid_ward_dialog_anna4_lipsync1");
      ObjDelete("spr_ward_dialog_anna4_glasses");
      
      ObjMultiSet( { { "obj_ward_dialog_anna4", { input = 1, alp = 1 } },
                     { "anm_ward_dialog_anna4_give", { input = 1, alp = 1, frame = 300 } },
                     { "anm_ward_dialog_anna4_head", { alp = 1 } } } );
                     
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl4notebook", use_lvl4notebook_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4notebook", use_lvl4notebook_inv );
  cmn.AddSubscriber( "use_lvl4notebook", use_lvl4notebook_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl4notebook_inv", use_lvl4notebook_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl4notebook_beg", use_lvl4notebook_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4notebook_end", use_lvl4notebook_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_unfinishedsocks () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_unfinishedsocks" ] = {
        type = "use",
        inv_obj = "inv_unfinishedsocks",
        use_place = "obj_ward_use_unfinishedsocks",
        room = private.room_objname
    };
  --------------------------------------------------------------------------------------------
  local use_unfinishedsocks_inv = function ()
  
    interface.InventoryItemRemove( "inv_unfinishedsocks" );
  
  end;
  local use_unfinishedsocks_beg = function ()
  
    ObjDelete( "obj_ward_use_unfinishedsocks" );
  
  end;
  local use_unfinishedsocks_end = function ()
    
    ObjSet("spr_ward_bed_socks",  { alp = 1 });
  
    if cmn.IsEventDone("use_knittingneedles") and cmn.IsEventDone("use_woolball") then
  
      ObjDelete("anm_ward_dialog_anna3_hands_1");
      ObjAttach("obj_ward_dialog_anna3", "rm_ward");
      
      ObjDelete("vid_ward_dialog_anna3_lipsync1");
      ObjDelete("vid_ward_dialog_anna3_lipsync2");
      ObjDelete("spr_ward_dialog_anna3_glasses");
      
      ObjMultiSet( { { "obj_ward_dialog_anna3", { input = 1, alp = 1 } },
                     { "anm_ward_dialog_anna3_give", { input = 1, alp = 1, frame = 300 } },
                     { "obj_ward_use_lvl4pen", { input = 1, alp = 1 } },
                     { "obj_ward_use_lvl4notebook", { input = 1, alp = 1 } },
                     { "anm_ward_dialog_anna3_head", { alp = 1 } } } );
                     
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_unfinishedsocks", use_unfinishedsocks_beg, private.room_objname );
  cmn.AddSubscriber( "use_unfinishedsocks", use_unfinishedsocks_inv );
  cmn.AddSubscriber( "use_unfinishedsocks", use_unfinishedsocks_end, private.room_objname );
  cmn.AddSubscriber( "use_unfinishedsocks_inv", use_unfinishedsocks_inv, private.room_objname );
  cmn.AddSubscriber( "use_unfinishedsocks_beg", use_unfinishedsocks_beg, private.room_objname );
  cmn.AddSubscriber( "use_unfinishedsocks_end", use_unfinishedsocks_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_poursouptobowl () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_poursouptobowl" ] = {
    type = "click",
    use_place = "obj_foodtray_clk_poursouptobowl",
    room = private.room_objname,
    zz = "zz_foodtray",
    zz_gate = "gzz_ward_foodtray"
  };
  --------------------------------------------------------------------------------------------
  local clk_poursouptobowl_beg = function ()
  
    ObjDelete( "obj_foodtray_clk_poursouptobowl" );
    ObjDelete( "obj_foodtray_touch_plate" );
    ObjDelete( "anm_foodtray_plate_touch" );
    
    ObjMultiSet( { {"spr_foodtray_fishsoup", { alp = 1 }},
                   {"spr_foodtray_plate_sh", { alp = 1 }} } );
  
  end;
  local clk_poursouptobowl_end = function ()
    
    ObjDelete( "spr_foodtray_fishsoup_soup" );
    ObjDelete( "spr_foodtray_fishsoup_soup_sh" );
  
    ObjMultiSet( { {"anm_foodtray_pan_use",  { alp = 1, frame = 300 }},
                   {"spr_foodtray_fishsoup", { input = 1 }},
                   {"spr_foodtray_fishsoup_soup_2", { alp = 1 }},
                   {"spr_foodtray_fishsoup_soup_3", { alp = 1 }},
                   {"gfx_foodtray_fishsoup", { alp = 1, active = 1 }},
                   {"spr_ward_tray_fish", { alp = 1 }} } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_poursouptobowl", clk_poursouptobowl_beg, private.room_objname );
  cmn.AddSubscriber( "clk_poursouptobowl", clk_poursouptobowl_end, private.room_objname );
  cmn.AddSubscriber( "clk_poursouptobowl_beg", clk_poursouptobowl_beg, private.room_objname );
  cmn.AddSubscriber( "clk_poursouptobowl_end", clk_poursouptobowl_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_wardfirst () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_wardfirst" ] = {
    type = "click",
    use_place = "obj_ward_clk_wardfirst",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_wardfirst_task = function ()
    interface_impl.SetCurrentGlobalTask( 30 );
  end;
  local clk_wardfirst_loc = function ()
    
    ObjDelete("vid_ward_dialog_anna1_lipsync1");
    ObjDelete("spr_ward_dialog_anna1_glasses");
    
    ObjDelete("obj_ward_clk_wardfirst");
    ObjDelete("anm_ward_dialog_anna1_hands_1");
    
    ObjAttach("obj_ward_dialog_anna1", "rm_ward");
    
    ObjMultiSet( { { "obj_ward_use_volunteersign", { input = 1, alp = 1 } },
                   { "obj_ward_dialog_anna1", { input = 1, alp = 1 } },
                   { "anm_ward_dialog_anna1_give", { input = 1, alp = 1, frame = 300 } },
                   { "anm_ward_dialog_anna1_head", { alp = 1 } },
                   { "gzz_ward_drawerunit", { event_mdown = function() cmn.GotoSubRoomMDown( "ward_drawerunit" ); end, event_mup = function() cmn.GotoSubRoomMUp( "ward_drawerunit", "zz_drawerunit" ); end } },
                   { "gzz_ward_foodtray", { event_mdown = function() cmn.GotoSubRoomMDown( "ward_foodtray" ); end, event_mup = function() cmn.GotoSubRoomMUp( "ward_foodtray", "zz_foodtray" ); end } },
                   { "gzz_ward_lvl4clock", { event_mdown = function() cmn.GotoSubRoomMDown( "ward_lvl4clock" ); end, event_mup = function() cmn.GotoSubRoomMUp( "ward_lvl4clock", "zz_lvl4clock" ); end } } } );
                   
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_wardfirst", clk_wardfirst_loc, private.room_objname );
  cmn.AddSubscriber( "clk_wardfirst", clk_wardfirst_task );

  --------------------------------------------------------------------------------------------
  -- function opn_ward () end;
  --------------------------------------------------------------------------------------------
  local opn_ward = function ()
  
    int_map_impl.OpenRoom( "rm_ward" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_ward", opn_ward );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_foodtray" );
  
  function zz_foodtray.Close()
    
    cmn.HideNote( 0 );
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_ward();
  
  if cmn.IsEventDone("clk_wardfirst") and not cmn.IsEventDone("get_pandaseye2") then
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  end;
  if cmn.IsEventDone("use_volunteersign") and not cmn.IsEventDone("get_puzzlepart4") then
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  end;
  if cmn.IsEventDone("use_woolball") and cmn.IsEventDone("use_unfinishedsocks") and cmn.IsEventDone("use_knittingneedles") and not cmn.IsEventDone("get_socksforsophia") then
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  end;
  if cmn.IsEventDone("use_lvl4pen") and cmn.IsEventDone("use_lvl4notebook") and not cmn.IsEventDone("get_sophiasaddress") then
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/common/audio/audio2/aud_mermaidsward_env");
  cmn.PlayAudio("env", "assets/levels/common/audio/audio2/aud_mermaidsward_env");
  
  if cmn.IsEventDone("clk_wardfirst") and not cmn.IsEventDone("get_pandaseye2") then
    common_impl.current_dialog = "obj_ward_dialog_anna1";
    --ObjSet("anm_ward_dialog_anna1_hand_2",  { playing = 1 });
  end;
  if cmn.IsEventDone("use_volunteersign") and not cmn.IsEventDone("get_puzzlepart4") then
    common_impl.current_dialog = "obj_ward_dialog_anna2";
    --ObjSet("anm_ward_dialog_anna2_hand_2",  { playing = 1 });
  end;
  if cmn.IsEventDone("use_woolball") and cmn.IsEventDone("use_unfinishedsocks") and cmn.IsEventDone("use_knittingneedles") and not cmn.IsEventDone("get_socksforsophia") then
    common_impl.current_dialog = "obj_ward_dialog_anna3";
    --ObjSet("anm_ward_dialog_anna3_hand_2",  { playing = 1 });
  end;
  if cmn.IsEventDone("use_lvl4pen") and cmn.IsEventDone("use_lvl4notebook") and not cmn.IsEventDone("get_sophiasaddress") then
    common_impl.current_dialog = "obj_ward_dialog_anna4";
    --ObjSet("anm_ward_dialog_anna4_hand_2",  { playing = 1 });
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_puzzlepart()

  local item = "inv_puzzlepart";

  if cmn.ApplyObj( item, "gzz_ward_drawerunit" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_drawerunit" );

  elseif ( cmn.ApplyObj( item, "obj_drawerunit_use_puzzlepart" ) and cmn.CheckMultiObject( "puzzlepart", 4 ) ) then

    cmn.CallEventHandler( "use_puzzlepart_inv" );
    cmn.CallEventHandler( "use_puzzlepart_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_puzzlepart" );
      cmn.CallEventHandler( "use_puzzlepart_end" );
      
      common.CloseSubRoom();
      cmn.GotoRoom("mg_boxdoors");
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_ward/audio/aud_use_parts_drawers");

    ObjAnimate("spr_drawerunit_puzzle_3", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    ObjAnimate("spr_drawerunit_puzzle_3_sh", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    
    ObjAnimate("spr_drawerunit_puzzle_2", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1 });
    ObjAnimate("spr_drawerunit_puzzle_2_sh", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1 });
    
    ObjAnimate("spr_drawerunit_puzzle_1", "alp", 0, 0, "", { 0, 0, 0,   0.6, 0, 0,   0.9, 0, 1 });
    ObjAnimate("spr_drawerunit_puzzle_1_sh", "alp", 0, 0, "", { 0, 0, 0,   0.6, 0, 0,   0.9, 0, 1 });
    
    ObjAnimate("spr_drawerunit_puzzle_4", "alp", 0, 0, func_after, { 0, 0, 0,   0.9, 0, 0,   1.2, 0, 1,   1.5, 0, 1 });
    ObjAnimate("spr_drawerunit_puzzle_4_sh", "alp", 0, 0, "", { 0, 0, 0,   0.9, 0, 0,   1.2, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_cakeamulet()

  local item = "inv_cakeamulet";

  if cmn.ApplyObj( item, "gzz_ward_foodtray" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_foodtray" );

  elseif ( cmn.ApplyObj( item, "obj_foodtray_use_cakeamulet" ) ) then

    cmn.CallEventHandler( "use_cakeamulet_inv" );
    cmn.CallEventHandler( "use_cakeamulet_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_cakeamulet" );
      cmn.CallEventHandler( "use_cakeamulet_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_ward/audio/aud_use_cakeamulet");
  
    ObjSet("anm_foodtray_drawer_open",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_tongs()

  local item = "inv_tongs";

  if cmn.ApplyObj( item, "gzz_ward_foodtray" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_foodtray" );

  elseif ( cmn.ApplyObj( item, "obj_foodtray_use_tongs" ) and cmn.IsEventDone("use_cakeamulet") ) then

    cmn.CallEventHandler( "use_tongs_inv1" );
    cmn.CallEventHandler( "use_tongs_beg1" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_tongsfoodtray" );
      cmn.CallEventHandler( "use_tongs_end1" );
      
      public.get_longrod();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_ward/audio/aud_use_tweezers4");

    ObjMultiSet( { {"anm_foodtray_use_tongs",  { alp = 1, playing = 1, endtrig = func_after }},
                   {"anm_foodtray_use_tongs_2", { alp = 1, playing = 1 }} } );
    
  elseif cmn.ApplyObj( item, "gzz_nearnurseshouse_bench" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bench" );

  elseif ( cmn.ApplyObj( item, "obj_bench_use_tongs" ) ) then

    cmn.CallEventHandler( "use_tongs_inv2" );
    cmn.CallEventHandler( "use_tongs_beg2" );

    local func_after = function ()

      cmn.Lock( 0 );

      rm_nearnurseshouse.get_lockpart2();
      rm_nearnurseshouse.get_figurehead();

      cmn.SetEventDone( "use_tongsbench" );
      cmn.CallEventHandler( "use_tongs_end2" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_ward/audio/aud_use_tweezers4");

    ObjSet( "anm_bench_tong", { animfunc = "func_use_tong", endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_selfmadepen()

  local item = "inv_selfmadepen";

  if cmn.ApplyObj( item, "gzz_ward_foodtray" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_foodtray" );

  elseif ( cmn.ApplyObj( item, "obj_foodtray_use_selfmadepen" ) ) then

    cmn.CallEventHandler( "use_selfmadepen_inv" );
    cmn.CallEventHandler( "use_selfmadepen_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_selfmadepen" );
      cmn.CallEventHandler( "use_selfmadepen_end" );
    
    end;
    
    local anm_open = function ()
      
      ObjMultiSet( { {"anm_foodtray_pan_open", { alp = 1, playing = 1, endtrig = func_after }},
                     {"obj_foodtray_pan_cover", { alp = 0 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_ward/audio/aud_opn_pan");
  
    ObjSet("anm_foodtray_use_handle",  { alp = 1, playing = 1, endtrig = anm_open });
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_honeyspoon()

  local item = "inv_honeyspoon";

  if cmn.ApplyObj( item, "gzz_ward_foodtray" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_foodtray" );

  elseif ( cmn.ApplyObj( item, "obj_foodtray_use_honeyspoon" ) ) then

    cmn.CallEventHandler( "use_honeyspoon_inv" );
    cmn.CallEventHandler( "use_honeyspoon_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_honeyspoon" );
      cmn.CallEventHandler( "use_honeyspoon_end" );
      
      public.get_honey();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_ward/audio/aud_take_honey");
  
    ObjSet("anm_foodtray_use_honeyspoon",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_wrench()

  local item = "inv_wrench";

  if cmn.ApplyObj( item, "gzz_ward_lvl4clock" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_lvl4clock" );

  elseif ( cmn.ApplyObj( item, "obj_lvl4clock_use_wrench" ) ) then

    cmn.CallEventHandler( "use_wrench_beg1" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_wrenchclock" );
      cmn.CallEventHandler( "use_wrench_end1" );
      
      public.get_lvl4bolt2();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_ward/audio/aud_use_wrench");

    ObjSet("anm_lvl4clock_use_wrench",  { alp = 1, playing = 1, endtrig = func_after });

  elseif cmn.ObjIntersectCheck( item, "obj_complex_brokendogcase_use_wrench" ) and cmn.IsEventDone( "use_lvl4bolt" )
  and cmn.IsEventDone( "use_longrod" ) and cmn.IsEventDone("use_sophiaspullover") and cmn.IsEventDone("use_bone") then

    cmn.CallEventHandler( "use_wrench_inv2", "inv_complex_brokendogcase" );
    cmn.CallEventHandler( "use_wrench_beg2", "inv_complex_brokendogcase" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_wrenchdogcase" );
      cmn.CallEventHandler( "use_wrench_end2", "inv_complex_brokendogcase" );
      
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level4/inv_complex/inv_brokendogcase/audio/aud_use_wrench2");

    ObjSet("anm_complex_brokendogcase_use_wrench",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl4clockhands()

  local item = "inv_lvl4clockhands";

  if cmn.ApplyObj( item, "gzz_ward_lvl4clock" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_lvl4clock" );

  elseif ( cmn.ApplyObj( item, "obj_lvl4clock_use_lvl4clockhands" ) ) then

    cmn.CallEventHandler( "use_lvl4clockhands_inv" );
    cmn.CallEventHandler( "use_lvl4clockhands_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl4clockhands" );
      cmn.CallEventHandler( "use_lvl4clockhands_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/rm_ward/audio/aud_use_arrows4");

    ObjSet("anm_lvl4clock_use_lvl4clockhands",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_volunteersign()

  local item = "inv_volunteersign";

  if ( cmn.ApplyObj( item, "obj_ward_use_volunteersign" ) ) then

    cmn.CallEventHandler( "use_volunteersign_inv" );
    cmn.CallEventHandler( "use_volunteersign_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_volunteersign" );
      
      private.dialog_anna_open( 2 );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_purse/audio/aud_xx_clk_cloth");

    ObjAnimate("spr_ward_bed_sign", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_woolball()

  local item = "inv_woolball";

  if ( cmn.ApplyObj( item, "obj_ward_use_woolball" ) ) then

    cmn.CallEventHandler( "use_woolball_inv" );
    cmn.CallEventHandler( "use_woolball_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_woolball" );
      
      if cmn.IsEventDone("use_unfinishedsocks") and cmn.IsEventDone("use_knittingneedles") then
        private.dlg_start_func = "woolball";
        private.dialog_anna_open( 3 );
      else 
        cmn.CallEventHandler( "use_woolball_end" );
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_purse/audio/aud_xx_clk_cloth");

    ObjAnimate("spr_ward_bed_wool", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl4pen()

  local item = "inv_lvl4pen";

  if ( cmn.ApplyObj( item, "obj_ward_use_lvl4pen" ) and cmn.IsEventDone("get_socksforsophia") ) then

    cmn.CallEventHandler( "use_lvl4pen_inv" );
    cmn.CallEventHandler( "use_lvl4pen_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl4pen" );
      
      if cmn.IsEventDone("use_lvl4notebook") then
        private.dlg_start_func = "lvl4pen";
        private.dialog_anna_open( 4 );
      else 
        cmn.CallEventHandler( "use_lvl4pen_end" );
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_purse/audio/aud_xx_clk_cloth");

    ObjAnimate("spr_ward_bed_pen", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_knittingneedles()

  local item = "inv_knittingneedles";

  if ( cmn.ApplyObj( item, "obj_ward_use_knittingneedles" ) ) then

    cmn.CallEventHandler( "use_knittingneedles_inv" );
    cmn.CallEventHandler( "use_knittingneedles_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_knittingneedles" );
      
      if cmn.IsEventDone("use_unfinishedsocks") and cmn.IsEventDone("use_woolball") then
        private.dlg_start_func = "knittingneedles";
        private.dialog_anna_open( 3 );
      else 
        cmn.CallEventHandler( "use_knittingneedles_end" );
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_purse/audio/aud_xx_clk_cloth");

    ObjAnimate("spr_ward_bed_needles", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl4notebook()

  local item = "inv_lvl4notebook";

  if ( cmn.ApplyObj( item, "obj_ward_use_lvl4notebook" ) and cmn.IsEventDone("get_socksforsophia") ) then

    cmn.CallEventHandler( "use_lvl4notebook_inv" );
    cmn.CallEventHandler( "use_lvl4notebook_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl4notebook" );
      
      if cmn.IsEventDone("use_lvl4pen") then
        private.dlg_start_func = "lvl4notebook";
        private.dialog_anna_open( 4 );
      else 
        cmn.CallEventHandler( "use_lvl4notebook_end" );
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_purse/audio/aud_xx_clk_cloth");

    ObjAnimate("spr_ward_bed_notebook", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_unfinishedsocks()

  local item = "inv_unfinishedsocks";

  if ( cmn.ApplyObj( item, "obj_ward_use_unfinishedsocks" ) ) then

    cmn.CallEventHandler( "use_unfinishedsocks_inv" );
    cmn.CallEventHandler( "use_unfinishedsocks_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_unfinishedsocks" );
      
      if cmn.IsEventDone("use_knittingneedles") and cmn.IsEventDone("use_woolball") then
        private.dlg_start_func = "unfinishedsocks";
        private.dialog_anna_open( 3 );
      else 
        cmn.CallEventHandler( "use_unfinishedsocks_end" );
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/inv_complex/inv_purse/audio/aud_xx_clk_cloth");

    ObjAnimate("spr_ward_bed_socks", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_honey()

  cmn.SetEventDone( "get_honey" );
  cmn.CallEventHandler( "get_honey" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_longrod") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_fishsoup()

  cmn.SetEventDone( "get_fishsoup" );
  cmn.CallEventHandler( "get_fishsoup" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_kitchenknife()
  
  ObjSet("spr_foodtray_kitchenknife",  { ang = 0.8185 });

  cmn.SetEventDone( "get_kitchenknife" );
  cmn.CallEventHandler( "get_kitchenknife" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_twotoothedfork()
  
  ObjSet("spr_foodtray_twotoothedfork",  { ang = 1.073 });

  cmn.SetEventDone( "get_twotoothedfork" );
  cmn.CallEventHandler( "get_twotoothedfork" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );

end;
--------------------------------------------------------------------------------------------
function public.get_longrod()
  
  ObjSet("spr_foodtray_longrod",  { ang = -2.6235 });

  cmn.SetEventDone( "get_longrod" );
  cmn.CallEventHandler( "get_longrod" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_honey") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_ballerina()

  cmn.SetEventDone( "get_ballerina" );
  cmn.CallEventHandler( "get_ballerina" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_lvl4bolt2") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_lvl4bolt2()

  cmn.SetEventDone( "get_lvl4bolt2" );
  cmn.CallEventHandler( "get_lvl4bolt2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  if cmn.IsEventDone("get_ballerina") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_pandaseye2()
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_pandaseye2_end" );
    
  end;

  cmn.SetEventDone( "get_pandaseye2" );
  cmn.CallEventHandler( "get_pandaseye2_inv" );
  cmn.CallEventHandler( "get_pandaseye2_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  common_impl.PlayBackgroundMusic();
  
  ObjAnimate("obj_ward_dialog_anna1", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.5, 0, 0 });

end;
--------------------------------------------------------------------------------------------
function public.get_puzzlepart4()
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_puzzlepart4_end" );

  end;

  cmn.SetEventDone( "get_puzzlepart4" );
  cmn.CallEventHandler( "get_puzzlepart4_inv" );
  cmn.CallEventHandler( "get_puzzlepart4_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  common_impl.PlayBackgroundMusic();
  
  ObjAnimate("obj_ward_dialog_anna2", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.5, 0, 0 });

end;
--------------------------------------------------------------------------------------------
function public.get_socksforsophia()
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_socksforsophia_end" );
    
    interface_impl.CompleteClues( {2} );
    interface_impl.ShowGlobalTask();

  end;

  cmn.SetEventDone( "get_socksforsophia" );
  cmn.CallEventHandler( "get_socksforsophia_inv" );
  cmn.CallEventHandler( "get_socksforsophia_mid" );
  
  cmn.ShowBbt( "ward_after_get_socks" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  common_impl.PlayBackgroundMusic();
  
  ObjAnimate("obj_ward_dialog_anna3", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.5, 0, 0 });

end;
--------------------------------------------------------------------------------------------
function public.get_sophiasaddress()
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_sophiasaddress_end" );

  end;

  cmn.SetEventDone( "get_sophiasaddress" );
  cmn.CallEventHandler( "get_sophiasaddress_inv" );
  cmn.CallEventHandler( "get_sophiasaddress_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  common_impl.PlayBackgroundMusic();
  
  ObjAnimate("obj_ward_dialog_anna4", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.5, 0, 0 });

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function public.clk_wardfirst()
  
  cmn.SetEventDone("clk_wardfirst");
  cmn.Lock( 1 );
  
  private.dialog_anna_open( 1 );
  
end;
--------------------------------------------------------------------------------------------
function public.clk_poursouptobowl()

  cmn.CallEventHandler( "clk_poursouptobowl_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_poursouptobowl" );
    cmn.CallEventHandler( "clk_poursouptobowl_end" );

    cmn.Lock( 0 );
  
  end;

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/rm_ward/audio/aud_get_fish");
  
  ObjSet("anm_foodtray_pan_use",  { alp = 1, playing = 1, endtrig = func_after });

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_ward()

  if not ( cmn.IsEventDone( "opn_ward" ) ) then
    cmn.SetEventDone( "opn_ward" );
    cmn.CallEventHandler("opn_ward");
    cmn.ShowBbt( "ward_open" );
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_drawers()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_drawerunit_use_puzzlepart" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_ward/audio/aud_xx_clk_drawers");
  
  ObjSet("anm_drawerunit_drawers_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_clock()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_lvl4clock_use_lvl4clockhands" );
  
  cmn.PlayAudio("snd", "assets/levels/level1/rm_apartmentlivingroom/audio/aud_xx_small_box1");
  
  ObjSet("anm_lvl4clock_door_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_clock_bolt()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_lvl4clock_use_wrench" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_ward/audio/aud_clk_nut");
  
  ObjSet("anm_lvl4clock_bolt_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_tray_drawer()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_foodtray_use_cakeamulet" );
  
  cmn.PlayAudio("snd", "assets/levels/level2/rm_corridor/audio/aud_xx_clk_door_small2");
  
  ObjSet("anm_foodtray_drawer_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_tray_honey()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_foodtray_use_honeyspoon" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_lvl4nearhospital/audio/aud_xx_paint");
  
  ObjSet("anm_foodtray_honey_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_tray_rod()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_foodtray_use_tongs" );
  
  cmn.PlayAudio("snd", "assets/levels/level3/inv_complex/inv_oldpruners/audio/aud_xx_clk_cutters");
  
  ObjSet("anm_foodtray_rod_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_tray_pan()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_foodtray_use_selfmadepen" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_ward/audio/aud_xx_clk_pan");
  
  ObjSet("anm_foodtray_pan_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_tray_plate()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "foodtray_need_food" );
  
  cmn.PlayAudio("snd", "assets/levels/level4/rm_ward/audio/aud_xx_clk_plate");
  
  ObjSet("anm_foodtray_plate_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_anna_open( num )
  
  private.dlg_finished = false;
  
  cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  
  local func_after = function() private.dialog_anna1_beg(); end;
  if num == 2 then
    func_after = function() private.dialog_anna2_beg(); end;
  elseif num == 3 then
    func_after = function() private.dialog_anna3_beg(); end;
  elseif num == 4 then
    func_after = function() private.dialog_anna4_beg(); end;
  end;
  
  ObjAttach("obj_ward_dialog_anna"..num, "rm_ward");
  ObjAnimate("obj_ward_dialog_anna"..num, "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_anna1_beg()
  
  cmn.Lock(0);

  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "ward", "anna1", 2 );
  
  local dialog_end = function ()
    
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "clk_wardfirst" );
    cmn.ShowBbt( "ward_after_dialog_1" );
    
    interface_impl.ShowGlobalTask();
    
  end;
  
  local anm_give = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_ward_dialog_anna1_lipsync1");
    ObjDelete("spr_ward_dialog_anna1_glasses");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_ward_dialog_anna1_timer",  { playing = 0 }},
                   {"anm_ward_dialog_anna1_give", { alp = 1, playing = 1, endtrig = dialog_end }},
                   {"anm_ward_dialog_anna1_hands_1", { alp = 0 }},
                   {"anm_ward_dialog_anna1_head", { alp = 1 }} } );
    
  end;
  
  private.dlg_lipsync = "vid_ward_dialog_anna1_lipsync1";

  cmn.ShowDlgBbt( "dlg_anna1_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level4/rm_ward/audio/aud_dlg_anna1_voc");

  ObjMultiSet( { {"tmr_ward_dialog_anna1_timer", { time = 6.9, playing = 1, endtrig = anm_give }},
                 {"vid_ward_dialog_anna1_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = anm_give }},
                 {"obj_character_dialog_continue", { event_mup = anm_give }} } );
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_anna2_beg()
  
  cmn.Lock(0);

  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "ward", "anna2", 2 );
  
  local dialog_end = function ()
    
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "use_volunteersign_end" );
    cmn.ShowBbt( "ward_after_dialog_2" );
    interface_impl.ShowGlobalTask();
    
  end;
  
  local anm_give = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_ward_dialog_anna2_lipsync3");
    ObjDelete("spr_ward_dialog_anna2_glasses");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_ward_dialog_anna2_timer",  { playing = 0 }},
                   {"anm_ward_dialog_anna2_give", { alp = 1, playing = 1, endtrig = dialog_end }},
                   {"anm_ward_dialog_anna2_hands_1", { alp = 0 }},
                   {"anm_ward_dialog_anna2_head", { alp = 1 }} } );
    
  end;
  
  local anna_talks3 = function ()
  
    ObjDelete("vid_ward_dialog_anna2_lipsync2");
    ObjAttach("vid_ward_dialog_anna2_lipsync3", "obj_ward_dialog_anna2");
  
    cmn.ShowDlgBbt( "dlg_anna2_phrase_3" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level4/rm_ward/audio/aud_dlg_anna2_3_voc");
    private.dlg_lipsync = "";
    
    ObjMultiSet( { {"tmr_ward_dialog_anna2_timer", { endtrig = anm_give, time = 8.4, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_give }},
                   {"obj_character_dialog_continue", { event_mup = anm_give }},
                   {"vid_ward_dialog_anna2_lipsync3", { playing = 1 }} } );
  
  end;
  
  local anna_talks2 = function ()
  
    ObjDelete("vid_ward_dialog_anna2_lipsync1");
    ObjAttach("vid_ward_dialog_anna2_lipsync2", "obj_ward_dialog_anna2");
  
    cmn.ShowDlgBbt( "dlg_anna2_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level4/rm_ward/audio/aud_dlg_anna2_2_voc");
    private.dlg_lipsync = "";
    
    ObjMultiSet( { {"tmr_ward_dialog_anna2_timer", { endtrig = anna_talks3, time = 8.4, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anna_talks3 }},
                   {"obj_character_dialog_continue", { event_mup = anna_talks3 }},
                   {"vid_ward_dialog_anna2_lipsync2", { playing = 1 }} } );
  
  end;
  
  private.dlg_lipsync = "vid_ward_dialog_anna2_lipsync1";

  cmn.ShowDlgBbt( "dlg_anna2_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level4/rm_ward/audio/aud_dlg_anna2_1_voc");

  ObjMultiSet( { {"tmr_ward_dialog_anna2_timer", { time = 6.9, playing = 1, endtrig = anna_talks2 }},
                 {"vid_ward_dialog_anna2_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = anna_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = anna_talks2 }} } );
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_anna3_beg()
  
  cmn.Lock(0);

  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "ward", "anna3", 2 );
  
  local dialog_end = function ()
    
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "use_"..private.dlg_start_func.."_end" );
    cmn.ShowBbt( "ward_after_dialog_3" );
    
  end;
  
  local anm_give = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_ward_dialog_anna3_lipsync2");
    ObjDelete("spr_ward_dialog_anna3_glasses");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_ward_dialog_anna3_timer",  { playing = 0 }},
                   {"anm_ward_dialog_anna3_give", { alp = 1, playing = 1, endtrig = dialog_end }},
                   {"anm_ward_dialog_anna3_hands_1", { alp = 0 }},
                   {"anm_ward_dialog_anna3_head", { alp = 1 }} } );
    
  end;
  
  local anna_talks2 = function ()
  
    ObjDelete("vid_ward_dialog_anna3_lipsync1");
    ObjAttach("vid_ward_dialog_anna3_lipsync2", "obj_ward_dialog_anna3");
  
    cmn.ShowDlgBbt( "dlg_anna3_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level4/rm_ward/audio/aud_dlg_anna3_2_voc");
    private.dlg_lipsync = "";
    
    ObjMultiSet( { {"tmr_ward_dialog_anna3_timer", { endtrig = anm_give, time = 6.2, playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_give }},
                   {"obj_character_dialog_continue", { event_mup = anm_give }},
                   {"vid_ward_dialog_anna3_lipsync2", { playing = 1 }} } );
  
  end;
  
  private.dlg_lipsync = "vid_ward_dialog_anna3_lipsync1";

  cmn.ShowDlgBbt( "dlg_anna3_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level4/rm_ward/audio/aud_dlg_anna3_1_voc");

  ObjMultiSet( { {"tmr_ward_dialog_anna3_timer", { time = 4.2, playing = 1, endtrig = anna_talks2 }},
                 {"vid_ward_dialog_anna3_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = anna_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = anna_talks2 }} } );
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_anna4_beg()
  
  cmn.Lock(0);

  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "ward", "anna4", 2 );
  
  local dialog_end = function ()
    
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "use_"..private.dlg_start_func.."_end" );
    cmn.ShowBbt( "ward_after_dialog_4" );
    
  end;
  
  local anm_give = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_ward_dialog_anna4_lipsync1");
    ObjDelete("spr_ward_dialog_anna4_glasses");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_ward_dialog_anna4_timer",  { playing = 0 }},
                   {"anm_ward_dialog_anna4_give", { alp = 1, playing = 1, endtrig = dialog_end }},
                   {"anm_ward_dialog_anna4_hands_1", { alp = 0 }},
                   {"anm_ward_dialog_anna4_head", { alp = 1 }} } );
    
  end;
  
  private.dlg_lipsync = "vid_ward_dialog_anna4_lipsync1";

  cmn.ShowDlgBbt( "dlg_anna4_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level4/rm_ward/audio/aud_dlg_anna4_voc");

  ObjMultiSet( { {"tmr_ward_dialog_anna4_timer", { time = 5.4, playing = 1, endtrig = anm_give }},
                 {"vid_ward_dialog_anna4_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = anm_give }},
                 {"obj_character_dialog_continue", { event_mup = anm_give }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_anna1()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "clk_wardfirst" );
    cmn.ShowBbt( "ward_after_dialog_1" );
    
    interface_impl.ShowGlobalTask();
    
  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    ObjDelete("spr_ward_dialog_anna1_glasses");
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  ObjMultiSet( { {"tmr_ward_dialog_anna1_timer",  { playing = 0 }},
                 {"anm_ward_dialog_anna1_give", { alp = 1, playing = 1, endtrig = func_after_dlg }},
                 {"anm_ward_dialog_anna1_hands_1", { alp = 0 }},
                 {"anm_ward_dialog_anna1_head", { alp = 1 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_anna2()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "use_volunteersign_end" );
    cmn.ShowBbt( "ward_after_dialog_2" );
    interface_impl.ShowGlobalTask();
    
  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    ObjDelete("spr_ward_dialog_anna2_glasses");
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  ObjMultiSet( { {"tmr_ward_dialog_anna2_timer",  { playing = 0 }},
                 {"anm_ward_dialog_anna2_give", { alp = 1, playing = 1, endtrig = func_after_dlg }},
                 {"anm_ward_dialog_anna2_hands_1", { alp = 0 }},
                 {"anm_ward_dialog_anna2_head", { alp = 1 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_anna3()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "use_"..private.dlg_start_func.."_end" );
    cmn.ShowBbt( "ward_after_dialog_3" );
    
  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    ObjDelete("spr_ward_dialog_anna3_glasses");
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  ObjMultiSet( { {"tmr_ward_dialog_anna3_timer",  { playing = 0 }},
                 {"anm_ward_dialog_anna3_give", { alp = 1, playing = 1, endtrig = func_after_dlg }},
                 {"anm_ward_dialog_anna3_hands_1", { alp = 0 }},
                 {"anm_ward_dialog_anna3_head", { alp = 1 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_anna4()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "use_"..private.dlg_start_func.."_end" );
    cmn.ShowBbt( "ward_after_dialog_4" );
    
  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete("spr_ward_dialog_anna4_glasses");
    ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  ObjMultiSet( { {"tmr_ward_dialog_anna4_timer",  { playing = 0 }},
                 {"anm_ward_dialog_anna4_give", { alp = 1, playing = 1, endtrig = func_after_dlg }},
                 {"anm_ward_dialog_anna4_hands_1", { alp = 0 }},
                 {"anm_ward_dialog_anna4_head", { alp = 1 }} } );
  
end;
--*********************************************************************************************************************
