-- name=rm_moregames
--******************************************************************************************
function public.Init()

end;
--******************************************************************************************
function public.PreOpen()

  --cmn.StopAllEnv();
  --cmn.PlayAudio( "mus", "assets/levels/common/audio/aud_achivement_mus", 1 );

  for i = 1, 8, 1 do

    ObjStopAnimate( "spr_moregames_surface_"..i, 6 );

    ObjSet( "spr_moregames_surface_"..i, { scale_x = 1, scale_y = 1 } );

  end;

  if IsCollectorsEdition() then

    ObjSet( "spr_moregames_ce", { alp = 1 } );

    for i = 1, 7, 1 do
      ObjSet( "spr_moregames_surface_"..i.."_text_ce", { alp = 1 } );
    end;

  else

    ObjSet( "spr_moregames_ce", { alp = 0 } );

    for i = 1, 8, 1 do
      ObjSet( "spr_moregames_surface_"..i.."_text_ce", { alp = 0 } );
    end;

  end;

end;
--******************************************************************************************
function public.Open()

end;
--******************************************************************************************
function public.PreClose()

  --cmn.StopAllMus();

end;
--******************************************************************************************
function public.Close()

end;
--******************************************************************************************
--выход из комнаты
function public.Exit()

  room.Switch("rm_menu");

end;
--******************************************************************************************
function public.MouseEnterBack()

  local alp = ObjGet( "spr_moregames_exit_focus" ).alp;
  ObjAnimate( "spr_moregames_exit_focus", 8,0,0, "", {0,0,alp, 0.3,0,1});
  SetCursor(CURSOR_HAND);

end;

function public.MouseLeaveBack()

  local alp = ObjGet( "spr_moregames_exit_focus" ).alp;
  ObjAnimate( "spr_moregames_exit_focus", 8,0,0, "", {0,0,alp, 0.3,0,0});
  SetCursor(CURSOR_DEFAULT);

end;
--******************************************************************************************
function public.ClickImage( num )

  local url_os = "_pc";
  if GetPlatform() == "mac" then
    url_os = "_mac";
  end;

  local url_game_ver = "_se";
  if IsCollectorsEdition() then
    url_game_ver = "_ce";
  end;

  --DbgTrace( "str_moregames_img_"..num..url_os..url_game_ver );

  local url = StringGet( "str_moregames_img_"..num..url_os..url_game_ver );

  OpenBrowser( url );

end;
--******************************************************************************************
function public.MEnterImage( num )

  SetCursor( CURSOR_HAND );

  local obj = "spr_moregames_surface_"..num;
  local scale = ObjGet( obj ).scale_x;

  local max_scale = 1.1;  -- max_scale > 1
  local max_tme = 0.3;
  local tme = ( ( max_scale - scale ) * max_tme ) / ( max_scale - 1 );

  --DbgTrace( "MEnterImage, obj = "..obj..", scale = "..scale..", tme = "..tme );

  ObjAnimate( obj, 6, 0, 0, "", { 0, 0, scale, scale,   tme, 0, max_scale, max_scale } );

end;
----------------------------------------------------------------------------
function public.MLeaveImage( num )

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_moregames_surface_"..num;
  local scale = ObjGet( obj ).scale_x;

  local max_scale = 1.1;  -- max_scale > 1
  local max_tme = 0.3;
  local tme = ( ( scale - 1 ) * max_tme ) / ( max_scale - 1 );

  --DbgTrace( "MLeaveImage, obj = "..obj..", scale = "..scale..", tme = "..tme );

  ObjAnimate( obj, 6, 0, 0, "", { 0, 0, scale, scale,    tme, 0, 1, 1 } );

end;
--****************************************************************************************